--ActorManager.lua
--========================================================================
--角色管理类
-- 管理角色形象 / 创建角色 保存角色句柄 /
local ActorManager = class("ActorManager");

function ActorManager:ctor()
	self.globalActorID	= 0;				--全局角色ID
	self.actorList		= {};
end

--========================================================================
--分配ID
function ActorManager:allocActorID()
	self.globalActorID = self.globalActorID + 1;
	return self.globalActorID;
end
--========================================================================
--角色管理
--创建角色
function ActorManager:CreateActor( resid, pid )
	local id = self:allocActorID();
	local actor = require("app.actor.Actor"):create(id, resid, pid);
	self.actorList[id] = actor;
	return actor;
end

--创建战斗者
function ActorManager:CreateFighter( resid, pid )
	local id = self:allocActorID();
	local actor = require("app.fight.fighter"):create(id, resid, pid);
	self.actorList[id] = actor;
	return actor;
end

--销毁角色
function ActorManager:DestroyActor( id )
	self.actorList[id] = nil;
end

--查找角色
function ActorManager:GetActor( id )
	return self.actorList[id];
end

cc.exports.ActorManager = ActorManager:create();
