--enum.lua

--========================================================================
--========================================================================
--枚举定义
--游戏状态类
local Enum = class("Enum")
function Enum:ctor()
	self.list = {};
	self.list.ServerName = 
	{
		server = 'server';
	}
	self.list.SDKLoginType = {
		NULL			= -1,
		EMPTY			= 0,
		LOGIN_GOOGLE 	= 1,	-- google
		LOGIN_FACEBOOK 	= 2,	-- facebook
		LOGIN_IOS		= 3,	-- IOS
		LOGIN_ACCOUNT 	= 99,	--账号登陆
		LOGIN_GUEST 	= 100 	-- 游客
	}
	self.list.LoginState =
	{
		idle			= 0;	--空闲
		saveJson		= 1;	
		loadResource	= 2;	
		gotoMainScene	= 3;	
	}

	self.list.FighterState = 
	{
		idle			= 0;	--空闲
		attack			= 1;	--攻击
		showSkill		= 2;	--展示技能
		death			= 3;	--死亡
	}

	self.list.FightState = 
	{
		None			= 0;	-- 默认
		Prepare			= 1;	-- 战前准备
		PlotBegin		= 2;	-- 前置剧情
		Progress		= 3;	-- 战斗中
		PlotEnd			= 4;	-- 后置剧情
		End				= 5;	-- 战后结算
		Next			= 6;	-- 战斗间隙
		Will			= 7;	-- 战前准备状态的 前置临时状态
	}

	self.list.FightType = 
	{
		Boss			= 2;	-- 挑战boss
		RandomBoss		= 3;	-- 随机boss
		GuildBoss		= 4;	-- 公会boss
		TrialTower 		= 5;	-- 试炼塔
		DailyRound		= 6;	-- 每日副本
		Event			= 7;	-- 战斗活动
		Arena			= 8;	-- 竞技场
		CopyRound		= 9;	-- 副本活动
		MultArena		= 11;	-- 多队竞技场
		Story			= 12;	-- 故事剧情
	}

	self.list.AnimationType =
	{
		none			= 'none';	--默认
		idle			= 'idle';	--空闲
		hit				= 'hit';	--被击
		win				= 'win';	--胜利
		attack			= 'attack';	--攻击
		die				= 'die';	--死亡
		skill			= 'skill';	--技能
		run				= 'run';	--跑
		keep			= 'keep';	--硬直
	}

	self.list.FighterSpecialStateType = 
	{
		dot,
		reflect,
		shield,
		dazed,
		active,
		slow,
		haste,
	}

	self.list.DirectionType = 
	{
		right			= 0;	--朝右
		left			= 1;	--朝左
	}

	self.list.SkillType = 
	{
		normalAttack	= 0;	--普通炮击
		activeSkill		= 1;	--主动技能
		passiveSkill	= 2;	--被动技能

		passive4Skill	= 4;	--觉醒技能4
		passive5Skill	= 5;	--觉醒技能5
	}

	self.list.AttackState = 
	{
		miss			= 0;	-- 未命中
		normal			= 1;	-- 命中
		crital			= 2;	-- 暴击
	}

	self.list.ParaName = 
	{
		[1]				= 'hp';		--耐久
		[2]				= 'atk';	--炮击
		[3]				= 'def';	--攻速
		[4]				= 'cd';		--防御,
	}

	self.list.breakItem = 
	{
		[1]				= 40001;	--耐久
		[2]				= 40002;	--炮击
		[3]				= 40004;	--反坦
		[4]				= 40006;	--反导
		[5]				= 40005;	--制导
		[7]				= 40003;  --防御,
	}

	self.list.groupName = 
	{
		[1]				= '赤龙';
		[2]				= '黑鹰';
		[3]				= '白虎';
		
	}

	self.list.typeName = 
	{
		[1]				= '中坦';
		[2]				= '重坦';
		[3]				= '反坦';
		[4]				= '火炮';
		[5]				= '火箭炮';
		[6]				= '轮式装甲';
	}

	self.list.evolve = 
	{
		cardBreak				= 1;	--突破
		cardRemodel				= 2;	--改造
	}

	self.list.Attribute = 
	{
		[1]		= 'hp';			--耐久
		[2]		= 'atk';		--炮击
		[3]		= 'def';		--防御
		[4]		= 'aspd';		--攻速,
		[5]		= 'crit';		--暴击,
		[6]		= 'crit_dam';	--爆伤,
		[7]		= 'damage_enlarge';
		[8]		= 'damage_reduce';
		[9]		= 'heal_effect';
	}

	self.list.BuffTrigger =
	{
		hpLow			= 1;	--血量低于某数值
		hitNum			= 2;	--每N次普攻
		skillNum		= 3;	--每N次主动技能
		heal			= 4;	--受到治疗
		damage			= 5;	--受到伤害
		skill			= 6;	--受到主动伤害
	}

	--默认字体，统一使用FONT_JP
	self.list.SystemFont = 
    {
	   FONT_IMPACT ='font/SourceHanSansCN-Medium.otf',
	   FONT_HUAKANG ='font/SourceHanSansCN-Medium.otf',
	   FONT_JP="font/SourceHanSansCN-Medium.otf",
	   FONT_SIYUAN = 'font/SourceHanSansCN-Medium.otf', --思源黑体，暂时使用汉仪菱心体
	   FONT_CV = 'font/SourceHanSansCN-Medium.otf',	-- CV 特有字体 NanumBrushScript-Regular.ttf
	}
	

	--字体颜色
	self.list.SystemFontColor = 
    {
		TITLE_LEVEL =cc.c4b(77,77,77, 255), --标题等级颜色
		WHITE=cc.c4b(255,255,255, 255),
		TASK_NO=cc.c4b(81,183,231, 255),--任务数字字体颜色：  impact     字号36   rgb值   81,183,231
		TASK_LEVEL=cc.c4b(149,221,255, 255),--任务难度字体颜色：  汉仪       字号22   rgb值 149,221,255
		GRAYBLACK=cc.c4b( 119,101,127, 255),
	}
	

	--装备品质颜色
	self.list.EquipQualityColor = 
    {
		[0] = cc.c4b(203	,203,203, 255),		-- 白        cbcbcb     203  203  203
		[1] = cc.c4b(203	,203,203, 255),		-- 白        cbcbcb     203  203  203
		[2] = cc.c4b(79		,230,111, 255),		-- 绿        4fe66f     79   230  111
		[3] = cc.c4b(254	,103,220, 255),		-- 紫        fe67dc     254  103  220
		[4] = cc.c4b(247	,180,1	, 255),		-- 橙        f7b401     247  180  1
	}
	-- N,  R ,SR,SSR,UR
	-- 白，绿，蓝，紫，红
	self.list.QualityName = {
		[1] = 'common', -- white
		[2] = 'green',
		[3] = 'blue',
		[4] = 'purple',
		[5] = 'yellow',

	}
	
	self.list.ItemQualityColorName = {
		[1] = 'green',
		[2] = 'green',
		[3] = 'blue',
		[4] = 'blue',
		[5] = 'purple',
		[6] = 'purple',
		[7] = 'purple',
		[8] = 'red',
		
	}
	--属性相关数字颜色
	self.list.AttributeColor = 
    {
		yellow = cc.c4b(255 , 236,   73, 255),--黄
		green = cc.c4b(74 , 252,   74, 255),--绿色
		red = cc.c4b(255 ,  96,    96, 255),--红
		white = cc.c4b(255	,255,255, 255),		-- 白        cbcbcb     203  203  203
		blue =cc.c4b(59,166,241,255),--蓝色 3ba6f1   
		black =cc.c4b(0,0,0,255),--黑   
	}
	
	--聊天按钮弹起状态字体颜色 	0 		0 		0 	255
	--聊天按钮按下状态字体颜色 	123  	196   	253 255
	self.list.ChatButtonStyle = 
    {
		UP  	= cc.c4b(0,0,0,255),
		DOWN  	= cc.c4b(123,196,253,255),
	}

	self.list.ChatTextStyle = 
    {
		PLAYER_NAME			= cc.c4b(51,186,249,255),  --玩家名字颜色
		UNION_NAME			= cc.c4b(101,255,202,255),--工会名字颜色
		SYSTEM				= cc.c4b(100,253,255,255),--系统玩家名字颜色
		REWARD_NAME			= cc.c4b(254,209,51,255),--奖励名字颜色
		BLACK				= cc.c4b(0,0,0,255),
	}

	self.list.GameState = 
	{
		Logo 				= 0;
		Login				= 1;
		Main				= 2;
		Fight				= 3;
		Plot				= 4;
	}

	-- 主界面看板类型
	self.list.KanbanType = {
		KANBAN_ROLE		= 1, -- 角色
		KANBAN_AVATAR	= 2, -- 皮肤
		KANBAN_LOVE		= 3, --恋爱
		KANBAN_BARE		= 4, -- 重破
	}
	-- cv文件名(R001_gacha1.mp3) = cv_id + '_' + cvTypeEnumStr[cvTypeEnum] + cvTypeIndex + '.png'
	-- cv类型 ()
	self.list.cvTypeEnum = {
		-- 枚举类型对应表id
		CV_GACHA 		= 1,		-- 抽卡			

		CV_GIFT 		= 2,		-- 爱恋
		CV_PURIFIED 	= 3,		-- 净化 解锁碎片，每次解锁时播放对应音效，全部解锁时随机
		CV_BROKEN 		= 4,		-- 点击未激活或者未全部解锁大破

		CV_HIT		 	= 5,		-- 战斗 攻击
		CV_SKILL 		= 6,		-- 战斗 技能
		CV_UNABLE 		= 7,		-- 战斗 被击杀	

		CV_LOGIN 		= 8, 		-- 登录界面，特殊处理
		
		CV_TOUCH1		= 10,		-- 主界面点击，默认
		CV_TOUCH2 		= 11,		-- 主界面点击，首次，时间8-10
		CV_TOUCH3 		= 12,		-- 主界面点击，首次，时间22-24

		CV_HOME_LOGIN1 	= 20,		-- 进入主界面，默认
		CV_HOME_LOGIN2 	= 21,		-- 进入主界面，首次，时间8-10
		CV_HOME_LOGIN3 	= 22,		-- 进入主界面，首次，时间12-14
		CV_HOME_LOGIN4 	= 23,		-- 进入主界面，首次，时间16-18
		CV_HOME_LOGIN5 	= 24,		-- 进入主界面，首次，时间22-24

		CV_BROKEN_FIGHT 		= 25,		-- 战斗中大破
		CV_BROKEN_FIGHT_OVER 	= 26,		-- 战斗结束大破
		
		CV_NULL 		= 0,	--未定义

	}
	
	self.list.cvTypeEnumStr = {
		-- 枚举类型
		[1] 		= 'gacha',		
		[2] 		= 'gift',
		[3] 		= 'purified',
		[4] 		= 'broken',
		[5]		 	= 'hit',
		[6] 		= 'skill',
		[7] 		= 'unable',

		[8] 		= 'login', -- 登录界面，特殊处理

		[10] 		= 'touch',
		[11] 		= 'touch_daytime',
		[12] 		= 'touch_night',
		[20] 		= 'home_back',
		[21] 		= 'home_morning',
		[22] 		= 'home_lunch',
		[23] 		= 'home_afternoon',
		[24] 		= 'home_night',
		[25] 		= 'broken_fight',
		[26] 		= 'broken_fight_over',

		[0] 		= 'NULL',	--未定义

	}

	-- 推送主题 
	-- 目前IOS/ANDORID 同时只会接受一个推送主题
	self.list.PushType = {
		-- 通用
		-- android
		PUSH_EVENT_11 = 'android_all',	-- 推送 on  夜间推送 on
		PUSH_EVENT_12 = 'android_day', 	-- 推送 on  夜间推送 off

		-- ios
		PUSH_EVENT_21 = 'ios_all',
		PUSH_EVENT_22 = 'ios_day',
	}
	
	self.list.CastType =
	{
		normal		= 1,
		crit		= 2,
		restrain	= 3,
		restrainCrit= 4,
		heal		= 5,
		absorb		= 6,
		reflect		= 7,
	}

	self.list.BuffType =
	{
		up		= 1,
		down	= 2,
		reflect	= 3,
		dot_per	= 4,
		hot_per	= 5,
		heal_per= 6,
		dazed	= 7,
		shield	= 8,
		purge	= 9,
		dispel	= 10,
		dot		= 11,
		hot		= 12,
		heal	= 13,
		silent	= 14,
		refresh	= 15,
		imm_neg	= 16,
		imm_dam	= 17,
		reject	= 18,
		combo	= 19,
		reborn	= 20,
		cd_lang	= 21,
		reborn_other	= 22,
		heal_return		= 23,
		cleanup			= 24,
		breakup			= 25,
		imm_kill		= 26,
	}

	self.list.MessageBoxType = 
	{
		OK 			= 1,
		CANCEL_OK 	= 2,
	}

	self.list.TeamType = {
		COMMON = 1,
		EVENT = 2,
		GUILD_MISSION = 3,
		ARENA = 4,
		TRIAL = 5,
		CARD = 6,
		GUILD_BOSS = 7,
		TRIAL_R = 8,
		TRIAL_G = 9,
		TRIAL_B = 10,
		ARENA_1 = 11,
		ARENA_2 = 12,
		ARENA_3 = 13,
		STORY 	= 14,
	}

	self.list.CardTeamState = {
		NONE = 0,
		SELECT = 1,
		TEAM_CHANGE = 2,
		EVENT_TEAM_CHANGE = 3,
		FIGHT = 6,
		EVENT = 7,
		GUILD_BOSS = 8,
		ARENA = 9,
		Future = 10,
		TRIAL = 11,
	}

	self.list.EventPanelType = {
		MAIN = 1,
		ROUND = 2,
	}
	self.list.ActivityIndex = {
		-- operate表operate_id
		SIGN 		= 12,
		LEVEL_GIFT 	= 8,
		FP_GIFT 	= 9,
		THREE_DAY 	= 13,

		SEVEN_DAY 	= 1,
		SEVEN_CON 	= 14, --七日连续登录
		-- FIRST_RECHARGE = 1000,
		-- SEVEN_DAY = 1,
		-- CUMULATIVE_RECHARGE = 2, --累计充值
		-- DAILY_RECHARGE = 3, 	--每日充值
		-- LEVEL_GIFT = 4, 		--等级礼包
		-- FP_GIFT = 5, 			--战斗力礼包
		-- WEEK_RECHARGE = 6, 		--每周充值
		-- FIRST_RECHARGE = 101, 	--首次充值
		MONTH_CARD = 201, 		--月卡
		-- SIGN = 202, 			--签到
		-- POWAR = 203, 			--体力礼包

		-- RECHARGE = 301, 		--充值大礼包<首充，百元礼包>

	}
	self.list.ObtainFrom = 
	{
		[1] = '军火库', 
		[2] = '商城',
		[3] = '公会商店',
		[4] = '礼包商店',
		[5] = '财政部',
		[6] = '能量釜',
		[7] = '活动抽卡包',
		[8] = 'PT抽卡包',
		[9] = '普通抽卡包',
		[10] = '每日副本',
		[11] = '委托任务',
	}
	self.list.BackFromEvent = 
	{
		GuildPanel 		  = 'NetworkGuildUpdateGuildMoney',
	}

	self.list.RestraintType = {
		[1] = 2, 
		[2] = 3, 
		[3] = 1, 
		[4] = 3, 
		[5] = 2, 
		[6] = 1, 
	}

	self.list.BreakSkillOpen = {
		[1] = 1, 
		[2] = 1, 
		[3] = 4, 
		[4] = 7, 
		[5] = 11, 
	}


	self.list.ScritEvent = {
		AnimationTypeAction = 1,
		AddDamage			= 2,
		AddBuff				= 3,
		AddFollow			= 4,
		AddSound			= 5,
		AddAvatarEffect		= 6,
		AddTraceEffect		= 7,
		AddSceneEffect		= 8,
		AddSceneShake		= 9,
	}
	
	self.list.ShopType = {
		COMMON    	= 1,
		GUILD 		= 2,
	}

	self.list.RANK_ENUM = {
	    ENUM_1    = 1,    -- 关卡排行
	    ENUM_2    = 2,    -- 竞技场周排行
	    ENUM_3    = 3,    -- 试炼
	    ENUM_4    = 4,    -- 工会
	    ENUM_201    = 201,    -- 竞技场月排行
	    ENUM_401    = 401,    -- 工会内个人排行
	}

	self.list.CommonShopType = {
		CLIENT			= 0,
		SHOP    		= 1,
		GIFT 			= 2,
		GIFT_ACTIVITY   = 3,
		MONTH_CARD 		= 4,
		RECHARGE    	= 5,
		GUILD 			= 6,
		RESOLVE 		= 7,
		ROLE 			= 8,
		EQUIP 			= 9,
		AVATAR 			= 10,
		MAZE 			= 11,
		GROWUP 			= 12,
		BATTLEPASS_1 	= 13,
		BATTLEPASS_2 	= 14,
		ARENA		 	= 15,
		ADVENTURE1		= 16,
		ADVENTURE2		= 17,
		GROWUP_SP		= 18,
		MULT_ARENA		= 19,
		SPECIAL			= 20,
		BUBBLE			= 21,
	}

	self.list.TimeEnum = {
		TimeEnumNow = "在线",
		TimeEnum5m	= "五分钟前",
		TimeEnum10m	= "十分钟前",
		TimeEnum30m	= "三十分钟前",
		TimeEnum1h	= "一小时前",
		TimeEnum3h	= "三小时前",
		TimeEnum12h = "十二小时前",
		TimeEnum1d	= "一天前",
		TimeEnum3d	= "三天前",
	}

	self.list.ItemType = {
		ITEM_TYPE_MONEY		= 1,--// 游戏币
		ITEM_TYPE_TOKEN		= 2,--// 代币
		ITEM_TYPE_EXP		= 3,--// 用户经验值
		ITEM_TYPE_GACHA		= 4,--// 抽卡券
		ITEM_TYPE_BUFF		= 5,--// 可使用的挂机buff
		ITEM_TYPE_AFK		= 6,--// 立即获得挂机收益
		ITEM_TYPE_REPAIR	= 7,--// 快速修理券
		ITEM_TYPE_EQUIP		= 8,--;// 装备
		ITEM_TYPE_PARTNER	= 9,--;// 角色占位
		ITEM_TYPE_ACHIEVE 	= 10--;//成就碎片
	}

	self.list.TrackEventTokenAOS = {
		TRACK_RE_START 		= 't3cf74',     -- 下载资源
		TRACK_RE_COM     	= 'd6dzbb',     -- 资源下载完成
		TRACK_LOGIN_ON		= 'ytxusp',     -- 显示登录窗口
		TRACK_MOVIE_PLAY	= 'ofgl1o',     -- 播放序章视频
		TRACK_TU_START		= 'z5jmpr',     -- 新手引导开始
		TRACK_TU7_STAGE1	= 'mqq5rt',     -- 关卡1boss
		TRACK_TU8_SKILL		= 'cry4sl',     -- 技能引导
		TRACK_TU15_LEVELUP	= 'mzejir',     -- 角色升级
		TRACK_TU22_STAGE2	= '6q9tf6',     -- 关卡2boss
		TRACK_TU26_CARD		= 'h9tnfw',     -- 单次抽卡
		TRACK_TU37_STAGE3	= 'zakde6',     -- 关卡3boss
		TRACK_TU43_STAGE4	= 'uydr85',     -- 关卡4boss
		TRACK_TU_FINISH 	= 'psrq3c',     -- 新手引导结束
		TRACK_PURCHASE		= 'glitct',     -- 支付购买
	}

	self.list.TrackEventTokenOne = {
		TRACK_RE_START 		= '6xkw4v',     -- 下载资源
		TRACK_RE_COM     	= 'ikjfad',     -- 资源下载完成
		TRACK_LOGIN_ON		= 'gly9bn',     -- 显示登录窗口
		TRACK_MOVIE_PLAY	= 'k6ah6i',     -- 播放序章视频
		TRACK_TU_START		= 'xv3cf1',     -- 新手引导开始
		TRACK_TU7_STAGE1	= 'c785jz',     -- 关卡1boss
		TRACK_TU8_SKILL		= '3g0jqe',     -- 技能引导
		TRACK_TU15_LEVELUP	= 'eij7e1',     -- 角色升级
		TRACK_TU22_STAGE2	= 'kx3cb5',     -- 关卡2boss
		TRACK_TU26_CARD		= 'y6t2jl',     -- 单次抽卡
		TRACK_TU37_STAGE3	= '2kvp1i',     -- 关卡3boss
		TRACK_TU43_STAGE4	= '38784q',     -- 关卡4boss
		TRACK_TU_FINISH 	= '26bpsj',     -- 新手引导结束
		TRACK_PURCHASE		= 'uu88ux',     -- 支付购买
	}
	
	-- 等级解锁 
	-- value对应start表id字段 
	-- 更新时间：2019-9-27
	self.list.levelLockItemIds = {
		LEVLE_LOCK_1		= 1,	-- 随机商店
		LEVLE_LOCK_2		= 2,	--	快速战斗
		LEVLE_LOCK_3		= 3,	--	七日登录
		LEVLE_LOCK_4		= 4,	--	签到
		LEVLE_LOCK_5		= 5,	--	道具使用
		LEVLE_LOCK_6		= 6,	--	首冲
		LEVLE_LOCK_7		= 7,	--	随机BOSS
		LEVLE_LOCK_8		= 9,	--	每日副本
		LEVLE_LOCK_9		= 10,	--	试炼
		LEVLE_LOCK_10		= 11,	--	公会
		LEVLE_LOCK_11		= 12,	--	科研所
		LEVLE_LOCK_12		= 13,	--	每日副本-科技币
		LEVLE_LOCK_13		= 17,	--	驻守
		LEVLE_LOCK_14		= 14,	--	图书馆
		LEVLE_LOCK_15		= 8,	--	融合中心
		LEVLE_LOCK_16		= 15,	--	每日副本-合成石
		LEVLE_LOCK_17		= 16,	--	重构中心
		LEVLE_LOCK_18		= 18,  	-- 军械库
		LEVLE_LOCK_19		= 19,	-- 任务
		LEVLE_LOCK_20		= 20,	--  竞技场
		LEVLE_LOCK_21		= 21, 	-- 共鸣水晶
		LEVLE_LOCK_22		= 22, 	-- 排行榜
		LEVLE_LOCK_23		= 23, 	-- 迷宫
		LEVLE_LOCK_24		= 24, 	-- 大冒险
		LEVLE_LOCK_25		= 25, 	-- 多队伍竞技场
	}

	self.list.levelLockItemNameId = {
		FastFightRewardPanel= 2,	--	快速战斗
		Login7RewardPanel	= 3,	--	七日登录
		ActivityPanel		= 4,	--	签到
		ActivityRechargePanel = 6,	--	首冲
		RoundBossPanel		= 7,	--	随机BOSS
		TrialPanel			= 10,	--	试炼
		GuildPanel			= 11,	--	公会
		HomeBaseSkillPanel	= 12,	--	科研所
		CardLevelUpStarCardListPanel = 8,	--	融合中心
		CardResolvePanel	= 16,	--	重构中心
		EquipComposePanel	= 18,  	-- 军械库
		ArenaPanel			= 20,	--  竞技场
		FutureCardPanel		= 21, 	-- 共鸣水晶
		RankListPanel		= 22, 	-- 排行榜
		EventMainPanel		= 23, 	-- 迷宫
	}
	-- 适配属性
	-- self.list.Adapter = {
	-- 	red		= 2,
	-- 	green	= 3,
	-- 	blue	= 1,
	-- }

	self.list.FightRestraintType = {
		ALL_RED 	= 2, -- 红3 红4 030 130 031 040
		ALL_GREEN 	= 3, -- 003 103 013 004
		ALL_BLUE 	= 1, -- 300 301 310 400
		RED_GREEN	= 6, --红2 蓝2 022
		RED_BLUE 	= 4, --红2 绿2 220
		GREEN_BLUE 	= 5, --绿2 蓝2 202

		RED_BASE 	= 2,
		GREEN_BASE	= 3,
		BLUE_BASE 	= 1,
		NULL 		= -1,
	}

	self.list.FightRestraintEnum = {
		[1]		= 'blue',
		[2]		= 'red',
		[3]		= 'green',
	}

	self.list.ItemQualityBg = {
		[1] = 1,
		[2] = 2,
		[3] = 2,
		[4] = 3,
		[5] = 3,
		[6] = 4,
		[7] = 4,
		[8] = 4,
		[9] = 5,
		[10] = 5,
		[11] = 5,
		[12] = 5,
		[13] = 5,
		[14] = 5,
		[15] = 5,
		[16] = 5,
		[17] = 5,
		[18] = 5,
		[19] = 5,
		[20] = 5,
	}

	self.list.SkillCon =
	{
		job		= 1,--目标职业
		color	= 2,--目标颜色
		bigHp	= 3,--目标最大血量
		smallHp	= 4,--目标最小血量
		buff	= 5,--目标当前buff类型
		pos		= 6,--目标站位
		atkBigHp	= 7,--攻击者最大血量
		atkSmallHp	= 8,--攻击者最小血量
		atkBuff		= 9,--攻击者当前buff类型
		damage		= 10,--目标伤害占比
		kill		= 11,--击杀目标

	}

	self.list.HeaderType = {
		HEAD_ICON = 1,
		HEAD_TITLE = 2,
		HEAD_TITLE_GUILD = 3,
		HEAD_TITLE_EVENT = 4,
		HEAD_TITLE_EVENT_SHOP = 5,
		HEAD_TITLE_NO_MONEY = 6,
	}

	self.list.HeaderTypeMoneys = {
		[1] = {10001 , 10002}, --头像样式-金币，钻石，
		[2] = {10001 , 10002}, --标题样式-金币，钻石，
		[3] = {10011 , 10002}, --标题样式-工会币，钻石，
		[4] = {10019 , 10002}, --标题样式-活动PT，钻石，
		[5] = {10010 , 10002}, --标题样式-活动币，钻石，
		[6] = {0 , 0}, --标题样式-不显示钱
	}

	self.list.RewardType = {
		REWARD_TYPE_COMMON = 1;
		REWARD_TYPE_FAST_FIGHT = 2;
		REWARD_TYPE_FIGHT_INCOME = 3;
	}

	self.list.PromptShowType = {
		SHOW_TYPE_NONE = 0,
		SHOW_TYPE_ONE = 1,
		SHOW_TYPE_TWO = 2,
	}

	self.list.ArenaRoleMonsterType = {
		NONE = 0,
		ROLE = 1,
		MONSTER = 2,
	}

	self.list.LiveEnterType = {
		BARE_COLLECT = 1,
	}
	
	self.list.AutoBattleBuff = {
		monthCard	= 1,
		activity	= 2,
		admob		= 3,
	}


	local cStateType = {
		MAIN 		= 10,
		SHOP 		= 11,
		BATTLEPASS 	= 12,
		ACTIVITY 	= 13,
		SETTING 	= 19,
		HOME 		= 20,
		STORE       = 21,
		GUILD_MAIN 	= 30,
		FIGHT 		= 40,
		MISSION     = 41,
		CARD 		= 50,
	}

	self.list.ConfigStateType = cStateType;

	local cState = {
		--主界面
		GachaListPanel				= 1000, --抽卡
		ShopPanel					= 1100, --商店
		ActivityPanel 				= 1200, --福利
		BattlepassEventPanel 			= 1400, --battlepass
		--BattlePassRewardPanel 		= 1400, --battlepass reward
		EventMainPanel 				= 1500, --event活动
		ActivityRechargePanel		= 1600, --首充
		Login7RewardPanel			= 1205, --七日奖励
		ThreeDayActivityPanel		= 1206, --剑圣降临
		MailPanel					= 1700, --邮件
		ChatPanel					= 1800, --聊天
		MainActivityBtn				= 1207, --主界面活动按钮
		RankListPanel				= 2000, --排行榜

		--商店
		ShopPanelShop				= 1101, --商店
		ShopPanelGift				= 1102, --礼包
		ShopPanelGiftActivity		= 1103, --活动礼包
		ShopPanelMonthCard			= 1104, --月卡
		ShopPanelRecharge			= 1105, --充值
		ShopPanelAvatar				= 1106, --皮肤
		ShopPanelGrowup				= 1107, --成长礼包
		SpecialOfferPanel			= 1108, --特价礼包

		--福利
		ActivityPanelSign			= 1201, --签到
		ActivityPanelMonth			= 1202, --月卡
		ActivityMenuLevelGift		= 1203, --等级礼包
		ActivityMenuFpGift			= 1204, --战斗力礼包

		--battlepass
		BattlePassMenuDaliy			= 1302, --每日
		BattlePassMenuWeek			= 1303, --每周
		BattlePassMenuUltimate		= 1304, --终极

		--设置
		SettingPanel		       	= 1900, --头像
		HeadSelectPanel       		= 1901, --头像更换
		KanBanSelectPanel      		= 1902, --看板娘更换
		BgSelectPanel 				= 1903, --背景更换
		CardBookPanel				= 1904, --图鉴
		SettingAudioPanelLanguage	= 1905, --语言

		--基地
		EquipComposePanel       	= 2100, --装备合成
		CardLoveListPanel      		= 2200, --爱恋
		LibraryCollectionPannel 	= 2300, --图书馆
		CardComposePanel			= 2400, --卡牌合成
		ArenaPanel       			= 2500, --竞技场
		TrialPanel       			= 2600, --试炼
		CardLevelUpStarCardListPanel= 2700, --卡牌升星
		RandomShopPanel       		= 2800, --随机商店 
		DailyRoundPanel       		= 2900, --每日副本
		FutureCardPanel				= 2910, --共鸣水晶
		ArenaMultPanel				= 2920, --多队竞技场

		StorePanelRole				= 2801, --角色商店
		StorePanelEquip				= 2802, --装备商店

		--公会
		GuildPanel					= 3000, --公会
		GuildCreatePanel			= 3100, --公会创建
		GuildSearchPanel			= 3200, --公会加入
		GuildMainInfoPanel			= 3300, --公会大厅
		GuildChatPanel				= 3400, --公会留言
		GuildDonatePanel			= 3600, --公会捐献
		HomeBaseSkillPanel			= 3700, --基地科技
		GuildIconSelectPanel		= 3800, --icon更换

		--战斗
		FastFightRewardPanel		= 4000, --快速挂机
		FightItemPanel				= 4100, --道具使用
		OnlineRewardPanel			= 4200, --时长礼包
		HarvestPanel				= 4300, --欢乐时光
		RoundBossPanel				= 4400, --随机boss
		MissionPanel				= 4500, --目标奖励
		FightIncomePanel			= 4600, --领取挂机奖励
		admobBuff					= 4900, --admobBuff
		admobReward					= 4901, --admobReward
		admobGacha					= 4902, --admobGacha

		FightSpeedUp				= 4700, --战斗加速
		FightGoToRoleShow			= 4800, --跳过立绘
		FightStatisticsPanel		= 5000, --战斗统计

		--目标奖励
		MissionPanelRound		= 4501, --关卡目标奖励
		MissionPanelCareer		= 1301, --生涯
		MissionPanelDaily		= 1302, --每日

		--卡牌
		CardAvatarUsePanel			= 5100, --卡牌皮肤
		CardCommentPanel			= 5200, --卡牌评论
		CardCvPanel					= 5300, --CV

		--商店入口
		ShopSpecialPanel			= 6101,
		ShopBubblePanel				= 6102,
	}

	self.list.ConfigState = cState;

	self.list.ConfigStateTypeList = {
		[cStateType.MAIN] = {
			[1]=cState.ShopPanel,				
			[3]=cState.Login7RewardPanel,		
			[6]=cState.MailPanel,
			[7]=cState.ChatPanel,
			[11]=cState.ActivityRechargePanel,
			[12]=cState.BattlepassEventPanel,
			[13]=cState.ThreeDayActivityPanel,
			[15]=cState.MainActivityBtn,
			[16]=cState.BgSelectPanel,
			[17]=cState.CardBookPanel,
			[18]=cState.ActivityPanelSign,
			[20]=cState.RankListPanel,
			[32]=cState.ShopSpecialPanel,
			[33]=cState.ShopBubblePanel,
		},
		[cStateType.SHOP] = {
			[1]=cState.ShopPanelShop,			
			[2]=cState.ShopPanelGift,			
			[3]=cState.ShopPanelGiftActivity,	
			[4]=cState.ShopPanelMonthCard,		
			[5]=cState.ShopPanelRecharge,	
			[10]=cState.ShopPanelAvatar,
			[12]=cState.ShopPanelGrowup
		},
		[cStateType.ACTIVITY] = {
			--[8]=cState.ActivityMenuLevelGift,
			--[9]=cState.ActivityMenuFpGift,
			[12]=cState.ActivityPanelSign,	
			--[201]=cState.ActivityPanelMonth,	
		},
		[cStateType.BATTLEPASS] = {
			[1]=cState.BattlePassMenuDaliy,
			[2]=cState.BattlePassMenuWeek,
			[3]=cState.BattlePassMenuUltimate,	
		},

		[cStateType.SETTING] = {
			[1]=cState.HeadSelectPanel,
			[2]=cState.KanBanSelectPanel,
			[3]=cState.BgSelectPanel,
			[4]=cState.CardBookPanel,	
		},
		[cStateType.HOME] = {
			[1]=cState.EquipComposePanel,       	
			[2]=cState.CardLoveListPanel,  	
			[3]=cState.LibraryCollectionPannel, 	
			[4]=cState.CardComposePanel,			
			[5]=cState.ArenaPanel,       			
			[6]=cState.TrialPanel,       			
			[7]=cState.CardLevelUpStarCardListPanel,
			[8]=cState.RandomShopPanel,       		
			[9]=cState.EventMainPanel,       		
			[10]=cState.FutureCardPanel,
			[11]=cState.ArenaMultPanel,
			[12]=cState.GuildPanel,       		
		},
		[cStateType.STORE] = {
			[8]=cState.StorePanelRole, 	
			[9]=cState.StorePanelEquip,  	
		},
		[cStateType.GUILD_MAIN] = {
			--[1]=cState.GuildMainInfoPanel,  
			[1]=cState.HomeBaseSkillPanel,
			[3]=cState.GuildChatPanel,   	
			[4]=cState.ShopPanelGuild,      	
			[5]=cState.GuildDonatePanel,
			[6]=cState.GuildIconSelectPanel,
		},
		[cStateType.FIGHT] = {
			[4]=cState.MissionPanel,
			[5]=cState.RoundBossPanel,
			[7]=cState.ChatPanel,
			[8]=cState.FightItemPanel,
			[20]=cState.admobBuff,
			[21]=cState.admobReward,
			[206]=cState.OnlineRewardPanel,
			[207]=cState.FastFightRewardPanel,
			[209]=cState.HarvestPanel,
		},
		[cStateType.MISSION] = {
			[1]=cState.MissionPanelRound,
			[2]=cState.MissionPanelCareer,
			[3]=cState.MissionPanelDaily,
		},
		[cStateType.CARD] = {
			[1]=cState.CardAvatarUsePanel,
			[2]=cState.CardCommentPanel,	
			[3]=cState.CardCvPanel,	
		}
	}

	self.list.RoundTargetRewardType = {
		ROUNE = 1,
		EVENT = 2,
		TRIAL = 3,
	}

	self.list.UserStatus = {
		NORMAL = 0,
		BANNED = 1,
		MUTED  = 2,
	}

	self.list.PackageNameCode = {
		['com.nani.ego.kr.aos'] = 12,
		['com.nani.ego.kr.one'] = 11,
		['com.nani.ego.kr.ios'] = 13,
		['com.nani.ego.kr.oneb'] = 14,
	}

	self.list.LoginPackageType = {
		['com.nani.ego.kr.aos'] = {
			[1]		= 1001,
			[2]		= 1002,
			[3]		= 1003,
			[100]	= 1100,
		},
		['com.nani.ego.kr.one'] = {
			[1]		= 2001,
			[2]		= 2002,
			[3]		= 2003,
			[100]	= 2100,
		},
		['com.nani.ego.kr.ios'] = {
			[1]		= 3001,
			[2]		= 3002,
			[3]		= 3003,
			[100]	= 3100,
		},
		['com.nani.ego.kr.oneb'] = {
			[1]		= 4001,
			[2]		= 4002,
			[3]		= 4003,
			[100]	= 4100,
		},
	}

	self.list.HelpShow = {
		CardLovePanel 				 = {1,1}, 	--爱恋 {说明图,显示位置(1:HeaderPanel,2:界面内)}
		GuildMainPanel 				 = {2,2},  	--公会
		GuildBossPanel 				 = {3,1}, 	--公会boss
		ArenaPanel 					 = {4,1}, 	--竞技场
		BareCollectPanel 			 = {5,1}, 	--救世手册
		CardLevelUpStarCardListPanel = {6,1},	--融合中心
		TrialPanel 					 = {7,1}, 	--试炼之路
		RoundBossPanel 				 = {8,1}, 	--随机boss
		CardBookPanel 				 = {9,1}, 	--图鉴
		FightPanel 					 = {10,2}, 	--战斗
		CardResolvePanel 			 = {11,1}, 	--重构中心
		MainPanel 					 = {12,2}, 	--主界面
		FutureCardPanel 			 = {13,1}, 	--共鸣水晶
		-- CopyRoundPanel 			 	 = {15,1}, 	--大冒险
		TrialSelPanel 				 = {17,1}, 	--属性试炼
		BelleBallMainPanel 			 = {18,1}, 	--弹球规则
		-- GachaListPanel 			 	 = {14,1}, 	--抽卡列表
	}

	self.list.FunnelType = {
		re_on		= 1,
		re_start	= 2,
		re_50		= 3,
		re_com		= 4,
		perm_on		= 5,
		term_on		= 6,
		term_agree	= 7,
		term_all	= 8,
		login_on	= 9,
		login_success=10,
		start_push	= 11,
		nickname_on	= 12,
		nickname_off= 13,
		movie_play	= 14,
		movie_end	= 15,
		movie_skip	= 16,
		tu_start	= 17,
		tu1			= 18,
		tu2			= 19,
		tu3			= 20,
		tu4			= 21,
		tu5			= 22,
		tu6			= 23,
		tu7_stage1	= 24,
		tu8_skill	= 25,
		tu9			= 26,
		tu10		= 27,
		tu11		= 28,
		tu12		= 29,
		tu13		= 30,
		tu14		= 31,
		tu15_levelup= 32,
		tu16		= 33,
		tu17		= 34,
		tu18		= 35,
		tu19		= 36,
		tu20		= 37,
		tu21		= 38,
		tu22_stage2	= 39,
		tu23		= 40,
		tu24		= 41,
		tu25		= 42,
		tu26_card	= 43,
		tu27		= 44,
		tu28		= 45,
		tu29		= 46,
		tu30		= 47,
		tu31		= 48,
		tu32		= 49,
		tu33		= 50,
		tu34		= 51,
		tu35		= 52,
		tu36		= 53,
		tu37_stage3	= 54,
		tu38		= 55,
		tu39		= 56,
		tu40		= 57,
		tu41		= 58,
		tu42		= 59,
		tu43_stage4	= 60,
		tu44		= 61,
		tu_finish	= 62,
	}

	self.list.MissionType = {
		MISSION_GACHA 				= 1;--抽卡
		MISSION_GACHA_SPECIAL		= 2;--特殊抽卡
		MISSION_GACHA_FIVE_STAR 	= 3;--五星抽卡
		MISSION_FAST_BATTLE 		= 4;--快速挂机
		MISSION_DAILY_BATTLE 		= 5;--每日副本
		MISSION_GUILD_BATTLE 		= 6;--公会战
		MISSION_LOGIN 				= 7;--登录
		MISSION_RANDOM_BOSS 		= 8;--随机boss
		MISSION_RANDOM_BOSS_PURPLE 	= 9;--随机boss紫色
		MISSION_RANDOM_BOSS_YELLOW 	= 10;--随机boss黄色
		MISSION_GOLD_COST 			= 11;--游戏币消耗
		MISSION_EQUIP_COMPOSE 		= 12;--装备合成
		MISSION_RANDOM_BOSS_REFRESH = 13;--随机boss刷新
		MISSION_HOME_SKILL 			= 14;--基地科技
		MISSION_CARD_COMPOSE 		= 15;--卡牌合成
		MISSION_GUILD_DONATE 		= 16;--公会捐献
		MISSION_ROLE_STAR_FIVE 		= 17;--获得5星英雄
		MISSION_ROLE_STAR_SIX 		= 18;--获得6星英雄
		MISSION_ROLE_STAR_TEN 		= 19;--获得10星英雄
		MISSION_ITEM_COST 			= 20;--道具使用
		MISSION_TRIAL 				= 21;--试炼
		MISSION_RANDOM_SHOP 		= 22;--刷新商店
		MISSION_ROLE_LEVEL 			= 23;--玩家等级
		MISSION_MAIN_CHAPTER 		= 24;--主线章节
		MISSION_MAIN_ROUND 			= 25;--主线关卡
		MISSION_COST_PARTNER 		= 26;--消耗卡牌
		MISSION_TRIAL_TIER 			= 27;--试炼通关层
		MISSION_EQUIP_PURPLE 		= 28;--紫色装备数量
		MISSION_EQUIP_YELLOW 		= 29;--黄色装备数量
		MISSION_LIFT_MISSION 		= 30;--累计完成生涯任务
		MISSION_FIGHT_INCOME 		= 31;--领取挂机收获
		MISSION_SHOP_BUY 			= 32;--商店购买次数
		MISSION_ROLE_STAR_NINE 		= 33;--获得9星英雄
		MISSION_ROLE_STAR_ELEVEN 	= 34;--获得11星英雄
		MISSION_ROLE_STAR_TWELVE 	= 35;--获得12星英雄
		MISSION_ARENA_CHALLENGE_NUM = 36;--竞技场挑战次数
		MISSION_ARENA_WIN_NUM 		= 37;--竞技场胜利次数
		MISSION_CARD_LEVEL_UP 		= 38;--卡牌每天升级一次
		MISSION_GUILD_RAID_CHALLENGE_NUM = 39;--公会boss挑战次数
	}
	
	self:GenTriangleValue();

end

function Enum:getTable(table_name)
	return self.list[table_name];
end

function Enum:TriangleCos(key)
	if not self.list.TriangleCos[key] then
		self.list.TriangleCos[key] = tonumber(string.format("%0.4f", math.cos(key)));
	end
	return self.list.TriangleCos[key];
end

function Enum:TriangleSin(key)
	if not self.list.TriangleSin[key] then
		self.list.TriangleSin[key] = tonumber(string.format("%0.4f", math.sin(key)));
	end
	return self.list.TriangleSin[key];
end

function Enum:GenTriangleValue()
	self.list.TriangleCos = {};
	self.list.TriangleSin = {};
	for i=0, 90 do
		local v = tonumber(string.format("%0.4f", math.sin(math.rad(i))));
		self.list.TriangleSin[i] = v;
		self.list.TriangleSin[180-i] = v;
		self.list.TriangleSin[i+180] = -v;
		self.list.TriangleSin[360-i] = -v;
		self.list.TriangleCos[90-i] = v;
		self.list.TriangleCos[i+90] = -v;
		self.list.TriangleCos[270-i] = -v;
		self.list.TriangleCos[270+i] = v;
	end
end

function Enum:ChangeDefFont( ln )
	-- body
	self.list.SystemFont.FONT_SIYUAN = 'font/SourceHanSansCN-Medium.otf';
	self.list.SystemFont.FONT_IMPACT ='font/SourceHanSansCN-Medium.otf';
   	self.list.SystemFont.FONT_HUAKANG ='font/SourceHanSansCN-Medium.otf';
    self.list.SystemFont.FONT_JP="font/SourceHanSansCN-Medium.otf";
end

cc.exports.TableName = {
	SkillScript = 'skill_script',
	SkillEffect = 'skill_effect',
}

cc.exports.Enum = Enum:create();
