--globalfunctions.lua

--========================================================================
--========================================================================
--全局公用函数

local GlobalFunctions = class("GlobalFunctions")
function GlobalFunctions:ctor()
end

function GlobalFunctions:containsTouchLocation(ctrl, touch)
	if not ctrl.convertToNodeSpace or not ctrl.getContentSize then
		print('no')
		return false;
	end
	local location = touch:getLocation();
	local locationInNode = ctrl:convertToNodeSpace(location);
	print(locationInNode.x, locationInNode.y)
	local size = ctrl:getContentSize();
	local rect = cc.rect(0, 0, size.width, size.height)
	if not cc.rectContainsPoint(rect, locationInNode) then
		return false;
	end
	return true;
end

function GlobalFunctions:genSpriteByCache(name)
	local sprite = nil;
	if not cc.SpriteFrameCache:getInstance():getSpriteFrameByName(name) then
		local cache = cc.SpriteFrameCache:getInstance()
	    cache:addSpriteFrames();
	end

	sprite = cc.Sprite:createWithSpriteFrameName(name);
	return sprite;
end
--时间转换函数   秒 => 小时:分钟:秒 
function GlobalFunctions:ChangeTime( time, separator, ...)
	if time == nil then
		print('-->>function ChangeTime 没有时间值传入')
		return
	end
	--local tab = 
	local separator = separator or ":"
	separator = tostring(separator)
	local time = tonumber(time)

	local hour = math.floor( time/3600 )
	local sum = time - hour*3600
	local minute = math.floor( sum / 60 )
	local second = sum - minute*60
	local result = string.format('%02d'.. separator ..'%02d'.. separator .. '%02d' , hour, minute, second)
	return result
end
--时间转换为 枚举类型
function GlobalFunctions:convertTimeEnumType( time )
	-- local timeEnum = {
	-- 	TimeEnumNow = "在线",
	-- 	TimeEnum5m	= "五分钟前",
	-- 	TimeEnum10m	= "十分钟前",
	-- 	TimeEnum30m	= "三十分钟前",
	-- 	TimeEnum1h	= "一小时前",
	-- 	TimeEnum3h	= "三小时前",
	-- 	TimeEnum12h = "十二小时前",
	-- 	TimeEnum1d	= "一天前",
	-- 	TimeEnum3d	= "三天前",
	-- }
	local timeEnum = Enum:getTable("TimeEnum");

	local curTime = TimeManager:getCurTime();
	local offTime =  curTime - time;

	local result = timeEnum.TimeEnumNow;
	if offTime < 60*5 then
		result = timeEnum.TimeEnumNow;
	elseif offTime < 60*10 then 
		result = timeEnum.TimeEnum5m;
	elseif offTime < 60*30 then 
		result = timeEnum.TimeEnum10m;
	elseif offTime < 60*60 then 
		result = timeEnum.TimeEnum30m;
	elseif offTime < 60*60*3 then 
		result = timeEnum.TimeEnum1h;
	elseif offTime < 60*60*12 then 
		result = timeEnum.TimeEnum3h;
	elseif offTime < 60*60*24 then 
		result = timeEnum.TimeEnum12h;
	elseif offTime < 60*60*24*3 then 
		result = timeEnum.TimeEnum1d;
	else
		result = timeEnum.TimeEnum3d;
	end
	return result;
end

function GlobalFunctions:getLastDay( loginTime )
	local ret = 0;
	local loginDay = tonumber(os.date("%d",loginTime));
	local h = tonumber(os.date("%H",loginTime));
	local m = tonumber(os.date("%M",loginTime));
	local s = tonumber(os.date("%S",loginTime));
	local loginDayLastSec = 3600*24 - h*3600 - m*60 - s;

	local curTime = TimeManager:getCurTime();
	local curDay = tonumber(os.date("%d",curTime));
	local lastTime = curTime-loginTime;
	if lastTime < 3600*24 then
		if curDay == loginDay then
			ret = 0;
		else
			ret = 1;
		end
	else
		ret = math.floor((lastTime-loginDayLastSec)/(3600*24)) + 1
	end
	return ret;
end

function GlobalFunctions:ChangeFormatTime( time )
	-- body
	local ret = ''
    if time > 86400 then
        local day = math.floor(time / 86400);
        local hour = math.floor((time - day * 86400) / 3600);
        ret = day..LANG.UI_MISSION_21..hour..LANG.UI_MISSION_22
    elseif time > 0 then
        -- ret = Sec2Time(math.floor(time));

        local time = tonumber(time);
		local hour = math.floor( time/3600 );
		local sum = time - hour*3600;
		local minute = math.floor( sum / 60 );

		if hour > 0 then
			ret = string.format(LANG.UI_OFFLINE_2 , (hour and tostring(hour) or ''), (minute and tostring(minute) or '') ) ;
		elseif minute > 0 then
			ret = string.format(LANG.UI_OFFLINE_3 , (minute and tostring(minute) or '') ) ;
		end

    end
    return ret;
end

--获取一个字符串多项式的值
function GlobalFunctions:GetMathsValue(Args)
	--多项式检测
	local legalChar = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', '.', '+', '-', '*', '/', '(', ')', '^'};
	local haveIllegalChar = false;
	for i=1, string.len(Args) do
		haveIllegalChar = false;
		local argsChar = string.sub(Args,i,i);
		local isMatch = false;
		for _, char in pairs(legalChar) do
			if string.byte(char) == string.byte(argsChar) then
				isMatch = true;
				break;
			end
		end
		if isMatch == false then
			haveIllegalChar = true;
			break;
		end
	end
	if haveIllegalChar == true then
		return tonumber(Args);
	end

	local fun = assert(loadstring('return ' .. Args));
	return fun();
end

function GlobalFunctions:fixControlMid(control,margin)
	if not control then
		return
	end

	local _height = control:getContentSize().height;
	local _width  = control:getContentSize().width;
	local childWidth = 0;
	local ctrlWidth = 0;

	for _k , ctrl in pairs(control:getChildren()) do
		ctrl:setAnchorPoint(cc.p(0.5,0.5))
		if ctrlWidth == 0 then
			ctrlWidth = ctrl:getContentSize().width;
		end
		childWidth = childWidth + ctrl:getContentSize().width + (margin ~= nil and margin or 0);
	end

	childWidth = childWidth - (margin ~= nil and margin or 0);

	local beginX = (_width - childWidth)/2 + ctrlWidth / 2;
	local nextX = 0;
	for _k , ctrl in pairs(control:getChildren()) do
		ctrl:setPosition(cc.p(beginX + nextX,_height/2));
		nextX = nextX + ctrl:getContentSize().width + (margin ~= nil and margin or 0);
	end
end
function GlobalFunctions:fixControlLeft(control,margin)
	if not control then
		return
	end

	local _height = control:getContentSize().height;
	local _width  = control:getContentSize().width;
	local childWidth = 0;
	local ctrlWidth = 0;


	for _k , ctrl in pairs(control:getChildren()) do
		ctrl:setAnchorPoint(cc.p(0.5,0.5))
		if ctrlWidth == 0 then
			ctrlWidth = ctrl:getContentSize().width;
		end
		childWidth = childWidth + ctrl:getContentSize().width + (margin ~= nil and margin or 0);
	end

	childWidth = childWidth - (margin ~= nil and margin or 0);

	local beginX = ctrlWidth / 2;
	local nextX = 0;
	for _k , ctrl in pairs(control:getChildren()) do
		ctrl:setPosition(cc.p(beginX + nextX,_height/2));
		nextX = nextX + ctrl:getContentSize().width + (margin ~= nil and margin or 0);
	end
end
function GlobalFunctions:fixControlMidLeft(control , count  , margin)
	if not control then
		return
	end

	local _height = control:getContentSize().height;
	local _width  = control:getContentSize().width;
	local childWidth = 0;
	local ctrlWidth = 0;
	for _k , ctrl in pairs(control:getChildren()) do
		ctrl:setAnchorPoint(cc.p(0.5,0.5))
		if ctrlWidth == 0 then
			ctrlWidth = ctrl:getContentSize().width;
		end
		if childWidth == 0 then
			childWidth = (ctrl:getContentSize().width + (margin ~= nil and margin or 0)) * count;
		end
	end

	childWidth = childWidth - (margin ~= nil and margin or 0);

	local beginX = (_width - childWidth)/2 + ctrlWidth / 2;
	local nextX = 0;
	for _k , ctrl in pairs(control:getChildren()) do
		ctrl:setPosition(cc.p(beginX + nextX,_height/2));
		nextX = nextX + ctrl:getContentSize().width + (margin ~= nil and margin or 0);
	end
end

--==============================--
--desc:多个物品弹出
--time:2019-08-05 07:58:48
--@itemReward:
--@roleReward:
--@text:
--@return 
--==============================--
function GlobalFunctions:showRewardPrompt(rewardTable , text)
	if rewardTable == nil then
		return;
	end
	local money = rewardTable.money;
	local itemReward = rewardTable.itemChange;
	local roleReward = rewardTable.newPartner;
	local equipReward = rewardTable.newEquip;

	if money and money.change then
		if not string.find(money.change , '-') then
			local name = ResTable:getValue('item',tonumber(MONEY_ID),'name');
			Prompt:Show(string.format(text or LANG.UI_SHOP_45, name, money.change));
		end
	end

	if itemReward then
		local items = {};
		for _k , item  in pairs(itemReward) do
			if item and item.no then
				local addNum = tonumber(item.addNum) or tonumber(item.item_num);
				if addNum > 0 then 
					if not items[tostring(item.no)] then
						items[tostring(item.no)] = 0;
					end
					items[tostring(item.no)] = items[tostring(item.no)] + addNum;
				end
			end
		end
		for _k , addNum in pairs(items) do
			local name = ResTable:getValue('item',tonumber(_k),'name');
			Prompt:Show(string.format(text or LANG.UI_SHOP_45, name, addNum) , Enum:getTable('PromptShowType').SHOW_TYPE_TWO);
		end
	end
	if roleReward then
		for _k , role  in pairs(roleReward) do
			local roleId = ResTable:getValue('role',role.no,'role_id');
			local name = ResTable:getValue('role_info',roleId,'name');
			Prompt:Show(string.format(text or LANG.UI_SHOP_45, name, 1) , Enum:getTable('PromptShowType').SHOW_TYPE_TWO);
		end
	end
	if equipReward then
		for _k , equip  in pairs(equipReward) do
			local name = ResTable:getValue('item',equip.no,'name');
			Prompt:Show(string.format(text or LANG.UI_SHOP_45, name, 1) , Enum:getTable('PromptShowType').SHOW_TYPE_TWO);
		end
	end
end
--==============================--
--desc:主动弹出错误提示框
--time:2019-08-28 02:31:27
--@msg:
--@return 
--==============================--
function GlobalFunctions:showErrorPromt( msg )
	if define.debug_model == true  then
		MessageBox:create(msg,1);
	end
end

-- itemId,count 与IconTemplate逻辑一致！！
-- 通用装备 道具 详情
function GlobalFunctions:showCommonInfo( itemId,count )
	UIManager:push('CommonInfoPanel',itemId,count)
end

function GlobalFunctions:cutText(text , length)
	local nextUtf8strIndex = function(str , index)
		if string.byte(str , index) > 127 then
			index = index + 3;
		elseif string.byte(str , index) < 128 then
			index = index + 1;
		end
		return index;
	end
	local index = 1;
	local len = 0;
	local tempText = '';
	while index < string.len(text) do
		local oldIndex = index;
		index = nextUtf8strIndex(text , index)
		local sub = string.sub(text , oldIndex , index - 1);
		tempText = tempText..tostring(sub);
		len = len + 1;
		if len >= length then
			break;
		end
	end
	return tempText..'...';
end

function GlobalFunctions:numberToK(number)
	if not number then
		return;
	end
	number = tonumber(number);
	local tmp = math.floor(number / 1000);
	return tmp > 0 and tmp..'K' or number;
end

--tiem YY-MM-DD HH:MM:SS
function GlobalFunctions:timeFormat(time)
	if not time then
		return;
	end
	local timeArray= string.split(tostring(time), " ");
	local date = string.split(timeArray[1] , "-");
	local time = string.split(timeArray[2] , ":");
    return {year = date[1] , month = date[2] , day = date[3] , hour = time[1] , minute = time[2] , second = time[3]};
end

--溶解
function GlobalFunctions:getRongJieShader()
	local vertShaderByteArray = "\n".. 
	"attribute vec4 a_position; \n" ..
	"attribute vec2 a_texCoord; \n" ..
	"attribute vec4 a_color; \n" ..
	"#ifdef GL_ES \n" ..
	"varying lowp vec4 v_fragmentColor; \n" ..
	"varying mediump vec2 v_texCoord; \n" ..
	"#else \n" ..
	"varying vec4 v_fragmentColor; \n" ..
	"varying vec2 v_texCoord; \n" ..
	"#endif \n" ..
	"\n" ..
	"void main()\n" ..
	"{\n" ..
	    "gl_Position = CC_PMatrix * a_position;\n" ..
	    "v_fragmentColor = a_color;\n" ..
	    "v_texCoord = a_texCoord;\n" ..
	"}" 

	local flagShaderByteArray = "\n" .. 
	"#ifdef GL_ES \n" ..
	"precision mediump float; \n" ..
	"#endif \n" ..
	"  \n" ..
	"varying vec2 v_texCoord; \n" ..
	"uniform sampler2D u_texture1; \n" ..
	"  \n" ..
	"void main(void) \n" ..
	"{ \n" ..
	    "gl_FragColor=texture2D(CC_Texture0,v_texCoord); \n" ..
	    "vec4 col=texture2D(u_texture1,v_texCoord); \n" ..
	    "float threshold = abs(sin(CC_Time[3] * 0.1)); \n" ..
	    "if(col.g<threshold){ \n" ..
	        "discard; \n" ..
	    "} \n" ..
	"}"


	return vertShaderByteArray, flagShaderByteArray;
end

function GlobalFunctions:setSpriteRongJie( sprite, noiseSp )
	local vertShaderByteArray, flagShaderByteArray = GlobalFunctions:getRongJieShader();
	local glProgram = cc.GLProgram:createWithByteArrays(vertShaderByteArray, flagShaderByteArray);
	-- glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
	-- glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
	-- glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
	glProgram:link();
	-- glProgram:updateUniforms();
	sprite:setGLProgram(glProgram);

	sprite:getGLProgramState():setUniformTexture("u_texture1", noiseSp:getTexture());
end

--置灰
function GlobalFunctions:getVFShader(r,g,b)
	local vertShaderByteArray = "\n"..  
	"attribute vec4 a_position; \n" ..  
	"attribute vec2 a_texCoord; \n" ..  
	"attribute vec4 a_color; \n"..  
	"varying vec4 v_fragmentColor; \n" ..  
	"varying vec2 v_texCoord;  \n"..  
	"void main() \n"..  
	"{ \n" ..  
	"gl_Position = CC_PMatrix * a_position; \n" .. 
	"v_fragmentColor = a_color; \n" .. 
	"v_texCoord = a_texCoord; \n" .. 
	"}";

	local flagShaderByteArray = "\n" ..  
	"varying vec4 v_fragmentColor; \n" ..  
	"varying vec2 v_texCoord; \n" ..  
	"void main() \n" ..  
	"{"..
		"vec4 v_orColor = v_fragmentColor * texture2D(CC_Texture0, v_texCoord);"..
    	"float gray = dot(v_orColor.rgb, vec3("..r..","..g..","..b.."));"..
    	"gl_FragColor = vec4(gray, gray, gray, v_orColor.a);"..
	"}";
	return vertShaderByteArray, flagShaderByteArray;
end

function GlobalFunctions:setSpriteGrey( sprite ,r,g,b)

	r = r or 0.299
	g = g or 0.587
	b = b or 0.114

	local vertShaderByteArray, flagShaderByteArray = GlobalFunctions:getVFShader(r , g , b);
	local glProgram = cc.GLProgram:createWithByteArrays(vertShaderByteArray, flagShaderByteArray);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
	glProgram:link();
	glProgram:updateUniforms();
	sprite:setGLProgram(glProgram);
end

function GlobalFunctions:getRemoveVFShader()
	local vertShaderByteArray = "\n"..  
	"attribute vec4 a_position; \n" ..  
	"attribute vec2 a_texCoord; \n" ..  
	"attribute vec4 a_color; \n"..  
	"varying vec4 v_fragmentColor; \n" ..  
	"varying vec2 v_texCoord;  \n"..  
	"void main() \n"..  
	"{ \n" ..  
	"gl_Position = CC_PMatrix * a_position; \n" .. 
	"v_fragmentColor = a_color; \n" .. 
	"v_texCoord = a_texCoord; \n" .. 
	"}";

	local flagShaderByteArray = "\n" ..  
	"varying vec4 v_fragmentColor; \n" ..  
	"varying vec2 v_texCoord; \n" ..  
	"void main() \n" ..  
	"{"..
		"gl_FragColor = texture2D(CC_Texture0, v_texCoord);"..
	"}";
	return vertShaderByteArray, flagShaderByteArray;
end
function GlobalFunctions:removeSpriteGrey(sprite)
	local vertShaderByteArray, flagShaderByteArray = GlobalFunctions:getRemoveVFShader();
	local glProgram = cc.GLProgram:createWithByteArrays(vertShaderByteArray, flagShaderByteArray);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
	glProgram:link();
	glProgram:updateUniforms();
	sprite:setGLProgram(glProgram);
end

function GlobalFunctions:getGaussianShader()
	local vertShaderByteArray = "\n"..
    "attribute vec4 a_position; \n" ..
    "attribute vec2 a_texCoord; \n" ..
    "attribute vec4 a_color; \n" ..
    "#ifdef GL_ES \n" .. 
    "varying lowp vec4 v_fragmentColor;\n" ..
    "varying mediump vec2 v_texCoord;\n" ..
    "#else \n" ..
    "varying vec4 v_fragmentColor;\n" ..
    "varying vec2 v_texCoord;\n" ..
    "#endif\n" ..
    "void main()\n" ..
    "{\n" .. 
    " gl_Position = CC_PMatrix * a_position;\n"..
    " v_fragmentColor = a_color;\n"..
    " v_texCoord = a_texCoord;\n" ..
	"}\n"


	local flagShaderByteArray =  "\n" ..
	"#ifdef GL_ES \n" ..
	"precision mediump float; \n" ..
	"#endif \n" ..
	"varying vec4 v_fragmentColor; \n" ..
	"varying vec2 v_texCoord; \n" ..
	"uniform vec2 resolution; \n" ..
	"uniform float blurRadius;\n" ..
	"uniform float sampleNum; \n" ..
	"vec4 blur(vec2);\n" ..
	"\n" ..

	"void main(void)\n" ..
	"{\n" ..
	"    vec4 col = blur(v_texCoord); //* v_fragmentColor.rgb;\n" ..
	"    gl_FragColor = vec4(col) * v_fragmentColor;\n" ..
	"}\n" ..
	"\n" ..

	"vec4 blur(vec2 p)\n" ..
	"{\n" ..
	"    if (blurRadius > 0.0 && sampleNum > 1.0)\n" ..
	"    {\n" ..
	"        vec4 col = vec4(0);\n" ..
	"        vec2 unit = 1.0 / resolution.xy;\n" ..
	" \n" ..       
	"        float r = blurRadius;\n" ..
	"        float sampleStep = r / sampleNum;\n" ..
	"\n" ..        
	"        float count = 0.0;\n" ..
	"\n" ..        
	"        for(float x = -r; x < r; x += sampleStep)\n" ..
	"        {\n" ..
	"            for(float y = -r; y < r; y += sampleStep)\n" ..
	"            {\n" ..
	"                float weight = (r - abs(x)) * (r - abs(y));\n" ..
	"                col += texture2D(CC_Texture0, p + vec2(x * unit.x, y * unit.y)) * weight;\n" ..
	"                count += weight;\n" ..
	"            }\n" ..
	"        }\n" ..
	"\n" ..        
	"        return col / count;\n" ..
	"    }\n" ..
	"\n" .. 
	"    return texture2D(CC_Texture0, p);\n" ..
	"}\n"

	return vertShaderByteArray,flagShaderByteArray
end

function GlobalFunctions:setGaussianGary(sprite , blurRadius , sampleNum)
	blurRadius = blurRadius or 3;
	sampleNum = sampleNum or 2;
	local vertShaderByteArray, flagShaderByteArray = GlobalFunctions:getGaussianShader();
	local pProgram = cc.GLProgram:createWithByteArrays(vertShaderByteArray,flagShaderByteArray)
    local glprogramstate = cc.GLProgramState:getOrCreateWithGLProgram(pProgram)

	local size = sprite:getTexture():getContentSizeInPixels()
    sprite:setGLProgramState(glprogramstate)
    glprogramstate:setUniformVec2("resolution", cc.p(size.width, size.height));
    glprogramstate:setUniformFloat("blurRadius", blurRadius);
    glprogramstate:setUniformFloat("sampleNum", sampleNum);
    --glprogramstate:setUniformVec2("pix_size", cc.p(0,0));
end
--==============================--
--desc:无序table转为有序table并排序
-- 按key值从小到大排序
--如果key有跳过数字，则排序后key~= 排序前key
--time:2019-08-17 05:34:15
--@t:
--@return 
--==============================--
function GlobalFunctions:sortTableByKey( t )

	if t ==nil or next(t) == nil then
		return nil;
	end

	local allkeys = table.keys(t);
	table.sort( allkeys,function ( key1,key2 )
		return tonumber(key1) < tonumber(key2)
	end)

	local retT = {}
	for i=1,#allkeys do
		retT[i] = t[allkeys[i]]
	end

	return retT;
end

function GlobalFunctions:lAnimationName( name )
	local ret = model.UserDefaultModel:getLanguageSet();
	return ret..'_'..name;
end

function GlobalFunctions:getURLbyLanguage()
	local ret = 'https://helpdesk.433.co.kr/?n=ramengoen'
	local lg = model.UserDefaultModel:getLanguageSet();
	if lg == 'kr' then
		ret = 'https://helpdesk.433.co.kr/?n=ramengo'
	elseif lg == 'cn' or lg == 'tw' then
		ret = 'https://helpdesk.433.co.kr/?n=ramengotc'
	elseif lg == 'jp' then
		ret = 'https://helpdesk.433.co.kr/?n=ramengojp'
	end
	return ret;
end

local isKr = true
function GlobalFunctions:isKorean()
	return isKr
end

function GlobalFunctions:loadLanguage()

	GlobalFunctions:recordTime('fb-log---loadLanguage')
	local ret = model.UserDefaultModel:getLanguageSet();

	cc.exports.LANG = require("language.language_cn");

	local storagePath = define.writablePath .. "/new_version/hotfix/";
	local fullPath = define.writablePath .. "/new_version/"
	Enum:ChangeDefFont( ret );
	cc.FileUtils:getInstance():purgeCachedEntries()
	cc.FileUtils:getInstance():addSearchPath('res_'..ret..'/', true)
	cc.FileUtils:getInstance():addSearchPath(fullPath..'res/', true)
	cc.FileUtils:getInstance():addSearchPath(storagePath..'res/', true)
	
	cc.FileUtils:getInstance():addSearchPath(fullPath..'res_'..ret..'/',true)
	cc.FileUtils:getInstance():addSearchPath(storagePath..'res_'..ret..'/', true)

	cc.FileUtils:getInstance():addSearchPath(storagePath..'src/', true)
	self:initLanguage(LANG)

	if ret == 'kr' or ret == '' then
		isKr = true
	else
		isKr = false
	end

	GlobalFunctions:recordTime('fb-log---loadLanguage end')

end

local fonts = Enum:getTable("SystemFont")
function GlobalFunctions:createTitleNode( root, title, subtitle, x, y )
	-- body
	local titleNode = cc.Node:create():addTo( root );
	titleNode:setPosition( x , y );

	local label = cc.Label:createWithTTF(title , fonts.FONT_SIYUAN , 20);
	label:addTo(titleNode);
	label:setName('title');
	label:setTextColor(cc.c3b(255 , 255 , 255));
	label:enableOutline(cc.c4b(60 , 60 , 60 , 60) , 2);

	--[[
	local sublabel = cc.Label:createWithTTF('-'..subtitle..'-' , fonts.FONT_SIYUAN , 9);
	sublabel:setPosition(0, -18);
	sublabel:setName('sub');
	sublabel:addTo(titleNode);
	sublabel:setTextColor(cc.c3b(0 , 142 , 219));
	]]
	return titleNode;
end

local orignLang = nil
function GlobalFunctions:initLanguage(t)
	if orignLang == nil then
		orignLang = clone(t)
	end
	
	ResTable:loadLanguageTable()

	for k,v in pairs(t) do
		if type(v) ~= 'table' then
		  	t[k] = ResTable:getLangByNum( orignLang[k] ) --v

		else
			for k1,v1 in pairs(v) do
				if type(v1) ~= 'table' then
					v[k1] = ResTable:getLangByNum( orignLang[k][k1] ) --v1
				else
					for k2,v2 in pairs(v1) do
						v1[k2] = ResTable:getLangByNum( orignLang[k][k1][k2] ) --v2
					end
					v[k1] = v1
				end
				
			end
			t[k] = v

		end
	end
	cc.exports.LANG = t

	ResTable:resetReplaceFieldTable()
end

function GlobalFunctions:recordTime(msg)
	-- body
	if true then
		return;
	end
	if self.lastTims == nil then
		self.lastTims = socket.gettime()*1000;
		print(msg, 0)
		return;
	end

	local curTime = socket.gettime()*1000
	print( msg, math.floor(curTime-self.lastTims) )
	self.lastTims = curTime;
	
end

function GlobalFunctions:getItemIconFileAndNum(item)
	local num = 1;

	if not item then
		return '' , num;
	end

	local id = item[1]
    if id == ROLE_TYPE then
        id = item[2];
        local data = ResTable:getRowData('role' , id);
        if not data then
            return;
        end
        local name = ResTable:getValue('role_info',data.role_id,'name');
        local imagePath = ResTable:getValue('role_resource', data.resource_id , 'icon');
        if not imagePath then
            return;
        end
        return 'image/icon/'..imagePath..'.png' , num, name;
    elseif id == ROLE_AVATAR_TYPE then
        id = item[2];
        local data = ResTable:getRowData('role_avatar' , id);
        if not data then
            return;
        end

        local imagePath = ResTable:getValue('role_resource', data.resource_id , 'icon');
        if not imagePath then
            return;
        end
        return 'image/icon/'..imagePath..'.png' , num, data.name;
    elseif id == BARE_COLLECT_TYPE then
        id = item[2];
        local data = ResTable:getRowData('role' , id);
        if not data then
            return;
        end

        local name = ResTable:getValue('role_info',data.role_id,'name');
        local imagePath = ResTable:getValue('role_resource', data.resource_id , 'icon');
        if not imagePath then
            return;
        end
        return 'image/icon/'..imagePath..'.png' , num, name;
    elseif id > 80000 and id < 90000 then
        num = item[2];
        local data = ResTable:getRowData('equip', id);
        if not data then
            return;
        end

        local itemData = ResTable:getRowData('item' , id);
        return 'image/icon/E'..itemData.icon..'.png' , num, itemData.name;
    else
        num = item[2];
        if id == 10001 then
            num = ConvertStrToDigitUnit(tostring(num));
        end
        local data = ResTable:getRowData('item', id)
        if not data then
            return;
        end
        return 'image/icon/I'..data.icon..'.png' , num, data.name;
	end
	
	return '' , num, '';
end

function GlobalFunctions:getHeadIconFile(headIcon)
	if not headIcon then
		return '';
	end
	local resourceId = 1;
	if headIcon < 1000 then
		resourceId = ResTable:getValue('role' , headIcon,'resource_id');
	else
		resourceId = ResTable:getValue('role_avatar' , headIcon,'resource_id');
	end
	local imagePath = ResTable:getValue('role_resource', resourceId , 'icon');
	return 'image/icon/'..imagePath..'.png';
end

function GlobalFunctions:getHeadIconData(no)
	local data = {roleType = ROLE_AVATAR_TYPE,no = no}
	if no < 1000 then
		data.roleType = ROLE_TYPE;
		local cardNos=model.CardModel:getCardByNo(no);
		local maxQualityCard = nil;
		for pid,_v in pairs(cardNos) do
			local card = model.CardModel:GetCard(pid);
			if card and (not maxQualityCard or card.quality > maxQualityCard.quality) then
				maxQualityCard = card;
			end
		end
		if maxQualityCard then
			data.quality = maxQualityCard.quality;
			data.starLv = maxQualityCard.star_lv;
		end
	end
	return data;
end

function GlobalFunctions:createTitle(titleName , width , height , enTitleName , notShoLight)
	titleName = titleName or '';
	width = width or 604;
	height = height or 46

	local titleNode = cc.Node:create();

	local titleBg = cc.Scale9Sprite:create('image/commonImg/top_1_bg_71_46.png');
	titleBg:addTo(titleNode);
    titleBg:setCapInsets(cc.rect(10,0,51,46));
	titleBg:setContentSize(cc.size(width , height));

	if not notShoLight then
		local lightName = 'menu_light_582_36';

		local titleLight = cc.Sprite:create('image/commonImg/'..lightName..'.png');
		titleLight:addTo(titleNode);
		titleLight:setPosition(0 , height/2);
	end

	if titleName then
		local title = cc.Label:createWithTTF(titleName , fonts.FONT_SIYUAN , 18);
		title:addTo(titleNode);
		title:setName('title');
	end
	--[[
	if enTitleName then
		local title = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 8);
		title:addTo(titleNode);
		title:setName('enTitle');
		title:setPosition(0 , -18);
		title:setTextColor(cc.c3b(0,140,220));
	end
	]]
	return titleNode;
end

-- 播放CV时，同时显示一句话，
-- 父节点
-- roleId 非看板娘时传入roleId,看板娘使用nil
-- cvPos 默认坐标
function GlobalFunctions:showCVInfo( fatherNode,roleId,cvType,cvPos1,delayTime, endCallBack ,infoType)

	if fatherNode == nil then
		return 
	end

	local infoNode = fatherNode:getChildByTag(999)
	if infoNode then
		infoNode:stopAllActions()
		infoNode:removeFromParent();
	end

	-- cvPos1 固定位置 距离右下角
	local worldPos = cc.p(StageSize.width/2,220) --世界坐标
	local cvPos = fatherNode:convertToNodeSpace(worldPos);

	-- local testInfo = {
	-- 	'근데 마스터님은 안 궁금하세요?',
	-- 	'어떤 소설 속 주인공인지? ',
	-- 	'마스터님이 무슨 상상을 하시든 그 이상일 수도 있는데?',
	-- 	'마스터님? 여긴 어떻게?... ',
	-- 	'당신이 나의 마스터? 나랑 같이 물놀이 할래? 헤헷♥',
	-- 	'111마스터.. 왜 자꾸 싫다는거야?\t111마스터.. 왜 자꾸 싫다는거야?'
	-- }
	-- local cvInfo = testInfo[math.random( 1,6 )]
	local cvInfo = '';
	local retData = 0;
	if infoType and infoType == 1 then
		cvInfo,retData = model.UserModel:getLoveCvInfo(roleId);
	else
		cvInfo = model.UserModel:getCurrentCVInfo(roleId,cvType);
	end
	-- cvInfo如果需要分页，需要在配置信息里面添加\t
	-- cvInfo = '근데 마스터님은 안 궁금하세요?\t어떤 소설 속 주인공인지?\t마스터님이 무슨 상상을 하시든 그 이상일 수도 있는데?당신이 나의 마스터?\t 나랑 같이 물놀이 할래? 헤헷♥'
	
	local cvInfoArr = {}
	local startIndex,endIndex,_ = 0,0,0
	local bTrue = true 
	local arrIndex = 1;
	while bTrue do
		_,endIndex = string.find(cvInfo,'\t',startIndex)
		local tempT = string.sub(cvInfo,startIndex,endIndex);
		cvInfoArr[arrIndex] = tempT;
		if endIndex == nil then 
			bTrue = false 
		else
			startIndex = endIndex+1
		end
		arrIndex = arrIndex + 1;
	end 


	local curCvArrIndex,curCvInfo = next(cvInfoArr)
	if curCvInfo == nil then
		return 
	end
	-- cvPos = cc.pAdd(cvPos,cc.p(-180,100))


	infoNode = cc.Node:create()
		:addTo(fatherNode)
		:setTag(999)
		:setPosition(cvPos)

	local msgList = {}

	local msgNode = cc.Node:create()
	:addTo(infoNode)

	local infoBg = cc.Sprite:create('image/commonImg/cv_info_bg.png')
		:addTo(msgNode)
		-- :setScale(-1,-1)
	-- :setPosition(0 , height/2)

	local title = cc.Label:createWithTTF( '', fonts.FONT_CV , 20)
		:addTo(msgNode)
		:setDimensions(600, 30)
		:setContentSize(cc.size(600, 30))
		:setAnchorPoint(cc.p(0.5,0.5))
		:setPosition(cc.p(0,0)) -- -284
		:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
		-- :setAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER,cc.TEXT_ALIGNMENT_CENTER)
		-- :setOverflow(cc.LabelOverflow.SHRINK)
	table.insert(msgList, {node=msgNode, label=title})


	local totalLen = string.len( curCvInfo )
	local curLen = 1;
	local tempStr = string.sub(curCvInfo, 1,curLen)
	title:setString(tempStr)
	local witeTime = 0;
	local bwite = false
	
	local callback =  function (  )
		if curLen >= totalLen then 
			curCvArrIndex,curCvInfo = next(cvInfoArr,curCvArrIndex)
			if curCvArrIndex == nil or totalLen < 1 then
				-- print('============= stop ===================== ')
				infoNode:stopAllActions()
				infoNode:runAction(cc.Sequence:create(cc.DelayTime:create(10),cc.RemoveSelf:create()))
				if endCallBack then
					endCallBack();
				end
				return ;
			end
			curLen = 1;
			totalLen = string.len( curCvInfo )
			bwite = true;
			witeTime = 0;
		end
		if bwite == true then
			if witeTime==0 then
				for k,v in pairs(msgList) do
					v.node:runAction(cc.MoveBy:create(0.3,cc.p(0,50)))
				end	
			end	

			if witeTime < 30 then
				witeTime = witeTime + 1
			else
				bwite = false;

				msgNode = cc.Node:create()
				:addTo(infoNode)
				infoBg = cc.Sprite:create('image/commonImg/cv_info_bg.png')
				:addTo(msgNode)
				title = cc.Label:createWithTTF( '', fonts.FONT_CV , 20)
					:addTo(msgNode)
					:setDimensions(600, 30)
					:setContentSize(cc.size(600, 30))
					:setAnchorPoint(cc.p(0.5,0.5))
					:setPosition(cc.p(0,0)) -- -284
					:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
				table.insert(msgList, {node=msgNode, label=title})
			end
		else
			curLen = curLen + 1;
			tempStr = string.sub(curCvInfo, 1,curLen)
			-- print('============= curLen === ',curLen,'     temStr == ',tempStr)
			title:setString(tempStr);
		end
	end
	-- print('============= start ===================== ')


	local act2 = function (  )
		-- print('============= start 2222 ===================== ')
		local delay = cc.DelayTime:create(0.02)
		local sequence = cc.Sequence:create(delay, cc.CallFunc:create(callback))
		local action = cc.RepeatForever:create(sequence)
		infoNode:runAction(action);

	end
	if delayTime == nil then
		delayTime = 0.1
	end
	infoNode:runAction(cc.Sequence:create(cc.DelayTime:create(delayTime),cc.CallFunc:create( act2 )))
	-- local act1 = cc.FadeOut:create(5.0);
	-- local act2 = cc.RemoveSelf:create();
	-- infoNode:runAction(cc.Sequence:create(act1,act2))

	return retData;
end

-- 初始化/清理model
function GlobalFunctions:clearAllModel(  )
	
	for k,modelItem in pairs(model) do

		if modelItem and modelItem.clearAll then
			modelItem.clearAll(modelItem);
		end


	end

end

function GlobalFunctions:sendFunnel(funnel_id)
	if not model.UserDefaultModel:getFunnel(funnel_id) then
		model.UserDefaultModel:setFunnel(funnel_id)
		Network.NetworkManager:Send(Network.NetworkCmdType.req_record_funnel, {id=funnel_id});
	end
end

function GlobalFunctions:trackEvent(eventToken)
	if eventToken == nil or eventToken == '' then
		return;
	end
	
	local eName = '';
	local package_name = sdkManager.SDKLuaHelper:getPackageName()
	if package_name == 'com.nani.ego.kr.aos' then
		eName = Enum:getTable('TrackEventTokenAOS')[eventToken];
	elseif package_name == 'com.nani.ego.kr.one' then
		eName = Enum:getTable('TrackEventTokenOne')[eventToken];
	else
		return;
	end

	local args = {
		eventName = eName
	}
	sdkManager.SDKLuaHelper:trackEvent(args)
end

function GlobalFunctions:changeStamp2Datetime(time)
	local t = os.date('*t', time or 0)
	t.hour = t.hour < 10 and ('0'..t.hour) or tostring(t.hour);
	t.min = t.min < 10 and ('0'..t.min) or tostring(t.min);
	local form = '%d-%d-%d %s:%s';
	local timeStr = string.format(form, t.year,t.month,t.day,t.hour,t.min)
	return timeStr
end

function GlobalFunctions:changeStamp2Datetime2(time)
	local t = os.date('*t', time or 0)
	t.hour = t.hour < 10 and ('0'..t.hour) or tostring(t.hour);
	t.min = t.min < 10 and ('0'..t.min) or tostring(t.min);
	local form = '%d-%d %s:%s';
	local timeStr = string.format(form, t.month,t.day,t.hour,t.min)
	return timeStr
end

function GlobalFunctions:getTokenByLan(lan)
	local token = 'usd';
	if lan == 'kr' then
		token = 'krw'
	elseif lan == 'jp' then
		token = 'jpy'
	else
		token = 'usd'
	end
	return token
end

cc.exports.GlobalFunctions = GlobalFunctions:create();
cc.exports.GlobalMove = false;