local ConfigStateTools = class('ConfigStateTools')
local fonts = Enum:getTable("SystemFont")
local ConfigStateTypeList = Enum:getTable("ConfigStateTypeList")
local ConfigStateType = Enum:getTable("ConfigStateType")
local CommonShopType = Enum:getTable('CommonShopType');
local RoundTargetRewardType = Enum:getTable("RoundTargetRewardType");
local ActivityIndex = Enum:getTable('ActivityIndex')
local stateType = { --共用界面处理
--[[
    ShopPanel = {
        [CommonShopType.SHOP]           = 'Shop',
        [CommonShopType.GUILD]          = 'Guild',
        [CommonShopType.RECHARGE]       = 'Recharge',
        [CommonShopType.GIFT]           = 'gift',
    },
    ]]
    RoundTargetRewardPanel = {
        [RoundTargetRewardType.ROUNE]         = 'Round',
        [RoundTargetRewardType.EVENT]         = 'Event',
        [RoundTargetRewardType.TRIAL]         = 'Trial',
    },
    ActivityPanel = {
        [ActivityIndex.SIGN]         = 'Sign',
        [ActivityIndex.MONTH_CARD]   = 'Month',
    },
}
function ConfigStateTools:ctor(  )

end

function ConfigStateTools:checkLock(name , type)
    if stateType[name] then
        if stateType[name][type] then
            name = name..tostring(stateType[name][type]);
        else
            name = name..tostring(stateType[name][1]);
        end
    end
    return self:checkLockByName(name);
end

function ConfigStateTools:checkLockByName(name)
    return not model.ConfigStateModel:isOpenByName(name);
end

function ConfigStateTools:checkLockById(id)
    return not model.ConfigStateModel:isOpenById(id);
end

function ConfigStateTools:checkVisibleByName(name)
    return model.ConfigStateModel:isVisibleByName(name);
end

function ConfigStateTools:checkVisibleById(id)
    return model.ConfigStateModel:isVisibleById(id);
end

function ConfigStateTools:checkVisibleByType(sType,index)
    local typeList = ConfigStateTypeList[sType];
    if not typeList then
        return;
    end

    if typeList[index] then
        return model.ConfigStateModel:isVisibleById(typeList[index]);
    end

    return true;
end

function ConfigStateTools:checkLockByType(sType,index)
    local typeList = ConfigStateTypeList[sType];
    if not typeList then
        return;
    end

    if typeList[index] then
        return self:checkLockById(typeList[index]);
    end

    return false;
end

function ConfigStateTools:getOpenIndexByType(sType)
    local typeList = ConfigStateTypeList[sType];
    if typeList then
        for _k , id in ipairs(typeList) do
            if model.ConfigStateModel:isOpenById(id) then
                return _k;
            end
        end
    end

    return nil;
end

function ConfigStateTools:setVisibleByType(sType , nodes)

    local openList = {};
    local typeList = ConfigStateTypeList[sType];
    if not typeList then
        return;
    end
    for _k , id in pairs(typeList) do
        if nodes[_k] then
            local visible = model.ConfigStateModel:isVisibleById(id);
            nodes[_k]:setVisible(visible);
            if visible then
                local state = model.ConfigStateModel:getStateById(id);
                table.insert(openList , {index = _k , state = state});
            end
        end
    end
    return openList;
end


return ConfigStateTools