local RedDotTools = class('RedDotTools')

-- local TAG_RED_DOT = TAG_RED_DOT_DEFAULT --红点tag

function RedDotTools:ctor(  )
    -- body
end



--==============================--
--desc: 给节点 增加红点功能
--time:2019-09-04 03:39:46
--@node: 
--@bAdd: 
--@dotImg:红点资源（默认 image/common/btn_bg_0.png）
--@dotPos:红点坐标（默认 cc.p(nodeSize.width,nodeSize.heigth))
--@return 
--==============================--
function RedDotTools:setRedDotToNode( node,bAdd,dotImg,dotPos )
    if node == nil then
        return 
    end
    local redDotTag = Conf.TAG_RED_DOT_DEFAULT;
    local redDot = node:getChildByTag(redDotTag);

    if bAdd == false then
        if redDot then
            redDot:setVisible(false);
        end
        return 
    end

    if redDot == nil then
        if dotPos == nil then
            local nodeSize = node:getContentSize();
            dotPos = cc.p(nodeSize.width,nodeSize.height)
        end
        local redDotImg  = dotImg or 'image/commonImg/tip_1.png'
        redDot = cc.Sprite:create(redDotImg);
        redDot:addTo(node)
        redDot:setPosition(dotPos)
        redDot:setTag(redDotTag)
    end

    redDot:setVisible(true)

end

function RedDotTools:pushMainPanelRedDot( btnKey )
    EventManager:FireEvent(EventType.UIActivityBtn , btnKey);
end

function RedDotTools:pushGuildRedDot( depth )
    -- 3 公会通关奖励返回公会boss
    -- 2 公会boss返回公会
    -- 2 公会捐献返回公会
    -- 1 公会返回主界面
    if depth == 1 then
        EventManager:FireEvent(EventType.UIFooterRedDotShow,4);
    elseif depth == 2 then 
        EventManager:FireEvent(EventType.NetworkGuildRedDotShow);
    elseif depth == 3 then 
        EventManager:FireEvent(EventType.NetworkGuildBossRedDotShow);
    end

end

-- depth 层次
-- btnKey
function RedDotTools:pushHomeBaseRedDot( depth,btnKey )
    
    -- 3 
    -- 2 基地子界面 返回 基地
    -- 2 
    -- 1 基地返回 主界面
    if depth == 1 then
        EventManager:FireEvent(EventType.UIFooterRedDotShow,5);
    elseif depth == 2 then 
        EventManager:FireEvent(EventType.UIHomeBaseRedDotShow,btnKey);
    elseif depth == 3 then 
        -- EventManager:FireEvent(EventType.NetworkGuildBossRedDotShow);
    end

end

function RedDotTools:pushCardRedDot(depth)
    if depth == 1 then
        EventManager:FireEvent(EventType.UIFooterRedDotShow,2);
    end
end

function RedDotTools:pushGachaRedDot(depth)
    if depth == 1 then
        EventManager:FireEvent(EventType.UIFooterRedDotShow,6);
    end
end

function RedDotTools:pushFightSceneRedDot( btnKey )
    --  随机boss 返回 战斗
    --  道具使用 返回 战斗
    --  挂机   返回 战斗

    -- 战斗界面 按钮tag
-- local FightMenuTag = {
-- 	TAG_ROUND_REWARD = 1,
-- 	TAG_CHAT 		 = 2,
-- 	TAG_ITEM_USE	 = 4,
-- 	TAG_RANDOM_BOSS  = 5,
-- 	TAG_ONLINE 		 = 6,
-- 	TAG_FAST_FIGHT   = 7,
-- }

    EventManager:FireEvent(EventType.FightPanelBtnRedDot,btnKey);

end


function RedDotTools:pushFootRedDot( btnKey )
    -- body
end

return RedDotTools