cc.exports.MessageBox = {}
local MessageBox = cc.exports.MessageBox
-- 
function MessageBox:clearAll(  )
	self.root = nil;
	self.scene = nil;
	self.messageBoxList = {};
	self.boxIndex = 0;

	EventManager:UnregisterEvent(EventType.UIMessageBoxClose)
end
function MessageBox:init(root,scene)
	self:clearAll();
	self.root 	= root;
	self.scene 	= scene;
	self.messageBoxList = {};
	self.boxIndex = 0;

	EventManager:RegisterEvent(EventType.UIMessageBoxClose , handler(self , self.closeBox));
end
-- boxData 
function MessageBox:create(boxData, btnType, callback, cancelCallBack, clickBackgroundCallback)
	if self.root == nil then
		return;
	end

	if self.boxIndex > 1 then
		print('error, 一次只允许弹出一个messageBox');
		return ;
	end

	self.boxIndex = self.boxIndex + 1;

	local msgBox = nil;
	if type(boxData) == 'string' then
		msgBox = template.MessageBoxTemplate:create(self.root);
		msgBox:initData(boxData,btnType);
	else
		msgBox = template.MessageBoxType2Template:create(self.root);
		msgBox:initData(boxData,btnType);
	end
	self.messageBoxList[self.boxIndex] = msgBox
	-- self.messageBoxList[self.boxIndex]:initData(boxData,btnType);
	self.messageBoxList[self.boxIndex]:addClickListener(callback, cancelCallBack, clickBackgroundCallback);
	self.messageBoxList[self.boxIndex]:setPosition(StageSize.width/2, StageSize.height/2);
	self.messageBoxList[self.boxIndex]:setLocalZOrder(10000 + self.boxIndex * 10);

	return self.messageBoxList[self.boxIndex];
end

function MessageBox:setOkBtnName(text)
	self.messageBoxList[self.boxIndex]:setOkBtnName(text)
end

function MessageBox:setCancelBtnName(text)
	self.messageBoxList[self.boxIndex]:setCancelBtnName(text)
end

function MessageBox:getOKBtn(  )
	return self.messageBoxList[self.boxIndex]:getOkBtn();
end
function MessageBox:closeBox()
	if self.boxIndex == nil or self.messageBoxList[self.boxIndex] ==nil then
		return false;
	end
	self.messageBoxList[self.boxIndex]:removeFromParent();
	self.messageBoxList[self.boxIndex] = nil;
	self.boxIndex = self.boxIndex - 1;
	return true;
end

function MessageBox:setCostInfo(icon, v1, v2)
	self.messageBoxList[self.boxIndex]:setCostInfo(icon, v1, v2)
end

return MessageBox
