local scheduler = cc.Director:getInstance():getScheduler();
local NetworkManager = Network.NetworkManager;
local NetworkCmdType = Network.NetworkCmdType;
local ServerName = Enum:getTable('ServerName');
local LoginState = Enum:getTable('LoginState');
local fonts = Enum:getTable("SystemFont");
local UserStatus = Enum:getTable('UserStatus');

local state = {
	[1] = {msg = 'receive msg', cnt = 30};
	[2] = {msg = 'init Models', cnt = 50};
	[3] = {msg = 'preload ???', cnt = 80};
	[4] = {msg = 'preload audio', cnt = 100};
}

local LoginScene = class("LoginScene", function()
	local scene = nil;
	scene = display.newScene("LoginScene")
	
	return scene;
end)

function LoginScene:ctor()
	--加载资源
	--设置ui根结点
	self.loginState = LoginState.idle;
	
	local function onNodeEvent(event)
		if event == "enter" then
			self:onEnter()
		elseif event == "exit" then
			self:onExit()
		end
	end
	self:registerScriptHandler(onNodeEvent)
	self.m_scheduleHandler = nil;
	AudioManager:preLoad();

	--
	self.bg = cc.Sprite:create('image/loading/loading.png')
		:setLocalZOrder(-10)
		:setPosition(StageSize.width/2, StageSize.height/2)
		:addTo(self)

	--
	self.spineNode = cc.Node:create()
		:setLocalZOrder(-5)
		:setPosition(StageSize.width/2, StageSize.height/2)
		:addTo(self)

	-- progress bar
	self.bottomNode = cc.Node:create()
		:setPosition(StageSize.width/2, 123)
		:addTo(self)

	self.progressBg = cc.Sprite:create('image/loading/loading_progress_bg_1.png')
		:addTo(self.bottomNode)

	self.progressBg2 = cc.Sprite:create('image/loading/loading_progress_bg_2.png')
		:addTo(self.bottomNode)
		:setPosition(0,-49)

	self.progressBar = cc.Scale9Sprite:create('image/loading/loading_progress.png');
	self.progressBar:setCapInsets(CCRectMake(8,0,6,17));
	self.progressBar:addTo(self.bottomNode);
	self.progressBar:setAnchorPoint(0 , 0.5);
	self.progressBar:setPosition(-271 , -2.5);

	--self.progressBar = cc.ProgressTimer:create(cc.Sprite:create('image/loading/progress_fg.png'));
    --self.progressBar:setType(cc.PROGRESS_TIMER_TYPE_BAR);
    --self.progressBar:setMidpoint(cc.p(0, 0));
    --self.progressBar:setBarChangeRate(cc.p(1, 0));
	--self.progressBar:addTo(self.bottomNode);

	--self.light = cc.Sprite:create('image/loading/light.png')
	--	:setPosition(-221, 0)
	--	:addTo(self.bottomNode)

	self.progressLabel = cc.Label:createWithTTF("0",fonts.FONT_SIYUAN, 18)
		:enableOutline(cc.c3b(0,105,180))
		:setPosition(0,-1)
		:addTo(self.bottomNode)

	self.loadingLabel = cc.Label:createWithTTF('Loading    ', fonts.FONT_SIYUAN, 20)
		:setPosition(cc.p(-269, 27))
		:setAnchorPoint(cc.p(0, 0.5))
		:addTo(self.bottomNode)

	
	self.word = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
		:setPosition(0, -49)
		:setTextColor(cc.c3b(255 , 200, 0))
		:addTo(self.bottomNode)

	self.barWidth = 541;
	self.curPercent = 0;
	self.aimPercent = 0;
	self.receiveMsgFlag = false;
	self.enterNextSceneFlag = false;

	self.playVideoEnd = false;
end

function LoginScene:initVideoNode()
	-- body
	self.playVideoEnd = true;

	local st = model.UserDefaultModel:getPlayVideoState()
	if st==true then
		return
	end

	self.videoNode = cc.Node:create()
	:addTo(self)
	self.videoBg = cc.LayerColor:create(cc.c4b(0, 0, 0, 255),StageSize.width*3, StageSize.height*3)
		:addTo(self.videoNode)
		:setVisible(false)
	self.videoPlayer = nil

	local targetPlatform = cc.Application:getInstance():getTargetPlatform()
	if (cc.PLATFORM_OS_IPHONE == targetPlatform) or (cc.PLATFORM_OS_ANDROID == targetPlatform) then

		local videoPlayer = ccexp.VideoPlayer:create();
		local onVideoEventCallback = function(sener, eventType)
			if eventType == ccexp.VideoPlayerEvent.COMPLETED then

				videoPlayer:stop()
				-- IOS端直接移除会导致崩溃，
				videoPlayer:runAction(cc.Sequence:create(cc.RemoveSelf:create()))

				AudioManager:resumeMusic()

				self.playVideoEnd = true;
				self.videoBg:setVisible(false)
				model.UserDefaultModel:setPlayVideoState(true)
				GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').movie_end);

			end
		end
		videoPlayer:setAnchorPoint(cc.p(0.5, 0.5))
		videoPlayer:setPosition(cc.p(StageSize.width/2,StageSize.height/2))
		videoPlayer:setContentSize(cc.size(StageSize.width, StageSize.height))
		videoPlayer:setFileName('pv_res.mp4')
		videoPlayer:setKeepAspectRatioEnabled(true)
		videoPlayer:setTouchEnabled(false)
		videoPlayer:setFullScreenEnabled(true) -- ios为开放此API，需要通过坐标，显示区域处理
		videoPlayer:setVisible(true)
		videoPlayer:addEventListener(onVideoEventCallback)
		videoPlayer:addTo(self.videoNode)

		self.videoPlayer = videoPlayer
		
	end

end

function LoginScene:onEnter()
	--调度器注册
	GlobalFunctions:recordTime('fb-log---LoginSceneEnter  ')
	self.m_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.update), 0, false);

	self.loginState = LoginState.gotoMainScene;
	self.exeEnd = true;
	self.state = 1;
	self.keepLogin = false

	local uid = model.AccountModel:getAccountUid()
	local lg = model.UserDefaultModel:getLanguageSet();
	local req = {};
	req.reqcode = 2100;
	req.country = sdkManager.SDKLuaHelper:getCountry();
	req.uid = uid;
	req.aid = model.AccountModel:getAccountID()
	req.lg = lg;
	TimeManager:setReqTime();
	getDBdata(self, define.server_url, req, function(response)

		if response.userStatus and response.userStatus.status == UserStatus.BANNED then
			local MessageBoxType = Enum:getTable('MessageBoxType')
			MessageBox:init(self,self);
			--local banTime = response.userStatusTime or 2524579200
			--local t = os.date('*t', banTime)
			--local timeStr = string.format(LANG.TIME_FORMAT, t.year, t.month, t.day, t.hour, t.min)
			--local str = string.format(LANG.USER_STATUS_BANNED, tostring(timeStr))
			local msgBox = MessageBox:create(LANG.VERSION_UPDATE_10, MessageBoxType.CANCEL_OK, function()
				local user_app_id = response.uid;
				local nickname = response.name;
				local device_info = model.AccountModel:getDeviceModel()
				local game_ver = model.AccountModel:getGameVersion();
				local os_ver = model.AccountModel:getOSVersion()
				local platform = model.AccountModel:getGameCode();
				local game_server = model.UserModel:getServer();
				local url = string.format(GlobalFunctions:getURLbyLanguage()..'&user_app_id=%s&nickname=%s&device_info=%s&game_ver=%s&os_ver=%s&platform=%s&game_server=%s',
				tostring(user_app_id),tostring(nickname),tostring(device_info),tostring(game_ver),tostring(os_ver),tostring(platform),tostring(game_server));
				cc.Application:getInstance():openURL(url)
				cc.Director:getInstance():endToLua();
			end, function()
				cc.Director:getInstance():endToLua();
			end, function()
				cc.Director:getInstance():endToLua();
			end);
			msgBox:setCancelBtnName(LANG.VERSION_UPDATE_11);
			msgBox:setOkBtnName(LANG.VERSION_UPDATE_12);
			return;
		end
		self.keepLogin = true

		self.coroutine = coroutine.create(function()
			self.exeEnd = false;
			model.RechargeModel:Init(response);
			GlobalFunctions:recordTime('fb-log---RechargeModel  ')

			model.EquipModel:Init(response.equips, response.equip_wear);
			GlobalFunctions:recordTime('fb-log---EquipModel:Init  ')

			--卡牌
			model.CardModel:Init(response.partners)
			GlobalFunctions:recordTime('fb-log---CardModel:Init  ')
			model.CardModel:InitAllGetCard(response.getCard)
			GlobalFunctions:recordTime('fb-log---CardModel:InitAllGetCard  ')
			model.CardModel:initAvatarData(response.avatars)
			GlobalFunctions:recordTime('fb-log---CardModel:initAvatarData  ')
			--model.CardModel:InitGetCardRecord(response.getCardRecord);

			--抽卡次数
			model.GachaModel:Init(response.gacha);
			GlobalFunctions:recordTime('fb-log---GachaModel  ')

			model.GuildModel:retGuildInfo(response);
			GlobalFunctions:recordTime('fb-log---GuildModel  ')

			--shop
			--model.ShopModel:Init(response.shop);
			-- model.GemModel:Init(response.crystal);

			-- event
			model.EventModel:initData(response.maze);
			GlobalFunctions:recordTime('fb-log---EventModel  ')

			--homebase
			--baseskill
			model.HomeModel:InitHomeData(response.homebase);
			GlobalFunctions:recordTime('fb-log---HomeModel:InitHomeData  ')
			model.HomeModel:InitSkillData(response.skillData);
			GlobalFunctions:recordTime('fb-log---HomeModel:InitSkillData  ')
		
			model.ItemModel:initItems(response.items);
			GlobalFunctions:recordTime('fb-log---ItemModel  ')

			-- money
			model.MoneyModel:Init(response.money);
			GlobalFunctions:recordTime('fb-log---MoneyModel  ')
			
			model.MailModel:initMailData(response.mails);
			GlobalFunctions:recordTime('fb-log---MailModel  ')

			--随机boss
			model.RoundBossModel:Init(response.round_boss);
			GlobalFunctions:recordTime('fb-log---RoundBossModel  ')
			
			-- round
			model.RoundModel:Init(response.round);
			model.RoundModel:updateCopyRoundInfo(response.user_adventure_record);
			model.RoundModel:updateCopyRoundTime(response.adventure_open);
			GlobalFunctions:recordTime('fb-log---RoundModel:Init  ')
			model.RoundModel:initRoundMission( response.user_bank )

			-- auto fight
			model.AutoFightModel:Init(response.autoBattle);
			model.AutoFightModel:InitFastInfo(response.fastInfo);
			GlobalFunctions:recordTime('fb-log---AutoFightModel  ')

			model.OnlineModel:initOnline(response.onlineReward,response.curTime);
			GlobalFunctions:recordTime('fb-log---OnlineModel  ')

			--admob
			model.AdmobModel:initAdmob( response.admob )
			
			model.TrialModel:InitData(response.trial_round)
			GlobalFunctions:recordTime('fb-log---TrialModel  ')

			-- gacha admob
			model.GachaAdmobModel:init( response.gacha_admob )
		
			--用户信息
			model.UserModel:Init(response)
			self:checkPlayVideo() --在UserModel数据返回之后执行	
			GlobalFunctions:recordTime('fb-log---UserModel  ')
			
			--功能开关
			model.ConfigStateModel:Init(response.configState);
			GlobalFunctions:recordTime('fb-log---ConfigStateModel  ')

			--红点
			model.EnterGameRedDotModel:updateRedDot(response.redDot)
			GlobalFunctions:recordTime('fb-log---EnterGameRedDotModel  ')
			
			--bareCollect
			model.BareCollectModel:Init(response.bareCollect, response.bless_info);
			GlobalFunctions:recordTime('fb-log---BareCollectModel  ')

			--arena
			model.ArenaModel:initData(response.arena);

			-- table
			--ResTable:loadTable('role_remodeling');
			model.RankModel:initData(response.rankTop)

			--operates
			model.OperateModel:Init(response.operates);

			--activity
			model.ActivityModel:Init(response.activity);
			model.ActivityModel:initLoginConInfo(response.cumulative_login);

			self.exeEnd = true;
			coroutine.yield(); -- 222
			self.exeEnd = false;   
			--print('===================aaaaaaaaaaaa===================')
			-- 初始新手引导，需要在user之后

			--初始化编队选择 必须在卡牌后面初始化
			model.TeamModel:Init(response.teams);
			GlobalFunctions:recordTime('fb-log---TeamModel  ')
			------------------------- 
		
			model.CardModel:initLove(response.love);

			-- recount
			model.RecountModel:Init();
			GlobalFunctions:recordTime('fb-log---RecountModel  ')

			model.FutureCardModel:Init(response.altar)
			
			CardProManager:GenCardPro();
			GlobalFunctions:recordTime('fb-log---CardProManager  ')

			model.RechargeModel:initRechargeTaskData( response.operate_opens_recharge_task )
			
			--
			-- announcement
			model.AnnouncementModel:Init(response.announcement)
			GlobalFunctions:recordTime('fb-log---AnnouncementModel  ')

			model.StoryModel:Init(response.dungeon_information)

			self.exeEnd = true;
			coroutine.yield();
			self.exeEnd = false;


			-- cv preload
			--AudioManager:preloadTeam(model.TeamModel:getCurrentTeam());

			-- effect preload
			--FrameEffectManager:preloadAllEffect();
			--FrameEffectManager:preLoadPngs();
			--TimeManager:startEvent();

			self.receiveMsgFlag = false;
			self.enterNextSceneFlag = true;

			--设置bugly用户ID
			sdkManager.BuglyManager:buglySetUserId(uid)
			self.exeEnd = true;
		end)
		-- receiveMsgFlag 放到 coroutine之后，防止coroutine.resume极低概率提前触发
		self.receiveMsgFlag = true;
		TimeManager:setOriTime(response.curTime, response.nextHeartBeatTime)
		TimeManager:beginUpdate(response.curTime)
		TimeManager:setZeroTime(response.zeroTime)

	end, 0)
	self:showSpine()
	self:showParticle()
	self.loadingLabel:runAction(cc.RepeatForever:create(cc.Sequence:create(
			cc.DelayTime:create(0.2),
			cc.CallFunc:create(function() self.loadingLabel:setString('Loading .  ') end),
			cc.DelayTime:create(0.2),
			cc.CallFunc:create(function() self.loadingLabel:setString('Loading .. ') end),
			cc.DelayTime:create(0.2),
			cc.CallFunc:create(function() self.loadingLabel:setString('Loading ...') end),
			cc.DelayTime:create(0.2),
			cc.CallFunc:create(function() self.loadingLabel:setString('Loading    ') end)
		)))

	self.word:runAction(cc.RepeatForever:create(cc.Sequence:create(
			cc.CallFunc:create(function() 
				local key = math.random(1, #LANG.LOADING_MESSAGE);
				self.word:setString(LANG.LOADING_MESSAGE[key]) 
			end),
			cc.DelayTime:create(2)
			)))

end

function LoginScene:checkPlayVideo()
	if model.UserModel:getUserLevel() >= 2 then
		self.playVideoEnd = true;
        return;
    end
	self:initVideoNode();

	local playSt = model.UserDefaultModel:getPlayVideoState()
	if playSt==false and self.videoPlayer then
		AudioManager:pauseMusic()
		self.playVideoEnd = false;
		self.videoBg:setVisible(true)
		self.videoPlayer:play()
		GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').movie_play);
	else
		self.playVideoEnd = true;
	end
end

function LoginScene:onExit()
	GlobalFunctions:recordTime('fb-log---LoginSceneExit  ')
	if self.m_scheduleHandler then 
		scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
		self.m_scheduleHandler = nil 
	end
	self:removeSpine()
	self:removeParticle()
end

function LoginScene:update(dt)
	if self.curPercent ~= self.aimPercent then
		self.curPercent = self.aimPercent;

		local percent = self.curPercent / 100;
		local width = percent*self.barWidth;
		if width > 0 then
			width = width < 22 and 22 or width;
		end
		self.progressBar:setContentSize(cc.size(width , 17));
		--self.light:setPosition(-self.barWidth/2 + width, 0)

		self.progressLabel:setString(self.curPercent..'%');
	end

	if self.loginState == LoginState.idle then
		-- idel では 何もしない
		
	elseif self.loginState == LoginState.saveJson then
		-- 1.マスターデータ保存----------------------------------------------------
		
		
	elseif self.loginState == LoginState.loadResource then
		
		self.loginState = LoginState.idle;-- 待機
		
		
	elseif self.loginState == LoginState.gotoMainScene then
		-- 3.ユーザーデータ取得 & 全パネル初期化----------------------------------------------------
		if state[self.state] and self.aimPercent == state[self.state].cnt and self.enterNextSceneFlag and self.playVideoEnd then
			GlobalFunctions:recordTime('fb-log---runMainScene  ')
			AudioManager:stopMusic();
			App:run("MainScene");
			return;
		end
		if self.aimPercent < state[self.state].cnt then
			self.aimPercent = self.aimPercent + 1;
			if self.aimPercent > 100 then
				self.aimPercent = 100;
			end
		end
		-- GlobalFunctions:recordTime('fb-log---loginPer: '..self.aimPercent..' time:')

		if self.receiveMsgFlag then
			if self.aimPercent == state[self.state].cnt and self.exeEnd==true then
				self.state = self.state + 1;
				if not state[self.state] then
					self.state = self.state - 1;
					return;
				end
				--self.showTitleLabel:setString(state[self.state].msg);
				if self.keepLogin then
					coroutine.resume(self.coroutine);
				end
			end
		end
	end
end

function LoginScene:showSpine()
	local spine_res = 'loading';
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.skeletonNode = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)

		self.skeletonNode:addTo(self.spineNode)
		self.skeletonNode:setLocalZOrder(-5)
		self.skeletonNode:setAnimation(0, "idle", true)

		-- registerEvent
		self.skeletonNode:registerSpineEventHandler(function (event)
	--		print(string.format("[spine] %d start: %s", 
	--								event.trackIndex,
	--								event.animation))
		end, sp.EventType.ANIMATION_START)

		self.skeletonNode:registerSpineEventHandler(function (event)
	--		print(string.format("[spine] %d end:", 
	--								event.trackIndex))
		end, sp.EventType.ANIMATION_END)
    
		self.skeletonNode:registerSpineEventHandler(function (event)
	--		print(string.format("[spine] %d complete: %d", 
	--								event.trackIndex,
	--								event.loopCount))
		end, sp.EventType.ANIMATION_COMPLETE)

		self.skeletonNode:registerSpineEventHandler(function (event)
	--		print(string.format("[spine] %d event: %s, %d, %f, %s", 
	--								event.trackIndex,
	--								event.eventData.name,
	--								event.eventData.intValue,
	--								event.eventData.floatValue,
	--								event.eventData.stringValue))
		end, sp.EventType.ANIMATION_EVENT)

		local listener = cc.EventListenerTouchOneByOne:create()
		listener:registerScriptHandler(function (touch, event)
			return true
	    end, cc.Handler.EVENT_TOUCH_BEGAN )

		local eventDispatcher = self.spineNode:getEventDispatcher()
		eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self.spineNode)
	end
end

function LoginScene:showParticle()
	self.particle = cc.ParticleSystemQuad:create('Effect/particle/loadingp.plist')
		:addTo(self)
		:setPosition(StageSize.width/2, StageSize.height/2)
end

function LoginScene:removeSpine()
	if self.skeletonNode then
		self.skeletonNode:removeFromParent()
		self.skeletonNode = nil;
	end
end

function LoginScene:removeParticle()
	self.particle:removeFromParent()
end
return LoginScene
