﻿

local scheduler = cc.Director:getInstance():getScheduler();
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local MainScene = class("MainScene", function()

	--[[
	local scene = nil;
	scene = display.newScene("MainScene");
	local creatorFileName = 'creator/Scene/main_scene.ccreator';
	if cc.FileUtils:getInstance():isFileExist(creatorFileName) then
		print('reader have been created')
		cc.exports.reader = creator.CreatorReader:createWithFilename(creatorFileName);
		reader:setup();
	else
		print('ERROR!!!! no file named ' .. creatorFileName);
	end
	return scene;
	--]]
	local scene = nil;
	scene = display.newScene("MainScene", {physics=2})
	
	return scene;
end)


function MainScene:clearAll(  )
	EventManager:clearAll();
	FightManager:clearAll();

	Prompt:clearAll()
	WaitingPanel:clearAll();
	FpUpPanel:clearAll()
	MessageBox:clearAll();
	ShowAnimationPanel:clearAll();
	ReconnectionPanel:clearAll();

	-- FightManager:clearAll();
	UIManager:clearAll();
	DragonBonesManager:DestroyAll()
	Webproxy:close()

	self:registEvent(false)
	if self.m_scheduleHandler then 
		cc.Director:getInstance():getScheduler():unscheduleScriptEntry(self.m_scheduleHandler)
		self.m_scheduleHandler = nil 
	end

	--设置各界面根节点引用
	self.layerList = {};
	--设置handler引用	
	self.layerHandlerList = {};
	self.swallowLayerList = {};
	self.swallowListenerList = {};
	self.swallowCallbackList = {};




end

function MainScene:ctor()

	GlobalFunctions:recordTime('fb-log---MainScene:1ctor  ')
	self:clearAll();
	--加载资源
	local function onNodeEvent(event)
		if event == "enter" then
			self:onEnter()
		elseif event == "exit" then
			self:onExit()
		end
		print("Event:"..event)

	end
	self:registerScriptHandler(onNodeEvent)
	self.m_scheduleHandler = nil;

	--设置ui引用
	self.layerRoot = 'app.layer.MainScene.';
	
	self.swallowPanelList = 
	{
		BagPanel		= true,
		FightPanel		= true,
		CardPanel		= true,
		EntrustPanel	= true,
		TeamPanel		= true,
		GuildPanel		= true,
		BelleBallMainPanel = true;
		CardPicturePanel	= false,
		CardListPanel	= true,
		CardInfoPanel	= true,
		CardEvolvePanel = true,
		CardEquipChangePanel = true,

	}
	GlobalFunctions:recordTime('fb-log---MainScene:2ctor  ')
	self:InitScene();
	GlobalFunctions:recordTime('fb-log---MainScene:InitScene  ')
	self:registEvent();

end

function MainScene:InitScene(  )
	
	--设置ui根结点
	--self.uiRoot = self:getChildByName('Canvas');
	self.uiBgNode = cc.Node:create();
	self.uiBgNode:addTo(self);

	self.uiRoot = cc.Node:create();
	self.uiRoot:addTo(self);


	-- init MainPanel
	--self.layerHandlerList['MainPanel'] = MainPanel:create();
	--self.layerHandlerList['MainPanel']:Init(self);
	UIManager:Init();
	GlobalFunctions:recordTime('fb-log---MainScene:UIManager:Init  ')

	-- fight manager
	FightManager:EnterGame();
	GlobalFunctions:recordTime('fb-log---MainScene:FightManager:EnterGame  ')
	DownloadControler:EnterGame()
	GlobalFunctions:recordTime('fb-log---MainScene:DownloadControler:EnterGame  ')

	self.loadPanel = 0
	self.delayNum = 0;
	self.preLoadPanelList = {
		-- FightPanel = true,
		-- FooterPanel = true,
		MainPanel	= true,
	}
	self.MainPanels = {
		MainPanel		= true,
		CardListPanel	= true,
		FightPanel		= true,
		GuildPanel		= true,
		BelleBallMainPanel = true,
		HomeBasePanel	= true,
		FooterPanel = true,
		FightPanel = true,
		HeaderPanel = true,
		GachaListPanel = true,
	}

	-- for nodeName, handlerClass in pairs(LayerHandlerClassList) do
	-- 	local nodeHandler = handlerClass:create(self, 'MainScene', nodeName);
	-- 	UIManager:AddLayer(nodeName, nodeHandler);
	-- 	if not nodeHandler.hasBase then
	-- 		UIManager:InitPanelGlobalFunction(nodeName, nodeHandler, self, self.layerList);
	-- 	end
	-- 	if self.preLoadPanelList[nodeName] then
	-- 		UIManager:preInit(nodeName);
	-- 	end
	-- 	self.layerHandlerList[nodeName] = nodeHandler;
	-- end
	GlobalFunctions:recordTime('fb-log---MainScene:InitPanel  ')

	-- init loading manager
	--LoadingManager:InitWithLoadingPanelHandler(self.layerHandlerList['LoadingPanel']);

	-- init Prompt
	local nodePrompt = cc.Node:create();
	nodePrompt:setPosition(StageSize.width/2, StageSize.height/2)
	UIManager:InitPanelZorder('Prompt', nodePrompt);	
	self:addChild(nodePrompt);
	Prompt:Init(nodePrompt, self);
	GlobalFunctions:recordTime('fb-log---MainScene:Prompt  ')

	-- init fight waiting
	local nodeWaiting = cc.Node:create();
	nodeWaiting:setPosition(StageSize.width/2, StageSize.height/2);
	nodeWaiting:addTo(self);
	WaitingPanel:Init(nodeWaiting, self);
	UIManager:InitPanelZorder('WaitingPanel', nodeWaiting);
	GlobalFunctions:recordTime('fb-log---MainScene:WaitingPanel  ')

	--init fpUp
	local fpUpPanel = cc.Node:create();
	fpUpPanel:setPosition(display.center);
	fpUpPanel:addTo(self);
	FpUpPanel:Init(fpUpPanel, self);
	UIManager:InitPanelZorder('FpUpPanel', fpUpPanel);
	GlobalFunctions:recordTime('fb-log---MainScene:FpUpPanel  ')

	-- init paymentHelper
	-- UIManager:push('PaymentHelerPanel');
	sdkManager.PaymentHelper = require('app.layer.MainScene.PaymentHelperPanel'):create()
	sdkManager.PaymentHelper:addTo(self)
	sdkManager.PaymentHelper:setPosition(display.center);
	sdkManager.PaymentHelper:setLocalZOrder(PANEL_ZORDER * 15);
	sdkManager.PaymentHelper:setVisible(false);
	-- self.layerHandlerList['PaymentHelerPanel'] = sdkManager.PaymentHelper

	-- init show animation
	local showAnimation = cc.Node:create();
	showAnimation:setPosition(StageSize.width/2, StageSize.height/2);
	showAnimation:addTo(self);
	ShowAnimationPanel:Init(showAnimation, self);
	UIManager:InitPanelZorder('ShowAnimationPanel', showAnimation);
	GlobalFunctions:recordTime('fb-log---MainScene:ShowAnimationPanel  ')

	-- init 
	local reconnection = cc.Node:create();
	reconnection:setPosition(StageSize.width/2, StageSize.height/2);
	reconnection:addTo(self);
	ReconnectionPanel:Init(reconnection, self);
	UIManager:InitPanelZorder('ReconnectionPanel', reconnection);
	GlobalFunctions:recordTime('fb-log---MainScene:WaitingPanel  ')

	MessageBox:init(self,self);
	GlobalFunctions:recordTime('fb-log---MainScene:MessageBox  ')
	self:sendRequest();
	GlobalFunctions:recordTime('fb-log---MainScene:sendRequest  ')

	-- UIManager:InitMainPanels()
	GlobalFunctions:recordTime('fb-log---MainScene:InitMainPanels  ')
	--UIManager:switch('MainPanel');
	-- EventManager:FireEvent(EventType.UIFooterChooseFooter , 1); --显示主页MainPanel

	
	-- Webproxy
	model.ChatModel:Init();

	-- touch effect layer
	self:addTouchEffectLayer();

	self:addKeyboardTouch();

	self.noticeNode = cc.Node:create();
	self.noticeNode:setPosition(StageSize.width/2, StageSize.height/2);
	self.noticeNode:addTo(self);
	self.noticeNode:setLocalZOrder(1000000-1)
	self.noticeNode:setVisible(false)
	local noticeBg = cc.Sprite:create('image/commonImg/big_tip_rect.png')
	noticeBg:addTo(self.noticeNode)


	self:initEdge()

	--[[
	local btnTest = ccui.Button:create('image/commonImg/btn_bg1.png')
		:setPosition(50, 50)
		:setLocalZOrder(10000000)
		:addTo(self)
		:addClickEventListener(function()
			print("=================================")
			print(cc.Director:getInstance():getTextureCache():getCachedTextureInfo())
			print("=================================")
		end)
	--]]
end

function MainScene:registEvent( regist )
	if regist == false then
		EventManager:UnregisterEvent(EventType.MainSceneEnterPanel)
		EventManager:UnregisterEvent(EventType.MainSceneLeavePanel)
		EventManager:UnregisterEvent(EventType.MainSceneAddSwallowCallback)
		EventManager:UnregisterEvent(EventType.MainSceneReloadGame)
		EventManager:UnregisterEvent(EventType.MainSceneReplaceTitleScene)
		EventManager:UnregisterEvent(EventType.UIGuidePanel)
		EventManager:UnregisterEvent(EventType.UITipsMessage)

		EventManager:UnregisterEvent(EventType.ShieldGuide)
		EventManager:UnregisterEvent(EventType.AddImportantAnnouncement)
		return 
	end
	EventManager:RegisterEvent(EventType.MainSceneEnterPanel, handler(self, self.Enter));
	EventManager:RegisterEvent(EventType.MainSceneLeavePanel, handler(self, self.Leave));
	EventManager:RegisterEvent(EventType.MainSceneAddSwallowCallback, handler(self, self.addSwallowCallback));

	EventManager:RegisterEvent(EventType.MainSceneReloadGame, handler(self, self.reloadGame));
	EventManager:RegisterEvent(EventType.MainSceneReplaceTitleScene, handler(self, self.replaceTitleScene));

	EventManager:RegisterEvent(EventType.UIGuidePanel , handler(self, self.showHandPosition));
	EventManager:RegisterEvent(EventType.UITipsMessage , handler(self, self.showTipsPosition));

	EventManager:RegisterEvent(EventType.ShieldGuide , handler(self, self.showShieldGuide));

	EventManager:RegisterEvent(EventType.AddImportantAnnouncement, handler(self, self.pushImportantAnnouncement))
	
end

function MainScene:initEdge()
	--设置重力

    self:getPhysicsWorld():setGravity(cc.p(0,-1600))    --重力 cc.p(0,-100)
    -- self:getPhysicsWorld():setDebugDrawMask(cc.PhysicsWorld.DEBUGDRAW_ALL)
    local size = display.size
    local body = cc.PhysicsBody:createEdgeBox(cc.size(size.width-40,size.height),cc.PHYSICSBODY_MATERIAL_DEFAULT,2)
    local edgeNode = cc.Node:create()
    edgeNode:setPosition(size.width/2,size.height/2)
    edgeNode:setPhysicsBody(body)
    self:addChild(edgeNode)
    --监听碰撞
    local function onContactBegin(contact)
        local tagA = contact:getShapeA():getBody():getNode():getTag()
	    local tagB = contact:getShapeB():getBody():getNode():getTag()
	    if (tagA>10000 and tagB>100 and tagB<500) or (tagB>10000 and tagA>100 and tagA<500) then
	    	-- print("tagA: ", tagA, "tagB:", tagB)
	    	-- if (tagA>200 and tagA<300) or (tagB>200 and tagB<300) then
	    	-- 	-- return false;
	    	-- end
	        return true;
	    end
        return false;
    end
    local function onContactPreSolve(contact)
    	-- local tag = contact:getShapeA():getBody():getNode():getTag()
     --    print('碰撞-1-',tag)     --碰撞后的回调事件
	    -- if (tagA>10000 and tagB>400 and tagB<500) or (tagB>10000 and tagA>400 and tagA<500) then
	        -- local curNode = nil
	        -- if tagA>10000 then
	        --     curNode = contact:getShapeB():getBody():getNode()

	        --     local body = contact:getShapeA():getBody()
	        --     local vel = body:getVelocity()
	        --     print("velX, velY:", vel.x, vel.y)
	        -- else
	        --     curNode = contact:getShapeA():getBody():getNode()
	        -- end
	    -- end
        return true
    end
    local function onContactPostSolve(contact)
    	-- local tag = contact:getShapeA():getBody():getNode():getTag()
     --    print('碰撞-2-',tag)     --碰撞后的回调事件
     	EventManager:FireEvent('EGO_ContactEvent', contact)
    end
    local function onContactSeparate(contact)
    	-- EventManager:FireEvent('EGO_ContactEvent', contact)
    end

    local contactListener = cc.EventListenerPhysicsContact:create()
    contactListener:registerScriptHandler(onContactBegin,cc.Handler.EVENT_PHYSICS_CONTACT_BEGIN)
    contactListener:registerScriptHandler(onContactPreSolve,cc.Handler.EVENT_PHYSICS_CONTACT_PRESOLVE)
    contactListener:registerScriptHandler(onContactPostSolve,cc.Handler.EVENT_PHYSICS_CONTACT_POSTSOLVE)
    contactListener:registerScriptHandler(onContactSeparate,cc.Handler.EVENT_PHYSICS_CONTACT_SEPARATE)
    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithFixedPriority(contactListener,1)

end

function MainScene:reloadGame()
	-- body
	print('app backto foreground')
	self:clearAll();
	cc.Director:getInstance():getTextureCache():removeUnusedTextures();

    GlobalFunctions:loadLanguage();
    ResTable:reloadMulLangTable();
	TimeManager:stopEvent(  )
	App:run("LoginScene");
end

function MainScene:replaceTitleScene( ... )
	self:clearAll();
	cc.Director:getInstance():getTextureCache():removeUnusedTextures();

    GlobalFunctions:loadLanguage();
    ResTable:reloadMulLangTable();
	TimeManager:stopEvent(  )
	App:run("TitleScene");

end


function MainScene:sendRequest()
	Network.NetworkManager:Send(Network.NetworkCmdType.req_enter_game_data, {});	
	if cc.exports.queryMsg then
		Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_good_verify, cc.exports.queryMsg);
		cc.exports.queryMsg = nil
	end
	--model.ArenaModel:reqArenaInfo()
end

-- 后台返回 处理
function MainScene:eventBackFromBackground(  )
	-- 客户端计时器需要更新
	-- 挂机收益
	-- Prompt:Show('app backto foreground');
	print('app backto foreground')
	-- self:clearAll();
	-- -- cc.Director:getInstance():getScheduler():unscheduleAll()
	
	-- cc.Director:getInstance():getTextureCache():removeUnusedTextures()
	-- App:run("LoginScene");

	TimeManager:timeBackGround();

	local url = define.udw_url[global_branch.package_enum];
	if not url then
		return
	end

	local ssn = define.ssn
	local bundleid, market;
	local package_name = sdkManager.SDKLuaHelper:getPackageName()
	if package_name == 'com.nani.ego.kr.aos' then
		bundleid = package_name
		market = 12

	elseif package_name == 'com.nani.ego.kr.one' then
		bundleid = package_name
		market = 13

	else
		return
	end

	if self.sendXhr then
		return
	end

	local newVersionFile = define.writablePath .. "/new_version/version.manifest";
	local fileUtils = cc.FileUtils:getInstance();
	local file;
	if fileUtils:isFileExist(newVersionFile) then
	local fileData = fileUtils:getStringFromFile(newVersionFile);
		file = json.decode(fileData);
	else
		local fileData = fileUtils:getStringFromFile('version/project.manifest');
		file = json.decode(fileData);
	end
	local version = tostring(file['version']);

	local getShowMsg = function(msgType, msg, globalMsg, lan)
		if globalMsg and globalMsg[msgType] and globalMsg[msgType].messages and globalMsg[msgType].messages[lan] then
			return globalMsg[msgType].messages[lan];
		else
			return msg;
		end
	end

	local xhr = cc.XMLHttpRequest:new()
	xhr.responseType = cc.XMLHTTPREQUEST_RESPONSE_STRING
	local udw_url = url..'?ssn='..ssn..'&bundleid='..bundleid..'&market='..market..'&version='..version
	xhr:open("GET", udw_url)
	xhr:registerScriptHandler(function()
		self.sendXhr = false
		if  xhr.readyState == 4 and xhr.status == 200 then
			local r = Cjson.decode(xhr.response)
			local code = tonumber(r.Code)
			local msg = r.Msg
			local url = r.Url
			local ext = r.ext
			local data = r.data
			local glMsg = r.globalMsg
			local lan = cc.UserDefault:getInstance():getStringForKey('lg_set', 'default')
			if lan == 'default' then
				lan = device.language
			end
			if lan == 'kr' then
				lan = 'ko'
			elseif lan == 'jp' then
				lan = 'ja'
			elseif lan == 'sp' then
				lan = 'es'
			elseif lan == 'cn' then
				lan = 'zh-tw'
			elseif lan == 'tw' then
				lan = 'zh-tw'
			end
			if code == 1 then
local time = '';
				if glMsg and glMsg.maintenance and glMsg.maintenance.utcStartTime and glMsg.maintenance.utcEndTime then
					local c = os.date('!*t',os.time())--中时区的时间
					local d = os.date('*t',os.time())
					local timeZone= (d.hour - c.hour) * 3600 + (d.min - c.min) * 60
					timeZone = timeZone/3600
					local a, b
					local st = {}
					local et = {}
					a, b, st.year, st.month, st.day, st.hour, st.min = string.find(glMsg.maintenance.utcStartTime, "(%d+)-(%d+)-(%d+)%s*(%d+):(%d+)");
					st.hour = st.hour + timeZone
					local st_c = os.date("%H:%M", os.time(st))
					a, b, et.year, et.month, et.day, et.hour, et.min = string.find(glMsg.maintenance.utcEndTime, "(%d+)-(%d+)-(%d+)%s*(%d+):(%d+)");
					et.hour = et.hour + timeZone
					local et_c = os.date("%H:%M", os.time(et))
					time = string.format('(%s~%s)', tostring(st_c), tostring(et_c))
				end
				local showMsg = getShowMsg('maintenance', msg, glMsg, lan)
				showMsg = showMsg .. time
				MessageBox:create(showMsg , MessageBoxType.OK, function()
					cc.Director:getInstance():endToLua();
				end, function()
					cc.Director:getInstance():endToLua();
				end, function()
					cc.Director:getInstance():endToLua();
				end);
			elseif code == 2 then
				-- 大版本更新
				local showMsg = getShowMsg('marketUpdate', msg, glMsg, lan)
				MessageBox:create(showMsg , MessageBoxType.OK, function()
					local url = ''
					if package_name == 'com.nani.ego.kr.aos' then
						url = 'https://play.google.com/store/apps/details?id=com.nani.ego.kr.aos'
					elseif package_name == 'com.nani.ego.kr.one' then
						url = 'https://onesto.re/0000751708'
					end
					if url ~= '' then
						cc.Application:getInstance():openURL(url)
					end
					cc.Director:getInstance():endToLua();
					end, function()
				end, function()
					cc.Director:getInstance():endToLua();
				end);
			end
		end
	end)
	xhr:send()
	self.sendXhr = true
end

function MainScene:onEnter()
	GlobalFunctions:recordTime('fb-log---MainSceneEnter  ')
	--UIManager:push('FooterPanel');

	WaitingPanel:Show()
	WaitingPanel:HideAni()--不显示动画

	--AudioManager:stopAllEffects()
	AudioManager:SetState(Enum:getTable('GameState').Main);
	AudioManager:playMusic(Conf.main, 2, true);
	cc.Director:getInstance():getTextureCache():removeUnusedTextures()

	--设置界面对应事件回调
	-- uicontrol:addTouchEventListener(handler(self, self.func))
	--调度器注册
	self.allPanelsInitEnd = false;
	self.m_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.update), 0, false);

	--バックグラウンド処理
	--テスト
	local eventDispatcher = self:getEventDispatcher();
	local foreground_listener = cc.EventListenerCustom:create("BACK_GROUND", function()
		-- Prompt:Show('app goto background');
		print('app goto background')
		end)
    eventDispatcher:addEventListenerWithSceneGraphPriority(foreground_listener, self);

	--復帰処理
	--テスト
	local background_listener = cc.EventListenerCustom:create("FORE_GROUND", function()
		self:eventBackFromBackground();
		end)
    eventDispatcher:addEventListenerWithSceneGraphPriority(background_listener, self);

    self:initGuideShieldLayer();
end

function MainScene:onExit()
	if self.m_scheduleHandler then
		scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
		self.m_scheduleHandler = nil
	end
end

function MainScene:update(dt)
	-- body
	if self.allPanelsInitEnd == true then
		return
	end

	local st = true
	local layerRoot = 'app.layer.MainScene.';
	for k, v in pairs(self.preLoadPanelList) do
		local handlerClass = require(layerRoot .. k);--LayerHandlerClassList[k]
		if self.layerHandlerList[k] == nil then
			local nodeName = k
			local nodeHandler = handlerClass:create(self, 'MainScene', nodeName);
			UIManager:AddLayer(nodeName, nodeHandler);
			if not nodeHandler.hasBase then
				UIManager:InitPanelGlobalFunction(nodeName, nodeHandler, self, self.layerList);
			end
			self.layerHandlerList[nodeName] = nodeHandler;
			UIManager:InitMainPanelsByKey(nodeName)
			st = false

			break;
		end
	end

	if st then
		if self.delayNum <=3 then
			if self.delayNum == 1 then
				UIManager:switch('MainPanel');
			end
			st = false;
			self.delayNum = self.delayNum+1
		end
	end

	if st then
		if self.loadPanel == 0 then
			self.loadPanel = 1
			-- EventManager:FireEvent(EventType.UIFooterChooseFooter , 1); --显示主页MainPanel --改为第一次创建后自动显示 footer 和 header
		end

		for k, v in pairs(self.MainPanels) do
			local handlerClass = require(layerRoot .. k);--LayerHandlerClassList[k]
			if self.layerHandlerList[k] == nil then
				local nodeName = k
				local nodeHandler = handlerClass:create(self, 'MainScene', nodeName);
				UIManager:AddLayer(nodeName, nodeHandler);
				if not nodeHandler.hasBase then
					UIManager:InitPanelGlobalFunction(nodeName, nodeHandler, self, self.layerList);
				end
				self.layerHandlerList[nodeName] = nodeHandler;
				UIManager:InitMainPanelsByKey(nodeName)
				st = false

				break;
			end
		end
		
	end

	if st then
		if self.loadPanel == 1 then --第二批面板加载完成
			self.loadPanel = 2
		end
		for k, v in pairs(LayerHandlerClassList) do
			local nodeName = v;
			local handlerClass = require(layerRoot .. v);
			if self.layerHandlerList[nodeName] == nil then
				local nodeHandler = handlerClass:create(self, 'MainScene', nodeName);
				UIManager:AddLayer(nodeName, nodeHandler);
				if not nodeHandler.hasBase then
					UIManager:InitPanelGlobalFunction(nodeName, nodeHandler, self, self.layerList);
				end
				if self.preLoadPanelList[nodeName] then
					UIManager:preInit(nodeName);
				end
				self.layerHandlerList[nodeName] = nodeHandler;
				st = false

				break;
			end
			
		end

	end 
	self.allPanelsInitEnd = st;
	if self.allPanelsInitEnd then
		TimeManager:mainSceneLoadOver();
		self:initRemindNode();
		self:initTipsNode();
		WaitingPanel:Hide()
		
		if model.GuideModel:isInGuide() then
			GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu_start);
			self:showShieldGuide(true)
		else
			self:showShieldGuide(false)

			if model.UserModel:getIsPopNotice() == 1 then
				UIManager:push('AnnouncePanel')
			else
				if model.AutoFightModel:IsFull() then
					EventManager:FireEvent(EventType.FightIncomeFull);
				end
			end
			-- autolua.SDKCToollua:naverCafeStart( )
		end
		model.GuideModel:startTriggerGuide();

		self:initBg()
	end
	-- GlobalFunctions:recordTime('fb-log---MainScene:InitPanel  ')
end

function MainScene:Enter(layerName, ...)
	if self.layerHandlerList[layerName] then
		self.layerHandlerList[layerName]:onEnter(...);
	end
	if self.swallowLayerList[layerName] then
		self.swallowListenerList[layerName] = cc.EventListenerTouchOneByOne:create();
		local onTouchBegan = function()
			print('touch ', layerName)
			return true;
		end
		local onTouchEnd = function()
			if self.swallowCallbackList[layerName] then
				self.swallowCallbackList[layerName]();
			end
		end
		-- lcz mark
		self.swallowListenerList[layerName]:setSwallowTouches(true);
		self.swallowListenerList[layerName]:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN)
		self.swallowListenerList[layerName]:registerScriptHandler(onTouchEnd, cc.Handler.EVENT_TOUCH_ENDED)
		local eventDispatcher = self.swallowLayerList[layerName]:getEventDispatcher();
	    eventDispatcher:addEventListenerWithSceneGraphPriority(self.swallowListenerList[layerName], self.swallowLayerList[layerName])
	end
end

function MainScene:Leave(layerName)
	if self.layerHandlerList[layerName] then
		self.layerHandlerList[layerName]:onLeave();
	end
	if self.swallowListenerList[layerName] then
		self.swallowLayerList[layerName]:getEventDispatcher():removeEventListener(self.swallowListenerList[layerName]);
		self.swallowListenerList[layerName] = nil;
	end
end

-- function MainScene:update(dt)
-- end

function MainScene:getLayerList(nodeName)
	return self.layerList[nodeName];
end

function MainScene:addTouchEffectLayer()
	local touchEffectLayer = ccui.Layout:create()
		:setContentSize(cc.size(StageSize.width*2, StageSize.height*2))
		:addTo(self)
		:setLocalZOrder(2000)
	
	self.touch = cc.EventListenerTouchOneByOne:create();
    local function onTouchBegan(tap, event)
    	GlobalMove = false;
        local location = tap:getLocation()
	
		local data = {}
		data.name = 'click';
		data.num = 14;
		data.frame = 25;
		local animation = FrameEffectManager:createFrameAnimation(data.name, data.num, data.frame);
		local action = cc.Animate:create(animation);

		local touchEffect1 = cc.Sprite:create()
			:addTo(touchEffectLayer)
            :move(location.x, location.y)
			:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA));

		local callback = function()
			touchEffect1:removeFromParent();
		end
		local action2 = cc.CallFunc:create(callback)

		touchEffect1:runAction(cc.Sequence:create(action, action2));

        local tapeffect1 = cc.ParticleSystemQuad:create("Effect/particle/click.plist")
			:addTo(touchEffectLayer)
            :setAutoRemoveOnFinish(true)
            :move(location.x, location.y)
			:setPositionType(cc.POSITION_TYPE_RELATIVE)
        return true
    end

    local onTouchMove = function(touch,event)
        local posEnd = touch:getLocation();
        local posStart = touch:getStartLocation()
        local dis = cc.pGetDistance(posStart,posEnd)
        if dis > 20 then
            GlobalMove = true;
        end
    end
    local onTouchEnd = function(touch ,event )
    end

    self.touch:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN)
    self.touch:registerScriptHandler(onTouchMove, cc.Handler.EVENT_TOUCH_MOVED);
    self.touch:registerScriptHandler(onTouchEnd, cc.Handler.EVENT_TOUCH_ENDED);
    local eventDispatcher = self:getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(self.touch, touchEffectLayer)
end

function MainScene:initGuideShieldLayer()
	-- body
	local btn = ccui.Button:create('image/commonImg/bg_5_582_176.png');
	btn:addTo(self);
	btn:setPosition(StageSize.width/2, StageSize.height/2);
	btn:setContentSize(cc.size(StageSize.width*2, StageSize.height*2))
	btn:setScale9Enabled(true)
	btn:setLocalZOrder(999998);
	btn:addClickEventListener(function()
			end);
	btn:setOpacity(0)
	self.ShieldLayer = btn
end

function MainScene:showShieldGuide(v)
	if v then
		self.ShieldLayer:setPosition(StageSize.width/2, StageSize.height/2);
	else
		self.ShieldLayer:setPosition(-30000, 0);
	end
end

function MainScene:initRemindNode()
	-- body

	self.remindNode = cc.Node:create();
	self.remindNode:addTo(self)
	self.remindNode:setLocalZOrder(999999)
	self.remindNode:setPosition(StageSize.width/2, StageSize.height/2)
	self.remindNode:setVisible(false)


	self.infoNode = cc.Node:create()
		:addTo(self.remindNode);
	local infoBg = cc.Sprite:create('image/guide/banzi.png')
		:addTo(self.infoNode)
	self.infoLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18)
	self.infoLabel:addTo(self.infoNode)
		:setAnchorPoint(cc.p(0.5 ,0.5))
		:setPosition(cc.p(0,0))
		:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 2)
		:setMaxLineWidth(350)
		:setContentSize(cc.size(360 , 100))
		:setLineBreakWithoutSpace(true)	
		:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
		:setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
	
	self.hand = cc.Sprite:create('image/guide/shou.png')
		:addTo(self.remindNode)

	local spine_res = 'guidering_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.guideSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.guideSpine:setAnimation(0, 'guidering_spine', true)
		self.guideSpine:addTo(self.remindNode);
	else
		print('error : 缺少spine 资源')
	end  
end

function MainScene:showHandPosition( wpt, msg )
	local handPos = cc.p(0,0)
	local handPosMoveBy = cc.p(0,0);
	local rotation = 0;
	local infoPos = cc.p(0,0)

	if wpt == nil or next(wpt) == nil then
		self.remindNode:setVisible(false)
		return 
	end

	local particlePos = self.remindNode:convertToNodeSpace(wpt);

	self.infoLabel:setString(msg);
	if particlePos.x < 0 then
		handPos.x = particlePos.x + 50 
		handPosMoveBy.x =  10;

		if particlePos.y > -280 then
			handPos.y = particlePos.y - 45
			handPosMoveBy.y =  -10

			infoPos.x = handPos.x + 200
			infoPos.y = handPos.y - 80
		else
			handPos.y = particlePos.y + 55 
			handPosMoveBy.y = 10
			
			rotation =  -90

			infoPos.x = handPos.x + 190
			infoPos.y = handPos.y + 80
		end

	else

		handPos.x = particlePos.x - 50 
		handPosMoveBy.x =  - 10;

		if particlePos.y > -280 then
			handPos.y = particlePos.y - 45
			handPosMoveBy.y =  - 10
			rotation =  90

			infoPos.x = handPos.x - 200
			infoPos.y = handPos.y - 80
		else
			handPos.y = particlePos.y + 55 
			handPosMoveBy.y = 10
			rotation =  180

			infoPos.x = handPos.x - 190
			infoPos.y = handPos.y + 80
		end
	end

	self.hand:setPosition(handPos)
	self.hand:setRotation(rotation)
	self.hand:stopAllActions()
	self.hand:runAction(cc.RepeatForever:create(cc.Sequence:create(
		cc.MoveBy:create(0.5,handPosMoveBy),
		cc.MoveBy:create(0.5,cc.p(-handPosMoveBy.x,-handPosMoveBy.y))
		)))
	
	if infoPos.x + 184 > StageSize.width/2 then
		infoPos.x = StageSize.width/2 - 190
	elseif infoPos.x - 184 < -StageSize.width/2 then 
		infoPos.x = 190 -StageSize.width/2
	end
	self.infoNode:setPosition(infoPos);
	if msg=='' then
		self.infoNode:setVisible(false)
	else
		self.infoNode:setVisible(true)
	end

	self.guideSpine:setPosition(particlePos);

	self.remindNode:setVisible(true)

end

function MainScene:initTipsNode()
	-- body

	self.tipsNode = cc.Node:create();
	self.tipsNode:addTo(self)
	self.tipsNode:setLocalZOrder(999998)
	self.tipsNode:setPosition(StageSize.width/2, StageSize.height/2)
	self.tipsNode:setVisible(false)


	self.tipInfoNode = cc.Node:create()
		:addTo(self.tipsNode);
	local infoBg = cc.Sprite:create('image/guide/banzi.png')
		:addTo(self.tipInfoNode)
	self.tipLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18)
	self.tipLabel:addTo(self.tipInfoNode)
		:setAnchorPoint(cc.p(0.5 ,0.5))
		:setPosition(cc.p(0,0))
		:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 2)
		:setMaxLineWidth(350)
		:setContentSize(cc.size(360 , 100))
		:setLineBreakWithoutSpace(true)	
		:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
		:setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER)
	
	self.tipArrow = cc.Sprite:create('image/guide/arrow.png')
		:addTo(self.tipsNode)

end

function MainScene:showTipsPosition( wpt, msg )
	local handPos = cc.p(0,0)
	local rotation = 0;
	local infoPos = cc.p(0,0)

	if wpt == nil or next(wpt) == nil then
		self.tipsNode:setVisible(false)
		return 
	end

	local particlePos = self.tipsNode:convertToNodeSpace(wpt);

	self.tipLabel:setString(msg);
	if particlePos.x < 0 then
		handPos.x = particlePos.x
		handPos.y = particlePos.y

		infoPos.x = handPos.x +140
		infoPos.y = handPos.y + 73

		-- if particlePos.y > -280 then
		-- 	handPos.y = particlePos.y - 45

		-- 	infoPos.x = handPos.x + 200
		-- 	infoPos.y = handPos.y - 80
		-- else
		-- 	handPos.y = particlePos.y + 55 
			
		-- 	rotation =  -90

		-- 	infoPos.x = handPos.x + 190
		-- 	infoPos.y = handPos.y + 80
		-- end

	else

		handPos.x = particlePos.x
		handPos.y = particlePos.y

		infoPos.x = handPos.x -140
		infoPos.y = handPos.y + 73

		-- if particlePos.y > -280 then
		-- 	handPos.y = particlePos.y - 45
		-- 	rotation =  90

		-- 	infoPos.x = handPos.x - 200
		-- 	infoPos.y = handPos.y - 80
		-- else
		-- 	handPos.y = particlePos.y + 55 
		-- 	rotation =  180

		-- 	infoPos.x = handPos.x - 190
		-- 	infoPos.y = handPos.y + 80
		-- end
	end

	self.tipArrow:setPosition(handPos)
	-- self.tipArrow:setRotation(rotation)
	
	self.tipInfoNode:setPosition(infoPos);

	self.tipsNode:setVisible(true)

end

function MainScene:initBg()
	local sp = cc.Sprite:create('image/commonImg/lbg.png');
	local texture = sp:getTexture();
	texture:setTexParameters(gl.LINEAR, gl.LINEAR, gl.REPEAT, gl.REPEAT)
	local testTop = cc.Sprite:createWithTexture(texture, cc.rect(0, 0, StageSize.width, StageSize.height))
	testTop:addTo(self.uiBgNode)
	testTop:setPosition(StageSize.width/2, StageSize.height/2+700)
	testTop:setLocalZOrder(-1);
	testTop:setAnchorPoint(0.5, 0)

	local testBottom = cc.Sprite:createWithTexture(texture, cc.rect(0, 0, StageSize.width, StageSize.height))
	testBottom:addTo(self.uiBgNode)
	testBottom:setPosition(StageSize.width/2, StageSize.height/2-700)
	testBottom:setLocalZOrder(-1);
	testBottom:setAnchorPoint(0.5, 1)
end

function MainScene:pushImportantAnnouncement(word)
	self.noticeNode:setVisible(true)
	local ntWidth = 500
	local ntlayout = ccui.Layout:create()
		:setAnchorPoint(cc.p(0.5, 0.5))
		:setContentSize(cc.size(ntWidth, 40))
		:setClippingEnabled(true)
		:addTo(self.noticeNode)

	local ntlabel = cc.Label:createWithTTF(word, Enum:getTable("SystemFont").FONT_SIYUAN, 22)
		:setTextColor(cc.c3b(255,255,0))
		:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
		:setAnchorPoint(cc.p(0, 0.5))
		:setPosition(ntWidth, 20)
		:addTo(ntlayout)
		-- :enableOutline(cc.c3b(0, 0, 0), 1)
	
	local size = ntlabel:getContentSize();
	local moveWidth = size.width+ntWidth;
	local moveTime = 4;
	
	ntlabel:runAction(cc.Sequence:create(
		cc.MoveBy:create(moveTime, cc.p(-moveWidth, 0)),
		cc.CallFunc:create(function()
			ntlayout:removeFromParent()
			self.noticeNode:setVisible(false)
		end)
	))
end

function MainScene:addKeyboardTouch()

	local keyboardTouchLayer = ccui.Layout:create()
		:setContentSize(cc.size(StageSize.width*2, StageSize.height*2))
		:addTo(self)
		:setVisible(false)
		:setLocalZOrder(1000000)

	local msgBox = template.MessageBoxTemplate:create(keyboardTouchLayer);
	msgBox:setPosition(StageSize.width/2, StageSize.height/2);
	msgBox:initData(LANG.COMMON_EXIT_TIP,Enum:getTable('MessageBoxType').CANCEL_OK);

	local canKeyboradTouch = true;
	---[[
	if self.keyboardListener then
		self:getEventDispatcher():removeEventListener(self.keyboardListener);
		self.keyboardListener = nil;
	end

	local onKeyReleased = function(keyCode, event)
		if keyCode == cc.KeyCode.KEY_BACK then
			if model.GuideModel:isInGuide() then
				return;
			end
			if canKeyboradTouch then
				canKeyboradTouch = false;
				keyboardTouchLayer:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(function() 
					if not UIManager:keyboardBack() then
						msgBox:addClickListener(function()
							cc.Director:getInstance():endToLua();
						end,function()
							keyboardTouchLayer:setVisible(false);
						end);
						keyboardTouchLayer:setVisible(true);
					end
					canKeyboradTouch = true;
				end)));
			end
		end
	end

	self.keyboardListener = cc.EventListenerKeyboard:create()
	self.keyboardListener:registerScriptHandler(onKeyReleased, cc.Handler.EVENT_KEYBOARD_RELEASED )

	local eventDispatcher = keyboardTouchLayer:getEventDispatcher()
	eventDispatcher:addEventListenerWithSceneGraphPriority(self.keyboardListener, keyboardTouchLayer)
	--]]
	--[[
	local btn = ccui.Button:create('image/commonImg/add_btn_1.png');
	btn:setLocalZOrder(1000001)
	btn:setPosition(21.5,21.5)
	btn:addTo(self)
	btn:addClickEventListener(function()
		if model.GuideModel:isInGuide() then
			return;
		end
		if canKeyboradTouch then
			canKeyboradTouch = false;
			keyboardTouchLayer:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(function() 
				if not UIManager:keyboardBack() then
					msgBox:addClickListener(function()
						cc.Director:getInstance():endToLua();
					end,function()
						keyboardTouchLayer:setVisible(false);
					end);
					keyboardTouchLayer:setVisible(true);
				end
				canKeyboradTouch = true;
			end)));
		end
	end)
	--]]
end

return MainScene;
