﻿local scheduler = cc.Director:getInstance():getScheduler();
local NewPlayerScene = class("NewPlayerScene", function()
	local scene = nil;
	scene = display.newScene("VersionUpdateScene")

	return scene;
end)
local fonts = Enum:getTable("SystemFont");

function NewPlayerScene:ctor()
	self.editInputStr = ''

	local function onNodeEvent(event)
		if event == "enter" then
			self:onEnter()
		elseif event == "exit" then
			self:onExit()
		end
	end
	self:registerScriptHandler(onNodeEvent)
	self.m_scheduleHandler = nil;

	--设置当前场景的提示
	local nodePrompt = cc.Node:create();
	nodePrompt:setPosition(display.center);
	nodePrompt:setLocalZOrder(2000);
	nodePrompt:addTo(self);
	Prompt:Init(nodePrompt, self);

	self.namePanel = cc.Node:create()
		:setPosition(StageSize.width/2, StageSize.height/2+115)
		:addTo(self)

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.namePanel);
	bg:setPosition(0 , 11);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(514 , 331));

	local titleNode = GlobalFunctions:createTitle(LANG.TUTORIAL_2,514,46,LANG.TUTORIAL_3);
	titleNode:addTo(self.namePanel);
	titleNode:setPosition(0,200);

	local nameBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	nameBg:addTo(self.namePanel);
	nameBg:setPosition(0 , 58);
	nameBg:setCapInsets(cc.rect(11,11,34,28));
	nameBg:setContentSize(cc.size(492 , 218));

	self.btn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
	self.btn:setPosition(0, -100);
	self.btn:addTouchEventListener(handler(self, self.decideName));
	self.btn:addTo(self.namePanel);
	self.btn:setLocalZOrder(1000);
	local label = cc.Label:createWithTTF('OK', fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c3b(50 , 85 , 150))
	self.btn:setTitleLabel(label)

	local nameBg = cc.Scale9Sprite:create('image/commonImg/edit_bg_28_0_177_49.png')
	:addTo(self.namePanel)
	:setPosition(0 , 53)
	:setCapInsets(cc.rect(28,0,177,49))
	:setContentSize(cc.size(334 , 49))

	local nameImg = cc.Sprite:create('image/commonImg/edit_img.png')
	:addTo(self.namePanel)
	:setPosition(cc.p(139,55))

	self.editBox = ccui.EditBox:create(cc.size(261, 49), cc.Scale9Sprite:create());
	self.editBox:setFontColor(cc.c4b(150, 150, 150, 255));
	self.editBox:setFontSize(18);
	self.editBox:setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
	self.editBox:setMaxLength(8); 
	self.editBox:setText('');
	self.editBox:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE);
	self.editBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE);
	self.editBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
	self.editBox:setPlaceHolder(LANG.TUTORIAL_5)
	self.editBox:setPlaceholderFontColor(cc.c3b(150, 150, 150));
	self.editBox:setPlaceholderFontSize(18);
	self.editBox:setPosition(-14, 53);
	self.editBox:addTo(self.namePanel);
	self.editBox:registerScriptEditBoxHandler(function(event)
			-- if event == "began" then
			-- 	self.editBox:setText(self.editInputStr or "");
			-- end
			
			-- if event == "changed" then
			-- 	local str =  self.noticeEditBox:getText();
			-- 	-- self.notice:setString(str);
			-- 	self.changeNotice = true ;
			-- end
			
			if event == "return" then
				local str =  self.editBox:getText()
				str = string.lower(str)
				self.editBox:setText(str)
				self.editInputStr = str;
				local str3, btrue = checkStr( str )
				if btrue == false then
					-- self.editInputStr = str3;
					Prompt:Show(LANG.UI_CRTNAME);
					-- self.editBox:setText(str3)
					return
				end

				local str2,bRet = tools.SensitiveTools:checkSensitive( str )
				if bRet == true then
					-- self.editInputStr = str2;
					Prompt:Show(LANG.UI_SENSITIVE);
					-- self.editBox:setText(str2)
					return 
				else
					self.editBox:setText(str)
				end
			end
		end);

	local line = cc.Sprite:create('image/commonImg/line.png');
		line:addTo(self.namePanel);
		line:setContentSize(cc.size(492,1))
		line:setPosition(cc.p(0,-4))

	self.word1 = cc.Label:createWithTTF(LANG.TUTORIAL_4, fonts.FONT_SIYUAN, 20)
		:setPosition(0, 119.5)
		:addTo(self.namePanel)

	local tipsImg = cc.Sprite:create('image/commonImg/tip_2.png');
	tipsImg:addTo(self.namePanel);
	tipsImg:setPosition(0 , -27);
	
	self.word2 = cc.Label:createWithTTF(LANG.TUTORIAL_6,fonts.FONT_SIYUAN, 20)
		:setTextColor(cc.c3b(255 , 200 , 0))
		:setPosition(0, -27)
		:addTo(self.namePanel)
	
	local width = tipsImg:getContentSize().width;
	local wordWith = self.word2:getContentSize().width;
	local posX = -wordWith/2;
	tipsImg:setPosition(posX,-27);
	self.word2:setPosition(posX + width/2 + wordWith/2,-27);

	self.block = cc.LayerColor:create(cc.c4b(0, 0, 0, 255),display.width, display.height)
		:setLocalZOrder(-10)
		:addTo(self)
end

function NewPlayerScene:onEnter()
	--AudioManager:playEffect( 'title', 1, true )
	EventManager:RegisterEvent(EventType.UILoginCreateNewUser, handler(self, self.retCreateNewUser))

	GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').nickname_on);
	self.decideFlag = false
end

function NewPlayerScene:onExit()
end

function NewPlayerScene:decideName(sender, eventType)
	if eventType == 2 then
		local nameTxt =  self.editInputStr--self.editBox:getText();
		local str3, btrue = checkStr( nameTxt )
		if btrue == false then
			Prompt:Show(LANG.UI_CRTNAME);
			return
		end
		local _,bRet = tools.SensitiveTools:checkSensitive( nameTxt )
		if bRet == true then
			Prompt:Show(LANG.UI_SENSITIVE);
			return 
		end
		if nameTxt ~= '' then
			if self.decideFlag then
				return
			end
			self.decideFlag = true
			self.name_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.nameCooldownUpdate), 0.5, false);
			model.AccountModel:reqCreateNewAccount(nameTxt)
		else
			Prompt:Show(LANG.TUTORIAL_7);
		end
	end
end

function NewPlayerScene:nameCooldownUpdate()
	if self.name_scheduleHandler then
		scheduler:unscheduleScriptEntry(self.name_scheduleHandler)
		self.decideFlag = false
	end
end

function NewPlayerScene:retCreateNewUser(msg)
	--[[
	GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').nickname_off);
	local args = {
		eventName = Enum:getTable('TrackEventToken').TRACK_MOVIE_PLAY
	}
	sdkManager.SDKLuaHelper:trackEvent(args)
	]]
	GlobalFunctions:trackEvent('TRACK_MOVIE_PLAY')
		
	self.namePanel:setVisible(false);
	model.UserDefaultModel:clearAboutUserData();
	self.block:runAction(cc.Sequence:create(cc.FadeIn:create(2.5), cc.CallFunc:create(handler(self, self.enterNextScene))));
end

function NewPlayerScene:enterNextScene()
	--App:run("TutoPlotScene");
	App:run("LoginScene")
end

return NewPlayerScene;
