local scheduler = cc.Director:getInstance():getScheduler();
local NetworkManager = Network.NetworkManager;
local NetworkCmdType = Network.NetworkCmdType;
local fonts = Enum:getTable("SystemFont");
local MessageBoxType = Enum:getTable('MessageBoxType')

local CHECK_STEP = {
	STEP_NULL 			= 0,

	STEP_SPLASH			= 1,	-- 闪屏
	STEP_AGE_LIMIT		= 2,	-- 年龄分级
	STEP_PERMISSION		= 3,	-- 权限
	
	STEP_CHECK_DOWN		= 4,	-- 检测更新

}

local VersionUpdateScene = class("VersionUpdateScene", function()
	local scene = nil;
	scene = display.newScene("VersionUpdateScene")

	return scene;
end)

function VersionUpdateScene:ctor()
	--加载资源
	--设置ui根结点


	local function onNodeEvent(event)
		if event == "enter" then
			self:onEnter()
		elseif event == "exit" then
			self:onExit()
		end
	end
	self:registerScriptHandler(onNodeEvent)
end

function VersionUpdateScene:onEnter()

	self.touchLayer = cc.Layer:create()
	self.touchLayer:setContentSize(cc.size(StageSize.width, StageSize.height));
	self.touchLayer:setTouchEnabled(true);
    self.touchLayer:registerScriptTouchHandler(function()
--		sdkManager.SDKLuaHelper:restart()
		cc.Director:getInstance():restart();
	end);
	self.touchLayer:addTo(self);

end

function VersionUpdateScene:onExit()
	if self.m_scheduleHandler then 
		scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
		self.m_scheduleHandler = nil 
	end
end

return VersionUpdateScene
