--挂点特效类
local AvatarActorEffect = class("AvatarActorEffect", require("app.effect.Effect"))
local FightRestraintEnum = Enum:getTable('FightRestraintEnum')

function AvatarActorEffect:ctor(id, skillResid)
	AvatarActorEffect.super.ctor(self, id, skillResid);
end

function AvatarActorEffect:Initialize( actorID, pos, effectScale, layer, effectID, restraintType )
	self.actor = FightManager:GetFighter(actorID);

	if not self.actor then
		return;
	end

	self.effectName = ResTable:getValue(TableName.SkillEffect, effectID, 'name')
	self.restraintType = restraintType
	print('a effect init:', self.id, self.actor.resID, effectID, self.effectName, pos)
	DragonBonesManager:loadDragonBonesResources(self.effectName, 'Effect/db/')
	self.effect = DragonBonesManager:getFactory():buildArmatureDisplay(self.effectName)
--	self.effect:setScale(effectScale)
	local fatherDB = self.actor:getArmatureDB()
	fatherDB:getArmature():getSlot(pos):setChildArmature(self.effect:getArmature());
	if self.effect:getAnimation():hasAnimation('none') then
		local timeScale = 1/FightManager:SpeedUp()
		self.effect:getAnimation():play('none', 1, timeScale)
	else
		print(self.effectName, 'error!')
	end
end

function AvatarActorEffect:run()
	local timeScale = 1/FightManager:SpeedUp()
	if self.effect:getAnimation():hasAnimation(self.effectName) then
		self.effect:getAnimation():play(self.effectName, 1, timeScale)
	else
		self.effect:getAnimation():play(FightRestraintEnum[self.restraintType], 1, timeScale)
	end
end

--销毁
function AvatarActorEffect:Destroy()
	if not self.actor then
		return;
	end
	AvatarActorEffect.super.Destroy(self);
end

return AvatarActorEffect;

