--挂点特效类
local AvatarEffect = class("AvatarEffect", require("app.effect.Effect"))
local FightRestraintEnum = Enum:getTable('FightRestraintEnum')

function AvatarEffect:ctor(id, skillResid)
	AvatarEffect.super.ctor(self, id, skillResid);
end

function AvatarEffect:Initialize( actorID, avatarPos, pos, effectScale, layer, effectID, restraintType )
	self.actor = FightManager:GetFighter(actorID);

	if not self.actor then
		return;
	end

	local effectName = ResTable:getValue(TableName.SkillEffect, effectID, 'name')
	print('a effect init:', self.id, self.actor.resID, effectID, effectName, json.encode(pos))
	DragonBonesManager:loadDragonBonesResources(effectName, 'Effect/db/')
	local effect = DragonBonesManager:getFactory():buildArmatureDisplay(effectName)
	local db_id = DragonBonesManager:AddDisplay(effect, effectName)
	self.destroyCallback = function()
		effect:removeFromParent()
		DragonBonesManager:RemoveDisplay(db_id)
	end

	local timeScale = 1/FightManager:SpeedUp()

	local fatherNode = self.actor:getEffectNode();
	--effect:setScale(effectScale)
	if pos.pos == 2 then
		effect:setPosition(0, -50)
	end
	effect:addTo(fatherNode)

	if effect:getAnimation():hasAnimation(effectName) then
		effect:getAnimation():play(effectName, 1, timeScale)
	else
		effect:getAnimation():play(FightRestraintEnum[restraintType], 1, timeScale)
	end
	if self.actor:IsEnemy() then
		effect:getArmature():setFlipX(true);
	end
	local listener = cc.EventListenerCustom:create("complete", function(event)
		self:setDestroy()
	end)
	effect:getEventDispatcher():setEnabled(true)
	effect:getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

--更新
function AvatarEffect:Update( dt )
	if not self.runningState then
		return true;
	end
	local running = true;
	if self.destroyFlag then
		self:Destroy();
		running = false;
	end
	return running;
end

--销毁
function AvatarEffect:Destroy()
	if not self.actor then
		return;
	end
	if self.destroyCallback then
		self.destroyCallback()
	end
	--self.actor:DetachEffect(self);
	AvatarEffect.super.Destroy(self);
end

function AvatarEffect:setDestroy()
	self.destroyFlag = true;
end

return AvatarEffect;
