local EffectFunction = class("EffectFunction")
local SkillCon = Enum:getTable('SkillCon');

function EffectFunction:ctor()

end

function EffectFunction:SetAnimation( fighterID, animationType )
	local fighterList = {}
	if type(fighterID) ~= 'table' then
		table.insert(fighterList, fighterID);
	else
		fighterList = fighterID;
	end

	for k, v in pairs(fighterList) do
		local fighter = FightManager:GetFighter(v);
		if fighter and fighter:isAlive() then
			fighter:SetAnimation(animationType)
		end
	end
end

--攻击者攻击达到目标身上，伤害效果生效
function EffectFunction:AddDamage( attackerID, targetIDList, Skill, damageNum )
	local attacker = FightManager:GetFighter(attackerID);
	local targetList = {};
	for _, v in pairs(targetIDList) do
		local fighter = FightManager:GetFighter(v);
		fighter:SkillEffect(attacker, Skill, damageNum);
	end
end

function EffectFunction:AddBuff( attackerID, targetIDList, Skill )
	local attacker = FightManager:GetFighter(attackerID);
	local targetList = {};
	for _, v in pairs(targetIDList) do
		local fighter = FightManager:GetFighter(v);
		if fighter then
			fighter:AddBuff(attacker, Skill);
		end
	end
end

function EffectFunction:AddBuff2( attackerID, targetIDList, Skill )--给第二类目标加buff
	local attacker = FightManager:GetFighter(attackerID);
	local targetList = {};
	for _, v in pairs(targetIDList) do
		local fighter = FightManager:GetFighter(v);
		if fighter then
			fighter:AddBuff2(attacker, Skill);
		end
	end
end

function EffectFunction:AddFollow( attackerID, Skill )
	local attacker = FightManager:GetFighter(attackerID);
	attacker:CastFollowSkill(Skill);
end

--播放音效
function EffectFunction:PlaySound(soundIndex)
	local soundName = ResTable:getValue('skill_voice', soundIndex, 'name')
	if soundName then
		AudioManager:playEffect(soundName, 3)
	end
end

--加载纹理资源
function EffectFunction:PreLoadAvatar( avatarName )
	--asyncLoadManager:PreLoadArmatureTextureFile(avatarName);
end

--========================================================================
--特效

--挂点特效
function EffectFunction:AttachAvatarPosEffect( fighterID, avatarPos, pos, effectScale, layer, effectID, skillID, restraintType)
	local fighterList = {}
	if type(fighterID) ~= 'table' then
		table.insert(fighterList, fighterID);
	else
		fighterList = fighterID;
	end
	local first

	for k, v in pairs(fighterList) do
		local fighter = FightManager:GetFighter(v);
		if fighter and fighter:isAlive() then
			local effect = FightEffectManager:CreateAvatarPosEffect(v, avatarPos, pos, effectScale, layer, effectID, skillID, restraintType);
			if not first then
				first = effect
			end
		end
	end
	if first then
		return first
	end
end

--追踪特效
function EffectFunction:AttachTraceEffect( attackerID, startOffsetPos, flightPathType, traceTime, effectScale, targetID, effectType, effectID, skillID )
	local attacker = FightManager:GetFighter(attackerID);
	local target = FightManager:GetFighter(targetID);
	if type(targetID) == 'table' then
		for _, v in pairs(targetID) do
			target = v;
			break;
		end
	end
	if not attacker or not target then
		return;
	end

	FightEffectManager:CreateTraceEffect(attackerID, startOffsetPos, flightPathType, traceTime, effectScale, targetID, effectType, effectID, skillID);
end

--场景特效
function EffectFunction:AttachSceneEffect(targetID, posType, effectScale, effectName, skillID)
	local fighterList = {}
	if type(targetID) ~= 'table' then
		table.insert(fighterList, targetID);
	else
		fighterList = targetID
	end

	return FightEffectManager:CreateSceneEffect(fighterList, posType, effectScale, effectName, skillID);
end

--导弹特效
function EffectFunction:AttachMissileEffect( attackerID, skillID )
	FightEffectManager:CreateMissileEffect(attackerID, skillID);
end

function EffectFunction:AttachMissileHitEffect( attackerID, effectName, skillID )
	FightEffectManager:CreateMissileHitEffect(attackerID, effectName, skillID);
end


--判定本次技能产生的 衍生效果
function EffectFunction:MakeSkillSecEff( attackerID, targetIDList, Skill )

	local ret = false;
	local bAll = false;
	if not Skill.tableData['follow_condition'] or not Skill.tableData['follow_result'] then
		return;
	end
		-- 	job		= 1,--目标职业
		-- color	= 2,--目标颜色
		-- bigHp	= 3,--目标最大血量
		-- smallHp	= 4,--目标最小血量
		-- buff	= 5,--目标当前buff类型
		-- pos		= 6,--目标站位
		-- atkBigHp	= 7,--攻击者最大血量
		-- atkSmallHp	= 8,--攻击者最小血量
		-- atkBuff		= 9,--攻击者当前buff类型
		-- damage		= 10,--目标伤害占比
		-- kill		= 11,--击杀目标

	local attacker = FightManager:GetFighter(attackerID);
	local tmpTagList = {}

	for k,v in pairs(Skill.tableData['follow_condition']) do
		print(k,v)
		if #v == 2 then
			if v[1] == SkillCon.job then
				for _, fid in pairs(targetIDList) do
					local fighter = FightManager:GetFighter(fid);
					if fighter:GetJob() == v[2] then
						tmpTagList[fid] = 1;
						if ret == false then
							ret = true;
						end
						-- break;
					end
				end

			elseif v[1] == SkillCon.color then
				for _, fid in pairs(targetIDList) do
					local fighter = FightManager:GetFighter(fid);
					if fighter:GetColor() == v[2] then
						tmpTagList[fid] = 1;
						if ret == false then
							ret = true;
						end
						-- break;
					end
				end

			elseif v[1] == SkillCon.bigHp then
				for _, fid in pairs(targetIDList) do
					local fighter = FightManager:GetFighter(fid);
					if fighter:getHpPercent() >= v[2] then
						tmpTagList[fid] = 1;
						if ret == false then
							ret = true;
						end
						-- break;
					end
				end

			elseif v[1] == SkillCon.smallHp then
				for _, fid in pairs(targetIDList) do
					local fighter = FightManager:GetFighter(fid);
					if fighter:getHpPercent() <= v[2] then
						tmpTagList[fid] = 1;
						if ret == false then
							ret = true;
						end
						-- break;
					end
				end

			elseif v[1] == SkillCon.buff then
				for _, fid in pairs(targetIDList) do
					if BuffManager:isHaveBuff(fid, v[2]) then
						tmpTagList[fid] = 1;
						if ret == false then
							ret = true;
						end
						-- break;
					end
				end

			elseif v[1] == SkillCon.pos then
				for _, fid in pairs(targetIDList) do
					local fighter = FightManager:GetFighter(fid);
					if fighter:getMartixIdx() == v[2] then
						tmpTagList[fid] = 1;
						if ret == false then
							ret = true;
						end
						-- break;
					end
				end

			elseif v[1] == SkillCon.atkBigHp then
				if attacker:getHpPercent() >= v[2] then
					if ret == false then
						ret = true;
					end
					if bAll == false then
						bAll = true;
					end
				end

			elseif v[1] == SkillCon.atkSmallHp then
				if attacker:getHpPercent() <= v[2] then
					if ret == false then
						ret = true;
					end
					if bAll == false then
						bAll = true;
					end
				end

			elseif v[1] == SkillCon.atkBuff then
				if BuffManager:isHaveBuff(attackerID, v[2]) then
					if ret == false then
						ret = true;
					end
					if bAll == false then
						bAll = true;
					end
				end

			elseif v[1] == SkillCon.damage or v[1] == SkillCon.kill then
				local dieNum = 0;
				for _, fid in pairs(targetIDList) do
					local fighter = FightManager:GetFighter(fid);
					local isDie, damPer = fighter:WillSkillEffect(attacker, Skill);

					if v[1] == SkillCon.damage and damPer >= v[2] then
						tmpTagList[fid] = 1;
						if ret == false then
							ret = true;
						end
					end

					if isDie then
						dieNum = dieNum + 1;
					end
					if v[1] == SkillCon.kill and dieNum >= v[2] then
						if ret == false then
							ret = true;
						end
						if bAll == false then
							bAll = true;
						end
					end
				end
				
			end

			-- if ret == true then
			-- 	break;
			-- end

		end
	end

	local lastTagList = {}
	if ret then
		if bAll then
			lastTagList = targetIDList
		else
			for k,v in pairs(tmpTagList) do
				table.insert(lastTagList, k)
			end
		end
		for k,v in pairs(Skill.tableData['follow_result']) do
			if #v == 2 and v[1] == 2 then --加衍生伤害修正
				for _, fid in pairs(lastTagList) do
					local fighter = FightManager:GetFighter(fid);
					fighter:SetSecDamEff(v[2]);
				end
				break;
			end
		end
	end

	return ret, lastTagList;
end

function EffectFunction:SetSkillSecEff( attackerID, targetIDList, Skill )

	if not Skill.tableData['follow_result'] then
		return;
	end
	local attacker = FightManager:GetFighter(attackerID);
	for k,v in pairs(Skill.tableData['follow_result']) do
		if #v == 4 and v[1] == 1 then --加衍生buff
			if v[2] == 1 then --给attackerID加buff
				if math.random() <= v[3] then
					BuffManager:AddBuff(attacker, attacker, v[4], Skill);
				end
			elseif v[2] == 2 then --给目标加buff
				for _, fid in pairs(targetIDList) do
					local fighter = FightManager:GetFighter(fid);
					if math.random() <= v[3] then
						BuffManager:AddBuff(fighter, attacker, v[4], Skill);
					end
				end
			elseif v[2] == 3 then --给attacker方的全体加buff
				FightManager:AddBuffToALL(attacker, v[3], v[4], Skill);
			end
		elseif #v == 2 and v[1] == 2 then --加衍生伤害修正
		end
	end

end

cc.exports.EffectFunction = EffectFunction:create();
