local FrameEffectManager = class("FrameEffectManager")

function FrameEffectManager:ctor()
	self.effectPreLoadList = {};
	self.effectData =
	{
		['n_atk1_1'] = {name = 'n_atk1_1', num = 40, rate = 60},
		['n_atk1_2'] = {name = 'n_atk1_2', num = 40, rate = 60},
		['n_atk2_1'] = {name = 'n_atk2_1', num = 40, rate = 60},
		['n_atk2_2'] = {name = 'n_atk2_2', num = 40, rate = 60},
		['n_atk3_1'] = {name = 'n_atk3_1', num = 40, rate = 60},
		['n_atk3_2'] = {name = 'n_atk3_2', num = 40, rate = 60},
		['s_atk1_1'] = {name = 's_atk1_1', num = 90, rate = 60},
		['s_atk1_2'] = {name = 's_atk1_2', num = 53, rate = 60},
		['s_atk2_1'] = {name = 's_atk2_1', num = 105, rate = 60},
		['s_atk2_2'] = {name = 's_atk2_2', num = 120, rate = 60},
		['s_atk3_1'] = {name = 's_atk3_1', num = 105, rate = 60},
		['s_atk3_2'] = {name = 's_atk3_2', num = 100, rate = 60},
		['s_atk4_1'] = {name = 's_atk4_1', num = 60, rate = 60},
		['s_atk4_2'] = {name = 's_atk4_2', num = 60, rate = 60},
		['s_atk4_3'] = {name = 's_atk4_3', num = 120, rate = 60},
		['s_atk4_B'] = {name = 's_atk4_B', num = 70, rate = 60},
		['s_atk5_1'] = {name = 's_atk5_1', num = 60, rate = 60},
		['s_atk5_2'] = {name = 's_atk5_2', num = 120, rate = 60},
		['s_atk6_1'] = {name = 's_atk6_1', num = 100, rate = 60},
		['s_atk6_2'] = {name = 's_atk6_2', num = 100, rate = 60},
		['e_atk1_1'] = {name = 'e_atk1_1', num = 100, rate = 60},
		['e_atk2_1'] = {name = 'e_atk2_1', num = 100, rate = 60},
		['t_atk1_1'] = {name = 't_atk1_1', num = 49, rate = 60},
		['t_atk1_2'] = {name = 't_atk1_2', num = 49, rate = 60},
		['t_atk1_3'] = {name = 't_atk1_3', num = 49, rate = 60},
		['Harvest_1'] = {name = 'Harvest_1', num = 25, rate = 15},
		['Harvest_2'] = {name = 'Harvest_2', num = 25, rate = 15},
		['Harvest_3'] = {name = 'Harvest_3', num = 18, rate = 15},
		['Harvest_5'] = {name = 'Harvest_5', num = 10, rate = 15},
		['Harvest_6'] = {name = 'Harvest_6', num = 13, rate = 15},
		['Harvest_7'] = {name = 'Harvest_7', num = 14, rate = 15},
		['Skills_UI']	= {name = 'Skills_UI', num = 21, rate = 15},
		['buff_1']		= {name = 'buff_1',		num = 25,	rate = 15},
		['buff_2_1']	= {name = 'buff_2_1',	num = 8,	rate = 15},
		['buff_2_2']	= {name = 'buff_2_2',	num = 8,	rate = 15},
		['buff_3']		= {name = 'buff_3',		num = 18,	rate = 15},
		['buff_4']		= {name = 'buff_4',		num = 20,	rate = 15},
		['buff_5']		= {name = 'buff_5',		num = 30,	rate = 15},
		['buff_6']		= {name = 'buff_6',		num = 20,	rate = 15},
		['buff_7']		= {name = 'buff_7',		num = 24,	rate = 15},
		['buff_8']		= {name = 'buff_8',		num = 25,	rate = 15},
		['buff_9']		= {name = 'buff_9',		num = 10,	rate = 15},
		['buff_10_1']	= {name = 'buff_10_1',	num = 25,	rate = 15},
		['buff_10_2']	= {name = 'buff_10_2',	num = 7,	rate = 15},
		['buff_11']		= {name = 'buff_11',	num = 8,	rate = 15},
		['buff_12']		= {name = 'buff_12',	num = 10,	rate = 15},
		['buff_13']		= {name = 'buff_13',	num = 6,	rate = 15},
		['buff_14']		= {name = 'buff_14',	num = 9,	rate = 15},
		['buff_15']		= {name = 'buff_15',	num = 9,	rate = 15},
		['buff_16']		= {name = 'buff_16',	num = 9,	rate = 15},
		['buff_17']		= {name = 'buff_17',	num = 11,	rate = 15},
		['buff_18']		= {name = 'buff_18',	num = 15,	rate = 15},
		['buff_19']		= {name = 'buff_19',	num = 15,	rate = 15},
		['buff_20']		= {name = 'buff_20',	num = 5,	rate = 15},
		['buff_21']		= {name = 'buff_21',	num = 13,	rate = 15},
		['buff_22']		= {name = 'buff_22',	num = 15,	rate = 15},
		['combo_1_2']	= {name = 'combo_1_2',	num = 20,	rate = 15},
		['combo_2_1']	= {name = 'combo_2_1',	num = 13,	rate = 15},
		['combo_2_3']	= {name = 'combo_2_3',	num = 20,	rate = 15},
		['combo_3_1']	= {name = 'combo_3_1',	num = 10,	rate = 15},
		['combo_3_2']	= {name = 'combo_3_2',	num = 16,	rate = 15},
		['combo_3_3']	= {name = 'combo_3_3',	num = 20,	rate = 15},
		['skill_name_effect']	= {name = 'skill_name_effect',	num = 7,	rate = 15},
		['income_box_2']	= {name = 'income_box_2',	num = 15,	rate = 15},
		['ui_fight_challenge']	= {name = 'ui_fight_challenge',	num = 12,	rate = 15},
	};
end

function FrameEffectManager:preLoadEffect( effect )
	if self.effectPreLoadList[effect] then
		return true;
	end
	local frameEffectPath = 'Effect/frame/';
	local plistName = frameEffectPath..effect..'/'..effect..'.plist';
	local textureName = frameEffectPath..effect..'/'..effect..'.png';
	if cc.FileUtils:getInstance():isFileExist(plistName) then
		cc.SpriteFrameCache:getInstance():addSpriteFrames(plistName, textureName)
	else
		plistName = frameEffectPath..effect..'/'..effect..'-0.plist';
		if cc.FileUtils:getInstance():isFileExist(plistName) then
			local aimIndex = 0;
			for i=0, 99 do
				plistName = frameEffectPath..effect..'/'..effect..'-'..i..'.plist';
				if not cc.FileUtils:getInstance():isFileExist(plistName) then
					aimIndex = i - 1;
					break;
				end
			end

			for i=0, aimIndex do
				plistName = frameEffectPath..effect..'/'..effect..'-'..i..'.plist';
				textureName = frameEffectPath..effect..'/'..effect..'-'..i..'.png';
				cc.SpriteFrameCache:getInstance():addSpriteFrames(plistName, textureName);
			end
		else
			return false;
		end
	end
	self.effectPreLoadList[effect] = true;
	return true;
end

function FrameEffectManager:preLoadPngs(loadedHandler)

	local frameEffectPath = 'Effect/frame/';
	local list = {};
	for k, _ in pairs(self.effectData) do
		local textureName = frameEffectPath..k..'/'..k..'.png';
		if cc.FileUtils:getInstance():isFileExist(textureName) then
			list[textureName] = 0;
		else
			local plistName = frameEffectPath..k..'/'..k..'-0.plist';
			if cc.FileUtils:getInstance():isFileExist(plistName) then
				local aimIndex = 0;
				for i=0, 99 do
					plistName = frameEffectPath..k..'/'..k..'-'..i..'.plist';
					if not cc.FileUtils:getInstance():isFileExist(plistName) then
						aimIndex = i - 1;
						break;
					end
				end

				for i=0, aimIndex do
					local textureName = frameEffectPath..k..'/'..k..'-'..i..'.png';
					if cc.FileUtils:getInstance():isFileExist(textureName) then
						list[textureName] = 0;
					end
				end
			end
		end
	end

	local checkFun = function()
		local loaded = true;
		for k, v in pairs(list) do
			loaded = false;
			break;
		end
		if loaded then
			loadedHandler();
		end
	end


	for k, _ in pairs(self.effectData) do
		local textureName = frameEffectPath..k..'/'..k..'.png';
		if cc.FileUtils:getInstance():isFileExist(textureName) then
			cc.Director:getInstance():getTextureCache():addImageAsync(textureName, function()
				list[textureName] = nil;
				checkFun();
			end);
		else
			local plistName = frameEffectPath..k..'/'..k..'-0.plist';
			if cc.FileUtils:getInstance():isFileExist(plistName) then
				local aimIndex = 0;
				for i=0, 99 do
					plistName = frameEffectPath..k..'/'..k..'-'..i..'.plist';
					if not cc.FileUtils:getInstance():isFileExist(plistName) then
						aimIndex = i - 1;
						break;
					end
				end

				for i=0, aimIndex do
					local textureName = frameEffectPath..k..'/'..k..'-'..i..'.png';
					if cc.FileUtils:getInstance():isFileExist(textureName) then
					cc.Director:getInstance():getTextureCache():addImageAsync(textureName, function()
						list[textureName] = nil;
						checkFun();
					end);
					else
						print(textureName .. ' not exist')
					end
				end
			end
		end
	end
end

function FrameEffectManager:createFrameAnimation(effect, frameNum, frameRate)
	if not self:preLoadEffect(effect) then
		print('create frame animation error!, effect Name', tostring(effect));
		return nil;
	end
	if not frameNum then
		print('create frame animation error!, lack of frame Num, effect Name', tostring(effect));
		return nil;
	end
	frameRate = frameRate or 60;
	local animation = cc.Animation:create();
	for i=0, frameNum-1 do
		local frameName = effect..string.format('_%d.png', i);
		local frame = cc.SpriteFrameCache:getInstance():getSpriteFrame(frameName);
		animation:addSpriteFrame(frame);
	end
	if frameRate == 0 then
		frameRate = 60;
	end
	local sec = math.floor((1 / frameRate) * 1000 + 0.5) / 1000;
	animation:setDelayPerUnit(sec);
    --animation:setRestoreOriginalFrame(true);
	return animation;
end

function FrameEffectManager:createFrameAnimationOnePng(imgPath, frameNum, frameRate)

	local sp = cc.Sprite:create(imgPath);
	local texture = sp:getTexture();

	if not frameNum then
		print('create frame animation error!, lack of frame Num, effect Name', tostring(effect));
		return nil;
	end
	frameRate = frameRate or 60;
	local animation = cc.Animation:create();

	for i=0, frameNum-1 do
		local frame = cc.SpriteFrame:createWithTexture(texture, CCRectMake(45*i, 0, 45,44) )
		-- CCSpriteFrame::frameWithTexture(playerRunTexture, cocos2d::CCRectMake(72*i, 0, 72, 72))
		animation:addSpriteFrame(frame);
	end
	if frameRate == 0 then
		frameRate = 60;
	end
	local sec = math.floor((1 / frameRate) * 1000 + 0.5) / 1000;
	animation:setDelayPerUnit(sec);
    --animation:setRestoreOriginalFrame(true);
	return animation;
end

function FrameEffectManager:createAction(effectName)
	if self.effectData[effectName] then
		local data = self.effectData[effectName];
		local animation = self:createFrameAnimation(data.name, data.num, data.rate);
		return cc.Animate:create(animation);
	else
		print('error! no such frame effect')
		print(debug.traceback())
	end
end

function FrameEffectManager:getFrameAnimationData(effectName)
	return self.effectData[effectName];
end

function FrameEffectManager:preloadAllEffect()
	for k, _ in pairs(self.effectData) do
		self:preLoadEffect(k);
	end
end

cc.exports.FrameEffectManager = FrameEffectManager:create();

