local MissileEffect = class("MissileEffect", require("app.effect.Effect"))
local posList = 
{
	left = {
		[1] = {x = -118,		y = 1097,	r = -6.1},
		[2] = {x = -174,		y = 1110,	r = -8.9},
		[3] = {x = -183,		y = 1125,	r = -9.2},
		[4] = {x = -233,		y = 1147,	r = -11.5},
		[5] = {x = -284,		y = 1152,	r = -13.8},
	},
	right = {
		[1] = {x = 118,		y = 1097,	r = 6.1},
		[2] = {x = 174,		y = 1110,	r = 8.9},
		[3] = {x = 183,		y = 1125,	r = 9.2},
		[4] = {x = 233,		y = 1147,	r = 11.5},
		[5] = {x = 284,		y = 1152,	r = 13.8},
	},
}

function MissileEffect:ctor(id, skillResid)
	MissileEffect.super.ctor(self, id, skillResid)
end

function MissileEffect:Initialize( attackerID, action )
	self.attacker = FightManager:GetFighter(attackerID);

	if not self.attacker then
		return;
	end

	self.effectSprite = cc.Sprite:create();

	local pos = nil;
	if self.attacker:IsEnemy() then
		pos = posList.left;
		self.effectSprite:setFlipX(true);
	else
		pos = posList.right;
	end

	local aimPos = pos[math.random(1, #pos)];

	self.effectSprite:setPosition(aimPos.x, aimPos.y);
	self.effectSprite:setRotation(aimPos.r);
	self.effectSprite:setScale(1);

	EventManager:FireEvent(EventType.FightAddEffect, self.effectSprite, self);

	--播放特效
	self.effectSprite:runAction(cc.Sequence:create(action, cc.CallFunc:create(handler(self, self.setDestroy))));
end

--更新
function MissileEffect:Update( dt )
	if not self.runningState then
		return true;
	end
	local running = true;
	if self.destroyFlag then
		self:Destroy();
		running = false;
	end
	return running;
end

--销毁
function MissileEffect:Destroy()
	EventManager:FireEvent(EventType.FightDelEffect, self);
	MissileEffect.super.Destroy(self);
end

function MissileEffect:setDestroy()
	self.destroyFlag = true;
end

return MissileEffect;
