local MissileHitEffect = class("MissileHitEffect", require("app.effect.Effect"))

local rocketPos =
{
	[1] = {x = 197,  y = 915 ,r = 6.1},
	[2] = {x = 70, y = 886 ,r = 8.9},
	[3] = {x = 295, y = 842,r = 9.2},
	[5] = {x = 641, y = 705,r = 13.8},
}

function MissileHitEffect:ctor(id, skillResid)
	MissileHitEffect.super.ctor(self, id, skillResid)
end

function MissileHitEffect:Initialize( attackerID, action )
	self.attacker = FightManager:GetFighter(attackerID);

	if not self.attacker then
		return;
	end

	self.effectSprite = cc.Sprite:create();

	local aimPos;
	if self.attacker:IsEnemy() then
		print('ERROR, MissileHitEffect');
		return false;
	else
		aimPos = rocketPos[math.random(1, #rocketPos)];
	end

	self.effectSprite:setPosition(aimPos.x, aimPos.y);
	self.effectSprite:setRotation(aimPos.r);
	self.effectSprite:setScale(1);

	EventManager:FireEvent(EventType.FightAddEffect, self.effectSprite, self);

	--播放特效
	self.effectSprite:runAction(cc.Sequence:create(action, cc.CallFunc:create(handler(self, self.setDestroy))));
	return true;
end

--更新
function MissileHitEffect:Update( dt )
	if not self.runningState then
		return true;
	end
	local running = true;
	if self.destroyFlag then
		self:Destroy();
		running = false;
	end
	return running;
end

--销毁
function MissileHitEffect:Destroy()
	EventManager:FireEvent(EventType.FightDelEffect, self);
	MissileHitEffect.super.Destroy(self);
end

function MissileHitEffect:setDestroy()
	self.destroyFlag = true;
end

return MissileHitEffect;
