--挂点特效类
local SceneEffect = class("SceneEffect", require("app.effect.Effect"))
local rowList = 
{
	[1] = 1,	[2] = 1,	[3] = 1,
	[4] = 2,	[5] = 2,	[6] = 2,
	[7] = 3,	[8] = 3,	[9] = 3,
}
local colList = 
{
	[1] = 1,	[2] = 2,	[3] = 3,
	[4] = 1,	[5] = 2,	[6] = 3,
	[7] = 1,	[8] = 2,	[9] = 3,
}
local frontRowList = 
{
	[1] = 1,	[2] = 1,	[3] = 1,
	[4] = 1,	[5] = 1,	[6] = 1,
	[7] = 2,	[8] = 2,	[9] = 2,
}

function SceneEffect:ctor(id, skillResid)
	SceneEffect.super.ctor(self, id, skillResid);
end

function SceneEffect:Initialize( targetID, posType, effectScale, effectID )
	local firstTarget
	for k, v in pairs(targetID) do
		firstTarget = FightManager:GetFighter(v);
		break
	end
	if not firstTarget then
		return
	end
	local targetPos = firstTarget:getFormationIndex()
	local pos_index = FIGHT_SCENE_EFFECT_POS[posType]
	if not pos_index then
		return
	end
	local isFlipX = false
	if firstTarget:IsEnemy() then
		pos_index = pos_index[2]
	else
		pos_index = pos_index[1]
		isFlipX = true
	end

	local aimPos
	if posType == 1 then
		aimPos = pos_index

	elseif posType == 2 then
		aimPos = pos_index[rowList[targetPos]]

	elseif posType == 3 then
		aimPos = pos_index[colList[targetPos]]

	elseif posType == 4 then
		aimPos = pos_index[frontRowList[targetPos]]

	else
		return
	end

	local effectName = ResTable:getValue(TableName.SkillEffect, effectID, 'name')
	print('a scene effect init:', self.id, effectID, effectName)

	DragonBonesManager:loadDragonBonesResources(effectName, 'Effect/db/')
	local effect = DragonBonesManager:getFactory():buildArmatureDisplay(effectName)
	local db_id = DragonBonesManager:AddDisplay(effect, effectName)

	self.destroyCallback = function()
		effect:removeFromParent()
		DragonBonesManager:RemoveDisplay(db_id)
	end

	local timeScale = 1/FightManager:SpeedUp()
	print(aimPos.x, aimPos.y)
	effect:setPosition(aimPos.x, aimPos.y + DesignSize.height/2)
	effect:getArmature():setFlipX(isFlipX)
	effect:setScale(effectScale)
	effect:setLocalZOrder(200)
	effect:getAnimation():play(effectName, 1, timeScale)

	EventManager:FireEvent(EventType.FightAddEffect, effect, self);

	local listener = cc.EventListenerCustom:create("complete", function(event)
		self:setDestroy()
	end)
	effect:getEventDispatcher():setEnabled(true)
	effect:getEventDispatcher():addEventListenerWithFixedPriority(listener, 1);
end

--更新
function SceneEffect:Update( dt )
	if not self.runningState then
		return true;
	end
	local running = true;
	if self.destroyFlag then
		self:Destroy();
		running = false;
	end
	return running;
end

--销毁
function SceneEffect:Destroy()
	if self.destroyCallback then
		self.destroyCallback()
	end
	--self.actor:DetachEffect(self);
	SceneEffect.super.Destroy(self);
end

function SceneEffect:setDestroy()
	self.destroyFlag = true;
end

return SceneEffect;
