--eventManager.lua

--========================================================================
--事件管理类

--事件类型
local EventType = {};
EventType['UIEntrustTaskDetail'] = 1;			-- 委托 进行委托
EventType['UIEntrustInterTask'] = 2;			-- 委托 中断委托
EventType['UIEntrustGetReward'] = 3;			-- 委托 获取奖励
EventType['UIEntrustReqNewTask'] = 4;			-- 委托 请求新委托
EventType['NetworkEntrustRevMsg'] = 5;			-- 委托 接收消息
EventType['NetworkEntrustDetail'] = 6;			-- 委托 编队信息
EventType['NetworkEntrustBegin'] = 7;			-- 委托 开始任务
EventType['NetworkEntrustGetReward'] = 8;		-- 委托 获取奖励
EventType['NetworkEntrustInter'] = 9;			-- 委托 中断任务
EventType['NetworkNewEntrust'] = 10;			-- 委托 刷新任务

--卡牌
EventType['UICardUpdateAll'] 						=	100		-- 卡牌ui更新
EventType['UICardCheckBigTemplate']					=	101 	--点击BigTemplate事件
EventType['UICardCheckMidTemplate']					=	102		--点击MidTemplate事件
EventType['UICardEvolveStrCheckMidTemplate']		=	103 	--点击卡牌强化中选择面板
EventType['UICardEvolveBreakCheckMidTemplate']		=	104 	--点击卡牌突破中选择面板
EventType['UICardEquipSelectCheckTemplate']			=	105		--CardEquipSelect面板点击装备
EventType['UICardEquipUpPopupPanelCheckTemplate']	=	106 	--CardEquipUpPopupPanel装备选择的点击
EventType['UICardEquipUpTopCheckTemplate']			=	107		--CardEquipUpPopupPanel上排的点击事件
EventType['UICardEquipStrNeedCheckTemplate']		=	108		--CardEquipUpPopupPanel所需材料的点击事件
EventType['CardSkillTemplate']						=	109		--技能点击
EventType["CardEvolvePanelTips"]					=	111 	--CardEvolvePanel Tips
EventType["CardInfoPanelTips"]						=	112 	--CardInfoPanel Tips
EventType['UICardListNeedUpdate']					=	113;
EventType['UICardListCardNeedUpdate']				=	114;
EventType['UICardEquipIcon']						=	115;
EventType['UICardEvolveOnBreak']					=	116;
EventType['UICardEvolveResultUpdate']				=	117;
EventType['UICardEvolveResultClose']				=	118;
EventType['UICardChangeIcon']						=	119;
EventType['UICardListEquipSkin']					=	120;
EventType['UICardEvolveBreakCallBack']				=	121;
EventType['NetworkCardBreakRevMsg']					=	122;
EventType['NetworkCardRemodeling']					=	123;
EventType['NetworkCardAwaken']						=	124;
EventType['UICardEquipOnkey']						=	125;
EventType['UICardEquipOnkeyMix']					=	126;
EventType['NetworkCardBreakOneKey']					=	127;
EventType['UICardEquipUpdateStr']					=	128;
EventType['UICardEvolveTipUpdateCost']				=	129;
EventType['UICardEvolveUpdateAwakenCost']			=	130;
EventType['NetworkRetLevelUp']						=	131;
EventType['NetworkRetStarLevelUp']					=	132;
EventType['NetworkRetCardBreak']					=	133;
EventType['UIUpdateCardLevelUpList']				=	134;
EventType['UIUpdateCardLevelUpData']				=	135;
EventType['NetworkCardListRetLevelUp']				=	136;
EventType['NetworkCardListRetLevelBreak']			=	137;
EventType['UIStarLevelUpSelectPid']					=	138;
EventType['NetworkCardBookGetReward']				=	139;
EventType['UIUpdateCardBookData']				    =	140;
EventType['NetworkCardAvatarRetUse']				=	141;
EventType['NetworkRetCardResolve']					=	142;
EventType['NetworkRetCardReset']					=	143;
EventType['NetworkRetCardAvatarChange']				=	144;
EventType['UICardLiveUpdate']						=	145;
EventType['NetworkLoveLevelUp']						=	146;
EventType['NetworkRetCardAvatarGet']				=	147;
EventType['NetworkRetCardAvatarCheck']				=	148;


-- 背包
EventType["UIBagPanelUpdate"] = 200 -- 背包内容更新
EventType["NetWorkBagOpenGift"] = 201 -- 开箱子
EventType["UIEquipResolve"] = 202 -- 不知道干什么用的
EventType["NetworkRetEquipCompose"] = 203 -- 物品合成
EventType["UIShowBagOperationMessage"] = 204 -- 显示出售/合成成功信息
EventType["UIEquipResolved"] = 205 -- 拆解装备
EventType["UIRefreshShop"] = 206 -- 刷新背包界面
EventType["UITipsItemNum"] = 207 -- 背包tips
--EventType["NetworkRetEquipStrengthen"] = 208 --装备强化
EventType["NetworkRetEquipWear"] = 209 --装备强化
EventType["NetworkRetEquipOneKey"] = 210 --一键装备
EventType["NetworkRetEquipTakeOff"] = 211 --卸下
EventType["NetworkRetEquipTakeOffAll"] = 212 --卸下全部
EventType["NetworkRetUpdateTeamSlot"] = 213 -- 强化
EventType["UIEquipStrengthen"] = 214 -- 强化
EventType["UIEquipComposeUpdateList"] = 215 -- 合成
EventType["NetworkRetEquipOneKeyCompose"] = 217 -- 一键合成



-- 战斗
EventType['FightRoleEnter'] = 500;
EventType['FightAddEffect'] = 501;
EventType['FightDelEffect'] = 502;
EventType['Die']			= 503;
EventType['FightChangeCameraCaster'] = 504;
EventType['Revive']			= 505;
EventType['FightBackCamera'] = 506;
EventType['FightOver']		= 507;
EventType['FightAddLabel']	= 508;
EventType['FightChangeTotalHp'] = 509;
EventType['FightChangeShow'] = 510;
EventType['FightHpChange']	= 511;
EventType['FightChangeCameraTarget'] = 512;
EventType['FightPauseSkillScript'] = 513;
EventType['FightContinueSkillScript'] = 514;
EventType['FightNext'] = 515;
EventType['FightPanelClearDamage'] = 516;
EventType['FightPanelInitRoundInfo'] = 517;
EventType['FightPanelShake'] = 518;
EventType['FightPanelScale'] = 519;
EventType['FightPanelStart'] = 520;
EventType['FightPanelInterrupt'] = 521;
EventType['FightPanelGetChapterReward'] = 523;
EventType['FightCastActiveSkill'] = 525;
EventType['FightStopActiveSkill'] = 526;
EventType['FightPanelPause'] = 527;
EventType['FightCheckMusic'] = 528;
EventType['FightBuffLabelAdd'] = 529;
EventType['RecountInit'] = 530;
EventType['RecountAdd'] = 531;
EventType['RecountUpdate'] = 532;
EventType['FightBossWarning'] = 533;
EventType['FightBuffIconUpdate'] = 534;
EventType['FightPalyMusic'] = 535;
EventType['FightBegin'] = 536;
EventType['FightPauseSkill'] = 537;
EventType['SceneNext'] = 538;
EventType['SceneRollCenter'] = 539;
EventType['SceneRollBack'] = 540;
EventType['SceneEndRollCenter'] = 541;
EventType['FightPanelDestroyArmature'] = 542;
EventType['FightPanelStopRun'] = 543;
EventType['FightStartSkill'] = 544;
EventType['FightOverSkill'] = 545;
EventType['FightFastInfo'] = 546;
EventType['AutoFightAllyEnter'] = 547;
EventType['AutoFightAllyLeave'] = 548;
EventType['AutoFightEnemyEnter'] = 549;
EventType['AutoFightEnemyLeave'] = 550;
EventType['FightSceneBgMove'] = 551;
EventType['FightSceneBgStop'] = 552;
EventType['AutoFightEnemyMoveIn'] = 553;
EventType['AutoFightEnemyReset'] = 554;
EventType['UIFightScenePanelUpdateBg'] = 555;
EventType['AutoFightAddBullet'] = 556;
EventType['FightIncomeChange'] = 557;
EventType['AutoFightTimeScale'] = 558;
EventType['AutoFightTeamChange'] = 559;
EventType['AutoFightCoinScatter'] = 560;
EventType['FightMapSetNewRound'] = 563;
EventType['AutoFightItemUse'] = 564;
EventType['RoundBossUpdate'] = 565; --关卡挑战胜利 获得随机boss
EventType['FightDoorOpen'] = 566;
EventType['FightEnableChallenge'] = 569;
-- EventType['FightUpdateBuffNode'] = 570;
EventType['FightPanelBtnRedDot'] = 572;
EventType['FightInitSkillIcon'] = 573;
EventType['FightUpdateSkillIcon'] = 574;
EventType['FightUpdateTime'] = 575;
EventType['FightIncomeGetReward'] = 576;
EventType['BossDamageDown'] = 577;
EventType['FightPanelRandomBossPoint'] = 578; -- 随机BOSS 感知点
EventType['FightUpdateFooterRedDot'] = 580;
EventType["FightPanelTeamRestraintChange"]		=581	--队伍克制变动
EventType['DailyRoundInfo']	= 582
EventType["FightPanelUpdateScene"] = 585	--更新场景
EventType["FightRoundBreakGetReward"] = 586	--每五关 关卡突破 奖励
EventType['FightShowSkill'] = 587
EventType['FightPanelBtnVisible'] = 588
EventType['FightPreloadSkillEffect'] = 589
EventType['FightShowSkillOver'] = 590

EventType['FightFooterBuff'] = 591
EventType['FightShowSkillExt'] = 592
EventType['FightShowSkillAuto'] = 593

--
EventType['UILoginAnnouncement'] = 600     -- 公告ui更新
-- EventType['UINoticeCheckOpenPanelTemplate'] = 601  -- 公告面板点击子面板
EventType['UILoginShowServerInfo'] 	= 602  -- 显示服务器信息
EventType['UILoginWithUID'] 		= 603  -- 正式登陆游戏
-- EventType['UILoginCreateAccount'] 		= 604  -- 创建账号

EventType['UILoginCreateNewUser'] 	= 605	-- 创建账号
EventType['LoginUnregister']		= 606	-- 注销账号
EventType['LoginRevertUnreg']		= 607	-- 取消注销账号
EventType['UILoginShowUnregInfo']	= 608	-- 显示注销账号信息
EventType['UIRetGuestBind']			= 609	-- 返回游客绑定
EventType['UILoginChangeName'] 		= 612	-- 创建账号
EventType['UIRetEnterGame'] 		= 613	-- 进游游戏
EventType['UILoginRecoverAccount']	= 614	-- 恢复账号返回


-- roundBoss 610 620
EventType['RoundBossBuy'] = 610; -- 随机boss购买	
EventType['RoundBossRefreshAll'] = 611; -- 随机boss更新	


-- 欢乐时光
EventType['HarvestPowerGen']	= 650

-- 家园
EventType["UIRepOilWellResource"] = 700 -- 领取油井奖励
EventType["UIRepGoldMineResource"] = 701 -- 领取金矿奖励
EventType["UIStartOilWellLevelUpgrade"] = 702 -- 油井开始升级
EventType["UIStartGoldMineLevelUpgrade"] = 703 -- 金矿开始升级
EventType["UIFinishOilWellLevelUpgrade"] = 704 -- 油井升级完毕
EventType["UIFinishGoldMineLevelUpgrade"] = 705 -- 金矿升级完毕
EventType["UIUpdateCollegeIndicator"] = 706 -- 更新科研所图标状态
EventType["UIRepResourceUpdate"] = 707
EventType["UIStartTime"] = 708
EventType["UIRetEndUpgrade"] = 709
EventType["UIRetStartUpgrade"] = 710
EventType["UIRetSkillLevelUpPanelShow"] = 711
EventType["UIHomeUpdateTime"] = 712
EventType["NetworkRetBaseSkillInfo"] = 713
EventType["NetworkRetBaseSkillLevelUp"] = 714
EventType["NetworkRetBaseSkillClearCd"] = 715
EventType["NetworkRetBaseCardComposePromotion"] = 716
EventType["NetworkRetBaseCardCompose"] = 717



-- 研究所
EventType["UISkillLevelUpInfoRequesting"] = 750
EventType["UISkillLevelUpInfoUpdate"] = 751
EventType["UISkillUpgradablePartnerRequesting"] = 752
EventType["UISkillUpgradablePartnerUpdate"] = 753
EventType["UISkillStartUpgrade"] = 754

EventType["UIHomeCardCheckBigTemplate"] = 721  --Home/CardSelectPanel点击

-- 商城
EventType["UIFreshYbShop"] = 801 -- 礼盒、蓝钻刷新
EventType["UIFreshRefreshShop"] = 802 -- 商城、军火库刷新
EventType["UIFreshShop"] = 803 -- 刷新商店刷新
EventType["UIBuyYbSuccess"] = 804 -- 购买蓝钻成功
EventType["UIBuyYbFail"] = 805 -- 购买蓝钻失败
EventType["UIBuyGiftSuccess"] = 806 -- 购买礼盒成功
EventType["UIBuyGiftFail"] = 807 -- 购买礼盒失败
EventType["UIBuyShopItemSuccess"] = 808 -- 购买商店物品成功
EventType["UIBuyShopItemFail"] = 809 -- 购买商店物品失败
EventType["UIBuyRefreshShopItemSuccess"] = 810 -- 购买军火库物品成功
EventType["UIBuyRefreshShopItemFail"] = 811 -- 购买军火库物品失败
EventType["UIRefreshShopSuccess"] = 812 -- 刷新军火库成功
EventType["UIRefreshShopFail"] = 813 -- 刷新军火库失败
EventType["UIShopPanelUpdate"] = 814 -- 商店界面更新
EventType["UIRefreshItem"]= 815 --刷新刷新令的数量
EventType["UIRefreshShopRefreshTime"]= 816 --刷新商店刷新时间
EventType["UIRefreshRandomShopInfo"]= 817 --刷新随机商店
EventType["UIRetShopInfo"]= 818 --商店数据
EventType["UIRetEventShopInfo"]= 819 --event商店数据
EventType["UIBuyEventShop"]= 820 --购买event商店
EventType["UIBuyStoreItemSuccess"]= 821 --购买store
EventType["UIRetStoreInfo"]= 822 --store数据
EventType["UIRetBattlepassInfo"]= 823 --battlepass商店数据
EventType["UIRetBattlepassShopBuy"]= 824 --battlepass商店购买


--任务
EventType["UITaskUpdateAll"]				= 	900 --任务ui刷新
EventType["UITaskDayPanelCheckTemplate"]	=	901 --每日任务点击
EventType["UITaskSelectPanelCheckTemplate"]	=	902 --任务选择点击
EventType["NetWorkDailyOnShow"]				=   903

-- 剧情
EventType["PlotFinish"]			= 1000

-- 技能
EventType["UIRetSkillLevelUpInfo"] = 1100	-- 刷新技能升级数据
EventType["UIRetUpgradableCardInfo"] = 1101 -- 获取可升级角色列表
EventType["UIRetSkillListInfo"] = 1103		-- 获取角色的可升级技能列表
EventType["UIRetStartSkillLevelUp"] = 1104	-- 请求开始升级
EventType["UIRetCancelSkillLevelUp"] = 1105	-- 请求取消升级
EventType["UIRetFinishSkillLevelUp"] = 1106 -- 请求升级完成
EventType["UIRetUpdateSkillLevelUp"] = 1107 
EventType["UIRetSpeedSkillLevelUp"] = 1108 --加速训练


--编队
EventType["UITeamUpdateAll"]	=1200		--编队UI刷新
EventType["UITeamRoleCheck"]	=1202		--点击角色
EventType["UITeamCardCheck"]	=1203		--点击卡牌列表
EventType["UITeamCardCheck2"]	=1204		--点击卡牌列表2
EventType["UITeamCardTips"]		=1205		--编队tips消息
EventType["UITeamCardChangeOil"]		=1206		--编队油耗变动
EventType["UITeamCardChangePower"]		=1207		--编队战斗力变动
EventType["UITeamFormationChange"]		=1208		--编队阵型变动
EventType["UITeamUpdateRoundInfoOption"]=1209		--roundInfo界面跳转编队界面保存option
EventType["UITeamOnShow"]=1210		--

--Header,Footer
EventType["UIHeaderUpdateAll"]		=	1300		--Header刷新
EventType["UIHeaderPanelBackEvent"]	=	1301		--Header设置回调
EventType["UIHeaderPanelShowHead"]	=	1302		--Header设置头像
EventType["UIFooterChoose"]			=	1303		--Footer设置选择
EventType["UIHeaderPanelUpdateFP"]	=	1304		--HeaderFp更新
EventType["UIHeaderPanelSetTitle"]	=	1305		
EventType["UIMainTipsShow"]			=	1306		--Footer设置选择
EventType["UIHeaderPanelUpdateIcon"]=	1307		
EventType["UIHeaderPanelShowAction"]=	1308	
EventType["UIShowFooterAction"]		=	1309		
EventType["UIHeaderPanelUpdate"]	=	1310
EventType["UIHeaderPanelUpdateLevel"]=	1311
EventType["UIHeadeMoneyUpdate"]		= 	1312 	--顶部货币条刷新
EventType["UIFooterRedDotShow"]		= 	1313 	-- Footer刷新红点
EventType["UIHeadeUpdateHeadType"]	= 	1315 	-- Footer刷新红点
EventType["UIEventUnlockChange"]	= 	1314 	-- 开启等级解锁
EventType["UIFooterChooseFooter"]	= 	1316 	-- 选择footer
EventType["UIFooterUpdateZOrder"]	= 	1317 	-- 更新footer ZOrder
-- EventType["UIHeadeUpdateMoneyNodeVisible"]	= 	1318 	-- 更新Header money显示
EventType["UIHeaderPanelVisible"]	= 	1319
EventType["UIFightFooterPanelVisible"]	= 	1320
EventType["UIHeadeUpdateCardBookRedDot"]	= 	1321
EventType["UIFooterUpdateSelect"]	= 	1322
EventType["UIHeadeRunAction"]	= 	1323
EventType["UIFooterRunAction"]	= 	1324
EventType["HeaderUpdateTitle"]	=  1325


--排行榜
EventType["UIRankListView"]	=1399		--排行榜更新

--公会
EventType["UIGuildUpdateAll"]	=1400		--公会更新

--指挥中心
EventType["UICommanderUpdateAll"]	=1500	--指挥中心更新

-- 抽卡
EventType["NetworkGachaInfo"]	= 1600	--抽卡信息
EventType["NetworkGachaResult"]	= 1601	--抽卡结果
EventType["NetworkGachaGetReward"]	= 1602	--抽卡奖励
EventType["UIGachaOpen"]	= 1603	--翻开卡牌

--抽卡界面与商店
EventType["UIRetireUpdateAll"]	= 1702
EventType["UIRetirePaperCheck"]	= 1703
EventType["UIRetireCheck"]		= 1704
EventType["UIRetireShopCheck"]	= 1705

-- 主场景
EventType["MainSceneEnterPanel"] = 1800  --主场景进入
EventType["MainSceneLeavePanel"] = 1801  --主场景离开
EventType["MainSceneAddSwallowCallback"] = 1802  --添加触摸底层事件
EventType["MainSceneReloadGame"] = 1803  --重启游戏
EventType["MainSceneReplaceTitleScene"] = 1804  --重启游戏,直接退到选择登陆方式页面

-- UIManager
EventType["UIManagerRecordHeaderBackEvent"] = 1900 --记录header返回按钮事件




--ViewList2
EventType["ViewList2Check"] 		= 2000 --点击事件
EventType["ViewList2AddItem"] 		= 2001 --添加
EventType["ViewList2RemoveItem"] 	= 2002 --删除
EventType["ViewList2updateItem"] 	= 2003 --更新子项
EventType["ViewList2updateAll"]		= 2004 --整个更新

--邮件
EventType["NetworkMailRetAllMail"]			= 2100 --返回所有邮件
EventType["NetworkMailRetOpenMail"]			= 2101 --打开邮件邮件
EventType["NetworkMailRetGetRewardMail"]	= 2102 --获得单个邮件的奖励
EventType["NetworkMailRetGetAllRewardMail"]	= 2103 --获得所有邮件的奖励
EventType["NetworkMailNtNewMail"]			= 2104 --获得新邮件
EventType["NetworkMailNewMailTip"]			= 2105 --未读邮件提示
EventType["NetworkMailDelAll"]				= 2106 --删除所有已读邮件（已领取，已读）
--主界面
--EventType["UIMainPanelCommonBtnTips"]		= 2151 --主界面
EventType["UIMainPanelKanBan"]				= 2152 --主界面看板娘更新
EventType["UIMainPanelShowAction"]			= 2153 --主界面看板娘更新
-- EventType["UIMainPanelEventShow"]			= 2154 --主界面看板娘更新
-- EventType["UIMainPanelEventRewardTip"]		= 2155 --主界面看板娘更新
EventType["UIMainPanelMainBg"]				= 2156 --主界面看板娘更新
EventType["FightIncomeFull"]				= 2157 --主界面提示挂机已满
EventType["UIUserLevelUpShow"]				= 2158 --玩家升级返回奖励
EventType["UIUpdateBtnShow"]				= 2159
EventType["UIUpdateBattlePassRewardLevel"]  = 2160




--公会
EventType["NetworkGuildRetGuildInfo"]			= 2200 --获得公会数据
EventType["NetworkGuildRetAllGuildList"]		= 2201 --获得公会列表
EventType["NetworkGuildRetJoinGuild"]			= 2202 --加入公会
EventType["NetworkGuildRetSearchGuild"]			= 2203 --查找公会
EventType["NetworkGuildRetCreateGuild"]			= 2204 --创建公会
EventType["NetworkGuildRetGuildMember"]			= 2205 --创建公会
EventType["NetworkGuildRetApplyList"]			= 2206 --创建公会
EventType["UIGuildMemberInfo"]					= 2207 
EventType["NetworkGuildRetGuildAppoint"]		= 2208 --委任公会
EventType["NetworkGuildRetGuildFired"]			= 2209 --开除公会
EventType["NetworkGuildRetGuildDepose"]			= 2210 --免职
EventType["NetworkGuildRetGuildQuit"]			= 2211 --退出
EventType["NetworkGuildRetGuildDismiss"]		= 2212 --解散
EventType["NetworkGuildRetGuildApply"]			= 2213 --通过申请
EventType["NetworkGuildRetGuildNotApply"]		= 2214 --拒绝申请
EventType["NetworkGuildRetGuildDonateInfo"]		= 2215 --公会祭奠信息
EventType["NetworkGuildRetGuildDonate"]			= 2216 --公会祭奠
EventType["NetworkGuildRetGetDonateReward"]		= 2217 --公会祭奠奖励
EventType["NetworkGuildRetGuildRank"]			= 2218 --公会排行榜
EventType["NetworkGuildRetGuildMessInfo"]		= 2219 --公会留言
EventType["NetworkGuildRetGuildSysMess"]		= 2220 --公会系统信息
EventType["NetworkGuildRetGuildMess"]			= 2221 --留言
EventType["UIGuildApplyPass"]					= 2222 
EventType["NetworkGuildRetGuildNotice"]			= 2223 --公会公告
EventType["NetworkGuildRetGuildGetInfo"]		= 2224 --公会数据
-- EventType["UIRetGetGuildShopData"]				= 2225 --公会商店数据
-- EventType["UIRetGuildShopBuy"]					= 2226 --购买公会商品
EventType["UIGuildNotApplyPass"]				= 2227 --拒绝
EventType["NetworkGuildUpdateGuildMoney"]		= 2228 --更新公会祭奠货币
EventType["NetworkGuildRetGuildIcon"]			= 2229 --公会icon
EventType["NetworkGuildRetSetAudit"]			= 2230 --设置审批状态
EventType["NetworkGuildRetMemberTeam"]			= 2231 --公会成员队伍


EventType["NetworkGuildBossBonusStage"]			= 2232 --公会技能信息
EventType["NetworkGuildBossBuyChallengeNum"]	= 2233 --购买挑战boss次数
EventType["NetworkGuildRedDotShow"]				= 2234 --公会主界面刷新红点
EventType["NetworkGuildBossRedDotShow"]			= 2235 --公会副本刷新红点
EventType["NetworkGuildBossCheckPoint"]			= 2236 --公会副本扫荡刷新
EventType["UIUpateGuildBonusRedDot"]			= 2237 --公会boss奖励红点

EventType["UpdateGuildBossInfoPanel"]			= 2238 --新公会boss刷新
EventType['NetworkGuildRaidRank']				= 2239
EventType['NetworkGuildRaidDamageRank']			= 2240	
EventType["NetworkGuildUpdateMemberList"]		= 2241 --刷新工会列表



-- 运营活动
-- EventType["NetworkRetLimitActivityData"]		= 2250 --限时活动数据
EventType["NetworkRetActivityData"]				= 2251 --活动数据
EventType["NetworkRetLimitActivityReward"]		= 2252 --获取限时活动奖励
-- EventType["NetworkRetBuyMonthCard"]				= 2254 --购买月卡
--EventType["UILimitActivityBtn"]					= 2255 --限时活动按钮
EventType["NetworkRetActivityGetFirstRecharge"]	= 2256 --领取首充奖励
EventType["NetworkRetSignGetReward"]			= 2257 --签到奖励
EventType["NetworkRetLevelGiftGetReward"]		= 2258 --
EventType["NetworkRetFpGiftGetReward"]			= 2259 --
EventType["NetworkRetPowarGetReward"]			= 2260 --
EventType["UIActivityBtn"]						= 2261 --
EventType["NetwordRetRoundReward"]				= 2262 --
EventType["NetworkRetOnlineReward"]				= 2263 -- 在线奖励
EventType["NetworkRetOnlineData"]				= 2264 -- 在线奖励
EventType["NetworkRetThreeDayGetReward"]		= 2265 -- 三日奖励
EventType["NetworkRetCDKGift"]					= 2266 -- CDKEY奖励
EventType["NetwordRetRoundTargetReward"]				= 2267 -- 目标奖励


EventType["UIUpdateMainActivityPage"]		    = 2300 --主界面页面更新

-- loading界面
EventType["LoadingGoOn"]						= 2330
EventType["LoadingAddCallback"]					= 2331

EventType["TimeManagerRefreshShopState"]		= 2350 --计时界面刷新商店状态


-- 战斗活动
EventType["NetworkGetEventInfo"]				= 2400
EventType["NetworkEventGetReward"]				= 2401
EventType["NetworkEventReset"]					= 2402
EventType["NetworkEventFightBegin"]				= 2403
EventType["NetworkEventFightEnd"]				= 2404
EventType["NetworkEventResetFighterHp"]			= 2405
EventType["NetworkEventUpdatePt"]				= 2406
EventType["UIEventDailyMissionGetReward"]		= 2407
EventType["NetworkEventSwitchPanel"]			= 2408
EventType["NetworkEventSelectBuff"]				= 2409
EventType["NetwordEventGetReward"]				= 2410
EventType["NetworkEventGetMapInfo"]				= 2411
-- EventType["NetworkEventGetMapItemInfo"]			= 2413
EventType["NetworkEventInitInfo"]				= 2414
EventType["NetworkEventGetHardLog"]				= 2415
EventType["NetworkEventMapItemFight"]			= 2417
EventType["UIEventRewardUpdate"]				= 2418
EventType["UIEventChallengeUpdate"]				= 2419

--公会副本
EventType["NetworkGuildMissionRetInfo"]			= 2450
-- EventType["NetworkGuildMissionOpen"]			= 2451
-- EventType["NetworkGuildMissionClearCd"]		= 2452
-- EventType["NetworkGuildMissionFight"]		= 2453
-- EventType["NetworkGuildMissionFightEnd"]		= 2454
EventType["NetworkGuildMissionRank"]			= 2455
EventType["NetworkGuildBossKillBonusGet"]		= 2456
-- EventType["UITeamUpdateCd"]					= 2456

--每日任务
EventType["UIDailyMissionRetConditionReward"]	= 2500
EventType["UIDailyMissionRetReward"]			= 2501
EventType["UIDailyMissionShow"]					= 2502
EventType["UIDailyMissionAdd"]					= 2503

-- 聊天
EventType["ChatReceiveMsg"]						= 2600
EventType["ChatChangeRoom"]						= 2601
EventType["ChatGenMsg"]							= 2602

--图书馆收藏
EventType["NetWorkLibraryAchievementInfo"]		= 4900
EventType["NetworkLibraryGetReward"]			= 4901

--治疗
EventType["NetworkRetTreatmentInfo"]			= 3001
EventType["NetworkRetTreatment"]				= 3002
EventType["NetworkRetTreatmentComplete"]		= 3003
EventType["NetworkRetTreatmentSpeed"]			= 3004
EventType["NetworkRetTreatmentCancel"]			= 3005

-- 基地 试炼之战
EventType["UITrialPanelFightOver"]					= 3040
EventType["UITrialPanelGetReward"]					= 3041
-- EventType["UITrialPanelBuyAutoNum"]					= 3042
EventType["UITrialPanelUpdateRewardTips"]			= 3043


--基地
EventType["NetworkRetBaseEquipLevelUp"]				= 3051
EventType["NetworkRetBaseSkillLevel"]				= 3053
EventType["NetworkRetBaseSkillLevelUpComplete"]		= 3054
EventType["NetworkRetBaseCardLevelUp"]				= 3055
EventType["NetworkRetBaseCardLevelUpComplete"]		= 3056
EventType["NetworkRetBaseTreatmentLevelUp"]			= 3057
-- EventType["NetworkRetBaseTreatmentLevelUpComplete"]	= 3058
EventType["NetworkRetBaseLevelUp"]					= 3059
EventType["NetworkRetBaseInfo"]						= 3060
EventType["UIHomeBaseLevelUpUpdateUI"]			    = 3061
EventType["UIHomeBaseUpdateEquip"]					= 3062
EventType["UIHomeBaseUpdateSkill"]					= 3063
EventType["UIHomeBaseUpdateLibrary"]				= 3064
-- EventType["UIHomeBaseUpdateTreatment"]				= 3065
EventType["NetworkRetBaseOnShow"]					= 3066
EventType["NetworkRetBaseCardLevelUpOnShow"]		= 3067
EventType["UIHomeBaseCardLevelUpUpdateUI"]			= 3068
EventType["UIHomeBaseRedDotShow"] 					= 3069


--MessageBox
EventType["UIMessageBoxClose"]						= 3100

-- model
EventType['ModelUserLevelUp']						= 3150

-- battlepass
EventType['UIRetMissionData']							= 3200
EventType['UIRetMissionDailyRewardItem']				= 3201
EventType['UIRetMissionLifeReward']						= 3204
EventType['UIRetMissionLifeGoalReward']					= 3205
EventType['UIRetMissionDailyReward']					= 3207

-- recharge
EventType["NetworkRetRechargeInfo"]					= 3300
EventType["NetworkRetRechargeBuyDiamond"]			= 3301
EventType["NetworkRetRechargeGetReward"]			= 3302
EventType["NetworkRetRechargeBuyMonthCard"]			= 3303
EventType["NetworkRetRechargeRewardMonthCard"]		= 3304
EventType["NetworkRetRechargeGoodInfo"]				= 3305
EventType["NetworkRetRechargeGoodVerify"]			= 3306
EventType["NetworkRetRechargeUncomsumed"]			= 3307
EventType["NetworkRetRechargeChangeAuto"]			= 3308
EventType['SDKQueryPurchaseCallback']				= 3309 
EventType['NetworkRetRechargeGoodReward']			= 3310
EventType['NetworkRetRechargeGrowupReward']			= 3311
EventType['NetworkRetRechargeGiftFree']				= 3312
-- arena
EventType["NetworkRetGetRankList"]					= 3400
EventType["NetworkRetGetArenaRankLvReward"]			= 3401
EventType["UIUpdateArenaRankRewardTime"]			= 3402
EventType["UIUpdateArenaPanelRedDot"]				= 3403
EventType["NetworkRetArenaInfo"]					= 3404
EventType["UIShowLastTime"]							= 3405

--card comment
EventType["NetworkRetCardCommentInfo"]				= 3451
EventType["NetworkRetCardCommentCardLike"]			= 3452
EventType["NetworkRetCardCommentLike"]				= 3453
EventType["NetworkRetCardComment"]					= 3454

--bare collect
EventType["NetworkRetBareCollectActive"]			= 3500
EventType["NetworkRetBareCollectChange"]				= 3501
EventType["NetworkRetLoveChange"]					= 3502
EventType["NetworkRetBareCollectAddNew"]			= 3503

--setting
EventType["UIBgSelectUpdateBg"]						= 3550

-- Announcement
EventType["AddNewAnnouncement"]						= 3600
EventType["AddImportantAnnouncement"]				= 3601

-- admob
EventType["NetworkRetAdmobReward"]					= 3650
EventType["NetworkRetAdmobInfo"]					= 3651

--futurecard
EventType["UIFutureCardUpdate"]						= 3700
EventType["UIFutureCardSel"]						= 3701

--box
EventType["NetworkRetOpenBox"]						= 3750

EventType["UIUpdateEventPos"]						= 3800
EventType["UIUpdateEventBuff"]						= 3801
EventType["UIUpdateEventShop"]						= 3802
EventType["UIUpdateEventRobot"]						= 3803

EventType["UIGuidePanel"]							= 3900
EventType["ShieldGuide"]							= 3901
EventType["UITipsMessage"]							= 3902

--battlepass
EventType["NetworkRetBattlepassData"]				= 3950
EventType["NetworkRetBattlepassReward"]				= 3951
EventType["NetworkRetBattlepassMissionReward"]		= 3952
EventType["UIBuyBattlepassSpecial"]					= 3953

cc.exports.EventType = EventType;
--========================================================================
--事件管理者
local EventManager = class("EventManager")


--初始化
function EventManager:ctor()
	self.eventList = {};			--事件列表

	--loading
	--self:RegisterEvent(EventType.StartLoading, Event, Event.OnStartLoad);

	--UI
	--self:RegisterEvent(EventType.EnterBossFightArea, Event, Event.OnEnterBossFightArea);
	--self:RegisterEvent(EventType.EnterFightArea, Event, Event.OnEnterFightArea);
	--self:RegisterEvent(EventType.EnterWorldMapArea, Event, Event.OnEnterWorldMapArea);
	
	--战斗
	--[[
	self:RegisterEvent(EventType.EnterFight, Event, Event.OnEnterFight);
	--]]

	--任务
	--[[
	self:RegisterEvent(EventType.TaskInitFinished, Event, Event.OnTaskInitFinished);
	--]]
	
	--其他
	--self:RegisterEvent(EventType.RecoverDisplayMemory, Event, Event.OnRecoverDisplayMemory);	--回收显存
end

--注册事件
function EventManager:RegisterEvent( eventType, callback, ... )
	--print(eventType)
	if not self.eventList[eventType] then
		self.eventList[eventType] = {};
	end
	table.insert(self.eventList[eventType], callback);
end

--取消注册
function EventManager:UnregisterEvent( eventType )
	self.eventList[eventType] = nil;
end

--查看事件是否被注册
function EventManager:IsRegisterEvent( eventType )
	if self.eventList[eventType] then
		return true;
	else
		return false;
	end
end

--触发事件
function EventManager:FireEvent( eventType, ... )
	if self.eventList[eventType] then
		for k, v in pairs(self.eventList[eventType]) do
			v(...);
		end
	end
end

function EventManager:clearAll( )
	self.eventList = {}
end

cc.exports.EventManager = EventManager:create();
