local SkillScriptManager = class("SkillScriptManager")
local scheduler = cc.Director:getInstance():getScheduler();

function SkillScriptManager:ctor()

	self:Init();
end

function SkillScriptManager:clearAll(  )
	self:registEvent(false);
end

function SkillScriptManager:Init( ... )
	self:clearAll();

	self.skillScriptList = {};
	self.cur_id = 0;
	self.isStop = false;
	self:registEvent();
end

function SkillScriptManager:registEvent( regist )

	if regist == false then
		EventManager:UnregisterEvent(EventType.FightPauseSkillScript);
		EventManager:UnregisterEvent(EventType.FightContinueSkillScript);
	end
	EventManager:RegisterEvent(EventType.FightPauseSkillScript, handler(self, self.showSkillPause));
	EventManager:RegisterEvent(EventType.FightContinueSkillScript, handler(self, self.showSkillContinue));end

function SkillScriptManager:CreateSkillScript( scriptID, t )
	self.cur_id = self.cur_id + 1;
	self.skillScriptList[self.cur_id] = require("app.fight.SkillScript"):create(self.cur_id, scriptID, t)
	return self.skillScriptList[self.cur_id];
end

function SkillScriptManager:GetSkillScript( id )
	if self.skillScriptList[id] then
		return self.skillScriptList[id]
	end
	return nil;
end

function SkillScriptManager:Update( dt )
	for k, v in pairs(self.skillScriptList) do
		if not v:Update(dt) then
			self.skillScriptList[k] = nil;
		end
	end
end

function SkillScriptManager:TakeOff( id )
	if self.skillScriptList[id] then
		self.skillScriptList[id]:TakeOff();
	end
end

function SkillScriptManager:Pause()
	self.isStop = true;
	for k, v in pairs(self.skillScriptList) do
		v:Pause()
	end
end

function SkillScriptManager:Continue()
	self.isStop = false;
	for k, v in pairs(self.skillScriptList) do
		v:Continue()
	end
end

function SkillScriptManager:IsStop()
	return self.isStop;
end

function SkillScriptManager:Initialize()
end

function SkillScriptManager:Reset()
	self.skillScriptList = {};
end

function SkillScriptManager:checkScriptRunning(skill)
	local findScript = false
	for k, v in pairs(self.skillScriptList) do
		if v:GetScriptName() == skill:GetScriptName() then
			findScript = true;
		end
	end
	return findScript;
end

function SkillScriptManager:showSkillPause(skill)
	for k, v in pairs(self.skillScriptList) do
		if v:GetScriptName() == skill:GetScriptName() then
			v:Pause();
		end
	end
end

function SkillScriptManager:showSkillContinue(skill)
	for k, v in pairs(self.skillScriptList) do
		if v:GetScriptName() == skill:GetScriptName() then
			v:Continue();
		end
	end
end

cc.exports.SkillScriptManager = SkillScriptManager:create();
