--fightActiveSkill.lua
--=================================================================
local FightActiveSkill = class("FightActiveSkill", require("app.fight.fightBaseSkill"));
--=================================================================
--主动技能类
local SkillType = Enum:getTable("SkillType");
local BuffType = Enum:getTable("BuffType");

--构造函数
function FightActiveSkill:ctor(fighter, id)
	FightActiveSkill.super.ctor(self, fighter, id);
	self.m_skillType = SkillType.activeSkill;		--类型为普通攻击
	self.m_priority = 1;
	self.m_releaseFlag = false;						
	
	self:initSkillProperty();
end

function FightActiveSkill:initSkillProperty()
	local data = ResTable:getRowData('skill', self.m_resid);
	self.hit_type = data['hit_type'];
	self.pre_cd = tonumber(data['pre_cd']);
	self.cd = tonumber(data['cd']);
	self.castCount = 0;
	self.tableData = data;
	self.name = data.name;
end

--=================================================================
--释放技能
function FightActiveSkill:RunSkill(targetList, secList)
	self.castCount = self.castCount + 1;
	self.targetList = targetList;
	self.secTagList = secList;

	self:RunRealSkill()
end

function FightActiveSkill:RunRealSkill()
	if self.m_fighter:HasSpecialState('reject') then
		BuffManager:causeBuffEffect(self.m_fighter.id, BuffType.reject)
	end
	local t = 1
	if self.m_fighter:HasSpecialState('combo') then
		local ret = BuffManager:causeBuffEffect(self.m_fighter.id, BuffType.combo)
		if ret==true then
			t = 2
		end
	end
	self.m_fightAttackClass = FightAttackManager:CreateAttack(self.m_fighter, self.targetList, self.secTagList, self, t);
	FightSkillManager:AddSkill(self.m_fighter:GetID(), self);

	FightActiveSkill.super.RunJueXingSkill(self);

end

-- 获取攻击间隔
function FightActiveSkill:GetCastCD()
	if self.castCount > 0 then
		return self.cd;
	else
		return self.pre_cd;
	end
end

return FightActiveSkill;
