--fightAttackManager.lua
--====================================================================
--攻击管理者
local FightAttackManager = class("FightAttackManager")

function FightAttackManager:ctor()
	self.attackList = {};				--攻击列表
	self.globalAttackID = 0;			--全局攻击id
end

--分配攻击id
function FightAttackManager:allocAttackID()
	self.globalAttackID = self.globalAttackID + 1;
	return self.globalAttackID;
end

--清除所有攻击类
function FightAttackManager:Clear()
	self.attackList = {};
end

--重置攻击id
function FightAttackManager:ResetAttackID()
	self.globalAttackID = 0;
end

--获取攻击类
function FightAttackManager:GetAttackClass(attackid)
	return self.attackList[attackid];
end

--创建攻击
function FightAttackManager:CreateAttack(attacker, targetList, secList, skill, t)
	local attackID = self:allocAttackID();
	local fightAttack = require("app.fight.fightAttack"):create(attackID, attacker, targetList, secList, skill, t);
	self.attackList[attackID] = fightAttack;
	return fightAttack, targetList;
end	

--删除攻击
function FightAttackManager:DestroyAttack(attackClass)
	local attackID = attackClass:GetID();
	if self.attackList[attackID] ~= nil then
		self.attackList[attackID]:SetNeedDestroy(true);
	end
end

cc.exports.FightAttackManager = FightAttackManager:create();
