local FightFunction = class("FightFunction")

function FightFunction:ctor()
end

function FightFunction:CaculateAttackDamage(attacker, target, damageItem, isCrit)
	local CastType = Enum:getTable('CastType');

	local baseDamage = damageItem.baseDamage;
	local factor = damageItem.factor;

	local damage, finalDamage, cast_type = 0, 0, CastType.normal;

	local isRestrain = self:getRestrain(attacker, target);
	--[[
	local def = target.m_propertyData:GetCurrentPropertyData('def');
	local defenseReduction = def / (def + Conf.DefCoefficient);
	--]]
	local defenseReduction = 0;
	-- normal attack
	damage = HpPlus(HpMultiply(attacker.m_propertyData:GetCurrentPropertyData('atk'), factor), tostring(baseDamage));


	finalDamage = damage;
	if isCrit then
		finalDamage = HpMultiply(damage, (attacker.m_propertyData:GetCurrentPropertyData('crit_dam')+200)/100);
	end
	if isRestrain then
		local restraintNum = tonumber(Conf.restraintNum)/100 + 1
		finalDamage = HpMultiply(finalDamage, restraintNum);
	end

	if isCrit then
		if isRestrain then
			cast_type = CastType.restrainCrit;
		else
			cast_type = CastType.crit;
		end
	else
		if isRestrain then
			cast_type = CastType.restrain;
		else
			cast_type = CastType.normal;
		end
	end

		--finalDamage = damage * (1 - defenseReduction) * self:getFactor(damageItem.hitType, target.m_propertyData:GetCurrentPropertyData('def_type'));

	return finalDamage, cast_type;
end

function FightFunction:getRestrain(attacker, target)
	if (target.fightAttribute - attacker.fightAttribute == 1) or (attacker.fightAttribute - target.fightAttribute == 2) then
		return true;
	else
		return false;
	end
end

function FightFunction:getFactor(attackType, defendType)
	if attackType == 1 then
		if defendType == 1 then
			return 1;
		elseif defendType == 2 then
			return 0.5;
		elseif defendType == 3 then
			return 1.5;
		end
	elseif attackType == 2 then
		if defendType == 1 then
			return 1.5;
		elseif defendType == 2 then
			return 1;
		elseif defendType == 3 then
			return 0.5;
		end
	elseif attackType == 3 then
		if defendType == 1 then
			return 0.5;
		elseif defendType == 2 then
			return 1.5;
		elseif defendType == 3 then
			return 1;
		end
	end
	return 1;
end

function FightFunction:CaculateMissileHit(gAtt, agDef)
	if (gAtt + agDef) == 0 then
		return false;
	end
	local hit = (Conf.MissileCoefficientA * gAtt - Conf.MissileCoefficientB * agDef) / (gAtt + agDef);
	if hit < 0 then
		hit = 0;
	elseif hit > 1 then
		hit = 1;
	end
	local r = math.random();
	return (r <= hit);
end

function FightFunction:getHpSprite(num, isEnemy)
	isEnemy = isEnemy or false;
	local imagePath;
	if isEnemy then
		imagePath = 'image/nums/fight_hp_enemy.png';
	else
		imagePath = 'image/nums/fight_hp_ally.png';
	end
	if tostring(num) == '/' then
		num = 10;
	else
		num = tonumber(num)
	end
	local sp = cc.Sprite:create(imagePath, cc.rect(num*18+2,0,14,18));
	return sp;
end

cc.exports.FightFunction = FightFunction:create();
