--fightNormalSkill.lua
--=================================================================
local FightNormalSkill = class("FightNormalSkill", require("app.fight.fightBaseSkill"));
--=================================================================
--普通攻击类
local SkillType = Enum:getTable("SkillType");

--构造函数
function FightNormalSkill:ctor(fighter, id)
	FightNormalSkill.super.ctor(self, fighter, id);
	self.m_skillType = SkillType.normalAttack;		--类型为普通攻击
	self.m_priority = 1;							--优先级为1，最低
	self.m_releaseFlag = false;						

	self:initSkillProperty();
end

function FightNormalSkill:initSkillProperty()
	local data = ResTable:getRowData('skill', self.m_resid);
	self.hit_type = data['hit_type'];
	self.pre_cd = tonumber(data['pre_cd']);
	self.cd = tonumber(data['cd']);
	self.castCount = 0;
	self.tableData = data;
end

--=================================================================
--释放技能
function FightNormalSkill:RunSkill(targetList, secList)
	self.castCount = self.castCount + 1;
	self.targetList = targetList;
	self.secTagList = secList;

	self.m_fightAttackClass = FightAttackManager:CreateAttack(self.m_fighter, self.targetList, self.secTagList, self);
	FightSkillManager:AddSkill(self.m_fighter:GetID(), self);

	FightNormalSkill.super.RunJueXingSkill(self);
end

-- 获取攻击间隔
function FightNormalSkill:GetCastCD()
	if self.castCount > 0 then
		local aspd = self.m_fighter.m_propertyData:GetCurrentPropertyData('aspd');
		if aspd > 0 then
			return math.floor(self.cd/aspd*100)/100;
		else
			return self.cd;
		end
	else
		return self.pre_cd;
	end
end

return FightNormalSkill;
