--fightPassiveSkill.lua
--=================================================================
local FightPassiveSkill = class("FightPassiveSkill", require("app.fight.fightBaseSkill"));
--=================================================================
--普通攻击类
local SkillType = Enum:getTable("SkillType");

--构造函数
function FightPassiveSkill:ctor(fighter, id, lv)
	FightPassiveSkill.super.ctor(self, fighter, id, lv);
	self.m_skillType = SkillType.passiveSkill;		--这个类型可能会被修改 SkillType.passiveSkill SkillType.passive4Skill SkillType.passive5Skill
	self:initSkillProperty();
end

function FightPassiveSkill:initSkillProperty()
	local skillOriData = ResTable:getRowData('skill', self.m_resid);
	self.hit_type = skillOriData['hit_type'];
	self.pre_cd = tonumber(skillOriData['pre_cd']);
	self.cd = tonumber(skillOriData['cd']);
	self.castCount = 0;
	self.tableData = skillOriData;

	self.triggerRate = skillOriData['awake_pro'];
	self.triggerNum = 0;
end

--=================================================================
--释放技能
function FightPassiveSkill:RunSkill(targetList, secList)
	self.castCount = self.castCount + 1;

	self.targetList = targetList;
	self.secTagList = secList;

	FightSkillManager:AddSkill(self.m_fighter:GetID(), self);

	local haveSecEff, secEffTagList = EffectFunction:MakeSkillSecEff(self.m_fighter:GetID(), self.targetList, self); --计算是否有衍生效果

	self.m_fighter:castNoScriptSkill(self, targetList);

	if haveSecEff then --添加衍生效果
		EffectFunction:SetSkillSecEff(self.m_fighter:GetID(), secEffTagList, self);
	end

	if self:GetSkillType()==SkillType.passive4Skill or self:GetSkillType()==SkillType.passive5Skill then
		EventManager:FireEvent(EventType.FightShowSkillExt, self.m_fighter:GetID(), 2);
	end
	
	local secTagIDList = {}
	for _, v in pairs(self.secTagList) do
		table.insert(secTagIDList, v:GetID());
	end
	EffectFunction:AddBuff2( self.m_fighter:GetID(), secTagIDList, self )
	
end

function FightPassiveSkill:TriggerNum()
	self.triggerNum = self.triggerNum + 1
	if self.triggerNum >= self.cd then --SkillType.passive4Skill 次数触发
		self.triggerNum = 0
		return true;
	end
	return false;
end

function FightPassiveSkill:TriggerRandom( v ) --SkillType.passive5Skill 概率触发
	if self.triggerRate[v] > math.random() then
		return true;
	end
	return false;
end

-- 获取攻击间隔
function FightPassiveSkill:GetCastCD()
	if self.castCount > 0 then
		if self.cd == 0 then
			return 999999;
		else
			return self.cd;
		end
	else
		return self.pre_cd;
	end
end

return FightPassiveSkill;
