local FightShowSkillManager = class("FightShowSkillManager");
local scheduler = cc.Director:getInstance():getScheduler();
local FighterState = Enum:getTable('FighterState');

function FightShowSkillManager:ctor()
	self:Init();
end

function FightShowSkillManager:clearAll(  )
	self:registEvent(false);
end

function FightShowSkillManager:Init( ... )
	self:clearAll();
	self:registEvent();

	self.eventList = {}
	self.shakeEnd = 0;
end

function FightShowSkillManager:registEvent( regist )

end

function FightShowSkillManager:showSkill(fighter, skill)
	FightManager:SkillPause()
	EventManager:FireEvent(EventType.FightShowSkill, fighter, skill)
	EventManager:FireEvent(EventType.FightPanelBtnVisible, false)
	-- 	EventManager:FireEvent(EventType.UIHeaderPanelVisible, false)
	-- 	EventManager:FireEvent(EventType.UIFightFooterPanelVisible, false)

	self.eventList['scenePanelShow'] = false
	self.eventList['skillScriptRunOver'] = false
	self.eventList['skillScriptShow'] = {}

	self.showSkillFighter = fighter
	self.curShowSkill = skill
end

function FightShowSkillManager:addSkillScriptCheckCallback(callback)
	table.insert(self.eventList['skillScriptShow'], {over = false, callback = callback})
end

function FightShowSkillManager:setScenePanelShowOver()
	self.eventList['scenePanelShow'] = true
end

function FightShowSkillManager:setSkillScriptRunOver()
	self.eventList['skillScriptRunOver'] = true
end

function FightShowSkillManager:shakeIsEnd()
	return self.shakeEnd == 0;
end

function FightShowSkillManager:setShakeEnd(v)
	self.shakeEnd = v;
end

function FightShowSkillManager:checkScriptOver()
	for k, v in pairs(self.eventList['skillScriptShow']) do
		if not v.over and v.callback() then
			v.over = true
		end
	end
end

function FightShowSkillManager:checkShowOver()
	if SkillScriptManager:IsStop()==true then
		return;
	end
	self:checkScriptOver()
	local allOver = true
	if not self.eventList['scenePanelShow'] then
		allOver = false
	end
	if not self.eventList['skillScriptRunOver'] then
		allOver = false
	end
	for k, v in pairs(self.eventList['skillScriptShow']) do
		if not v.over then
			allOver = false
			break
		end
	end

	if allOver then
		EventManager:FireEvent(EventType.FightShowSkillOver, self.showSkillFighter, self.curShowSkill)
		EventManager:FireEvent(EventType.FightPanelBtnVisible, true)
		EventManager:FireEvent(EventType.UIHeaderPanelVisible, true)
		-- EventManager:FireEvent(EventType.UIFightFooterPanelVisible, true)
		FightManager:SkillContinue()
		self.showSkillFighter:SetFighterState(FighterState.idle)
		self.showSkillFighter = nil
		self.curShowSkill = nil
	end
end

function FightShowSkillManager:ForceOver()
	EventManager:FireEvent(EventType.FightPanelBtnVisible, true)
	EventManager:FireEvent(EventType.UIHeaderPanelVisible, true)
	EventManager:FireEvent(EventType.UIFightFooterPanelVisible, true)
	FightManager:SkillContinue()
	if self.showSkillFighter then
		self.showSkillFighter:SetFighterState(FighterState.idle)
	end
	if self.showSkillFighter and self.curShowSkill then
		EventManager:FireEvent(EventType.FightShowSkillOver, self.showSkillFighter, self.curShowSkill)
	end
	self.showSkillFighter = nil
	self.curShowSkill = nil
end

cc.exports.FightShowSkillManager = FightShowSkillManager:create();
