local LoadingManager = class("LoadingManager")
local scheduler = cc.Director:getInstance():getScheduler();

function LoadingManager:ctor()
end

function LoadingManager:InitWithLoadingPanelHandler(callback)
	self.loadingHandler = callback;
	EventManager:RegisterEvent(EventType.LoadingGoOn, handler(self, self.setGoOn));
	EventManager:RegisterEvent(EventType.LoadingAddCallback, handler(self, self.giveLoadingCallback));
end

function LoadingManager:EnterFightLoading( ... )
	self.isEnter = true;
	self.infoGoOnFlag = false;
	self.leaveCallback = nil;
	self.firstPhase2 = true;
	self.m_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.update), 0, false);
	UIManager:push('LoadingPanel');

	self.callbackList = {};
	local args = { ... };
	for k, v in ipairs(args) do
		table.insert(self.callbackList, v);
	end
end

function LoadingManager:update()
	-- 1 loading Panel enter	
	-- 2 UIManager do swtich
	-- 3 loading wait flag --TODO
	-- 4 loading Panel leave
	--
	if self.loadingHandler.phase == 1 then
	elseif self.loadingHandler.phase == 2 then
		if self.callbackList[1] then
			self.callbackList[1]();
			table.remove(self.callbackList, 1);
		end
		self.loadingHandler:update();
	elseif self.loadingHandler.phase == 3 then
		if self.callbackList[1] then
			self.callbackList[1]();
			table.remove(self.callbackList, 1);
		end
		if self.infoGoOnFlag then
			self.loadingHandler:onPhase4();
		end
		self.loadingHandler:update();
	elseif self.loadingHandler.phase == 4 then
	elseif self.loadingHandler.phase == 5 then
		self:Leave();
	end
end

function LoadingManager:Leave()
	self.isEnter = false;
	if self.leaveCallback then
		self.leaveCallback();
	end
	if self.m_scheduleHandler then
		scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
		self.m_scheduleHandler = nil
	end
	UIManager:pop('LoadingPanel');
end

function LoadingManager:setGoOn( leaveCallback )
	self.infoGoOnFlag = true;
	self.leaveCallback = leaveCallback;
end

function LoadingManager:giveLoadingCallback( ... )
	local args = { ... };
	for k, v in ipairs(args) do
		table.insert(self.callbackList, v);
	end
end

cc.exports.LoadingManager = LoadingManager:create();
