local AccountBindNode = class("AccountBindNode" , function (  )
	return cc.Node:create()
end)
local fonts = Enum:getTable("SystemFont")
local SDKLoginType = Enum:getTable("SDKLoginType")
local MessageBoxType = Enum:getTable('MessageBoxType')

--

function AccountBindNode:ctor(scene, sceneName, name)

	self:Init();
end

function AccountBindNode:Init()

	self:initPanels()
	self:initUnregiestNode()
	EventManager:RegisterEvent(EventType.UIRetGuestBind , handler(self , self.retGuestBind));
end

function AccountBindNode:initPanels()

	local accountLayout = ccui.Layout:create()
		:setBackGroundImage('image/task/blackbg.png')
		:setBackGroundImageScale9Enabled(true)
		:setTouchEnabled(true)
		:setContentSize(StageSize)
		:setLocalZOrder(-1)
		:setAnchorPoint(cc.p(0.5,0.5))
		:addTo(self)
	accountLayout:addClickEventListener(handler(self, self.onClickBack));


	self.root = cc.Node:create()
		:addTo(self)



    self.noSDKlayout = ccui.Layout:create()
		:addTo(self.root)
		:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png')
		:setBackGroundImageScale9Enabled(true)
		:setBackGroundImageCapInsets(cc.rect(11,4,18,21))
		-- bg:setTouchEnabled(true);
		:setContentSize(cc.size(604,187))
		:setAnchorPoint(0.5,1)
		:setPosition(0 , 70)


	-- self.sdkNode = cc.Node:create()
	-- 	:addTo(self.root)

	self.sdkLayout = ccui.Layout:create()
		:addTo(self.root)
		:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png')
		:setBackGroundImageScale9Enabled(true)
		:setBackGroundImageCapInsets(cc.rect(11,4,18,21))
		-- bg:setTouchEnabled(true);
		:setContentSize(cc.size(606,268))
		:setAnchorPoint(0.5,1)
		:setPosition(0 , 100)
		:setVisible(false)

	
	self.titleNode = cc.Node:create()
		:addTo(self.root)
		:setPosition(cc.p(0,70))

	local titleBg = cc.Scale9Sprite:create('image/commonImg/top_1_bg_71_46.png')
		:addTo(self.titleNode)
		:setCapInsets(cc.rect(10,0,51,46))
		:setContentSize(cc.size(604 , 46))
		:setAnchorPoint(0.5,0)

	local titleLight = cc.Sprite:create('image/commonImg/menu_light_582_36.png')
		:addTo(self.titleNode)
		:setPosition(0 , 28)
		:setAnchorPoint(0.5,0)

	self.titleName = cc.Label:createWithTTF(LANG.UI_TITLE_24 , fonts.FONT_SIYUAN , 18)
		:addTo(self.titleNode)
		:setPosition(0 , 14)

	local btnLabel = cc.Label:createWithTTF(LANG.UI_TITLE_25 , fonts.FONT_SIYUAN , 20);
	btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	self.unRegisterBtn = ccui.Button:create('image/commonImg/btn_1_219_55_2.png' , 'image/commonImg/btn_1_219_55_2.png')
		:addTo(self.root)
		:setPosition(-130 , -60)
		:setTitleLabel(btnLabel)
	self.unRegisterBtn:addClickEventListener(handler(self, self.unRegisterClick));

	local btnLabel1 = cc.Label:createWithTTF(LANG.UI_TITLE_26 , fonts.FONT_SIYUAN , 20);
	btnLabel1:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	self.logoutBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png')
		:addTo(self.root)
		:setPosition(130 , -60)
		:setTitleLabel(btnLabel1)
	self.logoutBtn:addClickEventListener(handler(self, self.logoutBtnClick));

	self.accountNode = cc.Node:create()
		:addTo(self.root)
		:setPosition(cc.p(0,22))
		
	local accountBg1 = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
		:addTo(self.accountNode)
		:setCapInsets(cc.rect(11,11,34,28))
		:setContentSize(cc.size(582 , 75))

	local accountBg2 = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
		:addTo(self.accountNode)
		:setPosition(0 , 3)
		:setCapInsets(cc.rect(11,11,34,28))
		:setContentSize(cc.size(555 , 42))

	local flgarr = cc.Sprite:create("image/commonImg/arrow_bg.png")
		:addTo(self.accountNode)
		:setPosition(cc.p(-247, 5))

	local accLabel = cc.Label:createWithTTF(LANG.UI_TITLE_20 , fonts.FONT_SIYUAN , 20)
		:addTo(self.accountNode)
		:setPosition(-210, 5)
		:setTextColor(cc.c3b(160 , 200 , 255))

	self.accIcon = cc.Sprite:create('image/commonImg/arrow_bg.png')
	:addTo(self.accountNode)
	:setPosition( -168, 5 )

	self.accInfoLabel = cc.Label:createWithTTF('googlepaly@google.com' , fonts.FONT_SIYUAN , 20)
	self.accInfoLabel:addTo(self.accountNode)
	self.accInfoLabel:setPosition(225, 0)
	self.accInfoLabel:setAnchorPoint(cc.p(1,0.5))



	self.sdkNode = cc.Node:create()
		:addTo(self.root)

	local loginType;
	local platform = cc.Application:getInstance():getTargetPlatform()
	if (cc.PLATFORM_OS_IPHONE == platform) or (cc.PLATFORM_OS_IPAD == platform) then 
		loginType = {
			SDKLoginType.LOGIN_IOS,
			SDKLoginType.LOGIN_GOOGLE,
			SDKLoginType.LOGIN_FACEBOOK
		}
	else
		loginType = {
			SDKLoginType.LOGIN_GOOGLE,
			SDKLoginType.LOGIN_FACEBOOK
		}
	end
	local row,col = 0,0;
	for i=1,#loginType do
		col = (i - 1) % 2  -- 0 ,1
		row = math.floor((i - 1) / 2); -- 0,1
		local btn = ccui.Button:create('image/login/login_type_'..string.format( "%.3d",loginType[i] )..'.png')
			:setPosition(-142 + col *284, -34-row*65)
			:setScale(0.65)
			:addTo(self.sdkNode)
			:setTag(loginType[i])
			:addClickEventListener(handler(self, self.guestBindSDKClick))
	end
	self.sdkRow = row;
	self.sdkLayout:setContentSize(cc.size(606,268 + row*60))


end

function AccountBindNode:initUnregiestNode(  )
	self.unRegisterNode = cc.Node:create()
		:setLocalZOrder(200)
		:addTo(self)
		:setVisible(false)

	local bg1 = cc.Sprite:create('image/commonImg/common_tips_bg.png')
		:setPosition(0, 0)
		:addTo(self.unRegisterNode)

	local bg2 = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png');
	bg2:addTo(self.unRegisterNode);
	bg2:setContentSize(cc.size(582 , 186));

	local titlelabel = cc.Label:createWithTTF(LANG.UI_TITLE_NOTICE , fonts.FONT_SIYUAN , 20)
	:addTo(self.unRegisterNode)
	:setPosition(0, 135)

	local info = cc.Label:createWithTTF(LANG.ACCOUNT_3 , fonts.FONT_SIYUAN , 20)
		:addTo(self.unRegisterNode)
		:setPosition(0, 10)
		:setTextColor(cc.c3b(160 , 200 , 255))

	local btnLabel1 = cc.Label:createWithTTF(LANG.UI_TITLE_21 , fonts.FONT_SIYUAN , 20);
	-- btnLabel1:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	local cancelBtn = ccui.Button:create('image/commonImg/btn_1_219_55_2.png' , 'image/commonImg/btn_1_219_55_2.png')
		:addTo(self.unRegisterNode)
		:setPosition(-150 , -130)
		:setTitleLabel(btnLabel1)
		:setTag(1)
		:addClickEventListener(function()
			self.unRegisterNode:setVisible(false);
			self.accountNode:setVisible(true);
		end)

	local btnLabel1 = cc.Label:createWithTTF(LANG.ACCOUNT_4 , fonts.FONT_SIYUAN , 20);
	-- btnLabel1:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	local unRegisterBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png')
		:addTo(self.unRegisterNode)
		:setPosition(150 , -130)
		:setEnabled(true)
		:setTitleLabel(btnLabel1)
		:setTag(2)
		:addClickEventListener(handler(self, self.unregisterAccount))
end

function AccountBindNode:logoutBtnClick(sender , event)
	if self.logoutCallback then
		self.logoutCallback();
	end
	self:onClickBack()
end


function AccountBindNode:unRegisterClick(sender , event)
	self.unRegisterNode:setVisible(true);
	self.accountNode:setVisible(false);
end

function AccountBindNode:unregisterAccount( sender,event )
	self.unRegisterNode:setVisible(false);
	model.AccountModel:reqUnregisterSDK(1);
end

function AccountBindNode:guestBindSDKClick(sender , event)
	local platform = sender:getTag();
	-- 1 登录第三方
	-- 2 验证第三方并判断是否绑定游客
	self.bindPlatformType = platform;
	sdkManager.SDKLuaHelper:signIn(platform,handler(self,self.retSDKLogin));
end

function AccountBindNode:retSDKLogin( strData )
	-- print("sdkLoginCallback === "..tostring(strData));
	local jsonData = Cjson.decode(strData)
	if jsonData == nil or jsonData.code ~= 0 then
		-- self.loginStep = LOGIN_STEP.STEP_BEGIN;
		-- self:checkLogin()
		Prompt:Show(LANG.UI_TITLE_12);
		return 
	else
		model.AccountModel:setSDKLoginInfo( jsonData )
	end

	model.AccountModel:setSDKLoginInfo( jsonData )

	if jsonData.debug == true then
		-- 非ios,android平台 ，验证登录直接成功
		-- self.loginStep = LOGIN_STEP.STEP_LOGIN_UID;
		-- return 
	end
	model.AccountModel:reqSDKBind(self.bindPlatformType)
end

function AccountBindNode:retGuestBind()
	local msgBox = MessageBox:create(LANG.ACCOUNT_9, MessageBoxType.OK, function()
		self:updateInfo()
	end,function()
	end,function()
		self:updateInfo()
	end);
	msgBox:setTitle(LANG.UI_TITLE_NOTICE)
end

function AccountBindNode:onClickBack()
	self.logoutCallback = nil 
	self.bindPlatformType = nil;
	self:onLeave();
end

function AccountBindNode:updateInfo(  )
	local platformType = model.UserDefaultModel:getPlatformType()
	self.accIcon:setTexture('image/login/login_small_'..string.format( "%.3d",platformType )..'.png')
	local showSDK = false;
	if platformType == SDKLoginType.LOGIN_ACCOUNT then
		self.unRegisterBtn:setVisible(false)
		self.logoutBtn:setPosition(cc.p(0 , -60))

		-- 显示账号，以及登出
	elseif platformType == SDKLoginType.LOGIN_GUEST then
		local name = model.AccountModel:getAccountGuest()
		self.accInfoLabel:setString(tostring(name));
		-- guest
		showSDK = true;

		self.unRegisterBtn:setVisible(false)
		self.logoutBtn:setPosition(cc.p(0,-113 - self.sdkRow*60))

	else 
		local name = model.AccountModel:getPlatformEmail()
		self.accInfoLabel:setString(tostring(name));
		-- sdk登陆
		-- self.fbBtn:setVisible(false)
		-- self.gpBtn:setVisible(false)
		self.unRegisterBtn:setVisible(true)
		
		self.logoutBtn:setPosition(cc.p(130 , -60))

	end

	if showSDK == true then
		
		self.sdkNode:setVisible(true);
		self.noSDKlayout:setVisible(false)
		self.sdkLayout:setVisible(true);

		self.titleNode:setPosition(0 , 100);
		self.titleName:setString(LANG.UI_TITLE_27)
		self.accountNode:setPosition(0 , 50);

	else
		self.sdkNode:setVisible(false);
		self.sdkLayout:setVisible(false);
		self.noSDKlayout:setVisible(true)

		self.titleNode:setPosition(0 , 70);
		self.titleName:setString(LANG.UI_TITLE_24)

		self.accountNode:setPosition(0 , 22);


	end

end

function AccountBindNode:onEnter(logoutCallback)
	self:updateInfo()
	self.bindPlatformType = nil;
	self.logoutCallback = logoutCallback
	self.unRegisterNode:setVisible(false)
	self.accountNode:setVisible(true);
	self:setVisible(true);
end

function AccountBindNode:onClickBack( sender,event )
	self:onLeave()
end

function AccountBindNode:onLeave()
	self:setVisible(false);
end
return AccountBindNode;
