

local ActivityPanel = class('ActivityPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local menuTag = {model.ActivityModel.ActivityMenuIndex.SIGN}

function ActivityPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ActivityPanel');

    self.useCCreator = false;
    self.isPopup = true;
	--self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
    --self.showFooter = true;

end

function ActivityPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);
    self.root:setPosition(StageSize.width/2,StageSize.height/2);

    self.reqChangeIndex = -1;
    self.activityMenuIndex = -1;

    --self:initPanel();
    self:initSignInfo()
    --self:initLevelGiftInfo();
    --self:initFpGiftInfo()

    self:registEvent();
end


function ActivityPanel:initPanel(  )
    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);
    
	local bgSprite1 = cc.Sprite:create('image/bg/Bg_3.png');
	bgSprite1:addTo(bgNode);

	local bgSprite2 = cc.Sprite:create('image/activity/main/bg_1.png');
	bgSprite2:setPosition(cc.p(0,33));
	bgSprite2:addTo(bgNode);

    local btnNode = cc.Node:create()
    btnNode:addTo(self.root)
    btnNode:setPosition(cc.p(0,208))

    self.activityMenuBtn = {}
    local len = #menuTag;
    for i=1,len do

        self.activityMenuBtn[menuTag[i]] = {};

        local btnImg = 'image/common/common_button_52_1_'
        if i ~= 1 and i ~= len then
            btnImg = 'image/common/common_button_52_2_'
        end
        local btn = ccui.Button:create( btnImg..'1.png' , btnImg..'2.png');
        btn:addTo(btnNode);
        btn:addClickEventListener(handler(self,self.onMenuItemCall));
        btn:setTag(menuTag[i])
        btn:setPosition(cc.p(-224 + 155*(i-1), 50))
        self.activityMenuBtn[menuTag[i]].btn = btn;

        local btnName = cc.Label:createWithTTF(LANG.UI_ACTIVITY_TYPE[i] ,  fonts.FONT_SIYUAN , 20);
        btnName:addTo(btn);
        btnName:setTextColor(cc.c3b(60 , 60 , 60));
        btnName:enableOutline(cc.c4b(255 , 255 , 255 , 255),2);
        btnName:setPosition(cc.p(btn:getContentSize().width/2,btn:getContentSize().height/2))
        self.activityMenuBtn[menuTag[i]].btnName = btnName;
    end
    -- self.activityMenuBtn[model.ActivityModel.ActivityMenuIndex.SIGN] = btnNode:getChildByTag(1)
    -- self.activityMenuBtn[model.ActivityModel.ActivityMenuIndex.LEVEL_GIFT] = btnNode:getChildByTag(2)
    -- self.activityMenuBtn[model.ActivityModel.ActivityMenuIndex.FP_GIFT] = btnNode:getChildByTag(3)



end

function ActivityPanel:initSignInfo(  )
    self.signNode = cc.Node:create();
    self.signNode:addTo(self.root)
    self.signNode:setVisible(false);

    -- list
    --local bgList = cc.Sprite:create('image/activity/sign/sign_4.png');
	--bgList:setPosition(cc.p(0,-14));
    --bgList:addTo(self.signNode);

    local bgList = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bgList:addTo(self.signNode);
	bgList:setPosition(0 , -14);
	bgList:setCapInsets(cc.rect(11,11,34,28));
	bgList:setContentSize(cc.size(586 , 880));

    local bgTop = cc.Sprite:create('image/activity/sign/sign_3.png');
	bgTop:setPosition(cc.p(10,361));
    bgTop:addTo(self.signNode);

    self.signDay = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 25);
    self.signDay:addTo(self.signNode);
    self.signDay:setAnchorPoint( 0 , 0.5);
    self.signDay:setPosition(-260 , 382);
    self.signDay:setTextColor(cc.c3b(130 , 40 , 40));
    self.signDay:enableOutline(cc.c3b(255 , 220 , 230),1);

    self.signListView = ccui.ScrollView:create();
	self.signListView:setTouchEnabled(true)
        :setBounceEnabled(true)
        :setDirection(ccui.ScrollViewDir.vertical)
        :setContentSize(cc.size(586 , 672))
        :setAnchorPoint(cc.p(0.5,0.5))
        :setScrollBarEnabled(false)
        :addTo(self.signNode)
        :setPosition(cc.p(0,-105))

    -- 补签
    --[[
    local repairedBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
    repairedBg:addTo(self.signNode)
    repairedBg:setCapInsets(cc.rect(20,0,100,42));
	repairedBg:setContentSize(cc.size(267 , 42));
    repairedBg:setPosition(cc.p(158,-487))

    local repairedImg = cc.Sprite:create('image/commonImg/arrow_bg.png');
    repairedImg:addTo(self.signNode);
    repairedImg:setAnchorPoint(1 , 0.5)
    repairedImg:setPosition(11 , -487)

	self.signRepaired =  cc.Label:createWithTTF('5/5' , fonts.FONT_SIYUAN , 23);
	self.signRepaired:addTo(self.signNode);
	self.signRepaired:setPosition(253 , -487);
	self.signRepaired:setAnchorPoint(1 , 0.5);

	local signLable1 =  cc.Label:createWithTTF(LANG.UI_ACTIVITY_23 , fonts.FONT_SIYUAN , 23);
	signLable1:addTo(self.signNode);
	signLable1:setAnchorPoint(1 , 0.5);
    signLable1:setPosition(215 , -487);
    signLable1:setTextColor(cc.c4b(165 , 200 , 255 , 255));

    local width = signLable1:getContentSize().width;
    repairedImg:setPositionX(signLable1:getPositionX()-width-10);
    ]]
end

function ActivityPanel:initLevelGiftInfo(  )
    self.levelGiftNode = cc.Node:create();
    self.levelGiftNode:addTo(self.root)
    self.levelGiftNode:setVisible(false);

    local listBg = cc.Sprite:create('image/activity/main/levelGift_list_bg.png')
    listBg:addTo(self.levelGiftNode)
    listBg:setPosition(cc.p(1,-140))

    local btnLabel = cc.Label:createWithTTF(LANG.UI_ACTIVITY_24, fonts.FONT_SIYUAN, 20)
    btnLabel:enableOutline(cc.c4b(40 , 130 , 231 , 255),2);
    self.levelGiftAllGetBtn = ccui.Button:create('image/common/common_button_50_1.png');
    self.levelGiftAllGetBtn:setPosition(232,-415);
    self.levelGiftAllGetBtn:setTitleLabel(btnLabel);
    self.levelGiftAllGetBtn:addClickEventListener(handler(self, self.onActivityAllGetCall));
    self.levelGiftAllGetBtn:addTo(self.levelGiftNode);


    --[[
    local initData = {
        width = 615,
        height = 545,
        cellWidth = 615 ,
        cellHeight = 150,
        cellReloadFunc = handler(self,self.reloadLevelGiftCellItem),

    }
    self.levelGiftListView = template.TableViewTemplate:create()
    self.levelGiftListView:initWithSizeAndItem(initData) ;
    self.levelGiftListView:getView():setPosition(cc.p(-308,-380));
    self.levelGiftNode:addChild(self.levelGiftListView:getView())
    ]]

    self.levelGiftListView = template.FrameLoadScrollViewTemplate:create()
    self.levelGiftListView:setPosition(-308,-380);
    self.levelGiftListView:Init(cc.size(615 , 545) , cc.size(615 , 150) , 1 , 5);
    self.levelGiftListView:addLoadCellHandler(handler(self,self.reloadLevelGiftCellItem));
    self.levelGiftListView:addTo(self.levelGiftNode);
end

function ActivityPanel:initFpGiftInfo(  )
    self.FpGiftNode = self.levelGiftNode;
end

function ActivityPanel:registEvent(  )
    EventManager:RegisterEvent(EventType.NetworkRetActivityData,handler(self,self.retActivityData));
    EventManager:RegisterEvent(EventType.NetworkRetSignGetReward , handler(self,self.retSignGetReward));
	EventManager:RegisterEvent(EventType.NetworkRetLevelGiftGetReward , handler(self,self.retLevelGiftGetReward));
	EventManager:RegisterEvent(EventType.NetworkRetFpGiftGetReward , handler(self,self.retFpGiftGetReward));
end

function ActivityPanel:retActivityData()

    if self.reqChangeIndex == nil or self.reqChangeIndex == -1 then
        return ;
    end

    if not model.ActivityModel:hasInitIndex(self.reqChangeIndex) then
        print('======= 请求服务器数据 错误 !!! ')
        return
    end 

    self:onShow(self.reqChangeIndex);

end

function ActivityPanel:showLevelGiftInfo(  )
    if self.activityMenuIndex ~= model.ActivityModel.ActivityMenuIndex.LEVEL_GIFT 
        and self.activityMenuIndex ~= model.ActivityModel.ActivityMenuIndex.FP_GIFT then

        self.levelGiftNode:setVisible(false);
        return 
    end
    self.levelGiftNode:setVisible(true);

    local activityGiftData = model.ActivityModel:getActivityDataByIndex(self.activityMenuIndex)
	if  activityGiftData == nil then
		return;
    end

    local redDotState = model.ActivityModel:getRedDotStateActivityByIndex( self.activityMenuIndex )
    self.levelGiftAllGetBtn:setVisible(redDotState);

    local giftData = activityGiftData.data;

    table.sort(giftData , function(first , second)
        local firstState = model.ActivityModel:getActivityStateByTypeAndId(self.activityMenuIndex,first.id);
        local secondState = model.ActivityModel:getActivityStateByTypeAndId(self.activityMenuIndex,second.id);

        if firstState ~= secondState then
            if firstState == 1 and secondState ~= 1 then
                return true;
            elseif firstState == 0 and secondState == 2 then
                return true;
            end
        else
            return first.id < second.id;
        end
        return false;
    end);

    self.activityList = {}
    --self.levelGiftData = activityGiftData.data;
    self.levelGiftListView:reloadData(giftData);

end

function ActivityPanel:reloadLevelGiftCellItem(cell , idx , data)
    if self.activityMenuIndex ~= model.ActivityModel.ActivityMenuIndex.LEVEL_GIFT 
        and self.activityMenuIndex ~= model.ActivityModel.ActivityMenuIndex.FP_GIFT then
        return nil
    end
    data.activityType = self.activityMenuIndex

    local cellNode = template.ActivityLevelGiftItemTemplate:create();
    cellNode:addTo(cell)
    cellNode:setData(data);
    
    self.activityList[data.id] = cellNode;

    return cell ;

end

function ActivityPanel:showFpGiftInfo(  )
    self:showLevelGiftInfo()
end

function ActivityPanel:showSignInfo(  )
    if self.activityMenuIndex ~= model.ActivityModel.ActivityMenuIndex.SIGN then
        self.signNode:setVisible(false);
        return 
    end
    self.signNode:setVisible(true);


    local activitySignData = model.ActivityModel:getActivityDataByIndex(self.activityMenuIndex)
	if  activitySignData == nil then
		return;
    end

    local signMonth = activitySignData.signMonth
    local signDay = activitySignData.signDay
    local signData = activitySignData.signData
    local signStates = activitySignData.signState
    -- local signToday = activitySignData.signToday;


    if signData == nil then
        return 
    end
    self.signListView:removeAllChildren();
    self.singItemList = {}
    local len = #signData;
    local column = 5
    local maxHeight = (math.floor( (len-1)/column ) +1) *110
    if maxHeight < 672 then
        maxHeight = 672;
    end
	self.signListView:setInnerContainerSize(cc.size(586,maxHeight))

    for i=1,len do
        local col = (i- 1) % column  -- 0,1,2,
        local row = math.floor((i - 1) / column); --0,1.。
        
        local itemData ={}
        itemData.reward = signData[i];
        itemData.state = signStates[i]
        -- itemData.today = signToday;
        itemData.day = i;
        local signItem = template.ActivitySignTemplate:create(); 
        signItem:InitData(itemData);
        signItem:addTo(self.signListView);
        signItem:setPosition(71+col*111,maxHeight - row * 110 - 55);

        self.singItemList[i] = signItem;
    end

    local repairedNum = model.ActivityModel:getSignRepaired() or 0
    local repairedDay = model.ActivityModel:getSignRepairedDay();
    --self.signRepaired:setString(tostring(repairedNum));
    if repairedNum > 0 and self.singItemList[repairedDay] then
        self.singItemList[repairedDay]:setRepairedState(true)
    end

    self.signDay:setString(string.format(LANG.UI_EVENT_29 , signMonth , signDay));
end

function ActivityPanel:retFpGiftGetReward(msg)
    
    if msg.id == nil then
        return 
    end

    if type(msg.id) == 'table' then
        local nextItemId = nil;
        local _k,itemId = next(msg.id,_k);
        while itemId do
            _k,nextItemId = next(msg.id,_k);
            if self.activityList[itemId]  then
                if nextItemId then
                    self.activityList[itemId]:setStateAction();
                else
                    self.activityList[itemId]:setStateAction(function() 
                        UIManager:push('RewardPanel',msg);
                        self:showLevelGiftInfo();
                    end);
                end
            end
            itemId = nextItemId;
        end
    else
        if self.activityList[msg.id]  then
            self.activityList[msg.id]:setStateAction(function() 
                UIManager:push('RewardPanel',msg)
                self:showLevelGiftInfo();        
            end);
        end
    end

	self:updateRedDotState(model.ActivityModel.ActivityMenuIndex.FP_GIFT);
end

function ActivityPanel:retLevelGiftGetReward(msg)

    if msg.id == nil then
        return 
    end

    if type(msg.id) == 'table' then
        local nextItemId = nil;
        local _k,itemId = next(msg.id,_k);
        while itemId do
            _k,nextItemId = next(msg.id,_k);
            if self.activityList[itemId]  then
                if nextItemId then
                    self.activityList[itemId]:setStateAction();
                else
                    self.activityList[itemId]:setStateAction(function()
                        UIManager:push('RewardPanel',msg);
                        self:showLevelGiftInfo();
                    end);
                end
            end
            itemId = nextItemId;
        end
    else
        if self.activityList[msg.id]  then
            self.activityList[msg.id]:setStateAction(function() 
                UIManager:push('RewardPanel',msg)
                self:showLevelGiftInfo();    
            end);
        end
    end
	self:updateRedDotState(model.ActivityModel.ActivityMenuIndex.LEVEL_GIFT);
end

function ActivityPanel:retSignGetReward(msg)
    self.singItemList[msg.pos]:setState(msg.state);
    UIManager:push('RewardPanel',msg);
    if msg.isRepaired == 1 then
        local repairedNum = model.ActivityModel:getSignRepaired() or 0
        local repairedDay = model.ActivityModel:getSignRepairedDay();
        --self.signRepaired:setString(tostring(repairedNum));
        if repairedNum > 0 and self.singItemList[repairedDay] then
            self.singItemList[repairedDay]:setRepairedState(true)
        end

    end

    --self:updateRedDotState(model.ActivityModel.ActivityMenuIndex.SIGN);
end

function ActivityPanel:changeMenuIndex( index )
    
    if index == nil or self.activityMenuIndex == index  then
        return 
    end

    if not model.ActivityModel:hasInitIndex(index) then
        self.reqChangeIndex = index;
        model.ActivityModel:reqActivityByIndex(index);
        return 
    end

    self.activityMenuIndex = index;

    --self:changeMenuState()

    self:showSignInfo(self.activityMenuIndex == model.ActivityModel.ActivityMenuIndex.SIGN)
    --self:showLevelGiftInfo(self.activityMenuIndex == model.ActivityModel.ActivityMenuIndex.LEVEL_GIFT)
    --self:showFpGiftInfo(self.activityMenuIndex == model.ActivityModel.ActivityMenuIndex.FP_GIFT)
    --self:updateRedDotState(self.activityMenuIndex);

end

function ActivityPanel:changeMenuState(  )
    
    for _k , btn in pairs(self.activityMenuBtn) do
		btn.btn:setTouchEnabled(_k ~= self.activityMenuIndex);
        btn.btn:setBrightStyle(_k == self.activityMenuIndex and ccui.BrightStyle.highlight or ccui.BrightStyle.normal)
        if _k == self.activityMenuIndex then
            btn.btnName:setTextColor(cc.c3b(255 , 255 , 255));
            btn.btnName:enableOutline(cc.c4b(19 , 93 , 188 , 255) , 2);
        else
            btn.btnName:setTextColor(cc.c3b(50 , 50 , 50));
            btn.btnName:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
        end
	end

end

function ActivityPanel:onMenuItemCall( sender,event )
    local index = sender:getTag()

    if tools.ConfigStateTools:checkLockByType(Enum:getTable('ConfigStateType').ACTIVITY , index)then
        Prompt:Show(LANG.COMMON_CLOSE);
        return;
    end

    if self:checkClickLock(index) then
        return 
    end

    self:changeMenuIndex(index)

end

-- 等级礼包，战力礼包 一键领取
function ActivityPanel:onActivityAllGetCall( sender,event )
    model.ActivityModel:reqActivityItemReward(self.activityMenuIndex,0);
end

function ActivityPanel:checkClickLock( index,notShowPrompt )
	local locked,lockLv = model.ActivityModel:getLockStateActivityByIndex(index);

	if locked and  notShowPrompt ~= true then
		Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
	end

	return locked
end

function ActivityPanel:updateLock( index )
    local locked,lockLv = model.ActivityModel:getLockStateActivityByIndex(index);
    -- tools.LevelLockTools:setLockToNode(self.activityMenuBtn[index],locked,lockLv,3,cc.p(0,0))
    self:setLockToNode(self.activityMenuBtn[index].btn,locked,lockLv,cc.p(78,26))
end

function ActivityPanel:setLockToNode( btn ,locked,lockLv,lockPos)

    if btn == nil then
        return ;
    end
    local lockNode = btn:getChildByTag(Conf.TAG_LOCK_DEFAULT);

    if  locked == false then
        if lockNode ~= nil then
            lockNode:setVisible(false);
        end
    else
        if lockPos == nil then
            lockPos = cc.p(0,0)
        end

        if lockNode == nil then
            lockNode = cc.Node:create();
            lockNode:addTo(btn);
            lockNode:setTag(Conf.TAG_LOCK_DEFAULT)
            lockNode:setPosition(lockPos)

            local bg = cc.Sprite:create('image/lock/item_bg1.png')
            bg:setContentSize(cc.size(156,52))
            bg:addTo(lockNode);
        
            -- local titleBg = cc.Sprite:create('image/lock/item_title_bg1.png')
            -- titleBg:addTo(node)
            -- titleBg:setPosition(cc.p(0,-21))
        
            local lock = cc.Sprite:create('image/lock/item_lock1.png')
            lock:addTo(lockNode);
            lock:setPosition(cc.p(-54,0))
        
            local lv =  cc.Label:createWithTTF(string.format(LANG.UI_ACTIVITY_25,lockLv ) ,  fonts.FONT_JP , 15);
            lv:addTo(lockNode);
            lv:setPosition(16 , 0);
            lv:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 1);


        end
        lockNode:setVisible(true)
    end



end

function ActivityPanel:updateRedDotState( index )
    local state = model.ActivityModel:getRedDotStateActivityByIndex( index )
    tools.RedDotTools:setRedDotToNode(self.activityMenuBtn[index].btn,state,nil,cc.p(140,47));
end


function ActivityPanel:onEnter( index )
    self:addSwallowCallback(handler(self, self.onClickBack));
    self.activityMenuIndex = -1;
    model.ActivityModel:resetInit()

    index = model.ActivityModel.ActivityMenuIndex.SIGN;
    local jumpToIndex = nil;
    for _k , idx in ipairs(menuTag) do
        if not tools.ConfigStateTools:checkLockByType(Enum:getTable('ConfigStateType').ACTIVITY , idx) and not self:checkClickLock(idx,true) then
            if idx == index then
                jumpToIndex = idx;
                break;
            end

            if not jumpToIndex then
                jumpToIndex = idx;
            end
        end
    end

    if not jumpToIndex then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('ActivityPanel');
        return;
    else
        index = jumpToIndex;
    end

    self:onShow(index)

    --self:updateLock(model.ActivityModel.ActivityMenuIndex.SIGN)
    --self:updateLock(model.ActivityModel.ActivityMenuIndex.FP_GIFT)
    --self:updateLock(model.ActivityModel.ActivityMenuIndex.LEVEL_GIFT)

    --self:updateRedDotState(model.ActivityModel.ActivityMenuIndex.SIGN)
    --self:updateRedDotState(model.ActivityModel.ActivityMenuIndex.MONTH_CARD)
    --self:updateRedDotState(model.ActivityModel.ActivityMenuIndex.FP_GIFT)
    --self:updateRedDotState(model.ActivityModel.ActivityMenuIndex.LEVEL_GIFT)

end

function ActivityPanel:onShow(index)
    self.reqChangeIndex = -1;
    
    if self:checkClickLock(index,true) then
        self.root:setVisible(true)
        return 
    end
    self:changeMenuIndex(index)
    self.root:setVisible(true)

end

function ActivityPanel:onLeave( ... )
    --tools.RedDotTools:pushMainPanelRedDot(2);  -- 活动红点刷新
    --tools.RedDotTools:pushMainPanelRedDot(11); -- 首冲红点刷新
    tools.RedDotTools:pushMainPanelRedDot(18);--邮件

    self.root:setVisible(false);
end
function ActivityPanel:onClickBack()
    UIManager:pop('ActivityPanel');
    -- tools.RedDotTools:pushHomeBaseRedDot(2,8)

end

return ActivityPanel
