
local ActivityRechargePanel = class('ActivityRechargePanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local iamgePath = 'image/recharge/';


function ActivityRechargePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ActivityRechargePanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function ActivityRechargePanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self.activityMenuIndex = 1;

    self:initPanel()
    self:registEvent();
end

function ActivityRechargePanel:initPanel(  )

    local bg = cc.Sprite:create(iamgePath..'recharge_bg_1.png')
        :addTo(self.root)
        :setPosition(0,42)

    local bg = cc.Sprite:create(iamgePath..'recharge_bg_2.png')
        :addTo(self.root)
        :setPosition(0,-220)

    local bg = cc.Sprite:create(iamgePath..'recharge_bg_6.png')
        :addTo(self.root)
        :setPosition(-9,-111)

    --底部按钮
    local label = cc.Label:createWithTTF(LANG.UI_SHOP_103,fonts.FONT_SIYUAN,20)
        :enableOutline(cc.c3b(145,40,40),2)
    self.rechargeBtn = ccui.Button:create( 'image/commonImg/btn_9_227_65.png' , 'image/commonImg/btn_9_227_65.png')
    self.rechargeBtn:addTo(self.root)
        :setPosition(cc.p(1,-395))
        :setTitleLabel(label)
        :setTag(2)
        :setVisible(false)
        :addClickEventListener(handler(self,self.onRechageClick))

    local label = cc.Label:createWithTTF(LANG.COMMON_OK,fonts.FONT_SIYUAN,20)
        :enableOutline(cc.c3b(55,85,155),2)
    self.okBtn = ccui.Button:create( 'image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png')
    self.okBtn:addTo(self.root)
            :setPosition(cc.p(1,-395))
            :setTitleLabel(label)
            :setTag(1)
            :setVisible(false)
            :addClickEventListener(handler(self,self.onRechageClick))
        
    -- reward
    self.rewardList = {}
    for i=1,3 do
        self.rewardList[i] = {}

        self.rewardList[i].node = cc.Node:create()
            :addTo(self.root)
            :setPosition(cc.p(-173 + 173*(i-1),-223))

        self.rewardList[i].btn = ccui.Button:create(iamgePath..'recharge_bg_4.png',iamgePath..'recharge_bg_4.png')
        self.rewardList[i].btn:addTo(self.rewardList[i].node)
        self.rewardList[i].btn:setTag(i)
        self.rewardList[i].btn:addClickEventListener(handler(self,self.getReward))


        local title = cc.Label:createWithTTF(string.format( LANG.UI_RECHARGE_4,i ) ,  fonts.FONT_SIYUAN , 20)
            :addTo(self.rewardList[i].node)
            :setPosition(cc.p(0,43))

        self.rewardList[i].reward1 = template.ItemTemplate:create();
        self.rewardList[i].reward1:addTo(self.rewardList[i].node)
        self.rewardList[i].reward1:setPosition(cc.p(-39,-14))
        self.rewardList[i].reward1:setScale(0.7)

        self.rewardList[i].geted1 = cc.Sprite:create('image/activity/login7/login7_bg_1.png')
            :addTo(self.rewardList[i].node)
            :setPosition(cc.p(-39,-14))
            :setScale(0.7)

        self.rewardList[i].reward2 = template.ItemTemplate:create();
        self.rewardList[i].reward2:addTo(self.rewardList[i].node)
        self.rewardList[i].reward2:setPosition(cc.p(39,-14))
        self.rewardList[i].reward2:setScale(0.7)

        self.rewardList[i].geted2 = cc.Sprite:create('image/activity/login7/login7_bg_1.png')
            :addTo(self.rewardList[i].node)
            :setPosition(cc.p(39,-14))
            :setScale(0.7)

       
        self.rewardList[i].canGet = cc.Sprite:create(iamgePath..'recharge_bg_5.png')
            :addTo(self.rewardList[i].node)
            :setVisible(false)

        self.rewardList[i].get = cc.Sprite:create('image/commonImg/geted.png')
            :addTo(self.rewardList[i].node)
            :setPosition(0,-14)
            :setVisible(false)
    end
end

function ActivityRechargePanel:registEvent(  )
    EventManager:RegisterEvent(EventType.NetworkRetRechargeInfo,handler(self,self.retRechargeInfo));
    EventManager:RegisterEvent(EventType.NetworkRetRechargeGetReward,handler(self,self.retRechargeReward));

end
function ActivityRechargePanel:retRechargeInfo()

    if not model.RechargeModel:hasInitOk() then
        print('======= 请求服务器数据 错误 !!! ')
        return
    end 

    if not self.root:isVisible() then
        return;
    end

    self:showRewardInfo()
end

function ActivityRechargePanel:retRechargeReward( msg )
    self:showRewardInfo()
    UIManager:push('RewardPanel',msg)
end

function ActivityRechargePanel:showRewardInfo( ... )
    local rechargeData = model.RechargeModel:getRechargeInfoByNo(self.activityMenuIndex)
    if rechargeData == nil then
        print('======error ======== not found recharge info by index ',self.activityMenuIndex);
        return 
    end
    -- dump(rechargeData,'rechargeData == ');
    local spineRoleId = nil;
    local rewardState = {};
    for _k , v in pairs(rechargeData.reward_stage or {}) do
        rewardState[v] = _k;
    end
    local rewardDatas = rechargeData.data or {};
    local btnState = rechargeData.get_state or 0;

    local rechargeDays = 0
    if rechargeData.complete_day > 0 then
        local curTime = TimeManager:getCurTime();
        local offTime = curTime - rechargeData.complete_day;
        rechargeDays = math.floor( tonumber(offTime) /(60*60*24) ) + 1;
    end

    local _k,itemRewards = next(rewardDatas,_k);
    while _k ~= nil and self.rewardList[_k] ~= nil do
        local rewards = itemRewards.reward_item or {}
        local reward1 = rewards[1]
        if reward1 then
            self.rewardList[_k].reward1:Init(reward1[1],reward1[2])
            if reward1[1] == ROLE_TYPE then
                spineRoleId = reward1[2];
            end
        end
       
        local reward2 = rewards[2]
        if reward2 then
            self.rewardList[_k].reward2:setVisible(true);
            self.rewardList[_k].geted2:setVisible(true);
            self.rewardList[_k].reward2:Init(reward2[1],reward2[2])
        else
            self.rewardList[_k].reward2:setVisible(false);
            self.rewardList[_k].geted2:setVisible(false);
        end

        if rewardState[_k] ~= nil then
            self.rewardList[_k].geted1:setVisible(true)
            self.rewardList[_k].geted2:setVisible(true)
            self.rewardList[_k].get:setVisible(true)
        else
            self.rewardList[_k].geted1:setVisible(false)
            self.rewardList[_k].geted2:setVisible(false)
            self.rewardList[_k].get:setVisible(false)
        end

        if btnState == 1 and not rewardState[_k] and _k <= rechargeDays then
            self.rewardList[_k].canGet:setVisible(true)
        else
            self.rewardList[_k].canGet:setVisible(false)
        end

        if  (btnState == 1 and not rewardState[_k] and _k <= rechargeDays) or rewardState[_k] ~= nil then
            self.rewardList[_k].btn:loadTextures(iamgePath..'recharge_bg_3.png',iamgePath..'recharge_bg_3.png')
        else 
            self.rewardList[_k].btn:loadTextures(iamgePath..'recharge_bg_4.png',iamgePath..'recharge_bg_4.png')
        end

        _k,itemRewards = next(rewardDatas,_k);
    end
    
    if btnState > 0 then
        self.okBtn:setVisible(true);
        self.rechargeBtn:setVisible(false);
    else
        self.okBtn:setVisible(false);
        self.rechargeBtn:setVisible(true);
    end
end

function ActivityRechargePanel:onRechageClick( sender,event )
    local index = sender:getTag()
    -- print(' onRechageClick  == ',index);
    if index == 1 then -- 前往充值
        self:onClickBack();
    elseif index == 2 then -- 领取奖励
        UIManager:push('ShopPanel',Enum:getTable('CommonShopType').RECHARGE)
    end
end

function ActivityRechargePanel:getReward(sender , event)
    local tag = sender:getTag();
    model.RechargeModel:reqRechargeGetReward(self.activityMenuIndex,tag)
end

function ActivityRechargePanel:reqData(callback)
	model.RechargeModel:reqRechargeInfo(callback)
end

function ActivityRechargePanel:onEnter(  )
	self:addSwallowCallback(handler(self, self.onClickBack));

    self:reqData();

    self.root:setVisible(true)
end

function ActivityRechargePanel:onLeave( ... )
    tools.RedDotTools:pushMainPanelRedDot(11);
    self.root:setVisible(false);
end

function ActivityRechargePanel:onClickBack()
    UIManager:pop('ActivityRechargePanel');
end

-- 引导相关
function ActivityRechargePanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 59 then
		local btn = self.rechargeBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end
return ActivityRechargePanel
