local AnnouncePanel = class("AnnouncePanel" , require('app.layer.BaseLayer'))
local HelpShow = Enum:getTable('HelpShow');
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/help/'
function AnnouncePanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'AnnouncePanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function AnnouncePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels();
end

function AnnouncePanel:initPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_c9_1_2.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(18,50,123,73));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(604 , 780));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -10);

	-- local bg = ccui.Scale9Sprite:create("image/commonImg/bg_c9_2_3.png")
	-- 	:setCapInsets(CCRectMake(10,10,117,94))
	-- 	:setContentSize(cc.size(546 , 595))
	-- 	:setPosition(cc.p(0 , 25))
	-- 	:addTo(self.root)

	self.scorllview = ccui.ScrollView:create();
	self.scorllview:setTouchEnabled(true);
	self.scorllview:setBounceEnabled(true);
	self.scorllview:setDirection(ccui.ScrollViewDir.vertical);
	self.scorllview:setContentSize(cc.size(600 , 700));
	self.scorllview:setAnchorPoint(cc.p(0,0));
	self.scorllview:setScrollBarEnabled(false);
    self.scorllview:setPosition(-300 , -350);
    self.scorllview:addTo(self.root);

	local btnLabel = cc.Label:createWithTTF(LANG.UI_ANNOUNCE_TIP , fonts.FONT_SIYUAN , 20);
	btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	btnLabel:setAnchorPoint(0, 0.5)
	btnLabel:addTo(self.root)
	btnLabel:setPosition(-250, -375)

	self.okBtn = ccui.Button:create('image/commonImg/ric_27.png' , 'image/commonImg/ric_27.png');
	self.okBtn:addTo(self.root);
	self.okBtn:setPosition(-280 , -375);
	self.okBtn:addClickEventListener(function() self.okIcon:setVisible(not self.okIcon:isVisible()) end);
	-- self.okBtn:setTitleLabel(btnLabel);

	self.okIcon = cc.Sprite:create('image/commonImg/ric_green.png')
	self.okIcon:addTo(self.root)
	self.okIcon:setPosition(-280, -375)
	self.okIcon:setVisible(false)
end

function AnnouncePanel:onEnter()
	self.showList = {}
	self:addSwallowCallback(handler(self , self.onClickBack));

	local no = model.UserModel:getUserData().noticeId;
	local data = nil
	for k, v in pairs(ResTable:getTable('notice').contain) do
		if v.no == no then
			no = v.no;
			data = v;
			break;
		end
	end
	if not data then
		UIManager:pop('AnnouncePanel');
		return;
	end
	if data.follow_list then
		self.showList = clone(data.follow_list)
	end

	self:updateInfo(no);

	self.root:setVisible(true);
end

function AnnouncePanel:updateInfo( no )
	local data = nil
	for k, v in pairs(ResTable:getTable('notice').contain) do
		if v.no == no then
			no = v.no;
			data = v;
			break;
		end
	end
	if not data then
		UIManager:pop('AnnouncePanel');
		return;
	end

	local lg = model.UserDefaultModel:getLanguageSet();
	local iconName = 'image/announcement/announcement_'..data.notice_icon..'_'..lg..'.png';
	if not cc.FileUtils:getInstance():isFileExist(iconName) then
		UIManager:pop('AnnouncePanel');
		return;
	end

	self.scorllview:removeAllChildren();

	local spr = cc.Sprite:create(iconName)
	spr:setAnchorPoint(0,0)
	spr:addTo(self.scorllview)
	self.scorllview:setInnerContainerSize( spr:getContentSize() );
end

function AnnouncePanel:updateZOrder(curPanelName)
	local panelZOder = UIManager:getPanelLocalZOrder(curPanelName) or 1;
	panelZOder = panelZOder * PANEL_ZORDER + 30;
	self.root:setLocalZOrder(panelZOder);
end

function AnnouncePanel:onClickBack()
	if self.showList and #self.showList > 0 then
		local no = table.remove(self.showList, 1)
		self:updateInfo(no)
		return;
	end
	UIManager:pop('AnnouncePanel');
end

function AnnouncePanel:onLeave()
	if self.okIcon:isVisible() then
		Network.NetworkManager:Send(Network.NetworkCmdType.req_announcement_push, {});
	end
	self.root:setVisible(false);
	if model.AutoFightModel:IsFull() then
		EventManager:FireEvent(EventType.FightIncomeFull);
	end
end

return AnnouncePanel;
