local ArenaMultFightPanel = class("ArenaMultFightPanel",require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local imgPath = 'image/trial/';
local TeamType = Enum:getTable('TeamType')

function ArenaMultFightPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ArenaMultFightPanel');
	self.useCCreator = false;
    self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
    self.showFooter = true;
end

function ArenaMultFightPanel:Init( root,scene )
    -- body
    self.root = root;
    self.scene = scene;
    self.root:setVisible(false);
    self.curTeamType = TeamType.ARENA_1;
    -- self.root:setPosition(StageSize.width/2,StageSize.height/2);

    self:initPannel();
    self:initTeam()
    self:initMonster()
    self:initMultTeams();
    self.curMoveIdx = 0;

end

function ArenaMultFightPanel:initPannel(  )

	local blackBg = ccui.Layout:create();
	blackBg:setBackGroundImage('image/task/blackbg.png');
	blackBg:setBackGroundImageScale9Enabled(true);
	blackBg:setTouchEnabled(true);
	blackBg:setContentSize(StageSize);
	blackBg:setLocalZOrder(-2);
	blackBg:setAnchorPoint(cc.p(0.5,0.5));
	blackBg:setPosition(0, 0);
    blackBg:addTo(self.root);
    
    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);

    local bg1 = cc.Sprite:create('image/round/BG_chapter_0.png');
    bg1:addTo(bgNode);
    --bg1:setPosition(cc.p(0,72));

    local bg4 = cc.Sprite:create('image/fight/scene/scene61.png');
    bg4:addTo(bgNode);
    bg4:setPosition(cc.p(0,-400));

    
     --编队 挑战
    local label = cc.Label:createWithTTF(LANG.UI_TRIAL_3 ,  fonts.FONT_SIYUAN , 20)
        :enableOutline(cc.c4b(130 , 15 , 0 , 255),2)
    self.fightBtn = ccui.Button:create('image/commonImg/btn_9_219_55.png' , 'image/commonImg/btn_9_219_55.png')
        :addTo(self.root)
        :setPosition(0, -StageSize.height/2+150)
        :setTitleLabel(label)
    self.fightBtn:addClickEventListener(handler(self , self.onFight))

    self.teamNode = cc.Node:create();
    self.teamNode:addTo(self.root);
    self.teamNode:setPosition(0,-50);

    self.monsterNode = cc.Node:create();
    self.monsterNode:addTo(self.root);
    self.monsterNode:setPosition(0,-50);

end


function ArenaMultFightPanel:initTeam(  )
    self.teamList = {}
    for i=1,TEAM_MAX_MEMBER do
        local roleNode = cc.Node:create();
        roleNode:addTo(self.teamNode)
        roleNode:setVisible(false)

        local bloodVolume = require('app.template.BloodVolume'):create(roleNode);
        bloodVolume:setPosition(0, 55);
        bloodVolume:setLevel(99)

        self.teamList[i] = {}
        self.teamList[i].roleNode = roleNode;
        self.teamList[i].bloodVolume = bloodVolume;
        self.teamList[i].armature = nil;
        self.teamList[i].pid = -1;

    end
end

function ArenaMultFightPanel:initMonster(  )
    self.monsterList = {}
    
    for i=1,6 do
        local roleNode = cc.Node:create();
        roleNode:addTo(self.monsterNode)
        roleNode:setVisible(false);

        local bloodVolume = require('app.template.BloodVolume'):create(roleNode);
        bloodVolume:setPosition(0, 55);
        bloodVolume:setLevel(99)

        -- local monsterFrameAni = cc.Sprite:create();
        -- monsterFrameAni:addTo(roleNode);
        -- monsterFrameAni:setLocalZOrder(1)
        -- monsterFrameAni:setScale(1.4)
        -- monsterFrameAni:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
        self.monsterList[i] = {}
        self.monsterList[i].roleNode = roleNode;
        self.monsterList[i].bloodVolume = bloodVolume;
        self.monsterList[i].armature = nil;
        self.monsterList[i].monster_id = -1;
        self.monsterList[i].monster_lv = -1;
        -- self.monsterList[i].monsterFrameAni = monsterFrameAni;
    end
end

function ArenaMultFightPanel:showTeamNode(  )
    self.curTeamType = TeamType.ARENA_1;
    for k,v in pairs(self.selfTeamNodeList) do
        if v.curPos == self.curSelIdx then
            self.curTeamType = v.teamId;
        end
    end

    self.team  = model.TeamModel:getTeamById(self.curTeamType);
    local curFormation = model.TeamModel:getCurrentTeamFormation(self.curTeamType)
	local teamPos = model.TeamModel:getTeamFormationPosById(curFormation);
    self.haveTeam = false;
    for i=TEAM_MAX_MEMBER, 1, -1 do
        local formationIndex = teamPos[i];
        local pos = FightManager:getRolePosByFormationIndex(formationIndex);
        self.teamList[i].roleNode:setPosition(pos.x, pos.y);
        self.teamList[i].roleNode:setLocalZOrder(100 + pos.z);

        local pid = self.team[i];
        local card = model.CardModel:GetCard(pid);
        if pid ~= -1 then
            self.haveTeam = true;
            if true then --self.teamList[i].pid ~= pid
                if self.teamList[i].armature~= nil then
                    self.teamList[i].armature:removeFromParent()
					DragonBonesManager:RemoveDisplay(self.teamList[i].armature_id)
                    self.teamList[i].armature = nil;
                    self.teamList[i].pid = -1;
                end
    
                local no = card.no;
                local roleData = ResTable:getRowData('role', no);
                local rolePreData = ResTable:getRowData('role_pre', roleData.role_id);
                local resId = model.CardModel:getCardResIdByPid(pid);
                local roleResData = ResTable:getRowData('role_resource', resId);
                
                local modelPath = roleResData.model;
                if modelPath then 
                    local armature, id = DragonBonesManager:GetArmature(modelPath);
                    armature:getAnimation():play('idle');
                    armature:addTo(self.teamList[i].roleNode);
                    armature:setScale(0.4);
                    armature:setLocalZOrder(-1);
                    self.teamList[i].armature = armature;
                    self.teamList[i].armature_id = id;
                    self.teamList[i].pid = pid;
    
                    self.teamList[i].bloodVolume:setPercent(math.floor(100));
                    self.teamList[i].bloodVolume:setDefType(rolePreData.def_type);
                    self.teamList[i].bloodVolume:setLevel(card.level);
                    
                    self.teamList[i].roleNode:setVisible(true);
                else
                    print("====================error==========showTeamNode==no armature============pid == "..tostring(pid))
                end
            else
                self.teamList[i].bloodVolume:setPercent(math.floor(100));
            end

        else
            if self.teamList[i].armature~= nil then
                self.teamList[i].armature:removeFromParent()
				DragonBonesManager:RemoveDisplay(self.teamList[i].armature_id)
                self.teamList[i].armature = nil;
                self.teamList[i].pid = -1;
            end
            self.teamList[i].roleNode:setVisible(false);

        end
	end

end

function ArenaMultFightPanel:initMultTeams()
    -- body
    local topNode = cc.Node:create()
    topNode:addTo(self.root)
    topNode:setPosition(0, StageSize.height/2-100-NOTCH_HEIGHT)

    local bg = cc.Scale9Sprite:create('image/commonImg/list_mask_2_4_0__23_34.png')
    bg:setContentSize(cc.size(640, 600))
    bg:setPosition(0, -20)
    bg:setAnchorPoint(0.5, 1)
    bg:setFlipY(true)
    bg:addTo(topNode)

    local topBg = cc.Sprite:create('image/arena/arenaMult/am_ft_top.png')
    topBg:addTo(topNode)
    self.rank1Label = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18);
    self.rank1Label:addTo(topNode);
    self.rank1Label:setPosition(-250 , 0);
    self.rank1Label:enableOutline(cc.c3b(0,74,226),1);
    self.rank2Label = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18);
    self.rank2Label:addTo(topNode);
    self.rank2Label:setPosition(250 , 0);
    self.rank2Label:enableOutline(cc.c3b(226,0,96),1);

    self.name1Label = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18);
    self.name1Label:addTo(topNode);
    self.name1Label:setPosition(-100 , 0);
    -- self.name1Label:enableOutline(cc.c3b(0,74,226),1);
    self.name2Label = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18);
    self.name2Label:addTo(topNode);
    self.name2Label:setPosition(100 , 0);
    -- self.name2Label:enableOutline(cc.c3b(226,0,96),1);

    local line1Spr = cc.Sprite:create('image/arena/arenaMult/am_light_2.png')
    line1Spr:setPosition(0, -200)
    line1Spr:addTo(topNode)
    local line2Spr = cc.Sprite:create('image/arena/arenaMult/am_light_2.png')
    line2Spr:setPosition(0, -370)
    line2Spr:addTo(topNode)

    local rightNode = cc.Node:create()
    rightNode:addTo(topNode)
    rightNode:setPosition(150, -120)

    self.enemyTeamList = {}
    self.enemyPFLabelList = {}
    self.selBtns = {}
    local teamIds = {11,12,13}
    for i=1,3 do
        local teamItems = {}
        local teamTicon = cc.Sprite:create('image/arena/arenaMult/am_team'..i..'.png')
        teamTicon:addTo(rightNode)
        teamTicon:setPosition(0, 0-(i-1)*170+65)

        local teamNode = cc.Node:create()
        teamNode:addTo(rightNode)
        teamNode:setPosition(0, 0-(i-1)*170)

        local teamBg = cc.Sprite:create('image/arena/arenaMult/am_right_tmbg.png');
        teamBg:addTo(teamNode);

        local pfLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18);
        pfLabel:addTo(teamNode);
        pfLabel:setPosition(0 , 25);
        self.enemyPFLabelList[i] = pfLabel;

        for j=1, TEAM_MAX_MEMBER do
            local icon = require('app.template.ItemTemplate'):create();
            icon:addTo(teamNode);
            icon:setScale(0.55)
            -- icon:Init(ROLE_TYPE, card.no, card.star_lv, card.level, team[i])
            -- icon:updateAltarLevelColor(card.oriLv)
            icon:setPosition((j-1)*62-92, -30)
            table.insert(teamItems, icon)
        end

        local buffSelectBtn = ccui.Button:create('image/commonImg/common_item_select.png', 'image/commonImg/common_item_select.png', 'image/commonImg/common_item_select.png');
        buffSelectBtn:addTo(teamNode);
        buffSelectBtn:setScale9Enabled(true)
        buffSelectBtn:setContentSize(cc.size(620, 170))
        buffSelectBtn:addClickEventListener(handler(self , self.switchShowTeam));
        buffSelectBtn:setPosition(-150,0);
        buffSelectBtn:setTag(i);
        buffSelectBtn:setOpacity(0)

        self.enemyTeamList[i] = teamItems;
        self.selBtns[i] = buffSelectBtn;

    end

    local leftNode = cc.Node:create()
    leftNode:addTo(topNode)
    leftNode:setPosition(-150, -120)

    self.selfTeamList = {}
    self.selfTeamNodeList = {}
    local teamIds = {11,12,13}
    for i=1,3 do
        local teamItems = {}
        local teamTicon = cc.Sprite:create('image/arena/arenaMult/am_team'..i..'.png')
        teamTicon:addTo(leftNode)
        teamTicon:setPosition(0, 0-(i-1)*170+65)

        local teamNode = cc.Node:create()
        teamNode:addTo(leftNode)
        teamNode:setPosition(0, 0-(i-1)*170)
        teamNode:setCascadeOpacityEnabled(true)

        local teamBg = cc.Sprite:create('image/arena/arenaMult/am_left_tmbg.png');
        teamBg:addTo(teamNode);

        local pfLabel = cc.Label:createWithTTF(''..i ,  fonts.FONT_SIYUAN , 18);
        pfLabel:addTo(teamNode);
        pfLabel:setPosition(0 , 25);

        for j=1, TEAM_MAX_MEMBER do
            local icon = require('app.template.ItemTemplate'):create();
            icon:addTo(teamNode);
            icon:setScale(0.55)
            -- icon:Init(ROLE_TYPE, card.no, card.star_lv, card.level, team[i])
            -- icon:updateAltarLevelColor(card.oriLv)
            icon:setPosition((j-1)*62-92, -30)
            table.insert(teamItems, icon)
        end

        local teamBtn = ccui.Button:create('image/commonImg/team_icon.png')
        :addTo(teamNode)
        :setPosition(cc.p(110,25))
        :setTag(teamIds[i])
        :setScale(0.7)
        :addClickEventListener(handler(self , self.teamBtnClick));  


        -- local m1Spr = cc.Sprite:create('image/team/btn_auto.png');
        -- m1Spr:addTo(teamNode);
        -- m1Spr:setPosition(cc.p(-110,25))
        -- m1Spr:setVisible(false)
        -- local m2Spr = cc.Sprite:create('image/team/btn_ok.png');
        -- m2Spr:addTo(teamNode);
        -- m2Spr:setPosition(cc.p(-110,25))
        -- m2Spr:setVisible(false)
        local moveBtn = ccui.Button:create('image/guild/not_join/not_join_bg_6.png')
        :addTo(teamNode)
        :setPosition(cc.p(-110,25))
        :setTag(i)
        :setScale(0.7)
        :addClickEventListener(handler(self , self.moveTeamNode));

        self.selfTeamList[i] = teamItems;
        --m1Spr=m1Spr, m2Spr=m2Spr,

        self.selfTeamNodeList[i] = {teamNode=teamNode, moveBtn=moveBtn, curPos=i, teamId=teamIds[i], pfLabel=pfLabel}

    end


end

function ArenaMultFightPanel:updateEnemyTeamsIcon()
    -- body
    for i=1,3 do
        local teamData = self.enemyData.team[i+10];
        local powerNum = self.enemyData.powerList[i+10];
        local tmpTeam = teamData.arena_team;
        local monsterList = teamData.monsterList;
        local totalFp = '0';
        local fp = 0;
        if tmpTeam then
            for j=1,TEAM_MAX_MEMBER do
                if tmpTeam[j] and tmpTeam[j].no>0 then
                    if self.enemyData.isRobot == 1 then
                        self.enemyTeamList[i][j]:Init(MONSTER_ROLE_TYPE, tmpTeam[j].no, tmpTeam[j].star_lv, tmpTeam[j].level)
                    else
                        self.enemyTeamList[i][j]:Init(ROLE_TYPE, tmpTeam[j].no, tmpTeam[j].star_lv, tmpTeam[j].level, nil, tmpTeam[j].quality)
                    end
                else
                    self.enemyTeamList[i][j]:clearItem()
                end
            end

            if self.enemyData.isRobot == 1 then
                self.enemyPFLabelList[i]:setString(LANG.UI_GUILD_4..':'..powerNum)
            else
                self.enemyPFLabelList[i]:setString(LANG.UI_GUILD_4..':'..powerNum)
            end
        end

    end

end

function ArenaMultFightPanel:updateSelfTeamsIcon()
    local name = model.UserModel:getUserName();
    self.name1Label:setString(tostring(name));
    if self.arenaData.rank <= 0 then
        self.rank1Label:setString(LANG.UI_ARENA_MU_11)
    else
        self.rank1Label:setString(string.format(LANG.UI_ARENA_MU_12, tostring(self.arenaData.rank)))
    end

    if self.enemyData.isRobot == 1 then
        local robotData = ResTable:getRowData('robot' , self.enemyData.uid);
        self.name2Label:setString(robotData.name)
    else
        self.name2Label:setString(self.enemyData.name)
    end
    self.rank2Label:setString(string.format(LANG.UI_ARENA_MU_12, tostring(self.enemyData.rank)))

    -- body
    for i=1,3 do
        
        local tmpTeam = model.TeamModel:getTeamById(i+10);
        if tmpTeam then
            local fpValue = model.TeamModel:getCurrentTeamFp(i+10)
            for j=1,TEAM_MAX_MEMBER do
                if tmpTeam[j] then
                    local data = model.CardModel:GetCard(tmpTeam[j]);
                    if data then
                        self.selfTeamList[i][j]:Init(ROLE_TYPE , data.no , data.star_lv, data.level, tmpTeam[j]);
                    else
                        self.selfTeamList[i][j]:clearItem()
                    end
                else
                    self.selfTeamList[i][j]:clearItem()
                end
            end
            self.selfTeamNodeList[i].pfLabel:setString(LANG.UI_GUILD_4..':'..fpValue)
        end

    end

end

function ArenaMultFightPanel:switchShowTeam(sender , event)
    local idx = sender:getTag()
    for k,v in pairs(self.selBtns) do
        if k == idx then
            v:setOpacity(255)
        else
            v:setOpacity(0)
        end
    end
    self.curSelIdx = idx;

    self:showTeamNode();
    self:showMonsterNode();
end

function ArenaMultFightPanel:moveTeamNode(sender , event)
    local idx = sender:getTag()
    if self.curMoveIdx == 0 then --选取
        for k,v in pairs(self.selfTeamNodeList) do
            if k == idx then
                -- v.m1Spr:setVisible(true)
                -- v.m2Spr:setVisible(false)
            else
                -- v.m1Spr:setVisible(false)
                -- v.m2Spr:setVisible(true)
                v.teamNode:runAction( cc.RepeatForever:create(cc.Sequence:create(cc.FadeTo:create(0.5, 80),cc.FadeTo:create(0.5, 180))) )
            end
        end

        self.curMoveIdx = idx;
    else --交换

        for k,v in pairs(self.selfTeamNodeList) do
            -- if k == idx then
            --     v.m1Spr:setVisible(false)
            --     v.m2Spr:setVisible(false)
            -- else
            --     v.m1Spr:setVisible(false)
            --     v.m2Spr:setVisible(false)
            -- end
            v.teamNode:stopAllActions();
            v.teamNode:setOpacity(255);
        end
        if self.curMoveIdx ~= idx then
            local pt1x, pt1y = self.selfTeamNodeList[idx].teamNode:getPosition();
            local ptPos = self.selfTeamNodeList[idx].curPos;

            local curPt1x, curPt1y = self.selfTeamNodeList[self.curMoveIdx].teamNode:getPosition();
            self.selfTeamNodeList[idx].curPos = self.selfTeamNodeList[self.curMoveIdx].curPos;
            self.selfTeamNodeList[self.curMoveIdx].curPos = ptPos;

            self.selfTeamNodeList[idx].teamNode:runAction(cc.MoveTo:create(0.3,cc.p(curPt1x,curPt1y)))

            self.selfTeamNodeList[self.curMoveIdx].teamNode:runAction(cc.MoveTo:create(0.3,cc.p(pt1x,pt1y)))

        end
        self.curMoveIdx = 0;

    end

    self:showTeamNode();
    
end

function ArenaMultFightPanel:showMonsterNode(  )

    local tmpTeam = self.enemyData.team[self.curSelIdx+10].arena_team;
    local formationId = self.enemyData.team[self.curSelIdx+10].formation
    local formation = ResTable:getValue('formation', formationId, 'position')
    if not formation then
        formation = {1,2,3,4}
    end
    for i=1, 4 do 
		local data = tmpTeam[i];
        if data and data.no>0 then
            local role_pos = FightManager:getEnemyPosByFormaitionIndex(formation[i] or i);
            if self.monsterList[i].monster_id ~= data.no then
                if self.monsterList[i].armature~= nil then
                    self.monsterList[i].armature:removeFromParent()
					DragonBonesManager:RemoveDisplay(self.monsterList[i].armature_id)
                    self.monsterList[i].armature = nil;
                    self.monsterList[i].monster_id = -1;
                    self.monsterList[i].monster_lv = -1;
                end

                local armature, id = nil, 0;
                if self.enemyData.isRobot == 1 then
                    local monsterData = ResTable:getRowData('monster', data.no);
                    armature, id = DragonBonesManager:GetArmature(monsterData.model);
                    self.monsterList[i].bloodVolume:setDefType(monsterData.def_type);
                else
                    local roleData = ResTable:getRowData('role', data.no);
                    local rolePreData = ResTable:getRowData('role_pre', roleData.role_id);
                    local roleResData = ResTable:getRowData('role_resource', roleData.resource_id);
                    armature, id = DragonBonesManager:GetArmature(roleResData.model);
                    self.monsterList[i].bloodVolume:setDefType(rolePreData.def_type);
                end

                if armature then 
                    armature:getAnimation():play('idle');
                    armature:setScale(0.4);
                    armature:addTo(self.monsterList[i].roleNode);
                    armature:getArmature():setFlipX(true);
                    armature:setLocalZOrder(-1);
                    self.monsterList[i].armature = armature;
                    self.monsterList[i].armature_id = id;
                    self.monsterList[i].monster_id = data.no;
                    self.monsterList[i].monster_lv = data.level;

                    self.monsterList[i].bloodVolume:setPercent(100);
                    self.monsterList[i].bloodVolume:setLevel(data.level);
                    self.monsterList[i].roleNode:setPosition(cc.p(role_pos.x,role_pos.y));
                    self.monsterList[i].roleNode:setVisible(true);
                    self.monsterList[i].roleNode:setLocalZOrder(role_pos.z)
                end
            else
                if self.monsterList[i].monster_lv ~= data.level then
                    self.monsterList[i].bloodVolume:setLevel(data.level );
                    self.monsterList[i].monster_lv = data.level;
                end
                self.monsterList[i].roleNode:setPosition(cc.p(role_pos.x,role_pos.y));
                self.monsterList[i].roleNode:setLocalZOrder(role_pos.z)
            end

        else
            if self.monsterList[i].armature~= nil then
                self.monsterList[i].armature:removeFromParent()
				DragonBonesManager:RemoveDisplay(self.monsterList[i].armature_id)
                self.monsterList[i].armature = nil;
                self.monsterList[i].monster_id = -1;
                self.monsterList[i].monster_lv = -1;
            end
            self.monsterList[i].roleNode:setVisible(false);

		end
	end
end

function ArenaMultFightPanel:showTrialList(  )
    self.fightBtn:setTouchEnabled(true);

    self:showTeamNode();
    self:showMonsterNode();
end

function ArenaMultFightPanel:onFight( )
    AudioManager:playEffect(Conf.confirmButton);

    local fightOrders = {}
    for k,v in pairs(self.selfTeamNodeList) do
        fightOrders[v.curPos] = v.teamId;
    end
    model.ArenaModel:setMultArenaFight( self.enemyData.uid )
    model.ArenaModel:setMultArenaFightOrders(fightOrders)

end


function ArenaMultFightPanel:onClickBack( ... )
	UIManager:pop('ArenaMultFightPanel');
end

function ArenaMultFightPanel:onEnter(uid)
    self.trialType = 1;
    self.curSelIdx = 1;
    self.arenaData = model.ArenaModel:getMultArenaInfo();
    self.enemyData = nil;
    for _k , rankData in pairs(self.arenaData.rankList) do
        if rankData and rankData.uid==uid then
            self.enemyData = rankData;
        end
    end
    if not self.enemyData then
        UIManager:pop('ArenaMultFightPanel');
        return;
    end

    for k,v in pairs(self.selBtns) do
        if k == self.curSelIdx then
            v:setOpacity(255)
        else
            v:setOpacity(0)
        end
    end

    self.curTeamType = TeamType.ARENA_1;

    self:onShow();
    EventManager:FireEvent(EventType.UIFooterUpdateSelect,5);

end

function ArenaMultFightPanel:onShow()
    self:showTrialList()
    self:updateEnemyTeamsIcon();
    self:updateSelfTeamsIcon();
    self.root:setVisible(true)
end

function ArenaMultFightPanel:onLeave( ... )
    self.root:setVisible(false);
    self:clearData();
end

function ArenaMultFightPanel:clearData(  )
end

function ArenaMultFightPanel:teamBtnClick(sender , event)
    local idx = sender:getTag()
    UIManager:push('TeamPanel',idx)
end

return ArenaMultFightPanel
