local ArenaMultFightResult = class("ArenaMultFightResult", require('app.layer.BaseLayer'))

local imagePath = 'image/fight/result/';
local fonts = Enum:getTable("SystemFont")

 -- local titleMsg = { [1]='伤害输出', [2]='治疗恢复', [3]='承受伤害'}
 local titleMsg = { [1]=LANG.UI_FIGHT_STATISTICS_1, [2]=LANG.UI_FIGHT_STATISTICS_2, [3]=LANG.UI_FIGHT_STATISTICS_3}
 local titlePng = { [1]='statistics_item_1.png', [2]='statistics_item_2.png', [3]='statistics_item_3.png'}
 local textColor = { [1]=cc.c3b(255,225,215), [2]=cc.c3b(235,255,225), [3]=cc.c3b(215,250,255)}
 local rolePos = {cc.p(0,88), cc.p(0,26), cc.p(0,-34),cc.p(0,-95)}

function ArenaMultFightResult:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'ArenaMultFightResult');

	self.scene = scene;
	self.useCCreator = false;
	self.haveSwallowLayer = true;
	self.isPopup = true;
end

function ArenaMultFightResult:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels();
end

function ArenaMultFightResult:initPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,960));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 7);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_FIGHT_STATISTICS_4 , 606 , 63 , 'STATISTICS');
	titleNode:addTo(self.root);
    titleNode:setPosition(0 , 448);

    self:initLeftListNode()
    self:initRightListNode()
end

function ArenaMultFightResult:initLeftListNode()

	local topNode = cc.Node:create()
	topNode:addTo(self.root)
	topNode:setPosition(0, 170);

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_c9_2_3.png');
	listBg:addTo(topNode);
	listBg:setPosition(0 , 40);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(568 , 430));

    self.leftWinBg = cc.Sprite:create(imagePath..'st_win.png')
	:addTo(topNode)
	:setPosition(22,210)
	
    self.leftLoseBg = cc.Sprite:create(imagePath..'st_lose.png')
	:addTo(topNode)
	:setPosition(22,210)

	local hdBg = cc.Sprite:create('image/commonImg/icon_role_2.png')
	:addTo(topNode)
	:setPosition(-240,190)
	:setScale(0.7)

    self.leftHeadNode = cc.Sprite:create();
    self.leftHeadNode:addTo(topNode)
	self.leftHeadNode:setPosition(-240,190)
	self.leftHeadNode:setScale(0.6)
	
    self.leftName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	:setPosition(-197, 190)
	:addTo(topNode)
	:setAnchorPoint(0, 0.5)
	:enableOutline(cc.c3b(120, 85, 10), 2)

	self.leftBodyNode = cc.Node:create()
    :addTo(topNode)

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.leftBodyNode);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(540 , 300));

	self.leftRoleList = {};
    for i=1,3 do
    	local cellNode = cc.Node:create()
    	cellNode:setPosition(0, 90-(i-1)*90)
    	cellNode:addTo(self.leftBodyNode)
    	local bg = cc.Scale9Sprite:create('image/commonImg/bg_4_563_126.png')
			:addTo(cellNode)
			:setContentSize(cc.size(500, 80))

		local nameSpr = cc.Sprite:create('image/arena/arenaMult/am_team'..i..'.png')
			:addTo(cellNode)
			:setPosition(110, 12)

		local pfIcon = cc.Sprite:create('image/commonImg/fight_icon.png')
			:addTo(cellNode)
			:setPosition(80, -12)

		local pflabel = cc.Label:createWithTTF('18888', fonts.FONT_SIYUAN, 22)
			:setPosition(100, -12)
			:addTo(cellNode)
			:setAnchorPoint(0, 0.5)
			:enableOutline(cc.c3b(20, 20, 20), 2)

		local rtIcon = cc.Sprite:create('image/arena/arenaMult/am_win_icon.png')
			:setPosition(200, 0)
			:addTo(cellNode)

		local teamRoleItems = {}
		for j=1, TEAM_MAX_MEMBER do
			local roleNode = template.ItemTemplate:create(2);
			roleNode:addTo(cellNode);
			roleNode:setPosition(-210+(j-1)*75, 0);
			roleNode:setScale(0.6);
			table.insert(teamRoleItems, roleNode)
		end

		self.leftRoleList[i] = {pflabel=pflabel, rtIcon=rtIcon, teamRoleItems=teamRoleItems}

    end

    local winNode = cc.Node:create()
    winNode:addTo(topNode)
    winNode:setPosition(0, -160)
    self.winNode = winNode;
    local winBg = cc.Scale9Sprite:create('image/commonImg/btn_2_103_36.png')
    winBg:setContentSize(cc.size(568, 36));
    winBg:addTo(winNode)
    local line = cc.Scale9Sprite:create('image/commonImg/line4.png')
    line:addTo(winNode)
    line:setRotation(90)
    local pflabel = cc.Label:createWithTTF(LANG.UI_ARENA_MU_14, fonts.FONT_SIYUAN, 16)
		:setPosition(-270, 0)
		:addTo(winNode)
		:setAnchorPoint(0, 0.5)
	self.winL1 = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
		:setPosition(-120, 0)
		:addTo(winNode)
		:setAnchorPoint(1, 0.5)
	local arrow = cc.Sprite:create('image/commonImg/arrow_6.png')
		:addTo(winNode)
		:setPosition(-100,0)
	self.winL2 = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
		:setPosition(-80, 0)
		:addTo(winNode)
		:setAnchorPoint(0, 0.5)

	local shouyiIcon = cc.Sprite:create('image/icon/I10031.png')
		:addTo(winNode)
		:setPosition(20,0)
		:setScale(0.3)
	local shouyilabel = cc.Label:createWithTTF(LANG.UI_ARENA_MU_17, fonts.FONT_SIYUAN, 16)
		:setPosition(40, 0)
		:addTo(winNode)
		:setAnchorPoint(0, 0.5)
	self.shouyiL1 = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
		:setPosition(200, 0)
		:addTo(winNode)
		:setAnchorPoint(1, 0.5)
	local arrow = cc.Sprite:create('image/commonImg/arrow_6.png')
		:addTo(winNode)
		:setPosition(210,0)
	self.shouyiL2 = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
		:setPosition(220, 0)
		:addTo(winNode)
		:setAnchorPoint(0, 0.5)

	local loseNode = cc.Node:create()
    loseNode:addTo(topNode)
    loseNode:setPosition(0, -150)
    self.loseNode = loseNode;
    local loseBg = cc.Scale9Sprite:create('image/commonImg/btn_2_103_36.png')
    loseBg:setContentSize(cc.size(568, 36));
    loseBg:addTo(loseNode)
    local loselabel = cc.Label:createWithTTF(LANG.UI_ARENA_MU_21, fonts.FONT_SIYUAN, 16)
		:setPosition(-270, 0)
		:addTo(loseNode)
		:setAnchorPoint(0, 0.5)
	
end

function ArenaMultFightResult:initRightListNode()

	local botNode = cc.Node:create()
	botNode:addTo(self.root)
	botNode:setPosition(0, -280);

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_c9_2_3.png');
	listBg:addTo(botNode);
	listBg:setPosition(0 , 40);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(568 , 430));

    self.rightWinBg = cc.Sprite:create(imagePath..'st_win.png')
	:addTo(botNode)
	:setPosition(22,210)
    self.rightLoseBg = cc.Sprite:create(imagePath..'st_lose.png')
	:addTo(botNode)
	:setPosition(22,210)

	local hdBg = cc.Sprite:create('image/commonImg/icon_role_2.png')
	:addTo(botNode)
	:setPosition(-240,190)
	:setScale(0.7)

    self.rightHeadNode = cc.Sprite:create();
    self.rightHeadNode:addTo(botNode)
	self.rightHeadNode:setPosition(-240,190)
	self.rightHeadNode:setScale(0.6)
	
    self.rightName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	:setPosition(-197, 190)
	:addTo(botNode)
	:setAnchorPoint(0, 0.5)
	:enableOutline(cc.c3b(120, 85, 10), 2)

	self.rightBodyNode = cc.Node:create()
    :addTo(botNode)

    local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.rightBodyNode);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(540 , 300));

    self.rightRoleList = {};
    for i=1,3 do
    	local cellNode = cc.Node:create()
    	cellNode:setPosition(0, 90-(i-1)*90)
    	cellNode:addTo(self.rightBodyNode)
    	local bg = cc.Scale9Sprite:create('image/commonImg/bg_4_563_126.png')
			:addTo(cellNode)
			:setContentSize(cc.size(500, 80))

		local nameSpr = cc.Sprite:create('image/arena/arenaMult/am_team'..i..'.png')
			:addTo(cellNode)
			:setPosition(110, 12)

		local pfIcon = cc.Sprite:create('image/commonImg/fight_icon.png')
			:addTo(cellNode)
			:setPosition(80, -12)

		local pflabel = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 22)
			:setPosition(100, -12)
			:addTo(cellNode)
			:setAnchorPoint(0, 0.5)
			:enableOutline(cc.c3b(20, 20, 20), 2)

		local rtIcon = cc.Sprite:create('image/arena/arenaMult/am_win_icon.png')
			:setPosition(200, 0)
			:addTo(cellNode)

		local teamRoleItems = {}
		for j=1, TEAM_MAX_MEMBER do
			local roleNode = template.ItemTemplate:create(2);
			roleNode:addTo(cellNode);
			roleNode:setPosition(-210+(j-1)*75, 0);
			roleNode:setScale(0.6);
			table.insert(teamRoleItems, roleNode)
		end

		self.rightRoleList[i] = {pflabel=pflabel, rtIcon=rtIcon, teamRoleItems=teamRoleItems}

    end

    local winNode = cc.Node:create()
    winNode:addTo(botNode)
    winNode:setPosition(0, -160)
    self.win2Node = winNode;
    local winBg = cc.Scale9Sprite:create('image/commonImg/btn_7_103_36.png')
    winBg:setContentSize(cc.size(568, 36));
    winBg:addTo(winNode)
    local pflabel = cc.Label:createWithTTF(LANG.UI_ARENA_MU_15, fonts.FONT_SIYUAN, 16)
		:setPosition(-270, 0)
		:addTo(winNode)
		:setAnchorPoint(0, 0.5)
	self.win2L1 = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
		:setPosition(-120, 0)
		:addTo(winNode)
		:setAnchorPoint(1, 0.5)
	local arrow = cc.Sprite:create('image/commonImg/arrow_6.png')
		:addTo(winNode)
		:setPosition(-100,0)
	self.win2L2 = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
		:setPosition(-80, 0)
		:addTo(winNode)
		:setAnchorPoint(0, 0.5)

	local loseNode = cc.Node:create()
    loseNode:addTo(botNode)
    loseNode:setPosition(0, -150)
    self.lose2Node = loseNode;
    local loseBg = cc.Scale9Sprite:create('image/commonImg/btn_7_103_36.png')
    loseBg:setContentSize(cc.size(568, 36));
    loseBg:addTo(loseNode)
    local loselabel = cc.Label:createWithTTF(LANG.UI_ARENA_MU_21, fonts.FONT_SIYUAN, 16)
		:setPosition(-270, 0)
		:addTo(loseNode)
		:setAnchorPoint(0, 0.5)

end

function ArenaMultFightResult:onEnter( )
	self.root:setVisible(true);
	self:addSwallowCallback(handler(self, self.onClickBack));
	
	self:UpdateInfo()

end

function ArenaMultFightResult:UpdateInfo()

	local arenaData = model.ArenaModel:getMultArenaInfo();
    local iconNo = model.UserModel:getHeadIcon() or 1;
    local headIconFile = GlobalFunctions:getHeadIconFile(iconNo)
    self.leftHeadNode:setTexture(headIconFile);

    local enemyData = model.ArenaModel:getMultArenaEnemyPlayer();
    if enemyData then
        local headIconFile = GlobalFunctions:getHeadIconFile(enemyData.head_icon)
    	self.rightHeadNode:setTexture(headIconFile);
    end
    if enemyData.isRobot == 1 then
        local robotData = ResTable:getRowData('robot' , enemyData.uid);
        self.rightName:setString(robotData.name)
    else
        self.rightName:setString(enemyData.name)
    end


	local resultList = model.ArenaModel:getMultArenaResult()
	local isWin = false
	if #resultList == 2 then
		if resultList[1] == 1 then
			isWin = true
		end
	elseif #resultList == 3 then
		if (resultList[1] == 1 and resultList[2] == 1) or 
			(resultList[2] == 1 and resultList[3] == 1) or 
			(resultList[1] == 1 and resultList[3] == 1) then
			isWin = true
		end
	end

	local oldInfo = model.ArenaModel:getOldMultArenaInfo()
	local oldRank, oldPro = 0, 0;
	if oldInfo then
		oldRank = oldInfo.rank;
		oldPro = oldInfo.hour_reward_level;
	end

	self.leftName:setString(model.UserModel:getUserName())
	if isWin then
		self.leftWinBg:setVisible(true)
	    self.leftLoseBg:setVisible(false)
	    self.leftName:enableOutline(cc.c3b(120, 85, 10), 2)

	    self.rightWinBg:setVisible(false)
	    self.rightLoseBg:setVisible(true)
	    self.rightName:enableOutline(cc.c3b(0, 100, 150), 2)

	    self.winNode:setVisible(true)
	    self.win2Node:setVisible(true)
	    self.loseNode:setVisible(false)
	    self.lose2Node:setVisible(false)

	    self.winL1:setString( LANG.UI_ARENA_MU_16..oldRank )
	    self.winL2:setString( LANG.UI_ARENA_MU_16..arenaData.rank )
	    if oldPro>0 then
	    	local rankRwdData = ResTable:getRowData('multiple_arena_rank_reward' , oldPro);
	    	self.shouyiL1:setString(rankRwdData.reward)
	    else
	    	self.shouyiL1:setString(0)
	    end
	    local rankRwdData = ResTable:getRowData('multiple_arena_rank_reward' , arenaData.hour_reward_level);
	    self.shouyiL2:setString(rankRwdData.reward)

	    self.win2L1:setString(LANG.UI_ARENA_MU_16..arenaData.rank)
	    self.win2L2:setString(LANG.UI_ARENA_MU_16..oldRank)

	    if oldRank == arenaData.rank then
	    	self.winNode:setVisible(false)
		    self.win2Node:setVisible(false)
		    self.loseNode:setVisible(true)
		    self.lose2Node:setVisible(true)
	    end
	    
	else
		self.leftWinBg:setVisible(false)
	    self.leftLoseBg:setVisible(true)
	    self.leftName:enableOutline(cc.c3b(0, 100, 150), 2)

	    self.rightWinBg:setVisible(true)
	    self.rightLoseBg:setVisible(false)
	    self.rightName:enableOutline(cc.c3b(120, 85, 10), 2)

	    self.winNode:setVisible(false)
	    self.win2Node:setVisible(false)
	    self.loseNode:setVisible(true)
	    self.lose2Node:setVisible(true)
	end

	for i=1,3 do
		local tid = model.ArenaModel:getMultArenaTeamIdByIdx( i )
		local tmpTeam = model.TeamModel:getTeamById(tid);
        if tmpTeam then
            for j=1,TEAM_MAX_MEMBER do
                if tmpTeam[j] then
                    local data = model.CardModel:GetCard(tmpTeam[j]);
                    if data then
                        self.leftRoleList[i].teamRoleItems[j]:Init(ROLE_TYPE , data.no , data.star_lv, data.level, tmpTeam[j]);
                    else
                        self.leftRoleList[i].teamRoleItems[j]:clearItem()
                    end
                else
                    self.leftRoleList[i].teamRoleItems[j]:clearItem()
                end
            end
        end
        local fpValue = model.TeamModel:getCurrentTeamFp(tid)
        self.leftRoleList[i].pflabel:setString(fpValue);
        if resultList[i] == 1 then
        	self.leftRoleList[i].rtIcon:setTexture('image/arena/arenaMult/am_win_icon.png')
        	self.rightRoleList[i].rtIcon:setTexture('image/arena/arenaMult/am_lose_icon.png')
        elseif resultList[i] == 0 then
        	self.leftRoleList[i].rtIcon:setTexture('image/arena/arenaMult/am_lose_icon.png')
        	self.rightRoleList[i].rtIcon:setTexture('image/arena/arenaMult/am_win_icon.png')
        else
        	self.leftRoleList[i].rtIcon:setTexture('image/arena/arenaMult/am_un_icon.png')
        	self.rightRoleList[i].rtIcon:setTexture('image/arena/arenaMult/am_un_icon.png')
        end

    end

    local enemyData = model.ArenaModel:getMultArenaEnemyPlayer();
    local enemyPowerList = model.ArenaModel:getMultArenaPower();
    for i=1,3 do
        local tmpTeam = enemyData.team[i+10].arena_team;
        if tmpTeam then
            for j=1,TEAM_MAX_MEMBER do
                if tmpTeam[j] then
                    if enemyData.isRobot == 1 then
                        self.rightRoleList[i].teamRoleItems[j]:Init(MONSTER_ROLE_TYPE, tmpTeam[j].no, tmpTeam[j].star_lv, tmpTeam[j].level)
                    else
                        self.rightRoleList[i].teamRoleItems[j]:Init(ROLE_TYPE, tmpTeam[j].no, tmpTeam[j].star_lv, tmpTeam[j].level, nil, tmpTeam[j].quality)
                    end
                else
                    self.rightRoleList[i].teamRoleItems[j]:clearItem()
                end
            end
        end
        if enemyPowerList[i] then
        	self.rightRoleList[i].pflabel:setString(enemyPowerList[i]);
        else
        	self.rightRoleList[i].pflabel:setString('-.-');
        end

    end

end

function ArenaMultFightResult:onLeave()
	self.root:setVisible(false);
end

function ArenaMultFightResult:onClickOkBtn( sender,eventType )
	self:onClickBack();
end

function ArenaMultFightResult:onClickBack()
	UIManager:pop('ArenaMultFightResult');
    EventManager:FireEvent(EventType.FightNext);
    UIManager:set('ArenaMultPanel', {'HomeBasePanel', 'ArenaMultPanel'})
end

return ArenaMultFightResult;
