local ArenaMultHistoryPanel = class("ArenaMultHistoryPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local imagePath = 'image/event/';


function ArenaMultHistoryPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ArenaMultHistoryPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function ArenaMultHistoryPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function ArenaMultHistoryPanel:initPanels()

	local bg = cc.Scale9Sprite:create('image/commonImg/common_tips_bg.png');
	bg:addTo(self.root);
	bg:setContentSize(cc.size(604 , 950));

	GlobalFunctions:createTitleNode( bg, LANG.UI_ARENA_MU_18, '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.root);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(582 , 806));

	local initData = {
        width = 580,
        height = 800,
        cellWidth = 562,
        cellHeight = 94,
        direction = 1,
        cellReloadFunc = handler(self,self.reloadCell),

    }
    self.tableView = template.TableViewTemplate:create()
    self.tableView:initWithSizeAndItem(initData);
    self.tableView:getView():setPosition(-290, -400);
    self.tableView:getView():addTo(self.root)

	EventManager:RegisterEvent('ArenaMultHistoryPanel:onShow',handler(self,self.onShow));
end

function ArenaMultHistoryPanel:onEnter()
	-- local data = model.ArenaModel:getMultArenaHistory()
	if true then
		local msg = {}
    	msg.season = model.ArenaModel:getMultArenaSeason();
    	msg.id = model.ArenaModel:getMultArenaHistoryId();
    	Network.NetworkManager:Send(Network.NetworkCmdType.req_multarena_history, msg);
	end

	self.root:setVisible(true);
	self:addSwallowCallback(handler(self , self.onClickBack));
end

function ArenaMultHistoryPanel:onShow()
	self.dataList = model.ArenaModel:getMultArenaHistory()
	self.tableView:reloadData(self.dataList);
end

function ArenaMultHistoryPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.ArenaMultHistoryItem:create(cell);
		cellNode:setTag(999);
    end
    cellNode:initData(self.dataList[index + 1]);
end

function ArenaMultHistoryPanel:onClickBack()
	UIManager:pop('ArenaMultHistoryPanel');
end

function ArenaMultHistoryPanel:onLeave()
	self.root:setVisible(false);
end

return ArenaMultHistoryPanel;
