
local ArenaMultListPanel = class('ArenaMultListPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/arena/rankList/';
local MessageBoxType = Enum:getTable('MessageBoxType')


function ArenaMultListPanel:ctor(scene, sceneName, name)
    self.super.ctor(self, scene, sceneName, 'ArenaMultListPanel');
    
    self.isPopup = true;

end

function ArenaMultListPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel()
    self:registEvent();
end

function ArenaMultListPanel:initPanel(  )

    local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,671));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -18);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_ARENA_RANK_TITLE_1 , 606 , 63 , LANG.UI_L_ARENA_RANK_TITLE_2 , true);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 349);

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.root);
	listBg:setPosition(0 , -116);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(582 , 447));

    local node = cc.Node:create();
    node:addTo(self.root);
    node:setPosition(0 , 219);

    local bg = cc.Sprite:create(imagePath..'arena_rank_list_6.png');
    bg:addTo(node);

    self.curName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22);
    self.curName:addTo(node);
    self.curName:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.curName:setAnchorPoint(0 , 0.5);
    self.curName:setPosition(78 , 59);

    self.level = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22);
    self.level:addTo(node);
    self.level:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.level:setAnchorPoint(0 , 0.5);
    self.level:setPosition(78 , 28);

    self.refreshBtn = ccui.Button:create(imagePath..'arena_rank_list_4.png' , imagePath..'arena_rank_list_4.png');
    self.refreshBtn:addTo(node);
    self.refreshBtn:addClickEventListener(handler(self , self.refrashBtnClick));
    self.refreshBtn:setPosition(258 , 51);

    local icon = ResTable:getValue('item',COLOR_DIA,'icon');
    self.refreshCostIcon = cc.Sprite:create('image/icon/I'..COLOR_DIA..'.png')
        :addTo(node)
        :setScale(0.25)
        :setPosition(258,20)
    self.refreshTimes = cc.Label:createWithTTF('x0',fonts.FONT_SIYUAN,14)
        :addTo(node)
        :setPosition(258,20)
        :enableOutline(cc.c3b(0,0,0),1)

    local fpBg = cc.Sprite:create(imagePath..'arena_rank_list_8.png');
    fpBg:addTo(node);
    fpBg:setPosition(173,-14);

    local fpImg = cc.Sprite:create(imagePath..'arena_rank_list_7.png');
    fpImg:addTo(node);
    fpImg:setPosition(94,-14);

    self.fp = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    self.fp:addTo(node);
    self.fp:setAnchorPoint(1 , 0.5);
    self.fp:setPosition(249 , -14);

    self.rankList = {};
    for i = 1 , 3 do
        self.rankList[i] = template.ArenaMultEnemyTemplate:create(self.root);
        self.rankList[i]:setPosition(0 , 29 - 145 * (i - 1));
    end

    local rankIconNode = cc.Node:create();
    rankIconNode:addTo(node);
    rankIconNode:setPosition(0 , 0);

    self.rankBg = cc.Sprite:create();
    self.rankBg:addTo(rankIconNode);

    self.addScroe = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22)
    self.addScroe:addTo(rankIconNode);
    self.addScroe:enableOutline(cc.c4b(90 , 155 , 160 , 255),2);

    local rwdNode = cc.Node:create()
    rwdNode:addTo(rankIconNode)
    rwdNode:setPosition(115, -60)
    local rwdBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
    rwdBg:addTo(rwdNode)
    rwdBg:setContentSize(cc.size(330,30))
    local rwdIcon = cc.Sprite:create('image/icon/I10031.png')
    rwdIcon:addTo(rwdNode)
    rwdIcon:setPosition(-140,0)
    rwdIcon:setScale(0.3)
    self.rwdNumLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 16)
    self.rwdNumLabel:addTo(rwdNode);
    self.rwdNumLabel:setPosition(140, 0)
    self.rwdNumLabel:setAnchorPoint(1,0.5)
    self.rwdNumLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
end

function ArenaMultListPanel:registEvent()
    EventManager:RegisterEvent('ArenaMultListPanel:updateRankList',handler(self,self.updateRankList));
end

function ArenaMultListPanel:onEnter()

    self:addSwallowCallback(handler(self , self.onClickBack))
    self.runReFresh = false;
    self:onShow();
    self:updateRankList()
    model.ArenaModel:refreshMultArenaEnemyList(true)
    self.root:setVisible(true);
end

function ArenaMultListPanel:onShow()
    self.arenaData = model.ArenaModel:getMultArenaInfo();

    local iconNo = model.UserModel:getHeadIcon() or 1;
    local name = model.UserModel:getUserName();
    local level = model.UserModel:getUserLevel();

    local fp = '0';
    for i=1,3 do
        fp = fp+model.TeamModel:getCurrentTeamFp(i+10)
    end

    self.curName:setString(tostring(name));
    self.level:setString('Lv.'..tostring(level));
    self.fp:setString(ConvertStrToDigitUnit(tostring(fp)));
   
end

function ArenaMultListPanel:updateRankList()

    self.arenaData = model.ArenaModel:getMultArenaInfo();

    self.addScroe:setString(tostring(self.arenaData.rank));
    if self.arenaData.rank>0 and self.arenaData.rank<4 then
        self.addScroe:setString( '' )
        self.rankBg:setTexture('image/arena/arenaMult/am_rk'..self.arenaData.rank..'.png')
    elseif self.arenaData.rank == 0 then
        self.addScroe:setString( '9999+' )
        self.rankBg:setTexture('image/arena/arenaMult/am_rk4.png')
    else
        self.rankBg:setTexture('image/arena/arenaMult/am_rk4.png')
    end

    local rankRwdData = ResTable:getRowData('multiple_arena_rank_reward' , self.arenaData.hour_reward_level);
    if rankRwdData then
        self.rwdNumLabel:setString(LANG.UI_ARENA_MU_9..rankRwdData.reward)
    else
        self.rwdNumLabel:setString(LANG.UI_ARENA_MU_9..'0')
    end

    local delayRefresh = 0;
    local rankList = self.arenaData.rankList
    local index = 1;
    
    local rankListData = {}
    for uid , rankData in pairs(rankList) do
        table.insert(rankListData,rankData);
    end

    if#rankListData > 1 then
        table.sort(rankListData,function(firstData,secondData) 
            return firstData.rank < secondData.rank;
        end)
    end
    for _k , rankData in pairs(rankListData) do
        self.rankList[_k]:initData(rankData);
        if self.runReFresh then
            self.rankList[_k]:runRefreshAction(delayRefresh);
            delayRefresh = delayRefresh + 2;
        end
    end
    self.runReFresh = false;

    local costNum = 0;
    local refreshTimes = self.arenaData.fight_refresh_num
    if refreshTimes == 3 then
        costNum = 10;
    elseif refreshTimes == 4 then
        costNum = 30;
    elseif refreshTimes == 5 then
        costNum = 50;
    elseif refreshTimes >= 6 then
        costNum = 100;
    end
    self.costNum = costNum;

    if costNum == 0 then
        self.refreshCostIcon:setVisible(false);
        self.refreshTimes:setPositionX(258)
        self.refreshTimes:setString(string.format(LANG.UI_ARENA_19,(3-refreshTimes)));
    else
        self.refreshCostIcon:setVisible(true);
        self.refreshTimes:setString(string.format(LANG.UI_ARENA_18,costNum));
        local width = self.refreshTimes:getContentSize().width;
        local iconWidth = self.refreshCostIcon:getBoundingBox().width;
        local posX = 258-width/2;
        self.refreshCostIcon:setPositionX(posX);
        self.refreshTimes:setPositionX(posX+iconWidth/2+width/2);
    end
end

function ArenaMultListPanel:refrashBtnClick()
    AudioManager:playEffect(Conf.buttonClick);
    if self.costNum > 0 then
        MessageBox:create(string.format(LANG.UI_NOTICE_3,tostring(self.costNum)) , MessageBoxType.CANCEL_OK,function()
            self:reqRankList();
            self.runReFresh = true;
        end);
    else
        self:reqRankList();
        self.runReFresh = true;
    end
end

function ArenaMultListPanel:reqRankList()
    model.ArenaModel:refreshMultArenaEnemyList(false);
end

function ArenaMultListPanel:onLeave()
    self.root:setVisible(false);
end
function ArenaMultListPanel:onClickBack()
    UIManager:pop('ArenaMultListPanel');
end

return ArenaMultListPanel