
local ArenaMultPanel = class('ArenaMultPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/arena/';
local rankOutline = {
    [1] = cc.c3b(100,100,100),
    [2] = cc.c3b(60,150,20),
    [3] = cc.c3b(20,120,170),
    [4] = cc.c3b(170,40,160),
    [5] = cc.c3b(180,85,0),
    [6] = cc.c3b(190,0,0),
    [7] = cc.c3b(0,0,0),
}
local LimitMaxNum = 6000;

function ArenaMultPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ArenaMultPanel');

	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
    self.showFooter = true;

end

function ArenaMultPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel()
    self:registEvent();
end

function ArenaMultPanel:initPanel(  )
    self.timeCnt = 0;

    local bg = cc.Sprite:create('image/bg/Bg_7.png');
    bg:addTo(self.root);

    local spine_res = 'bg_spine'
    local spine = sp.SkeletonAnimation:create('spine/jingjichang_spine/'..spine_res..".json", 'spine/jingjichang_spine/'..spine_res..".atlas", 1)
    spine:addTo(self.root)
    spine:setPosition(0, 0)
    spine:setAnimation(0, "bg_spine", true)

    local particle = cc.ParticleSystemQuad:create("Effect/particle/lanxing.plist")
    particle:addTo(self.root);
    particle:setPosition(0, 0)

    local btnName = {LANG.UI_L_REWARD_1,LANG.UI_FIGHT_36,LANG.UI_ARENA_20, LANG.UI_TITLE_NOTICE}
    local btnIcon = {'main_btn_17','main_btn_18','main_btn_19', 'main_info_icon'}
    self.btnList = {};
    for i = 1 , 4 do

		local btn = ccui.Button:create('image/main/main_btn_bg.png');
		btn:setTag(i);
		btn:addTo(self.root);
		btn:addClickEventListener(handler(self, self.btnClick));
		btn:setAlphaTouchEnable(true);
		btn:setPosition(-232 , 297-90*(i-1));

		local btnBg = cc.Sprite:create('image/main/'..btnIcon[i]..'.png')
		btnBg:addTo(btn);
		btnBg:setPosition(36.5,36);

		local btnNameLabel = cc.Label:createWithTTF( btnName[i], fonts.FONT_SIYUAN, 20)
			:setPosition(36.5 , 11)
            :addTo(btn)

        self.btnList[i] = btn;
    end

    self.lastTimeNode = cc.Node:create()
    self.lastTimeNode:addTo(self.root);
    self.lastTimeNode:setPosition(0,385);

    local bg = cc.Sprite:create('image/commonImg/time_bg_1.png');
    bg:addTo(self.lastTimeNode);

    bg = cc.Sprite:create('image/commonImg/time_1.png');
    bg:addTo(self.lastTimeNode);
    bg:setPosition(-147 , 0);

    --self.lastTimeLabel = cc.Label:createWithTTF(LANG.UI_ARENA_1 ,  fonts.FONT_SIYUAN , 15)
    --self.lastTimeLabel:addTo(self.lastTimeNode);
    --self.lastTimeLabel:setPosition(-47 , 0);
    --self.lastTimeLabel:setTextColor(cc.c3b(255,255,0));

    self.lastTime = cc.Label:createWithTTF('0' ,  fonts.FONT_SIYUAN , 15)
    self.lastTime:addTo(self.lastTimeNode);
    --self.lastTime:setAnchorPoint(0 , 0.5);
    self.lastTime:setPosition(0 , 0);
    self.lastTime:setTextColor(cc.c3b(255,255,0));

    self.rankIconNode = cc.Node:create();
    self.rankIconNode:addTo(self.root);
    self.rankIconNode:setPosition(0 , 142);
    self.rankIconNode:setScale(0.8);

    local spine_res = 'jingjichang_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankChangeSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.rankChangeSpine:addTo(self.rankIconNode)
        self.rankChangeSpine:registerSpineEventHandler(function (event)
            self.rankChangeSpine:setVisible(false);
            local curRankData = model.ArenaModel:getCurArenaRankData();
            self.rankKeepSpine:setVisible(true);
            self.rankKeepSpine:clearTracks();
            self.rankKeepSpine:setAnimation(0, ('b'..curRankData.rank), true);
            self.rankStarKeepSpine:setVisible(true);
            self.rankStarKeepSpine:clearTracks();
            self.rankStarKeepSpine:setAnimation(0, ('d'..curRankData.order), true);
        end, sp.EventType.ANIMATION_COMPLETE)
	else
		print('error : 缺少spine 资源')
    end

    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankKeepSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.rankKeepSpine:addTo(self.rankIconNode)
	else
		print('error : 缺少spine 资源')
    end
    
    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankStarChangeSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.rankStarChangeSpine:addTo(self.rankIconNode)
        self.rankStarChangeSpine:registerSpineEventHandler(function (event)
            self.rankStarChangeSpine:setVisible(false);
            local curRankData = model.ArenaModel:getCurArenaRankData();
            self.rankStarKeepSpine:setVisible(true);
            self.rankStarKeepSpine:clearTracks();
            self.rankStarKeepSpine:setAnimation(0, ('d'..curRankData.order), true);
        end, sp.EventType.ANIMATION_COMPLETE)
	else
		print('error : 缺少spine 资源')
    end
    
    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankStarKeepSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.rankStarKeepSpine:addTo(self.rankIconNode)
	else
		print('error : 缺少spine 资源')
	end

    self.level = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    self.level:addTo(self.root);
    self.level:setPosition(0 , 24);

    local spine_res = 'duodui_spine'
    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
        self.boxSp = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.boxSp:addTo(self.root)
        self.boxSp:setAnimation(0, "idle2", true)
    end

    local barNode = cc.Node:create()
    barNode:addTo(self.root)
    barNode:setPosition(0, -123)

    local bg = cc.Scale9Sprite:create("image/commonImg/pgs_bg_1_223_12.png")
        :addTo(barNode)
        -- :setPosition(59,-228)
        :setCapInsets(cc.rect(10,0,203,12))
        :setContentSize(cc.size(520 , 26))

    self.levelProgress = cc.Scale9Sprite:create('image/commonImg/pgs_1_23_30.png');
    self.levelProgress:addTo(barNode);
    self.levelProgress:setAnchorPoint(0 , 0.5);
    self.levelProgress:setContentSize(cc.size(516 , 22))
    self.levelProgress:setPosition(-258 , 0);

    self.levelScore = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 14);
    self.levelScore:addTo(barNode);
    self.levelScore:enableOutline(cc.c3b(0,0,0),2);



    local abNode = cc.Node:create()
    abNode:setPosition(0,-80)
    abNode:addTo(self.root)

    local bg = cc.Sprite:create(imagePath..'arena_7.png');
    bg:addTo(abNode);
    bg:setPosition(0 , -241);

    local icon = ResTable:getValue('item' , ARENA_MULT_ITEM , 'icon');
    self.itemIcon = cc.Sprite:create("image/icon/I"..icon..".png");
    self.itemIcon:addTo(abNode);
    self.itemIcon:setScale(0.5)
    self.itemIcon:setPosition(-112 , -246);

    self.lastTimesLabel = cc.Label:createWithTTF(LANG.UI_ARENA_5 ,  fonts.FONT_SIYUAN , 20)
    self.lastTimesLabel:addTo(abNode);
    self.lastTimesLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
    self.lastTimesLabel:setPosition(-75 , -241); -- -59,-241

    self.itemNum = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20);
    self.itemNum:addTo(abNode);
    self.itemNum:setAnchorPoint(1 , 0.5);
    self.itemNum:setPosition(87 , -241);

    self.addBtn = ccui.Button:create('image/commonImg/add_btn_1.png','image/commonImg/add_btn_1.png');
    self.addBtn:addTo(abNode);
    self.addBtn:setPosition(119,-241);
    self.addBtn:addClickEventListener(function() 
        UIManager:push('ShopPanel');
    end);

    local label = cc.Label:createWithTTF(LANG.UI_ARENA_2 ,  fonts.FONT_SIYUAN , 20);
    label:enableOutline(cc.c3b(170,25,10),2);
    self.challengeBtn = ccui.Button:create('image/commonImg/btn_9_219_55.png','image/commonImg/btn_9_219_55.png');
    self.challengeBtn:addTo(self.root);
    self.challengeBtn:setPosition(0 , -400);
    self.challengeBtn:setTitleLabel(label);
    self.challengeBtn:addClickEventListener(handler(self , self.challengeBtnClick));


    local preHourNode = cc.Node:create()
    preHourNode:addTo(self.root)
    preHourNode:setPosition(200, -100)

    local perHourLabel1 = cc.Label:createWithTTF(LANG.UI_ARENA_MU_4 ,  fonts.FONT_SIYUAN , 13);
    perHourLabel1:addTo(preHourNode);
    perHourLabel1:enableOutline(cc.c4b(0 , 0 , 0 , 255),1);
    perHourLabel1:setAnchorPoint(1 , 0.5);
    perHourLabel1:setPosition(-20 , 0);
    local valIcon = cc.Sprite:create('image/icon/I10031.png');
    valIcon:addTo(preHourNode);
    valIcon:setPosition(0,0);
    valIcon:setScale(0.3)
    local perHourLabel2 = cc.Label:createWithTTF('32323242' ,  fonts.FONT_SIYUAN , 13)
    perHourLabel2:addTo(preHourNode);
    perHourLabel2:setAnchorPoint(cc.p(0,0.5));
    perHourLabel2:enableOutline(cc.c4b(0 , 0 ,60 , 255),1);
    perHourLabel2:setPosition(20 , 0);
    self.perHourLabel = perHourLabel2;


    local label = cc.Label:createWithTTF(LANG.COMMON_CLICK_GET ,  fonts.FONT_SIYUAN , 20);
    label:enableOutline(cc.c3b(50 , 85 , 150),2);
    self.rwdBtn = ccui.Button:create('image/commonImg/btn_1_139_55.png','image/commonImg/btn_1_139_55.png');
    self.rwdBtn:addTo(self.root);
    self.rwdBtn:setPosition(0 , -200);
    self.rwdBtn:setTitleLabel(label);
    self.rwdBtn:addClickEventListener(handler(self , self.rwdBtnClick));


    local rankNode = cc.Node:create()
    rankNode:addTo(self.root)
    rankNode:setPosition(200, 200)
    local rankBg = cc.Sprite:create('image/arena/arenaMult/am_rank_bg.png')
    rankBg:addTo(rankNode)

    local curName = cc.Label:createWithTTF(LANG.UI_ARENA_MU_2 ,  fonts.FONT_SIYUAN , 18);
    curName:addTo(rankNode);
    curName:setAnchorPoint(0 , 0.5);
    curName:setPosition(-100 , -120);
    self.myRankLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18)
    self.myRankLabel:addTo(rankNode);
    self.myRankLabel:setAnchorPoint(cc.p(1,0.5));
    self.myRankLabel:setPosition(100 , -120);

    self.rankList = {}
    for i=1,3 do
        local playerNode = cc.Node:create()
        playerNode:addTo(rankNode)
        playerNode:setPosition(0, 90-(i-1)*75)

        local headBg = cc.Sprite:create('image/commonImg/icon_enemy.png');
        headBg:setPosition(-35 , 0);
        headBg:addTo(playerNode);
        headBg:setScale(0.50)

        local headIcon = cc.Sprite:create();
        headIcon:addTo(playerNode);
        headIcon:setPosition(-35, 0);
        headIcon:setScale(0.45);

        local curName = cc.Label:createWithTTF(''..i ,  fonts.FONT_SIYUAN , 12);
        curName:addTo(playerNode);
        curName:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
        curName:setAnchorPoint(0 , 0.5);
        curName:setPosition(0 , 15);
        
        local valIcon = cc.Sprite:create('image/commonImg/fight_icon.png');
        valIcon:addTo(playerNode);
        valIcon:setPosition(10,-15);
        valIcon:setScale(0.75)

        local valName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 16)
        valName:addTo(playerNode);
        valName:setAnchorPoint(cc.p(0,0.5));
        valName:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
        valName:setPosition(30 , -15);

        self.rankList[i] = {headIcon=headIcon, pName=curName, pFtVal=valName}

    end

    self.ProductPreHour = 0;
    self.CurNumber = 0;
end

function ArenaMultPanel:registEvent()
    EventManager:RegisterEvent('ArenaMultPanel:onShow',handler(self,self.onShow));
    EventManager:RegisterEvent('ArenaMultPanel:updateRankInfo',handler(self,self.updateRankInfo));
    EventManager:RegisterEvent('ArenaMultPanel:updateRewardItemProgress',handler(self,self.updateRewardItemProgress));

end

function ArenaMultPanel:onEnter()
    if not model.ArenaModel:getMultArenaInfo() then
        return;
    else
        self:onShow()
        model.ArenaModel:refreshMultArenaEnemyList(true)
    end
    self.timeCnt = 0;
end

function ArenaMultPanel:updateRankInfo(bUpdataTop)
    self.arenaData = model.ArenaModel:getMultArenaInfo();
    if self.arenaData.rank <= 0 then
        self.myRankLabel:setString(LANG.UI_ARENA_MU_11)
    else
        self.myRankLabel:setString( string.format(LANG.UI_ARENA_MU_12, tostring(self.arenaData.rank)) )
    end
    if self.arenaData.hour_reward_level <= 0 then
        self.perHourLabel:setString(0)
        self.ProductPreHour = 0
    else
        local rankRwdData = ResTable:getRowData('multiple_arena_rank_reward' , self.arenaData.hour_reward_level);
        self.perHourLabel:setString(rankRwdData.reward)
        self.ProductPreHour = rankRwdData.reward
    end
    if bUpdataTop then
        self:updateRankList()
    end

    self:updateFightTimes();
end

function ArenaMultPanel:updateRewardItemProgress()
    self.arenaData = model.ArenaModel:getMultArenaInfo();
    if self.arenaData.hour_reward_level <= 0 then
        self.perHourLabel:setString(0)
        self.ProductPreHour = 0
    else
        local rankRwdData = ResTable:getRowData('multiple_arena_rank_reward' , self.arenaData.hour_reward_level);
        self.perHourLabel:setString(rankRwdData.reward)
        self.ProductPreHour = rankRwdData.reward
    end

    local endTime = TimeManager:getCurTime()
    if self.arenaData.close_time > 0 then
        endTime = math.min(self.arenaData.close_time, endTime);
    else
        endTime = 0;
    end
    local tmpTime = 0
    if endTime > self.arenaData.hour_update_time then
        tmpTime = endTime - self.arenaData.hour_update_time
    end

    local curScore = self.arenaData.hour_reward + math.floor(tmpTime/3600*self.ProductPreHour);
    curScore = curScore>LimitMaxNum and LimitMaxNum or curScore;
    curScore = curScore<0 and 0 or curScore;
    local percent = curScore/LimitMaxNum;
    percent = percent > 1 and 1 or percent;
    local width = 516*percent;
    self.levelProgress:setContentSize(cc.size(width , 22))
    self.levelScore:setString(tostring(curScore)..'/'..tostring(LimitMaxNum));
    self.CurNumber = curScore;

    if percent<0.3 then
        self.boxSp:setAnimation(0, "idle1", true)
    elseif percent>0.7 then
        self.boxSp:setAnimation(0, "idle3", true)
    else
        self.boxSp:setAnimation(0, "idle2", true)
    end
    
end

function ArenaMultPanel:updateEnterFrame(timeType)
    if timeType~=1 then
        return
    end
    if self.arenaData then
        local endTime = TimeManager:getCurTime()
        if self.arenaData.close_time > 0 then
            endTime = math.min(self.arenaData.close_time, endTime);
        else
            endTime = 0;
        end
        local tmpTime = 0
        if endTime > self.arenaData.hour_update_time then
            tmpTime = endTime - self.arenaData.hour_update_time
        end

        local curScore = self.arenaData.hour_reward + math.floor(tmpTime/3600*self.ProductPreHour);
        curScore = curScore>LimitMaxNum and LimitMaxNum or curScore;
        curScore = curScore<0 and 0 or curScore;
        local percent = curScore/LimitMaxNum;
        percent = percent > 1 and 1 or percent;
        if curScore ~= self.CurNumber then
            local width = 516*percent;
            self.levelProgress:setContentSize(cc.size(width , 22))
            self.levelScore:setString(tostring(curScore)..'/'..tostring(LimitMaxNum));
            self.CurNumber = curScore;

            if percent<0.3 then
                self.boxSp:setAnimation(0, "idle1", true)
            elseif percent>0.7 then
                self.boxSp:setAnimation(0, "idle3", true)
            else
                self.boxSp:setAnimation(0, "idle2", true)
            end
        end

        self.timeCnt = self.timeCnt + 1;
        if self.timeCnt>=5 then
            self.timeCnt = 0;
            model.ArenaModel:refreshMultArenaEnemyList(true)
        end
    end
end

function ArenaMultPanel:onShow()

    self.arenaData = model.ArenaModel:getMultArenaInfo();
    self.arenaSend = false;
    
    if self.arenaData.season == -1 then
        Prompt:Show(LANG.UI_ARENA_15);
        UIManager:pop('ArenaMultPanel');
        return
    end

    self:updateRankList()
    self:updateRankInfo();
    self:showLastTime(true);
    self:updateRewardItemProgress();

    self:updateFightTimes();

    -- self.rankChangeSpine:clearTracks();
    -- self.rankChangeSpine:setToSetupPose();
    -- self.rankChangeSpine:setVisible(false);
    -- self.rankKeepSpine:clearTracks();
    -- self.rankKeepSpine:setToSetupPose();
    -- self.rankKeepSpine:setVisible(false);
    -- self.rankStarChangeSpine:clearTracks();
    -- self.rankStarChangeSpine:setToSetupPose();
    -- self.rankStarChangeSpine:setVisible(false);
    -- self.rankStarKeepSpine:clearTracks();
    -- self.rankStarKeepSpine:setToSetupPose();
    -- self.rankStarKeepSpine:setVisible(false);
    -- local changeRankState = model.ArenaModel:getChangeRankState();
    -- if changeRankState == 1 then --升大段
    --     Prompt:Show(string.format(LANG.UI_ARENA_12 , tostring(curRankData.name)));
    --     self.rankChangeSpine:setVisible(true);
    --     self.rankChangeSpine:setAnimation(0, ('a'..curRankData.rank), false)
    -- elseif changeRankState == 2 then --升小段
    --     Prompt:Show(string.format(LANG.UI_ARENA_12 , tostring(curRankData.name)));
    --     self.rankKeepSpine:setVisible(true);
    --     self.rankKeepSpine:setAnimation(0, ('b'..curRankData.rank), true);
    --     self.rankStarChangeSpine:setVisible(true);
    --     self.rankStarChangeSpine:setAnimation(0, ('c'..(curRankData.order-1)), false);
    -- else
    --     self.rankKeepSpine:setVisible(true);
    --     self.rankKeepSpine:setAnimation(0, ('b'..curRankData.rank), true);
    --     self.rankStarKeepSpine:setVisible(true);
    --     self.rankStarKeepSpine:setAnimation(0, ('d'..curRankData.order), true);
    -- end

    TimeManager:registUpdateEvent('ArenaMultPanel',handler(self,self.updateTime),true);

    self:updateRewardRedDot();

    self.root:setVisible(true);
    EventManager:FireEvent(EventType.UIFooterUpdateSelect,5);
end

function ArenaMultPanel:updateFightTimes()
    local challengeNum = self.arenaData.challenge_num;
    if challengeNum <= 0 then
        local itemNum = model.ItemModel:getItemNum(ARENA_MULT_ITEM);
        self.lastTimesLabel:setString(LANG.UI_CARD_19);
        self.lastTimesLabel:setPositionX(-59)
        self.itemIcon:setVisible(true);
        self.addBtn:setVisible(itemNum<=0);
        self.itemNum:setString(tostring(itemNum));
    else
        self.lastTimesLabel:setString(LANG.UI_ARENA_5);
        self.lastTimesLabel:setPositionX(-73)
        self.itemIcon:setVisible(false);
        self.addBtn:setVisible(false);
        self.itemNum:setString(tostring(challengeNum));
    end
end

function ArenaMultPanel:updateRankList()
    for k,v in pairs(self.arenaData.top_rank) do
        if self.rankList[ v.rank ] then
            local headIconFile = GlobalFunctions:getHeadIconFile(v.head_icon)
            self.rankList[ v.rank ].headIcon:setTexture(headIconFile)
            if v.isRobot==1 then
                local robotData = ResTable:getRowData('robot' , v.uid);
                self.rankList[ v.rank ].pName:setString(robotData.name)
            else
                self.rankList[ v.rank ].pName:setString(v.name)
            end
            self.rankList[ v.rank ].pFtVal:setString(v.top_power)
        end
    end
end

function ArenaMultPanel:updateRewardRedDot()
 --    local state = model.ArenaModel:rewardRedDotActiveState();
 --    tools.RedDotTools:setRedDotToNode(self.btnList[1],state,nil,cc.p(68 , 56)); --36,36
    
 --    local show = model.TeamModel:checkTeamFormationRedDotState();
	-- tools.RedDotTools:setRedDotToNode(self.btnList[2],show,nil,cc.p(68,56))
end

function ArenaMultPanel:updateTime()
    local lastTime , timeType = model.ArenaModel:getMultAranaLastTime();
    self:updateEnterFrame(timeType);

    local day = math.floor(lastTime / 86400);
    local lastSeconds = lastTime - day * 86400;
    local timeStr = GlobalFunctions:ChangeTime(lastSeconds);
    if day > 0 then
        timeStr = string.format(LANG.UI_ARENA_3 , day)..tostring(timeStr);
    end

    if timeType == 1 then
        self.lastTime:setString(string.format(LANG.UI_ARENA_17,tostring(timeStr)));
    elseif timeType  == 2 then
        self.lastTime:setString(string.format(LANG.UI_ARENA_16,tostring(timeStr)));
    end

    if lastTime <= 0 and not self.arenaSend then
        if timeType ~= 0 then
            Network.NetworkManager:Send(Network.NetworkCmdType.req_multarena_info, {});
            self.arenaSend = true;
        end
    end

end

function ArenaMultPanel:challengeBtnClick()
    AudioManager:playEffect(Conf.buttonClick);
    local itemNum = model.ItemModel:getItemNum(ARENA_MULT_ITEM);
    if self.arenaData.challenge_num <= 0 and itemNum < Conf.arena_cost_item_num then
        Prompt:Show(LANG.UI_ARENA_10);
        return;
    end

    for i=1,3 do
        if not model.TeamModel:checkTeamByTid(i+10) then
            Prompt:Show(LANG.UI_ARENA_MU_1);
            return;
        end
    end
    local lastTime , timeType = model.ArenaModel:getMultAranaLastTime();
    if timeType == 2 then
        Prompt:Show(LANG.UI_ARENA_MU_22);
        return;
    end
    UIManager:push('ArenaMultListPanel');
end

function ArenaMultPanel:showLastTime(visible)
    self.lastTimeNode:setVisible(visible);
end

function ArenaMultPanel:rwdBtnClick()
    if self.CurNumber<=0 then
        return;
    end
    local msg = {}
    msg.season = model.ArenaModel:getMultArenaSeason();
    Network.NetworkManager:Send(Network.NetworkCmdType.req_multarena_reward, msg);
end

function ArenaMultPanel:btnClick(sender , event)
    local tag = sender:getTag();
    AudioManager:playEffect(Conf.buttonClick);
    if tag == 1 then
        self:showLastTime(false);
        UIManager:push('ArenaMultRewardPanel');
        self:updateTime();
    elseif tag == 2 then
        UIManager:push('ArenaMultTeamPanel');
    elseif tag == 3 then
        UIManager:push('StorePanel' , Enum:getTable('CommonShopType').MULT_ARENA);
    elseif tag == 4 then
        UIManager:push('ArenaMultHistoryPanel');
    else
        
    end
end

function ArenaMultPanel:onLeave()
    TimeManager:registUpdateEvent('ArenaMultPanel',nil,true);
    self.root:setVisible(false);
end
function ArenaMultPanel:onClickBack()
    UIManager:pop('ArenaMultPanel');
end

return ArenaMultPanel