local ArenaMultRwdListPanel = class('ArenaMultRwdListPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/arena/arenaReward/';

function ArenaMultRwdListPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ArenaMultRwdListPanel');
    self.isPopup = true;
end

function ArenaMultRwdListPanel:Init(root)
    self.root = root;
    self.root:setVisible(false);
    self:initPanel()
end

function ArenaMultRwdListPanel:initPanel(  )

    local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/common_tips_bg.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(604,660));
	bg:setAnchorPoint(0.5,0.5);
    self.bg = bg;

    GlobalFunctions:createTitleNode( bg, LANG.UI_L_REWARD_1, '',  bg:getContentSize().width/2, bg:getContentSize().height -36 );
    
    local bg = cc.Scale9Sprite:create('image/commonImg/bg_3_11_4_33_20.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -10);
    bg:setCapInsets(cc.rect(11,4,33,20));
	bg:setContentSize(cc.size(580 , 520));

    local initData = {
        width = 560,
        height = 500,
        cellWidth = 560,
        cellHeight = 80,
        direction = 1,
        cellReloadFunc = handler(self,self.reloadCell),
        cellTouchFunc = handler(self,self.cellItemTouch) ,

    }
    self.selListView = template.TableViewTemplate:create()
    self.selListView:initWithSizeAndItem(initData);
    self.selListView:getView():setPosition(-280, -260);
    self.selListView:getView():addTo(self.root)


    self.curRank = 0;
    self.dataList = {}

end

function ArenaMultRwdListPanel:onEnter()
    self:addSwallowCallback(handler(self , self.onClickBack))
    self:updateData();
    self.root:setVisible(true);
end

function ArenaMultRwdListPanel:updateData()

    if self.curRank>0 then
        return;
    end
    self.curRank=1;

    local rewardDatas = ResTable:getTable('multiple_arena_reward').contain;
    for k,v in pairs(rewardDatas) do
        table.insert(self.dataList, v)
    end

    if #self.dataList > 1 then
        table.sort(self.dataList , function(first , second)
            return first.no < second.no;
        end);
    end

    self.selListView:reloadData(self.dataList);

end

function ArenaMultRwdListPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.ArenaRwdRankItem:create(cell);
		cellNode:setTag(999);
    end
    cellNode:initData(self.dataList[index + 1]);
end

function ArenaMultRwdListPanel:cellItemTouch(table,cell)
end

function ArenaMultRwdListPanel:onLeave()
    self.root:setVisible(false);
end
function ArenaMultRwdListPanel:onClickBack()
    UIManager:pop('ArenaMultRwdListPanel');
    UIManager:push('ArenaMultRewardPanel')
end

return ArenaMultRwdListPanel