
local ArenaMultTeamPanel = class('ArenaMultTeamPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/arena/rankList/';
local MessageBoxType = Enum:getTable('MessageBoxType')
local FightType = Enum:getTable('FightType');

function ArenaMultTeamPanel:ctor(scene, sceneName, name)
    self.super.ctor(self, scene, sceneName, 'ArenaMultListPanel');
    
    self.isPopup = true;

end

function ArenaMultTeamPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel()
end

function ArenaMultTeamPanel:initPanel(  )

    local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/common_tips_bg.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,670));
	bg:setAnchorPoint(0.5,0.5);
	-- bg:setPosition(0 , -18);

    GlobalFunctions:createTitleNode( bg, LANG.UI_FIGHT_36, '',  bg:getContentSize().width/2, bg:getContentSize().height -36 );

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.root);
	listBg:setPosition(0 , -10);
    -- listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(582 , 530));

    self.teamList = {}
    local teamIds = {11,12,13}

    for i=1,3 do
        local teamItems = {}
        local teamNode = cc.Node:create()
        teamNode:addTo(self.root)
        teamNode:setPosition(0, 160-(i-1)*170)

        local teamBg = cc.Sprite:create('image/arena/arenaMult/am_tm_bg.png');
        teamBg:addTo(teamNode);

        local teamTicon = cc.Sprite:create('image/arena/arenaMult/am_team'..i..'.png')
        teamTicon:addTo(teamNode)
        teamTicon:setPosition(-190, 40)

        for j=1, TEAM_MAX_MEMBER do
            local icon = require('app.template.ItemTemplate'):create();
            icon:addTo(teamNode);
            icon:setScale(0.8)
            -- icon:Init(ROLE_TYPE, card.no, card.star_lv, card.level, team[i])
            -- icon:updateAltarLevelColor(card.oriLv)
            icon:setPosition((j-1)*90-220, -20)
            table.insert(teamItems, icon)
        end

        local btnLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_36, fonts.FONT_SIYUAN, 20)
        :enableOutline(cc.c3b(55 , 85 , 155) , 2);
        local teamBtn = ccui.Button:create('image/commonImg/btn_11.png')
        :addTo(teamNode)
        :setPosition(cc.p(180,-20))
        :setTitleLabel(btnLabel)
        :setTag(teamIds[i])
        :addClickEventListener(handler(self , self.teamBtnClick));  

        self.teamList[i] = teamItems;

    end

end

function ArenaMultTeamPanel:onEnter()

    self:addSwallowCallback(handler(self , self.onClickBack))
    self:onShow();

    self.root:setVisible(true);
end

function ArenaMultTeamPanel:onShow()

    local teamIds = {11,12,13}
    for i=1,3 do
        local teamInfo = model.TeamModel:getTeamById( teamIds[i] )
        for j=1, TEAM_MAX_MEMBER do
            if teamInfo[j] and teamInfo[j] > 0 then
                local card = model.CardModel:GetCard(teamInfo[j])
                self.teamList[i][j]:Init(ROLE_TYPE, card.no, card.star_lv, card.level, teamInfo[j])
                self.teamList[i][j]:updateAltarLevelColor(card.oriLv)
            else
                self.teamList[i][j]:clearItem()
            end

        end
    end

end

function ArenaMultTeamPanel:onLeave()
    self.root:setVisible(false);
end
function ArenaMultTeamPanel:onClickBack()
    UIManager:pop('ArenaMultTeamPanel');
end

function ArenaMultTeamPanel:teamBtnClick(sender , event)
    -- body
    local idx = sender:getTag()
    UIManager:push('TeamPanel',idx)
    EventManager:FireEvent(EventType.UITeamUpdateRoundInfoOption , {fightType = FightType.MultArena});
end

return ArenaMultTeamPanel