
local ArenaPanel = class('ArenaPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/arena/';
local rankOutline = {
    [1] = cc.c3b(100,100,100),
    [2] = cc.c3b(60,150,20),
    [3] = cc.c3b(20,120,170),
    [4] = cc.c3b(170,40,160),
    [5] = cc.c3b(180,85,0),
    [6] = cc.c3b(190,0,0),
    [7] = cc.c3b(0,0,0),
}

function ArenaPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ArenaPanel');

	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
    self.showFooter = true;

end

function ArenaPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel()
    self:registEvent();
end

function ArenaPanel:initPanel(  )

    local bg = cc.Sprite:create('image/bg/Bg_7.png');
    bg:addTo(self.root);

    local spine_res = 'bg_spine'
    local spine = sp.SkeletonAnimation:create('spine/jingjichang_spine/'..spine_res..".json", 'spine/jingjichang_spine/'..spine_res..".atlas", 1)
    spine:addTo(self.root)
    spine:setPosition(0, 0)
    spine:setAnimation(0, "bg_spine", true)

    local particle = cc.ParticleSystemQuad:create("Effect/particle/lanxing.plist")
    particle:addTo(self.root);
    particle:setPosition(0, 0)

    local btnName = {LANG.UI_L_REWARD_1,LANG.UI_FIGHT_36,LANG.UI_ARENA_20}
    self.btnList = {};
    for i = 1 , 3 do

		local btn = ccui.Button:create('image/main/main_btn_bg.png');
		btn:setTag(i);
		btn:addTo(self.root);
		btn:addClickEventListener(handler(self, self.btnClick));
		btn:setAlphaTouchEnable(true);
		btn:setPosition(-232 , 297-90*(i-1));

		local btnBg = cc.Sprite:create('image/main/main_btn_'..(16+i)..'.png')
		btnBg:addTo(btn);
		btnBg:setPosition(36.5,36);

		local btnNameLabel = cc.Label:createWithTTF( btnName[i], fonts.FONT_SIYUAN, 20)
			:setPosition(36.5 , 11)
            :addTo(btn)

        self.btnList[i] = btn;
    end

    self.lastTimeNode = cc.Node:create()
    self.lastTimeNode:addTo(self.root);
    self.lastTimeNode:setPosition(0,385);

    local bg = cc.Sprite:create('image/commonImg/time_bg_1.png');
    bg:addTo(self.lastTimeNode);

    bg = cc.Sprite:create('image/commonImg/time_1.png');
    bg:addTo(self.lastTimeNode);
    bg:setPosition(-147 , 0);

    --self.lastTimeLabel = cc.Label:createWithTTF(LANG.UI_ARENA_1 ,  fonts.FONT_SIYUAN , 15)
    --self.lastTimeLabel:addTo(self.lastTimeNode);
    --self.lastTimeLabel:setPosition(-47 , 0);
    --self.lastTimeLabel:setTextColor(cc.c3b(255,255,0));

    self.lastTime = cc.Label:createWithTTF('0' ,  fonts.FONT_SIYUAN , 15)
    self.lastTime:addTo(self.lastTimeNode);
    --self.lastTime:setAnchorPoint(0 , 0.5);
    self.lastTime:setPosition(0 , 0);
    self.lastTime:setTextColor(cc.c3b(255,255,0));

    self.rankIconNode = cc.Node:create();
    self.rankIconNode:addTo(self.root);
    self.rankIconNode:setPosition(0 , 142);
    self.rankIconNode:setScale(0.8);

    local spine_res = 'jingjichang_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankChangeSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.rankChangeSpine:addTo(self.rankIconNode)
        self.rankChangeSpine:registerSpineEventHandler(function (event)
            self.rankChangeSpine:setVisible(false);
            local curRankData = model.ArenaModel:getCurArenaRankData();
            self.rankKeepSpine:setVisible(true);
            self.rankKeepSpine:clearTracks();
            self.rankKeepSpine:setAnimation(0, ('b'..curRankData.rank), true);
            self.rankStarKeepSpine:setVisible(true);
            self.rankStarKeepSpine:clearTracks();
            self.rankStarKeepSpine:setAnimation(0, ('d'..curRankData.order), true);
        end, sp.EventType.ANIMATION_COMPLETE)
	else
		print('error : 缺少spine 资源')
    end

    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankKeepSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.rankKeepSpine:addTo(self.rankIconNode)
	else
		print('error : 缺少spine 资源')
    end
    
    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankStarChangeSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.rankStarChangeSpine:addTo(self.rankIconNode)
        self.rankStarChangeSpine:registerSpineEventHandler(function (event)
            self.rankStarChangeSpine:setVisible(false);
            local curRankData = model.ArenaModel:getCurArenaRankData();
            self.rankStarKeepSpine:setVisible(true);
            self.rankStarKeepSpine:clearTracks();
            self.rankStarKeepSpine:setAnimation(0, ('d'..curRankData.order), true);
        end, sp.EventType.ANIMATION_COMPLETE)
	else
		print('error : 缺少spine 资源')
    end
    
    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankStarKeepSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.rankStarKeepSpine:addTo(self.rankIconNode)
	else
		print('error : 缺少spine 资源')
	end

    self.level = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    self.level:addTo(self.root);
    self.level:setPosition(0 , 24);

    local bg = cc.Sprite:create(imagePath..'arena_1.png');
    bg:addTo(self.root);
    bg:setPosition(0 , -123);

    local bg = cc.Sprite:create(imagePath..'arena_2.png');
    bg:addTo(self.root);
    bg:setPosition(0 , -132);

    self.levelProgress = cc.Sprite:create(imagePath..'arena_3.png');
    self.levelProgress:addTo(self.root);
    self.levelProgress:setAnchorPoint(0 , 0.5);
    self.levelProgress:setPosition(-246.5 , -132);

    local bg = cc.Sprite:create(imagePath..'arena_4.png');
    bg:addTo(self.root);
    bg:setPosition(0 , -144);

    self.levelScore = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 14);
    self.levelScore:addTo(self.root);
    self.levelScore:setPosition(0 , -144);
    self.levelScore:enableOutline(cc.c3b(0,0,0),2);

    local bg = cc.Sprite:create(imagePath..'arena_7.png');
    bg:addTo(self.root);
    bg:setPosition(0 , -241);

    local icon = ResTable:getValue('item' , ARENA_ITEM , 'icon');
    self.itemIcon = cc.Sprite:create("image/icon/I"..icon..".png");
    self.itemIcon:addTo(self.root);
    self.itemIcon:setScale(0.5)
    self.itemIcon:setPosition(-112 , -246);

    self.lastTimesLabel = cc.Label:createWithTTF(LANG.UI_ARENA_5 ,  fonts.FONT_SIYUAN , 20)
    self.lastTimesLabel:addTo(self.root);
    self.lastTimesLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
    self.lastTimesLabel:setPosition(-75 , -241); -- -59,-241

    self.itemNum = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20);
    self.itemNum:addTo(self.root);
    self.itemNum:setAnchorPoint(1 , 0.5);
    self.itemNum:setPosition(87 , -241);

    self.addBtn = ccui.Button:create('image/commonImg/add_btn_1.png','image/commonImg/add_btn_1.png');
    self.addBtn:addTo(self.root);
    self.addBtn:setPosition(119,-241);
    self.addBtn:addClickEventListener(function() 
        UIManager:push('ShopPanel');
    end);

    local label = cc.Label:createWithTTF(LANG.UI_ARENA_2 ,  fonts.FONT_SIYUAN , 20);
    label:enableOutline(cc.c3b(170,25,10),2);
    self.challengeBtn = ccui.Button:create('image/commonImg/btn_9_219_55.png','image/commonImg/btn_9_219_55.png');
    self.challengeBtn:addTo(self.root);
    self.challengeBtn:setPosition(0 , -329);
    self.challengeBtn:setTitleLabel(label);
    self.challengeBtn:addClickEventListener(handler(self , self.challengeBtnClick));
end

function ArenaPanel:registEvent()
    EventManager:RegisterEvent(EventType.NetworkRetArenaInfo,handler(self,self.onShow));
    EventManager:RegisterEvent(EventType.UIUpdateArenaPanelRedDot,handler(self,self.updateRewardRedDot));
    EventManager:RegisterEvent(EventType.UIShowLastTime,handler(self,self.showLastTime));
end

function ArenaPanel:onEnter()
    if model.ArenaModel:hasInit() then
        self:onShow()
    else
        model.ArenaModel:reqArenaInfo()
    end
end

function ArenaPanel:onShow()

    self.arenaSend = false;
    
    if model.ArenaModel:getSeason() == -1 then
        Prompt:Show(LANG.UI_ARENA_15);
        UIManager:pop('ArenaPanel');
        return
    end

    self:showLastTime(true);

    local curRankData = model.ArenaModel:getCurArenaRankData();
    local nextRankData = model.ArenaModel:getNextArenaRankData();
    local curScore = model.ArenaModel:getScore();
    local challengeNum = model.ArenaModel:getChallengeNum();

    self.level:setString(tostring(curRankData.name));
    self.level:enableOutline(rankOutline[curRankData.rank],2);
    
    local nextScore = 0;
    if nextRankData then
        nextScore = nextRankData.point;
    else 
        nextScore = curRankData.point;
    end
    local percent = curScore/nextScore;
    percent = percent > 1 and 1 or percent;
    local width = 493*percent;
    self.levelProgress:setTextureRect(cc.rect(0 , 0 , width , 24));
    self.levelScore:setString(tostring(curScore)..'/'..tostring(nextScore));

    local challengeNum = model.ArenaModel:getChallengeNum();
    if challengeNum <= 0 then

        local itemNum = model.ItemModel:getItemNum(ARENA_ITEM);

        self.lastTimesLabel:setString(LANG.UI_CARD_19);
        self.lastTimesLabel:setPositionX(-59)
        self.itemIcon:setVisible(true);
        self.addBtn:setVisible(itemNum<=0);
        self.itemNum:setString(tostring(itemNum));
    else
        self.lastTimesLabel:setString(LANG.UI_ARENA_5);
        self.lastTimesLabel:setPositionX(-73)
        self.itemIcon:setVisible(false);
        self.addBtn:setVisible(false);
        self.itemNum:setString(tostring(challengeNum));
    end

    self.rankChangeSpine:clearTracks();
    self.rankChangeSpine:setToSetupPose();
    self.rankChangeSpine:setVisible(false);
    self.rankKeepSpine:clearTracks();
    self.rankKeepSpine:setToSetupPose();
    self.rankKeepSpine:setVisible(false);
    self.rankStarChangeSpine:clearTracks();
    self.rankStarChangeSpine:setToSetupPose();
    self.rankStarChangeSpine:setVisible(false);
    self.rankStarKeepSpine:clearTracks();
    self.rankStarKeepSpine:setToSetupPose();
    self.rankStarKeepSpine:setVisible(false);
    local changeRankState = model.ArenaModel:getChangeRankState();
    if changeRankState == 1 then --升大段
        Prompt:Show(string.format(LANG.UI_ARENA_12 , tostring(curRankData.name)));
        self.rankChangeSpine:setVisible(true);
        self.rankChangeSpine:setAnimation(0, ('a'..curRankData.rank), false)
    elseif changeRankState == 2 then --升小段
        Prompt:Show(string.format(LANG.UI_ARENA_12 , tostring(curRankData.name)));
        self.rankKeepSpine:setVisible(true);
        self.rankKeepSpine:setAnimation(0, ('b'..curRankData.rank), true);
        self.rankStarChangeSpine:setVisible(true);
        self.rankStarChangeSpine:setAnimation(0, ('c'..(curRankData.order-1)), false);
    else
        self.rankKeepSpine:setVisible(true);
        self.rankKeepSpine:setAnimation(0, ('b'..curRankData.rank), true);
        self.rankStarKeepSpine:setVisible(true);
        self.rankStarKeepSpine:setAnimation(0, ('d'..curRankData.order), true);
    end

    model.ArenaModel:setChangeRankState(0);

    TimeManager:registUpdateEvent('ArenaPanel',handler(self,self.updateTime),true);

    self:updateRewardRedDot();

    self.root:setVisible(true);
    EventManager:FireEvent(EventType.UIFooterUpdateSelect,5);
end

function ArenaPanel:updateRewardRedDot()
    local state = model.ArenaModel:rewardRedDotActiveState();
    tools.RedDotTools:setRedDotToNode(self.btnList[1],state,nil,cc.p(68 , 56)); --36,36
    
    local show = model.TeamModel:checkTeamFormationRedDotState();
	tools.RedDotTools:setRedDotToNode(self.btnList[2],show,nil,cc.p(68,56))
end

function ArenaPanel:updateTime()
    local lastTime , timeType = model.ArenaModel:getAranaLastTime();

    local day = math.floor(lastTime / 86400);
    local lastSeconds = lastTime - day * 86400;
    local timeStr = GlobalFunctions:ChangeTime(lastSeconds);
    if day > 0 then
        timeStr = string.format(LANG.UI_ARENA_3 , day)..tostring(timeStr);
    end

    if timeType == 1 then
        self.lastTime:setString(string.format(LANG.UI_ARENA_17,tostring(timeStr)));
    elseif timeType  == 2 then
        self.lastTime:setString(string.format(LANG.UI_ARENA_16,tostring(timeStr)));
    end

    if lastTime <= 0 and not self.arenaSend then
        if timeType ~= 0 then
            model.ArenaModel:setInit(false);
            model.ArenaModel:reqArenaInfo()
            self.arenaSend = true;
        end
    end

    if UIManager:panelIsVisible('ArenaRewardPanel') then
        EventManager:FireEvent(EventType.UIUpdateArenaRankRewardTime , timeStr , timeType);
    end
end

function ArenaPanel:challengeBtnClick()
    AudioManager:playEffect(Conf.buttonClick);
    UIManager:push('ArenaRankListPanel');
end

function ArenaPanel:showLastTime(visible)
    self.lastTimeNode:setVisible(visible);
end

function ArenaPanel:btnClick(sender , event)
    local tag = sender:getTag();
    AudioManager:playEffect(Conf.buttonClick);
    if tag == 1 then
        self:showLastTime(false);
        UIManager:push('ArenaRewardPanel');
        self:updateTime();
    elseif tag == 2 then
        UIManager:push('TeamPanel',Enum:getTable('TeamType').ARENA);
    else
        UIManager:push('StorePanel' , Enum:getTable('CommonShopType').ARENA);
    end
end

function ArenaPanel:onLeave()
    TimeManager:registUpdateEvent('ArenaPanel',nil,true);
    self.root:setVisible(false);
end
function ArenaPanel:onClickBack()
    UIManager:pop('ArenaPanel');
end

-- 引导相关
function ArenaPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 73 then
		local btn = self.challengeBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return ArenaPanel