
local ArenaRankListInfoPanel = class('ArenaRankListInfoPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")


function ArenaRankListInfoPanel:ctor(scene, sceneName, name)
    self.super.ctor(self, scene, sceneName, 'ArenaRankListInfoPanel');
    
    self.isPopup = true;

end

function ArenaRankListInfoPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel()
    self:registEvent();
end

function ArenaRankListInfoPanel:initPanel(  )

    local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,489));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -6);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_ARENA_ENEMY_TITLE_1 , 606 , 63 , LANG.UI_L_ARENA_ENEMY_TITLE_2 , true);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 270);

	local teamBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	teamBg:addTo(self.root);
	teamBg:setPosition(0 , -44);
    teamBg:setCapInsets(cc.rect(11,11,34,28));
    teamBg:setContentSize(cc.size(560 , 204));

    local costBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	costBg:addTo(self.root);
	costBg:setPosition(-119 , -196);
    costBg:setCapInsets(cc.rect(11,11,34,28));
    costBg:setContentSize(cc.size(267 , 42));

    local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	arrow:addTo(self.root);
    arrow:setPosition(-248,29);
    
	local label = cc.Label:createWithTTF(LANG.UI_ARENA_11 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.root);
	label:setAnchorPoint(0 , 0.5);
	label:setPosition(-221 , 29);
	label:setTextColor(cc.c4b(160 , 200 , 255 , 255));

    self.info = template.ArenaRankListTemplate:create(self.root);
    self.info:setPosition(0 , 143);
    self.info:setChallengeBtnVisible(false);

    self.teamView = ccui.ScrollView:create();
	self.teamView:setTouchEnabled(true);
	self.teamView:setBounceEnabled(true);
	self.teamView:setDirection(ccui.ScrollViewDir.horizontal);
	self.teamView:setContentSize(cc.size(500, 118));
	self.teamView:setAnchorPoint(cc.p(0.5, 0.5));
	self.teamView:setPosition(5 , -65);
	self.teamView:setScrollBarEnabled(false);
	self.teamView:addTo(self.root);

    local icon = ResTable:getValue('item' , ARENA_ITEM , 'icon');
    self.itemIcon = cc.Sprite:create("image/icon/I"..icon..".png");
    self.itemIcon:addTo(self.root);
    self.itemIcon:setScale(0.45)
    self.itemIcon:setPosition(-222 , -197);

    self.lastTimesLabel = cc.Label:createWithTTF(LANG.UI_ARENA_5 ,  fonts.FONT_SIYUAN , 20)
    self.lastTimesLabel:addTo(self.root);
    self.lastTimesLabel:setPosition(-181 , -196);

    self.itemNum = cc.Label:createWithTTF(LANG.UI_ARENA_5 ,  fonts.FONT_SIYUAN , 20);
    self.itemNum:addTo(self.root);
    self.itemNum:setAnchorPoint(1,0.5);
    self.itemNum:setPosition(6 , -196);

    local btnLabel = cc.Label:createWithTTF(LANG.UI_ARENA_6 , fonts.FONT_SIYUAN , 20);
	btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

	self.challengeBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.challengeBtn:addTo(self.root);
	self.challengeBtn:setPosition(144 , -196);
	self.challengeBtn:addClickEventListener(handler(self , self.challengeBtnClick));
	self.challengeBtn:setTitleLabel(btnLabel);
end

function ArenaRankListInfoPanel:registEvent()
    --EventManager:RegisterEvent(EventType.NetworkRetGetRankList,handler(self,self.updateRankList));
end

function ArenaRankListInfoPanel:onEnter(uid)
    self:addSwallowCallback(handler(self , self.onClickBack))

    local rankData = model.ArenaModel:getRankList(uid);
    if rankData then
        self.info:initData(rankData);

        self.teamView:removeAllChildren();

        local num = #rankData.arena_team;
	    local maxWidth = 130 * num;

	    self.teamView:setInnerContainerSize(cc.size(maxWidth , 118));

        for _k , role in pairs(rankData.arena_team) do
            if role.no ~= -1 then
                local icon = template.ItemTemplate:create();
                icon:addTo(self.teamView);
                icon:setPosition(51.5 + 130 * (_k - 1)  , 59);
                if rankData.isRobot == 1 then
                    icon:Init(MONSTER_ROLE_TYPE, role.no, role.star_lv, role.level);
                else
                    icon:Init(ROLE_TYPE, role.no, role.star_lv, role.level, 0, role.quality, role.avatar_no);
                end
            else
                local bg = cc.Sprite:create('image/commonImg/icon_item_add.png');
                bg:addTo(self.teamView);
                bg:setPosition(51.5 + 130 * (_k - 1)  , 59);
            end
        end
    end

    local challengeNum = model.ArenaModel:getChallengeNum();
    if challengeNum <= 0 then

        local itemNum = model.ItemModel:getItemNum(ARENA_ITEM);

        self.lastTimesLabel:setString(LANG.UI_CARD_19);
        self.lastTimesLabel:setPositionX(-173);
        self.itemIcon:setVisible(true);
        self.itemNum:setString(tostring(itemNum));
    else
        self.lastTimesLabel:setString(LANG.UI_ARENA_5);
        self.lastTimesLabel:setPositionX(-181);
        self.itemIcon:setVisible(false);
        self.itemNum:setString(tostring(challengeNum));
    end

    self.uid = uid;
    
    self.root:setVisible(true);
end

function ArenaRankListInfoPanel:challengeBtnClick()
    TimeManager:registUpdateEvent('ArenaPanel',nil,true);
    model.ArenaModel:reqArenaChallenge(self.uid);
end

function ArenaRankListInfoPanel:onLeave()
    self.root:setVisible(false);
end
function ArenaRankListInfoPanel:onClickBack()
    UIManager:pop('ArenaRankListInfoPanel');
end

return ArenaRankListInfoPanel