
local ArenaRankListPanel = class('ArenaRankListPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/arena/rankList/';
local MessageBoxType = Enum:getTable('MessageBoxType')
local freeRefreshTimes = 10;


function ArenaRankListPanel:ctor(scene, sceneName, name)
    self.super.ctor(self, scene, sceneName, 'ArenaRankListPanel');
    
    self.isPopup = true;

end

function ArenaRankListPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel()
    self:registEvent();
end

function ArenaRankListPanel:initPanel(  )

    local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,671));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -18);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_ARENA_RANK_TITLE_1 , 606 , 63 , LANG.UI_L_ARENA_RANK_TITLE_2 , true);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 349);

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.root);
	listBg:setPosition(0 , -116);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(582 , 447));

    local node = cc.Node:create();
    node:addTo(self.root);
    node:setPosition(0 , 219);

    local bg = cc.Sprite:create(imagePath..'arena_rank_list_6.png');
    bg:addTo(node);

    self.curName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22);
    self.curName:addTo(node);
    self.curName:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.curName:setAnchorPoint(0 , 0.5);
    self.curName:setPosition(78 , 59);

    self.level = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22);
    self.level:addTo(node);
    self.level:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.level:setAnchorPoint(0 , 0.5);
    self.level:setPosition(78 , 28);

    self.refreshBtn = ccui.Button:create(imagePath..'arena_rank_list_4.png' , imagePath..'arena_rank_list_4.png');
    self.refreshBtn:addTo(node);
    self.refreshBtn:addClickEventListener(handler(self , self.refrashBtnClick));
    self.refreshBtn:setPosition(258 , 51);

    local icon = ResTable:getValue('item',COLOR_DIA,'icon');
    self.refreshCostIcon = cc.Sprite:create('image/icon/I'..COLOR_DIA..'.png')
        :addTo(node)
        :setScale(0.25)
        :setPosition(258,20)
    self.refreshTimes = cc.Label:createWithTTF('x0',fonts.FONT_SIYUAN,14)
        :addTo(node)
        :setPosition(258,20)
        :enableOutline(cc.c3b(0,0,0),1)

    local fpBg = cc.Sprite:create(imagePath..'arena_rank_list_8.png');
    fpBg:addTo(node);
    fpBg:setPosition(173,-14);

    local fpImg = cc.Sprite:create(imagePath..'arena_rank_list_7.png');
    fpImg:addTo(node);
    fpImg:setPosition(94,-14);

    self.fp = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    self.fp:addTo(node);
    self.fp:setAnchorPoint(1 , 0.5);
    self.fp:setPosition(249 , -14);

    self.rankIconNode = cc.Node:create();
    self.rankIconNode:addTo(node);
    self.rankIconNode:setScale(0.2);
    self.rankIconNode:setPosition(0 , 27);

    self.rankBg = cc.Sprite:create();
    self.rankBg:addTo(self.rankIconNode);

    self.rankStar = cc.Sprite:create();
    self.rankStar:addTo(self.rankIconNode);

    local bg = cc.Sprite:create('image/arena/arena_1.png');
    bg:addTo(node);
    bg:setPosition(0 , -63);

    local bg = cc.Sprite:create('image/arena/arena_2.png');
    bg:addTo(node);
    bg:setPosition(0 , -72);

    self.levelProgress = cc.Sprite:create('image/arena/arena_3.png');
    self.levelProgress:addTo(node);
    self.levelProgress:setAnchorPoint(0 , 0.5);
    self.levelProgress:setPosition(-246.5 , -72);

    local bg = cc.Sprite:create('image/arena/arena_4.png');
    bg:addTo(node);
    bg:setPosition(0 , -84);

    self.score = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 14);
    self.score:addTo(node);
    self.score:setPosition(0 , -84);
    self.score:enableOutline(cc.c3b(0,0,0),2);

    self.rankList = {};
    for i = 1 , 3 do
        self.rankList[i] = template.ArenaRankListTemplate:create(self.root);
        self.rankList[i]:setPosition(0 , 29 - 145 * (i - 1));
    end
end

function ArenaRankListPanel:registEvent()
    EventManager:RegisterEvent(EventType.NetworkRetGetRankList,handler(self,self.updateRankList));
end

function ArenaRankListPanel:onEnter()

    self:addSwallowCallback(handler(self , self.onClickBack))
    self:onShow();

    self.runReFresh = false;

    local rankList = model.ArenaModel:getRankList();

    if #table.keys(rankList) > 0 then
        self:updateRankList()
    else
        self:reqRankList();
    end

    self.root:setVisible(true);
end

function ArenaRankListPanel:onShow()

    local iconNo = model.UserModel:getHeadIcon() or 1;
    local name = model.UserModel:getUserName();
    local level = model.UserModel:getUserLevel();
    local score = model.ArenaModel:getScore();
    local curRankData = model.ArenaModel:getCurArenaRankData();
    local nextRankData = model.ArenaModel:getNextArenaRankData();
    local fp = model.TeamModel:getCurrentTeamFp(6);
    if fp == nil or  tostring(fp) == '0' then
        fp = model.TeamModel:getCurrentTeamFp();
    end

    self.curName:setString(tostring(name));
    self.level:setString('Lv.'..tostring(level));
    self.fp:setString(ConvertStrToDigitUnit(tostring(fp)));

    local nextScore = 0;
    if nextRankData then
        nextScore = nextRankData.point;
    else 
        nextScore = curRankData.point;
    end
    local percent = score/nextScore;
    percent = percent > 1 and 1 or percent;
    local width = 493*percent;
    self.levelProgress:setTextureRect(cc.rect(0 , 0 , width , 24));
    self.score:setString(tostring(score)..'/'..tostring(nextScore));
   
    self.rankBg:setTexture('image/arena/arena_rank_bg_'..curRankData.rank..'.png');
    self.rankStar:setTexture('image/arena/arena_rank_star_'..curRankData.order..'.png');
end

function ArenaRankListPanel:updateRankList()
    local delayRefresh = 0;
    local rankList = model.ArenaModel:getRankList();
    local index = 1;
    
    local rankListData = {}
    for uid , rankData in pairs(rankList) do
        table.insert(rankListData,rankData);
    end

    if#rankListData > 1 then
        table.sort(rankListData,function(firstData,secondData) 
            return firstData.fight_score < secondData.fight_score;
        end)
    end
    for _k , rankData in pairs(rankListData) do
        self.rankList[_k]:initData(rankData);
        if self.runReFresh then
            self.rankList[_k]:runRefreshAction(delayRefresh);
            delayRefresh = delayRefresh + 2;
        end
    end

    local costNum = 0;
    local refreshTimes = model.ArenaModel:getFightRefreshTimes();
    if refreshTimes == freeRefreshTimes then
        costNum = 10;
    elseif refreshTimes == freeRefreshTimes+1 then
        costNum = 30;
    elseif refreshTimes == freeRefreshTimes+2 then
        costNum = 50;
    elseif refreshTimes >= freeRefreshTimes+3 then
        costNum = 100;
    end
    self.costNum = costNum;

    if costNum == 0 then
        self.refreshCostIcon:setVisible(false);
        self.refreshTimes:setPositionX(258)
        self.refreshTimes:setString(string.format(LANG.UI_ARENA_19,(freeRefreshTimes-refreshTimes)));
    else
        self.refreshCostIcon:setVisible(true);
        self.refreshTimes:setString(string.format(LANG.UI_ARENA_18,costNum));
        local width = self.refreshTimes:getContentSize().width;
        local iconWidth = self.refreshCostIcon:getBoundingBox().width;
        local posX = 258-width/2;
        self.refreshCostIcon:setPositionX(posX);
        self.refreshTimes:setPositionX(posX+iconWidth/2+width/2);
    end
end

function ArenaRankListPanel:refrashBtnClick()
    AudioManager:playEffect(Conf.buttonClick);
    if self.costNum > 0 then
        MessageBox:create(string.format(LANG.UI_NOTICE_3,tostring(self.costNum)) , MessageBoxType.CANCEL_OK,function()
            self:reqRankList();
            self.runReFresh = true;
        end);
    else
        self:reqRankList();
        self.runReFresh = true;
    end
end

function ArenaRankListPanel:reqRankList()
    local msg = {};
    msg.season = model.ArenaModel:getSeason() or 0;
    local	guideStep = model.GuideModel:getGuideStep() ; -- 新手引导阶段

	if guideStep == model.GuideModel.GUIDE_STEP_ENUM.GUIDE_ENUM_ARENA  then
		msg.guideStep = model.GuideModel.GUIDE_STEP_ENUM.GUIDE_ENUM_ARENA;
	end
    Network.NetworkManager:Send(Network.NetworkCmdType.req_arena_rank_list, msg);
end

function ArenaRankListPanel:onLeave()
    self.root:setVisible(false);
end
function ArenaRankListPanel:onClickBack()
    UIManager:pop('ArenaRankListPanel');
end

function ArenaRankListPanel:guideItemClick(  )
    self.rankList[1]:challengeBtnClick()
end

-- 引导相关
function ArenaRankListPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 74 then
		local btn = self.refreshBtn;
        pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
    elseif guideNo == 75 then
		local btn = self.rankList[1]:getchallengeBtn();
        pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end


return ArenaRankListPanel