
local ArenaRewardPanel = class('ArenaRewardPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/arena/arenaReward/';

local rewardName = {
    [1] = 'reward_rank',
    [2] = 'reward_daily',
    [3] = 'reward_season',
}

function ArenaRewardPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ArenaRewardPanel');

    self.isPopup = true;

end

function ArenaRewardPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel()
    self:registEvent();
end

function ArenaRewardPanel:initPanel(  )

    local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,629));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -16);
    self.bg = bg;

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_REWARD_1 , 606 , 63 , LANG.UI_L_REWARD_2 , true);
	titleNode:addTo(self.root);
    titleNode:setPosition(0 , 329);
    
    local bg = cc.Scale9Sprite:create('image/commonImg/bg_3_11_4_33_20.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -30);
    bg:setCapInsets(cc.rect(11,4,33,20));
	bg:setContentSize(cc.size(580 , 555));

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.root);
	listBg:setPosition(0 , -112);
    listBg:setCapInsets(cc.rect(11,11,34,28));
    listBg:setContentSize(cc.size(563 , 271));

    local line = cc.Sprite:create('image/commonImg/line.png');
    line:addTo(self.root);
    line:setPosition(0,-261);

    self.menuList = {};
    for i = 1 , 3 do
        self.menuList[i] = {};
        
        local menuNode = cc.Node:create();
        menuNode:addTo(self.root);
        menuNode:setPosition(-193 + (i-1)*193 , 261);

        local unTexture = 'image/commonImg/top_2_bg_59_30.png';
		local texture = 'image/commonImg/top_1_bg_59_30.png';
		
		local label = cc.Label:createWithTTF(LANG.UI_ARENA_MENU[i] , fonts.FONT_SIYUAN , 20);

		local bgBtn = ccui.Button:create(texture,texture,unTexture);
		bgBtn:addTo(menuNode);
		bgBtn:setTag(i);
		bgBtn:setTitleLabel(label)
		bgBtn:setScale9Enabled(true);
		bgBtn:setCapInsets(cc.rect(10 , 0 , 39 , 30));
		bgBtn:setContentSize(cc.size(193 , 30));
		bgBtn:addClickEventListener(handler(self , self.menuClick));
        self.menuList[i].btn = bgBtn;

        local light = cc.Sprite:create('image/commonImg/menu_light_264_36.png');
        light:addTo(menuNode);
        light:setPosition(0,14);
        self.menuList[i].light = light;
    end

    local bg = cc.Sprite:create(imagePath..'arena_reward_3.png');
    bg:addTo(self.root);
    bg:setPosition(0,406);

    bg = cc.Sprite:create('image/commonImg/time_1.png');
    bg:addTo(self.root);
    bg:setPosition(-140 , 406);

    --self.lastTimeLabel = cc.Label:createWithTTF(LANG.UI_ARENA_1 ,  fonts.FONT_SIYUAN , 15)
    --self.lastTimeLabel:addTo(self.root);
    --self.lastTimeLabel:setPosition(-40 , 406);
    --self.lastTimeLabel:setTextColor(cc.c3b(255,255,0));

    self.lastTime = cc.Label:createWithTTF('0' ,  fonts.FONT_SIYUAN , 15)
    self.lastTime:addTo(self.root);
    --self.lastTime:setAnchorPoint(0 , 0.5);
    self.lastTime:setPosition(0 , 406);
    self.lastTime:setTextColor(cc.c3b(255,255,0));

    self.rewardTipsImg = cc.Sprite:create('image/commonImg/tip_2.png');
    self.rewardTipsImg:addTo(self.root);
    self.rewardTipsImg:setPosition(0 , -284);

    self.rewardTips = cc.Label:createWithTTF('0' ,  fonts.FONT_SIYUAN , 20)
    self.rewardTips:addTo(self.root);
    self.rewardTips:setTextColor(cc.c3b(255 , 200 , 0));
    self.rewardTips:setPosition(0 , -284);

    self.rewardLastTimeNode = cc.Node:create();
    self.rewardLastTimeNode:addTo(self.root);
    self.rewardLastTimeNode:setPosition(0 , 203);

    local bg = cc.Sprite:create('image/arena/arenaReward/arena_reward_3.png');
    bg:addTo(self.rewardLastTimeNode);

    local label = cc.Label:createWithTTF(LANG.UI_ARENA_7 ,  fonts.FONT_SIYUAN , 20)
    label:addTo(self.rewardLastTimeNode);
    label:setPosition(-28 , 0);

    self.rewardLastTime = cc.Label:createWithTTF('00:00:00' ,  fonts.FONT_SIYUAN , 20)
    self.rewardLastTime:addTo(self.rewardLastTimeNode);
    self.rewardLastTime:setAnchorPoint(0 , 0.5);
    self.rewardLastTime:setPosition(8 , 0);

    local width = label:getContentSize().width;
    local lastTimeWidth = self.rewardLastTime:getContentSize().width;
    local posX = -lastTimeWidth/2
    label:setPositionX(posX);
    self.rewardLastTime:setPositionX(posX+width/2);

    self.curRankIcon = {};
    self.curRankReward = {};
    local spine_res = 'jingjiui_spine'
    for i = 1 , 2 do

        self.curRankIcon[i] = {};
        local node = cc.Node:create();
        node:addTo(self.root);
        node:setPosition(i == 1 and -119 or 167 , 134);
        self.curRankIcon[i].node = node;

        local bg = cc.Sprite:create(imagePath..'arena_reward_6.png');
        bg:addTo(node);

        local bg = cc.Sprite:create('image/commonImg/arrow_bg.png');
        bg:addTo(node);
        bg:setPosition(-13,30);

        local bg = cc.Sprite:create(imagePath..'arena_reward_8.png');
        bg:addTo(node);
        bg:setContentSize(cc.size(121,63));
        bg:setPosition(28,-14);

        local label = cc.Label:createWithTTF(LANG.UI_ARENA_RANK_LABEL[i] ,  fonts.FONT_SIYUAN , 18)
        label:addTo(node);
        label:setPosition(7 , 30);
        label:setAnchorPoint(0 , 0.5);
        label:setTextColor(cc.c3b(160 , 200 , 255));

        local curRankSpineNode = cc.Node:create();
        curRankSpineNode:addTo(node);
        self.curRankIcon[i].rankSpineNode = curRankSpineNode;

        local rankIconNode = cc.Node:create();
        rankIconNode:addTo(node);
        rankIconNode:setScale(0.28);
        rankIconNode:setPosition(-96 , 0);
    
        local rankBg = cc.Sprite:create();
        rankBg:addTo(rankIconNode);
        self.curRankIcon[i].rankBg = rankBg;
    
        local rankStar = cc.Sprite:create();
        rankStar:addTo(rankIconNode);
        self.curRankIcon[i].rankStar = rankStar;

        if i == 1 then
            for j = 1 , 2 do
                local template = template.ItemTemplate:create(2);
                template:addTo(node);
                template:setPosition(-1 + 59 * (j - 1) , -15);
                template:setScale(0.5)
                self.curRankReward[j] = template;
            end
        else
            self.topRank = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,18)
                :addTo(node)
                :setPosition(30,-15)
        end
    end

    local initData = {
		width = 554,
		height = 270,
		cellWidth = 160 ,
		cellHeight = 270,
		direction = 0,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.rankRewardListView = template.TableViewTemplate:create()
	self.rankRewardListView:initWithSizeAndItem(initData);
	self.rankRewardListView:getView():setPosition(-277, -247);
	self.rankRewardListView:getView():addTo(self.root)

    local btnLabel = cc.Label:createWithTTF(LANG.UI_MAIL_4 , fonts.FONT_SIYUAN , 20);
        btnLabel:enableOutline(cc.c4b(55 , 85 , 155 , 255) , 2);
    self.oneKeyBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png')
        :addTo(self.root)
        :setTitleLabel(btnLabel)
        :setPosition(0 , -350)
    self.oneKeyBtn:addClickEventListener(function() 
        self:oneKeyBtnClick()
    end);
end

function ArenaRewardPanel:registEvent()
    EventManager:RegisterEvent(EventType.NetworkRetGetArenaRankLvReward,handler(self,self.retGetReward));
    EventManager:RegisterEvent(EventType.UIUpdateArenaRankRewardTime,handler(self,self.updateTime));
end

function ArenaRewardPanel:onEnter()
    self:addSwallowCallback(handler(self , self.onClickBack))
    self.rewardType = 1;
    self:updateData();
    self:updateCurRankIcon();
    self:updateArenaRewardRedDot()
    self.root:setVisible(true);
end

function ArenaRewardPanel:menuClick(sender , event)
    local index = sender:getTag();
    AudioManager:playEffect(Conf.buttonClick);
    if index == self.rewardType then
        return
    end

    self.rewardType = index;

    self:updateData();
end

function ArenaRewardPanel:updateCurRankIcon()
    local curRankData = model.ArenaModel:getCurArenaRankData();
    local topRankData = model.ArenaModel:getTopArenaRankData();

    local datas={curRankData,topRankData};

    local spine_res = 'jingjiui_spine';
    for i = 1 , 2 do
        local data = datas[i];
        self.curRankIcon[i].rankSpineNode:removeAllChildren();

        if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
            local rankSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
            rankSpine:setAnimation(0,'idle'..data.rank,true);
            rankSpine:addTo(self.curRankIcon[i].rankSpineNode);
        else
            print('error : 缺少spine 资源')
        end

        self.curRankIcon[i].rankBg:setTexture('image/arena/arena_rank_bg_'..data.rank..'.png')
        self.curRankIcon[i].rankStar:setTexture('image/arena/arena_rank_star_'..data.order..'.png');
    end

    if self.topRank then
        self.topRank:setString(tostring(topRankData.name));
    end
end

function ArenaRewardPanel:updateData()

    for _k , menu in pairs(self.menuList) do
		local label = menu.btn:getTitleLabel();
		if _k == self.rewardType then
			menu.btn:setBright(true)
            label:setTextColor(cc.c3b(255 , 255 , 255));
            menu.light:setVisible(true);
		else
            menu.btn:setBright(false)
            menu.light:setVisible(false);
			label:setTextColor(cc.c3b(180 , 180 , 180));
		end
	end

    self.rewardTips:setString(LANG.UI_ARENA_RANK_REWARD_TIP[self.rewardType]);

    TimeManager:registUpdateEvent('ArenaRewardPanel',nil,true);
    if self.rewardType == 2 then
        self:updateDailyTime();
        TimeManager:registUpdateEvent('ArenaRewardPanel',handler(self,self.updateDailyTime),true);
        self.rewardLastTimeNode:setVisible(true);
        for i = 1 , 2 do
            self.curRankIcon[i].node:setPositionY(106);
        end
    else
        for i = 1 , 2 do
            self.curRankIcon[i].node:setPositionY(134);
        end
        self.rewardLastTimeNode:setVisible(false);
    end

    local width = self.rewardTipsImg:getContentSize().width;
    local rewardTipsWidth = self.rewardTips:getContentSize().width;
    local posX = -rewardTipsWidth/2;

    self.rewardTipsImg:setPositionX(posX);
    self.rewardTips:setPositionX(posX + width / 2 + rewardTipsWidth / 2)

    local rewardDatas = ResTable:getTable('arena_reward').contain.order;

    local curRankData = model.ArenaModel:getCurArenaRankData();

    local jumpToIndex = 1;
    for _k , data in ipairs(rewardDatas) do
        if curRankData and curRankData.point == data.point then
            local reward = data[rewardName[self.rewardType]];--ResTable:getValue('arena_reward' , curRankData.no , rewardName[self.rewardType]);
            if #reward ==1 then
                self.curRankReward[1]:setVisible(true);
                self.curRankReward[2]:setVisible(false);
                self.curRankReward[1]:Init(reward[1][1] , reward[1][2]);
                self.curRankReward[1]:setPosition(29 , -15);
            else
                for i = 1 , 2 do
                    if reward[i] then
                        self.curRankReward[i]:setVisible(true);
                        self.curRankReward[i]:Init(reward[i][1] , reward[i][2]);
                        self.curRankReward[i]:setPosition(-1 + 59 * (i - 1) , -15);
                    else 
                        self.curRankReward[i]:setVisible(false);
                    end
                end
            end
        end

        if data.point == curRankData.point then
            jumpToIndex = _k;
            break;
        end
    end

    self.rankRewardList = {};
    self.rankRewardListView:reloadData(rewardDatas);

    --if self.rewardType == 1 and jumpToRewardIndex > 0 then
    --   jumpToIndex = jumpToRewardIndex;
    --end
    self.rankRewardListView:scrollToCellIndex(jumpToIndex - 1);

    if self.rewardType == 1 then
        self.oneKeyBtn:setVisible(true)
        self.bg:setPosition(0 , -51);
        self.bg:setContentSize(cc.size(606,700));
    else
        self.oneKeyBtn:setVisible(false)
        self.bg:setPosition(0 , -16);
        self.bg:setContentSize(cc.size(606,629));
    end
end

function ArenaRewardPanel:updateArenaRewardRedDot()
    local state = model.ArenaModel:rewardRedDotActiveState();
    tools.RedDotTools:setRedDotToNode(self.menuList[1].btn,state,nil,cc.p(183.5,20));
end

function ArenaRewardPanel:updateDailyTime()
    local lastTime = TimeManager:getNextDayTime() - TimeManager:getCurTime();
    self.rewardLastTime:setString(tostring(GlobalFunctions:ChangeTime(lastTime)));
end

function ArenaRewardPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.ArenaRewardTemplate:create(cell);
		cellNode:setPosition(80, 135);
		cellNode:setTag(999);
        table.insert(self.rankRewardList, cellNode)
    end
    
    local rewardData = ResTable:getTable('arena_reward').contain.order;

    local data = rewardData[index + 1];
    cellNode:initData(data , self.rewardType);

    -- self.rankRewardList[data.no] = cellNode;
    --cell:setTag(data.no);

end

function ArenaRewardPanel:cellItemTouch(table,cell)

    if self.rewardType == 1 then
        local dataIndex = cell:getIdx() + 1;
        local rewardData = ResTable:getTable('arena_reward').contain.order;
        local data = rewardData[dataIndex];

        local curRankData = model.ArenaModel:getCurArenaRankData();

        if model.ArenaModel:getRankRewardState(data.no) then
            return;
        end

        if data.point > curRankData.point then
            return
        end

        local msg = {};
        msg.season = model.ArenaModel:getSeason() or 0;
        msg.no = data.no;
        Network.NetworkManager:Send(Network.NetworkCmdType.req_arena_rank_lv_reward, msg);
    end
end

function ArenaRewardPanel:oneKeyBtnClick()
    local rewardData = ResTable:getTable('arena_reward').contain.order;
    local curRankData = model.ArenaModel:getCurArenaRankData();
    local canNot = true;
    for k,data in pairs(rewardData) do
        if not model.ArenaModel:getRankRewardState(data.no) and data.point <= curRankData.point then
            canNot = false;
            break;
        end
    end

    if canNot then
        Prompt:Show(LANG.UI_ARENA_21);
        return
    end

    local msg = {};
    msg.season = model.ArenaModel:getSeason() or 0;
    msg.no = 0;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_arena_rank_lv_reward, msg);
end

function ArenaRewardPanel:retGetReward(msg)
    if msg and msg.arena.reward_ids then
        -- local num = #msg.arena.reward_ids;
        -- for _k , no in pairs(msg.arena.reward_ids) do
        --     print('fubin---reward 11：', no)
        --     for k,cellNode in pairs(self.rankRewardList) do
        --         print('fubin---reward 22：', cellNode:getNo())
        --         if cellNode:getNo() == tonumber(no) then
        --             print('fubin---reward 33：', no)
        --             cellNode:setGetState(2);
        --             break;
        --         end
        --     end
        --     -- self.rankRewardList[no]:setGetState(2);
        -- end
        UIManager:push('RewardPanel' , msg);
    end
    self:updateArenaRewardRedDot();
end

function ArenaRewardPanel:updateTime(time,timeType)
    if timeType == 1 then
        self.lastTime:setString(string.format(LANG.UI_ARENA_17,tostring(time)));
    elseif timeType == 2 then
        self.lastTime:setString(string.format(LANG.UI_ARENA_16,tostring(time)));
    end
end


function ArenaRewardPanel:onLeave()
    self.root:setVisible(false);
    for i = 1 , 2 do
        self.curRankIcon[i].rankSpineNode:removeAllChildren();
    end
end
function ArenaRewardPanel:onClickBack()
    TimeManager:registUpdateEvent('BattlePassPanel',nil,true);
    UIManager:pop('ArenaRewardPanel');
    EventManager:FireEvent(EventType.UIUpdateArenaPanelRedDot);
    EventManager:FireEvent(EventType.UIShowLastTime,true);
end

return ArenaRewardPanel