local BankPanel = class('BankPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/activity/three_day/'

function BankPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'BankPanel');

	self.useCCreator = false;
    self.isPopup = true;

end

function BankPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel();
    self:registEvent();
end


function BankPanel:initPanel(  )

    local bg = cc.Sprite:create(imagePath..'rd_1.png');
    bg:addTo(self.root);
    bg:setAnchorPoint(0.5, 0);
	bg:setPosition(0, 30)

    bg = cc.Sprite:create(imagePath..'rd_vip_1.png');
    bg:addTo(self.root);
    bg:setAnchorPoint(0.5, 0);
    bg:setPosition(-50 , 190);

    bg = cc.Sprite:create(imagePath..'rd_vip_2.png');
    bg:addTo(self.root);
    bg:setAnchorPoint(0.5, 0);
    bg:setPosition(150 , 300);

    bg = cc.Sprite:create(imagePath..'three_day_bg_5.png');
    bg:addTo(self.root);
    bg:setPosition(98 , 88);

    local bg = cc.Sprite:create(imagePath..'rd_bg.png');
    bg:addTo(self.root);
    bg:setPosition(0 , -150);

    local initData = {
        width = 550,
        height = 600,
        cellWidth = 550,
        cellHeight = 150,
        direction = 1,
        cellReloadFunc = handler(self,self.reloadCell),
        cellTouchFunc = handler(self,self.cellItemTouch) ,
    }
    self.tableView = template.TableViewTemplate:create()
    self.tableView:initWithSizeAndItem(initData);
    self.tableView:getView():setPosition(-275, -300-150);
    self.tableView:getView():addTo(self.root)


    self.buyNode = cc.Node:create()
    self.buyNode:addTo(self.root)
    self.buyNode:setPosition(170,200);

    self.priceLabel = cc.Label:createWithTTF('9999' , fonts.FONT_SIYUAN , 18);
	-- self.priceLabel:addTo(buyBtn);
	-- self.priceLabel:setPosition(-220 , 35);
	-- self.priceLabel:setAnchorPoint(0 , 0.5);
	-- self.priceLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.priceLabel:enableOutline(cc.c3b(144 , 38 , 38) , 2);

    local buyBtn = ccui.Button:create(imagePath..'vip_buy_btn.png', imagePath..'vip_buy_btn.png', imagePath..'vip_buy_btn.png');
    buyBtn:addTo(self.buyNode);
    buyBtn:setScale9Enabled(true)
    -- buyBtn:setContentSize(cc.size(620, 170))
    buyBtn:addClickEventListener(handler(self , self.clickBuy));
	buyBtn:setTitleLabel(self.priceLabel);

    self.saleNode = cc.Node:create()
    self.saleNode:addTo(self.buyNode)
    self.saleNode:setPosition(90,20)
    local saleBg = cc.Sprite:create('image/shop/month_bg2.png')
    saleBg:addTo(self.saleNode)
    self.saleLabel = cc.Label:createWithTTF(LANG.UI_SHOP_OFF[4] , fonts.FONT_SIYUAN , 16);
    self.saleLabel:addTo(self.saleNode);
    self.saleLabel:enableOutline(cc.c3b(82 , 52 , 16) , 2);

	local oneKeyLabel = cc.Label:createWithTTF(LANG.UI_ROUND_15 , fonts.FONT_SIYUAN , 20);
	oneKeyLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	self.oneKeyBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.oneKeyBtn:addTo(self.root);
	self.oneKeyBtn:setTitleLabel(oneKeyLabel);
	self.oneKeyBtn:setPosition(0 , -550);
	self.oneKeyBtn:addClickEventListener(handler(self , self.getReward));
    

end

function BankPanel:registEvent(  )
    EventManager:RegisterEvent('BankTaskItem:onRechargeUpdate',handler(self,self.onRechargeUpdate));
    EventManager:RegisterEvent('EGO_SHOP_IS_BUY',handler(self,self.checkMonthCard));
end

function BankPanel:onEnter()
	self.season_id = 1;
    self:addSwallowCallback(handler(self , self.onClickBack));
    self:onShow();
    self.root:setVisible(true);

    --请求后台对应月卡是否买过
    if self.is_recharge==0 and self.payData then
        local msg = {}
        msg.sale_type = self.payData.sale_type;
        msg.sale_value = self.payData.sale_value;
        Network.NetworkManager:Send(Network.NetworkCmdType.req_is_buy_gift, msg);
    end
end

function BankPanel:onRechargeUpdate(is_recharge)
	self.is_recharge = is_recharge;
	self.buyNode:setVisible(self.is_recharge == 0)
end

function BankPanel:onShow()
    self.dataList = {}
    self.payData = nil;
    self.is_recharge = 0;
    self.bgPic = ''
    local tmpData = model.RoundModel:getRoundMissionById( self.season_id );
    if not tmpData then
    	return;
    end

    local payList = ResTable:getTable('round_bank_pay').contain;
	for _k , data in pairs(payList) do
		if data.season_id == self.season_id then
			self.payData = data;
			break;
		end
	end
    self.saleNode:setVisible(false)
	if self.payData then
        local price = ResTable:getValue('price', self.payData.price, CURRENCY) or 0;
		self.priceLabel:setString(tostring(string.format(LANG.UI_ROUND_31,tostring(price))))
	end

	self.dataList = tmpData.round_bank_missions;
	self.is_recharge = tmpData.is_recharge;
	self.buyNode:setVisible(self.is_recharge == 0)
    self.bgPic = tmpData.banner;
	table.sort( self.dataList, function(first , second)
		return first.no < second.no;
	end )
	self.tableView:reloadData(self.dataList);

end

function BankPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.BankTaskItem:create(cell);
		cellNode:setTag(999);
    end
    cellNode:Init(self.dataList[index + 1], self.season_id, self.is_recharge);
end

function BankPanel:cellItemTouch( table,cell )
	local tag = cell:getTag()

end

function BankPanel:getReward(sender , event)
	local msg = {};
    msg.season_id = self.season_id;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_round_mission_rwd, msg);
end

function BankPanel:retGetReward(msg)
    self:onShow();
    UIManager:push('RewardPanel',msg);
end

function BankPanel:clickBuy()
	-- body
	local buyItem = {
        no = self.season_id,
        type = 9
    }
    sdkManager.PaymentHelper:onPayment(buyItem,handler(self,self.retBuyEnd));
end

function BankPanel:retBuyEnd(msg)
    -- self:updateCurBattlepassData()
    -- self.bpNumLabel:setString( model.EventModel:getEventBPPoint() )
    -- self:updateRwdList();
    -- UIManager:push('RewardPanel',msg)
end

function BankPanel:checkMonthCard( data )
    -- body
    if data.sale==1 then
        self.saleNode:setVisible(true)
        local price = ResTable:getValue('price', self.payData.sale_price, CURRENCY) or 0;
        self.priceLabel:setString(tostring(string.format(LANG.UI_ROUND_31,tostring(price))))
    end
end

function BankPanel:onLeave()
    self.root:setVisible(false);
end
function BankPanel:onClickBack()
    TimeManager:registUpdateEvent('BankPanel',nil,true);
    UIManager:pop('BankPanel');
end

return BankPanel
