local BareCollectActiveTipPanel = class("BareCollectActiveTipPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local homeImagePath = 'image/equip/'

function BareCollectActiveTipPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'BareCollectActiveTipPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function BareCollectActiveTipPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function BareCollectActiveTipPanel:initPanels()

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -35);
    bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(604 , 561));

	local bg = cc.Scale9Sprite:create('image/commonImg/top_1_bg_71_46.png');
	bg:addTo(self.root);
	bg:setPosition(0 , 268.5);
    bg:setCapInsets(cc.rect(10,0,51,46));
	bg:setContentSize(cc.size(604 , 46));

	local bg = cc.Sprite:create('image/commonImg/menu_light_582_36.png');
	bg:addTo(self.root);
	bg:setPosition(0 , 291);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.root);
	bg:setPosition(0 , 4);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(582 , 471));

	local label = cc.Label:createWithTTF(LANG.UI_BARE_COLLECT_6 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.root);
	label:setPosition(0 , 269);

	local bg = cc.Sprite:create('image/commonImg/arrow_bg.png');
	bg:addTo(self.root);
	bg:setPosition(-259 , 207);

	local label = cc.Label:createWithTTF(LANG.UI_BARE_COLLECT_7 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.root);
	label:setPosition(-235 , 207);
	label:setAnchorPoint(0 , 0.5);
	label:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	local activeBg = cc.Sprite:create('image/bareCollect/bare_collect_12.png');
	activeBg:setPosition(0 , 46);
	activeBg:addTo(self.root);

	local costBg = cc.Sprite:create('image/bareCollect/bare_collect_11.png');
	costBg:setPosition(0 , -162);
	costBg:addTo(self.root);
	
	local costNodePos = {cc.p(-135 , -137),cc.p(140 , -137),cc.p(0,-187)};
	local costName = {LANG.UI_BARE_COLLECT_8,LANG.UI_BARE_COLLECT_9,LANG.UI_BARE_COLLECT_12};
	self.costList = {};
	for i = 1 , 3 do

		self.costList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(costNodePos[i]);

		local costIcon = cc.Sprite:create();
		costIcon:setPosition(i == 3 and -244 or -111, 2);
		costIcon:setScale(0.5);
		costIcon:addTo(node);
		self.costList[i].costIcon = costIcon;

		local label = cc.Label:createWithTTF(costName[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setPosition(i ==3 and -171 or -57 , 0);
		label:setTextColor(cc.c4b(160 , 200 , 255 , 255));

		local cost = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
		cost:addTo(node);
		cost:setAnchorPoint(1 , 0.5);
		cost:setPosition(i == 3 and 258 or 117 , 0);
		self.costList[i].cost = cost;
	end

	local label = cc.Label:createWithTTF(LANG.UI_BARE_COLLECT_10 , fonts.FONT_SIYUAN , 20);
	label:enableOutline(cc.c3b(120 , 120 , 120) , 2);

	local activeBtn = ccui.Button:create('image/commonImg/btn_1_219_55_2.png' , 'image/commonImg/btn_1_219_55_2.png');
	activeBtn:addTo(self.root);
	activeBtn:setPosition(-132 , -275);
	activeBtn:setTag(1);
	activeBtn:addClickEventListener(handler(self , self.activeClick));
	activeBtn:setTitleLabel(label);


	local label = cc.Label:createWithTTF(LANG.UI_BARE_COLLECT_11 , fonts.FONT_SIYUAN , 20);
	label:enableOutline(cc.c3b(50 , 85 , 150) , 2);

	local activeAllBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	activeAllBtn:addTo(self.root);
	activeAllBtn:setPosition(132 , -275);
	activeAllBtn:setTag(2);
	activeAllBtn:addClickEventListener(handler(self , self.activeClick));
	activeAllBtn:setTitleLabel(label);
end

function BareCollectActiveTipPanel:onEnter(bareId , pos)

	self:addSwallowCallback(handler(self , self.onClickBack));

	local bareData = model.BareCollectModel:getBareData(bareId);

	if bareData then
		if bareData.activation_cost then

			local costMoney = bareData.activation_cost[1];
			local icon = ResTable:getValue('item',costMoney,'icon');

			local haveNum = model.ItemModel:getItemNum(costMoney);
			self.costList[1].costIcon:setTexture('image/icon/I'..icon..'.png');
			self.costList[1].cost:setString(tostring(haveNum));

			self.costList[2].costIcon:setTexture('image/icon/I'..icon..'.png');
			self.costList[2].cost:setString(tostring(bareData.activation_cost[2]));

			self.costList[3].costIcon:setTexture('image/icon/I'..icon..'.png');
			if bareData.activeNum then
				local activeNum = 12 - bareData.activeNum;
				self.costList[3].cost:setString(tostring(bareData.activation_cost[2] * activeNum));
			end
		end
	end
	
	self.curBareId = bareId;
	self.curPos = pos;

	self.root:setVisible(true);
end

function BareCollectActiveTipPanel:activeClick(sender , event)
	local tag = sender:getTag();

	local pos = self.curPos;
	if tag == 2 then
		pos = 0;
	end

	local msg = {};
    msg.bare_id = self.curBareId;
    msg.pos = pos;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_bare_collect_active, msg);
end

function BareCollectActiveTipPanel:onClickBack()
	UIManager:pop('BareCollectActiveTipPanel');
end

function BareCollectActiveTipPanel:onLeave()
	self.root:setVisible(false);
end

function BareCollectActiveTipPanel:guideRandomClick( ... )
	local btn = self.root:getChildByTag(1)
	self:activeClick(btn,null);
end

-- 引导相关
function BareCollectActiveTipPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 85 then
		local btn = self.root:getChildByTag(1)
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return BareCollectActiveTipPanel;
