local BareCollectPanel = class("BareCollectPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/bareCollect/'
local cvTypeEnum = Enum:getTable("cvTypeEnum");
local BareItemId = 14003;

function BareCollectPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'BareCollectPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function BareCollectPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self.curIdx = 1;
	self.curPos = nil
	self.saveIdx = 1;
	self:initPanels()
end

function BareCollectPanel:initPanels()

	local bg = cc.Sprite:create('image/bg/Bg_6.png');
	bg:addTo(self.root);

	self.barePageView = ccui.PageView:create();
	self.barePageView:addTo(self.root);
	self.barePageView:setPosition(0 , 31);
	self.barePageView:setContentSize(cc.size(640 , 938));
	self.barePageView:setAnchorPoint(0.5,0.5);
    self.barePageView:addEventListener(handler(self , self.pageViewEvent));

	self.posNode = cc.Node:create();
	self.posNode:addTo(self.root);
	self.posNode:setPosition(0 , -452);

	self.zfNode = cc.Node:create()
	self.zfNode:addTo(self.root)
	self.zfNode:setPosition(250, StageSize.height/2-130-NOTCH_HEIGHT)
	local zfBtn = ccui.Button:create(imagePath..'zf_enter.png',imagePath..'zf_enter.png')
		:addTo(self.zfNode)
	zfBtn:addClickEventListener(handler(self , self.openZfPanel));
	local zfLabel = cc.Label:createWithTTF(LANG.UI_BARE_ZF_1, fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c3b(60 , 60 , 60) , 2)
		:addTo(self.zfNode)
		:setPosition(0, -20)

	local isLock = tools.ConfigStateTools:checkLockById(5400);
	self.zfNode:setVisible(not isLock)


	local itemNode = cc.Node:create()
	itemNode:addTo(self.root)
	itemNode:setPosition(-200, StageSize.height/2-60-NOTCH_HEIGHT)
	local itemBg = cc.Scale9Sprite:create('image/commonImg/com_bg.png')
	itemBg:addTo(itemNode)
	itemBg:setContentSize(cc.size(150, 40))
	local itemIcon = cc.Sprite:create('image/icon/I14003.png')
	itemIcon:addTo(itemNode)
	itemIcon:setPosition(-50, 0)
	itemIcon:setScale(0.5)
	self.itemNumLabel = cc.Label:createWithTTF('9999', fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c3b(60 , 60 , 60) , 2)
		:addTo(itemNode)
		:setPosition(30, 0)

	self:registEvent();

	self:addTouchEvent();
end

function BareCollectPanel:addTouchEvent()

	-- if self.touchListener then
	-- 	local eventDispatcher = cc.Director:getInstance():getEventDispatcher();
	-- 	eventDispatcher:removeEventListener(self.touchListener);
	-- end
	-- -- listener
	-- local toucheBegan = function(touches, event)
	-- 	print('fubin---touch SCROLLVIEW_SCROLL')
 --    end
	
	-- self.touchListener = cc.EventListenerTouchOneByOne:create()
 --    self.touchListener:registerScriptHandler(toucheBegan, cc.Handler.SCROLLVIEW_SCROLL)

 --    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
 --    eventDispatcher:addEventListenerWithSceneGraphPriority(self.touchListener, self.barePageView)
end

function BareCollectPanel:registEvent()
    EventManager:RegisterEvent(EventType.NetworkRetBareCollectActive,handler(self,self.retBareCollectActive));
    EventManager:RegisterEvent(EventType.NetworkRetBareCollectAddNew,handler(self,self.onShow));
end

function BareCollectPanel:onEnter(bareId)
	self.isGuide = false;
	if bareId == 0 then
		self.bareId = nil;
		self.saveIdx = 1;
		self:onUpdateArgs(1, nil)
	else
		self.bareId = bareId;
	end

	-- self.bareId = bareId;
	self.root:stopAllActions();
	self.isShowAnimation = false;
	if not model.BareCollectModel:isInitAddNew() then
		Network.NetworkManager:Send(Network.NetworkCmdType.req_bare_collect_add_new, {});
	else
		self:onShow();
	end
	TimeManager:registUpdateEvent('BareCollectPanel',handler(self,self.onEnterFrame),false);
end

function BareCollectPanel:onEnterFrame()
	if self.root:isVisible() then
		local page = self.barePageView:getCurrentPageIndex() + 1;
		if page ~= self.curIdx then
	        local data = self.bareDatas[page]
	        if data.needInit then
				self.bareList[data.bare_id]:Init(data);
			end
			self.curPos:setPositionX(self.posXList[page]);
	    end
	end
end

function BareCollectPanel:onShow()
	local bareCollectData =  model.BareCollectModel:getBareData();

	local activeNum = 0;
	local bareDatas = {};

	for _k , bare in pairs(bareCollectData) do
		if bare.activeState == 1 then
			activeNum = activeNum + 1;
		end
		table.insert(bareDatas , bare);
	end

	local bareNum = #bareDatas;

	if bareNum > 1 then
		table.sort(bareDatas , function(first , second)
			if first.activeState == 1 and second.activeState ~= 1 then
				return true;
			elseif first.activeState ~= 1 and second.activeState == 1 then
				return false;
			end
			
			return first.order < second.order;
		end);
	end

	self.bareDatas = bareDatas;

	local moveToPage = 0;
	local speed = 0.02;

	if self.curPos == nil then
		self.barePageView:removeAllPages();
		
		self.bareList= {};
		for i = 1 ,bareNum do
			local data = bareDatas[i];
			local widget = ccui.Widget:create();
			widget:setContentSize(cc.size(640 , 938));
			self.barePageView:addPage(widget);
			local template = template.BareCollectTemplate:create();
			template:setIndexPos(i);
			template:addTo(widget);
			template:setPosition(320 , 469);
			template:setLargeBtnTag(data.bare_id)
			template:addLargeBtnClickEventListener(handler(self , self.lareBtnClick))
			template:addBgTouchEvent(handler(self , self.bareCollectClick))
			template:setBgBtnTag(data.bare_id)
			if (not self.bareId and i == 1) or self.bareId == data.bare_id then
				template:Init(data);
			else
				-- template:runAction(cc.Sequence:create(cc.DelayTime:create(speed*i),cc.CallFunc:create(function()
				-- 	template:Init(data);
				-- end)))
			end
			self.bareList[data.bare_id] = template;
			if self.bareId == data.bare_id then
				moveToPage = i-1;
			end
		end

		self.posNode:removeAllChildren();
		self.posXList = {};
		local posX = -30 * (bareNum-1) / 2
		for i = 1 , bareNum do
			-- local bg = cc.Sprite:create('image/bareCollect/bare_collect_7.png');
			-- bg:setPosition(posX + 30*(i-1) , 0);
			-- bg:addTo(self.posNode);

			local btn = ccui.Button:create('image/bareCollect/bare_collect_7.png');
			btn:addTo(self.posNode);
			btn:setTag(i);
			--self.largeBtn:setSwallowTouches(false);
			btn:setPosition(posX + 30*(i-1) , 0);
			btn:addClickEventListener(handler(self , self.clickChangePage));
			
			self.posXList[i] = posX + 30*(i-1);
		end

		self.curPos = cc.Sprite:create('image/bareCollect/bare_collect_8.png');
		self.curPos:addTo(self.posNode);

	else
		for i = 1 ,bareNum do
			local data = bareDatas[i];
			if (not self.bareId and i == 1) or self.bareId == data.bare_id then
				if data.needInit then
					self.bareList[data.bare_id]:Init(data);
				end
			end
			if self.bareId == data.bare_id then
				moveToPage = i-1;
			end
		end

	end

	if self.bareId then
		self.barePageView:setCurrentPageIndex(moveToPage);
		self.curPos:setPositionX(self.posXList[moveToPage+1]);
		self.curIdx = moveToPage+1;
		self.saveIdx = self.curIdx;
	else
		self.barePageView:setCurrentPageIndex(self.saveIdx-1);
	    self.curPos:setPositionX(self.posXList[self.saveIdx]);
	end

	local haveNum = model.ItemModel:getItemNum(BareItemId);
	self.itemNumLabel:setString( tostring(haveNum) )

	self.root:setVisible(true);

end

function BareCollectPanel:pageViewEvent(sender , event)
	if event == ccui.PageViewEventType.turning then
		local page = self.barePageView:getCurrentPageIndex() + 1;
        self.curPos:setPositionX(self.posXList[page]);
        self.saveIdx = page;

        -- local data = self.bareDatas[page]
        -- if data.needInit then
        -- 	self.bareList[data.bare_id]:Init(data);
        -- end

    end

end

function BareCollectPanel:clickChangePage(sender, event)
	local idx = sender:getTag();
	if (self.barePageView:getCurrentPageIndex() + 1) == idx then
		return;
	end
	self.barePageView:setCurrentPageIndex(idx-1);
    self.curPos:setPositionX(self.posXList[idx]);
    self.saveIdx = idx;
end
--[[
function BareCollectPanel:bareListViewEventListener(sender , event)
	if event == ccui.ScrollviewEventType.containerMoved then
		local posX = self.bareListView:getInnerContainerPosition().x;
		self:updateMoveX(posX);
	end
end

function BareCollectPanel:updateMoveX(posX)
	for _k , v in pairs(self.bareList) do
		if v.setMovePosX then
			v:setMovePosX(posX);
			local curBare = v:getIndexPos();
			if v:getCurState() == 1 and curBare ~= self.curBare then
				if self.posXList[curBare] then
					self.curBare = curBare;
					self.curPos:setPositionX(self.posXList[curBare]);
					local bareId = v:getBareId();
					local bareData = model.BareCollectModel:getBareData(bareId);
					if bareData.activeState ~= 0 then
						self.bg:setVisible(true);
						self.bg:setTexture('image/role/'..bareData.res_name..'.png');
					else
						self.bg:setVisible(false);
					end
				end
			end
		end
	end
end
]]
function BareCollectPanel:lareBtnClick(sender , event)
	local tag = sender:getTag();
	AudioManager:playEffect(Conf.confirmButton);
	local bareData = model.BareCollectModel:getBareData(tag);
	if bareData then
		if bareData.activeState ~= 0 and bareData.activeNum >= 12 then
			UIManager:push('BareCollectViewPanel',tag);
		end
	end
end

function BareCollectPanel:bareCollectClick(sender , event)
	local tag = sender:getTag();
	self:activeClick(tag);
end

function BareCollectPanel:activeClick(bareId , pos)

	if self.isShowAnimation then
		return;
	end

	local bareData = model.BareCollectModel:getBareData(bareId);
	if bareData.activeState == 0  then
		AudioManager:playCVStopBefor(bareData.role_id,nil ,cvTypeEnum.CV_BROKEN);
		return;
	end
	if  bareData.activeNum >= 12 then
		return;
	end
	--AudioManager:preloadCVFile(bareData.role_id)
	AudioManager:playCVStopBefor(bareData.role_id,nil ,cvTypeEnum.CV_BROKEN);

	if bareData.mapState then
		local posList = {};
		for i = 1 , 12 do
			if not bareData.mapState[i] then
				table.insert(posList , i);
			end
		end
		local pos = posList[math.random(1,#posList)];
		UIManager:push('BareCollectActiveTipPanel',bareId,pos);
		return;
	end
end

function BareCollectPanel:retBareCollectActive(data)
	UIManager:pop('BareCollectActiveTipPanel');
	local bareData = model.BareCollectModel:getBareData(data.bare_id);
	if bareData then
		if data.pos == 0 then
			model.BareCollectModel:setBareDataInitEnd(data.bare_id, true)
			self:showAllActiveSpine(data.bare_id);
			
			-- 解锁全部
			AudioManager:playCVStopBefor(bareData.role_id ,nil,cvTypeEnum.CV_PURIFIED,12);

		else
			self.isShowAnimation = true;
			-- 解锁随机一个
			AudioManager:playCVStopBefor(bareData.role_id ,nil,cvTypeEnum.CV_PURIFIED,bareData.activeNum ); -- data.pos，改为播放

			self.bareList[data.bare_id]:showSlotMachine(data.pos,function()
				if bareData.activeNum >= 12 then
					model.BareCollectModel:setBareDataInitEnd(data.bare_id, true)
					--if self.bareList[data.bare_id] then
					--	self.bareList[data.bare_id]:Init(bareData);
					--end
					UIManager:push('BareCollectViewPanel',data.bare_id);
					--self.root:runAction(cc.Sequence:create(cc.DelayTime:create(0.01) , cc.CallFunc:create(function()
					--	UIManager:push('BareCollectViewPanel',data.bare_id,0,Enum:getTable('LiveEnterType').BARE_COLLECT);
					--end)));
				end
				self.isShowAnimation = false;
			end)
		end
	end

	local haveNum = model.ItemModel:getItemNum(BareItemId);
	self.itemNumLabel:setString( tostring(haveNum) )

	if self.isGuide == true then
		self.isGuide = false;
		if model.ShopModel:getShopGiftData(3) then
			local act2 = function ( )
				UIManager:push('ShopGiftRecommendPanel')
			end
			self.root:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create( act2 )))
		end
	end
end

function BareCollectPanel:showAllActiveSpine(bareId)
	self.isShowAnimation = true;
	ShowAnimationPanel:Show('BareCollectViewPanel' , function()
		local animationNode = ShowAnimationPanel:getAnmiationNode();
		if cc.FileUtils:getInstance():isFileExist('spine/tiaozhuan_spine/tiaozhuan_spine.json') then
			local bareCollectSpine = sp.SkeletonAnimation:create('spine/tiaozhuan_spine/tiaozhuan_spine.json', 'spine/tiaozhuan_spine/tiaozhuan_spine.atlas', 1)
	
			bareCollectSpine:addTo(animationNode)
			bareCollectSpine:setPosition(3 , 67);
			bareCollectSpine:setAnimation(0, "tiaozhuan_spine", false);
			bareCollectSpine:registerSpineEventHandler(function (event)
				if event.eventData.name == 'tiaozhuan' then
					UIManager:push('BareCollectViewPanel',bareId);
				end
			end, sp.EventType.ANIMATION_EVENT);
			bareCollectSpine:registerSpineEventHandler(function (event)
				bareCollectSpine:runAction(cc.Sequence:create(cc.DelayTime:create(0.01), cc.CallFunc:create(function() 
					ShowAnimationPanel:Hide()
					self.isShowAnimation = false;
				end)));
			end, sp.EventType.ANIMATION_COMPLETE)
			
		end
	end);
end

function BareCollectPanel:onClickBack()
	if self.isShowAnimation then
		return;
	end
	
	UIManager:pop('BareCollectPanel');
end

function BareCollectPanel:onLeave()
	self.isShowAnimation = false;
	self.root:stopAllActions();
	self.root:setVisible(false);
	TimeManager:registUpdateEvent('BareCollectPanel',nil,false);
end

function BareCollectPanel:guideBareItemLargeCall( ... )
	if self.bareDatas and self.bareDatas[1] then
		self:showActivePanel(self.bareDatas[1].bare_id)
	end
end

function BareCollectPanel:guideBareItemBgCall( ... )
	if self.bareDatas and self.bareDatas[1] then
		self:activeClick(self.bareDatas[1].bare_id , 1)
	end
	
end

function BareCollectPanel:openZfPanel()
	UIManager:push('ZfUpPanel');
end


-- 引导相关
function BareCollectPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 84 then
		local btn = self.barePageView:getItem(0):getChildren()[1];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
		local ret = model.UserDefaultModel:getLanguageSet();
		if ret == 'cn' then
			self.isGuide = true;
		end
	end
	return pos;
end

return BareCollectPanel;
