local BattlePassGiftPanel = class('BattlePassGiftPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/battlePass/'

function BattlePassGiftPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'BattlePassGiftPanel');

	self.useCCreator = false;
    self.isPopup = true;
    
end

function BattlePassGiftPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
  
      self:initPanel();
end

function BattlePassGiftPanel:initPanel(  )
    
    local node = cc.Node:create()
        :addTo(self.root)
    
    local bg = ccui.Layout:create();
    bg:addTo(node);
    bg:setBackGroundImage(imagePath..'battlepass_gift_bg_1.png');
    bg:setTouchEnabled(true);

    self.label = cc.Label:createWithTTF('' ,'font/SourceHanSansCN-Medium.otf',20)
        :addTo(node)
        :setVisible(false)

    self.btn = ccui.Button:create(imagePath..'battlepass_gift_btn_1.png',imagePath..'battlepass_gift_btn_1.png')
    self.btn:addTo(node)
    self.btn:setPosition(0,-402)
    self.btn:addClickEventListener(handler(self,self.battlepassGiftBuy))
    -- self.btn:setTitleLabel(self.giftBtn[i].label);

    local scView = ccui.ScrollView:create();
    scView:setTouchEnabled(true); 
    scView:setBounceEnabled(true);
    scView:setDirection(ccui.ScrollViewDir.horizontal);
    scView:setContentSize(cc.size(360, 120));
    scView:setAnchorPoint(cc.p(0.5, 0.5));
    scView:setPosition(0 , -105);
    scView:setScrollBarEnabled(false);
    scView:addTo(node);
    self.scView = scView;

end

function BattlePassGiftPanel:onEnter()

    self:addSwallowCallback(handler(self , self.onClickBack))

    local giftData = nil;
    local battlepassId = model.BattlepassEventModel:getBattlepassId();
    local battlepassGift = ResTable:getTable('battlepass_gift').contain;
    for _k , data in pairs(battlepassGift) do
        if data.battlepass_id == battlepassId then
            giftData = data;
            break;
        end
    end

    if not giftData then
        return;
    end

    self.btn:setTag(giftData.no);
    -- self.label:setString(tostring(string.format(LANG.UI_SHOP_72,giftData.price)));

    local rewardNum = #giftData.gift;
    self.scView:removeAllChildren();
    self.scView:setInnerContainerSize(cc.size(360, 120));
    for i=1, rewardNum do
        local r = giftData.gift[i];
        local layout = ccui.Layout:create();
        layout:addTo(self.scView);
        local icon = template.ItemTemplate:create(2);
        icon:addTo(layout);
        icon:Init(r[1] , r[2]);
        icon:setScale(0.8);
        icon:setPosition(45 + 90 * (i - 1) , 50);
    end
    self.scView:setTouchEnabled(rewardNum > 4);

    self.root:setVisible(true);
end

function BattlePassGiftPanel:battlepassGiftBuy(sender , event)
    local tag = sender:getTag()
    local buyItem = {
        no = tag,
        type = 7
    }
    EventManager:FireEvent(EventType.UIBuyBattlepassSpecial , buyItem);
    self:onClickBack()
end


function BattlePassGiftPanel:onLeave()
    self.root:setVisible(false);
end

function BattlePassGiftPanel:onClickBack()
    UIManager:pop('BattlePassGiftPanel');
end

return BattlePassGiftPanel

