local BattlepassPanel = class('BattlepassPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/battlePass/'
local CommonShopType = Enum:getTable('CommonShopType');
local BATTLEPASS_MOVE_Y = 251;
local BATTLEPASS_VIEW_HEIGHT = StageSize.height + BATTLEPASS_MOVE_Y;
local SHOP_SCROLL_VIEW_HEIGHT = 0;

function BattlepassPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'BattlepassPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = false;
end

function BattlepassPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
  
      self:initPanel();
  
      self:registEvent();
end

function BattlepassPanel:initPanel(  )
    
    local bg = cc.Sprite:create('image/bg/Bg_5.png')
    :addTo(self.root)

    self.bpNode = cc.Node:create()
        :addTo(self.root)

    self.bpScrollView = ccui.ScrollView:create();
	self.bpScrollView:setTouchEnabled(true)
        :setBounceEnabled(false)
        :setDirection(ccui.ScrollViewDir.vertical)
        :setContentSize(cc.size(640 , StageSize.height))
        :setAnchorPoint(cc.p(0.5,0.5))
        :setScrollBarEnabled(false)
        :addTo(self.bpNode)
        :setInnerContainerSize(cc.size(640,BATTLEPASS_VIEW_HEIGHT))
        :addEventListener(handler(self , self.bpScrollViewListener))

    local bpTopHeight = BATTLEPASS_VIEW_HEIGHT/2;
    local node = ccui.Layout:create()
        :addTo(self.bpScrollView)
        :setPosition(320,bpTopHeight)

    self.bpPoster = cc.Sprite:create(imagePath..'battlepass_posters.png')
        :addTo(node)
        :setPosition(0,bpTopHeight-203.5)

    local label = cc.Label:createWithTTF(LANG.UI_BATTLEPASS_1,fonts.FONT_SIYUAN,20)
        :enableOutline(cc.c3b(145,40,40),2)
    self.bpSpecialBuyBtn = ccui.Button:create(imagePath..'battlepass_bg_5.png',imagePath..'battlepass_bg_5.png')
    self.bpSpecialBuyBtn:addTo(node)
    self.bpSpecialBuyBtn:setPosition(-169,bpTopHeight-342)
    self.bpSpecialBuyBtn:setTitleLabel(label)
    self.bpSpecialBuyBtn:addClickEventListener(function() 
        UIManager:push('BattlePassGiftPanel');
    end)

    local bpCountdownNode = cc.Node:create()
        :addTo(node)
        :setPosition(154,bpTopHeight-343)

    local bpCountdownBg = cc.Sprite:create(imagePath..'battlepass_bg_4.png')
        :addTo(bpCountdownNode)

    local bpCountdownLabel = cc.Label:createWithTTF(LANG.UI_BATTLEPASS_2 , fonts.FONT_SIYUAN , 18)
        :addTo(bpCountdownNode)
        :setPosition(0,21)

    self.bpCountdown = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
        :addTo(bpCountdownNode)
        :setPosition(0,-17)
        :setTextColor(cc.c3b(255,255,0))
    
    local bpLevelNode = cc.Node:create()
        :addTo(node)
        :setPosition(0,bpTopHeight-474)
        :setLocalZOrder(5)

    local bpLevelBg = cc.Sprite:create(imagePath..'battlepass_bg_3.png')
        :addTo(bpLevelNode)

    local icon = ResTable:getValue('item' , BATTLEPASS_POINT, 'icon')
    local bpLevelIcon = cc.Sprite:create('image/icon/I'..icon..'.png')
        :addTo(bpLevelNode)
        :setPosition(-249,18)

    local bpLevelProgressBg = cc.Sprite:create(imagePath..'battlepass_bg_7.png')
        :addTo(bpLevelNode)
        :setPosition(0,17)
    
    self.bpLevelProgress = cc.Scale9Sprite:create(imagePath..'battlepass_bg_14.png')
    self.bpLevelProgress:addTo(bpLevelNode)
    self.bpLevelProgress:setAnchorPoint(0,0.5)
    self.bpLevelProgress:setPosition(-197,17)
    self.bpLevelProgress:setCapInsets(cc.rect(10,0,4,13))

    self.bgLevelExp = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
        :addTo(bpLevelNode)
        :setPosition(0,8)
        :enableOutline(cc.c3b(120,80,60) , 2)

    local bpLevelBg = cc.Sprite:create(imagePath..'battlepass_bg_6.png')
        :addTo(bpLevelNode)
        :setPosition(239,18)

    self.bpLevel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18)
        :addTo(bpLevelNode)
        :setPosition(239,18)
        :enableOutline(cc.c3b(0,0,0),2)

    local bpListScrollViewHeight = BATTLEPASS_VIEW_HEIGHT-512

    self.bpListScrollView = template.FrameLoadScrollViewTemplate:create()
    self.bpListScrollView:setAnchorPoint(0.5,0.5);
    self.bpListScrollView:setPosition(0,bpTopHeight-512-bpListScrollViewHeight/2);
    self.bpListScrollView:Init(cc.size(640 , bpListScrollViewHeight) , cc.size(640 , 173),1,0);
    self.bpListScrollView:addLoadCellHandler(handler(self,self.reloadBalltepassCellItem));
    self.bpListScrollView:addTo(node);
    self.bpListScrollView:setBounceEnabled(false)
    self.bpListScrollView:addEventListener(handler(self,self.bpListScrollViewListener));

    self.bpMissionNode = cc.Node:create()
        :addTo(self.root)

    local bpMissionBg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png')
    bpMissionBg:addTo(self.bpMissionNode);
    bpMissionBg:setPosition(0 , 6);
    bpMissionBg:setCapInsets(cc.rect(11,4,18,21));
    bpMissionBg:setContentSize(cc.size(604 , 904));

    local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.bpMissionNode);
	bg:setPosition(0 , 9);
	bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(583,877));

    self.bpMissionScrollView = template.FrameLoadScrollViewTemplate:create()
    self.bpMissionScrollView:setPosition(-282,-415);
    self.bpMissionScrollView:Init(cc.size(564 , 856) , cc.size(564 , 132) , 1 , 0);
    self.bpMissionScrollView:addLoadCellHandler(handler(self,self.reloadMissionCellItem));
    self.bpMissionScrollView:addTo(self.bpMissionNode);

    self.bpMissionMenu = {};
    for i = 1 , 3 do

        local texture = 'image/commonImg/menu_left_71_46.png';
        local unTexture = 'image/commonImg/menu_left_71_46_u.png';

        if i == 2 then
            texture = 'image/commonImg/menu_mid_71_46.png';
            unTexture = 'image/commonImg/menu_mid_71_46_u.png';
        end
        
        self.bpMissionMenu[i] = {};

        local node = cc.Node:create();
        node:addTo(self.bpMissionNode);
        node:setPosition(-201 + 201*(i-1) , 480);
        self.bpMissionMenu[i].node = node;

        local btn = ccui.Button:create(texture , texture , unTexture);
        btn:addTo(node);
        btn:setTag(i);
        btn:addClickEventListener(handler(self , self.missionMenuClick));
        btn:setScale9Enabled(true);
        btn:setCapInsets(cc.rect(10 , 0 , 39 , 46));
        btn:setContentSize(cc.size(201 , 46));
        self.bpMissionMenu[i].btn = btn;

        local light = cc.Sprite:create('image/commonImg/menu_light_1.png');
        light:addTo(node);
        light:setPosition(0 , btn:getContentSize().height/2);
        self.bpMissionMenu[i].light = light;

        local label = cc.Label:createWithTTF(LANG.UI_BATTLEPASS_MISSION_MENU[i] , fonts.FONT_SIYUAN , 20);
        label:setTextColor(cc.c3b(180 , 180 , 180));
        btn:setTitleLabel(label);
        self.bpMissionMenu[i].label = label;
    end

    self.bpShopNode = cc.Node:create()
        :addTo(self.root)

    local topHeight = NOTCH_HEIGHT+154
    local topBg = cc.Sprite:create('image/shop/shop_top_bg.png')
        :setPosition(0,StageSize.height/2-topHeight)
        :addTo(self.bpShopNode)
    
    local titleHeight = 46;
    local topBgHeight = topBg:getContentSize().height;
    local titltPosY = StageSize.height/2-topHeight-topBgHeight/2-titleHeight/2;

    local shopTitleNode = cc.Node:create()
        :addTo(self.bpShopNode)
        :setPosition(0 , titltPosY)

    local topBg = cc.Sprite:create('image/commonImg/title_bg_1_604_46.png')
        :addTo(shopTitleNode)

    local lightBg = cc.Sprite:create('image/commonImg/menu_light_2.png')
        :addTo(shopTitleNode)
        :setPosition(0 , 22)

    self.shopTitle = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18)
        :addTo(shopTitleNode)

    local haveMoneyNode = cc.Node:create()
        :addTo(self.bpShopNode)
        :setPosition(188 , titltPosY)

    local bg = cc.Sprite:create('image/commonImg/bg_3_200_42.png')
        :addTo(haveMoneyNode)

    self.moneyIcon = cc.Sprite:create()
        :addTo(haveMoneyNode)
        :setPosition(-71 , 0)
        :setScale(0.35)

    local moneyLabel = cc.Label:createWithTTF(LANG.UI_CARD_19 , fonts.FONT_SIYUAN , 20)
	    :addTo(haveMoneyNode)
	    :setPosition(-26 , 0)
	    :setTextColor(cc.c3b(160 , 200 , 255))

    self.moneyNum = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
        :addTo(haveMoneyNode)
        :setAnchorPoint(1 , 0.5)
        :setPosition(86 , 0)

    local bpShopScrollViewBg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
    bpShopScrollViewBg:addTo(self.bpShopNode);
    bpShopScrollViewBg:setCapInsets(cc.rect(11,4,18,21));
    bpShopScrollViewBg:setContentSize(cc.size(602,690));

    self.bpShopScrollView = ccui.ScrollView:create();
    self.bpShopScrollView:setTouchEnabled(true)
        :setBounceEnabled(true)
        :setDirection(ccui.ScrollViewDir.vertical)
        :setScrollBarEnabled(false)
        :addTo(self.bpShopNode)

    local bgHeight = StageSize.height-topHeight-topBgHeight/2-titleHeight-FOOTER_HEIGHT;
    local bgPosY = titltPosY-titleHeight/2-bgHeight/2+2;
    SHOP_SCROLL_VIEW_HEIGHT = bgHeight-62;
    local scrollPosY = bgPosY - bgHeight/2 + 51;

    bpShopScrollViewBg:setPosition(0 , bgPosY);
    bpShopScrollViewBg:setContentSize(cc.size(602,bgHeight));

    self.bpShopScrollView:setPosition(-290.5 , scrollPosY);
    self.bpShopScrollView:setContentSize(cc.size(581 , SHOP_SCROLL_VIEW_HEIGHT));

    local battlepassMenuNode = cc.Node:create()
        :addTo(self.root)
        :setPosition(0,-StageSize.height/2+56)

    local battlepassMenuBg = cc.Scale9Sprite:create(imagePath..'battlepass_bg_1.png');
    battlepassMenuBg:addTo(battlepassMenuNode);
    battlepassMenuBg:setCapInsets(cc.rect(0,5,9,111));
    battlepassMenuBg:setContentSize(cc.size(640,111));

    self.battlepassSelectImg = cc.Sprite:create(imagePath..'battlepass_bg_2.png')
        :addTo(battlepassMenuNode)
        :setPosition(0,-9)

	self.battlepassMenu = {};
    for i = 1 , 4 do
        self.battlepassMenu[i] = {};
        local node = cc.Node:create();
        node:addTo(battlepassMenuNode);
        node:setPosition(-240 + 160*(i-1) , -13);
        self.battlepassMenu[i].node = node;

        local btn = ccui.Button:create(imagePath..'battlepass_footer_'..i..'.png',imagePath..'battlepass_footer_'..i..'.png');
        btn:addTo(node);
        btn:setTag(i);
        btn:addClickEventListener(handler(self , self.battlepassMenuClick));
        self.battlepassMenu[i].btn = btn;

        local label = cc.Label:createWithTTF(LANG.UI_BATTLEPASS_MUNE_NUM[i] , fonts.FONT_SIYUAN , 20)
            :addTo(node)
            :setPosition(0,-30)

        if i > 1 then
            local line = cc.Sprite:create('image/footer/footer_bg_3.png')
                :addTo(battlepassMenuNode)
                :setPosition(-160 + 160*(i-2),-9)
        end
    end
end

function BattlepassPanel:registEvent()
    EventManager:RegisterEvent(EventType.NetworkRetBattlepassData, handler(self, self.onShow));
    EventManager:RegisterEvent(EventType.NetworkRetBattlepassReward, handler(self, self.retBattlepassReward));
    EventManager:RegisterEvent(EventType.NetworkRetBattlepassMissionReward, handler(self, self.retBattlepassMissionReward));
    EventManager:RegisterEvent(EventType.UIRetBattlepassInfo, handler(self, self.retBattlepassShop));
    EventManager:RegisterEvent(EventType.UIRetBattlepassShopBuy, handler(self, self.retBattlepassShopBuy));
    EventManager:RegisterEvent(EventType.UIBuyBattlepassSpecial, handler(self, self.buyBattlepassSpecial));
end

function BattlepassPanel:onEnter()
    if model.BattlepassModel:isInit() then
        self:onShow()
    else
        Network.NetworkManager:Send(Network.NetworkCmdType.req_battlepass_data, {});
    end
end

function BattlepassPanel:onShow()

    if not self.haveInitialize then
		return
    end
    model.ShopModel:resetShopInit()
    self.battlepassType = 1;
    self:updateBattlepass();

    self.root:setVisible(true)
end

function BattlepassPanel:updateVisible()
    self.openMenuList =  tools.ConfigStateTools:setVisibleByType(Enum:getTable('ConfigStateType').BATTLEPASS , self.menuList);
    if not self.openMenuList or #self.openMenuList <= 0 then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('BattlepassPanel');
        return
    end

    table.sort(self.openMenuList , function(first , second)
        return first.index < second.index;
    end);

    self.battlepassType = nil;

    for _k , openData in ipairs(self.openMenuList) do
        self.menuList[openData.index]:setPositionX(-180 + 120 * (_k - 1));
        if not self.battlepassType and openData.state == 0 then
            self.battlepassType = openData.index;
        end
    end

    if not self.battlepassType then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('BattlepassPanel');
        return
    end
end

function BattlepassPanel:battlepassMenuClick(sender , event)
    local tag = sender:getTag();
    self.battlepassType = tag;
    self:updateBattlepass()
end

function BattlepassPanel:updateBattlepass()

    self.battlepassSelectImg:setPositionX(-240 + 160*(self.battlepassType-1));

    self.bpNode:setVisible(self.battlepassType == 1);
    self.bpMissionNode:setVisible(self.battlepassType == 2);
    self.bpShopNode:setVisible(self.battlepassType == 3 or self.battlepassType == 4);
    self.curShopType = 0;
    TimeManager:registUpdateEvent('BattlepassPanel',nil,true);

    if self.battlepassType == 1 then
        self:showBattlepass();
    elseif self.battlepassType == 2 then
        self:updateBattlepassMission(1);
    elseif self.battlepassType == 3 then
        self:showBattlepassShop(CommonShopType.BATTLEPASS_1)
    elseif self.battlepassType == 4 then
        self:showBattlepassShop(CommonShopType.BATTLEPASS_2)
    end
end

function BattlepassPanel:showBattlepassShop(shopType)
    if not model.ShopModel:shopHasInit(shopType) then
        model.ShopModel:reqShopInfo(shopType);
        return
    end
    self:updateShop(shopType)
    self:updateShopMoney(shopType)
end

function BattlepassPanel:retBattlepassShop(msg)
    self:updateShop(msg.index)
    self:updateShopMoney(msg.index)
end
function BattlepassPanel:updateShopMoney(shopType)
    local image = imagePath..'shop_top_bg.png';
    if shopType == CommonShopType.BATTLEPASS_1 then
        local num = model.ItemModel:getItemNum(BATTLEPASS_SHOP_1_ITEM);
        self.moneyNum:setString(tostring(num));
        local itemIcon = ResTable:getValue('item' , BATTLEPASS_SHOP_1_ITEM , 'icon');
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        self.shopTitle:setString(tostring(LANG.UI_BATTLEPASS_MUNE_NUM[3]));
    else
        local num = model.ItemModel:getItemNum(BATTLEPASS_SHOP_2_ITEM);
        self.moneyNum:setString(tostring(num));
        local itemIcon = ResTable:getValue('item' , BATTLEPASS_SHOP_2_ITEM , 'icon');
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        self.shopTitle:setString(tostring(LANG.UI_BATTLEPASS_MUNE_NUM[4]));
    end
end
function BattlepassPanel:updateShop(shopType)
    local battlepassShop = model.ShopModel:getShopDataByIndex(shopType);
    if not battlepassShop then
        return;
    end

    self.curShopType = shopType;

    local shopData = {};

    for _k , data in pairs(battlepassShop) do
        table.insert(shopData , data);
    end

    if #shopData > 1 then
        table.sort(shopData , function(first , second)
            return (first.order or first.no) <(second.order or second.no);
        end);
    end

    self.shopItems = {};
    self.bpShopScrollView:removeAllChildren();

    local num = math.ceil(#shopData/3);
    local maxHeight = num * 203+5;
    if maxHeight < SHOP_SCROLL_VIEW_HEIGHT then
        maxHeight = SHOP_SCROLL_VIEW_HEIGHT;
    end
    
    self.bpShopScrollView:setInnerContainerSize(cc.size(581,maxHeight))

    for _k , data in ipairs(shopData) do
        local row = math.ceil(_k / 3);
        local col = _k % 3;
        col = col == 0 and 3 or col;
      
        local item = template.ShopItemTemplate:create();
        item:Init(data);
        item:setPosition(94.5 + (col-1) * 198 , maxHeight-100-(row - 1)*203);
        item:addTo(self.bpShopScrollView);
        item:setItemTag(data.no);
        item:addItemClickEventListener(handler(self , self.shopItemClick));
        self.shopItems[data.no] = item;
    end
end

function BattlepassPanel:missionMenuClick(sender , event)
    local tag = sender:getTag();
    self:updateBattlepassMission(tag)
end

function BattlepassPanel:shopItemClick(sender , event)
    AudioManager:playEffect(Conf.buttonClick)
    local id = sender:getTag();
    
    local shopData = model.ShopModel:getShopDataByIndex(self.curShopType);
        
    if not shopData then
        return;
    end

    local itemData = shopData[id]

    if not itemData then
        return;
    end

    if itemData.times ~= 0 then
        UIManager:push('TipsShopPanel' , self.curShopType , id);
    else
        Prompt:Show(LANG.UI_SHOP_37);
    end
end

function BattlepassPanel:retBattlepassShopBuy(msg)
    local id = msg.id;
    if msg.times and msg.times >= 0 then
            local shopData = model.ShopModel:getShopDataByIndex(msg.shop_type);

        if not shopData then
            return;
        end

        local data = shopData[msg.id]
        self.shopItems[msg.id]:Init(data);
    end
    self:updateShopMoney(msg.shop_type)
    UIManager:push('RewardPanel',msg,{effectName = 'RewardGoods'})
end

function BattlepassPanel:updateBattlepassMission(battlepassMissionType)

    for _type , menu in pairs(self.bpMissionMenu) do
		if _type == battlepassMissionType then
            menu.label:setTextColor(cc.c3b(255 , 255 , 255));
            menu.light:setVisible(true);
            menu.btn:setBright(true);
        else
            menu.label:setTextColor(cc.c3b(180 , 180 , 180));
            menu.light:setVisible(false);
            menu.btn:setBright(false);
		end
    end

    self.battlepassMissionType = battlepassMissionType;

    local battlepassMission = model.BattlepassModel:getBattlepassByTimeType(self.battlepassMissionType);

    if not battlepassMission then
        return;
    end

    local missionData = {};
    for no , data in pairs(battlepassMission) do
        table.insert(missionData , data);
    end

    if #missionData > 1 then
        table.sort(missionData , function(first , second)
            if first.state ~= second.state then
                if first.state == 2 and second.state ~= 2 then
                    return true;
                elseif first.state ~= 2 and second.state ~= 2 then
                    if first.state == 0 and second.state == 1 then
                        return true;
                    end
                end
            else
                return first.no < second.no;
            end
            return false;
        end);
    end
    
    self.battlepassMissionCell = {};
    self.bpMissionScrollView:reloadData(missionData);
end

function BattlepassPanel:reloadMissionCellItem(cell , idx , data)
    local cellNode = template.BattlepassMissionTemplate:create();
	cellNode:addTo(cell)
	cellNode:initData(data);
    cellNode:addDailyMissionClickEventListener(handler(self , self.getMissionReward));
    self.battlepassMissionCell[data.no] = cellNode;
    return cell;
end

function BattlepassPanel:getMissionReward(state , data)
	if state == 1 then
        Network.NetworkManager:Send(Network.NetworkCmdType.req_battlepass_mission_reward, {no = data.no});
	else
        --self:jumpTo(data.type);
    end
end

function BattlepassPanel:retBattlepassMissionReward(msg)
    if msg.no and self.battlepassMissionCell[msg.no] then
        local data = model.BattlepassModel:getBattlepassMissionData(msg.time_type,msg.no);
        self.battlepassMissionCell[msg.no]:initData(data);
    end
    UIManager:push('RewardPanel',msg)
end

function BattlepassPanel:showBattlepass()
    self:updateBattlepassTime()
    self:updateCurBattlepassData();
    self:updateBattlepassData();
    TimeManager:registUpdateEvent('BattlepassPanel',handler(self,self.updateBattlepassTime),true);
end

function BattlepassPanel:updateCurBattlepassData()
    local specialState = model.BattlepassModel:getSpecialState();
    self.bpSpecialBuyBtn:setVisible(specialState == 0);

    local curBattlepassNo = model.BattlepassModel:getCurBattlepassRewardNo();
    local curBattlepass = model.BattlepassModel:getBattlepassReward(curBattlepassNo)

    if curBattlepass then
        self.bpLevel:setString(tostring(curBattlepass.level));
        local curPointNum = model.BattlepassModel:getCurBattlepassPoint()
        local percent = curPointNum/curBattlepass.total_point;
        percent = math.max(percent,0);
        percent = math.min(percent,1);
        self.bpLevelProgress:setContentSize(cc.size(394*percent , 13));

        self.bgLevelExp:setString(string.format('%d/%d',curPointNum,curBattlepass.total_point));
    end
end

function BattlepassPanel:updateBattlepassTime()
    local lastTime = model.BattlepassModel:getBattlepassCountDown()
    if lastTime > 86400 then
        local day = math.floor(lastTime / 86400);
        local hour = math.floor((lastTime - day * 86400) / 3600);
        lastTime = day..LANG.UI_MISSION_21..hour..LANG.UI_MISSION_22
    else
        lastTime = Sec2Time(math.floor(lastTime));
    end
    self.bpCountdown:setString(' '..tostring(lastTime));

    if self.battlepassType == 2 then
        local lastTime = model.BattlepassModel:getBattlepassCountDown(1)
        if lastTime <= 0 then
            model.BattlepassModel:setInit(false)
            Network.NetworkManager:Send(Network.NetworkCmdType.req_battlepass_data, {});
            TimeManager:registUpdateEvent('BattlepassPanel',nil,true);
        end
    end
end

function BattlepassPanel:updateBattlepassData()
    self.bpScrollView:jumpToTop()
    self.bpScrollView:setTouchEnabled(true);
    self.bpListScrollView:jumpToTop()
    self.bpListScrollView:setSwallowTouches(false);
    self.bpListScrollView:setTouchEnabled(false)

    local battlepassReward = model.BattlepassModel:getBattlepassReward();
    
    if not battlepassReward then
        return;
    end

    local curPointNum = model.BattlepassModel:getCurBattlepassPoint()
    local specialState = model.BattlepassModel:getSpecialState();

    local curNo = 0;
    local curNotGetNo = 0;
    local bpReward = {{no = 0}};
    for _k , data in pairs(battlepassReward) do
        table.insert(bpReward , data);
    end

    local num = #bpReward;
    if num > 1 then
        table.sort(bpReward , function(first , second)
            return first.no < second.no;
        end);
    end

    self.battlePassCell = {};
    self.bpListScrollView:reloadData(bpReward);
end

function BattlepassPanel:reloadBalltepassCellItem(cell , idx , data)
    local cellNode = template.BattlepassTemplate:create();
    cellNode:addTo(cell)
    cellNode:Init(data);
    cellNode:addBattlepassClickEventListener(handler(self , self.battlepassRewardClick));
    self.battlePassCell[data.no] = cellNode;
    return cell;
end

function BattlepassPanel:bpScrollViewListener(sender,event)
    if event == SCROLLVIEW_EVENT_CONTAINER_MOVED or event == SCROLLVIEW_EVENT_SCROLLING then
        local y = sender:getInnerContainerPosition().y;
        if y >= 0 then
            self.bpListScrollView:setSwallowTouches(true);
            self.bpListScrollView:setTouchEnabled(true)
        else
            self.bpListScrollView:setSwallowTouches(false);
            self.bpListScrollView:setTouchEnabled(false)
        end
	end
end

function BattlepassPanel:bpListScrollViewListener(sender , event)
    --print('event=======>',event);
    local y = sender:getInnerContainerPosition().y;
    local size = sender:getInnerContainerSize();
    local targetY = BATTLEPASS_VIEW_HEIGHT-512-size.height
    --print('value=======>',targetY);
    --print('y=======>',y);
    if event == SCROLLVIEW_EVENT_CONTAINER_MOVED or event == SCROLLVIEW_EVENT_SCROLL_TO_TOP then
        if self.bpScrollView:getInnerContainerPosition().y < 0 or y <= targetY then
            self.bpListScrollView:setTouchEnabled(false)
            self.bpListScrollView:setSwallowTouches(false);
            self.bpScrollView:setTouchEnabled(true);
        end
	end
end

function BattlepassPanel:battlepassRewardClick(rType , no)
    local rewardData = model.BattlepassModel:getBattlepassReward(no);

    if rType == 2 then
        local specialState = model.BattlepassModel:getSpecialState();
        if specialState == 0 then
            Prompt:Show(LANG.UI_MISSION_29);
            return;
        end

        if rewardData.reward_special_state == 1 then
            Prompt:Show(LANG.UI_MISSION_26);
            return;
        end
    else
        if rewardData.reward_free_state == 1 then
            Prompt:Show(LANG.UI_MISSION_26);
            return;
        end
    end

    local curPointNum = model.BattlepassModel:getCurBattlepassPoint()
    if curPointNum < rewardData.total_point then
        Prompt:Show(LANG.UI_MISSION_29);
        return;
    end
    Network.NetworkManager:Send(Network.NetworkCmdType.req_battlepass_reward, {rewardType = rType , no = no});
end

function BattlepassPanel:retBattlepassReward(msg)
    if msg.no and self.battlePassCell[msg.no] then
        local data = model.BattlepassModel:getBattlepassReward(msg.no);
        self.battlePassCell[msg.no]:Init(data);
    end
    UIManager:push('RewardPanel',msg)
end

function BattlepassPanel:buyBattlepassSpecial(data)
    sdkManager.PaymentHelper:onPayment(data,handler(self,self.retBuyBattlepassSpeical));
end

function BattlepassPanel:retBuyBattlepassSpeical(msg)
    self:updateBattlepass()
    UIManager:push('RewardPanel',msg)
end

function BattlepassPanel:jumpTo(bType)
    if bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_GACHA then--抽卡
        UIManager:push('GachaListPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_GACHA_SPECIAL then--特殊抽卡
		UIManager:push('GachaListPanel', 2)
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_GACHA_FIVE_STAR then  --五星抽卡
        UIManager:push('GachaListPanel', 3);
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_FAST_BATTLE then --快速挂机
        local locked,lockLv = model.AutoFightModel:getLockStateFastFight()
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_BATTLE_PASS_31);
            return
        end

        UIManager:switch('FightPanel');
        UIManager:push('FastFightRewardPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_DAILY_BATTLE then 	--每日副本
        local locked,lockLv = model.HomeModel:getLockStateByType(model.HomeModel.HomeMenuTag.TAG_DAILYROUND);
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_BATTLE_PASS_31);
            return;
        end
        UIManager:push('DailyRoundPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_LOGIN then --登录

    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_RANDOM_BOSS --随机boss
    or bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_RANDOM_BOSS_PURPLE --随机boss
    or bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_RANDOM_BOSS_YELLOW --随机boss
    or bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_RANDOM_BOSS_REFRESH then --随机boss刷新
        local locked,lockLv = model.RoundBossModel:getLockStateRoundBoss();
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_BATTLE_PASS_31);
            return
        end
        
        UIManager:push('RoundBossPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_GOLD_COST then --游戏币消耗		
        UIManager:switch('CardListPanel')
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_EQUIP_COMPOSE then --装备合成	
        UIManager:push('EquipComposePanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_HOME_SKILL then --基地科技			
        local locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_11)
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_BATTLE_PASS_31);
            return
        end
        UIManager:push('HomeBaseSkillPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_CARD_COMPOSE then --卡牌合成
        local locked,lockLv = model.HomeModel:getLockStateByType(model.HomeModel.HomeMenuTag.TAG_CARD_COMPOSE);
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_BATTLE_PASS_31);
            return
        end
        UIManager:push('CardComposePanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_GUILD_DONATE then --公会捐献
        if model.GuildModel:chackGuild() then
			UIManager:set('GuildDonatePanel', {'GuildPanel', 'GuildDonatePanel'})
       end
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_ROLE_STAR_SEVEN --七星卡牌
    or bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_ROLE_STAR_TEN	--十星卡牌
    or bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_COST_PARTNER then --消耗卡牌
		UIManager:set('CardLevelUpStarCardListPanel', {'HomeBasePanel', 'CardLevelUpStarCardListPanel'})
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_ITEM_COST then --道具使用
        local locked,lockLv = model.ItemModel:getLockStateFightItemUse()
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_BATTLE_PASS_31);
            return
        end

        UIManager:switch('FightPanel');
        UIManager:push('FightItemPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_TRIAL  --试炼
    or  bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_TRIAL_TIER then --试炼通关层
        local locked,lockLv = model.HomeModel:getLockStateByType(model.HomeModel.HomeMenuTag.TAG_TRIAL);

        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_BATTLE_PASS_31);
            return
        end

		UIManager:set('TrialPanel', {'HomeBasePanel', 'TrialPanel'})
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_RANDOM_SHOP then --刷新商店刷新
        local locked,lockLv = model.HomeModel:getLockStateByType(model.HomeModel.HomeMenuTag.TAG_RANDOMSHOP);

        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_BATTLE_PASS_31);
            return
        end
        
		UIManager:set('RandomShopPanel', {'HomeBasePanel', 'RandomShopPanel'})
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_ROLE_LEVEL then --玩家等级
        UIManager:switch('FightPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_MAIN_CHAPTER then --主线章节
        UIManager:switch('FightPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_MAIN_ROUND then --主线关卡
        UIManager:switch('FightPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_FIGHT_INCOME then --领取挂机收获
        UIManager:switch('FightPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_SHOP_BUY then --商店购买次数
        UIManager:push('ShopPanel');
    elseif bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_ARENA_CHALLENGE_NUM --竞技场挑战次数
    or bType == model.BattlepassModel.BattlePassType.BATTLE_PASS_ARENA_WIN_NUM then --竞技场胜利次数
		UIManager:set('ArenaPanel', {'HomeBasePanel', 'ArenaPanel'})
    end
end

function BattlepassPanel:onLeave()
    self.root:setVisible(false);
end

function BattlepassPanel:onClickBack()
    UIManager:pop('BattlepassPanel');
    TimeManager:registUpdateEvent('BattlepassPanel',nil,true);
end

return BattlepassPanel

