local BattlePassRewardPanel = class('BattlePassRewardPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/battlePass/'

function BattlePassRewardPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'BattlePassRewardPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function BattlePassRewardPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
  
      self:initPanel();
  
      self:registEvent();
end

function BattlePassRewardPanel:initPanel()
    
	local bg = cc.Sprite:create('image/bg/Bg_3.png');
	bg:addTo(self.root);

	bg = cc.Sprite:create(imagePath..'battle_pass_bg_50.png');
    bg:addTo(self.root);
    bg:setPosition(0 , 36);

    self.navi = cc.Sprite:create(imagePath..'battle_pass_bg_2.png');
    self.navi:addTo(self.root);
    self.navi:setPosition(-168 , 204);

    self.title = cc.Sprite:create(imagePath..'battle_pass_bg_51.png');
    self.title:addTo(self.root);
    self.title:setPosition(131 , 315);

    bg = cc.Sprite:create(imagePath..'battle_pass_bg_21.png');
	bg:setPosition(162,135);
    bg:addTo(self.root);

    local label = cc.Label:createWithTTF(LANG.UI_BATTLE_PASS_1 , fonts.FONT_SIYUAN , 20);
    label:addTo(self.root);
    label:setPosition(50 , 275);
    label:setAnchorPoint(0 , 0.5);
    label:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

    self.lastTime = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
    self.lastTime:addTo(self.root);
    self.lastTime:setPosition(152 , 275);
    self.lastTime:setAnchorPoint(0 , 0.5);
    self.lastTime:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

    self.moneyProgress = cc.Sprite:create(imagePath..'battle_pass_bg_22.png');
	self.moneyProgress:setPosition(41,135);
	self.moneyProgress:setAnchorPoint(0,0.5);
    self.moneyProgress:addTo(self.root);

    self.moneyNum = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
    self.moneyNum:addTo(self.root);
    self.moneyNum:setPosition(162 , 121);
    self.moneyNum:enableOutline(cc.c4b(190 , 100 , 0 , 255) , 2);

    bg = cc.Sprite:create(imagePath..'battle_pass_bg_17.png');
    bg:addTo(self.root);
    bg:setPosition(17 , 137);

    self.level = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 30);
    self.level:addTo(self.root);
    self.level:setPosition(17,137);
    self.level:enableOutline(cc.c4b(190 , 100 , 0 , 255) , 2);

    bg = cc.Sprite:create(imagePath..'battle_pass_bg_24.png');
    bg:addTo(self.root);
    bg:setPosition(17 , 100);

    label = cc.Label:createWithTTF(LANG.UI_BATTLE_PASS_6 , fonts.FONT_SIYUAN , 20);
    label:addTo(self.root);
    label:setPosition(17 , 100);
    label:enableOutline(cc.c4b(190 , 100 , 0 , 255) , 2);

    self.openGetBtn = ccui.Button:create(imagePath..'battle_pass_bg_25.png' , imagePath..'battle_pass_bg_25.png');
	self.openGetBtn:addTo(self.root);
	self.openGetBtn:setPosition(218 , 180);
    self.openGetBtn:addClickEventListener(function() UIManager:push('BattlePassGiftPanel',1); end);
    
	self.openGetLabel = cc.Label:createWithTTF(LANG.UI_BATTLE_PASS_5 , fonts.FONT_SIYUAN , 20);
	self.openGetLabel:addTo(self.openGetBtn);
	self.openGetLabel:setPosition(self.openGetBtn:getContentSize().width / 2 , self.openGetBtn:getContentSize().height / 2);

    self.rewardListView = template.FrameLoadScrollViewTemplate:create()
    self.rewardListView:setPosition(0,-132);
    self.rewardListView:setAnchorPoint(0.5,0.5);
    self.rewardListView:Init(cc.size(586 , 325) , cc.size(586 , 100) , 1 , 0);
    self.rewardListView:addEventListener(handler(self , self.rewardEvent));
    self.rewardListView:addLoadCellHandler(handler(self,self.reloadRewardCellItem));
    self.rewardListView:addTo(self.root);

    bg = cc.Sprite:create(imagePath..'battle_pass_bg_23.png');
	bg:setPosition(0,-169);
    bg:addTo(self.root);

    label = cc.Label:createWithTTF(LANG.UI_BATTLE_PASS_23 , fonts.FONT_SIYUAN , 20);
    label:addTo(self.root);
    label:setPosition(-227,47);

    label = cc.Label:createWithTTF(LANG.UI_BATTLE_PASS_24 , fonts.FONT_SIYUAN , 20);
    label:addTo(self.root);
    label:setPosition(-69,47);

    label = cc.Label:createWithTTF(LANG.UI_BATTLE_PASS_25 , fonts.FONT_SIYUAN , 20);
    label:addTo(self.root);
    label:setPosition(154,47);

    self.lockNode = cc.Node:create();
    self.lockNode:addTo(self.root);
    self.lockNode:setPosition(157 , -167);

    bg = cc.Sprite:create(imagePath..'battle_pass_bg_27.png');
    bg:addTo(self.lockNode);

	local label = cc.Label:createWithTTF(LANG.UI_BATTLE_PASS_32, fonts.FONT_SIYUAN, 20)
		-- :setTextColor(cc.c3b(255, 255, 255))
        :enableOutline(cc.c3b(40, 130, 230), 2)
    local openBtn = ccui.Button:create(imagePath..'common_button_32_4.png' , imagePath..'common_button_32_4.png');
    openBtn:addTo(self.lockNode);
    openBtn:setTitleLabel(label)
	openBtn:setPosition(-3 , -109);
    openBtn:addClickEventListener(function() UIManager:push('BattlePassGiftPanel',1); end);
    
    bg = cc.Sprite:create(imagePath..'battle_pass_bg_13.png');
    bg:addTo(self.lockNode);
    bg:setPosition(-65 , 212);

    local viewNode = cc.Node:create();
    viewNode:addTo(self.root);
    viewNode:setPosition(0 , -346);

    bg = cc.Sprite:create(imagePath..'battle_pass_bg_16.png');
    bg:addTo(viewNode);

    label = cc.Label:createWithTTF(LANG.UI_BATTLE_PASS_7 , fonts.FONT_SIYUAN , 20);
    label:addTo(viewNode);
    label:setPosition(-229,15);
    label:setTextColor(cc.c3b(60 , 60 , 60));

    self.viewLevel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
    self.viewLevel:addTo(viewNode);
    self.viewLevel:setPosition(-229,-15);
    self.viewLevel:setTextColor(cc.c3b(60 , 60 , 60));

    bg = cc.Sprite:create(imagePath..'battle_pass_bg_30.png');
    bg:addTo(viewNode);
    bg:setPosition(-77 , 0);

    self.viewRewardIcon = template.IconTemplate:create(viewNode);
    self.viewRewardIcon:setPosition(-77 , 0);
    self.viewRewardIcon:setScale(0.7);

    self.viewRewardLock = cc.Sprite:create(imagePath..'battle_pass_bg_13.png');
    self.viewRewardLock:addTo(viewNode);
    self.viewRewardLock:setPosition(-116 , 31);

    self.viewRewardGeted = cc.Sprite:create(imagePath..'battle_pass_bg_11.png');
    self.viewRewardGeted:addTo(viewNode);
    self.viewRewardGeted:setPosition(-77 , 0);

    bg = cc.Sprite:create(imagePath..'battle_pass_bg_10.png');
    bg:addTo(viewNode);
    bg:setPosition(155 , 0);

    self.viewItemNode = cc.Sprite:create();
	self.viewItemNode:addTo(viewNode);
    self.viewItemNode:setPosition(115,0);

end

function BattlePassRewardPanel:registEvent()
    EventManager:RegisterEvent(EventType.UIRetBattlePassGetReward, handler(self, self.retGetReward));
    EventManager:RegisterEvent(EventType.UIRetBattlePassGetGiftReward, handler(self, self.retGetGiftReward));
end


function BattlePassRewardPanel:updateData()
    local battlePassReward = model.BattlePassModel:getBattlePassReward();
    
    if not battlePassReward then
        return;
    end

    local curPointNum = model.ItemModel:getItemNum(BATTLE_PASS);
    local specialState = model.BattlePassModel:getSpecialState();

    local curNo = 0;
    local curNotGetNo = 0;
    local bPassReward = {};
    for _k , data in pairs(battlePassReward) do
        table.insert(bPassReward , data);

        local haveNo = false;
        if curPointNum >= data.total_point then
            if data.reward_state ~= 1 and (curNo == 0 or curNo > data.no) then
                curNo = data.no;
                haveNo = true;
            elseif specialState == 1 and data.reward_special_state ~= 1 and (curNo == 0 or curNo > data.no) then
                curNo = data.no;
                haveNo = true;
            end
        end

        if not haveNo and data.reward_state ~= 1 then
            if curNotGetNo == 0 then
                curNotGetNo = data.no;
            elseif curNotGetNo > data.no then
                curNotGetNo = data.no;
            end
        end
    end

    if curNo == 0 then
        curNo = curNotGetNo == 0 and 1 or curNotGetNo;
    end
    --curNo = curNo == 0 and 1 or curNo;

    local num = #bPassReward;
    if num > 1 then
        table.sort(bPassReward , function(first , second)
            return first.no < second.no;
        end);
    end

    self.maxViewNo = math.floor(num / 10) * 10;

    self.battlePassRewardCell = {};
    self.rewardListView:reloadData(bPassReward);
    self.rewardListView:jumpToItem(curNo);

    self.curViewNo = math.ceil((curNo+3) / 10) * 10;
    self.curViewNo = self.curViewNo > self.maxViewNo and self.maxViewNo or self.curViewNo;

    self:updateView();
end

function BattlePassRewardPanel:rewardEvent(sender , event)
	if event == ccui.ScrollviewEventType.containerMoved then
        local y = sender:getInnerContainerPosition().y;

        for i = 10 , self.maxViewNo , 10 do
            if self.battlePassRewardCell[i] then
                local sub = -y-self.battlePassRewardCell[i]:getParent():getPositionY();
                if (sub > -50.5 and sub < 959.5) and i ~= self.curViewNo then
                    self.curViewNo = i;
                    self:updateView();
                end
            end
        end
	end
end

function BattlePassRewardPanel:updateView()
    local data = model.BattlePassModel:getBattlePassReward(self.curViewNo);

    if not data then
        return;
    end

    self.viewLevel:setString(tostring(data.no));
	local curPointNum = model.ItemModel:getItemNum(BATTLE_PASS);
	
	if data.reward and data.reward[1] then
		local reward = data.reward[1];
		self.viewRewardIcon:Init(reward[1] , reward[2]);
		self.viewRewardGeted:setVisible(data.reward_state == 1);
		self.viewRewardLock:setVisible(curPointNum < data.total_point);
		self.viewRewardIcon:setVisible(true);
	else
		self.viewRewardGeted:setVisible(false);
		self.viewRewardLock:setVisible(false);
		self.viewRewardIcon:setVisible(false);
	end

	self.viewItemNode:removeAllChildren();

	if data.special_reward and data.special_reward[1] then
		for _k , item in pairs(data.special_reward) do
			local layout = ccui.Layout:create();
			layout:addTo(self.viewItemNode);
			layout:setPosition(80 * (_k - 1) , 0);

			local icon = template.IconTemplate:create(layout);
			icon:Init(item[1] , item[2]);
			icon:setScale(0.7);

			if curPointNum < data.total_point then
				local lock = cc.Sprite:create('image/battlePass/battle_pass_bg_13.png');
				lock:addTo(layout);
				lock:setPosition(-39 , 31);
			elseif data.reward_special_state == 1 then
				local geted = cc.Sprite:create('image/battlePass/battle_pass_bg_11.png');
				geted:addTo(layout);
			end
		end
	end
end

function BattlePassRewardPanel:reloadRewardCellItem(cell , idx , data)
    local cellNode = template.BattlePassRewardTemplate:create(cell);
    cellNode:initData(data);
    cellNode:addClickEventListener(handler(self , self.getRewardClick));
    self.battlePassRewardCell[data.no] = cellNode;
    return cell;
end

function BattlePassRewardPanel:getRewardClick(rType , no)

    local rewardData = model.BattlePassModel:getBattlePassReward(no);

    if rType == 2 then
        local specialState = model.BattlePassModel:getSpecialState();
        if specialState == 0 then
            Prompt:Show(LANG.UI_BATTLE_PASS_29);
            return;
        end

        if rewardData.reward_special_state == 1 then
            Prompt:Show(LANG.UI_BATTLE_PASS_30);
            return;
        end
    else
        if rewardData.reward_state == 1 then
            Prompt:Show(LANG.UI_BATTLE_PASS_30);
            return;
        end
    end

    local curPointNum = model.ItemModel:getItemNum(BATTLE_PASS);
    if curPointNum < rewardData.total_point then
        Prompt:Show(LANG.UI_BATTLE_PASS_29);
        return;
    end
    Network.NetworkManager:Send(Network.NetworkCmdType.req_battle_pass_get_reward, {rewardType = rType , no = no});
end

function BattlePassRewardPanel:retGetReward(msg)

    if msg.no and self.battlePassRewardCell[msg.no] then
        local data = model.BattlePassModel:getBattlePassReward(msg.no);
        self.battlePassRewardCell[msg.no]:initData(data);
    end

    self:updateCurData();

    UIManager:push('RewardPanel' , msg);
end

function BattlePassRewardPanel:onEnter()

    if model.BattlePassModel:isInit() then
        self:onShow()
    else
        Network.NetworkManager:Send(Network.NetworkCmdType.req_battle_pass_data, {});
    end
end

function BattlePassRewardPanel:onShow()

    if not self.haveInitialize then
		return
    end

    self:updateCurData();
    self:updateData();
    self:updateTime();

    TimeManager:registUpdateEvent('BattlePassRewardPanel',handler(self,self.updateTime),true);
    self.root:setVisible(true)
end

function BattlePassRewardPanel:updateCurData()

    local specialState = model.BattlePassModel:getSpecialState();
    if specialState == 0 then
        self.openGetBtn:loadTextures(imagePath..'battle_pass_bg_25.png' , imagePath..'battle_pass_bg_25.png');
        self.openGetLabel:setString(LANG.UI_BATTLE_PASS_5);
        self.openGetLabel:setTextColor(cc.c3b(255 , 255 , 255));
        self.openGetLabel:enableOutline(cc.c4b(40 , 130 , 230 , 255) , 2);
        self.openGetLabel:setPosition(self.openGetBtn:getContentSize().width / 2 , self.openGetBtn:getContentSize().height / 2);
        self.lockNode:setVisible(true);
    else
        self.openGetBtn:loadTextures(imagePath..'battle_pass_bg_37.png' , imagePath..'battle_pass_bg_37.png');
        self.openGetLabel:setString(LANG.UI_BATTLE_PASS_26);
        self.openGetLabel:setTextColor(cc.c3b(60 , 60 , 60));
        self.openGetLabel:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
        self.openGetLabel:setPosition(self.openGetBtn:getContentSize().width / 2 , self.openGetBtn:getContentSize().height / 2-1);
        self.lockNode:setVisible(false);
    end

    local curBattlePassNo = model.BattlePassModel:getCurBattlePassRewardNo();
    local curBattlePass = model.BattlePassModel:getBattlePassReward(curBattlePassNo)

    if curBattlePass then
        self.level:setString(tostring(curBattlePassNo));
        local curPointNum = model.ItemModel:getItemNum(BATTLE_PASS);
        local percent = curPointNum/curBattlePass.total_point;
        percent = percent > 1 and 1 or percent;
        self.moneyProgress:setTextureRect(cc.rect(0,0,243*percent , 10));

        self.moneyNum:setString(string.format('%d/%d',curPointNum,curBattlePass.total_point));
    end
end

function BattlePassRewardPanel:updateTime()
    local lastTime = model.BattlePassModel:getBattlePassCountDown(self.battlePassType)
    if lastTime > 86400 then
        local day = math.floor(lastTime / 86400);
        local hour = math.floor((lastTime - day * 86400) / 3600);
        lastTime = day..LANG.UI_BATTLE_PASS_21..hour..LANG.UI_BATTLE_PASS_22
    else
        lastTime = Sec2Time(math.floor(lastTime));
    end
    self.lastTime:setString(' '..lastTime);
end

function BattlePassRewardPanel:retGetGiftReward(msg)
    self:updateCurData();

    for no , cell in pairs(self.battlePassRewardCell) do
        local data = model.BattlePassModel:getBattlePassReward(no);
        cell:initData(data);
    end
    
    UIManager:pop('BattlePassGiftPanel');
    UIManager:push('RewardPanel' , msg);
end

function BattlePassRewardPanel:onLeave()
    self.root:setVisible(false);
end

function BattlePassRewardPanel:onClickBack()
    UIManager:pop('BattlePassRewardPanel');
    TimeManager:registUpdateEvent('BattlePassRewardPanel',nil,true);
    EventManager:FireEvent(EventType.UIUpdateBattlePassRewardLevel);
    tools.RedDotTools:pushMainPanelRedDot(14);
end

return BattlePassRewardPanel

