local BelleBallMainPanel = class("BelleBallMainPanel",require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local imgPath = 'image/playball/';
local CommonShopType = Enum:getTable('CommonShopType');

function BelleBallMainPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'BelleBallMainPanel');

    self.useCCreator = false;
	self.isPopup = false;
	self.haveSwallowLayer = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_ICON;
    -- self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
    
end

function BelleBallMainPanel:Init( root )
    -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPannel();
    self:registEvent();

end

function BelleBallMainPanel:registEvent(  )
 --    EventManager:RegisterEvent('EGO_ContactEvent' , handler(self , self.onContactBegin));
	-- EventManager:RegisterEvent('PlayBallPanel:refreshAllBox' , handler(self , self.refreshAllBox));
 --    EventManager:RegisterEvent('PlayBallPanel:refreshTopItems' , handler(self , self.refreshTopItems));
end

function BelleBallMainPanel:initPannel(  )

	local blackBg = ccui.Layout:create();
	blackBg:setBackGroundImage('image/task/blackbg.png');
	blackBg:setBackGroundImageScale9Enabled(true);
	blackBg:setTouchEnabled(true);
	blackBg:setContentSize(StageSize);
	blackBg:setLocalZOrder(-2);
	blackBg:setAnchorPoint(cc.p(0.5,0.5));
	blackBg:setPosition(0, 0);
    blackBg:addTo(self.root);
    
    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);

    local bg1 = cc.Sprite:create('image/playball/bb_bg.png');
    bg1:addTo(bgNode);
    
    local limitH = -104;
    self.bannerSpr = cc.Sprite:create( 'image/playball/banner1_img.png' )
    self.bannerSpr:addTo(bgNode)
    self.bannerSpr:setAnchorPoint(0.5,0)
    self.bannerSpr:setPosition(0, -104)

    local infoNode = cc.Node:create()
    infoNode:addTo(bgNode)
    infoNode:setPosition(0, limitH-100)
    local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
    infoBg:setContentSize(cc.size(606, 144))
    infoBg:addTo(infoNode)

    self.helpListView = ccui.ListView:create()
		:ignoreContentAdaptWithSize(false)
		:setAnchorPoint(cc.p(0.5,0.5))
		:setBounceEnabled(true)
		:setDirection(ccui.ScrollViewDir.vertical)
		:setContentSize(cc.size(560 , 140))
		:setScrollBarEnabled(false)
		:addTo(infoNode)

	local lg = model.UserDefaultModel:getLanguageSet();
	local tableName = 'language_help_'..lg;
	local info = ResTable:getValue(tableName, 18,'info');
	if info then
		local formatStr , colorPos = formatColorText(info);
		local info = cc.Label:createWithTTF(tostring(formatStr) , Enum:getTable("SystemFont").FONT_HUAKANG , 18);
		info:setLineBreakWithoutSpace(true);
		info:setMaxLineWidth(560)

		local strLen = getStrLen(formatStr);

		for i = 0 , strLen-1 do
			local label = info:getLetter(i);
			if label then
				local changeColor = false
				for _k , pos in pairs(colorPos) do
					if i >= pos.sPos-1 and i <= pos.ePos-1 then
						label:setColor(cc.c3b(pos.color[1] , pos.color[2] , pos.color[3]));
						changeColor = true;
						break;
					end
				end
				if not changeColor then
					label:setColor(cc.c3b(255 , 255 , 255));
				end
			end
		end

		local size = info:getContentSize();
		local layout = ccui.Layout:create();
		layout:setContentSize(size);
		info:addTo(layout);
		info:setPosition(size.width/2 , size.height/2);

		self.helpListView:pushBackCustomItem(layout);
	end


    local topNode = cc.Node:create()
    topNode:addTo(self.root)
    topNode:setPosition(0, StageSize.height/2)
    --商店
    local shopNode = cc.Node:create()
    shopNode:addTo(topNode)
    shopNode:setPosition(StageSize.width/2-70 ,-120)
    local spine_res = 'gameshop';
    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
        local skAnimation3 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        skAnimation3:addTo(shopNode)
        skAnimation3:setAnimation(0, "gameshop", true)
    end
    local shopBtn = ccui.Button:create('image/commonImg/common_item_select.png')
        :addTo(shopNode)
        :setScale9Enabled(true)
    shopBtn:setContentSize(cc.size(100, 100))
    shopBtn:setScale9Enabled(true)
    shopBtn:setOpacity(0)
    shopBtn:addClickEventListener(handler(self , self.onOpenShop))

    

    self.bottomNode = cc.Node:create()
    self.bottomNode:addTo(self.root)
    local bottomNode = cc.Node:create()
    bottomNode:addTo(self.bottomNode)
    bottomNode:setPosition(0, -StageSize.height/2)

    self.enterList = {}
    self.enterNode = cc.Node:create()
    self.enterNode:addTo(bottomNode)
    self.enterNode:setPosition(0, 200)

    --"background_img":"","banner_img":"","button_img":""

    local halfW = 110;
    local cnt = 1;
    local midIdx = math.ceil(cnt/2)
    local extX = halfW*((cnt+1)%2)
    for i=1,cnt do
    	local itemNode = cc.Node:create()
	    itemNode:addTo(self.enterNode)
	    itemNode:setPosition(  (i-midIdx)*2*halfW - extX ,0)
	    local spine_res = 'startgame';
	    local spine = nil
	    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
	        spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
	        spine:addTo(itemNode)
	        spine:setAnimation(0, "game1_idle2", true)
	    end
	    local btn = ccui.Button:create('image/playball/ball_enter.png')
	        :addTo(itemNode)
	    btn:setOpacity(0);
	    btn:setTag(i);
	    btn:addClickEventListener(handler(self , self.onStartBallGame))
    end

    local btmBg1 = cc.Sprite:create( imgPath..'bb_light.png' )
    btmBg1:addTo(bottomNode)
    btmBg1:setAnchorPoint(0.5,0)
    -- btmBg1:setBlendFunc(cc.blendFunc(GL_ZERO, GL_SRC_COLOR));
    -- btmBg1:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA));
    btmBg1:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE));
    
end

function BelleBallMainPanel:onClickBack( ... )
	UIManager:pop('BelleBallMainPanel');
end

function BelleBallMainPanel:refreshTopItems()
    -- for i=1,3 do
    --     local iconFile = GlobalFunctions:getItemIconFileAndNum( {self.BallItemIds[i], 0} );
    --     local num = model.ItemModel:getItemNum(self.BallItemIds[i])
    --     self.itemList[i].itemIcon:setTexture(iconFile);
    --     self.itemList[i].itemLabel:setString(num);
    -- end
end

function BelleBallMainPanel:onEnter( no )
    self.no = 1;
    local ballData = ResTable:getRowData('belle_ball', self.no)
    
    self:onShow();
    self:refreshTopItems();

end

function BelleBallMainPanel:onShow()
	EventManager:FireEvent(EventType.UIFooterUpdateSelect,4);
    self.root:setVisible(true)
end

function BelleBallMainPanel:onOpenShop()
    UIManager:push('StorePanel', Enum:getTable('CommonShopType').BUBBLE);
end

function BelleBallMainPanel:onStartBallGame(sender , event)
	local index = sender:getTag();
	UIManager:push('PlayBallPanel')
end

function BelleBallMainPanel:onLeave( ... )
    self.root:setVisible(false);
end

return BelleBallMainPanel
