local CardAvatarUsePanel = class("CardAvatarUsePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local AnimationType = Enum:getTable('AnimationType');

function CardAvatarUsePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardAvatarUsePanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE_NO_MONEY;

end

function CardAvatarUsePanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
      self.curSelIdx = 0;
      self.lastSpine = '';
      self.bHaveSpine = false;
      self:InitPanels();
      self.bMove = false;
      self:registerHandler();
end

function CardAvatarUsePanel:InitPanels()

	local bg = cc.Sprite:create('image/bg/Bg_14.png');
	bg:addTo(self.root);
 --    GlobalFunctions:createTitleNode( bg, LANG.UI_L_CARD_AVATAR_TITLE_1, LANG.UI_L_CARD_AVATAR_TITLE_2,  
	-- bg:getContentSize().width/2, bg:getContentSize().height -18 );
	
	-- local scorllNode = cc.Node:create();
	-- scorllNode:addTo(self.root);
	-- scorllNode:setPosition( -265, -160 );

	-- local scBg = cc.Sprite:create('image/card/cardAvatar/avatar_bg2.png')
	-- :addTo(scorllNode)
	-- :setPosition(270, 205)

	self.avatarSpr = cc.Sprite:create()
	self.avatarSpr:addTo(self.root)

	self.skeletonNode = cc.Node:create()
	self.skeletonNode:addTo(self.root)

	self.scorllview = ccui.ScrollView:create();
	self.scorllview:setTouchEnabled(true);
	self.scorllview:setBounceEnabled(true);
	self.scorllview:setDirection(ccui.ScrollViewDir.horizontal);
	self.scorllview:setContentSize(cc.size(StageSize.width , 150));
	self.scorllview:setAnchorPoint(cc.p(0,0));
	self.scorllview:setScrollBarEnabled(false);
    self.scorllview:setPosition(-StageSize.width/2 , -StageSize.height/2);
    self.scorllview:addTo(self.root);

    -- self.scorllview:setInnerContainerSize( cc.size(540+380 , 425) );
    self.maxOffsetX = 380;

	self.selFlag = cc.Sprite:create('image/card/cardAvatar/avatar_sel.png');
	self.selFlag:addTo(self.scorllview);
	self.selFlag:setPosition(-4000 , 200);

	self.curUseFlag = cc.Sprite:create('image/commonImg/btn_bg3.png');
	self.curUseFlag:addTo(self.scorllview);
	self.curUseFlag:setPosition(-4000 , 200);
	self.curUseFlag:retain();

	local useLabel = cc.Label:createWithTTF(LANG.UI_CARD_AVATAR_USE , fonts.FONT_SIYUAN , 10);
	useLabel:addTo(self.curUseFlag);
	useLabel:enableOutline(cc.c3b(50 , 130 , 200) , 2);
	useLabel:setPosition(25, 12)


	self.useAniNode = cc.Node:create()
	self.useAniNode:addTo(self.scorllview);
	self.useAniNode:setPosition(-4000 , 200);
	self.useAniNode:setVisible(false);
	self.useAniNode:retain();

	local spine_res = 'pifuchuandai_spine';
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.useSkeAni = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.useSkeAni:addTo(self.useAniNode)
	end
	self.useParticle = cc.ParticleSystemQuad:create("Effect/particle/pifujiesuo.plist")
	self.useParticle:addTo(self.useAniNode);
	local useAniSpr = cc.Sprite:create('image/card/cardAvatar/avatar_cell_bg.png')
	useAniSpr:addTo(self.useAniNode);

	-- local barBg = cc.Sprite:create('image/card/cardAvatar/avatar_bar1.png');
	-- barBg:addTo(scorllNode);
	-- barBg:setAnchorPoint( cc.p(0,0) );
	-- barBg:setPosition(7 , -14);

	-- self.bar = cc.Sprite:create('image/card/cardAvatar/avatar_bar2.png');
	-- self.bar:setAnchorPoint( cc.p(0,0) );
	-- self.bar:setPosition(7, -14);
	-- self.bar:addTo(scorllNode);

	-- self.barMoveXMax = barBg:getContentSize().width - self.bar:getContentSize().width - 2;
	self.topNode = cc.Node:create()
	self.topNode:addTo(self.root)
	self.topNode:setPosition(0, StageSize.height/2 - 100)

	local headNode = cc.Node:create()
	headNode:addTo(self.topNode)
	headNode:setPosition(StageSize.width/2-70, -120)

	local stencil = cc.Sprite:create('image/card/cardAvatar/avatar_head_b1.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:addTo(headNode);

	self.headIcon = cc.Sprite:create()
	self.headIcon:addTo(clippingNode)
	local headBg2 = cc.Sprite:create('image/card/cardAvatar/avatar_head_b2.png');
	headBg2:addTo(headNode)

	local headLabel = cc.Label:createWithTTF(LANG.UI_CARD_AVATAR_1 , fonts.FONT_SIYUAN , 18);
	headLabel:addTo(headNode);
	headLabel:setPosition(0, -40)
	headLabel:enableOutline(cc.c3b(60 , 60 , 60), 2);

	local headBtn = ccui.Button:create('image/card/cardAvatar/avatar_head_b1.png');
	headBtn:addTo(headNode);
	-- headBtn:setContentSize(cc.size(185 , 102))
	-- headBtn:setScale9Enabled(true)
	headBtn:addClickEventListener(handler(self , self.onShowModel));
	headBtn:setOpacity(0)


	self.bottomNode = cc.Node:create()
	self.bottomNode:addTo(self.root)
	self.bottomNode:setPosition(0, 200-StageSize.height/2)

	local nameBg = cc.Sprite:create('image/card/cardAvatar/avatar_name_bg.png')
	nameBg:addTo(self.topNode)
	self.nameLabel = cc.Label:createWithTTF('', fonts.FONT_SIYUAN , 25);
	self.nameLabel:addTo(self.topNode);
	self.nameLabel:setPosition(0, -7)

	self.buyBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.buyBtn:addTo(self.bottomNode);
	self.buyBtn:addClickEventListener(handler(self , self.OkButtonClick));

	local btnLabel = cc.Label:createWithTTF(LANG.UI_SETTING_20 , fonts.FONT_SIYUAN , 20);
	btnLabel:addTo(self.buyBtn);
	btnLabel:setPosition(self.buyBtn:getContentSize().width/2 , self.buyBtn:getContentSize().height/2);
	btnLabel:setTextColor(cc.c3b(255 , 255 , 255));
	btnLabel:enableOutline(cc.c4b(60 , 60 , 60 , 60) , 2);

	self.tipNode = cc.Node:create()
	self.tipNode:addTo(self.bottomNode)
	local tipBg = cc.Sprite:create('image/commonImg/tip_bg_1_309_28.png')
	tipBg:addTo(self.tipNode)
	local tipLabel = cc.Label:createWithTTF(LANG.UI_CARD_AVATAR_USE , fonts.FONT_SIYUAN , 18);
	tipLabel:addTo(self.tipNode);
	tipLabel:setTextColor(cc.c3b(255 , 255 , 0));
	local tipSpr = cc.Sprite:create('image/commonImg/tip_2.png')
	tipSpr:addTo(self.tipNode)
	tipSpr:setPosition( -20-tipLabel:getContentSize().width/2 ,0)

	spine_res = 'pifuchuandai_spine';
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.btnAni = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.btnAni:addTo(self.bottomNode)
	end


	-- self.scorllview:addEventListener( handler(self , self.rewardEvent)  );

	EventManager:RegisterEvent(EventType.NetworkRetCardAvatarChange , handler(self, self.retCardAavatarChange));
	EventManager:RegisterEvent(EventType.NetworkRetCardAvatarGet , handler(self, self.retCardAavatarGet));
	EventManager:RegisterEvent(EventType.NetworkRetCardAvatarCheck , handler(self, self.retCardAavatarCheck));


	self.swtichBtn = ccui.Button:create('image/main/main_witch_btn_1_.png' , 'image/main/main_witch_btn_1_.png');
	self.swtichBtn:addTo(self.root);
	self.swtichBtn:setPosition(-StageSize.width/2+120 , -StageSize.height/2+200);
	self.swtichBtn:addClickEventListener(handler(self , self.swtichBtnClick));

	self.swtichBtnImg = cc.Sprite:create('image/main/main_live2d_off.png');
	self.swtichBtnImg:addTo(self.swtichBtn);
	self.swtichBtnImg:setPosition(self.swtichBtn:getContentSize().width/2,self.swtichBtn:getContentSize().height/2+4);

	self.showLive2dBtn = ccui.Button:create('image/main/main_witch_btn_1_.png', 'image/main/main_witch_btn_1_.png');
	self.showLive2dBtn:addTo(self.root);
	self.showLive2dBtn:setPosition(-StageSize.width/2+56 , -StageSize.height/2+200);
	self.showLive2dBtn:addClickEventListener(handler(self , self.showLive2dBtnCall));
	self.showLive2dBtn:setTag(1);

	self.showLive2dImg = cc.Sprite:create('image/main/main_ui_off.png');
	self.showLive2dImg:addTo(self.showLive2dBtn);
	self.showLive2dImg:setPosition(self.showLive2dBtn:getContentSize().width/2,self.showLive2dBtn:getContentSize().height/2+4);

	self:initModelNode();
end

function CardAvatarUsePanel:initModelNode()
	self.modelNode = cc.Node:create()
	self.modelNode:addTo(self.root)
	self.modelNode:setVisible(false)

	local bgBtn = ccui.Button:create('image/commonImg/mask_icon.png');
	bgBtn:addTo(self.modelNode);
	bgBtn:setContentSize(cc.size(StageSize.width , StageSize.height))
	bgBtn:setScale9Enabled(true)
	-- bgBtn:setOpacity(0)
	bgBtn:addClickEventListener(function()
		self.modelNode:setVisible(false)
	end);

	local bg = cc.Sprite:create('image/card/cardAvatar/avatar_model_bg.png')
	bg:addTo(self.modelNode)

end

function CardAvatarUsePanel:onShowModel()
	if self.lastArmature ~= nil then
		self.lastArmature:removeFromParent();
		DragonBonesManager:RemoveDisplay(self.lastArmatureId)
		self.lastArmature = nil
		self.lastArmatureId = -1;
	end

	local roleResData = ResTable:getRowData('role_resource', self.resIdList[ self.curSelIdx ]);
	local modelPath = roleResData.model;
	if not modelPath then return; end
	local armature, id = DragonBonesManager:GetArmature(modelPath);
	armature:setName('model');
	armature:addTo(self.modelNode);
	armature:setScale(0.8);
	self.lastArmature,self.lastArmatureId = armature,id;

	armature:getAnimation():play(AnimationType.idle, -1);

	self.modelNode:setVisible(true)

end

function CardAvatarUsePanel:rewardEvent(sender , event)
	-- if event == ccui.ScrollviewEventType.containerMoved then
 --        local x = sender:getInnerContainerPosition().x;
 --        local per = -x/self.maxOffsetX;
 --        if per > 1 then
 --        	per = 1;
 --        end
 --        if per < 0 then
 --        	per = 0;
 --        end

 --        self.bar:setPosition(7 + per * self.barMoveXMax , -14);
	-- end
end

function CardAvatarUsePanel:updateInfo( pid, no )
	-- body
	self.pid = pid;
	self.roldId = no;
	local curAvatarId = model.CardModel:getCardResIdByPid(pid);
	local lastSelIdx = 1;
	self.curUseIdx = 1;

	self.scorllview:removeAllChildren();
	self.cardList = {};
	self.cardOtherNodeList = {};

	self.avatarIdList = {};
	local isCheckAvatar = false;
	local roleData = ResTable:getRowData('role', self.roldId);
	if roleData then

		local rname = ResTable:getValue('role_info',self.roldId,'name');
		self.avatarIdList[1] = { 0, true, rname };
		if roleData.avatar_id and next(roleData.avatar_id) ~= nil then
			for i,v in ipairs(roleData.avatar_id) do
				local isHave = model.CardModel:onIsHaveAvatarByAvatarItemId(v);
				local roleAvatar = ResTable:getRowData('role_avatar', v);
				if roleAvatar then
					self.avatarIdList[i+1] = { v, isHave ,roleAvatar.name,roleAvatar.gateway};
					if not isHave and v == self.roldId * 100 then
						isCheckAvatar = true;
					end
				end
			end
		end
	end

	self.resIdList = model.CardModel:getAvatarResList( self.roldId );

	local totalNum = #self.resIdList;
	local maxWidth = 210*totalNum + 10;
	self.scorllview:setInnerContainerSize( cc.size(maxWidth , 150) );

	for i=1, #self.resIdList do

		local name , time = self:getAvartCardInfo(i);

		local cellNode = cc.Node:create()
		cellNode:addTo(self.scorllview)
		cellNode:setPosition(100 + 200*(i-1), 75)
		cellNode:setScale(0.8)

		local bgBtn = ccui.Button:create('image/commonImg/mask_icon.png');
		bgBtn:addTo(cellNode);
		bgBtn:setContentSize(cc.size(185 , 102))
		bgBtn:setScale9Enabled(true)
		bgBtn:addClickEventListener(handler(self , self.onSelAvatar));
		bgBtn:setTag(i);
		bgBtn:setSwallowTouches(false)
		-- bgBtn:setOpacity(0);

		local roleResData = ResTable:getRowData('role_resource', self.resIdList[i]);
		local icon = cc.Sprite:create('image/role/'..roleResData.card..'.png')
		icon:addTo(cellNode)

		local roleSize = icon:getContentSize();
		local offScale = roleResData['avatar_show'][3]
		local w = 185/offScale;-- 185*4
		local h = 102/offScale;--102*4
		local offx = roleResData['avatar_show'][1]
		local offy = roleResData['avatar_show'][2]
		icon:setTextureRect(cc.rect( roleSize.width/2+offx-w/2, roleSize.height/2-offy-h/2 , w , h));
		icon:setScale(offScale)

		-- local maxW = icon:getContentSize().width;
		-- local maxH = icon:getContentSize().height;
		-- icon:setTextureRect(cc.rect(maxW/2-(185*2) , maxH/2-(102*2) , 185*4 , 102*4));
		-- icon:setScale(0.25)

		local bg = cc.Sprite:create('image/card/cardAvatar/avatar_cell_bg.png');
		bg:addTo(cellNode);

		local nbg = cc.Sprite:create('image/card/cardAvatar/avatar_cell_n.png')
		nbg:addTo(cellNode)
		nbg:setPosition(0 , -38);

		local nameLabel = cc.Label:createWithTTF(name , fonts.FONT_SIYUAN , 16);
		nameLabel:addTo(cellNode);
		nameLabel:setPosition(0 , -38);

		local avatarNo = self.avatarIdList[i][1];
		local shadowTip = cc.Node:create()
		shadowTip:addTo(cellNode)

		local shadowSpr = ccui.Scale9Sprite:create("image/commonImg/mask_icon.png");
		shadowSpr:setContentSize(cc.size(190 , 110));
		shadowSpr:addTo(shadowTip)
		local lockSpr = cc.Sprite:create('image/cardLove/card_love_7.png')
		lockSpr:addTo(shadowTip)

		local getTipNode = cc.Node:create();
		getTipNode:addTo(shadowTip)

		local gateway = self.avatarIdList[i][4];
		local avatarTipLabel = cc.Label:createWithTTF(gateway or '',fonts.FONT_SIYUAN,20)
		:addTo(getTipNode)
		:setPosition(0,3)
		:enableOutline(cc.c4b(0,0,0,255),2)

		local avatarTipLine = cc.Scale9Sprite:create('image/commonImg/line4.png')
		:addTo(getTipNode)
		:setPosition(0 , -10)
		:setCapInsets(cc.rect(4,0,16,5))

		local width = avatarTipLabel:getContentSize().width;
		avatarTipLine:setContentSize(cc.size(width+6,5));

		local label = cc.Label:createWithTTF(LANG.COMMON_CLICK_GET,fonts.FONT_SIYUAN,20)
		:setTextColor(cc.c3b(255,255,0))
		:enableOutline(cc.c3b(135,100,55),2)
		local getAvatarBtn = ccui.Button:create('image/commonImg/btn_13.png','image/commonImg/btn_13.png');
		getAvatarBtn:addTo(shadowTip);
		getAvatarBtn:setTitleLabel(label);
		getAvatarBtn:addClickEventListener(function()
			Network.NetworkManager:Send(Network.NetworkCmdType.req_card_avatar_get , {no = self.roldId});
		end);

		if self.avatarIdList[i][2] then
			shadowTip:setVisible(false)
		else
			shadowTip:setVisible(true)
			getAvatarBtn:setVisible(false)
			if avatarNo == 100*self.roldId then
				getTipNode:setVisible(true)
				lockSpr:setVisible(false)
			else
				lockSpr:setVisible(true)
			end
		end

		-- local bigCard = template.CardTemplate:create(self.scorllview);
		-- bigCard:setAvatarRes( self.roldId, self.resIdList[i], self.avatarIdList[i], name, time );
		-- bigCard:setPosition( 206*(i-1) + 103 , 212);
		-- bigCard:addCardClickEventListener(handler(self, self.onSelAvatar));
		-- bigCard:setCardTag(i);

		-- self.cardList[i] = bigCard;

		self.cardList[i] = cellNode;
		self.cardOtherNodeList[i] = {lockSpr=lockSpr, getAvatarBtn=getAvatarBtn, shadowTip=shadowTip , getTipNode=getTipNode}

		if self.resIdList[i] == curAvatarId then
			lastSelIdx = i;
		end
		DownloadControler:checkNeedDownloadSpineModel(roleResData.model)

		-- if i <= 6 then
		-- 	bigCard:runCardListAction(0.03 * i);
		-- end
	end

	-- self.curUseFlag = cc.Sprite:create('image/commonImg/card_select.png');

	if self.avatarIdList[lastSelIdx][2]==false then
		lastSelIdx = 1;
	end

	self.curUseFlag:addTo(self.scorllview);
	self.useAniNode:addTo(self.scorllview);
	self.cardList[lastSelIdx]:setScale(1.0)
	local tmpPtx, tmpPty = self.cardList[lastSelIdx]:getPosition();
	self.curUseFlag:setPosition(  tmpPtx-70, tmpPty+35 );
	self.curUseFlag:setScale(1.0)
	self.curUseIdx = lastSelIdx;
	self.curSelIdx = lastSelIdx;

	self.selFlag = cc.Sprite:create('image/card/cardAvatar/avatar_sel.png');
	self.selFlag:addTo(self.scorllview);
	self.selFlag:setPosition(tmpPtx, tmpPty);

	self:updateRolePic(lastSelIdx)

	if isCheckAvatar then
		Network.NetworkManager:Send(Network.NetworkCmdType.req_card_avatar_check , {no = self.roldId});
	end
end

function CardAvatarUsePanel:registerHandler()

	self.swallowLayer = cc.LayerColor:create(cc.c4b(0, 0, 0, 0));
	self.swallowLayer:setContentSize( cc.size(StageSize.width, StageSize.height) );
	self.swallowLayer:setPosition(-StageSize.width/2, -StageSize.height/2);
	self.swallowLayer:setLocalZOrder(100);
	self.swallowLayer:addTo(self.root);

	-- listener
	self.swallowListener = cc.EventListenerTouchOneByOne:create();
	local onTouchBegan = function(touch, event)
		self.bMove = false;
        return true
	end
	local onTouchMove = function(touch,event)
		local posEnd = touch:getLocation();
		local posStart = touch:getStartLocation()
		local dis = cc.pGetDistance(posStart,posEnd)
		if dis > 20 then
			self.bMove = true;
		end
	end
	local onTouchEnd = function(touch ,event )
	end
	self.swallowListener:setSwallowTouches(false);
	self.swallowListener:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN);
	self.swallowListener:registerScriptHandler(onTouchMove, cc.Handler.EVENT_TOUCH_MOVED);
	self.swallowListener:registerScriptHandler(onTouchEnd, cc.Handler.EVENT_TOUCH_ENDED);
	local eventDispatcher = self.swallowLayer:getEventDispatcher();
	eventDispatcher:addEventListenerWithSceneGraphPriority(self.swallowListener, self.swallowLayer);
end

function CardAvatarUsePanel:updateRolePic( idx )
	local roleResData = ResTable:getRowData('role_resource', self.resIdList[idx]);
	self.avatarSpr:setTexture('image/role/'..roleResData.card..'.png');

	self.headIcon:setTexture('image/icon/'..roleResData.icon..'.png')

	local name , time = self:getAvartCardInfo(idx);
	self.nameLabel:setString(name)

	if self.curUseIdx == idx then
		self.tipNode:setVisible(true)
		self.buyBtn:setVisible(false)
		self.btnAni:setAnimation(0, "shine", false)
	else
		self.tipNode:setVisible(false)
		self.buyBtn:setVisible(true)

		self.bottomNode:stopAllActions()
	end

	local spine_res = roleResData.spine;
	if spine_res~=nil and cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		if self.lastSpine ~= spine_res then
			self.skeletonNode:removeAllChildren();
			local skeAni = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			skeAni:addTo(self.skeletonNode)
			skeAni:setAnimation(0, "idle", true)

			self.lastSpine = spine_res;
		end

		self.swtichBtn:setVisible(true)
		self.bHaveSpine = true
	else
		self.swtichBtn:setVisible(false)
		self.bHaveSpine = false
	end

	self.skeletonNode:setVisible(false)
	self.avatarSpr:setVisible(true)
	self.swtichBtnImg:setTexture('image/main/main_live2d_on.png');

	self.avatarSpr:setOpacity(0)
	self.avatarSpr:runAction( cc.FadeIn:create(0.5) )

end

function CardAvatarUsePanel:getAvartCardInfo(index)
	local name = '';
	if true then --self.avatarIdList[index][1] ~= 0
		name = self.avatarIdList[index][3];
	end
	local time = '';
	local avatarData = model.CardModel:onGetAvatarData( self.avatarIdList[index][1] );
	if avatarData then
		-- name = ResTable:getValue('role_avatar', avatarData.no, 'name');
		if avatarData.overdue_time == 0 then
			time = LANG.UI_L_FOROVER;
		else
			time = GlobalFunctions:ChangeFormatTime( avatarData.overdue_time - os.time() );
		end
	end

	return name , time;
end

function CardAvatarUsePanel:onSelAvatar( sender , event )
	-- body
	if self.bMove then
		return;
	end
	AudioManager:playEffect(Conf.buttonClick);
	local idx = sender:getTag();
	if not self.avatarIdList[idx][2] then
		if self.roldId * 100 == self.avatarIdList[idx][1] then
			Prompt:Show(LANG.UI_CARD_68);
		end
		return;
	end
	self.curSelIdx = idx;
	self.selFlag:setPosition( self.cardList[idx]:getPosition() );
	for k,v in pairs(self.cardList) do
		if k==self.curSelIdx then
			v:setScale(1.0)
		else
			v:setScale(0.8)
		end
	end
	local tmpPtx, tmpPty = self.cardList[self.curUseIdx]:getPosition();
	if self.curSelIdx == self.curUseIdx then
		self.curUseFlag:setPosition(  tmpPtx-70, tmpPty+35 );
		self.curUseFlag:setScale(1.0)
	else
		self.curUseFlag:setPosition(  tmpPtx-50, tmpPty+30 );
		self.curUseFlag:setScale(0.8)
	end

	self:updateRolePic( self.curSelIdx )

	local ret = model.UserDefaultModel:getDataByKey( 'avatar_'..self.resIdList[self.curSelIdx] )
	if ret ~= 1 then
		model.UserDefaultModel:setDataByKey( 'avatar_'..self.resIdList[self.curSelIdx], 1 )
	end
end

function CardAvatarUsePanel:onEnter( pid, no )

	self:updateInfo(pid, no);
	self.modelNode:setVisible(false)
	
	self.root:setVisible(true);

end

function CardAvatarUsePanel:retCardAavatarGet(msg)
	for _k , data in pairs(self.avatarIdList) do
		if data[1] == msg.avatar_no then
			self.avatarIdList[_k][2] = true;
			local name , time = self:getAvartCardInfo(_k);
			self.cardOtherNodeList[_k].shadowTip:setVisible(false)
			-- self.cardList[_k]:setAvatarRes( self.roldId, self.resIdList[_k], self.avatarIdList[_k], name, time );
			break;
		end
	end
	UIManager:push('RewardPanel',msg);
end

function CardAvatarUsePanel:retCardAavatarCheck(msg)
	for _k , data in pairs(self.avatarIdList) do
		if data[1] == self.roldId * 100 and msg.is_get == 1 then
			self.cardOtherNodeList[_k].getTipNode:setVisible(false)
			self.cardOtherNodeList[_k].shadowTip:setVisible(true)
			self.cardOtherNodeList[_k].getAvatarBtn:setVisible(true)
			self.cardOtherNodeList[_k].lockSpr:setVisible(false)
			break;
		end
	end
end

function CardAvatarUsePanel:OkButtonClick(sender , event)
	if self.curSelIdx == 0 then
		return;
	end
	AudioManager:playEffect(Conf.confirmButton);
	local msg = {};
	msg.pid = self.pid;
	msg.aid = model.CardModel:getMaxAvatarByItemId( self.avatarIdList[ self.curSelIdx ][1] );
	if self.avatarIdList[ self.curSelIdx ][1] == 0 then
		msg.aid = 0;
	end
	if msg.aid == -1 then
		return;
	end
	self.buyBtn:setEnabled(false)
	self.lastUseIdx = self.curSelIdx
	Network.NetworkManager:Send(Network.NetworkCmdType.req_card_avatar_change , msg);
end

function CardAvatarUsePanel:retCardAavatarChange(msg,oldResId)
	self.btnAni:setAnimation(0, "button", false)
	self.curUseIdx = self.lastUseIdx
	self.buyBtn:setEnabled(true)

	if self.curSelIdx == self.lastUseIdx then
		self.bottomNode:runAction(cc.Sequence:create( cc.DelayTime:create(1), cc.CallFunc:create(function()
			self.tipNode:setVisible(true)
			self.buyBtn:setVisible(false)
			self.btnAni:setAnimation(0, "shine", false)
		end
		) ))
	end
	
	
	local avatarTemplate = self.cardList[self.curUseIdx];
	if avatarTemplate then
		local tmpPtx, tmpPty = avatarTemplate:getPosition();
		self.curUseFlag:setPosition(  tmpPtx-70, tmpPty+35 );
		self.curUseFlag:setScale(1)

		self.useAniNode:setPosition(  tmpPtx, tmpPty );
		self.useAniNode:setVisible(true)
		self.useSkeAni:setAnimation(0, "pifuchuandai_spine", false)
		self.useParticle:resetSystem()
		self.useAniNode:runAction(cc.Sequence:create( cc.DelayTime:create(0.5), cc.CallFunc:create(function()
			self.useAniNode:setVisible(false)
		end
		) ))

		-- local name = '';
		-- if msg.aid == 0 then
		-- 	local card = model.CardModel:GetCard(msg.pid);
		-- 	name = ResTable:getValue('role_info', card.no, 'name');
		-- else
		-- 	local card = model.CardModel:getCardAvatar(msg.aid);
		-- 	local avatarID = card.no;
		-- 	name = ResTable:getValue('role_avatar', avatarID, 'name');
		-- end

		-- ShowAnimationPanel:Show('CardAvatarUsePanel' , function()
		-- 	local animationNode = ShowAnimationPanel:getAnmiationNode();
		-- 	animationNode:runAction(cc.Sequence:create(cc.DelayTime:create(0.5) , cc.CallFunc:create(function() 
		-- 		UIManager:pop('CardAvatarUsePanel');
		-- 		UIManager:push('CardLivePanel' , msg.pid, oldResId);
		-- 	end)));
			
		-- 	local particleNode = cc.Node:create();
		-- 	particleNode:addTo(animationNode);
		-- 	particleNode:setPosition(-StageSize.width/2,-StageSize.height/2);

		-- 	local x , y = avatarTemplate:getPosition();
		-- 	local wsPos = avatarTemplate:getParent():convertToWorldSpace(cc.p(x , y));
		-- 	local beginPos = particleNode:convertToNodeSpace(wsPos);
			
		-- 	local particleKey = cc.ParticleSystemQuad:create("Effect/particle/yaoshi1.plist")
		-- 	particleKey:addTo(particleNode);
		-- 	particleKey:setPosition(beginPos);
		-- 	particleKey:resetSystem();
			
		-- 	local endPos = cc.p(StageSize.width/2,StageSize.height/2+200);
			
		-- 	local bezierP1,bezierP2 = cc.p(0,0),cc.p(0,0);
		-- 	if endPos.x > beginPos.y  then
		-- 		bezierP1.x = endPos.x + 100;
		-- 		bezierP2.x = endPos.x + 50;
		-- 	else
		-- 		bezierP1.x = endPos.x - 100;
		-- 		bezierP2.x = endPos.x - 50;
		-- 	end
		-- 	bezierP1.y = beginPos.y + 200 --(endPos.y - beginPos.y)/2
		-- 	bezierP2.y = beginPos.y + 200 --(endPos.y - beginPos.y)/1
		-- 	local bezierAct = cc.BezierTo:create(1 ,{bezierP1,bezierP2,endPos});
		
		-- 	particleKey:runAction(cc.Sequence:create(bezierAct , cc.CallFunc:create(function() 
		-- 		particleKey:stopSystem();
			
		-- 		local spine_res = 'jiesuanjihuo_spine'
		-- 		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		-- 			local avatarChangeSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		-- 			avatarChangeSpine:addTo(particleNode)
		-- 			avatarChangeSpine:setPosition(cc.p(StageSize.width/2,StageSize.height/2));
		-- 			avatarChangeSpine:setAnimation(0,'jiesuanjihuo_spine',false);

		-- 			avatarChangeSpine:registerSpineEventHandler(function (event)
		-- 				if event.eventData.name == 'change' then
		-- 					local resId = model.CardModel:getCardResIdByPid( msg.pid );
		-- 					 EventManager:FireEvent(EventType.UICardLiveUpdate , msg.pid , resId);
		-- 				end
		-- 			end, sp.EventType.ANIMATION_EVENT);
	 
		-- 			avatarChangeSpine:registerSpineEventHandler(function (event)
		-- 				avatarChangeSpine:runAction(cc.Sequence:create(cc.DelayTime:create(0.01), cc.CallFunc:create(function() 
		-- 					ShowAnimationPanel:Hide()
		-- 					Prompt:Show( string.format(LANG.UI_CARD_AVATAR , (name and tostring(name) or '') ) );
		-- 				end)));
		-- 			end, sp.EventType.ANIMATION_COMPLETE)
		-- 		else
		-- 			print('error : 缺少spine 资源')
  --  				end
		-- 	end)));
		-- end);
	end
end

function CardAvatarUsePanel:onLeave()
	self.root:setVisible(false);
end

function CardAvatarUsePanel:onClickBack()
	UIManager:pop('CardAvatarUsePanel');
end

function CardAvatarUsePanel:showLive2dBtnCall( sender,event )
	local tag = sender:getTag();

	local nextTag = 1;
	local btnImg = 'image/main/main_ui_off.png'
	if tag == 1 then
		-- 屏蔽
		nextTag = 2;
		btnImg = 'image/main/main_ui_on.png';

		self.topNode:setVisible(false)
		self.bottomNode:setVisible(false)
		self.scorllview:setVisible(false)
		self.swtichBtn:setVisible(false)

		UIManager:pop('HeaderPanel')
	else
		-- 显示
		UIManager:push("HeaderPanel" , self.name , self);

		self.topNode:setVisible(true)
		self.bottomNode:setVisible(true)
		self.scorllview:setVisible(true)
		self.swtichBtn:setVisible(self.bHaveSpine)

	end
	self.showLive2dBtn:setTag(nextTag)
	self.showLive2dImg:setTexture(btnImg)
end

function CardAvatarUsePanel:swtichBtnClick()
	-- body
	if self.skeletonNode:isVisible() then
		self.swtichBtnImg:setTexture('image/main/main_live2d_on.png');
		self.skeletonNode:setVisible(false)
		self.avatarSpr:setVisible(true)
	else
		self.swtichBtnImg:setTexture('image/main/main_live2d_off.png');
		self.skeletonNode:setVisible(true)
		self.avatarSpr:setVisible(false)
	end
end

return CardAvatarUsePanel;
