local CardCommentPanel = class("CardCommentPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local imagePath = 'image/card/cardComment/'

function CardCommentPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardCommentPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function CardCommentPanel:Init(root)
      self.root = root;
	  self.root:setVisible(false);
	  
	  self.commentTime = 0;

      self:InitPanels();
end

function CardCommentPanel:InitPanels()

	local bg = cc.Sprite:create(imagePath..'card_comment_bg_1.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -10);

    GlobalFunctions:createTitleNode( bg, LANG.UI_COMMENT_1, LANG.UI_COMMENT_2,  
	bg:getContentSize().width/2, bg:getContentSize().height -18 );

	self.icon = template.ItemTemplate:create(2);
	self.icon:addTo(self.root);
	self.icon:setPosition(-218 , 289);

	self.cardName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	self.cardName:enableOutline(cc.c3b(255, 255, 255), 2)
	self.cardName:setTextColor(cc.c3b(60 , 60 , 60))
	self.cardName:setAnchorPoint(0, 0.5)
	self.cardName:setPosition(-150, 321)
	self.cardName:addTo(self.root)

	self.cardJob = cc.Sprite:create();
	self.cardJob:addTo(self.root);
	self.cardJob:setPosition(61 , 321);
	self.cardJob:setAnchorPoint(0 , 0.5);

	self.likeBtn = ccui.Button:create(imagePath..'card_comment_bg_10.png' , imagePath..'card_comment_bg_10.png');
	self.likeBtn:addTo(self.root);
	self.likeBtn:setPosition(214 , 321);
	self.likeBtn:addClickEventListener(handler(self , self.likeBntClick))

	local btnTitle = cc.Label:createWithTTF(LANG.UI_COMMENT_3, fonts.FONT_SIYUAN, 20)
	btnTitle:addTo(self.likeBtn);
	btnTitle:setPosition(self.likeBtn:getContentSize().width/2 + 20 , self.likeBtn:getContentSize().height/2);
	btnTitle:enableOutline(cc.c3b(40 , 130 , 230),2);

	local likeBg = cc.Sprite:create(imagePath..'card_comment_bg_8.png');
	likeBg:addTo(self.root);
	likeBg:setPosition(-131 , 276);

	self.likeNum = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	self.likeNum:setTextColor(cc.c3b(60 , 60 , 60));
	self.likeNum:setAnchorPoint(0, 0.5)
	self.likeNum:setPosition(-108, 276)
	self.likeNum:addTo(self.root)

	self.commentNum = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	self.commentNum:setTextColor(cc.c3b(60 , 60 , 60));
	self.commentNum:setAnchorPoint(0, 0.5)
	self.commentNum:setPosition(142, 231)
	self.commentNum:addTo(self.root)

	bg = cc.Sprite:create(imagePath..'card_comment_bg_2.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -63);

	local initData = {
        width = 522,
        height = 542,
        cellWidth = 522,
        cellHeight = 145,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		viewDidScrollFunc = handler(self,self.viewDidScrollFunc),
	}
	
	self.commentTableView = template.TableViewTemplate:create()
    self.commentTableView:initWithSizeAndItem(initData) ;
    self.commentTableView:getView():setPosition(cc.p(-264,-333));
    self.commentTableView:getView():addTo(self.root)

	
	--local barBg = cc.Sprite:create(imagePath..'card_comment_bg_3.png');
	--barBg:addTo(self.root);
	--barBg:setPosition(262 , -61);
--
	--self.bar = cc.Sprite:create(imagePath..'card_comment_bg_4.png');
	--self.bar:setAnchorPoint( cc.p(0,0) );
	--self.bar:setPosition(9, -14);
	--self.bar:addTo(self.root);

	--self.barMoveXMax = barBg:getContentSize().width - self.bar:getContentSize().width - 2;

	local commentBg = cc.Sprite:create(imagePath..'card_comment_bg_12.png');
	commentBg:addTo(self.root);
	commentBg:setPosition(-76 , -373);

	--commentBg = cc.Sprite:create(imagePath..'card_comment_bg_13.png');
	--commentBg:addTo(self.root);
	--commentBg:setPosition(-76 , -373);

	self.textBox = cc.EditBox:create(cc.size(388, 33),imagePath..'card_comment_bg_13.png');
	self.textBox:setFontColor(cc.c3b(255, 255, 255))
	self.textBox:setMaxLength(50);
	self.textBox:setFont(fonts.FONT_SIYUAN, 20);
	self.textBox:registerScriptEditBoxHandler(handler(self, self.handlerInput));
	self.textBox:setPosition(-76, -373);
	self.textBox:addTo(self.root);

	self.sendBtn = ccui.Button:create(imagePath..'card_comment_bg_14.png',imagePath..'card_comment_bg_14.png');
	self.sendBtn:addTo(self.root);
	self.sendBtn:setPosition(202 , -373);
	self.sendBtn:addClickEventListener(handler(self , self.sendBtnClick));

	local sendBtnTitle = cc.Label:createWithTTF(LANG.UI_COMMENT_5 , fonts.FONT_SIYUAN , 20);
	sendBtnTitle:enableOutline(cc.c3b(60 , 60 , 60) , 2);
	self.sendBtn:setTitleLabel(sendBtnTitle);

	self:registEvent();
end

function CardCommentPanel:registEvent()
    EventManager:RegisterEvent(EventType.NetworkRetCardCommentInfo,handler(self,self.onShow));
    EventManager:RegisterEvent(EventType.NetworkRetCardCommentCardLike,handler(self,self.retCommentCardLike));
    EventManager:RegisterEvent(EventType.NetworkRetCardCommentLike,handler(self,self.retCommentLike));
    EventManager:RegisterEvent(EventType.NetworkRetCardComment,handler(self,self.retComment));
end

function CardCommentPanel:reloadCellPanel(cell , idx)
	local cellNode = cell:getChildByTag(999);
	if not cellNode then
		cellNode = template.CardCommentTemplate:create();
		cellNode:addTo(cell);
		cellNode:setTag(999);
		cellNode:setPosition(261 , 63.5); --261,72.5
		cellNode:addLikeClickEventListener(handler(self , self.commentLikeClick))
	end

	local data = self.comment[idx+1];
	cellNode:Init(data);
	--cellNode:setLikeTag(data.cid);
end

function CardCommentPanel:handlerInput(eventName, pSender)
	if eventName == "began" then
		self.textBox:setText("");
	end
	
	if eventName == "return" then
		local str =  self.textBox:getText()
		self.editInputStr = str;
		local str2,bRet = tools.SensitiveTools:checkSensitive( str )
		self.textBox:setText(str2)
		if bRet == true then
			Prompt:Show(LANG.UI_SENSITIVE);
			return 
		end
	end

end

function CardCommentPanel:rewardEvent(sender , event)
	if event == ccui.ScrollviewEventType.containerMoved then
        local x = sender:getInnerContainerPosition().x;
        local per = -x/self.maxOffsetX;
        if per > 1 then
        	per = 1;
        end
        if per < 0 then
        	per = 0;
        end

        self.bar:setPosition(9 + per * self.barMoveXMax , -14);
	end
end
                                     
function CardCommentPanel:onEnter(no)
	model.CardCommentModel:reqCardCommentData(no , 1);
end

function CardCommentPanel:onShow(msg)

	self:addSwallowCallback(handler(self , self.onClickBack));
	self:updateData(msg.no , msg.reset == 0)
	self.root:setVisible(true);
end

function CardCommentPanel:viewDidScrollFunc(view)
	if self.commentTotalNum >= 4 then
		local offset = view:getContentOffset();
		if offset.y > 5 then
			model.CardCommentModel:reqCardCommentData(self.no);
		end
	end
end

function CardCommentPanel:updateData(no , notReset)
	self.no = no;

	local commentData = model.CardCommentModel:getCommentDataByNo(self.no);
	
	if not commentData then
		return
	end
	
	local roleData = ResTable:getRowData('role', self.no);
	local roleInfoData = ResTable:getRowData('role_info', roleData.role_id);
	local rolePreData = ResTable:getRowData('role_pre', roleData.role_id);
	
	self.cardName:setString(tostring(roleInfoData.name));
	self.cardJob:setTexture('image/card/card_job_'..rolePreData.job_type..'.png');
	self.icon:Init(ROLE_TYPE,self.no);

	local width = self.cardName:getContentSize().width;
	self.cardJob:setPositionX(self.cardName:getPositionX() + width + 10);
	
	self.comment = {};
	if commentData.comment then
		for _cid , cData in pairs(commentData.comment) do
			table.insert(self.comment , cData);
		end
	end
	
	self.commentTotalNum = #self.comment;
	if self.commentTotalNum > 1 then
		table.sort(self.comment , function(first , second)
			return first.cid > second.cid;
		end)
	end
	
	local totalNum = model.CardCommentModel:getCommentTotalNum(no)

	self.commentNum:setString(string.format(LANG.UI_COMMENT_4,totalNum));

	self.commentTableView:reloadData(self.comment);
	if notReset then
		self.commentTableView:jumpToCurPos();
	end

	self:updateCardLikeData(self.no);
end

function CardCommentPanel:updateCardLikeData(no)
	local commentData = model.CardCommentModel:getCommentDataByNo(no);
	if not commentData then
		return
	end

	local likeState = model.CardCommentModel:getCommentCardLikeState(no);

	self.likeBtn:setVisible(likeState <= 0);
	self.likeNum:setString(tostring(commentData.likeNum));
end

function CardCommentPanel:likeBntClick()
	model.CardCommentModel:reqCardCommentCardLike(self.no)
end

function CardCommentPanel:commentLikeClick(tag , no , cid)
	model.CardCommentModel:reqCardCommentLike(tag , no , cid)
end

function CardCommentPanel:sendBtnClick()
	if (os.time() - self.commentTime) < 10 then
		Prompt:Show(LANG.CHAT_5);
		return;
	end
	self.commentTime = os.time();
	model.CardCommentModel:reqCardComment(self.no,self.editInputStr);
end

function CardCommentPanel:retCommentCardLike(msg)
	self:updateCardLikeData(msg.no);
end

function CardCommentPanel:retCommentLike(msg)
	local commentData = model.CardCommentModel:getCommentDataByNo(msg.no);
	if not commentData or not commentData.comment[msg.cid] then
		return
	end
	
	for idx , data in ipairs(self.comment) do
		local cell = self.commentTableView:cellAtIndex(idx - 1);
		if cell then
			local cellNode = cell:getChildByTag(999);
			if cellNode and cellNode:getCid() == msg.cid then
				cellNode:Init(commentData.comment[msg.cid]);
				break;
			end
		end
	end
end

function CardCommentPanel:retComment(msg)
	
	self:updateData(msg.no);
	
	self.textBox:setText("");
end

function CardCommentPanel:onLeave()
	self.root:setVisible(false);
end

function CardCommentPanel:onClickBack()
	UIManager:pop('CardCommentPanel');
end

return CardCommentPanel;
