local CardComposePanel = class("CardComposePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/home/cardCompose/'
local ALL_RANK = 9999;
local MessageBoxType = Enum:getTable('MessageBoxType')

local menuStar = {
	[1] = ALL_RANK,
	[2] = 1,
	[3] = 2,
	[4] = 3,
}

function CardComposePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardComposePanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function CardComposePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.updateMenuFlag = false;
	self.cardMenuRanks = {};
	self.selectPidList = {-1 , -1 , -1};

	self:initPanels()
end

function CardComposePanel:initPanels()

	local bg = cc.Sprite:create('image/bg/Bg_3.png');
	bg:addTo(self.root);

	bg = cc.Sprite:create(imagePath..'card_compose_bg_1.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -254);


	self.composeSlots = {};
	for i = 1 , 3 do
		self.composeSlots[i] = {};

		self.composeSlots[i].slot = cc.Node:create();
		self.composeSlots[i].slot:addTo(self.root);
		self.composeSlots[i].slot:setPosition(-195 + 195 * (i - 1) , 275);
		self.composeSlots[i].slot:setScale(i == 2 and 1 or 0.8);

		self.composeSlots[i].slotNo = cc.Sprite:create(imagePath..'card_compose_bg_2.png');
		self.composeSlots[i].slotNo:addTo(self.composeSlots[i].slot);

		self.composeSlots[i].icon = template.CardTemplate:create(self.composeSlots[i].slot);
		self.composeSlots[i].icon:addCardClickEventListener(handler(self , self.composeIconClick));
	end

	self.costItemList = {};
	for i = 1 , 2 do

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(i == 1 and -192 or 12 , 22);

		local bg = cc.Sprite:create('image/card/cardLevelUpStar/card_levelup_star_bg_5.png');
		bg:addTo(node);

		bg = cc.Sprite:create('image/icon/I'..CARD_COMPOSE_ITEM..'.png');
		bg:addTo(node);
		bg:setScale(0.4);
		bg:setPosition(-81 , 2);
	
		local label = cc.Label:createWithTTF(i == 1 and LANG.UI_CARD_19 or LANG.UI_CARD_20, fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
		label:setPosition(-40 , 0);

		self.costItemList[i] = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.costItemList[i]:addTo(node);
		self.costItemList[i]:setAnchorPoint(1 , 0.5);
		self.costItemList[i]:setTextColor(cc.c3b(60 , 60 , 60));
		self.costItemList[i]:setPosition(80 , 0);
	end

	self.composeBtn = ccui.Button:create('image/commonImg/btn_bg1.png' , 'image/commonImg/btn_bg1.png');
	self.composeBtn:addTo(self.root);
	self.composeBtn:setPosition(192 , 23);
	self.composeBtn:addClickEventListener(handler(self , self.composeBtnClick));

	local btnLabel = cc.Label:createWithTTF(LANG.UI_CARD_9 , fonts.FONT_SIYUAN , 20);
	btnLabel:addTo(self.composeBtn);
	btnLabel:setPosition(self.composeBtn:getContentSize().width/2 , self.composeBtn:getContentSize().height/2);
	btnLabel:setTextColor(cc.c3b(255 , 255 , 255));
	btnLabel:enableOutline(cc.c4b(19 , 93 , 188 , 255) , 2);


	self.starMenuList = {};
    for i = 1 , 4 do
		self.starMenuList[i] = {};

		local unTexture = imagePath..'card_compose_bg_5.png';
        local texture = imagePath..'card_compose_bg_6.png';
        if i == 1 or i == 3 then
            unTexture = imagePath..'card_compose_bg_3.png';
            texture = imagePath..'card_compose_bg_4.png';
        end

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(-227 + 151 * (i - 1) , -36);
		self.starMenuList[i].node = node;

		node = cc.Node:create();
		node:addTo(self.starMenuList[i].node);
        self.starMenuList[i].unselectNode = node;

		local bgBtn = ccui.Button:create(unTexture , unTexture);
		bgBtn:addTo(node);
		bgBtn:setTag(i);
		bgBtn:setScaleX(i == 3 and -1 or 1);
		bgBtn:addClickEventListener(handler(self , self.menuBtnClick));

		if i == 1 then
			local label = cc.Label:createWithTTF('ALL' , fonts.FONT_SIYUAN , 20);
			label:addTo(node);
			label:setTextColor(cc.c3b(50 , 50 , 50));
			label:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
		end

		node = cc.Node:create();
		node:addTo(self.starMenuList[i].node);
		self.starMenuList[i].selectNode = node;

		bgBtn = ccui.Button:create(texture , texture);
		bgBtn:addTo(node);
		bgBtn:setScaleX(i == 3 and -1 or 1);

		if i == 1 then
			local label = cc.Label:createWithTTF('ALL' , fonts.FONT_SIYUAN , 20);
			label:addTo(node);
			label:enableOutline(cc.c4b(19 , 93 , 188 , 255) , 2);
		end

		local starNum = i - 1;
		local width = 20 * starNum;
		local posX = -width / 2 + 10;
		for j = 1 , starNum do
			local star = cc.Sprite:create('image/card/card_star_1.png');
			star:addTo(self.starMenuList[i].node);
			star:setPosition(posX + 20 * (j - 1) , 0);
		end
	end

	local initData = {
		width = 602,
		height = 427,
		cellWidth = 199,
		cellHeight = 427,
		direction = 0,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.cardView = template.TableViewTemplate:create()
	self.cardView:initWithSizeAndItem(initData) ;
	self.cardView:getView():setPosition(cc.p(-301, -479.5));
	self.cardView:getView():addTo(self.root)

	--self.cardView = ccui.ScrollView:create();
	--self.cardView:setTouchEnabled(true);
	--self.cardView:setBounceEnabled(true);
	--self.cardView:setDirection(ccui.ScrollViewDir.horizontal);
	--self.cardView:setContentSize(cc.size(602 , 427));
	--self.cardView:setAnchorPoint(0.5 , 0.5);
	--self.cardView:setPosition(0 , -266);
	--self.cardView:setScrollBarEnabled(false);
	--self.cardView:addEventListener(handler(self , self.cardViewEventListener));
	--self.cardView:addTo(self.root);

	EventManager:RegisterEvent(EventType.NetworkRetBaseCardComposePromotion, handler(self, self.retBaseCardComposePromotion));
	EventManager:RegisterEvent(EventType.NetworkRetBaseCardCompose, handler(self, self.retBaseCardCompose));
end

function CardComposePanel:composeIconClick(sender , event)
	local pid = sender:getTag();
	for index , curPid in ipairs(self.selectPidList) do
		if pid == curPid then
			self.selectPidList[index] = -1;
			self.composeSlots[index].icon:setVisible(false);

			for idx , selectPid in pairs(self.selectCardIndex) do
				if selectPid == pid then
					local cell = self.cardView:cellAtIndex(idx);
					if cell then
						local cellNode = cell:getChildByTag(999);
						if cellNode then
							cellNode:setState('none');
						end
					end
					self.selectCardIndex[idx] = nil;
					break;
				end
			end
			break;
		end
	end
end

function CardComposePanel:onEnter()

	self.selectIndex = 1;
	self:reset();
	
	self.root:setVisible(true);
end

function CardComposePanel:reset()
	self.selectCardIndex = {};
	self:resetState();
	self:initCards();
	self:updateList();
	self:updateMenuState();
end

function CardComposePanel:resetState()
	self.selectPidList = {-1 , -1 , -1};
	for _k , slot in pairs(self.composeSlots) do
		slot.icon:setVisible(false);
	end
end
function CardComposePanel:initCards()

	self.cards = {};
	self.cards[ALL_RANK] = {};

	for _k , card in pairs(model.CardModel:GetAllCard()) do
		if card.star_lv <= 3 and not model.CardModel:isInOtherModule(card.pid) then
			if not self.cards[card.star_lv] then
				self.cards[card.star_lv] = {};
			end
			table.insert(self.cards[ALL_RANK] ,  card);
			table.insert(self.cards[card.star_lv] ,  card);
		end
	end

	for _k , cards in pairs(self.cards) do
		if #cards > 1 then
			table.sort(cards , function(first , second)
				local firstQuality = first.quality;
				local secondQuality =  second.quality;
				
				if firstQuality > secondQuality then
					return true;
				elseif firstQuality < secondQuality then
					return false;
				end

				return first.pid < second.pid;
			end);
		end
	end	
end

function CardComposePanel:menuBtnClick(sender , event)
	local index = sender:getTag();

	if index == self.selectIndex then
		return;
	end

	self.selectIndex = index;
	self.selectCardIndex = {};
	self:resetState();
	self:updateMenuState();
	self:updateList();
end

function CardComposePanel:updateMenuState()
	for _idx , menuBtn in pairs(self.starMenuList) do
		menuBtn.unselectNode:setVisible(_idx ~= self.selectIndex);
		menuBtn.selectNode:setVisible(_idx == self.selectIndex);
	end
end

function CardComposePanel:updateList()
	--self.cardView:removeAllChildren();
	self.cardList = {};

	--self:updateCost();

	if not self.cards[menuStar[self.selectIndex]] then
		self.cardView:reloadData({});
		return;
	end
	
	self.cardView:reloadData(self.cards[menuStar[self.selectIndex]]);

	--local totalNum = #self.cards[menuStar[self.selectIndex]];
	--local cardViewxHeight = 427;
	--local maxWidth = 199 * totalNum;
	--maxWidth = maxWidth < 602 and 602 or maxWidth;
--
	--self.cardView:setInnerContainerSize(cc.size(maxWidth, cardViewxHeight));
--
	--for i = 1 , totalNum do
	--	local pid = self.cards[menuStar[self.selectIndex]][i].pid;
	--	local x = 90 + 199*(i-1);
	--	local template = template.CardTemplate:create(self.cardView);
	--	template:Init(pid);
	--	template:setPosition(x , 213.5);
	--	template:addCardClickEventListener(handler(self , self.cardClick));
	--	template:setCardTag(pid);
--
	--	if model.TreatmentModel:isInTreatment(pid) then
	--		template:setState('treatment');
	--	elseif model.TeamModel:isRoleInTeam(pid) then
	--		template:setState('fight');
	--	end
	--	self.cardList[pid] = template;
	--end
--
	--self.cardView:jumpToLeft();
end
function CardComposePanel:cellItemTouch( table,cell )
	local idx = cell:getIdx();
	local cardData = self.cards[menuStar[self.selectIndex]][idx + 1];
	local pid = cardData.pid;
	local flag = self:isCanCompose(pid);

	if flag ~= 0 then
		Prompt:Show(LANG.UI_CARD_COMPOSE_ERROR[flag]);
		return;
	end

	local slotEmpty = false;
	for index , curPid in ipairs(self.selectPidList) do
		if curPid == -1 then
			self.selectPidList[index] = pid;
			self.composeSlots[index].icon:setVisible(true);
			self.composeSlots[index].icon:Init(pid);
			self.composeSlots[index].icon:setCardTag(pid);
			slotEmpty = true;
			break;
		end
	end

	if not slotEmpty then
		Prompt:Show(LANG.UI_CARD_8);
		return;
	end

	if self.selectIndex == 1 then
		local role = model.CardModel:GetCard(pid); 
		for i , star in pairs(menuStar) do
			if star == role.star_lv then
				self.selectIndex = i;
				self:updateMenuState();
				self:updateList();
				break;
			end
		end
		for _idx , cardData in pairs(self.cards[menuStar[self.selectIndex]]) do
			if cardData.pid == pid then
				_idx = _idx-1;
				local cell = self.cardView:cellAtIndex(_idx);
				if cell then
					local cellNode = cell:getChildByTag(999);
					if cellNode then
						cellNode:setState('ready');
						self.selectCardIndex[_idx] = pid;
					end
				end
			end
		end
	else
		local cellNode = cell:getChildByTag(999);
		if cellNode then
			cellNode:setState('ready');
			self.selectCardIndex[idx] = pid;
		end
	end
end

function CardComposePanel:reloadCellPanel( cell,index )
	local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
		cellNode = template.CardTemplate:create(cell);
		cellNode:setTouchEnabled(false);
		cellNode:setPosition(99.5, 213.5);
		cellNode:setTag(999);
	end

	local cardData = self.cards[menuStar[self.selectIndex]][index+1];
	cellNode:Init(cardData.pid);
	
	if self.selectCardIndex[index] then
		cellNode:setState('ready');
	else
		cellNode:setState('nona');
	end
end

function CardComposePanel:composeBtnClick(sender , event)

	AudioManager:playEffect(Conf.cardOpen);

	if self.selectIndex == 1 then
		self:randomCompose();
		return;
	end

	for index , pid in ipairs(self.selectPidList) do
		if pid == -1 then
			self:oneKeyCompose();
			return;
		end
	end

	local msg = {};
	msg.cardList = self.selectPidList;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_base_card_compose , msg);
end

function CardComposePanel:randomCompose()

	math.randomseed(os.time());
	local tmpNums = {
		[1] = 2,
		[2] = 3,
		[3] = 4,
	};
	local nums = {};
	while(#table.keys(tmpNums) ~= 0) do
		local tKeys = table.keys(tmpNums);
		local randomPos = math.random(1, #tKeys);
		local key = tKeys[randomPos];
		table.insert(nums , tmpNums[key]);
		tmpNums[key] = nil;
	end

	self.selectCardIndex = {};

	local isCompose = false;
	for _k , selectIndex in ipairs(nums) do
		local cards = self.cards[menuStar[selectIndex]];
		if cards then
			local selectCount = 0;
			local selectPidList = {-1 , -1 , -1};
			for i = #cards ,  1 , -1 do
				local flag = self:isCanCompose(cards[i].pid);
				if flag == 0 then
					for index , selectPid in ipairs(selectPidList) do
						if selectPid == -1 then
							selectPidList[index] = cards[i].pid;
							selectCount = selectCount + 1;
							self.selectCardIndex[i-1] = cards[i].pid;
							break;
						end
					end

					if selectCount >= 3 then
						isCompose = true;
						self.selectIndex = selectIndex;
						self:updateMenuState();
						self:updateList();
						self:sendCardCompose(selectPidList);
						break;
					end
				end
			end
		end
		if isCompose then
			break;
		end
	end
	if not isCompose then
		self.selectCardIndex = {};
		Prompt:Show(LANG.UI_CARD_7);
	end
end

function CardComposePanel:oneKeyCompose()

	AudioManager:playEffect(Conf.cardOpen);

	local cards = self.cards[menuStar[self.selectIndex]];

	local selectCount = 0;

	local selectPidList = {-1 , -1 , -1};
	
	self.selectCardIndex = {};

	if cards then
		for i = #cards ,  1 , -1 do
			local flag = self:isCanCompose(cards[i].pid);
			if flag == 0 then
				for index , selectPid in ipairs(selectPidList) do
					if selectPid == -1 then
						selectPidList[index] = cards[i].pid;
						self.selectCardIndex[i-1]=cards[i].pid;
						selectCount = selectCount + 1;
						break;
					end
				end

				if selectCount >= 3 then
					break;
				end
			end
		end
	end

	if selectCount < 3 then
		self.selectCardIndex = {};
		Prompt:Show(LANG.UI_CARD_7);
		return;
	end	

	self:sendCardCompose(selectPidList);
end

function CardComposePanel:sendCardCompose(selectPidList)
	for index , card in ipairs(self.cards[menuStar[self.selectIndex]]) do
		local cell = self.cardView:cellAtIndex(index - 1);
		if cell then
			local cellNode = cell:getChildByTag(999);
			if cellNode then
				if self.selectCardIndex[index - 1] then
					cellNode:setState('ready');
				else
					cellNode:setState('nona');
				end
			end
		end
	end

	self.selectPidList = {-1 , -1 , -1};

	for index , curPid in ipairs(selectPidList) do
		self.selectPidList[index] = curPid;
		self.composeSlots[index].icon:setVisible(true);
		self.composeSlots[index].icon:Init(curPid);
		self.composeSlots[index].icon:setTag(curPid);
	end

	local msg = {};
	msg.cardList = selectPidList;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_base_card_compose , msg);
end

function CardComposePanel:retBaseCardComposePromotion(msg)
	self:reset();
end

function CardComposePanel:retBaseCardCompose(msg)

	AudioManager:playEffect(Conf.cardGet);

	self:reset();
	if msg.newPartner then
		UIManager:push('RoleShowPanel' , msg.newPartner);
	end

	--if msg.pid then
	--	local curCard = model.CardModel:GetCard(msg.pid);
	--	if curCard then
	--		local curRoleTableData = ResTable:getRowData('role' , curCard.no);
	--		if curRoleTableData then
	--			local haveCard = false;
	--			local allCards = model.CardModel:GetAllCard();
	--			for _k , card in pairs(allCards) do
	--				if card.pid ~= msg.pid then
	--					local roleTableData = ResTable:getRowData('role' , card.no);
	--					if roleTableData.role_id == curRoleTableData.role_id then
	--						if roleTableData.quality >= curRoleTableData.quality then
	--							haveCard = true;
	--							break;
	--						end
	--					end
	--				end
	--			end
	--			if not haveCard then
	--				UIManager:push('RoleShowPanel' , msg.newPartner);
	--			end
	--		end
	--	end
	--end
end

function CardComposePanel:isCanCompose(pid)
	if model.CardModel:isInOtherModule(pid) then
		return 1;
	end

	--local role = model.CardModel:GetCard(pid);
	--if not role then
	--	return -1;
	--end
	--local roleId = ResTable:getValue('role' , role.no , 'role_id');
	--local roleRank = ResTable:getValue('role_pre' , roleId , 'rank');

	--[[
	if self.maxRank == roleRank then
		return 3;
	end
	]]

	--local data = model.HomeModel:getHomeBaseByKey('card');
	--local openRank = ResTable:getValue('base_role' , data.level , 'role_rank');
	--if roleRank >= openRank then
	--	return 4 , openRank;
	--end

	for _k , selectPid in pairs(self.selectPidList) do
		if selectPid == pid then
			return 5;
		end
	end

	return 0;
end

function CardComposePanel:onClickBack()
	UIManager:switch('HomeBasePanel');
end

function CardComposePanel:onLeave()
	self.root:setVisible(false);
end

return CardComposePanel;
