local CardCvPanel = class("CardCvPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');

function CardCvPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardCvPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function CardCvPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function CardCvPanel:initPanels()

	local bg = cc.Sprite:create('image/common/card_info_cv_bg.png');
	bg:addTo(self.root);
	bg:setPosition(0 , 28);

	local titleLabel = cc.Label:createWithTTF(LANG.UI_CARD_21 , fonts.FONT_SIYUAN , 20);
	titleLabel:addTo(self.root);
	titleLabel:setPosition(0 , 430);
	titleLabel:setTextColor(cc.c3b(255 , 255 , 255));

	titleLabel = cc.Label:createWithTTF('- List -' , fonts.FONT_SIYUAN , 9);
	titleLabel:addTo(self.root);
	titleLabel:setPosition(0 , 411);
	titleLabel:setTextColor(cc.c3b(0 , 142 , 219));

	self.cvNode = cc.Node:create();
	self.cvNode:addTo(self.root);
end

function CardCvPanel:onEnter(roleNo)

	if not roleNo then
		UIManager:pop('CardCvPanel'); 
		return;
	end

	self:addSwallowCallback(handler(self, self.onClickBack));

	self.roleNo = roleNo;
	self.soundList = {};

	self.cvNode:removeAllChildren();

	local index = 1;
	for soundName , sound in pairs(AudioManager.cvList) do

		local col = index % 3;
		col = col == 0 and 3 or col;
		local row = math.ceil(index / 3);
		
		local btn = ccui.Button:create('image/card/cardInfo/card_info_cv_bg_1.png' , 'image/card/cardInfo/card_info_cv_bg_1.png');
		btn:addTo(self.cvNode);
		btn:setTag(index);
		btn:addClickEventListener(handler(self , self.soundClick));
		btn:setPosition(-168 + 168 *(col - 1) , 349 - 96 * (row - 1));

		local btnLabel = cc.Label:createWithTTF(LANG.UI_CARD_SOUND_TYPE[soundName] , fonts.FONT_SIYUAN , 20);
		btnLabel:addTo(btn);
		btnLabel:setPosition(btn:getContentSize().width/2 + 19 , btn:getContentSize().height/2);
		btnLabel:setTextColor(cc.c3b(60 , 60 , 60));
		btnLabel:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);

		self.soundList[index] = soundName;

		index = index + 1;
	end

	self.root:setVisible(true);
end

function CardCvPanel:soundClick(sender , event)
	local tag = sender:getTag();
	if self.soundList[tag] then
		-- AudioManager:playCVStopBefor(self.roleNo , self.soundList[tag]);
	end
end

function CardCvPanel:onClickBack()
	UIManager:pop('CardCvPanel');
end

function CardCvPanel:onLeave()
	self.root:setVisible(false);
end

return CardCvPanel;
