local CardLevelUpStarComplatePanel = class("CardLevelUpStarComplatePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/card/cardLevelUpStar/'
local MessageBoxType = Enum:getTable('MessageBoxType')


function CardLevelUpStarComplatePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardLevelUpStarComplatePanel');

	self.isPopup = true;

	self.useCCreator = false;
end

function CardLevelUpStarComplatePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function CardLevelUpStarComplatePanel:initPanels()

	--self.particleWin = cc.ParticleSystemQuad:create("Effect/particle/winp.plist")
	--self.particleWin:addTo(self.root);
	--self.particleWin:setPosition(cc.p(0,245))
	--self.particleWin:stopSystem();

	local spine_res = 'RewardPanelEffect'
	self.effect = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
	self.effect:setPositionY(30);
	self.effect:addTo(self.root);

	self.infoNode = cc.Node:create();
	self.infoNode:addTo(self.root);
	self.infoNode:setCascadeOpacityEnabled(true);

	self.oldCardIcon = template.ItemTemplate:create(2);
	self.oldCardIcon:addTo(self.infoNode);
	self.oldCardIcon:setPosition(-101 , 150);

	self.newCardIcon = template.ItemTemplate:create(2);
	self.newCardIcon:addTo(self.infoNode);
	self.newCardIcon:setPosition(101 , 150);

	self.attList = {};
	for i = 1 , 5 do
		self.attList[i] = {};
		self.attList[i].node = cc.Node:create();
		self.attList[i].node:addTo(self.infoNode);
		self.attList[i].node:setPosition(0 , 17 - 59 * (i - 1));

		self.attList[i].bg = cc.Sprite:create('image/card/cardBreak/card_break_7.png');
		self.attList[i].bg:addTo(self.attList[i].node);

		self.attList[i].attImg = cc.Sprite:create();
		self.attList[i].attImg:addTo(self.attList[i].node);
		self.attList[i].attImg:setPosition(-230 , 2);

		self.attList[i].attName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
		self.attList[i].attName:addTo(self.attList[i].node);
		self.attList[i].attName:setAnchorPoint(0 , 0.5);
		self.attList[i].attName:setPosition(-207 , 2);

		self.attList[i].att = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
		self.attList[i].att:addTo(self.attList[i].node);
		self.attList[i].att:setPosition(-11 , 2);

		self.attList[i].nextImg = cc.Sprite:create('image/card/cardBreak/card_break_3.png');
		self.attList[i].nextImg:addTo(self.attList[i].node);
		self.attList[i].nextImg:setPosition(80 , 2);

		self.attList[i].nextAtt = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
		self.attList[i].nextAtt:addTo(self.attList[i].node);
		self.attList[i].nextAtt:setTextColor(cc.c3b(255 , 228 , 0));
		self.attList[i].nextAtt:setPosition(179 , 2);
	end
end

function CardLevelUpStarComplatePanel:onEnter()

	local tempMsg , oldPro = model.CardModel:getStarBreakTempData();

	local pid = tempMsg.pid;

	local data = model.CardModel:GetCard(pid);
	if not data then
		return;
	end

	local pro = CardProManager:GetCardPro(pid);
	if not pro then
		return;
	end
	
	--self.particleWin:resetSystem();
	self.effect:clearTracks();
	self.effect:addAnimation(0, GlobalFunctions:lAnimationName('StarningSuccess') , false)

	self.oldCardIcon:Init(ROLE_TYPE , data.no , data.star_lv - 1, 0, pid);
	self.oldCardIcon:updateAltarLevelColor(data.oriLv)
	self.newCardIcon:Init(ROLE_TYPE , data.no , data.star_lv, 0, pid);
	self.oldCardIcon:updateAltarLevelColor(data.oriLv)
	
	for i = 1 , 5 do
		self.attList[i].node:setVisible(false);
	end

	local index = 1;
	for _k , attName in pairs({'fp' , 'hp' , 'atk' , 'def'}) do
		if oldPro[attName] then
			self.attList[index].node:setVisible(true);
			self.attList[index].attImg:setTexture('image/card/cardBreak/att_bg_'.._k..'.png');
			self.attList[index].attName:setString(LANG.UI_CARAD_BREAK_SUCCESS_ATT_TYPE[_k]);
			if attName == 'crit' then
				self.attList[index].att:setString(tostring(math.floor(oldPro[attName] / 10000 *100))..'%');
			elseif attName == 'crit_dam' then
				self.attList[index].att:setString(tostring(oldPro[attName] + 200)..'%');
			else
				self.attList[index].att:setString(tostring(oldPro[attName]));
			end

			if pro[attName] then
				if attName == 'crit' then
					self.attList[index].nextAtt:setString(tostring(math.floor(pro[attName] / 10000 *100))..'%');
				elseif attName == 'crit_dam' then
					self.attList[index].nextAtt:setString(tostring(pro[attName] + 200)..'%');
				else
					self.attList[index].nextAtt:setString(tostring(pro[attName]));
				end
			end
			index = index + 1;
		end
	end

	self.infoNode:setOpacity(0);
	self.infoNode:runAction(cc.FadeIn:create(0.3));

	self.root:setVisible(true);
	self:addSwallowCallback(handler(self, self.onClickBack));

	self.msg = msg;
end

function CardLevelUpStarComplatePanel:onLeave()
	self.root:setVisible(false);
	local tempMsg = model.CardModel:getStarBreakTempData();

	local option = {
		effectName = 'Reback',
		rewardType = Enum:getTable('RewardType').REWARD_TYPE_COMMON,
	}
	
	UIManager:push('RewardPanel' , tempMsg , option);
end

function CardLevelUpStarComplatePanel:onClickBack()
	UIManager:pop('CardLevelUpStarComplatePanel');
end

return CardLevelUpStarComplatePanel;
