local CardLevelUpStarPanel = class("CardLevelUpStarPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local cardImagePath = 'image/card/card/';
local imagePath = 'image/card/cardLevelUpStar/';

local costPos = {
	[1] = {cc.p(-189 , -351),cc.p(-2 , -351)},
	[2] = {
		cc.p(-189 , -326),cc.p(-2 , -326),
		cc.p(-189 , -378),cc.p(-2 , -378)
		}
}

local curValuePosX = {
	[1] = {-47 , 2},
	[2] = {-4 , 45},
	[3] = {-4 , 45},
}

function CardLevelUpStarPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardLevelUpStarPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function CardLevelUpStarPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.curPid = nil;

	self:initPanels()
end

function CardLevelUpStarPanel:initPanels()

	self.bg = cc.Sprite:create();
	self.bg:addTo(self.root);

	self.cardPanelNavi = cc.Sprite:create();
	self.cardPanelNavi:addTo(self.root);
	self.cardPanelNavi:setPosition(-2 , 101);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -164);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(604 , 564));

	bg = cc.Sprite:create(imagePath..'card_levelup_star.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -149);

	self.defTypeNode = cc.Sprite:create('image/card/card_def_type_bg.png');
	self.defTypeNode:addTo(self.root);
	self.defTypeNode:setPosition(-260 , 72);

	local size = self.defTypeNode:getContentSize();
	self.infoDefType = cc.Sprite:create();
	self.infoDefType:addTo(self.defTypeNode);
	self.infoDefType:setScale(0.65);
	self.infoDefType:setPosition(size.width/2 , size.height/2);

	self.infoQuality = cc.Sprite:create();
	self.infoQuality:addTo(self.root);
	self.infoQuality:setAnchorPoint(0 , 0.5);
	self.infoQuality:setPosition(-229 , 76);

	self.infoName = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.infoName:addTo(self.root);
	self.infoName:setAnchorPoint(0 , 0.5);
	self.infoName:setPosition(-230 , 37);

	self.jopTypeNode = cc.Sprite:create('image/card/card_job_bg_1.png');
	self.jopTypeNode:addTo(self.root);
	self.jopTypeNode:setPosition(-73 , 37);

	--local size = self.jopTypeNode:getContentSize();
	--self.jopTypeImg = cc.Sprite:create('image/card/card_job_bg.png');
	--self.jopTypeImg:addTo(self.jopTypeNode);
	--self.jopTypeImg:setPosition(size.width/2-21 , size.height/2);
--
	--self.jopType = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	--self.jopType:addTo(self.jopTypeNode);
	--self.jopType:enableOutline(cc.c3b(90 , 90 , 90),2);
	--self.jopType:setPosition(size.width/2+17 , size.height/2);

	self.starNode = cc.Node:create();
	self.starNode:addTo(self.root);
	self.starNode:setPosition(4 , 76);
	self.starNode:setLocalZOrder(20);

	self.starList = {};
	for i = 1 , 5 do
		local starBg = cc.Sprite:create('image/card/star_level_bg.png');
		starBg:addTo(self.starNode);
		starBg:setPosition(26 * (i - 1) , 0);

		self.starList[i] = cc.Sprite:create();
		self.starList[i]:addTo(self.starNode);
		self.starList[i]:setPosition(26 * (i - 1) , 0);
	end

	self.nextStarImg = cc.Sprite:create(cardImagePath..'card_bg_5.png');
	self.nextStarImg:addTo(self.root);
	self.nextStarImg:setPosition(135.5 , 76);

	self.nextStarNode = cc.Node:create();
	self.nextStarNode:addTo(self.root);
	self.nextStarNode:setPosition(162 , 76);

	self.nextStarList = {};
	for i = 1 , 5 do
		local starBg = cc.Sprite:create('image/card/star_level_bg.png');
		starBg:addTo(self.nextStarNode);
		starBg:setPosition(26 * (i - 1) , 0);

		self.nextStarList[i] = cc.Sprite:create();
		self.nextStarList[i]:addTo(self.nextStarNode);
		self.nextStarList[i]:setPosition(26 * (i - 1) , 0);
	end

	local attPos = {
		[1] = cc.p(0 , -19),
		[2] = cc.p(-137 , -68),
		[3] = cc.p(137 , -68),
	};

	local attLabelOutline = {
		[1] = cc.c3b(185 , 40 , 40),
		[2] = cc.c3b(10 , 150 , 90),
		[3] = cc.c3b(210 , 80 , 10),
	}

	self.attributeList = {};
	
	for i = 1 , 3 do

		self.attributeList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(attPos[i]);
		self.attributeList[i].node =  node;

		local bg = cc.Sprite:create(i == 1 and 'image/card/card_att_bg_1.png' or 'image/card/card_att_bg_2.png');
		bg:addTo(node);

		local bg = cc.Sprite:create('image/card/card_att_img_'..i..'.png');
		bg:setPosition(i == 1 and cc.p(-224 , 1) or cc.p(-86 , 1));
		bg:addTo(node);

		local label = cc.Label:createWithTTF(LANG.UI_CARD_ATT[i] , fonts.FONT_SIYUAN , 17);
		label:addTo(node);
		label:setPosition(i == 1 and cc.p(-235 , 1) or cc.p(-98 , 1));
		label:enableOutline(attLabelOutline[i] ,2);

		self.attributeList[i].curValue = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.attributeList[i].curValue:addTo(node);
		self.attributeList[i].curValue:setPosition(curValuePosX[i][1] , 0);

		self.attributeList[i].bg = cc.Sprite:create('image/commonImg/arrow_7.png');
		self.attributeList[i].bg:addTo(node);
		self.attributeList[i].bg:setPosition(curValuePosX[i][2] , 0);

		self.attributeList[i].nextValue = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.attributeList[i].nextValue:addTo(node);
		self.attributeList[i].nextValue:setPosition(i == 1 and 48 or 91 , 0);
	end

	local bg = cc.Sprite:create('image/commonImg/arrow_bg.png');
	bg:addTo(self.root);
	bg:setPosition(-249 , -167);

	local label = cc.Label:createWithTTF(LANG.UI_CARD_22 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.root);
	label:setTextColor(cc.c4b(165 , 200 , 255 , 255));
	label:setPosition(-179 , -167);

	self.costIconList = {};
	for i = 1 , 5 do
		self.costIconList[i] = template.CardStarLevelUpTemplate:create(self.root);
		self.costIconList[i]:setPosition(-222 + 111 * (i - 1) , -241);
		self.costIconList[i]:setTag(i);
		self.costIconList[i]:addClickEventListener(handler(self , self.costIconClick));
	end

	self.costItemList = {};
	for i = 1 , 4 do

		self.costItemList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.root);
		self.costItemList[i].node = node;

		local bg = cc.Sprite:create('image/commonImg/bg_3_180_42.png');
		bg:addTo(node);

		self.costItemList[i].costIcon = cc.Sprite:create();
		self.costItemList[i].costIcon:addTo(node);
		self.costItemList[i].costIcon:setScale(0.5);
		self.costItemList[i].costIcon:setPosition(-65 , 4);
	
		local label = cc.Label:createWithTTF((i == 1 or i == 3) and LANG.UI_CARD_19 or LANG.UI_CARD_20, fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setTextColor(cc.c3b(160 , 200 , 255));
		label:setPosition(-18 , 0);

		self.costItemList[i].cost = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.costItemList[i].cost:addTo(node);
		self.costItemList[i].cost:setAnchorPoint(1 , 0.5);
		self.costItemList[i].cost:setPosition(84 , 0);
	end

	self.levelUpBtn = ccui.Button:create('image/commonImg/btn_1_169_55.png' , 'image/commonImg/btn_1_169_55.png');
	self.levelUpBtn:addTo(self.root);
	self.levelUpBtn:setPosition(0 , -351);
	self.levelUpBtn:addClickEventListener(handler(self , self.levelUpBtnClick));

	local btnLabel = cc.Label:createWithTTF(LANG.UI_CARD_23 , fonts.FONT_SIYUAN , 20);
	btnLabel:addTo(self.levelUpBtn);
	btnLabel:setPosition(self.levelUpBtn:getContentSize().width/2 , self.levelUpBtn:getContentSize().height/2);
	btnLabel:setTextColor(cc.c3b(255 , 255 , 255));
	btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

	self.levelUpBtnShader = cc.Sprite:create('image/commonImg/btn_black_1_169_55.png');
	self.levelUpBtnShader:addTo(self.root);
	self.levelUpBtnShader:setPosition(0 , -351);
	self.levelUpBtnShader:setVisible(false);

	self.maxLevelTipImg = cc.Sprite:create('image/commonImg/tip_2.png');
	self.maxLevelTipImg:addTo(self.root);
	self.maxLevelTipImg:setPosition(0 , -425);

	self.maxLevelTip = cc.Label:createWithTTF(LANG.UI_CARD_24 , fonts.FONT_SIYUAN , 20);
	self.maxLevelTip:addTo(self.root);
	self.maxLevelTip:setPosition(0 , -425);
	self.maxLevelTip:setTextColor(cc.c3b(255,200,0));

	EventManager:RegisterEvent(EventType.UIStarLevelUpSelectPid , handler(self, self.updateCardCost));
	EventManager:RegisterEvent(EventType.NetworkRetStarLevelUp , handler(self, self.retStarLevelUp));
end

function CardLevelUpStarPanel:onEnter(pid)

	self.curPid = pid;

	self:onShow();

	self.root:setVisible(true);
end

function CardLevelUpStarPanel:onShow(isUp)
	local card = model.CardModel:GetCard(self.curPid);
	local resId = model.CardModel:getCardResIdByPid(self.curPid);
	local imagePath = ResTable:getValue('role_resource', resId, 'card');
	self.roleData = ResTable:getRowData('role', card.no);
	local roleInfoData = ResTable:getRowData('role_info', card.no);

	self.infoQuality:setTexture('image/card/card_quality_'..card.quality..'.png');

	self.bg:setTexture('image/card/cardQualityBg/card_bg_quality_'..card.quality..'.png');

	self.cardPanelNavi:setTexture('image/role/'..imagePath..'.png');

	local rolePreData = ResTable:getRowData('role_pre', card.no);
	self.infoDefType:setTexture('image/commonImg/def_type_'..rolePreData.def_type..'.png');
	--self.jopType:setString(tostring(LANG.UI_CARD_JOB_TYPE[rolePreData.job_type]));
	self.jopTypeNode:setTexture('image/card/card_job_bg_'..rolePreData.job_type..'.png');

	local color = math.ceil(card.star_lv/5);
	local num = card.star_lv % 5;
	num = num == 0 and 5 or num;
	for i = 1 , 5 do
		if i <= num then
			self.starList[i]:setTexture('image/card/star_level_'..color..'.png');
		end
		self.starList[i]:setVisible(i <= (isUp and (num - 1) or num));
		--self.starList[i]:setVisible(i <= (num - 1));
	end

	self.infoName:setString(tostring(roleInfoData.name));
	local ptx,pty = self.infoName:getPosition();
	local nameSize = self.infoName:getContentSize();
	self.jopTypeNode:setPosition( ptx+50+nameSize.width, pty )

	self.jopTypeNode:setPositionX(self.infoName:getPositionX()+self.infoName:getContentSize().width + 55);

	self.levelUpBtn:setPositionX(0);

	for i = 1 , 4 do
		self.costItemList[i].node:setVisible(false);
	end

	local pro = CardProManager:GetCardPro(self.curPid);

	self.attributeList[1].curValue:setString(tostring(pro.fp));
	self.attributeList[2].curValue:setString(tostring(pro.hp));
	self.attributeList[3].curValue:setString(tostring(pro.atk));
	--self.attributeList[4].curValue:setString(tostring(pro.def));

	self.selectCards = {};

	local index = 1;
	local nextPro = pro;

	local isSsrMaxStarLevel = false;
	if card.quality < 5 and card.star_lv >= CARD_STAR_SSR_MAX_LEVEL then
		isSsrMaxStarLevel = true;
	end

	self.starConditionData = model.CardModel:getCardStarConditionTableData(rolePreData.def_type , card.star_lv + 1);
	if self.starConditionData and not isSsrMaxStarLevel then

		local nextStarLevel = card.star_lv + 1;
		nextPro = CardProManager:genPro(card , nextStarLevel);

		self.nextStarNode:setVisible(true);
		self.nextStarImg:setVisible(true);
		self.nextStarImg:setVisible(true);
		self.levelUpBtn:setTouchEnabled(true);
		self.levelUpBtnShader:setVisible(false);

		self:setAttState(true);

		self.attributeList[1].nextValue:setString(tostring(nextPro.fp));
		self.attributeList[2].nextValue:setString(tostring(nextPro.hp));
		self.attributeList[3].nextValue:setString(tostring(nextPro.atk));
		--self.attributeList[4].nextValue:setString(tostring(nextPro.def));

		local color = math.ceil(nextStarLevel/5);
		local num = nextStarLevel % 5;
		num = num == 0 and 5 or num;
		for i = 1 , 5 do
			if i <= num then
				self.nextStarList[i]:setTexture('image/card/star_level_'..color..'.png');
			end
			self.nextStarList[i]:setVisible(i <= num);
		end

		local mainCostCard = self.starConditionData.cost_main[1];
		local secondCostCard = self.starConditionData.cost_other;
		local costItem = self.starConditionData.cost_item;

		if mainCostCard and mainCostCard[2] then
			for i = 1 , mainCostCard[2] do
				if self.costIconList[i] then
					self.costIconList[i]:setVisible(true);
					self.costIconList[i]:Init(self.starConditionData.def_type , mainCostCard[1] , card.no);
					self.selectCards[index] = -1;
					index = index + 1;
				end
			end
		end

		if secondCostCard and #secondCostCard > 0 then
			for _k , secondCost in ipairs(secondCostCard) do
				if secondCost[3] then
					for i = 1 , secondCost[3] do
						if self.costIconList[index] then
							self.costIconList[index]:setVisible(true);
							self.costIconList[index]:Init(secondCost[1] , secondCost[2]);
							self.selectCards[index] = -1;
							index = index + 1;
						end
					end
				end
			end
		end

		local conditonRound = self.starConditionData.round_no;
		local roundId = model.RoundModel:getRoundIndex();
		if roundId <= conditonRound then
			self.maxLevelTip:setVisible(true);
			self.maxLevelTipImg:setVisible(true);
			local roundName = ResTable:getValue('round', conditonRound , 'name');
			roundName = roundName or '';
			self.maxLevelTip:setString(string.format(LANG.UI_CARD_61,roundName));
		else
			if costItem then
				local costNum = #costItem;
				if costNum > 0 then
					local posIndex = costNum >= 2 and 2 or 1;
					for _k , item in ipairs(costItem) do
						local _idx = _k * 2
						local icon = ResTable:getValue('item' , item[1] , 'icon');
						self.costItemList[_idx - 1].costIcon:setTexture('image/icon/I'..icon..'.png');
						self.costItemList[_idx].costIcon:setTexture('image/icon/I'..icon..'.png');
					
						local haveNum = model.ItemModel:getItemNum(item[1]);
						self.costItemList[_idx - 1].cost:setString(tostring(haveNum));
						self.costItemList[_idx - 1].cost:setTextColor(haveNum >= item[2] and cc.c3b(255,255,255) or cc.c3b(255,0,0));
						self.costItemList[_idx].cost:setString(tostring(item[2]));
					
						self.costItemList[_idx - 1].node:setVisible(true);
						self.costItemList[_idx].node:setVisible(true);

						self.costItemList[_idx - 1].node:setPosition(costPos[posIndex][_idx - 1]);
						self.costItemList[_idx].node:setPosition(costPos[posIndex][_idx]);
					end
					self.levelUpBtn:setPositionX(189);
				end
			end

			self.maxLevelTip:setVisible(false);
			self.maxLevelTipImg:setVisible(false);
		end
	else
		self:setAttState(false);
		self.nextStarNode:setVisible(false);
		self.nextStarImg:setVisible(false);
		self.nextStarImg:setVisible(false);
		self.maxLevelTip:setVisible(true);
		self.maxLevelTipImg:setVisible(true);

		self.levelUpBtnShader:setVisible(true);
		self.levelUpBtn:setTouchEnabled(false);
		if isSsrMaxStarLevel then
			self.maxLevelTip:setString(LANG.UI_CARD_46);
		elseif card.quality < 4 then
			self.maxLevelTip:setString(LANG.UI_CARD_66);
		else
			self.maxLevelTip:setString(LANG.UI_CARD_47);
		end
	end

	local width = self.maxLevelTipImg:getContentSize().width+4;
	local maxLevelTipWidth = self.maxLevelTip:getContentSize().width+4;
	local posX = -maxLevelTipWidth/2;

	self.maxLevelTipImg:setPositionX(posX);
	self.maxLevelTip:setPositionX(posX + width / 2 + maxLevelTipWidth / 2);

	for i = index , 5 do
		self.costIconList[i]:setVisible(false);
	end

	if isUp then
		if cc.FileUtils:getInstance():isFileExist('spine/shengxing_spine/shengxing_spine3.json') then
			ShowAnimationPanel:Show('CardLevelUpStarPanel' , function()
				local animationNode = ShowAnimationPanel:getAnmiationNode();
				
				local spineNode = cc.Node:create();
				spineNode:addTo(animationNode);
				spineNode:setPosition(4 , 76);
	
				local starUpSpine = sp.SkeletonAnimation:create('spine/shengxing_spine/shengxing_spine3.json', 'spine/shengxing_spine/shengxing_spine3.atlas', 1)
	
				starUpSpine:addTo(spineNode)
				starUpSpine:setPosition(26 * (num - 1) , 0);
				starUpSpine:setAnimation(0, "idle", false)
				
				self.starList[num]:setVisible(true);

				starUpSpine:registerSpineEventHandler(function (event)
					if event.eventData.name == 'shengxing6.plist' then
						local effect = cc.ParticleSystemQuad:create('Effect/particle/shengxing6.plist');
						effect:addTo(spineNode);
						effect:setPosition(26 * (num - 1) , 0);
						effect:setAutoRemoveOnFinish(true)

						spineNode:runAction(cc.Sequence:create(cc.DelayTime:create(0.5) , cc.CallFunc:create(function()
							ShowAnimationPanel:Hide()
							UIManager:push('StarAndBreakComplatePanel',1);
						end)));
					end
				end, sp.EventType.ANIMATION_EVENT)
			end);
		end
	end
end

function CardLevelUpStarPanel:setAttState(state)
	for i = 1 , 3 do
		self.attributeList[i].bg:setVisible(state);
		self.attributeList[i].nextValue:setVisible(state);
		self.attributeList[i].curValue:setPositionX(state and curValuePosX[i][1] or curValuePosX[i][2]);
	end
end

function CardLevelUpStarPanel:costIconClick(sender , event)
	local index = sender:getTag();
	AudioManager:playEffect(Conf.confirmButton);
	if self.selectCards[index] and self.starConditionData then

		local selectCards = {};
		for _k , pid in ipairs(self.selectCards) do
			selectCards[_k] = pid;
		end

		UIManager:push('CardLevelUpStarSelectCardPanel' ,self.curPid ,selectCards);
	end
end

function CardLevelUpStarPanel:updateCardCost(selectCards)
	if not selectCards then
		return;
	end

	self.selectCards = {};
	for _k , pid in ipairs(selectCards) do
		self.selectCards[_k] = pid;
	end

	for i = 1 , 5 do
		if self.selectCards[i] ~= -1 then
			self.costIconList[i]:setData(self.selectCards[i]);
		end
	end

end

function CardLevelUpStarPanel:levelUpBtnClick()

	if not self.starConditionData then
		return;
	end

	local conditonRound = self.starConditionData.round_no;
	local roundId = model.RoundModel:getRoundIndex();
	if roundId <= conditonRound then
		local roundName = ResTable:getValue('round', conditonRound , 'name');
		roundName = roundName or '';
		Prompt:Show(string.format(LANG.UI_CARD_62 ,roundName,self.starConditionData.star));
		return
	end

	local msg = {};
	msg.pid = self.curPid;
	msg.main_cards = {};
	msg.second_cards = {};
	msg.start_id = self.starConditionData.id;

	local mainCardNum = 0;
	if self.starConditionData.cost_main and self.starConditionData.cost_main[1] and self.starConditionData.cost_main[1][2] then
		mainCardNum = self.starConditionData.cost_main[1][2];
	end
	
	for i = 1 , #self.selectCards do
		local pid = self.selectCards[i];
		if pid ~= -1 then
			if i > mainCardNum then
				table.insert(msg.second_cards , pid);
			else
				table.insert(msg.main_cards , pid);
			end
		else
			Prompt:Show(LANG.UI_CARD_25);
			return;
		end
	end

	Network.NetworkManager:Send(Network.NetworkCmdType.req_card_star_level_up , msg);
end

function CardLevelUpStarPanel:retStarLevelUp()
	self:onShow(true);
	AudioManager:playEffect(Conf.cardHeroLevelUp);
end

function CardLevelUpStarPanel:onClickBack()
	UIManager:pop('CardLevelUpStarPanel')
end

function CardLevelUpStarPanel:onLeave()
	self.root:setVisible(false);
end

return CardLevelUpStarPanel;
