local CardLevelUpStarSelectCardPanel = class("CardLevelUpStarSelectCardPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");

function CardLevelUpStarSelectCardPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardLevelUpStarSelectCardPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function CardLevelUpStarSelectCardPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self.selectCards = {};
	self.animationList = {};
	self.panelType = 1;
	self:initPanels()
end

function CardLevelUpStarSelectCardPanel:initPanels()

	self.bg = cc.Sprite:create('image/bg/Bg_5.png');
	self.bg:addTo(self.root);

	local viewBg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png')
		:addTo(self.root)
		:setPosition(0 , 177)
		:setCapInsets(cc.rect(11,4,18,21))
		:setContentSize(cc.size(604 , 592))

	local viewBg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png')
		:addTo(self.root)
		:setPosition(0 , -284)
		:setCapInsets(cc.rect(11,4,18,21))
		:setContentSize(cc.size(604 , 302))

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
		:addTo(self.root)
		:setPosition(0 , -234)
		:setCapInsets(cc.rect(11,11,34,28))
		:setContentSize(cc.size(570 , 167))
	
	local bg = cc.Sprite:create('image/fight/result/result_win_bg_1.png')
		:addTo(self.root)
		:setPosition(-131,-175)

	local bg = cc.Sprite:create('image/fight/result/result_win_bg_1.png')
		:addTo(self.root)
		:setPosition(131,-175)
		:setScaleX(-1)

	local label = cc.Label:createWithTTF(LANG.UI_CARD_22,fonts.FONT_SIYUAN,20)
		:addTo(self.root)
		:setPosition(0,-175)

	local initData = {
        width = 604,
        height = 562,
        cellWidth = 604 ,
        cellHeight = 425,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
    self.cardListView = template.TableViewTemplate:create()
    self.cardListView:initWithSizeAndItem(initData);
    self.cardListView:getView():setPosition(cc.p(-302,-104));
	self.cardListView:getView():addTo(self.root)
	
	self.costIconList = {};
	for i = 1 , 5 do
		self.costIconList[i] = template.CardStarLevelUpTemplate:create(self.root);
		self.costIconList[i]:setPosition(-222 + 111 * (i - 1) , -256);
		self.costIconList[i]:setTag(i);
		self.costIconList[i]:addClickEventListener(handler(self , self.costIconClick));
	end

	local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	self.okBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png','image/commonImg/btn_1_219_55.png');
	self.okBtn:setPosition(0, -378);
	self.okBtn:setTitleLabel(label);
	self.okBtn:addClickEventListener(handler(self , self.okBtnClick));
	self.okBtn:addTo(self.root);
end

function CardLevelUpStarSelectCardPanel:costIconClick(sender , event)
	local index = sender:getTag();
	if self.animationList[index] then
		return;
	end
	for pid , pos in pairs(self.curSelectCards) do
		if pos == index then
			local allIndicesIdx = self.cardListView:getAllIndicesCellIdx();
			for _k , idx in pairs(allIndicesIdx) do
				local cell = self.cardListView:cellAtIndex(idx);
				local children = cell:getChildren();
				for _k , child in pairs(children) do
					if child:isVisible() and child:getCardTag() == pid then
						child:setState('nona');
						break;
					end
				end
			end
			self.curSelectCards[pid] = nil;
			if self.costIconList[pos] then
				local data = self.costIconCondition[pos];
				if data then
					self.costIconList[pos]:Init(data[1],data[2],data[3]);
				end
			end
			break;
		end
	end
end

function CardLevelUpStarSelectCardPanel:reloadCellPanel(cell , idx)
	local startNum = idx * 3 + 1;
	local curMaxNum = (idx+1) * 3;
	curMaxNum = curMaxNum > self.cardMaxNum and self.cardMaxNum or curMaxNum;
	local children = cell:getChildren();
	if #children <= 0 then
		for i = 1 , 3 do
			local x = 101 + 201*(i-1);
			local y = 212.5;
			local bigCard = template.CardTemplate:create(cell);
			bigCard:setPosition(x,y);
			bigCard:setTouchEnabled(false);
			bigCard:addCardClickEventListener(handler(self, self.cardClick));
			if startNum <= curMaxNum then
				local card = self.cards[startNum];
				bigCard:Init(card.pid);
				bigCard:setCardTag(card.pid);
				local isIn , states = model.CardModel:isInOtherModule(card.pid);
				bigCard:initCardInTeamState(states);
				if self.curSelectCards[card.pid] then
					bigCard:setState('select',2);
				else
					bigCard:setState('nona');
				end
				startNum = startNum + 1;
			else
				bigCard:setVisible(false);
			end
		end
	else
		for i = 1 , 3 do
			local bigCard = children[i];
			if startNum <= curMaxNum then
				local card = self.cards[startNum];
				bigCard:Init(card.pid);
				bigCard:setCardTag(card.pid);
				bigCard:setVisible(true);
				local isIn , states = model.CardModel:isInOtherModule(card.pid);
				bigCard:initCardInTeamState(states);
				if self.curSelectCards[card.pid] then
					bigCard:setState('select',2);
				else
					bigCard:setState('nona');
				end
				startNum = startNum + 1;
			else
				bigCard:setVisible(false);
			end
		end
	end
	return cell;
end

function CardLevelUpStarSelectCardPanel:cellItemTouch(table , cell)
	if self.curSelectPid then
		local card = model.CardModel:GetCard(self.curSelectPid);
		if not card then
			return;
		end
		if model.CardModel:isFutureCard(self.curSelectPid) then
	        Prompt:Show(LANG.UI_L_11706);
	        return;
		end
		local isIn,states = model.CardModel:isInOtherModule(self.curSelectPid);
		if isIn then
			Prompt:Show(LANG.UI_CARD_IN_TEAM_TIPS[1]);
			return
		end

		if card.level > 1 then
			Prompt:Show(LANG.UI_CARD_67);
		end

		local mainNum = 0;
		local secondNum = 0;
		local mainHavePos = {};
		local secondHavePos = {};
		for pid , pos in pairs(self.curSelectCards) do
			if pid == self.curSelectPid then --已经选中就取消
				if self.animationList[pos] then
					return;
				end
				local children = cell:getChildren();
				for _k , child in pairs(children) do
					if child:isVisible() and child:getCardTag() == self.curSelectPid then
						child:setState('nona');
						break;
					end
				end
				if self.costIconList[pos] then
					local data = self.costIconCondition[pos];
					if data then
						self.costIconList[pos]:Init(data[1],data[2],data[3]);
					end
				end
				self.curSelectCards[self.curSelectPid] = nil;
				return;
			end
			if pos <= self.mainCardNum then
				mainNum = mainNum + 1;
				mainHavePos[pos] = 1;
			else
				secondNum = secondNum + 1;
				secondHavePos[pos] = 1;
			end
		end

		local inType = -1;
		local mainCostCard = self.starConditionData.cost_main[1];
		if mainCostCard and mainCostCard[2] then
			if card.no == self.curCard.no then --同名检查
				inType = 1;--同名卡已满
				if mainNum < self.mainCardNum then
					for i = 1,self.mainCardNum do
						if not mainHavePos[i] then
							if self.costIconList[i] then
								self:addSelectAnimation(i);
								self.costIconList[i]:setData(self.curSelectPid);
							end
							self.curSelectCards[self.curSelectPid] = i;
							inType = 0;
							break;
						end
					end
				end
			end
		end

		if inType ~= 0 then
			if secondNum >= self.secondCardNum then
				return;
			end

			if not self.secondConditionCardPids[self.curSelectPid] then
				return;
			end
			
			for i = self.mainCardNum+1,self.mainCardNum+self.secondCardNum do
				if not secondHavePos[i] then
					if self.costIconList[i] then
						self:addSelectAnimation(i);
						self.costIconList[i]:setData(self.curSelectPid);
					end
					self.curSelectCards[self.curSelectPid] = i;
					break;
				end
			end
		end

		local children = cell:getChildren();
		for _k , child in pairs(children) do
			if child:isVisible() and child:getCardTag() == self.curSelectPid then
				child:setState('select',2);
				break;
			end
		end
	end
end

function CardLevelUpStarSelectCardPanel:addSelectAnimation(index)
	local spine_res = 'shengxingtianjia_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local addAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		addAnimation:addTo(self.root)
		addAnimation:setLocalZOrder(10)
		addAnimation:setPosition(-222 + 111 * (index - 1) , -256)
		addAnimation:registerSpineEventHandler(function (event)
			if event.eventData.name == 'appear' then
				self.costIconList[index]:setVisible(true);
			end
		end, sp.EventType.ANIMATION_EVENT);
		addAnimation:registerSpineEventHandler(function (event)
			self.root:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(function() 
				addAnimation:removeFromParent();
				self.animationList[index] = nil;
			end)));
		end, sp.EventType.ANIMATION_COMPLETE)
		addAnimation:setAnimation(0,'shengxingtianjia_spine',false);
		self.animationList[index] = addAnimation;
	else
		print('error : 缺少spine 资源')
    end
end

function CardLevelUpStarSelectCardPanel:cardClick(sender , event)
	self.curSelectPid = sender:getTag();
end

function CardLevelUpStarSelectCardPanel:onEnter(starPid,selectCards)
	self.curCard = model.CardModel:GetCard(starPid);
	if not self.curCard then
		return;
	end

	local rolePreData = ResTable:getRowData('role_pre', self.curCard.no);
	if not rolePreData then
		return;
	end

	self.starConditionData = model.CardModel:getCardStarConditionTableData(rolePreData.def_type , self.curCard.star_lv + 1);
	if not self.starConditionData then
		return 
	end

	local index = 1;
	self.starPid = starPid;
	self.selectCards = selectCards;
	self.cards = {};
	self.curSelectCards = {};
	self.costIconCondition = {};

	local mainCostCard = self.starConditionData.cost_main[1];
	local secondCostCard = self.starConditionData.cost_other;
	for _k , pid in pairs(selectCards) do
		if pid > 0 then
			self.curSelectCards[pid] = _k;
		end
	end
	local mainHavePids = {};
	self.mainCardNum = 0;
	if mainCostCard and mainCostCard[2] then
		self.mainCardNum = mainCostCard[2];
		local allCards = model.CardModel:getCardByNo(self.curCard.no);
		if allCards then
			local star = mainCostCard[1];
			for pid , _ in pairs(allCards) do
				local mainCard = model.CardModel:GetCard(pid);
				if mainCard and star == mainCard.star_lv and self.starPid ~= pid then
					table.insert(self.cards , mainCard);
					mainHavePids[pid] = 1;
				end
			end
		end
		for i = 1 , mainCostCard[2] do
			if self.costIconList[i] then
				self.costIconList[i]:setVisible(true);
				self.costIconList[i]:Init(self.starConditionData.def_type , mainCostCard[1] , self.curCard.no);
				self.costIconCondition[i] = {self.starConditionData.def_type , mainCostCard[1] , self.curCard.no}
				if self.selectCards[index] and self.selectCards[index] > 0 then
					self.costIconList[i]:setData(self.selectCards[index]);
				end
				index = index + 1;
			end
		end
	end

	self.secondCardNum = 0;
	self.secondConditionCardPids = {};
	if secondCostCard then
		for _k , cost in ipairs(secondCostCard) do
			local starAllCards = model.CardModel:getCardDefTypeList(cost[2] , cost[1]);
			local allCards = starAllCards;
			if cost[1] == 0 then
				allCards = {};
				for _k , starCards in pairs(starAllCards) do
					for _pid , _k in pairs(starCards) do
						allCards[_pid] = _k;
					end
				end
			end
			for pid , _ in pairs(allCards) do
				if self.starPid ~= pid then
					self.secondConditionCardPids[pid] = 1; 
					if not mainHavePids[pid] then
						local secondCard = model.CardModel:GetCard(pid);
						if secondCard then
							table.insert(self.cards , secondCard);
						end
					end
				end
			end

			if cost[3] then
				self.secondCardNum = self.secondCardNum + cost[3];
				for i = 1 , cost[3] do
					if self.costIconList[index] then
						self.costIconList[index]:setVisible(true);
						self.costIconList[index]:Init(cost[1] , cost[2]);
						self.costIconCondition[index] = {cost[1] , cost[2]};
						if self.selectCards[index] and self.selectCards[index] > 0 then
							self.costIconList[index]:setData(self.selectCards[index]);
						end
						index = index + 1;
					end
				end
			end
		end
	end

	for i = index , 5 do
		self.costIconList[i]:setVisible(false);
	end

	if #self.cards > 1 then
		table.sort(self.cards, function(first, second)
			local firstIsIn = model.CardModel:isInOtherModule(first.pid);
			local secondIsIn = model.CardModel:isInOtherModule(second.pid);

			if not firstIsIn and secondIsIn then
				return true
			elseif firstIsIn and not secondIsIn then
				return false;
			end

			local ret = model.CardModel:sortPid(first.pid, second.pid, -1)
			return ret;

		end);
	end

	self.cardMaxNum = #self.cards;
	local tableViewCellMaxNum = math.ceil(self.cardMaxNum/3);

	self.cardListView:setDataCount(tableViewCellMaxNum);
	self.cardListView:reloadData();
	self.root:setVisible(true);

end

function CardLevelUpStarSelectCardPanel:okBtnClick()
	self.selectCards = {};
	for i = 1 , self.mainCardNum+self.secondCardNum do
		self.selectCards[i] = -1;
	end
	for pid , pos in pairs(self.curSelectCards) do
		if self.selectCards[pos] then
			self.selectCards[pos] = pid
		end
	end
	self:onClickBack();
end

function CardLevelUpStarSelectCardPanel:onClickBack()
	UIManager:pop('CardLevelUpStarSelectCardPanel');
	EventManager:FireEvent(EventType.UIStarLevelUpSelectPid , self.selectCards);
end

function CardLevelUpStarSelectCardPanel:onLeave()
	self.root:setVisible(false);
end

return CardLevelUpStarSelectCardPanel;
