local CardListPanel = class("CardListPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local cardImagePath = 'image/card/';

local cardMenuPos = {
	cc.p(-151 , 425),
	cc.p(150 , 425),
}

function CardListPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardListPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_ICON;
	self.showFooter = true;
end

function CardListPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function CardListPanel:initPanels()

	self.bg = cc.Sprite:create('image/bg/Bg_5.png');
	self.bg:addTo(self.root);

	local topHight = NOTCH_HEIGHT + 143
	local menuHeight = 46;
	local menuPosY = StageSize.height/2-topHight;
	local menuNode = cc.Node:create()
		:addTo(self.root)
		:setPosition(0,menuPosY-20)
	self.cardMenuList = {};
	for i = 1 , 2 do
		self.cardMenuList[i] = {};

		local node = cc.Node:create();
		node:addTo(menuNode);
		node:setPosition(-151 + 302 * (i-1),0);

		local texture = 'image/commonImg/menu_left_71_46.png';
		local unTexture = 'image/commonImg/menu_left_71_46_u.png';
		
		local label = cc.Label:createWithTTF(LANG.UI_CARD_LIST_TYPE[2-(i-1)] , fonts.FONT_SIYUAN , 20);

		local btn = ccui.Button:create(texture,texture,unTexture);
		self.cardMenuList[i].label = label;

		btn:addTo(node);
		btn:setTag(i);
		btn:setTitleLabel(label);
		btn:setScale9Enabled(true);
		btn:setCapInsets(cc.rect(10 , 0 , 51 , 46));
		btn:setContentSize(cc.size(302 , 46));
		btn:addClickEventListener(handler(self , self.cardListClick));
		self.cardMenuList[i].btn = btn;

		local light = cc.Sprite:create('image/commonImg/menu_light_1.png');
		light:addTo(node);
		light:setPosition(0 , btn:getContentSize().height/2);
		self.cardMenuList[i].light = light;
	end

	local viewBgHeight = StageSize.height-topHight-menuHeight/2-FOOTER_HEIGHT-20;
	local viewPosY = menuPosY-menuHeight/2-viewBgHeight/2;

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.root);
	bg:setPosition(0 , viewPosY-20);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(604 , viewBgHeight));

	local layout = ccui.Layout:create()
    layout:setContentSize(cc.size(604,viewBgHeight-38))
	layout:addTo(self.root)
	layout:setPosition(-302,viewPosY-viewBgHeight/2+36-20);
    layout:setClippingEnabled(true);

	self.tableView = cc.TableView:create( cc.size(604,viewBgHeight-38));
	self.tableView:addTo(layout);
	self.tableView:setVerticalFillOrder(cc.TABLEVIEW_FILL_TOPDOWN);
	self.tableView:setAnchorPoint(0.5 , 0.5);
	--self.tableView:setPosition(-309 , -401);
    self.tableView:setDirection(cc.SCROLLVIEW_DIRECTION_VERTICAL);
    self.tableView:setDelegate()
	self.tableView:registerScriptHandler(handler(self,self.numberOfCellsInTableView),cc.NUMBER_OF_CELLS_IN_TABLEVIEW)
	self.tableView:registerScriptHandler(handler(self,self.scrollViewDidScroll),cc.SCROLLVIEW_SCRIPT_SCROLL)
	self.tableView:registerScriptHandler(handler(self,self.tableCellTouched),cc.TABLECELL_TOUCHED)
    self.tableView:registerScriptHandler(handler(self,self.cellSizeForTable),cc.TABLECELL_SIZE_FOR_INDEX)
	self.tableView:registerScriptHandler(handler(self,self.tableCellAtIndex),cc.TABLECELL_SIZE_AT_INDEX)

	local bottomNode = cc.Node:create()
		:addTo(self.root)
		:setPosition(0,viewPosY-viewBgHeight/2-20);

	local line = cc.Sprite:create('image/commonImg/line.png');
	line:addTo(bottomNode);
	line:setContentSize(cc.size(604,1))
	line:setPosition(cc.p(0,33))

	local cardNumBg = cc.Sprite:create('image/commonImg/num_bg.png');
	cardNumBg:addTo(bottomNode);
	cardNumBg:setPosition(211 , 23);

	cardNumBg = cc.Sprite:create('image/commonImg/num_icon.png');
	cardNumBg:addTo(bottomNode);
	cardNumBg:setPosition(209 , 16);
	
	self.curCardNum = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.curCardNum:addTo(bottomNode);
	self.curCardNum:setAnchorPoint(1 , 0.5);
	self.curCardNum:setPosition(289 , 16);

	--[[
	self.cardListView = ccui.ScrollView:create();
	self.cardListView:setTouchEnabled(true); 
	self.cardListView:setBounceEnabled(true);
	self.cardListView:setDirection(ccui.ScrollViewDir.vertical);
	self.cardListView:setContentSize(cc.size(618, 802));
	self.cardListView:setAnchorPoint(cc.p(0.5, 0.5));
	self.cardListView:setPosition(0, -17);
	self.cardListView:setScrollBarEnabled(false);
	self.cardListView:addTo(self.root);
	]]

	self.swtichBtnList = {};
	for i = 1 , 2 do
		self.swtichBtnList[i] = ccui.Button:create('image/commonImg/btn_5_132_45.png' , 'image/commonImg/btn_5_132_45.png');
		self.swtichBtnList[i]:addTo(self.root);
		self.swtichBtnList[i]:setPosition(i == 1 and 94 or 244 , StageSize.height/2 - 105 - NOTCH_HEIGHT);
		self.swtichBtnList[i]:setTag(i);
		self.swtichBtnList[i]:addClickEventListener(handler(self , self.swtichBtnClick));

		local label = cc.Label:createWithTTF(LANG.UI_CARD_BTN[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(self.swtichBtnList[i]);
		label:setPosition(self.swtichBtnList[i]:getContentSize().width/2,self.swtichBtnList[i]:getContentSize().height/2);
		label:enableOutline(cc.c4b(125 , 125 , 125, 255) , 2);
	end

	EventManager:RegisterEvent(EventType.UIUpdateCardLevelUpList, handler(self, self.updateCardList));
end

function CardListPanel:onEnter()
	self:onShow(1);
end

function CardListPanel:onShow(cardListIndex)
	--self.bg:setTexture('image/bg/Bg_1.png');
	cardListIndex = cardListIndex or 1;

	self.cards = {};
	local cards = {};
	for i = 1 , 2 do
		self.cards[i] = {};
	end
	local cardIndex = 0;
	for k, card in pairs(model.CardModel:GetAllCard()) do
		cardIndex = cardIndex + 1;
		self.cards[2][cardIndex] = card;

		local cardData = ResTable:getRowData('role', card.no);

		if not cards[cardData.role_id] then
			cards[cardData.role_id] = card;
		else

			local curCard = cards[cardData.role_id];
			local curCardData = ResTable:getRowData('role', curCard.no);

			local cardInTeam = model.TeamModel:isRoleInTeam(card.pid);
			local curCardInTeam = model.TeamModel:isRoleInTeam(curCard.pid);
			
			if cardInTeam and not curCardInTeam then
				cards[cardData.role_id] = card;
			elseif (not cardInTeam and not curCardInTeam) or (cardInTeam and curCardInTeam) then
				if card.level > curCard.level then
					cards[cardData.role_id] = card;
				elseif card.level == curCard.level then
					if card.star_lv > curCard.star_lv then
						cards[cardData.role_id] = card;
					elseif card.star_lv == curCard.star_lv then
						if card.no > curCard.no then
							cards[cardData.role_id] = card;
						end
					end
				end
			end
		end
	end

	for _k , card in pairs(cards) do
		table.insert(self.cards[1] , card);
	end

	local sortFunc = function(first, second)
		local first_state = 3;
		if model.TeamModel:isRoleInTeam(first.pid) then
			first_state = 3;
		else
			first_state = 1;
		end
		local second_state = 3;
		if model.TeamModel:isRoleInTeam(second.pid) then
			second_state = 3;
		else
			second_state = 1;
		end
		if first_state > second_state then
			return true;
		elseif first_state < second_state then
			return false;
		end

		if first.level > second.level then
			return true;
		elseif first.level < second.level then
			return false;
		end

		if first.star_lv > second.star_lv then
			return true;
		elseif first.star_lv < second.star_lv then
			return false;
		end

		return first.no > second.no;
	end

	if #self.cards[1] > 1 then
		model.CardModel:sortFuc2( self.cards[1] )
		-- table.sort(self.cards[1], sortFunc);
	end
	if #self.cards[2] > 1 then
		model.CardModel:sortFuc2( self.cards[2] )
		-- table.sort(self.cards[2] ,sortFunc);
	end

	self.curCardNum:setString(tostring(cardIndex)..'/'..tostring(CARD_MAX_NUM));

	self.cardListIndex = cardListIndex;
	self:updateData();
	self:updateBtnRedDot();

	self.root:setOpacity(50);
	self.root:runAction(cc.FadeIn:create(0.2))

	EventManager:FireEvent(EventType.UIFooterUpdateSelect,2);
	self.root:setVisible(true);
end

function CardListPanel:onResume()
	local offset = self.tableView:getContentOffset();
	local offsetX = offset.x;
	local offsetY = offset.y;

	self:onShow(self.cardListIndex);

	local maxInset = self.tableView:maxContainerOffset();
    local minInset = self.tableView:minContainerOffset();

    offsetX = math.min(offsetX, maxInset.x);
    offsetX = math.max(offsetX, minInset.x);
    offsetY = math.min(offsetY, maxInset.y);
    offsetY = math.max(offsetY, minInset.y);

    self.tableView:setContentOffsetInDuration(cc.p(offsetX , offsetY) , 0);
end

function CardListPanel:scrollViewDidScroll(table)

end

function CardListPanel:tableCellTouched(table)
	if self.curSelectPid then
		if self.cardListIndex==1 then
			UIManager:push('CardPanel' , self.curSelectPid, true, self.cards[self.cardListIndex]);
		else
			UIManager:push('CardPanel' , self.curSelectPid, true, nil);
		end
		
		AudioManager:playEffect(Conf.buttonClick);
		self.curSelectPid = nil;
	end
end

function CardListPanel:numberOfCellsInTableView(table)
	return self.tableViewCellMaxNum;
end

function CardListPanel:cellSizeForTable(table)
	return 604 , 425;
end

function CardListPanel:tableCellAtIndex(table,idx)
	
	local startNum = idx * 3 + 1;
	local curMaxNum = (idx+1) * 3;
	curMaxNum = curMaxNum > self.cardMaxNum and self.cardMaxNum or curMaxNum;
	local cell = table:dequeueCell()
	if not cell then
		cell = cc.TableViewCell:new();
		for i = 1 , 3 do
			local x = 101 + 201*(i-1);
			local y = 212.5;
			local bigCard = template.CardTemplate:create(cell);
			bigCard:setTouchEnabled(false);
			if startNum <= curMaxNum then
				local card = self.cards[self.cardListIndex][startNum];
				bigCard:Init(card.pid);
				bigCard:checkRedDot();
				bigCard:checkFlag(card.no);
				if model.TeamModel:CurrentTeamHaveCard(card.pid) then
					bigCard:initCardInTeamState({Enum:getTable('CardTeamState').FIGHT});
				else
					bigCard:initCardInTeamState();
				end
	
				bigCard:setPosition(x, y);
				bigCard:addCardClickEventListener(handler(self, self.enterCardInfo));
				bigCard:setCardTag(card.pid);
				startNum = startNum + 1;
			else
				bigCard:setPosition(x, y);
				bigCard:setVisible(false);
			end
		end
	else
		local children = cell:getChildren();
		for i = 1 , 3 do
			local bigCard = children[i];
			if startNum <= curMaxNum then
				local card = self.cards[self.cardListIndex][startNum];
				bigCard:setVisible(true);
				bigCard:Init(card.pid);
				bigCard:checkRedDot();
				bigCard:checkFlag(card.no);
				if model.TeamModel:CurrentTeamHaveCard(card.pid) then
					bigCard:initCardInTeamState({Enum:getTable('CardTeamState').FIGHT});
				else
					bigCard:initCardInTeamState();
				end
				bigCard:addCardClickEventListener(handler(self, self.enterCardInfo));
				bigCard:setCardTag(card.pid);

				startNum = startNum + 1;
			else
				bigCard:setVisible(false);
			end
		end
	end
	return cell;
end

function CardListPanel:updateData()
	for index , menu in pairs(self.cardMenuList) do
		if index == self.cardListIndex then
			menu.label:setTextColor(cc.c3b(255 , 255 , 255));
			menu.btn:setBright(true);
			menu.light:setVisible(true);
		else
			menu.label:setTextColor(cc.c3b(180 , 180 , 180));
			menu.btn:setBright(false);
			menu.light:setVisible(false);
		end
	end

	self.cardList = {};
	self.cardMaxNum = #self.cards[self.cardListIndex];
	self.tableViewCellMaxNum = math.ceil(self.cardMaxNum/3);

	self.tableView:reloadData();
end

function CardListPanel:enterCardInfo(sender , event)
	self.curSelectPid = sender:getTag();
end

function CardListPanel:updateCardList(pid)
	for _pid , card in pairs(self.cardList) do
		if tonumber(_pid) == pid then
			card.bigCard:Init(pid);
		end
		card.bigCard:checkRedDot();
	end
end

function CardListPanel:cardListClick(sender , event)

	local tag = sender:getTag();

	if tag == self.cardListIndex then
		return;
	end

	Prompt:Show(tag == 2 and LANG.UI_CARD_18 or LANG.UI_CARD_17);

	self.cardListIndex = tag;

	self:updateData();
end

function CardListPanel:swtichBtnClick(sender , event)
	local tag = sender:getTag();
	AudioManager:playEffect(Conf.buttonClick);
	if tag == 1 then
		UIManager:push('EquipWearPanel');
	else
		-- UIManager:push('TeamPanel',Enum:getTable('TeamType').CARD);
		UIManager:push('TeamListPanel');
	end
end

function CardListPanel:updateBtnRedDot()
	local state = model.EquipModel:getTeamSlotEquipActiveState();
	tools.RedDotTools:setRedDotToNode(self.swtichBtnList[1],state,nil,cc.p(120 , 33));
	
	local show = model.TeamModel:checkTeamFormationRedDotState();
	tools.RedDotTools:setRedDotToNode(self.swtichBtnList[2],show,nil,cc.p(120,33))
end

function CardListPanel:onClickBack()
	UIManager:switch('MainPanel');
end

function CardListPanel:onLeave()
	self.root:setVisible(false);
end

function CardListPanel:guideCardItemClick( guide_no )
	local tag = 1;
	local node = cc.Node:create();
	node:setTag(tag);

	self:enterCardInfo(node)

	self:tableCellTouched();
end

function CardListPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 18 then
		local cellChidrens = self.tableView:cellAtIndex(0):getChildren();
		local btn = cellChidrens[1];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 21 then 
		local btn = self.swtichBtnList[1];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end
return CardListPanel;
