local CardLoveActiveTipPanel = class("CardLoveActiveTipPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local homeImagePath = 'image/equip/'
local cvTypeEnum = Enum:getTable("cvTypeEnum");

local picParam = {
	[1] = {0.8, 4,-180},
	[2] = {0.8, -22,-77},
	[3] = {0.8, 0,-165},
	[4] = {0.75, 10,-125},
	[5] = {0.8, -24,-130},
	[6] = {1, -33,-370},
}

function CardLoveActiveTipPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardLoveActiveTipPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function CardLoveActiveTipPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function CardLoveActiveTipPanel:initPanels()

	local bg = cc.Sprite:create('image/cardLove/nlv_bg.png');
	bg:addTo(self.root);

	local stencil = cc.Sprite:create('image/cardLove/nlv_shadow.png');
	self.clipNode = cc.ClippingNode:create()
		:setStencil(stencil)
		:setInverted(false)
		:setAlphaThreshold(0.5)
		:addTo(self.root)

	self.rolePic = cc.Sprite:create('image/role/R04401_Love.png')
	self.rolePic:addTo(self.clipNode)

	self.epbg = cc.Sprite:create('image/cardLove/nlv_bg3.png');
	self.epbg:addTo(self.root);
	self.epbg:setPosition(0, 188)

	self.epLabel = cc.Label:createWithTTF('EP1' , fonts.FONT_SIYUAN , 20);
	self.epLabel:addTo(self.root);
	self.epLabel:setAnchorPoint(0,0.5);
	self.epLabel:setPosition(-190, 188);

	local bg2 = cc.Sprite:create('image/cardLove/nlv_bg2.png');
	bg2:addTo(self.root);


	local barNode = cc.Node:create()
	barNode:addTo(self.root)
	barNode:setPosition(0, -30)
	local barBg = cc.Sprite:create('image/cardLove/nlv_bar_bg.png')
	barBg:addTo(barNode)

	self.barProgress = cc.ProgressTimer:create(cc.Sprite:create('image/cardLove/nlv_bar.png'))
		:setAnchorPoint(cc.p(0.5, 0.5))
		:addTo(barNode)
		-- :setPosition(0,-0.3)
		:setType(cc.PROGRESS_TIMER_TYPE_BAR)
		:setMidpoint(cc.p(0, 0))
		:setBarChangeRate(cc.p(1, 0))
		:setPercentage(50)

	self.barlabel = cc.Label:createWithTTF('0/0' , fonts.FONT_SIYUAN , 16);
	self.barlabel:addTo(barNode);
	self.barlabel:enableOutline(cc.c3b(180 , 120 , 40) , 2);

	local infoNode = cc.Node:create()
	infoNode:setPosition(0 , -128);
	infoNode:addTo(self.root);
	
	local costNodePos = {cc.p(-100 , 46),cc.p(100 , 46),cc.p(0,0)};
	local costName = {LANG.UI_BARE_COLLECT_8,LANG.UI_CARD_LOVE_16,LANG.UI_CARD_LOVE_17};
	self.costList = {};
	for i = 1 , 3 do

		self.costList[i] = {};

		local node = cc.Node:create();
		node:addTo(infoNode);
		node:setPosition(costNodePos[i]);

		local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
		bg:addTo(node);
		if i==3 then
			bg:setContentSize(cc.size(380 , 36))
		else
			bg:setContentSize(cc.size(180 , 36));
		end

		local costIcon = cc.Sprite:create('image/cardLove/mk_2.png');
		costIcon:setPosition(i == 3 and -170 or -70, 0);
		costIcon:setScale(0.6);
		costIcon:addTo(node);
		self.costList[i].costIcon = costIcon;

		local label = cc.Label:createWithTTF(costName[i] , fonts.FONT_SIYUAN , 16);
		label:addTo(node);
		label:setAnchorPoint(0, 0.5)
		label:setPosition(i ==3 and -140 or -40 , 0);
		label:setTextColor(cc.c4b(245 , 225 , 230 , 255));

		local cost = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 16);
		cost:addTo(node);
		cost:setAnchorPoint(1 , 0.5);
		cost:setTextColor(cc.c4b(245 , 225 , 230 , 255));
		cost:setPosition(i == 3 and 150 or 50 , 0);
		self.costList[i].cost = cost;
	end

	local label = cc.Label:createWithTTF(LANG.UI_CARD_LOVE_18 , fonts.FONT_SIYUAN , 14);
	label:enableOutline(cc.c3b(120 , 100 , 190) , 1);
	label:setPosition(80, 19)
	local activeBtn = ccui.Button:create('image/cardLove/nlv_btn1.png' , 'image/cardLove/nlv_btn1.png');
	activeBtn:addTo(self.root);
	activeBtn:setPosition(-100 , -175);
	activeBtn:setTag(1);
	activeBtn:addClickEventListener(handler(self , self.activeClick));
	activeBtn:addChild(label);


	local label = cc.Label:createWithTTF(LANG.UI_CARD_LOVE_19 , fonts.FONT_SIYUAN , 14);
	label:enableOutline(cc.c3b(200 , 80 , 110) , 1);
	label:setPosition(80, 19)
	local activeAllBtn = ccui.Button:create('image/cardLove/nlv_btn2.png' , 'image/cardLove/nlv_btn2.png');
	activeAllBtn:addTo(self.root);
	activeAllBtn:setPosition(100 , -175);
	activeAllBtn:setTag(2);
	activeAllBtn:addClickEventListener(handler(self , self.activeClick));
	activeAllBtn:addChild(label);

	EventManager:RegisterEvent(EventType.NetworkLoveLevelUp , handler(self, self.retLoveLvUp));
end

function CardLoveActiveTipPanel:onEnter(lovelId, level)

	self:addSwallowCallback(handler(self , self.onClickBack));

	local roleLoveData = model.CardModel:getLoveData(lovelId);
	if not roleLoveData then
		UIManager:pop('CardLovePanel');
		return
	end

	self.roleLoveData = roleLoveData;
	self.lovelId = lovelId;
	self.level = level

	local givingLevel = self.roleLoveData.loveLevel+1;
	local data = self.roleLoveData.loveData[givingLevel];

	if data then
		if data.item_cost then
			local cost = data.item_cost[1];
			local icon = ResTable:getValue('item',cost[1],'icon');

			local haveNum = model.ItemModel:getItemNum(cost[1]);
			-- self.costList[1].costIcon:setTexture('image/icon/I'..icon..'.png');
			self.costList[1].cost:setString(tostring(haveNum));

			-- self.costList[2].costIcon:setTexture('image/icon/I'..icon..'.png');
			self.costList[2].cost:setString(tostring(cost[2]));

			-- self.costList[3].costIcon:setTexture('image/icon/I'..icon..'.png');

			local costNum = data.love_value - self.roleLoveData.loveValue;
			self.costList[3].cost:setString(tostring(costNum));
		end
	end

	local idx = self.level
	local img = 'image/role/'..data.show_pg..'.png'
	if self.level == 1 then
		local res_id = ResTable:getValue('role', data.role_id, 'resource_id')
		local navi = ResTable:getValue('role_resource', res_id, 'card')
		img = 'image/role/'..navi..'.png'
	else
		local hasData = self.roleLoveData.loveData[self.roleLoveData.loveLevel];
		img = 'image/role/'..hasData.show_pg..'.png'
	end
	self.rolePic:setTexture(img)
	if data and data.show_head_cut then
		local cut = data.show_head_cut;
		-- self.rolePic:setScale( picParam[idx][1] )
		-- self.rolePic:setPosition( picParam[idx][2],picParam[idx][3] )
		self.rolePic:setScale( cut[3] )
		self.rolePic:setPosition( cut[1],cut[2] )
	end

	if self.level-1 <= 0 then
		self.epLabel:setVisible(false)
		self.epbg:setVisible(false)
	else
		self.epLabel:setVisible(true)
		self.epbg:setVisible(true)
	end
	self.epLabel:setString('EP.'..(self.level-1))

	local pro = (self.roleLoveData.loveValue/data.love_value)*100
	self.barlabel:setString(self.roleLoveData.loveValue..'/'..data.love_value);

	self.barProgress:setPercentage(pro)

	self.root:setVisible(true);
end

function CardLoveActiveTipPanel:activeClick(sender , event)
	local tag = sender:getTag();

	local givingLevel = self.roleLoveData.loveLevel+1;
	local data = self.roleLoveData.loveData[givingLevel];
	if data then
		for _k , item in pairs(data.item_cost) do
			local num = model.ItemModel:getItemNum(item[1]);
			if num < item[2] then
				Prompt:Show(LANG.UI_CARD_LOVE_4);--两手空空怎么把妹！？
				return;
			end
		end
		local msg = {};
		msg.love_id = self.lovelId;
		msg.activeType = tag;
		Network.NetworkManager:Send(Network.NetworkCmdType.req_love_level_up , msg);
	end

end

function CardLoveActiveTipPanel:retLoveLvUp(isLevelUp, unlockIdx)
	-- self:updateInfo()
	self:playGiftCV()
	self.unlockIdx = unlockIdx;

	if isLevelUp then --解锁全部
		-- self.beatBarSpine:setAnimation(0, "fly", false)
		self.root:runAction( cc.Sequence:create( 
		cc.DelayTime:create(0),
		cc.CallFunc:create(function()
				-- self:playHappyAni()
				UIManager:pop('CardLoveActiveTipPanel');
				EventManager:FireEvent('CardLovePanel_Change' , true, 0);
			end)
		) )
	else
		-- self.beatBarSpine:setAnimation(0, "fly", false)
		self.root:runAction( cc.Sequence:create( 
		cc.DelayTime:create(0),
		cc.CallFunc:create(function()
				UIManager:pop('CardLoveActiveTipPanel');
				EventManager:FireEvent('CardLovePanel_Change' , false, self.unlockIdx);

			end)
		) )
	end
end


function CardLoveActiveTipPanel:onClickBack()
	UIManager:pop('CardLoveActiveTipPanel');
end

function CardLoveActiveTipPanel:onLeave()
	self.root:setVisible(false);
end

function CardLoveActiveTipPanel:playGiftCV()
	-- body
	local giftCvIndex = 1; 
	local curLevel = self.roleLoveData.loveLevel;
	local curValue = self.roleLoveData.loveValue+1;
	local data = self.roleLoveData.loveData[curLevel];

	local totalValue = 0
	if data then
		totalValue = data.love_value;
	end


	if curLevel==5 then
		if curValue > 0 and curValue <= 7 then
			giftCvIndex = 1;
		elseif curValue >= totalValue then
			giftCvIndex = 3;
		else
			giftCvIndex = 2;
		end

	elseif curLevel==4 then
		if curValue > 0 and curValue <= 6 then
			giftCvIndex = 1;
		elseif curValue >= totalValue then
			giftCvIndex = 3;
		else
			giftCvIndex = 2;
		end

	else
		if curValue > 0 and curValue <= 4 then
			giftCvIndex = 1;
		elseif curValue >= totalValue then
			giftCvIndex = 3;
		else
			giftCvIndex = 2;
		end
	end

	AudioManager:playCVStopBefor(self.roleLoveData.loveData[1].role_id,nil ,cvTypeEnum.CV_GIFT,giftCvIndex);

end

return CardLoveActiveTipPanel;
