local CardLoveListPanel = class("CardLoveListPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local imagePath = 'image/cardLove/';

function CardLoveListPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardLoveListPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function CardLoveListPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function CardLoveListPanel:initPanels()

	local bg = cc.Sprite:create('image/bg/Bg_15.png');
	bg:addTo(self.root);

	self.loveView = ccui.PageView:create();
	self.loveView:addTo(self.root);
	self.loveView:setPosition(0 , 31);
	self.loveView:setContentSize(cc.size(372 , 815));
	self.loveView:setAnchorPoint(0.5,0.5);
	self.loveView:setClippingEnabled(false);
    self.loveView:addEventListener(handler(self , self.pageViewEvent));
end

function CardLoveListPanel:pageViewEvent(sender , event)

end

function CardLoveListPanel:onEnter()

	local loveData = model.CardModel:getLoveData();
	if not loveData then
		UIManager:pop('CardLoveListPanel');
		return
	end
	print_ro(loveData, 'fubin')

	local loveDatas = {};
	for _k , data in pairs(loveData) do
		local hide = 0
		if data.loveData and data.loveData[1] then
			hide = data.loveData[1].hide;
		end
		if hide ~= 1 then
			table.insert(loveDatas , data);
		end
	end

	local loveNum = #loveDatas;
	if loveNum > 1 then
		table.sort(loveDatas , function(first , second)
			return first.roleId < second.roleId;
		end);
	end

	self.loveView:removeAllPages();

	for i = 1 ,loveNum do
		local data = loveDatas[i];
		local widget = ccui.Widget:create();
		widget:setContentSize(cc.size(372 , 815));
		self.loveView:addPage(widget);
		local template = template.LoveListTemplate:create();
		template:addTo(widget);
		template:setPosition(186 , 407.5);
		template:Init(data);
		template:setLoveTag(data.loveId);
		template:addLoveClickEventListener(handler(self , self.cardLoveClick));
	end

	self.root:setVisible(true);
end

function CardLoveListPanel:cardLoveClick(sender , event)
	local loveId = sender:getTag();
	UIManager:push('CardLovePanel' , loveId);
end

function CardLoveListPanel:onClickBack()
	UIManager:pop('CardLoveListPanel');
end

function CardLoveListPanel:onLeave()
	self.root:setVisible(false);
end

return CardLoveListPanel;
