local CardLoveLivePanel = class("CardLoveLivePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');

function CardLoveLivePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardLoveLivePanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE_NO_MONEY;
end

function CardLoveLivePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.curPid = nil;

	self:initPanels()
end

function CardLoveLivePanel:initPanels()

	self.bg = cc.Sprite:create('image/bg/Bg_3.png');
	self.bg:addTo(self.root);

	self.touchNode = cc.Node:create();
	self.touchNode:addTo(self.root)

	self.loveNavi = cc.Sprite:create();
	self.loveNavi:addTo(self.touchNode);

	self.skeletonNode = cc.Node:create();
	self.skeletonNode:addTo(self.touchNode);

	self.swtichBtn = ccui.Button:create('image/card/live_switch_off.png' ,'image/card/live_switch_off.png' , 'image/card/live_switch_on.png');
	self.swtichBtn:addTo(self.root);
	self.swtichBtn:setPosition(227 , StageSize.height/2 - 88);
	self.swtichBtn:setTag(1);
	self.swtichBtn:addClickEventListener(handler(self , self.swtichBtnClick));
end
--[[
function CardLoveLivePanel:registerHandler()

	if self.cardLoveListener then
		local eventDispatcher = self.touchNode:getEventDispatcher();
		eventDispatcher:removeEventListener(self.cardLoveListener);
		self.cardLoveListener = nil;
	end

	self.cardLoveListener = cc.EventListenerTouchOneByOne:create();
	local onTouchBegan = function(tap, event)
		self.moveMaxX = 0;
		self.moveMaxY = 0;
		local width = StageSize.width/2;
		local height = StageSize.height/2;
		local size = {width = 0,height=0};
		if self.curState == 2 then
			size = self.loveNavi:getContentSize();
		else
			if nil ~= self.skAnimation then
				size = self.animationSize;
			else
				size = self.loveNavi:getContentSize();
			end
		end

		--self.moveMaxX = size.width/2-width;
		self.moveMaxY = size.height/2-height;
		--self.moveMaxX = math.max(self.moveMaxX,0);
		self.moveMaxY = math.max(self.moveMaxY,0);

		--print('moveMaxX=================>',self.moveMaxX);
		--print('moveMaxY=================>',self.moveMaxY);
		return true;
	end
	local onTouchMove = function(touch , event)
		local delta = touch:getDelta();
		local x , y = self.touchNode:getPosition();
		x = delta.x+x;
		y = delta.y+y;

		if x >= self.moveMaxX then
			x = self.moveMaxX	
		elseif x <= -self.moveMaxX then
			x = -self.moveMaxX
		end

		if y >= self.moveMaxY then
			y = self.moveMaxY
		elseif y <= -self.moveMaxY then
			y = -self.moveMaxY
		end

		self.touchNode:setPosition(x,y);
	end
	local onTouchEnd = function(touch,event)
		local posEnd = touch:getLocation();
		local posStart = touch:getStartLocation()
		local dis = cc.pGetDistance(posStart,posEnd)
		if dis < 20 then
			if nil ~= self.skAnimation and not self.spPlayTouch then
				self.spPlayTouch = true;
				self.skAnimation:setMix('idle', 'touch', 0.7)
				self.skAnimation:setAnimation(0, "touch", false)
			end

			local ret = AudioManager:playDialogLoveCV(self.roleId,self.level,self.love_cvIndex)
			if ret == -1 then
				self.love_cvIndex = 1;
				AudioManager:playDialogLoveCV(self.roleId,self.level,self.love_cvIndex)
			end
			self.love_cvIndex = self.love_cvIndex + 1;
		end
	end
	self.cardLoveListener:setSwallowTouches(true);
	self.cardLoveListener:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN);
	self.cardLoveListener:registerScriptHandler(onTouchMove, cc.Handler.EVENT_TOUCH_MOVED);
	self.cardLoveListener:registerScriptHandler(onTouchEnd, cc.Handler.EVENT_TOUCH_ENDED);
	local eventDispatcher = self.touchNode:getEventDispatcher();
	eventDispatcher:addEventListenerWithSceneGraphPriority(self.cardLoveListener, self.touchNode);
end
]]
function CardLoveLivePanel:onEnter(loveId,level)

	--self:registerHandler();
	--self.touchNode:setPosition(0,0)
	--self.curState = 2;
	self.love_cvIndex = 1;
	self:onShow(loveId,level);

	self.root:setVisible(true);
	self:addSwallowCallback(handler(self,self.cardLoveClick));
end

function CardLoveLivePanel:cardLoveClick()
	if self.skAnimation ~= nil and not self.spPlayTouch then
		self.spPlayTouch = true;
		self.skAnimation:setMix('idle', 'touch', 0.7)
		self.skAnimation:setAnimation(0, "touch", false)
	end
	local roleLoveData = model.CardModel:getLoveData(self.loveId);
	local ret = AudioManager:playDialogLoveCV(roleLoveData.roleId,self.level,self.love_cvIndex)
	if ret == -1 then
		self.love_cvIndex = 1;
		AudioManager:playDialogLoveCV(roleLoveData.roleId,self.level,self.love_cvIndex)
	end
	self.love_cvIndex = self.love_cvIndex + 1;
end

function CardLoveLivePanel:onShow(loveId,level)
	local roleLoveData = model.CardModel:getLoveData(loveId);
	if not roleLoveData or not level or roleLoveData.loveLevel < level then
		UIManager:pop('CardLoveLivePanel');
		return;
	end

	self.loveId = loveId;
	self.level = level
	--local roleQuality = ResTable:getValue('role' , roleId , 'quality');
	--self.bg:setTexture('image/card/cardQualityBg/card_bg_quality_'..roleQuality..'.png');

	local data = roleLoveData.loveData[self.level];

	self.loveNavi:setTexture('image/role/'..data.show_pg..'.png');

	self.spine_res = data.show_spine;
	--self.spine_res = 'R030_Spine';
	

	self.skeletonNode:removeAllChildren();
	self.skAnimation = nil
	--self.animationSize = nil;

	if self.spine_res ~= nil then
		if cc.FileUtils:getInstance():isFileExist('spine/'..self.spine_res.."/"..self.spine_res..".json") then
			self:addSpineAnimation()
		else
			DownloadControler:addDownLoadList(self.spine_res, 'spine/',  function()
					self:addSpineAnimation()
				end)
		end
		self.swtichBtn:setEnabled(true)
	else
		self.swtichBtn:setEnabled(false)
	end

	self:switchState(2);
end


function CardLoveLivePanel:addSpineAnimation()
	-- body
	local roleLoveData = model.CardModel:getLoveData(self.loveId);
	local data = roleLoveData.loveData[self.level];

	self.spine_res = data.show_spine;
	--self.spine_res = 'R030_Spine';
	if data.spine_bg then
		self.bg:setTexture('image/cardLove/'..data.spine_bg..'.png');
	end
	--self.animationSize = nil;
	self.skAnimation = nil
	self.skeletonNode:removeAllChildren();

	if self.spine_res~=nil and cc.FileUtils:getInstance():isFileExist('spine/'..self.spine_res.."/"..self.spine_res..".json") then
		self.skAnimation = sp.SkeletonAnimation:create('spine/'..self.spine_res.."/"..self.spine_res..".json", 'spine/'..self.spine_res.."/"..self.spine_res..".atlas", 1)
		self.skAnimation:addTo(self.skeletonNode)
		self.skAnimation:setAnimation(0, "idle", true)
		-- registerEvent
		self.skAnimation:registerSpineEventHandler(function (event)
		end, sp.EventType.ANIMATION_START)

		self.skAnimation:registerSpineEventHandler(function (event)
		end, sp.EventType.ANIMATION_END)

		self.skAnimation:registerSpineEventHandler(function (event)
			if self.spPlayTouch then
				self.spPlayTouch = false
				self.skAnimation:setMix('touch', 'idle', 0.7)
				self.skAnimation:setAnimation(0, "idle", true)
			end
		end, sp.EventType.ANIMATION_COMPLETE)

		self.skAnimation:registerSpineEventHandler(function (event)
		end, sp.EventType.ANIMATION_EVENT)

		--self.skAnimation:update(0);
		--self.animationSize = self.skAnimation:getBoundingBox();
	end
end

function CardLoveLivePanel:swtichBtnClick(sender , event)
	local tag = sender:getTag();
	self:switchState(tag)
end

function CardLoveLivePanel:switchState(state)
	if state == 1 and self.skAnimation == nil then
		--if self.spine_res and self.spine_res ~= '' then
		--	Prompt:Show(LANG.UI_UPDATE_2);
		--else
			Prompt:Show(LANG.UI_CARD_2);
		--end
		return
	end

	self.swtichBtn:setTag(state == 1 and 2 or 1);
	self.swtichBtn:setBright(state == 2)

	self.loveNavi:setVisible(state == 2);

	if self.skAnimation ~= nil then
		self.skeletonNode:setVisible(state == 1);
		self.bg:setVisible(state == 1);
		--self.touchNode:setPosition(0,0)
		self.spPlayTouch = false
		self.skAnimation:setAnimation(0, "idle", true)
	end

	--self.curState = state;
end

function CardLoveLivePanel:onClickBack()
 	UIManager:pop('CardLoveLivePanel');
end

function CardLoveLivePanel:onLeave()
	--[[
	if self.cardLoveListener then
		local eventDispatcher = self.touchNode:getEventDispatcher();
		eventDispatcher:removeEventListener(self.cardLoveListener);
		self.cardLoveListener = nil;
	end
	
	self.animationSize = nil;
	]]
	self.skeletonNode:removeAllChildren();
	self.skAnimation = nil
	self.root:setVisible(false);
end

return CardLoveLivePanel;
