local CardLovePanel = class("CardLovePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local imagePath = 'image/cardLove/';
local cvTypeEnum = Enum:getTable("cvTypeEnum");

-- 缺少满级立绘，需要在点击立绘时播放CV_GIFT音效
function CardLovePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardLovePanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function CardLovePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function CardLovePanel:initPanels()

	self.testGrid = cc.NodeGrid:create()
	self.testGrid:addTo(self.root)

	local bg = cc.Sprite:create('image/bg/Bg_15.png');
	bg:addTo(self.testGrid);

	local bg = cc.LayerColor:create(cc.c4b(0, 0, 0, 127.5))
		:setContentSize(cc.size(StageSize.width, StageSize.height))
		:setPosition(-StageSize.width/2, -StageSize.height/2)
		:addTo(self.testGrid);

	local showLoveNode = cc.Node:create()
		:setPosition(-130,56)
		:addTo(self.testGrid)

	self.loveNavi = cc.Sprite:create();
	self.loveSpine = nil;
	local stencil = cc.Sprite:create(imagePath..'card_love_11.png');
	self.activeBgClippingNode = cc.ClippingNode:create()
		:setStencil(stencil)
		:addChild(self.loveNavi)
		:setInverted(false)
		:setAlphaThreshold(0.5)
		:addTo(showLoveNode)

	local clipNode = cc.ClippingRectangleNode:create( cc.rect(-50,-250,100,200) )
	clipNode:addTo(showLoveNode)
	self.lightClipNode = clipNode;
	local spine_res = 'ailianjiesuo_spine';
	self.lightSpine = nil
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.lightSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.lightSpine:addTo(clipNode)
		self.lightSpine:registerSpineEventHandler(function (event)
			if event.eventData.name == 'disappear' then
				self:hideMaskSpr()
			end
		end, sp.EventType.ANIMATION_EVENT)
	end

	self.maskCellList = {}
	self.lightCellList = {}

	local showLoveFgBtn = ccui.Button:create(imagePath..'card_love_1.png',imagePath..'card_love_1.png')
		:addTo(showLoveNode)
	showLoveFgBtn:addClickEventListener(handler(self , self.showLoveClick));

	self.activeNode = cc.Node:create()
		:addTo(showLoveNode)

	local dialogBtn = ccui.Button:create(imagePath..'card_love_btn_2.png',imagePath..'card_love_btn_2.png')
		:addTo(self.activeNode)
		:setPosition(-132,-245)
	dialogBtn:addClickEventListener(handler(self , self.dialogBtnClick))
	
	local liveBtn = ccui.Button:create(imagePath..'card_love_btn_1.png',imagePath..'card_love_btn_1.png')
		:addTo(self.activeNode)
		:setPosition(-132,-303)
	liveBtn:addClickEventListener(handler(self , self.liveBtnClick))

	self.notActiveNode = cc.Node:create()
		:addTo(showLoveNode)
	
	-- local nodeActiveShader = cc.Sprite:create(imagePath..'card_love_2.png')
	-- 	:addTo(self.notActiveNode)

	local notActiveTitle = cc.Label:createWithTTF(LANG.UI_CARD_LOVE_8,fonts.FONT_SIYUAN,20)
		:addTo(self.notActiveNode)
		:setPosition(0,-305)
		:enableGlow( cc.c4b(240,100,230,255))

	self.loveLevelList = {};
	for i = 1 , LOVE_MAX_LEVEL do
		self.loveLevelList[i] = {};
		local node = cc.Node:create()
			:addTo(self.testGrid)
			:setPosition(175,333-140*(i-1))

		local bg = cc.DrawNode:create()
		bg:drawPolygon({cc.p(0,0),cc.p(0,112),cc.p(226,112),cc.p(226,0)} , 4 , cc.c4f(0,0,0,1) , 0 , cc.c4f(0,0,0,0))
		bg:addTo(node)
		bg:setPosition(-113,-56)
		
		local navi = cc.Sprite:create()
			:addTo(node)
			:setOpacity(127.5)
		self.loveLevelList[i].navi = navi;

		local btn = ccui.Button:create(imagePath..'card_love_5.png',imagePath..'card_love_5.png')
		:addTo(node)
		:setTag(i)
		btn:addClickEventListener(handler(self,self.loveLevelClick))
		
		local ep = cc.Label:createWithTTF('EP.'..i,fonts.FONT_SIYUAN,15)
			:addTo(node)
			:setAnchorPoint(0,0.5)
			:setPosition(-104,38)
			:enableOutline(cc.c3b(60,60,60),2)
		
		local notActiveNode = cc.Node:create()
			:addTo(node)
		self.loveLevelList[i].notActiveNode = notActiveNode

		local lock = cc.Sprite:create(imagePath..'card_love_7.png')
			:addTo(notActiveNode)

		local progressNode = cc.Node:create()
			:addTo(notActiveNode)
		self.loveLevelList[i].progressNode = progressNode;

		local progressBg = cc.Sprite:create(imagePath..'card_love_8.png')
			:addTo(progressNode)
			:setPosition(0,-39)

		local progress = cc.Scale9Sprite:create(imagePath..'card_love_9.png')
			:addTo(progressNode)
			:setCapInsets(cc.rect(6,0,197,12))
			:setContentSize(cc.size(12 , 12))
			:setAnchorPoint(0,0.5)
			:setPosition(-104.5,-39)
		self.loveLevelList[i].progress = progress
	end

	local attTipBg = cc.Sprite:create(imagePath..'card_love_6.png')
		:addTo(self.testGrid)
		:setPosition(-9,-403)

	self.attTip = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,16)
		:addTo(self.testGrid)
		:setPosition(-9,-403)
	
	self.activeAttTip = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,16)
		:addTo(self.testGrid)
		:setPosition(-9,-452)
		:setTextColor(cc.c3b(255,255,0))
		:enableOutline(cc.c3b(0,0,0),1)

	self.happyNode = cc.Node:create()
	self.happyNode:addTo(self.root)

	EventManager:RegisterEvent('CardLovePanel_Change' , handler(self, self.retLove));
end

function CardLovePanel:onEnter(loveId)

	self.loveId = loveId or -1;
	self.hideSprIdx = 0;
	self:onShow();
	self.root:setVisible(true);
end

function CardLovePanel:onResume()
	self.root:setVisible(true);
end

function CardLovePanel:onShow(bchange)
	local roleLoveData = model.CardModel:getLoveData(self.loveId);
	if not roleLoveData then
		UIManager:pop('CardLovePanel');
		return
	end

	self.roleLoveData = roleLoveData;

	for i = 1 , LOVE_MAX_LEVEL do
		local data = roleLoveData.loveData[i];
		if self.loveLevelList[i] then
			self.loveLevelList[i].navi:setTexture('image/role/'..data.show_pg..'.png')

			local size = self.loveLevelList[i].navi:getContentSize();
			local cut = data.small_pg_cut;
			local width = 226/cut[3];
			local height = 112/cut[3];
			self.loveLevelList[i].navi:setTextureRect(cc.rect(size.width/2-width/2+(cut[1]/cut[3]),size.height/2-height/2+(cut[2]/cut[3]),width,height));
			self.loveLevelList[i].navi:setScale(cut[3]);
			if roleLoveData.loveLevel >= data.love_lv then--已经到达的等级
				self.loveLevelList[i].navi:setOpacity(255);
				self.loveLevelList[i].notActiveNode:setVisible(false);
				GlobalFunctions:removeSpriteGrey(self.loveLevelList[i].navi)
			else
				if roleLoveData.loveLevel+1 == data.love_lv then --下一等级
					local totalValue = data.love_value;
					local curValue = roleLoveData.loveValue;

					local width = curValue/totalValue * 209;
					if width > 0 then
						width = math.max(width,12);
						width = math.min(width,209);
					else
						width = 0;
					end
					self.loveLevelList[i].progress:setContentSize(cc.size(width,12));
					self.loveLevelList[i].progressNode:setVisible(true);
				else--未达到等级
					self.loveLevelList[i].progressNode:setVisible(false);
				end

				self.loveLevelList[i].navi:setOpacity(127.5);
				self.loveLevelList[i].notActiveNode:setVisible(true);
				GlobalFunctions:setSpriteGrey(self.loveLevelList[i].navi);
			end
		end
	end

	local showLevel = 1;
	if roleLoveData.loveData[roleLoveData.loveLevel+1] then
		showLevel = roleLoveData.loveLevel+1
	end
	self:updateLoveNode(showLevel, bchange);
	self:updateBottomAttNode();
end

function CardLovePanel:updateLoveNode(level, bchange)
	if self.showLevel == level and bchange~=true and self.lastLoveId==self.loveId then
		return
	end
	if level > self.roleLoveData.loveLevel+1 then
		Prompt:Show(LANG.UI_CARD_LOVE_11);
		return;
	end

	self.love_cvIndex = 1;

	local data = self.roleLoveData.loveData[level];
	if data then
		local cut = data.show_pg_cut;
		-- self.loveNavi:setTexture('image/cardLove/'..data.show_pg..'_BG.png');
		self.loveNavi:setTexture('image/role/'..data.show_pg..'.png');
		self.loveNavi:setScale(cut[3]);
		self.loveNavi:setPosition(cut[1],cut[2]);

		for k,v in pairs(self.maskCellList) do
			v:removeFromParent()
		end
		self.maskCellList = {}

		if self.loveSpine then
			self.loveSpine:removeFromParent()
			self.loveSpine = nil;
		end

		if self.roleLoveData.loveLevel >= level then
			self.activeNode:setVisible(true);
			self.notActiveNode:setVisible(false);

			-- local spine_res = data.show_pg;
			-- if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			-- 	self.loveSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			-- 	self.loveSpine:addTo(self.activeBgClippingNode)
			-- 	self.loveSpine:setScale(cut[3]);
			-- 	self.loveSpine:setPosition(cut[1],cut[2]);
			-- 	self.loveSpine:setAnimation(0,'idle',true);
			-- end

		else
			self.activeNode:setVisible(false);
			self.notActiveNode:setVisible(true);
			
			if true then
				local maskSpr = cc.Sprite:create('image/cardLove/'..data.show_pg..'_B.png')
				local maskTexture = maskSpr:getTexture()
				local maskCnt = data.love_value
				local mWidth = maskSpr:getContentSize().width;
				local mHeight = maskSpr:getContentSize().height/maskCnt;
				local startPosY = maskSpr:getContentSize().height/2

				for i=1,maskCnt do
					local tmpSt = true
					for k,v in pairs(self.roleLoveData.love_state) do
						if i == v then
							tmpSt = false
							break;
						end
					end

					if tmpSt then
						-- local node = cc.NodeGrid:create()
						-- node:addTo(self.activeBgClippingNode)

						local cellSpr = cc.Sprite:createWithTexture(maskTexture, cc.rect(0, (i-1)*mHeight, mWidth, mHeight))
						-- cellSpr:addTo(node)
						cellSpr:addTo(self.activeBgClippingNode)
						cellSpr:setAnchorPoint(0.5, 1)
						cellSpr:setPosition(0, startPosY - (i-1)*mHeight)

						self.maskCellList[i] = cellSpr
					end
				end
			end

		end

		self.showLevel = level;
		self.lastLoveId = self.loveId;
	end
end

function CardLovePanel:updateBottomAttNode()
	local data = self.roleLoveData.loveData[LOVE_MAX_LEVEL];
	local attTipStr = '';
	--local activeAttTipStr = '';
	for _k,attData in ipairs(data.effect) do
		local attType = attData[1];
		local attName = LANG.UI_CARD_LOVE_ATT_NAME[attType];
		if(attData[2] > 0) then
			attTipStr = attTipStr..string.format(attName,tostring(attData[2]))..', ';
			--activeAttTipStr = activeAttTipStr..string.format(attName,attData[3])..', ';
		elseif(attData[3] > 0) then
			attTipStr = attTipStr..string.format(attName,((attData[3]*100)..'%'))..', ';
			--activeAttTipStr = activeAttTipStr..string.format(attName,((attData[3]*100)..'%'))..', ';
		end
	end

	if attTipStr ~= '' then
		attTipStr = string.sub(attTipStr,1,-3);
	end

	--if activeAttTipStr ~= '' then
	--	activeAttTipStr = string.sub(activeAttTipStr,1,-2);
	--end

	local roleName = ResTable:getValue('role_info', data.role_id , 'name');

	self.attTip:setString(string.format(LANG.UI_CARD_LOVE_9,attTipStr));
	self.activeAttTip:setString(string.format(LANG.UI_CARD_LOVE_10,roleName,attTipStr));
	self.activeAttTip:setVisible(self.roleLoveData.loveLevel >= LOVE_MAX_LEVEL);
end

function CardLovePanel:loveLevelClick(sender , event)
	local level = sender:getTag();
	self:updateLoveNode(level);
end

function CardLovePanel:dialogBtnClick(sender , event)
	if self.roleLoveData.loveLevel >= self.showLevel then
		local data = self.roleLoveData.loveData[self.showLevel];
		if data then
			local option = {
				love_lv = data.love_lv,
				role_id = data.role_id
			}
			UIManager:push('PlotPanel' , 3 , data.dialog_id,option);
		end
	else 
		Prompt:Show(LANG.UI_CARD_LOVE_5); --主人和我的关系可还没有这么深入呢哦~
	end
end

function CardLovePanel:liveBtnClick(sender , event)
	UIManager:push('CardLoveLivePanel',self.loveId,self.showLevel);
end

function CardLovePanel:showLoveClick(sender , event)
	if (self.roleLoveData.loveLevel+1) ==  self.showLevel then
		local givingLevel = self.roleLoveData.loveLevel+1;
		local data = self.roleLoveData.loveData[givingLevel];
		if data then
			UIManager:push('CardLoveActiveTipPanel',self.loveId, self.showLevel);
		end
	elseif self.roleLoveData.loveLevel >= self.showLevel then
		local data = self.roleLoveData.loveData[self.showLevel];
		if data then
			local ret = AudioManager:playDialogLoveCV(data.role_id,data.love_lv,self.love_cvIndex)
			if ret == -1 then
				self.love_cvIndex = 1;
				AudioManager:playDialogLoveCV(data.role_id,data.love_lv,self.love_cvIndex)
			end
			self.love_cvIndex = self.love_cvIndex + 1;
		end
	end
end

function CardLovePanel:retLove(isLevelUp, unlockIdx)
	local curLevel = self.roleLoveData.loveLevel;
	
	-- if isLevelUp then
	-- 	Prompt:Show(LANG.UI_CARD_LOVE_12);
	-- else
	-- 	local data = self.roleLoveData.loveData[curLevel+1];
	-- 	if data and data.item_cost[1] then
	-- 		local costNum = data.item_cost[1][2] or 0;
	-- 		Prompt:Show(string.format(LANG.UI_CARD_LOVE_3 , costNum)); --谢谢主人的礼物~好感度上升x
	-- 	end
	-- end

	self:playOneMaskCell(unlockIdx)
	local act1 = cc.DelayTime:create(2)
	local act2 = cc.CallFunc:create( function()
			self:onShow(isLevelUp)
		end )
	self.root:runAction( cc.Sequence:create( act1,act2 ) )
	

	-- local giftCvIndex = 1; 
	-- local curLevel = self.roleLoveData.loveLevel;
	-- local curLevelValue = self.roleLoveData.loveValue;
	local data = self.roleLoveData.loveData[curLevel];
	-- local levelValue = 0
	-- if data then
	-- 	levelValue = data.love_value;
	-- end
	-- local value = curLevelValue - levelValue;
	-- if curLevel >= 0 and curLevel <= 3 then
	-- 	if value > 0 and value <= 2 then
	-- 		giftCvIndex = 1;
	-- 	elseif value >=3 and value <= 4 then
	-- 		giftCvIndex = 2;
	-- 	elseif value >= 5 and value <= 6 then
	-- 		giftCvIndex = 3;
	-- 	elseif value >= 7 and value <= 8 then
	-- 		giftCvIndex = 4;
	-- 	else
	-- 		giftCvIndex = 5;
	-- 	end
	-- else
	-- 	if value > 0 and value <= 3 then
	-- 		giftCvIndex = 1;
	-- 	elseif value >=4 and value <= 7 then
	-- 		giftCvIndex = 2;
	-- 	elseif value >= 8 and value <= 10 then
	-- 		giftCvIndex = 3;
	-- 	elseif value >= 11 and value <= 14 then
	-- 		giftCvIndex = 4;
	-- 	else
	-- 		giftCvIndex = 5;
	-- 	end
	-- end

	-- AudioManager:playCVStopBefor(self.roleLoveData.loveData[1].role_id,nil ,cvTypeEnum.CV_GIFT,giftCvIndex);

	if isLevelUp then
		if data then
			self:playHappyAni(data)
			-- local option = {
			-- 	love_lv = data.love_lv,
			-- 	role_id = data.role_id
			-- }
			-- UIManager:push('PlotPanel' , 3 , data.dialog_id,option, true);
		end
	end
end

function CardLovePanel:playOneMaskCell(unlockIdx)
	if unlockIdx == 0 then
		self.hideSprIdx = unlockIdx;
		self.lightClipNode:setClippingRegion( cc.rect(-175,-410,350,820) )
		self.lightSpine:setAnimation(0, "ailianjiesuo_spine", false)

		-- local roleLoveData = model.CardModel:getLoveData(self.loveId);
		-- self.roleLoveData = roleLoveData;

		-- for k,v in pairs(self.roleLoveData.love_state) do
		-- 	local spr = self.maskCellList[v]
		-- 	if spr and spr:isVisible() then
		-- 		local ltSprite = cc.Sprite:create('image/cardLove/lv_light.png')
		-- 		local ltTexture = ltSprite:getTexture()
		-- 		local ltSpr = cc.Sprite:createWithTexture(ltTexture, v:getTextureRect() )
		-- 		ltSpr:addTo(self.activeBgClippingNode)
		-- 		ltSpr:setAnchorPoint(0.5, 1)
		-- 		ltSpr:setPosition( spr:getPosition() )
		-- 		ltSpr:setBlendFunc(cc.blendFunc(GL_ONE , GL_ONE));

		-- 		ltSpr:setOpacity(0)
		-- 		ltSpr:runAction(cc.Sequence:create( 
		-- 			cc.FadeIn:create(0.8),
		-- 			cc.CallFunc:create(function()
		-- 				spr:setVisible(false)
		-- 			end),
		-- 			cc.DelayTime:create(0.7),
		-- 			cc.FadeOut:create(1),
		-- 			cc.RemoveSelf:create()
		-- 		));

		-- 	end
		-- end

		return;

	end

	for k,v in pairs(self.maskCellList) do
		if v:isVisible() and k==unlockIdx then
			--消融
			-- local ltSprite = cc.Sprite:create('image/cardLove/lv_light.png')
			-- local ltTexture = ltSprite:getTexture()
			-- local ltSpr = cc.Sprite:createWithTexture(ltTexture, v:getTextureRect() )
			-- ltSpr:addTo(self.activeBgClippingNode)
			-- ltSpr:setAnchorPoint(0.5, 1)
			-- ltSpr:setPosition( v:getPosition() )
			-- ltSpr:setBlendFunc(cc.blendFunc(GL_ONE , GL_ONE));

			self.hideSprIdx = unlockIdx;
			local rect = v:getTextureRect();
			local px, py = v:getPosition()
			self.lightClipNode:setClippingRegion( cc.rect(px-rect.width/2, py-rect.height, rect.width, rect.height+1  ) )
			self.lightSpine:setAnimation(0, "ailianjiesuo_spine", false)

			-- v:setVisible(false)

			-- ltSpr:runAction(cc.Sequence:create( 
			-- 	cc.DelayTime:create(3),
			-- 	cc.RemoveSelf:create()
			-- ));

			-- 方块消失特效
			-- v:runAction(cc.Sequence:create(
			-- 	cc.TurnOffTiles:create(1, cc.size(100, 100)),
			-- 	-- cc.ShatteredTiles3D:create(2, cc.size(20, 5), 20, false),
			-- 	-- cc.RemoveSelf:create()
			-- 	cc.CallFunc:create(function()
			-- 			v:setVisible(false)
			-- 		end)
			-- ));

			-- ltSpr:setOpacity(0)
			-- ltSpr:runAction(cc.Sequence:create( 
			-- 	cc.FadeIn:create(0.8),
			-- 	cc.CallFunc:create(function()
			-- 		v:setVisible(false)
			-- 	end),
			-- 	cc.DelayTime:create(0.7),
			-- 	cc.FadeOut:create(1),
			-- 	cc.RemoveSelf:create()
			-- ));

			break;

		end
	end
end

function CardLovePanel:hideMaskSpr()
	if self.hideSprIdx > 0 then
		self.maskCellList[self.hideSprIdx]:setVisible(false)
	else
		for k,v in pairs(self.maskCellList) do
			v:setVisible(false)
		end

	end
end

function CardLovePanel:onClickBack()
	UIManager:pop('CardLovePanel');
end

function CardLovePanel:onLeave()
	self.root:setVisible(false);
end


function CardLovePanel:playHappyAni( data )

	EventManager:FireEvent(EventType.UIHeaderPanelVisible, false, true)

	self.happyNode:removeAllChildren()
	local batchNode = cc.SpriteBatchNode:create('Effect/frame/xintiao/xintiao.png')
	batchNode:addTo(self.happyNode)
	batchNode:setCascadeOpacityEnabled(true);
	batchNode:setPosition(0, -StageSize.height/2)

	local maxTime = 0

	for i=1,200 do
		local testSpr = cc.Sprite:create('Effect/frame/xintiao/xintiao.png')
		testSpr:addTo(batchNode)
		local rate = math.floor( math.random(10, 60) )
		local ani = FrameEffectManager:createFrameAnimation('xintiao', 20, rate)
		testSpr:runAction( cc.RepeatForever:create( cc.Animate:create(ani)) )

		local scale = math.random()
		scale = scale<0.2 and 0.2 or scale
		testSpr:setScale(scale)
		local x = math.random(0, StageSize.width) - StageSize.width/2
		local y = math.random(-500, 250)
		testSpr:setPosition(x, y)

		local time = math.random(200, 500)/1000 * 10
		local delayTime = 0--10-time--math.random(1,13)

		if time > maxTime then
			maxTime = time
		end

		testSpr:setOpacity(0)
		testSpr:runAction( cc.Sequence:create( cc.DelayTime:create(delayTime), cc.FadeIn:create(0.2), 
			cc.MoveTo:create(time , cc.p(x, StageSize.height+ 200)), cc.RemoveSelf:create()  )  )

	end

	-- local act1 = cc.DelayTime:create(0.5)
	-- local act2 = cc.CallFunc:create( function()
	-- 		-- local act = cc.Ripple3D:create( 3, cc.size(200,200), cc.p(StageSize.width/2, StageSize.height/2), 800, 10, 50)
	-- 		-- self.testGrid:runAction( cc.Sequence:create(act, cc.StopGrid:create() ))
	-- 	end )
	local act3 = cc.DelayTime:create(2)
	-- local act4 = cc.CallFunc:create( function()
	-- 		self.testGrid:runAction( cc.FadeOut:create(0.5) )
	-- 		self.rolePic:runAction( cc.FadeIn:create(0.5) )
	-- 	end )
	-- local act5 = cc.DelayTime:create(0.5)
	local act8 = cc.CallFunc:create( function()
			batchNode:runAction( cc.FadeOut:create(0.5) )

			local option = {
				love_lv = data.love_lv,
				role_id = data.role_id
			}
			UIManager:push('PlotPanel' , 3 , data.dialog_id,option, true);

		end )

	self.root:runAction( cc.Sequence:create( act3,act8 ) )

end

return CardLovePanel;
