local CardPanel = class("CardPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local cardImagePath = 'image/card/card/';
local cardSkillImagePath = 'image/card/cardSkill/';

local restraintType = {
	[1] = 2, 
	[2] = 3, 
	[3] = 1, 
	[4] = 3, 
	[5] = 2, 
	[6] = 1, 
}

local curValuePosX = {
	[1] = {-47 , 2},
	[2] = {-4 , 45},
	[3] = {-4 , 45},
}

function CardPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function CardPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.curPid = nil;
	self.cardBtnList = {};

	self:initPanels()
end

function CardPanel:initPanels()

	self.bg = cc.Sprite:create('image/bg/Bg_3.png');
	self.bg:addTo(self.root);

	self.qualityBg = cc.Sprite:create();
	self.qualityBg:addTo(self.root);

	self.cardPanelNavi = cc.Sprite:create();
	self.cardPanelNavi:addTo(self.root);
	self.cardPanelNavi:setPosition(-2 , 101);

	self.swtichBtnList = {};
	for i = 1 , 2 do
		if i == 2 then
			self.swtichBtnList[i] = ccui.Button:create('image/commonImg/btn_5_132_45.png' , 'image/commonImg/btn_5_132_45.png');
			self.swtichBtnList[i]:addTo(self.root);
			self.swtichBtnList[i]:setPosition(i == 1 and 90 or 240 , StageSize.height/2 - 94- NOTCH_HEIGHT);
			self.swtichBtnList[i]:setTag(i);
			self.swtichBtnList[i]:addClickEventListener(handler(self , self.swtichBtnClick));

			local label = cc.Label:createWithTTF(LANG.UI_CARD_SWITCH_BTN[i] , fonts.FONT_SIYUAN , 20);
			label:addTo(self.swtichBtnList[i]);
			label:setPosition(65 , 24);
			label:enableOutline(cc.c4b(125 , 125 , 125, 255) , 2);
		end
	end

	-- self.bigBtn = ccui.Button:create('image/card/btn_info.png');
	-- self.bigBtn:addTo(self.root);
	-- self.bigBtn:setPosition(-280 , StageSize.height/2 - 165);
	-- self.bigBtn:addClickEventListener(function()
	-- 	AudioManager:playEffect(Conf.buttonClick);
	-- 	local resId = model.CardModel:getCardResIdByPid( self.curPid );
 -- 		UIManager:push('CardLivePanel' , self.curPid, resId);
	-- end);

	local avatarNode = cc.Node:create();
	avatarNode:addTo(self.root);
	avatarNode:setPosition(-280 , StageSize.height/2 - 220);

	self.avartBtn = ccui.Button:create('image/card/btn_avatar.png');
	self.avartBtn:addTo(avatarNode);
	self.avartBtn:addClickEventListener(function()
		AudioManager:playEffect(Conf.buttonClick);
		UIManager:push('CardAvatarUsePanel' , self.curPid, self.roleData.role_id);
	end);

	-- local particle1 = cc.ParticleSystemQuad:create('Effect/particle/card_avatar.plist')
	-- 	:addTo(avatarNode);

	self.cardBtnList[1] = avatarNode;

	local commentBtn = ccui.Button:create('image/card/btn_commont.png');
	commentBtn:addTo(self.root);
	commentBtn:setPosition(-280 , StageSize.height/2 - 333);
	commentBtn:addClickEventListener(function()
		AudioManager:playEffect(Conf.buttonClick);
		local card = model.CardModel:GetCard(self.curPid);
		UIManager:push('CardCommentPanel' , card.no);
	end);

	self.cardBtnList[2] = commentBtn;

	local bareBtn = ccui.Button:create('image/card/btn_bare.png');
	bareBtn:addTo(self.root);
	bareBtn:setPosition(-280 , StageSize.height/2 - 275);
	bareBtn:addClickEventListener(function()
		AudioManager:playEffect(Conf.buttonClick);
		local card = model.CardModel:GetCard(self.curPid);
		local isHave , bareId = model.BareCollectModel:isHaveBare(card.no);
		if isHave then
			local bareData = model.BareCollectModel:getBareData(bareId);
			if bareData then
				if bareData.activeState == 1 then
					UIManager:push('BareCollectPanel' , bareId);
				else
					Prompt:Show(bareData.get_des);
				end
			end
		end
	end);

	self.bareBtn = bareBtn;

	self.menuList = {};
    for i = 1 , 3 do
		self.menuList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(-201 + 201 * (i - 1) , -70);
        self.menuList[i].unselectNode = node;
        
        local unTexture = 'image/commonImg/menu_1_202_45_u.png';
        local texture = 'image/commonImg/menu_1_202_45.png';

		local bgBtn = ccui.Button:create(unTexture , unTexture);
		bgBtn:addTo(node);
		bgBtn:setTag(i);
		bgBtn:addClickEventListener(handler(self , self.menuClick));

		local label = cc.Label:createWithTTF(LANG.UI_CARD_MENU_BTN[i] , fonts.FONT_SIYUAN , 16);
		label:addTo(node);
		label:setTextColor(cc.c3b(180 , 180 , 180));

		node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(-201 + 201 * (i - 1) , -70);
		self.menuList[i].selectNode = node;

		bgBtn = ccui.Button:create(texture , texture);
		bgBtn:addTo(node);

		local light = cc.Sprite:create('image/commonImg/menu_light_1.png');
		light:addTo(node);
		light:setPosition(0 , 23);

		label = cc.Label:createWithTTF(LANG.UI_CARD_MENU_BTN[i] , fonts.FONT_SIYUAN , 16);
		label:addTo(node);
	end
	
	--升级
	self.levelUpNode = cc.Node:create();
	self.levelUpNode:addTo(self.root);
	self.levelUpNode:setPosition(0 , -185);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.levelUpNode);
	bg:setPosition(0 , 12);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(604 , 564));

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.levelUpNode);
	bg:setPosition(0 , 149);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(582 , 265));
	
	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.levelUpNode);
	bg:setPosition(0 , -106);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(582 , 227));

	local levelBg = cc.Sprite:create('image/card/cardLevelUp/card_level_up_2.png');
	levelBg:addTo(self.levelUpNode);
	levelBg:setPosition(160 , 227);

	self.nextLevelNode = cc.Node:create();
	self.nextLevelNode:addTo(self.levelUpNode);
	self.nextLevelNode:setPosition(219 , 247);

	local bg = cc.Sprite:create('image/commonImg/arrow_1_bg.png');
	bg:addTo(self.nextLevelNode);
	bg:setPosition(-32 , 0);

	self.nextLevel = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.nextLevel:addTo(self.nextLevelNode);
	self.nextLevel:setTextColor(cc.c3b(255 , 255 , 255));

	self.maxLevel = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.maxLevel:addTo(self.levelUpNode);
	self.maxLevel:setTextColor(cc.c3b(255 , 255 , 255));
	self.maxLevel:setPosition(160 , 207);

	self.nextMaxNode = cc.Node:create();
	self.nextMaxNode:addTo(self.levelUpNode);
	self.nextMaxNode:setPosition(219 , 207);

	local bg = cc.Sprite:create('image/commonImg/arrow_1_bg.png');
	bg:addTo(self.nextMaxNode);
	bg:setPosition(-32 , 0);

	self.nextMaxLevel = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.nextMaxLevel:addTo(self.nextMaxNode);
	self.nextMaxLevel:setTextColor(cc.c3b(255 , 255 , 255));

	local attPos = {
		[1] = cc.p(0 , 125),
		[2] = cc.p(-137 , 76),
		[3] = cc.p(137 , 76),
	};

	local attLabelOutline = {
		[1] = cc.c3b(185 , 40 , 40),
		[2] = cc.c3b(10 , 150 , 90),
		[3] = cc.c3b(210 , 80 , 10),
	}

	self.attributeList = {};
	
	for i = 1 , 3 do

		self.attributeList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.levelUpNode);
		node:setPosition(attPos[i]);
		self.attributeList[i].node =  node;

		local bg = cc.Sprite:create(i == 1 and 'image/card/card_att_bg_1.png' or 'image/card/card_att_bg_2.png');
		bg:addTo(node);

		local bg = cc.Sprite:create('image/card/card_att_img_'..i..'.png');
		bg:setPosition(i == 1 and cc.p(-224 , 1) or cc.p(-86 , 1));
		bg:addTo(node);

		local label = cc.Label:createWithTTF(LANG.UI_CARD_ATT[i] , fonts.FONT_SIYUAN , 17);
		label:addTo(node);
		label:setPosition(i == 1 and cc.p(-235 , 1) or cc.p(-98 , 1));
		label:enableOutline(attLabelOutline[i] ,2);

		self.attributeList[i].curValue = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.attributeList[i].curValue:addTo(self.attributeList[i].node);
		self.attributeList[i].curValue:setPosition(curValuePosX[i][1] , 0);

		self.attributeList[i].bg = cc.Sprite:create('image/commonImg/arrow_7.png');
		self.attributeList[i].bg:addTo(self.attributeList[i].node);
		self.attributeList[i].bg:setPosition(curValuePosX[i][2] , 0);

		self.attributeList[i].nextValue = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.attributeList[i].nextValue:addTo(self.attributeList[i].node);
		self.attributeList[i].nextValue:setPosition(i == 1 and 48 or 91 , 0);
	end

	local costTitle = cc.Sprite:create('image/commonImg/arrow_bg.png');
	costTitle:addTo(self.levelUpNode);
	costTitle:setPosition(-258 , -19);

	local costTitleLabel = cc.Label:createWithTTF(LANG.UI_CARD_RESOLVE_6 , fonts.FONT_SIYUAN , 23);
	costTitleLabel:addTo(self.levelUpNode);
	costTitleLabel:setPosition(-213 , -19);
	costTitleLabel:setTextColor(cc.c3b(160 , 200 , 255));

	self.itemCostNode = cc.Node:create();
	self.itemCostNode:addTo(self.levelUpNode);
	self.itemCostNode:setPosition(0 , -64);

	local itemIcon = ResTable:getValue('item' , BREAK_MONEY , 'icon');
	self.itemCost = {};
	for i = 1 , 2 do

		self.itemCost[i] = {};

		local node = cc.Node:create();
		node:addTo(self.itemCostNode);
		node:setPosition(i == 1 and -132 or 145 , -9);
		
		local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
		bg:addTo(node);
		bg:setPosition(-5 , 0);
		bg:setCapInsets(cc.rect(11,4,18,21));
		bg:setContentSize(cc.size(267 , 42));

		local bg = cc.Sprite:create('image/icon/I'..itemIcon..'.png');
		bg:addTo(node);
		bg:setScale(0.5);
		bg:setPosition(-112 , 4);
		self.itemCost[i].icon = bg;

		local label = cc.Label:createWithTTF(i == 1 and LANG.UI_CARD_19 or LANG.UI_CARD_20 , fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setTextColor(cc.c3b(160 , 200 , 255));
		label:setPosition(-60 , 0);

		self.itemCost[i].cost= cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.itemCost[i].cost:addTo(node);
		self.itemCost[i].cost:setAnchorPoint(1 , 0.5);
		self.itemCost[i].cost:setPosition(i == 1 and 75 or 117 , 0);
	end

	self.addBtn = ccui.Button:create('image/card/cardLevelUp/card_level_up_4.png');
	self.addBtn:addTo(self.levelUpNode);
	self.addBtn:setPosition(-26 , -73);
	self.addBtn:addClickEventListener(handler(self , self.addBtnClick));

	self.coinCostNode = cc.Node:create();
	self.coinCostNode:addTo(self.levelUpNode);
	self.coinCostNode:setPosition(0 , -123);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.coinCostNode);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(543 , 42));

	local itemIcon = ResTable:getValue('item' , MONEY_ID , 'icon');
	local bg = cc.Sprite:create('image/icon/I'..itemIcon..'.png');
	bg:addTo(self.coinCostNode);
	bg:setScale(0.5);
	bg:setPosition(-239 , 0);

	local label = cc.Label:createWithTTF(LANG.UI_CARD_20 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.coinCostNode);
	label:setPosition(-191 , 0);
	label:setTextColor(cc.c3b(160 , 200 , 255));

	self.cost = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.cost:addTo(self.coinCostNode);
	self.cost:setAnchorPoint(1 , 0.5);
	self.cost:setPosition(262 , 0);

	self.levelUpBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.levelUpBtn:addTo(self.levelUpNode);
	self.levelUpBtn:setPosition(5 , -179);
	self.levelUpBtn:addClickEventListener(handler(self , self.levelUpBtnClick));

	self.levelUpBtnLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.levelUpBtnLabel:addTo(self.levelUpBtn);
	self.levelUpBtnLabel:setPosition(self.levelUpBtn:getContentSize().width/2 , self.levelUpBtn:getContentSize().height/2);
	self.levelUpBtnLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.levelUpBtnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

	self.levelUpBtnShader = cc.Sprite:create('image/commonImg/btn_black_1_219_55.png');
	self.levelUpBtnShader:addTo(self.levelUpNode);
	self.levelUpBtnShader:setPosition(5 , -179);
	self.levelUpBtnShader:setVisible(false);

	--[[
	self.leveUpTipsNode = cc.Node:create();
	self.leveUpTipsNode:addTo(self.levelUpNode);
	self.leveUpTipsNode:setPosition(0 , -244);
	local tipsLabel = cc.Label:createWithTTF(LANG.UI_L_11706 , fonts.FONT_SIYUAN , 20)
	:addTo(self.leveUpTipsNode)
	:setTextColor(cc.c3b(255,200,0))
	local tipsSpr = cc.Sprite:create('image/commonImg/tip_2.png')
	:addTo(self.leveUpTipsNode)
	:setPosition( -20-tipsLabel:getContentSize().width/2, 0 )
	]]

	self.breakOpenSkillNode = cc.Node:create();
	self.breakOpenSkillNode:addTo(self.levelUpNode);
	self.breakOpenSkillNode:setPosition(0 , -244);

	self.breakOpenSkillWarning = cc.Sprite:create('image/commonImg/tip_2.png');
	self.breakOpenSkillWarning:addTo(self.breakOpenSkillNode);

	self.breakOpenSkillLabel = cc.Label:createWithTTF(LANG.UI_CARD_26 , fonts.FONT_SIYUAN , 20);
	self.breakOpenSkillLabel:addTo(self.breakOpenSkillNode);
	self.breakOpenSkillLabel:setTextColor(cc.c3b(255,200,0));

	self.breakOpenSkillBg = cc.Sprite:create();
	self.breakOpenSkillBg:addTo(self.breakOpenSkillNode);
	self.breakOpenSkillBg:setScale(0.4);

	self.breakOpenSkillIcon = cc.Sprite:create();
	self.breakOpenSkillIcon:addTo(self.breakOpenSkillNode);
	self.breakOpenSkillIcon:setScale(0.4);

	self.breakOpenSkillName = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.breakOpenSkillName:addTo(self.breakOpenSkillNode);
	self.breakOpenSkillName:setTextColor(cc.c3b(255,200,0));

	--技能
	self.skillNode = cc.Node:create();
	self.skillNode:addTo(self.root);
	self.skillNode:setPosition(0 , -185);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.skillNode);
	bg:setPosition(0 , -4);
	bg:setCapInsets(cc.rect(11,4,18,21));
    bg:setContentSize(cc.size(604 , 514));

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.skillNode);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(582 , 105));
	bg:setPosition(0 , 190);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.skillNode);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(582 , 337));
	bg:setPosition(0 , -40);
	
	local skillTitle = cc.Sprite:create('image/commonImg/arrow_bg.png');
	skillTitle:addTo(self.skillNode);
	skillTitle:setPosition(-250 , 98);

	local skillTitleLabel = cc.Label:createWithTTF(LANG.UI_CARD_27 , fonts.FONT_SIYUAN , 23);
	skillTitleLabel:addTo(self.skillNode);
	skillTitleLabel:setPosition(-206 , 99);
	skillTitleLabel:setTextColor(cc.c3b(160 , 200 , 255));
	
	self.skillList = {};
	for i = 1 , 5 do
		self.skillList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.skillNode);
		node:setPosition(-222 + 111 * (i - 1) , 23);
        self.skillList[i].node = node;

		local skillTypeBg = ccui.Button:create();
		skillTypeBg:addTo(node);
		skillTypeBg:setTag(i);
		skillTypeBg:addClickEventListener(handler(self , self.skillClick));
		self.skillList[i].skillTypeBg = skillTypeBg

		local select = cc.Sprite:create('image/card/cardSkill/card_skill_5.png');
		select:addTo(node);
		self.skillList[i].select = select;

		local icon = cc.Sprite:create();
		icon:addTo(node);
		self.skillList[i].icon = icon;

		local lock = cc.Sprite:create('image/lock/lock_bg_2.png');
		lock:addTo(node);
		lock:setPosition(36 , 30);
		self.skillList[i].lock = lock;

		local empty = cc.Label:createWithTTF('EMPTY' , fonts.FONT_SIYUAN , 20);
		empty:addTo(node);
		empty:setTextColor(cc.c3b(130 , 130 , 130));
		self.skillList[i].empty = empty;
	end

	self.skillName = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.skillName:addTo(self.skillNode);
	self.skillName:setAnchorPoint(0 , 0.5);
	self.skillName:setPosition(-263 , -70);

	self.skillTypeNode = cc.Node:create();
	self.skillTypeNode:addTo(self.skillNode);
	self.skillTypeNode:setAnchorPoint(0 , 0.5);
	self.skillTypeNode:setPosition(-263 , -70);

	self.skillCdInfo = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.skillCdInfo:addTo(self.skillNode);
	self.skillCdInfo:setAnchorPoint(0,1);
	self.skillCdInfo:setPosition(-263 , -90);

	self.skillInfo = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.skillInfo:addTo(self.skillNode);
	self.skillInfo:setAnchorPoint(0 , 1);
	self.skillInfo:setPosition(-263 , -120);
	self.skillInfo:setContentSize(cc.size(532 , 0));
	self.skillInfo:setLineBreakWithoutSpace(true);
	self.skillInfo:setMaxLineWidth(532);
	self.skillInfo:setLineHeight(25);

	self.skillOpenWarning = cc.Sprite:create('image/commonImg/tip_2.png');
	self.skillOpenWarning:addTo(self.skillNode);
	self.skillOpenWarning:setPosition(-46 , -234);

	self.skillOpenBreakLevel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.skillOpenBreakLevel:addTo(self.skillNode);
	self.skillOpenBreakLevel:setPosition(-46 , -234);
	self.skillOpenBreakLevel:setTextColor(cc.c3b(255,200,0));

	self.skillOpenBreakImgNode = cc.Node:create();
	self.skillOpenBreakImgNode:addTo(self.skillNode);
	self.skillOpenBreakImgNode:setPosition(-46 , -234);

	self.skillOpenBreakLabel = cc.Label:createWithTTF(LANG.UI_CARD_51 , fonts.FONT_SIYUAN , 20);
	self.skillOpenBreakLabel:addTo(self.skillNode);
	self.skillOpenBreakLabel:setPosition(-46 , -234);
	self.skillOpenBreakLabel:setTextColor(cc.c3b(255,200,0));

	self.buffBtn = ccui.Button:create('image/card/cardSkill/card_skill_2.png');
	self.buffBtn:addTo(self.skillNode);
	self.buffBtn:setPosition(260 , -73);
	self.buffBtn:addClickEventListener(handler(self , self.buffBtnClick));


	--信息
	self.cardInfoNode = cc.Node:create();
	self.cardInfoNode:addTo(self.root);
	self.cardInfoNode:setPosition(0 , -185);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.cardInfoNode);
	bg:setPosition(0 , -74-17);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(604,334+35));
	
	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.cardInfoNode);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(582 , 65));
	bg:setPosition(0 , 50);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.cardInfoNode);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(582 , 236+35));
	bg:setPosition(0 , -110-17);

	-- local line = cc.Sprite:create('image/commonImg/line.png')
	-- 	:addTo(self.cardInfoNode)
	-- 	:setPosition(0,-43)

	-- local line = cc.Sprite:create('image/commonImg/line_v.png')
	-- 	:addTo(self.cardInfoNode)
	-- 	:setPosition(0,-68)

	-- local line = cc.Sprite:create('image/commonImg/line.png')
	-- 	:addTo(self.cardInfoNode)
	-- 	:setPosition(0,-93)

	local infoTitle = cc.Sprite:create('image/commonImg/arrow_bg.png');
	infoTitle:addTo(self.cardInfoNode);
	infoTitle:setPosition(-256 , -21);

	local infoTitleLabel = cc.Label:createWithTTF(LANG.UI_CARD_39 , fonts.FONT_SIYUAN , 23);
	infoTitleLabel:addTo(self.cardInfoNode);
	infoTitleLabel:setAnchorPoint(0 , 0.5);
	infoTitleLabel:setPosition(-232 , -21);
	infoTitleLabel:setTextColor(cc.c3b(160 , 200 , 255));

	self.cardInfoList = {};
	for i = 1 , 2 do

		local node = cc.Node:create();
		node:addTo(self.cardInfoNode);
		-- node:setPosition(i == 1 and -142 or 142 , -70);
		node:setPosition(-142 , -70-(i-1)*40);

		local bg = cc.Sprite:create('image/commonImg/arrow_2_bg.png');
		bg:addTo(node);
		bg:setPosition(-120 , 0);
	
		local label = cc.Label:createWithTTF(LANG.UI_CARD_INFO_LABEL[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setTextColor(cc.c4b(165 , 200 , 255 , 255));
		label:setPosition(-110 , 0);
		label:setAnchorPoint(0, 0.5)

		self.cardInfoList[i] = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
		self.cardInfoList[i]:addTo(node);
		self.cardInfoList[i]:setAnchorPoint(0,0.5);
		self.cardInfoList[i]:setPosition(123 , 0);
	end

	local bg = cc.Sprite:create('image/commonImg/arrow_2_bg.png');
	bg:addTo(self.cardInfoNode);
	bg:setPosition(-263 , -116-35);

	local label = cc.Label:createWithTTF(LANG.UI_CARD_29 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.cardInfoNode);
	label:setTextColor(cc.c4b(165 , 200 , 255 , 255));
	label:setPosition(-253 , -116-35);
	label:setAnchorPoint(0, 0.5);

	self.infoCareerView = ccui.ScrollView:create();
	self.infoCareerView:setTouchEnabled(true);
	self.infoCareerView:setBounceEnabled(true);
	self.infoCareerView:setDirection(ccui.ScrollViewDir.vertical);
	self.infoCareerView:setContentSize(cc.size(537 , 80));
	self.infoCareerView:setAnchorPoint(0.5, 0.5);
	self.infoCareerView:setPosition(0 , -176-35);
	self.infoCareerView:setScrollBarEnabled(false);
	self.infoCareerView:addTo(self.cardInfoNode);
	
	self.infoCareer = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.infoCareer:addTo(self.infoCareerView);
	self.infoCareer:setAnchorPoint(0 , 1);
	self.infoCareer:setContentSize(cc.size(537 , 80));
	self.infoCareer:setLineBreakWithoutSpace(true);
	self.infoCareer:setMaxLineWidth(537);
	self.infoCareer:setLineHeight(25);

	self.showCvBtn = ccui.Button:create('image/commonImg/btn_3_133_36.png' , 'image/commonImg/btn_3_133_36.png');
	self.showCvBtn:addTo(self.cardInfoNode);
	self.showCvBtn:setPosition(215 , -19);
	self.showCvBtn:addClickEventListener(function()
		AudioManager:playEffect(Conf.buttonClick);
		UIManager:push('CardCvPanel' , self.roleData.role_id);
	end);

	self.cardBtnList[3] = self.showCvBtn;

	local btnLabel = cc.Label:createWithTTF(LANG.UI_CARD_21 , fonts.FONT_SIYUAN , 17);
	btnLabel:addTo(self.showCvBtn);
	btnLabel:setPosition(self.showCvBtn:getContentSize().width/2 , self.showCvBtn:getContentSize().height/2);
	btnLabel:setTextColor(cc.c3b(60 , 60 , 60));
	btnLabel:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);


	--公共

	self.lineBlue = cc.Sprite:create('image/commonImg/line3.png')
		:addTo(self.root)

	self.defTypeNode = cc.Sprite:create('image/card/card_def_type_bg.png');
	self.defTypeNode:addTo(self.root); --card:260,63 skill:-260,23 info:-260,-137

	local size = self.defTypeNode:getContentSize();
	self.infoDefType = cc.Sprite:create();
	self.infoDefType:addTo(self.defTypeNode);
	self.infoDefType:setScale(0.65);
	self.infoDefType:setPosition(size.width/2 , size.height/2);

	self.infoQuality = cc.Sprite:create();
	self.infoQuality:addTo(self.root);
	self.infoQuality:setAnchorPoint(0 , 0.5);
	self.infoQuality:setPosition(-229,63); --card:-229,63 skill:-229,23 info:-229,-137

	self.starNode = cc.Node:create();
	self.starNode:addTo(self.root);
	self.starNode:setPosition(-122,63); --card:-122,63 skill:0,23

	self.starList = {};
	for i = 1 , 5 do
		local starBg = cc.Sprite:create('image/card/star_level_bg.png');
		starBg:addTo(self.starNode);
		starBg:setPosition(27 * (i - 1) , 0);

		self.starList[i] = cc.Sprite:create();
		self.starList[i]:addTo(self.starNode);
		self.starList[i]:setPosition(27 * (i - 1) , 0);
	end

	self.infoName = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.infoName:addTo(self.root);
	self.infoName:setAnchorPoint(0 , 0.5);
	self.infoName:setPosition(-230 , 2); --card:230,24 skill:-230,-13

	self.breakNode = cc.Node:create();
	self.breakNode:addTo(self.root);
	self.breakNode:setPosition(-221 , -31); --card:-217,-16 skill:88,-13

	self.curLevelNode = cc.Node:create();
	self.curLevelNode:addTo(self.root);
	self.curLevelNode:setPosition(153 , 23); --card:160,62 skill:115,27

	local label = cc.Label:createWithTTF(LANG.UI_CARD_38 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.curLevelNode);
	label:setPosition(-19 , 0);

	self.curLevel = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.curLevel:addTo(self.curLevelNode);
	self.curLevel:setPosition(23 , 0);

	self.jopTypeNode = cc.Sprite:create('image/card/card_job_bg_1.png');
	self.jopTypeNode:addTo(self.root);
	self.jopTypeNode:setPosition(-77 , 23); --card:-77,23 skill:-77,-13

	--local size = self.jopTypeNode:getContentSize();
	--self.jopTypeImg = cc.Sprite:create('image/card/card_job_bg.png');
	--self.jopTypeImg:addTo(self.jopTypeNode);
	--self.jopTypeImg:setPosition(size.width/2-21 , size.height/2);
--
	--self.jopType = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	--self.jopType:addTo(self.jopTypeNode);
	--self.jopType:enableOutline(cc.c3b(90 , 90 , 90),2);
	--self.jopType:setPosition(size.width/2+17 , size.height/2);


	EventManager:RegisterEvent(EventType.NetworkCardListRetLevelUp , handler(self, self.retLevelUp));
	EventManager:RegisterEvent(EventType.NetworkCardListRetLevelBreak , handler(self, self.retLevelBreak));
	EventManager:RegisterEvent(EventType.NetworkCardAvatarRetUse , handler(self, self.setCommonData));

	self:initSwitchNode();
end

function CardPanel:initSwitchNode()
	local switchNode = cc.Node:create()
	switchNode:addTo(self.root)
	switchNode:setPosition(0, 200)
	self.switchNode = switchNode;

	local leftBtn = ccui.Button:create('image/card/avatar_arr.png' , 'image/card/avatar_arr.png');
	leftBtn:addTo(switchNode);
	leftBtn:setAnchorPoint(cc.p(0, 0.5));
	leftBtn:setPosition(-StageSize.width/2 + 20 , 0);
	leftBtn:setScale(0.7);
	leftBtn:addClickEventListener(handler(self , self.leftBtnClick));

	local rightBtn = ccui.Button:create('image/card/avatar_arr.png' , 'image/card/avatar_arr.png');
	rightBtn:addTo(switchNode);
	rightBtn:setAnchorPoint(cc.p(0, 0.5));
	rightBtn:setRotation(180);
	rightBtn:setPosition(StageSize.width/2 - 20 , 0);
	rightBtn:setScale(0.7);
	rightBtn:addClickEventListener(handler(self , self.rightBtnClick));
end

function CardPanel:onEnter(pid, isFromeCardList, list)

	self.menuType = 1;
	if isFromeCardList==nil then
		self.isFromeCardList = true
	else
		self.isFromeCardList = isFromeCardList
	end 

	self.list = list;
	self.switchNode:setVisible(false)
	self.showIdx = 1;
	if self.list then
		self.switchNode:setVisible(true)
		for k,v in pairs(self.list) do
			if v.pid == pid then
				self.showIdx = k;
				break;
			end
		end
	end
	
	self.curPid = pid or self.curPid;
	local show = not model.CardModel:IsHaveLive2d(self.curPid)
	tools.RedDotTools:setRedDotToNode(self.cardBtnList[1],show,nil,cc.p(130,35))

	self:setCommonData();
	local tipAvatar = model.CardModel:IsHaveNewAvatar( self.roleData.role_id )
	tools.RedDotTools:setRedDotToNode(self.avartBtn,tipAvatar,nil,cc.p(40,40))

	self:switchPanel();
	--self:updateEquipWearRedDot();
	self:updateStarLevelUpRedDot();

	self.root:setVisible(true);
end

function CardPanel:leftBtnClick(sender , event)
	self.showIdx = self.showIdx-1;
	if self.showIdx<=0 then
		self.showIdx = #self.list;
	end
	self:updatePid( self.list[self.showIdx].pid );
end

function CardPanel:rightBtnClick(sender , event)
	self.showIdx = self.showIdx+1;
	if self.showIdx>#self.list then
		self.showIdx = 1;
	end
	self:updatePid( self.list[self.showIdx].pid );
end

function CardPanel:updatePid( pid )
	self.curPid = pid or self.curPid;
	self:onUpdateArgs(1, self.curPid)
	local show = not model.CardModel:IsHaveLive2d(self.curPid)
	tools.RedDotTools:setRedDotToNode(self.cardBtnList[1],show,nil,cc.p(130,35))

	self:setCommonData();
	local tipAvatar = model.CardModel:IsHaveNewAvatar( self.roleData.role_id )
	tools.RedDotTools:setRedDotToNode(self.avartBtn,tipAvatar,nil,cc.p(40,40))

	self:switchPanel();
	self:updateStarLevelUpRedDot();
end

function CardPanel:setCommonData()
	local card = model.CardModel:GetCard(self.curPid);
	local resId = model.CardModel:getCardResIdByPid(self.curPid);
	local imagePath = ResTable:getValue('role_resource', resId, 'card');
	self.roleData = ResTable:getRowData('role', card.no);
	self.roleInfoData = ResTable:getRowData('role_info', card.no);

	self.infoQuality:setTexture('image/card/card_quality_'..card.quality..'.png');

	self.qualityBg:setTexture('image/card/cardQualityBg/card_bg_quality_'..card.quality..'.png');
	self.cardPanelNavi:setTexture('image/role/'..imagePath..'.png');

	local rolePreData = ResTable:getRowData('role_pre', card.no);
	self.infoDefType:setTexture('image/commonImg/def_type_'..rolePreData.def_type..'.png');

	local color = math.ceil(card.star_lv / 5);
	local num = card.star_lv % 5;
	num = num == 0 and 5 or num;
	for i = 1 , 5 do
		if i <= num then
			self.starList[i]:setTexture('image/card/star_level_'..color..'.png');
		end
		self.starList[i]:setVisible(i <= num);
	end

	self.infoName:setString(tostring(self.roleInfoData.name));
	self.jopTypeNode:setTexture('image/card/card_job_bg_'..rolePreData.job_type..'.png');
	--self.jopType:setString(tostring(LANG.UI_CARD_JOB_TYPE[rolePreData.job_type]));

	self.swtichBtnList[2]:setVisible(card.quality > 3);

	self:updateVisible();
end

function CardPanel:updateVisible()
	local card = model.CardModel:GetCard(self.curPid);
	local posX = -280
	local posY = StageSize.height/2 - 220
	for i , node in ipairs(self.cardBtnList) do
		local visible = tools.ConfigStateTools:checkVisibleByType(Enum:getTable('ConfigStateType').CARD , i);
		if i == 1 then
			-- visible = visible and model.CardModel:isHaveAvatar(card.no);
		end
		self.cardBtnList[i]:setVisible(visible);
		if visible and i ~= 3 then
			self.cardBtnList[i]:setPosition( posX, posY )
			posY = posY - 60
		end
	end

	local haveBare = model.BareCollectModel:isHaveBare(card.no)

	self.bareBtn:setVisible(haveBare);
	if haveBare then
		self.bareBtn:setPosition( posX, posY )
		posY = posY - 60
	end
end

function CardPanel:swtichBtnClick(sender , event)
	local tag = sender:getTag();

	if tag == 2 then
		UIManager:set('CardLevelUpStarPanel', {'CardListPanel', 'CardLevelUpStarPanel'}, self.curPid)
	elseif tag == 1 then
		--local inTeam , pos = model.TeamModel:isRoleInTeam(self.curPid);
		--UIManager:push('EquipWearPanel' , 'CardPanel' , (pos ~= -1 and pos or nil));
	end
	AudioManager:playEffect(Conf.buttonClick);
end

function CardPanel:menuClick(sender , event)
	local menuType = sender:getTag();
	AudioManager:playEffect(Conf.buttonClick);
	if menuType == self.menuType then
		return;
	end

	self.menuType = menuType;

	self:switchPanel();
end

function CardPanel:switchPanel()

	for menuType , menu in pairs(self.menuList) do
		menu.unselectNode:setVisible(self.menuType ~= menuType);
		menu.selectNode:setVisible(self.menuType == menuType);
	end

	self.levelUpNode:setVisible(self.menuType == 1);
	self.skillNode:setVisible(self.menuType == 2);
	self.cardInfoNode:setVisible(self.menuType == 3);

	if self.menuType == 1 then
		self:showLevelUpNode();
	elseif self.menuType == 2 then
		self:showSkillNode();
	elseif self.menuType == 3 then
		self:showInfoNode();
	end
end

function CardPanel:showInfoNode()

	for i = 1 , 3 do 
		self.menuList[i].unselectNode:setPositionY(-70);
    	self.menuList[i].selectNode:setPositionY(-70);
	end
    
	self.curLevelNode:setVisible(false);
	self.breakNode:setVisible(false);
	self.jopTypeNode:setVisible(true);

	self.defTypeNode:setPosition(-260 , -137);
	self.infoQuality:setPosition(-229 , -137);
	self.lineBlue:setPosition(0,-150)
	self.starNode:setPosition(165 , -137);

	self.infoName:setPosition(self.infoQuality:getPositionX() + self.infoQuality:getContentSize().width + 10 , -139);
	self.jopTypeNode:setPosition(self.infoName:getPositionX() + self.infoName:getContentSize().width + 55 , -139);

	local pos = string.find(self.roleInfoData.birthday , "\\");
	local month = string.sub(self.roleInfoData.birthday , 1 , pos-1);
	local day = string.sub(self.roleInfoData.birthday , pos + 1 , #self.roleInfoData.birthday);

	self.cardInfoList[1]:setString(tostring(month..LANG.UI_CARD_40..day..LANG.UI_CARD_41));
	self.cardInfoList[2]:setString(tostring(self.roleInfoData.Like));

	self.infoCareer:setString(tostring(self.roleInfoData.Career));

	local height = self.infoCareer:getContentSize().height;
	height = height < 80 and 80 or height;
	self.infoCareerView:setInnerContainerSize(cc.size(537 ,height));
	self.infoCareerView:setTouchEnabled(height > 80);
	self.infoCareer:setPosition(0 , height);
end

function CardPanel:showSkillNode()

	for i = 1 , 3 do 
		self.menuList[i].unselectNode:setPositionY(90);
		self.menuList[i].selectNode:setPositionY(90);
	end

	self.curLevelNode:setVisible(true);
	self.breakNode:setVisible(true);
	self.jopTypeNode:setVisible(true);

	self.defTypeNode:setPosition(-260 , 23);
	self.infoQuality:setPosition(-229 , 23);
	self.lineBlue:setPosition(0,-30.5)
	self.curLevelNode:setPosition(115,27);
	self.infoName:setPosition(-230,-13);

	self.breakNode:setPosition(88,-13);
	self.starNode:setPosition(self.infoQuality:getPositionX() + self.infoQuality:getContentSize().width + 30 , 23);
	self.jopTypeNode:setPosition(self.infoName:getPositionX() + self.infoName:getContentSize().width + 55 , -13);

	local card = model.CardModel:GetCard(self.curPid);

	self.breakNode:removeAllChildren();

	local posX = 0;
	for i = 1 , 6 do
		local star = cc.Sprite:create('image/card/card_break_level_bg.png');
		star:addTo(self.breakNode);
		star:setPosition(posX , 0);
		if i <= card.break_lv then
			star = cc.Sprite:create('image/card/card_break_level.png');
			star:addTo(self.breakNode);
			star:setPosition(posX , 0);
		end

		posX = posX + 25;
	end
	

	self.skills = {};

	local skillId = model.CardModel:getCardSkillIdByPid(self.curPid);
	local roleSkill = ResTable:getRowData('role_skill' , skillId);
	
	local cardBreakAttributeTabelData = {};
	for _k , breakAttributeData in pairs(ResTable:getTable('role_grade').contain) do
		if breakAttributeData.skill_open and breakAttributeData.skill_open~= '' then
			if breakAttributeData.skill_open == 'skill3' then
				cardBreakAttributeTabelData[3] = breakAttributeData;
			elseif breakAttributeData.skill_open == 'skill4' then
				cardBreakAttributeTabelData[4] = breakAttributeData;
			elseif breakAttributeData.skill_open == 'skill5' then
				cardBreakAttributeTabelData[5] = breakAttributeData;
			end
		end
	end

	for i = 1 , 5 do
		self.skillList[i].lock:setVisible(false);
		self.skillList[i].icon:setVisible(false);
		self.skillList[i].empty:setVisible(false);
		if roleSkill['skill'..i..'_no'] and roleSkill['skill'..i..'_no'] ~= '' then
			if not self.skillList[i] then
				break;
			end

			local skillResid = roleSkill['skill'..i..'_no'];
			local skillData = ResTable:getRowData('skill', skillResid);

			self.skillList[i].skillTypeBg:loadTextures('image/card/cardSkill/card_skill_type_'..skillData.skill_type..'.png',
													'image/card/cardSkill/card_skill_type_'..skillData.skill_type..'.png');
	
			self.skillList[i].icon:setVisible(true);
			self.skillList[i].icon:setTexture('image/skillicon/'..skillData.icon..'.png');

			if i < 3 or card.break_lv >= cardBreakAttributeTabelData[i].grade then
				self.skillList[i].icon:setOpacity(255);
				self.skills[i] = {data = skillData , level = -1};
			else
				self.skillList[i].lock:setVisible(true);
				self.skillList[i].icon:setOpacity(125);
				self.skills[i] = {data = skillData , level = cardBreakAttributeTabelData[i].grade};
			end
		else
			self.skillList[i].empty:setVisible(true);
			self.skillList[i].skillTypeBg:loadTextures('image/card/cardSkill/card_skill_4.png','image/card/cardSkill/card_skill_4.png');
		end
	end

	self:updateSkillInfo(1);
end

function CardPanel:updateSkillInfo(pos)
	if self.skills[pos] then
		
		local showBuffBtn = false;
		if self.skills[pos].data.follow_result ~= '' and #self.skills[pos].data.follow_result > 0 then
			for _k , data in pairs(self.skills[pos].data.follow_result) do
				if data[1] == 1 then
					showBuffBtn = true;
					break;
				end
			end
		end
		if not showBuffBtn then
			if (self.skills[pos].data.buff ~= '' and #self.skills[pos].data.buff > 0) or 
				(self.skills[pos].data.buff_2 ~= '' and #self.skills[pos].data.buff_2 > 0) then
					showBuffBtn = true;
			end
		end

		self.buffBtn:setVisible(showBuffBtn);
		self.buffBtn:setTag(pos);

		for _k , skill in pairs(self.skillList) do
			skill.select:setVisible(_k == pos);
		end

		local skillData = self.skills[pos].data;

		self.skillName:setString(tostring(skillData.name));

		self.skillTypeNode:setPositionX(self.skillName:getPositionX() + self.skillName:getContentSize().width + 10)
		self.skillTypeNode:removeAllChildren();

		local skillType = skillData.show_type;
		for i = 1, #skillType do
			local sType = cc.Sprite:create('image/skill/skill_type_'..skillType[i]..'.png');
			sType:addTo(self.skillTypeNode);
			sType:setAnchorPoint(0 , 0.5);
			sType:setPosition(73 * (i - 1) , 0);
		end
		
		local formatStr , colorPos = formatColorText(skillData.info);

		self.skillInfo:setString(tostring(formatStr));

		local strLen = getStrLen(formatStr);

		for i = 0 , strLen-1 do
			local label = self.skillInfo:getLetter(i);
			if label then
				local changeColor = false
				for _k , pos in pairs(colorPos) do
					if i >= pos.sPos-1 and i <= pos.ePos-1 then
						label:setColor(cc.c3b(pos.color[1] , pos.color[2] , pos.color[3]));
						changeColor = true;
						break;
					end
				end
				if not changeColor then
					label:setColor(cc.c3b(255 , 255 , 255));
				end
			end
		end

		--[[
		if tonumber(skillData.pre_cd) < 1 and skillData.cd == 0 then
			self.skillCdInfo:setString(LANG.UI_CARD_53);
		elseif tonumber(skillData.pre_cd) > 1 and skillData.cd == 0 then
			self.skillCdInfo:setString(LANG.UI_CARD_54..tostring(skillData.pre_cd)..LANG.UI_CARD_55..'，'..LANG.UI_CARD_53);
		elseif tonumber(skillData.pre_cd) < 1 and skillData.cd ~= 0 then
			self.skillCdInfo:setString(LANG.UI_CARD_58..'，'..LANG.UI_CARD_56..tostring(skillData.cd)..LANG.UI_CARD_57);
		else
			self.skillCdInfo:setString(LANG.UI_CARD_54..tostring(skillData.pre_cd)..LANG.UI_CARD_55..'，'..LANG.UI_CARD_56..tostring(skillData.cd)..LANG.UI_CARD_57);
		end
		]]

		if skillData.cd ~= 0 then
			self.skillCdInfo:setString(LANG.UI_CARD_56..tostring(skillData.cd)..LANG.UI_CARD_57);
		else
			self.skillCdInfo:setString(LANG.UI_CARD_53);
		end

		local breakImgWidth = 0;
		local breakLabelWidth = 0;
		if self.skills[pos].level == -1 then
			self.skillOpenBreakLevel:setString(LANG.UI_CARD_42);
		else
			self.skillOpenBreakLevel:setString(LANG.UI_CARD_43);
			breakLabelWidth = self.skillOpenBreakLabel:getContentSize().width;

			self.skillOpenBreakImgNode:removeAllChildren();
			for i = 1 , self.skills[pos].level do
				local breakImg = cc.Sprite:create('image/card/card_break_level.png');
				breakImg:addTo(self.skillOpenBreakImgNode);
				breakImg:setPosition(25 * (i - 1) , 0);
				breakImgWidth = breakImgWidth + 25;
			end
		end
		
		local width = self.skillOpenWarning:getContentSize().width;
		local breakLevelWidth = self.skillOpenBreakLevel:getContentSize().width;
		local posX = -(breakLevelWidth + breakLabelWidth + breakImgWidth) / 2;
		self.skillOpenWarning:setPositionX(posX);
		self.skillOpenBreakLevel:setPositionX(posX + width / 2 + breakLevelWidth / 2);
		
		if self.skills[pos].level ~= -1 then

			self.skillOpenBreakImgNode:setPositionX(posX + width / 2 + breakLevelWidth + 12.5);
			self.skillOpenBreakLabel:setPositionX(posX + width / 2 + breakLevelWidth + breakImgWidth + breakLabelWidth / 2);
			self.skillOpenBreakImgNode:setVisible(true);
			self.skillOpenBreakLabel:setVisible(true);
		else
			self.skillOpenBreakImgNode:setVisible(false);
			self.skillOpenBreakLabel:setVisible(false);
		end
	end
end

function CardPanel:buffBtnClick(sender , event)
	local tag = sender:getTag();

	if self.skills[tag] then
		UIManager:push('SkillBuffPanel' , self.skills[tag].data);
	end
end

function CardPanel:skillClick(sender , event)
	local pos = sender:getTag();
	AudioManager:playEffect(Conf.confirmButton);
	self:updateSkillInfo(pos);
end

function CardPanel:setAttState(state)
	for i = 1 , 3 do
		self.attributeList[i].bg:setVisible(state);
		self.attributeList[i].nextValue:setVisible(state);
		self.attributeList[i].curValue:setPositionX(state and curValuePosX[i][1] or curValuePosX[i][2]);
	end
end

function CardPanel:showLevelUpNode()

	for i = 1 , 3 do 
		self.menuList[i].unselectNode:setPositionY(131);
		self.menuList[i].selectNode:setPositionY(131);
	end

	self.breakNode:setVisible(true);
	self.jopTypeNode:setVisible(true);
	self.curLevelNode:setVisible(true);
	self.nextMaxNode:setVisible(false);
	self.breakOpenSkillNode:setVisible(false);
	self.levelUpBtnShader:setVisible(false);
	self.levelUpBtn:setTouchEnabled(true);
	self.addBtn:setVisible(false);
	self.itemCostNode:setVisible(true);
	self.coinCostNode:setVisible(true);

	self.defTypeNode:setPosition(-260,63);
	self.infoQuality:setPosition(-229,63);
	self.infoName:setPosition(-230,24);
	self.breakNode:setPosition(-217,-16);
	self.breakOpenSkillNode:setPosition(0 , -244);
	self.lineBlue:setPosition(0,-149)

	self.curLevel:setTextColor(cc.c3b(255,255,255));

	self.jopTypeNode:setPosition(self.infoName:getPositionX() + self.infoName:getContentSize().width + 57 , 23);
	self.starNode:setPosition(self.infoQuality:getPositionX() + self.infoQuality:getContentSize().width + 30 , 63);

	local pro = CardProManager:GetCardPro(self.curPid);

	self.attributeList[1].curValue:setString(tostring(pro.fp));
	self.attributeList[2].curValue:setString(tostring(pro.hp));
	self.attributeList[3].curValue:setString(tostring(pro.atk));
	--self.attributeList[4].curValue:setString(tostring(pro.def));

	local card = model.CardModel:GetCard(self.curPid);
	self.curLevel:setString(tostring(card.level));

	self.breakNode:removeAllChildren();
	local posX = 0;
	for i = 1 , 6 do
		local star = cc.Sprite:create('image/card/card_break_level_bg.png');
		star:addTo(self.breakNode);
		star:setPosition(posX , 0);
		if i <= card.break_lv then
			star = cc.Sprite:create('image/card/card_break_level.png');
			star:addTo(self.breakNode);
			star:setPosition(posX , 0);
		end
		posX = posX + 25;
	end
	

	local levelUpBtnRedDot = false;

	local curBreakData = model.CardModel:getCardBreakTableData(card.break_lv);
	local nextBreakData = model.CardModel:getCardBreakTableData(card.break_lv+1);
	local maxLevel = 0;
	if curBreakData then
		maxLevel = curBreakData.lv_limit;
	else
		maxLevel = nextBreakData.lv_needed;
	end

	local levelUpType = 0;--升至最高等级
	if model.CardModel:isFutureCard(self.curPid) then
		levelUpType = 4;--共鸣水晶中
	else
		if card.break_lv < 6 then
			if nextBreakData and card.level >= nextBreakData.lv_needed and card.level <= nextBreakData.lv_limit then
				if card.star_lv < nextBreakData.star_needed then
					if card.quality < 4 or
					  (card.quality < 5 and card.star_lv >= CARD_STAR_SSR_MAX_LEVEL) or
					  (card.quality >= 5 and card.star_lv >= CARD_STAR_MAX_LEVEL) then
						levelUpType = 0;--升至最高等级
					else
						levelUpType = 3;--升星
					end
				else
					levelUpType = 2;--突破
				end
			else
				if card.level < maxLevel then
					levelUpType = 1;--升级
				end
			end
		else
			if card.level < maxLevel then
				levelUpType = 1;--升级
			elseif nextBreakData and card.star_lv < nextBreakData.star_needed then
				if card.quality < 4 or
				  (card.quality < 5 and card.star_lv >= CARD_STAR_SSR_MAX_LEVEL) or 
				  (card.quality >= 5 and card.star_lv >= CARD_STAR_MAX_LEVEL) then
					levelUpType = 0;--升至最高等级
				else
					levelUpType = 3;--升星
				end
			end
		end
	end

	self.maxLevel:setString('MAX:'..tostring(maxLevel));

	if levelUpType == 1 then --升级
		self:setAttState(true);
		self.nextLevelNode:setVisible(true);
		self.curLevelNode:setPosition(126,62);
		self.maxLevel:setPositionX(160);

		local itemIcon = ResTable:getValue('item' , CARD_LEVEL_UP_EXP , 'icon');
		self.itemCost[1].icon:setTexture('image/icon/I'..itemIcon..'.png');
		self.itemCost[2].icon:setTexture('image/icon/I'..itemIcon..'.png');
		self.levelUpBtn:setTag(1);

		local haveExpNum = model.ItemModel:getItemNum(CARD_LEVEL_UP_EXP);
		local maxUpLevel = card.level + 5 > maxLevel and maxLevel or card.level + 5;
		
		local costGoldTotal = '0';
		local curCostGoldTotal = '0';
		local costExpTotal = 0;
		local curCostExpTotal = 0;
		local nextLevel = card.level;
		for i=card.level+1, maxUpLevel do
			local cost = ResTable:getMultiValue('role_lv', card.no, i);
			curCostGoldTotal = HpPlus(ConvertDigitUnitToStr(curCostGoldTotal) , ConvertDigitUnitToStr(cost.cost))
			curCostExpTotal = curCostExpTotal + cost.exp;
			if not model.MoneyModel:isEnough(curCostGoldTotal) then
				break;
			end
			if haveExpNum < curCostExpTotal then
				break;
			end
			nextLevel = i;
			costGoldTotal = curCostGoldTotal;
			costExpTotal = curCostExpTotal;
		end
	
		if nextLevel == card.level then
			self.levelUpBtnShader:setVisible(true);
			self.levelUpBtn:setTouchEnabled(false);

			local costEnough = haveExpNum >= curCostExpTotal;
			self.addBtn:setVisible(not costEnough);
			self.itemCost[1].cost:setPositionX(costEnough and 117 or 75);
			self.itemCost[2].cost:setString(tostring(curCostExpTotal));
			self.itemCost[1].cost:setTextColor(costEnough and cc.c3b(255 , 255 , 255) or cc.c3b(255,0,0));
			self.cost:setTextColor(model.MoneyModel:isEnough(curCostGoldTotal) and cc.c3b(255 , 255 , 255) or cc.c3b(255,0,0));
			self.cost:setString(ConvertStrToDigitUnit(tostring(curCostGoldTotal)));
			self.levelUpBtnLabel:setString(LANG.UI_CARD_45);
			nextLevel = nextLevel + 1;
		else
			levelUpBtnRedDot = true;
			self.cost:setTextColor(cc.c3b(255 , 255 , 255));
			self.cost:setString(ConvertStrToDigitUnit(tostring(costGoldTotal)));
			self.itemCost[1].cost:setPositionX(117);
			self.itemCost[1].cost:setTextColor(cc.c3b(255 , 255 , 255));
			self.itemCost[2].cost:setString(tostring(costExpTotal));
			self.levelUpBtnLabel:setString(string.format(LANG.UI_CARD_33,(nextLevel-card.level)));
		end

		self.nextLevel:setString(tostring(nextLevel));
		self.itemCost[1].cost:setString(tostring(haveExpNum));
		
		local nextPro = CardProManager:genPro(card , nil , nil , nextLevel);
		self.attributeList[1].nextValue:setString(tostring(nextPro.fp));
		self.attributeList[2].nextValue:setString(tostring(nextPro.hp));
		self.attributeList[3].nextValue:setString(tostring(nextPro.atk));

	elseif levelUpType == 2 then --突破

		local itemIcon = ResTable:getValue('item' , BREAK_MONEY , 'icon');
		self.itemCost[1].icon:setTexture('image/icon/I'..itemIcon..'.png');
		self.itemCost[2].icon:setTexture('image/icon/I'..itemIcon..'.png');

		self:setAttState(true);
		self.nextLevelNode:setVisible(false);
		self.nextMaxNode:setVisible(true);

		self.maxLevel:setPositionX(128);
		self.curLevelNode:setPosition(160 , 62);

		self.levelUpBtn:setTag(2);
		self.levelUpBtnLabel:setString(LANG.UI_CARD_31);
		self.nextMaxLevel:setString(tostring(nextBreakData.lv_limit));

		local breakImg = cc.Sprite:create('image/commonImg/arrow_1_bg.png');
		breakImg:addTo(self.breakNode);
		breakImg:setPosition(posX  , 0);
		posX = posX + 25;
		for i = 1 , 6 do
			local star = cc.Sprite:create('image/card/card_break_level_light_bg.png');
			star:addTo(self.breakNode);
			star:setPosition(posX , 0);
			if i <= (card.break_lv+1) then
				star = cc.Sprite:create('image/card/card_break_level.png');
				star:addTo(self.breakNode);
				star:setPosition(posX , 0);
			end
			posX = posX + 25;
		end
		local nextPro = CardProManager:genPro(card , nil ,card.break_lv+1);
		self.attributeList[1].nextValue:setString(tostring(nextPro.fp));
		self.attributeList[2].nextValue:setString(tostring(nextPro.hp));
		self.attributeList[3].nextValue:setString(tostring(nextPro.atk));
		
		local itemNum = model.ItemModel:getItemNum(BREAK_MONEY);
		local isCoinEnough = model.MoneyModel:isEnough(tostring(nextBreakData.coin_cost))
		local isItemEnough = itemNum >= nextBreakData.item_cost
		self.addBtn:setVisible(not isItemEnough);
		self.itemCost[1].cost:setString(tostring(itemNum));
		self.itemCost[1].cost:setPositionX(isItemEnough and 117 or 75);
		self.itemCost[1].cost:setTextColor(isItemEnough and cc.c3b(255 , 255 , 255) or cc.c3b(255,0,0));
		self.itemCost[2].cost:setString(tostring(nextBreakData.item_cost));
		self.cost:setString(tostring(nextBreakData.coin_cost));
		self.cost:setTextColor(isCoinEnough and cc.c3b(255 , 255 , 255) or cc.c3b(255,0,0));
		
		if isCoinEnough and isItemEnough then
			local inTeam , pos = model.TeamModel:isRoleInTeam(self.curPid);
			levelUpBtnRedDot = inTeam;
			self.levelUpBtnShader:setVisible(false);
			self.levelUpBtn:setTouchEnabled(true);
		else
			self.levelUpBtnShader:setVisible(true);
			self.levelUpBtn:setTouchEnabled(false);
		end
		
		if nextBreakData.skill_open and nextBreakData.skill_open ~= '' then
			local skillId = model.CardModel:getCardSkillIdByPid(self.curPid);
			local roleSkillData = ResTable:getRowData('role_skill' , skillId);
			if roleSkillData[tostring(nextBreakData.skill_open)..'_no'] then
			
				self.breakOpenSkillNode:setVisible(true);
				self.breakOpenSkillBg:setVisible(true);
				self.breakOpenSkillIcon:setVisible(true);
				self.breakOpenSkillName:setVisible(true);
				self.breakOpenSkillLabel:setString(LANG.UI_CARD_26);
			
				local skillId = roleSkillData[tostring(nextBreakData.skill_open)..'_no'];
				local skillData = ResTable:getRowData('skill' , skillId);
			
				self.breakOpenSkillBg:setTexture(cardSkillImagePath..'card_skill_type_'..skillData.skill_type..'.png');
				self.breakOpenSkillIcon:setTexture('image/skillicon/'..skillData.icon..'.png');
				self.breakOpenSkillName:setString(tostring(skillData.name));
				local width = self.breakOpenSkillWarning:getContentSize().width;
				local labelWidth = self.breakOpenSkillLabel:getContentSize().width;
				local iconWidth = self.breakOpenSkillIcon:getBoundingBox().width;
				local nameWidh = self.breakOpenSkillName:getContentSize().width;
				local _x = -(labelWidth + iconWidth + nameWidh)/2;
				self.breakOpenSkillWarning:setPositionX(_x);
				self.breakOpenSkillLabel:setPositionX(_x + width / 2 + labelWidth / 2);
				self.breakOpenSkillBg:setPositionX(_x + width / 2 + labelWidth + iconWidth / 2);
				self.breakOpenSkillIcon:setPositionX(_x + width / 2 + labelWidth + iconWidth / 2);
				self.breakOpenSkillName:setPositionX(_x + width / 2 + labelWidth + iconWidth + nameWidh/ 2);
			end
		end
	elseif levelUpType == 3 then --升星
		self:setAttState(false);
		self.nextLevelNode:setVisible(false);
		self.breakOpenSkillNode:setVisible(true);
		self.breakOpenSkillBg:setVisible(false);
		self.breakOpenSkillIcon:setVisible(false);
		self.breakOpenSkillName:setVisible(false);
		self.itemCostNode:setVisible(false);
		self.coinCostNode:setVisible(false);

		self.maxLevel:setPositionX(160);
		self.curLevelNode:setPosition(160 , 62);
		self.breakOpenSkillNode:setPosition(0 , -84);

		self.levelUpBtn:setTag(3);
		self.levelUpBtnLabel:setString(tostring(LANG.UI_CARD_65));--前往升星
		self.breakOpenSkillLabel:setString(tostring(LANG.UI_CARD_49));--为角色升星以提升等级上限

		local width = self.breakOpenSkillWarning:getContentSize().width;
		local labelWidth = self.breakOpenSkillLabel:getContentSize().width;
		local _x = -labelWidth/2;
		self.breakOpenSkillWarning:setPositionX(_x);
		self.breakOpenSkillLabel:setPositionX(_x + width / 2 + labelWidth / 2);
	else
		self:setAttState(false);
		self.nextLevelNode:setVisible(false);
		self.breakOpenSkillNode:setVisible(true);
		self.breakOpenSkillBg:setVisible(false);
		self.breakOpenSkillIcon:setVisible(false);
		self.breakOpenSkillName:setVisible(false);
		self.levelUpBtnShader:setVisible(true);
		self.levelUpBtn:setTouchEnabled(false);

		self.curLevelNode:setPosition(160 , 62);
		self.maxLevel:setPositionX(160);

		local itemIcon = ResTable:getValue('item' , CARD_LEVEL_UP_EXP , 'icon');
		local haveExpNum = model.ItemModel:getItemNum(CARD_LEVEL_UP_EXP);

		self.cost:setTextColor(cc.c3b(255 , 255 , 255));
		self.cost:setString('-');
		self.itemCost[1].cost:setString(tostring(haveExpNum));
		self.itemCost[1].icon:setTexture('image/icon/I'..itemIcon..'.png');
		self.itemCost[2].icon:setTexture('image/icon/I'..itemIcon..'.png');
		self.itemCost[2].cost:setString('-');
		self.itemCost[1].cost:setTextColor(cc.c3b(255 , 255 , 255));
		self.levelUpBtnLabel:setString(LANG.UI_CARD_45);

		if levelUpType == 4 then --共鸣水晶
			self.breakOpenSkillLabel:setString(LANG.UI_L_11706);
		else
			self.breakOpenSkillLabel:setString(LANG.UI_CARD_50);
		end

		local width = self.breakOpenSkillWarning:getContentSize().width;
		local labelWidth = self.breakOpenSkillLabel:getContentSize().width;
		local _x = -labelWidth/2;
		self.breakOpenSkillWarning:setPositionX(_x);
		self.breakOpenSkillLabel:setPositionX(_x + width / 2 + labelWidth / 2);
	end

	tools.RedDotTools:setRedDotToNode(self.levelUpBtn,levelUpBtnRedDot,nil,cc.p(209 , 45));
end

function CardPanel:updateStarLevelUpRedDot()
	local isEnough = model.CardModel:getCardStarActiveState(self.curPid);
	tools.RedDotTools:setRedDotToNode(self.swtichBtnList[2],isEnough,nil,cc.p(120 , 33));
end

function CardPanel:levelUpBtnClick(sender , event)
	local tag = sender:getTag();
	local card = model.CardModel:GetCard(self.curPid);

	if tag == 3 then
		UIManager:set('CardLevelUpStarPanel', {'CardListPanel', 'CardLevelUpStarPanel'}, self.curPid)
	elseif tag == 2 then
		local nextBreakData = model.CardModel:getCardBreakTableData(card.break_lv+1);
		if nextBreakData then
			if card.level >= nextBreakData.lv_needed and card.level <= nextBreakData.lv_limit then
				if card.star_lv >= nextBreakData.star_needed then
					local msg = {};
					msg.pid = self.curPid;
					Network.NetworkManager:Send(Network.NetworkCmdType.req_card_break , msg);
				else
					Prompt:Show(LANG.UI_CARD_34);
				end
				return;
			end
		else
			local breakData = model.CardModel:getCardBreakTableData(card.break_lv);
			if breakData then
				if card.level >= nextBreakData.lv_limit then
					Prompt:Show(LANG.UI_CARD_35);
					return;
				end
			end
		end
	else
		local maxLevel = 0;
		if card.break_lv == 0 then
			local curBreakData = model.CardModel:getCardBreakTableData(card.break_lv + 1);
			maxLevel = curBreakData.lv_needed;
		else
			local curBreakData = model.CardModel:getCardBreakTableData(card.break_lv);
			maxLevel = curBreakData.lv_limit;
		end
		
		if card.level >= maxLevel then
			Prompt:Show(LANG.UI_CARD_36);
		else
			local lvUpData = ResTable:getMultiValue('role_lv', card.no, card.level)
			if lvUpData then
				if model.MoneyModel:isEnough(lvUpData.cost) then
					local pro = CardProManager:GetCardPro(self.curPid);
					local msg = {};
					msg.pid = self.curPid;
					Network.NetworkManager:Send(Network.NetworkCmdType.req_card_level_up , msg);
				else
					Prompt:Show(LANG.UI_CARD_37);
				end
			end
		end
	end
end

function CardPanel:retLevelUp(msg)
	self:showLevelUpNode();
	AudioManager:playEffect(Conf.cardHeroLevelUp);
end

function CardPanel:retLevelBreak()
	self:showLevelUpNode();
	AudioManager:playEffect(Conf.cardHeroLevelUp);
end

function CardPanel:showGoToBreakAnimation()
end

function CardPanel:soundClick(sender, event)
	local index = sender:getTag();
	for _k , sound in pairs(self.soundList) do
		sound:soundStop();
	end
	self.soundList[index]:soundStart();
end

function CardPanel:addBtnClick()
	UIManager:push('ShopPanel');
end

function CardPanel:onClickBack()
	if self.isFromeCardList then
		EventManager:FireEvent(EventType.UIUpdateCardLevelUpList , self.curPid);
	end
	UIManager:pop('CardPanel');
end

function CardPanel:onLeave()
	self.root:setVisible(false);
end

function CardPanel:guideLevelUpBtnClick( isEnd)

	local node = cc.Node:create();
	local tag = 1;
	node:setTag(tag);
	self:levelUpBtnClick(node);
	if isEnd == 1 then
		self.root:runAction(cc.Sequence:create(
			cc.DelayTime:create(0.2),
			cc.CallFunc:create(function (  )
				self:onClickBack()
			end )
		))
	end

end

function CardPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 19 or guideNo == 20 then
		local btn = self.levelUpBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return CardPanel;
