local CardResolveRewardPanel = class("CardResolveRewardPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")

function CardResolveRewardPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CardResolveRewardPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function CardResolveRewardPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
	  self.curBuyCount = 0;
      self:InitPanels();
end

function CardResolveRewardPanel:InitPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(604,525));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 33);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_CARD_RESOLVE_9 , 604 , 46 , LANG.UI_CARD_RESOLVE_10);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 318);

	self.title = titleNode:getChildByName('title');

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , 187);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(550 , 161));

	local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	arrow:addTo(self.root);
    arrow:setPosition(-238,235);

	self.resolveLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 23);
	self.resolveLabel:addTo(self.root);
	self.resolveLabel:setAnchorPoint(0 , 0.5);
	self.resolveLabel:setPosition(-216 , 235);
	self.resolveLabel:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	self.scorllview = ccui.ScrollView:create();
	self.scorllview:setTouchEnabled(true);
	self.scorllview:setBounceEnabled(true);
	self.scorllview:setDirection(ccui.ScrollViewDir.vertical);
	self.scorllview:setContentSize(cc.size(550 , 100));
	self.scorllview:setAnchorPoint(cc.p(0,0));
	self.scorllview:setScrollBarEnabled(false);
    self.scorllview:setPosition(-275 , 120);
    self.scorllview:addTo(self.root);

	self.nameNode = cc.Node:create()
	self.nameNode:addTo(self.scorllview)
	self.nameNode:setPosition(275, 0)

	self.nameList = {};
	for i = 1 , 15 do
		
		self.nameList[i] = {};

		local row = math.ceil(i/3);
		local col = i%3;
		col = col == 0 and 3 or col;

		local node = cc.Node:create();
		node:addTo(self.nameNode);
		node:setPosition(-180 + 180*(col-1) , -20 - 48*(row-1));
		self.nameList[i].node = node;

		local nameBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
		nameBg:addTo(node);
    	nameBg:setCapInsets(cc.rect(11,11,34,28));
		nameBg:setContentSize(cc.size(172 , 32));

		local name = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN, 16);
		name:addTo(node);
		self.nameList[i].name = name;
	end

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , -15);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(550 , 209));

	local line = cc.Sprite:create('image/commonImg/line.png');
    line:addTo(self.root);
	line:setContentSize(cc.size(549,1))
	line:setPosition(cc.p(0,35))

	local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	arrow:addTo(self.root);
    arrow:setPosition(-238,59);

	local label = cc.Label:createWithTTF(LANG.UI_CARD_RESOLVE_15 , fonts.FONT_SIYUAN , 23);
	label:addTo(self.root);
	label:setAnchorPoint(0 , 0.5);
	label:setPosition(-216 , 59);
	label:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	self.dropListView = ccui.ListView:create();
	self.dropListView:setTouchEnabled(true);
	self.dropListView:setBounceEnabled(true);
	self.dropListView:setDirection(ccui.ScrollViewDir.horizontal);
	self.dropListView:setContentSize(cc.size(480, 110));
	self.dropListView:setAnchorPoint(0.5 , 0.5);
	self.dropListView:setPosition(0, -41);
	self.dropListView:setScrollBarEnabled(false);
	self.dropListView:addTo(self.root);
	self.dropListView:setItemsMargin(22);

	local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)

	self.getBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png','image/commonImg/btn_1_219_55.png');
	self.getBtn:setPosition(0, -171);
	self.getBtn:setTitleLabel(label);
	self.getBtn:addClickEventListener(function()
		UIManager:pop('CardResolveRewardPanel');
	end);
	self.getBtn:addTo(self.root);
end

function CardResolveRewardPanel:onEnter(msg , resolveType)

	self:addSwallowCallback(handler(self , self.onClickBack));

	if resolveType == 1 then
		self.title:setString(tostring(LANG.UI_CARD_RESOLVE_9));
		self.resolveLabel:setString(tostring(LANG.UI_CARD_RESOLVE_13));
	else 
		self.title:setString(tostring(LANG.UI_CARD_RESOLVE_11));
		self.resolveLabel:setString(tostring(LANG.UI_CARD_RESOLVE_14));
	end

	for i = 1 , 15 do
		self.nameList[i].node:setVisible(false);
	end

	local totalNum = 0
	if msg.cardNos then
		for _k , no in pairs(msg.cardNos) do
			local name = ResTable:getValue('role_info', no,'name');
			self.nameList[_k].node:setVisible(true);
			self.nameList[_k].name:setString(tostring(name));
			totalNum = totalNum + 1
		end
	end

	local totalH = 100
	if totalNum > 6 then
		totalH = totalH + math.ceil((totalNum-6)/3)*48;
	end
	self.scorllview:setInnerContainerSize(cc.size(550, totalH));
	self.nameNode:setPosition(275, totalH)
	if totalNum > 6 then
		self.scorllview:setTouchEnabled(true);
		self.scorllview:jumpToPercentVertical( 0 );
	else
		self.scorllview:setTouchEnabled(false);
	end

	self.dropListView:removeAllChildren()
	
	local money = msg.money 
	if money ~= nil and  money.change and string.find(money.change , '-') == nil then

		local layout = ccui.Layout:create();
		layout:setContentSize(cc.size(103,103))
		local icon = template.ItemTemplate:create(2);
		icon:addTo(layout);
		icon:Init(MONEY_ID, money.change);
		icon:setPosition(51.5, 51.5)
		self.dropListView:pushBackCustomItem(layout)
	end

	if msg.itemChange then
		local items = {};
		for k, v in ipairs(msg.itemChange) do
			if tonumber(v.addNum) > 0  then
				if not items[v.no] then
					items[v.no] = 0;
				end
				items[v.no] = items[v.no] + v.addNum;
			end
		end
		for k, v in pairs(items) do
			local layout = ccui.Layout:create();
			layout:setContentSize(cc.size(103,103))
			local icon = template.ItemTemplate:create(2);
			icon:addTo(layout);
			icon:Init(k, v);
			icon:setPosition(51.5, 51.5)
			self.dropListView:pushBackCustomItem(layout)
		end
	end

	self.root:setVisible(true);
end

function CardResolveRewardPanel:onLeave()
	self.root:setVisible(false);
end

function CardResolveRewardPanel:onClickBack()
	UIManager:pop('CardResolveRewardPanel');
end

return CardResolveRewardPanel;
