local ComTaskPanel = class('ComTaskPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/activity/three_day/'

function ComTaskPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ComTaskPanel');

	self.useCCreator = false;
    self.isPopup = true;

end

function ComTaskPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel();
end


function ComTaskPanel:initPanel(  )
    local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
    :addTo(self.root)
    :setScale9Enabled(true)
    :setContentSize(cc.size(604, 850))
    :setTouchEnabled(true);

    GlobalFunctions:createTitleNode( bg, LANG.UI_EVENT_2, '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );

    local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
    bg:addTo(self.root);
    bg:setCapInsets(cc.rect(11,11,34,28));
    bg:setContentSize(cc.size(582 , 680));
    bg:setPosition(0, 10)

    local initData = {
        width = 564,
        height = 660,
        cellWidth = 564,
        cellHeight = 132,
        cellReloadFunc = handler(self,self.reloadCell),
        cellTouchFunc = handler(self,self.cellItemTouch) ,
    }
    
    self.tableView = template.TableViewTemplate:create()
    self.tableView:initWithSizeAndItem(initData) ;
    self.tableView:getView():setPosition(cc.p(-282,-320));
    self.tableView:getView():addTo(self.root)

	local oneKeyLabel = cc.Label:createWithTTF(LANG.UI_ROUND_15 , fonts.FONT_SIYUAN , 20);
	oneKeyLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	self.oneKeyBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.oneKeyBtn:addTo(self.root);
	self.oneKeyBtn:setTitleLabel(oneKeyLabel);
	self.oneKeyBtn:setPosition(0 , -375);
	self.oneKeyBtn:addClickEventListener(handler(self , self.getReward));

    EventManager:RegisterEvent('OneKeyGetReward',handler(self,self.OneKeyGetReward));
end

function ComTaskPanel:onEnter(season_id)
	self.season_id = season_id;
    self:addSwallowCallback(handler(self , self.onClickBack));
    self:onShow();
    self.root:setVisible(true);
end

function ComTaskPanel:onShow()
    self.dataList = {}
    local tmpData = model.RoundModel:getRoundMissionById( self.season_id );
    if not tmpData then
    	return;
    end

	self.dataList = tmpData.round_bank_missions;
	table.sort( self.dataList, function(first , second)
		return first.no < second.no;
	end )
	self.tableView:reloadData(self.dataList);

end

function ComTaskPanel:reloadCell(cell , idx)
    if self.dataList[idx + 1] then
        local child = cell:getChildByTag(999);
        if not child then
            child = template.CommonTaskCell:create();
            child:addTo(cell);
            child:setPosition(282 , 65.5);
            child:addBtnClickEventListener(handler(self , self.rewardClick))
            child:setTag(999);
        end
        local task = self.dataList[idx + 1];
        child:Init(task.no, 'round_bank_mission', task);
        child:setBtnTag(task.no);
    end
    
    return cell;
end

function ComTaskPanel:rewardClick(no, idxBtn)
    local msg = {};
    msg.season_id = self.season_id;
    msg.mission_id = no;
    msg.tag = 1;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_round_mission_item_rwd, msg);
end

function ComTaskPanel:cellItemTouch( table,cell )
	local tag = cell:getTag()
end

function ComTaskPanel:getReward(sender , event)
	local msg = {};
    msg.season_id = self.season_id;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_round_mission_rwd, msg);
end

function ComTaskPanel:OneKeyGetReward()
    self:onShow();
end

function ComTaskPanel:onLeave()
    self.root:setVisible(false);
end
function ComTaskPanel:onClickBack()
    UIManager:pop('ComTaskPanel');
end

return ComTaskPanel
