local ComTipsItemPanel = class("ComTipsItemPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local CommonShopType = Enum:getTable('CommonShopType');

function ComTipsItemPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ComTipsItemPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function ComTipsItemPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
	  self.curBuyCount = 0;
      self:InitPanels();
end

function ComTipsItemPanel:InitPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(484,454));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 0);

	local titleNode = GlobalFunctions:createTitle(LANG.UI_L_BUYTOOLS_1,484);
	titleNode:addTo(self.root);
	titleNode:setPosition(0,227);

	local itemNameBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	itemNameBg:addTo(self.root);
	itemNameBg:setPosition(0 , 170);
    itemNameBg:setCapInsets(cc.rect(11,11,34,28));
	itemNameBg:setContentSize(cc.size(462 , 59));

	local nameImg = cc.Sprite:create('image/commonImg/arrow_bg.png');
	nameImg:addTo(self.root);
	nameImg:setPosition(-188 , 170);

	self.itemName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 23);
	self.itemName:addTo(self.root);
	self.itemName:setAnchorPoint(0 , 0.5);
	self.itemName:setPosition(-169 , 170);
	self.itemName:setTextColor(cc.c3b(160 , 200 , 255));

	self.itemIcon = template.ItemTemplate:create();
	self.itemIcon:setPosition(0 , 70);
	self.itemIcon:addTo(self.root);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , -70);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(462 , 119));

	self.itemInfo = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.itemInfo:addTo(self.root);
	self.itemInfo:setAnchorPoint(0 , 1);
	self.itemInfo:setContentSize(cc.size(423 , 110));
	self.itemInfo:setLineBreakWithoutSpace(true);
	self.itemInfo:setMaxLineWidth(423);
	self.itemInfo:setLineHeight(30);
	self.itemInfo:setPosition(-206 , -20);


	local costBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	costBg:addTo(self.root);
	costBg:setPosition(-114 , -180);
    costBg:setCapInsets(cc.rect(11,11,34,28));
	costBg:setContentSize(cc.size(217 , 42));

	self.costMoneyIcon = cc.Sprite:create();
	self.costMoneyIcon:setPosition(cc.p(-195,-180));
	self.costMoneyIcon:setScale(0.4);
	self.costMoneyIcon:addTo(self.root);

	self.costNum = cc.Label:createWithTTF('0', fonts.FONT_SIYUAN, 20);
	self.costNum:setAnchorPoint(1, 0.5);
	self.costNum:setPosition(-21, -180);
	self.costNum:addTo(self.root);

	local btnLabel = cc.Label:createWithTTF(LANG.UI_SETTING_21 , fonts.FONT_SIYUAN , 20);
	btnLabel:enableOutline(cc.c3b(50 , 85 , 150) , 2);

	self.btn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.btn:addTo(self.root);
	self.btn:setPosition(116 , -180);
	self.btn:addClickEventListener(handler(self , self.buyButtonClick));
	self.btn:setTitleLabel(btnLabel);
end

function ComTipsItemPanel:onEnter(ftype, data)

	if ftype==nil or data == nil then
		return;
	end
	self:addSwallowCallback(handler(self , self.onClickBack));
	self.data = data;
	self.ftype = ftype;
	self.root:setVisible(true);
	self:updateInfo();

end

function ComTipsItemPanel:updateInfo()

	local nameStr = '';
	local infoStr = '';
	self.costType = MONEY_ID;
	self.costPrice = 0;
	self.haveValue = 0;
	local costStr = '';
	local itemId = 10001;
	local itemCnt = 0;

	if self.data then
		if self.ftype == 1 then
			local itemData = ResTable:getRowData('maze_store', self.data.item[1]);
			itemId = itemData.item[1];
			itemCnt = itemData.item[2];

			self.costType = itemData.price[1];
			self.costPrice = itemData.price[2];
			costStr = tostring(ConvertStrToDigitUnit(itemData.price[2]));

			local toolData = ResTable:getRowData('item', itemId);
			nameStr = toolData.name;
			infoStr = toolData.info;
		end
		
	end

	self.itemIcon:Init(itemId , itemCnt);
	self.itemName:setString(nameStr);
	self.itemInfo:setString(infoStr);

	local icon = ResTable:getValue('item',self.costType,'icon');
	self.costMoneyIcon:setTexture('image/icon/I'..icon..'.png');
	self.costNum:setString(tostring(costStr));

end

function ComTipsItemPanel:buyButtonClick(sender , event)

	if self.costType == MONEY_ID then
		local haveMoney = model.MoneyModel:getWholeMoney();
		if HpCompare(haveMoney, '<', tostring(self.costPrice)) then
			Prompt:Show(LANG.UI_SHOP_56);
			return
		end
		-- strCost = ConvertStrToDigitUnit(strCost);
	else
		local haveValue = model.ItemModel:getItemNum(self.costType);
		if haveValue < self.costPrice then
			Prompt:Show(LANG.UI_SHOP_56);
			return
		end
	end

	if self.ftype == 1 then
		model.EventModel:reqEventMapShopOnce(self.data.item[1], self.data.tid);
		UIManager:pop('ComTipsItemPanel');
	end
end
function ComTipsItemPanel:onLeave()
	self.root:setVisible(false);
end

function ComTipsItemPanel:onClickBack()
	UIManager:pop('ComTipsItemPanel');
end

return ComTipsItemPanel;
