
-- 这是一个顶层panel，只能有一个点击返回功能！
local CommonInfoPanel = class("CommonInfoPanel", require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");

function CommonInfoPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'CommonInfoPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.haveSwallowLayer = true;
    self.isPopup = true;
end

function CommonInfoPanel:Init(root)
	self.root = root;
    self.root:setVisible(false);
end

function CommonInfoPanel:onEnter(itemId,itemCount)	
    self:showItems( itemId, itemCount )

	self.root:setVisible(true);
	self:addSwallowCallback(handler(self, self.onClickBack));
end

function CommonInfoPanel:showItems( itemId, itemCount )
    -- print('=========showItem === ',itemId,'....count = ',itemCount)
    if itemId > 80000 and itemId < 90000 then
        self:_showEquipTips(itemId)
    elseif itemId == ROLE_TYPE then 
        self:_showRoleTips(itemCount)
    elseif itemId == ROLE_AVATAR_TYPE then
        self:_showRoleAvatarTips(itemCount)
    else
        self:_showCommomTips(itemId, itemCount)
    end
end

function CommonInfoPanel:onLeave()
	self.root:setVisible(false);
end

function CommonInfoPanel:onClickBack()
    if self.equipNode then
        self.equipNode:setVisible(false);
    end
    if self.commonNode then
        self.commonNode:setVisible(false);
    end

    if self.roleAvatarNode then
        self.roleAvatarNode:setVisible(false);
    end

    if self.roleNode then
        self.roleNode:setVisible(false);
    end
    UIManager:pop('CommonInfoPanel');
end



--- -------------- private ------------------------

function CommonInfoPanel:_showRoleTips( no )
    -- body
    -- print('show role info === role_no = ',no);
    self:_initRoleTips();
    self.roleNode:setVisible(true);

	local roleData = ResTable:getRowData('role', no);
    if roleData == nil then
        return 
    end

	local roleResource = ResTable:getRowData('role_resource', roleData.resource_id);
	local imagePath = roleResource.card;
	self.cardPanelNavi:setTexture('image/role/'..imagePath..'.png');

end

function CommonInfoPanel:_showRoleAvatarTips( no )
    -- body
    -- print('show role info === role_no = ',no);
    self:_initRoleAvatarTips();
    self.roleAvatarNode:setVisible(true);

	local avatarData = ResTable:getRowData('role_avatar', no);
    if avatarData == nil then
        return 
    end

	local roleResource = ResTable:getRowData('role_resource', avatarData.resource_id);
	local imagePath = roleResource.card;
	self.avatarPanelNavi:setTexture('image/role/'..imagePath..'.png');

end

function CommonInfoPanel:_showEquipTips( id )
    self:_initEquipTips();

    self.equipNode:setVisible(true);
    self.equipIcon:Init(id)

    local itemData = ResTable:getRowData('item' , id);
    local colorName = Enum:getTable('ItemQualityColorName')[itemData.quality] or 'green';
    self.equipnameBg:setTexture('image/tips/title_'..colorName..'.png');

    self.equipName:setString(itemData.name);
    -- itemData.instruction = '简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述'
    -- itemData.info = '简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述'
    self.equipInstruction:setString(tostring(itemData.instruction))
    self.equipInfo:setString(tostring(itemData.info));

    local equipData = ResTable:getRowData('equip' , id);

    local att = GetMathsValue(string.format(tostring(equipData['value1']) , 0));
    local attribute1 =equipData['attribute1']
    local attributeInfo = LANG.UI_CARAD_ATT_TYPE[attribute1].."   "..tostring(att);
    self.equipAttribute:setString(attributeInfo);


    -- local starCount =  itemData.quality;
    -- self.equipStarNode:removeAllChildren();
    -- local color = math.ceil(starCount / 5);
    -- local num = starCount % 5;
    -- num = num == 0 and 5 or num;
    -- local posX = -(15 * num / 2) + 7.5;
    -- for i = 1 , num do
    --     local star = cc.Sprite:create('image/card/card_star_'..color..'.png');
    --     star:addTo(self.equipStarNode);
    --     star:setPositionX(posX + 15 * (i - 1));
    -- end

end

function CommonInfoPanel:_showCommomTips( id,count )
    self:_initCommonTips();
   
    self.commonNode:setVisible(true);
    
    self.commonIcon:Init(id)

    local itemData = ResTable:getRowData('item' , id);
    local colorName = Enum:getTable('ItemQualityColorName')[itemData.quality] or 'green';
    self.commonNameBg:setTexture('image/tips/title_'..colorName..'.png');
    -- itemData.instruction = '简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述'
    -- itemData.info = '简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述简短描述'
    self.commonName:setString(itemData.name);
    self.commonInstruction:setString(tostring(itemData.instruction))
    self.commonInfo:setString(tostring(itemData.info));
end

function CommonInfoPanel:_initRoleTips(  )
    if self.roleNode ~= nil then
        return ;
    end
    self.roleNode = cc.Node:create();
    self.roleNode:addTo(self.root);

	self.bg = cc.Sprite:create('image/bg/Bg_3.png');
	self.bg:addTo(self.roleNode);

	self.cardPanelNavi = cc.Sprite:create();
	self.cardPanelNavi:addTo(self.roleNode);
	self.cardPanelNavi:setPosition(0, 55);


end

function CommonInfoPanel:_initRoleAvatarTips(  )
    if self.roleAvatarNode ~= nil then
        return ;
    end
    self.roleAvatarNode = cc.Node:create();
    self.roleAvatarNode:addTo(self.root);

	self.avatarBg = cc.Sprite:create('image/bg/Bg_3.png');
	self.avatarBg:addTo(self.roleAvatarNode);

	self.avatarPanelNavi = cc.Sprite:create();
	self.avatarPanelNavi:addTo(self.roleAvatarNode);
	self.avatarPanelNavi:setPosition(0, 55);


end

function CommonInfoPanel:_initCommonTips(  )
    if self.commonNode ~= nil then
        return ;
    end

    self.commonNode = cc.Node:create();
    self.commonNode:addTo(self.root);

    local bg = cc.Sprite:create('image/tips/tips_bg_common.png');
    bg:addTo(self.commonNode)
    bg:setPosition(cc.p(3,16))

    self.commonNameBg = cc.Sprite:create('image/tips/title_blue.png')
        :addTo(self.commonNode)
        :setPosition(cc.p(2,136))

    self.commonIcon = template.ItemTemplate:create();
    self.commonIcon:addTo(self.commonNode);
    self.commonIcon:setPosition(cc.p(-113,104))

	self.commonName = cc.Label:createWithTTF('commonName', fonts.FONT_SIYUAN, 20)
        :addTo(self.commonNode)
        :setPosition(44, 137)

    self.commonInstruction = cc.Label:createWithTTF('instruction',fonts.FONT_JP,20)
        :addTo(self.commonNode)
        :setPosition(cc.p(-40,115))
        :setAnchorPoint(cc.p(0, 1))
        :setDimensions(180, 0)
        :setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)


    local infoBg = cc.Sprite:create('image/tips/title_common.png')
    infoBg:addTo(self.commonNode)
    infoBg:setPosition(cc.p(-66,21))

	local infoLabel = cc.Label:createWithTTF(LANG.UI_COMMON_1, fonts.FONT_JP, 20)
        :addTo(self.commonNode)
        :setPosition(-159, 20)
        :setAnchorPoint(cc.p(0,0.5))

    self.commonInfo = cc.Label:createWithTTF('info...',fonts.FONT_JP,20)
        :addTo(self.commonNode)
        :setPosition(cc.p(-159,0))
        :setAnchorPoint(cc.p(0, 1))
        :setDimensions(320, 100)
        :setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
        :setOverflow(cc.LabelOverflow.SHRINK)
end

function CommonInfoPanel:_initEquipTips(  )
    if self.equipNode ~= nil then
        return ;
    end

    self.equipNode = cc.Node:create();
    self.equipNode:addTo(self.root);

    local bg = cc.Sprite:create('image/tips/tips_bg_equip.png');
    bg:addTo(self.equipNode)
    bg:setPosition(cc.p(-2,-21))

    self.equipnameBg = cc.Sprite:create('image/tips/title_blue.png')
        :addTo(self.equipNode)
        :setPosition(cc.p(8,135))

    self.equipIcon = template.ItemTemplate:create();
    self.equipIcon:addTo(self.equipNode);
    self.equipIcon:setPosition(cc.p(-113,99))

	self.equipName = cc.Label:createWithTTF('commonName', fonts.FONT_SIYUAN, 20)
        :addTo(self.equipNode)
        :setPosition(46, 137)

    self.equipInstruction = cc.Label:createWithTTF('instruction',fonts.FONT_JP,20)
        :addTo(self.equipNode)
        :setPosition(cc.p(-43,110))
        :setAnchorPoint(cc.p(0, 1))
        :setDimensions(180, 0)
        :setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
    
    -- 星级
    -- local starBg = cc.Sprite:create('image/RandomShop/item_star_bg.png')
    --     :addTo(self.equipNode)
    --     :setPosition(cc.p(-112,29))
    
    -- self.equipStarNode = cc.Node:create();
    -- self.equipStarNode:addTo(self.equipNode);
    -- self.equipStarNode:setPosition(cc.p(-115,30))
    -- 属性
    local attributeBg = cc.Sprite:create('image/tips/title_common.png')
    attributeBg:addTo(self.equipNode)
    attributeBg:setPosition(cc.p(-66,-18))

    local attributeLabel = cc.Label:createWithTTF(LANG.UI_COMMON_2, fonts.FONT_JP, 20)
        :addTo(self.equipNode)
        :setPosition(-159, -17)
        :setAnchorPoint(cc.p(0,0.5))

    self.equipAttribute = cc.Label:createWithTTF('ATK   999',fonts.FONT_JP,20)
        :addTo(self.equipNode)
        :setPosition(cc.p(-156,-50))
        :setAnchorPoint(cc.p(0, 0.5))
        -- :setDimensions(320, 0)
        -- :setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)

    -- 装备描述
    local infoBg = cc.Sprite:create('image/tips/title_common.png')
    infoBg:addTo(self.equipNode)
    infoBg:setPosition(cc.p(-66,-85))

	local infoLabel = cc.Label:createWithTTF(LANG.UI_COMMON_3, fonts.FONT_JP, 20)
        :addTo(self.equipNode)
        :setPosition(-159, -86)
        :setAnchorPoint(cc.p(0,0.5))

    self.equipInfo = cc.Label:createWithTTF('info...',fonts.FONT_JP,20)
        :addTo(self.equipNode)
        :setPosition(cc.p(-159,-109))
        :setAnchorPoint(cc.p(0, 1))
        :setDimensions(320, 100)
        :setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
        :setOverflow(cc.LabelOverflow.SHRINK)

end

return CommonInfoPanel;
