local CopyRoundPanel = class("CopyRoundPanel",require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local FightType = Enum:getTable('FightType');
local MessageBoxType = Enum:getTable('MessageBoxType')
local imgPath = 'image/trial/';

function CopyRoundPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'CopyRoundPanel');
    self.scene = scene;
	self.useCCreator = false;
    self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
    self.showFooter = true;

    self.selectedId = nil;
    
end

function CopyRoundPanel:Init( root,scene )
    -- body
    self.root = root;
    self.scene = scene;
    self.root:setVisible(false);

    self:initPannel();
    self:registEvent();

end

function CopyRoundPanel:registEvent(  )
	EventManager:RegisterEvent(EventType.UITrialPanelFightOver , handler(self , self.retFightOverAuto));
end

function CopyRoundPanel:initPannel(  )

	local blackBg = ccui.Layout:create();
	blackBg:setBackGroundImage('image/task/blackbg.png');
	blackBg:setBackGroundImageScale9Enabled(true);
	blackBg:setTouchEnabled(true);
	blackBg:setContentSize(StageSize);
	blackBg:setLocalZOrder(-2);
	blackBg:setAnchorPoint(cc.p(0.5,0.5));
	blackBg:setPosition(0, 0);
    blackBg:addTo(self.root);
    
    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);

    local bg1 = cc.Sprite:create('image/bg/Bg_copy_round.png');
    bg1:addTo(bgNode);

    local topNode = cc.Node:create()
    topNode:addTo(self.root)
    topNode:setPosition(0, 420)
    -- local topBg = cc.Sprite:create( imgPath..'n_r_bg1.png' )
    -- topBg:addTo(topNode)
    local spine_res = 'Seafloor_Spine';
    if spine_res~=nil and cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
        local skAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        skAnimation:addTo(topNode)
        skAnimation:setAnimation(0, GlobalFunctions:lAnimationName("biaoti"), true)
    end
    local timeBg = cc.Sprite:create( imgPath..'n_r_bg2.png' )
    timeBg:addTo(topNode)
    timeBg:setPosition(0, -100)
    self.timeLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18)
        -- :setTextColor(cc.c3b(255,255,0))
        :addTo(topNode)
        :setPosition(0, -88)
        :enableOutline(cc.c3b(16,37,142), 1)


    local rightNode = cc.Node:create()
        :addTo(self.root)
        :setPosition(cc.p(0,0))
    self.trialItem = {}
    for i=1,2 do

        self.trialItem[i] = {}
        self.trialItem[i].node = cc.Node:create()
            :addTo(rightNode)

        local itemBg = cc.Sprite:create( imgPath..'copy_round_item.png')
            :addTo(self.trialItem[i].node);

        self.trialItem[i].title = cc.Label:createWithTTF(string.format( LANG.UI_TRIAL_17,1 ),fonts.FONT_SIYUAN,18)
            :addTo(self.trialItem[i].node)
            :setPosition(cc.p(-50,20))
            :enableOutline(cc.c3b(0 , 0 , 0),2);

        self.trialItem[i].msg = cc.Label:createWithTTF('获得金币120000',fonts.FONT_SIYUAN,18)
            :addTo(self.trialItem[i].node)
            :setPosition(cc.p(-50,-20))
            :setTextColor(cc.c3b(100 , 255 , 210))
            :setVisible(false)

        -- self.trialItem[i].headItem = template.ItemTemplate:create()
        -- self.trialItem[i].headItem:addTo(self.trialItem[i].node)
        -- self.trialItem[i].headItem:setPosition(cc.p(-200,0))
        -- self.trialItem[i].headItem:setScale(0.9)
        local headNode = cc.Node:create()
        headNode:addTo(self.trialItem[i].node)
        headNode:setPosition(cc.p(-200,0))
        headNode:setScale(0.9)

        if true then

            local bossInfo = {}
            self.trialItem[i].headItem = bossInfo

            local bg = cc.Sprite:create('image/commonImg/icon_enemy_empty.png')
                :addTo(headNode)

            bossInfo.node = cc.Node:create()
                :addTo(headNode)

            bossInfo.bg = cc.Sprite:create('image/commonImg/icon_enemy.png')
                :addTo(bossInfo.node)

            bossInfo.bareFlag = cc.Scale9Sprite:create('image/commonImg/common_item_select.png');
            bossInfo.bareFlag:addTo(bossInfo.node);
            bossInfo.bareFlag:setContentSize(cc.size(112 , 112));
            bossInfo.bareFlag:setVisible(false)

            bossInfo.icon = cc.Sprite:create()
            local stencil = cc.Sprite:create('image/commonImg/icon_clipping_bg.png');
            stencil:setScale(1.05);
            local clippingNode = cc.ClippingNode:create();
            clippingNode:setStencil(stencil);
            clippingNode:addChild(bossInfo.icon);
            clippingNode:setInverted(false);
            clippingNode:setAlphaThreshold(0);
            clippingNode:addTo(bossInfo.node);

            bossInfo.restraint = cc.Sprite:create('image/commonImg/def_type_1.png')
                :setPosition(-31, 32)
                :setScale(0.55)
                :addTo(bossInfo.node)

            bossInfo.starNode = cc.Node:create()
                :setPosition(-26, -37)
                :addTo(bossInfo.node)

            bossInfo.level = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
                :setAnchorPoint(1, 0.5)
                :setPosition(44, 37)
                :enableOutline(cc.c3b(60,60,60),2)
                :addTo(bossInfo.node)
        end

        self.trialItem[i].rwdItem = {}
        self.trialItem[i].rwdItem[1] = template.ItemTemplate:create()
        self.trialItem[i].rwdItem[1]:addTo(self.trialItem[i].node)
        self.trialItem[i].rwdItem[1]:setPosition(cc.p(110,0))
        self.trialItem[i].rwdItem[1]:setScale(0.8)

        self.trialItem[i].rwdItem[2] = template.ItemTemplate:create()
        self.trialItem[i].rwdItem[2]:addTo(self.trialItem[i].node)
        self.trialItem[i].rwdItem[2]:setPosition(cc.p(200,0))
        self.trialItem[i].rwdItem[2]:setScale(0.8)
        -- self.trialItem[i].headItem:setCanShowInfo(true,true);

        -- if spine_res~=nil and cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
        --     local skAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        --     skAnimation:addTo(self.trialItem[i].node)
        --     skAnimation:setAnimation(0, "idle1", true)
        -- end

        if i == 1 then
            if spine_res~=nil and cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
                local skAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
                skAnimation:addTo(self.trialItem[i].node)
                skAnimation:setAnimation(0, "idle2", true)
            end
        end
    end

    -- topItem
    self.trialItem[2].node:setPosition(cc.p(0,-180))
    local topMaskBg = cc.Scale9Sprite:create('image/lock/item_bg5.png')
    topMaskBg:addTo(self.trialItem[2].node);
    topMaskBg:setContentSize(cc.size(530, 120))
    local topMask = cc.Sprite:create('image/lock/lock_bg_2.png')
        :setScale(2)
        :addTo(self.trialItem[2].node);
    -- midItem
    self.trialItem[1].node:setPosition(cc.p(0,-30))
    self.trialItem[1].complete = cc.Node:create()
        :addTo(self.trialItem[1].node)
        :setVisible(false)
        -- :setScale(0.83)
    local midMask = cc.Scale9Sprite:create('image/lock/item_bg5.png')
    midMask:addTo(self.trialItem[1].complete);
    midMask:setContentSize(cc.size(530, 120))
    local midComplete = cc.Sprite:create( imgPath..'item_all_complete.png')
        :addTo(self.trialItem[1].complete);

    --商城按钮
    self.shopBtn = ccui.Button:create( imgPath .. "n_r_btn.png")
        :addTo(self.root)
        :setPosition(cc.p(250,150))
    self.shopBtn:addClickEventListener(handler(self , self.onOpenShop));	

    local size = self.shopBtn:getContentSize()
    local btnName = cc.Sprite:create(imgPath .. 'shop_icon.png')
	if btnName then
		btnName:addTo(self.shopBtn)
			:setPosition(size.width/2 , size.height/2)
    end
    
    local btnName = cc.Label:createWithTTF( LANG.UI_MAIN_6, fonts.FONT_SIYUAN, 20)
			:enableOutline(cc.c3b(60, 60, 60), 2)
			:setPosition(size.width / 2 , 5)
			:addTo(self.shopBtn)


    --任务按钮
    self.taskBtn = ccui.Button:create( imgPath .. "n_r_btn.png")
        :addTo(self.root)
        :setPosition(cc.p(250,280))
    self.taskBtn:addClickEventListener(handler(self , self.onOpenTask));    

    local size = self.taskBtn:getContentSize()
    local btnName = cc.Sprite:create(imgPath .. 'task_icon.png')
    if btnName then
        btnName:addTo(self.taskBtn)
            :setPosition(size.width/2 , size.height/2)
    end
    
    local btnName = cc.Label:createWithTTF( LANG.UI_TITLE_MUBIAO, fonts.FONT_SIYUAN, 20)
            :enableOutline(cc.c3b(60, 60, 60), 2)
            :setPosition(size.width / 2 , 5)
            :addTo(self.taskBtn)

    --挑战
    local label = cc.Label:createWithTTF(LANG.UI_TRIAL_3 ,  fonts.FONT_SIYUAN , 20)
        :enableOutline(cc.c4b(175 , 10 , 0 , 255),1)
    self.fightBtn = ccui.Button:create('image/commonImg/btn_9_219_55.png' , 'image/commonImg/btn_9_219_55.png')
        :addTo(self.root)
        :setPosition(0, -350)
        :setTitleLabel(label)
    self.fightBtn:addClickEventListener(handler(self , self.onFight))

    local sparticle = cc.ParticleSystemQuad:create("Effect/particle/shuye.plist")
    sparticle:addTo(self.root);
    sparticle:setPosition(0, 0.5*StageSize.height);

end

function CopyRoundPanel:showTrialPointInfo(  )
    if self.selectedId == nil  then
        return 
    end

    local data = ResTable:getRowData('adventure_round', self.selectedId);
    local isPassAll = model.RoundModel:isCopyRoundPassAll();
    if data == nil or isPassAll==true then
        return 
    end
    self.fightBtn:setTouchEnabled(true);
end

function CopyRoundPanel:showTrialList(  )
    local trialId = model.RoundModel:getCurCopyRoundId()
    if trialId == 0 then
        return
    end
    trialId = trialId - 1
    trialId = math.max(trialId, 0)
    self.selectedId = nil

    local isPassAll = model.RoundModel:isCopyRoundPassAll();
    local tempTrialId = trialId;
    for i=1,2  do
        tempTrialId = trialId + i
        local itemData = ResTable:getRowData('adventure_round', tempTrialId);
        if itemData == nil then
            if i ~= 1 then
                self.trialItem[i].node:setVisible(false);
            else
                self.trialItem[i].complete:setVisible(true);
            end
        else
            if i == 1 then
                self.selectedId = tempTrialId
                if isPassAll == true then
                    self.trialItem[i].complete:setVisible(true);
                end
            end
            self.trialItem[i].node:setVisible(true);
            self.trialItem[i].title:setString(string.format( LANG.UI_TRIAL_17,itemData.no ))


            local complete_reward_list = itemData.drop or {};
            for j=1,2 do
                if complete_reward_list[j] then
                    self.trialItem[i].rwdItem[j]:Init(tonumber(complete_reward_list[j][1]) , tonumber(complete_reward_list[j][2]));
                    self.trialItem[i].rwdItem[j]:setVisible(true)
                else
                    self.trialItem[i].rwdItem[j]:setVisible(false)
                end
            end

            local bossInfo = itemData.monster[1];
            -- self.trialItem[i].headItem:Init(MONSTER_TYPE, bossInfo[1])
            if bossInfo and bossInfo[1] then
                local bossId = bossInfo[1];
                local data = ResTable:getRowData('monster', bossId);
                self.trialItem[i].headItem.bareFlag:setVisible(false)
                if data then
                    self.trialItem[i].headItem.icon:setTexture('image/icon/'..data.icon..'.png')
                    self.trialItem[i].headItem.restraint:setTexture('image/commonImg/def_type_'..data['def_type']..'.png');
                    if data.show > 0 then
                        self.trialItem[i].headItem.bareFlag:setVisible(true)
                    end
                end
                local attributeData = ResTable:getRowData('monster_attribute', bossInfo[2]);
                self.trialItem[i].headItem.level:setString('Lv.'..tostring(attributeData.lv));

                self.trialItem[i].headItem.starNode:removeAllChildren();
                local color = math.ceil(attributeData.star / 5);
                local num = attributeData.star % 5;
                num = num == 0 and 5 or num;
                for j = 1 , 5 do
                    if j <= num then
                        local star = cc.Sprite:create('image/card/star_level_'..color..'.png');
                        star:addTo(self.trialItem[i].headItem.starNode);
                        star:setPosition(14*(j-1),0)
                        star:setScale(0.55);
                    end
                end

            end

        end
        -- 
    end

    local openData = model.RoundModel:getCopyRoundOpenInfo()
    if openData then
        local startTime = openData.open_time
        local endTime = openData.close_time
        if startTime ~= 0 then
            local startTable = os.date('*t', startTime)
            local endTable = os.date('*t', endTime)
            local msg = string.format( LANG.UI_EVENT_29,startTable.month,startTable.day ).."~"..string.format( LANG.UI_EVENT_29,endTable.month,endTable.day )
            self.timeLabel:setString(msg..'(KST)');
        else
            self.timeLabel:setString('');
        end
    else
        self.timeLabel:setString('');
    end

    self:showTrialPointInfo()

    -- if model.RoundModel:isCopyRoundNewWin() == true then
    --     self.comSpine:setAnimation(0, "tiaozhan1", false)
    -- else
    --     self.comSpine:setAnimation(0, "tiaozhan2", true)
    -- end
    model.RoundModel:setCopyRoundNewWin(false)
end


function CopyRoundPanel:retFightOverAuto( msg )
    --扫荡结果更新UI
	UIManager:push('RewardPanel', msg);
end

function CopyRoundPanel:updateTeamBtnRedDot()
    local show = model.TeamModel:checkTeamFormationRedDotState();
	tools.RedDotTools:setRedDotToNode(self.teamBtn,show,nil,cc.p(36,44))
end

function CopyRoundPanel:onOpenShop(  )
    local openData = model.RoundModel:getCopyRoundOpenInfo()
    if openData==nil then
        return
    end
    local endTime = openData.show_time
    local curTime = TimeManager:getCurTime();
    if curTime<=endTime then
        UIManager:push('StorePanel', Enum:getTable('CommonShopType').ADVENTURE2);    
    else
        Prompt:Show(LANG.UI_ROUND_30);
    end
    
end

function CopyRoundPanel:onOpenTask(  )
    local openData = model.RoundModel:getCopyRoundOpenInfo()
    if openData==nil then
        return
    end
    local endTime = openData.show_time
    local curTime = TimeManager:getCurTime();
    if curTime<=endTime then
        UIManager:push('ComTaskPanel', 2);
    else
        Prompt:Show(LANG.UI_ROUND_30);
    end
    
end

function CopyRoundPanel:onFight( )
    
    AudioManager:playEffect(Conf.confirmButton);
    local isPassAll = model.RoundModel:isCopyRoundPassAll();
    if isPassAll then
        return
    end
    local openData = model.RoundModel:getCopyRoundOpenInfo()
    local trialId = model.RoundModel:getCurCopyRoundId()
    if openData==nil or trialId==0 then
        return
    end
    if openData then
        local startTime = openData.open_time
        local endTime = openData.close_time
        local curTime = TimeManager:getCurTime();
        if curTime>=startTime and curTime<=endTime then
            UIManager:push('NewRoundInfoPanel', {fightType = FightType.CopyRound, select_key = self.selectedId})
        else
            if curTime<=openData.show_time then
                Prompt:Show(LANG.UI_ROUND_28);
            else
                Prompt:Show(LANG.UI_ROUND_30);
            end
        end
    end

end


function CopyRoundPanel:onClickBack( ... )
	UIManager:pop('CopyRoundPanel');
end

function CopyRoundPanel:onEnter()
    self.tempTime = 0

    self:onShow();
    EventManager:FireEvent(EventType.UIFooterUpdateSelect,1);
    AudioManager:playMusic(Conf.copyFight, 2, true);

end

function CopyRoundPanel:onShow()
    self:showTrialList()
    self:updateTeamBtnRedDot();
    self.root:setVisible(true)
end

function CopyRoundPanel:onLeave( ... )
    self.root:setVisible(false);
    self:clearData();
    AudioManager:playMusic(Conf.main, 2, true);
end

function CopyRoundPanel:clearData(  )
    self.selectedId = nil;
end

return CopyRoundPanel
