local EquipComposePanel = class("EquipComposePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/equip/equip_compose/'
local MessageBoxType = Enum:getTable('MessageBoxType')
local TeamType = Enum:getTable('TeamType');

function EquipComposePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EquipComposePanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function EquipComposePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function EquipComposePanel:initPanels()

	local bgSprite1 = cc.Sprite:create('image/bg/Bg_5.png');
	bgSprite1:addTo(self.root);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , 251);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(602 , 409));

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , 289);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(565 , 295));

	local composeNumBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	composeNumBg:addTo(self.root);
	composeNumBg:setPosition(0 , 239);
    composeNumBg:setCapInsets(cc.rect(11,11,34,28));
	composeNumBg:setContentSize(cc.size(335 , 42));

	local costBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	costBg:addTo(self.root);
	costBg:setPosition(0 , 185);
    costBg:setCapInsets(cc.rect(11,11,34,28));
	costBg:setContentSize(cc.size(265 , 42));
	
	self.swtichBtnList = {};
	for i = 1 , 2 do
		self.swtichBtnList[i] = ccui.Button:create('image/commonImg/btn_5_132_45.png' , 'image/commonImg/btn_5_132_45.png');
		self.swtichBtnList[i]:addTo(self.root);
		self.swtichBtnList[i]:setPosition(i == 1 and 94 or 244 , StageSize.height/2 - 92 - NOTCH_HEIGHT);
		self.swtichBtnList[i]:setTag(i);
		self.swtichBtnList[i]:addClickEventListener(handler(self , self.swtichBtnClick));

		local label = cc.Label:createWithTTF(LANG.UI_EQUIP_COMPOSE_SWTICH_BTN[i] , fonts.FONT_SIYUAN , 20);
		label:enableOutline(cc.c4b(125 , 125 , 125, 255) , 2);
		self.swtichBtnList[i]:setTitleLabel(label);
	end

	local composeEquipBg = cc.Sprite:create('image/commonImg/arrow_4_bg.png');
	composeEquipBg:addTo(self.root);
	composeEquipBg:setPosition(0 , 365);

	self.composeEquipList = {};
	for i = 1 , 2 do
		local icon = template.ItemTemplate:create(2);
		icon:addTo(self.root);
		icon:setPosition(i == 1 and -120 or 120 , 365);
		icon:addItemClickEventListener(handler(self , self.composeEquipListClick));
		self.composeEquipList[i] = icon
	end

	self.composeSpineNode = cc.Node:create();
	self.composeSpineNode:addTo(self.root);

	self.haveNum = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.haveNum:addTo(self.root);
	self.haveNum:setPosition(-120 , 297);

	self.composeNum = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.composeNum:addTo(self.root);
	self.composeNum:setPosition(0 , 239);

	self.composeNumBtnSub = ccui.Button:create('image/commonImg/sub_btn_1.png','image/commonImg/sub_btn_1.png');
	self.composeNumBtnSub:addTo(self.root);
	self.composeNumBtnSub:setPosition(-143 , 239);
	self.composeNumBtnSub:setTag(1);
	self.composeNumBtnSub:addClickEventListener(handler(self , self.composeNumBtnClick));

	self.composeNumBtnAdd = ccui.Button:create('image/commonImg/add_btn_2.png','image/commonImg/add_btn_2.png');
	self.composeNumBtnAdd:addTo(self.root);
	self.composeNumBtnAdd:setPosition(143 , 239);
	self.composeNumBtnAdd:setTag(2);
	self.composeNumBtnAdd:addClickEventListener(handler(self , self.composeNumBtnClick));

	local itemIcon = ResTable:getValue('item' , MONEY_ID , 'icon');
	local costIconImg = cc.Sprite:create('image/icon/I'..itemIcon..'.png');
	costIconImg:addTo(self.root);
	costIconImg:setScale(0.5);
	costIconImg:setPosition(-101 , 186);

	self.costIconNum = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.costIconNum:addTo(self.root);
	self.costIconNum:setAnchorPoint(1 , 0.5);
	self.costIconNum:setPosition(118 , 185);

	local btnLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_16 , fonts.FONT_SIYUAN , 20)
		:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)

	self.composeBtn = ccui.Button:create('image/commonImg/btn_1_219_55_2.png','image/commonImg/btn_1_219_55_2.png');
	self.composeBtn:addTo(self.root);
	self.composeBtn:setPosition(-133 , 96);
	self.composeBtn:addClickEventListener(handler(self , self.composeBtnClick));
	self.composeBtn:setTitleLabel(btnLabel);

	local btnLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_17 , fonts.FONT_SIYUAN , 20)
		:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2)

	self.composeOneKeyBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png','image/commonImg/btn_1_219_55.png');
	self.composeOneKeyBtn:addTo(self.root);
	self.composeOneKeyBtn:setPosition(133 , 96);
	self.composeOneKeyBtn:addClickEventListener(handler(self , self.composeOneKeyBtnClick));
	self.composeOneKeyBtn:setTitleLabel(btnLabel);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -237);
    bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(604 , 437));

	self.composeEquipMenu = {};
	self.equipRedDotNode = {};
	for i = 1 , 4 do
		
		local texture = 'image/commonImg/menu_left_71_46.png';
		local unTexture = 'image/commonImg/menu_left_71_46_u.png';

		if i == 2 or i == 3 then
			texture = 'image/commonImg/menu_mid_71_46.png';
			unTexture = 'image/commonImg/menu_mid_71_46_u.png';
		end

		local label = cc.Label:createWithTTF(LANG.UI_EQUIP_TYPE[i] , fonts.FONT_SIYUAN , 20);
		label:setScaleX(i == 4 and -1 or 1);
		local bgBtn = ccui.Button:create(texture,texture,unTexture);
		bgBtn:addTo(self.root);
		bgBtn:setTag(i);
		bgBtn:setTitleLabel(label);
		bgBtn:setScaleX(i == 4 and -1 or 1);
		bgBtn:setScale9Enabled(true);
		bgBtn:setCapInsets(cc.rect(10 , 0 , 51 , 46));
		bgBtn:setContentSize(cc.size(151 , 46));
		bgBtn:setPosition(-226.5 + 151*(i-1) , 5);
		bgBtn:addClickEventListener(handler(self , self.composeEquipMenuBtnClick));
		self.composeEquipMenu[i] = bgBtn;

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(-226.5 + 151*(i-1) , 5)
		self.equipRedDotNode[i]=node;
	end
	
	self.light = cc.Sprite:create('image/commonImg/menu_light_1.png');
	self.light:addTo(self.root);
	self.light:setPosition(-226.5 , 5+self.composeEquipMenu[1]:getContentSize().height/2);

	local initData = {
        width = 604,
        height = 426,
        cellWidth = 604 ,
        cellHeight = 124,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

    }
    self.composeEquipView = template.TableViewTemplate:create()
    self.composeEquipView:initWithSizeAndItem(initData) ;
    self.composeEquipView:getView():setPosition(cc.p(-302,-448));
	self.composeEquipView:getView():addTo(self.root)

	EventManager:RegisterEvent(EventType.NetworkRetEquipCompose, handler(self, self.retEquipCompose));
	EventManager:RegisterEvent(EventType.NetworkRetEquipOneKeyCompose, handler(self, self.retEquipOneKeyCompose));

end

function EquipComposePanel:swtichBtnClick(sender , event)
	local tag = sender:getTag();
	AudioManager:playEffect(Conf.buttonClick);
	if tag == 1 then
		UIManager:push('EquipWearPanel', self.teamType);
	else
		UIManager:push('EquipPanel', self.teamType);
	end
end

function EquipComposePanel:onEnter(teamType)
	self.teamType = teamType or TeamType.COMMON;
	local locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_18)
	if locked then
		Prompt:Show(string.format(LANG.UI_EQUIP_42 , lockLv));
		UIManager:pop('EquipComposePanel');
		return
	end

	self.curType = 1;
	self.selectComposeId = nil;
	self.composeId = nil;
	
	self.composeSpineNode:removeAllChildren();
	self:updateRedDot()
	self:updateComposeEquipMenuBtnState();

	self.root:setVisible(true);
	self:updateBtnRedDot();
end

function EquipComposePanel:updateBtnRedDot()
	local state = model.EquipModel:getTeamSlotEquipActiveState();
	tools.RedDotTools:setRedDotToNode(self.swtichBtnList[1],state,nil,cc.p(120 , 33));
end

function EquipComposePanel:cellItemTouch(table,cell)
	if self.selectComposeId then
		self.composeId = self.selectComposeId; 
		self:updateComposeEquip();
		self.selectComposeId = nil;
		AudioManager:playEffect(Conf.buttonClick);
	end
end

function EquipComposePanel:reloadCellPanel(cell , idx)
	local children = cell:getChildren();

	if not self.equipComposes[idx + 1] then
		return;
	end

	local equipComposes = self.equipComposes[idx + 1];

	if not children or #children <= 0 then
		for i = 1 , 5 do
			local x = 65 + 118.5 * (i - 1);
			local y = 62;
			local equipTemplate = template.ItemTemplate:create(2);
			equipTemplate:setPosition(cc.p(x , y));
			equipTemplate:addTo(cell);
			equipTemplate:addItemClickEventListener(handler(self , self.selectComposeEquip));
			if equipComposes[i] then
				local equipCompose = equipComposes[i];
				local equipNo = equipCompose.equip_cost[1];

				if not self.equipNoHaveNum[equipNo] then
					local haveNum = model.EquipModel:getEquipNum(equipNo);
					self.equipNoHaveNum[equipNo] = haveNum
				end

				if not self.composeId then
					self.composeId = equipCompose.id;
				end

				local costNum =  #equipCompose.equip_cost;
				
				equipTemplate:Init(equipCompose.equip_id);
				equipTemplate:setItemTag(equipCompose.id);
				equipTemplate:showRedDot(self.equipNoHaveNum[equipNo] >= costNum);
				equipTemplate:setSelect(equipCompose.id == self.composeId);
				
			else
				equipTemplate:setVisible(false);
			end
		end
	else
		for i = 1 , 5 do
			if equipComposes[i] then
				local equipCompose = equipComposes[i];
				local equipNo = equipCompose.equip_cost[1];

				if not self.equipNoHaveNum[equipNo] then
					local haveNum = model.EquipModel:getEquipNum(equipNo);
					self.equipNoHaveNum[equipNo] = haveNum
				end

				if not self.composeId then
					self.composeId = equipCompose.id;
				end

				local costNum =  #equipCompose.equip_cost;
				
				children[i]:Init(equipCompose.equip_id);
				children[i]:setItemTag(equipCompose.id);
				children[i]:showRedDot(self.equipNoHaveNum[equipNo] >= costNum);
				children[i]:setSelect(equipCompose.id == self.composeId);
			else
				children[i]:setVisible(false);
			end
		end
	end

	return cell;
end

function EquipComposePanel:setEquipData()

	self.selectComposeId = nil;
	self.equipNoHaveNum = {}
	self.equipComposes = {};

	local equipComposes = model.EquipModel:getEquipComposeTableDataByType(self.curType);
		
	if not equipComposes then
		return;
	end

	local maxNum = #equipComposes;

	if maxNum > 1 then
		table.sort(equipComposes , function(first , second) 
			return first.id < second.id;
		end);
	end

	for idx , equipComposeData in ipairs(equipComposes) do
		local index = math.ceil(idx / 5);
		if not self.equipComposes[index] then
			self.equipComposes[index] = {};
		end

		table.insert(self.equipComposes[index] , equipComposeData);
	end
	

	self.composeEquipView:setDataCount(#self.equipComposes);
	self.composeEquipView:reloadData();

	self:updateComposeEquip();
end

function EquipComposePanel:updateRedDot(composeType)
	for i = 1 , 4 do
		if composeType then 
			if i == composeType then
				local state = model.EquipModel:getEquipComposeActiveState(i);
				tools.RedDotTools:setRedDotToNode(self.equipRedDotNode[i],state[i],nil,cc.p(65 , 13));
				break;
			end
		else
			local state = model.EquipModel:getEquipComposeActiveState(i);
			tools.RedDotTools:setRedDotToNode(self.equipRedDotNode[i],state[i],nil,cc.p(65 , 13));
		end
	end
end

function EquipComposePanel:selectComposeEquip(sender , event)
	self.selectComposeId = sender:getTag();
end

function EquipComposePanel:composeEquipMenuBtnClick(sender , event)
	local tag = sender:getTag();
	AudioManager:playEffect(Conf.buttonClick);
	if self.curType == tag then
		return;
	end
	self.curType = tag;
	self:updateComposeEquipMenuBtnState();
end

function EquipComposePanel:updateComposeEquipMenuBtnState()
	for _k , menu in pairs(self.composeEquipMenu) do
		local label = menu:getTitleLabel();
		if _k == self.curType then
			menu:setBright(true)
            label:setTextColor(cc.c3b(255 , 255 , 255));
            self.light:setPositionX(menu:getPositionX());
		else
            menu:setBright(false)
			label:setTextColor(cc.c3b(180 , 180 , 180));
		end
	end
	self.composeId = nil;
	self:setEquipData();
end

function EquipComposePanel:updateComposeEquip()

	for index , equipComposeData in ipairs(self.equipComposes) do
		local cell = self.composeEquipView:cellAtIndex(index-1);
		if cell then
			local children = cell:getChildren();
			for _idx , child in ipairs(children) do
				if child:getItemTag() == self.composeId then
					child:setSelect(true);
				else
					child:setSelect(false);
				end
			end
		end
	end

	local equipCompose = ResTable:getRowData('equip_compose' , self.composeId);
	if not equipCompose then
		return;
	end

	local strenlevel = 1;

	local equipItem = ResTable:getRowData('item' , equipCompose.equip_id);
	
	if not equipItem then
		return;
	end

	self.composeEquipList[1]:setVisible(true);
	self.composeEquipList[2]:setVisible(true);
	self.composeEquipList[1]:Init(equipCompose.equip_cost[1]);
	self.composeEquipList[2]:Init(equipCompose.equip_id);
	self.composeEquipList[1]:setItemTag(equipCompose.equip_cost[1]);
	self.composeEquipList[2]:setItemTag(equipCompose.equip_id);

	local costNum = #equipCompose.equip_cost;
	
	local haveNum = self.equipNoHaveNum[equipCompose.equip_cost[1]] or 0;
	
	self.haveNum:setString(tostring(haveNum)..'/'..tostring(costNum));

	if costNum <= haveNum then
		local totalComposeNum = math.floor(haveNum / costNum);
		local curComposeNum = 0;
		local totalCost = '0';
		for i = 1 , totalComposeNum do
			totalCost = ConvertStrToDigitUnit(HpPlus(ConvertDigitUnitToStr(tostring(equipCompose.coin_cost)) , ConvertDigitUnitToStr(tostring(totalCost))));
			if model.MoneyModel:isEnough(totalCost) then
				curComposeNum = curComposeNum + 1;
			else
				break;
			end
		end
		self.curComposeCount = curComposeNum;
		self.composeNum:setString(tostring(curComposeNum));
		self.costIconNum:setString(totalCost);
	else
		self.curComposeCount = 0;
		self.composeNum:setString('0');
		self.costIconNum:setString('0');
	end
end

function EquipComposePanel:composeEquipListClick(sender , event)
	local tag = sender:getTag();
	local data = {
		no = tag, 
		enterType = 3,
	}
	UIManager:push('TipsEquipPanel' , data);
end

function EquipComposePanel:composeNumBtnClick(sender , event)

	local tag = sender:getTag();

	local equipCompose = ResTable:getRowData('equip_compose' , self.composeId);

	if tag == 1 then --减
		self.curComposeCount = self.curComposeCount - 1;
		if self.curComposeCount <= 0 then
			self.curComposeCount = 0;
			self.costIconNum:setString('0');
		else
			local costCoin = ConvertStrToDigitUnit(HpMultiply(ConvertDigitUnitToStr(tostring(equipCompose.coin_cost)) , tostring(self.curComposeCount)));
			self.costIconNum:setString(costCoin);
		end
		self.composeNum:setString(tostring(self.curComposeCount));
	else
		local curComposeCount = self.curComposeCount + 1;

		local costNum = #equipCompose.equip_cost;

		local haveNum = self.equipNoHaveNum[equipCompose.equip_cost[1]] or 0;

		local costCoin = ConvertStrToDigitUnit(HpMultiply(ConvertDigitUnitToStr(tostring(equipCompose.coin_cost)) , tostring(curComposeCount)));

		if (costNum * curComposeCount) > haveNum or not model.MoneyModel:isEnough(costCoin) then
			return;
		end

		self.curComposeCount = self.curComposeCount + 1;

		self.costIconNum:setString(costCoin);

		self.composeNum:setString(tostring(self.curComposeCount));
	end
end

function EquipComposePanel:composeBtnClick()

	if not self.curComposeCount or self.curComposeCount <= 0 then
		local equipCompose = ResTable:getRowData('equip_compose' , self.composeId);
		local haveNum = self.equipNoHaveNum[equipCompose.equip_cost[1]] or 0;
		local costCoin = ConvertDigitUnitToStr(tostring(equipCompose.coin_cost));

		if model.MoneyModel:isEnough(costCoin) then
			Prompt:Show(LANG.UI_EQUIP_18);
		else
			Prompt:Show(LANG.UI_EQUIP_41);
		end
		return;
	end

	AudioManager:playEffect(Conf.confirmButton);

	for index , equipCompose in ipairs(self.equipComposes) do
		for idx , compose in ipairs(equipCompose) do
			if compose.id == self.composeId then

				local haveNum = self.equipNoHaveNum[compose.equip_cost[1]] or 0;
				local costNum = #compose.equip_cost * self.curComposeCount;
				if haveNum < costNum then
					Prompt:Show(LANG.UI_EQUIP_19);
					return;
				end
			
				local msg = {};
				msg.composeId = self.composeId;
				msg.num = self.curComposeCount;
				Network.NetworkManager:Send(Network.NetworkCmdType.req_equip_compose , msg);
				break;
			end
		end
	end
	
end

function EquipComposePanel:retEquipCompose(msg)
	self:showComposeSpine(msg);
	--UIManager:push('RewardPanel', msg , {rewardType = Enum:getTable('RewardType').REWARD_TYPE_COMMON});
	--self:setEquipData();
	--self:updateRedDot(self.curType);
end

function EquipComposePanel:retEquipOneKeyCompose(msg)
	self:showComposeSpine(msg);
	--UIManager:push('RewardPanel', msg ,  {rewardType = Enum:getTable('RewardType').REWARD_TYPE_COMMON});
	--self:setEquipData();
	--self:updateRedDot(self.curType);
end

function EquipComposePanel:showComposeSpine(msg)
	self:updateRedDot(self.curType);
	self:updateBtnRedDot();
	self.composeSpineNode:removeAllChildren();
	self.composeEquipList[1]:setVisible(true);
	self.composeEquipList[2]:setVisible(false);
	if cc.FileUtils:getInstance():isFileExist('spine/hecheng_spine/hecheng_spine.json') then
		local equipComposeSpine = sp.SkeletonAnimation:create('spine/hecheng_spine/hecheng_spine.json', 'spine/hecheng_spine/hecheng_spine.atlas', 1)

		equipComposeSpine:addTo(self.composeSpineNode)
		equipComposeSpine:setPosition(-120 , 365);
		equipComposeSpine:setAnimation(0, "hecheng_xiaoshi", false);
		equipComposeSpine:registerSpineEventHandler(function (event)
			if event.eventData.name == 'change' then
				self.composeEquipList[1]:setVisible(false);
			end
		end, sp.EventType.ANIMATION_EVENT);
		equipComposeSpine:registerSpineEventHandler(function (event)
			equipComposeSpine:runAction(cc.Sequence:create(cc.DelayTime:create(0.01), cc.CallFunc:create(function() 
				equipComposeSpine:removeFromParent();
			end)));
		end, sp.EventType.ANIMATION_COMPLETE)
		
	end

	if cc.FileUtils:getInstance():isFileExist('spine/hecheng_spine/hecheng_spine.json') then
		local equipComposeSpine = sp.SkeletonAnimation:create('spine/hecheng_spine/hecheng_spine.json', 'spine/hecheng_spine/hecheng_spine.atlas', 1)

		equipComposeSpine:addTo(self.composeSpineNode)
		equipComposeSpine:setPosition(120 , 365);
		equipComposeSpine:setAnimation(0, "hecheng_shengcheng", false);
		equipComposeSpine:registerSpineEventHandler(function (event)
			if event.eventData.name == 'change' then
				self.composeEquipList[2]:setVisible(true);
			end
		end, sp.EventType.ANIMATION_EVENT);
		equipComposeSpine:registerSpineEventHandler(function (event)
			equipComposeSpine:runAction(cc.Sequence:create(cc.DelayTime:create(0.01), cc.CallFunc:create(function() 
				equipComposeSpine:removeFromParent();
				local option = {
					effectName = 'ComposeSuccess',
					rewardType = Enum:getTable('RewardType').REWARD_TYPE_COMMON
				}
				UIManager:push('RewardPanel', msg , option);
				self:setEquipData();
			end)));
		end, sp.EventType.ANIMATION_COMPLETE)
		
	end
end

function EquipComposePanel:composeOneKeyBtnClick() 
	AudioManager:playEffect(Conf.confirmButton);
	local state = model.EquipModel:getEquipComposeActiveState(self.curType);
	if state[self.curType] then
		UIManager:push('EquipOneKeyComposePanel' , self.curType)
	else
		Prompt:Show(LANG.UI_EQUIP_21);
	end
end

function EquipComposePanel:onClickBack()
	UIManager:pop('EquipComposePanel');
end

function EquipComposePanel:onLeave()
	self.composeSpineNode:removeAllChildren();
	self.selectComposeId = nil;
	self.root:setVisible(false);
end

return EquipComposePanel;
