local EquipOneKeyComposePanel = class("EquipOneKeyComposePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/equip/equip_compose/'
local MessageBoxType = Enum:getTable('MessageBoxType')

function EquipOneKeyComposePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EquipOneKeyComposePanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function EquipOneKeyComposePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function EquipOneKeyComposePanel:initPanels()


	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(604,642));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 54);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_EQUIPCOMP_TITLE_1 , 604 , 46 , LANG.UI_L_EQUIPCOMP_TITLE_2);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 398);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , 241);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(551 , 261));

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , -39);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(551 , 261));

	local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	arrow:addTo(self.root);
    arrow:setPosition(-239,344);

	local arrowLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_61 , fonts.FONT_SIYUAN , 23);
	arrowLabel:addTo(self.root);
	arrowLabel:setAnchorPoint(0 , 0.5);
	arrowLabel:setPosition(-216 , 344);
	arrowLabel:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	local line = cc.Sprite:create('image/commonImg/line.png');
    line:addTo(self.root);
	line:setContentSize(cc.size(549,1))
	line:setPosition(cc.p(0,317))

	local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	arrow:addTo(self.root);
    arrow:setPosition(-239,64);

	local arrowLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_60 , fonts.FONT_SIYUAN , 23);
	arrowLabel:addTo(self.root);
	arrowLabel:setAnchorPoint(0 , 0.5);
	arrowLabel:setPosition(-216 , 64);
	arrowLabel:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	local line = cc.Sprite:create('image/commonImg/line.png');
    line:addTo(self.root);
	line:setContentSize(cc.size(549,1))
	line:setPosition(cc.p(0,37))

	self.costEquipView = ccui.ScrollView:create();
	self.costEquipView:setTouchEnabled(true);
	self.costEquipView:setBounceEnabled(true);
	self.costEquipView:setDirection(ccui.ScrollViewDir.vertical);
	self.costEquipView:setContentSize(cc.size(540 , 182));
	self.costEquipView:setAnchorPoint(0.5 , 0.5);
	self.costEquipView:setPosition(0 , -63);
	self.costEquipView:setScrollBarEnabled(false);
	self.costEquipView:addTo(self.root);

	self.composeEquipView = ccui.ScrollView:create();
	self.composeEquipView:setTouchEnabled(true);
	self.composeEquipView:setBounceEnabled(true);
	self.composeEquipView:setDirection(ccui.ScrollViewDir.vertical);
	self.composeEquipView:setContentSize(cc.size(540 , 182));
	self.composeEquipView:setAnchorPoint(0.5 , 0.5);
	self.composeEquipView:setPosition(0 , 217);
	self.composeEquipView:setScrollBarEnabled(false);
	self.composeEquipView:addTo(self.root);

	local node = cc.Node:create();
	node:addTo(self.root);
	node:setPosition(-119 , -216);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(node);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(267,42));

	local itemIcon = ResTable:getValue('item' , MONEY_ID , 'icon');
	local costIcon = cc.Sprite:create('image/icon/I'..itemIcon..'.png');
	costIcon:addTo(node);
	costIcon:setScale(0.5);
	costIcon:setPosition(-112 , 0);
	
	local label = cc.Label:createWithTTF(LANG.UI_CARD_20, fonts.FONT_SIYUAN , 20);
	label:addTo(node);
	label:setTextColor(cc.c4b(160 , 200 , 255 , 255));
	label:setPosition(-60 , 0);

	self.costIconNum = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.costIconNum:addTo(node);
	self.costIconNum:setAnchorPoint(1 , 0.5);
	self.costIconNum:setPosition(117, 0);

	local btnLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_17 , fonts.FONT_SIYUAN , 20);
	btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

	self.composeBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.composeBtn:addTo(self.root);
	self.composeBtn:setPosition(147 , -215);
	self.composeBtn:addClickEventListener(handler(self , self.oneKeyBtnClick));
	self.composeBtn:setTitleLabel(btnLabel)
end


function EquipOneKeyComposePanel:onEnter(equipType)
	
	self:addSwallowCallback(handler(self , self.onClickBack));
	if not equipType then
		return;
	end

	local equipComposes = model.EquipModel:getEquipComposeTableDataByType(equipType);

	if not equipComposes then
		return;
	end

	self.equipType = equipType;

	self.equips = {};
	self.equipOri = {};
	local allEquips = model.EquipModel:getAllEquip();
	for no, num in pairs(allEquips) do
		local equip_type = ResTable:getValue('equip', no, 'type');
		if equip_type == equipType then
			self.equips[no] = num;
			self.equipOri[no] = num;
		end
	end
	
	self.costTotalCoin = '0';
	self.composeEquipNum = {};
	self.costEquipNum = {};
	for _k , compose in ipairs(equipComposes) do
		local equip_id = compose.equip_id;
		local equip_cost_id = compose.equip_cost[1];
		if not self.equips[equip_id] then
			self.equips[equip_id] = 0;
			self.equipOri[equip_id] = 0;
		end
		if not self.equips[equip_cost_id] then
			self.equips[equip_cost_id] = 0;
			self.equipOri[equip_cost_id] = 0;
		end
	end
		 
	for _k , compose in ipairs(equipComposes) do
		local composeNo = compose.equip_id;
		local costNo = compose.equip_cost[1];
		local costNum = #compose.equip_cost;
		local coin_cost = compose.coin_cost;

		local genNum = math.floor(self.equips[costNo] / costNum);
		local delNum = genNum * costNum;
		if genNum > 0 then
			local costCoin = HpMultiply(ConvertDigitUnitToStr(tostring(coin_cost)) , tostring(genNum));
			self.costTotalCoin = ConvertStrToDigitUnit(HpPlus(costCoin , ConvertDigitUnitToStr(tostring(self.costTotalCoin))));

			
			self.equips[costNo] = self.equips[costNo] - delNum;
			self.equips[composeNo] = self.equips[composeNo] + genNum;
		end
	end
	for no, num in pairs(self.equips) do
		if num > self.equipOri[no] then
			self.composeEquipNum[no] = num - self.equipOri[no];
		end

		if num < self.equipOri[no] then
			self.costEquipNum[no] = self.equipOri[no] - num;
		end
	end

	self.costEquipView:removeAllChildren();
	self.costEquipList = {};
	for equipNo , num in pairs(self.costEquipNum) do
		if num > 0 then
			local template = template.ItemTemplate:create();
			template:addTo(self.costEquipView);
			template:Init(equipNo, num);
			table.insert(self.costEquipList , template);
		end
	end

	local composeEquipListNum = #self.costEquipList;

	local maxHeight = math.ceil(composeEquipListNum / 4) * 134;
	if maxHeight < 182 then
		maxHeight = 182;
	end
	local maxWidth = 540;

	self.costEquipView:setInnerContainerSize(cc.size(maxWidth, maxHeight));

	for i = 1 , composeEquipListNum do
		local col = i % 4;
		col = col == 0 and 4 or col;
		local row = math.ceil(i / 4);
		self.costEquipList[i]:setPosition(57 + 142 * (col - 1) , maxHeight - 59 - 134 * (row - 1));
	end

	self.composeEquipView:removeAllChildren();
	self.composeEquipList = {};
	for equipNo , num in pairs(self.composeEquipNum) do
		if num > 0 then
			local template = template.ItemTemplate:create();
			template:addTo(self.composeEquipView);
			template:Init(equipNo, num);
			table.insert(self.composeEquipList , template);
		end
	end

	local composeEquipListNum = #self.composeEquipList;

	local maxHeight = math.ceil(composeEquipListNum / 4) * 134;
	if maxHeight < 182 then
		maxHeight = 182;
	end
	local maxWidth = 540;

	self.composeEquipView:setInnerContainerSize(cc.size(maxWidth, maxHeight));

	for i = 1 , composeEquipListNum do
		local col = i % 4;
		col = col == 0 and 4 or col;
		local row = math.ceil(i / 4);
		self.composeEquipList[i]:setPosition(57 + 142 * (col - 1) , maxHeight - 59 - 134 * (row - 1));
	end

	self.costIconNum:setString(self.costTotalCoin);

	self.root:setVisible(true);
end

function EquipOneKeyComposePanel:oneKeyBtnClick()

	if not model.MoneyModel:isEnough(self.costTotalCoin) then
		Prompt:Show(LANG.UI_EQUIP_41);
		return
	end
	self:onClickBack();
	
	local msg = {};
	msg.type = self.equipType;

	Network.NetworkManager:Send(Network.NetworkCmdType.req_equip_one_key_compose , msg);
end


function EquipOneKeyComposePanel:onClickBack()
	if self.updateEquip then
		EventManager:FireEvent(EventType.UIEquipComposeUpdateList);
	end
	UIManager:pop('EquipOneKeyComposePanel');
end

function EquipOneKeyComposePanel:onLeave()
	self.root:setVisible(false);
end

return EquipOneKeyComposePanel;
