local EquipWearBareLoveSelectPanel = class("EquipWearBareLoveSelectPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local homeImagePath = 'image/home/'

function EquipWearBareLoveSelectPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EquipWearBareLoveSelectPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function EquipWearBareLoveSelectPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function EquipWearBareLoveSelectPanel:initPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,705));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -12);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_ARENA_RANK_TITLE_1 , 606 , 63);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 372);

	self.title = titleNode:getChildByName('title');

	self.topTip = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,18)
		:addTo(self.root)
		:setPosition(0,308)
		:setTextColor(cc.c3b(255,255,0))

	self.curWearNode = cc.Node:create()
		:addTo(self.root)

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
		:addTo(self.curWearNode)
		:setPosition(0 , 178)
		:setCapInsets(cc.rect(11,11,34,28))
		:setContentSize(cc.size(582 , 197))

	local bg = cc.Sprite:create('image/fight/result/result_win_bg_1.png')
		:addTo(self.curWearNode)
		:setPosition(-133,254)

	local bg = cc.Sprite:create('image/fight/result/result_win_bg_1.png')
		:addTo(self.curWearNode)
		:setPosition(133,254)
		:setScaleX(-1)

	local label = cc.Label:createWithTTF(LANG.UI_EQUIP_46,fonts.FONT_SIYUAN,20)
		:addTo(self.curWearNode)
		:setPosition(0,254)

	self.curWearTemplate = template.BareLoveWearTemplate:create()
	self.curWearTemplate:addTo(self.curWearNode)
	self.curWearTemplate:setPosition(0,163)
	self.curWearTemplate:addBtnClickEventListener(handler(self , self.wearClick));

	self.listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
		:addTo(self.root)
		:setPosition(0 , -36)
    	:setCapInsets(cc.rect(11,11,34,28))
		:setContentSize(cc.size(582 , 626))
end

function EquipWearBareLoveSelectPanel:onEnter(pid , bareLoveType)
	self.pid = pid;
	self.bareLoveType = bareLoveType;

	self:onShow();

	self.root:setVisible(true);
	self:addSwallowCallback(handler(self , self.onClickBack));
end

function EquipWearBareLoveSelectPanel:onShow()
	local card = model.CardModel:GetCard(self.pid);

	if not card then
		UIManager:pop('EquipWearBareLoveSelectPanel');
		return
	end

	if self.bareLoveType == 1 then
		self.title:setString(LANG.UI_EQUIP_44);
		self.topTip:setString(LANG.UI_EQUIP_45);
	else
		self.title:setString(LANG.UI_EQUIP_49);
		self.topTip:setString(LANG.UI_EQUIP_51);
	end

	self:updateData();
end

function EquipWearBareLoveSelectPanel:updateData()
	local dataNum = 0;
	self.dataList = {};
	self.curWearData = nil;
	local card = model.CardModel:GetCard(self.pid);
	if self.bareLoveType == 1 then
		local loveDatas = model.CardModel:getLoveDataByRoleId(card.no);
		if loveDatas then
			for _k , data in pairs(loveDatas) do
				if data.loveId == card.love_id then
					self.curWearData = data;
				else
					table.insert(self.dataList,data);
				end
			end

			dataNum = #self.dataList;

			if dataNum > 1 then
				table.sort(self.dataList,function(firstData , secondData)
					if firstData.loveLevel ~= secondData.loveLevel then
						return firstData.loveLevel > secondData.loveLevel
					end

					return firstData.loveId < secondData.loveId;
				end);
			end
		end
	else
		local curWearBareId = card.bare_id;
		if self.bareLoveType == 3 then
			curWearBareId = card.bare_id_2;
		end
		local bareData = model.BareCollectModel:getBareData();
		for bareId , data in pairs(bareData) do
			table.insert(self.dataList,data);
			if bareId == curWearBareId then
				self.curWearData = data;
			end
		end

		dataNum = #self.dataList;

		if dataNum > 1 then
			table.sort(self.dataList,function(firstData , secondData)
				if firstData.activeState ~= secondData.activeState then
					return firstData.activeState > secondData.activeState
				end

				if firstData.pid == 0 and  secondData.pid ~= 0 then
					return true;
				elseif firstData.pid ~= 0 and  secondData.pid == 0 then
					return false;
				end

				if firstData.activeNum ~= secondData.activeNum then
					return firstData.activeNum > secondData.activeNum
				end

				return firstData.bare_id < secondData.bare_id;
			end);
		end
	end

	local listHeight = 626;
	local listPosY = -36;
	if self.curWearData then
		self.curWearNode:setVisible(true)
		self.curWearTemplate:Init(self.curWearData,self.bareLoveType);
		self.curWearTemplate:setTakeOff(true);
		if self.bareLoveType == 1 then
			self.curWearTemplate:setTag(self.curWearData.loveId);
		else 
			self.curWearTemplate:setTag(self.curWearData.bare_id);
		end

		listHeight = 414
		listPosY = -142
	else
		self.curWearNode:setVisible(false)
	end

	self.listBg:setContentSize(cc.size(582,listHeight));
	self.listBg:setPositionY(listPosY)
	
	if self.tableView then
		self.tableView:getView():removeFromParent()
		self.tableView = nil;
	end

	local tableViewWidth = listHeight-10;
	local initData = {
        width = 582,
        height = tableViewWidth,
        cellWidth = 582 ,
        cellHeight = 146,
		cellReloadFunc = handler(self,self.reloadCellPanel),
	}
	
    self.tableView = template.TableViewTemplate:create()
    self.tableView:initWithSizeAndItem(initData) ;
    self.tableView:getView():setPosition(cc.p(-291,listPosY-(tableViewWidth/2)));
	self.tableView:getView():addTo(self.root)

	self.tableView:setDataCount(dataNum);
	self.tableView:reloadData();
end

function EquipWearBareLoveSelectPanel:reloadCellPanel(cell , idx)

	local cellNode = cell:getChildByTag(999);
	if not cellNode then
		cellNode = template.BareLoveWearTemplate:create()
		cellNode:addTo(cell);
		cellNode:setTag(999);
		cellNode:setPosition(291,73)
		cellNode:addBtnClickEventListener(handler(self,self.wearClick))
	end

	local data = self.dataList[idx+1];
	cellNode:Init(data,self.bareLoveType);
	if self.bareLoveType == 1 then
		cellNode:setBtnTag(data.loveId);
	else
		cellNode:setBtnTag(data.bare_id);
	end

	return cell;
end

function EquipWearBareLoveSelectPanel:wearClick(wearType , id)
	if self.bareLoveType == 1 then--爱恋
		local msg = {};
		msg.pid = self.pid;
		if wearType == 1 then--穿戴
			msg.love_id = id;
			Network.NetworkManager:Send(Network.NetworkCmdType.req_love_wear, msg);
		else--卸下
			Network.NetworkManager:Send(Network.NetworkCmdType.req_love_takeoff, msg);
		end
	else--破衣
		local msg = {};
		msg.pid = self.pid;
		if self.bareLoveType == 3 then
			msg.idx = 2
		else
			msg.idx = 1
		end
		if wearType == 1 then--穿戴
			msg.bare_id = id;
			Network.NetworkManager:Send(Network.NetworkCmdType.req_bare_collect_wear, msg);
		else--卸下
			Network.NetworkManager:Send(Network.NetworkCmdType.req_bare_collect_takeoff, msg);
		end
	end

	self:onClickBack();
end

function EquipWearBareLoveSelectPanel:onClickBack()
	UIManager:pop('EquipWearBareLoveSelectPanel');
end

function EquipWearBareLoveSelectPanel:onLeave()
	self.root:setVisible(false);
end

return EquipWearBareLoveSelectPanel;
