local EventBattlePassGiftPanel = class('EventBattlePassGiftPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/battlePass/'

function EventBattlePassGiftPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EventBattlePassGiftPanel');

	self.useCCreator = false;
    self.isPopup = true;
    self.giftId = 0;
    self.lastGiftId = 0;
    self.giftData = nil;
    
end

function EventBattlePassGiftPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
  
      self:initPanel();
end

function EventBattlePassGiftPanel:initPanel(  )

    local bg = cc.Sprite:create('image/event/eventbp/bp_gift_bg.png');
    bg:addTo(self.root);

    local gift1Label = cc.Label:createWithTTF(LANG.UI_MAZE_56 ,fonts.FONT_SIYUAN,20)
        :enableOutline(cc.c3b(125,125,125),2)
        :addTo(self.root)
        :setPosition(0, -76)
        -- :setAnchorPoint(0, 0.5)
        -- :setTextColor(cc.c3b(255,255,0))

    self.giftView = ccui.ScrollView:create();
    self.giftView:setTouchEnabled(true);
    self.giftView:setBounceEnabled(true);
    self.giftView:setDirection(ccui.ScrollViewDir.horizontal);
    self.giftView:setContentSize(cc.size(380, 100));
    self.giftView:setAnchorPoint(cc.p(0.5, 0.5));
    self.giftView:setScrollBarEnabled(false);
    self.giftView:setPosition(0, -127)
    self.giftView:addTo(self.root);

    local gift2Label = cc.Label:createWithTTF(LANG.UI_MAZE_57 ,fonts.FONT_SIYUAN,20)
        :enableOutline(cc.c3b(125,125,125),2)
        :addTo(self.root)
        :setPosition(0, -210)
        -- :setAnchorPoint(0, 0.5)
        -- :setTextColor(cc.c3b(255,255,0))

    self.gift2View = ccui.ScrollView:create();
    self.gift2View:setTouchEnabled(true);
    self.gift2View:setBounceEnabled(true);
    self.gift2View:setDirection(ccui.ScrollViewDir.horizontal);
    self.gift2View:setContentSize(cc.size(380, 100));
    self.gift2View:setAnchorPoint(cc.p(0.5, 0.5));
    self.gift2View:setScrollBarEnabled(false);
    self.gift2View:setPosition(0, -265)
    self.gift2View:addTo(self.root);


    self.btnlabel = cc.Label:createWithTTF('' ,'font/SourceHanSansCN-Medium.otf',33)
        :enableOutline(cc.c3b(203,115,173),2)
    local btn = ccui.Button:create('image/event/eventbp/bp_btn.png','image/event/eventbp/bp_btn.png')
    btn:addTo(self.root)
    btn:setPosition(0,-410)
    btn:addClickEventListener(handler(self,self.battlepassGiftBuy))
    btn:setTitleLabel(self.btnlabel);

end

function EventBattlePassGiftPanel:onEnter()

    self:addSwallowCallback(handler(self , self.onClickBack))

    local battlepassId = model.EventModel:getBPData().battlepass_id;
    local battlepassGift = ResTable:getTable('maze_bp_gift').contain;
    for _k , data in pairs(battlepassGift) do
        if data.battlepass_id == battlepassId then
            self.giftId = data.no;
            self.giftData = data;
            break;
        end
    end

    if self.lastGiftId ~= self.giftId then
        self.giftView:removeAllChildren();
        local cnt = 0
        for k,v in pairs(self.giftData.gift) do
            local item=template.ItemTemplate:create()
            item:Init(v[1] , v[2]);
            item:setScale(0.6);
            item:addTo(self.giftView);
            item:setPosition(k*80-40,40)
            cnt = cnt + 1;
        end
        self.giftView:setInnerContainerSize(cc.size(cnt*80,100))

        self.gift2View:removeAllChildren();
        cnt = 0
        for k,v in pairs(self.giftData.gift2) do
            local item=template.ItemTemplate:create()
            item:Init(v[1] , v[2]);
            item:setScale(0.6);
            item:addTo(self.gift2View);
            item:setPosition(k*80-40,40)
            cnt = cnt + 1;
        end
        self.gift2View:setInnerContainerSize(cc.size(cnt*80,100))
    end

    local price = ResTable:getValue('price', self.giftData.price, CURRENCY) or 0;

    self.btnlabel:setString(tostring(string.format(LANG.UI_MAZE_59,tostring(price))));

    self.root:setVisible(true);
end

function EventBattlePassGiftPanel:battlepassGiftBuy(sender , event)
    local buyItem = {
        no = self.giftId,
        type = 8
    }
    EventManager:FireEvent('EventBattlePassPanel:buyBattlepassSpecial' , buyItem);
    self:onClickBack()
end


function EventBattlePassGiftPanel:onLeave()
    self.root:setVisible(false);
end

function EventBattlePassGiftPanel:onClickBack()
    UIManager:pop('EventBattlePassGiftPanel');
end

return EventBattlePassGiftPanel

