local EventBattlePassPanel = class('EventBattlePassPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/battlePass/'
local CommonShopType = Enum:getTable('CommonShopType');
local BATTLEPASS_MOVE_Y = 251;
local BATTLEPASS_VIEW_HEIGHT = StageSize.height-80 + BATTLEPASS_MOVE_Y;
local SHOP_SCROLL_VIEW_HEIGHT = 0;

function EventBattlePassPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EventBattlePassPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = false;
end

function EventBattlePassPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
  
      self:initPanel();
  
      self:registEvent();
end

function EventBattlePassPanel:initTopNode( parent )
    -- body
    local topNode = cc.Node:create()
    topNode:addTo( parent )
    topNode:setPosition(0, StageSize.height/2 -200 - NOTCH_HEIGHT)

    local bg = cc.Sprite:create('image/event/eventbp/bp_banner.png')
    bg:addTo(topNode);

    local label = cc.Label:createWithTTF(LANG.UI_MAZE_58,fonts.FONT_SIYUAN,20)
        :enableOutline(cc.c3b(145,40,40),2)
    self.bpSpecialBuyBtn = ccui.Button:create(imagePath..'battlepass_bg_5.png',imagePath..'battlepass_bg_5.png')
    self.bpSpecialBuyBtn:addTo(topNode)
    self.bpSpecialBuyBtn:setPosition(-169,-150)
    self.bpSpecialBuyBtn:setTitleLabel(label)
    self.bpSpecialBuyBtn:addClickEventListener(function() 
        UIManager:push('EventBattlePassGiftPanel');
    end)

    local bpCountdownNode = cc.Node:create()
        :addTo(topNode)
        :setPosition(154,-150)

    local bpCountdownBg = cc.Sprite:create(imagePath..'battlepass_bg_4.png')
        :addTo(bpCountdownNode)

    local bpCountdownLabel = cc.Label:createWithTTF(LANG.UI_BATTLEPASS_2 , fonts.FONT_SIYUAN , 18)
        :addTo(bpCountdownNode)
        :setPosition(0,21)
        :enableOutline(cc.c3b(0,0,0),2)

    self.bpCountdown = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
        :addTo(bpCountdownNode)
        :setPosition(0,-17)
        :setTextColor(cc.c3b(255,255,0))
        :enableOutline(cc.c3b(0,0,0),2)

    
    local bpLevelNode = cc.Node:create()
        :addTo(topNode)
        :setPosition(0,-280)
        :setLocalZOrder(5)

    local bpLevelBg = cc.Sprite:create(imagePath..'battlepass_bg_3.png')
        :addTo(bpLevelNode)

    local bpMsgLabel = cc.Label:createWithTTF(LANG.UI_MAZE_53 , fonts.FONT_SIYUAN , 25)
        :addTo(bpLevelNode)
        :setPosition(-240,18)
        :setAnchorPoint(0, 0.5)
        :enableOutline(cc.c3b(0,0,0),2)

    local bpLevelIcon = cc.Sprite:create('image/event/eventbp/bp_icon.png')
        :addTo(bpLevelNode)
        :setPosition(50,18)
        :setScale(0.7)

    -- local bpLevelProgressBg = cc.Sprite:create(imagePath..'battlepass_bg_7.png')
    --     :addTo(bpLevelNode)
    --     :setPosition(0,17)
    
    -- self.bpLevelProgress = cc.Scale9Sprite:create(imagePath..'battlepass_bg_14.png')
    -- self.bpLevelProgress:addTo(bpLevelNode)
    -- self.bpLevelProgress:setAnchorPoint(0,0.5)
    -- self.bpLevelProgress:setPosition(-197,17)
    -- self.bpLevelProgress:setCapInsets(cc.rect(10,0,4,13))

    -- self.bgLevelExp = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
    --     :addTo(bpLevelNode)
    --     :setPosition(0,8)
    --     :enableOutline(cc.c3b(120,80,60) , 2)

    -- local bpLevelBg = cc.Sprite:create(imagePath..'battlepass_bg_6.png')
    --     :addTo(bpLevelNode)
    --     :setPosition(239,18)

    self.bpNumLabel = cc.Label:createWithTTF('50000' , fonts.FONT_SIYUAN , 25)
        :addTo(bpLevelNode)
        :setPosition(100,18)
        :setAnchorPoint(0, 0.5)
        :enableOutline(cc.c3b(0,0,0),2)

    local bpRwdTitleNode = cc.Node:create()
        :addTo(topNode)
        :setPosition(0,-400)
        :setLocalZOrder(2)

    local bpRwdTitleBg = cc.Sprite:create('image/event/eventbp/bp_title_bg.png')
        :addTo(bpRwdTitleNode)
        :setFlipX(true)

    local lable = cc.Label:createWithTTF(LANG.UI_MAZE_58 , fonts.FONT_SIYUAN , 20)
            :addTo(bpRwdTitleNode)
            :setPosition(-160,5)
            :setTextColor(cc.c3b(255,220,110))
            :enableOutline(cc.c3b(65,45,40),1)

    local lable = cc.Label:createWithTTF(LANG.UI_FIGHT_65 , fonts.FONT_SIYUAN , 20)
        :addTo(bpRwdTitleNode)
        :setPosition(160,5)
        :enableOutline(cc.c3b(0,0,0),1)

end

function EventBattlePassPanel:initPanel()
    -- body
    local newRoot = cc.Node:create()
    newRoot:addTo(self.root)
    newRoot:setLocalZOrder(0)

    local bg = cc.Sprite:create('image/bg/Bg_5.png')
    bg:addTo(newRoot)

    local bottomHeight = StageSize.height-430- NOTCH_HEIGHT;
    local scorllWidth = StageSize.width

    self.scorllview = ccui.ScrollView:create();
    self.scorllview:setTouchEnabled(true);
    self.scorllview:setBounceEnabled(true);
    self.scorllview:setDirection(ccui.ScrollViewDir.vertical);
    self.scorllview:setContentSize(cc.size(scorllWidth , bottomHeight));
    self.scorllview:setAnchorPoint(cc.p(0,0));
    self.scorllview:setScrollBarEnabled(false);
    self.scorllview:setPosition(-scorllWidth/2 , -bottomHeight/2);
    self.scorllview:addTo(newRoot);

    self:initTopNode( newRoot )
    self.battlePassCell = {}
    self:initList();

end

function EventBattlePassPanel:registEvent()
    EventManager:RegisterEvent(EventType.NetworkRetBattlepassData, handler(self, self.onShow));
    EventManager:RegisterEvent('EventBattlePassPanel:retBattlepassReward', handler(self, self.retBattlepassReward));
    EventManager:RegisterEvent('EventBattlePassPanel:buyBattlepassSpecial', handler(self, self.buyBattlepassSpecial));
end

function EventBattlePassPanel:onEnter()
    self:updateRwdList()
    self.bpNumLabel:setString( model.EventModel:getEventBPPoint() )
    self:updateBattlepass();
    self.root:setVisible(true)
end

function EventBattlePassPanel:initList()
    local totalH = 86
    local baseBagPos = 0;
    local scorllWidth = StageSize.width;

    local rwdList = model.EventModel:getBPRwdList();
    for k,data in pairs(rwdList) do
        if data then
            local cell = cc.Node:create()
            cell:setPosition(scorllWidth/2, totalH)
            cell:addTo(self.scorllview)

            local cellNode = template.EventBattlePassItemCell:create();
            cellNode:addTo(cell)
            cellNode:Init(data);
            cellNode:addBattlepassClickEventListener(handler(self , self.battlepassRewardClick));
            self.battlePassCell[data.no] = cellNode;

            totalH = totalH + 172
            if false then 
                baseBagPos = totalH;
            end

        end
    end
    totalH = totalH-86

    local footerHeight = 0
    -- local tmpTop = StageSize.height/2 -120 - NOTCH_HEIGHT
    local tmpTop = StageSize.height/2 -537 - 97 - NOTCH_HEIGHT
    local lastHeight = tmpTop + StageSize.height/2 - footerHeight; --剩余高度空间 120是footer高度

    self.scorllview:setInnerContainerSize(cc.size(scorllWidth, totalH));

    self.baseBagPos = 0;
    if totalH > lastHeight then
        self.scorllview:setPosition(-scorllWidth/2 , -StageSize.height/2 + footerHeight);
        self.scorllview:setContentSize(cc.size(scorllWidth , lastHeight));
        if baseBagPos >= lastHeight then
            self.baseBagPos = (totalH-baseBagPos)/(totalH-lastHeight)*100;
        else
            self.baseBagPos = 100;
        end

    else
        -- for k,v in pairs(self.battlePassCell) do
        --     local x,y = v.cellNode:getPosition()
        --     v.cellNode:setPosition(x, y+(lastHeight-totalH))
        -- end
        totalH = lastHeight
        self.scorllview:setPosition(-scorllWidth/2 , -StageSize.height/2+(lastHeight-totalH) + footerHeight);
        self.scorllview:setContentSize(cc.size(scorllWidth , totalH));
        self.scorllview:setInnerContainerPosition(cc.p(0,0))
        
    end
    
    if false then
        self.scorllview:jumpToPercentVertical( self.baseBagPos );
    end

end

function EventBattlePassPanel:updateRwdList()
    local rwdList = model.EventModel:getBPRwdList();
    for k,data in pairs(rwdList) do
        if data then
            self.battlePassCell[data.no]:updateInfo(data)
        end
    end
end

function EventBattlePassPanel:updateBattlepass()

    TimeManager:registUpdateEvent('EventBattlePassPanel',nil,true);
    self:updateBattlepassTime()
    self:updateCurBattlepassData();
    TimeManager:registUpdateEvent('EventBattlePassPanel',handler(self,self.updateBattlepassTime),true);
end

function EventBattlePassPanel:updateCurBattlepassData()
    local specialState = model.EventModel:getBPData().special_state;
    self.bpSpecialBuyBtn:setVisible(specialState ~= 1);

    -- local curBattlepassNo = model.EventModel:getBPData().curLimitRwdId;
    -- local curBattlepass = model.EventModel:getBPRwdList(curBattlepassNo)

    -- if curBattlepass then
        -- self.bpLevel:setString(tostring(curBattlepass.level));
        -- local curPointNum = model.EventModel:getEventBPPoint()
        -- local percent = curPointNum/curBattlepass.total_point;
        -- percent = math.max(percent,0);
        -- percent = math.min(percent,1);
        -- self.bpLevelProgress:setContentSize(cc.size(394*percent , 13));

        -- self.bgLevelExp:setString(string.format('%d/%d',curPointNum,curBattlepass.total_point));
    -- end
end

function EventBattlePassPanel:updateBattlepassTime()
    local endTime = model.EventModel:getBPData().show_time;
    local lastTime = endTime - TimeManager:getCurTime()
    if lastTime > 86400 then
        local day = math.floor(lastTime / 86400);
        local hour = math.floor((lastTime - day * 86400) / 3600);
        lastTime = day..LANG.UI_MISSION_21..hour..LANG.UI_MISSION_22
    else
        lastTime = Sec2Time(math.floor(lastTime));
    end
    self.bpCountdown:setString(' '..tostring(lastTime));
end

function EventBattlePassPanel:battlepassRewardClick(rType , no)
    local rewardData = model.EventModel:getBPRwdList(no);

    if rType == 2 then
        local specialState = model.EventModel:getBPData().special_state;
        if specialState == 0 then
            Prompt:Show(LANG.UI_MAZE_54);
            return;
        end

        if rewardData.reward_special_state == 1 then
            Prompt:Show(LANG.UI_MISSION_26);
            return;
        end
    else
        if rewardData.reward_free_state == 1 then
            Prompt:Show(LANG.UI_MISSION_26);
            return;
        end
    end

    local curPointNum = model.EventModel:getEventBPPoint()
    if curPointNum < rewardData.total_point then
        Prompt:Show(LANG.UI_MAZE_52);
        return;
    end
    Network.NetworkManager:Send(Network.NetworkCmdType.req_event_bp_reward, {rewardType = rType , no = no});
end

function EventBattlePassPanel:retBattlepassReward(msg)
    if msg.no and self.battlePassCell[msg.no] then
        local data = model.EventModel:getBPRwdList(msg.no);
        self.battlePassCell[msg.no]:updateGetState(data);
    end
    UIManager:push('RewardPanel',msg)
end

function EventBattlePassPanel:buyBattlepassSpecial(data)
    sdkManager.PaymentHelper:onPayment(data,handler(self,self.retBuyBattlepassSpeical));
end

function EventBattlePassPanel:retBuyBattlepassSpeical(msg)
    self:updateCurBattlepassData()
    self.bpNumLabel:setString( model.EventModel:getEventBPPoint() )
    self:updateRwdList();
    UIManager:push('RewardPanel',msg)
end

function EventBattlePassPanel:onLeave()
    self.root:setVisible(false);
end

function EventBattlePassPanel:onClickBack()
    UIManager:pop('EventBattlePassPanel');
    TimeManager:registUpdateEvent('EventBattlePassPanel',nil,true);
end

return EventBattlePassPanel

