local EventBuffPanel = class("EventBuffPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local imagePath = 'image/event/';


function EventBuffPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EventBuffPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function EventBuffPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function EventBuffPanel:initPanels()

	local bg = cc.Scale9Sprite:create('image/commonImg/common_tips_bg.png');
	bg:addTo(self.root);
	bg:setContentSize(cc.size(604 , 950));

	GlobalFunctions:createTitleNode( bg, LANG.UI_MAZE_10, '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.root);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(582 , 806));

	self.buffView = ccui.ScrollView:create();
	self.buffView:setTouchEnabled(true);
	self.buffView:setBounceEnabled(true);
	self.buffView:setDirection(ccui.ScrollViewDir.vertical);
	self.buffView:setContentSize(cc.size(582, 806));
	self.buffView:setAnchorPoint(cc.p(0.5, 0.5));
	self.buffView:setScrollBarEnabled(false);
	self.buffView:addTo(self.root);

	self.infoLabel = cc.Label:createWithTTF(LANG.UI_MAZE_12, fonts.FONT_SIYUAN, 20)
		:setTextColor(cc.c3b(250, 255, 0))
		:setPosition(10, -440)
		:addTo(self.root)
	local tipSpr = cc.Sprite:create('image/commonImg/tip_2.png')
	tipSpr:addTo(self.root)
	tipSpr:setPosition( -10-self.infoLabel:getContentSize().width/2, -440 )
end

function EventBuffPanel:onEnter()
	local buffs = model.EventModel:getBuff();

	if not buffs then
		self:onClickBack();
		return;
	end

	local buffNum = #buffs;
	if buffNum > 1 then
		table.sort(buffs,function(first , second) 
			local firstData = ResTable:getRowData('maze_buff',first);
			local secondData = ResTable:getRowData('maze_buff',second);
			if firstData.quality ~= secondData.quality then
				return firstData.quality > secondData.quality;
			end
			return first > second;
			
		end);
	end
	
	local maxWidth = 582;
	local maxHeight = math.ceil(buffNum / 3)*340;
	maxHeight = maxHeight < 806 and 806 or maxHeight;

	self.buffView:removeAllChildren();
	self.buffView:setInnerContainerSize(cc.size(maxWidth , (maxHeight)));

	for i=1, buffNum do
		local col = (i-1) % 3;
		local row = math.floor((i-1) / 3);

		local buff = buffs[i];
		local icon = template.EventBuffBigTemplate:create();
		icon:Init(buff);
		icon:addTo(self.buffView);
		icon:setScale(0.8)
		icon:setPosition(100 + 191 * col , maxHeight - 170 - 300 *row);
	end

	self.root:setVisible(true);
	self:addSwallowCallback(handler(self , self.onClickBack));
end

function EventBuffPanel:onClickBack()
	UIManager:pop('EventBuffPanel');
end

function EventBuffPanel:onLeave()
	self.root:setVisible(false);
end

return EventBuffPanel;
