local EventBuffSelectPanel = class("EventBuffSelectPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local imagePath = 'image/event/eventBuff/';


function EventBuffSelectPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EventBuffSelectPanel');

	self.useCCreator = false;
	self.isPopup = true;
	
end

function EventBuffSelectPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function EventBuffSelectPanel:initPanels()

    local buffItemsNode = cc.Node:create()
    buffItemsNode:addTo(self.root)

    local buffAniNode = cc.Node:create()
    buffAniNode:addTo(self.root)

	-- local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	-- bg:addTo(self.root);
	-- bg:setPosition(0 , -27);
 --    bg:setCapInsets(cc.rect(11,11,34,28));
	-- bg:setContentSize(cc.size(582 , 390));

	self.buffList = {};
	self.btnList = {};
	self.bufAniList = {}
	for i = 1 , 3 do
		local template = template.EventBuffBigTemplate:create();
		template:setPosition(-200 + 200 * (i-1) , -3);
		template:addTo(buffItemsNode);
		self.buffList[i] = template;

    	local buffSelectBtn = ccui.Button:create('image/commonImg/common_item_select.png', 'image/commonImg/common_item_select.png', 'image/commonImg/common_item_select.png');
    	buffSelectBtn:addTo(self.root);
    	buffSelectBtn:setScale9Enabled(true)
    	buffSelectBtn:setContentSize(cc.size(200, 370))
    	buffSelectBtn:addClickEventListener(handler(self , self.buffClick));
    	buffSelectBtn:setPosition(-200 + 200 * (i-1),-3);
		buffSelectBtn:setTitleLabel(label);
		buffSelectBtn:setTag(i);
		buffSelectBtn:setOpacity(0)

		local spine_res = 'buffchoose_spine'
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			local addAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			addAnimation:addTo(buffAniNode)
			addAnimation:setPosition(-200 + 200 * (i-1),-3)
			addAnimation:setAnimation(0,'idle3',true);
			addAnimation:setVisible(false)
			self.bufAniList[i] = addAnimation;
	    end

		self.btnList[i] = buffSelectBtn;
		
	end

	local spine_res = 'buffchoose_spine'
	self.chooseAni = nil
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local addAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		addAnimation:addTo(self.root)
		addAnimation:registerSpineEventHandler(function (event)
			if event.animation == 'choose' then
				self.chooseAni:setAnimation(0, "idle1", true)
			end	
		end, sp.EventType.ANIMATION_COMPLETE)
		self.chooseAni = addAnimation;
    end

	local spine_res = 'buffchoose_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local addAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		addAnimation:addTo(self.root)
		self.selBtnAni = addAnimation
		addAnimation:setPosition(0,-240)
		addAnimation:registerSpineEventHandler(function (event)
			if event.eventData.name == 'appear' then
				self.selBtn:setVisible(true);
			end
		end, sp.EventType.ANIMATION_EVENT);

		addAnimation:registerSpineEventHandler(function (event)
			if event.animation == 'appear' then
				self.selBtnAni:setAnimation(0, "idle2", true)
			end	
		end, sp.EventType.ANIMATION_COMPLETE)
    end

    local label = cc.Label:createWithTTF(LANG.COMMON_OK ,  fonts.FONT_SIYUAN , 20)
    label:enableOutline(cc.c3b(145 , 40 , 40),2);
	self.selBtn = ccui.Button:create(imagePath..'buff_btn.png' , imagePath..'buff_btn.png');
    self.selBtn:addTo(self.root);
    self.selBtn:addClickEventListener(handler(self , self.selectBuffClick));
    self.selBtn:setPosition(0,-255);
	self.selBtn:setTitleLabel(label);

	local titleBg = cc.Sprite:create(imagePath..'title_bg.png')
	titleBg:addTo(self.root)
	titleBg:setPosition(0, 223)

	local tlabel = cc.Label:createWithTTF(LANG.UI_MAZE_15 ,  fonts.FONT_SIYUAN , 20)
    tlabel:enableOutline(cc.c4b(10 , 60 , 150 , 255),2);
    tlabel:addTo(self.root)
    tlabel:setPosition(0, 223)

end

function EventBuffSelectPanel:onEnter(tid, bclick)--buffs

	self:addSwallowCallback(handler(self, self.onClickBack));
	self.tid = tid;
	self.bclick = bclick or true
	print('fubin---buffselectpanel:', self.bclick)
	EventManager:RegisterEvent(EventType.UIUpdateEventBuff , handler(self, self.updateEventBuff));

	for i = 1 , 3 do
		self.buffList[i]:setVisible(false)
	end

	self.buffs = model.EventModel:getFightBuffsById(self.tid);
	if self.buffs == nil then
	else
		self:updateEventBuff();
	end

	self.selectIndex = -1;
	for k,v in pairs(self.btnList) do
		v:setOpacity(0)
	end
	self.selBtn:setVisible(false)
	self.selBtnAni:setVisible(false)
	self.chooseAni:setVisible(false)

	self.root:setVisible(true);
end

function EventBuffSelectPanel:updateEventBuff()
	-- body
	if self.buffs == nil then
		self.buffs = model.EventModel:getFightBuffsById(self.tid);
	end
	for i = 1 , 3 do
		self.buffList[i]:setVisible(true)
		if self.buffs[i] then
			local quality = self.buffList[i]:Init(self.buffs[i]);
			if quality == 3 then
				self.bufAniList[i]:setVisible(true)
			else
				self.bufAniList[i]:setVisible(false)
			end
		end
	end

end

function EventBuffSelectPanel:buffClick(sender , event)
	local index = sender:getTag();
	if index == self.selectIndex then
		return
	end
	self.selectIndex = index;

	for k,v in pairs(self.btnList) do
		if k ==  self.selectIndex then
			v:setOpacity(255)
		else
			v:setOpacity(0)
		end
	end
	self.chooseAni:setPosition( self.bufAniList[self.selectIndex]:getPosition() )
	self.chooseAni:setVisible(true)
	self.chooseAni:setAnimation(0,'choose',false);

	local sX,sY = self.btnList[self.selectIndex]:getPosition()
	self.selBtn:setVisible(false)
	self.selBtn:setPosition(sX, -240)

	self.selBtnAni:setPosition(sX, -240)
	self.selBtnAni:setAnimation(0, "appear", false)

	-- if self.selBtnAni:isVisible() == false then
	-- 	self.selBtnAni:setVisible(true)
	-- 	self.selBtnAni:setAnimation(0, "appear", false)
	-- end

end

function EventBuffSelectPanel:selectBuffClick()
	if self.bclick==false then
		Prompt:Show(LANG.UI_EVENT_CLICK);
		return;
	end
	
	if self.selectIndex == -1 then
		return;
	end

	if self.buffs[self.selectIndex] then
		model.EventModel:reqEventMapFightBuff(self.buffs[self.selectIndex], self.tid, self.selectIndex);
		self:onClickBack()
	end
end

function EventBuffSelectPanel:onClickBack()
	UIManager:pop('EventBuffSelectPanel')
end

function EventBuffSelectPanel:onLeave()
	EventManager:UnregisterEvent(EventType.UIUpdateEventBuff)
	self.root:setVisible(false);
end

return EventBuffSelectPanel;
