local EventItemPanel = class("EventItemPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/setup/'
local MessageBoxType = Enum:getTable('MessageBoxType')

function EventItemPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SettingPanel');

	self.useCCreator = false;
	self.isPopup = true;
end


function EventItemPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function EventItemPanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 630))
	:setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, LANG.UI_MAZE_39, '',  bg:getContentSize().width/2, bg:getContentSize().height -36 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(582 , 438));
	bg1:setPosition(cc.p(0 , 0));
	bg1:addTo(self.root);

	local initData = {
		width = 580,
		height = 430,
		cellWidth = 580,
		cellHeight = 110,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-290, -215);
	self.selListView:getView():addTo(self.root)
	self.selListView:getView():setVisible(true)

	local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	local btn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
	btn:addTo(self.root);
	btn:setPosition(0, -265)
	btn:addClickEventListener(handler(self, self.clickBtn));
	btn:setTitleLabel(label);

	self.dataList = {}
	
end

function EventItemPanel:onEnter(sid)
	self.sid = sid;
	self.pid = -1

	local itemId = model.EventModel.EVENT_ITEMID_1;
	local itemData = model.ItemModel:getItem(itemId);

	local testData= { 	{itemId, itemData.num}
					}

	self.dataList = {}
	local cellData = {}

	for k, v in pairs(testData) do
		
		table.insert(cellData, v)
		if #cellData==5 then
			table.insert(self.dataList, cellData)
			cellData = {}
		end
	end

	if #cellData>0 then
		table.insert(self.dataList, cellData)
		cellData = {}
	end

	self.selListView:reloadData(self.dataList);

	self:addSwallowCallback(handler(self, self.onClickBack));

	self.root:setVisible(true);
end

function EventItemPanel:onClickBack()
	UIManager:pop('EventItemPanel');
end

function EventItemPanel:onLeave()
	self.root:setVisible(false);
end

function EventItemPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.CommonRowItemCell:create(cell);
		cellNode:setTag(999);
		cellNode:setCallBack(handler(self, self.openUseItemPanel))
    end

    if self.dataList[index+1] then
    	cellNode:initData( self.dataList[index+1], 0 );
    end
end

function EventItemPanel:cellItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
    end
end

function EventItemPanel:openUseItemPanel( itemid )
	UIManager:pop('EventItemPanel');
	UIManager:push('EventItemUsePanel', itemid)
end

function EventItemPanel:clickBtn()
	UIManager:pop('EventItemPanel');
end

return EventItemPanel;
