local EventItemUsePanel = class("EventItemUsePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/setup/'
local MessageBoxType = Enum:getTable('MessageBoxType')

function EventItemUsePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SettingPanel');

	self.useCCreator = false;
	self.isPopup = true;
end


function EventItemUsePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function EventItemUsePanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 630))
	:setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, LANG.UI_L_TOOLS_1, LANG.UI_L_TOOLS_2,  bg:getContentSize().width/2, bg:getContentSize().height -36 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(582 , 396));
	bg1:setPosition(cc.p(0 , 20));
	bg1:addTo(self.root);

	local bg2 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg2:setContentSize(cc.size(549 , 304));
	bg2:setPosition(cc.p(0 , -20));
	bg2:addTo(self.root);

	self.tipLabel = cc.Label:createWithTTF(LANG.UI_MAZE_13 , fonts.FONT_SIYUAN , 20);
	self.tipLabel:addTo(self.root)
	self.tipLabel:setAnchorPoint(cc.p(0.5,0.5))
	self.tipLabel:setDimensions(500, 0)
	self.tipLabel:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER);
	self.tipLabel:setPosition(0,180)

	local initData = {
		width = 540,
		height = 300,
		cellWidth = 540,
		cellHeight = 150,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-270, -170);
	self.selListView:getView():addTo(self.root)
	self.selListView:getView():setVisible(true)

	local costNode = cc.Node:create()
	:addTo(self.root)
	:setPosition(0, -200)

	local costBg = cc.Sprite:create('image/commonImg/com_bg.png')
	:addTo(costNode)
	:setContentSize(cc.size(211 , 42));

	self.costIcon = cc.Sprite:create('image/head/header_bg_9.png')
	:addTo(costNode)
	:setPosition(-80, 0)
	:setScale(0.3)
	local tmpLabel = cc.Label:createWithTTF(LANG.UI_HOME_37 , fonts.FONT_SIYUAN , 20)
	:addTo(costNode)
	:setTextColor(cc.c3b(165 , 200 , 255))
	:setAnchorPoint(cc.p(0,0.5))
	:setPosition(-60,0)

	self.costLabel = cc.Label:createWithTTF('99999' , fonts.FONT_SIYUAN , 20)
	:addTo(costNode)
	:setPosition(40,0)

	local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	local btn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
	btn:addTo(self.root);
	btn:setPosition(0, -265)
	btn:addClickEventListener(handler(self, self.clickBtn));
	btn:setTitleLabel(label);

	self.dataList = {}
	
end

function EventItemUsePanel:onEnter(tid)
	self.toolId = tid;

	self.dataList = {}
	local cellData = {}

	local cards = model.CardModel:GetAllCard()

	for k, v in pairs(cards) do
		if v.level >= 60 then --and v.event_hp<10000
			table.insert(cellData, v.pid)
			if #cellData==4 then
				table.insert(self.dataList, cellData)
				cellData = {}
			end
		end
	end

	if #cellData>0 then
		table.insert(self.dataList, cellData)
		cellData = {}
	end

	self.selListView:reloadData(self.dataList);

	local data = ResTable:getRowData('item', self.toolId)
	if data then
		self.costIcon:setTexture("image/icon/I"..data.icon..".png")
	end
	local itemData = model.ItemModel:getItem(self.toolId);
	self.costLabel:setString(itemData.num)

	self.root:setVisible(true);

	self:addSwallowCallback(handler(self, self.onClickBack));
end

function EventItemUsePanel:onClickBack()
	UIManager:pop('EventItemUsePanel');
	-- UIManager:push('EventItemPanel');
end

function EventItemUsePanel:onLeave()
	self.root:setVisible(false);
end

function EventItemUsePanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.EventUseToRoleCell:create(cell);
		cellNode:setTag(999);
    end

    if self.dataList[index+1] then
    	cellNode:initData( self.dataList[index+1], self.tid );
    end
end

function EventItemUsePanel:cellItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
    end
end

function EventItemUsePanel:clickBtn()
	if next(self.dataList) then
		model.EventModel:useItem( self.toolId )
	end
	UIManager:pop('EventItemUsePanel');
	-- UIManager:push('EventItemPanel');
end

return EventItemUsePanel;
