local EventMsgTipPanel = class('EventMsgTipPanel', require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');

function EventMsgTipPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'EventMsgTipPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.isPopup = true;
end

function EventMsgTipPanel:Init(root)
	self.root = root;
	self.root:setVisible(false)

	self:InitPanel()
end

function EventMsgTipPanel:InitPanel()

	self.boxBg = ccui.Layout:create();
	self.boxBg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png')
	self.boxBg:setBackGroundImageScale9Enabled(true)
	self.boxBg:setBackGroundImageCapInsets(cc.rect(11,4,18,21))
	self.boxBg:setContentSize(cc.size(602,317));
	self.boxBg:setTouchEnabled(true);
	self.boxBg:setAnchorPoint(cc.p(0.5,0.5));
	self.boxBg:setPosition(0, 42.5);
	self.boxBg:addTo(self.root);

    self.boxBg1 = ccui.Layout:create();
	self.boxBg1:setBackGroundImage('image/commonImg/bg_1_11_11_34_28.png')
	self.boxBg1:setBackGroundImageScale9Enabled(true)
	self.boxBg1:setBackGroundImageCapInsets(cc.rect(11,11,34,28))
	self.boxBg1:setContentSize(cc.size(582,186));
	self.boxBg1:setTouchEnabled(true);
	self.boxBg1:setAnchorPoint(cc.p(0.5,0.5));
	self.boxBg1:setPosition(0, 65);
	self.boxBg1:addTo(self.root);

	self.okBtn = ccui.Button:create('res/image/commonImg/btn_1_219_55.png' , 'res/image/commonImg/btn_1_219_55.png');
	self.okBtn:addTo(self.root);
	self.okBtn:addClickEventListener(handler(self, self.OkClick));
	self.okBtn:setPosition(0, -75);
	local okLabel = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20);
	okLabel:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2);
	self.okBtn:setTitleLabel(okLabel);

	-- self.cancelBtn = ccui.Button:create('res/image/commonImg/btn_1_219_55_2.png' , 'res/image/commonImg/btn_1_219_55_2.png');
	-- self.cancelBtn:addTo(self.root);
	-- self.cancelBtn:addClickEventListener(handler(self, self.CancelClick));
	-- self.cancelBtn:setPosition(0, -100);
	-- local cancelLabel = cc.Label:createWithTTF(LANG.COMMON_CANCEL , fonts.FONT_SIYUAN , 20);
	-- cancelLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	-- self.cancelBtn:setTitleLabel(cancelLabel);

	self.midText = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
	self.midText:addTo(self.root);
	self.midText:setPosition(0,70);
	self.midText:setMaxLineWidth(450);
	self.midText:setTextColor(cc.c3b(165, 200, 255));
	self.midText:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)


	local titleBg = cc.Sprite:create('image/commonImg/com_title_bg.png')
	titleBg:addTo(self.root)
	titleBg:setPosition(0, 205)

	self.tlabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 24)
    self.tlabel:enableOutline(cc.c4b(10 , 60 , 150 , 255),2);
    self.tlabel:addTo(self.root)
    self.tlabel:setPosition(0, 205)

    self.tIcon = cc.Sprite:create()
    self.tIcon:setPosition(-180, 205)
    self.tIcon:addTo(self.root)

end

function EventMsgTipPanel:onEnter(data)
	self:addSwallowCallback(handler(self, self.onClickBack));
	self.root:setVisible(true)

	if data.callback then
		self.callback = data.callback
	else
		self.callback = nil
	end
	if data.cancelCallback then
		self.cancelCallback = data.cancelCallback;
	end

	self:updateInfo(data);
end

function EventMsgTipPanel:onLeave()
	self.root:setVisible(false)
end

function EventMsgTipPanel:onClickBack()
	UIManager:pop('EventMsgTipPanel');
end

function EventMsgTipPanel:updateInfo(data)

	self.tlabel:setString( data.title )
	self.midText:setString( data.info )
	if data.icon==nil or data.icon == '' then
		self.tIcon:setVisible(false)
	else
		self.tIcon:setVisible(true)
		self.tIcon:setTexture(data.icon)
	end
end

function EventMsgTipPanel:OkClick()
	AudioManager:playEffect(Conf.confirmButton)
	if self.callback then
		self.callback();
		self.callback = nil;
	end
	self:onClickBack()
end
function EventMsgTipPanel:CancelClick()
	AudioManager:playEffect(Conf.cancleButton)
	if self.cancelCallback then
		self.cancelCallback();
		self.cancelCallback = nil;
	end
	self:onClickBack()
end

return EventMsgTipPanel
