local EventResultPanel = class("EventResultPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");

function EventResultPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EventResultPanel');

	self.useCCreator = false;
	self.isPopup = true;
end


function EventResultPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function EventResultPanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 506))
	:setPosition(0, -110)
	:setTouchEnabled(true);

	local infoNode = cc.Node:create();
	infoNode:addTo(self.root)
	local infoBg = cc.Sprite:create('image/event/e_result.png')
	infoBg:addTo(infoNode);

	local i1Icon = cc.Sprite:create('image/commonImg/fight_icon.png')
	i1Icon:addTo(infoNode)
	i1Icon:setPosition(-240, 60)
	local t1Label = cc.Label:createWithTTF(LANG.UI_MAZE_45 ,  fonts.FONT_SIYUAN , 20)
    -- t1Label:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    t1Label:addTo(infoNode)
    t1Label:setAnchorPoint(0, 0.5)
    t1Label:setPosition(-220, 60);
	self.mNumLable = cc.Label:createWithTTF('888' ,  fonts.FONT_SIYUAN , 20)
    self.mNumLable:addTo(infoNode)
    self.mNumLable:setAnchorPoint(1, 0.5)
    self.mNumLable:setPosition(250, 60);


    local t2Label = cc.Label:createWithTTF(LANG.UI_MAZE_48 ,  fonts.FONT_SIYUAN , 20)
    t2Label:addTo(infoNode)
    t2Label:setAnchorPoint(0.5, 0.5)
    t2Label:setPosition(20, 15);
	self.b1NumLable = cc.Label:createWithTTF('888' ,  fonts.FONT_SIYUAN , 20)
    self.b1NumLable:addTo(infoNode)
    self.b1NumLable:setAnchorPoint(1, 0.5)
    self.b1NumLable:setPosition(250, 15);

    local t3Label = cc.Label:createWithTTF(LANG.UI_MAZE_49 ,  fonts.FONT_SIYUAN , 20)
    t3Label:addTo(infoNode)
    t3Label:setAnchorPoint(0.5, 0.5)
    t3Label:setPosition(20, -27);
	self.b2NumLable = cc.Label:createWithTTF('888' ,  fonts.FONT_SIYUAN , 20)
    self.b2NumLable:addTo(infoNode)
    self.b2NumLable:setAnchorPoint(1, 0.5)
    self.b2NumLable:setPosition(250, -27);

    local t4Label = cc.Label:createWithTTF(LANG.UI_MAZE_50 ,  fonts.FONT_SIYUAN , 20)
    t4Label:addTo(infoNode)
    t4Label:setAnchorPoint(0.5, 0.5)
    t4Label:setPosition(20, -69);
	self.b3NumLable = cc.Label:createWithTTF('888' ,  fonts.FONT_SIYUAN , 20)
    self.b3NumLable:addTo(infoNode)
    self.b3NumLable:setAnchorPoint(1, 0.5)
    self.b3NumLable:setPosition(250, -69);

    local i2Icon = cc.Sprite:create('image/commonImg/fight_icon.png')
	i2Icon:addTo(infoNode)
	i2Icon:setPosition(-240, -27)
	local t5Label = cc.Label:createWithTTF(LANG.UI_MAZE_46 ,  fonts.FONT_SIYUAN , 20)
    t5Label:addTo(infoNode)
    t5Label:setAnchorPoint(0, 0.5)
    t5Label:setPosition(-220, -27);


    local dropSp1 = cc.Sprite:create('image/fight/roundInfo/round_info_2.png')
	dropSp1:addTo(self.root)
	dropSp1:setPosition(0, -130)
	local label = cc.Label:createWithTTF(LANG.UI_MAZE_47, fonts.FONT_SIYUAN, 20)
	label:setPosition(0,-130)
	label:addTo(self.root)

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(582 , 195));
	bg1:setPosition(cc.p(0 , -250));
	bg1:addTo(self.root);

	local initData = {
		width = 580,
		height = 190,
		cellWidth = 580,
		cellHeight = 110,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-290, -345);
	self.selListView:getView():addTo(self.root)
	self.selListView:getView():setVisible(true)

	-- local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	-- :enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	-- local btn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
	-- btn:addTo(self.root);
	-- btn:setPosition(0, -400)
	-- btn:addClickEventListener(handler(self, self.clickBtn));
	-- btn:setTitleLabel(label);


	self.titleEffect = DragonBonesManager:GetUIEffect('tongguan');
	self.titleEffect:setPosition(0, 260);
	self.titleEffect:addTo(self.root);

	self.dataList = {}

	EventManager:RegisterEvent('EventType.EventResultPanel', handler(self, self.updateInfo));
	
end

function EventResultPanel:onEnter()

	local resultData = model.EventModel:getEventResultData()
	if resultData==nil then
		model.EventModel:reqEventResultData()
		return
	end

	self:updateInfo()
	
end

function EventResultPanel:updateInfo()
	local resultData = model.EventModel:getEventResultData()

	local totalMonsterNum = 0;
	for k,v in pairs(resultData.monster) do
		totalMonsterNum = totalMonsterNum+v;
	end
	self.mNumLable:setString( totalMonsterNum )

	local buffList = {};
	for k,v in pairs(resultData.buff) do
		local buffData = ResTable:getRowData('maze_buff' , v);
		if buffList[buffData.quality]==nil then
			buffList[buffData.quality] = {}
		end
		table.insert( buffList[buffData.quality], v )
	end
	if buffList[3] then
		self.b1NumLable:setString( #buffList[3] )
	else
		self.b1NumLable:setString( 0 )
	end

	if buffList[2] then
		self.b2NumLable:setString( #buffList[2] )
	else
		self.b2NumLable:setString( 0 )
	end

	if buffList[1] then
		self.b3NumLable:setString( #buffList[1] )
	else
		self.b3NumLable:setString( 0 )
	end


	local testData= {}
	for k,v in pairs(resultData.item) do
		table.insert(testData, {tonumber(k), tonumber(v)})
	end
	self.dataList = {}
	local cellData = {}
	for k, v in pairs(testData) do
		table.insert(cellData, v)
		if #cellData==5 then
			table.insert(self.dataList, cellData)
			cellData = {}
		end
	end
	if #cellData>0 then
		table.insert(self.dataList, cellData)
		cellData = {}
	end
	self.selListView:reloadData(self.dataList);

	self:addSwallowCallback(handler(self, self.onClickBack));
	self.root:setVisible(true);
	self.titleEffect:getAnimation():play(GlobalFunctions:lAnimationName("win"), 1);

end

function EventResultPanel:onClickBack()
	UIManager:pop('EventResultPanel');
end

function EventResultPanel:onLeave()
	self.root:setVisible(false);
end

function EventResultPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.CommonRowItemCell:create(cell);
		cellNode:setTag(999);
		cellNode:setCallBack(handler(self, self.openUseItemPanel))
    end

    if self.dataList[index+1] then
    	cellNode:initData( self.dataList[index+1], 0 );
    end
end

function EventResultPanel:cellItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
    end
end

function EventResultPanel:openUseItemPanel( itemid )
	UIManager:pop('EventResultPanel');
end

function EventResultPanel:clickBtn()
	UIManager:pop('EventResultPanel');
end

return EventResultPanel;
