local EventRoleStatePanel = class('EventRoleStatePanel', require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local TeamType = Enum:getTable('TeamType')

function EventRoleStatePanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'EventRoleStatePanel');

	self.scene = scene;
	self.useCCreator = false;
	self.isPopup = true;
end

function EventRoleStatePanel:Init(root)
	self.root = root;
	self.root:setVisible(false)

	self:InitPanel()
end

function EventRoleStatePanel:InitPanel()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 730))
	:setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, LANG.UI_MAZE_40, '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(580 , 600));
	bg1:addTo(self.root);

	local initData = {
		width = 580,
		height = 600,
		cellWidth = 580,
		cellHeight = 150,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-290, -300);
	self.selListView:getView():addTo(self.root)
	self.selListView:getView():setVisible(true)

	-- local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	-- :enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	-- local btn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
	-- btn:addTo(self.root);
	-- btn:setPosition(0, -220)
	-- btn:addClickEventListener(handler(self, self.clickBtn));
	-- btn:setTitleLabel(label);

	self.dataList = {}
	self.infoLabel = cc.Label:createWithTTF(LANG.UI_MAZE_11, fonts.FONT_SIYUAN, 20)
		:setTextColor(cc.c3b(250, 255, 0))
		:setPosition(10, -330)
		:addTo(self.root)

	self.infoMark = cc.Sprite:create('image/commonImg/tip_2.png')
		:setPosition(-self.infoLabel:getContentSize().width/2-10, -330)
		:addTo(self.root)
end

function EventRoleStatePanel:onEnter()
	self:addSwallowCallback(handler(self, self.onClickBack));
	self.root:setVisible(true)

	self:updateRoleList();
end

function EventRoleStatePanel:onLeave()
	self.root:setVisible(false)
end

function EventRoleStatePanel:onClickBack()
	UIManager:pop('EventRoleStatePanel');
end

function EventRoleStatePanel:updateRoleList()
	self.dataList = {}
	local cellData = {}
	local cards = model.CardModel:GetAllCard()
	local tmpList = {}

	for k, v in pairs(cards) do
		if v.level >= 60 then
			table.insert(tmpList, v.pid)
		end
	end

	model.CardModel:sortFuc(tmpList, TeamType.EVENT)

	for k, v in pairs(tmpList) do
		table.insert(cellData, v)
		if #cellData==4 then
			table.insert(self.dataList, cellData)
			cellData = {}
		end
	end

	if #cellData>0 then
		table.insert(self.dataList, cellData)
		cellData = {}
	end
	self.selListView:reloadData(self.dataList);

end

function EventRoleStatePanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.EventUseToRoleCell:create(cell);--template.CommonRowItemCell:create(cell);
		cellNode:setTag(999);
    end

    if self.dataList[index+1] then
    	cellNode:initData( self.dataList[index+1], 0 );
    end
end

function EventRoleStatePanel:cellItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
    end
end

function EventRoleStatePanel:clickBtn()
	UIManager:pop('EventRoleStatePanel');
end

return EventRoleStatePanel
