local EventShopOncePanel = class("EventShopOncePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/setup/'
local MessageBoxType = Enum:getTable('MessageBoxType')

function EventShopOncePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SettingPanel');

	self.useCCreator = false;
	self.isPopup = true;
end


function EventShopOncePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function EventShopOncePanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 530))
	:setTouchEnabled(true);

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(582 , 340));
	bg1:setPosition(cc.p(0 , 0));
	bg1:addTo(self.root);

	-- local bg1 = ccui.Scale9Sprite:create("image/commonImg/common_tips_bg_s2.png");
	-- bg1:setContentSize(cc.size(582 , 175));
	-- bg1:setPosition(cc.p(0 , -60));
	-- bg1:addTo(self.root);

	self.tipLabel = cc.Label:createWithTTF(LANG.UI_MAZE_31 , fonts.FONT_SIYUAN , 20);
	self.tipLabel:addTo(self.root)
	self.tipLabel:setDimensions(500, 0)
	-- self.tipLabel:setTextColor(cc.c3b(255, 210, 0))
	self.tipLabel:setPosition(0,110)
	-- self.tipLabel:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2);

	local itemNode = cc.Node:create();
	itemNode:addTo(self.root)

	self.selSpr = cc.Scale9Sprite:create('image/commonImg/select_1_20_20_93_117.png');
	self.selSpr:addTo(itemNode);
	self.selSpr:setContentSize(cc.size(120 , 200));
	self.selSpr:setVisible(false)

	self.itemList = {}
	for i=1,4 do
		local cellNode = cc.Node:create()
		:addTo(itemNode)
		:setPosition(-70+(i-2)*140, 0)

		local tmpIcon = template.ItemTemplate:create(2);
		tmpIcon:addTo(cellNode)
		tmpIcon:Init(10011+i , 100)

		local costNode = cc.Node:create()
		:addTo(cellNode)
		:setPosition(0, -80)

		local costBg = cc.Scale9Sprite:create('image/commonImg/com_bg.png')
		:addTo(costNode)
		:setContentSize(cc.size(110 , 30));
		local costIcon = cc.Sprite:create('image/icon/I10001.png')
		:addTo(costNode)
		:setPosition(-35, 0)
		:setScale(0.3)

		local costLabel = cc.Label:createWithTTF('99999' , fonts.FONT_SIYUAN , 18)
		:addTo(costNode)
		:enableOutline(cc.c3b(120 , 120 , 120) , 1)
		-- :setAnchorPoint(cc.p(0,0.5))
		:setPosition(12,0)

		local offNode = cc.Node:create()
		:addTo(cellNode)
		:setPosition(45, 40)
		local offBg = cc.Sprite:create('image/shop/month_bg2.png')
		:addTo(offNode)
		local offLabel = cc.Label:createWithTTF('DC\n50%' , fonts.FONT_SIYUAN , 13)
		:addTo(offNode)
		:enableOutline(cc.c3b(80 , 50 , 15) , 1)
		:setLineHeight(15)
		:setPosition(3,3)

		local costBtn = ccui.Button:create('image/commonImg/com_bg.png');
		costBtn:addTo(cellNode);
		costBtn:setPosition(0, -30);
		costBtn:setScale9Enabled(true)
		costBtn:setContentSize(cc.size(140 , 200))
		costBtn:setOpacity(0)
		costBtn:setTag(i)
		costBtn:addClickEventListener(handler(self, self.cellItemTouch));

		table.insert( self.itemList, {cellNode=cellNode, itemIcon=tmpIcon, costLabel=costLabel, costBtn=costBtn, costIcon=costIcon, offLabel=offLabel} )

	end

	local infoLabel = cc.Label:createWithTTF(LANG.UI_MAZE_38 , fonts.FONT_SIYUAN , 20);
	infoLabel:addTo(self.root)
	infoLabel:setTextColor(cc.c3b(255, 255, 0))
	infoLabel:setPosition(0,-145)
	-- self.tipLabel:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2);

	local cancelLabel = cc.Label:createWithTTF(LANG.COMMON_CANCEL , fonts.FONT_SIYUAN , 20);
    cancelLabel:enableOutline(cc.c4b(135 , 135 , 135 , 255) , 2);

    local cancelBtn = ccui.Button:create('image/commonImg/btn_1_219_55_2.png' , 'image/commonImg/btn_1_219_55_2.png');
    cancelBtn:addTo(self.root);
    cancelBtn:setPosition(-118, -220);
    cancelBtn:addClickEventListener(handler(self, self.onClickBack));
    cancelBtn:setTitleLabel(cancelLabel);


	local okLabel = cc.Label:createWithTTF(LANG.UI_MAZE_36 , fonts.FONT_SIYUAN , 20);
	okLabel:enableOutline(cc.c4b(135 , 135 , 135 , 255) , 2);

	local okBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	okBtn:addTo(self.root);
	okBtn:setPosition(118, -220);
	okBtn:addClickEventListener(handler(self, self.clickOkBtn));
	okBtn:setTitleLabel(okLabel);


	local titleBg = cc.Sprite:create('image/commonImg/com_title_bg.png')
	titleBg:addTo(self.root)
	titleBg:setPosition(0, 252)

	local tlabel = cc.Label:createWithTTF(LANG.UI_MAZE_30 ,  fonts.FONT_SIYUAN , 24)
    tlabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    tlabel:addTo(self.root)
    tlabel:setPosition(0, 252)

    local tIcon = cc.Sprite:create('image/event/e_shop_icon.png')
    tIcon:setPosition(-180, 252)
    tIcon:addTo(self.root)
	
end


function EventShopOncePanel:onEnter(tid, bclick)

	self:addSwallowCallback(handler(self, self.onClickBack));
	self.tid = tid;
	self.bclick = bclick or true
	EventManager:RegisterEvent(EventType.UIUpdateEventShop , handler(self, self.updateEventShop));

	self.items = model.EventModel:getFightShopById(self.tid);
	if self.items == nil then
	else
		self:updateEventShop();
	end

	self.selectIndex = -1;
	self.selSpr:setVisible(false)

	self.root:setVisible(true);
end

function EventShopOncePanel:updateEventShop()
	self.selectIndex = -1;
	self.selSpr:setVisible(false);
	self.items = model.EventModel:getFightShopById(self.tid);
	self.canBuy = false;

	for i = 1 , 4 do
		if self.items[i] then
			local itemData = ResTable:getRowData('maze_store',self.items[i][1]);
			if itemData ~= nil then
				self.itemList[i].itemIcon:Init( itemData.item[1], itemData.item[2] );

				local icon = ResTable:getValue('item' , itemData.price[1] , 'icon');
				self.itemList[i].costIcon:setTexture('image/icon/I'..icon..'.png');
				self.itemList[i].costLabel:setString( tostring(ConvertStrToDigitUnit(itemData.price[2]))  )
				self.itemList[i].offLabel:setString( 'DC\n'..itemData.discount..'%'  )

				if self.items[i][2] == 1 then
					self.itemList[i].costBtn:setEnabled(false)
					self.itemList[i].costBtn:setOpacity(255);
				else
					self.itemList[i].costBtn:setEnabled(true)
					self.itemList[i].costBtn:setOpacity(0);
					self.canBuy = true;
				end

			end
		end
	end
end

function EventShopOncePanel:onClickBack()
	UIManager:pop('EventShopOncePanel');
end

function EventShopOncePanel:onLeave()
	EventManager:UnregisterEvent(EventType.UIUpdateEventShop)
	self.root:setVisible(false);
end

function EventShopOncePanel:cellItemTouch(sender , event)
	local index = sender:getTag();
	self.selectIndex = index;

	for k,v in pairs(self.itemList) do
		if self.selectIndex == k then
			local x,y = v.cellNode:getPosition();
			self.selSpr:setPosition( x,y-30 )
			self.selSpr:setVisible(true)
		end
	end

	UIManager:push('ComTipsItemPanel' , 1 , {tid=self.tid, item=self.items[self.selectIndex]});

end

function EventShopOncePanel:clickOkBtn()
	if self.bclick==false then
		Prompt:Show(LANG.UI_EVENT_CLICK);
		return;
	end

	if self.canBuy == false then
		model.EventModel:reqGiveUpShopOnce(self.tid);
		UIManager:pop('EventShopOncePanel');
	else
		local msgBox = MessageBox:create(LANG.UI_MAZE_37 , MessageBoxType.CANCEL_OK,function()
			model.EventModel:reqGiveUpShopOnce(self.tid);
			UIManager:pop('EventShopOncePanel');
		end);
	end
	
	-- if self.selectIndex ~= -1 then
	-- 	model.EventModel:reqEventMapShopOnce(self.items[self.selectIndex][1], self.tid);
	-- 	self.itemList[self.selectIndex].costBtn:setEnabled(false)
	-- 	self.itemList[self.selectIndex].costBtn:setOpacity(255);
	-- 	self.selectIndex = -1;
	-- else
	-- 	UIManager:pop('EventShopOncePanel');
	-- end
end

return EventShopOncePanel;
