local EventShopPanel = class('EventShopPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local CommonShopType = Enum:getTable('CommonShopType');

function EventShopPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EventShopPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE_EVENT_SHOP;
	self.showFooter = false;
end

function EventShopPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
      self.root:setPosition(StageSize.width/2,StageSize.height/2);
  
      self:initPanel();
  
      self:registEvent();
end

function EventShopPanel:initPanel(  )

    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);
    
	local bgSprite1 = cc.Sprite:create('image/bg/Bg_4.png');
	bgSprite1:addTo(bgNode);

    self:initSpineAni();

	local bgList = cc.Sprite:create('image/commonImg/bg_5_602_496.png');
	bgList:setPosition(cc.p(0,-194));
    bgList:addTo(self.root);
    
    bgList = cc.Scale9Sprite:create('image/commonImg/bg_604_241.png');
    bgList:setCapInsets(CCRectMake(0,40,587,100));
	bgList:setContentSize(cc.size(587, 680));
	bgList:setPosition(cc.p(0,-194));
    bgList:addTo(self.root);

    self.eventTimeBg = cc.Sprite:create('image/eventShop/event_shop_bg_2.png');
    self.eventTimeBg:addTo(self.root);
    self.eventTimeBg:setPosition(-147 , 223);

    local tmpLabel = cc.Label:createWithTTF(LANG.UI_SHOP_40 ,  fonts.FONT_IMPACT , 20);
    tmpLabel:addTo(self.root);
    tmpLabel:setAnchorPoint(cc.p(0,0.5));
    tmpLabel:setPosition( -273, 223 );
    tmpLabel:enableOutline(cc.c4b(180 , 110 , 40 , 255) , 2);

    self.eventTime = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
    self.eventTime:addTo(self.root);
    self.eventTime:setAnchorPoint(0 , 0.5);
    self.eventTime:setPosition( -273 + tmpLabel:getContentSize().width + 3  , 223);
    self.eventTime:enableOutline(cc.c4b(180 , 110 , 40 , 255) , 2);
    

    self.shopMenuList = {};
    for i = 1 , 2 do
		self.shopMenuList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(i == 1 and -151 or 151  , 179);
        self.shopMenuList[i].unselectNode = node;
        
        local unTexture = 'image/eventShop/event_menu_bg_1.png';
        local texture = 'image/eventShop/event_menu_bg_2.png';

		local bgBtn = ccui.Button:create(unTexture , unTexture);
		bgBtn:addTo(node);
		bgBtn:setTag(i);
		bgBtn:setScaleX(i == 2 and -1 or 1);
		bgBtn:addClickEventListener(handler(self , self.menuClick));

		local label = cc.Label:createWithTTF(LANG.UI_EVENT_SHOP_LABEL[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setTextColor(cc.c3b(50 , 50 , 50));
		label:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);

		node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(i == 1 and -151 or 151  , 179);
		self.shopMenuList[i].selectNode = node;

		bgBtn = ccui.Button:create(texture , texture);
		bgBtn:addTo(node);
		bgBtn:setScaleX(i == 1 and -1 or 1);

		label = cc.Label:createWithTTF(LANG.UI_EVENT_SHOP_LABEL[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:enableOutline(cc.c4b(19 , 93 , 188 , 255) , 2);
    end

    
    local initData = {
        width = 570,
        height = 650,
        cellWidth = 0,
        cellHeight = 0,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

    }
    
    self.eventShopTableView = template.TableViewTemplate:create()
    self.eventShopTableView:initWithSizeAndItem(initData) ;
    self.eventShopTableView:getView():setPosition(cc.p(-285,-519));
    self.eventShopTableView:getView():addTo(self.root)
    self.eventShopTableView:setCellSize(cc.size(570 , 310));

    self.eventWelfareTableView = template.TableViewTemplate:create()
    self.eventWelfareTableView:initWithSizeAndItem(initData) ;
    self.eventWelfareTableView:getView():setPosition(cc.p(-285,-519));
    self.eventWelfareTableView:getView():addTo(self.root)
    self.eventWelfareTableView:setCellSize(cc.size(570 , 170));

    -- list
    --self.shopListView = ccui.ScrollView:create();
	--self.shopListView:setTouchEnabled(true);
	--self.shopListView:setBounceEnabled(true);
	--self.shopListView:setDirection(ccui.ScrollViewDir.vertical);
	--self.shopListView:setContentSize(cc.size(570 , 650));
	--self.shopListView:setAnchorPoint(cc.p(0.5,0.5));
	--self.shopListView:setScrollBarEnabled(false);
    --self.shopListView:addTo(self.root);
    --self.shopListView:setPosition(cc.p(0,-194));

end

function EventShopPanel:initSpineAni()

    if global_branch.branch_audit_event_showBg then
		
		if self.skeletonBg == nil then
			self.skeletonBg = cc.Sprite:create('image/shop/shop_bg.png')
                :addTo(self.root)
                :setPosition(114,105);
		end

		return 
    end
    
    local spine_res = 'NPC001_Spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then

		self.skeletonNode = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.skeletonNode:setPosition(cc.p(200,-30))

        self.skeletonNode:setMix('idle1','idle2',0.1);
		self.skeletonNode:setAnimation(0, "idle1", false);
		self.skeletonNode:addAnimation(0, "idle2", true);

        self.skeletonNode:addTo(self.root)
	
	else
		Prompt:Show(LANG.UI_CARD_2);
	end
end

function EventShopPanel:registEvent(  )
    EventManager:RegisterEvent(EventType.UIRetEventShopInfo, handler(self, self.onShow));
    EventManager:RegisterEvent(EventType.UIBuyEventShop, handler(self, self.retShopBuy));
end

function EventShopPanel:cellItemTouch(table , cell)
    if self.eventShopType == 1 and self.selectItemId then
        local id = self.selectItemId;
        local shopData = model.ShopModel:getEventShopDataById(id);
        if not shopData then
            return;
        end

        local costName = ResTable:getValue('item' , shopData.price[1] , 'name');
        local nameStr = shopData.name;
        if nameStr == nil then
            nameStr = ResTable:getLangByNum(shopData.name_no)
        end
        local msg = string.format(LANG.UI_SHOP_61 , tostring(shopData.price[2]), tostring(costName),tostring(nameStr))

        MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
            model.ShopModel:reqBuyEventShopData(id,shopData.price[2]);
        end);
        self.selectItemId = nil;
    end
end

function EventShopPanel:reloadCellPanel(cell , idx)
    if self.eventShopType == 1 then
        local startNum = idx * 3 + 1;
	    local curMaxNum = (idx+1) * 3;
	    curMaxNum = curMaxNum > self.shopDataMaxNum and self.shopDataMaxNum or curMaxNum;
        local children = cell:getChildren();
        for i = 1 , 3 do
            local itemTemplate = children[i];
            if itemTemplate == nil  then
                local x = 100+(i-1)*190;
                local y = 175;
                itemTemplate = template.RandomShopItemTemplate:create();
                itemTemplate:setPosition(x , y);
                itemTemplate:addTo(cell);
                itemTemplate:addItemClickEventListener(handler(self , self.listItemClick));
            end
            if startNum <= curMaxNum then
                local itemData = self.sortShopData[startNum];
                itemTemplate:InitData(itemData);
                itemTemplate:setItemTag(itemData.no);
                itemTemplate:setVisible(true);

                self.shopItems[itemData.no] = itemTemplate;

                startNum = startNum + 1;
            else
                itemTemplate:setVisible(false);
            end
        end

    else
        local itemData = self.sortShopData[idx + 1];
	    local children = cell:getChildByTag(999);
        if not children then --560,154
            children = template.ShopGiftItemTemplate:create();
            children:setPosition(285, 85);
            children:addTo(cell);
            children:addBtnClickEventListener(handler(self , self.listItemClick));
        end
        children:InitDataEventWelfate(itemData);
        children:setBtnTag(itemData.id);
        self.shopItems[itemData.id] = children;
    end
end

function EventShopPanel:showShopList()

    for i = 1 , 2 do
        self.shopMenuList[i].unselectNode:setVisible(i ~= self.eventShopType);
        self.shopMenuList[i].selectNode:setVisible(i == self.eventShopType);
    end

    self.shopItems = {};

    if self.eventShopType == 1 then
        self.sortShopData= model.ShopModel:getEventShopData();
        self.shopDataMaxNum = #self.sortShopData;
        self.eventShopTableView:getView():setVisible(true);
        self.eventWelfareTableView:getView():setVisible(false);

        self.eventShopTableView:setDataCount(math.ceil(self.shopDataMaxNum/3));
        self.eventShopTableView:reloadData();
    else
        local shopData= model.EventModel:getEventWelfareData();
        self.sortShopData = {};
        for id , data in pairs(shopData) do
            table.insert(self.sortShopData , data);
        end
        self.shopDataMaxNum = #self.sortShopData;

        self.eventShopTableView:getView():setVisible(false);
        self.eventWelfareTableView:getView():setVisible(true);

        self.eventWelfareTableView:setDataCount(self.shopDataMaxNum);
        self.eventWelfareTableView:reloadData();
    end
end

function EventShopPanel:menuClick(sender , event)
    local tag = sender:getTag();

    if tag == self.eventShopType then
        return;
    end

    self.eventShopType = tag;

    self:showShopList();
end

function EventShopPanel:listItemClick(sender , event)
    local id = sender:getTag();
    AudioManager:playEffect(Conf.buttonClick)

    if self.eventShopType == 1 then
       self.selectItemId = id;
    else
    end
end

function EventShopPanel:onEnter()

    if model.ShopModel:shopHasInit(CommonShopType.MAZE) then
        self:onShow()
    else
        model.ShopModel:reqShopInfo(CommonShopType.MAZE);
    end
    self.root:setVisible(true)

end

function EventShopPanel:onShow()
    self.eventShopType = 1;
    self:showShopList()

    local startTime = model.EventModel:getEventStartTime()
    local endTime = model.EventModel:getEventCloseTime()
    if startTime ~= 0 then
        local startTable = os.date('*t', startTime)
        local endTable = os.date('*t', endtime)


        local msg = string.format( LANG.UI_EVENT_29,startTable.month,startTable.day ).."--"..string.format( LANG.UI_EVENT_29,endTable.month,endTable.day )

        self.eventTime:setString(msg);
    end
    
end

function EventShopPanel:retShopBuy(msg)

    if self.eventShopType == 1 then
        if msg.event_items then
            Prompt:Show('数据过期，重新刷新');
            self:showShopList();
            return
        end
        local shopData = model.ShopModel:getEventShopDataById(msg.id);

        if not shopData then
            return;
        end

        if self.shopItems[msg.id] then
            self.shopItems[msg.id]:InitData(shopData);
        end
    else
        local shopData = model.EventModel:getEventWelfareDataById(msg.id);

        if not shopData then
            return;
        end

        if self.shopItems[msg.id] then
            self.shopItems[msg.id]:InitDataEventWelfate(shopData);
        end
    end

    UIManager:push('RewardPanel' , msg);
end

function EventShopPanel:onLeave( ... )
    self.root:setVisible(false);
end

function EventShopPanel:onClickBack()
    UIManager:pop('EventShopPanel');
end

return EventShopPanel

