local EventTireSelPanel = class("EventTireSelPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')

function EventTireSelPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'EventTireSelPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function EventTireSelPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
      self:InitPanels();
end

function EventTireSelPanel:InitPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 400))
	:setTouchEnabled(true);

	GlobalFunctions:createTitleNode( bg, LANG.UI_MAZE_33, '',  bg:getContentSize().width/2, bg:getContentSize().height -50 );

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , -30);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(582 , 310));

	self.simplebtn = ccui.Button:create('image/event/map/simple_tire.png');
	self.simplebtn:addTo(self.root);
	self.simplebtn:setPosition(-150 , -30);
	self.simplebtn:addClickEventListener(handler(self , self.clickSimple));

	self.hardbtn = ccui.Button:create('image/event/map/hard_tire.png');
	self.hardbtn:addTo(self.root);
	self.hardbtn:setPosition(150 , -30);
	self.hardbtn:addClickEventListener(handler(self , self.clickHard));

end

function EventTireSelPanel:onEnter()
	self:addSwallowCallback(handler(self , self.onClickBack));
	self.root:setVisible(true);
end

function EventTireSelPanel:onLeave()
	self.root:setVisible(false);
end

function EventTireSelPanel:onClickBack()
	UIManager:pop('EventTireSelPanel');
end

function EventTireSelPanel:clickSimple()
	EventManager:FireEvent('showChangeTierAct', 0, 3);
	UIManager:pop('EventTireSelPanel');
end

function EventTireSelPanel:clickHard()
	EventManager:FireEvent('showChangeTierAct', 0, 4);
	UIManager:pop('EventTireSelPanel');
end

return EventTireSelPanel;
