local FastFightRewardPanel = class("FastFightRewardPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
-- local scheduler = cc.Director:getInstance():getScheduler();
local imagePath = 'image/fight/fast/'
function FastFightRewardPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'FastFightRewardPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function FastFightRewardPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
	self:registEvent()
end

function FastFightRewardPanel:initPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(604,625));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -17);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_FIGHT_GUAJI_1 , 604 , 46 , LANG.UI_L_FIGHT_GUAJI_2);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 318);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , -16);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(550 , 300));

	for i=1,#LANG.UI_FIGHT_FAST do
		local info = cc.Label:createWithTTF(LANG.UI_FIGHT_FAST[i] , fonts.FONT_SIYUAN , 20)
			:addTo(self.root)
			:setPosition(-1 , 300 - i * 40)
	end

	local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	arrow:addTo(self.root);
    arrow:setPosition(-238,106);
    
	local label = cc.Label:createWithTTF(LANG.UI_FIGHT_64 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.root);
	label:setAnchorPoint(0 , 0.5);
	label:setPosition(-216 , 106);
	label:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	local line = cc.Sprite:create('image/commonImg/line.png');
    line:addTo(self.root);
	line:setContentSize(cc.size(549,1))
	line:setPosition(cc.p(0,80))

	self.rewardView = ccui.ScrollView:create();
	self.rewardView:setTouchEnabled(true);
	self.rewardView:setBounceEnabled(true);
	self.rewardView:setDirection(ccui.ScrollViewDir.vertical);
	self.rewardView:setContentSize(cc.size(502 , 230));
	self.rewardView:setAnchorPoint(0.5 , 0.5);
	self.rewardView:setPosition(0 , -42);
	self.rewardView:setScrollBarEnabled(false);
	self.rewardView:addTo(self.root);

	self.btnLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_65 , fonts.FONT_SIYUAN , 20);
	self.btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

	self.useBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.useBtn:addTo(self.root);
	self.useBtn:setPosition(115 , -275);
	self.useBtn:addClickEventListener(handler(self , self.useBtnClick));
	self.useBtn:setTitleLabel(self.btnLabel);

	-- 钻石刷新
	local refreshBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	refreshBg:addTo(self.root);
	refreshBg:setPosition(-116 , -295);
    refreshBg:setCapInsets(cc.rect(11,11,34,28));
	refreshBg:setContentSize(cc.size(207 , 33));

	local itemIcon = ResTable:getValue('item' , FAST_FIGHT_ITEM , 'icon');
	local costIcon = cc.Sprite:create('image/icon/I'..itemIcon..'.png');
	costIcon:setContentSize(COST_ITEM_SIZE);
	costIcon:setPosition(cc.p(-202,-295));
	costIcon:addTo(self.root);

	local haveNum = cc.Label:createWithTTF(LANG.UI_ENTRUST_16 , fonts.FONT_SIYUAN , 20);
	haveNum:addTo(self.root);
	haveNum:setPosition(-161 , -295);

	self.costNum = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.costNum:addTo(self.root);
	self.costNum:setAnchorPoint(1,0.5);
	self.costNum:setPosition(-46 , -295);

	self.addBtn = ccui.Button:create('image/commonImg/add_btn_1.png','image/commonImg/add_btn_1.png');
    self.addBtn:addTo(self.root);
    self.addBtn:setPosition(-25,-295);
    self.addBtn:addClickEventListener(function()
    	if model.GuideModel:isInGuide() then
    		Prompt:Show(LANG.COMMON_NOT);
    	else
        	UIManager:push('ShopPanel');
        end
	end);
	
	local lastTimesBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	lastTimesBg:addTo(self.root);
	lastTimesBg:setPosition(-116 , -256);
    lastTimesBg:setCapInsets(cc.rect(11,11,34,28));
	lastTimesBg:setContentSize(cc.size(207 , 33));

	local lastTimesArrow = cc.Sprite:create('image/commonImg/arrow_3_bg.png');
	lastTimesArrow:addTo(self.root);
	lastTimesArrow:setPosition(-200 , -256);

	local lastTimesLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_68 , fonts.FONT_SIYUAN , 20);
	lastTimesLabel:addTo(self.root);
	lastTimesLabel:setPosition(-146 , -256);

	self.useTimes = cc.Label:createWithTTF('5/5' , fonts.FONT_SIYUAN , 20);
	self.useTimes:addTo(self.root);
	self.useTimes:setAnchorPoint(1,0.5);
	self.useTimes:setPosition(-22 , -256);

	local countDownbg = cc.Sprite:create('image/commonImg/time_bg_1.png');
    countDownbg:addTo(self.root);
    countDownbg:setPosition(0,-205);

    local countDownbg = cc.Sprite:create('image/commonImg/time_1.png');
    countDownbg:addTo(self.root);
    countDownbg:setPosition(-147 , -205);

    local label = cc.Label:createWithTTF(LANG.UI_FIGHT_67 ,  fonts.FONT_SIYUAN , 15)
    label:addTo(self.root);
    label:setPosition(-45 , -205);
    label:setTextColor(cc.c3b(255,255,0));

    self.countdown = cc.Label:createWithTTF('0' ,  fonts.FONT_SIYUAN , 15)
    self.countdown:addTo(self.root);
    self.countdown:setAnchorPoint(0 , 0.5);
    self.countdown:setPosition(label:getPositionX()+label:getContentSize().width/2+2 , -205);
    self.countdown:setTextColor(cc.c3b(255,255,0));

	local restTimes = model.GachaAdmobModel:getRestTimes(FAST_FIGHT_ADMOB_TYPE_19);
	local maxTimes = model.GachaAdmobModel:getMaxTimes(FAST_FIGHT_ADMOB_TYPE_19);
	if restTimes and maxTimes then
		local admobNode = {};
		admobNode.node = cc.Node:create()
			:setPosition(cc.p(135, -335))
			:addTo(self.root)
		admobNode.admobBtn = ccui.Button:create('image/fight/fast/admob.png');
		admobNode.admobBtn:addTo(admobNode.node);
		admobNode.admobBtn:setZoomScale(0)
		admobNode.admobBtn:setPosition(cc.p(0, 0))
		admobNode.admobBtn:addClickEventListener(function()	
			local restTimes = model.GachaAdmobModel:getRestTimes(FAST_FIGHT_ADMOB_TYPE_19);
			if restTimes <= 0 then
				return;
			end
			local args = {
				admob_index = 5
			}			
			sdkManager.SDKLuaHelper:playAdMob(args, function(strData)
				local jsonData = Cjson.decode(strData)
				jsonData.code = tonumber(jsonData.code)
				if jsonData.code and jsonData.code ~= 0 and jsonData.code ~= 100 then
					if jsonData.code == 3 then
						Prompt:Show(LANG.UI_ADMOB_9)
					else
						Prompt:Show(LANG.UI_ADMOB_10)
					end
					return
				end
				local reqGacha = false
				if jsonData.code and jsonData.code == 0 then
					reqGacha = true
				end
				if not reqGacha then
					return
				end
				local msg = {
					admob    = 1,
				}
				Network.NetworkManager:Send(Network.NetworkCmdType.req_fast_fight , msg);

				model.GachaAdmobModel:consume(FAST_FIGHT_ADMOB_TYPE_19);
				local restTimes = model.GachaAdmobModel:getRestTimes(FAST_FIGHT_ADMOB_TYPE_19);
				if restTimes <= 0 then
					admobNode.label1:setVisible(false)
					admobNode.icon1:setVisible(false)
					admobNode.label2:setVisible(true)
					admobNode.icon2:setVisible(true)
				else
					admobNode.label1:setString(LANG.UI_FIGHT_103 .. string.format( "%d/%d", restTimes, maxTimes))
				end
			end)
		end)
		admobNode.label1 = cc.Label:createWithTTF(LANG.UI_FIGHT_103 .. string.format( "%d/%d", restTimes, maxTimes), fonts.FONT_SIYUAN, 18)
			:setAnchorPoint(cc.p(0, 0.5))
			:enableOutline(cc.c3b(94 , 62 , 0) , 1)
			:setTextColor(cc.c3b(255,255,255))
			:addTo(admobNode.node)
			:setPosition(-75, -5)
		admobNode.icon1 = cc.Sprite:create('image/chouka/main/admob_ico_small.png')
			:addTo(admobNode.node)
			:setScale(1)
			:setPosition(-100, -5)
		admobNode.label2 = cc.Label:createWithTTF(string.format(LANG.UI_GACHA_33, '00:00:00'), fonts.FONT_SIYUAN, 18)
			:setAnchorPoint(cc.p(0, 0.5))
			:enableOutline(cc.c3b(94 , 62 , 0) , 1)
			:setTextColor(cc.c3b(255,255,255))
			:addTo(admobNode.node)
			:setPosition(-75, -5)
		admobNode.icon2 = cc.Sprite:create('image/chouka/main/admob_ico_small_disable.png')
			:addTo(admobNode.node)
			:setScale(1)
			:setPosition(-100, -5)
		TimeManager:registUpdateEvent('FastFightAdmobCount',function()
			local rT2T = TimeManager:getTime2Tomorrow();
			local sec = rT2T % 60
			local min = ((rT2T - sec) / 60) % 60
			local hour = math.floor((rT2T - sec - min*60) / 3600)
			sec = tostring(sec)
			min = tostring(min)
			hour = tostring(hour)				
			if string.len(sec) == 1 then sec = '0'..sec end
			if string.len(min) == 1 then min = '0'..min end
			if string.len(hour) == 1 then hour = '0'..hour end
			admobNode.label2:setString(string.format(LANG.UI_GACHA_33, hour..':'..min..':'..sec))
		end,true);
		if restTimes > 0 then
			admobNode.label1:setVisible(true)
			admobNode.icon1:setVisible(true)
			admobNode.label2:setVisible(false)
			admobNode.icon2:setVisible(false)
		else
			admobNode.label1:setVisible(false)
			admobNode.icon1:setVisible(false)
			admobNode.label2:setVisible(true)
			admobNode.icon2:setVisible(true)
		end
	end
end

function FastFightRewardPanel:registEvent(  )
	EventManager:RegisterEvent(EventType.FightFastInfo, handler(self, self.retGetFastReward));
end

function FastFightRewardPanel:onEnter()

	self:addSwallowCallback(handler(self, self.onClickBack));

	self:showListView()

	self.useBtn:setEnabled(true)
	
	self:updateUI();

	self:checkUpdateTime();

	self.root:setVisible(true);
end

function FastFightRewardPanel:showListView(  )
	local roundDrop = ResTable:getValue('round', model.RoundModel:getRoundIndex(), 'drop');
	local len = #roundDrop;
    local column = 4
    
    local maxHeight = math.ceil(len/column)*135
    if maxHeight < 230 then
        maxHeight = 230;
	end
	self.rewardView:removeAllChildren();
    self.rewardView:setInnerContainerSize(cc.size(502,maxHeight))

    for i=1,len do
        local col = (i- 1) % column  -- 0,1,2,3
        local row = math.floor((i - 1) / column); --0,1.。

        local drop = roundDrop[i];

		local template = template.ItemTemplate:create(2);
		template:addTo(self.rewardView);
		template:Init(drop[1] , 0);
		template:setPosition(51.5+col*133,maxHeight - row * 135 - 51.5);
    end
	-- local num = #roundDrop;

	-- local maxWidth = num * 130;
	-- if maxWidth < 404 then
	-- 	maxWidth = 404;
	-- end
	-- local maxHeight = 117;

	-- self.rewardView:setInnerContainerSize(cc.size(maxWidth, maxHeight));
	-- self.rewardView:removeAllChildren();

	-- for _k , drop in pairs(roundDrop) do
	-- 	local template = template.IconTemplate:create(self.rewardView);
	-- 	template:Init(drop[1] , drop[2]);
	-- 	template:setPosition(71 + 130 * (_k - 1) , 58.5);
	-- end

end

function FastFightRewardPanel:updateUI()

	local costNum = model.AutoFightModel:getFastInfoData(2) or 0;
	local haveNum = model.ItemModel:getItemNum(FAST_FIGHT_ITEM);

	self.costNum:setString(tostring(haveNum)..'/'..tostring(costNum));

	local haveTimes = model.AutoFightModel:getFastInfoData(3) or 0;
	local totalTimes = model.AutoFightModel:getFastInfoData(4) or 0;
	haveTimes =  totalTimes - haveTimes;
	self.useTimes:setString(string.format('%d/%d' , haveTimes , totalTimes));

	self:checkRedDot();
end

function FastFightRewardPanel:checkRedDot()

	local state = false;
	if self.useBtn:isEnabled() then
		state = model.AutoFightModel:getFastFightRedDotState();
	end

	tools.RedDotTools:setRedDotToNode(self.useBtn,state,nil,cc.p(209 , 45));
end

function FastFightRewardPanel:checkUpdateTime(  )

	local lastTime = model.AutoFightModel:getFastRewardCountDown() --  getFastInfoData(5) or 0;
	lastTime = math.floor(lastTime);
	self:updateTime();

	if lastTime <= 0 then
		TimeManager:registUpdateEvent('FastFightRewardPanel',nil,true); -- 取消注册
	else
		TimeManager:registUpdateEvent('FastFightRewardPanel',handler(self,self.updateTime),true);
	end

end

function FastFightRewardPanel:updateTime()
	local lastTime = model.AutoFightModel:getFastRewardCountDown()  -- getFastInfoData(5) or 0;
	lastTime = math.floor(lastTime);
	self.countdown:setString(GlobalFunctions:ChangeTime(lastTime));

	local bFree = lastTime <= 0;
	self.btnLabel:setString(bFree and LANG.UI_FIGHT_65 or LANG.UI_FIGHT_66);

	if bFree then
		TimeManager:registUpdateEvent('FastFightRewardPanel',nil,true); -- 取消注册
	end

end

function FastFightRewardPanel:useBtnClick()
	local msg = {}
	local	guideStep = model.GuideModel:getGuideStep() ; -- 新手引导阶段
	-- print('guideStep === ',guideStep);
	if guideStep == model.GuideModel.GUIDE_STEP_ENUM.GUIDE_ENUM_8 then
		msg.guideStep = model.GuideModel.GUIDE_STEP_ENUM.GUIDE_ENUM_8;

		model.GuideModel:stopGuide()
		self.useBtn:setEnabled(false)
	end
	Network.NetworkManager:Send(Network.NetworkCmdType.req_fast_fight , msg);
end

function FastFightRewardPanel:retGetFastReward(msg)
	if msg and msg.itemChange then
		local items = {};
		for _k , item in pairs(msg.itemChange) do
			if item.no ~= COLOR_DIA then
				table.insert(items,item);
			end
		end
		msg.itemChange = items
	end
	UIManager:push('RewardPanel',msg , {rewardType = Enum:getTable('RewardType').REWARD_TYPE_FAST_FIGHT})
	self:updateUI();
	self:checkUpdateTime()
end

function FastFightRewardPanel:onClickBack()
	EventManager:FireEvent(EventType.UIFooterRedDotShow,10);
    tools.RedDotTools:pushFightSceneRedDot(207)
	UIManager:pop('FastFightRewardPanel');

	model.GuideModel:resumeGuide()
end

function FastFightRewardPanel:onLeave()
    TimeManager:registUpdateEvent('FastFightRewardPanel',nil,true); -- 取消注册

	-- if self.m_scheduleHandler then
	-- 	scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
	-- 	self.m_scheduleHandler = nil
	-- end

	self.root:setVisible(false);
end

-- 引导相关
function FastFightRewardPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 37 then
		local btn = self.useBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return FastFightRewardPanel;
