local FightItemPanel = class("FightItemPanel", require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont");
local imgPath = 'image/fight/item/';

function FightItemPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'FightItemPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.isPopup = true;

	self.allItems = nil;

end

function FightItemPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:InitPanel();
	self:InitItemPanel();

	EventManager:RegisterEvent(EventType.AutoFightItemUse, handler(self, self.itemUseCallback));

end

function FightItemPanel:InitPanel( )

	local bgImg = ccui.ImageView:create(imgPath .. 'bg.png');
	bgImg:addTo(self.root);
	bgImg:setTouchEnabled(true);
	bgImg:setPosition(cc.p(0 , 112));

	GlobalFunctions:createTitleNode( bgImg, LANG.UI_L_TOOLS_1, LANG.UI_L_TOOLS_2,  
		bgImg:getContentSize().width/2, bgImg:getContentSize().height -16 );

	self.itemListView = ccui.ListView:create();
	self.itemListView:ignoreContentAdaptWithSize(false);
	self.itemListView:setAnchorPoint(cc.p(0.5,0.5));
	self.itemListView:setBounceEnabled(true);
	self.itemListView:setDirection(ccui.ScrollViewDir.vertical);
	self.itemListView:setContentSize(cc.size(128 , 488));
	self.itemListView:setScrollBarEnabled(true);
	-- self.itemListView:setItemsMargin(10);
	self.itemListView:setPosition(cc.p(-214 , 97));
	self.itemListView:addTo(self.root);
end

function FightItemPanel:InitItemPanel()

	-- info node
	self.infoNode = cc.Node:create();
	self.infoNode:addTo(self.root);

	local nameBg = cc.Sprite:create(imgPath..'name_bg.png');
	nameBg:addTo(self.infoNode);
	nameBg:setPosition(cc.p(73,326));
	nameBg:setContentSize(cc.size(408,33))
	
	self.itemName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20);
	self.itemName:setTextColor(cc.c4b(50, 50, 50, 255));
	self.itemName:setPosition(-102, 337);
	self.itemName:addTo(self.infoNode);
	self.itemName:setAnchorPoint(cc.p(0,0.5))
	self.itemName:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);

	self.description = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20);
	self.description:setPosition(80, 154);
	self.description:setDimensions(350, 70);
	self.description:addTo(self.infoNode); 
	self.description:setAnchorPoint(cc.p(0.5,1));
	self.description:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
	self.description:setTextColor(cc.c4b(50, 50, 50, 255));

	self.icon = require('app.template.ItemTemplate'):create();
	self.icon:addTo(self.infoNode);
	self.icon:setPosition(73, 236);

	self.showNode = cc.Node:create();
	self.showNode:addTo(self.infoNode);
	self.showNode:setVisible(true);
	--持有数量
	local haveBg = cc.Sprite:create(imgPath .. 'info_bg2.png')
	haveBg:addTo(self.showNode);
	haveBg:setPosition(cc.p(82,10))

	local haveBg2 = cc.Sprite:create(imgPath .. 'info_bg3.png')
	haveBg2:addTo(self.showNode);
	haveBg2:setPosition(cc.p(165,12))

	local lable1 = cc.Label:createWithTTF(LANG.UI_FIGHT_69, fonts.FONT_SIYUAN, 20)
		:setPosition(-24, 10)
		:addTo(self.showNode)
		:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 2)
		:setTextColor(cc.c4b(255, 255, 255, 255));

	self.itemTotalNum1 = cc.Label:createWithTTF('5000', fonts.FONT_SIYUAN, 20)
		:setPosition(105, 12)
		:addTo(self.showNode)
		:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2)
		:setTextColor(cc.c4b(50, 50, 50, 255));

	self.itemTotalNum2 = cc.Label:createWithTTF('5000', fonts.FONT_SIYUAN, 20)
		:setPosition(215, 12)
		:addTo(self.showNode)
		:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2)
		:setTextColor(cc.c4b(50, 50, 50, 255));

	-- 购买数量 按钮加减
	-- local y = -99;

	-- self.btn1 = ccui.Button:create(imgPath .. 'btn_sub10.png');
	-- self.btn1:setPosition(-128, y);
	-- self.btn1:setTag(1);
	-- self.btn1:addClickEventListener(handler(self, self.chooseNums));
	-- self.btn1:addTo(self.infoNode);

	self.btn2 = ccui.Button:create('image/equip/equip_compose/equip_compose_bg8.png','','image/equip/equip_compose/equip_compose_bg7.png');
	self.btn2:setPosition(-28, -51);
	self.btn2:setTag(2);
	self.btn2:addClickEventListener(handler(self, self.chooseNums));
	self.btn2:addTo(self.showNode);

	self.btn3 = ccui.Button:create('image/equip/equip_compose/equip_compose_bg10.png','','image/equip/equip_compose/equip_compose_bg9.png');
	self.btn3:setPosition(182, -51);
	self.btn3:setTag(3);
	self.btn3:addClickEventListener(handler(self, self.chooseNums));
	self.btn3:addTo(self.showNode);

	-- self.btn4 = ccui.Button:create(imgPath .. 'btn_max.png');
	-- self.btn4:setPosition(226, y);
	-- self.btn4:setTag(4);
	-- self.btn4:addClickEventListener(handler(self, self.chooseNums));
	-- self.btn4:addTo(self.infoNode);

	local sp1 = cc.Sprite:create('image/equip/equip_compose/equip_compose_bg12.png');
	sp1:setPosition(76, -51);
	sp1:addTo(self.showNode);

	self.buyNum = cc.Label:createWithTTF('1', fonts.FONT_SIYUAN, 20);
	self.buyNum:setPosition(78, -51);
	self.buyNum:addTo(self.showNode);
	self.buyNum:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 2);
	self.buyNum:setTextColor(cc.c4b(255, 193, 2, 255));

	-- 将获得道具数量
	local mayGetBg = cc.Sprite:create(imgPath .. 'info_bg1.png')
	mayGetBg:addTo(self.showNode);
	mayGetBg:setPosition(cc.p(13,-141))

	self.getItemLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_71, fonts.FONT_SIYUAN, 20)
		:setPosition(-58, -142)
		:addTo(self.showNode)
		:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 2)
		:setTextColor(cc.c4b(255, 255, 255, 255));

	self.getItemNum = cc.Label:createWithTTF('5000', fonts.FONT_SIYUAN, 20)
		:setPosition(72, -144)
		:addTo(self.showNode)
		:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2)
		:setTextColor(cc.c4b(50, 50, 50, 255));

	self.getItemSp = cc.Sprite:create();
	-- self.getItemSp:setContentSize(COST_ITEM_SIZE);
	self.getItemSp:setPosition(-105, -140);
	self.getItemSp:addTo(self.showNode);
	self.getItemSp:setScale(0.4)

	local btnLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_29, fonts.FONT_SIYUAN, 20)
	btnLabel:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 2)
	self.btnUse2 = ccui.Button:create('image/common/common_button_46_1.png');
	self.btnUse2:setPosition(209, -133);
	self.btnUse2:setTitleLabel(btnLabel);
	self.btnUse2:addClickEventListener(handler(self, self.useItem));
	self.btnUse2:addTo(self.showNode);


	-- 未持有道具
	self.noInfoNode = cc.Node:create();
	self.noInfoNode:addTo(self.infoNode);

	local noInfoSp = cc.Sprite:create('image/fight/item/bg_noItem.png')
	noInfoSp:addTo(self.noInfoNode);
	noInfoSp:setPosition(cc.p(76, -26))

	-- local posY2 = -136;
	-- self.getItemLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_38, fonts.FONT_SIYUAN, 20);
	-- self.getItemLabel:setPosition(-27, posY2);
	-- self.getItemLabel:setTextColor(cc.c4b(60, 60, 60, 255));
	-- self.getItemLabel:addTo(self.infoNode);

	-- self.getItemSp = cc.Sprite:create();
	-- self.getItemSp:setContentSize(COST_ITEM_SIZE);
	-- self.getItemSp:setPosition(30, posY2);
	-- self.getItemSp:addTo(self.infoNode);
	-- self.getItemSp:setScale(0.4)

	-- self.getBuffLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_39, fonts.FONT_SIYUAN, 20);
	-- self.getBuffLabel:setPosition(65, posY2);
	-- self.getBuffLabel:setTextColor(cc.c4b(60, 60, 60, 255));
	-- self.getBuffLabel:addTo(self.infoNode);

	-- self.getItemNum = cc.Label:createWithTTF('99999999999', fonts.FONT_SIYUAN, 24);
	-- self.getItemNum:setPosition(65, posY2);
	-- self.getItemNum:setTextColor(cc.c4b(60, 60, 60, 255));
	-- self.getItemNum:addTo(self.infoNode);
	-- self.getItemNum:setAnchorPoint(cc.p(0,0.5));

	-- self.btnUse2 = ccui.Button:create('image/common/common_button_4.png');
	-- self.btnUse2:setPosition(50, -178);
	-- self.btnUse2:setTitleLabel(cc.Label:createWithTTF(LANG.UI_FIGHT_29, fonts.FONT_SIYUAN, 24));
	-- self.btnUse2:addClickEventListener(handler(self, self.useItem));
	-- self.btnUse2:addTo(self.infoNode);



	
	-- local noInfoLabel1 = cc.Label:createWithTTF(LANG.UI_FIGHT_40, fonts.FONT_SIYUAN, 26);
	-- noInfoLabel1:setPosition(56, 36);
	-- noInfoLabel1:setTextColor(cc.c4b(181, 181, 181, 255));
	-- noInfoLabel1:addTo(self.noInfoNode);
 
	-- local noInfoLabel2 = cc.Label:createWithTTF(LANG.UI_FIGHT_41, fonts.FONT_SIYUAN, 20);
	-- noInfoLabel2:setPosition(56, 1);
	-- noInfoLabel2:setTextColor(cc.c4b(181, 181, 181, 255));
	-- noInfoLabel2:addTo(self.noInfoNode);

	-- local noInfoLabel3 = cc.Label:createWithTTF(LANG.UI_FIGHT_42, fonts.FONT_SIYUAN, 20);
	-- noInfoLabel3:setPosition(56, -33);
	-- noInfoLabel3:setTextColor(cc.c4b(181, 181, 181, 255));
	-- noInfoLabel3:addTo(self.noInfoNode);
 
	-- self.infoNode:setVisible(false);
	self.noInfoNode:setVisible(true);
end

function FightItemPanel:onEnter()
	self.root:setVisible(true);
	self:addSwallowCallback(handler(self, self.onClickBack));
	if self.isInit ~= true  then
		self.isInit = true ;
		self:initAllItems();
	end

	self:updateItems();
end

function FightItemPanel:onLeave()
	self.root:setVisible(false);
end

function FightItemPanel:initAllItems(  )
end

function FightItemPanel:updateItems()

	for k,item in pairs(self.allItems) do
		item.num = model.ItemModel:getItemNum(item.no);
	end

	table.sort( self.allItems,function(item1,item2) 
		return item1.num > item2.num 
	end );

	self.itemList = {}
	self.itemListView:removeAllChildren(true);
	local selectNo = -1;
	for i=1, #self.allItems do
		local data = self.allItems[i];

		local layout = ccui.Layout:create();
		layout:setContentSize(cc.size(110 , 115));

		local item = template.FightItemTemplate:create()
		item:initData(data);
		item:getRoot():addTo(layout);
		item:getRoot():setPosition(55,55);
		item:setSelected(i == 1) ;
		item:setCallback(handler(self, self.clickItem))

		if i == 1 then
			selectNo = data.no;
		end
		self.itemListView:pushBackCustomItem(layout)
		self.itemList[data.no] = item;
	end
	self:showItemInfo(selectNo);
end


function FightItemPanel:onClickBack()
	UIManager:pop('FightItemPanel');
	tools.RedDotTools:pushFightSceneRedDot(8)

end

function FightItemPanel:clickItem(tag)
	self:updateItemList(tag)
	self:showItemInfo(tag);
end

function FightItemPanel:updateItemList( tag )

	local index = 1;
	for k,item in pairs(self.itemList) do
		item:setSelected(k == tag);
	end
end
function FightItemPanel:showItemInfo( id )
	-- body
	local item = model.ItemModel:getItem(id);
	if item == nil then
		return;
	end
	self.totalNum = item.num;
	self.id = item.no;

	self.icon:Init(item.no);

	self.itemData = ResTable:getRowData('item', item.no);
	self.itemName:setString(self.itemData['name']);
	self.description:setString(self.itemData['instruction']);

	if self.totalNum == 0 then
		self.noInfoNode:setVisible(true);
		self.showNode:setVisible(false)
		return;
	end

	self.noInfoNode:setVisible(false);
	self.showNode:setVisible(true);

	self.useNum = 1;
	self.buyNum:setString(self.useNum);
	self.itemTotalNum1:setString( self.totalNum);
	self.itemTotalNum2:setString( self.totalNum - self.useNum);

	self:showMayGetNum();

end

function FightItemPanel:showMayGetNum(  )
	-- self.itemData
	local useData = ResTable:getRowDataByKey('item_use','item_id',tonumber(self.id));
	local time_get = useData['time']/Conf.HEART_BEAT_TIME
	
	local reward_type = useData['reward_type']
	self.prompStr = '';

	if self.itemData['type'] == 5 then
		--直接收益
		local round = model.RoundModel:getRoundIndex();
		local roundData = ResTable:getRowData('round',round);
		local coin_get,exp_get = roundData['coin'],roundData['exp'];

		local itemtotalNum = '0';
		local itemIcon = ResTable:getValue('item' , MONEY_ID , 'icon');
		local itemSpTexture = 'image/icon/I'..itemIcon..'.png'; --Enum:getTable('SpecialItemTexture')[MONEY_ID];

		local rewardName = LANG.UI_FIGHT_43
		local rewardNum = '0'

		if reward_type == 7 then
			local coin_get2 = ConvertDigitUnitToStr(coin_get);
			rewardNum = ConvertStrToDigitUnit(HpMultiply(coin_get2,time_get * self.useNum));
		elseif reward_type == 8 then 
			rewardNum = exp_get * time_get* self.useNum;
			local itemIcon = ResTable:getValue('item' , EXP_ID , 'icon');
			itemSpTexture = 'image/icon/I'..itemIcon..'.png'; --num:getTable('SpecialItemTexture')[EXP_ID];
			rewardName = LANG.UI_FIGHT_44
		else 
			print('error====================================== 无效道具！！！type = ',reward_type);
		end
		-- rewardNum = rewardNum * 
		self.prompStr = string.format( LANG.UI_FIGHT_45,self.itemData['name'],self.useNum,rewardNum,rewardName )

		-- self.getBuffLabel:setVisible(false);
		-- self.getItemLabel:setVisible(true);
		self.getItemNum:setVisible(true);
		self.getItemSp:setVisible(true);
		self.getItemLabel:setString(LANG.UI_FIGHT_71)
		self.getItemSp:setTexture(itemSpTexture);
		self.getItemNum:setString(tostring(rewardNum));
	elseif self.itemData['type'] == 6 then 
		-- buff
		-- local itemSpTexture =  'image/icon/I'..MONEY_ID..'.png'
		local rewardName = LANG.UI_FIGHT_43

		if reward_type == 7 then 

		elseif reward_type == 8 then 
			-- itemSpTexture =  'image/icon/I'..EXP_ID..'.png'
			rewardName = LANG.UI_FIGHT_44
		else
			print('error====================================== 无效道具！！！type = ',reward_type);
		end
		local buffTimes = useData['times']; --次数
		local buffTexture = 'image/fight/income/increase_num_'..buffTimes..'.png';
		local buffTime = useData['time']; --时长
		local buffTimeStr = GlobalFunctions:ChangeTime(buffTime*self.useNum);
		self.prompStr = string.format( LANG.UI_FIGHT_46,self.itemData['name'],self.useNum,buffTimeStr,rewardName,buffTimes )

		local getBuffStr = string.format( LANG.UI_FIGHT_47,rewardName,buffTimes,buffTimeStr )

		self.getItemLabel:setString(LANG.UI_FIGHT_72)
		self.getItemNum:setVisible(true);
		self.getItemSp:setVisible(false);
		self.getItemNum:setString(tostring(buffTimeStr));

	end
	-- print('...itemUse=====self.prompStr === '..tostring(self.prompStr));

end

function FightItemPanel:chooseNums(sender, event)
	local tag = sender:getTag();
	if tag == 1 then
		self.useNum = self.useNum - 10;
	elseif tag == 2 then
		self.useNum = self.useNum - 1;
	elseif tag == 3 then
		self.useNum = self.useNum + 1;
	elseif tag == 4 then
		self.useNum = self.totalNum;
	end

	if self.useNum < 1 then
		self.useNum = 1;
	elseif self.useNum > self.totalNum then
		self.useNum = self.totalNum;
	end
	
	-- self.buyNum:setString(self.useNum .. '/' .. self.totalNum);
	self.buyNum:setString(self.useNum);
	-- self.itemTotalNum1:setString( self.totalNum);
	self.itemTotalNum2:setString( self.totalNum - self.useNum);
	self:showMayGetNum();
end

function FightItemPanel:useItem()
	local msg = {};
	msg.useItem = self.id;
	msg.useNum = self.useNum;

	Network.NetworkManager:Send(Network.NetworkCmdType.req_income_item, msg);
end

function FightItemPanel:itemUseCallback( msg )
	Prompt:Show(self.prompStr);


	self.totalNum = self.totalNum - self.useNum;
	self.useNum = 1;

	self.itemList[self.id]:setNum(self.totalNum);

	if self.totalNum == 0 then
		self.noInfoNode:setVisible(true);
		self.showNode:setVisible(false)
		return;
	end

	self.buyNum:setString(self.useNum);
	self.itemTotalNum1:setString( self.totalNum);
	self.itemTotalNum2:setString( self.totalNum - self.useNum);
	self:showMayGetNum();

end

return FightItemPanel;

