local FightRoundBreakPanel = class("FightRoundBreakPanel", require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont");

function FightRoundBreakPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'FightRoundBreakPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.isPopup = true;


end

function FightRoundBreakPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

    self:initRewardNode()
    self:initBreakPromt()

	EventManager:RegisterEvent(EventType.FightRoundBreakGetReward, handler(self, self.onShowRoundBreakAni));
end

function FightRoundBreakPanel:initRewardNode( ... )
    self.rewardNode = cc.Node:create();
    self.rewardNode:addTo(self.root)
    -- self.rewardNode:setLocalZOrder(5)

	self.title = cc.Label:createWithTTF(string.format(LANG.UI_FIGHT_79, '100'), fonts.FONT_SIYUAN, 40)
		:enableOutline(cc.c3b(60, 60, 60), 2)
		:setPosition(0, 180)
		:addTo(self.rewardNode)
    self.title:setLocalZOrder(5)
    self.title:setVisible(false)

    self.rewardList = ccui.ScrollView:create();
	self.rewardList:setDirection(ccui.ScrollViewDir.horizontal)
        :setContentSize(cc.size(497, 118))
        :setScrollBarEnabled(false)
        :addTo(self.rewardNode)
        :setAnchorPoint(cc.p(0.5,0.5))
        :setPosition(cc.p(0,0))
        :setLocalZOrder(5)
        :setCascadeOpacityEnabled(true)
        :setVisible(false)

    self.openNode = cc.Node:create()
    self.openNode:addTo(self.rewardNode)
    self.openNode:setPosition(0, -200)
    self.openNode:setVisible(false)

    local msgBg = cc.Sprite:create('image/commonImg/tip_bg_1_309_28.png')
        :addTo(self.openNode)
        :setScale(2)
    local msgBg2 = cc.Sprite:create('image/commonImg/menu_light_264_36.png')
        :addTo(self.openNode)
        :setPosition(0, 30)
    self.openLabel = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 30)
        :addTo(self.openNode)
end

function FightRoundBreakPanel:initBreakPromt( ... )
    self.promtNode = cc.Node:create()
        :addTo(self.root)
        :setVisible(false)

    self.promtNode:setCascadeOpacityEnabled(true);

    local bg = cc.Sprite:create('image/fight/round_break_bg.png')
        :addTo(self.promtNode)

    self.promtTitle = cc.Label:createWithTTF('money increase:', fonts.FONT_HUAKANG, 20)
        :setPosition(-74, 0)
        :addTo(self.promtNode)

    self.promtLabelFirst = cc.Label:createWithTTF('999', fonts.FONT_HUAKANG, 20)
        :setAnchorPoint(cc.p(1, 0.5))
        :setPosition(20, 0)
        :addTo(self.promtNode)

    self.arrowSp = cc.Sprite:create('image/fpUp/level_up_bg_2.png')
        :addTo(self.promtNode)
        :setPosition(40 , 0)

    self.promtLabelSecond = cc.Label:createWithTTF('999', fonts.FONT_HUAKANG, 20)
        :setAnchorPoint(cc.p(0, 0.5))
        :setPosition(60, 0)
        :addTo(self.promtNode)

end

function FightRoundBreakPanel:initSpine( ... )
    if self.skeletonNode ~= nil then
        return 
    end

    local spine_res = 'tongguan_spine1'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then

		self.skeletonNode = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.skeletonNode:addTo(self.rewardNode)
        self.skeletonNode:setLocalZOrder(3)
        self.skeletonNode:registerSpineEventHandler(handler(self,self.spineAnimationEventCall),sp.EventType.ANIMATION_EVENT)
                
		self.skeletonNode:registerSpineEventHandler(function (event)
            		-- print(string.format("[spine] %d complete: %d", 
            		-- 						event.trackIndex,
                    --                         event.loopCount))
                    self.canPop = true 

                end, sp.EventType.ANIMATION_COMPLETE)
	else
        print('error : 缺少spine 资源')
    end     

    spine_res = 'tongguan2_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then

		self.skeletonNode2 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.skeletonNode2:addTo(self.rewardNode)
        self.skeletonNode2:setLocalZOrder(4)
	else
        print('error : 缺少spine 资源  tongguan2_spine')
    end 

end

function FightRoundBreakPanel:spineAnimationEventCall (event)
        local eventName = event.eventData.name;
        -- print('=========eventName === ',eventName)
        if eventName == 'tongguanp3'  then	-- eventName == 'tongguanp1' or eventName == 'tongguanp2' or
            self:showParticle(eventName);
        elseif eventName == 'tongguan2_spine' then 
            self:showSpine2()
        elseif eventName == 'reward' then 
            self:showReward()
        end		
end

function FightRoundBreakPanel:getParticle( particleName )
    local paticle = self.rewardNode:getChildByName(particleName)
    if paticle == nil then
        paticle = cc.ParticleSystemQuad:create("Effect/particle/"..tostring(particleName)..".plist")
        paticle:addTo(self.rewardNode);
        paticle:setName(particleName)
    end
    return paticle

end

function FightRoundBreakPanel:showParticle( particleName )
    
    if particleName == 'tongguanp3' then
        self.particle3 = self:getParticle(particleName)
        self.particle3:setPosition(cc.p(0,50))
        self.particle3:setLocalZOrder(10)
        self.particle3:resetSystem()
    end
end

function FightRoundBreakPanel:showSpine2(  )
    if self.skeletonNode2 ~= nil then
        self.skeletonNode2:setAnimation(0, "tongguan2_spine", false)
    end
end

function FightRoundBreakPanel:showSpine(  )
    self:initSpine()
    self.rewardNode:setVisible(true)
    self.skeletonNode:setAnimation(0, GlobalFunctions:lAnimationName('tongguan_spine1'), false)
end

function FightRoundBreakPanel:showReward(  )
    self.title:setVisible(true)

    local roundIndex = self.lastRound-- model.RoundModel:getRoundIndex()
    local roundName = ResTable:getValue('round', roundIndex , 'name');
    self.title:setString(string.format(LANG.UI_FIGHT_79, tostring(roundName)))

    local star = 0
    for _k , starData in pairs(ResTable:getTable('role_star').contain) do
        if starData.round_no == roundIndex then
            star = starData.star
            break;
        end
    end

    if star>0 then
        self.openNode:setVisible(true)
        self.openLabel:setString(string.format(LANG.UI_FIGHT_100, tostring(star)))
    end

    local itemList = self.roundReward
    local itemSize = cc.size(114,118)
    local index = 0
	if itemList then
		for k, v in ipairs(itemList) do
            local item = require('app.template.ItemTemplate'):create(2);
            item:addTo(self.rewardList);
			item:setPosition(250 + index*itemSize.width , itemSize.height/2);
			item:setCanShowInfo(true);
			item:Init(v[1], v[2]);
			index = index + 1;
		end
	end

    self.rewardList:setVisible(true)
end

function FightRoundBreakPanel:showPromtRecurisve(  )
    self.promtNode:setVisible(true)
    self.promtNode:setPosition(cc.p(0,0))
    self.promtNode:setOpacity(0)

    local promtInfo = table.remove( self.promtList )
    if promtInfo == nil then
        self.canPop = true ;
        self:onClickBack()
        return 
    end

    self.promtTitle:setString(promtInfo.title)
    self.promtLabelFirst:setString(promtInfo.first)
    self.promtLabelSecond:setString(promtInfo.second)

    self.promtNode:runAction(cc.Sequence:create(
        cc.Spawn:create(cc.FadeIn:create(0.5),cc.MoveBy:create(0.5,cc.p(0,10))),
        cc.DelayTime:create(1),
        cc.FadeOut:create(0.5),
        cc.CallFunc:create(function (  )
            self:showPromtRecurisve()
        end )
    ))


end

function FightRoundBreakPanel:showRoundBreakPromt( ... )
    self:removeSwallowLayer();

    local curRound = model.RoundModel:getRoundIndex();
    local roundData = ResTable:getRowData('round', curRound);
    local lastRound = self.lastRound --curRound - 1;
    local roundDataLast = ResTable:getRowData('round', lastRound);
    local lastMoney,lastExp = nil,nil 
    if roundDataLast == nil then
        lastMoney = 0
        lastExp = 0
    end
    self.promtList = {}
    local moneyPromt = {
        title = LANG.UI_FIGHT_80,
        first = lastMoney or ConvertStrToDigitUnit(HpMultiply(ConvertDigitUnitToStr(roundDataLast['coin']), 3)),
        second = ConvertStrToDigitUnit(HpMultiply(ConvertDigitUnitToStr(roundData['coin']), 3)),
    }
    table.insert( self.promtList,moneyPromt )
    local expPromt = {
        title = LANG.UI_FIGHT_81,
        first = lastExp or tonumber(roundDataLast['exp'])*3,
        second = tonumber(roundData['exp'])*3,
    }
    table.insert( self.promtList,expPromt )

    self.rewardNode:setVisible(false);

    self:showPromtRecurisve()

end

function FightRoundBreakPanel:onEnter( option )
    self.root:setVisible(true);
  
    self.rewardList:removeAllChildren()
    self.rewardNode:setVisible(false)
    self.title:setVisible(false)
    self.openNode:setVisible(false)

    self.lastRound = nil;
    self.callback = nil ;
    self.callbackParams = nil;
    self.showType = 1;
    if option then
        self.lastRound = option.round;
        self.callback = option.callback;
        self.showType = option.type;
        self.callbackParams = option.callbackParams;
    end
    if self.showType == 1 then
        self:addSwallowCallback(handler(self, self.onClickBack));
        model.RoundModel:reqRoundBreakReward( self.lastRound )
    else
        -- self.showStep = 2;
        self.canPop = false;
        self:showRoundBreakPromt()
    end
end

function FightRoundBreakPanel:onShowRoundBreakAni( msg )
    -- self.showStep = 1;
    self.canPop = false;

    self.roundReward = {};
    local money = msg.money 
	if money ~= nil and  money.change and string.find(money.change , '-') == nil then
        table.insert(self.roundReward , {MONEY_ID, money.change});
	end

	local exp = msg.userExp;
	if exp ~= nil and exp.change then
		table.insert(self.roundReward , {EXP_ID, exp.change});
    end
    
	if msg.itemChange then
		for k, v in ipairs(msg.itemChange) do
			if tonumber(v.addNum) > 0  then
				table.insert(self.roundReward , {v.no, v.addNum});
			end
		end
    end
    
	if msg.newPartner  then
		isShow = true;
		for _k , v  in pairs(msg.newPartner) do
			table.insert(self.roundReward , {ROLE_TYPE,v.no});
		end
	end

	if msg.newEquip then
		for _k , v  in pairs(msg.newEquip) do
            table.insert(self.roundReward , {v.no,1});
		end
	end

	if msg.newAvatar then
		for _k , v  in pairs(msg.newAvatar) do
			table.insert(self.roundReward , {ROLE_AVATAR_TYPE,v.no});
		end
	end

    self:showSpine();
end

function FightRoundBreakPanel:onLeave()
	self.root:setVisible(false);
end

function FightRoundBreakPanel:onClickBack()

    if self.canPop == false then
        return 
    end
    -- if self.showStep == 1 then
    --     self.canPop = false 
    --     self.showStep = 2;
    --     self:showRoundBreakPromt();
    --     return 
    -- end
    if self.callback then
        self.callback(self.callbackParams)
    end
	UIManager:pop('FightRoundBreakPanel');

end

return FightRoundBreakPanel