local FightStatisticsPanel = class("FightStatisticsPanel", require('app.layer.BaseLayer'))

local imagePath = 'image/fight/result/';
local fonts = Enum:getTable("SystemFont")

 -- local titleMsg = { [1]='伤害输出', [2]='治疗恢复', [3]='承受伤害'}
 local titleMsg = { [1]=LANG.UI_FIGHT_STATISTICS_1, [2]=LANG.UI_FIGHT_STATISTICS_2, [3]=LANG.UI_FIGHT_STATISTICS_3}
 local titlePng = { [1]='statistics_item_1.png', [2]='statistics_item_2.png', [3]='statistics_item_3.png'}
 local textColor = { [1]=cc.c3b(255,225,215), [2]=cc.c3b(235,255,225), [3]=cc.c3b(215,250,255)}
 local rolePos = {cc.p(0,88), cc.p(0,26), cc.p(0,-34),cc.p(0,-95)}

function FightStatisticsPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'FightStatisticsPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.haveSwallowLayer = true;
	self.isPopup = true;
end

function FightStatisticsPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels();
end

function FightStatisticsPanel:initPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,830));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 7);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_FIGHT_STATISTICS_4 , 606 , 63 , 'STATISTICS');
	titleNode:addTo(self.root);
    titleNode:setPosition(0 , 448);

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.root);
	listBg:setPosition(0 , 163);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(568 , 290));

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.root);
	listBg:setPosition(0 , -246);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(568 , 290));

    self:initLeftListNode()
    self:initRightListNode()

    self:initOtherInfo()

    self.stbtn1 = ccui.Button:create(imagePath .. 'statistics_btn_1.png',imagePath .. 'statistics_btn_1.png');
	self.stbtn1:setPosition(170, -460)
	self.stbtn1:addTo(self.root);
	self.stbtn1:addClickEventListener(handler(self, self.st1));
	self.stbtn1:setEnabled(false)

	self.stbtn2 = ccui.Button:create(imagePath .. 'statistics_btn_2.png',imagePath .. 'statistics_btn_2.png');
	self.stbtn2:setPosition(250, -460)
	self.stbtn2:addTo(self.root);
	self.stbtn2:addClickEventListener(handler(self, self.st2));
	self.stbtn2:setEnabled(false)
	
	self.noSelect = cc.Sprite:create(imagePath..'statistics_bg_4.png');
	self.noSelect:addTo(self.root);
	self.noSelect:setPosition(170,-460);
end

function FightStatisticsPanel:initLeftListNode()

    self.leftWinBg = cc.Sprite:create(imagePath..'st_win.png')
	:addTo(self.root)
	:setPosition(22,372)
	
    self.leftLoseBg = cc.Sprite:create(imagePath..'st_lose.png')
	:addTo(self.root)
	:setPosition(22,372)

    self.leftHeadNode = template.ItemTemplate:create();
    self.leftHeadNode:addTo(self.root)
	self.leftHeadNode:setPosition(-240,352)
	self.leftHeadNode:setScale(0.6)
	
    self.leftName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	:setPosition(-197, 352)
	:addTo(self.root)
	:setAnchorPoint(0, 0.5)
	:enableOutline(cc.c3b(120, 85, 10), 2)

	self.leftBodyNode = cc.Node:create()
    :addTo(self.root)
	:setPosition(0, 163)
	
	local bg = cc.Sprite:create(imagePath..'statistics_bg_6.png');
	bg:addTo(self.leftBodyNode);
	bg:setPosition(0,-7);

    for i=1,3 do
    	local bg = cc.Sprite:create(imagePath..titlePng[i])
			:addTo(self.leftBodyNode)
			:setPosition(-162 + (i-1)* 159, 130)

    	local label = cc.Label:createWithTTF(titleMsg[i], fonts.FONT_SIYUAN, 15)
			:setPosition(8, 0)
			:addTo(self.leftBodyNode)
			:setPosition(-117 + (i-1)* 159, 130)
			:setTextColor(textColor[i])

    end

    self.leftRoleList = {};
	for i=1, TEAM_MAX_MEMBER do
		self.leftRoleList[i] = {}

		self.leftRoleList[i].node = cc.Node:create()
			:addTo(self.leftBodyNode)
			:setPosition(rolePos[i])

		self.leftRoleList[i].roleNode = template.ItemTemplate:create(2);
		self.leftRoleList[i].roleNode:addTo(self.leftRoleList[i].node);
		self.leftRoleList[i].roleNode:setPosition(-232, -4);
		self.leftRoleList[i].roleNode:setScale(0.5);

		self.leftRoleList[i].info = {}
		for j=1,3 do
			self.leftRoleList[i].info[j] = {}
			local node = cc.Node:create()
			:addTo(self.leftRoleList[i].node)
			:setPosition(-118+(j-1)*154 ,3)

			local label = cc.Label:createWithTTF('18888', fonts.FONT_SIYUAN, 22)
			:setPosition(0, -17)
			:addTo(node)
			:enableOutline(cc.c3b(20, 20, 20), 2)

			local barBg = cc.Sprite:create(imagePath..'statistics_bg_7.png')
			:addTo(node)

			local bar = cc.Scale9Sprite:create(imagePath..'statistics_ps_'..j..'.png')
			:addTo(node)
			:setPosition(-67 , 0)
			:setAnchorPoint(0,0.5)
    		:setCapInsets(cc.rect(5,0,2,10))

			self.leftRoleList[i].info[j].label = label;
			self.leftRoleList[i].info[j].bar = bar;

		end

	end
end

function FightStatisticsPanel:initOtherInfo()
	self.leftSkillList = {}
	self.leftOtherNode = cc.Node:create()
	:addTo(self.root)

	self.leftScrollView = ccui.ScrollView:create();
	self.leftScrollView:setTouchEnabled(true);
	self.leftScrollView:setBounceEnabled(true);
	self.leftScrollView:setDirection(ccui.ScrollViewDir.vertical);
	self.leftScrollView:setContentSize(cc.size(558 , 280));
	self.leftScrollView:setAnchorPoint(0.5 , 0.5);
	self.leftScrollView:setPosition(0 , 163);
	self.leftScrollView:addTo(self.leftOtherNode);

	self.leftScrollView:setInnerContainerSize(cc.size(558 , 412));

	for i=1, TEAM_MAX_MEMBER do
		local cell = require('app.template.CardSticTemplate'):create(self.leftScrollView);
		cell:setPosition(72+(i-1)*138, 412);
		self.leftSkillList[i] = cell
	end


	self.rightSkillList = {}
	self.rightOtherNode = cc.Node:create()
	:addTo(self.root)

	self.rightScrollView = ccui.ScrollView:create();
	self.rightScrollView:setTouchEnabled(true);
	self.rightScrollView:setBounceEnabled(true);
	self.rightScrollView:setDirection(ccui.ScrollViewDir.vertical);
	self.rightScrollView:setContentSize(cc.size(558 , 280));
	self.rightScrollView:setAnchorPoint(0.5 , 0.5);
	self.rightScrollView:setPosition(0 , -246);
	self.rightScrollView:addTo(self.rightOtherNode);

	self.rightScrollView:setInnerContainerSize(cc.size(558 , 412));

	for i=1, TEAM_MAX_MEMBER do
		local cell = require('app.template.CardSticTemplate'):create(self.rightScrollView);
		cell:setPosition(72+(i-1)*138, 412);
		self.rightSkillList[i] = cell
	end
	
end

function FightStatisticsPanel:initRightListNode()

    self.rightWinBg = cc.Sprite:create(imagePath..'st_win.png')
	:addTo(self.root)
	:setPosition(22,-35)
    self.rightLoseBg = cc.Sprite:create(imagePath..'st_lose.png')
	:addTo(self.root)
	:setPosition(22,-35)

    self.rightHeadNode = template.ItemTemplate:create(2)
    self.rightHeadNode:addTo(self.root)
	self.rightHeadNode:setPosition(-240,-56)
	self.rightHeadNode:setScale(0.6)
	
    self.rightName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	:setPosition(-197, -56)
	:addTo(self.root)
	:setAnchorPoint(0, 0.5)
	:enableOutline(cc.c3b(120, 85, 10), 2)

	self.rightBodyNode = cc.Node:create()
    :addTo(self.root)
    :setPosition(0, -249)

	local bg = cc.Sprite:create(imagePath..'statistics_bg_6.png');
	bg:addTo(self.rightBodyNode);
	bg:setPosition(0,-7);

    for i=1,3 do
    	local bg = cc.Sprite:create(imagePath..titlePng[i])
			:addTo(self.rightBodyNode)
			:setPosition(-162 + (i-1)* 159, 130)

    	local label = cc.Label:createWithTTF(titleMsg[i], fonts.FONT_SIYUAN, 15)
			:setPosition(8, 0)
			:addTo(self.rightBodyNode)
			:setPosition(-117 + (i-1)* 159, 130)
			:setTextColor(textColor[i])

    end

    self.rightRoleList = {};
	for i=1, TEAM_MAX_MEMBER do
		self.rightRoleList[i] = {}

		self.rightRoleList[i].node = cc.Node:create()
			:addTo(self.rightBodyNode)
			:setPosition(rolePos[i])

		self.rightRoleList[i].roleNode = template.ItemTemplate:create(2);
		self.rightRoleList[i].roleNode:addTo(self.rightRoleList[i].node);
		self.rightRoleList[i].roleNode:setPosition(-232, -4);
		self.rightRoleList[i].roleNode:setScale(0.5);

		self.rightRoleList[i].info = {}
		for j=1,3 do
			self.rightRoleList[i].info[j] = {}
			local node = cc.Node:create()
			:addTo(self.rightRoleList[i].node)
			:setPosition(-118+(j-1)*154 ,3)

			local label = cc.Label:createWithTTF('18888', fonts.FONT_SIYUAN, 22)
			:setPosition(0, -17)
			:addTo(node)
			:enableOutline(cc.c3b(20, 20, 20), 2)

			local barBg = cc.Sprite:create(imagePath..'statistics_bg_7.png')
			:addTo(node)

			local bar = cc.Scale9Sprite:create(imagePath..'statistics_ps_'..j..'.png')
			:addTo(node)
			:setPosition(-67 , 0)
			:setAnchorPoint(0,0.5)
    		:setCapInsets(cc.rect(5,0,2,10))

			self.rightRoleList[i].info[j].label = label;
			self.rightRoleList[i].info[j].bar = bar;

		end
	end
end

function FightStatisticsPanel:onEnter( )
	self.root:setVisible(true);
	self:addSwallowCallback(handler(self, self.onClickBack));
	
	self:UpdateInfo()

	self:switchShow(false)

	self.leftScrollView:scrollToTop(0, true)
	self.rightScrollView:scrollToTop(0, true)
end

function FightStatisticsPanel:st1()
	self:switchShow(false)
	AudioManager:playEffect(Conf.buttonClick);
end
function FightStatisticsPanel:st2()
	self:switchShow(true)
	AudioManager:playEffect(Conf.buttonClick);
end

function FightStatisticsPanel:switchShow(b)
	-- body
	self.stbtn1:setEnabled( b )
	self.leftBodyNode:setVisible( not b )
	self.rightBodyNode:setVisible( not b )

	self.leftOtherNode:setVisible(b)
	self.rightOtherNode:setVisible(b)
	self.stbtn2:setEnabled( not b )

	self.noSelect:setPositionX(b and 170 or 250);
end

function FightStatisticsPanel:UpdateInfo()
	local leftList, rightList, leftSumR, rightSumR = FightManager:getRecordFightMsg()
	local isWin = false
	if FightManager:getWin() == 1 then
		isWin = true
	end

	if isWin then
		self.leftWinBg:setVisible(true)
	    self.leftLoseBg:setVisible(false)
	    self.leftName:enableOutline(cc.c3b(120, 85, 10), 2)

	    self.rightWinBg:setVisible(false)
	    self.rightLoseBg:setVisible(true)
	    self.rightName:enableOutline(cc.c3b(0, 100, 150), 2)
	else
		self.leftWinBg:setVisible(false)
	    self.leftLoseBg:setVisible(true)
	    self.leftName:enableOutline(cc.c3b(0, 100, 150), 2)

	    self.rightWinBg:setVisible(true)
	    self.rightLoseBg:setVisible(false)
	    self.rightName:enableOutline(cc.c3b(120, 85, 10), 2)
	end

	for i=1, TEAM_MAX_MEMBER do
		self.leftRoleList[i].node:setVisible(false)
		self.rightRoleList[i].node:setVisible(false)
	end

	local leftTitle = true
	for fid,v in pairs(leftList) do
		local fighter = FightManager:GetFighter(fid)
		if fighter then
			local idx = fighter:GetPositionIndex()
			if self.leftRoleList[idx] then
				self.leftRoleList[idx].node:setVisible(true)

				if leftTitle then
					leftTitle = false
					if fighter.pid and fighter.pid > 0 then
			        	local card = model.CardModel:GetCard(fighter.pid);
						self.leftHeadNode:Init(ROLE_TYPE , card.no,card.star_lv,card.level);
						self.leftHeadNode:updateAltarLevelColor(card.oriLv)

			            local name = ResTable:getValue('role_info', card.no, 'name');
			            self.leftName:setString( '['..name..']' )
			        end	
				end

				if fighter.pid and fighter.pid > 0 then
		        	local card = model.CardModel:GetCard(fighter.pid);
					self.leftRoleList[idx].roleNode:Init(ROLE_TYPE , card.no,card.star_lv,card.level);
					self.leftRoleList[idx].roleNode:updateAltarLevelColor(card.oriLv)
		        end	

		        local atkPro = 0
		        if leftSumR['Atk']>0 then
		        	atkPro = v['Atk']/leftSumR['Atk']
				end
				
				local width = 133 * atkPro;
				if width > 0 then
					width = width < 12 and 12 or width;
				end
		        self.leftRoleList[idx].info[1].label:setString( v['Atk'] )
		        self.leftRoleList[idx].info[1].bar:setContentSize(cc.size(width,10))

		        local helpPro = 0
		        if leftSumR['Help']>0 then
		        	helpPro = v['Help']/leftSumR['Help']
				end
				
				width = 133 * helpPro;
				if width > 0 then
					width = width < 12 and 12 or width;
				end
		        self.leftRoleList[idx].info[2].label:setString( v['Help'] )
		        self.leftRoleList[idx].info[2].bar:setContentSize(cc.size(width,10))

		        local damPro = 0
		        if leftSumR['Dam']>0 then
		        	damPro = v['Dam']/leftSumR['Dam']
				end
				
				width = 133 * damPro;
				if width > 0 then
					width = width < 12 and 12 or width;
				end
		        self.leftRoleList[idx].info[3].label:setString( v['Dam'] )
		        self.leftRoleList[idx].info[3].bar:setContentSize(cc.size(width,10))

			end
		end

	end

	local rightTitle = true
	local idx = 1
	for fid,v in pairs(rightList) do
		local fighter = FightManager:GetFighter(fid)
		if fighter then
			if self.rightRoleList[idx] then
				self.rightRoleList[idx].node:setVisible(true)

				if rightTitle then
					rightTitle = false
					local resId = fighter:GetResID();
					if fighter:getIsAutoMonster() then
						self.rightHeadNode:Init(MONSTER_ROLE_TYPE , resId, 1, fighter:getFightLv());
			            local name = ResTable:getValue('monster', resId, 'name');
			            self.rightName:setString( '['..name..']' )
					else
						self.rightHeadNode:Init(ROLE_TYPE , resId, 1, fighter:getFightLv());
			            local name = ResTable:getValue('role_info', resId, 'name');
			            self.rightName:setString( '['..name..']' )
					end

					

				end				

				if fighter:getIsAutoMonster() then
			        self.rightRoleList[idx].roleNode:Init(MONSTER_ROLE_TYPE , fighter:GetResID(), 1, fighter:getFightLv());
			    else
			    	self.rightRoleList[idx].roleNode:Init(ROLE_TYPE , fighter:GetResID(), 1, fighter:getFightLv());
			    end

		        local atkPro = 0
		        if rightSumR['Atk']>0 then
		        	atkPro = v['Atk']/rightSumR['Atk']
				end
				local width = 133 * atkPro;
				if width > 0 then
					width = width < 12 and 12 or width;
				end

		        self.rightRoleList[idx].info[1].label:setString( v['Atk'] )
		        self.rightRoleList[idx].info[1].bar:setContentSize(cc.size(width,10))

		        local helpPro = 0
		        if rightSumR['Help']>0 then
		        	helpPro = v['Help']/rightSumR['Help']
				end
				
				width = 133 * helpPro;
				if width > 0 then
					width = width < 12 and 12 or width;
				end

		        self.rightRoleList[idx].info[2].label:setString( v['Help'] )
		        self.rightRoleList[idx].info[2].bar:setContentSize(cc.size(width,10))

		        local damPro = 0
		        if rightSumR['Dam']>0 then
		        	damPro = v['Dam']/rightSumR['Dam']
				end
				
				width = 133 * damPro;
				if width > 0 then
					width = width < 12 and 12 or width;
				end
		        self.rightRoleList[idx].info[3].label:setString( v['Dam'] )
		        self.rightRoleList[idx].info[3].bar:setContentSize(cc.size(width,10))

		        idx = idx+1

			end
		end

	end


	---更新技能统计数值
	for i=1, TEAM_MAX_MEMBER do
		self.leftSkillList[i]:Init(nil)
		self.rightSkillList[i]:Init(nil)
	end

	for fid,v in pairs(leftList) do
		local fighter = FightManager:GetFighter(fid)
		if fighter then
			local idx = fighter:GetPositionIndex()
			if self.leftSkillList[idx] then
				self.leftSkillList[idx]:Init(fighter)
			end
		end
	end

	local idx = 1
	for fid,v in pairs(rightList) do
		local fighter = FightManager:GetFighter(fid)
		if fighter then
			if self.rightSkillList[idx] then
				self.rightSkillList[idx]:Init(fighter)
				idx = idx + 1
			end
		end
	end

end

function FightStatisticsPanel:onLeave()
	self.root:setVisible(false);
end

function FightStatisticsPanel:onClickOkBtn( sender,eventType )
	self:onClickBack();
end

function FightStatisticsPanel:onClickBack()
	UIManager:pop('FightStatisticsPanel');
end

return FightStatisticsPanel;
