local FooterPanel = class("FooterPanel" , require('app.layer.BaseLayer'))

local footerPath = 'image/footer/'

local scheduler = cc.Director:getInstance():getScheduler();
local FightType = Enum:getTable('FightType')
local AutoBattleBuff = Enum:getTable('AutoBattleBuff')


local footerClickList = 
{
	[1] = 'MainPanel',
	[2] = 'CardListPanel',
	[3] = 'FightPanel',
	--[3] = 'GachaListPanel',
	[4] = 'BelleBallMainPanel', --'GuildPanel',
	[5] = 'HomeBasePanel',
	[6] = 'GachaListPanel',
}

local btnPos = {
	cc.p(-270, -520),
	cc.p(-163, -520),
	cc.p(-55, -520),
	cc.p(53, -520),
	cc.p(162, -520), 
	cc.p(270, -520), 
}

local fonts = Enum:getTable("SystemFont")

function FooterPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'FooterPanel');

	self.useCCreator = false;
	self.isPopup = true;
	self.haveSwallowLayer = false;

	if IsKr then
		footerClickList[4] = 'GuildPanel'
	end
end

function FooterPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels();
end

function FooterPanel:initPanels()
	self.initAniEnd = true;
	self.canClick = true;

	self.node = cc.Node:create();
	self.node:addTo(self.root);
	self.node:setPosition(0 , 568 - StageSize.height / 2);

	self.btnNode = cc.Node:create();
	self.btnNode:addTo(self.node)

	-- bg
	self.bg = cc.Sprite:create(footerPath .. 'footer_bg_1.png')
		:setLocalZOrder(0)
		:setPosition(0, -519)
		:addTo(self.btnNode)

	local light = cc.Sprite:create(footerPath..'footer_bg_4.png');
	light:addTo(self.bg);
	light:setPosition(self.bg:getContentSize().width/2,self.bg:getContentSize().height/2+43)

	-- btns

	self.lineList = {};
	for i = 1 , 5 do
		local line = cc.Sprite:create(footerPath..'footer_bg_3.png')
		line:addTo(self.btnNode);
		line:setPosition(-217 + (i-1)*108 , -520);

		self.lineList[i] = line;
	end

	self.btnList = {};
	for i=1, 6 do
		local btn = {};
		self.btnList[i] = btn;

		btn.root = cc.Node:create()
			:setPosition(btnPos[i])
			:addTo(self.btnNode)
		btn.root:setCascadeOpacityEnabled(true);

		btn.select = cc.Sprite:create(footerPath..'footer_bg_2.png')
		btn.select:addTo(btn.root);
		btn.select:setVisible(i == 1);
		btn.select:setPosition(0 , -1);

		local btnIconName = footerPath .. 'footer_btn_' .. i .. '.png';
		local btnName = LANG.UI_FOOTER_NAME[i];
		if IsKr and i==4 then
			btnIconName = footerPath .. 'footer_btn_' .. i .. '-b.png';
			btnName = LANG.UI_L_HOME[model.HomeModel.HomeMenuTag.TAG_GUILD];
		end

		btn.btn = ccui.Button:create(btnIconName)
		btn.btn:setZoomScale(0)
		btn.btn:setTag(i)
		btn.btn:addClickEventListener(handler(self, self.clickFooter))
		btn.btn:addTo(btn.root)

		btn.label = cc.Label:createWithTTF(btnName , fonts.FONT_SIYUAN , 20);
		btn.label:addTo(btn.root);
		btn.label:setPosition(0 , -29);
		btn.label:enableOutline(i== 1 and cc.c3b(30 , 80 , 140) or cc.c3b(0 , 0 , 0) , 2);

		if i == 4 then
			btn.lockImg2 = cc.Sprite:create('image/footer/footer_shader.png')
				:setVisible(false)
				:addTo(btn.root)
			local lock = cc.Sprite:create('image/lock/lock_bg_2.png')
				:addTo(btn.lockImg2)
				:setPosition(52.5,44)
		end
	end

	self.fightRoleNode = cc.Node:create()
		:setLocalZOrder(5)
		:setVisible(false)
		:setPosition(0, -582)
		:addTo(self.node)
	
	self.skillCastNewList = {};
	local spaceL = 140;
	for j=1, TEAM_MAX_MEMBER do
		local info = require('app.template.SkillCastTemplateNew'):create(self.fightRoleNode, j)
		info:setPosition(-1.5*spaceL+(j-1)*spaceL, 100);
		self.skillCastNewList[j] = info;
	end

	-- income
	self:initFightBtnNode()
	self:initFastReward()
	self:initIncomeNode()
	
	self:registEvent()
	self.playBtnBossProgress = false;

	UIManager:push("FooterPanel" , 'MainPanel');
	self:runAction()
end

function FooterPanel:isAniEnd()
	return self.initAniEnd;
end

function FooterPanel:runAction()
	self.initAniEnd = false;
	for i,btnIdxs in ipairs({{3,4},{2,5},{1,6}}) do
		for _k , idx in ipairs(btnIdxs) do
			self.btnList[idx].root:stopAllActions();
			self.btnList[idx].root:setPosition(btnPos[idx].x , -611);
			self.btnList[idx].root:setOpacity(0);

			local action1 = cc.MoveTo:create(10/25 , cc.p(btnPos[idx].x , btnPos[idx].y+5));
			local action2 = cc.FadeIn:create(7/25);
			local actionSpawn = cc.Spawn:create(action1,action2);
			local action3 = cc.MoveTo:create(2/25 , btnPos[idx]);
			
			self.btnList[idx].root:runAction(cc.Sequence:create(cc.DelayTime:create((5+4*(i-1))/25) , actionSpawn , action3));
		end
	end

	for i = 1 , 5 do
		self.lineList[i]:stopAllActions()
		self.lineList[i]:setOpacity(0);
		local action1 = cc.FadeIn:create(4/25);
		local action2 = cc.FadeTo:create(4/25,127);

		self.lineList[i]:runAction(cc.Sequence:create(cc.DelayTime:create(28/25) , action1 , action2));
	end
	self.root:runAction( cc.Sequence:create(cc.DelayTime:create(28/25) , cc.CallFunc:create(function()
			self.initAniEnd = true;
		end)
	))
end

function FooterPanel:registEvent()

	EventManager:RegisterEvent(EventType.UIFooterRedDotShow, handler(self, self.updateRedDotShow));
	EventManager:RegisterEvent(EventType.UIEventUnlockChange, handler(self, self.updateLevelLock));
	EventManager:RegisterEvent(EventType.UIFooterChooseFooter , handler(self , self.chooseFooter));
	EventManager:RegisterEvent(EventType.UIFooterUpdateZOrder , handler(self , self.updateZOrder));
	EventManager:RegisterEvent(EventType.UIFooterUpdateSelect , handler(self , self.setSelectState));
	EventManager:RegisterEvent(EventType.UIFooterRunAction, handler(self, self.runAction));

	EventManager:RegisterEvent(EventType.FightNext, handler(self, self.backAutoFight));
	EventManager:RegisterEvent(EventType.FightBegin, handler(self, self.leaveAutoFight));
	EventManager:RegisterEvent(EventType.FightInitSkillIcon, handler(self, self.initSkillIcon));
    EventManager:RegisterEvent(EventType.FightUpdateSkillIcon, handler(self, self.updateSkillIcon));
	EventManager:RegisterEvent(EventType.FightIncomeChange, handler(self, self.updateIncomeLabel));
	EventManager:RegisterEvent(EventType.Die, handler(self, self.setFighterDie));
	EventManager:RegisterEvent(EventType.Revive, handler(self, self.setFighterRevive));
	EventManager:RegisterEvent(EventType.FightIncomeChange, handler(self, self.playIncomeBoxEffect));
	EventManager:RegisterEvent(EventType.FightUpdateFooterRedDot, handler(self, self.updateRedDotShow));
	EventManager:RegisterEvent(EventType.UIFightFooterPanelVisible, function(visible)
		if UIManager:getLayer('FightPanel'):isVisible() then
			self.node:setVisible(visible)
		end
	end)

	EventManager:RegisterEvent(EventType.FightAddLabel, handler(self, self.updateFighterHp));
	EventManager:RegisterEvent(EventType.FightFooterBuff, handler(self, self.updateFighterBuff));

	EventManager:RegisterEvent(EventType.AutoFightTimeScale, handler(self, self.updateBuff));

	
end

function FooterPanel:initIncomeNode()
	self.incomeState = 0;
	self.incomeNode = cc.Node:create()
		:setPosition(StageSize.width/2-35, -422)
		:addTo(self.node)

	self.incomeBtn = ccui.Button:create('image/commonImg/bg_1_11_11_34_28.png')
		:setPosition(0, 0)
		:setTouchEnabled(true)
		:setZoomScale(0)
		:setOpacity(0)
		:setFlippedX(true)
		:setScale9Enabled(true)
		:setContentSize(cc.size(75 , 75))
		:addTo(self.incomeNode)
	self.incomeBtn:addClickEventListener(handler(self, self.showIncomePanel))

	local spine_res = 'baoxiang_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.income1Spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.income1Spine:addTo(self.incomeNode)
		self.income1Spine:setAnimation(0,'baoxiang_spine_idle1',true);
		self.income1Spine:registerSpineEventHandler( handler(self,self.resetIncomeAni), sp.EventType.ANIMATION_COMPLETE )
		self.income1St = false;

		self.income2Spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.income2Spine:addTo(self.incomeNode)
		self.income2Spine:setAnimation(0,'baoxiang_spine_lizi1',true);

		self.income3Spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.income3Spine:addTo(self.incomeNode)
		self.income3Spine:setVisible(false)
		self.income3Spine:setAnimation(0,'baoxiang_spine_full2',true);
	end

	local labelBg = cc.Sprite:create(footerPath .. 'guajiincom_bg.png');
	labelBg:addTo(self.incomeNode);
	labelBg:setPosition(0, -30)

	local tmpLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_24, fonts.FONT_SIYUAN, 16)
		:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2)
		:setPosition(0, -30)
		:addTo(self.incomeNode)

	self.boxIncomeEffect = cc.Sprite:create()
		:setLocalZOrder(100)
		:addTo(self.incomeNode)
		:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE))
		:setPosition(25, 20);

	self.incomeLabel = cc.Label:createWithTTF('327.78AB', fonts.FONT_IMPACT, 20)
		:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2)
		:setPosition(0, 0)
		:addTo(self.incomeNode)
		:setVisible(false)
	self:updateFightIncomeVisible();

	-- buff 加成
	-- 月卡，活动，广告
	local pos = {
		cc.p(-81,12),
		cc.p(-63,30),
		cc.p(-46,48)
	}
	self.buffNode = cc.Node:create()
		:addTo(self.incomeNode)

	-- 月卡，活动，广告
	for i=1,3 do
		local tempNode = cc.Node:create()
			:addTo(self.buffNode)
			:setPosition(pos[i])
			:setTag(i)
		local bgImg = footerPath .. 'buff_bg1.png'
		if i ~= 1 then
			bgImg = footerPath .. 'buff_bg2.png'
		end
		local bg = cc.Sprite:create(bgImg)
			:addTo(tempNode)

		local onlineBtn = ccui.Button:create(footerPath .. 'buff_item'..i..'.png')
			:addTo(tempNode)
			:setTag(i);
		onlineBtn:addClickEventListener(handler(self,self.showBuffInfo));

		local title_label = cc.Label:createWithTTF('X2', fonts.FONT_SIYUAN, 10)
			:setPosition(15, 0)
			:addTo(tempNode)
			:setTag(101)
	end
	self.buffMonth = self.buffNode:getChildByTag(1)
	self.buffMonthLabel = self.buffMonth:getChildByTag(101)
	self.buffActivity = self.buffNode:getChildByTag(2)
	self.buffActivityLabel = self.buffActivity:getChildByTag(101)
	self.buffAdmob = self.buffNode:getChildByTag(3)
	self.buffAdmobLabel = self.buffAdmob:getChildByTag(101)


	self.buffMonthLabel:setString('X2')
	self.buffActivityLabel:setString('X4')
	self.buffAdmobLabel:setString('X2')

	-- self.buffMonth:setVisible(false)
	-- self.buffActivity:setVisible(false)
	-- self.buffAdmob:setVisible(false)

end

function FooterPanel:initFightBtnNode()
	self.fightBtnNode = cc.Node:create()
		:addTo(self.node)
		:setPosition(0, -407)

	local bg = cc.Sprite:create(footerPath..'lang_bar_bg.png')
		:addTo(self.fightBtnNode)

	local bgBtn = ccui.Button:create(footerPath..'fight_btn.png');
	bgBtn:addTo(self.fightBtnNode);
	bgBtn:addClickEventListener(handler(self,self.startFight));

	self.fightBtnSpr = cc.Sprite:create(footerPath..'fight_btn_spr.png')
		:addTo(self.fightBtnNode)
		:setPosition(0,0)
		:setVisible(false)

	self.fightNum = cc.Sprite:create(footerPath..'f5.png')
		:addTo(self.fightBtnNode)
		:setPosition(0,0)
		:setVisible(false)

	self.btnCooldown = 5
	local spine_res = 'challenge_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.btnSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.btnSpine:addTo(self.fightBtnNode)
		self.btnSpine:setPosition(0, 0)
		self.btnSpine:setAnimation(0,GlobalFunctions:lAnimationName('challenge_spine_2'),true);

		self.btnSpine:registerSpineEventHandler(function (event)
			if self.btnCooldown == 5 then
				return;
			end
			self.btnSpine:setAnimation(0,GlobalFunctions:lAnimationName('challenge_spine_2'),true);
		end, sp.EventType.ANIMATION_COMPLETE)
	end
end

function FooterPanel:initFastReward()
	self.fastFightNode = cc.Node:create()
		:addTo(self.node)
		:setPosition(-StageSize.width/2+65, -412);

	local bgBtn = ccui.Button:create('image/fight/fast/fast_btn.png');
	bgBtn:addTo(self.fastFightNode);
	bgBtn:addClickEventListener(handler(self,self.showFastFightRewardPanel));

	local label = cc.Label:createWithTTF(LANG.UI_FIGHT_73 , fonts.FONT_SIYUAN , 16);
	label:addTo(self.fastFightNode);
	label:setPosition(15 , 0);
	label:setTextColor(cc.c3b(255, 255, 255))
	label:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
end

function FooterPanel:onEnter(curPanelName)

	-- onEnter
	self:updateLock(4);
	self:updateLock(3);
	--初始化 红点
	self:updateRedDotShow(6);
	self:updateRedDotShow(5);
	self:updateRedDotShow(4);
	self:updateRedDotShow(2);
	self:updateRedDotShow(10)

	self:updateZOrder(curPanelName);

	self.btnNode:setVisible(true);
	self.fightRoleNode:setVisible(false);
	if curPanelName == 'FightPanel' then
		local incomeMoney = model.AutoFightModel:getIncomeMoney();
		self:setIncomeLabel(incomeMoney);
		self:updateIncomeBox();

		self.fightBtnNode:setVisible(true);
		self.fastFightNode:setVisible(true);
		self.incomeNode:setVisible(true);
	else
		self.fightBtnNode:setVisible(false);
		self.fastFightNode:setVisible(false);
		self.incomeNode:setVisible(false);
	end

	self:updateBuff()

	self.root:setVisible(true);

end

function FooterPanel:showBuffInfo( sender,event )
	local tag = sender:getTag()
	local buffTimestamp, buffTimes = model.AutoFightModel:getBuffTimestampAndTimes(tag)
	if tonumber(buffTimestamp) == nil or tonumber(buffTimestamp) <= 0 then
		return;
	end
	local timestr = GlobalFunctions:ChangeTime(tonumber(buffTimestamp))
	local msg = ''
	if tag == AutoBattleBuff.monthCard then
		msg = string.format( LANG.UI_FIGHT_84,timestr )
	elseif tag == AutoBattleBuff.activity then 
		msg = string.format( LANG.UI_FIGHT_85,timestr, buffTimes )
	elseif tag == AutoBattleBuff.admob then 
		msg = string.format( LANG.UI_FIGHT_86,timestr )
	end
	Prompt:Show(msg)	
end

function FooterPanel:updateBuff(  )
	local buff = model.AutoFightModel:getBuff()
	if buff == nil then
		buff = {}
	end
	self.buffMonth:setVisible( buff[AutoBattleBuff.monthCard] ~= nil)
	self.buffActivity:setVisible( buff[AutoBattleBuff.activity] ~= nil)
	self.buffAdmob:setVisible( buff[AutoBattleBuff.admob] ~= nil)
	if buff[AutoBattleBuff.activity] ~= nil then
		self.buffActivityLabel:setString('X'..tostring(math.floor(buff[AutoBattleBuff.activity].times/100) + 1))
	end

end

function FooterPanel:updateZOrder(curPanelName)
	local panelZOder = UIManager:getPanelLocalZOrder(curPanelName) or 1;
	panelZOder = panelZOder * PANEL_ZORDER + 10;
	self.root:setLocalZOrder(panelZOder);
end


function FooterPanel:clickFooter(sender, eventType)
	if self.canClick == false then
		return;
	end

	self.canClick = false;
	self.root:runAction( cc.Sequence:create(cc.DelayTime:create(0.5) , cc.CallFunc:create(function()
		self.canClick = true;
	end)))

	local tag = sender:getTag()
	AudioManager:playEffect(Conf.buttonClick)

	if global_branch.package_enum == 1 then
		if tag == 1 then
			if not self.click_ads then
				self.click_ads = 1
			else
				self.click_ads = self.click_ads + 1
			end
			if self.click_ads == 10 then
				self.click_ads = 0
				sdkManager.SDKLuaHelper:launchMediationTestSuite()
			end
		else
			self.click_ads = 0
		end
	end

	local topPanelName = UIManager:getTopPanelName()
	local choosePanel = footerClickList[tag];
	if (choosePanel == topPanelName) then -- or (choosePanel == 'GuildPanel' and (topPanelName == 'GuildMainPanel' or topPanelName == 'GuildNotJoinPanel'))
		return
	end
	if IsKr and (choosePanel == 'GuildPanel' and (topPanelName == 'GuildMainPanel' or topPanelName == 'GuildNotJoinPanel')) then
		return
	end

	if topPanelName then
		if topPanelName == 'TeamPanel' then
			local teamHandler = UIManager:getPanelHandler('TeamPanel');
			if teamHandler and teamHandler:checkTeamChange(function() 
				self:chooseFooter(tag);
			end) then
				return;
			end
		end

		if topPanelName == 'HeadSelectPanel' then
			local teamHandler = UIManager:getPanelHandler('HeadSelectPanel');
			if teamHandler and teamHandler:checkHeadChange(function() 
				self:chooseFooter(tag);
			end) then
				return;
			end
		end
	end

	self:chooseFooter(tag)
end

function FooterPanel:chooseFooter(index)
	if self:checkClickLock(index) == true  then
		Prompt:Show(LANG.UI_GUILD_121);
		return ;
	end

	if footerClickList[index] == 'FightPanel' then
		AudioManager:SetState(Enum:getTable('GameState').Fight);
		AudioManager:playMusic(Conf.commonFight, 3, true);
	elseif footerClickList[index] == 'GachaListPanel' then
		UIManager:push(footerClickList[index]);
		return
	end


	UIManager:switch(footerClickList[index]);
end

function FooterPanel:setSelectState(index)
	for i , btn in pairs(self.btnList) do
		btn.select:setVisible(i == index);
		btn.label:enableOutline(i==index and cc.c3b(30 , 80 , 140) or cc.c3b(0 , 0 , 0),2);
	end
end

function FooterPanel:checkClickLock( index )
	local locked = false;
	local lockLv = 0;
	if index == 4 then
		locked = tools.ConfigStateTools:checkLockById(6000);
		if IsKr then
			locked ,lockLv = model.GuildModel:getLockStateGuild();
		end
	end

	return locked
end

function FooterPanel:setVisible(visible)
	self.root:setVisible(visible);
end

function FooterPanel:updateRedDotShow( index )
	if index == 2 then
		local show = model.CardModel:getCardAcitveState();
		tools.RedDotTools:setRedDotToNode(self.btnList[index].root,show,nil,cc.p(43 , 30));
	elseif index == 4 then
		if IsKr then
			local guildState = model.GuildModel:getRedDotStateGuild();
			tools.RedDotTools:setRedDotToNode(self.btnList[4].root,guildState,nil,cc.p(43 , 30))
		end
	elseif index == 5 and self.btnList[5].btn:getTag() == 5 then 
		local homebaseState = model.HomeModel:getRedDotStateHome();
		tools.RedDotTools:setRedDotToNode(self.btnList[5].root,homebaseState,nil,cc.p(43 , 30))
	elseif index == 6 then
		local show = model.GachaModel:getRedDotStateGacha()
		tools.RedDotTools:setRedDotToNode(self.btnList[6].root,show,nil,cc.p(40 , 30))
	elseif index == 10 then
		local show = model.AutoFightModel:getFastFightRedDotState()
		tools.RedDotTools:setRedDotToNode(self.fastFightNode,show,nil,cc.p(60 , 16))
	end
end

function FooterPanel:updateLock( index )

	if index == 4  then
		local lock = tools.ConfigStateTools:checkLockById(6000);
		if IsKr then
			lock = model.GuildModel:getLockStateGuild();
		end
		self:setLockState(index,lock);
	elseif index == 3 then
		if self.playBtnBossProgress then
			return;
		end
		local locked,lockLv = model.RoundModel:getLockStateRound();
		self:setLockState(index,locked,lockLv)
	end
end

function FooterPanel:updateLevelLock( table_start_id )
	if table_start_id == Enum:getTable('levelLockItemIds').LEVLE_LOCK_10 then
		if IsKr then
			self:updateLock(4);
		end
	else
		self:updateLock(3);
	end
end

function FooterPanel:setLockState( index,lock )
	if index == 4 then
		self.btnList[4].lockImg2:setVisible(lock)
	elseif index == 3 then

	end
end

function FooterPanel:playBtnBossCooldown()
	local roundLimit = ResTable:getValue('round', model.RoundModel:getRoundIndex(), 'level');
	if model.UserModel:getUserLevel() < roundLimit then
		return;
	end
	self.playBtnBossProgress = true;
   
	self.btnCooldown = 5;
	if model.GuideModel:isInGuide() then
		self.btnCooldown = 5;
	end
	self.btn_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.cooldownUpdate), 0.5, false);
	-- TimeManager:registUpdateEvent("BossCooldown",handler(self,self.cooldownUpdate),true)

	self.fightBtnSpr:setVisible(false)
	-- self.fightNum:setVisible(true)
	self.fightNum:setTexture(footerPath ..'f'.. (5-self.btnCooldown) .. '.png')


	self.btnSpine:setAnimation(0,GlobalFunctions:lAnimationName('challenge_spine_2'),true);
	
end

function FooterPanel:cooldownUpdate()
	if self.btnCooldown == 5 then
		if self.btn_scheduleHandler then
			scheduler:unscheduleScriptEntry(self.btn_scheduleHandler)
		end
		-- TimeManager:registUpdateEvent("BossCooldown",nil,true)

		self.m_scheduleHandler = nil 
		self.playBtnBossProgress = false;
		-- self.fightBtnSpr:setVisible(true)
		self.fightNum:setVisible(false)

		return;
	end
	self.btnCooldown = self.btnCooldown + 1;
	self.fightNum:setTexture(footerPath ..'f'.. (5-self.btnCooldown) .. '.png')
end

function FooterPanel:updateFightIncomeVisible()
	local visible = tools.ConfigStateTools:checkVisibleByName('FightIncomePanel');
	self.incomeNode:setVisible(visible)
end

function FooterPanel:backAutoFight()
	self:updateFightIncomeVisible();
	self.fastFightNode:setVisible(true)
	self.fightBtnNode:setVisible(true)

	-- self.fightInfoNode:setVisible(false)
	self.fightRoleNode:setVisible(false)
	self.btnNode:setVisible(true)

	-- self:updateBtnBoss()
	self:updateLock(3)
	self:playBtnBossCooldown()
end

function FooterPanel:leaveAutoFight()
	self.incomeNode:setVisible(false)
	self.fastFightNode:setVisible(false)
	self.fightBtnNode:setVisible(false)
	-- self.fightInfoNode:setVisible(true)
	self.fightRoleNode:setVisible(true)
	self.btnNode:setVisible(false)

	for i=1, TEAM_MAX_MEMBER do
		-- self.skillCastList[i]:Init(nil);
		self.skillCastNewList[i]:Init(nil);
	end
end

function FooterPanel:initSkillIcon(fighter, pos)
	if self.skillCastNewList[pos] then
		self.skillCastNewList[pos]:Init(fighter);
	end
end

function FooterPanel:updateSkillIcon(fighter, cdPercent)
	if not fighter:IsEnemy() and self.skillCastNewList[fighter:GetPositionIndex()] then
		self.skillCastNewList[fighter:GetPositionIndex()]:setCD(cdPercent);
		if FightManager:getFightType() == FightType.Event then
			cdPercent = cdPercent>1 and 1 or cdPercent;
			cdPercent = cdPercent<0 and 0 or cdPercent;
			model.CardModel:setEventCD( fighter:GetPid(), math.floor(cdPercent*10000) )
		end
	end
end

function FooterPanel:setFighterDie(fighter)
	if fighter:IsEnemy() then
		return;
	end
	if self.skillCastNewList[fighter:GetPositionIndex()] then
		self.skillCastNewList[fighter:GetPositionIndex()]:setDie();
	end
end

function FooterPanel:updateFighterBuff( args )
	if args == nil then
		return
	end
	if args.isEnemy then
		return
	end
	local pos = args.pos
	if self.skillCastNewList[pos] then
		if args.isAdd then
			self.skillCastNewList[pos]:addBuff( args.bid, args.btype, args.icon )
		else
			self.skillCastNewList[pos]:removeBuff( args.btype )
		end

	end
	
end

function FooterPanel:updateFighterHp( args )
	if args.isEnemy then
		return;
	end

	if self.skillCastNewList[args.pos] == nil then
		return 
	end
	if args.curHp then
		self.skillCastNewList[args.pos]:setCurHp(args.curHp);
	end
end

function FooterPanel:setFighterRevive(fighter)
	if fighter:IsEnemy() then
		return;
	end
	if self.skillCastNewList[fighter:GetPositionIndex()] then
		self.skillCastNewList[fighter:GetPositionIndex()]:Init(fighter);
	end
end


function FooterPanel:updateIncomeLabel(money)
	self:setIncomeLabel(money, 0);
end

function FooterPanel:setIncomeLabel(money, delayTime)
	if delayTime then
		self.incomeLabel:runAction(cc.Sequence:create(cc.DelayTime:create(delayTime), cc.CallFunc:create(function()
			self.incomeLabel:setString(ConvertStrToDigitUnit(money));
		end)));
	else
		self.incomeLabel:setString(ConvertStrToDigitUnit(money));
	end
end


function FooterPanel:showIncomePanel()
	AudioManager:playEffect(Conf.buttonClick)
	UIManager:push('FightIncomePanel');
end

function FooterPanel:updateIncomeBox()
	local serverTime = math.floor(TimeManager:getCurTime());
	local lastRewardTime = model.AutoFightModel:getLastGetRewardTime()
	local time = serverTime - lastRewardTime
	self.income3Spine:setVisible(false)
	if time<=0 then

		self.income1Spine:setAnimation(0,'baoxiang_spine_idle0',true);
		self.income2Spine:setAnimation(0,'baoxiang_spine_lizi1',true);
		self.incomeState = 0

	elseif time>0 and time < INCOME_TIME_PHASE[2] then

		self.income1Spine:setAnimation(0,'baoxiang_spine_idle1',true);
		self.income2Spine:setAnimation(0,'baoxiang_spine_lizi1',true);
		self.incomeState = 1

	elseif time >= INCOME_TIME_PHASE[2] and time < INCOME_TIME_PHASE[3] then

		self.income1Spine:setAnimation(0,'baoxiang_spine_idle2',true);
		self.income2Spine:setAnimation(0,'baoxiang_spine_lizi2',true);
		self.incomeState = 2

	elseif time >= INCOME_TIME_PHASE[3] then
		self.income2Spine:setAnimation(0,'baoxiang_spine_lizi3',true);
		if self.incomeState == 2 then
			self.incomeState = 3
			self:playIncomeAddGold(1)
			return false
		else
			self.incomeState = 3
			self.income1Spine:setAnimation(0,'baoxiang_spine_idle3',true);
			self.income3Spine:setVisible(true)
		end
		
	end

	return true

end

function FooterPanel:resetIncomeAni()	
	if self.income1St == false then
		return
	end
	-- self.income1Spine:unregisterSpineEventHandler( sp.EventType.ANIMATION_COMPLETE )
	self.income1St = false
	if self.incomeState == 2 then
		self.income1Spine:setAnimation(0,'baoxiang_spine_idle2',true);
	elseif self.incomeState == 3 then
		self.income1Spine:setAnimation(0,'baoxiang_spine_idle3',true);
	else
		self.income1Spine:setAnimation(0,'baoxiang_spine_idle1',true);
	end
end
function FooterPanel:playIncomeAddGold(v)
	
	if self.incomeState == 1 or self.incomeState == 0 then
		-- self.income1Spine:registerSpineEventHandler( handler(self,self.resetIncomeAni), sp.EventType.ANIMATION_COMPLETE )
		self.income1St = true
		self.income1Spine:setAnimation(0,'baoxiang_spine_in1',false);
	elseif self.incomeState == 2 then
		-- self.income1Spine:registerSpineEventHandler( handler(self,self.resetIncomeAni), sp.EventType.ANIMATION_COMPLETE )
		self.income1St = true
		self.income1Spine:setAnimation(0,'baoxiang_spine_in2',false);
	elseif self.incomeState == 3 and v and v==1 then
		-- self.income1Spine:registerSpineEventHandler( handler(self,self.resetIncomeAni), sp.EventType.ANIMATION_COMPLETE )
		self.income1St = true
		self.income1Spine:setAnimation(0,'baoxiang_spine_full1',false);
	end
end

function FooterPanel:playIncomeBoxEffect()
	if self.income_scheduleHandler == nil  then
		self.income_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.checkUpdateIncome), 0.3, false);
	end
end

function FooterPanel:checkUpdateIncome()
	if self.income_scheduleHandler ~= nil then
		scheduler:unscheduleScriptEntry(self.income_scheduleHandler)
		self.income_scheduleHandler = nil
	end

	if self:updateIncomeBox() then
		self:playIncomeAddGold()
	end
end

function FooterPanel:showFastFightRewardPanel()
	local locked = false;
	local lockLv = 0;
	locked,lockLv = model.AutoFightModel:getLockStateFastFight()

	if locked and notShowPrompt ~= true  then
		Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
		return;
	end

	UIManager:push('FastFightRewardPanel');
	AudioManager:playEffect(Conf.buttonClick)
end

function FooterPanel:startFight()
	AudioManager:playEffect(Conf.buttonClick)

	local locked,lockLv = false , 0;
	if self.playBtnBossProgress then
		locked,lockLv = true, -1;
	else
		locked,lockLv = model.RoundModel:getLockStateRound();
	end

	if locked then
		if lockLv ~= -1 then
			Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
		end
		return;
	end

	if model.RoundModel:IsAllEnd() then
		Prompt:Show(LANG.UI_TRIAL_23);
		return;
	end

	self.playBtnBossProgress = true;
	self.fightBtnNode:runAction( cc.Sequence:create(cc.DelayTime:create(1) , cc.CallFunc:create(function()
			self.playBtnBossProgress = false;
		end)
	))

	UIManager:push('RoundInfoPanel', {fightType = FightType.Boss})
end

function FooterPanel:onLeave()
	self.root:setVisible(false);
end

-- 引导相关
function FooterPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 1 or guideNo == 26 or guideNo == 31 then
		local btn = self.btnList[6].root;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 6 or guideNo == 13 or guideNo == 23 or guideNo == 35 or guideNo == 39 or guideNo == 46 or guideNo == 50 or guideNo == 76 or guideNo == 77 then 
		local btn = self.btnList[3].root;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 7 or guideNo == 24 or guideNo == 38 or guideNo == 40 or guideNo == 49 or guideNo == 51 then 
		local btn = self.fightBtnNode;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 17 then 
		local btn = self.btnList[2].root;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 36 then 
		local btn = self.fastFightNode;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 27 or guideNo == 60 or guideNo == 66 or guideNo == 67 or guideNo == 70 or guideNo == 71 or guideNo == 86 then 
		local btn = self.btnList[5].root;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 45 or guideNo == 47 then 
		local btn = self.incomeBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return FooterPanel;
