local FpUpPanel = class("FpUpPanel")
local imagePath = 'image/fpUp/'
local scheduler = cc.Director:getInstance():getScheduler();

local moveEnd = 400;

local FIGHT_POWER_ACT_STEP = {

	STEP_BEGIN	= 1, -- 移动
	STEP_SHOW 	= 2, -- 播放战力提示动画
	STEP_END 	= 3, -- 渐隐消失

	STEP_WAIT 	= 10,
	STEP_WAIT_NEXT = 11,

	STEP_NULL = -1,
}

function FpUpPanel:ctor()
	self:clearAll()
end
function FpUpPanel:clearAll(  )
	self.root = nil;
	self.scene = nil;
	self.hasInit = false;
	self.showAct = nil;
end
--初始化面板
function FpUpPanel:Init(root, scene)
	self.root = root;
	self.scene = scene;
	self.hasInit = true ;
	self.showData = {};
	self.showData.total = 0;
	self.showData.update = 0;
	self.showData.current = 0;

	self.actionSpeed = 1;
	self.step = -1;
	self.isUp = nil;

	self.root:setVisible(false);
end

function FpUpPanel:initPanel( isUp )

	if self.showAct ~= nil and self.isUp==isUp then
		return
	end
	if self.showAct ~= nil then
		if self.showAct.node then
			self.showAct.node:stopAllActions()
		end
		if self.showAct.fpUpAnimation2 then
			self.showAct.fpUpAnimation2:stopAllActions()
		end
		if self.showAct.fpUpAnimation then
			self.showAct.fpUpAnimation:stopAllActions()
		end
		if self.showAct.lineLight then
			self.showAct.lineLight:stopAllActions()
		end
		self.step = FIGHT_POWER_ACT_STEP.STEP_NULL;
		self.showAct = nil
		self.root:removeAllChildren();

	end
	self.showAct = {}
	self.isUp = isUp

	local node = cc.Node:create();
	node:setPosition(0 , 130);
	node:setVisible(false);
	node:setCascadeOpacityEnabled(true);
	node:addTo(self.root);
	self.showAct.node = node;

	local bgName = 'level_up_bg_1.png'
	if isUp == false then
		bgName = 'level_up_bg_3.png'
	end
	local upBg = cc.Sprite:create(imagePath..bgName);
	upBg:addTo(node);
	self.showAct.upBg = upBg;

	local fpImg = cc.Sprite:create('image/head/head_fp.png');
	fpImg:addTo(node);
	fpImg:setPosition(-139 , 0);
	self.showAct.fpImg = fpImg;

	local msg = LANG.UI_FIGHT_78
	if isUp == false then
		msg = LANG.UI_FIGHT_101
	end
	local fpLabel = cc.Label:createWithTTF(msg, Enum:getTable('SystemFont').FONT_SIYUAN, 20);
	fpLabel:addTo(node);
	fpLabel:setPosition(-77,0);
	self.showAct.fpLabel = fpLabel;

	local fp = cc.Label:createWithTTF('0', Enum:getTable('SystemFont').FONT_SIYUAN, 20);
	fp:addTo(node);
	fp:setPosition(4 , 0);
	self.showAct.fp = fp;

	local bg2Name = 'level_up_bg_2.png'
	if isUp == false then
		bg2Name = 'level_up_bg_4.png'
	end
	local upImg = cc.Sprite:create(imagePath..bg2Name);
	upImg:addTo(node);
	upImg:setPosition(60 , 0);
	self.showAct.upImg = upImg;

	local fpUp = cc.Label:createWithTTF('0', Enum:getTable('SystemFont').FONT_SIYUAN, 20);
	fpUp:addTo(node);
	fpUp:setPosition(110 , 0);
	self.showAct.fpUp = fpUp;

	local fpUpAnimation = cc.Sprite:create();
	fpUpAnimation:addTo(node);
	fpUpAnimation:setVisible(false);
	fpUpAnimation:setPosition(0 , 5);
	fpUpAnimation:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
	self.showAct.fpUpAnimation = fpUpAnimation;

	local lineLight = cc.Sprite:create(imagePath..'level_up_bg_6.png');
	lineLight:addTo(node);
	lineLight:setScale(1.52);
	lineLight:setPosition(-647 , 81);
	lineLight:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
	self.showAct.lineLight = lineLight;

	local fpUpAnimation2 = cc.Sprite:create();
	fpUpAnimation2:addTo(node);
	fpUpAnimation2:setVisible(false);
	fpUpAnimation2:setPosition(0 ,29);
	fpUpAnimation2:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
	self.showAct.fpUpAnimation2 = fpUpAnimation2;

	self.root:setVisible(true);

end

function FpUpPanel:Show( totalFp,upFp )
	if self.hasInit ~= true or tonumber(totalFp)==tonumber(upFp) then
		return;
	end
	table.insert( self.showData,1,{totalFp,upFp} )
	self:initPanel( tonumber(totalFp) < tonumber(upFp))
	
	if self.step == FIGHT_POWER_ACT_STEP.STEP_NULL  or self.step == FIGHT_POWER_ACT_STEP.STEP_END then

	else
		self.step = FIGHT_POWER_ACT_STEP.STEP_WAIT_NEXT
	end
	self:updateStepState();

end

function FpUpPanel:clearAll(  )
	self.showData = {}
end


function FpUpPanel:updateInfo(dt)

	if self.showData.total == nil then
		return 
	end
	-- if self.showData.total == 0 or self.showData.updata == 0 then
	-- 	return 
	-- end

	if self.showData.current >= self.showData.update  then
		return 
	end
	self.showData.current = self.showData.current + self.showData.update/5
	if self.showData.current > self.showData.update then
		self.showData.current = self.showData.update
	end
	self.showAct.fpUp:setString(tostring(math.ceil(self.showData.current)));
end

function FpUpPanel:showUpdate( bTrue )
	if bTrue == true  then
		if self.m_scheduler == nil then
			self.m_scheduler = scheduler:scheduleScriptFunc(handler(self, self.updateInfo), 0.1/self.actionSpeed, false);
		end
	else
		if self.m_scheduler then
			scheduler:unscheduleScriptEntry(self.m_scheduler);
			self.m_scheduler = nil;
		end
	end
end

function FpUpPanel:updateStepState(  )
	local currData  = table.remove( self.showData )
	if currData == nil then
		self.step = FIGHT_POWER_ACT_STEP.STEP_END;
		self:runStepEvent();
		return
	end

	self.showData.total,self.showData.update = tonumber(currData[1]),tonumber(currData[2])
	print('fubin----updateStepState: ', self.showData.total,self.showData.update)
	if self.showData.total == nil then
		self.step = FIGHT_POWER_ACT_STEP.STEP_END;
	elseif self.showData.update == 0 then 
		self.step = FIGHT_POWER_ACT_STEP.STEP_WAIT_NEXT
	else
		if self.step == FIGHT_POWER_ACT_STEP.STEP_NULL then

		else
			self.step = FIGHT_POWER_ACT_STEP.STEP_SHOW
		end 
		--self.current = self.total - self.update
		self.showData.current = 0
		self.showAct.fp:setString(tostring(self.showData.total));
		self.showAct.fpUp:setString(tostring(self.showData.current));
	end
	
	self:runStepEvent();

end

function FpUpPanel:runStepEvent(notShowLight)
	
	if self.step == FIGHT_POWER_ACT_STEP.STEP_NULL then
		self:runStepBegin()
	elseif self.step == FIGHT_POWER_ACT_STEP.STEP_SHOW then
		self:runStepFpUp(notShowLight)
	elseif self.step == FIGHT_POWER_ACT_STEP.STEP_END then
		self:runStepEnd()
	elseif self.step == FIGHT_POWER_ACT_STEP.STEP_WAIT_NEXT then 
		self:updateStepState()
	end


end


function FpUpPanel:runStepBegin(  )
	self.step = FIGHT_POWER_ACT_STEP.STEP_WAIT

	self.showAct.node:setVisible(true);
	self.showAct.node:stopAllActions();
	self.showAct.node:setOpacity(255);
	self.showAct.node:setPositionX(-727);
	self.showAct.node:runAction(cc.Sequence:create(cc.MoveTo:create(3/15 , cc.p(0 , 130)) , cc.CallFunc:create(function()
		self.step = FIGHT_POWER_ACT_STEP.STEP_SHOW
		self:runStepEvent(true)
	end)));

	self.showAct.lineLight:stopAllActions();
	self.showAct.lineLight:setPositionX(-647);
	self.showAct.lineLight:setOpacity(255);
	self.showAct.lineLight:runAction(cc.Sequence:create(cc.DelayTime:create(2/15) , cc.MoveTo:create(2/15 , cc.p(43 , 81)) , cc.FadeOut:create(5/15)));
end

function FpUpPanel:runStepFpUp(notShowLight)
	self:showUpdate(true);
	self.showAct.node:stopAllActions();
	self.showAct.node:setOpacity(255);
	self.showAct.node:setPositionX(0);

	if not notShowLight then
		self.showAct.lineLight:stopAllActions();
		self.showAct.lineLight:setPositionX(-647);
		self.showAct.lineLight:setOpacity(255);
		self.showAct.lineLight:runAction(cc.Sequence:create(cc.DelayTime:create(2/15) , cc.MoveTo:create(2/15 , cc.p(43 , 81)) , cc.FadeOut:create(5/15)));
	end

	local fpUpAnimation = FrameEffectManager:createFrameAnimation('FP_up', 8, 15);
	self.showAct.fpUpAnimation:setVisible(true);
	self.showAct.fpUpAnimation:stopAllActions();
	local actFpUpAni = cc.Sequence:create(cc.Animate:create(fpUpAnimation) , cc.CallFunc:create(function() 
		self.showAct.fpUpAnimation:setVisible(false);
	end))
	self.showAct.fpUpAnimation:runAction(cc.Speed:create(actFpUpAni,self.actionSpeed));


	local fpUpAnimation2 = FrameEffectManager:createFrameAnimation('FP_up_2', 13 , 15);
	self.showAct.fpUpAnimation2:setVisible(false);
	self.showAct.fpUpAnimation2:stopAllActions();
	local actFpUpAni2 = cc.Sequence:create(cc.CallFunc:create(function() 
		self.showAct.fpUpAnimation2:setVisible(true);
	end) ,  cc.Animate:create(fpUpAnimation2) , cc.CallFunc:create(function() 
		self.showAct.fpUpAnimation2:setVisible(false);
		self.step = FIGHT_POWER_ACT_STEP.STEP_WAIT_NEXT;
		self:runStepEvent()

	end))
	self.showAct.fpUpAnimation2:runAction(cc.Speed:create(actFpUpAni2,self.actionSpeed));
end


function FpUpPanel:runStepEnd(  )

	self:showUpdate(false);
	self.showAct.node:runAction(
		cc.Sequence:create(
			cc.FadeOut:create(2), 
			cc.CallFunc:create(handler(self , self.actionEnd))
			)
		);
end


function FpUpPanel:actionEnd()
	self.step = FIGHT_POWER_ACT_STEP.STEP_NULL;
	self:Hide();

end

function FpUpPanel:Hide()

	self.showAct = nil
	self.showData = {};
	self.root:removeAllChildren();
	self.root:setVisible(false);
end
return FpUpPanel;
