local FutureCardPanel = class("FutureCardPanel", require('app.layer.BaseLayer'))

local imgPath = 'image/fight/result/';
local fonts = Enum:getTable("SystemFont");
local scheduler = cc.Director:getInstance():getScheduler();

local rolePos = {
	[1] = {x = 175, y = 248, zorder = 80},
	[2] = {x = 12, y = 152, zorder = 100},
	[3] = {x = 9, y = 325, zorder = 80},
	[4] = {x = -165, y = 248, zorder = 50},
}

function FutureCardPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'FutureCardPanel');
	
	self.scene = scene;
	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function FutureCardPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self.root:setCascadeOpacityEnabled(true);

	local bg = cc.Sprite:create('image/card/cardfuture/future_bg.png')
	:addTo(self.root)
	:setPosition(0,40)

	-- role
	self.showRoleNode = cc.Node:create();
	self.showRoleNode:setPosition(0, 242);
	self.showRoleNode:addTo(self.root);

	self.showRoleList = {};
	local tmpPosIdx = {1, 4, 3, 2}
	for i=1, TEAM_MAX_MEMBER do
		local k = tmpPosIdx[i]
		self.showRoleList[k] = {}

		self.showRoleList[k].node = cc.Node:create()
			:addTo(self.showRoleNode)
			:setPosition(cc.p(-233 +(i-1)*155, 0))
			:setScale(0.8)

		self.showRoleList[k].bg = cc.Sprite:create(imgPath..'quality_bg_null.png')
			:addTo(self.showRoleList[k].node)

		self.showRoleList[k].roleBg = cc.Sprite:create('image/iconL/R003_IconL.png')
			:addTo(self.showRoleList[k].node)
			:setVisible(false)
			:setTextureRect(LRect)

		-- self.showRoleList[k].empty =  cc.Sprite:create(imgPath..'role_pos_'..i..'_2.png')
		-- 	:addTo(self.showRoleList[k].node)
		-- 	:setPosition(cc.p(15,-45))

		local tmpBg = cc.Sprite:create('image/commonImg/shadow1.png')
			:addTo(self.showRoleList[k].node)
			:setPosition(0, -148)

		if k == 4 then
			local rect = cc.Sprite:create('image/card/f_state_rect.png')
				:addTo(self.showRoleList[k].node)
			self.showRoleList[k].node:setScale(0.9)
		end

		self.showRoleList[k].posSp =  cc.Node:create()
			:addTo(self.showRoleList[k].node)
			:setPosition(cc.p(0,-165))

		self.showRoleList[k].lvLabel = cc.Label:createWithTTF('LV 9999', fonts.FONT_SIYUAN, 20)
			:addTo(self.showRoleList[k].posSp)
			:enableOutline(cc.c3b(60 , 60 , 60) , 2)
			:setPosition(0, 15)

		local tmpSpr =  cc.Sprite:create('image/commonImg/line2.png')
			:addTo(self.showRoleList[k].posSp)

		self.showRoleList[k].nameLabel = cc.Label:createWithTTF('name', fonts.FONT_SIYUAN, 16)
			:addTo(self.showRoleList[k].posSp)
			:enableOutline(cc.c3b(60 , 60 , 60) , 2)
			:setPosition(0, -15)

		self.showRoleList[k].qualitySpr = cc.Sprite:create('image/card/card_quality_4.png')
			:addTo(self.showRoleList[k].node)
			:setPosition(-80, 190)
			:setAnchorPoint(0,1)

		if k == 4 then
			self.showRoleList[k].lvLabel:enableOutline(cc.c3b(180 , 100 , 0) , 2)
			self.showRoleList[k].nameLabel:enableOutline(cc.c3b(180 , 100 , 0) , 2)
		end

		

		-- local border =  cc.Sprite:create(imgPath..'quality_bg_border.png')
		-- 	:addTo(self.showRoleList[i].node)
	end 
	
	self.particleKey = cc.ParticleSystemQuad:create("Effect/particle/wshine.plist")
	self.particleKey:addTo(self.showRoleNode);
	self.particleKey:stopSystem()

	self.titleNode = cc.Node:create()
	:addTo(self.root)
	:setPosition(0, 500)
	local titleBg = cc.Sprite:create('image/card/cardfuture/future_title_bg.png')
	:addTo(self.titleNode)
	self.titleLabel = cc.Label:createWithTTF(LANG.UI_L_11706, fonts.FONT_SIYUAN, 25)
	:addTo(self.titleNode)

	local tipNode = cc.Node:create()
	:addTo(self.root)
	:setPosition(0, 20)
	local tipBg = cc.Sprite:create('image/commonImg/tip_bg_1_547_33.png')
	:addTo(tipNode)
	local tipLabel = cc.Label:createWithTTF(LANG.UI_L_11708, fonts.FONT_SIYUAN, 20)
	:addTo(tipNode)
	:setTextColor(cc.c3b(255,210,0))
	local tipSpr = cc.Sprite:create('image/commonImg/tip_2.png')
	:addTo(tipNode)
	:setPosition(-20-tipLabel:getContentSize().width/2,0)

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/common_tips_bg.png");
	bg1:setContentSize(cc.size(610 , 450));
	bg1:setPosition(cc.p(0 , -230));
	bg1:addTo(self.root);

	self.rewardListView = ccui.ScrollView:create();
	self.rewardListView:setTouchEnabled(true)
		:setBounceEnabled(true)
		:setDirection(ccui.ScrollViewDir.vertical)
		:setContentSize(cc.size(600 , 330))
		:setAnchorPoint(cc.p(0.5,0.5))
		:setScrollBarEnabled(false)
		:addTo(self.root)
		:setPosition(cc.p(0,-245))

	self.itemList = {};

	self.rewardListView:removeAllChildren();
    local len = #(model.FutureCardModel:getFutureCardList());
    local column = 5
    local maxHeight = (math.floor( (len-1)/column ) +1) *120
    if maxHeight < 260 then
        maxHeight = 260;
    end
	self.rewardListView:setInnerContainerSize(cc.size(600,maxHeight))

    for i=1,len do
        local col = (i- 1) % column  -- 0,1,2,
        local row = math.floor((i - 1) / column); --0,1.。
		local item = require('app.template.FutureCardTemplate'):create(self.rewardListView);
		item:setPosition(60+col*120,maxHeight - row * 120 - 60  );
		self.itemList[i] = item;
	end


	local slotInfoNode = cc.Node:create()
	:addTo(self.root)
	:setPosition(305, -437)
	local slotLine = ccui.Scale9Sprite:create('image/commonImg/line.png')
	:addTo(slotInfoNode)
	:setContentSize(cc.size(610 , 3))
	:setPosition(0, 18)
	:setAnchorPoint(1,0.5)
	local slotBg = cc.Sprite:create('image/commonImg/num_bg.png')
	:addTo(slotInfoNode)
	:setPosition(0, 7)
	:setAnchorPoint(1,0.5)
	self.slotLabel = cc.Label:createWithTTF('5/15', fonts.FONT_SIYUAN, 20)
	:addTo(slotInfoNode)
	:setAnchorPoint(1,0.5)
	:setPosition(-10, 0)
	local slotSpr = cc.Sprite:create('image/commonImg/num_icon.png')
	:addTo(slotInfoNode)
	:setPosition(-100,0)

	self.haveItemNode = cc.Node:create()
        :addTo(self.root)
        :setPosition(193 , -51)
        :setLocalZOrder(100)

    local bg = cc.Sprite:create('image/commonImg/bg_3_200_42.png')
        :addTo(self.haveItemNode)

	local altarData = model.FutureCardModel:getFutureCardById(1);
	local icon = ResTable:getValue('item' , altarData.cost[1] , 'icon');
    local moneyIcon = cc.Sprite:create("image/icon/I"..icon..".png")
        :addTo(self.haveItemNode)
        :setPosition(-71 , 0)
        :setScale(0.35)

    local moneyLabel = cc.Label:createWithTTF(LANG.UI_CARD_19 , fonts.FONT_SIYUAN , 20)
	    :addTo(self.haveItemNode)
	    :setPosition(-26 , 0)
	    :setTextColor(cc.c3b(160 , 200 , 255))

    self.moneyNum = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
        :addTo(self.haveItemNode)
        :setAnchorPoint(1 , 0.5)
        :setPosition(86 , 0)

	EventManager:RegisterEvent(EventType.UIFutureCardUpdate, handler(self, self.updateSlotNum));

end


function FutureCardPanel:onEnter()
	
	-- self:addSwallowCallback(function()
	-- end);

	self.root:setVisible(true);
	self.root:setOpacity(255);

	self.m_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.onEnterFrame), 1, false);

	self:updateInfo()

end

function FutureCardPanel:onClickBack()
	UIManager:pop('FutureCardPanel');
end

function FutureCardPanel:updateInfo()
	-- body
	local maxRoleList, maxLv = model.FutureCardModel:getMax4LvCard()
	self.titleLabel:setString(LANG.UI_L_11707..maxLv)
	for k,v in pairs(maxRoleList) do
		local pid = v
		if pid > 0  then
			local cardData = model.CardModel:GetCard(pid);
			--local roleData = ResTable:getRowData('role', cardData.no);
			local resId = model.CardModel:getCardResIdByPid(pid);
			local roleResource = ResTable:getRowData('role_resource', resId);
			local roleName = ResTable:getValue('role_info', cardData.no, 'name');

			self.showRoleList[k].bg:setTexture('image/card/card_quality_bg_'..cardData.quality..'.png')
			self.showRoleList[k].roleBg:setTexture('image/iconL/'..roleResource.iconlarge..'.png');
			self.showRoleList[k].roleBg:setTextureRect(cc.rect(155 , 225 , 175 , 400));

			self.showRoleList[k].qualitySpr:setTexture('image/card/card_quality_'..cardData.quality..'.png')

			self.showRoleList[k].lvLabel:setString('Lv '..cardData.level)
			self.showRoleList[k].nameLabel:setString(roleName)

			self.showRoleList[k].roleBg:setVisible(true)
			-- self.showRoleList[k].empty:setVisible(false)
			self.showRoleList[k].posSp:setVisible(true)

			self.showRoleList[k].qualitySpr:setVisible(true)
			
		else
			self.showRoleList[k].bg:setTexture(imgPath..'quality_bg_null.png')
			self.showRoleList[k].roleBg:setVisible(false)
			-- self.showRoleList[k].empty:setVisible(true)
			self.showRoleList[k].posSp:setVisible(false)

			self.showRoleList[k].qualitySpr:setVisible(false)
		end
		-- self.showRoleList[k].node:setVisible(false)
	end

	--local fcardList = model.FutureCardModel:getFutureCardList();
	--for k,v in pairs(fcardList) do
	--	if self.itemList[k] then
	--		self.itemList[k]:Init(v)
	--	end
	--end
	self:updateSlotNum()
	
end

function FutureCardPanel:updateSlotNum()
	-- body
	local fcardList = model.FutureCardModel:getFutureCardList();
	local num = 0
	local isSet = false;
	for k,v in pairs(fcardList) do
		if v.unlock==1 then
			num = num+1
		end
		if self.itemList[k] then
			self.itemList[k]:Init(v)
		end

		if not isSet then
			local itemNum = model.ItemModel:getItemNum(v.cost[1]);
			self.moneyNum:setString(tostring(itemNum));
			isSet = true;
		end
	end
	self.slotLabel:setString( tostring(num)..'/'..tostring(#self.itemList) )
end

function FutureCardPanel:onEnterFrame()
	local curTime = TimeManager:getCurTime();
	for k,v in pairs(self.itemList) do
		v:updateCDTime( curTime )
	end
end

function FutureCardPanel:onLeave()
	self.root:setVisible(false);

	self.particleKey:stopSystem();
	-- self.rewardListView:removeAllChildren()
	-- self.rewardList = {};

	if self.m_scheduleHandler then 
		scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
		self.m_scheduleHandler = nil 
	end
end

return FutureCardPanel;
