local FutureCardSelPanel = class("FutureCardSelPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/setup/'
local MessageBoxType = Enum:getTable('MessageBoxType')

function FutureCardSelPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SettingPanel');

	self.useCCreator = false;
	self.isPopup = true;
end


function FutureCardSelPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function FutureCardSelPanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 850))
	:setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, LANG.UI_L_HOME[10], '',  bg:getContentSize().width/2, bg:getContentSize().height -36 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(582 , 694));
	bg1:setPosition(cc.p(0 , 0));
	bg1:addTo(self.root);

	local initData = {
		width = 580,
		height = 690,
		cellWidth = 580,
		cellHeight = 110,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-290, -345);
	self.selListView:getView():addTo(self.root)
	self.selListView:getView():setVisible(true)

	local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	local btn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
	btn:addTo(self.root);
	btn:setPosition(0, -385)
	btn:addClickEventListener(handler(self, self.clickBtn));
	btn:setTitleLabel(label);

	self.dataList = {}

	EventManager:RegisterEvent(EventType.UIFutureCardSel, handler(self, self.selOneCard));
	
end

function FutureCardSelPanel:onEnter(sid)
	self.sid = sid;
	self.pid = -1
	self:addSwallowCallback(handler(self , self.onClickBack));

	local maxRoleList, maxLv = model.FutureCardModel:getMax4LvCard()

	self.dataList = {}
	local cellData = {}
	local cardList = {}

	for k, card in pairs(model.CardModel:GetAllCard()) do
		local st = true
		for _,v in pairs(maxRoleList) do
			if card.pid==v then
				st=false
				break;
			end
		end
		
		if st and ((card.oriLv and card.oriLv>=1) or (card.level >= maxLv)) then
			st=false
		end
		if st then
			table.insert(cardList, card.pid)
			--table.insert(cellData, card.pid)
			--if #cellData==5 then
			--	table.insert(self.dataList, cellData)
			--	cellData = {}
			--end
		end
	end

	--if #cellData>0 then
	--	table.insert(self.dataList, cellData)
	--	cellData = {}
	--end
	local cardNum = #cardList;
	if cardNum > 1 then
		model.CardModel:sortFuc( cardList )
	end

	for _k , pid in ipairs(cardList) do
		table.insert(cellData, pid)
		if #cellData==5 then
			table.insert(self.dataList, cellData)
			cellData = {}
		end
	end

	if #cellData>0 then
		table.insert(self.dataList, cellData)
		cellData = {}
	end

	self.selListView:reloadData(self.dataList);

	self.root:setVisible(true);
end

function FutureCardSelPanel:onClickBack()
	UIManager:pop('FutureCardSelPanel');
end

function FutureCardSelPanel:onLeave()
	self.root:setVisible(false);
end

function FutureCardSelPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.FutureCardSelCell:create(cell);
		cellNode:setTag(999);
    end

    if self.dataList[index+1] then
    	cellNode:initData( self.dataList[index+1], self.sid );
    end
end

function FutureCardSelPanel:cellItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
    end
end

function FutureCardSelPanel:clickBtn()
	if self.pid > 0 then
		model.FutureCardModel:reqUpdateSlot(1, self.sid, self.pid)
	end
	UIManager:pop('FutureCardSelPanel');
end

function FutureCardSelPanel:selOneCard( pid )
	self.pid = pid
end

return FutureCardSelPanel;
