local FutureCardTakeOffPanel = class("FutureCardTakeOffPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/setup/'

function FutureCardTakeOffPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SettingPanel');

	self.useCCreator = false;
	self.isPopup = true;
end


function FutureCardTakeOffPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function FutureCardTakeOffPanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 490))
	:setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, LANG.UI_L_HOME[10], '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/common_tips_bg_s2.png");
	bg1:setContentSize(cc.size(582 , 175));
	bg1:setPosition(cc.p(0 , -60));
	bg1:addTo(self.root);

	local mainNode = cc.Node:create()
	:addTo(self.root)
	:setPosition(0, 100)
	self.oriRoleNode = template.ItemTemplate:create()
	:addTo(mainNode)
	:setPosition(120, 0)

	self.curRoleNode = template.ItemTemplate:create()
	:addTo(mainNode)
	:setPosition(-120, 0)

	local arrowSpr = cc.Sprite:create('image/commonImg/arrow_4_bg.png')
	:addTo(mainNode)

	self.msgLabel = cc.Label:createWithTTF( LANG.UI_L_11714, fonts.FONT_SIYUAN , 20);
	self.msgLabel:addTo(self.root)
	self.msgLabel:setPosition(0,-50)
	self.msgLabel:setDimensions(500, 0)

	self.tipLabel = cc.Label:createWithTTF(LANG.UI_L_11713 , fonts.FONT_SIYUAN , 18);
	self.tipLabel:addTo(self.root)
	self.tipLabel:setTextColor(cc.c3b(255, 210, 0))
	self.tipLabel:setPosition(0,-130)
	-- self.tipLabel:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2);

	local tipSpr = cc.Sprite:create('image/commonImg/tip_2_19_19.png')
	:addTo(self.root)
	:setPosition( -20-self.tipLabel:getContentSize().width/2, -130 )


	local cancelLabel = cc.Label:createWithTTF(LANG.COMMON_CANCEL , fonts.FONT_SIYUAN , 20);
	cancelLabel:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2);

	local cancelBtn = ccui.Button:create('image/commonImg/btn_1_219_55_2.png' , 'image/commonImg/btn_1_219_55_2.png');
	cancelBtn:addTo(self.root);
	cancelBtn:setPosition(-118, -200);
	cancelBtn:addClickEventListener(handler(self, self.onClickBack));
	cancelBtn:setTitleLabel(cancelLabel);


	local okLabel = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20);
	okLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

	local okBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	okBtn:addTo(self.root);
	okBtn:setPosition(118, -200);
	okBtn:addClickEventListener(handler(self, self.clickOkBtn));
	okBtn:setTitleLabel(okLabel);
	
end

function FutureCardTakeOffPanel:onEnter(sid, pid)
	self.sid = sid;
	self.pid = pid
	self:addSwallowCallback(handler(self , self.onClickBack));

	local card = model.CardModel:GetCard(self.pid);
	if card then
		self.curRoleNode:Init(ROLE_TYPE , card.no,card.star_lv,card.level,self.pid);
		self.oriRoleNode:Init(ROLE_TYPE , card.no,card.star_lv,card.oriLv,self.pid);
	end

	self.root:setVisible(true);
end

function FutureCardTakeOffPanel:onClickBack()
	UIManager:pop('FutureCardTakeOffPanel');
end

function FutureCardTakeOffPanel:onLeave()
	self.root:setVisible(false);
end

function FutureCardTakeOffPanel:clickOkBtn()
	if self.pid > 0 then
		model.FutureCardModel:reqUpdateSlot(2, self.sid, self.pid)
	end
	UIManager:pop('FutureCardTakeOffPanel');
end

return FutureCardTakeOffPanel;