local GachaResultPanel = class("GachaResultPanel")--, require('app.layer.BaseLayer'));

local imgPath = 'image/chouka/result/';
local fonts = Enum:getTable('SystemFont');
local RestrainType = Enum:getTable("FightRestraintType")
local cvTypeEnum = Enum:getTable("cvTypeEnum");
local CARD_TOTAL_NUM = 12;

local def_type_name = 
{
	[RestrainType.RED_BASE] = 'red',
	[RestrainType.GREEN_BASE] = 'green',
	[RestrainType.BLUE_BASE] = 'blue',
}
 local STEP = {
	SHOW_ROLE = 1,
	SHOW_ROLE_END = 2,
	SHOW_RESUTL = 3,
	SHOW_RESULT_END = 4,
	SHOW_ACIEVEMENT = 5,
	SHOW_ACIEVEMENT_ING = 6,
	SHOW_ACIEVEMENT_END = 7,

	
	SHOW_END = 0,
	SHOW_NULL = -1,

	TEST = 100,

}
function GachaResultPanel:ctor()

	self.count = 1
	self.step = STEP.SHOW_NULL;

	self.spPlayTouch = false
	self.openCnt = 0
	self.isGoldCard = false
	self.quality = 3
end

function GachaResultPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels();

end

function GachaResultPanel:initPanels()

	local touchEvent = 	function ( sender,eventType )
		if eventType == ccui.TouchEventType.ended then
			self:stepEventCall();
		end
	end

	local bg1 = ccui.ImageView:create('image/chouka/main/bg_1.png'); --imgPath .. 'bg1.png'
	bg1:addTo(self.root);
	bg1:addTouchEventListener(touchEvent)
	bg1:setTouchEnabled(true);
	bg1:setLocalZOrder(1)
	self.bg = bg1

	self.mask = cc.LayerColor:create(cc.c4b(0, 0, 0, 255))
	self.mask:setContentSize( cc.size(StageSize.width, StageSize.height) );
	self.mask:setPosition(-StageSize.width/2, -StageSize.height/2);
	self.mask:addTo(self.root);
	self.mask:setOpacity(200);
	self.mask:setLocalZOrder(2)

	do
		self.resultShowNode = cc.Node:create();
		self.resultShowNode:addTo(self.root) 
		self.resultShowNode:setLocalZOrder(10)

		self.resultItemList = {};
		for i=1, CARD_TOTAL_NUM do
			local x,y=0,0
			if i%3 == 2 or i==10 then
				x = 0
				y = 370 - ( math.floor(i/3) * 250);
			elseif i%3 == 1 then
				x = -180
				y = 250 - ( math.floor((i-1)/3) * 250);
			else
				x = 180
				y = 250 - ( math.floor((i-1)/3) * 250);
			end
			
			-- x = -180 + ((i-1)%3)*180;
			-- y = 370 - ( math.floor((i-1)/3) * 250);
			self.resultItemList[i] = require('app.template.CardGachaTemplate'):create(self.resultShowNode , i)
			self.resultItemList[i]:setPosition(x, y);
			self.resultItemList[i]:savePos()
		end
	end 
	
	self.particle5 = cc.ParticleSystemQuad:create("Effect/particle/gacha5.plist")
	self.particle5:addTo(self.root);
	self.particle5:stopSystem();
	self.particle5:setLocalZOrder(15)

	self.particle4 = cc.ParticleSystemQuad:create("Effect/particle/gacha2.plist")
	self.particle4:addTo(self.root);
	self.particle4:stopSystem();
	self.particle4:setLocalZOrder(16)

	do
		self.resultRoleNode = cc.Node:create();
		self.resultRoleNode:addTo(self.root) 
		self.resultRoleNode:setLocalZOrder(20)
		
		self.quSpBg = cc.Sprite:create(imgPath .. 'gBg1_3.png');
		self.quSpBg:setPosition(0, 0);
		self.quSpBg:addTo(self.resultRoleNode);

		self.roleM = cc.Sprite:create();
		self.roleM:setScale(2);
		self.roleM:addTo(self.resultRoleNode);

		local roleShadow = cc.Sprite:create(imgPath..'gRole_shadow.png')
		:addTo(self.resultRoleNode)
		:setOpacity(200)
		--[[
		self.enName = cc.Label:createWithTTF('SEREN', 'font/NanumBrushScript-Regular.ttf', 200);
		self.enName:setTextColor(cc.c3b(255, 255, 255));
		-- self.enName:enableOutline(cc.c3b(150,150,130));
		self.enName:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
		self.enName:setPosition(0, -250);
		self.enName:addTo(self.resultRoleNode);
		self.enName:setDimensions(400, 210)
		self.enName:setOverflow(cc.LabelOverflow.SHRINK)
		self.enName:setVisible(false)
		]]
		self.role = cc.Sprite:create();
		self.role:setScale(0.6);
		self.role:addTo(self.resultRoleNode);

		self.roldMsgBg = cc.Sprite:create(imgPath..'gRoleMsg_bg3.png');
		self.roldMsgBg:addTo(self.resultRoleNode);
		self.roldMsgBg:setPosition(0, -350);

		self.quSpBg2 = cc.Sprite:create(imgPath .. 'gBg2_3.png');
		self.quSpBg2:setPosition(0, 0);
		self.quSpBg2:addTo(self.resultRoleNode);

		self.labelMsg = cc.Label:createWithTTF('', fonts.FONT_CV, 18);
		self.labelMsg:setTextColor(cc.c3b(255, 255, 255));
		-- self.labelMsg:enableOutline(cc.c3b(150,150,130));
		self.labelMsg:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
		self.labelMsg:setPosition(0, -350);
		self.labelMsg:setDimensions(400, 0)
		self.labelMsg:addTo(self.resultRoleNode);

		local quNode = cc.Node:create();
		quNode:setPosition(0, 350);
		quNode:addTo(self.resultRoleNode);

		self.star = cc.Node:create();
		self.star:addTo(quNode);

		self.labelName = cc.Label:createWithTTF('name', fonts.FONT_HUAKANG, 28);
		self.labelName:setTextColor(cc.c3b(255, 255, 255));
		self.labelName:enableOutline(cc.c3b(150,150,130));
		self.labelName:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
		self.labelName:setPosition(0, 300);
		self.labelName:addTo(self.resultRoleNode);

		self.labelNameSpr = cc.Sprite:create()
		:addTo(self.resultRoleNode)
		:setPosition(0, 300)
		
	end
	self:initSpineNode();

	self.clickParticle = cc.ParticleSystemQuad:create("Effect/particle/gacha3.plist")
	self.clickParticle:addTo(self.root);
	self.clickParticle:stopSystem();
	self.clickParticle:setLocalZOrder(30)

	self.click2Particle = cc.ParticleSystemQuad:create("Effect/particle/gacha7.plist")
	self.click2Particle:addTo(self.root);
	self.click2Particle:stopSystem();
	self.click2Particle:setLocalZOrder(32)
	--
	self.btnSkip = ccui.Button:create(imgPath .. 'btnSkip.png');
	self.btnSkip:setPosition(StageSize.width/2-90, -StageSize.height/2+90);
	self.btnSkip:setZoomScale(0);
	self.btnSkip:addClickEventListener(handler(self, self.skip));
	self.btnSkip:setLocalZOrder(42)
	self.btnSkip:addTo(self.root)

	self.btnBack = ccui.Button:create(imgPath .. 'btnBack.png');
	self.btnBack:setPosition(StageSize.width/2-100, -StageSize.height/2+100);
	-- self.btnBack:setPosition(230, 450);
	self.btnBack:setZoomScale(0);
	self.btnBack:addClickEventListener(handler(self, self.backToInfo));
	self.btnBack:addTo(self.root) 
	--

	EventManager:RegisterEvent(EventType.UIGachaOpen,handler(self,self.gachaOpen));
	EventManager:RegisterEvent('GachaResultPanel:shakeRoot',handler(self,self.shakeRoot));
end

function GachaResultPanel:gachaOpen( isGoldCard )
	-- body

	self.openCnt = self.openCnt + 1
	if self.openCnt == self.count then --全翻开了
		self.step = STEP.SHOW_RESULT_END
		self.btnSkip:setVisible(false);
	end

	if isGoldCard and self.step ~= STEP.SHOW_RESULT_END and self.btnSkip:isVisible()==false then
		for i=1,CARD_TOTAL_NUM do
			local item =self.resultItemList[i]
			if item and item:isCanPlay() then
				if item:getPlayState()==false and item:isGold()==true then
					item:skipAni(i);
					break;
				else
					break;
				end
			end
		end
	end
	
end

function GachaResultPanel:initSpineNode()
	local spine_res = 'gacha_spine'
	self.gachaSpine = nil
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.gachaSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.gachaSpine:addTo(self.root)
		self.gachaSpine:setLocalZOrder(22)

		self.gachaSpine:registerSpineEventHandler(function (event)
			if event.animation == 'card1' or event.animation == 'card2' or event.animation == 'card3' then
				self.spPlayTouch = true
			end
			if event.animation == 'touch1' or event.animation == 'touch2' or event.animation == 'touch3' then
				-- 动画最后结束
				self.step = STEP.SHOW_RESULT_END
			end
			
		end, sp.EventType.ANIMATION_COMPLETE)

		self.gachaSpine:registerSpineEventHandler(function (event)
			if event.eventData.name == 'appear' then
				self.clickParticle:stopSystem();
				self.resultRoleNode:setVisible(true)
				self.resultRoleNode:setScaleX(0)
				self.resultRoleNode:runAction( cc.ScaleTo:create(0.3, 1, 1) )
				self.particle4:setLocalZOrder(16);
				
			elseif event.eventData.name == 'shake' then
				if self.quality == 5 then
					self:shakeRoot()
				end
			end
			
		end, sp.EventType.ANIMATION_EVENT)
		
	end
end

function GachaResultPanel:playTouchAni()
	-- body
	if self.spPlayTouch == false then
		return
	end
	self.spPlayTouch = false

	if self.gachaSpine then
		self.clickParticle:resetSystem();

		if self.quality == 5 then
			self.gachaSpine:setAnimation(0, "touch3", false)
			AudioManager:playEffect(Conf.gachaTouch3);

		elseif self.quality == 4 then
			self.click2Particle:resetSystem();
			self.gachaSpine:setAnimation(0, "touch2", false)
			AudioManager:playEffect(Conf.gachaTouch);

		else
			self.gachaSpine:setAnimation(0, "touch1", false)
			AudioManager:playEffect(Conf.gachaTouch);

		end

	end

end

function GachaResultPanel:showGachaInfo()

	self.curShowNum = 1;
	
	self.btnBack:setVisible(false);
	self.btnSkip:setVisible(false);
	self.resultShowNode:setVisible(false);

	self.step = STEP.SHOW_ROLE;
	if self.count == 1 then
		self:showRole( self.gachaResultInfo[1].no );
		self:showRoleAction();
	else
		self:showResultAction();
		self.root:runAction( cc.Sequence:create(cc.DelayTime:create(1.4), cc.CallFunc:create(function()
			self.btnSkip:setVisible(true);
		end)  ) )
		
	end
	
end

function GachaResultPanel:directShowInfo()
	self.btnBack:setVisible(false);
	self.btnSkip:setVisible(false);
	self.resultShowNode:setVisible(false);
	self.spPlayTouch = false
	self.step = STEP.SHOW_ROLE;
	if self.count == 1 then
		self:showRole( self.gachaResultInfo[1].no );
		self.resultRoleNode:setVisible(false)
		self.gachaSpine:setVisible(true)
		self.cvSoundId = AudioManager:playCVStopBefor(self.gachaResultInfo[1].no ,nil,cvTypeEnum.CV_GACHA );
		if self.gachaSpine then
			if self.quality==5 then
				self.gachaSpine:setAnimation(0, "touch3", false)
			elseif self.quality==4 then
				self.gachaSpine:setAnimation(0, "touch2", false)
			else
				self.gachaSpine:setAnimation(0, "touch1", false)
			end
		end

		self.root:runAction(cc.Sequence:create(cc.DelayTime:create(2),cc.CallFunc:create(function() 
			self.step = STEP.SHOW_RESULT_END
		end)));
	else
		self.resultRoleNode:setVisible(false)
		self.resultShowNode:setVisible(true)
		self.resultShowNode:stopAllActions();

		self:directShowItem();
	end
end

function GachaResultPanel:directShowItem()
	local num = self.count % CARD_TOTAL_NUM;
	num = num == 0 and CARD_TOTAL_NUM or num;
	for i=1,num do
		local item =self.resultItemList[i]
		if item then
			item:directShow();
		end
		if i == num then
			self.root:runAction(cc.Sequence:create(cc.DelayTime:create(1.5),cc.CallFunc:create(function() 
				if self.count >= #self.gachaResult then
					self.step = STEP.SHOW_RESULT_END
				else
					self:setDirectGachaResult();
					self:directShowItem()
				end
			end)));
		end
	end
end

function GachaResultPanel:skip()
	local b = self.resultItemList[1]:getPlayState()
	if b == true then
		return;
	end
	self.root:stopAllActions();

	self.btnSkip:setVisible(false);
	-- self.step = STEP.SHOW_RESULT_END
	self.resultRoleNode:setVisible(false);
	self.resultShowNode:setVisible(true);
	-- self.btnBack:setVisible(true);

	for i=1,CARD_TOTAL_NUM do
		local item =self.resultItemList[i]
		if item and item:isCanPlay() then
			if item:getPlayState()==false and item:isGold()==false then
				item:skipAni(i);
				-- break;
			else
				-- break;
			end
		end
	end

	self.root:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(function() 
				for i=1,CARD_TOTAL_NUM do
					local item =self.resultItemList[i]
					if item and item:isCanPlay() then
						if item:getPlayState()==false and item:isGold()==true then
							item:skipAni(i);
							break;
						else
							break;
						end
					end
				end
			end)));

	-- local count = #self.gachaResultInfo
	-- if count >= 1 then 
	-- 	local index = math.random( 1,count );
	-- 	self.cvSoundId = AudioManager:playCVStopBefor(self.gachaResultInfo[index].no,nil ,cvTypeEnum.CV_GACHA );
	-- 	print('skip  touch =========== self.cvSoundId =  == ',self.cvSoundId )
	-- end 
end

function GachaResultPanel:setDirectGachaResult()
		for i=1,CARD_TOTAL_NUM do
			local item =self.resultItemList[i]
			if item then
				item:setVisible(false)
			end
		end

		local index = 1;
		for i=(self.count+1), #self.gachaResult do
			if not self.resultItemList[index] then
				break;
			end
			local info = {};
			local gachaItem = self.gachaResult[i];
			if gachaItem['partner'] then
				info.no = gachaItem['partner'].no;
				info.num = gachaItem['partner'].num;

				self.resultItemList[index]:InitByNo(info.no)
				self.resultItemList[index]:setVisible(true)

				self.count = self.count + 1;
				self.gachaResultInfo[self.count] = info;

				index = index + 1;
			end
		end
end

function GachaResultPanel:setGachaResult(result)
	-- print_ro(result);
	self.gachaResultInfo = {};
	local preloadCVList = {};
	local count = 0;
	for i=1,CARD_TOTAL_NUM do
		local item =self.resultItemList[i]
		if item then
			item:setVisible(false)
		end
	end
	for i=1, #result do
		local info = {};
		local gachaItem = result[i];
		if gachaItem['partner'] then
			info.no = gachaItem['partner'].no;
			info.num = gachaItem['partner'].num;
		
			table.insert(preloadCVList, info.no)

			self.resultItemList[i]:InitByNo(info.no)
			self.resultItemList[i]:setVisible(true)
			count = count + 1;

			self.gachaResultInfo[count] = info;
		end
	end
	self.count = count;

end

function GachaResultPanel:showRole(no)

	local role_data = ResTable:getRowData('role', no);
	local role_re = ResTable:getRowData('role_resource', role_data.role_id);
	local role_pre = ResTable:getRowData('role_pre' , role_data.role_id);
	local role_info = ResTable:getRowData('role_info' , role_data.role_id);

	local qu = role_data['quality'];

	self.roleM:setTexture('image/role/'..role_re['card']..'.png');
	local roleSize = self.roleM:getContentSize();
	local w = 223
	local h = 380
	local offx = role_re['navi_show'][1]
	local offy = role_re['navi_show'][2]
	self.roleM:setTextureRect(cc.rect( roleSize.width/2+offx-50, roleSize.height/2-offy-106 , w , h));

	GlobalFunctions:setSpriteGrey(self.roleM, 1,0,0)
	self.roleM:setOpacity(80)
	-- self.roleM:setColor(cc.c3b(255,0,0))

	self.role:setTexture('image/role/'..role_re['card']..'.png');
	local roleSize = self.role:getContentSize();
	self.role:setTextureRect(cc.rect( (roleSize.width-760)/2, (roleSize.height-1330)/2 , 760 , 1290));

	
	if GlobalFunctions:isKorean() then
		self.labelName:setVisible(false)
		self.labelNameSpr:setTexture('image/name/'..role_re['role_name']..'.png');
		self.labelNameSpr:setVisible(true)
	else
		self.labelNameSpr:setVisible(false)
		self.labelName:setString('['..tostring(role_info['name'])..']');
		self.labelName:setVisible(true)
	end

	--self.enName:setString(tostring(role_info['name_en']));
	local cvInfo = model.UserModel:getRoleCvInfo(role_data.resource_id,cvTypeEnum.CV_GACHA);
	self.labelMsg:setString( tostring(cvInfo) )
	local starName = 'gStar_3.png'
	if qu >=5 then
		self.labelName:enableOutline(cc.c3b(230,110,120), 2);
		self.labelMsg:setTextColor(cc.c3b(235,100,110))
		--self.enName:setTextColor(cc.c3b(250,230,230))
		starName = 'gStar_5.png'
	elseif qu == 4 then
		self.labelName:enableOutline(cc.c3b(25,140,180), 2);
		self.labelMsg:setTextColor(cc.c3b(50,160,200))
		--self.enName:setTextColor(cc.c3b(230,240,250))
		starName = 'gStar_4.png'
	else
		self.labelName:enableOutline(cc.c3b(150,150,130), 2);
		self.labelMsg:setTextColor(cc.c3b(115,115,105))
		--self.enName:setTextColor(cc.c3b(135,135,135))
		starName = 'gStar_3.png'
	end
	self.quality = qu;

	self.isGoldCard = false
	if qu >=5 then
		self.isGoldCard = true
	end
	self.particle4:stopSystem();
	self.particle5:stopSystem();
	if self.isGoldCard then
		self.particle4:resetSystem();
		self.particle5:resetSystem();
		self.particle4:setLocalZOrder(28);
	end
	-- self.quality:setTexture('image/card/card_quality_'..qu..'.png');
	self.quSpBg:setTexture(imgPath..'gBg1_'..qu..'.png');
	self.quSpBg2:setTexture(imgPath..'gBg2_'..qu..'.png');

	self.roldMsgBg:setTexture(imgPath..'gRoleMsg_bg'..qu..'.png');

	local starLv = role_pre['rank'];
	self.star:removeAllChildren()
	local col = (starLv - 1) % 5 + 1
	local row = math.floor((starLv - 1) / 5);
	local lastStarX = 0
	for j=1,5 do
		local row1 = row;
		if col < j then
			row1 = row -1 
		end
		if row1 >= 0 then 
			local sp = cc.Sprite:create(imgPath..starName)
			-- local sp = cc.Sprite:create('image/card/card_rank_'..tostring(row1 + 1)..'/6.png')
			sp:addTo(self.star);
			sp:setPosition(cc.p(25*(j-1),0));
			lastStarX = 25*(j-1);
			-- sp:setOpacity(0);
		end 
	end
	self.star:setPositionX(-lastStarX/2)

end

function GachaResultPanel:showRoleAction()
	if self.gachaSpine then
		self.gachaSpine:setVisible(true)
		self.resultRoleNode:setVisible(false)
		self.spPlayTouch = false
		-- AudioManager:playEffect(Conf.gachaFly);
		if self.quality==5 then
			self.gachaSpine:setAnimation(0, "card3", false)
		elseif self.quality==4 then
			self.gachaSpine:setAnimation(0, "card2", false)
		else
			self.gachaSpine:setAnimation(0, "card1", false)
		end
	end
end

function GachaResultPanel:showSpecialRoleAction()
	self.resultRoleNode:setVisible(false)
	self.spPlayTouch = true
	self:playTouchAni()
end

function GachaResultPanel:showResultAction(  )
	-- body
	self.resultRoleNode:setVisible(false)
	self.resultShowNode:setVisible(true)
	self.resultShowNode:stopAllActions();
	for i=1,CARD_TOTAL_NUM do
		local item =self.resultItemList[i]
		if item then
			item:initAni(i);
		end
	end
	self.step = STEP.SHOW_RESUTL

end

function GachaResultPanel:stepEventCall( )
	if self.spPlayTouch == true then --点击 翻开卡牌
		self.cvSoundId = AudioManager:playCVStopBefor(self.gachaResultInfo[1].no ,nil,cvTypeEnum.CV_GACHA );
		self:playTouchAni()
		return;
	end

	-- print('=========self.step === '..self.step);
	if self.step == STEP.SHOW_RESULT_END then 
		if self.cvSoundId ~= nil and self.cvSoundId ~= -1 then
			AudioManager:stopEffect(self.cvSoundId)
			self.cvSoundId = nil
		end
		self:onClickBack()
	end
end


function GachaResultPanel:onEnter(option, bgPath,isDirectShow)
	self.callback = option.callback;
	self.openCnt = 0
	self.gachaResult = {};
	self.fromName = nil
	if option.fromName == 'GachaListPanel' then
		self.fromName = option.fromName
		UIManager:pop("FooterPanel");
	end

	self.root:setVisible(true);
	self.bg:loadTexture(bgPath);

	if isDirectShow then
		self.count = 0;
		self.gachaResultInfo = {};
		self.gachaResult = option.gachaResults or {};
		self:setDirectGachaResult();
		self:directShowInfo();
	else
		self:setGachaResult(option.gachaResults);
		self:showGachaInfo();
	end
end


function GachaResultPanel:onClickBack(  )
	if self.root:isVisible()==false then
		return;
	end

	if self.callback then
        self.callback()
    end
    self.gachaSpine:setVisible(false)
    self.particle4:stopSystem();
	self.particle5:stopSystem();
	
	if self.root:isVisible() then
		if self.fromName == 'GachaListPanel' then
			self.fromName = nil
			-- UIManager:push("FooterPanel" , 'GachaListPanel');
		end
	end

	self.root:setVisible(false);
	
end

function GachaResultPanel:backToInfo(needBack)
	if needBack then
		self.spPlayTouch = false;
		self.step = STEP.SHOW_RESULT_END
	end
	self:stepEventCall()
end

function GachaResultPanel:getGuidePosition(  )
	local node = self.resultRoleNode;
	local pos = cc.p(node:getPosition());
	pos = node:getParent():convertToWorldSpace(pos);
	return pos
end

function GachaResultPanel:shakeRoot()
    local act = cc.Sequence:create( cc.DelayTime:create(0.03) ,cc.CallFunc:create(function()
        self.root:setPosition( math.random()*40-20, math.random()*40-20)
    end))
    local repeqt = cc.Repeat:create(act ,8)

    self.root:runAction( cc.Sequence:create( repeqt ,cc.CallFunc:create(function()
        self.root:setPosition(0, 0)
    end)) )
end

return GachaResultPanel;
