local GemComposePanel = class("GemComposePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");

function GemComposePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'GemComposePanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.isPopup = false;
end


function GemComposePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function GemComposePanel:initPanels()

	local bgImg = cc.Sprite:create('image/bg/Bg_14.png')
	bgImg:addTo(self.root)


	local initData = {
		width = 580,
		height = 365,
		cellWidth = 580,
		cellHeight = 130,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-290, -235);
	self.selListView:getView():addTo(self.root)
	self.selListView:getView():setVisible(true)

	local titleBtnNode = cc.Node:create();
	titleBtnNode:addTo(self.root)
	titleBtnNode:setPosition(0, -StageSize.height/2+150)
	
	local composeBtn = ccui.Button:create('image/commonImg/menu_1_151_46_u.png' ,'image/commonImg/menu_1_151_46_u.png', 'image/commonImg/menu_1_151_46.png');
	composeBtn:addTo(titleBtnNode);
	composeBtn:setPosition(0 , 0);
	composeBtn:setContentSize(cc.size(182 , 40))
	composeBtn:setScale9Enabled(true)
	composeBtn:addClickEventListener(handler(self , self.composeBtnClick));
	local label = cc.Label:createWithTTF('合成', fonts.FONT_SIYUAN, 20)
    :enableOutline(cc.c3b(30, 60, 110), 2)
	composeBtn:setTitleLabel(label)

	self.dataList = nil

	self:initTopNode();
	self:initItemNode();

	self:initCastNode();

	self:initBottomNode()
	
end

function GemComposePanel:initBottomNode()
	local btmNode = cc.Node:create()
	btmNode:addTo(self.root)
	btmNode:setPosition(0, -StageSize.height/2)

	local bg = cc.Sprite:create('image/footer/footer_bg_1.png')
		:setLocalZOrder(0)
		:setAnchorPoint(cc.p(0.5, 0))
		:setPosition(0, 0)
		:addTo(btmNode)

	local light = cc.Sprite:create('image/footer/footer_bg_4.png');
	light:addTo(btmNode);
	light:setPosition(0, bg:getContentSize().height)

	for i = 1 , 2 do
		local line = cc.Sprite:create('image/footer/footer_bg_3.png')
		line:addTo(btmNode);
		line:setPosition(-106 + (i-1)*214 , bg:getContentSize().height/2);
	end

	self.btnList = {};
	local btnPos = {
		cc.p(-213, 48),
		cc.p(0, 48),
		cc.p(213, 48),
	}
	local btnName = {
		'符文',
		'背包',
		'合成'
	}
	for i=1, 3 do
		local btn = {};
		self.btnList[i] = btn;

		btn.root = cc.Node:create()
			:setPosition(btnPos[i])
			:addTo(btmNode)
		btn.root:setCascadeOpacityEnabled(true);

		btn.select = cc.Scale9Sprite:create('image/footer/footer_bg_2.png')
		btn.select:addTo(btn.root);
		btn.select:setContentSize(cc.size( 210, 93 ) )
		btn.select:setVisible(i == 3);
		btn.select:setPosition(0 , -1);

		btn.btn = ccui.Button:create('image/footer/footer_gem_' .. i .. '.png')
		btn.btn:setZoomScale(0)
		btn.btn:setTag(i)
		btn.btn:setEnabled(i ~= 3)
		btn.btn:addClickEventListener(handler(self, self.clickFooter))
		btn.btn:addTo(btn.root)

		btn.label = cc.Label:createWithTTF(btnName[i] , fonts.FONT_SIYUAN , 20);
		btn.label:addTo(btn.root);
		btn.label:setPosition(0 , -29);
		btn.label:enableOutline(i== 3 and cc.c3b(30 , 80 , 140) or cc.c3b(0 , 0 , 0) , 2);

	end
end

function GemComposePanel:clickFooter(sender, eventType)
	local tag = sender:getTag()
	AudioManager:playEffect(Conf.buttonClick)

	UIManager:pop('GemComposePanel');
	if tag == 1 then
		UIManager:push('GemInfoPanel');
	elseif tag == 2 then
		UIManager:push('GemListPanel');
	end

end

function GemComposePanel:initTopNode()
	-- body
	local topNode = cc.Node:create();
	topNode:addTo(self.root)
	topNode:setPosition(0, StageSize.height/2 - 200)

	local topBg = cc.Sprite:create('image/commonImg/common_tip_bg.png')
	topBg:addTo(topNode)

	self.titleLabel = cc.Label:createWithTTF('熔炼值达到xxx可以领取', fonts.FONT_SIYUAN, 20)
    self.titleLabel:enableOutline(cc.c3b(30, 60, 110), 2)
    self.titleLabel:addTo(topNode)

    self.getBtn = ccui.Button:create('image/commonImg/btn_g_70_29.png');
	self.getBtn:addTo(topNode);
	self.getBtn:setPosition(200, 0)
	self.getBtn:setContentSize(cc.size(100 , 40))
	self.getBtn:setScale9Enabled(true)
	self.getBtn:addClickEventListener(handler(self , self.getBtnClick));
	local getlabel = cc.Label:createWithTTF('领取', fonts.FONT_SIYUAN, 20)
    getlabel:enableOutline(cc.c3b(30, 60, 110), 2)
    getlabel:setPosition(30, 0)
	self.getBtn:setTitleLabel(getlabel)


	local skillBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png');
	skillBtn:addTo(topNode);
	skillBtn:setPosition(200, -60)
	skillBtn:setContentSize(cc.size(100 , 40))
	skillBtn:setScale9Enabled(true)
	skillBtn:addClickEventListener(handler(self , self.skillBtnClick));
	local skBtnlabel = cc.Label:createWithTTF('技能预览', fonts.FONT_SIYUAN, 20)
    skBtnlabel:enableOutline(cc.c3b(30, 60, 110), 2)
    skBtnlabel:setPosition(30, 0)
	skillBtn:setTitleLabel(skBtnlabel)

end

function GemComposePanel:initItemNode()
	-- body
	local itemNode = cc.Node:create()
	itemNode:addTo(self.root)

	self.itemComposeList = {}

	local ptList = { cc.p(0, 250), cc.p(-100, 100), cc.p(100, 100), cc.p(-200, -50), cc.p(200, -50) }
	for i=1,5 do
		local cellNode = cc.Node:create()
		cellNode:addTo(itemNode)
		cellNode:setPosition( ptList[i] )

		local cellBtn = ccui.Button:create('image/commonImg/icon_item_add.png');
		cellBtn:addTo(cellNode);
		cellBtn:setTag(i)
		cellBtn:addClickEventListener(handler(self , self.skillBtnClick));

		local cellIcon = cc.Sprite:create()
		cellIcon:addTo(cellNode)

		self.itemComposeList[i] = { btn=cellBtn, icon=cellIcon }

	end

	local targetItemBg = cc.Sprite:create('image/commonImg/icon_item_add.png');
	targetItemBg:addTo(itemNode);

	self.targetItemIcon = cc.Sprite:create('image/icon/M046_Icon.png')
	self.targetItemIcon:addTo(itemNode)

end

function GemComposePanel:initCastNode()
	local castNode = cc.Node:create()
	castNode:addTo(self.root)
	castNode:setPosition(0, -StageSize.height/2+400)

	local succNode = cc.Node:create()
	succNode:addTo(castNode)
	succNode:setPosition(0, 50)
	local succBg = cc.Sprite:create('image/commonImg/btn_12.png')
	succBg:addTo(succNode)
	local succArr = cc.Sprite:create('image/commonImg/arrow_5.png')
	succArr:addTo(succNode)
	succArr:setPosition(-80, 0)

	local succLabel = cc.Label:createWithTTF('成功率', fonts.FONT_SIYUAN, 16)
		:addTo(succNode)
		:setAnchorPoint(0 , 0.5)
		:setPosition(-60, 0)
		:enableOutline(cc.c3b(50 , 20 , 0),2)

	self.succProLabel = cc.Label:createWithTTF('50%', fonts.FONT_SIYUAN, 16)
		:addTo(succNode)
		:setAnchorPoint(1 , 0.5)
		:setPosition(80, 0)
		:enableOutline(cc.c3b(50 , 20 , 0),2)



	local expProgressBg = cc.Scale9Sprite:create("image/commonImg/pgs_bg_1_223_12.png")
		:addTo(castNode)
		:setPosition(0,-50)
		:setCapInsets(cc.rect(10,0,203,12))
		:setContentSize(cc.size(439 , 15))
	local progress = cc.Scale9Sprite:create("image/commonImg/pgs_1_445_21.png")
	self.expProgress = cc.ProgressTimer:create(progress);
	self.expProgress:setType(cc.PROGRESS_TIMER_TYPE_BAR);
	self.expProgress:setMidpoint(cc.p(0, 0));
	self.expProgress:setBarChangeRate(cc.p(1, 0));
	self.expProgress:setPosition(expProgressBg:getContentSize().width/2,expProgressBg:getContentSize().height/2);
	self.expProgress:setPercentage(10);
	self.expProgress:addTo(expProgressBg);
	self.proLabel = cc.Label:createWithTTF('10/15', fonts.FONT_SIYUAN, 20)
		:addTo(castNode)
		:setPosition(0,-65)
		:setAnchorPoint(0.5 , 0.5)
		:enableOutline(cc.c3b(50 , 20 , 0),2)



	local itemCastNode = cc.Node:create()
	itemCastNode:addTo(castNode)
	itemCastNode:setPosition(-150, -100)
	local iCastBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
	iCastBg:setContentSize(200, 42)
	iCastBg:addTo(itemCastNode)
	self.itemCastIcon = cc.Sprite:create('image/icon/E83019.png')
	self.itemCastIcon:setPosition( -80, 0 )
	self.itemCastIcon:setScale(0.5)
	self.itemCastIcon:addTo(itemCastNode)
	self.itemCastLabel = cc.Label:createWithTTF('87855', fonts.FONT_SIYUAN, 20)
		:addTo(itemCastNode)
		:setPosition(70,0)
		:setAnchorPoint(1 , 0.5)
		:enableOutline(cc.c3b(50 , 20 , 0),2)
	local buyBtn = ccui.Button:create('image/commonImg/add_btn_2.png');
	buyBtn:addTo(itemCastNode);
	buyBtn:setPosition(90, 0)
	buyBtn:addClickEventListener(handler(self , self.buyBtnClick));


	local goldCastNode = cc.Node:create()
	goldCastNode:addTo(castNode)
	goldCastNode:setPosition(150, -100)
	local iCastBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
	iCastBg:setContentSize(200, 42)
	iCastBg:addTo(goldCastNode)
	self.goldCastIcon = cc.Sprite:create('image/icon/I10001.png')
	self.goldCastIcon:setPosition( -80, 0 )
	self.goldCastIcon:setScale(0.5)
	self.goldCastIcon:addTo(goldCastNode)
	self.goldCastIcon = cc.Label:createWithTTF('87855', fonts.FONT_SIYUAN, 20)
		:addTo(goldCastNode)
		:setPosition(80,0)
		:setAnchorPoint(1 , 0.5)
		:enableOutline(cc.c3b(50 , 20 , 0),2)

end

function GemComposePanel:onEnter(sid)
	self.sid = sid;
	self.pid = -1

	if self.dataList == nil then
		local cellTmpList = {}
		self.dataList = {}

		for _k , celldata in pairs(ResTable:getTable('crystal_skill').contain) do
			local group = celldata.group;
			if self.dataList[group]==nil then
				self.dataList[group] = {}
				cellTmpList[group] = {}
			end

			table.insert(cellTmpList[group], celldata.skill)
			if #cellTmpList[group]==5 then
				table.insert(self.dataList[group], cellTmpList[group])
				cellTmpList[group] = {}
			end
			
		end

		for k,v in pairs(cellTmpList) do
			if #v>0 then
				table.insert(self.dataList[k], v)
			end
		end
	end
	self.selListView:reloadData(self.dataList[self.selfIdx]);


	self.root:setVisible(true);

end

function GemComposePanel:composeBtnClick(sender , event)
	AudioManager:playEffect(Conf.buttonClick);
	
	local gemIds = {}
	model.GemModel:composeGem( gemIds )

end

function GemComposePanel:updateInfo()
	

end

function GemComposePanel:skillBtnClick(sender , event)
	AudioManager:playEffect(Conf.buttonClick);

	UIManager:push('GemSkillPanel');
end

function GemComposePanel:getBtnClick(sender , event)
	AudioManager:playEffect(Conf.buttonClick);
end

function GemComposePanel:onClickBack()
	UIManager:pop('GemComposePanel');
end

function GemComposePanel:onLeave()
	self.root:setVisible(false);
end

function GemComposePanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.Common2RowItemCell:create(cell);
		cellNode:setTag(999);
		-- cellNode:setCallBack(handler(self, self.showSkillInfo))
    end

    if self.dataList[self.selfIdx][index+1] then
    	cellNode:initData( self.dataList[self.selfIdx][index+1], 0 );
    end
end

function GemComposePanel:cellItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
    end
end

return GemComposePanel;
