local GemListPanel = class("GemListPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/setup/'
local MessageBoxType = Enum:getTable('MessageBoxType')

function GemListPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'GemListPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.isPopup = false;
end


function GemListPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function GemListPanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(606, 720))
	:setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, '符文列表', LANG.UI_L_TOOLS_2,  bg:getContentSize().width/2, bg:getContentSize().height -50 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(582 , 570));
	bg1:setPosition(cc.p(0 , -50));
	bg1:addTo(self.root);

	self.tipsLabel = cc.Label:createWithTTF('装备后卡牌可以获得天赋携带的被动技能', fonts.FONT_SIYUAN, 18);
	self.tipsLabel:addTo(self.root);
	self.tipsLabel:setPosition(0, 260);
	self.tipsLabel:setTextColor(cc.c3b(255 , 255 , 0 ));

	local initData = {
		width = 582,
		height = 560,
		cellWidth = 580,
		cellHeight = 160,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-291, -330);
	self.selListView:getView():addTo(self.root)
	self.selListView:getView():setVisible(true)

	-- local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	-- :enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	-- local btn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
	-- btn:addTo(self.root);
	-- btn:setPosition(0, -350)
	-- btn:addClickEventListener(handler(self, self.clickBtn));
	-- btn:setTitleLabel(label);

	self.dataList = {1,2,3,4,5,6,7,8,9,10}

	self:initBottomNode()
	
end

function GemListPanel:initBottomNode()
	local btmNode = cc.Node:create()
	btmNode:addTo(self.root)
	btmNode:setPosition(0, -StageSize.height/2)

	local bg = cc.Sprite:create('image/footer/footer_bg_1.png')
		:setLocalZOrder(0)
		:setAnchorPoint(cc.p(0.5, 0))
		:setPosition(0, 0)
		:addTo(btmNode)

	local light = cc.Sprite:create('image/footer/footer_bg_4.png');
	light:addTo(btmNode);
	light:setPosition(0, bg:getContentSize().height)

	for i = 1 , 2 do
		local line = cc.Sprite:create('image/footer/footer_bg_3.png')
		line:addTo(btmNode);
		line:setPosition(-106 + (i-1)*214 , bg:getContentSize().height/2);
	end

	self.btnList = {};
	local btnPos = {
		cc.p(-213, 48),
		cc.p(0, 48),
		cc.p(213, 48),
	}
	local btnName = {
		'符文',
		'背包',
		'合成'
	}
	for i=1, 3 do
		local btn = {};
		self.btnList[i] = btn;

		btn.root = cc.Node:create()
			:setPosition(btnPos[i])
			:addTo(btmNode)
		btn.root:setCascadeOpacityEnabled(true);

		btn.select = cc.Scale9Sprite:create('image/footer/footer_bg_2.png')
		btn.select:addTo(btn.root);
		btn.select:setContentSize(cc.size( 210, 93 ) )
		btn.select:setVisible(i == 2);
		btn.select:setPosition(0 , -1);

		btn.btn = ccui.Button:create('image/footer/footer_gem_' .. i .. '.png')
		btn.btn:setZoomScale(0)
		btn.btn:setTag(i)
		btn.btn:setEnabled(i ~= 2)
		btn.btn:addClickEventListener(handler(self, self.clickFooter))
		btn.btn:addTo(btn.root)

		btn.label = cc.Label:createWithTTF(btnName[i] , fonts.FONT_SIYUAN , 20);
		btn.label:addTo(btn.root);
		btn.label:setPosition(0 , -29);
		btn.label:enableOutline(i== 2 and cc.c3b(30 , 80 , 140) or cc.c3b(0 , 0 , 0) , 2);

	end
end

function GemListPanel:clickFooter(sender, eventType)
	local tag = sender:getTag()
	AudioManager:playEffect(Conf.buttonClick)

	UIManager:pop('GemListPanel');
	if tag == 1 then
		UIManager:push('GemInfoPanel');
	elseif tag == 3 then
		UIManager:push('GemComposePanel');
	end

end

function GemListPanel:onEnter(sid)
	self.sid = sid;
	self.pid = -1

	self.selListView:reloadData(self.dataList);

	self.root:setVisible(true);
end

function GemListPanel:onClickBack()
	UIManager:pop('GemListPanel');
end

function GemListPanel:onLeave()
	self.root:setVisible(false);
end

function GemListPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.GemListCell:create(cell);
		cellNode:setTag(999);
		-- cellNode:setCallBack(handler(self, self.openUseItemPanel))
    end

    if self.dataList[index+1] then
    	cellNode:initData( self.dataList[index+1] );
    end
end

function GemListPanel:cellItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
    end
end

function GemListPanel:openUseItemPanel( itemid )
end

function GemListPanel:clickBtn()
	UIManager:pop('GemListPanel');
end

return GemListPanel;
