local GemSkillPanel = class("GemSkillPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");

function GemSkillPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'GemSkillPanel');

	self.useCCreator = false;
	self.isPopup = true;
end


function GemSkillPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function GemSkillPanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(606, 520))
	:setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, '技能预览', LANG.UI_L_TOOLS_2,  bg:getContentSize().width/2, bg:getContentSize().height -50 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(582 , 420));
	bg1:setPosition(cc.p(0 , -30));
	bg1:addTo(self.root);

	local initData = {
		width = 580,
		height = 365,
		cellWidth = 580,
		cellHeight = 130,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-290, -235);
	self.selListView:getView():addTo(self.root)
	self.selListView:getView():setVisible(true)

	local titleBtnNode = cc.Node:create();
	titleBtnNode:addTo(self.root)
	titleBtnNode:setPosition(0, 150)

	self.btns = {}
	self.selfIdx = 1;
	for i=1,3 do
		local swtichBtn = ccui.Button:create('image/commonImg/menu_1_151_46_u.png' ,'image/commonImg/menu_1_151_46_u.png', 'image/commonImg/menu_1_151_46.png');
		-- swtichBtn:loadTextureDisabled( 'image/commonImg/menu_1_151_46.png' )
		swtichBtn:addTo(titleBtnNode);
		swtichBtn:setPosition((i-2)*186 , 0);
		swtichBtn:setTag(i);
		swtichBtn:setContentSize(cc.size(182 , 40))
		swtichBtn:setScale9Enabled(true)
		swtichBtn:addClickEventListener(handler(self , self.swtichBtnClick));

		local btnName = '初级技能'
		if i==2 then
			btnName = '中级技能'
		elseif i==3 then
			btnName = '高级技能'
		end

		local label = cc.Label:createWithTTF(btnName, fonts.FONT_SIYUAN, 20)
        :enableOutline(cc.c3b(30, 60, 110), 2)
    	swtichBtn:setTitleLabel(label)

    	self.btns[i] = { btn=swtichBtn, label=label }

	end

	self.dataList = nil

	self.skillInfoNode = cc.Node:create();
	self.skillInfoNode:addTo(self.root)
	self.skillInfoNode:setVisible(false)

	local btn = ccui.Button:create('image/commonImg/common_tips_bg_s2.png');
	btn:addTo(self.skillInfoNode);
	btn:setContentSize(cc.size(StageSize.width , StageSize.height))
	btn:setScale9Enabled(true)
	btn:setOpacity(0)
	btn:addClickEventListener(handler(self, self.clickBtn));

	local infobg = ccui.Scale9Sprite:create("image/commonImg/common_tips_bg_s2.png");
	infobg:setContentSize(cc.size(582 , 164));
	infobg:addTo(self.skillInfoNode);

	self.qualityBg = cc.Sprite:create('image/commonImg/item_quality_2.png') --cc.p(103,103)
		:addTo(self.skillInfoNode)
		:setPosition(-200, 20)

	self.iconSpr = cc.Sprite:create();
	self.iconSpr:addTo(self.skillInfoNode)
	self.iconSpr:setPosition(-200, 20)

	self.skillName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20);
	self.skillName:addTo(self.skillInfoNode);
	self.skillName:setAnchorPoint(cc.p(0,0.5))
	self.skillName:setPosition(-130, 50);
	self.skillName:enableOutline(cc.c4b(0 , 0 , 0 ,255),2);

	self.skillDes = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
		:addTo(self.skillInfoNode)
		:setPosition(-130 , 30)
		:setAnchorPoint(0 , 1)
		:enableOutline(cc.c3b(50 , 20 , 0),2)
		:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
		:setDimensions(300, 80)
	
end

function GemSkillPanel:onEnter(sid)
	self.sid = sid;
	self.pid = -1

	if self.dataList == nil then
		local cellTmpList = {}
		self.dataList = {}

		for _k , celldata in pairs(ResTable:getTable('crystal_skill').contain) do
			local group = celldata.group;
			if self.dataList[group]==nil then
				self.dataList[group] = {}
				cellTmpList[group] = {}
			end

			table.insert(cellTmpList[group], celldata.skill)
			if #cellTmpList[group]==5 then
				table.insert(self.dataList[group], cellTmpList[group])
				cellTmpList[group] = {}
			end
			
		end

		for k,v in pairs(cellTmpList) do
			if #v>0 then
				table.insert(self.dataList[k], v)
			end
		end
	end

	self:updateInfo();

	self.root:setVisible(true);
	self:addSwallowCallback(handler(self, self.onClickBack));
end

function GemSkillPanel:swtichBtnClick(sender , event)
	local tag = sender:getTag();
	AudioManager:playEffect(Conf.buttonClick);
	self.selfIdx = tag;

	self:updateInfo()
end

function GemSkillPanel:updateInfo()
	for k,v in pairs(self.btns) do
		if k == self.selfIdx then
			v.btn:setEnabled(false)
			v.label:setOpacity(255)
		else
			v.btn:setEnabled(true)
			v.label:setOpacity(130)
		end
	end

	self.selListView:reloadData(self.dataList[self.selfIdx]);
end

function GemSkillPanel:onClickBack()
	UIManager:pop('GemSkillPanel');
end

function GemSkillPanel:onLeave()
	self.root:setVisible(false);
end

function GemSkillPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.Common2RowItemCell:create(cell);
		cellNode:setTag(999);
		cellNode:setCallBack(handler(self, self.showSkillInfo))
    end

    if self.dataList[self.selfIdx][index+1] then
    	cellNode:initData( self.dataList[self.selfIdx][index+1], 0 );
    end
end

function GemSkillPanel:cellItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
    end
end

function GemSkillPanel:showSkillInfo( skillid )
	local data = ResTable:getRowData('skill', skillid)
	if not data then
		return;
	end
	self.iconSpr:setTexture( "image/skillicon/"..data.icon..".png" )
	self.skillName:setString( data.name )
	self.skillDes:setString( data.info )

	self.skillInfoNode:setVisible(true)
end

function GemSkillPanel:clickBtn()
	self.skillInfoNode:setVisible(false)
end

return GemSkillPanel;
