local GuildBossBonusListPanel = class("GuildBossBonusListPanel",require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")


function GuildBossBonusListPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildBossBonusListPanel');

	self.useCCreator = false;
	self.isPopup = true;

	-- self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	-- self.showFooter = true;
end
function GuildBossBonusListPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:InitPanels();
	self:registEvent();
end

function GuildBossBonusListPanel:InitPanels()

    local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,761));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -42);

	local titleNode = GlobalFunctions:createTitle(LANG.UI_EVENT_2,606,63,nil,true);
	titleNode:addTo(self.root);
	titleNode:setPosition(0,370);

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.root);
	listBg:setPosition(0 , -39);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(582 , 736));

	local initData = {
        width = 564,
        height = 720,
        cellWidth = 564,
        cellHeight = 132,
		cellReloadFunc = handler(self,self.reloadCellPanel),
	}
	
	self.bonusTableView = template.TableViewTemplate:create()
    self.bonusTableView:initWithSizeAndItem(initData) ;
    self.bonusTableView:getView():setPosition(cc.p(-282,-399));
    self.bonusTableView:getView():addTo(self.root)

    self.overTip = cc.Node:create()
		:addTo(self.root)
		:setPosition(0 , -452)
		:setLocalZOrder(110)

	local dropImg = cc.Sprite:create('image/commonImg/tip_2.png');
	dropImg:addTo(self.overTip);

	local dropLabel = cc.Label:createWithTTF(LANG.UI_L_OVER , fonts.FONT_SIYUAN , 20);
	dropLabel:addTo(self.overTip);
	dropLabel:setTextColor(cc.c3b(255 , 200 , 0));

	local width = dropImg:getContentSize().width+10;
	local labelWidth = dropLabel:getContentSize().width;
	local posX = -labelWidth / 2;
	dropImg:setPosition(posX , 0);
	dropLabel:setPosition(posX + width/2+labelWidth/2 , 0);
end

function GuildBossBonusListPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkGuildBossBonusStage , handler(self , self.retGuildBonusStage));
end

function GuildBossBonusListPanel:onEnter()
    self:addSwallowCallback(handler(self , self.onClickBack));
    
    self:onShow();
end

function GuildBossBonusListPanel:onShow()
    self.guild_bonus_received = model.GuildModel:getHasRecBossRwd();
    self.guild_bonus_all_list = GlobalFunctions:sortTableByKey(ResTable:getTable("guild_raid_point").contain) -- 转有序数组 ()
    self.guild_boss_completed_stage = model.GuildModel:getGuildBossAllDamage();--奖励值判定

    self.guildBonusList = {};
    table.sort(  self.guild_bonus_all_list, function ( item1,item2 )

        if self.guild_bonus_received[item1.no] == nil and self.guild_bonus_received[item2.no] == nil then
            return item1.point < item2.point;
        end

        if self.guild_bonus_received[item1.no] and self.guild_bonus_received[item2.no] then
            return item1.point < item2.point;
        end

        return self.guild_bonus_received[item1.no] == nil 

    end )

    self.overTip:setVisible(model.GuildModel:getGuildBossOpenState() ~= 1)

    self.root:setVisible(true);
    self.bonusTableView:reloadData(self.guild_bonus_all_list);
end

function GuildBossBonusListPanel:oneKeyBtnClick()--一键领取
    
    if model.GuildModel:getGuildBossBonusState() ~= true then
        Prompt:Show(LANG.UI_GUILD_103);
        return 
    end

    model.GuildModel:reqGuildBonusStage(0);

end


function GuildBossBonusListPanel:onClickBack(  )--取消
    UIManager:pop("GuildBossBonusListPanel");
    tools.RedDotTools:pushGuildRedDot(3)
    EventManager:FireEvent(EventType.UIUpateGuildBonusRedDot);
end

function GuildBossBonusListPanel:onLeave()
	self.root:setVisible(false);
end

function GuildBossBonusListPanel:retGuildBonusStage( msg )
    self.isReqBonus = false;

    self.guild_bonus_received = model.GuildModel:getHasRecBossRwd();
    --if msg > 0 and self.guildBonusList[msg] ~= nil then
    --    self.guildBonusList[msg]:updateState(2);
    --end

    self:onShow();

    local rwdData = ResTable:getRowData('guild_raid_point',msg);
    local rewardTable = {}
    rewardTable.tempReward = rwdData.reward
    UIManager:push('RewardPanel' , rewardTable);

end

function GuildBossBonusListPanel:cellBtnClick( id )
    if self.guild_bonus_received[id] ~= nil then
        Prompt:Show(LANG.UI_GUILD_104);
        return 
    end

    local rwdData = ResTable:getRowData('guild_raid_point',id);
    if rwdData and rwdData.point > self.guild_boss_completed_stage then
        -- to GuildBoss
        self:onClickBack();
        return
    end
    if self.isReqBonus ~= true then
        self.isReqBonus = true ;
        model.GuildModel:getGuildBossRwd(id);
    end
end

function GuildBossBonusListPanel:reloadCellPanel( cell,idx )

    local cellNode  = cell:getChildByTag(999);
    if nil == cellNode then
        cellNode = template.RoundTargetRewardTemplate:create();
        cellNode:addTo(cell);
        cellNode:addBtnClickEventListener(handler(self,self.cellBtnClick))
		cellNode:setTag(999);
		cellNode:setPosition(cc.p(282 , 66));
    end

    local reward = self.guild_bonus_all_list[idx+1];--取当前cell数据

    self.guildBonusList[reward.no] = cellNode;

    local receive_state = 1; -- 0 不可领取，1 可领取，2 已领取
    if reward.point > self.guild_boss_completed_stage then
        receive_state = 0
    end
    if self.guild_bonus_received[reward.no] then
        receive_state = 2;
    end

    -- if reward.id > self.guild_boss_completed_stage then
    --     receive_state = 0
    -- end
    -- if self.guild_bonus_received[reward.id] then
    --     receive_state = 2;
    -- end

    -- local data = {
    --     reward = reward.reward_clear,
    --     receive_state = receive_state,
    --     title = string.format(LANG.UI_GUILD_60,reward.id);
    --     completeStage = self.guild_boss_completed_stage,
    --     curStage = reward.id 
    -- }
    -- cellNode:InitGuildBossReward(data);

    local data = {
        reward = reward.reward,
        receive_state = receive_state,

        title = string.format(LANG.UI_GUILD_BOSS_11,ConvertStrToDigitUnit(tostring(reward.point)));

        completeStage = self.guild_boss_completed_stage,
        curStage = reward.point,
        rewardNo = reward.no
    }
    cellNode:InitGuildBossReward(data);
    
    return cell ;

end

return GuildBossBonusListPanel;
