local GuildChatPanel = class("GuildChatPanel",require('app.layer.BaseLayer'))

local fonts = Enum:getTable('SystemFont')

local EDIT_INPUT_LIMIT =42;
-- 

function GuildChatPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildChatPanel');

	self.useCCreator = false;
	self.isPopup = true;
	self.haveSwallowLayer = true;

	--self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = false;
end

function GuildChatPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.joinAllGuildList = {};
	self.editInputStr = ''

	self:InitPanels();
	self:registEvent();
end

function GuildChatPanel:InitPanels()
	
	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -22);
    bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(606 , 715));

	local titleNode = GlobalFunctions:createTitle(LANG.UI_GUILD_TITLE[5],604,63,'MESSAGE');
	titleNode:addTo(self.root);
	titleNode:setPosition(0,367);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , 15);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(582 , 621));

	local btnLabel = cc.Label:createWithTTF(LANG.UI_GUILD_76, fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c3b(55 , 85 , 155) , 2);
	local chatBtn = ccui.Button:create('image/commonImg/btn_11.png')
		:addTo(self.root)
		:setPosition(cc.p(226,-334))
		:setTitleLabel(btnLabel)
		:addClickEventListener(handler(self , self.sendBtnClick));	

	local input = cc.Scale9Sprite:create('image/commonImg/edit_bg_28_0_177_49.png')
		:addTo(self.root)
		:setPosition(-70 , -334)
		:setCapInsets(cc.rect(28,0,177,49))
		:setContentSize(cc.size(434 , 49))
	
	self.textPlaceHolder = cc.Label:createWithTTF(string.format(LANG.UI_GUILD_77, tostring(EDIT_INPUT_LIMIT)), fonts.FONT_SIYUAN,15)
		:setTextColor(cc.c4b(150,150,150,255))
		:setPosition(cc.p(-86,-333))
		:addTo(self.root)

	self.logEditInput = ccui.EditBox:create(cc.size(360,40), cc.Scale9Sprite:create())
		:setFontColor(cc.c4b(150, 150, 150, 255))
		:setMaxLength(EDIT_INPUT_LIMIT) 
		-- :setText('')
		-- :setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
		-- :setReturnType(cc.KEYBOARD_RETURNTYPE_DONE)
		:addTo(self.root)
		:setFont(fonts.FONT_SIYUAN,15)
		-- :setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
		:setPosition(cc.p(-86,-333))
	self.logEditInput:registerScriptEditBoxHandler(function(event)
		 if event == "began" then
			self.textPlaceHolder:setVisible(false);
		 end
	
		if event == "return" then
			local str =  self.logEditInput:getText()
			self.editInputStr = str;
			local str2,bRet = tools.SensitiveTools:checkSensitive( str )
			self.logEditInput:setText(str2)
			if bRet == true then
				Prompt:Show(LANG.UI_SENSITIVE);
				return 
			end
		end
	end);
	local inputBg3 = cc.Sprite:create('image/commonImg/edit_img.png')
		:addTo(self.root)
		:setPosition(cc.p(116,-333));

    local initData = {
        width = 582,
        height = 610,
        cellWidth = 582,
        cellHeight = 132,
        cellReloadFunc = handler(self,self.reloadCellCreate),
    }
    self.logListView = template.TableViewTemplate:create()
    self.logListView:initWithSizeAndItem(initData);
    self.logListView:getView():setPosition(cc.p(-291,-290)); -- 0,15
	self.root:addChild(self.logListView:getView())

	self.root:setVisible(false);
end

function GuildChatPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildMessInfo, handler(self, self.retGuildMessInfo))
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildMess, handler(self, self.retGuildMessSend))
end

function GuildChatPanel:retGuildMessInfo(msg)
	self.logEditInput:setText('');
	self.textPlaceHolder:setVisible(true);
	self.editInputStr = '';
	self:onShowMessage();
end

function GuildChatPanel:retGuildMessSend(msg)
	self.logEditInput:setText('');
	self.textPlaceHolder:setVisible(true);
	self.editInputStr = '';
	self:onShowMessage();
end

function GuildChatPanel:sendBtnClick(sender , event)
	local text = self.editInputStr --self.logEditInput:getText();
	if not text or text == '' then
		Prompt:Show(LANG.CHAT_9);
		return;
	end
	local _,bRet = tools.SensitiveTools:checkSensitive( text )
	if bRet == true then
		Prompt:Show(LANG.UI_SENSITIVE);
		return 
	end

	--if #text > EDIT_INPUT_LIMIT then
	--	Prompt:Show(string.format( LANG.CHAT_8,EDIT_INPUT_LIMIT ));
	--	return;
	--end
	text = string.gsub(text, '\n', '')
	model.GuildModel:reqSendGuildMess(text);
end

function GuildChatPanel:onShowMessage()
	self.messInfo = model.GuildModel:getGuildMessInfo() or {};

	-----------------ceshi-----------------------------
	-- self.messInfo = {}
	-- for i=1,10 do
	-- 	local data = {
	-- 		message_time = os.time() - math.random( 200,2000 );
	-- 		uid = 15303158656545 + math.random( 0,10 );
	-- 		head_icon = 1 + math.random( 0,25 );
	-- 		message = 'test=============== === '..string.rep( 'math.random( 0,10 ) ', math.random( 0,10 ) ) ..i;
	-- 		level = 99;
	-- 		name = 'name ==== '..i;
	-- 		guild_flag = math.random( 0,2 );
	-- 	}
	-- 	table.insert( self.messInfo,data )
	-- end
	-----------------------ceshi---------------------
	self.logListView:reloadData(self.messInfo);
	
	self.logListView:scroolToBottom()

end
function GuildChatPanel:reloadCellCreate( cell,index )
	local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
		cellNode = template.GuildChatItemTemplate:create();
		cellNode:setTag(999);
		cellNode:addTo(cell);
		cellNode:setPosition(cc.p(291,66));
	end
	local messInfo = self.messInfo;

	local itemData = messInfo[index + 1 ] ;-- 
	cellNode:initData(itemData);

end


function GuildChatPanel:onEnter()

	self:addSwallowCallback(handler(self , self.onClickBack))
	model.GuildModel:reqGuildMessInfo()

	self.textPlaceHolder:setVisible(true);
	self.logEditInput:setText('');

	self.root:setVisible(true);
end

function GuildChatPanel:onShow()

end

function GuildChatPanel:onLeave()
	self.root:setVisible(false);
end

function GuildChatPanel:onClickBack()
	--self.root:setOpacity(255);
	--self.root:runAction(cc.Sequence:create(cc.FadeTo:create(0.2 , 50) , cc.CallFunc:create(function()
	--	
	--end)));

	UIManager:pop('GuildChatPanel');
	-- tools.RedDotTools:pushGuildRedDot(2)
end

return GuildChatPanel;
