local GuildCreatePanel = class("GuildCreatePanel",require('app.layer.BaseLayer'))

local fonts = Enum:getTable('SystemFont')
local MessageBoxType = Enum:getTable('MessageBoxType')

local ICON_NUM = 6;
local ellipseA = 342;
local ellipseB = 62;
local PI = 3.1415926
-- 创建公会页面
-- 
function GuildCreatePanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildCreatePanel');

	self.useCCreator = false;
	self.isPopup = false;
	self.haveSwallowLayer = false;

	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function GuildCreatePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.editInputStr = ''
	self:InitPanels();
	self:registEvent();
end

function GuildCreatePanel:InitPanels()
	
	local bg = cc.Sprite:create('image/bg/Bg_10.png')
		:addTo(self.root)

	local title = cc.Label:createWithTTF(LANG.UI_GUILD_106,fonts.FONT_SIYUAN,30)
		:addTo(self.root)
		:setPosition(0,314)

	local topBg = cc.Scale9Sprite:create('image/commonImg/time_bg_1.png')
		:addTo(self.root)
		:setCapInsets(cc.rect(0,6,483,19))
		:setContentSize(cc.size(483 , 38))
		:setPosition(0 , 258)
	
	local money1 = cc.Sprite:create('image/icon/I10002.png')
		:addTo(self.root)
		:setPosition(cc.p(-121,258))
		:setScale(0.4)

	local topLabel = cc.Label:createWithTTF(LANG.UI_GUILD_118 ,  fonts.FONT_SIYUAN , 18)
		:addTo(self.root)
		:setPosition(-99,259)
		:setAnchorPoint(0,0.5)
		:setTextColor(cc.c3b(255,255,0))

	self.createGuildPrice = cc.Label:createWithTTF('0' ,  fonts.FONT_SIYUAN , 18)
		:addTo(self.root)
		:setPosition(95,259)

	local nameBg = cc.Scale9Sprite:create('image/commonImg/edit_bg_28_0_177_49.png')
		:addTo(self.root)
		:setPosition(0 , -121)
		:setCapInsets(cc.rect(28,0,177,49))
		:setContentSize(cc.size(334 , 49))

	local nameImg = cc.Sprite:create('image/commonImg/edit_img.png')
		:addTo(self.root)
		:setPosition(cc.p(135,-121))
	
	self.guildNameEdit = ccui.EditBox:create(cc.size(264,49), cc.Scale9Sprite:create())
		:setFontColor(cc.c4b(255, 255, 255, 255))
		:setMaxLength(20)
		:addTo(self.root)
		:setPlaceHolder(LANG.UI_GUILD_67)
		:setPlaceholderFont(fonts.FONT_SIYUAN,18)
		:setFont(fonts.FONT_SIYUAN,18)
		:setMaxLength(7)
		:setPlaceholderFontColor(cc.c4b(255,255,255,255))
		:setPosition(cc.p(-14,-121))
		:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
		:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE)
	self.guildNameEdit:registerScriptEditBoxHandler(function(event)
			-- if event == "began" then
			-- 	self.guildNameEdit:setText(self.editInputStr or "");
			-- end
			
			if event == "return" then
				local str =  self.guildNameEdit:getText()
				self.editInputStr = str;
				local str3, btrue = checkStr( str )
				if btrue == false then
					Prompt:Show(LANG.UI_CRTNAME);
					-- self.editInputStr = str3
					-- self.guildNameEdit:setText(str3)
					return
				end

				local str2,bRet = tools.SensitiveTools:checkSensitive( str )
				self.guildNameEdit:setText(str2)
				if bRet == true then
					-- self.editInputStr = str2
					Prompt:Show(LANG.UI_SENSITIVE);
					return 
				end
			end
		end);

	local btnLabel = cc.Label:createWithTTF(LANG.COMMON_OK, fonts.FONT_SIYUAN, 20)
	btnLabel:enableOutline(cc.c4b(170 , 25 , 10 , 255) , 2)
	self.createGuildOk = ccui.Button:create('image/commonImg/btn_9_219_55.png');
	self.createGuildOk:setPosition(0, -210);
	self.createGuildOk:setTitleLabel(btnLabel);
	self.createGuildOk:addClickEventListener(handler(self, self.createGuildOkClick));
	self.createGuildOk:addTo(self.root);

	local guildIconNode = cc.Node:create()
		:addTo(self.root)
		:setPosition(0,62)
--
	local guildIconBg = cc.Sprite:create('image/guild/guild_icon/icon_bg.png')
		:addTo(guildIconNode)
	self.guildIcon = cc.Sprite:create()
		:addTo(guildIconNode)

	--self:initEllipse();

	self.root:setVisible(false);
end

function GuildCreatePanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkGuildRetCreateGuild, handler(self, self.retCreateGuild))
end

--更换公会Icon
function GuildCreatePanel:exchangeIconClick(sender , event)
	UIManager:push('GuildIconSelectPanel',handler(self,self.iconSelectOKClick),self.iconResId);
end

function GuildCreatePanel:iconSelectOKClick(tag)
	if tag == 0 then
		return ;
	end
	self.iconResId = tag;
	if self.createGuildGuildIcon then
		self.createGuildGuildIcon:setTexture('res/image/guild/guild_icon/icon_'..self.iconResId..'.png')
	end

end

--创建公会
function GuildCreatePanel:createGuildOkClick(sender , event)
	local guildName = self.editInputStr --self.createGuildEditGuildName:getText();
	local str3, btrue = checkStr( guildName )
	if btrue == false then
		Prompt:Show(LANG.UI_CRTNAME);
		return
	end

	local _,bRet = tools.SensitiveTools:checkSensitive( guildName )
	if bRet == true then
		Prompt:Show(LANG.UI_SENSITIVE);
		return 
	end

	if not guildName or guildName == '' then
		Prompt:Show(LANG.UI_GUILD_34);
		return;
	end
	
	if model.ItemModel:getItemNum(BLUE_DIA) < 500 then
		Prompt:Show(LANG.UI_GUILD_35);
		return;
	end
	
	model.GuildModel:createGuild(guildName , self.iconResId);
end
--创建公会返回
function GuildCreatePanel:retCreateGuild(msg)
	if IsKr then
		UIManager:switch('GuildPanel')
	else
		UIManager:pop('GuildCreatePanel')
		UIManager:push('GuildPanel')
	end
end
--取消创建公会
function GuildCreatePanel:createGuildCancleClick(sender , event)
	self:onClickBack();
end
function GuildCreatePanel:onEnter()
	self.iconResId = 1;		
	self.createGuildPrice:setString('500');
	self.guildNameEdit:setText('');

	self.guildIcon:setTexture('image/guild/guild_icon/icon_1.png');
	self.root:setVisible(true);
end

function GuildCreatePanel:onLeave()
	TimeManager:registUpdateEvent('GuildCreatePanel',nil);
	self.root:setVisible(false);
end

function GuildCreatePanel:onClickBack()
	UIManager:pop('GuildCreatePanel');
end

--椭圆旋转 , 废弃留着

function GuildCreatePanel:initEllipse()
	self.guildIconNode = cc.Node:create()
		:addTo(self.root)
		:setPosition(0,62);

	self:registerEventListener();

	self.iconAngle = {};
	self.iconList = {}
	for i = 1 , ICON_NUM do
		self.iconList[i] = {};

		local angle = (PI * 2) / ICON_NUM * (i-1);
		self.iconAngle[i] = angle;

		local angle = self:radianToAngle(angle);
		print(i,'===========>',angle);
		if angle >= 89 and angle <=91 then
			self.curPage = i;
			self.lastPage = i;
		end

		local node = cc.Node:create();
		node:addTo(self.guildIconNode);
		node:setPosition(self:getEllipsePos(angle));
		node:setCascadeOpacityEnabled(true);
		self.iconList[i].node = node;

		local bg = cc.Sprite:create('image/guild/guild_icon/icon_bg.png');
		bg:addTo(node);

		if cc.FileUtils:getInstance():isFileExist("image/guild/guild_icon/icon_"..i..".png") then
			local icon = cc.Sprite:create("image/guild/guild_icon/icon_"..i..".png");
			icon:addTo(node);
			self.iconList[i].icon = icon;
		end

		self:updateIconOpacity(i);
	end
end
function GuildCreatePanel:ellipseXat(angle)
	return ellipseA*math.cos(angle)
end

function GuildCreatePanel:ellipseYat(angle)
	return ellipseB*math.sin(angle)
end

function GuildCreatePanel:getEllipsePos(angle)
	return cc.p(self:ellipseXat(angle),self:ellipseYat(angle));
end

function GuildCreatePanel:getRealAngle(page)
	local angle = self:radianToAngle(self.iconAngle[page])
	if angle >= 0 then
		angle = math.floor(angle);
	else
		angle = math.ceil(angle);
	end
	local realAngle = angle % 360;
	if realAngle < 0 then
		realAngle = 360 - math.abs(realAngle);
	end
	return realAngle;
end

function GuildCreatePanel:radianToAngle(radian)
	return radian*180/PI; 
end

function GuildCreatePanel:angleToRadian(angle)
	return angle*PI/180;
end

function GuildCreatePanel:getAngleFromOffset(offset)
	if offset ~= 0 then
		return math.atan(offset/ellipseB);
	end
	return 0;
end

function GuildCreatePanel:getWeight(realAngle)
	local weight = realAngle - 90;
	weight = 5 - math.abs(weight/45);

	if realAngle > 180 then
		weight = math.abs(weight - 1);
		weight = weight + 1;
	end

	if weight < 1 then
		weight = 1;
	end

	return weight;
end

function GuildCreatePanel:updateIconOpacity(page)
	local realAngle = self:getRealAngle(page);

	local whith = 0.8; 
	if realAngle > 90 and realAngle < 150 then
		whith = whith + (150 - realAngle) / 60 * 0.2;
	elseif realAngle > 30 and realAngle <= 90 then
		whith = whith + (realAngle-30) / 60 * 0.2;
	end

	self.iconList[page].node:setLocalZOrder(whith * 100);
	self.iconList[page].node:setScale(whith);
	self.iconList[page].node:setOpacity(255*whith);
end

function GuildCreatePanel:movePages(offsetAngle)
	for i = 1 , ICON_NUM do
		self.iconAngle[i] = self.iconAngle[i] + offsetAngle;

		if i == self.curPage then
			self.endAngle = self.endAngle + offsetAngle
		end

		self.iconList[i].node:setPosition(self:getEllipsePos(self.iconAngle[i]))
		self:updateIconOpacity(i);
	end
end

function GuildCreatePanel:scrollToPage(page)
	print('scrollToPage==>',page,self:getRealAngle(page));

	self.changeAngle = 90 - self:getRealAngle(page);
	print('self.changeAngle======1=====>',self.changeAngle);
	self.changeAngle = self:angleToRadian(self.changeAngle);
	print('self.angleToRadian======2=====>',self.changeAngle);
	self.changeAngle = self.changeAngle / self.autoScrollSpeed;
	print('self.autoScrollSpeed======3=====>',self.changeAngle);

	self.isAutoScrolling = true;
end

function GuildCreatePanel:registerEventListener()

	self.isAutoScrolling = false;
	self.autoScrollSpeed = 10;
	self.changeAngle = 0;
	self.curPage = 1;
	self.lastPage = 1;
	self.endAngle = 0;
	self.touchMoveStartLocationX = 0;

	local touchListener = cc.EventListenerTouchOneByOne:create()
	touchListener:registerScriptHandler(function(touch, event)
		if not self.root:isVisible() then
			return false
		end
		local location = self.guildIconNode:convertToNodeSpace(touch:getLocation());
		local rectR = cc.rect(-320, -147, 640, 294)
		if cc.rectContainsPoint(rectR, location) then
			self.touchMoveStartLocationX = location.x;
			self.endAngle = 0;
			return true
		end
		return false
	end, cc.Handler.EVENT_TOUCH_BEGAN)
	touchListener:registerScriptHandler(function(touch, event)
		local location = self.guildIconNode:convertToNodeSpace(touch:getLocation());
		local moveX = location.x;
		local offset = moveX - self.touchMoveStartLocationX;
		self.touchMoveStartLocationX = moveX;
		print('offset=============>',offset);
		self:movePages(self:getAngleFromOffset(offset));
	end, cc.Handler.EVENT_TOUCH_MOVED)
	touchListener:registerScriptHandler(function(touch, event)
		local whith = 360/(ICON_NUM *2);
		local angle = self:radianToAngle(self.endAngle);

		local p = 0;
		if angle >= 0 then
			p = math.floor(angle / whith)
		else
			p = math.ceil(angle / whith)
		end

		print('p==========>',self.endAngle,angle,whith,p);
		if p < 0 then
			if(p % 2) ~= 0 then
				p = (p-1)/2
			else
				p = p/2;
			end
		else 
			if(p % 2) ~= 0 then
				p = (p+1)/2
			else
				p = p/2;
			end
		end
		print('p=======1===>',p);
		self.curPage = (self.curPage-p) % ICON_NUM;

		if self.curPage < 1 then
			self.curPage = ICON_NUM;
		end

		self:scrollToPage(self.curPage);

	end, cc.Handler.EVENT_TOUCH_ENDED)
	local eventDispatcher = self.guildIconNode:getEventDispatcher()
	eventDispatcher:addEventListenerWithSceneGraphPriority(touchListener, self.guildIconNode)

	TimeManager:registUpdateEvent('GuildCreatePanel',handler(self,self.update));
end

function GuildCreatePanel:update(dt)
	if self.isAutoScrolling then
		local realAngle = self:getRealAngle(self.curPage);

		if realAngle <= 91 and realAngle >= 89 then
			self.lastPage = self.curPage;
			self.isAutoScrolling = false;

			for i = 1 , 6 do
				print('===============>',i);
				print('iconAngle========>',self.iconAngle[i]);
				print('radianToAngle========>',self:radianToAngle(self.iconAngle[i]));
				print('getRealAngle============>',self:getRealAngle(i));
			end
		end

		self:movePages(self.changeAngle);
	end
end

return GuildCreatePanel;
