local GuildIconSelectPanel = class("GuildIconSelectPanel",require('app.layer.BaseLayer'))

local fonts = Enum:getTable('SystemFont')
local MessageBoxType = Enum:getTable('MessageBoxType')

-- 创建公会页面
-- 
function GuildIconSelectPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildIconSelectPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function GuildIconSelectPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:InitPanels();
	self:registEvent();
end

function GuildIconSelectPanel:InitPanels()
	
	local bg = cc.Sprite:create('image/guild/guild_iconSelect_bg.png');
	bg:setPosition(0, 99);
	bg:addTo(self.root);

	GlobalFunctions:createTitleNode( bg, LANG.UI_L_ALLIANCE_ICON_1, LANG.UI_L_ALLIANCE_ICON_2,  
		bg:getContentSize().width/2, bg:getContentSize().height -16 );

	self.iconView = ccui.ScrollView:create();
	self.iconView:setTouchEnabled(true);
	self.iconView:setBounceEnabled(true);
	self.iconView:setDirection(ccui.ScrollViewDir.vertical);
	self.iconView:setContentSize(cc.size(556, 280));
	self.iconView:setAnchorPoint(cc.p(0.5, 0.5));
	self.iconView:setPosition(0, 131);
	self.iconView:setScrollBarEnabled(false);
	self.iconView:addTo(self.root);

	self.oneKeyBtn = ccui.Button:create('image/commonImg/btn_bg1.png' , 'image/commonImg/btn_bg1.png');
	self.oneKeyBtn:addTo(self.root);
	self.oneKeyBtn:setPosition(0 , -70);
	self.oneKeyBtn:addClickEventListener(handler(self , self.iconSelectOKClick));

	local oneKeyLabel = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20);
	oneKeyLabel:addTo(self.oneKeyBtn);
	oneKeyLabel:setPosition(self.oneKeyBtn:getContentSize().width/2 , self.oneKeyBtn:getContentSize().height/2);
	oneKeyLabel:setTextColor(cc.c3b(255 , 255 , 255));
	oneKeyLabel:enableOutline(cc.c4b(19 , 93 , 188 , 255) , 2);
end

function GuildIconSelectPanel:registEvent()
end
--显示选择公会icon界面
function GuildIconSelectPanel:showIconSelectPanel()

	
	local maxHeight = 210 * 2;
    if maxHeight < 280 then
        maxHeight = 280;
	end
	
	self.iconView:removeAllChildren();

	self.iconView:setInnerContainerSize(cc.size(556,maxHeight))
	
	self.iconSelect = {};
	for i=1,6 do
		local row = math.ceil(i / 3);
		local col = i % 3;
		col = col == 0 and 3 or col;

		local node = ccui.Layout:create();
		node:addTo(self.iconView);
		node:setPosition(83 + 195 * (col - 1) , maxHeight - 99 - 200 * (row - 1));

		local bg = ccui.Button:create('image/guild/guild_bg1.png' , 'image/guild/guild_bg1.png');
		bg:addTo(node);
		bg:setTag(i);
		bg:setScale(0.6);
		bg:addClickEventListener(handler(self , self.iconSelectClick));

		bg = cc.Sprite:create('image/guild/guild_icon/icon_'..i..'.png');
		bg:addTo(node);
		bg:setPosition(0 , 10);
		bg:setScale(0.7);

		bg = cc.Sprite:create('image/guild/icon_select.png');
		bg:addTo(node);
		self.iconSelect[i] = bg;
	end
end

function GuildIconSelectPanel:iconSelectClick(sender , event)
	local iconId = sender:getTag();

	if iconId == self.currentIconId then
		return;
	end

	self.currentIconId = iconId;
	self:updateSelect();
end

function GuildIconSelectPanel:updateSelect()
	for _k , select in pairs(self.iconSelect) do
		select:setVisible(_k == self.currentIconId);
	end
end

--选择公会图标
function GuildIconSelectPanel:iconSelectOKClick(sender , event)
	if self.callfunc then
		self.callfunc(self.currentIconId)
	end
	self:onClickBack();
end

function GuildIconSelectPanel:onEnter( callfunc,iconId)
	self.callfunc = callfunc;
	self.currentIconId = iconId or 1
	self:showIconSelectPanel();
	self:updateSelect();
	self:addSwallowCallback(handler(self , self.onClickBack))
	self.root:setVisible(true);
end

function GuildIconSelectPanel:onLeave()
	self.root:setVisible(false);
end

function GuildIconSelectPanel:onClickBack()
	UIManager:pop('GuildIconSelectPanel');
end

return GuildIconSelectPanel;
