local GuildMainPanel = class("GuildMainPanel",require('app.layer.BaseLayer'))

local fonts = Enum:getTable('SystemFont')
local MessageBoxType = Enum:getTable('MessageBoxType')
local imagePath = 'image/guild/main/'

-- 公会主页面
--[[
local GuildMenuTag = {
	TAG_MAIN_INFO 			= 1,	-- 公会大厅
	TAG_GUILD_SHOP 			= 2,	-- 公会商店 
	TAG_GUILD_DONATE		= 3,	-- 公会捐献
	TAG_GUILD_BOSS 			= 4,	-- 公会boss
	TAG_GUILD_CHAT			= 5,	-- 公会留言
	TAG_GUILD_SKILL			= 6,	-- 科研所

	TAG_GUILD_NOTICE		= 7,	-- 公会公告
	

}
]]

local GuildMenuTag = {
	TAG_GUILD_SKILL			= 1,	-- 科研所
	TAG_GUILD_BOSS 			= 2,	-- 公会boss
	TAG_GUILD_CHAT			= 3,	-- 公会留言
	TAG_GUILD_SHOP 			= 4,	-- 公会商店
	TAG_GUILD_DONATE		= 5,	-- 公会捐献
	TAG_GUILD_ICON			= 6,	-- 公会Icon

	TAG_GUILD_NOTICE		= 7,	-- 公会公告
	TAG_GUILD_MENAGER		= 8,	-- 管理
}

function GuildMainPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildMainPanel');

	self.useCCreator = false;
	self.isPopup = false;
	self.haveSwallowLayer = false;

	if IsKr then
		self.showHeaderType = Enum:getTable('HeaderType').HEAD_ICON;
	else
		self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	end
	self.showFooter = true;
end

function GuildMainPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:InitPanels();
	self:registEvent();
end

function GuildMainPanel:InitPanels()
	
	local bg = cc.Sprite:create('image/bg/Bg_11.png')
	:addTo(self.root)
	self.btnNode = {};
	self:initInfoPanel();
	
	self.root:setVisible(false);
end

function GuildMainPanel:initInfoPanel()

	local mainNode = cc.Node:create();
	mainNode:addTo(self.root);
	mainNode:setPosition(0,StageSize.height/2-568)

	local infoNode = cc.Node:create()
	infoNode:addTo(mainNode)
	infoNode:setPosition(0,264);

	local bg = ccui.Layout:create();
	bg:addTo(infoNode);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,252));
	bg:setAnchorPoint(0.5,0.5);

	local titleNode = GlobalFunctions:createTitle(nil,606,46,nil);
	titleNode:addTo(infoNode);
	titleNode:setPosition(0 , 149);

	local guildInfoIconBg = cc.Sprite:create('image/guild/guild_icon/icon_bg.png');
	guildInfoIconBg:addTo(infoNode);
	guildInfoIconBg:setPosition(-159,19);

	self.guildInfoIcon = cc.Sprite:create();
	self.guildInfoIcon:addTo(infoNode);
	self.guildInfoIcon:setPosition(cc.p(-159,19))
	
	self.exchageBtn = ccui.Button:create(imagePath..'main_bg_12.png',imagePath..'main_bg_12.png')
		:addTo(infoNode)
		:setPosition(cc.p(-118,-68))
	self.exchageBtn:addClickEventListener(handler(self , self.onExchangeIcon));
	self.btnNode[GuildMenuTag.TAG_GUILD_ICON] = self.exchageBtn;

	self.guildInfoName = cc.Label:createWithTTF('name' , fonts.FONT_SIYUAN , 26)
		:addTo(infoNode)
		:setPosition(cc.p(126 ,123))

	local title1 = {LANG.UI_GUILD_85,LANG.UI_GUILD_86,LANG.UI_GUILD_87} -- 会长名字，公会ID，成员数
	local infoLable = {}
	for i=1,3 do
	
		local lable1 = cc.Label:createWithTTF(title1[i] , fonts.FONT_SIYUAN , 18)
			:addTo(infoNode)
			:setAnchorPoint(0,0.5)
			:setPosition(cc.p(-23 , 63 - 40*(i-1) ))

		infoLable[i] = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 18)
			:addTo(infoNode)
			:setAnchorPoint(cc.p(1,0.5))
			:setPosition(cc.p(267 , 63 - 40*(i-1) ))
	end
	self.guildInfoMaster = infoLable[1];
	self.guildInfoNumber = infoLable[2];
	self.guildInfoCount = infoLable[3];

	local btnList = {};
	local btnBg = {
		[1] = imagePath..'main_bg_7.png',
		[2] = imagePath..'main_bg_9.png',
	};
	local btnCallback = {
		[1] = function() UIManager:push('GuildMemberPanel') end,
		[2] = handler(self , self.onQuitOrDismissCall)
	}
	for i = 1 , 2 do
		local label = cc.Label:createWithTTF(i == 1 and LANG.UI_GUILD_111 or '' , fonts.FONT_SIYUAN , 16);
		btnList[i] = label;

		local btn = ccui.Button:create(btnBg[i],btnBg[i]);
		btn:addTo(infoNode);
		btn:setPosition(i == 1 and 45 or 204,-79);
		btn:addClickEventListener(btnCallback[i]);
		btn:setTitleLabel(label);

		if i == 1 then
			self.btnNode[GuildMenuTag.TAG_GUILD_MENAGER] = btn;
		end
	end

	self.managerBtnLabel = btnList[1];
	self.exitBtnLabel = btnList[2];

	-- --lv
	local lvNode = cc.Node:create();
	lvNode:addTo(mainNode);
	lvNode:setPosition(cc.p(0,75));

	local lvProgressBg =  cc.Sprite:create(imagePath.."main_bg_10.png");
	lvProgressBg:addTo(lvNode);

	self.guildInfoProgressBar = cc.Scale9Sprite:create(imagePath..'main_bg_11.png');
	self.guildInfoProgressBar:addTo(lvNode);
	self.guildInfoProgressBar:setPosition(-267 , 0);
	self.guildInfoProgressBar:setAnchorPoint(0 , 0.5);
    self.guildInfoProgressBar:setCapInsets(cc.rect(10,0,6,13));

	self.guildInfoLevel = cc.Label:createWithTTF("99" , fonts.FONT_SIYUAN , 18)
		:addTo(lvNode)
		:setPosition(cc.p(0 , 27.5))
		:enableOutline(cc.c4b(0 , 0 , 0 , 255) , 2)

	local label = cc.Label:createWithTTF(LANG.UI_GUILD_81 , fonts.FONT_SIYUAN , 16);
	local btn = ccui.Button:create(imagePath..'main_bg_8.png',imagePath..'main_bg_8.png');
	btn:addTo(lvNode);
	btn:setPosition(0,-38);
	btn:setTag(GuildMenuTag.TAG_GUILD_DONATE);
	btn:setTitleLabel(label);
	btn:addClickEventListener(handler(self , self.onMainMenuCall));

	self.btnNode[GuildMenuTag.TAG_GUILD_DONATE] = btn;

	local imgs = {
		[GuildMenuTag.TAG_GUILD_SKILL] = 'main_bg_14.png';
		[GuildMenuTag.TAG_GUILD_BOSS] = 'main_bg_13.png';
		[GuildMenuTag.TAG_GUILD_CHAT] = 'main_bg_16.png';
		[GuildMenuTag.TAG_GUILD_SHOP] = 'main_bg_15.png';
	};
	local btnNodePos = {
		[GuildMenuTag.TAG_GUILD_SKILL] = cc.p(163,-16);
		[GuildMenuTag.TAG_GUILD_BOSS] = cc.p(74,-157);
		[GuildMenuTag.TAG_GUILD_CHAT] = cc.p(225,-164);
		[GuildMenuTag.TAG_GUILD_SHOP] = cc.p(161,-300);
	};
	local scale = {
		[GuildMenuTag.TAG_GUILD_SKILL] = 0.9;
		[GuildMenuTag.TAG_GUILD_BOSS] = 1;
		[GuildMenuTag.TAG_GUILD_CHAT] = 0.8;
		[GuildMenuTag.TAG_GUILD_SHOP] = 1;
	};
	
	local labelPosX = {
		[GuildMenuTag.TAG_GUILD_SKILL] = -39.5;
		[GuildMenuTag.TAG_GUILD_BOSS] = -43;
		[GuildMenuTag.TAG_GUILD_CHAT] = -26.5;
		[GuildMenuTag.TAG_GUILD_SHOP] = -36;
	}

	local imgPos = {
		[GuildMenuTag.TAG_GUILD_SKILL] = cc.p(0,10),
		[GuildMenuTag.TAG_GUILD_BOSS] = cc.p(0,16),
		[GuildMenuTag.TAG_GUILD_CHAT] = cc.p(-2,11);
		[GuildMenuTag.TAG_GUILD_SHOP] = cc.p(0,13);
	}

	for i=1, 4 do
		local node = cc.Node:create();
		node:setPosition( btnNodePos[i] );
		node:addTo(mainNode);
		self.btnNode[i] = node;

		local btn = ccui.Button:create(imagePath..'main_bg_6.png')
		-- btn:setPosition(btnNodePos[i]);
		btn:setTag(i);
		btn:addTo(node);
		btn:setScale(scale[i]);
		btn:addClickEventListener(handler(self, self.onMainMenuCall));
		btn:setAlphaTouchEnable(true);

		local sp = cc.Sprite:create(imagePath..imgs[i]);
		sp:addTo(node);
		sp:setScale(scale[i]);
		sp:setPosition(imgPos[i]);

		local tmpLabel = cc.Label:createWithTTF(LANG.UI_GUILD_MAIN_NAME[i],  fonts.FONT_SIYUAN , 19);
	    tmpLabel:addTo(node);
		tmpLabel:setPosition(0 , labelPosX[i]);
	end

	self.helpBtn = ccui.Button:create('image/commonImg/help_1.png','image/commonImg/help_1.png')
	self.helpBtn:addTo(self.root);
	self.helpBtn:setPosition(283 , StageSize.height/2-97-NOTCH_HEIGHT)
	self.helpBtn:addClickEventListener(function() 
		UIManager:push('HelpPanel',self.name);
	end)
end

function GuildMainPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkGuildRedDotShow, handler(self, self.onShow))
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildNotice, handler(self, self.onShowGuideNotice))

	-- 退出/解散公会
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildDismiss, handler(self, self.retGuildQuitOrDismiss))
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildQuit, handler(self, self.retGuildQuitOrDismiss))
	
end

function GuildMainPanel:retAllGuildList(  )
	-- body
end

function GuildMainPanel:onShowGuideNotice( msg )
	--self.guildMainNotice:setString(msg.notice); 
end

function GuildMainPanel:changeNoticeCallback( changeString )
	model.GuildModel:reqGuildNotice(changeString);
	self.guildMainNotice:setString(changeString); 
end

function GuildMainPanel:onMainMenuCall(sender , event)
	local tag = sender:getTag();
	self:guildMenuClick(tag);
end
function GuildMainPanel:guildMenuClick(baseType)-- (sender , event)
	-- local baseType = sender:getTag();
	if baseType == nil or baseType == -1 then
		return 
	end
	if self:checkClickLock(baseType) then
		return ;
	end

	self.baseType = baseType
	AudioManager:playEffect(Conf.buttonClick);
	if baseType == GuildMenuTag.TAG_MAIN_INFO then
	elseif baseType == GuildMenuTag.TAG_GUILD_SHOP then
		UIManager:push('StorePanel' , Enum:getTable('CommonShopType').GUILD);
	elseif baseType == GuildMenuTag.TAG_GUILD_DONATE then
		UIManager:push('GuildDonatePanel');
	elseif baseType == GuildMenuTag.TAG_GUILD_BOSS then
		UIManager:push('GuildBossPanel');
	elseif baseType == GuildMenuTag.TAG_GUILD_CHAT then
		UIManager:push('GuildChatPanel');
	elseif baseType == GuildMenuTag.TAG_GUILD_SKILL then
		UIManager:push('HomeBaseSkillPanel');
	elseif baseType == GuildMenuTag.TAG_GUILD_NOTICE then
		UIManager:push('GuildeNoticePanel',{
			okCallback = handler(self,self.changeNoticeCallback),
		});
		-- print('=================show notice change=============');
	end
end

function GuildMainPanel:checkClickLock( baseType )

	local locked,lockLv = false , 0;
	
	if baseType == GuildMenuTag.TAG_GUILD_SKILL then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_11)
	end

	if locked then
		Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
	end
	return locked ;
end

function GuildMainPanel:updateLock( baseType )
end

function GuildMainPanel:updateLevelLock( table_start_id )
end

function GuildMainPanel:updateRedDotShow( baseType )
	--刷新红点
	if baseType == nil or baseType == -1 then
		return 
	end
	if baseType == GuildMenuTag.TAG_MAIN_INFO then
		-- donoting
	elseif baseType == GuildMenuTag.TAG_GUILD_SHOP then
		-- donoting
	elseif baseType == GuildMenuTag.TAG_GUILD_DONATE then
		local guildDonateRedDotState = model.GuildModel:getRedDotStateGuildDonate()
		tools.RedDotTools:setRedDotToNode(self.btnNode[baseType],guildDonateRedDotState,nil,cc.p(132,22))
	elseif baseType == GuildMenuTag.TAG_GUILD_BOSS then
		local guildBossRedDotState = model.GuildModel:getNewGuildBossFightState()
		tools.RedDotTools:setRedDotToNode(self.btnNode[baseType],guildBossRedDotState,nil,cc.p(41,70))
	elseif baseType == GuildMenuTag.TAG_GUILD_CHAT then
		-- donoting
	elseif baseType == GuildMenuTag.TAG_GUILD_NOTICE then
		-- donoting
	elseif baseType == GuildMenuTag.TAG_GUILD_SKILL then
		local skillRedDotState = model.HomeModel:getRedDotStateSkill();
		tools.RedDotTools:setRedDotToNode(self.btnNode[baseType],skillRedDotState,nil,cc.p(41,70));
	elseif baseType == GuildMenuTag.TAG_GUILD_MENAGER then
		local menagerRedDotState = model.GuildModel:getRedDotStateGuildApply();
		tools.RedDotTools:setRedDotToNode(self.btnNode[baseType],menagerRedDotState,nil,cc.p(132,32));
	end
end


function GuildMainPanel:onEnter()
	local guildInfo = model.GuildModel:getGuildInfo();

	if not guildInfo then
		return
	end

	self.guildInfoName:setString(tostring(guildInfo.name));	
	self.guildInfoMaster:setString(tostring(guildInfo.master_name));
	self.guildInfoNumber:setString(tostring(guildInfo.gid));	
	self.guildInfoCount:setString(tostring(guildInfo.member_count)..'/'..tostring(guildInfo.member_max));
	
	local curGuildLv = ResTable:getRowData('guild_lv' , guildInfo.level,true);
	local curExp = guildInfo.exp;
	local totalExp = guildInfo.exp;
	if curGuildLv ~= nil then
		if guildInfo.level > 1 then
			local preGuildLv = ResTable:getRowData('guild_lv' , guildInfo.level  - 1);
			if preGuildLv ~= nil then
				totalExp = (curGuildLv['exp'] - preGuildLv['exp']) or curGuildLv['exp'];
				curExp = guildInfo.exp - preGuildLv['exp'];
			end
		else
			totalExp = curGuildLv['exp'];
		end
	end

	local percentage = (curExp or 0)/(totalExp or 1);
	percentage = percentage > 1 and 1 or percentage;
	self.guildInfoLevel:setString('Lv.'..tostring(guildInfo.level)..'('..(math.floor(percentage*100))..'%)');
	
	local width = 534*percentage;
	if width > 0 then
		width = width < 26 and 26 or width
	end
	self.guildInfoProgressBar:setContentSize(cc.size(width,13));

	if cc.FileUtils:getInstance():isFileExist("image/guild/guild_icon/icon_"..guildInfo.icon..".png") then
		self.guildInfoIcon:setTexture( "image/guild/guild_icon/icon_"..guildInfo.icon..".png");
	end

	if guildInfo.guild_flag == 0 then
		--会长显示解散工会
		self.exitBtnLabel:setString(LANG.UI_GUILD_83)
		self.exchageBtn:setVisible(true);
	else
		-- --其他人显示退出工会
		self.exitBtnLabel:setString(LANG.UI_GUILD_82)
		self.exchageBtn:setVisible(false);
	end

	self:onShow();

end

function GuildMainPanel:onShow()

	--levelLock

	-- redDot
	self:updateRedDotShow(GuildMenuTag.TAG_GUILD_DONATE)
	self:updateRedDotShow(GuildMenuTag.TAG_GUILD_BOSS)
	self:updateRedDotShow(GuildMenuTag.TAG_GUILD_SKILL)
	self:updateRedDotShow(GuildMenuTag.TAG_GUILD_MENAGER)

	self:updateVisible();
	self.root:setOpacity(255);
	self.root:setVisible(true);
end

function GuildMainPanel:updateVisible()
	tools.ConfigStateTools:setVisibleByType(Enum:getTable('ConfigStateType').GUILD_MAIN , self.btnNode);
end

function GuildMainPanel:onExchangeIcon(sender , event)
	local iconId = model.GuildModel:getGuildIcon()
	UIManager:push('GuildIconSelectPanel',handler(self,self.iconSelectCallback),iconId);
end

function GuildMainPanel:iconSelectCallback(tag)
	print('======tag === ',tag)
	if tag == 0 then
		return ;
	end
	self.iconResId = tag;
	if self.guildInfoIcon then
		self.guildInfoIcon:setTexture('res/image/guild/guild_icon/icon_'..self.iconResId..'.png')
	end
	if self.iconResId ~= model.GuildModel:getGuildIcon() then
		model.GuildModel:reqGuildIcon(self.iconResId);
	end

end

function GuildMainPanel:onQuitOrDismissCall(sender , event)

	if model.GuildModel:getGuildInfo().guild_flag ~= 0 then
		-- 退出公会
		MessageBox:create(LANG.UI_GUILD_65,MessageBoxType.CANCEL_OK,function (  )
			model.GuildModel:reqGuildQuit();
		end)

		-- Prompt:Show(LANG.ERROR_INFO[9518]);
		-- return;
	else
		-- 解散公会
		MessageBox:create(LANG.UI_GUILD_62,MessageBoxType.CANCEL_OK,function (  )
			model.GuildModel:reqGuildDismiss();
		end)
	end

end

function GuildMainPanel:retGuildQuitOrDismiss(msg)
	self.root:setOpacity(255);
	self.root:runAction(cc.Sequence:create(cc.FadeTo:create(0.2 , 50) , cc.CallFunc:create(function()
		if IsKr then
			UIManager:switch('MainPanel')
		else
			UIManager:switch('HomeBasePanel');
		end
	end)));
	
end

function GuildMainPanel:onLeave()
	self.root:setVisible(false);
end

function GuildMainPanel:onClickBack()
	if IsKr then
		UIManager:switch('MainPanel')
	else
		UIManager:switch('HomeBasePanel');
	end

	-- self.root:setOpacity(255);
	-- self.root:runAction(cc.Sequence:create(cc.FadeTo:create(0.2 , 50) , cc.CallFunc:create(function()
	-- 	UIManager:switch('MainPanel');
	-- end)));
end

return GuildMainPanel;
