local GuildMemberDetailPanel = class("GuildMemberDetailPanel",require('app.layer.BaseLayer'))

local fonts = Enum:getTable('SystemFont')
local MessageBoxType = Enum:getTable('MessageBoxType')

-- 公会成员详情
-- 
function GuildMemberDetailPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildMemberDetailPanel');

	self.useCCreator = false;
	self.isPopup = true;

	-- self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	-- self.showFooter = true;
end

function GuildMemberDetailPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:InitPanels();
	self:registEvent();
end

function GuildMemberDetailPanel:InitPanels()
	
	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,459));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 9);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_ALLIANCE_MEM_1 , 606 , 63);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 270);

	local teamBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	teamBg:addTo(self.root);
	teamBg:setPosition(0 , -15);
    teamBg:setCapInsets(cc.rect(11,11,34,28));
    teamBg:setContentSize(cc.size(560 , 204));

    local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	arrow:addTo(self.root);
    arrow:setPosition(-248,56);
    
	local label = cc.Label:createWithTTF(LANG.UI_L_TEAMINFO , fonts.FONT_SIYUAN , 20);
	label:addTo(self.root);
	label:setAnchorPoint(0 , 0.5);
	label:setPosition(-221 , 56);
	label:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	self.infoNode = template.GuildMemberTemplate:create();
	self.infoNode:addTo(self.root);
	self.infoNode:setPosition(-1,161);

	local bg = cc.Sprite:create('image/guild/main_info/member_team_bg.png');
	bg:addTo(self.root);
	bg:setPosition(0,-38);

	self.teamIcon = {};
	for i = 1 , 4 do
		local bg = cc.Sprite:create('image/commonImg/icon_item_add.png');
		bg:addTo(self.root);
		bg:setPosition(-195 + 130 *(i-1),-38);

		local icon = template.ItemTemplate:create();
		icon:addTo(self.root);
		icon:setPosition(-195 + 130 *(i-1),-38);
		self.teamIcon[i] = icon;
	end

	local btnImg = {
		'image/commonImg/btn_8_169_55.png',
		'image/commonImg/btn_8_169_55.png',
		'image/commonImg/btn_1_169_55.png',
		'image/commonImg/btn_1_169_55.png'
	}
	local btnOutline = {
		cc.c4b(140 , 50 , 50 , 255),
		cc.c4b(140 , 50 , 50 , 255),
		cc.c4b(50 , 85 , 150 , 255),
		cc.c4b(50 , 85 , 150 , 255),
	}
	self.btns = {};
	for i = 1 , 4 do
		local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20);
		label:enableOutline(btnOutline[i] , 2);

		self.btns[i] = ccui.Button:create(btnImg[i] , btnImg[i]);
		self.btns[i]:addTo(self.root);
		self.btns[i]:setPosition(0 , -168);
		self.btns[i]:addClickEventListener(handler(self , self.onBtnClick));
		self.btns[i]:setTitleLabel(label);
	end
end

function GuildMemberDetailPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkGuildRetMemberTeam, handler(self, self.retMemberTeam))
end

function GuildMemberDetailPanel:onBtnClick( sender,event )
	local tag = sender:getTag();
	print('tag === ',tag);

	if tag == 1 then		-- 免职
		self:memberDetailSendDownBtnClick();
	elseif tag == 2 then 	-- 升职
		self:memberDetailSendUpBtnClick();
	elseif tag == 3 then 	-- 解散公会
		self:memberDetailDismissBtnClick();
	elseif tag == 4 then 	-- 退出公会
		self:memberDetailQuitBtnClick();
	elseif tag == 5 then 	-- 开出公会
		self:memberDetailFireBtnClick();
	elseif tag == 6 then 	-- 转让会长
		self:memberTransferBtnClick();
	elseif tag == 7 then
		self:memberImpeachBtnClick();
	else
		self:onClickBack();
	end

end

function GuildMemberDetailPanel:memberImpeachBtnClick()
	local guildInfo = model.GuildModel:getGuildInfo();
	local myGuildFlag = guildInfo.guild_flag;
	if myGuildFlag == 0 then
		return;
	end

	local member =  model.GuildModel:getGuildMemberByUid(self.memberDetailUid);
	local loginTime = os.date("*t",member.login)
	local zeroLoginTime = os.time({day=loginTime.day, month=loginTime.month, year=loginTime.year, hour=0, min=0, sec=0});
	local curTime = TimeManager:getCurTime();
	local loginOutDayNum = math.floor((curTime - zeroLoginTime)/86400);

	if loginOutDayNum < 7 then
		return;
	end


	if myGuildFlag == 2 and loginOutDayNum < 10 then
		Prompt:Show(LANG.UI_GUILD_126);
		return
	end

	MessageBox:create(LANG.UI_GUILD_124,MessageBoxType.CANCEL_OK,function (  )
		model.GuildModel:reqGuildImpeach();
		self:onClickBack();
	end)
end

function GuildMemberDetailPanel:memberTransferBtnClick()
	if model.GuildModel:getGuildInfo().guild_flag ~= 0 then
		return;
	end
	if self.memberDetailUid == model.UserModel:getUserUid() then
		return;
	end
 	local member =  model.GuildModel:getGuildMemberByUid(self.memberDetailUid);
	local msg = string.format(LANG.UI_GUILD_120,tostring(member.name));
	MessageBox:create(msg,MessageBoxType.CANCEL_OK,function (  )
		model.GuildModel:reqGuildTransfer(self.memberDetailUid);
		self:onClickBack();
	end)
end
--退出公会
function GuildMemberDetailPanel:memberDetailQuitBtnClick(sender , event)
	MessageBox:create(LANG.UI_GUILD_65,MessageBoxType.CANCEL_OK,function (  )
		model.GuildModel:reqGuildQuit();
		self:onClickBack();
	end)
end
--开出公会
function GuildMemberDetailPanel:memberDetailFireBtnClick(sender , event)
	if model.GuildModel:getGuildInfo().guild_flag > 1 then
		Prompt:Show(LANG.ERROR_INFO[9518]);
		return;
	end
	if  self.memberDetailUid == model.UserModel:getUserUid() then
		return;
	end
	MessageBox:create(LANG.UI_GUILD_64,MessageBoxType.CANCEL_OK,function (  )
		model.GuildModel:reqGuildFired( self.memberDetailUid);
		self:onClickBack();
	end)
end
--解散公会
function GuildMemberDetailPanel:memberDetailDismissBtnClick(sender , event)
	if model.GuildModel:getGuildInfo().guild_flag ~= 0 then
		Prompt:Show(LANG.ERROR_INFO[9518]);
		return;
	end
	MessageBox:create(LANG.UI_GUILD_62,MessageBoxType.CANCEL_OK,function (  )
		model.GuildModel:reqGuildDismiss();
		self:onClickBack();
	end)
end
--免职
function GuildMemberDetailPanel:memberDetailSendDownBtnClick(sender , event)
	if model.GuildModel:getGuildInfo().guild_flag ~= 0 then
		Prompt:Show(LANG.ERROR_INFO[9518]);
		return;
	end

	if  self.memberDetailUid == model.UserModel:getUserUid() then
		return;
	end
	MessageBox:create(LANG.UI_GUILD_63,MessageBoxType.CANCEL_OK,function (  )
		model.GuildModel:reqGuildDepose( self.memberDetailUid);
		self:onClickBack();
	end)
end
--委任-升职
function GuildMemberDetailPanel:memberDetailSendUpBtnClick()
	if model.GuildModel:getGuildInfo().guild_flag ~= 0 then
		Prompt:Show(LANG.ERROR_INFO[9518]);
		return;
	end
	local curUid = model.UserModel:getUserUid();
	if self.memberDetailUid == curUid then
		return;
	end
	MessageBox:create(LANG.UI_GUILD_66,MessageBoxType.CANCEL_OK,function (  )
		model.GuildModel:reqGuildAppoint( self.memberDetailUid);
		self:onClickBack();
	end)
end
--公会成员信息界面
function GuildMemberDetailPanel:onShowMemberDetailPanel(index,uid)

	local member = nil ;
	--公会成员信息
	if index == 2 then
		member =  model.GuildModel:getGuildMemberByUid(uid);
	else
		member = model.GuildModel:getApplyByUid(uid);
	end
	-- dump(member,' onShowMemberDetailPanel = ');
	if not member then
		return
	end

	self.infoNode:initData(member,1)

	--[[
	if member.guild_flag == nil or  member.guild_flag > 1 then
		self.managerIcon:setVisible(false);
		self.level:setPositionX(240);
	else
		self.level:setPositionX(191);
		self.managerIcon:setVisible(true);
		self.managerIcon:setTexture('image/guild/main_info/'..(member.guild_flag == 0 and 'manager_icon_1' or 'manager_icon_2')..'.png');
	end

	if member.head_icon == nil or member.head_icon == 0 then
		member.head_icon = 1
	end
	local headIconFile = GlobalFunctions:getHeadIconFile(member.head_icon)
	self.icon:setTexture(headIconFile);

	self.name:setString(tostring(member.name));			
	self.level:setString("LV "..tostring(member.level));
	self.fp:setString(tostring(member.top_power))	 
 
	local guildInfo = model.GuildModel:getGuildInfo();
	local myGuildFlag = guildInfo.guild_flag;

	local myUid = model.UserModel:getUserUid();

	if myUid == uid then
		self.headOnlineSp:setVisible(true);
	else
		local loginTime = member.login or 0;
		local loginTimeStr = GlobalFunctions:convertTimeEnumType(loginTime);
		self.headOnlineSp:setVisible(loginTimeStr == Enum:getTable('TimeEnum').TimeEnumNow);
	end
	]]
	local guildInfo = model.GuildModel:getGuildInfo();
	local myGuildFlag = guildInfo.guild_flag;
	local myUid = model.UserModel:getUserUid();
	if index == 2 then --工会成员信息
		local btnState = {};
		if myUid == uid then
			if myGuildFlag == 0 then -- 解散公会
				btnState[2] = {LANG.UI_GUILD_83,3};
			else	-- 退出
				btnState[2] = {LANG.UI_GUILD_82,4};
			end
		else
			if myGuildFlag == 0 then--会长
				btnState[2] = {LANG.UI_GUILD_84,5};--开除公会
				if member.guild_flag == 1 then --管理
					btnState[2] = {LANG.UI_GUILD_91,1};--免职
					btnState[4] = {LANG.UI_GUILD_119,6};--转让
				elseif member.guild_flag > 1 then
					btnState[3] = {LANG.UI_GUILD_90,2};--委任
				end
			elseif myGuildFlag == 1 then
				if member.guild_flag == 0 then
					local loginTime = os.date("*t",member.login)
					local zeroLoginTime = os.time({day=loginTime.day, month=loginTime.month, year=loginTime.year, hour=0, min=0, sec=0});
					local curTime = TimeManager:getCurTime();
					local loginOutDayNum = math.floor((curTime - zeroLoginTime)/86400);
					if loginOutDayNum >= 7 then
						btnState[1] = {LANG.UI_GUILD_123,7};
					else
						btnState[3] = {LANG.COMMON_OK,0};--确定
					end
				elseif member.guild_flag > 1 then --成员
					btnState[2] = {LANG.UI_GUILD_84,5};--开除公会
				else
					btnState[3] = {LANG.COMMON_OK,0};--确定
				end
			else
				if member.guild_flag == 0 then
					local loginTime = os.date("*t",member.login)
					local zeroLoginTime = os.time({day=loginTime.day, month=loginTime.month, year=loginTime.year, hour=0, min=0, sec=0});
					local curTime = TimeManager:getCurTime();
					local loginOutDayNum = math.floor((curTime - zeroLoginTime)/86400);
					if loginOutDayNum >= 7 then
						btnState[1] = {LANG.UI_GUILD_123,7};
					else
						btnState[3] = {LANG.COMMON_OK,0};--确定
					end
				else
					btnState[3] = {LANG.COMMON_OK,0};--确定
				end
			end
		end

		local count = 0;
		for i = 1 , 4 do
			if btnState[i] then
				self.btns[i]:setVisible(true);
				self.btns[i]:setTag(btnState[i][2]);
				self.btns[i]:getTitleLabel():setString(btnState[i][1]);
				--self.btns[i]:setTitleText(btnState[i][1]);
				count = count + 1;
			else
				self.btns[i]:setVisible(false);
			end
		end
	
		local startPosX = -184 * (count-1)/2;
		local index = 1;
		for i = 1 , 4 do
			if btnState[i] then
				self.btns[i]:setPositionX(startPosX + 184 * (index - 1));
				index = index + 1;
			end
		end

		if not member.teamInfo then
			local msg = {};
			msg.memberUid = uid
			Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_member_team_t , msg);
		else
			self:updateTeam(uid);
		end
	end
	self.memberDetailUid = uid;

	self.root:setVisible(true);
end

function GuildMemberDetailPanel:updateTeam(uid)
	local member = model.GuildModel:getGuildMemberByUid(uid);
	if member and member.teamInfo then
		for i = 1, 4 do
			local team = member.teamInfo[i];
			if team then
				self.teamIcon[i]:setVisible(true);
				self.teamIcon[i]:Init(ROLE_TYPE,team.no,team.star_lv,team.level);
			else
				self.teamIcon[i]:setVisible(false);
			end
		end
	end
end

function GuildMemberDetailPanel:retMemberTeam(uid)
	self:updateTeam(uid);
end

function GuildMemberDetailPanel:onEnter( uid,index)
	self:addSwallowCallback(handler(self, self.onClickBack));
	self:onShowMemberDetailPanel(index,uid);
	self.root:setVisible(true);

end

function GuildMemberDetailPanel:onShow()

end

function GuildMemberDetailPanel:onLeave()
	self.root:setVisible(false);
end

function GuildMemberDetailPanel:onClickBack()
	UIManager:pop('GuildMemberDetailPanel');
end

return GuildMemberDetailPanel;
