local GuildMemberPanel = class("GuildMemberPanel",require('app.layer.BaseLayer'))

local fonts = Enum:getTable('SystemFont')
local MessageBoxType = Enum:getTable('MessageBoxType')
local imagePath = 'image/guild/main_info/'

function GuildMemberPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildMemberPanel');

	self.useCCreator = false;
	self.isPopup = false;
	self.haveSwallowLayer = false;

	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function GuildMemberPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:InitPanels();
	self:registEvent();
end

function GuildMemberPanel:InitPanels()

	local bg = cc.Sprite:create('image/bg/Bg_5.png')
		:addTo(self.root)

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.root);
	bg:setPosition(0 , -28);
	bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(606 , 824));

	local titleNode = GlobalFunctions:createTitle('title',606,46,nil);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 407);

	self.infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	self.infoBg:addTo(self.root);
    self.infoBg:setCapInsets(cc.rect(11,11,34,28));
	self.infoBg:setContentSize(cc.size(576 , 786));
	self.infoBg:setPosition(0 , 42);

	self.title = titleNode:getChildByName('title');

	local btnNode = cc.Node:create();
	btnNode:addTo(self.root);
	btnNode:setPosition(cc.p(0,StageSize.height/2 - 92 - NOTCH_HEIGHT));
	btnNode:setLocalZOrder(10)

	self.guildInfoBtnList = {};
	local nameStr = {LANG.UI_GUILD_72,LANG.UI_GUILD_80,LANG.UI_GUILD_8} --成员，信息，申请
	for i = 1 , 3 do
		local btnLabel = cc.Label:createWithTTF(nameStr[i], fonts.FONT_SIYUAN, 20)
			:enableOutline(cc.c4b(125 , 125 , 125 , 255) , 2)
		self.guildInfoBtnList[i] = ccui.Button:create('image/commonImg/btn_5_132_45.png' , 'image/commonImg/btn_5_132_45.png')
		self.guildInfoBtnList[i]:setPosition(cc.p(244 - 150*(i-1),0))
			:setTag(i)
			:addTo(btnNode)
			:setTitleLabel(btnLabel)
			:addClickEventListener(handler(self , self.guildInfoBtnClick));
	end
	self.guildInfoBtnList[2]:setVisible(false);

	self:initMemberPanel();
	self:initApplyPanel();
	self:initLogPanel();

end

function GuildMemberPanel:initMemberPanel(  )
	-- body
	self.guildInfoMemberPanel = cc.Node:create();
	self.guildInfoMemberPanel:addTo(self.root);

	local initData = {
		width = 582,
		height = 640,
		cellWidth = 582,
		cellHeight = 132,
		cellReloadFunc = handler(self,self.reloadCellCreateMemberList),
	}
	self.guildInfoMemberListView = template.TableViewTemplate:create()
	self.guildInfoMemberListView:initWithSizeAndItem(initData) ;
	self.guildInfoMemberListView:getView():setPosition(cc.p(-291,-418)); -- 0,-98
	self.guildInfoMemberPanel:addChild(self.guildInfoMemberListView:getView())
	
	self.guildInfoMemberMyself = template.GuildMemberTemplate:create();
	self.guildInfoMemberMyself:addTo(self.guildInfoMemberPanel)
	self.guildInfoMemberMyself:setPosition(cc.p(0,299))

end

function GuildMemberPanel:initApplyPanel(  )
	-- body
	self.guildInfoApplyPanel = cc.Node:create();
	self.guildInfoApplyPanel:addTo(self.root)

	local initData = {
		width = 582,
		height = 710,
		cellWidth = 582,
		cellHeight = 176,
		cellReloadFunc = handler(self,self.reloadCellCreateApplyList),
	}
	self.guildInfoApplyListView = template.TableViewTemplate:create()
	self.guildInfoApplyListView:initWithSizeAndItem(initData);
	self.guildInfoApplyListView:getView():setPosition(cc.p(-291,-350)); -- 0,42
	self.guildInfoApplyPanel:addChild(self.guildInfoApplyListView:getView())

	local label1 = cc.Label:createWithTTF(LANG.UI_GUILD_73, fonts.FONT_SIYUAN, 20)
	:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2)
	self.guildInfoPassAll = ccui.Button:create('image/commonImg/btn_1_219_55.png','image/commonImg/btn_1_219_55.png');
	self.guildInfoPassAll:setPosition(126,-396);
	self.guildInfoPassAll:setTitleLabel(label1);
	self.guildInfoPassAll:addClickEventListener(handler(self, self.guildInfoPassAllClick));
	self.guildInfoPassAll:addTo(self.guildInfoApplyPanel);

	local label2 = cc.Label:createWithTTF(LANG.UI_GUILD_74, fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	self.guildInfoIgnoreAll = ccui.Button:create('image/commonImg/btn_1_219_55_2.png','image/commonImg/btn_1_219_55_2.png');
	self.guildInfoIgnoreAll:setPosition(-126,-396);
	self.guildInfoIgnoreAll:setTitleLabel(label2);
	self.guildInfoIgnoreAll:addClickEventListener(handler(self, self.guildInfoIgnoreAllClick));
	self.guildInfoIgnoreAll:addTo(self.guildInfoApplyPanel);

	local label = cc.Label:createWithTTF(LANG.UI_GUILD_112,fonts.FONT_SIYUAN,15);
	label:addTo(self.guildInfoApplyPanel);
	label:setAnchorPoint(1,0.5);
	label:setPosition(225,398)
	label:setTextColor(cc.c3b(150,150,150,255))

	local auditBtn = ccui.Button:create('image/guild/main_info/member_apply_bg_1.png','image/guild/main_info/member_apply_bg_1.png');
	auditBtn:addTo(self.guildInfoApplyPanel);
	auditBtn:setPosition(259,397);
	auditBtn:addClickEventListener(function()
		model.GuildModel:reqGuildSetAuditState()
	end);

	self.needAuditState = cc.Sprite:create('image/guild/main_info/member_apply_bg_3.png');
	self.needAuditState:addTo(self.guildInfoApplyPanel);
	self.needAuditState:setPosition(247,398);
	self.needAuditState:setVisible(false);

	self.notAuditState = cc.Sprite:create('image/guild/main_info/member_apply_bg_2.png');
	self.notAuditState:addTo(self.guildInfoApplyPanel);
	self.notAuditState:setPosition(271,398);
end

function GuildMemberPanel:initLogPanel()
	self.guildLogPanel = cc.Node:create();
	self.guildLogPanel:addTo(self.root)

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.guildLogPanel);
	bg:setPosition(0 , -32);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(582 , 787));

	self.guildLogListView = ccui.ListView:create();
	self.guildLogListView:addTo(self.guildLogPanel);
	self.guildLogListView:ignoreContentAdaptWithSize(false);
	self.guildLogListView:setAnchorPoint(0.5,0.5);
	self.guildLogListView:setBounceEnabled(true);
	self.guildLogListView:setDirection(ccui.ScrollViewDir.vertical);
	self.guildLogListView:setContentSize(cc.size(582,776));
	self.guildLogListView:setPosition(cc.p(0, -32));
	self.guildLogListView:setScrollBarEnabled(false);

end

function GuildMemberPanel:registEvent()
	-- 开出公会
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildFired, handler(self, self.retGuildFired))

	-- 通过/拒绝 公会申请
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildApply, handler(self, self.retGuildApply))
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildNotApply, handler(self, self.retGuildNotApply))
	-- 降职/升值
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildAppoint, handler(self, self.retGuildAppoint))
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildDepose, handler(self, self.retGuildDepose))
	-- 返回成员信息
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildMember, handler(self, self.retGuildMember))
	-- 返回申请信息
	EventManager:RegisterEvent(EventType.NetworkGuildRetApplyList, handler(self, self.retApplyList))
	EventManager:RegisterEvent(EventType.NetworkGuildRetSetAudit, handler(self, self.updateAuditState))
	EventManager:RegisterEvent(EventType.NetworkGuildUpdateMemberList, handler(self, self.updateMemberList))
end

function GuildMemberPanel:updateAuditState()
	local auditState = model.GuildModel:getGuildAuditState();
	self.needAuditState:setVisible(auditState == 0)
	self.notAuditState:setVisible(auditState ~= 0)
end

function GuildMemberPanel:showGuildMemberPanel(  )

	self.title:setString(LANG.UI_GUILD_87)
	self.infoBg:setContentSize(cc.size(582 , 651));
	self.infoBg:setPosition(0 , -98);

	-- body
	self.guildMemberList = {};

	local listData = model.GuildModel:getGuildMember();
	
	self.guildInfoMemberListView:reloadData(listData);

	local myUid = model.UserModel:getUserUid();
	local member =  model.GuildModel:getGuildMemberByUid(myUid);
	self.guildInfoMemberMyself:initData(member,1);
end

function GuildMemberPanel:showGuildApplyPanel( index )

	self.title:setString(LANG.UI_GUILD_15..LANG.UI_GUILD_8)
	self.infoBg:setContentSize(cc.size(582 , 721));
	self.infoBg:setPosition(0 , 5);

	local listData = model.GuildModel:getApplyList();
	self.guildMemberApplyList = {};
	
	self.guildInfoApplyListView:reloadData(listData);

	self.guildInfoPassAll:setVisible(#listData>0);
	self.guildInfoIgnoreAll:setVisible(#listData >0);

	self:updateAuditState();
end

function GuildMemberPanel:showGuildLogPanel()

	self.title:setString(LANG.UI_GUILD_15..LANG.UI_GUILD_80)
	self.infoBg:setContentSize(cc.size(582 , 787));
	self.infoBg:setPosition(0 , -32);

	local guildSysMess = model.GuildModel:getGuildSysMess();

	if guildSysMess ~= nil then
		self.guildLogListView:removeAllChildren(true);
		for _k , sysMessage in pairs(guildSysMess) do
			local listItemLayout = ccui.Layout:create();
			listItemLayout:setContentSize(cc.size(582 , 56));

			local itemNode = self:createInfoLogItem(sysMessage);
			if itemNode then
				itemNode:addTo(listItemLayout);
				itemNode:setPosition(cc.p(291,28));
			end

    		self.guildLogListView:pushBackCustomItem(listItemLayout);
    	end
	end
end

function GuildMemberPanel:createInfoLogItem( sysMessage )
	local itemNode = cc.Node:create();
	local bg = cc.Sprite:create('image/guild/guild_log/log_bg.png');
	bg:addTo(itemNode);
	--1：加入公会，2：退出公会/开除公会，3：公会升级,4 提升管理权限 5 移除管理权限 6 捐献 xxx钻石,7 击杀 x级boss

	-- if sysMessage.type == 3 then 
	-- 	--工会升到了 %s 级
	-- 	local lv = tonumber(sysMessage.name);
	-- 	local name = cc.Label:createWithTTF(tostring(lv) , fonts.FONT_SIYUAN , 20);
	-- 	name:addTo(itemNode);
	-- 	name:setAnchorPoint(cc.p(0.5,0.5));
	-- 	name:setPosition(cc.p(38,0));

	-- 	local notice =  cc.Label:createWithTTF(LANG.UI_GUILD_SYSTEM_NOTICE_TYPE[sysMessage.type] , fonts.FONT_SIYUAN , 20);
	-- 	notice:addTo(itemNode);
	-- 	notice:setAnchorPoint(cc.p(0.5,0.5));
	-- 	notice:setPosition(cc.p(5,0));
	-- 	notice:setTextColor(cc.c4b(60 , 60 , 60 , 255));
	-- else

	local name = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	name:addTo(itemNode);
	name:setTextColor(cc.c3b(255,255,0))

	if sysMessage.type ~= 3 then
		name:setString('['..sysMessage.name..']');
	end

	local notice =  cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	notice:addTo(itemNode);
	if sysMessage.type == 3 or sysMessage.type == 6 or sysMessage.type == 7 then 
		
		local str = '';
		if sysMessage.type == 6 and type(sysMessage.info) == 'table' then
			local  costType = sysMessage.info[1];
			local  costNum = sysMessage.info[2] or 0;
			local itemName = ResTable:getValue('item' , costType , 'name');
			itemName = itemName or '';
			str = string.format(LANG.UI_GUILD_105,costNum,itemName);
		else
			str = string.format( LANG.UI_GUILD_SYSTEM_NOTICE_TYPE[sysMessage.type],sysMessage.info );
		end
		
		
		notice:setString(str);
	else
		notice:setString(LANG.UI_GUILD_SYSTEM_NOTICE_TYPE[sysMessage.type]);
	end

	local width = name:getContentSize().width+5;
	local noticWidth = notice:getContentSize().width+5;
	local posX = -noticWidth/2;

	name:setPosition(posX , 0);
	notice:setPosition(posX+width/2+noticWidth/2 , 0);

	return itemNode;
	
end

function GuildMemberPanel:reloadCellCreateMemberList( cell,index )
	local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
		cellNode = template.GuildMemberTemplate:create();
		cellNode:setTag(999);
		cellNode:addTo(cell);
		cellNode:setPosition(cc.p(291,66));
	end
	local listData = model.GuildModel:getGuildMember();

	local itemData = listData[tostring(index+1)] or listData[index + 1 ] ;-- 
	cell:setTag(itemData.uid);
	cellNode:initData(itemData,2);
	self.guildMemberList[itemData.uid] = cellNode;

end

function GuildMemberPanel:reloadCellCreateApplyList( cell,index )
	local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
		cellNode = template.GuildMemberTemplate:create();
		cellNode:setTag(999);
		cellNode:addTo(cell);
		cellNode:setPosition(cc.p(291,88));
	end
	local listData = model.GuildModel:getApplyList();

	local itemData = listData[tostring(index+1)] or listData[index + 1 ] ;-- 
	cell:setTag(itemData.uid);
	cellNode:initData(itemData,3);
	self.guildMemberApplyList[itemData.uid] = cellNode;

end

function GuildMemberPanel:retGuildFired(msg)
	self:showGuildMemberPanel()
end
-- 升职
function GuildMemberPanel:retGuildDepose(msg)
	if msg == nil or msg.uid == nil then
		return
	end
	if self.guildMemberList ~= nil and self.guildMemberList[msg.uid] ~= nil then
		self.guildMemberList[msg.uid]:setManager(2);
	end
end
-- 降职
function GuildMemberPanel:retGuildAppoint(msg)
	if msg == nil or msg.uid == nil then
		return
	end
	if self.guildMemberList ~= nil and self.guildMemberList[msg.uid] ~= nil then
		self.guildMemberList[msg.uid]:setManager(1);
	end
end

function GuildMemberPanel:retGuildMember(msg)
	self:showGuildMemberPanel()
end

function GuildMemberPanel:retApplyList(msg)
	self:showGuildApplyPanel();
end

--通过申请
function GuildMemberPanel:retGuildApply(msg)
	self:showGuildApplyPanel();
end
-- 拒绝申请
function GuildMemberPanel:retGuildNotApply(msg)
	self:showGuildApplyPanel();
end
--所有通过
function GuildMemberPanel:guildInfoPassAllClick(sender , event)
	if model.GuildModel:getGuildInfo().guild_flag > 1 then
		Prompt:Show(LANG.ERROR_INFO[9518]);
		return;
	end
	local applyData = model.GuildModel:getApplyList();
	if not applyData then
		return;
	end
	local uidList = {};
	for _k , apply in pairs(applyData) do
		table.insert(uidList , apply.uid);
	end
	model.GuildModel:reqGuildApply(uidList);
end
--所有忽略
function GuildMemberPanel:guildInfoIgnoreAllClick(sender , event)
	if model.GuildModel:getGuildInfo().guild_flag > 1 then
		Prompt:Show(LANG.ERROR_INFO[9518]);
		return;
	end
	local applyData = model.GuildModel:getApplyList();

	if not applyData then
		return;
	end
	local uidList = {};
	for _k , apply in pairs(applyData) do
		table.insert(uidList , apply.uid);
	end
	model.GuildModel:reqGuildNotApply(uidList);
end

function GuildMemberPanel:updateMemberList()
	model.GuildModel:reqGuildMember();
end

--公会信息切换
function GuildMemberPanel:guildInfoBtnClick(sender , event)
	local index = sender:getTag();
	if index == 3 and model.GuildModel:getGuildInfo().guild_flag > 1 then --只有会长和管理才能看到申请
		Prompt:Show(LANG.UI_GUILD_100);
		return;
	end
	self:guildHallMenuChange(index);
end

function GuildMemberPanel:guildHallMenuChange(index)

	if self.selectIndex == index then
		return 
	end
	self.selectIndex = index;

	self.guildInfoMemberPanel:setVisible(index == 1)
	self.guildLogPanel:setVisible(index == 2)
	self.guildInfoApplyPanel:setVisible(index == 3)

	self:updateBtnPos();
	self:updateRedDot();

	if index == 1 then
		model.GuildModel:reqGuildMember();
	elseif index == 2 then
		self:showGuildLogPanel()
	elseif index == 3 then
		model.GuildModel:reqApplyList();
	end

end

function GuildMemberPanel:updateBtnPos(  )
	local pos = cc.p(244,0) -- - 150*(i-1)
	self.guildInfoBtnList[self.selectIndex]:setVisible(false);

	if self.selectIndex ~= 1 then
		self.guildInfoBtnList[1]:setVisible(true);
		self.guildInfoBtnList[1]:setPosition(pos);
		pos.x = pos.x - 150;
	end

	if self.selectIndex ~= 2 then
		self.guildInfoBtnList[2]:setVisible(true);
		self.guildInfoBtnList[2]:setPosition(pos);
		pos.x = pos.x - 150;
	end

	if self.selectIndex ~= 3 and model.GuildModel:getGuildInfo().guild_flag <= 1 then
		self.guildInfoBtnList[3]:setVisible(true);
		self.guildInfoBtnList[3]:setPosition(pos);
	else
		self.guildInfoBtnList[3]:setVisible(false);
	end
end

function GuildMemberPanel:onEnter()

	self.selectIndex = -1;
	self:guildHallMenuChange(1);
	
	self.root:setOpacity(255);
	self.root:setVisible(true)
end

function GuildMemberPanel:updateRedDot()
	local menagerRedDotState = model.GuildModel:getRedDotStateGuildApply();
	tools.RedDotTools:setRedDotToNode(self.guildInfoBtnList[3],menagerRedDotState,nil,cc.p(122,35));
end

function GuildMemberPanel:onLeave()
	self.root:setVisible(false);
end

function GuildMemberPanel:onClickBack()
	if IsKr then
		UIManager:switch('GuildPanel');
	else
		UIManager:pop('GuildMemberPanel')
	end
end

return GuildMemberPanel;
