local GuildNotJoinPanel = class("GuildNotJoinPanel",require('app.layer.BaseLayer'))

local FightType = Enum:getTable('FightType');
local fonts = Enum:getTable('SystemFont')
local MessageBoxType = Enum:getTable('MessageBoxType')
local imagePath = 'image/guild/not_join/'

-- 未加入公会页面

function GuildNotJoinPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildNotJoinPanel');

	self.useCCreator = false;
	self.isPopup = false;
	self.haveSwallowLayer = false;
	if IsKr then
		self.showHeaderType = Enum:getTable('HeaderType').HEAD_ICON;
	else
		self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	end
	self.showFooter = true;
end

function GuildNotJoinPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:InitPanels();
	self:registEvent();
end

function GuildNotJoinPanel:InitPanels()
	
	self.doNotJoinPanel = self.root;

	local bg = cc.Sprite:create('image/bg/Bg_9.png')
		:addTo(self.doNotJoinPanel)

	local topBg = cc.Scale9Sprite:create('image/commonImg/time_bg_1.png')
		:addTo(self.doNotJoinPanel)
		:setCapInsets(cc.rect(0,6,483,19))
		:setContentSize(cc.size(483 , 38))
		:setPosition(0 , 463)

	local topLabel = cc.Label:createWithTTF(LANG.UI_GUILD_115,  fonts.FONT_SIYUAN , 18)
		:addTo(self.doNotJoinPanel)
		:setPosition(0,463)
		:setTextColor(cc.c3b(255,255,0))

	local createNode = cc.Node:create()
		:addTo(self.doNotJoinPanel)
		:setPosition(-147,287)

	self.createGuildBtn = ccui.Button:create(imagePath..'not_join_btn_1.png',imagePath..'not_join_btn_1.png');
	self.createGuildBtn:addTo(createNode);
	self.createGuildBtn:addClickEventListener(handler(self , self.createGuildBtnClick));	

	local createLabel = cc.Label:createWithTTF(LANG.UI_GUILD_13 ,  fonts.FONT_SIYUAN , 28)
    :addTo(createNode)
	:setPosition(42 , 5)
	
	local createIcon = cc.Sprite:create(imagePath..'not_join_bg_1.png')
		:addTo(createNode)
		:setPosition(-82,0)
	
	local searchNode = cc.Node:create()
		:addTo(self.doNotJoinPanel)
		:setPosition(-147,159)

	self.searchGuildBtn = ccui.Button:create(imagePath..'not_join_btn_1.png',imagePath..'not_join_btn_1.png');
	self.searchGuildBtn:addTo(searchNode);
	self.searchGuildBtn:addClickEventListener(handler(self , self.searchGuildBtnClick));	

	local searchLabel = cc.Label:createWithTTF(LANG.UI_GUILD_116 ,  fonts.FONT_SIYUAN , 28)
    :addTo(searchNode)
	:setPosition(42 , 5)
	
	local searchIcon = cc.Sprite:create(imagePath..'not_join_bg_2.png')
		:addTo(searchNode)
		:setPosition(-82,0)

	local joinNode = cc.Node:create()
		:addTo(self.doNotJoinPanel)
		:setPosition(-145,-151)
	local joinBg = cc.Sprite:create(imagePath..'not_join_bg_3.png')
		:addTo(joinNode)

	local joinBg = cc.Sprite:create(imagePath..'not_join_bg_4.png')
		:addTo(joinNode)
		:setPosition(-1,-28)
	
	local joinTitle = cc.Label:createWithTTF(LANG.UI_GUILD_117 ,  fonts.FONT_SIYUAN , 26)
		:addTo(joinNode)
		:setPosition(0 , 192)

	local initData = {
		width = 270,
		height = 362,
		cellWidth = 270,
		cellHeight = 83,
		cellReloadFunc = handler(self,self.reloadCellCreate),
	}
	self.joinGuildListView = template.TableViewTemplate:create()
	self.joinGuildListView:initWithSizeAndItem(initData);
	self.joinGuildListView:getView():setPosition(cc.p(-136,-209)); -- -1,-28
	joinNode:addChild(self.joinGuildListView:getView())

	local refreshGuildBtn = ccui.Button:create(imagePath..'not_join_bg_6.png',imagePath..'not_join_bg_6.png');
	refreshGuildBtn:addTo(joinNode);
	refreshGuildBtn:setPosition(104,192);
	refreshGuildBtn:addClickEventListener(function()
		model.GuildModel:reqAllGuildJoinList();
	end);

	self.doNotJoinPanel:setVisible(false);
end

function GuildNotJoinPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkGuildRetAllGuildList, handler(self, self.retAllGuildList))
	EventManager:RegisterEvent(EventType.NetworkGuildRetJoinGuild, handler(self, self.retJoinGuild))
end

--刷新公会列表
function GuildNotJoinPanel:retAllGuildList()
	local guildList = model.GuildModel:getAllGuildData();
	self.joinAllGuildList = guildList or {};
	self.joinList = {};
	if #self.joinAllGuildList>0 then
		self.joinGuildListView:getView():setVisible(true);
		self.joinGuildListView:reloadData(self.joinAllGuildList);
	else
		self.joinGuildListView:getView():setVisible(false);
	end
end

function GuildNotJoinPanel:reloadCellCreate(cell,index)
	local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
		cellNode = template.GuildJoinItemTemplate:create();
		cellNode:setTag(999);
		cellNode:addTo(cell);
		cellNode:setPosition(cc.p(135,41.5));
	end
	local guildList = self.joinAllGuildList;

	local itemData = guildList[tostring(index+1)] or guildList[index + 1 ] ;-- 
	cell:setTag(itemData.gid);
	cellNode:initData(itemData);
	self.joinList[itemData.gid] = cellNode;
end

--申请加入公会返回
function GuildNotJoinPanel:retJoinGuild(msg)
	if self.joinList[msg.gid] then
		self.joinList[msg.gid]:setApplyJoin(true);
	end
end

--去创建公会
function GuildNotJoinPanel:createGuildBtnClick(sender , event)
	UIManager:push('GuildCreatePanel');
end

--加入公会列表
function GuildNotJoinPanel:searchGuildBtnClick(sender , event)
	UIManager:push('GuildSearchPanel');
end

function GuildNotJoinPanel:onEnter()
	model.GuildModel:reqAllGuildJoinList(0);
	--self:updateVisible();
	self.doNotJoinPanel:setVisible(true);
end

function GuildNotJoinPanel:onShow()

end

function GuildNotJoinPanel:updateVisible()
	local visible = tools.ConfigStateTools:checkVisibleByName('GuildCreatePanel');
	self.createGuildBtn:setVisible(visible);
	visible = tools.ConfigStateTools:checkVisibleByName('GuildSearchPanel');
	self.joinGuildBtn:setVisible(visible);
end

function GuildNotJoinPanel:onLeave()
	self.root:setVisible(false);
end

function GuildNotJoinPanel:onClickBack()
	self.doNotJoinPanel:setVisible(false);
	if IsKr then
		UIManager:switch('MainPanel');
	else
		UIManager:switch('HomeBasePanel');
	end

	-- self.root:setOpacity(255);
	-- self.root:runAction(cc.Sequence:create(cc.FadeTo:create(0.2 , 50) , cc.CallFunc:create(function()
	-- 	UIManager:switch('MainPanel');
	-- end)));
end

return GuildNotJoinPanel;
