local GuildPanel = class("GuildPanel",require('app.layer.BaseLayer'))

-- 公会主入口类
function GuildPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildCreatePanel');

	self.useCCreator = false;
	self.isPopup = false;
	self.haveSwallowLayer = false;
	if IsKr then
		self.showHeaderType = Enum:getTable('HeaderType').HEAD_ICON;
		self.showFooter = true;
	else
		self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
		self.showFooter = false;
	end
	
	-- 未加入公会
	-- 1 GuildNotJoinPanel
	-- 2 GuildCreatePanel
	-- 3 GuildIconSelectPanel
	-- 4 GuildSearchPanel
	-- 已加入公会
	-- 5 GuildMainPanel
	-- 6 GuildInfoPanel ( info,memberList,applayList)
	-- 10GuildDonatePanel
	-- 11 GuildChatPanel
	-- 12 Guild
end

function GuildPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:registEvent();
end

function GuildPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkGuildRetGuildInfo, handler(self, self.retGuildInfo))
end
--返回公会数据
function GuildPanel:retGuildInfo(msg)
	self:onShow();
end

function GuildPanel:onEnter()
	model.GuildModel:reqGuildInfo();
	self.root:setOpacity(50);
	self.root:runAction(cc.FadeIn:create(0.2))
	self.root:setVisible(true);
end

function GuildPanel:onShow()
	if model.GuildModel:isJoinGuild() then
		self:showGuildMainPanel();
	else
		self:showDoNotJoinPanel();
	end
	--]]
	if IsKr then
		EventManager:FireEvent(EventType.UIFooterUpdateSelect,4);
	else
		EventManager:FireEvent(EventType.UIFooterUpdateSelect,5);
	end
end

--显示创建加入公会界面
function GuildPanel:showDoNotJoinPanel()
	UIManager:push('GuildNotJoinPanel')
end

--显示主界面
function GuildPanel:showGuildMainPanel()
	UIManager:push('GuildMainPanel')
end

function GuildPanel:onLeave()
	self.root:setVisible(false);
end

return GuildPanel;
