local GuildRaidRankPanel = class("GuildRaidRankPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/guild/raid_rank/'

function GuildRaidRankPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'GuildRaidRankPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function GuildRaidRankPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
	  self:InitPanels();
	  self:registEvent();
end

function GuildRaidRankPanel:InitPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,871));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -18);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_GUILD_RAID_RANK_1 , 606 , 63 , LANG.UI_GUILD_RAID_RANK_2 , true);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 448);

	self.guildRankNode = cc.Node:create();
	self.guildRankNode:addTo(self.root);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_3_11_4_33_20.png');
	bg:addTo(self.guildRankNode);
	bg:setPosition(0 , 155);
    bg:setCapInsets(cc.rect(11,4,33,20));
	bg:setContentSize(cc.size(580 , 449));

	local initData = {
        width = 580,
        height = 436,
        cellWidth = 580,
        cellHeight = 50,
		cellReloadFunc = handler(self,self.reloadCellPanel),
	}
	
	self.guildRankTableView = template.TableViewTemplate:create()
    self.guildRankTableView:initWithSizeAndItem(initData);
    self.guildRankTableView:getView():setPosition(cc.p(-290,-63)); -- 0,155
	self.guildRankTableView:getView():addTo(self.guildRankNode)
	
	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.guildRankNode);
	bg:setPosition(0 , -211);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(580 , 258));

	local curRankArrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	curRankArrow:addTo(self.guildRankNode);
	curRankArrow:setPosition(-254 , -108);

	local curRankLabel = cc.Label:createWithTTF(LANG.UI_GUILD_RAID_RANK_6, fonts.FONT_SIYUAN , 20);
	curRankLabel:addTo(self.guildRankNode);
	curRankLabel:setAnchorPoint(0 , 0.5);
	curRankLabel:setPosition(-227 , -108);
	curRankLabel:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	local label = cc.Label:createWithTTF(LANG.UI_GUILD_RAID_RANK_4 , fonts.FONT_SIYUAN , 17);
	label:enableOutline(cc.c3b(55 , 85 , 155) , 2);

	local rewardBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png','image/commonImg/btn_2_103_36.png');
	rewardBtn:addTo(self.guildRankNode);
	rewardBtn:setPosition(220 , -113);
	rewardBtn:setTitleLabel(label);
	rewardBtn:addClickEventListener(function()
		UIManager:push('GuildRaidRankRewardPanel');
	end);

	self.curGuildRank = template.GuildRaidRankTemplate:create();
	self.curGuildRank:addTo(self.guildRankNode)
	self.curGuildRank:setPosition(0 , -161);

	local rewardBg = cc.Sprite:create(imagePath..'raid_rank_1.png');
	rewardBg:addTo(self.guildRankNode);
	rewardBg:setPosition(0 , -256);

	self.rewardListView = ccui.ScrollView:create();
	self.rewardListView:setDirection(ccui.ScrollViewDir.horizontal);
	self.rewardListView:setContentSize(cc.size(470, 118));
	self.rewardListView:setScrollBarEnabled(false);
	self.rewardListView:addTo(self.guildRankNode);
	self.rewardListView:setAnchorPoint(cc.p(0.5,0.5));
	self.rewardListView:setPosition(cc.p(0,-256));


	self.damageRankNode = cc.Node:create();
	self.damageRankNode:addTo(self.root);
	
	local bg = cc.Scale9Sprite:create('image/commonImg/bg_3_11_4_33_20.png');
	bg:addTo(self.damageRankNode);
	bg:setPosition(0 , 105);
    bg:setCapInsets(cc.rect(11,4,33,20));
	bg:setContentSize(cc.size(580 , 549));

	local initData = {
        width = 580,
        height = 536,
		cellWidth = 580,
        cellHeight = 50,
		cellReloadFunc = handler(self,self.reloadCellPanel),
	}
	
	self.damageRankTableView = template.TableViewTemplate:create()
    self.damageRankTableView:initWithSizeAndItem(initData) ;
    self.damageRankTableView:getView():setPosition(cc.p(-290,-163)); -- 0,105
	self.damageRankTableView:getView():addTo(self.damageRankNode)

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.damageRankNode);
	bg:setPosition(0 , -265);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(580 , 163));

	local curRankArrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	curRankArrow:addTo(self.damageRankNode);
	curRankArrow:setPosition(-254 , -210);

	local curRankLabel = cc.Label:createWithTTF(LANG.UI_GUILD_RAID_RANK_6, fonts.FONT_SIYUAN , 20);
	curRankLabel:addTo(self.damageRankNode);
	curRankLabel:setAnchorPoint(0 , 0.5);
	curRankLabel:setPosition(-227 , -210);
	curRankLabel:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	self.curRank = template.GuildRaidRankTemplate:create();
	self.curRank:addTo(self.damageRankNode)
	self.curRank:setPosition(0 , -265);

	local bg = cc.Sprite:create('image/commonImg/tip_2.png');
	bg:addTo(self.damageRankNode);
	bg:setPosition(149 , -325);

	local label = cc.Label:createWithTTF(LANG.UI_GUILD_RAID_RANK_9 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.damageRankNode);
	label:setPosition(0 , -325);
	label:setTextColor(cc.c3b(255 , 200 , 0));

	local width = bg:getContentSize().width;
	local labelWidth = label:getContentSize().width;
	local posX = -labelWidth/2;

	bg:setPositionX(posX);
	label:setPositionX(posX + width / 2 + labelWidth / 2);
	
	self.menuList = {};
	for i = 1 , 2 do
		local unTexture = 'image/commonImg/top_2_bg_59_30.png';
		local texture = 'image/commonImg/top_1_bg_59_30.png';
		
		local label = cc.Label:createWithTTF(LANG.UI_GUILD_RAID_RANK_MENU[i] , fonts.FONT_SIYUAN , 20);

		local bgBtn = ccui.Button:create(texture,texture,unTexture);
		bgBtn:addTo(self.root);
		bgBtn:setTag(i);
		bgBtn:setTitleLabel(label)
		bgBtn:setScale9Enabled(true);
		bgBtn:setPosition(i == 1 and -145 or 145 , 394)
		bgBtn:setCapInsets(cc.rect(10 , 0 , 39 , 30));
		bgBtn:setContentSize(cc.size(290 , 30));
		bgBtn:addClickEventListener(handler(self , self.menuClick));
		self.menuList[i] = bgBtn;
	end

	local label1 = cc.Label:createWithTTF(LANG.COMMON_OK, fonts.FONT_SIYUAN, 20)
	:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2)
	local rewardBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png','image/commonImg/btn_1_219_55.png');
	rewardBtn:setPosition(0,-395);
	rewardBtn:setTitleLabel(label1);
	rewardBtn:addTo(self.root);
	rewardBtn:addClickEventListener(function()
		self:onClickBack();
	end);

	self.overTip = cc.Node:create()
		:addTo(self.root)
		:setPosition(0 , -483)
		:setLocalZOrder(110)

	local dropImg = cc.Sprite:create('image/commonImg/tip_2.png');
	dropImg:addTo(self.overTip);

	local dropLabel = cc.Label:createWithTTF(LANG.UI_L_OVER , fonts.FONT_SIYUAN , 20);
	dropLabel:addTo(self.overTip);
	dropLabel:setTextColor(cc.c3b(255 , 200 , 0));

	local width = dropImg:getContentSize().width+10;
	local labelWidth = dropLabel:getContentSize().width;
	local posX = -labelWidth / 2;
	dropImg:setPosition(posX , 0);
	dropLabel:setPosition(posX + width/2+labelWidth/2 , 0);
end

function GuildRaidRankPanel:registEvent(  )
	EventManager:RegisterEvent(EventType.NetworkGuildRaidRank , handler(self , self.updateData));
	EventManager:RegisterEvent(EventType.NetworkGuildRaidDamageRank , 	handler(self , self.updateData));
end

function GuildRaidRankPanel:onEnter()

	self:addSwallowCallback(handler(self , self.onClickBack));

	model.GuildModel:resetGuildRaidRank();
	self:updateData(1);

	self.overTip:setVisible(model.GuildModel:getGuildBossOpenState() ~= 1);

	self.root:setVisible(true);
end

function GuildRaidRankPanel:menuClick(sender , event)
	local rankType = sender:getTag();
	self:updateData(rankType);
end

function GuildRaidRankPanel:updateData(rankType)

	for _k , btn in pairs(self.menuList) do
		local label = btn:getTitleLabel();
		if _k == rankType then
			btn:setBright(true)
			label:setTextColor(cc.c3b(255 , 255 , 255));
		else
			btn:setBright(false)
			label:setTextColor(cc.c3b(180 , 180 , 180));
		end
	end

	if rankType == 1 then
		local raidRank = model.GuildModel:getGuildRaidRank();
		if raidRank then
			self.rankType = rankType;
			self.guildRankNode:setVisible(true);
			self.damageRankNode:setVisible(false);

			if #raidRank > 1 then
				table.sort(raidRank , function(first , second)
					return first.damage > second.damage
				end);
			end

			local curGid = model.GuildModel:getGuildInfo().gid;
			local curRank = 0;
			self.rankListData = {};
			for _k , rank in ipairs(raidRank) do
				if rank.gid == curGid then
					curRank = _k
				end
				self.rankListData[_k] = rank;
			end

			local data = {
				gid = model.GuildModel:getGuildInfo().gid,
				name = model.GuildModel:getGuildInfo().name,
				damage = model.GuildModel:getGuildRaidDamage(),
			};

			local rank = curRank == 0 and LANG.UI_GUILD_RAID_RANK_7 or curRank

			self.curGuildRank:Init(rank,data,rankType);

			self.rewardListView:removeAllChildren();
			local rankReward = model.GuildModel:getGuildRaidRankRewardSortData();
			
			if rankReward then
				local rewards = nil;
				for _k , reward in pairs(rankReward) do
					rewards = reward.reward;
					if curRank >= reward.ranking_min and curRank <= reward.ranking_max then
						break;
					end
				end
				
				local rewardNum = #rewards;

				local maxWidth = rewardNum * 114;
				maxWidth = maxWidth < 470 and 470 or maxWidth;

				self.rewardListView:setInnerContainerSize(cc.size(maxWidth, 118));

				for i=1, rewardNum do
					local r = rewards[i];
					local icon = template.ItemTemplate:create();
					icon:Init(r[1] , r[2]);
					icon:addTo(self.rewardListView);
					icon:setPosition(51 + 114 * (i - 1) , 59);
				end
				self.rewardListView:setTouchEnabled(rewardNum > 4);
			end

			self.guildRankTableView:reloadData(self.rankListData);
		end
	elseif rankType == 2 then
		local damageRank = model.GuildModel:getGuildRaidDamageRank();
		if damageRank then
			self.guildRankNode:setVisible(false);
			self.damageRankNode:setVisible(true);

			self.rankType = rankType;

			if #damageRank > 1 then
				table.sort(damageRank , function(first , second)
					if first.damage > second.damage then
						return true
					elseif first.damage == second.damage then
						if first.join_time > second.join_time then
							return true;
						end
					end
					return false;
				end);
			end

			local curUid = model.UserModel:getUserUid();
			local curDamage = nil;
			local curRank = 0;
			self.rankListData = {};
			for _k , rank in ipairs(damageRank) do
				if rank.uid == curUid then
					self.curRank:Init(_k , rank , rankType);
				end
				self.rankListData[_k] = rank;
			end

			self.damageRankTableView:reloadData(self.rankListData);
		end
	end
end

function GuildRaidRankPanel:reloadCellPanel(cell , idx)
	local index = idx + 1;
	if self.rankListData[index] then
		local child = cell:getChildByTag(999);
		if not child then
			child = template.GuildRaidRankTemplate:create();
			child:addTo(cell);
			child:setPosition(290 , 25);
			child:setTag(999);
		end
		local data = self.rankListData[index];
		child:Init(index , data , self.rankType);
	end
	
	return cell;
end

function GuildRaidRankPanel:onLeave()
	self.root:setVisible(false);
end

function GuildRaidRankPanel:onClickBack()
	UIManager:pop('GuildRaidRankPanel');
end

return GuildRaidRankPanel;
