local GuildRaidRankRewardPanel = class("GuildRaidRankRewardPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/guild/raid_rank/'

function GuildRaidRankRewardPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'GuildRaidRankRewardPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function GuildRaidRankRewardPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
	  self:InitPanels();
end

function GuildRaidRankRewardPanel:InitPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(455,761));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(-4 , -35);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_GUILD_RAID_RANK_10 , 455 , 63 , LANG.UI_GUILD_RAID_RANK_11 , true);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 376);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_3_11_4_33_20.png');
	bg:addTo(self.root);
	bg:setPosition(-4 , 6);
    bg:setCapInsets(cc.rect(11,4,33,20));
	bg:setContentSize(cc.size(429 , 654));

	local initData = {
        width = 408,
        height = 640,
        cellWidth = 408,
        cellHeight = 160,
		cellReloadFunc = handler(self,self.reloadCellPanel),
	}
	
	self.guildRankTableView = template.TableViewTemplate:create()
    self.guildRankTableView:initWithSizeAndItem(initData);
    self.guildRankTableView:getView():setPosition(cc.p(-208,-314)); -- -4,6
	self.guildRankTableView:getView():addTo(self.root)
	
	local label1 = cc.Label:createWithTTF(LANG.COMMON_OK, fonts.FONT_SIYUAN, 20)
	:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2)
	local rewardBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png','image/commonImg/btn_1_219_55.png');
	rewardBtn:setPosition(-4,-362);
	rewardBtn:setTitleLabel(label1);
	rewardBtn:addTo(self.root);
	rewardBtn:addClickEventListener(function()
		self:onClickBack();
	end);
end

function GuildRaidRankRewardPanel:onEnter()

	self:addSwallowCallback(handler(self , self.onClickBack));
	self.rankReward = model.GuildModel:getGuildRaidRankRewardSortData();
	self.guildRankTableView:reloadData(self.rankReward);
	self.root:setVisible(true);
end

function GuildRaidRankRewardPanel:reloadCellPanel(cell , idx)
	local index = idx + 1;
	if self.rankReward[index] then
		local child = cell:getChildByTag(999);
		if not child then
			child = template.GuildRaidRankRewardTemplate:create();
			child:addTo(cell);
			child:setPosition(214 , 79);
			child:setTag(999);
		end
		local data = self.rankReward[index];
		child:Init(data);
	end
	
	return cell;
end

function GuildRaidRankRewardPanel:onLeave()
	self.root:setVisible(false);
end

function GuildRaidRankRewardPanel:onClickBack()
	UIManager:pop('GuildRaidRankRewardPanel');
end

return GuildRaidRankRewardPanel;
