local GuildSearchPanel = class("GuildSearchPanel",require('app.layer.BaseLayer'))

local FightType = Enum:getTable('FightType');
local fonts = Enum:getTable('SystemFont')
local MessageBoxType = Enum:getTable('MessageBoxType')

-- 未加入公会页面

function GuildSearchPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'GuildSearchPanel');

	self.useCCreator = false;
	self.isPopup = true;
	self.haveSwallowLayer = true;
end

function GuildSearchPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.guildSearchList = {};

	self:InitPanels();
	self:registEvent();
end

function GuildSearchPanel:InitPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,501));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -34);

	local titleNode = GlobalFunctions:createTitle(LANG.UI_GUILD_113,606,63,LANG.UI_GUILD_114);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 248);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , -66);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(582 , 406));

	local searchBg = cc.Scale9Sprite:create('image/commonImg/edit_bg_28_0_177_49.png');
	searchBg:addTo(self.root);
	searchBg:setPosition(0 , 186);
    searchBg:setCapInsets(cc.rect(28,0,177,49));
	searchBg:setContentSize(cc.size(464 , 49));

	self.joinSearchEdit = ccui.EditBox:create(cc.size(384,49), cc.Scale9Sprite:create())
		:setFontColor(cc.c4b(255, 255, 255, 255))
		:setMaxLength(20)
		:addTo(self.root)
		:setPlaceHolder(LANG.UI_GUILD_70)
		:setPlaceholderFont(fonts.FONT_SIYUAN,18)
		:setFont(fonts.FONT_SIYUAN,18)
		:setPlaceholderFontColor(cc.c4b(255,255,255,255))
		:setPosition(cc.p(-19,186))
		:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)

	local searchBtn = ccui.Button:create('image/guild/not_join/not_join_bg_2.png');
	searchBtn:addTo(self.root);
	searchBtn:setPosition(cc.p(200,185));
	searchBtn:setScale(0.4);
	searchBtn:addClickEventListener(handler(self , self.joinSearchBtnClick));

    local initData = {
        width = 582,
        height = 396,
        cellWidth = 582,
        cellHeight = 70,
        cellReloadFunc = handler(self,self.reloadCellCreate),
    }
    self.guildListView = template.TableViewTemplate:create()
    self.guildListView:initWithSizeAndItem(initData) ;
    self.guildListView:getView():setPosition(cc.p(-291,-274));
	self.root:addChild(self.guildListView:getView())

	self.root:setVisible(false);
end

function GuildSearchPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkGuildRetJoinGuild, handler(self, self.retJoinGuild))
	EventManager:RegisterEvent(EventType.NetworkGuildRetSearchGuild, handler(self, self.retSearchGuild))
end

--查询公会
function GuildSearchPanel:joinSearchBtnClick(sender , event)
	local  searchText = self.joinSearchEdit:getText();
	if not searchText or searchText == '' then
		Prompt:Show(LANG.UI_GUILD_41);
	end

	model.GuildModel:reqGuildSearchList(searchText);
end

function GuildSearchPanel:reloadCellCreate( cell,index )
	local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
		cellNode = template.GuildJoinItemTemplate:create();
		cellNode:setTag(999);
		cellNode:addTo(cell);
		cellNode:setPosition(cc.p(291,35));
	end
	local guildSearchList = self.guildSearchList;

	local itemData = guildSearchList[tostring(index+1)] or guildSearchList[index + 1 ] ;
	cell:setTag(itemData.gid);
	cellNode:initData(itemData,2);
	self.guildList[itemData.gid] = cellNode;

end

--申请加入公会返回
function GuildSearchPanel:retJoinGuild(msg)
	if self.root:isVisible() then
		if self.guildList[msg.gid] then
			self.guildList[msg.gid]:setApplyJoin(true);
		end
	end
end

--查找公会返回
function GuildSearchPanel:retSearchGuild(msg)
	self.guildSearchList = {};
	self.guildList = {};

	if model.GuildModel:getSearchGuild() ~= nil then
		table.insert(self.guildSearchList,model.GuildModel:getSearchGuild());
	end

	if not self.guildSearchList or #self.guildSearchList <= 0 then
		self.guildListView:getView():setVisible(false);
		print('=======show No joinPanel list ');
		-- Prompt:Show('您搜索的工会不存在');

		return;
	end
	self.guildListView:getView():setVisible(true);
	self.guildListView:reloadData(self.guildSearchList);
end
function GuildSearchPanel:onEnter()
	self:addSwallowCallback(handler(self , self.onClickBack))
	self.joinSearchEdit:setText('');
	self.root:setVisible(true);
end

function GuildSearchPanel:onShow()

end

function GuildSearchPanel:onLeave()
	self.root:setVisible(false);
end

function GuildSearchPanel:onClickBack()
	--self.root:setOpacity(255);
	--self.root:runAction(cc.Sequence:create(cc.FadeTo:create(0.2 , 50) , cc.CallFunc:create(function()
	--	
	--end)));

	UIManager:pop('GuildSearchPanel');
	-- tools.RedDotTools:pushGuildRedDot(2)
end

return GuildSearchPanel;
