local GuildeNoticePanel = class("GuildeNoticePanel",require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")

function GuildeNoticePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'GuildeNoticePanel');

	self.useCCreator = false;
    self.isPopup = true;

end

function GuildeNoticePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:InitPanels()
	-- self:registEvent()
end

function GuildeNoticePanel:InitPanels()

    local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(604,349));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 12);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_GUILD_78 , 604 , 46 , 'PLACARD');
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 210);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , 60);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
    infoBg:setContentSize(cc.size(582 , 236));

    self.notice = cc.Label:createWithTTF('' , fonts.FONT_HUAKANG , 20)
        :addTo(self.root)
        :setContentSize(cc.size(562 , 180))
        :setLineBreakWithoutSpace(true)
        :setMaxLineWidth(562)
        :setAnchorPoint(cc.p(0 , 1))
        :setPosition(cc.p(-281, 170))
    
    self.noticeEditBox = ccui.EditBox:create(cc.size(562 , 180) , cc.Scale9Sprite:create());
    self.noticeEditBox:setMaxLength(50);
    self.noticeEditBox:setText('');
    self.noticeEditBox:setFont(fonts.FONT_HUAKANG , 20);
    self.noticeEditBox:setAnchorPoint(cc.p(0 , 1));
    self.noticeEditBox:setOpacity(0);
    self.noticeEditBox:setFontColor(cc.c4b(255,255,255,0))
        :setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
    self.noticeEditBox:registerScriptEditBoxHandler(function(event)
        -- if event == "began" then
        --     self.noticeEditBox:setText(self.notice:getString());
        -- end
        
        if event == "changed" then
            local str =  self.noticeEditBox:getText();
            self.notice:setString(str);
            self.changeNotice = true ;
        end
        
        if event == "return" then
            local str =  self.noticeEditBox:getText()
            local _,bRet = tools.SensitiveTools:checkSensitive( str )
            if bRet == true then
                Prompt:Show(LANG.UI_SENSITIVE);
                return 
            end
            self.noticeEditBox:setText("")
            self.notice:setString(str)
        end
    end);
	self.noticeEditBox:setPosition(cc.p(-281, 170));
	self.noticeEditBox:addTo(self.root);

    local line = cc.Sprite:create('image/commonImg/line.png');
    line:addTo(self.root);
    line:setPosition(cc.p(0,-16))

    local tipImg = cc.Sprite:create('image/commonImg/tip_2.png');
    tipImg:addTo(self.root);

    local tipLabel = cc.Label:createWithTTF(LANG.UI_GUILD_17 , fonts.FONT_SIYUAN , 20);
    tipLabel:addTo(self.root);
    tipLabel:setTextColor(cc.c3b(255 , 200 , 0));

    local width = tipImg:getContentSize().width+10;
    local labelWidth = tipLabel:getContentSize().width;
    local posX = -labelWidth / 2;
    tipImg:setPosition(posX , -36);
    tipLabel:setPosition(posX + width/2+labelWidth/2 , -36);

    local btnLabel = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20);
    btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

    self.okBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
    self.okBtn:addTo(self.root);
    self.okBtn:setPosition(0 , -110);
    self.okBtn:addClickEventListener(handler(self , self.onOKBtnClick));
    self.okBtn:setTitleLabel(btnLabel);

end


function GuildeNoticePanel:onOKBtnClick(  )
    
    if self.okCallback and self.changeNotice == true then
        self.okCallback(self.notice:getString());
    end
    self:onClickBack();
end


function GuildeNoticePanel:onEnter( option)
	-- print('============GuildeNoticePanel=============')
    self:addSwallowCallback(handler(self , self.onClickBack))
    self.changeNotice = false;
    self.okCallback = nil;
    if option ~= nil then
        self.okCallback = option.okCallback;
    end
	local notice = model.GuildModel:getGuildNotice();
    self.notice:setString(tostring(notice))
	self:onShow();

end

function GuildeNoticePanel:onShow()
    self.root:setVisible(true);
end

function GuildeNoticePanel:onLeave()
	self.root:setVisible(false);
end

function GuildeNoticePanel:onClickBack()
    UIManager:pop('GuildeNoticePanel');
end

return GuildeNoticePanel;
