local HeaderPanel = class("HeaderPanel" , require('app.layer.BaseLayer'))
local HelpShow = Enum:getTable('HelpShow');

local shopMoneyPos = {
	[1] = cc.p(50 , 548),
	[2] = cc.p(234 , 548),
}

local announcementLayoutWidth = 355
local announcementLayoutHeight = 36

local HeaderTypeMoneys = Enum:getTable('HeaderTypeMoneys');
local HeaderType = Enum:getTable('HeaderType');

local imagePath = 'image/head/'

function HeaderPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'HeaderPanel');

	self.useCCreator = false;
	self.isPopup = true;
	self.haveSwallowLayer = false;
	self.posY = -NOTCH_HEIGHT


	self.curPanelName = nil;
	self.curScene = nil;
	self.headerType = nil;
	self.moneyTypes = nil;
	self.showMsgList = require('app.base.queue'):create();
	self.showTopMsg = false
	self.headItem = {};
end

function HeaderPanel:Init(root)
	self.root:setVisible(false);
	--self.root:setPositionY(StageSize.height / 2);
	self:initPanels();
	self:registEvent();

	UIManager:push("HeaderPanel" , "MainPanel" , UIManager:getPanelHandler("MainPanel"));
	self:showHeadNodeAction()
end

function HeaderPanel:registEvent()
	EventManager:RegisterEvent(EventType.UIHeaderPanelUpdateIcon, handler(self, self.updateHeadIcon));
	EventManager:RegisterEvent(EventType.UIHeaderPanelUpdateFP, handler(self, self.updateHeadFp));
	EventManager:RegisterEvent(EventType.UIHeaderPanelUpdateLevel, handler(self, self.updateHeadLevel));
	EventManager:RegisterEvent(EventType.UIHeadeMoneyUpdate, handler(self, self.updateHeadMoney));
	EventManager:RegisterEvent(EventType.UIHeadeUpdateHeadType, handler(self, self.updateHeadType));
	-- EventManager:RegisterEvent(EventType.UIHeadeUpdateMoneyNodeVisible, handler(self, self.setMoneyNodeVisible));
	EventManager:RegisterEvent(EventType.UIHeadeRunAction, handler(self, self.showHeadNodeAction));
	EventManager:RegisterEvent(EventType.UIHeadeUpdateCardBookRedDot, handler(self, self.updateCardBookRedDot));
	EventManager:RegisterEvent(EventType.UIHeaderPanelVisible, function(visible, bforce)
		if UIManager:getLayer('FightPanel'):isVisible() or bforce==true then
			self.root:setVisible(visible)
		end
	end)
	EventManager:RegisterEvent(EventType.AddNewAnnouncement, handler(self, self.pushAnnouncement))
	EventManager:RegisterEvent(EventType.HeaderUpdateTitle, handler(self, self.updateTitle))
end

function HeaderPanel:initPanels()

	self.node = cc.Node:create();
	self.node:addTo(self.root);
	self.node:setPosition(0 , StageSize.height / 2 - 568);

	self.headNode = cc.Node:create();
	self.headNode:addTo(self.node);

	self.headNodeBg = cc.Sprite:create(imagePath..'header_bg_1.png');
	self.headNodeBg:addTo(self.headNode);
	self.headNodeBg:setPosition(0 , 516);

	self.headIconNode = cc.Node:create();
	self.headIconNode:addTo(self.headNode);
	self.headIconNode:setPosition(-267 , 520);

	self.headIconBg = cc.Sprite:create(imagePath..'header_bg_2.png');
	self.headIconBg:addTo(self.headIconNode);

	self.headIcon = cc.Sprite:create();
	local stencil = cc.Sprite:create(imagePath..'header_bg_2.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:addChild(self.headIcon);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:addTo(self.headIconNode);
	clippingNode:setScale(0.95);

	self.headWhite = cc.DrawNode:create();
	self.headWhite:drawDot(cc.p(0,0),40,cc.c4f(1.0,1.0,1.0,1.0));
	self.headWhite:addTo(self.headIconNode);
	self.headWhite:setVisible(false);

	self.settingBtn = ccui.Button:create(imagePath.."header_bg_3.png" , imagePath.."header_bg_3.png");
	self.settingBtn:addTo(self.headIconNode);
	self.settingBtn:addClickEventListener(function()
		--AudioManager:playEffect(Conf.buttonClick);
		if UIManager:panelIsVisible('FightPanel') and not FightManager:getIsNotFight() then
			Prompt:Show(LANG.COMMON_NOT);
			return
		end
		-- AudioManager:playCVStopBefor(model.UserModel:getKanban(), 'Doubt');
		UIManager:push('SettingPanel');
	end);

	local expImg = cc.Sprite:create(imagePath .. 'header_bg_4.png');
 	self.expProgress = cc.ProgressTimer:create(expImg);
    self.expProgress:setType(cc.PROGRESS_TIMER_TYPE_RADIAL);
	self.expProgress:setReverseDirection(true);
	self.expProgress:setPosition(1 , -4);
	self.expProgress:setPercentage(0);
 	self.expProgress:addTo(self.headIconNode);

	self.lvBg = cc.Sprite:create(imagePath..'header_bg_5.png');
	self.lvBg:addTo(self.headIconNode);
	self.lvBg:setPosition(-11 , -35);

	self.level = cc.Label:createWithTTF('' , Enum:getTable('SystemFont').FONT_SIYUAN , 16);
	self.level:addTo(self.headIconNode);
	self.level:setAnchorPoint(0 , 0.5);
	self.level:setPosition(6 , -35);
	self.level:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
	self.level:setCascadeOpacityEnabled(true);

	self.playerName = cc.Label:createWithTTF('' , Enum:getTable('SystemFont').FONT_SIYUAN , 19);
	self.playerName:addTo(self.headNode);
	self.playerName:setAnchorPoint(0 , 0.5);
	self.playerName:setPosition(-201 , 549);
	self.playerName:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
	self.playerName:setCascadeOpacityEnabled(true);

	self.fpBg = cc.Sprite:create(imagePath..'header_bg_9.png');
	self.fpBg:addTo(self.headNode);
	self.fpBg:setPosition(-186 , 517);

	self.fpWhite = cc.Sprite:create(imagePath..'header_bg_13.png');
	self.fpWhite:addTo(self.headNode);
	self.fpWhite:setPosition(-186 , 517);
	self.fpWhite:setBlendFunc(cc.blendFunc(GL_ONE , GL_ONE));

	self.fp = cc.Label:createWithTTF('' , Enum:getTable('SystemFont').FONT_SIYUAN , 19);
	self.fp:addTo(self.headNode);
	self.fp:setAnchorPoint(1 , 0.5);
	self.fp:setPosition(-83 , 518);

	self.titleNode = cc.Node:create();
	self.titleNode:addTo(self.node);
	self.titleNode:setPosition(0 , 548);

	local bg = cc.Sprite:create(imagePath..'header_bg_11.png');
	bg:addTo(self.titleNode);
	bg:setPosition(0 , 0);

	self.title = cc.Label:createWithTTF('' , Enum:getTable('SystemFont').FONT_SIYUAN , 20);
	self.title:addTo(self.titleNode);
	self.title:setPosition(-117 , 0);
	self.title:enableBold();
	self.title:enableGlow(cc.c4b(60, 110, 220 , 178));

	self.backBtn = ccui.Button:create(imagePath..'header_bg_12.png',imagePath..'header_bg_12.png');
	self.backBtn:addTo(self.titleNode);
	self.backBtn:setPosition(-251 , 0);
	self.backBtn:addClickEventListener(handler(self , self.backBtnClick));

	self.helpBtn = ccui.Button:create('image/commonImg/help_1.png','image/commonImg/help_1.png')
	self.helpBtn:addTo(self.titleNode);
	self.helpBtn:setPosition(-117 , 0)
	self.helpBtn:addClickEventListener(function() 
		UIManager:push('HelpPanel',self.curPanelName);
	end)

	--顶部货币条
	local moneyPos = {
		[1] = cc.p(15 , 548),
		[2] = cc.p(190 , 548),
	}
	
	self.moneyNode = {};
	for i=1 , 2 do
		self.moneyNode[i] = {};

		self.moneyNode[i].node = cc.Node:create();
		self.moneyNode[i].node:addTo(self.node);
		self.moneyNode[i].node:setPosition(moneyPos[i]);

		self.moneyNode[i].moneyIcon = cc.Sprite:create();
		self.moneyNode[i].moneyIcon:addTo(self.moneyNode[i].node);

		self.moneyNode[i].moneyIconWhite = cc.Sprite:create()
		self.moneyNode[i].moneyIconWhite:addTo(self.moneyNode[i].node)
		self.moneyNode[i].moneyIconWhite:setBlendFunc(cc.blendFunc(GL_ONE , GL_ONE));
	
		self.moneyNode[i].num = cc.Label:createWithTTF('', Enum:getTable('SystemFont').FONT_SIYUAN, 19);
		self.moneyNode[i].num:addTo(self.moneyNode[i].node);
		self.moneyNode[i].num:setAnchorPoint(cc.p(1,0.5));
		self.moneyNode[i].num:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
		self.moneyNode[i].num:setPosition(121 , 0);
	end

	self.addMoneyBtn = ccui.Button:create(imagePath..'header_bg_6.png' , imagePath..'header_bg_6.png');
	self.addMoneyBtn:addTo(self.moneyNode[2].node);
	self.addMoneyBtn:setPosition(9 , -6);
	self.addMoneyBtn:addClickEventListener(function()
		AudioManager:playEffect(Conf.buttonClick);
		if UIManager:panelIsVisible('FightPanel') and not FightManager:getIsNotFight() then
			Prompt:Show(LANG.COMMON_NOT);
			return
		end
		if self:commonCheck() then
			return;
		end
		UIManager:push('ShopPanel',Enum:getTable('CommonShopType').RECHARGE);
	end);

	self.announcementNode = cc.Node:create()
		:setPosition((StageSize.width-announcementLayoutWidth)/2, StageSize.height/2-55)
		:setVisible(false)
		:addTo(self.root)
	self.hornIcon = cc.Sprite:create('image/main/horn.png')
		:setPosition(-announcementLayoutWidth/2-10, 0)
		:addTo(self.announcementNode)

	self.noticeNode = cc.Node:create()
		:addTo(self.root)
		:setVisible(false)
	local noticeBg = cc.Sprite:create('image/commonImg/big_tip_rect.png')
	noticeBg:addTo(self.noticeNode)

end

function HeaderPanel:showHeadNodeAction()
	self.headNodeBg:stopAllActions()
	self.headNodeBg:setOpacity(0)
	self.headNodeBg:runAction(cc.FadeIn:create(5/25));

	self.headIconBg:stopAllActions();
	self.headIconBg:setScale(1.2);
	local action1 = cc.ScaleTo:create(4/25 , 0.95 , 0.95);
	local action2 = cc.FadeIn:create(4/25);
	local actionSpawn = cc.Spawn:create(action1,action2);
	local action3 = cc.ScaleTo:create(2/25 , 1.0 , 1.0);
	self.headIconBg:runAction(cc.Sequence:create(cc.DelayTime:create(5/25) , actionSpawn , action3));

	self.headIcon:stopAllActions();
	self.headIcon:setOpacity(0);
	local action1 = cc.FadeIn:create(3/25);
	self.headIcon:runAction(cc.Sequence:create(cc.DelayTime:create(13/25) , action1));

	self.headWhite:stopAllActions();
	self.headWhite:setOpacity(255);
	self.headWhite:setVisible(false);
	local action1 = cc.FadeOut:create(11/25);
	self.headWhite:runAction(cc.Sequence:create(cc.DelayTime:create(8/25) , cc.CallFunc:create(function() 
		self.headWhite:setVisible(true);
	end), action1 , cc.CallFunc:create(function() 
		self.headWhite:setVisible(false);
	end)));

	self.settingBtn:stopAllActions();
	self.settingBtn:setOpacity(0);
	local action1 = cc.FadeIn:create(3/25);
	self.settingBtn:runAction(cc.Sequence:create(cc.DelayTime:create(5/25) , action1));

	local percent = self.expProgress:getPercentage();
	self.expProgress:stopAllActions();
	self.expProgress:setPercentage(28);
	local action1 = cc.ProgressTo:create(5/25, percent);
	self.expProgress:runAction(cc.Sequence:create(cc.DelayTime:create(11/25) , action1));

	self.lvBg:stopAllActions();
	self.lvBg:setVisible(false);
	self.lvBg:runAction(cc.Sequence:create(cc.DelayTime:create(26/25),cc.CallFunc:create(function() 
		self.lvBg:setVisible(true);
	end)));

	self.level:stopAllActions();
	self.level:setVisible(false);
	self.level:runAction(cc.Sequence:create(cc.DelayTime:create(26/25),cc.CallFunc:create(function() 
		self.level:setVisible(true);
	end)));

	self.fpBg:stopAllActions();
	self.fpBg:setVisible(false);
	self.fpBg:runAction(cc.Sequence:create(cc.DelayTime:create(30/25),cc.CallFunc:create(function() 
		self.fpBg:setVisible(true);
	end)));

	self.fpWhite:stopAllActions();
	self.fpWhite:setOpacity(255);
	self.fpWhite:setVisible(false);
	local action1 = cc.FadeOut:create(6/25);
	self.fpWhite:runAction(cc.Sequence:create(cc.DelayTime:create(30/25) , cc.CallFunc:create(function() 
		self.fpWhite:setVisible(true);
	end), action1 , cc.CallFunc:create(function() 
		self.fpWhite:setVisible(false);
	end)));

	self.fp:stopAllActions();
	self.fp:setVisible(false);
	self.fp:runAction(cc.Sequence:create(cc.DelayTime:create(30/25),cc.CallFunc:create(function() 
		self.fp:setVisible(true);
	end)));

	for i = 1 , 2 do
		local delayTime = (34+(i-1)*4)/25;
		self.moneyNode[i].moneyIcon:stopAllActions();
		self.moneyNode[i].moneyIcon:setVisible(false);
		self.moneyNode[i].moneyIcon:runAction(cc.Sequence:create(cc.DelayTime:create(delayTime),cc.CallFunc:create(function() 
			self.moneyNode[i].moneyIcon:setVisible(true);
		end)));

		self.moneyNode[i].num:stopAllActions();
		self.moneyNode[i].num:setVisible(false);
		self.moneyNode[i].num:runAction(cc.Sequence:create(cc.DelayTime:create(delayTime),cc.CallFunc:create(function() 
			self.moneyNode[i].num:setVisible(true);
		end)));

		self.moneyNode[i].moneyIconWhite:stopAllActions()
		self.moneyNode[i].moneyIconWhite:setOpacity(255);
		self.moneyNode[i].moneyIconWhite:setVisible(false);
		local action1 = cc.FadeOut:create(6/25);
		self.moneyNode[i].moneyIconWhite:runAction(cc.Sequence:create(cc.DelayTime:create(delayTime) , cc.CallFunc:create(function() 
			self.moneyNode[i].moneyIconWhite:setVisible(true);
		end), action1 , cc.CallFunc:create(function() 
			self.moneyNode[i].moneyIconWhite:setVisible(false);
		end)));

		
	end
end

function HeaderPanel:commonCheck()
	local topPanelName = UIManager:getTopPanelName()
	if 'PlayBallPanel' == topPanelName then
		local panelHandler = UIManager:getPanelHandler('PlayBallPanel');
		if panelHandler and panelHandler:getIsPlaying()==true then
			return true
		end
	end
	return false;
end

function HeaderPanel:backBtnClick()
	if self:commonCheck() then
		return;
	end
	AudioManager:playEffect(Conf.cancleButton);

	if self.curScene and self.curScene.onClickBack then
		self.curScene:onClickBack();
	else
		UIManager:popTop();
	end

	--if UIManager:isCallOnClickBack(self.curPanelName) and self.curScene then
	--	self.curScene:onClickBack();
	--else
	--	UIManager:popTop()
	--end
end

function HeaderPanel:onEnter(curPanelName , curScene)
	self:setData(curPanelName , curScene);
	self.root:setVisible(true);
end

function HeaderPanel:updateHeadType(curPanelName , curScene)
	self:setData(curPanelName , curScene);
end

function HeaderPanel:setData(curPanelName , curScene)
	self.curPanelName = curPanelName or self.curPanelName;
	self.curScene = curScene or self.curScene;
	
	local panelZOder = UIManager:getPanelLocalZOrder(self.curPanelName);
	panelZOder = panelZOder * PANEL_ZORDER + 10;
	self.root:setLocalZOrder(panelZOder);

	if self.curScene.showHeaderType then
		self.headerType = self.curScene.showHeaderType;
--	else
--		self.headerType = UIManager:getHeaderType(self.curPanelName) or HeaderType.HEAD_ICON
	end

	self.addMoneyBtn:setTouchEnabled(self.curPanelName ~= 'ShopPanel');

	self:updateData();
	self:updateHeadInfo();
	self:updateCardBookRedDot();
end

function HeaderPanel:updateVisible()
	local visible = tools.ConfigStateTools:checkVisibleByName('SettingPanel');
	self.settingBtn:setVisible(visible);
end

function HeaderPanel:updateCardBookRedDot()
	--local state = model.CardModel:getCardBookActiveState();
	--tools.RedDotTools:setRedDotToNode(self.headIconNode,state,nil,cc.p(37,35));
end

function HeaderPanel:updateData()

	if self.headerType == HeaderType.HEAD_ICON then
		self.titleNode:setVisible(false);
		self.headNode:setVisible(true);
		self:updateVisible();
	else
		self.titleNode:setVisible(true);
		self.headNode:setVisible(false);
		
		self:updateTitle(self.curPanelName)
	end

	self.moneyTypes = HeaderTypeMoneys[self.headerType];

	self.headItem = {};

	for i , _moneyType in ipairs(self.moneyTypes) do
		self.headItem[_moneyType] = 1;
		if _moneyType == 0 then
			self.moneyNode[i].node:setVisible(false);
		else
			local moneyData = self:getMoneyData(_moneyType);
			self.moneyNode[i].node:setVisible(true);
			self.moneyNode[i].moneyIcon:setTexture(moneyData.img);
			self.moneyNode[i].moneyIcon:setScale(moneyData.scale);
			self.moneyNode[i].num:setString(tostring(moneyData.num));
			if _moneyType == MONEY_ID then
				self.moneyNode[i].moneyIconWhite:setTexture(imagePath..'header_bg_14.png');
			else
				self.moneyNode[i].moneyIconWhite:setTexture(imagePath..'header_bg_15.png');
			end
		end
	end
end

function HeaderPanel:updateTitle(curPanelName)
	local title = LANG.UI_TITLE[curPanelName] or '';
		self.title:setString(tostring(title));

		local helpData = HelpShow[curPanelName];
		if helpData and helpData[2] == 1 then
			local width = self.title:getContentSize().width+5;
			local helpWidth = self.helpBtn:getContentSize().width+5;
			local posX = -helpWidth/2;

			self.title:setPositionX(-117+posX);
			self.helpBtn:setPositionX(-117+posX+width/2+helpWidth/2);
			self.helpBtn:setVisible(true);
		else
			self.title:setPositionX(-117);
			self.helpBtn:setVisible(false);
		end
end
--[[
function HeaderPanel:showTouch( index )
	if index == -1 then
		if self.swallowListener ~= nil then
			local eventDispatcher = cc.Director:getInstance():getEventDispatcher();
			eventDispatcher:removeEventListener(self.swallowListener);
			self.swallowCount = self.swallowCount - 1;
			self.swallowListener = nil ;
		end

		return 
	end

	local node = self.moneyNode[index].bg
	if node ~= nil then
		self:addSwallowLayer(node)
	end
end
function HeaderPanel:addSwallowLayer(node)
	if self.swallowCount > 0 then
		return;
	end
	self.swallowCount = self.swallowCount + 1;
	-- listener
	self.swallowListener = cc.EventListenerTouchOneByOne:create();
	local onTouchBegan = function(touch, event)

		if node:getParent():isVisible() == false then
			return false;
		end

		local pos = touch:getLocation()
		local nodePos = node:getParent():convertToNodeSpace(pos)
		if cc.rectContainsPoint(node:getBoundingBox(),nodePos) then
			self:showDiamodeInfo(true);
			return true;
		end

		return false;
	end
	local onTouchEnd = function()
		self:showDiamodeInfo(false);

	end
	self.swallowListener:setSwallowTouches(true);
	self.swallowListener:registerScriptHandler(onTouchBegan, cc.Handler.EVENT_TOUCH_BEGAN);
	self.swallowListener:registerScriptHandler(onTouchEnd, cc.Handler.EVENT_TOUCH_ENDED);
	local eventDispatcher = cc.Director:getInstance():getEventDispatcher();
	eventDispatcher:addEventListenerWithSceneGraphPriority(self.swallowListener, node);
end

function HeaderPanel:showDiamodeInfo( bTrue )
	if bTrue == false and self.diamondInfo ~= nil then
		self.diamondInfo:setVisible(false)
		return
	end
	local diamondType = {COLOR_DIA,COLOR_DIA_PAY}
	if self.diamondInfo == nil then
		self.diamondInfo = cc.Node:create()
			:addTo(self.root)
			:setPosition(cc.p(120 , StageSize.height/2 - 80))
		local bg = cc.Sprite:create(imagePath..'diamond_bg.png')
			:addTo(self.diamondInfo)

		self.diamodeNode = {}

		local diamondPos = {
			cc.p(-85,-5),
			cc.p(85,-5)
		}
		for i=1 , 2 do
			self.diamodeNode[i] = {};
	
			self.diamodeNode[i].node = cc.Node:create()
				:addTo(self.diamondInfo)
				:setPosition(diamondPos[i])
			
			local bg = cc.Sprite:create(imagePath..'diamond_bg1.png')
				:addTo(self.diamodeNode[i].node)
	
			local icon = ResTable:getValue('item' , diamondType[i] , 'icon');
			self.diamodeNode[i].moneyIcon = cc.Sprite:create('image/icon/I'..icon..'.png')
				:setPosition(-47 , 0)
				:addTo(self.diamodeNode[i].node)
				:setContentSize(COST_ITEM_SIZE);

			local numBg = cc.Label:createWithTTF('0000000', Enum:getTable('SystemFont').FONT_SIYUAN, 20)
				:addTo(self.diamodeNode[i].node)
				:setAnchorPoint(cc.p(1,0.5))
				:setTextColor(cc.c4b(83 , 83 , 83 , 255))
				:setPosition(55 , 0)
		
			self.diamodeNode[i].num = cc.Label:createWithTTF('', Enum:getTable('SystemFont').FONT_SIYUAN, 20)
				:addTo(self.diamodeNode[i].node)
				:setAnchorPoint(cc.p(1,0.5))
				:enableOutline(cc.c4b(76 , 76 , 76 , 255) , 2)
				:setPosition(55 , 0)
		end

	end

	self.diamondInfo:setVisible(true)
	local num = model.ItemModel:getItemNum(diamondType[1],true);
	self.diamodeNode[1].num:setString(num)
	local num = model.ItemModel:getItemNum(diamondType[2]);
	self.diamodeNode[2].num:setString(num);

end
]]
function HeaderPanel:onLeave()
	self.curPanelName = nil;
	self.curScene = nil;
	self.headerType = nil;
	self.moneyTypes = nil;
	self.root:setVisible(false);	
end

function HeaderPanel:getMoneyData( _type )
	local data = {
		img = "",
		num = "",
		type = _type,
	}

	local icon = ResTable:getValue('item' , _type , 'icon');
	data.img = 'image/icon/I'..icon..'.png';
	if _type == MONEY_ID then --金币
		--data.img = 'image/head/header_bg_8.png';
		data.num = model.MoneyModel:getMoney();
		data.scale = 0.35;
	else
		--data.img = 'image/head/header_bg_7.png';
		data.num = model.ItemModel:getItemNum(_type);
		data.scale = 0.3;
	end
	return data;
end

function HeaderPanel:updateHeadMoney(data)

	if not self.moneyTypes then
		return;
	end

	--单独刷新单个货币
	if data and data.type then
		local itemType = data.type
		local moneyData = self:getMoneyData(itemType);
		if self.moneyTypes then
			for _k , moneyType in ipairs(self.moneyTypes) do
				if itemType == moneyType then
					self.moneyNode[_k].num:setString(tostring(moneyData.num))
					break;
				end
			end
		end
		return
	end
	
	--所有货币刷新
	local len = #self.moneyTypes;
	for i=1,len do
		local itemType = self.moneyTypes[i];
		if itemType > 100 then
			local moneyData = self:getMoneyData(itemType);
			if self.moneyNode[i] then
				self.moneyNode[i].num:setString(tostring(moneyData.num))
			end
		end
	end

end

function HeaderPanel:updateHeadInfo()
	self:updateHeadLevel(model.UserModel:getExpPercent());
	self:updateHeadFp();
	self:updateHeadIcon();

	local name = model.UserModel:getUserName()
	self.playerName:setString(tostring(name));
end

function HeaderPanel:updateHeadIcon()
	local no = model.UserModel:getHeadIcon();
	if not no then
		no = 1;
	end
	local roleId = no
	if no < 1000 then
		roleId = ResTable:getValue('role' , no , 'role_id');
	end
	
	local imagePath = ResTable:getValue('role_resource', roleId, 'icon');
	self.headIcon:setTexture('image/icon/'..imagePath..'.png');
end

function HeaderPanel:updateHeadLevel(percent)
	percent = percent or 0;
	self.expProgress:setPercentage(28 + percent * 0.66);
	self.level:setString(tostring(model.UserModel:getUserLevel()));
end

function HeaderPanel:updateHeadFp()
	self.fp:setString(tostring(ConvertStrToDigitUnit(model.TeamModel:getCurrentTeamFp())));
end

function HeaderPanel:setVisible(visible)
	self.root:setVisible(visible);
end

-- function HeaderPanel:setMoneyNodeVisible(visibleIndexs)
-- 	if visibleIndexs then
-- 		for index , visible in pairs(visibleIndexs) do
-- 			if self.moneyNode[index] then
-- 				self.moneyNode[index].node:setVisible(visible);
-- 				if index == 1 then
-- 					self.addMoneyBtnNode:setVisible(visible);
-- 				end
-- 			end
-- 		end
-- 	end
-- end

function HeaderPanel:getHeadItem()
	return self.headItem;
end

-- 引导相关
function HeaderPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 5 then
		local btn = self.backBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 16 then
		pos = cc.p(StageSize.width/2, StageSize.height/2-300)
	end
	return pos;
end

-- 公告
function HeaderPanel:pushAnnouncement(word, front)
	if self.showTopMsg then
		if front then
			self.showMsgList:pushFront(word)
		else
			self.showMsgList:pushBack(word)
		end
	else
		self:showNextMsg(word)
	end
end

function HeaderPanel:showNextMsg(word)
	self.announcementNode:setVisible(true)
	self.showTopMsg = true
	print('showOneMsg', word)
	local layout = ccui.Layout:create()
		:setAnchorPoint(cc.p(0.5, 0.5))
		:setContentSize(cc.size(announcementLayoutWidth, announcementLayoutHeight))
		:setClippingEnabled(true)
		:addTo(self.announcementNode)

	local label = cc.Label:createWithTTF(word, Enum:getTable("SystemFont").FONT_SIYUAN, 18)
		:enableOutline(cc.c3b(0, 0, 0), 1)
		:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
		:setAnchorPoint(cc.p(0, 0.5))
		:setPosition(announcementLayoutWidth, announcementLayoutHeight/2)
		:setVisible(false)
		:addTo(layout)
	
	local size = label:getContentSize();
	local moveWidth = size.width+announcementLayoutWidth;
	local moveTime = 4;
	
	label:setVisible(true);
	label:runAction(cc.Sequence:create(
		cc.MoveBy:create(moveTime, cc.p(-moveWidth, 0)),
		cc.CallFunc:create(function()
			layout:removeFromParent()
			if self.showMsgList:len() > 0 then
				self:showNextMsg(self.showMsgList:popFront())
			else
				self.showTopMsg = false
				self.announcementNode:setVisible(false)
			end
		end)
	))
end


--废弃 ，先留着
--[[
function HeaderPanel:runTypeOneAction()

	self.bg:stopAllActions();
	self.bg:setPosition(cc.p(-640 , 508));
	self.bg:runAction(cc.MoveTo:create(15 / 60 , cc.p(0 , 508)));

	self.levelBg:stopAllActions();
	self.levelBg:setOpacity(0);
	self.levelBg:runAction(cc.Sequence:create(cc.DelayTime:create(15/60) ,cc.FadeIn:create(42/60)));

	self.fpBg:stopAllActions();
	self.fpBg:setPosition(cc.p(-422.5 , 531.5));
	self.fpBg:runAction(cc.Sequence:create(cc.MoveTo:create(14 / 60 , cc.p(-100.5 , 531.5)) , cc.MoveTo:create(6 / 60 , cc.p(-115.5 , 531.5))));


	local headIconBgAction1 = cc.Sequence:create(cc.ScaleTo:create(7/60 , 1.1 , 1.1) , cc.ScaleTo:create(3/60 , 1 , 1));
	local headIconBgAction2 = cc.FadeIn:create(7/60);
	self.headIconBg:stopAllActions();
	self.headIconBg:setOpacity(0);
	self.headIconBg:setScale(0.6);
	self.headIconBg:runAction(cc.Sequence:create(cc.DelayTime:create(24/60) , cc.Spawn:create(headIconBgAction1 , headIconBgAction2)));

	local headIconAction1 = cc.Sequence:create(cc.ScaleTo:create(7/60 , 0.9 , 0.9) , cc.ScaleTo:create(3/60 , 1 , 1));
	local headIconAction2 = cc.FadeIn:create(7/60);
	self.headIcon:stopAllActions();
	self.headIcon:setOpacity(0);
	self.headIcon:setScale(2.1);
	self.headIcon:runAction(cc.Sequence:create(cc.DelayTime:create(36/60) , cc.Spawn:create(headIconAction1 , headIconAction2)));

	self.headIconFg:stopAllActions();
	self.headIconFg:setOpacity(0);
	self.headIconFg:runAction(cc.Sequence:create(cc.DelayTime:create(43/60) ,cc.FadeIn:create(8/60)));

	self.moneyBg:stopAllActions();
	self.moneyBg:setPosition(cc.p(504 , 535));
	self.moneyBg:runAction(cc.Sequence:create(cc.DelayTime:create(68/60) ,cc.MoveTo:create(10/60 , cc.p(136 , 535))));

	self.name:setVisible(false);
	self.fp:setVisible(false);

	for i=1 , 2 do
		local moneyType = self.moneyTypes[i];
		self.moneyNode[moneyType].num:setVisible(false);
	end
	self.nameBg:stopAllActions();
	self.nameBg:setOpacity(0);
	self.nameBgImg:setVisible(false);
	self.expProgressBg:setVisible(false);
	self.expProgress:setVisible(false);
	for i=1 , 2 do
		local moneyType = self.moneyTypes[i];
		self.moneyNode[moneyType].moneyIcon:stopAllActions();
		self.moneyNode[moneyType].moneyIcon:setPosition(i == 1 and cc.p(351 , 537) or cc.p(349,537));
		local delayTime = 0;
		local pos = cc.p(0 , 0);
		if i == 1 then
			delayTime = 64;
			pos = cc.p(18 , 537);
		else
			delayTime = 78;
			pos = cc.p(180,537);
		end

		self.moneyNode[moneyType].moneyIcon:runAction(cc.Sequence:create(cc.DelayTime:create(delayTime/60) , cc.MoveTo:create(7/60 , pos) , cc.CallFunc:create(function() 
			if i == 1 then
				self.name:setVisible(true);
				self.fp:setVisible(true);
				self.nameBg:runAction(cc.FadeIn:create(6/60));
				self.nameBgImg:setVisible(true);
				self.expProgressBg:setVisible(true);
				self.expProgress:setVisible(true);
			end
			self.moneyNode[moneyType].num:setVisible(true);
		end)));
	end

	self.headIconLineTop:stopAllActions();
	self.headIconLineBottom:stopAllActions();

	self.headIconLineTop:setScale(0.3);
	self.headIconLineBottom:setScale(0.3);

	self.headIconLineTop:setOpacity(0);
	self.headIconLineBottom:setOpacity(0);

	local headIconLineTop1 = cc.Sequence:create(cc.ScaleTo:create(6/60 , 1.3 , 1.3) , cc.ScaleTo:create(5/60 , 1 , 1));
	local headIconLineTop2 = cc.FadeIn:create(6/60);
	
	self.headIconLineTop:runAction(cc.Sequence:create(cc.DelayTime:create(95/60) , cc.Spawn:create(headIconLineTop1 , headIconLineTop2)));

	local headIconLineBottom1 = cc.Sequence:create(cc.ScaleTo:create(6/60 , 1.3 , 1.3) , cc.ScaleTo:create(5/60 , 1 , 1));
	local headIconLineBottom2 = cc.FadeIn:create(6/60);
	
	self.headIconLineBottom:runAction(cc.Sequence:create(cc.DelayTime:create(95/60) , cc.Spawn:create(headIconLineBottom1 , headIconLineBottom2)));
end
]]
return HeaderPanel;
