local HomeBasePanel = class("HomeBasePanel" , require('app.layer.BaseLayer'))
local scheduler = cc.Director:getInstance():getScheduler();
local MessageBoxType = Enum:getTable('MessageBoxType')
local fonts = Enum:getTable("SystemFont");
local levelLockItemIds = Enum:getTable("levelLockItemIds");
local imagePath = 'image/home/'



local homeBtnPos = {
	[1] = cc.p(-49 , 38),-- 军械库
	[2] = cc.p(-140 , 289),-- 爱恋 
	[3] = cc.p(93 , 409),-- 图书馆
	[4] = cc.p(-61 , 168),-- 重构中心
	[5] = cc.p(187 , 194),-- 竞技场--TAG_TREATMENT
	[6] = cc.p(177 , 366),-- 试炼之战
	[7] = cc.p(66 , -197),-- 融合中心
	[8] = cc.p(137 , -43),-- 随机商店
	[9] = cc.p(168 , -366),-- 迷宫
	[10] = cc.p(-128 , -337),-- 共鸣水晶
	[11] = cc.p(-20 , -80),-- 多队竞技场
	[12] = cc.p(-30 , -120),-- 公会
}

local lockPosX = {
	[1] = 13,
	[2] = 13,
	[3] = -34,
	[4] = -34,
	[5] = -34,
	[6] = 13,
	[7] = -34,
	[8] = 13,
	[9] = -34,
	[10] = 13,
	[11] = 13,
	[12] = 13,
}

local labelPosX = {
	[1] = 23,
	[2] = 23,
	[3] = -21,
	[4] = -21,
	[5] = -21,
	[6] = 23,
	[7] = -21,
	[8] = 23,
	[9] = -21,
	[10] = 23,
	[11] = 23,
	[12] = 23,
}

local btnScaleX = {
	[1] = -1,-- 军械库
	[2] = -1,-- 爱恋 
	[3] = 1,-- 图书馆
	[4] = 1,-- 重构中心
	[5] = 1,-- 竞技场--TAG_TREATMENT
	[6] = -1,-- 试炼之战
	[7] = 1,-- 融合中心
	[8] = -1,-- 随机商店
	[9] = 1,-- 迷宫
	[10] = -1,-- 共鸣水晶
	[11] = -1,-- 
	[12] = -1,-- 
}

-- local homeBtnType = {
-- 	[1] = 'equip',
-- 	[2] = 'skill',
-- 	[3] = 'library',
-- 	[4] = 'card',
-- 	[5] = 'treatment',
-- 	-- [6] = 'trial',
-- 	-- [7] = 'cardCompose',
-- 	-- [8] = 'randomShop',
-- }

function HomeBasePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'HomeBasePanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_ICON;
	self.showFooter = true;
end

function HomeBasePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.bg = cc.Sprite:create('image/bg/Bg_13.png');
	self.bg:addTo(self.root);

	--self:initFloorAni();

	self:initPanels()
    self:registerEvent();

end

function HomeBasePanel:initPanels()

	self.homeBtnList = {};

	for _k , tag in pairs(model.HomeModel.HomeMenuTag) do

		if IsKr and tag==model.HomeModel.HomeMenuTag.TAG_GUILD then
			goto continue;
		end

		local btnNode = cc.Node:create()
			:addTo(self.root)
			:setPosition(homeBtnPos[tag])

		self.homeBtnList[tag] = btnNode;

		local btn =  ccui.Button:create(imagePath..'home_btn_1.png',imagePath..'home_btn_1.png');
		btn:addTo(btnNode);
		btn:addClickEventListener(handler(self , self.btnClick));
		btn:setAlphaTouchEnable(true);
		btn:setTag(tag);
		btn:setScaleX(btnScaleX[tag]);

		local itemLabel = cc.Label:createWithTTF(LANG.UI_L_HOME[tag] ,  fonts.FONT_SIYUAN , 18);
		itemLabel:addTo(btnNode);
		itemLabel:enableOutline(cc.c4b(60, 60, 60 , 255) , 2);
		itemLabel:setPosition(labelPosX[tag],5);

		::continue::
	end

	--self.mainFooter = FooterPanel:create(self , self.root);
	--self.mainFooter:setHomeButton(6);
end

function HomeBasePanel:initFloorAni()
	self.animation_1 = cc.Sprite:create();
	self.animation_1:addTo(self.root);
	self.animation_1:setPosition(-274, 344);

	self.animation_2 = cc.Sprite:create();
	self.animation_2:addTo(self.root);
	self.animation_2:setPosition(30, 145);

	self.animation_3 = cc.Sprite:create();
	self.animation_3:addTo(self.root);
	self.animation_3:setPosition(84, -70);

	self.animation_4 = cc.Sprite:create(imagePath..'home_bg_4.png');
	self.animation_4:addTo(self.root);

	self.animation_5 = cc.Sprite:create();
	self.animation_5:addTo(self.root);
	self.animation_5:setPosition(0, 394);

	self.animation_6_1 = cc.Sprite:create();
	self.animation_6_1:addTo(self.root);
	self.animation_6_1:setPosition(-286, 200);

	self.animation_6_2 = cc.Sprite:create();
	self.animation_6_2:addTo(self.root);
	self.animation_6_2:setPosition(-292 , 97);

	self.animation_6_4 = cc.Sprite:create();
	self.animation_6_4:addTo(self.root);
	self.animation_6_4:setPosition(-144, 55);

	self.animation_6_3 = cc.Sprite:create();
	self.animation_6_3:addTo(self.root);
	self.animation_6_3:setPosition(-209, 137);

	self.animation_7 = cc.Sprite:create();
	self.animation_7:addTo(self.root);
	self.animation_7:setPosition(263, -105);

	self.animation_1:setBlendFunc(cc.blendFunc(GL_ONE , GL_ONE_MINUS_SRC_ALPHA));
	self.animation_2:setBlendFunc(cc.blendFunc(GL_ONE , GL_ONE_MINUS_SRC_ALPHA));
	self.animation_3:setBlendFunc(cc.blendFunc(GL_ONE , GL_ONE_MINUS_SRC_ALPHA));
	self.animation_4:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_DST_ALPHA));
	self.animation_6_1:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
	self.animation_6_2:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
	self.animation_6_3:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
	self.animation_6_4:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
end

function HomeBasePanel:registerEvent( )
	
	EventManager:RegisterEvent(EventType.NetworkRetBaseSkillLevelUpComplete, handler(self, self.retBaseSkillLevelUpComplete));
	EventManager:RegisterEvent(EventType.NetworkRetBaseCardLevelUpComplete, handler(self, self.retBaseCardLevelUpComplete));
	-- EventManager:RegisterEvent(EventType.NetworkRetBaseTreatmentLevelUpComplete, handler(self, self.retBaseTreatmentLevelUpComplete));
	EventManager:RegisterEvent(EventType.NetworkRetBaseInfo, handler(self, self.retBaseInfo));
	-- EventManager:RegisterEvent(EventType.NetworkRetBaseLevelUp, handler(self, self.retBaseLevelUp));
	-- EventManager:RegisterEvent(EventType.UIHomeBaseUpdateEquip, handler(self, self.updateEquip));
	-- EventManager:RegisterEvent(EventType.UIHomeBaseUpdateSkill, handler(self, self.updateSkill));
	-- EventManager:RegisterEvent(EventType.UIHomeBaseUpdateLibrary, handler(self, self.updateLibrary));
	-- EventManager:RegisterEvent(EventType.UIHomeBaseUpdateTreatment, handler(self, self.updateTreatment));

	EventManager:RegisterEvent(EventType.UIHomeBaseRedDotShow, handler(self, self.updateRedDotShow))
	EventManager:RegisterEvent(EventType.UIEventUnlockChange, handler(self, self.updateLevelLock));
	--EventManager:RegisterEvent(EventType.DailyRoundInfo, handler(self, self.updateRedDotShow))

end

function HomeBasePanel:onEnter()
	self.showLevelUpFlag = false;
	--Network.NetworkManager:Send(Network.NetworkCmdType.req_base_info , {});
	self:onShow();
	self:updateVisible();
	self.root:setVisible(true);
	EventManager:FireEvent(EventType.UIFooterUpdateSelect,5);
	--self.mainFooter:enterFooter()
end

function HomeBasePanel:retBaseInfo(msg)
	self:onShow()
end

function HomeBasePanel:onShow()
	self.baseType = 0;

	--for _k , tag in pairs(model.HomeModel.HomeMenuTag) do
	--	if tag ~= 5 then
	--		self.homeBtnList[tag]:setProgress()
	--	end
	--end

	--self:showAllAni();

	self:updateLock(model.HomeModel.HomeMenuTag.TAG_CARD_COMPOSE)
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_RANDOMSHOP)
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_TRIAL)
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_MAZE)
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_LIBRARY)
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_CARD)  
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_EQUIP)  
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_ARENA) 
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_FUTURECARD)
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_MULTARENA)
	self:updateLock(model.HomeModel.HomeMenuTag.TAG_GUILD)

	--self:updateRedDotShow(model.HomeModel.HomeMenuTag.TAG_SKILL);
	self:updateRedDotShow(model.HomeModel.HomeMenuTag.TAG_LIBRARY);
	--self:updateRedDotShow(model.HomeModel.HomeMenuTag.TAG_RANDOMSHOP);
	self:updateRedDotShow(model.HomeModel.HomeMenuTag.TAG_CARD);
	self:updateRedDotShow(model.HomeModel.HomeMenuTag.TAG_EQUIP);
	self:updateRedDotShow(model.HomeModel.HomeMenuTag.TAG_ARENA);
	self:updateRedDotShow(model.HomeModel.HomeMenuTag.TAG_GUILD);
	-- for i=1,8 do
	-- 	self:UIHomeBaseRedDotShow(i)
	-- end

	--self:updateUI();
	--self:setSchedule(true);
	-- self.m_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.updateUI), 1, false);
end

function HomeBasePanel:setSchedule( bTrue )
	
	if self.scheduleState == bTrue then
		return 
	end
	self.scheduleState = bTrue
	if bTrue then
		TimeManager:registUpdateEvent('HomeBasePanel',handler(self,self.updateUI),true);
	else
		TimeManager:registUpdateEvent('HomeBasePanel',nil,true);
	end

end

function HomeBasePanel:showAllAni(  )
	--if self.showAni == true  then
	--	return ;
	--end
--
	--self.showAni = true ;

	local animation_1 = FrameEffectManager:createFrameAnimation('home_1', 35, 24)
	local animation_2 = FrameEffectManager:createFrameAnimation('home_2', 18, 24)
	local animation_3 = FrameEffectManager:createFrameAnimation('home_3', 20, 10)
	local animation_5 = FrameEffectManager:createFrameAnimation('home_5', 18, 24)
	local animation_7 = FrameEffectManager:createFrameAnimation('home_7', 20, 24)

	self:stopAllActions();
	
	self.animation_1:runAction(cc.RepeatForever:create(cc.Animate:create(animation_1)));
	self.animation_2:runAction(cc.RepeatForever:create(cc.Animate:create(animation_2)));
	self.animation_3:runAction(cc.RepeatForever:create(cc.Animate:create(animation_3)));
	self.animation_5:runAction(cc.RepeatForever:create(cc.Animate:create(animation_5)));
	self.animation_7:runAction(cc.RepeatForever:create(cc.Animate:create(animation_7)));

	self.animation_4:setOpacity(255)
	self.animation_4:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeOut:create(0.5) , cc.FadeIn:create(0.5))));

	self.animation_6_1:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.06) , cc.CallFunc:create(function()
		local n = math.random(0 , 5);
		self.animation_6_1:setTexture(imagePath..'/home_6/6_1/'..n..'.png');
	end))));

	self.animation_6_2:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.06) , cc.CallFunc:create(function()
		local n = math.random(0 , 5);
		self.animation_6_2:setTexture(imagePath..'/home_6/6_2/'..n..'.png');
	end))));

	self.animation_6_3:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.06) , cc.CallFunc:create(function()
		local n = math.random(0 , 5);
		self.animation_6_3:setTexture(imagePath..'/home_6/6_3/'..n..'.png');
	end))));

	self.animation_6_4:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.06) , cc.CallFunc:create(function()
		local n = math.random(0 , 5);
		self.animation_6_4:setTexture(imagePath..'/home_6/6_4/'..n..'.png');
	end))));


end

function HomeBasePanel:updateSkill()
	self.homeBtnList[model.HomeModel.HomeMenuTag.TAG_SKILL]:setProgress()
end

function HomeBasePanel:updateLibrary()
	self.homeBtnList[model.HomeModel.HomeMenuTag.TAG_LIBRARY]:setProgress()
end

-- function HomeBasePanel:updateTreatment()
-- 	self.homeBtnList[model.HomeModel.HomeMenuTag.TAG_TREATMENT]:setProgress()
-- end

function HomeBasePanel:updateUI()
	local startSchedule = false;

	for _k , tag in pairs(model.HomeModel.HomeMenuTag) do
		-- if i ~= 5 then
		-- 	self.homeBtnList[i]:updateLevelUp();
		-- end
		-- self.homeBtnList[tag]:updateLevelUp();

	end
	
	-- local homeBase = model.HomeModel:getHomeBase()
	-- for i = 1 , 5 do
	-- 	local data = homeBase[homeBtnType[i]];
	-- 	if data then
	-- 		-- self.homeBtnList[i]:updateLevelUp(data)
	-- 		self.homeBtnList[i]:updateLevelUp();

	-- 		if data.state == 1 then
	-- 			startSchedule = true;

	-- 			if data.time <= 0 and not data.send and self.baseType == i then
	-- 					model.HomeModel:setSend(homeBtnType[i] , true);
	-- 					self:sendLevelUpComplete(i);
	-- 				end
	-- 			end
	-- 		end


	-- 	end
	-- end

	self:setSchedule(startSchedule)

end

-- function HomeBasePanel:sendLevelUpComplete(baseType)
-- 	if baseType == 1 then
-- 		Network.NetworkManager:Send(Network.NetworkCmdType.req_base_equip_level_up_complete , {});
-- 	elseif baseType == 2 then
-- 		Network.NetworkManager:Send(Network.NetworkCmdType.req_base_skill_level_up_complete , {});
-- 	elseif baseType == 4 then
-- 		Network.NetworkManager:Send(Network.NetworkCmdType.req_base_card_level_up_complete , {});
-- 	elseif baseType == 5 then
-- 		Network.NetworkManager:Send(Network.NetworkCmdType.req_base_treatment_level_up_complete , {});
-- 	end
-- end

function HomeBasePanel:retBaseSkillLevelUpComplete(msg)
	--Prompt:Show('科研所升级成功');
	--self:updateSkill();
	--self:updateUI();
	--AudioManager:playEffect(Conf.cardHeroLevelUp);
end

function HomeBasePanel:retBaseCardLevelUpComplete(msg)
	-- Prompt:Show('重构中心升级成功');
	-- self:updateUI();
	-- AudioManager:playEffect(Conf.cardHeroLevelUp);
end

-- function HomeBasePanel:retBaseTreatmentLevelUpComplete(msg)
-- 	Prompt:Show('医疗室升级成功');
-- 	self:updateTreatment();
-- 	self:updateUI();
-- 	AudioManager:playEffect(Conf.cardHeroLevelUp);
-- end


-- function HomeBasePanel:retBaseLevelUp(msg)
-- 	self:updateUI();
-- end

function HomeBasePanel:btnClick(sender , event)
	local baseType = sender:getTag();
	self:homeBtnClick(baseType)
end
function HomeBasePanel:homeBtnClick(baseType)
	AudioManager:playEffect(Conf.buttonClick);
	if baseType == nil or baseType == -1 then
		return 
	end
	if self:checkClickLock(baseType) then
		return ;
	end

	self.baseType = baseType

	if baseType == model.HomeModel.HomeMenuTag.TAG_EQUIP then
		UIManager:push('EquipComposePanel');
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_LOVE then
		UIManager:push('CardLoveListPanel');
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_CARD then
		UIManager:push('CardLevelUpStarCardListPanel' , 'HomeBasePanel');
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_ARENA then
		UIManager:push('ArenaPanel')
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_TRIAL then
		if tools.ConfigStateTools:checkLockById(2601) then
			UIManager:push('TrialPanel');
		else
			if model.TrialModel:getFinshTrialId() >= 150 then
				UIManager:push('TrialSelPanel');
			else
				UIManager:push('TrialPanel');
			end
		end
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_CARD_COMPOSE then
		UIManager:push('CardResolvePanel');
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_RANDOMSHOP then
		UIManager:push('StorePanel');
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_MAZE then
		if not model.EventModel:getLockStateEvent() then
			UIManager:push('EventMainPanel');
		else
			Prompt:Show(LANG.UI_EVENT_31);
		end
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_FUTURECARD then
		UIManager:push('FutureCardPanel');
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_MULTARENA then
		UIManager:push('ArenaMultPanel');
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_GUILD then
		UIManager:push('GuildPanel')
	end
end

function HomeBasePanel:checkClickLock( baseType )

	local locked,lockLv = model.HomeModel:getLockStateByType(baseType);

	if locked then
		Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
	end

	return locked

end

function HomeBasePanel:updateVisible()
	tools.ConfigStateTools:setVisibleByType(Enum:getTable('ConfigStateType').HOME , self.homeBtnList);
end

function HomeBasePanel:updateLock( baseType )

	local locked,lockLv = model.HomeModel:getLockStateByType(baseType);
	tools.LevelLockTools:setLockToNode(self.homeBtnList[baseType],locked,lockLv,3,cc.p(lockPosX[baseType],5))

end

function HomeBasePanel:updateLevelLock( table_start_id )
	local menuTag = -1;
	if table_start_id == levelLockItemIds.LEVLE_LOCK_1 then
		menuTag = model.HomeModel.HomeMenuTag.TAG_RANDOMSHOP
	elseif table_start_id == levelLockItemIds.LEVLE_LOCK_9 then 
		menuTag = model.HomeModel.HomeMenuTag.TAG_TRIAL
	elseif table_start_id == levelLockItemIds.LEVLE_LOCK_15 then 
		menuTag = model.HomeModel.HomeMenuTag.TAG_CARD
	--elseif table_start_id == levelLockItemIds.LEVLE_LOCK_17 then 
	--	menuTag = model.HomeModel.HomeMenuTag.TAG_CARD_COMPOSE
	--elseif table_start_id == levelLockItemIds.LEVLE_LOCK_11 then 
	--	menuTag = model.HomeModel.HomeMenuTag.TAG_SKILL
	elseif table_start_id == levelLockItemIds.LEVLE_LOCK_14 then 
		menuTag = model.HomeModel.HomeMenuTag.TAG_LIBRARY
	elseif table_start_id == levelLockItemIds.LEVLE_LOCK_23 then 
		menuTag = model.HomeModel.HomeMenuTag.TAG_MAZE
	elseif table_start_id == levelLockItemIds.LEVLE_LOCK_18 then 
		menuTag = model.HomeModel.HomeMenuTag.TAG_EQUIP
	elseif table_start_id == levelLockItemIds.LEVLE_LOCK_35 then 
		menuTag = model.HomeModel.HomeMenuTag.TAG_FUTURECARD
	elseif table_start_id == levelLockItemIds.LEVLE_LOCK_25 then 
		menuTag = model.HomeModel.HomeMenuTag.TAG_MULTARENA
	elseif table_start_id == levelLockItemIds.LEVLE_LOCK_10 then 
		menuTag = model.HomeModel.HomeMenuTag.TAG_GUILD
	end
	if menuTag ~= -1 then
		self:updateLock(menuTag);
	end

end

function HomeBasePanel:updateRedDotShow( baseType )
	--刷新红点
	if baseType == nil or baseType == -1 then
		return 
	end
	if baseType == model.HomeModel.HomeMenuTag.TAG_EQUIP then
		local state = model.HomeModel:getEquipActiveState()
		tools.RedDotTools:setRedDotToNode(self.homeBtnList[baseType],state,nil,cc.p(100,23));
	--elseif baseType == model.HomeModel.HomeMenuTag.TAG_SKILL then
	--	local state = model.HomeModel:getRedDotStateSkill();
	--	tools.RedDotTools:setRedDotToNode(self.homeBtnList[baseType],state,nil,cc.p(10,65));
		
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_LIBRARY then
		local state = model.HomeModel:getRedDotStateLibraryCollection();
		tools.RedDotTools:setRedDotToNode(self.homeBtnList[baseType],state,nil,cc.p(10,65));
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_CARD then
		local state = model.HomeModel:getCardStarActiveState()
		tools.RedDotTools:setRedDotToNode(self.homeBtnList[baseType],state,nil,cc.p(57,23));

	elseif baseType == model.HomeModel.HomeMenuTag.TAG_ARENA then
		local state = model.ArenaModel:getRedDotStateArena();
		tools.RedDotTools:setRedDotToNode(self.homeBtnList[baseType],state,nil,cc.p(57,23));
	elseif baseType == model.HomeModel.HomeMenuTag.TAG_TRIAL then

	elseif baseType == model.HomeModel.HomeMenuTag.TAG_GUILD then
		local guildState = model.GuildModel:getRedDotStateGuild();
		tools.RedDotTools:setRedDotToNode(self.homeBtnList[baseType],guildState,nil,cc.p(100,23))

	elseif baseType == model.HomeModel.HomeMenuTag.TAG_CARD_COMPOSE then

	--elseif baseType == model.HomeModel.HomeMenuTag.TAG_RANDOMSHOP then
--
	--	local redDotState = model.ShopModel:getRedDotStateRandomShop()
	--	tools.RedDotTools:setRedDotToNode(self.homeBtnList[baseType],redDotState,nil,cc.p(10,65)) --cc.p(40,145)
	--elseif baseType == model.HomeModel.HomeMenuTag.TAG_DAILYROUND then
	--	local redDotState = model.DailyRoundModel:getRedDotStateDailyRound()
	--	tools.RedDotTools:setRedDotToNode(self.homeBtnList[baseType],redDotState,nil,cc.p(10,65)) --cc.p(40,145)
	end
end


function HomeBasePanel:onClickBack()
	UIManager:switch('MainPanel');
end
function HomeBasePanel:stopAllActions()
	self.animation_1:stopAllActions();
	self.animation_2:stopAllActions();
	self.animation_3:stopAllActions();
	self.animation_4:stopAllActions();
	self.animation_5:stopAllActions();
	self.animation_7:stopAllActions();

	self.animation_6_1:stopAllActions();
	self.animation_6_2:stopAllActions();
	self.animation_6_3:stopAllActions();
	self.animation_6_4:stopAllActions();
end
function HomeBasePanel:onLeave()
	-- if self.m_scheduleHandler then
	-- 	scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
	-- 	self.m_scheduleHandler = nil 
	-- end
	self:setSchedule(false)

	--self:stopAllActions();
    tools.RedDotTools:pushHomeBaseRedDot(1)

	self.root:setVisible(false);
end

-- 引导相关
function HomeBasePanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 28 then
		local btn = self.homeBtnList[8];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 61 then
		local btn = self.homeBtnList[9];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 68 or guideNo == 87 then
		local btn = self.homeBtnList[6];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 72 then
		local btn = self.homeBtnList[5];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return HomeBasePanel;
