local HomeBaseSkillPanel = class("HomeBaseSkillPanel" , require('app.layer.BaseLayer'))
local scheduler = cc.Director:getInstance():getScheduler();
local MessageBoxType = Enum:getTable('MessageBoxType')
local fonts = Enum:getTable("SystemFont");
local homeImagePath = 'image/home/homeSkill/'

function HomeBaseSkillPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'HomeBaseSkillPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function HomeBaseSkillPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self.curSkillId = -1;
	self.skillIds = {};
	self:initPanels()
end

function HomeBaseSkillPanel:initPanels()

	local bg = cc.Sprite:create('image/bg/Bg_5.png');
	bg:addTo(self.root);

	local bg = cc.Sprite:create('image/bg/Bg_role_1.png');
	bg:addTo(self.root);
	bg:setPosition(157,18)
	
	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(602,648));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -135);

	local bgPos = {cc.p(0 , 64) , cc.p(0 , -111) , cc.p(0 , -309)}
	local bgSize = {cc.size(582 , 221),cc.size(582 , 111),cc.size(582 , 267)};
	local arrowPos = {cc.p(-254 , 153) , cc.p(-254 , -83) , cc.p(-254 , -207)}
	local labelName = {LANG.UI_HOME_34,LANG.UI_HOME_35,LANG.UI_HOME_36}
	for i = 1 , 3 do

		local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
		bg:addTo(self.root);
		bg:setPosition(bgPos[i]);
    	bg:setCapInsets(cc.rect(11,11,34,28));
		bg:setContentSize(bgSize[i]);

		local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
		arrow:addTo(self.root);
		arrow:setPosition(arrowPos[i]);

		local label = cc.Label:createWithTTF(labelName[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(self.root);
		label:setAnchorPoint(0 , 0.5);
		label:setPosition(-227 , arrowPos[i].y);
		label:setTextColor(cc.c4b(160 , 200 , 255 , 255));
	end
	
	self.skillDefTypeList = {};
	for i = 1 , 3 do
		
		local unTexture = 'image/commonImg/top_2_bg_59_30.png';
		local texture = 'image/commonImg/top_1_bg_59_30.png';
		
		local label = cc.Label:createWithTTF(LANG.UI_HOME_34 , fonts.FONT_SIYUAN , 20);

		local bgBtn = ccui.Button:create(texture,texture,unTexture);
		bgBtn:addTo(self.root);
		bgBtn:setTag(i);
		bgBtn:setTitleLabel(label)
		bgBtn:setScale9Enabled(true);
		bgBtn:setPosition(-201+201*(i-1) , 210)
		bgBtn:setCapInsets(cc.rect(10 , 0 , 39 , 30));
		bgBtn:setContentSize(cc.size(201 , 42));
		bgBtn:addClickEventListener(handler(self , self.switchDefTypeClick));
		label:setPosition(117.5,21);
		self.skillDefTypeList[i] = bgBtn;

		local defType = cc.Sprite:create('image/commonImg/def_type_'..i..'.png');
		defType:addTo(bgBtn);
		defType:setScale(0.5);
		defType:setPosition(79.5 , 21);
	end

	self.skillList = {};
	for i = 1 , 2 do

		self.skillList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(i == 1 and -137 or 137 , 65);

		local skillBg = ccui.Button:create(homeImagePath..'home_skill_bg_5.png' , homeImagePath..'home_skill_bg_5.png');
		skillBg:addTo(node);
		skillBg:addClickEventListener(handler(self , self.skillClick));
		self.skillList[i].skillBg = skillBg;

		local skillIcon = cc.Sprite:create();
		skillIcon:addTo(node);
		self.skillList[i].skillIcon = skillIcon;

		local skillName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
		skillName:addTo(node);
		skillName:setPosition(0 , -80);
		self.skillList[i].skillName = skillName;

		local skillSelect = cc.Sprite:create(homeImagePath..'home_skill_bg_6.png');
		skillSelect:addTo(node);
		self.skillList[i].skillSelect = skillSelect;

		local skillLv = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
		skillLv:addTo(node);
		skillLv:setAnchorPoint(1 , 0.5);
		skillLv:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
		skillLv:setPosition(45 , -45);
		self.skillList[i].skillLv = skillLv;
	end

	--属性
	self.attList = {};
	for i = 1 , 2 do
		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(i == 1 and -136 or 136 , -132);

		local bg = cc.Sprite:create(homeImagePath..'home_skill_att_'..i..'.png');
		bg:addTo(node);

		local label = cc.Label:createWithTTF(LANG.UI_CARD_ATT_NAME[i] , fonts.FONT_SIYUAN , 17);
		label:addTo(node);
		label:enableOutline(i == 1 and cc.c3b(10,150,90) or cc.c3b(210,80,0), 2);
		label:setPosition(-97 , 0);
		
		self.attList[i] = {};
		
		local addNode = cc.Node:create();
		addNode:addTo(node);
		self.attList[i].addNode = addNode;

		local addCurValue = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 17);
		addCurValue:addTo(addNode);
		addCurValue:setPosition(-3 , 0);
		self.attList[i].addCurValue = addCurValue;

		local bg = cc.Sprite:create('image/commonImg/arrow_1_bg.png');
		bg:addTo(addNode);
		bg:setPosition(42 , 0);

		local addNextValue = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 17);
		addNextValue:addTo(addNode);
		addNextValue:setPosition(86 , 0);
		addNextValue:setTextColor(cc.c3b(246,255,0));
		self.attList[i].addNextValue = addNextValue;

		local curValue = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 17);
		curValue:addTo(node);
		curValue:setPosition(43 , 0);
		self.attList[i].curValue = curValue;

	end

	local itemIcon = ResTable:getValue('item' , SKILL_MONEY , 'icon');
	self.costList = {};
	for i = 1 , 2 do
		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(i == 1 and -137 or 145 , -266);

		local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
		bg:addTo(node);
    	bg:setCapInsets(cc.rect(11,11,34,28));
		bg:setContentSize(cc.size(267,42));

		local costIcon = cc.Sprite:create('image/icon/I'..itemIcon..'.png');
		costIcon:addTo(node);
		costIcon:setScale(0.5);
		costIcon:setPosition(-112 , 0);
		
		local label = cc.Label:createWithTTF(i == 1 and LANG.UI_HOME_37 or LANG.UI_HOME_38, fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
		label:setPosition(-60 , 0);

		self.costList[i] = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.costList[i]:addTo(node);
		self.costList[i]:setAnchorPoint(1 , 0.5);
		self.costList[i]:setPosition(i== 1 and 75 or  117, 0);
	end

	self.costTimeList = {};
	for i = 1 , 2 do
		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(i == 1 and -137 or 145 , -316);

		local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
		bg:addTo(node);
    	bg:setCapInsets(cc.rect(11,11,34,28));
		bg:setContentSize(cc.size(267,42));
		
		local label = cc.Label:createWithTTF(i == 1 and LANG.UI_HOME_39 or LANG.UI_HOME_40, fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setPosition(-84.5 , 0);

		self.costTimeList[i] = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
		self.costTimeList[i]:addTo(node);
		self.costTimeList[i]:setAnchorPoint(1 , 0.5);
		self.costTimeList[i]:setPosition(123 , 0);
	end

	self.addBtn = ccui.Button:create('image/card/cardLevelUp/card_level_up_4.png');
	self.addBtn:addTo(self.root);
	self.addBtn:setPosition(-26 , -266);
	self.addBtn:addClickEventListener(function()
		UIManager:push('StorePanel' , Enum:getTable('CommonShopType').GUILD);
	end);

	self.btnLabel = cc.Label:createWithTTF(LANG.UI_HOME_41 , fonts.FONT_SIYUAN , 20);
	self.btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

	self.levelUpBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.levelUpBtn:addTo(self.root);
	self.levelUpBtn:setPosition(0 , -410);
	self.levelUpBtn:addClickEventListener(handler(self , self.levelUpBtnClick));
	self.levelUpBtn:setTitleLabel(self.btnLabel);

	EventManager:RegisterEvent(EventType.NetworkRetBaseSkillInfo, handler(self, self.retBaseSkillInfo));
	EventManager:RegisterEvent(EventType.NetworkRetBaseSkillLevelUp, handler(self, self.retBaseSkillLevelUp));
	EventManager:RegisterEvent(EventType.NetworkRetBaseSkillClearCd, handler(self, self.retBaseSkillClearCd));

end

function HomeBaseSkillPanel:initSpineAni()

    local spine_res = 'NPC001_Spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then

		self.skeletonNode = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.skeletonNode:setPosition(cc.p(200,-30))

        self.skeletonNode:setMix('idle1','idle2',0.1);
		self.skeletonNode:setAnimation(0, "idle1", false)
		self.skeletonNode:addAnimation(0, "idle2", true)

        self.skeletonNode:addTo(self.root)
	
	else
		Prompt:Show(LANG.UI_CARD_2);
	end
end

function HomeBaseSkillPanel:onEnter()
	self.root:setVisible(true);
	Network.NetworkManager:Send(Network.NetworkCmdType.req_base_skill_info , {});
end

function HomeBaseSkillPanel:retBaseSkillInfo(msg)
	self.curSkillId = -1;
	self:onShow();

	self:setSchedule(true);
end
function HomeBaseSkillPanel:setSchedule( bTrue )
	
	if self.scheduleState == bTrue then
		return 
	end
	self.scheduleState = bTrue
	if bTrue then
		TimeManager:registUpdateEvent('HomeBaseSkillPanel',handler(self,self.updateUI),true);
	else
		TimeManager:registUpdateEvent('HomeBaseSkillPanel',nil,true);
	end

end
function HomeBaseSkillPanel:updateUI()
	local skillCd = model.HomeModel:getSkillCd();
	self.costTimeList[2]:setString(GlobalFunctions:ChangeTime(skillCd));

	self.levelUpBtn:setTag((skillCd < 14400) and 1 or 2);
	self.btnLabel:setString((skillCd < 14400) and LANG.UI_BASE_SKILL_6 or LANG.UI_BASE_SKILL_7);
end

function HomeBaseSkillPanel:onShow()
	local skillLevels = model.HomeModel:getBaseSkillLevel();
	
	self.skillDefTypeIds = {};
	for skillId , level in pairs(skillLevels) do
		local baseSkillData = ResTable:getMultiValue('base_skill_lv' , skillId , 1);
		if not self.skillDefTypeIds[baseSkillData.def_type] then
			self.skillDefTypeIds[baseSkillData.def_type] = {};
		end
		table.insert(self.skillDefTypeIds[baseSkillData.def_type] , baseSkillData);
	end

	for defType , skillData in pairs(self.skillDefTypeIds) do
		if #skillData > 1 then
			table.sort(skillData , function(first , second)
				return first.skill_id < second.skill_id;
			end);
		end
	end

	self.curDefType = 1;
	self:updateDefTypeSkill();
end

function HomeBaseSkillPanel:switchDefTypeClick(sender , event)
	local defType = sender:getTag();

	if defType == self.curDefType then
		return;
	end

	self.curDefType = defType;

	self:updateDefTypeSkill();
end

function HomeBaseSkillPanel:updateDefTypeSkill()

	self.curSkillId = -1;

	for _k , btn in pairs(self.skillDefTypeList) do
		local label = btn:getTitleLabel();
		if _k == self.curDefType then
			btn:setBright(true)
			label:setTextColor(cc.c3b(255 , 255 , 255));
		else
			btn:setBright(false)
			label:setTextColor(cc.c3b(180 , 180 , 180));
		end
	end

	if self.skillDefTypeIds[self.curDefType] then

		local skillLevels = model.HomeModel:getBaseSkillLevel();

		for i = 1 , #self.skillDefTypeIds[self.curDefType] do

			local skillData = self.skillDefTypeIds[self.curDefType][i];
			local skillId = skillData.skill_id;
			local curSkillLevel = skillLevels[skillId];

			self.skillList[i].skillBg:setTag(skillId);
			self.skillList[i].skillIcon:setTexture('image/home/home_base_skill_type_'..i..'_'..self.curDefType..'.png');
			self.skillList[i].skillLv:setString(tostring('Lv'..tostring(curSkillLevel)));
			self.skillList[i].skillName:setString(tostring(skillData.name));

			if self.curSkillId == -1 then
				self.curSkillId = skillId;
			end
		end

		self:switchSkill();
	end
end

function HomeBaseSkillPanel:skillClick(sender , event)
	local curSkillId = sender:getTag();
	AudioManager:playEffect(Conf.buttonClick)
	if self.curSkillId == curSkillId then
		return;
	end
	self.curSkillId = curSkillId;
	self:switchSkill();
end

function HomeBaseSkillPanel:switchSkill()

	local skillLevels = model.HomeModel:getBaseSkillLevel();

	local curSkillLevel = skillLevels[self.curSkillId];

	local skillAddValue = 0
	for i , skill in pairs(self.skillList) do
		local skillId = skill.skillBg:getTag();
		if skillId == self.curSkillId then
			skill.skillSelect:setVisible(true);
			skill.skillLv:setString('Lv'..tostring(curSkillLevel));
		else
			local data = ResTable:getMultiValue('base_skill_lv' , skillId , skillLevels[skillId]);
			skillAddValue = data and data.value or 0;
			skill.skillSelect:setVisible(false);
		end
	end

	local baseSkillData = ResTable:getMultiValue('base_skill_lv' , self.curSkillId , curSkillLevel);

	local nextBaseSkillData = ResTable:getMultiValue('base_skill_lv' , self.curSkillId , curSkillLevel + 1);

	local maxLevel = model.HomeModel:getBaseSkillMaxLevel(self.curSkillId);

	
	local useData = baseSkillData or nextBaseSkillData;

	local haveNum = model.ItemModel:getItemNum(SKILL_MONEY);
	self.costList[1]:setString(tostring(haveNum));
	self.costList[1]:setPositionX(117);
	self.addBtn:setVisible(false);

	if nextBaseSkillData and curSkillLevel < maxLevel then
		for i = 1 , 2 do
			if i == useData.type then
				self.attList[i].addNode:setVisible(true);
				self.attList[i].curValue:setVisible(false);
				self.attList[i].addCurValue:setString('+'..tostring(baseSkillData and baseSkillData.value/100 or 0)..'%');
				self.attList[i].addNextValue:setString('+'..tostring(nextBaseSkillData.value/100 or 0)..'%');
			else
				self.attList[i].addNode:setVisible(false);
				self.attList[i].curValue:setVisible(true);
				self.attList[i].curValue:setString('+'..tostring(skillAddValue/100)..'%');
			end
		end
	
		if haveNum < nextBaseSkillData.cost then
			self.costList[1]:setPositionX(75);
			self.addBtn:setVisible(true);
		end

		self.costList[2]:setString(tostring(nextBaseSkillData.cost));
		self.costTimeList[1]:setString(tostring(GlobalFunctions:ChangeTime(nextBaseSkillData.cd)));
	else
		for i = 1 , 2 do
			if i == useData.type then
				self.attList[i].addNode:setVisible(true);
				self.attList[i].curValue:setVisible(false);
				self.attList[i].addCurValue:setString('+'..tostring(baseSkillData and baseSkillData.value/100 or 0)..'%');
				self.attList[i].addNextValue:setString('+'..tostring(baseSkillData and baseSkillData.value/100 or 0)..'%');
			else
				self.attList[i].addNode:setVisible(false);
				self.attList[i].curValue:setVisible(true);
				self.attList[i].curValue:setString('+'..tostring(skillAddValue/100)..'%');
			end
		end
		self.costList[2]:setString('0');
		self.costTimeList[1]:setString('0');
	end

	self:updateUI();
end


function HomeBaseSkillPanel:levelUpBtnClick(sender , event)
	local tag = sender:getTag();
	AudioManager:playEffect(Conf.confirmButton)
	local msg = {};

	if tag == 1 then

		local maxLevel = model.HomeModel:getBaseSkillMaxLevel(self.curSkillId);

		local skillLevels = model.HomeModel:getBaseSkillLevel();
		local curSkillLevel = skillLevels[self.curSkillId];

		local nextBaseSkillData = ResTable:getMultiValue('base_skill_lv' , self.curSkillId , curSkillLevel + 1);
		if nextBaseSkillData and curSkillLevel < maxLevel then
			if model.ItemModel:getItemNum(SKILL_MONEY) < nextBaseSkillData.cost then
				Prompt:Show(LANG.UI_HOME_32);
			else
				msg.skill_id = self.curSkillId;
				Network.NetworkManager:Send(Network.NetworkCmdType.req_base_skill_level_up , msg);
			end
		else
			Prompt:Show(LANG.UI_HOME_33);
		end
	elseif tag == 2 then
		local cd = model.HomeModel:getSkillCd();
		local count = math.floor(cd / 3600);
		count = count + ((cd % 3600) > 0 and 1 or 0);
		MessageBox:create(string.format(LANG.UI_GUILD_46,(count * 10)),MessageBoxType.CANCEL_OK,function()
			Network.NetworkManager:Send(Network.NetworkCmdType.req_base_skill_clear_cd , msg);
		end);
	end
end

function HomeBaseSkillPanel:retBaseSkillLevelUp(msg)
	Prompt:Show(LANG.UI_HOME_30);
	--AudioManager:playCVStopBefor(model.UserModel:getKanban(), 'Sortie');
	AudioManager:playEffect(Conf.cardHeroLevelUp);
	self.curSkillId = msg.skillId;

	self:switchSkill();
end

function HomeBaseSkillPanel:retBaseSkillClearCd(msg)
	Prompt:Show(LANG.UI_HOME_31);
	self:updateUI();
end

function HomeBaseSkillPanel:onClickBack()
	UIManager:pop('HomeBaseSkillPanel');
	--UIManager:push('HomeBasePanel');
end

function HomeBaseSkillPanel:onLeave()
	-- if self.m_scheduleHandler then
	-- 	scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
	-- 	self.m_scheduleHandler = nil 
	-- end
	self:setSchedule(false);
	EventManager:FireEvent(EventType.UIHeaderPanelUpdateFP); -- 战斗力刷新
	self.root:setVisible(false);

	--tools.RedDotTools:pushHomeBaseRedDot(2,1);
end

return HomeBaseSkillPanel;
