local KanBanSelectPanel = class("KanBanSelectPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local KanbanType = Enum:getTable("KanbanType");

function KanBanSelectPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'KanBanSelectPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function KanBanSelectPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function KanBanSelectPanel:initPanels()

	local bg = cc.Sprite:create('image/bg/Bg_5.png');
	bg:addTo(self.root);

	self.navi = cc.Sprite:create();
	self.navi:addTo(self.root);
	self.navi:setPosition(-14 , 118);

	local nameNode = cc.Node:create()
	:addTo(self.root)
	:setPosition(-160, 100)

	self.nameBg = cc.Sprite:create('image/setup/ui_kankan_bg_2.png');
	self.nameBg:addTo(nameNode);

	local nameTag = cc.Sprite:create('image/commonImg/arrow_bg.png');
	nameTag:addTo(nameNode);
	nameTag:setPosition(-117, 0)

	self.nameBgLabel = cc.Label:createWithTTF(LANG.UI_SETTING_3 , fonts.FONT_SIYUAN , 20);
	self.nameBgLabel:setPosition(-93 , 0);
	self.nameBgLabel:setAnchorPoint(0 , 0.5);
	self.nameBgLabel:setTextColor(cc.c4b(160 , 200 , 255 , 255));
	-- self.nameBgLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
	self.nameBgLabel:addTo(nameNode);

	self.nameLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.nameLabel:setAnchorPoint(1 , 0.5);
	self.nameLabel:setPosition(130 , 0);
	-- self.nameLabel:setTextColor(cc.c4b(60 , 60 , 60 , 255));
	-- self.nameLabel:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
	self.nameLabel:addTo(nameNode);

	local Bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	Bg:addTo(self.root);
	Bg:setPosition(0 , -215);
	Bg:setCapInsets(cc.rect(11,4,18,21));
	Bg:setContentSize(cc.size(604,478));

	local labelName = {
		LANG.UI_SETTING_KANBAN_MENU[1],
		LANG.UI_SETTING_KANBAN_MENU[2],
		LANG.UI_L_HOME[2],
		LANG.UI_SETTING_26,
	}

	self.menuList = {};
	local tags = {KanbanType.KANBAN_ROLE, KanbanType.KANBAN_AVATAR, KanbanType.KANBAN_BARE, KanbanType.KANBAN_LOVE}--1,2,3,4
	if not tools.ConfigStateTools:checkVisibleByName('CardLoveListPanel') then
		tags = {KanbanType.KANBAN_ROLE, KanbanType.KANBAN_AVATAR, KanbanType.KANBAN_BARE};--1,2,4
	end
	local menuNum = #tags;
	local menuWidth = 604 / menuNum;
	local menuStartPosX = menuWidth/2 - 604/2;
    for _k , tag in ipairs(tags) do

		local label = cc.Label:createWithTTF(labelName[tag] , fonts.FONT_SIYUAN , 18);
		label:setScaleX(tag == KanbanType.KANBAN_LOVE and -1 or 1);

		local texture = 'image/commonImg/menu_left_71_46.png';
		local unTexture = 'image/commonImg/menu_left_71_46_u.png';

		if tag == KanbanType.KANBAN_AVATAR or tag == KanbanType.KANBAN_BARE then
			texture = 'image/commonImg/menu_mid_71_46.png';
			unTexture = 'image/commonImg/menu_mid_71_46_u.png';
		end
		local bgBtn = ccui.Button:create(texture,texture,unTexture);
		bgBtn:addTo(self.root);
		bgBtn:setTag(tag);
		bgBtn:setTitleLabel(label)
		bgBtn:setScale9Enabled(true);
		bgBtn:setScaleX(tag == KanbanType.KANBAN_LOVE and -1 or 1);
		bgBtn:setCapInsets(cc.rect(10 , 0 , 51 , 46));
		bgBtn:setContentSize(cc.size(menuWidth , 46));
		bgBtn:setPosition(menuStartPosX + menuWidth*(_k-1) , 47)
		bgBtn:addClickEventListener(handler(self , self.menuClick));
		self.menuList[tag] = bgBtn;
	end

	self.light = cc.Sprite:create('image/commonImg/menu_light_1.png');
	self.light:addTo(self.root);
	self.light:setPosition(cc.p(-266.5,47 + self.menuList[1]:getContentSize().height/2));
	
	local line = cc.Sprite:create('image/commonImg/line.png');
	line:addTo(self.root);
	line:setContentSize(cc.size(604,1))
	line:setPosition(cc.p(0,-409))

	local dropTip = cc.Node:create();
	dropTip:addTo(self.root);
	dropTip:setPosition(0 , -432);
	dropTip:setLocalZOrder(110);

	local dropImg = cc.Sprite:create('image/commonImg/tip_2.png');
	dropImg:addTo(dropTip);

	local dropLabel = cc.Label:createWithTTF(LANG.UI_TEAM_35 , fonts.FONT_SIYUAN , 20);
	dropLabel:addTo(dropTip);
	dropLabel:setTextColor(cc.c3b(255 , 200 , 0));

	local width = dropImg:getContentSize().width+10;
	local labelWidth = dropLabel:getContentSize().width;
	local posX = -labelWidth / 2;
	dropImg:setPosition(posX , 0);
	dropLabel:setPosition(posX + width/2+labelWidth/2 , 0);

	--self.cardView = ccui.ScrollView:create();
	--self.cardView:setTouchEnabled(true);
	--self.cardView:setBounceEnabled(true);
	--self.cardView:setDirection(ccui.ScrollViewDir.vertical);
	--self.cardView:setContentSize(cc.size(618 , 446));
	--self.cardView:setAnchorPoint(0.5 , 0.5);
	--self.cardView:setPosition(0 , -188);
	--self.cardView:setScrollBarEnabled(false);
	--self.cardView:addTo(self.root);

	--if self.cardListView then
	--	self.cardListView:getView():removeFromParent();
	--end
	--[[
	local initData = {
        width = 604,
        height = 420,
        cellWidth = 604 ,
        cellHeight = 131,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

    }
    self.cardListView = template.TableViewTemplate:create()
    self.cardListView:initWithSizeAndItem(initData);
    self.cardListView:getView():setPosition(cc.p(-302,-401)); --0,-191
	self.cardListView:getView():addTo(self.root)
	self.cardListView:setUseCellFreed(false);
	]]
end

function KanBanSelectPanel:onEnter()
	self.selectNo = nil;
	self.selectType,self.no = model.UserModel:getKanban();
	self:switchList(1);
	self:setNavi();
	self.root:setVisible(true);
end

function KanBanSelectPanel:updateVisible()
	local visible = tools.ConfigStateTools:checkVisibleByName('CardLoveListPanel');
	if not visible then
		self.menuList[3]:setVisible(false);
		self.menuList[4]:setPositionX(-226.5 + 151*2);
	end
end

function KanBanSelectPanel:menuClick(sender , event)
	local tag = sender:getTag()
	self:switchList(tag);
end

function KanBanSelectPanel:switchList(index)

	if self.cardListView then
		self.cardListView:getView():removeFromParent();
	end

	local initData = {
        width = 604,
        height = 420,
        cellWidth = 604 ,
        cellHeight = 131,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

    }
    self.cardListView = template.TableViewTemplate:create()
    self.cardListView:initWithSizeAndItem(initData);
    self.cardListView:getView():setPosition(cc.p(-302,-401)); --0,-191
	self.cardListView:getView():addTo(self.root)

	self.cards = {};
	self.cardIndexList = {};

	self.kType = index;

	for _k , btn in pairs(self.menuList) do
		local label = btn:getTitleLabel();
		if _k == index then
			btn:setBright(true)
			label:setTextColor(cc.c3b(255 , 255 , 255));
			self.light:setPositionX(btn:getPositionX());
		else
			btn:setBright(false)
			label:setTextColor(cc.c3b(180 , 180 , 180));
		end
	end

	if index == KanbanType.KANBAN_ROLE then -- 1
		local cards = model.CardModel:getAllGetCard();
		if not cards then
			return;
		end
		for roleId , _ in pairs(cards) do
			local roleData = ResTable:getRowData('role', roleId);
			if roleData then
				local data = {roleId = roleId}
				local cardNos=model.CardModel:getCardByNo(roleId);
				local maxQualityCard = nil;
				for pid,_v in pairs(cardNos) do
					local card = model.CardModel:GetCard(pid);
					if card and (not maxQualityCard or card.quality > maxQualityCard.quality) then
						maxQualityCard = card;
					end
				end
				if maxQualityCard then
					data.quality = maxQualityCard.quality;
					data.starLv = maxQualityCard.star_lv;
				end

				table.insert(self.cards , data);
			end
		end

		if #self.cards > 1 then
			table.sort(self.cards , function(firstData , secondData)
				local firstQuality = firstData.quality;
				local secondQuality = secondData.quality;

				if not firstQuality then
					firstQuality = ResTable:getValue('role', firstData.roleId,'quality');
				end
				if not secondQuality then
					secondQuality = ResTable:getValue('role', secondData.roleId,'quality');
				end

				local firstStar = firstData.starLv;
				local secondStar = secondData.starLv;
				if not firstStar then
					firstStar = ResTable:getValue('role_pre', firstData.roleId , 'initial_star');
				end
				if not secondStar then
					secondStar = ResTable:getValue('role_pre', secondData.roleId , 'initial_star');
				end

				if firstStar ~= secondStar then
					return firstStar > secondStar;
				end
				if firstQuality ~= secondQuality then
					return firstQuality > secondQuality;
				end
				return firstData.roleId < secondData.roleId;
			end);
		end
	elseif index == KanbanType.KANBAN_AVATAR then -- 2
		local avatars = model.CardModel:getAllAvatar();
		local haveIcon = {};
		for _k , avatar in pairs(avatars) do
			if not haveIcon[avatar.no] and avatar.overdue_time == 0 then
				haveIcon[avatar.no] = 1;
				table.insert(self.cards , avatar.no);
			end
		end

		if #self.cards > 1 then
			table.sort(self.cards , function(firstNo , secondNo)
				local firstRoleId = ResTable:getValue('role_avatar' , firstNo,'role_id');
				local secondRoleId = ResTable:getValue('role_avatar' , secondNo,'role_id');

				local firstData = ResTable:getRowData('role', firstRoleId);
				local secondData = ResTable:getRowData('role', secondRoleId);

				if firstData.quality ~= secondData.quality then
					return firstData.quality > secondData.quality;
				end
				return firstNo < secondNo;
			end);
		end
	elseif index == KanbanType.KANBAN_LOVE then -- 3
		local loveData = model.CardModel:getLoveData();
		if not loveData then
			return
		end

		self.cards = {};
		for _k , data in pairs(loveData) do
			if data.loveLevel > 0 then
				for _k , lData in pairs(data.loveData) do
					if lData.love_lv > 0 and lData.love_lv <= data.loveLevel then
						table.insert(self.cards , lData.id);
					end
				end
			end
		end

		if #self.cards > 1 then
			table.sort(self.cards , function(firstId , secondId)
				return firstId < secondId;
			end);
		end

	elseif index == KanbanType.KANBAN_BARE then -- 4
		local bareData = model.BareCollectModel:getBareData()
		if not bareData then
			return
		end

		self.cards = {};

		for _k , data in pairs(bareData) do
			if data.activeState == 1 and data.activeNum >= 12 then
				table.insert(self.cards , data.bare_id);
			end
		end

		if #self.cards > 1 then
			table.sort(self.cards , function(firstBareId , secondBareId)
				return firstBareId < secondBareId;
			end);
		end
	end
	

	for idx , card in ipairs(self.cards) do
		local index = math.ceil(idx / 5);
		if not self.cardIndexList[index] then
			self.cardIndexList[index] = {};
		end
		table.insert(self.cardIndexList[index] , card);
	end

	self.cardListView:setDataCount(#self.cardIndexList)
	self.cardListView:reloadData();
end

function KanBanSelectPanel:cellItemTouch(table , cell)
	if self.selectNo then
		if self.selectType == self.kType and self.selectNo == self.no then
			return;
		end

		for index , cardList in ipairs(self.cardIndexList) do
			local cell = self.cardListView:cellAtIndex(index - 1);
			if cell then
				local children = cell:getChildren();
				for _idx , child in ipairs(children) do
					local tag = 0;
					if self.kType == KanbanType.KANBAN_LOVE or self.kType == KanbanType.KANBAN_BARE then
						tag = child:getTag();
					else
						tag = child:getItemTag();
					end
					if tag == self.selectNo then
						child:setSelect(true);
					else
						child:setSelect(false);
					end
				end
			end
		end

		self.selectType = self.kType;
		self.no = self.selectNo;
		self.selectNo = nil;
		self:setNavi(true);

		local fileUtils = cc.FileUtils:getInstance();
		local fileName = model.UserModel:SelfSettingConfig();
		local settingConfig = {};
		if fileUtils:isFileExist(fileName) then
			local fileData = fileUtils:getStringFromFile(fileName);
			if fileData ~= '' then
				settingConfig = Cjson.decode(fileData);
			end
		end

		settingConfig.kanbanType = self.selectType
		settingConfig.kanban = self.no;
		fileUtils:writeStringToFile(Cjson.encode(settingConfig), fileName);

		model.UserModel:setKanban(self.selectType , self.no);

		AudioManager:playEffect(Conf.buttonClick);
		EventManager:FireEvent(EventType.UIMainPanelKanBan);
	end
end

function KanBanSelectPanel:createItem()
	local iconTemplate = ccui.ImageView:create('image/commonImg/item_quality_2.png');
	iconTemplate:addClickEventListener(handler(self , self.cardClick));
	iconTemplate:setTouchEnabled(true)
	iconTemplate:setSwallowTouches(false)

	local icon = cc.Sprite:create();
	icon:addTo(iconTemplate)
	icon:setPosition(51,51.5);
	icon:setScale(0.85,0.85);

	local select = cc.Sprite:create('image/commonImg/common_item_select.png');
	select:addTo(iconTemplate);
	select:setPosition(51,51.5);

	function iconTemplate:setSelect(visible)
		select:setVisible(visible);
	end

	function iconTemplate:Init(texture)
		icon:setTexture('image/icon/'..texture..'.png');
	end

	return iconTemplate;
end

function KanBanSelectPanel:reloadCellPanel(cell , idx)

	local cardList = self.cardIndexList[idx+1];

	if not cardList then
		return;
	end

	local typeIsSelect = self.selectType == self.kType;

	local children = cell:getChildren();
	if not children or #children <= 0 then
		for i = 1 , 5 do
			local x = 65 + 118.5 * (i - 1);
			local y = 62;
			local iconTemplate = nil;
			if self.kType == KanbanType.KANBAN_LOVE then -- 3
				iconTemplate = self:createItem();
				if cardList[i] then
					local loveIcon = ResTable:getValue('role_love' , cardList[i] , 'show_icon');
					iconTemplate:Init(loveIcon);
					iconTemplate:setTag(cardList[i]);
				else
					iconTemplate:setVisible(false);
				end
				iconTemplate:setSelect(typeIsSelect and self.no == cardList[i]);
			elseif self.kType == KanbanType.KANBAN_BARE then -- 4
				iconTemplate = self:createItem();
				if cardList[i] then
					local bareData = model.BareCollectModel:getBareData(cardList[i]);
					local bareIcon = ResTable:getValue('role_resource',bareData.resource_id,'icon');
					iconTemplate:Init(bareIcon);
					iconTemplate:setTag(cardList[i]);
				else
					iconTemplate:setVisible(false);
				end
				iconTemplate:setSelect(typeIsSelect and self.no == cardList[i]);
			elseif self.kType == KanbanType.KANBAN_AVATAR then
				iconTemplate = template.ItemTemplate:create();
				iconTemplate:addItemClickEventListener(handler(self , self.cardClick));
				if cardList[i] then
					iconTemplate:Init(ROLE_AVATAR_TYPE , cardList[i]);
					iconTemplate:setItemTag(cardList[i]);
				else
					iconTemplate:setVisible(false);
				end
				iconTemplate:setSelect(typeIsSelect and self.no == cardList[i]);
			else
				iconTemplate = template.ItemTemplate:create();
				iconTemplate:addItemClickEventListener(handler(self , self.cardClick));
				local cardData = cardList[i];
				if cardData then
					if cardData.quality then
						iconTemplate:Init(ROLE_TYPE , cardData.roleId,cardData.starLv,nil,nil,cardData.quality);
					else
						iconTemplate:Init(ROLE_TYPE , cardData.roleId);
					end
					iconTemplate:setItemTag(cardData.roleId);
					iconTemplate:setSelect(typeIsSelect and self.no == cardData.roleId);
				else
					iconTemplate:setVisible(false);
				end
			end
			iconTemplate:setPosition(cc.p(x , y));
			iconTemplate:addTo(cell);
			
		end
	else
		for i = 1 , 5 do
			if cardList[i] then
				if self.kType == KanbanType.KANBAN_LOVE then
					local loveIcon = ResTable:getValue('role_love' , cardList[i] , 'show_icon');
					children[i]:setVisible(true);
					children[i]:Init(loveIcon);
					children[i]:setTag(cardList[i]);
					children[i]:setSelect(typeIsSelect and self.no == cardList[i]);
				elseif self.kType == KanbanType.KANBAN_BARE then
					local bareData = model.BareCollectModel:getBareData(cardList[i]);
					local bareIcon = ResTable:getValue('role_resource',bareData.resource_id,'icon');
					children[i]:Init(bareIcon);
					children[i]:setTag(cardList[i]);
					children[i]:setVisible(true);
					children[i]:setSelect(typeIsSelect and self.no == cardList[i]);
				elseif self.kType == KanbanType.KANBAN_AVATAR then
					children[i]:setVisible(true);
					children[i]:Init(ROLE_AVATAR_TYPE , cardList[i]);
					children[i]:setItemTag(cardList[i]);
					children[i]:setSelect(typeIsSelect and self.no == cardList[i]);
				else
					local cardData = cardList[i];
					if cardData.quality then
						children[i]:Init(ROLE_TYPE , cardData.roleId,cardData.starLv,nil,nil,cardData.quality);
					else
						children[i]:Init(ROLE_TYPE , cardData.roleId);
					end
					children[i]:setVisible(true);
					children[i]:setItemTag(cardData.roleId);
					children[i]:setSelect(typeIsSelect and self.no == cardData.roleId);
				end
			else
				children[i]:setVisible(false);
			end
		end
	end
	return cell;
end

function KanBanSelectPanel:cardClick(sender , event)
	self.selectNo = sender:getTag();
end

function KanBanSelectPanel:setNavi(showName)
	self.navi:stopAllActions();
	self.navi:setOpacity(0);
	self.navi:setPosition(-14 , 118);

	local imagePath = '';
	local roleInfoId = self.no;

	if self.selectType == KanbanType.KANBAN_ROLE then
		local roleId = ResTable:getValue('role' , self.no , 'role_id');
		imagePath = ResTable:getValue('role_resource', roleId, 'card');

		roleInfoId = roleId;

		AudioManager:downloadCV(roleId)
	elseif self.selectType == KanbanType.KANBAN_AVATAR then
		local avatarRoleId = ResTable:getValue('role_avatar' , self.no , 'role_id');
		roleInfoId = avatarRoleId;

		imagePath = ResTable:getValue('role_resource', self.no, 'card');
	elseif self.selectType == KanbanType.KANBAN_LOVE then
		local loveData = ResTable:getRowData('role_love' , self.no);
		imagePath = loveData.show_pg;
		roleInfoId = loveData.role_id
		self.navi:setPosition(0,0);
	elseif self.selectType == KanbanType.KANBAN_BARE then
		local bareData = ResTable:getRowData('bare_collect' , self.no);
		imagePath = ResTable:getValue('role_resource', bareData.resource_id, 'card');
		roleInfoId = bareData.role_id;
	end
	
	local name = ResTable:getValue('role_info' , roleInfoId , 'name');
	self.nameLabel:setString(name);

	if showName then
		Prompt:Show(string.format(LANG.UI_USER_1,(name and tostring(name) or '')));
	end

	self.navi:setTexture('image/role/'..imagePath..'.png');
	self.navi:runAction(cc.FadeIn:create(0.3));	
end
function KanBanSelectPanel:onClickBack()
	--if self.no ~= -1 then
	--	local msg = {};
	--	msg.no = self.no;
--
	--	Network.NetworkManager:Send(Network.NetworkCmdType.req_user_set_kanban, msg);
	--end
	UIManager:pop('KanBanSelectPanel');
end
function KanBanSelectPanel:onLeave()
	self.root:setVisible(false);
end
return KanBanSelectPanel;
