local LevelUpPanel = class('LevelUpPanel', require('app.layer.BaseLayer'));

local imgPath = 'image/levelUp/';
local fonts = Enum:getTable("SystemFont");

function LevelUpPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'LevelUpPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.haveSwallowLayer = true;
    self.isPopup = true;	
end

function LevelUpPanel:Init(root)
	self.root = root;
	self.root:setVisible(false)

	self:initPanels();
	self:registEvent();
end

function LevelUpPanel:initPanels()

	-- local spine_res = 'RewardPanelEffect'
	-- self.effect = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
	-- self.effect:addTo(self.root);

	self:initSpineAni();

	self.title = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 80)
		:enableOutline(cc.c3b(60, 60, 60), 2)
		:setPosition(0, 165)
		:addTo(self.root)

	self.itemList = {}

	self.wordNode = cc.Node:create()
		:setCascadeOpacityEnabled(true)
		:addTo(self.root)
		:setPosition(0, 120)

	-- self.word_bg = cc.Sprite:create(imgPath .. 'bg.png')
	-- 	:setPosition(0, -230)
	-- 	:addTo(self.wordNode)

	-- self.word_bg2 = cc.Sprite:create(imgPath .. 'bg.png')
	-- 	:setPosition(0, -270)
	-- 	:addTo(self.wordNode)

	-- self.openWord = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	-- 	:setPosition(-70, -230)
	-- 	:addTo(self.wordNode)

	-- self.funWord = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 25)
	-- 	:setPosition(70, -230)
	-- 	:setTextColor(cc.c3b(0, 140, 255))
	-- 	:addTo(self.wordNode)
	-- 	:enableOutline(cc.c3b(255, 255, 255), 2)

	-- self.arrow1 = cc.Sprite:create(imgPath .. 'arrow.png')
	-- 	:setPosition(0, -230)
	-- 	:addTo(self.wordNode)

	-- self.arrow2 = cc.Sprite:create(imgPath .. 'arrow.png')
	-- 	:setFlipX(true)
	-- 	:setPosition(140, -230)
	-- 	:addTo(self.wordNode)

	-- self.word = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	-- 	:setPosition(0, -270)
	-- 	-- :setTextColor(cc.c3b(3, 242, 255))
	-- 	:addTo(self.wordNode)

end

function LevelUpPanel:initSpineAni()
	local spine_res = 'levelup_spine'
	self.gacha1Spine = nil
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then

		self.spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.spine:addTo(self.root)
		self.spine:setPosition(0, 180)

		self.spine:registerSpineEventHandler(function (event)
		end, sp.EventType.ANIMATION_START)

		self.spine:registerSpineEventHandler(function (event)
		end, sp.EventType.ANIMATION_END)
    
		self.spine:registerSpineEventHandler(function (event)
			if event.animation == 'start' then
				self.spine:setAnimation(0, "idle", true)
			end
		end, sp.EventType.ANIMATION_COMPLETE)

		self.spine:registerSpineEventHandler(function (event)
			if event.eventData.name == 'appear' then
				self:onPlayAni()
			end
			
		end, sp.EventType.ANIMATION_EVENT)

	end
end

function LevelUpPanel:registEvent(  )
	EventManager:RegisterEvent(EventType.UIUserLevelUpShow, handler(self, self.onShowReward));
end

function LevelUpPanel:onPlayAni()

	self.title:runAction(cc.Sequence:create(
		cc.Spawn:create(
			cc.FadeIn:create(0.1),
			cc.ScaleTo:create(0.1, 0.9)
		),
		cc.ScaleTo:create(0.1, 1)
	))

	for i,v in ipairs(self.itemList) do
		v:runAction(cc.Sequence:create(
			cc.DelayTime:create((i-1)*0.5),
			cc.FadeIn:create(1)
		));
	end

end

function LevelUpPanel:onEnter(levelUpData,option)
	if levelUpData == nil then
		return 
	end

	self.callback = nil;
	self.callbackParams = nil;
	self.callguide = false;
	if option ~= nil then
		self.callback = option.callback;
		self.callbackParams = option.callbackParams;

		self.callguide = option.guide or false;
	end

	print(levelUpData,'========== req level up ====  ');
	model.UserModel:reqLevelUp(); -- 获取升级奖励，存入客户端
	
	self.root:setVisible(true)
	self:addSwallowCallback(handler(self, self.onClickBack));
	self.canPop = false

	-- self.effect:addAnimation(0, GlobalFunctions:lAnimationName('UpgradeRewardEffect') , false)

	self.spine:setAnimation(0, "start", false)

	local level = model.UserModel:getUserLevel()

	self.title:setOpacity(0)
	self.title:setString(tostring(level))--string.format(LANG.UI_FIGHT_57, tostring(level))
	self.title:setScale(2)

	
	for k, v in pairs(self.itemList) do
		v:removeFromParent()
	end
	self.itemList = {}
	local levelUpReward = levelUpData.reward
	-- local reward = ResTable:getValue('user_lv', level, 'reward')
	local num = 0;
	for k, v in pairs(levelUpReward) do
		num = num + 1;
	end

	local space = 125;
	local index = 1;
	local beginX = (-space/2)*(num-1);
	for k, v in pairs(levelUpReward) do
		local item = require('app.template.ItemTemplate'):create(2)
		item:addTo(self.root);
		item:Init(v[1], v[2]);
		item:setOpacity(0);
		item:setPosition(beginX + (index-1)*125, 0)
		-- item:runAction(cc.Sequence:create(
		-- 	cc.DelayTime:create(1+(index-1)*0.5),
		-- 	cc.FadeIn:create(0.5)
		-- ));
		table.insert(self.itemList, item)

		index = index + 1;
	end
	
	local levelUpNum = levelUpData.change;
	local tempLevel = level;
	local unlockId,unlockLv = nil,nil;
	local idx = 1;
	self.wordNode:removeAllChildren()
	while levelUpNum and  levelUpNum > 0 do
		unlockId,unlockLv = model.UserModel:getUnlockIdByLv(tempLevel);
		if unlockId ~= -1 then
			local unlockItem = model.UserModel:getLevelLockItemById(unlockId);
			if tempLevel == level then
				if unlockItem.lv == tempLevel then
					-- self.openWord:setString(LANG.UI_FIGHT_58)
					tools.LevelLockTools:pushEventLevelUp(unlockId)

					local unlockIds = model.UserModel:getUnlockIdsByLv(level)
					for k,v in pairs(unlockIds) do
						local cellItem = model.UserModel:getLevelLockItemById(v);
						self:addOpenMsg(string.format(LANG.UI_FIGHT_58, cellItem.name), idx)
						idx = idx + 1
					end

				else
					-- self.openWord:setString(string.format(LANG.UI_FIGHT_59, tostring(unlockItem.lv)))
				end
				-- self.word:setString(unlockItem.explain)
				-- self.funWord:setString(unlockItem.name)
		
				self.wordNode:setOpacity(0)
				self.wordNode:runAction(cc.Sequence:create(
					cc.DelayTime:create(1+(index-1)*0.5),
					cc.FadeIn:create(0.5),
					cc.CallFunc:create(function()
						self.canPop = true
					end)
				));
			else
				if unlockItem.lv == tempLevel then
					tools.LevelLockTools:pushEventLevelUp(unlockId)
				end
			end

		end
		levelUpNum = levelUpNum - 1
		tempLevel = tempLevel - 1;
	end


end

function LevelUpPanel:addOpenMsg( msg, idx )
	local msgNode = cc.Node:create()
	msgNode:addTo(self.wordNode)
	msgNode:setPosition(0, (1-idx)*70-240)

	local msgBg = cc.Sprite:create('image/commonImg/tip_bg_1_309_28.png')
		:addTo(msgNode)
		:setScale(2)
	local msgBg2 = cc.Sprite:create('image/commonImg/menu_light_264_36.png')
		:addTo(msgNode)
		:setPosition(0, 30)
	local msgLabel = cc.Label:createWithTTF(msg, fonts.FONT_SIYUAN, 30)
		:addTo(msgNode)
end

function LevelUpPanel:onShowReward( msg )
	if msg.newPartner then
		UIManager:push('RoleShowPanel' , msg.newPartner);
	end
end

function LevelUpPanel:onLeave()
	self.root:setVisible(false)
end

function LevelUpPanel:onClickBack()
	if self.canPop then
		UIManager:pop('LevelUpPanel');

		if self.callback then
			self.callback(self.callbackParams);

			if self.callguide==true then
				model.GuideModel:checkLevelUpGuide( model.UserModel:getUserLevel() )
				model.GuideModel:startTriggerGuide();
			end
		else

			model.GuideModel:checkLevelUpGuide( model.UserModel:getUserLevel() )
			model.GuideModel:startTriggerGuide();
		end
	else
		-- self.effect:addAnimation(0, GlobalFunctions:lAnimationName('UpgradeRewardEffect') , false)

		for k, v in pairs(self.itemList) do
			v:stopAllActions();
			v:setOpacity(255)
		end
		self.wordNode:stopAllActions()
		self.wordNode:setOpacity(255)

		self.canPop = true;
	end
end

return LevelUpPanel;

