local Login7CtnRwdPanel = class("Login7CtnRwdPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");

function Login7CtnRwdPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'Login7CtnRwdPanel');

	self.useCCreator = false;
	self.isPopup = true;
end


function Login7CtnRwdPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

end

function Login7CtnRwdPanel:initPanels()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(600, 280))
	:setTouchEnabled(true);

	GlobalFunctions:createTitleNode( bg, LANG.UI_EVENT_9, '',  bg:getContentSize().width/2, bg:getContentSize().height -50 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(572 , 118));
	bg1:addTo(self.root);

	self.mainNode = cc.Node:create()
	self.mainNode:addTo(self.root)

	local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20)
	:enableOutline(cc.c3b(55,85,155),2)
	local btn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
	btn:addTo(self.root);
	btn:setPosition(0, -100)
	btn:addClickEventListener(handler(self, self.clickBtn));
	btn:setTitleLabel(label);
	
end

function Login7CtnRwdPanel:onEnter()
	
	if self.dataList == nil then
		self.dataList = {}
		for _ , data in pairs(ResTable:getTable('operate').contain) do
			if data.type==11 and data.value>=1 and data.value<=6 then

				local node = cc.Node:create()
				:setPosition( (data.value-1) * 95 - 237 ,  0 )
				:addTo(self.mainNode)

				local icon = template.ItemTemplate:create(2)
				icon:addTo(node)
				icon:setScale(0.7)
				local rwdInfo = data.reward_item[1]
				if rwdInfo then
					icon:Init(rwdInfo[1], rwdInfo[2]);
				end

				local word = cc.Label:createWithTTF(string.format(LANG.UI_ACTIVITY_48, data.value), fonts.FONT_SIYUAN, 15)
					:setPosition(0, -45)
					:addTo(node)
					:enableOutline(cc.c3b(0, 0, 0), 2)
				end
		end

	end

	self.root:setVisible(true);

	self:addSwallowCallback(handler(self, self.onClickBack));
end

function Login7CtnRwdPanel:onClickBack()
	UIManager:pop('Login7CtnRwdPanel');
end

function Login7CtnRwdPanel:onLeave()
	self.root:setVisible(false);
end

function Login7CtnRwdPanel:clickBtn()
	UIManager:pop('Login7CtnRwdPanel');
end

return Login7CtnRwdPanel;
