local Login7RewardPanel = class("Login7RewardPanel", require('app.layer.BaseLayer'))

local imgPath = 'image/activity/login7/'
local fonts = Enum:getTable("SystemFont")

function Login7RewardPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'Login7RewardPanel');

	self.useCCreator = false;
	self.isPopup = true;
	self.haveSwallowLayer = true;

	self.posX = 0;
	self.posY = 0;
end

function Login7RewardPanel:Init(root)
	self.root:setVisible(false);

	self:initPanels();
	self:registEvent();
end

function Login7RewardPanel:initPanels()

	self:init7DaysNode();

	--self:initTestNode();
end

function Login7RewardPanel:init7DaysNode( )

	self.mainNode = cc.Node:create();
	self.mainNode:addTo(self.root);

	local bg = cc.Sprite:create(imgPath..'login7_bg_2.png')
		:addTo(self.mainNode)
		:setPosition(0,48)

	local bg = cc.Sprite:create(imgPath..'login7_bg_3.png')
		:addTo(self.mainNode)
		:setPosition(0,-77)

	local rwdNode = cc.Node:create();
	rwdNode:addTo(self.mainNode)
	
	self.rewardList = {};
	-- icon list
	for i=1, 7 do
		local reward = {};
		self.rewardList[i] = reward;

		local x = 119.5;
		local btnImg = imgPath .. 'login7_bg_8.png'
		local titleColor = cc.c3b(255,255,0)
		local namePosY = -52;
		local nameFontSize = 20;
		local getedImg = imgPath..'login7_bg_9.png'
		local particle = 'Effect/particle/day7.plist'
		if i ~= 7 then
			x = -179.2 + (i-1)%4 * 119.5;
			btnImg = imgPath .. 'login7_bg_7.png'
			titleColor = cc.c3b(255,255,255)
			namePosY = -45;
			nameFontSize = 15;
			getedImg = imgPath..'login7_bg_6.png'
			particle = 'Effect/particle/day1.plist'
		end

		reward.node = cc.Node:create()
			:setPosition(x ,  2-math.floor( (i-1)/4 ) * 180 )
			:addTo(rwdNode)

		reward.bg = ccui.Button:create(btnImg,btnImg)
			:addTo(reward.node)
			:setTag(i)
		reward.bg:addClickEventListener(handler(self , self.dayClick))

		reward.title = cc.Label:createWithTTF('Day'..i,fonts.FONT_SIYUAN,17)
			:setTextColor(titleColor)
			:setPosition(0,66)
			:addTo(reward.node)

		reward.icon = cc.Sprite:create()
			:addTo(reward.node)
			:setPosition(0,5)
			:setScale(0.8)

		reward.name = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,nameFontSize)
			:setTextColor(cc.c3b(165,190,255))
			:setPosition(0,namePosY)
			:addTo(reward.node)

		if i ~= 7 then
			reward.num = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,15)
				:setTextColor(cc.c3b(165,190,255))
				:setPosition(0,-64)
				:addTo(reward.node)
		end

		reward.geted = cc.Sprite:create(getedImg)
			:addTo(reward.node)
			:setVisible(false)
		
		reward.effect = cc.ParticleSystemQuad:create(particle);
		reward.effect:addTo(reward.node);
		reward.effect:stopSystem()

		local spine_res = 'sevenday_spine'
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			spine:addTo(reward.node)
			spine:registerSpineEventHandler(function (event)
				if event.eventData.name == 'appear' then
					reward.geted:setVisible(true);
					reward.effect:setVisible(false)
					reward.effect:stopSystem()
				end
			end, sp.EventType.ANIMATION_EVENT)
			reward.getedSpine = spine;
		end 
	end

	local bg = cc.Sprite:create(imgPath..'login7_bg_4.png')
		:addTo(self.mainNode)
		:setPosition(0,114)

	local bg = cc.Sprite:create(imgPath..'login7_bg_5.png')
		:addTo(self.mainNode)
		:setPosition(0,119)

	local spNode = cc.Node:create()
	spNode:addTo(self.mainNode)
	spNode:setPosition(235 , -140)
	spNode:setVisible(false)

	self.spIcon = template.ItemTemplate:create()
	self.spIcon:addTo(spNode)
	self.spIcon:setScale(0.8)
	self.spIcon:addItemClickEventListener(handler(self, self.getConReward))
	self.spIcon:setItemSwallowTouches(true)

	self.spGeted = cc.Node:create()
		:addTo(spNode)
	local bg = cc.Scale9Sprite:create(imgPath .. 'login7_bg_1.png')
			:addTo(self.spGeted)
			:setContentSize(cc.size(80 , 80))

	local getedImg = cc.Sprite:create('image/commonImg/geted.png')
	:addTo(self.spGeted)


	local spLabel = cc.Label:createWithTTF(LANG.UI_ACTIVITY_46, fonts.FONT_SIYUAN, 20)
		:addTo(spNode)
		:setPosition(0, 95)
		:enableOutline(cc.c3b(0, 0, 0), 2)

	self.spEnableGet = cc.Scale9Sprite:create('image/commonImg/icon_item_light.png')
		:addTo(spNode)
		:setContentSize(cc.size(90 , 90))


	local label = cc.Label:createWithTTF(LANG.UI_EVENT_9,fonts.FONT_SIYUAN,15)
		:enableOutline(cc.c3b(55,85,155),2)
	local showBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png','image/commonImg/btn_2_103_36.png');
	showBtn:addTo(spNode);
	showBtn:setPosition(0, -80);
	showBtn:setTitleLabel(label);
	showBtn:addClickEventListener(function()
		UIManager:push('Login7CtnRwdPanel');
	end);

	--[[
	local msgNode = cc.Node:create()
	msgNode:addTo(self.mainNode)
	msgNode:setPosition(0, -300)

	local msgBg = cc.Sprite:create('image/commonImg/tip_bg_1_309_28.png')
		:addTo(msgNode);
	local msgLabel = cc.Label:createWithTTF(LANG.UI_ACTIVITY_47, fonts.FONT_SIYUAN, 17)
		:addTo(msgNode)
		-- :enableOutline(cc.c3b(60, 60, 60), 2)
		:setTextColor(cc.c3b(255,255,0))


	local barTipBtn = ccui.Button:create('image/commonImg/help_1.png');
	barTipBtn:addTo(self.mainNode);
	barTipBtn:setPosition(300 , 20);
	barTipBtn:addClickEventListener(function() 
		UIManager:push('HelpPanel',self.name);
	end);
	]]
end

function Login7RewardPanel:initTestNode()
	self.testNode = cc.Node:create();
	self.testNode:addTo(self.root);

	local title = cc.Sprite:create(imgPath .. 'login7/login7_bg_6.png')
		:addTo(self.testNode)
		:setPosition(80,60);

	local rwdNodeBg = cc.Sprite:create(imgPath .. 'login7/login7_bg_3.png')
		:addTo(self.testNode)
		:setPosition(75,-70);

	local rwdNode = cc.Node:create();
	rwdNode:addTo(self.testNode)
	
	self.testList = {};
	-- icon list
	for i=1, 4 do
		local reward = {};
		self.testList[i] = reward;

		reward.node = cc.Node:create()
			:setPosition( (i-1)%4 * 100 - 75 ,  -70 )
			:addTo(rwdNode)
			:setScale(0.8)

		reward.icon = template.ItemTemplate:create(2)
		reward.icon:addTo(reward.node)
		reward.icon:setPosition(0, 14)
		reward.icon:setItemTag(i)
		reward.icon:addItemClickEventListener(handler(self, self.dayClick))
		reward.icon:setItemSwallowTouches(true)

		reward.geted = cc.Node:create()
			:addTo(reward.node)
		local bg = cc.Scale9Sprite:create('image/commonImg/geted_1_20_20_77_102.png')
			:addTo(reward.geted)
    		:setCapInsets(cc.rect(20,20,70,102))
			:setContentSize(cc.size(100 , 132))

		local getedImg = cc.Sprite:create('image/commonImg/geted.png')
		:addTo(reward.geted)
		:setPosition(0,11)

		reward.word = cc.Label:createWithTTF('Day'..i, fonts.FONT_SIYUAN, 17)
			:setPosition(0, -52)
			:addTo(reward.node)
			:enableOutline(cc.c3b(60, 60, 60), 2)

		reward.enableGet = cc.Scale9Sprite:create('image/commonImg/select_1_20_20_93_117.png')
			:addTo(reward.node)
			:setCapInsets(cc.rect(20,20,93,117))
			:setContentSize(cc.size(119 , 150))
	end
end

function Login7RewardPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkRetActivityData, handler(self, self.retActivityData));
	EventManager:RegisterEvent(EventType.NetworkRetLimitActivityReward,handler(self,self.retLimitActivityReward));

end

function Login7RewardPanel:onEnter()
	self.reqChangeIndex = -1;

	self:onShow()
	self:addSwallowCallback(handler(self , self.onClickBack))

end

function Login7RewardPanel:onClickBack()
	UIManager:pop('Login7RewardPanel')
end

function Login7RewardPanel:onShow(index)
	index = index or model.ActivityModel.ActivityMenuIndex.SEVEN_DAY
	-- 改为每次进入时刷新数据
	if self.reqChangeIndex == -1 then
		self.reqChangeIndex = index;
		model.ActivityModel:reqActivityByIndex(self.reqChangeIndex);
		return 
	end
	self.activityMenuIndex = index
	self:initData()
	self.root:setVisible(true)
end

function Login7RewardPanel:onLeave()
	--tools.RedDotTools:pushMainPanelRedDot(3);
	--tools.RedDotTools:pushMainPanelRedDot(15);
	--EventManager:FireEvent(EventType.UIUpdateBtnShow,3);
	--EventManager:FireEvent(EventType.UIUpdateBtnShow,15);
	
	self.root:setVisible(false)
end

function Login7RewardPanel:retActivityData()
	
    if self.reqChangeIndex == nil or self.reqChangeIndex == -1 then
        return ;
    end

	if not model.ActivityModel:hasInitIndex(self.reqChangeIndex) then
		print('======= 请求服务器数据 错误 !!! ')
        return 
    end
	self:onShow(self.reqChangeIndex)
end

function Login7RewardPanel:retLimitActivityReward(msg)
	if not msg then
		return;
	end

	self.rewardList[self.currentDay].getedSpine:setVisible(true)
	self.rewardList[self.currentDay].getedSpine:setAnimation(0, ("day"..self.currentDay), false);
	self.rewardList[self.currentDay].getedSpine:stopAllActions();
	self.rewardList[self.currentDay].getedSpine:runAction(cc.Sequence:create(cc.DelayTime:create(1.5),cc.CallFunc:create(function() 
		UIManager:push('RewardPanel',msg)
	end)));
end

function Login7RewardPanel:initData()
	local data = model.ActivityModel:getActivityDataByIndex( self.activityMenuIndex )

	local isOpen = tools.ConfigStateTools:checkLockById(1208);--测试数据 和 7日数据 开关
	if isOpen then
		local canGet = 1;
		for i=1, 7 do
			-- if data.state[tostring(i)] ==1 then
			-- 	canGet = i;
			-- end
			
			self.rewardList[i].geted:setVisible(data.state[tostring(i)] == 2)
			self.rewardList[i].getedSpine:setVisible(false)
			if data.state[tostring(i)] == 1 then
				self.rewardList[i].effect:setVisible(true);
				self.rewardList[i].effect:resetSystem()
			else
				self.rewardList[i].effect:setVisible(false);
				self.rewardList[i].effect:stopSystem()
			end
			local info = data.data[i].reward_item[1];
			if info then
				local item = ResTable:getRowData('item' , info[1]);
        		self.rewardList[i].icon:setTexture('image/icon/I'..item.icon..'.png');
				if i == 7 then
					self.rewardList[i].name:setString(item.name..'  '..string.format(LANG.UI_ACTIVITY_49,info[2]))
				else
					self.rewardList[i].name:setString(tostring(item.name));
					if self.rewardList[i].num then
						self.rewardList[i].num:setString(string.format(LANG.UI_ACTIVITY_49,info[2]));
					end
				end
			end
		end

		local conRwd = model.ActivityModel:getContinueRwd();
		if conRwd then
			self.spGeted:setVisible(conRwd.state == 2)
			self.spEnableGet:setVisible(conRwd.state == 1)
			if conRwd.reward_item then
				local rwdInfo = conRwd.reward_item[1]
				if rwdInfo then
					self.spIcon:Init(rwdInfo[1], rwdInfo[2]);
				end
			else
				for _ , data in pairs(ResTable:getTable('operate').contain) do
					if data.type==11 and data.value==1 then
						local rwdInfo = data.reward_item[1]
						if rwdInfo then
							self.spIcon:Init(rwdInfo[1], rwdInfo[2]);
						end
					end
				end
			end
		end

		self.mainNode:setVisible(true)
		--self.testNode:setVisible(false)

	else

		--for i=1, 4 do
		--	self.testList[i].geted:setVisible(data.state[tostring(i)] == 2)
		--	self.testList[i].enableGet:setVisible(data.state[tostring(i)] == 1)
		--	local info = data.data[i].reward_item[1];
		--	self.testList[i].icon:Init(info[1], info[2])
		--end

		--self.mainNode:setVisible(false)
		--self.testNode:setVisible(true)
	end

end

function Login7RewardPanel:dayClick(sender , event)
	local day = sender:getTag();
	-- self:clickDay(day);

	self.currentDay = day;
	self:getReward();
	
end

-- function Login7RewardPanel:clickDay(day)
-- 	self.currentDay = day;
-- 	local data = model.ActivityModel:getActivityDataByIndex( self.activityMenuIndex )
-- 	local str = ResTable:getLangByNum(data.data[day].description_no)
-- 	self.rewardLabel:setString(tostring(str))
-- 	for k, v in pairs(self.rewardItemList) do
-- 		v:removeFromParent()
-- 	end
-- 	self.rewardItemList = {};

-- 	for k, v in ipairs(data.data[day].reward_item) do
-- 		local item = template.ItemTemplate:create(2)
-- 		item:addTo(self.rewardNode);
-- 		item:Init(v[1], v[2])
-- 		item:setScale(0.8)
-- 		item:setPosition(-150+(k-1)*100, 2)
-- 	end

-- 	if data.state[tostring(self.currentDay)] ~= 1 then
-- 		self.getBtn:setVisible(false);

-- 	else
-- 		self.getBtn:setVisible(true);

-- 	end

-- 	self.select:setPosition(nodePosList[day]);
-- end

function Login7RewardPanel:getReward()
	local data = model.ActivityModel:getActivityDataByIndex( self.activityMenuIndex )
	if data.state[tostring(self.currentDay)] ~= 1 then
		return
	end
	local dayData = data.data[self.currentDay];
	model.ActivityModel:reqActivityItemReward(model.ActivityModel.ActivityMenuIndex.SEVEN_DAY, dayData.id)
end

function Login7RewardPanel:getConReward()
	local data = model.ActivityModel:getContinueRwd();
	if data==nil or data.state ~= 1 then
		return
	end
	model.ActivityModel:reqActivityItemReward(model.ActivityModel.ActivityMenuIndex.SEVEN_CON, data.no)
end

-- 引导相关
function Login7RewardPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 55 then
		local btn = self.getBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return Login7RewardPanel;
