local LoginConRewardPanel = class("LoginConRewardPanel", require('app.layer.BaseLayer'))

local imgPath = 'image/activity/loginCon/'
local fonts = Enum:getTable("SystemFont")

function LoginConRewardPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'LoginConRewardPanel');

	self.useCCreator = false;
	--self.isPopup = true;
	self.haveSwallowLayer = true;

	self.posX = 0;
	self.posY = 0;
end

function LoginConRewardPanel:Init(root)
	self.root:setVisible(false);

	self:initPanels();
	self:registEvent();
end

function LoginConRewardPanel:initPanels()

	self.mainNode = cc.Node:create();
	self.mainNode:addTo(self.root);

	local bg = cc.Sprite:create(imgPath..'lc_bg.png')
		:addTo(self.mainNode)
		:setPosition(0,0)

	local titleSpr = cc.Sprite:create(imgPath..'lc_rt.png')
		:addTo(self.mainNode)
		:setPosition(0,195)

	local rwdNode = cc.Node:create();
	rwdNode:addTo(self.mainNode)
	
	self.rewardList = {};
	for i=1, 14 do
		local reward = {};
		self.rewardList[i] = reward;

		local btnImg = imgPath .. 'lc_rbg.png'
		-- local particle = 'Effect/particle/day7.plist'

		reward.node = cc.Node:create()
			:setPosition( -171 + ((i-1)%4)*114 ,  30-math.floor( (i-1)/4 ) * 120 )
			:addTo(rwdNode)

		reward.bg = ccui.Button:create(btnImg,btnImg)
			:addTo(reward.node)
			:setTag(i)
		reward.bg:addClickEventListener(handler(self , self.dayClick))

		reward.canClickSpr = cc.Sprite:create('image/commonImg/common_item_select.png')
			:addTo(reward.node)
			:setPosition(0, 3)
			:setScale(0.95)
			:setVisible(false)

		reward.icon = cc.Sprite:create()
			:addTo(reward.node)
			:setPosition(0,5)
			:setScale(0.7)

		reward.numLabel = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,15)
			:setPosition(45,-15)
			:addTo(reward.node)
			:enableOutline(cc.c3b(135,60,70), 2)
			:setAnchorPoint(1 , 0.5)

		local nameBg = cc.Sprite:create(imgPath .. 'lc_name_bg.png')
		nameBg:addTo(reward.node)
		nameBg:setPosition(0, -35)

		reward.name = cc.Label:createWithTTF('Day'..i ,fonts.FONT_SIYUAN,15) --string.format('累计%d天', i)
			:setPosition(0,-35)
			:addTo(reward.node)
			:enableOutline(cc.c3b(70,30,40), 2)

		reward.getNode = cc.Node:create()
			:addTo(reward.node)
			:setVisible(false)
		local getBg = cc.Scale9Sprite:create('image/commonImg/geted_1_20_20_77_102.png')
		getBg:setContentSize(cc.size(102,108))
		getBg:addTo(reward.getNode)
		-- reward.geted = cc.Sprite:create('image/commonImg/geted.png')
		-- 	:addTo(reward.getNode)
		reward.geted = require("app.template.GetTemplate"):create(reward.getNode);
		
		-- reward.effect = cc.ParticleSystemQuad:create(particle);
		-- reward.effect:addTo(reward.node);
		-- reward.effect:stopSystem()

		-- local spine_res = 'sevenday_spine'
		-- if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		-- 	local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		-- 	spine:addTo(reward.node)
		-- 	spine:registerSpineEventHandler(function (event)
		-- 		if event.eventData.name == 'appear' then
		-- 			reward.geted:setVisible(true);
		-- 			reward.effect:setVisible(false)
		-- 			reward.effect:stopSystem()
		-- 		end
		-- 	end, sp.EventType.ANIMATION_EVENT)
		-- 	reward.getedSpine = spine;
		-- end 
	end

	local timeNode = cc.Node:create()
	timeNode:addTo(self.mainNode)
	timeNode:setPosition(0, 220)

	local timeBg = cc.Scale9Sprite:create('image/commonImg/com_bg.png')
	timeBg:setContentSize(cc.size(240, 40))
	timeBg:addTo(timeNode)

	self.timeLabel = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
		:addTo(timeNode)

end

function LoginConRewardPanel:registEvent()
	EventManager:RegisterEvent('LoginConRewardPanel:updateData', handler(self, self.updateData));
	EventManager:RegisterEvent('LoginConRewardPanel:retUpdateReward',handler(self,self.retUpdateReward));

end

function LoginConRewardPanel:onEnter()
	self.reqChangeIndex = -1;

	self:onShow()
	self:addSwallowCallback(handler(self , self.onClickBack))
	self.root:setVisible(true)

end

function LoginConRewardPanel:onClickBack()
	UIManager:pop('LoginConRewardPanel')
end

function LoginConRewardPanel:onShow(index)
	self.info, self.list = model.ActivityModel:getLoginConAllInfo()
	if self.list == nil then
		local msg = { operate_id=self.info.operate_id }
        Network.NetworkManager:Send(Network.NetworkCmdType.req_login_con_list , msg);
		return 
	end
	self:updateData()
end

function LoginConRewardPanel:onLeave()
	self.root:setVisible(false)
end

function LoginConRewardPanel:retUpdateReward(msg)
	
	local idx = msg.cumulative_days;
	if not idx then
		return;
	end
	self.list[idx].state = 2;
	local dIdx = self.list[idx].value;
	if self.rewardList[dIdx] then
		local opt = {callback=function()
			self.rewardList[dIdx].getNode:setVisible(true)
			self.rewardList[dIdx].canClickSpr:setVisible(false)
			self.rewardList[dIdx].geted:showAction()
		end}

		UIManager:push('RewardPanel',msg, opt);
	end

end

function LoginConRewardPanel:updateData()
	
	if self.list == nil then
		self.info, self.list = model.ActivityModel:getLoginConAllInfo()
	end
	if self.list == nil then
		return;
	end

	local lastIdx = 0;
	for k,v in pairs(self.list) do
		lastIdx = k;
		if v.state==0 or v.state==1 then
			break;
		end
	end
	local startIdx = math.floor((lastIdx-1)/14) * 14;

	for k,v in pairs(self.rewardList) do
		local data = self.list[startIdx + k]
		self.rewardList[k].getNode:setVisible(data.state == 2)
		if data.state == 2 then
			self.rewardList[k].geted:setState(2)
		end
		self.rewardList[k].canClickSpr:setVisible(data.state == 1)
		self.rewardList[k].dayIdx = data.cumulative_days;

		local info = data.reward_item[1];
		if info then
			local iconFile , num = GlobalFunctions:getItemIconFileAndNum(info);
    		self.rewardList[k].icon:setTexture(iconFile);
			-- self.rewardList[i].name:setString(tostring(item.name));
			self.rewardList[k].numLabel:setString( num )
		end
	end


	local startTime = self.info.open_time
    local endTime = self.info.close_time
    if startTime ~= 0 then
        local startTable = os.date('*t', startTime)
        local endTable = os.date('*t', endTime)
        local msg = string.format( LANG.UI_EVENT_29,startTable.month,startTable.day ).."~"..string.format( LANG.UI_EVENT_29,endTable.month,endTable.day )
        self.timeLabel:setString(msg);
    else
        self.timeLabel:setString('');
    end

end

function LoginConRewardPanel:dayClick(sender , event)
	local day = sender:getTag();
	local idx = self.rewardList[day].dayIdx;
	if self.list[idx].state ~= 1 then
		return;
	end

	local msg = { id=self.list[idx].id }
    Network.NetworkManager:Send(Network.NetworkCmdType.req_login_con_rwd , msg);
	
end

return LoginConRewardPanel;
