--邮件
local MailPanel = class("MailPanel", require('app.layer.BaseLayer'));
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/mail/';

local  mailTag = 0

function MailPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'MailPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function MailPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanel()
	self:registEvent();
end

function MailPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkMailRetAllMail,handler(self,self.retAllMail));
	EventManager:RegisterEvent(EventType.NetworkMailRetOpenMail,handler(self,self.retOpenMail));
	EventManager:RegisterEvent(EventType.NetworkMailRetGetRewardMail,handler(self,self.retGetReward));
	EventManager:RegisterEvent(EventType.NetworkMailRetGetAllRewardMail,handler(self,self.retGetAllReward));
	EventManager:RegisterEvent(EventType.NetworkMailDelAll,handler(self,self.retGetAllRewardDel));
	EventManager:RegisterEvent(EventType.NetworkMailNtNewMail,handler(self,self.ntNewMail));
	EventManager:RegisterEvent(EventType.NetworkMailNewMailTip,handler(self,self.newMailTip));
end

function MailPanel:initPanel()
	
	local bg = ccui.Layout:create();
	bg:setBackGroundImage('image/commonImg/mail_bg.png');
	bg:setTouchEnabled(true);
	bg:setAnchorPoint(cc.p(0.5,0.5));
	bg:addTo(self.root);
	bg:setPosition(0 , -7);
    GlobalFunctions:createTitleNode( self.root, LANG.UI_L_MAIL_TITLE_1, LANG.UI_L_MAIL_TITLE_2,  0,  270 );

	local initData = {
        width = 580,
        height = 466,
        cellWidth = 570 ,
        cellHeight = 110,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

    }
    self.mailListView = template.TableViewTemplate:create()
    self.mailListView:initWithSizeAndItem(initData);
    self.mailListView:getView():setPosition(cc.p(-280,-233));
	self.mailListView:getView():addTo(self.root)

	--self.mailListView = ccui.ScrollView:create();
	--self.mailListView:setTouchEnabled(true);
	--self.mailListView:setBounceEnabled(true);
	--self.mailListView:setDirection(ccui.ScrollViewDir.vertical);
	--self.mailListView:setContentSize(cc.size(508, 582));
	--self.mailListView:setPosition(0, 19);
	--self.mailListView:setScrollBarEnabled(false);
	--self.mailListView:addTo(self.root);
	--self.mailListView:setAnchorPoint(cc.p(0.5,0.5));

	self.noData = cc.Label:createWithTTF(LANG.UI_MAIL_5 , fonts.FONT_SIYUAN , 20);
	self.noData:addTo(self.root);
	self.noData:setPosition(0 , 35);
	-- self.noData:setTextColor(cc.c4b(60 , 60 , 60 ,255));

	self.mailInfoNode = cc.Node:create();
	self.mailInfoNode:addTo(self.root);
	
	self.mailInfoView = ccui.ScrollView:create()
		:setTouchEnabled(true)
		:setBounceEnabled(true)
		:setDirection(ccui.ScrollViewDir.vertical)
		:setContentSize(cc.size(540, 346))
		:setPosition(0, 60)
		:setScrollBarEnabled(false)
		:addTo(self.mailInfoNode)
		:setAnchorPoint(cc.p(0.5,0.5))
		-- :setBackGroundImage('image/common/c9_white.png')
		-- :setBackGroundImageScale9Enabled(true)

	self.timeNode = cc.Node:create();
	self.timeNode:addTo(self.mailInfoView);
	self.timeNode:setPosition(467 , 177);

	self.mailTitle = cc.Label:createWithTTF('title111' , fonts.FONT_SIYUAN , 16)
		:addTo(self.timeNode)
		-- :setTextColor(cc.c3b(120 , 150 , 200))	
		:setPosition(cc.p(-450,0))
		:setAnchorPoint(cc.p(0,0.5))

	bg = cc.Sprite:create(imagePath..'mail_bg_3.png');
	bg:addTo(self.timeNode);

	self.lastTime = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 16)
		:addTo(self.timeNode)
		:setTextColor(cc.c3b(120 , 150 , 200))	
	
	local line = cc.Sprite:create('image/commonImg/line.png')
		:addTo(self.timeNode)
		:setPosition(cc.p(-250,-30))


	self.mailInfo = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 16);
	self.mailInfo:addTo(self.mailInfoView);
	self.mailInfo:setAnchorPoint(0 , 1);
	-- self.mailInfo:setTextColor(cc.c3b(60 , 60 , 60));
	self.mailInfo:setContentSize(cc.size(498 , 78));
	self.mailInfo:setLineBreakWithoutSpace(true);
	self.mailInfo:setMaxLineWidth(498);
	self.mailInfo:setLineHeight(30);
	self.mailInfo:setPositionX(8);

	self.mailRewardNode = cc.Node:create();
	self.mailRewardNode:addTo(self.mailInfoNode);
	self.mailRewardNode:setPosition(0 , -175);

	bg = cc.Sprite:create(imagePath..'mail_bg_1.png');
	bg:addTo(self.mailRewardNode);

	self.mailRewardView = ccui.ScrollView:create();
	self.mailRewardView:setTouchEnabled(true);
	self.mailRewardView:setBounceEnabled(true);
	self.mailRewardView:setDirection(ccui.ScrollViewDir.horizontal);
	self.mailRewardView:setContentSize(cc.size(540, 129));
	self.mailRewardView:setScrollBarEnabled(false);
	self.mailRewardView:addTo(self.mailRewardNode);
	self.mailRewardView:setAnchorPoint(cc.p(0.5,0.5));

	self.geted = cc.Sprite:create(imagePath..'mail_bg_7.png');
	self.geted:addTo(self.mailRewardNode);
	self.geted:setPosition(214 , 46);

	self.leftBtn = ccui.Button:create('image/commonImg/btn_1_219_55_2.png' , 'image/commonImg/btn_1_219_55_2.png');
	self.leftBtn:addTo(self.root);
	self.leftBtn:setPosition(-117 , -287);
	self.leftBtn:addClickEventListener(handler(self , self.btnClick));

	self.leftLabel = cc.Label:createWithTTF(LANG.UI_ROUND_14 , fonts.FONT_SIYUAN , 20);
	self.leftLabel:addTo(self.leftBtn);
	self.leftLabel:setPosition(self.leftBtn:getContentSize().width/2 , self.leftBtn:getContentSize().height/2);
	-- self.leftLabel:setTextColor(cc.c3b(60 , 60 , 60));
	self.leftLabel:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2);

	self.rightBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.rightBtn:addTo(self.root);
	self.rightBtn:setPosition(117 , -287);
	self.rightBtn:addClickEventListener(handler(self , self.btnClick));

	self.rightLabel = cc.Label:createWithTTF(LANG.UI_ROUND_15 , fonts.FONT_SIYUAN , 20);
	self.rightLabel:addTo(self.rightBtn);
	self.rightLabel:setPosition(self.rightBtn:getContentSize().width/2 , self.rightBtn:getContentSize().height/2);
	-- self.rightLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.rightLabel:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2);

	self.root:setVisible(false);
end

function MailPanel:onEnter()
	self:switchPanel(1);
	if model.MailModel:isReqMail() then
		model.MailModel:sendGetAllMail();
	else
		self:onShow();
	end
	self:addSwallowCallback(handler(self , self.onClickBack))
	self.root:setVisible(true);
end

function MailPanel:onShow()
	self:setMailListData();
	self:switchPanel(model.MailModel:isHaveMail() and 2 or 1);
end

function MailPanel:setMailListData()
	self.mailDatas = model.MailModel:getMailData();
	
	if(#self.mailDatas > 1) then
		table.sort(self.mailDatas, function(mail_1 , mail_2)
			if mail_1.opened ~= mail_2.opened then
				return mail_1.opened < mail_2.opened; 
			end

			return mail_1.stamp < mail_2.stamp;
		end);
	end

	self.mailListView:reloadData(self.mailDatas);
end

function MailPanel:cellItemTouch(table , cell)
	AudioManager:playEffect(Conf.buttonClick)

	local idx = cell:getIdx();

	local mail = self.mailDatas[idx + 1];

	if mail.opened == 0 then
		model.MailModel:sendOpenMail(mail.id);
	else
		self:showMailInfoPanel(mail.id);
	end
end

function MailPanel:reloadCellPanel(cell , idx)
	local cellNode = cell:getChildByTag(999);
	if not cellNode then
		cellNode = template.MailItemTemplate:create();
		cellNode:addTo(cell);
		cellNode:setPosition(280 , 47.5);
		cellNode:setTag(999)
	end
	
	local mailData = self.mailDatas[idx + 1];
	cellNode:Init(mailData);
end

function MailPanel:showMailInfoPanel(id)
	self:setMailInfoData(id);
	self:switchPanel(3);
end

function MailPanel:updateGetAllRewardBtnState()
	self.mailListGetAllRewardBtn:setVisible(model.MailModel:isHaveNotRewardGet());
end

function MailPanel:setMailInfoData(id)
	local mail = model.MailModel:getMail(id);

	if not mail then
		return
	end

	local lastTime = mail.stamp - TimeManager:getCurTime()
	lastTime = lastTime < 0 and 0 or lastTime;
	local days = math.floor(lastTime / 86400);
	local modDay = lastTime % 86400;

	if days > 0 then
		if modDay > 0 then
			days = days+1;
			days = days > 30 and 30 or days;
		end
		self.lastTime:setString(string.format(LANG.UI_MAIL_LAST_TIME,days));
	else
		local hours = math.floor(modDay/3600);
		local modHour = modDay%3600;
		if hours > 0 then
			if modHour > 0 then
				hours = hours + 1;
				hours = hours > 24 and 24 or hours;
			end
			self.lastTime:setString(string.format(LANG.UI_MAIL_15,hours));
		else
			self.lastTime:setString(LANG.UI_MAIL_16);
		end
	end

	self.mailInfo:setString(tostring(mail.info));
	--self.lastTime:setString(string.format(LANG.UI_MAIL_LAST_TIME,math.ceil((mail.stamp - TimeManager:getCurTime()) / 86400)));
	self.mailTitle:setString(tostring(mail.title))

	local height = self.mailInfo:getContentSize().height + 80;
	height = height < 346 and 346 or height;

	self.mailInfoView:setInnerContainerSize(cc.size(540 , height));
	self.timeNode:setPositionY(height - 35);
	self.mailInfo:setPositionY(height - 80);

	if mail.flag == 2 then
		self.mailRewardNode:setVisible(true);

		--已经领取
		self.geted:setVisible(mail.rewarded ~= 1);

		if mail.reward.item ~= '' and #mail.reward.item > 0 then
			self:btnState(mail.rewarded ~= 1 and 3 or 2);
		else
			self:btnState(4);
		end

		self.rewardItem = {};
		self.mailRewardView:removeAllChildren();
		
		local maxWidth = 0
		if mail.reward ~= nil and mail.reward.item ~= nil then
			maxWidth = (#mail.reward.item) * 114;
		end
		maxWidth = maxWidth < 488 and 488 or maxWidth;

		self.mailRewardView:setInnerContainerSize(cc.size(maxWidth,130))

		for _k , item in pairs(mail.reward.item) do
			local rewardIcon = template.ItemTemplate:create(2)
			rewardIcon:addTo(self.mailRewardView);
			rewardIcon:Init(tonumber(item[1]) , tonumber(item[2]));
			rewardIcon:setBlackShader(mail.rewarded ~= 1);
			rewardIcon:setPosition(47 + 94 * (_k - 1) , 65);
			rewardIcon:setScale(0.8)
			self.rewardItem[_k] = rewardIcon;
		end
	else
		self.mailRewardNode:setVisible(false);
		self:btnState(3)
	end

	self.curMailId = id;
end

function MailPanel:switchPanel(index)
	self.mailInfoNode:setVisible(index == 3);
	self.noData:setVisible(index == 1);
	self.mailListView:getView():setVisible(index == 2)

	if index == 1 or index == 2 then
		self:btnState(1);
	end
end

function MailPanel:btnState(state)
	if state == 1 then --一键删除，一键领取
		self.rightBtn:setVisible(true);
		self.leftBtn:setPositionX(-117);
		self.leftLabel:setString(LANG.UI_MAIL_3);
		self.rightLabel:setString(LANG.UI_MAIL_4);
		self.leftBtn:setTag(1);
		self.rightBtn:setTag(2);
	elseif state == 2 then -- 取消，领取
		self.rightBtn:setVisible(true);
		self.leftBtn:setPositionX(-117);
		self.leftLabel:setString(LANG.UI_MAIL_11);
		self.rightLabel:setString(LANG.UI_MAIL_12);
		self.leftBtn:setTag(3);
		self.rightBtn:setTag(4);
	elseif state == 3 then -- 取消
		self.rightBtn:setVisible(false);
		self.leftBtn:setPositionX(0);
		self.leftLabel:setString(LANG.UI_MAIL_11);
		self.leftBtn:setTag(3);
	elseif state == 4 then -- 取消，确定(领取)
		self.rightBtn:setVisible(true);
		self.leftBtn:setPositionX(-117);
		self.leftLabel:setString(LANG.UI_MAIL_11);
		self.rightLabel:setString(LANG.COMMON_OK);
		self.leftBtn:setTag(3);
		self.rightBtn:setTag(4);
	end
end

function MailPanel:btnClick(sender , event)
	local tag = sender:getTag();
	AudioManager:playEffect(Conf.confirmButton);
	if tag == 1 then --一键删除
		if model.MailModel:isHaveMail() then 
			model.MailModel:sendGetAllRewardDel();
		else
			Prompt:Show(LANG.UI_MAIL_14)
		end
	elseif tag == 2 then --一键领取
		if model.MailModel:isHaveNotRewardGet() then
			model.MailModel:sendGetAllReward();
		else
			Prompt:Show(LANG.UI_MAIL_14)
		end
	elseif tag == 3 then --取消
		self:switchPanel(2);
	elseif tag == 4 then -- 领取

		local mail = model.MailModel:getMail(self.curMailId);

		if not mail then
			return;
		end

		if  mail.rewarded == 1 then
			model.MailModel:sendGetReward(mail.id);
		end

	end
end

function MailPanel:retAllMail()
	self:onShow()
end

function MailPanel:retOpenMail(msg)
	if msg.id then
		self:setMailListData();
		self:showMailInfoPanel(msg.id);
	end
end

--删除邮件
function MailPanel:retGetAllRewardDel( )
	self:onShow()
end
--获得所有奖励
function MailPanel:retGetAllReward(msg)
	self:onShow()
	UIManager:push('RewardPanel',msg);
end

--获得单个奖励
function MailPanel:retGetReward(msg)
	if not msg then
		return;
	end
	self:onShow()
	UIManager:push('RewardPanel',msg);
	--GlobalFunctions:showRewardPrompt(msg , LANG.UI_ACTIVITY_16)

end

function MailPanel:ntNewMail()
	if self.root:isVisible() then
		model.MailModel:sendGetAllMail();
	end
end

function MailPanel:onClickBack(sender , event)
	tools.RedDotTools:pushMainPanelRedDot(6);
	--tools.RedDotTools:pushFightSceneRedDot(6);
	
	UIManager:pop('MailPanel');
end

function MailPanel:onLeave()
	self.root:setVisible(false);
end

return MailPanel
