local MainPanel = class("MainPanel" , require('app.layer.BaseLayer'));
local scheduler = cc.Director:getInstance():getScheduler();
local ActivityIndex = Enum:getTable('ActivityIndex');
local imagePath = 'image/main/';
local fonts = Enum:getTable("SystemFont")
local cvTypeEnum = Enum:getTable("cvTypeEnum");
local KanbanType = Enum:getTable("KanbanType");
local levelLockItemIds = Enum:getTable("levelLockItemIds");
local CommonShopType = Enum:getTable('CommonShopType');

-- 主界面 按钮tag
local mainMenuTag = {
	TAG_SHOP 		 = 1,		-- 商店
	TAG_ACTIVITY 	 = 2,		-- 福利
	TAG_LOGIN7		 = 3,		-- 福利 七日登录
	TAG_MAIL 		 = 6,		-- 邮件
	TAG_CHAT 		 = 7,		-- 聊天
	--TAG_EVENT 		 = 10,		-- 活动
	TAG_RECHAGE 	 = 11,		-- 充值奖励
	TAG_BATTLEPASS 	 = 12,		-- battlePass
	TAG_THREE_DAY 	 = 13,		-- 剑圣
	TAG_BATTLEPASS_REWARD = 14,	-- battlePass奖励
	TAG_OPEN_ACTIVITY  = 15,	-- 活动
	TAG_CHANGE_BG	 = 16,		-- 背景更换
	TAG_CARD_BOOK	 = 17,		-- 图鉴
	TAG_SIGN	 	 = 18,		-- 签到
	--TAG_MONTH_CARD	 = 19,		-- 月卡
	TAG_RANK		 = 20, 		-- 排行榜
	TAG_QUICK		 = 21, 		-- 快速入口

	TAG_COPYROUND	 = 25,		-- 新副本入口
	TAG_LOGIN_CON	 = 26,		-- 连续登录的入口
	TAG_GROWUP		 = 27,		-- 成长礼包商店入口
	TAG_MAZE_BP		 = 29,		-- 迷宫BP入口
	TAG_BANK_MISSION = 30,		-- bank_mission入口
	TAG_RECHARGE_TASK	= 31,	-- 累计充值奖励入口

	TAG_SPECIAL_SHOP = 32,		-- 特殊商店入口

	TAG_RECHARGE_Day	= 33,	-- 每日累计充值奖励入口
}

local btnNodePos = {
	[mainMenuTag.TAG_SHOP] = cc.p(269 , 1),
	[mainMenuTag.TAG_ACTIVITY] = cc.p(0 , 111),
	[mainMenuTag.TAG_LOGIN7] = cc.p(-269 , 321),
	[mainMenuTag.TAG_MAIL] = cc.p(269 , 321),
	[mainMenuTag.TAG_CHAT] = cc.p(278 , 180),
	--[mainMenuTag.TAG_EVENT] = cc.p(191 , -381),
	[mainMenuTag.TAG_RECHAGE] = cc.p(0 , -51),
	[mainMenuTag.TAG_BATTLEPASS] = cc.p(266 , 333),
	[mainMenuTag.TAG_THREE_DAY] = cc.p(0 , 36),
	[mainMenuTag.TAG_BATTLEPASS_REWARD] = cc.p(266 , 33),
	[mainMenuTag.TAG_OPEN_ACTIVITY] = cc.p(198 , 226),
	[mainMenuTag.TAG_CHANGE_BG] = cc.p(278 , 100),
	[mainMenuTag.TAG_CARD_BOOK] = cc.p(269 , 161),
	[mainMenuTag.TAG_SIGN] = cc.p(269 , 81),
	--[mainMenuTag.TAG_MONTH_CARD] = cc.p(0 , -96),
	[mainMenuTag.TAG_RANK] = cc.p(269 , 241),
	[mainMenuTag.TAG_QUICK] = cc.p(175 , 442),

	[mainMenuTag.TAG_SPECIAL_SHOP] = cc.p(269 , 1),
}

local btnRedDot = {
	[mainMenuTag.TAG_SHOP] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_ACTIVITY] = cc.p(55 , 55),
	[mainMenuTag.TAG_LOGIN7] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_LOGIN_CON] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_GROWUP] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_MAZE_BP] = cc.p(62.5, 70),
	[mainMenuTag.TAG_BANK_MISSION] = cc.p(62.5, 70),
	[mainMenuTag.TAG_MAIL] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_CHAT] = cc.p(45 , 41),
	--[mainMenuTag.TAG_EVENT] = cc.p(27 , -7),
	[mainMenuTag.TAG_RECHAGE] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_BATTLEPASS] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_THREE_DAY] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_BATTLEPASS_REWARD] = cc.p(73 , 72.5),
	[mainMenuTag.TAG_OPEN_ACTIVITY] = cc.p(74 , 75),
	--[mainMenuTag.TAG_GACHA] = cc.p(80, 	115),
	[mainMenuTag.TAG_CHANGE_BG] = cc.p(45 , 41),
	[mainMenuTag.TAG_CARD_BOOK] = cc.p(62.5 , 70),
	[mainMenuTag.TAG_SIGN] = cc.p(62.5 , 70),
	--[mainMenuTag.TAG_MONTH_CARD] = cc.p(55 , 55),
	[mainMenuTag.TAG_RANK] = cc.p(62.5 , 70),
}

local sceneParList = {
	[1] = { 'main_bg_snow', 0.5, 1},
	[2] = { 'main_bg_rain', 0.5, 1},
	[3] = { 'main_bg_cloud', 0, 0.5},
	[4] = { 'main_bg_shine', 0, 1},
	[5] = { 'main_bg_fire', 0.5, 0},
}

local RIGHT_BTN_OPEN = {};
local QUICK_NUM = 0;

function MainPanel:ctor(scene, sceneName , name)
	self.super.ctor(self, scene, sceneName, 'MainPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_ICON;
	self.showFooter = true;
	self.haveSwallowLayer = false;
	-- self:registEvent();

	self.firstShow = true;
	self.bgTime = 0;
	self.sceneParticleIdx = 0;
	self.kanBanType = 0;

	self.curRoleSp = nil;
	self.curRolePic = nil;
end

function MainPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()

	self:registEvent();

	-- self:initTest();
end

function MainPanel:initTest(  )
	-- test 
	-- local nowPw = 1000;
	
	-- local function testCall( sender,event )
	-- 	print('=============test===========')
	-- 	-- local event = cc.EventCustom:new('FORE_GROUND')
	-- 	-- cc.Director:getInstance():getEventDispatcher():dispatchEvent(event)
		
	-- 	local now = nowPw
	-- 	local pwUpdate = math.random( 100,300 )
	-- 	nowPw = nowPw + pwUpdate;
	-- 	FpUpPanel:Show(nowPw,pwUpdate);

	-- end
	-- local testbtn = ccui.Button:create('image/common/common_button_4.png');
	-- testbtn:setPosition(0, 300);
	-- testbtn:setTitleLabel(cc.Label:createWithTTF('test', Enum:getTable("SystemFont").FONT_HUAKANG, 23));
	-- testbtn:addClickEventListener(testCall);
	-- testbtn:addTo(self.root);

end

function MainPanel:registEvent()
	EventManager:RegisterEvent(EventType.UIActivityBtn,handler(self,self.updateBtnRedDot));
	--EventManager:RegisterEvent(EventType.UIUpdateMainActivityPage,handler(self,self.updateMainActivityPage));
	EventManager:RegisterEvent(EventType.UIMainPanelKanBan,handler(self,self.showKanbanMusume));
	-- EventManager:RegisterEvent(EventType.UIMainPanelShowAction,handler(self,self.action)); //方法不存在！！
	-- EventManager:RegisterEvent(EventType.UIMainPanelEventShow,handler(self,self.eventTip));
	-- EventManager:RegisterEvent(EventType.UIMainPanelEventRewardTip,handler(self,self.eventRewardTip));
	EventManager:RegisterEvent(EventType.UIMainPanelMainBg,handler(self,self.setMainBg));
	EventManager:RegisterEvent(EventType.FightIncomeFull,handler(self,self.showFightIncomeFull));
	EventManager:RegisterEvent(EventType.UIUpdateBtnShow,handler(self,self.updateLock));
	EventManager:RegisterEvent(EventType.UIUpdateBattlePassRewardLevel,handler(self,self.updateBattlePassRewardLevel));
	EventManager:RegisterEvent(EventType.UIEventUnlockChange, handler(self, self.updateLevelLock));
	EventManager:RegisterEvent(EventType.UIRetEnterGame, handler(self, self.runLeftBtnAction));

end
function MainPanel:initPanels()

	self.btnNodeName = {
		[mainMenuTag.TAG_MAIL] 			= LANG.UI_MAIN_2,
		[mainMenuTag.TAG_CHAT] 			= LANG.UI_MAIN_3,
		[mainMenuTag.TAG_CHANGE_BG] 	= LANG.UI_MAIN_4,
		[mainMenuTag.TAG_CARD_BOOK] 	= LANG.UI_MAIN_5,
		[mainMenuTag.TAG_SHOP] 			= LANG.UI_MAIN_6,
		[mainMenuTag.TAG_OPEN_ACTIVITY] = LANG.UI_MAIN_7,
		[mainMenuTag.TAG_SIGN] 			= LANG.UI_MAIN_8,
		[mainMenuTag.TAG_RANK] 			= LANG.UI_L_RANK_1,
		[mainMenuTag.TAG_LOGIN7] 		= LANG.UI_MAIN_10,
		[mainMenuTag.TAG_RECHAGE] 		= LANG.UI_SHOP_73,
		[mainMenuTag.TAG_THREE_DAY] 	= LANG.UI_MAIN_11,
		[mainMenuTag.TAG_BATTLEPASS] 	= LANG.UI_BATTLEPASS_1,
		[mainMenuTag.TAG_COPYROUND]		= LANG.UI_MAIN_12,
		[mainMenuTag.TAG_LOGIN_CON]		= LANG.UI_MAIN_13,
		[mainMenuTag.TAG_GROWUP]		= LANG.UI_MAIN_14,
		[mainMenuTag.TAG_MAZE_BP]		= LANG.UI_MAZE_58,
		[mainMenuTag.TAG_BANK_MISSION]  = LANG.UI_MAIN_16,
		[mainMenuTag.TAG_RECHARGE_TASK]	= LANG.UI_RECHARGE_11,
		[mainMenuTag.TAG_SPECIAL_SHOP] 	= LANG.UI_MAIN_15,
		[mainMenuTag.TAG_RECHARGE_Day]	= LANG.UI_RECHARGE_11..'Day',
	}

	self.picSp = cc.Sprite:create();
	self.picSp:setLocalZOrder(-7);
	self.picSp:addTo(self.root)

	self.skeletonNode = cc.Node:create();
	self.skeletonNode:addTo(self.root);
	self.skeletonNode:setLocalZOrder(-5);

	self.sceneParticleNode = cc.Node:create()
	self.sceneParticleNode:addTo(self.root);
	self.sceneParticleNode:setPosition( -StageSize.width/2, -StageSize.height/2 )

	self.cvNode = cc.Node:create()
	self.cvNode:addTo(self.root)

	self.skeletonBg = cc.Sprite:create();
	self.skeletonBg:addTo(self.skeletonNode);

	self.btnNode = cc.Node:create()
		:addTo(self.root)

	self.clippingLayout = ccui.Layout:create();
	self.clippingLayout:addTo(self.btnNode);
	self.clippingLayout:setContentSize(cc.size(100 , 240));
	self.clippingLayout:setPosition(152 , -14);
	self.clippingLayout:setTouchEnabled(false);
	self.clippingLayout:setClippingEnabled(true);

	self.openActivityNode = cc.Node:create();
	self.openActivityNode:addTo(self.clippingLayout);
	self.openActivityNode:setPosition(50 , 360);

	local bg = cc.Sprite:create(imagePath..'main_bg1.png');
	bg:addTo(self.openActivityNode);
	bg:setPosition(0,45);

	self.btns = {};
	local key = {mainMenuTag.TAG_THREE_DAY,mainMenuTag.TAG_RECHAGE};

	for k , v in pairs(key) do
		local i = v;
		local btn = ccui.Button:create(imagePath .. 'main_btn'..i..'.png')
		btn:setPosition(btnNodePos[i]);
		btn:setTag(i);
		btn:addTo(self.openActivityNode);
		btn:addClickEventListener(handler(self, self.btnClick));
		
		self.btns[i] = btn;
	end

	local key = {mainMenuTag.TAG_MAIL,mainMenuTag.TAG_RANK,mainMenuTag.TAG_CHANGE_BG,mainMenuTag.TAG_CARD_BOOK,mainMenuTag.TAG_SIGN,--mainMenuTag.TAG_CHAT,
				mainMenuTag.TAG_SHOP, mainMenuTag.TAG_SPECIAL_SHOP}

	RIGHT_BTN_OPEN = {};
	local index = 1;
	for k, v in pairs(key) do
		local i = v;
		local visible = tools.ConfigStateTools:checkVisibleByType(Enum:getTable('ConfigStateType').MAIN , i);
		if visible then
			btnNodePos[i] = cc.p(269 , 321-80*(index-1));
			local btn = ccui.Button:create(imagePath .. 'main_btnbg.png')
			btn:setPosition(btnNodePos[i]);
			btn:setTag(i);
			btn:addTo(self.btnNode);
			btn:addClickEventListener(handler(self, self.btnClick));
			--btn:setAlphaTouchEnable(true);
			self.btns[i] = btn;

			local btnImg = cc.Sprite:create(imagePath .. 'main_btn'..i..'.png')
				:addTo(btn)
				:setPosition(35.5,43)


			local title = cc.Label:createWithTTF(self.btnNodeName[i], fonts.FONT_SIYUAN, 16)
				:addTo(btn)
				:enableOutline(cc.c4b(80 , 80 , 80 , 255),2)
				:setPosition(35.5 , 10)

			RIGHT_BTN_OPEN[index] = i;
			index = index + 1;
		end
	end

	local btn = ccui.Button:create(imagePath .. 'main_btnbg.png')
	btn:setPosition(btnNodePos[mainMenuTag.TAG_OPEN_ACTIVITY]);
	btn:setTag(mainMenuTag.TAG_OPEN_ACTIVITY);
	btn:addTo(self.btnNode);
	btn:addClickEventListener(handler(self, self.btnClick));
	--btn:setAlphaTouchEnable(true);
	self.btns[mainMenuTag.TAG_OPEN_ACTIVITY] = btn;
	local btnImg = cc.Sprite:create(imagePath .. 'main_btn'..mainMenuTag.TAG_OPEN_ACTIVITY..'.png')
		:addTo(btn)
		:setPosition(35.5,43)
	local title = cc.Label:createWithTTF(self.btnNodeName[mainMenuTag.TAG_OPEN_ACTIVITY], fonts.FONT_SIYUAN, 16)
		:addTo(btn)
		:enableOutline(cc.c4b(70 , 135 , 200 , 255),2)
		:setPosition(50 , 18)
	

	index = 1;
	local key = {mainMenuTag.TAG_LOGIN7,mainMenuTag.TAG_THREE_DAY,mainMenuTag.TAG_RECHAGE, mainMenuTag.TAG_RECHARGE_TASK,
				mainMenuTag.TAG_RECHARGE_Day,
				mainMenuTag.TAG_BATTLEPASS, mainMenuTag.TAG_COPYROUND, mainMenuTag.TAG_LOGIN_CON, 
				mainMenuTag.TAG_GROWUP, mainMenuTag.TAG_MAZE_BP, mainMenuTag.TAG_BANK_MISSION}
	for k, v in pairs(key) do
		local i = v;
		btnNodePos[i] = cc.p(-269 , 321-80*(index-1));
		local btn = ccui.Button:create(imagePath .. 'main_btnbg.png')
		btn:setPosition(btnNodePos[i]);
		btn:setTag(i);
		btn:addTo(self.btnNode);
		btn:addClickEventListener(handler(self, self.btnClick));
		--btn:setAlphaTouchEnable(true);
		self.btns[i] = btn;
		local btnImg = cc.Sprite:create(imagePath .. 'main_btn'..i..'.png')
			:addTo(btn)
			:setPosition(35.5,43)
		local title = cc.Label:createWithTTF(self.btnNodeName[i], fonts.FONT_SIYUAN, 16)
			:addTo(btn)
			:enableOutline(cc.c4b(80 , 80 , 80 , 255),2)
			:setPosition(35.5 , 10)

		index = index + 1;
	end


	--quick pageView
	local quickNode = cc.Node:create()
		:addTo(self.btnNode)
		:setPosition(btnNodePos[mainMenuTag.TAG_QUICK])

	self.btns[mainMenuTag.TAG_QUICK] = quickNode;

	self.quickPageView = ccui.PageView:create()
	self.quickPageView:addTo(quickNode)
	self.quickPageView:setContentSize(cc.size(274 , 89))
	self.quickPageView:setAnchorPoint(0.5,0.5)
    self.quickPageView:addEventListener(handler(self , self.quickPageViewEvent))
    self.quickPageCell = {}

	self.curQuickPagePosBgList = {};
	self.curQuickPagePos = cc.Sprite:create(imagePath..'main_quick_circle.png')
		:addTo(quickNode)
		:setPosition(0 , -55)

	QUICK_NUM = 0;
	local mainQuickData = {};
	self.mainQuickNo = {};
	local main_quick = ResTable:getTable('main_quick').contain;
	local curTime = TimeManager:getCurTime();
	for _k , quickData in pairs(main_quick) do
		if quickData.open_time <= curTime and quickData.close_time > curTime then 
			table.insert(mainQuickData,quickData);
			QUICK_NUM = QUICK_NUM + 1;
			table.insert(self.mainQuickNo,quickData.no);
		end
	end
	if QUICK_NUM > 1 then
		table.sort(mainQuickData , function(first , second)
			return first.no < second.no;
		end);
	end
	if QUICK_NUM > 0 then
		for _k , quickData in ipairs(mainQuickData) do
			self:createQuickPage(quickData)
			local circle = cc.Sprite:create(imagePath..'main_quick_circle.png')
				:addTo(quickNode)
				:setPosition(-((QUICK_NUM-1)*16/2)+16*(_k-1),-55)
				:setOpacity(125)
			table.insert(self.curQuickPagePosBgList,circle);
		end
		self.btns[mainMenuTag.TAG_QUICK]:setVisible(true);
	else
		self.btns[mainMenuTag.TAG_QUICK]:setVisible(false);
	end

	-- btn_event 
	--local btn = ccui.Button:create(imagePath .. 'main_btn'..mainMenuTag.TAG_EVENT..'.png')
	--btn:addTo(self.btnNode)
	--btn:setTag(mainMenuTag.TAG_EVENT)
	--btn:setPosition(btnNodePos[mainMenuTag.TAG_EVENT]);
	--btn:addClickEventListener(handler(self, self.btnClick));
	--self.btns[mainMenuTag.TAG_EVENT] = btn;
--
	--local bg = cc.Sprite:create(imagePath..'main_event_bg.png');
	--bg:addTo(btn);
	--bg:setPosition(btn:getContentSize().width/2,btn:getContentSize().height/2);


	self.swtichBtn = ccui.Button:create('image/main/main_witch_btn_1_.png' , 'image/main/main_witch_btn_1_.png');
	self.swtichBtn:addTo(self.btnNode);
	self.swtichBtn:setPosition(-StageSize.width/2+120 , -StageSize.height/2+146);
	self.swtichBtn:addClickEventListener(handler(self , self.swtichBtnClick));

	self.swtichBtnImg = cc.Sprite:create('image/main/main_live2d_off.png');
	self.swtichBtnImg:addTo(self.swtichBtn);
	self.swtichBtnImg:setPosition(self.swtichBtn:getContentSize().width/2,self.swtichBtn:getContentSize().height/2+4);

	self.showLive2dBtn = ccui.Button:create('image/main/main_witch_btn_1_.png', 'image/main/main_witch_btn_1_.png'); --, 'image/main/main_live2d_off.png','image/main/main_live2d_off.png'
	self.showLive2dBtn:addTo(self.root);
	self.showLive2dBtn:setPosition(-StageSize.width/2+56 , -StageSize.height/2+146);
	self.showLive2dBtn:addClickEventListener(handler(self , self.showLive2dBtnCall));
	self.showLive2dBtn:setTag(1);

	self.showLive2dImg = cc.Sprite:create('image/main/main_ui_off.png');
	self.showLive2dImg:addTo(self.showLive2dBtn);
	self.showLive2dImg:setPosition(self.swtichBtn:getContentSize().width/2,self.swtichBtn:getContentSize().height/2+4);

	self.helpBtn = ccui.Button:create('image/commonImg/help_2.png','image/commonImg/help_2.png')
	self.helpBtn:addTo(self.btnNode);
	self.helpBtn:setPosition(-269 , StageSize.height/2-142-NOTCH_HEIGHT);
	self.helpBtn:addClickEventListener(function()
		UIManager:push('HelpPanel',self.name);
	end)
end

function MainPanel:createQuickPage(quickData)
	local widget = ccui.Widget:create()
			:setContentSize(cc.size(274 , 89))
	self.quickPageView:addPage(widget);
	local btn = ccui.ImageView:create(imagePath..'banner/'..quickData.picture..'.png')
	btn:addTo(widget)
	btn:setPosition(137,44.5)
	btn:setSwallowTouches(false)
	btn:setTouchEnabled(true)
	btn:setTag(quickData.no)
	btn:addClickEventListener(handler(self,self.quickBtnClick))
	table.insert(self.quickPageCell,btn);
end

function MainPanel:showLive2dBtnCall( sender,event )
	local tag = sender:getTag();

	local nextTag = 1;
	local btnImg = 'image/main/main_ui_off.png'
	if tag == 1 then
		-- 屏蔽
		nextTag = 2;
		btnImg = 'image/main/main_ui_on.png';

		self.btnNode:setVisible(false)
		UIManager:pop('HeaderPanel')
		UIManager:pop('FooterPanel')
	else
		-- 显示
		self.btnNode:setVisible(true)
		UIManager:push("HeaderPanel" , self.name , self);
		UIManager:push("FooterPanel" , self.name);

	end
	self.showLive2dBtn:setTag(nextTag)
	self.showLive2dImg:setTexture(btnImg)
end

function MainPanel:swtichBtnClick()
	-- body
	if self.skeletonNode:isVisible() then
		self.swtichBtnImg:setTexture('image/main/main_live2d_on.png');
		self.picSp:setVisible(true)
		self.skeletonNode:setVisible(false)
		self.curTouchNode = self.picSp;
	else
		self.swtichBtnImg:setTexture('image/main/main_live2d_off.png');
		self.picSp:setVisible(false)
		self.skeletonNode:setVisible(true)
		self.curTouchNode = self.skAnimation;
	end
end

function MainPanel:showFightIncomeFull(  )
	
	if not model.GuideModel:isInGuide() then
		local MessageBoxType = Enum:getTable('MessageBoxType')
		MessageBox:create(LANG.UI_FIGHT_76,MessageBoxType.CANCEL_OK,function (  )
			AudioManager:playEffect(Conf.confirmButton);
			EventManager:FireEvent(EventType.UIFooterChooseFooter , 3);
		end)
	end
end

function MainPanel:updateBattlePassRewardLevel()
	--local level = model.BattlepassEventModel:getCurBattlePassRewardNo() or 0;
	--self.battlePassRewardLevel:setString(string.format(LANG.UI_MAIN_1 , level));
end

function MainPanel:updateBtnRedDot(index)
	local show = false
	if self.btns[index] == nil then
		return 
	end
	if index == mainMenuTag.TAG_CHAT then
		-- UIManager:push('ChatPanel');
	elseif index == mainMenuTag.TAG_SHOP then
		show = model.ShopModel:getShopActiveState()
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index]);
	elseif index == mainMenuTag.TAG_MAIL then
		show = model.MailModel:getRedDotStateMail()
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	--elseif index == mainMenuTag.TAG_ACTIVITY then
	--	show = model.ActivityModel:getRedDotStateActivity()
	--	tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	elseif index == mainMenuTag.TAG_LOGIN7 then
		show = model.ActivityModel:getRedDotStateLogin7()
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	elseif index == mainMenuTag.TAG_LOGIN_CON then
		show = model.ActivityModel:getRedDotStateLoginCon()
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	elseif index == mainMenuTag.TAG_GROWUP then
		show = model.ShopModel:getShopActiveState(CommonShopType.GROWUP)
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	elseif index == mainMenuTag.TAG_OPEN_ACTIVITY then
		show = model.ActivityModel:getRedDotThreeDay()
		if not show then
			show = model.RechargeModel:getRedDotStateRecharge()
		end
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	elseif index == mainMenuTag.TAG_RECHAGE then 
		show = model.RechargeModel:getRedDotStateRecharge();
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	elseif index == mainMenuTag.TAG_THREE_DAY then
		show = model.ActivityModel:getRedDotThreeDay()
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	elseif index == mainMenuTag.TAG_SIGN then
		show = model.ActivityModel:getRedDotSign();
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index])
	elseif index == mainMenuTag.TAG_CARD_BOOK then
		show = model.CardModel:getCardBookActiveState();
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index]);
	elseif index == mainMenuTag.TAG_BATTLEPASS then
		show = model.BattlepassEventModel:getBattlepassActiveState();
		tools.RedDotTools:setRedDotToNode(self.btns[index],show,nil,btnRedDot[index]);
	end
end
function MainPanel:btnClick(sender , event)
	local index = sender:getTag();
	AudioManager:playEffect(Conf.buttonClick);


	if self:checkClickLock(index) then
		return
	end

	if index == mainMenuTag.TAG_CHAT then
		UIManager:push('ChatPanel');

	elseif index == mainMenuTag.TAG_SHOP then
		UIManager:push('ShopPanel');
	elseif index == mainMenuTag.TAG_MAIL then
		UIManager:push('MailPanel');
	elseif index == mainMenuTag.TAG_COPYROUND then
		UIManager:push('CopyRoundPanel')
	elseif index == mainMenuTag.TAG_LOGIN_CON then
		UIManager:push('LoginConRewardPanel')
	elseif index == mainMenuTag.TAG_GROWUP then
		UIManager:push('ShopPanel' , Enum:getTable('CommonShopType').GROWUP);
	--elseif index == mainMenuTag.TAG_ACTIVITY then 
	--	UIManager:push('ActivityPanel' , model.ActivityModel.ActivityMenuIndex.LEVEL_GIFT)
	elseif index == mainMenuTag.TAG_LOGIN7 then
		UIManager:push('Login7RewardPanel')
	elseif index == mainMenuTag.TAG_MAZE_BP then
		local endTime = model.EventModel:getBPData().show_time;
		local lastTime = endTime - TimeManager:getCurTime()
		if lastTime > 0 then
			UIManager:push('EventBattlePassPanel')
		else
			Prompt:Show(LANG.UI_L_OVER)
		end
	--elseif index == mainMenuTag.TAG_EVENT then
	--	UIManager:push('EventMainPanel');
	elseif index == mainMenuTag.TAG_RECHAGE then
		UIManager:push('ActivityRechargePanel');
	elseif index == mainMenuTag.TAG_THREE_DAY then
		UIManager:push('ThreeDayActivityPanel');
	elseif index == mainMenuTag.TAG_OPEN_ACTIVITY then
		self:updateOpenActivityNode();
	elseif index == mainMenuTag.TAG_CHANGE_BG then
		UIManager:push('BgSelectPanel');
	elseif index == mainMenuTag.TAG_CARD_BOOK then
		UIManager:push('CardBookPanel');
	elseif index == mainMenuTag.TAG_SIGN then
		UIManager:push('ActivityPanel' , model.ActivityModel.ActivityMenuIndex.SIGN)
	elseif index == mainMenuTag.TAG_RANK then
		UIManager:push('RankListPanel');
	elseif index == mainMenuTag.TAG_BATTLEPASS then
		UIManager:push('BattlepassEventPanel');
	elseif index == mainMenuTag.TAG_BANK_MISSION then
		UIManager:push('BankPanel')
	elseif index == mainMenuTag.TAG_RECHARGE_TASK then
		UIManager:push('RechargeTaskPanel', 2)
	elseif index == mainMenuTag.TAG_RECHARGE_Day then
		UIManager:push('RechargeTaskPanel', 3)
	elseif index == mainMenuTag.TAG_SPECIAL_SHOP then
		UIManager:push('StorePanel', Enum:getTable('CommonShopType').SPECIAL);
	end
end

function MainPanel:checkClickLock( index )
	local locked = false;
	local lockLv = 0;

	local isLock = tools.ConfigStateTools:checkLockByType(Enum:getTable('ConfigStateType').MAIN,index)
	if isLock then
		Prompt:Show(LANG.COMMON_CLOSE);
        return;
	end

	if index == mainMenuTag.TAG_CHAT then

	elseif index == mainMenuTag.TAG_SHOP then

	elseif index == mainMenuTag.TAG_MAIL then
		-- locked ,lockLv = model.MailModel:getLockStateMail();
	elseif index == mainMenuTag.TAG_LOGIN7 then 
		locked,lockLv = model.ActivityModel:getLockStateLogin7();
	elseif index == mainMenuTag.TAG_COPYROUND then
		locked , lockLv = tools.LevelLockTools:checkLockById(24);--levelLockItemIds.LEVLE_LOCK_24
	--elseif index == mainMenuTag.TAG_OPEN_ACTIVITY then
	--	locked,lockLv = model.ActivityModel:getLockStateLogin7();
	elseif index == mainMenuTag.TAG_RECHAGE then 
		locked,lockLv = model.RechargeModel:getLockLevelStateRecharge();
	elseif index == mainMenuTag.TAG_BATTLEPASS then
		--locked,lockLv = model.BattlepassEventModel:getLockStateBattlePass();
	elseif index == mainMenuTag.TAG_SIGN then
		locked,lockLv = model.ActivityModel:getLockStateActivityByIndex(model.ActivityModel.ActivityMenuIndex.SIGN);
	elseif index == mainMenuTag.TAG_RANK then
		locked,lockLv = model.RankModel:getLockStateRank();
	elseif index == mainMenuTag.TAG_MAZE_BP then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_23)
	end
	if locked then
		if index == mainMenuTag.TAG_SIGN then
			Prompt:Show(string.format(LANG.UI_ACTIVITY_43 , lockLv));
		elseif index == mainMenuTag.TAG_LOGIN7 then
			Prompt:Show(string.format(LANG.UI_MAIN_9 , lockLv));
		elseif lockLv then
			Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
		end
	end

	return locked

end

function MainPanel:updateLock( index )
	local locked = false;
	local lockLv = 0;
	if self.btns[index] == nil then
		return 
	end

	local visible = tools.ConfigStateTools:checkVisibleByType(Enum:getTable('ConfigStateType').MAIN,index);
	if not visible then
		self.btns[index]:setVisible(visible);
		return;
	end

	local isLock = tools.ConfigStateTools:checkLockByType(Enum:getTable('ConfigStateType').MAIN,index)
	if isLock then
		local size = self.btns[index]:getContentSize();
		tools.LevelLockTools:setLockToNode(self.btns[index],isLock,1,1,cc.p(size.width/2,size.height/2))
	else
		tools.LevelLockTools:setLockToNode(self.btns[index],false,1,1,cc.p(0,0))
	end

	if index == mainMenuTag.TAG_CHAT then

	elseif index == mainMenuTag.TAG_ACTIVITY then
	
	elseif index == mainMenuTag.TAG_SHOP then
		
	elseif index == mainMenuTag.TAG_MAIL then
		-- local locked,lockLv = model.MailModel:getLockStateMail()
		-- tools.LevelLockTools:setLockToNode(self.btns[mainMenuTag.TAG_MAIL].node,locked,lockLv,1,cc.p(0,0))
	elseif index == mainMenuTag.TAG_LOGIN7 then
		locked,lockLv = model.ActivityModel:getLockStateLogin7();
		self.btns[index]:setVisible(not locked);
	elseif index == mainMenuTag.TAG_COPYROUND then
		local open = model.RoundModel:isOpenCopyRound();
		self.btns[index]:setVisible(open);
	elseif index == mainMenuTag.TAG_MAZE_BP then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_23)
		local size = self.btns[index]:getContentSize();
		tools.LevelLockTools:setLockToNode(self.btns[index],locked,lockLv,1,cc.p(size.width/2,size.height/2))
	--elseif index == mainMenuTag.TAG_OPEN_ACTIVITY then
		--self:updateOpenActivityBtn();
	--elseif index == mainMenuTag.TAG_RECHAGE then
		--locked,lockLv = model.RechargeModel:getLockStateRecharge();
		--self.btns[index]:setVisible(not locked);
	--elseif index == mainMenuTag.TAG_EVENT then 
	--	locked,lockLv = model.EventModel:getLockStateEvent();
	--	self.btns[index]:setVisible(not locked);
	--elseif index == mainMenuTag.TAG_THREE_DAY then
	--	locked = model.ActivityModel:getThreeDayLocked();
	--	self.btns[index]:setVisible(not locked);
	--elseif index == mainMenuTag.TAG_BATTLEPASS then
	--	locked = model.BattlepassEventModel:getLockStateBattlePass();
	--	self.btns[index]:setVisible(not locked);
	--elseif index == mainMenuTag.TAG_BATTLEPASS_REWARD then
	--	locked = model.BattlepassEventModel:getLockStateBattlePassReward()
	--	self.btns[index]:setVisible(not locked);
	end
end

function MainPanel:updateLvLock(index)
	if index == mainMenuTag.TAG_RANK then
		self:updateLevelLock(levelLockItemIds.LEVLE_LOCK_22);
	elseif index == mainMenuTag.TAG_SIGN then
		self:updateLevelLock(levelLockItemIds.LEVLE_LOCK_4);
	end
end
function MainPanel:updateLevelLock( startId )
	if startId == levelLockItemIds.LEVLE_LOCK_22 then
		if self.btns[mainMenuTag.TAG_RANK] then
			local size = self.btns[mainMenuTag.TAG_RANK]:getContentSize();
			local locked,lockLv = model.RankModel:getLockStateRank();
			tools.LevelLockTools:setLockToNode(self.btns[mainMenuTag.TAG_RANK],locked,lockLv,1,cc.p(size.width/2,size.height/2))
		end
	elseif startId == levelLockItemIds.LEVLE_LOCK_4 then
		if self.btns[mainMenuTag.TAG_SIGN] then
			local size = self.btns[mainMenuTag.TAG_SIGN]:getContentSize();
			local locked,lockLv = model.ActivityModel:getLockStateActivityByIndex(model.ActivityModel.ActivityMenuIndex.SIGN);
			tools.LevelLockTools:setLockToNode(self.btns[mainMenuTag.TAG_SIGN],locked,lockLv,1,cc.p(size.width/2,size.height/2))
		end
	elseif startId == levelLockItemIds.LEVLE_LOCK_23 then
		if self.btns[mainMenuTag.TAG_MAZE_BP] then
			local size = self.btns[mainMenuTag.TAG_MAZE_BP]:getContentSize();
			tools.LevelLockTools:setLockToNode(self.btns[mainMenuTag.TAG_MAZE_BP],false,1,1,cc.p(size.width/2,size.height/2))
		end
	end
end

function MainPanel:onEnter()
	GlobalFunctions:recordTime('fb-log---MainPanel:onEnter')
	self.root:setVisible(true);
	
	self.markTime = 0;
	self:checkChangeBg();

	self:showKanbanMusume();
	
	self:resetQuick()

	if not AudioManager:isMusicPlaying() then
		AudioManager:playMusic(Conf.main, 2, true);
	end

	self.openActivityOpenPosY = 360;

	self:updateLvLock(mainMenuTag.TAG_RANK);
	--self:updateLvLock(mainMenuTag.TAG_SIGN);

	self:updateLock(mainMenuTag.TAG_SHOP);
	self:updateLock(mainMenuTag.TAG_MAIL);
	self:updateLock(mainMenuTag.TAG_LOGIN7);
	--self:updateLock(mainMenuTag.TAG_OPEN_ACTIVITY);
	--self:updateLock(mainMenuTag.TAG_RECHAGE);
	--self:updateLock(mainMenuTag.TAG_EVENT);
	--self:updateLock(mainMenuTag.TAG_THREE_DAY);
	self:updateLock(mainMenuTag.TAG_CARD_BOOK);
	self:updateLock(mainMenuTag.TAG_BATTLEPASS);
	self:updateLock(mainMenuTag.TAG_SIGN);
	self:updateLock(mainMenuTag.TAG_RANK);
	self:updateLock(mainMenuTag.TAG_COPYROUND);
	self:updateLock(mainMenuTag.TAG_MAZE_BP);

	self:updateBtnRedDot(mainMenuTag.TAG_SHOP);
	self:updateBtnRedDot(mainMenuTag.TAG_MAIL);
	self:updateBtnRedDot(mainMenuTag.TAG_SIGN);
	self:updateBtnRedDot(mainMenuTag.TAG_LOGIN7);
	self:updateBtnRedDot(mainMenuTag.TAG_LOGIN_CON);
	self:updateBtnRedDot(mainMenuTag.TAG_GROWUP);
	self:updateBtnRedDot(mainMenuTag.TAG_OPEN_ACTIVITY);
	self:updateBtnRedDot(mainMenuTag.TAG_RECHAGE);
	self:updateBtnRedDot(mainMenuTag.TAG_THREE_DAY);
	self:updateBtnRedDot(mainMenuTag.TAG_CARD_BOOK);
	self:updateBtnRedDot(mainMenuTag.TAG_BATTLEPASS);

	-- 检测新手引导

	self:updateBattlePassRewardLevel();
	self.openActivityNodeState = 1;
	self:runAction();
	self:addSwallowCallback(handler(self , self.resetOpenActivityNode))
	EventManager:FireEvent(EventType.UIFooterUpdateSelect,1);

	local roleId,avatarId = model.UserModel:getKanbanRoleAndAvatar()
	AudioManager:preloadCV(roleId) 
	self.onTouchBegin = true;
	local ret = AudioManager:playCVStopBefor(roleId ,nil,cvTypeEnum.CV_HOME_LOGIN1 );
	if ret ~= nil and ret ~= -1 then
		-- local pos = cc.p(self.curTouchNode:getPosition())
		-- GlobalFunctions:showCVInfo(self.cvNode);

		self.onTouchBegin = false;
		GlobalFunctions:showCVInfo(self.cvNode,nil,nil,nil,nil,
			function()
				self.onTouchBegin = true;
			end
		);

	end

	if model.GuideModel:getBJustEnd() then
		model.GuideModel:setBJustEnd(false)
		if model.UserModel:getIsPopNotice() == 1 and model.UserModel:getUserLevel()<7 then
			UIManager:push('AnnouncePanel')
		end
	end
end

function MainPanel:updateOpenActivityBtn()
	local key = {mainMenuTag.TAG_THREE_DAY,mainMenuTag.TAG_RECHAGE};

	local index = 0;
	for k , v in pairs(key) do
		local visible = tools.ConfigStateTools:checkVisibleByType(Enum:getTable('ConfigStateType').MAIN,v);
		if visible then
			if v == mainMenuTag.TAG_THREE_DAY then
				visible = not model.ActivityModel:getThreeDayLocked();
			end
		end
		if visible then
			self.btns[v]:setPositionY(-51+87*index);
			index = index + 1;
		end
		self.btns[v]:setVisible(visible);
	end
	self.openActivityOpenPosY = 290 - 85*index;

	return index;
end

function MainPanel:resetOpenActivityNode()
	if self.openActivityNodeState == 2 then
		self.openActivityNode:stopAllActions();
		self.openActivityNode:setPosition(50 , self.openActivityOpenPosY);
		self.openActivityNode:runAction(cc.MoveTo:create(0.3 , cc.p(50 , 360)));
		self.openActivityNodeState = 1;
	end
end

function MainPanel:updateOpenActivityNode()
	if 1 == self.openActivityNodeState then --关闭状态，打开
		self.openActivityNode:stopAllActions();
		self.openActivityNode:setPosition(50 , 360);
		self.openActivityNode:runAction(cc.MoveTo:create(0.3 , cc.p(50 , self.openActivityOpenPosY)));
		self.openActivityNodeState = 2;
	else
		self:resetOpenActivityNode();
	end
end

function MainPanel:showKanbanMusume()
	local kType , no = model.UserModel:getKanban();

	if not kType then
		kType = 1;
	end

	if not no then
		no = 13;
	end

	self.kanBanType = kType;

	-- self:clearKanbanMusume();
	local role_res = '';
	local spine_bg = '';
	local spine_res = nil;
	if kType == KanbanType.KANBAN_ROLE then
		local resourceId = ResTable:getValue('role' , no , 'resource_id');
		local resData = ResTable:getRowData('role_resource', resourceId);
		role_res = resData.card;
		spine_res = resData.spine;

		self:setMainBg()
		self.sceneParticleNode:setVisible(true)

	elseif kType == KanbanType.KANBAN_AVATAR then
		local resData = ResTable:getRowData('role_resource', no);
		role_res = resData.card;
		spine_res = resData.spine;

		self:setMainBg(1)
		self.sceneParticleNode:setVisible(true)

	elseif kType == KanbanType.KANBAN_LOVE then
		local loveData = ResTable:getRowData('role_love',no);
		role_res = loveData.show_pg;
		if loveData.show_spine then
			spine_res = loveData.show_spine;
		end
		if loveData.spine_bg then
			spine_bg = 'image/cardLove/'..loveData.spine_bg..'.png';
		end

		self.sceneParticleNode:setVisible(false)

	elseif kType == KanbanType.KANBAN_BARE then
		local resourceId = ResTable:getValue('bare_collect' , no , 'resource_id');
		local resData = ResTable:getRowData('role_resource', resourceId);
		role_res = resData.card;
		spine_res = resData.spine;

		self:setMainBg()
		self.sceneParticleNode:setVisible(true)

	end

	local bUpdate = false;
	if self.curRolePic ~= role_res or self.curRoleSp~=spine_res then
		self.curRoleSp = spine_res;
		self.curRolePic = role_res;
		bUpdate = true;
	end

	if bUpdate then
		self.picSp:setTexture('image/role/'..role_res..'.png');
		self.picSp:setPosition(0 , 0);
		self.picSp:setScale(1.0);

		self.skeletonBg:setTexture(spine_bg);
		if spine_res~=nil and cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			self.picSp:setVisible(false)
			self.skeletonNode:setVisible(true);
			self.spPlayTouch = false
			self:clearKanbanMusume();
			self.skAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)

			--self.skAnimation:setPosition(165 , 107);
			self.skAnimation:addTo(self.skeletonNode)
			self.skAnimation:setLocalZOrder(5)
			self.skAnimation:setAnimation(0, "idle", true)
	    
			self.skAnimation:registerSpineEventHandler(function (event)
				if self.spPlayTouch then
					self.spPlayTouch = false
					self.skAnimation:setMix('touch', 'idle', 0.7)
					self.skAnimation:setAnimation(0, "idle", true)
				end
		--		print(string.format("[spine] %d complete: %d", 
		--								event.trackIndex,
		--								event.loopCount))
			end, sp.EventType.ANIMATION_COMPLETE)

			self.curTouchNode = self.skAnimation;

			local listener = cc.EventListenerTouchOneByOne:create()
			listener:registerScriptHandler(function (touch, event)
				-- print('be touched kanban')

				return true
		    end, cc.Handler.EVENT_TOUCH_BEGAN )

			local eventDispatcher = self.root:getEventDispatcher()
			eventDispatcher:addEventListenerWithSceneGraphPriority(listener, self.root)

			self.swtichBtn:setVisible(true)
			self.swtichBtnImg:setTexture('image/main/main_live2d_off.png');
		else
			self.swtichBtn:setVisible(false)
			self.skeletonNode:setVisible(false);
			self.picSp:setVisible(true)
			self.curTouchNode = self.picSp;
		end

		self.nextTaskId = nil;
		
	end
	self:addTouchEvent();


end

function MainPanel:addTouchEvent()

	self.distance = 0;
	self.deltax = 0;
	self.deltay = 0;
	self.mscale = 1.0;

	if self.touchListener then
		local eventDispatcher = cc.Director:getInstance():getEventDispatcher();
		eventDispatcher:removeEventListener(self.touchListener);
	end
	-- listener
	local touchesBegan = function(touches, event)
		if self.root:isVisible() == false then
			return
		end
		self:resetOpenActivityNode();
		-- self.onTouchBegin = true ;
		--if #touches >= 2 then
		--	local touch = touches[1];
		--	local pos = touch:getLocation();
		--	local pos1 = self.spineNode:convertToNodeSpace(pos);

		--	touch = touches[2];
		--	pos = touch:getLocation();
		--	local pos2 = self.spineNode:convertToNodeSpace(pos);

		--	self.distance=math.sqrt((pos2.x-pos1.x)*(pos2.x-pos1.x)+(pos2.y-pos1.y)*(pos2.y-pos1.y));
		--	self.deltax = (pos1.x + pos2.x)/2 - self.mainb:getPositionX();
		--	self.deltay = (pos1.y + pos2.y)/2 - self.mainb:getPositionY();
		--end
    end

	local touchesMoved = function(touches, event)
		if self.root:isVisible() == false then
			return
		end
		if self.kanBanType == 3 or self.kanBanType == 4 then
			return;
		end

		if #touches >= 2 then
    	
        	local touch = touches[1];
			local pos = touch:getLocation();
			local pos1 = self.root:convertToNodeSpace(pos);

			touch = touches[2];
			pos = touch:getLocation();
			local pos2 = self.root:convertToNodeSpace(pos);

			local mdistance=math.sqrt((pos2.x-pos1.x)*(pos2.x-pos1.x)+(pos2.y-pos1.y)*(pos2.y-pos1.y));

			if self.distance == 0 then
				self.distance = mdistance
				self.deltax = (pos1.x+ pos2.x)/2 - self.curTouchNode:getPositionX();
				self.deltay = (pos2.y + pos1.y)/2 - self.curTouchNode:getPositionY();
				return
			end

			self.mscale = mdistance/self.distance * self.mscale;
			
			if self.mscale > 1.5 then
				self.mscale = 1.5;
			elseif self.mscale < 0.3 then
				self.mscale = 0.3;
			end

			self.distance = mdistance;
		
        	self.curTouchNode:setScale(self.mscale);
			
        	local x = (pos2.x+pos1.x)/2 - self.deltax;
			local y = (pos2.y+pos1.y)/2 - self.deltay;
		
        	self.curTouchNode:setPosition(ccp(x,y));
        	self.deltax = (pos1.x+ pos2.x)/2 - self.curTouchNode:getPositionX();
			self.deltay = (pos2.y + pos1.y)/2 - self.curTouchNode:getPositionY();
		elseif #touches == 1 then
			local x , y = self.curTouchNode:getPosition();
			local delta = touches[1]:getDelta();
			self.curTouchNode:setPosition(x + delta.x , y + delta.y);
        end
    end

    local touchesEnded = function(touches, event)
    	if self.root:isVisible() == false then
			return
		end
    	if #touches == 1 then
    		local touch = touches[1];
			local posEnd = touch:getLocation();
			local posStart = touch:getStartLocation()
			local dis = cc.pGetDistance(posStart,posEnd)
			if dis < 20 then
				if self.skAnimation and self.spPlayTouch==false then
					self.spPlayTouch = true;
					self.skAnimation:setMix('idle', 'touch', 0.7)
					self.skAnimation:setAnimation(0, "touch", false)
				end
				if 	self.onTouchBegin == true then
					local kanBanType,resourceId, no = model.UserModel:getKanbanTypeAndResourceId()
					if self.kanBanType == 3 then
						local loveData = ResTable:getRowData('role_love',no);
						if self.nextTaskId == nil then
							self.nextTaskId = model.UserModel:InitLoveCvInfo(loveData.dialog_id)
						end
						local ret = AudioManager:playLoveCVStopBefor(loveData.role_id,loveData.love_lv,cvTypeEnum.CV_TOUCH1);
						if ret ~= nil and ret ~= -1 then
							self.nextTaskId = GlobalFunctions:showCVInfo(self.cvNode,self.nextTaskId,nil,nil,nil,
								function()
									self.onTouchBegin = true;
								end
							,1);
						end
					else
						local ret = AudioManager:playCVStopBefor( resourceId,nil,cvTypeEnum.CV_TOUCH1 );
						if ret ~= nil and ret ~= -1 then
							-- local pos = cc.p(self.curTouchNode:getPosition())
							GlobalFunctions:showCVInfo(self.cvNode,nil,nil,nil,nil,
								function()
									self.onTouchBegin = true;
								end
							);
						end
					end
					self.onTouchBegin = false;
				else
				end

	    	end
	    end
		self.distance = 0;
		self.deltax = 0;
		self.deltay = 0;
    end

    local touchesCancelled = function(touch, event)
		self.distance = 0;
		self.deltax = 0;
		self.deltay = 0;
	end
	
	self.touchListener = cc.EventListenerTouchAllAtOnce:create()
    self.touchListener:registerScriptHandler(touchesBegan, cc.Handler.EVENT_TOUCHES_BEGAN)
    self.touchListener:registerScriptHandler(touchesMoved, cc.Handler.EVENT_TOUCHES_MOVED)
    self.touchListener:registerScriptHandler(touchesEnded, cc.Handler.EVENT_TOUCHES_ENDED)
    self.touchListener:registerScriptHandler(touchesCancelled, cc.Handler.EVENT_TOUCHES_CANCELLED)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(self.touchListener, self.curTouchNode)
end

function MainPanel:checkChangeBg()
	-- body
	local curT = 0
	local partIdx = 0
	local h = tonumber(os.date("%H",TimeManager:getCurTime()));
	if h>= 6 and h<= 15 then
		curT = 1
		partIdx = math.random(1,4)
	elseif h>=16 and h<=19 then
		curT = 2
		partIdx = math.random(1,5)
	else
		curT = 3
		partIdx = math.random(1,3)
	end
	partIdx = 2
	if curT ~= self.bgTime then
		self.bgTime = curT;
		self:setMainBg()
	end

end

function MainPanel:setMainBg( forceId )
	local no = model.UserModel:getMainBg();
	if not no or forceId==1 then
		no = 1;
	end
	if self.kanBanType == KanbanType.KANBAN_AVATAR or self.kanBanType == KanbanType.KANBAN_LOVE then
		no = 1;
	end

	local data = ResTable:getRowData('background', no)
	local res = ''
	local sp_res = ''
	if data and data.res then
		res = data.res;
	end
	if data and data.sp_res then
		sp_res = data.sp_res;
	end
	if data then
		if data.res_l and data.res_l[self.bgTime] then
			local bgResId = data.res_l[self.bgTime];
			local resVal = ResTable:getValue('background_res', bgResId, 'resource');
			if resVal then
				res = resVal;
			end
		end
		if data.sp_res_l and data.sp_res_l[self.bgTime] then
			local bgResId = data.sp_res_l[self.bgTime];
			local resVal = ResTable:getValue('background_res', bgResId, 'resource');
			if resVal then
				sp_res = resVal;
			end
		end
	end

	local bg_path = 'image/background/' .. res .. '.png'
	local bg_spine_json_path = '';
	local bg_spine_atlas_path = '';
	if sp_res and sp_res ~= '' then
		bg_spine_json_path = 'spine/'..sp_res..'/'..sp_res..'.json';
		bg_spine_atlas_path = 'spine/'..sp_res..'/'..sp_res..'.atlas';
	end
	if self.bg then
		self.bg:removeFromParent()
		self.bg = nil
	end
	if res ~= '' and cc.FileUtils:getInstance():isFileExist(bg_path) then
		self.bg = cc.Sprite:create(bg_path)
			:setLocalZOrder(-10)
			:addTo(self.root)
	end
	if self.bg_spine then
		self.bg_spine:removeFromParent()
		self.bg_spine = nil
	end
	if sp_res ~= nil and sp_res ~= '' and cc.FileUtils:getInstance():isFileExist(bg_spine_json_path) then
		self.bg_spine = sp.SkeletonAnimation:create(bg_spine_json_path, bg_spine_atlas_path, 1)

		self.bg_spine:setPosition(0, StageSize.height/2-1136/2)
		self.bg_spine:addTo(self.root)
		self.bg_spine:setLocalZOrder(-7)
		self.bg_spine:setAnimation(0, "idle", true)
	end

	if no == 3 then --特殊的 白天 傍晚 晚上的 背景
		local partIdx = 0
		if self.bgTime==1 then
			partIdx = math.random(1,4)
		elseif self.bgTime==2 then
			partIdx = math.random(1,5)
		else
			partIdx = math.random(1,3)
		end
		if partIdx ~= self.sceneParticleIdx then
			self.sceneParticleIdx = partIdx
			self.sceneParticleNode:removeAllChildren()

			local pData = sceneParList[self.sceneParticleIdx]
			local sparticle = cc.ParticleSystemQuad:create("Effect/particle/"..pData[1]..".plist")
			sparticle:addTo(self.sceneParticleNode);
			sparticle:setPosition(pData[2]*StageSize.width, pData[3]*StageSize.height);
		end
	else
		self.sceneParticleIdx = 0
		self.sceneParticleNode:removeAllChildren()
	end

	--[[
	if not self.mainParticleStar then
		self.mainParticleStar = cc.ParticleSystemQuad:create("Effect/particle/bgxing.plist")
		self.mainParticleStar:addTo(self.root);
		self.mainParticleStar:setLocalZOrder(-5);
	end
	self.mainParticleStar:resetSystem();

	if not self.mainParticleStar2 then
		self.mainParticleStar2 = cc.ParticleSystemQuad:create("Effect/particle/bgxing2.plist")
		self.mainParticleStar2:addTo(self.root);
		self.mainParticleStar2:setLocalZOrder(-5);
	end
	self.mainParticleStar2:resetSystem();
	]]
end

function MainPanel:clearKanbanMusume()
	if self.skAnimation then
		self.skAnimation:removeFromParent()
		self.skAnimation = nil
	end
end

function MainPanel:eventTip()
	
end

function MainPanel:eventRewardTip()

end

function MainPanel:runAction()
	self.isShowMainAction = true;
	self:showMainAction();
	EventManager:FireEvent(EventType.UIHeadeRunAction);
	EventManager:FireEvent(EventType.UIFooterRunAction);
end

function MainPanel:resetQuick()
	if QUICK_NUM > 0 then
		self.quickPageView:setCurrentPageIndex(0);
		self.curQuickPagePos:setPositionX(-((QUICK_NUM-1)*16/2));
		self.curQuickAutoMoveTime = 0;
	end
	if self.quickScheduleHandler then 
		scheduler:unscheduleScriptEntry(self.quickScheduleHandler)
		self.quickScheduleHandler = nil 
	end
	self.quickScheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.updateQuick), 1, false);
end

function MainPanel:updateQuick(dt)

	local isChangedPage = false;
	local curTime = TimeManager:getCurTime();
	local page = self.quickPageView:getCurrentPageIndex();

	local quickNos = {};
	for _k , no in ipairs(self.mainQuickNo) do
		quickNos[no] = _k;
	end

	local main_quick = ResTable:getTable('main_quick').contain;
	for _k , quickData in pairs(main_quick) do
		if quickData.open_time <= curTime and quickData.close_time > curTime then 
			if not quickNos[quickData.no] then
				self:createQuickPage(quickData)
				local circle = cc.Sprite:create(imagePath..'main_quick_circle.png')
					:addTo(self.btns[mainMenuTag.TAG_QUICK])
					:setOpacity(125)
				table.insert(self.curQuickPagePosBgList,circle);
				table.insert(self.mainQuickNo,quickData.no);
				
				QUICK_NUM = QUICK_NUM + 1;
				isChangedPage = true;
			end
		elseif quickNos[quickData.no] then
			local index = quickNos[quickData.no];
			self.quickPageView:removePageAtIndex(index-1);
			local posBg = self.curQuickPagePosBgList[index];
			posBg:removeFromParent();
			table.remove(self.curQuickPagePosBgList,index);

			table.remove(self.quickPageCell,index);
			table.remove(self.mainQuickNo,index);

			QUICK_NUM = QUICK_NUM - 1;

			if QUICK_NUM <= 0 then
				self.btns[mainMenuTag.TAG_QUICK]:setVisible(false);
				isChangedPage = false;
			else
				isChangedPage = true;
			end
		end
	end
	
	if QUICK_NUM > 0 then
		if isChangedPage then
			page = self.quickPageView:getCurrentPageIndex();
			for _k , posBg in pairs(self.curQuickPagePosBgList) do
				posBg:setPosition(-((QUICK_NUM-1)*16/2)+16*(_k-1),-55);
			end
		else
			self.curQuickAutoMoveTime = self.curQuickAutoMoveTime + 1;
			
			if self.curQuickAutoMoveTime >= 5 then
				local nextPage = page + 1;
				if nextPage >= QUICK_NUM then
					nextPage = 0;
				end
				self.curQuickAutoMoveTime = 0;
				-- self.quickPageView:scrollToPage(nextPage);	
				self.quickPageCell[page+1]:runAction(cc.FadeOut:create(0.3))
				self.btns[mainMenuTag.TAG_QUICK]:runAction( cc.Sequence:create(
						cc.DelayTime:create(0.3),
						cc.CallFunc:create( function() 
							self.quickPageView:setCurrentPageIndex(nextPage);
							self.quickPageCell[page+1]:setOpacity(255)
							self.quickPageCell[nextPage+1]:setOpacity(0)
							self.quickPageCell[nextPage+1]:runAction(cc.FadeIn:create(0.3))
						end)
					) 
				)
			end
		end
		self.curQuickPagePos:setPositionX(-((QUICK_NUM-1)*16/2)+16*page);
		self.btns[mainMenuTag.TAG_QUICK]:setVisible(true);
	else
		self.btns[mainMenuTag.TAG_QUICK]:setVisible(false);
	end

	self.markTime = self.markTime + 1
	if self.markTime >= 60 then
		self.markTime = 0
		self:checkChangeBg()
	end
end

function MainPanel:quickPageViewEvent(sender , event)
	--if event == ccui.PageViewEventType.turning then
	--	local page = self.quickPageView:getCurrentPageIndex();
	--	self.curQuickPagePos:setPositionX(-((QUICK_NUM-1)*16/2)+16*page)
    --end
end

function MainPanel:quickBtnClick(sender , event)
	local no = sender:getTag();
	local quickData = ResTable:getRowData('main_quick',no);
	if quickData and quickData.panel then
		if quickData.panel == 'FightPanel' or quickData.panel == 'BelleBallMainPanel' then
			if quickData.value and quickData.value ~= -1 then
				UIManager:switch(quickData.panel,quickData.value)
			else
				UIManager:switch(quickData.panel)
			end
		else
			if quickData.value and quickData.value ~= -1 then
				UIManager:push(quickData.panel,quickData.value)
			else
				UIManager:push(quickData.panel)
			end
		end
	end
end

function MainPanel:showMainAction()

	if QUICK_NUM > 0 then
		local pos = btnNodePos[mainMenuTag.TAG_QUICK];
		self.btns[mainMenuTag.TAG_QUICK]:stopAllActions();
		self.btns[mainMenuTag.TAG_QUICK]:setPosition(pos.x+280,pos.y);
		local action1 = cc.MoveTo:create(6/25 , cc.p(pos.x-5,pos.y));
		local action2 = cc.MoveTo:create(3/25 , cc.p(pos.x,pos.y));
		self.btns[mainMenuTag.TAG_QUICK]:runAction(cc.Sequence:create(cc.DelayTime:create(5/25) , action1 , action2));
	end
	--local pos = btnNodePos[mainMenuTag.TAG_EVENT];
	--self.btns[mainMenuTag.TAG_EVENT]:stopAllActions();
	--self.btns[mainMenuTag.TAG_EVENT]:setPosition(pos.x+263,pos.y);
	--local action1 = cc.MoveTo:create(6/25 , cc.p(pos.x-5,pos.y));
	--local action2 = cc.MoveTo:create(3/25 , cc.p(pos.x,pos.y));
	--self.btns[mainMenuTag.TAG_EVENT]:runAction(cc.Sequence:create(cc.DelayTime:create(30/25) , action1 , action2));

	local key = {mainMenuTag.TAG_MAIL,mainMenuTag.TAG_RANK,mainMenuTag.TAG_CARD_BOOK,mainMenuTag.TAG_SIGN,--mainMenuTag.TAG_CHAT,mainMenuTag.TAG_CHANGE_BG,
	mainMenuTag.TAG_SHOP}

	for _k , tag in ipairs(RIGHT_BTN_OPEN) do
		local pos = btnNodePos[tag];
		self.btns[tag]:stopAllActions();
		self.btns[tag]:setPosition(346 , pos.y);
		self.btns[tag]:setOpacity(0);

		local action1 = cc.MoveTo:create(5/25 , cc.p(pos.x-5,pos.y));
		local action2 = cc.FadeIn:create(5/25);
		local actionSpawn = cc.Spawn:create(action1,action2);
		local action3 = cc.MoveTo:create(2/25 , pos);

		self.btns[tag]:runAction(cc.Sequence:create(cc.DelayTime:create((12+(_k - 1)*3)/25) , actionSpawn , action3));
	end

	local key = {mainMenuTag.TAG_LOGIN7,mainMenuTag.TAG_THREE_DAY,mainMenuTag.TAG_RECHAGE, mainMenuTag.TAG_RECHARGE_TASK,
				mainMenuTag.TAG_RECHARGE_Day,
				mainMenuTag.TAG_BATTLEPASS, mainMenuTag.TAG_COPYROUND, mainMenuTag.TAG_LOGIN_CON, 
				mainMenuTag.TAG_GROWUP, mainMenuTag.TAG_MAZE_BP, mainMenuTag.TAG_BANK_MISSION }
	for k, v in pairs(key) do
		local i = v;
		self.btns[i]:stopAllActions();
		self.btns[i]:setVisible(false);
	end

	if model.BattlepassEventModel:isInit() then
		self:runLeftBtnAction();
	end
	--self.btns[mainMenuTag.TAG_SHOP]:stopAllActions();
	--self.btns[mainMenuTag.TAG_SHOP]:setVisible(false);
	--self.btns[mainMenuTag.TAG_SHOP]:runAction(cc.Sequence:create(cc.DelayTime:create(28/25),cc.CallFunc:create(function() 
	--	self.btns[mainMenuTag.TAG_SHOP]:setVisible(true);
	--end)));

	self.btns[mainMenuTag.TAG_OPEN_ACTIVITY]:stopAllActions();
	self.btns[mainMenuTag.TAG_OPEN_ACTIVITY]:setVisible(false);
	
	local showOpenActivity = tools.ConfigStateTools:checkVisibleByType(Enum:getTable('ConfigStateType').MAIN,mainMenuTag.TAG_OPEN_ACTIVITY);
	if showOpenActivity then
		local index = self:updateOpenActivityBtn();
		if index <= 0 then
			showOpenActivity = false
		else
			self.btns[mainMenuTag.TAG_OPEN_ACTIVITY]:runAction(cc.Sequence:create(cc.DelayTime:create(34/25),cc.CallFunc:create(function() 
				self.btns[mainMenuTag.TAG_OPEN_ACTIVITY]:setVisible(true);
			end)));
		end
	end

	self.openActivityNode:setVisible(showOpenActivity);

	self.openActivityNode:stopAllActions();
	self.openActivityNode:setPosition(50 , 360);
	local action1 = cc.MoveTo:create(10/25 , cc.p(50 , self.openActivityOpenPosY));
	local action2 = cc.MoveTo:create(10/25 , cc.p(50 , 360));
	local action3 = cc.Sequence:create(cc.DelayTime:create(42/25),action1,cc.DelayTime:create(8/25),action2);
	self.openActivityNode:runAction(action3);

end

function MainPanel:runLeftBtnAction()
	local index = 1;
	local key = {mainMenuTag.TAG_LOGIN7,mainMenuTag.TAG_THREE_DAY,mainMenuTag.TAG_RECHAGE, mainMenuTag.TAG_RECHARGE_TASK,
				mainMenuTag.TAG_RECHARGE_Day,
				mainMenuTag.TAG_BATTLEPASS, mainMenuTag.TAG_COPYROUND, mainMenuTag.TAG_LOGIN_CON, 
				mainMenuTag.TAG_GROWUP, mainMenuTag.TAG_MAZE_BP, mainMenuTag.TAG_BANK_MISSION}
	for k, v in pairs(key) do
		local i = v;
		local visible = tools.ConfigStateTools:checkVisibleByType(Enum:getTable('ConfigStateType').MAIN,i);
		if visible and self.btns[i]:isVisible()==false then
			local locked = false;
			if i == mainMenuTag.TAG_LOGIN7 then
				locked = model.ActivityModel:getLockStateLogin7();
			elseif i == mainMenuTag.TAG_THREE_DAY then
				locked = model.ActivityModel:getThreeDayLocked();
			elseif i == mainMenuTag.TAG_RECHAGE then
				locked = model.RechargeModel:getLockStateRecharge()
			elseif i == mainMenuTag.TAG_BATTLEPASS then
				locked = not model.BattlepassEventModel:isShowBattlepass();
			elseif i == mainMenuTag.TAG_COPYROUND then
				locked = not model.RoundModel:isOpenCopyRound();
			elseif i == mainMenuTag.TAG_LOGIN_CON then
				locked = model.ActivityModel:loginConUnAvailable();
			elseif i == mainMenuTag.TAG_GROWUP then
				locked = tools.ConfigStateTools:checkLockById(1107);
			elseif i == mainMenuTag.TAG_MAZE_BP then
				locked = not model.EventModel:isShowEventBp();
			elseif i == mainMenuTag.TAG_BANK_MISSION then
				locked = tools.ConfigStateTools:checkLockById(6100);
			elseif i == mainMenuTag.TAG_RECHARGE_TASK then
				locked = not model.RechargeModel:isOpenRechargeTask(2);
			elseif i == mainMenuTag.TAG_RECHARGE_Day then
				locked = not model.RechargeModel:isOpenRechargeTask(3);
			end

			if not locked then
				btnNodePos[i] = cc.p(-269 , 321-80*(index-1));
				self.btns[i]:setPosition(-366 , btnNodePos[i].y);
				self.btns[i]:setOpacity(0);

				local action1 = cc.MoveTo:create(5/25 , cc.p(btnNodePos[i].x+5,btnNodePos[i].y));
				local action2 = cc.FadeIn:create(5/25);
				local actionSpawn = cc.Spawn:create(action1,action2);
				local action3 = cc.MoveTo:create(2/25 , btnNodePos[i]);
				self.btns[i]:runAction(cc.Sequence:create(cc.DelayTime:create((35+(index - 1)*3)/25),cc.CallFunc:create(function() 
					self.btns[i]:setVisible(true);
				end), actionSpawn , action3));
				index = index + 1;
			end
		end
	end
end

function MainPanel:onLeave()
	self.root:setVisible(false);
	--self.mainParticleStar:stopSystem();
	--self.mainParticleStar2:stopSystem();
	if self.quickScheduleHandler then 
		scheduler:unscheduleScriptEntry(self.quickScheduleHandler)
		self.quickScheduleHandler = nil 
	end
	if self.updateScheduleHandler then 
		scheduler:unscheduleScriptEntry(self.updateScheduleHandler)
		self.updateScheduleHandler = nil 
	end
	-- self:clearKanbanMusume();
end

-- 引导相关
function MainPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 53 then
		local btn = self.btns[15];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 54 then
		local btn = self.btns[3];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 56 then
		local btn = self.btns[12];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 58 then
		local btn = self.btns[11];
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	
	end
	return pos;
end

return MainPanel;
