local MissionPanel = class("MissionPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/mission/'

local DAILY_PROGRESS_MAX_WIDTH = 484;

function MissionPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'MissionPanel');

	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function MissionPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function MissionPanel:initPanels()

	local bg = cc.Sprite:create('image/bg/Bg_5.png');
	bg:addTo(self.root);

	local viewBg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	viewBg:addTo(self.root);
	viewBg:setPosition(0 , 6);
	viewBg:setCapInsets(cc.rect(11,4,18,21));
	viewBg:setContentSize(cc.size(604 , 904));
	viewBg:setContentSize(cc.size(604 , 904));
	
	self.roundRewardNode = cc.Node:create();
	self.roundRewardNode:addTo(self.root);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.roundRewardNode);
	bg:setPosition(0 , 9+50);
	bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(583,777));

	local initData = {
        width = 564,
        height = 756,
        cellWidth = 564,
        cellHeight = 132,
		cellReloadFunc = handler(self,self.reloadCellPanel),
	}
	
	self.roundRewardTableView = template.TableViewTemplate:create()
    self.roundRewardTableView:initWithSizeAndItem(initData);
    self.roundRewardTableView:getView():setPosition(cc.p(-282,-315)); --428
    self.roundRewardTableView:getView():addTo(self.roundRewardNode)

	--生涯
	self.lifeMissionNode = cc.Node:create();
	self.lifeMissionNode:addTo(self.root);

	self.lifeMissionGoadNode = cc.Node:create();
	self.lifeMissionGoadNode:addTo(self.lifeMissionNode);
	self.lifeMissionGoadNode:setPosition(0 , 381);

	local bg = cc.Sprite:create('image/fight/roundReward/round_reward_3.png');
	bg:addTo(self.lifeMissionGoadNode);

	local bg = cc.Sprite:create('image/fight/roundReward/round_reward_2.png');
	bg:addTo(self.lifeMissionGoadNode);
	bg:setPosition(-269 , 49);
	bg:setLocalZOrder(10);

	self.lifeMissionGoalTitle = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.lifeMissionGoalTitle:addTo(self.lifeMissionGoadNode);
	self.lifeMissionGoalTitle:setAnchorPoint(0,0.5);
	self.lifeMissionGoalTitle:setPosition(-236,46);
	self.lifeMissionGoalTitle:enableOutline(cc.c4b(130 , 90 , 0 , 255),2);

	local progressBg = cc.Sprite:create('image/commonImg/pgs_bg_1_223_12.png');
	progressBg:addTo(self.lifeMissionGoadNode);
	progressBg:setPosition(-165 , -4);

	self.lifeMissionGoalProgress = cc.Scale9Sprite:create('image/commonImg/pgs_1_23_30.png');
	self.lifeMissionGoalProgress:setCapInsets(CCRectMake(10,0,3,20));
	self.lifeMissionGoalProgress:addTo(self.lifeMissionGoadNode);
	self.lifeMissionGoalProgress:setAnchorPoint(0 , 0.5);
	self.lifeMissionGoalProgress:setPosition(-280 , -4);

	self.lifeMissionGoalNum = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.lifeMissionGoalNum:addTo(self.lifeMissionGoadNode);
	self.lifeMissionGoalNum:setPosition(-165,-29);
	self.lifeMissionGoalNum:enableOutline(cc.c4b(60 , 60 , 60,255),2);

	local itemView = cc.Sprite:create('image/commonImg/bg_3_194_102.png');
	itemView:addTo(self.lifeMissionGoadNode);
	itemView:setPosition(58 , -4);

	self.lifeMissionGoalItemView = ccui.ScrollView:create();
	self.lifeMissionGoalItemView:setTouchEnabled(true);
	self.lifeMissionGoalItemView:setBounceEnabled(true);
	self.lifeMissionGoalItemView:setDirection(ccui.ScrollViewDir.horizontal);
	self.lifeMissionGoalItemView:setContentSize(cc.size(185, 87));
	self.lifeMissionGoalItemView:setAnchorPoint(cc.p(0.5, 0.5));
	self.lifeMissionGoalItemView:setPosition(58 , -4);
	self.lifeMissionGoalItemView:setScrollBarEnabled(false);
	self.lifeMissionGoalItemView:addTo(self.lifeMissionGoadNode);


	local label = cc.Label:createWithTTF(LANG.UI_ACTIVITY_13, fonts.FONT_SIYUAN, 18)
	label:enableOutline(cc.c3b(60, 60, 60), 2)

	self.lifeMissionGoalGetBtn = ccui.Button:create("image/commonImg/btn_2_103_36.png","image/commonImg/btn_2_103_36.png");
	self.lifeMissionGoalGetBtn:addTo(self.lifeMissionGoadNode);
	self.lifeMissionGoalGetBtn:setTitleLabel(label)
	self.lifeMissionGoalGetBtn:setPosition(222 , -6);
	self.lifeMissionGoalGetBtn:addClickEventListener(handler(self , self.getLifeMissionGoalReward));

	self.lifeMissionGoalNotGet = cc.Sprite:create('image/commonImg/btn_3_103_36.png');
	self.lifeMissionGoalNotGet:addTo(self.lifeMissionGoadNode);
	self.lifeMissionGoalNotGet:setPosition(222 , -3);

	label = cc.Label:createWithTTF(LANG.UI_MISSION_27 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.lifeMissionGoalNotGet);
	label:setPosition(self.lifeMissionGoalNotGet:getContentSize().width/2,self.lifeMissionGoalNotGet:getContentSize().height/2);
	label:setTextColor(cc.c4b(60 , 60 , 60 , 255));
	label:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);

	self.dailyMissionNode = cc.Node:create()
		:addTo(self.root)
	
	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
		:addTo(self.dailyMissionNode)
		:setPosition(0 , 374)
		:setCapInsets(cc.rect(11,11,34,28))
		:setContentSize(cc.size(583,123))

	local countdownBg = cc.Sprite:create(imagePath..'daily_mission_bg_1.png')
		:addTo(self.dailyMissionNode)
		:setPosition(0,435)
		
	local countdownLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_67,fonts.FONT_SIYUAN,16)
		:addTo(self.dailyMissionNode)
		:setPosition(-44,434)
		:setTextColor(cc.c3b(255,255,0))

	self.dailyMissionCountdown = cc.Label:createWithTTF('00:00:00',fonts.FONT_SIYUAN,16)
		:addTo(self.dailyMissionNode)
		:setPosition(44,434)
		:setTextColor(cc.c3b(255,255,0))

	local dailyMissionProgressBg = cc.Sprite:create(imagePath..'daily_mission_bg_2.png')
		:addTo(self.dailyMissionNode)
		:setPosition(0,361)

	self.dailyMissionProgress = cc.Scale9Sprite:create(imagePath..'daily_mission_bg_4.png')
	self.dailyMissionProgress:addTo(self.dailyMissionNode)
	self.dailyMissionProgress:setAnchorPoint(0,0.5)
	self.dailyMissionProgress:setPosition(-242,361)
	self.dailyMissionProgress:setCapInsets(cc.rect(10,0,4,13))

	self.dailyItem = template.ItemTemplate:create()
	self.dailyItem:addTo(self.dailyMissionNode);
	self.dailyItem:setScale(0.6);
	self.dailyItem:setPosition(-241,361);

	self.dailyMissionRewardBox = {};
	local dailyMissionReward = model.MissionModel:getDailyMissionReward();
	local dailyMissionRewardMaxValue = model.MissionModel:getDailyMissionRewardMaxValue();
	for no , reward in pairs(dailyMissionReward) do
		self.dailyMissionRewardBox[no] = {};
		local rewardNode = cc.Node:create()
			:addTo(self.dailyMissionNode)
			:setPosition(-242+reward.value/dailyMissionRewardMaxValue*DAILY_PROGRESS_MAX_WIDTH, 361)

		local boxImg = '';
		if reward.value == dailyMissionRewardMaxValue then
			boxImg = imagePath..'daily_mission_box_2.png'
		else
			boxImg = imagePath..'daily_mission_box_1.png'
		end
		local rewardBox = ccui.Button:create(boxImg,boxImg)
		rewardBox:addTo(rewardNode)
		rewardBox:setTag(no)
		rewardBox:addClickEventListener(handler(self , self.dailyMissionRewardClick))

		local rewardGet = cc.Sprite:create(imagePath..'daily_mission_bg_shader.png')
			:addTo(rewardNode)
		self.dailyMissionRewardBox[no].rewardGet = rewardGet;
			
		local rewardValueBg = cc.Sprite:create(imagePath..'daily_mission_bg_5.png')
			:addTo(rewardNode)
			:setPosition(0,-29)
		local rewardValue = cc.Label:createWithTTF('0',fonts.FONT_SIYUAN,16)
			:addTo(rewardNode)
			:setPosition(0,-29)
		self.dailyMissionRewardBox[no].rewardValue = rewardValue;
	end

	self.dailyMissionRewardListNode = cc.Node:create()
		:addTo(self.dailyMissionNode)
		:setPosition(236,411)

	self.dailyMissionRewardListBg = cc.Sprite:create(imagePath..'daily_mission_bg_3.png')
		:addTo(self.dailyMissionRewardListNode)
	
	self.dailyMissionRewardListView = cc.Node:create()
		:addTo(self.dailyMissionRewardListNode)
		:setPosition(0,7);

	--self.dailyMissionRewardListView = ccui.ScrollView:create();
	--self.dailyMissionRewardListView:setTouchEnabled(true);
	--self.dailyMissionRewardListView:setBounceEnabled(true);
	--self.dailyMissionRewardListView:setDirection(ccui.ScrollViewDir.horizontal);
	--self.dailyMissionRewardListView:setContentSize(cc.size(140, 64));
	--self.dailyMissionRewardListView:setAnchorPoint(cc.p(0.5, 0.5));
	--self.dailyMissionRewardListView:setScrollBarEnabled(false);
	--self.dailyMissionRewardListView:setPosition(0,7);
	--self.dailyMissionRewardListView:addTo(self.dailyMissionRewardListNode);

	self.missionListNode = cc.Node:create()
		:addTo(self.root)

	local listViewBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listViewBg:addTo(self.missionListNode);
	listViewBg:setPosition(0 , -63+50);
	listViewBg:setCapInsets(cc.rect(11,11,34,28));
	listViewBg:setContentSize(cc.size(582,636));

	self.lifeMissionListView = template.FrameLoadScrollViewTemplate:create()
	self.lifeMissionListView:setPosition(0,-62+50);
	self.lifeMissionListView:setAnchorPoint(0.5,0.5);
	self.lifeMissionListView:Init(cc.size(563 , 624) , cc.size(563 , 126) , 1 , 5);
	self.lifeMissionListView:addLoadCellHandler(handler(self,self.reloadMissionCellItem));
	self.lifeMissionListView:addTo(self.missionListNode);
	
	self.missionMenu = {};
	self.missionMenuNode = {};
	for i = 1 , 3 do

		local texture = 'image/commonImg/menu_left_71_46.png';
		local unTexture = 'image/commonImg/menu_left_71_46_u.png';

		if i == 2 then
			texture = 'image/commonImg/menu_mid_71_46.png';
			unTexture = 'image/commonImg/menu_mid_71_46_u.png';
		end
		
		self.missionMenu[i] = {};

		local node = cc.Node:create();
		node:addTo(self.root);
        node:setPosition(-201 + 201*(i-1) , 480);
        self.missionMenu[i].node = node;
        self.missionMenuNode[i] = node;

		local btn = ccui.Button:create(texture , texture , unTexture);
		btn:addTo(node);
		btn:setTag(i);
		btn:addClickEventListener(handler(self , self.menuClick));
		btn:setScale9Enabled(true);
		btn:setCapInsets(cc.rect(10 , 0 , 39 , 46));
		btn:setContentSize(cc.size(201 , 46));
		self.missionMenu[i].btn = btn;

		local light = cc.Sprite:create('image/commonImg/menu_light_1.png');
		light:addTo(node);
		light:setPosition(0 , btn:getContentSize().height/2);
		self.missionMenu[i].light = light;

		local label = cc.Label:createWithTTF(LANG.UI_MISSION_MENU[i] , fonts.FONT_SIYUAN , 20);
		label:setTextColor(cc.c3b(180 , 180 , 180));
		btn:setTitleLabel(label);
		self.missionMenu[i].label = label;
	
	end

	local oneKeyLabel = cc.Label:createWithTTF(LANG.UI_ROUND_15 , fonts.FONT_SIYUAN , 20);
	oneKeyLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	self.oneKeyBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.oneKeyBtn:addTo(self.root);
	self.oneKeyBtn:setTitleLabel(oneKeyLabel);
	self.oneKeyBtn:setPosition(0 , -380);
	self.oneKeyBtn:addClickEventListener(handler(self , self.oneKeyBtnClick));
	

	EventManager:RegisterEvent(EventType.UIRetMissionData, handler(self, self.updateMissionData));
	EventManager:RegisterEvent(EventType.NetwordRetRoundReward, handler(self, self.retRoundReward));
	EventManager:RegisterEvent(EventType.UIRetMissionDailyRewardItem, handler(self, self.retGetDailyMissionRewardItem));
	EventManager:RegisterEvent(EventType.UIRetMissionDailyReward, handler(self, self.retGetDailyMissionReward));
	EventManager:RegisterEvent(EventType.UIRetMissionLifeReward, handler(self, self.retGetLifeMissionReward));
	EventManager:RegisterEvent(EventType.UIRetMissionLifeGoalReward, handler(self, self.retgetLifeMissionGoalReward));
	EventManager:RegisterEvent(EventType.UIEventUnlockChange, handler(self, self.updateLevelLock));

end

function MissionPanel:onEnter()

	self.missionType = nil;
	if not self:updateVisile() then
		return;
	end

	self:updateLock(2);
	self:updateRoundReward();

	local spine_res = 'huanrao_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.skeletonNode = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.skeletonNode:setPosition(cc.p(-269 , 49))
		self.skeletonNode:setAnimation(0, "huanrao_spine", true);
		self.skeletonNode:setLocalZOrder(5);
        self.skeletonNode:addTo(self.lifeMissionGoadNode)
	end

	self:updateMenuRedDot();

	self.root:setVisible(true);
end

function MissionPanel:updateMissionData()
	self:updateRoundReward();
	self:updateMenuRedDot();
end

function MissionPanel:updateVisile()
	local openMenuList =  tools.ConfigStateTools:setVisibleByType(Enum:getTable('ConfigStateType').MISSION , self.missionMenuNode);
    if not openMenuList or #openMenuList <= 0 then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('MissionPanel');
        return false
    end

	if #openMenuList > 1 then
    	table.sort(openMenuList , function(first , second)
    	    return first.index < second.index;
		end);
	end

    self.missionType = nil;

    for _k , openData in ipairs(openMenuList) do
        if not self.missionType and openData.state == 0 then
            self.missionType = openData.index;
        end
    end

    if not self.missionType then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('MissionPanel');
        return false
	end
	return true;
end

function MissionPanel:checkClickLock(tag)
	local locked = false;
	local lockLv = 0;

	if tag == 2 or tag == 3 then
		locked,lockLv = model.MissionModel:getLockStatMission();
	end

	if locked then
		Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
	end

	return locked;

end

function MissionPanel:updateLevelLock(table_start_id)
	if table_start_id == Enum:getTable('levelLockItemIds').LEVLE_LOCK_19 then
		self:updateLock(2);
	end
end

function MissionPanel:updateLock( index )
	if index == 2 then
		local locked,lockLv = model.MissionModel:getLockStatMission();
		tools.LevelLockTools:setLockToNode(self.missionMenuNode[2],locked,lockLv,6,cc.p(-100,0))
		tools.LevelLockTools:setLockToNode(self.missionMenuNode[3],locked,lockLv,6,cc.p(-100,0))
	end
end


function MissionPanel:menuClick(sender , event)
	local tag = sender:getTag()

	if self:checkClickLock(tag) then
		return
	end

	if tag == self.missionType then
		return;
	end

	self.missionType = tag;
	self:updateRoundReward();
end

function MissionPanel:updateRoundReward()

	for _type , menu in pairs(self.missionMenu) do
		if _type == self.missionType then
            menu.label:setTextColor(cc.c3b(255 , 255 , 255));
            menu.light:setVisible(true);
            menu.btn:setBright(true);
        else
            menu.label:setTextColor(cc.c3b(180 , 180 , 180));
            menu.light:setVisible(false);
            menu.btn:setBright(false);
		end
    end
	TimeManager:registUpdateEvent('MissionPanel',nil,true);
	self.roundRewardNode:setVisible(self.missionType == 1);
	self.lifeMissionNode:setVisible(self.missionType == 2);
	self.dailyMissionNode:setVisible(self.missionType == 3);
	self.missionListNode:setVisible(self.missionType ~= 1);

	if self.missionType == 1 then
		self.roundRewards = {};
		for _k , reward in pairs(ResTable:getTable('round_reward').contain) do
			table.insert(self.roundRewards , reward);
		end
		if #self.roundRewards > 1 then
			table.sort(self.roundRewards , function(first , second)
				local firstGetReward = model.RoundModel:getRoundRewarded(first.id);
				local secondGetReward = model.RoundModel:getRoundRewarded(second.id);
				-- print(fristGetReward , secondGetReward);
				if firstGetReward == nil and secondGetReward ~= nil then
					return true;
				end
				if firstGetReward ~= nil and secondGetReward == nil then
					return false;
				end
				return first.id < second.id;
			end);
		end
		self.roundRewardTableView:reloadData(self.roundRewards);
	elseif self.missionType == 2 then
		self:updateLifeMissionGoalData();

    	local lifeMissionDatas = self:updateLifeMissionData();
    	self.lifeMissionDatas = lifeMissionDatas;

    	self.lifeMissionRewardCellByIndex = {};
    	self.missionRewardCell = {};
		self.lifeMissionListView:reloadData(lifeMissionDatas);
	else
		self:updateDailyMissionReward();
		self:updateDaliyMissionData();
		self:updateDailyMissionCountdown();
		TimeManager:registUpdateEvent('MissionPanel',handler(self,self.updateDailyMissionCountdown),true);
	end
end

function MissionPanel:updateDailyMissionCountdown()
	local lastTime = (model.MissionModel:getNextDayRefreshTime() - TimeManager:getCurTime());
	lastTime = lastTime < 0 and 0 or lastTime;
	self.dailyMissionCountdown:setString(tostring(GlobalFunctions:ChangeTime(lastTime)));

	if lastTime <= 0 then
		print('fubin----req_mission_data')
		Network.NetworkManager:Send(Network.NetworkCmdType.req_mission_data, {});
		TimeManager:registUpdateEvent('MissionPanel',nil,true);
	end
end

function MissionPanel:updateDaliyMissionData()
	local dailyMissionData = model.MissionModel:getDailyMissionByTimeType(1);

    if not dailyMissionData then
        return;
    end

    self.dailyMissionData = {};
    for no , data in pairs(dailyMissionData) do
        table.insert(self.dailyMissionData , data);
    end

    if #self.dailyMissionData > 1 then
        table.sort(self.dailyMissionData , function(first , second)
            if first.state ~= second.state then
                if first.state == 2 and second.state ~= 2 then
                    return true;
                elseif first.state ~= 2 and second.state ~= 2 then
                    if first.state == 0 and second.state == 1 then
                        return true;
                    end
                end
            else
                return first.no < second.no;
            end
            return false;
        end);
	end
	
	self.lifeMissionListView:reloadData(self.dailyMissionData);
end

function MissionPanel:updateDailyMissionReward()
	self.dailyMissionRewardListNode:setVisible(false);
	local dailyMissionReward = model.MissionModel:getDailyMissionReward()
	local dailyMissionItem = model.MissionModel:getDailyMissionItemNum()
	self.dailyItem:Init(DAILY_MISSION_ITEM,dailyMissionItem);
	local dailyMissionRewardMaxValue = model.MissionModel:getDailyMissionRewardMaxValue();
	local percentage = dailyMissionItem/dailyMissionRewardMaxValue;
	percentage = math.min(1,percentage);
	percentage = math.max(0,percentage);
	self.dailyMissionProgress:setContentSize(cc.size(percentage*DAILY_PROGRESS_MAX_WIDTH,13));
	for no , reward in pairs(dailyMissionReward) do
		if self.dailyMissionRewardBox[no] then
			if reward.state == 1 then
				self.dailyMissionRewardBox[no].rewardGet:setVisible(true);
				self.dailyMissionRewardBox[no].rewardGet:setTexture(imagePath..'daily_mission_bg_shader.png')
				self.dailyMissionRewardBox[no].rewardValue:setString(LANG.UI_MISSION_26);
			else
				if dailyMissionItem >= reward.value then
					self.dailyMissionRewardBox[no].rewardGet:setVisible(true);
					self.dailyMissionRewardBox[no].rewardGet:setTexture(imagePath..'daily_mission_box_light.png')
					self.dailyMissionRewardBox[no].rewardValue:setString(LANG.UI_ACTIVITY_20);
				else
					self.dailyMissionRewardBox[no].rewardGet:setVisible(false)
					self.dailyMissionRewardBox[no].rewardValue:setString(tostring(reward.value));
				end
			end
		end
	end
end

function MissionPanel:dailyMissionRewardClick(sender , event)
	local no = sender:getTag();
	local dailyMissionReward = model.MissionModel:getDailyMissionReward(no)
	if not dailyMissionReward then
		return
	end

	if dailyMissionReward.state ~= 1 and model.MissionModel:getDailyMissionItemNum() >= dailyMissionReward.value then
		Network.NetworkManager:Send(Network.NetworkCmdType.req_mission_get_daily_reward, {no = no});
	else
		if self.dailyMissionRewardListNode:isVisible() and self.lastNo == no then
			self.dailyMissionRewardListNode:setVisible(false);
		else
			self.lastNo = no
			local dailyMissionRewardMaxValue = model.MissionModel:getDailyMissionRewardMaxValue();
			self.dailyMissionRewardListNode:setPosition(-242+dailyMissionReward.value/dailyMissionRewardMaxValue*DAILY_PROGRESS_MAX_WIDTH, 411)
			self.dailyMissionRewardListNode:setVisible(true);

			self.dailyMissionRewardListView:removeAllChildren();
			local num = #dailyMissionReward.reward;
			if num == 1 then
				self.dailyMissionRewardListBg:setTexture('image/guild/donate/donate_bg_1.png');
			else
				self.dailyMissionRewardListBg:setTexture(imagePath..'daily_mission_bg_3.png');
			end
			local startPos = -(71 * (num-1) / 2);
			--local startPos = maxWidth

			for _k , item in pairs(dailyMissionReward.reward) do
				local icon = template.ItemTemplate:create(2);
				icon:addTo(self.dailyMissionRewardListView);
				icon:setScale(0.6);
				icon:setPosition(startPos + 71 * (_k - 1) , 0);
				icon:Init(item[1] , item[2]);
			end

			self.dailyMissionRewardListNode:stopAllActions()
			self.dailyMissionRewardListNode:runAction(cc.Sequence:create( cc.DelayTime:create(2), cc.CallFunc:create(function()
				self.dailyMissionRewardListNode:setVisible(false)
			end
			) ))
		end
	end
end

function MissionPanel:updateLifeMissionGoalData()
    local goalData = model.MissionModel:getLifeMissionGoalData();

    local totalTimes = model.MissionModel:getLifeMissionGoalTotalComplateTimes();
    
    local curGetData = nil;
    local curNotGetData = nil;
    local maxData = nil;
    for no , data in pairs(goalData) do
        if data.state == 0 and data.times <= totalTimes then
            if not curGetData then
                curGetData = data;
            elseif curGetData.no > data.no then
                curGetData = data;
            end
        end

        if data.state == 0 and data.times > totalTimes then
            if not curNotGetData then
                curNotGetData = data;
            elseif curNotGetData.no > data.no then
                curNotGetData = data;
            end
        end

        if not maxData then
            maxData = data;
        elseif maxData.no < data.no then
            maxData = data;
        end
    end

    local curData = nil;
    if curGetData then
        curData = curGetData;
        self.lifeMissionGoalGetBtn:setVisible(true);
        self.lifeMissionGoalNotGet:setVisible(false);
        self.lifeMissionGoalGetBtn:setTag(curData.no);
    elseif curNotGetData then
        curData = curNotGetData;
        self.lifeMissionGoalGetBtn:setVisible(false);
        self.lifeMissionGoalNotGet:setVisible(true);
    else 
        curData = maxData;
        self.lifeMissionGoalGetBtn:setVisible(false);
        self.lifeMissionGoalNotGet:setVisible(true);
    end

    local percentage = totalTimes/curData.times;
	percentage = percentage > 1 and 1 or percentage;
	local width = 231 * percentage;
	if width > 0 then
		width = width < 23 and 23 or width;
	end
	self.lifeMissionGoalProgress:setContentSize(cc.size(width , 30));
	
    self.lifeMissionGoalNum:setString(string.format("%d/%d" , totalTimes,curData.times));
    self.lifeMissionGoalTitle:setString(string.format(LANG.UI_MISSION_28,curData.times));
    
    self.lifeMissionGoalItemView:removeAllChildren();
    local num = #curData.reward;
	local maxWidth = 82.4 * num;

	self.lifeMissionGoalItemView:setInnerContainerSize(cc.size(maxWidth , 87));

	for _k , item in pairs(curData.reward) do
		local icon = template.ItemTemplate:create(2);
		icon:addTo(self.lifeMissionGoalItemView);
		icon:setScale(0.8);
		icon:setPosition(41.2 + 82.4 * (_k - 1) , 43.5);
		icon:Init(item[1] , item[2]);
	end
end

function MissionPanel:updateLifeMissionData()
    local lifeMissionData = model.MissionModel:getLifeMissionData();

    local lifeMissionDatas = {};
    for no , data in pairs(lifeMissionData) do
        table.insert(lifeMissionDatas , data);
    end

    if #lifeMissionDatas > 1 then
        table.sort(lifeMissionDatas , function(first , second)
            if first.state ~= second.state then
                if first.state == 2 and second.state ~= 2 then
                    return true;
                end
            else
                if first.percent > second.percent then
                    return true;
                elseif first.percent == second.percent then
                    return first.id < second.id;
                end
            end
            return false;
        end);
    end

    return lifeMissionDatas;
end

function MissionPanel:reloadCellPanel(cell , idx)

	if self.roundRewards[idx + 1] then
		local child = cell:getChildByTag(999);
		if not child then
			child = template.RoundRewardTemplate:create();
			child:addTo(cell);
			child:setPosition(282 , 65.5);
			child:addBtnClickEventListener(handler(self , self.rewardClick))
			child:setTag(999);
		end
		local reward = self.roundRewards[idx + 1];
		child:Init(reward);
		child:setBtnTag(reward.id);
	end
	
	return cell;
end

function MissionPanel:reloadMissionCellItem(cell , idx , data)
    local cellNode = nil;
	if self.missionType == 2 then
		cellNode = template.LifeMissionTemplate:create(cell);
		cellNode:initData(data , idx);
		cellNode:addClickEventListener(handler(self , self.getMissionReward));
    	cellNode:addShowSpineEndEventListener(handler(self , self.lifeMissionShowSpineEnd));
		self.lifeMissionRewardCellByIndex[idx] = cellNode;
		self.missionRewardCell[data.no] = cellNode
	else
		cellNode = template.DailyMissionTemplate:create();
		cellNode:addTo(cell)
		cellNode:initData(data);
		cellNode:addDailyMissionClickEventListener(handler(self , self.getMissionReward));
	end
    return cell;
end

function MissionPanel:getMissionReward(state , data)
	if state == 1 then
		if self.missionType == 2 then
			if not self.isReqLifeMissionReward then
				self.isReqLifeMissionReward = true;
        		Network.NetworkManager:Send(Network.NetworkCmdType.req_mission_life_reward, {no = data.no});
				self.root:runAction(cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(function() 
					self.isReqLifeMissionReward = false;
				end)));
			end
		else
			Network.NetworkManager:Send(Network.NetworkCmdType.req_mission_daily_reward_item, {no = data.no});
		end
	else
        --self:jumpTo(data.type);
    end
end

function MissionPanel:retGetLifeMissionReward(msg)
    
    self:updateLifeMissionGoalData();
    self:updateMenuRedDot(2);

    self.lifeMissionRewardMsg = msg;

    if msg.list then
    	local bext = true;
	    for k,v in pairs(msg.list) do
	    	if self.missionRewardCell[v.no] then
	        	self.missionRewardCell[v.no]:showSpine(bext);
	        	bext = false;
	        end
	    	-- EventManager:FireEvent('LifeMissionTemplate:playAni' , v.no, bext);
	    end
    else
    	if self.missionRewardCell[msg.no] then
        	self.missionRewardCell[msg.no]:showSpine(true);
        end
    	-- EventManager:FireEvent('LifeMissionTemplate:playAni' , msg.no, true);
    end

end

function MissionPanel:lifeMissionShowSpineEnd(index)
    local lifeMissionDatas = self:updateLifeMissionData();
    local runActionIndexs = {};
    local totalNum = 0;

    self.lifeMissionListView:stopAllActions();

    for _k , data in ipairs(lifeMissionDatas) do
        if self.lifeMissionRewardCellByIndex[_k] then

            local cellNode = self.lifeMissionRewardCellByIndex[_k];
            cellNode:setOpacity(255);
            cellNode:initData(data , _k);
            
            self.lifeMissionRewardCellByIndex[_k]=cellNode;
            self.missionRewardCell[data.no]=cellNode;

            local cell = self.lifeMissionListView:getCell(_k);
            if _k < index then
                cell:setPosition(555/2 , cell:getPositionY());
            else
                cell:setPosition(555/2 , cell:getPositionY() - 124);
                table.insert(runActionIndexs , _k);
                totalNum = totalNum + 1;
            end
        end
    end

    if totalNum > 0 then
        for _ , idx in ipairs(runActionIndexs) do
            local action = cc.MoveBy:create(0.3 , cc.p(0 , 124));
            local cell = self.lifeMissionListView:getCell(idx);
            if idx < totalNum then
                cell:runAction(action);
            else
                cell:runAction(cc.Sequence:create(action , cc.CallFunc:create(function() 
                    UIManager:push('RewardPanel',self.lifeMissionRewardMsg)
                end)));
            end
        end
    else
        UIManager:push('RewardPanel',self.lifeMissionRewardMsg)
    end
end

function MissionPanel:getLifeMissionGoalReward(sender , event)
    local no = sender:getTag();
    Network.NetworkManager:Send(Network.NetworkCmdType.req_mission_life_goal_reward, {no = no});
end

function MissionPanel:retgetLifeMissionGoalReward(msg)
    self:updateLifeMissionGoalData();
    self:updateMenuRedDot();
    UIManager:push('RewardPanel',msg)
end

function MissionPanel:retGetDailyMissionRewardItem(msg)
	self:updateDailyMissionReward();
	self:updateDaliyMissionData();
	self:updateDailyMissionCountdown();
	
	self:updateMenuRedDot(3);
	UIManager:push('RewardPanel',msg)
end

function MissionPanel:retGetDailyMissionReward(msg)
	self:updateDailyMissionReward();
	self:updateMenuRedDot(3);
	UIManager:push('RewardPanel',msg)
end

function MissionPanel:updateMenuRedDot(missionType)
	if missionType then
		local state = model.MissionModel:getActiveState(missionType);
		tools.RedDotTools:setRedDotToNode(self.missionMenuNode[missionType],state,nil,cc.p(90, 10));
	else
		for i = 1 ,3 do
			local state = model.MissionModel:getActiveState(i);
			tools.RedDotTools:setRedDotToNode(self.missionMenuNode[i],state,nil,cc.p(90, 10));
		end
	end
end

function MissionPanel:oneKeyBtnClick()
	local canGet = false;
	if self.missionType == 1 then
		local curRound = model.RoundModel:getRoundIndex();
		for k,v in pairs(self.roundRewards) do
			if not model.RoundModel:getRoundRewarded(v.id) and curRound > v.round_id then
				canGet = true;
				break;
			end
		end
		if canGet then
			self:rewardClick(0);
		end
	elseif self.missionType == 2 then
		if self.lifeMissionDatas then
			for k,v in pairs(self.lifeMissionDatas) do
				if v.state == 2 then
					canGet = true;
					break;
				end
			end
		end
		if canGet and not self.isReqLifeMissionReward then
			self.isReqLifeMissionReward = true;
			Network.NetworkManager:Send(Network.NetworkCmdType.req_mission_life_reward, {no = 0});
			self.root:runAction(cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(function() 
				self.isReqLifeMissionReward = false;
			end)));
		end
	else
		if self.dailyMissionData then
			for k,v in pairs(self.dailyMissionData) do
				if v.state == 2 then
					canGet = true;
					break;
				end
			end
		end
		if canGet then
			Network.NetworkManager:Send(Network.NetworkCmdType.req_mission_daily_reward_item, {no = 0});
		end
	end
	if not canGet then
		Prompt:Show(LANG.UI_MISSION_36)
	end
end

function MissionPanel:rewardClick(id)
	local msg = {};
	msg.id = id;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_round_reward , msg);
end

function MissionPanel:retRoundReward(msg)
	if msg.id and #msg.id > 0 then
		self:updateRoundReward();
		self:updateMenuRedDot(1);
	else
		Prompt:Show(LANG.UI_ROUND_17);
	end

	UIManager:push('RewardPanel' , msg);

end

function MissionPanel:jumpTo(bType)
    if bType == Enum:getTable("MissionType").MISSION_GACHA then--抽卡
        UIManager:push('GachaListPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_GACHA_SPECIAL then--特殊抽卡
		UIManager:push('GachaListPanel', 2)
    elseif bType == Enum:getTable("MissionType").MISSION_GACHA_FIVE_STAR then  --五星抽卡
        UIManager:push('GachaListPanel', 3);
    elseif bType == Enum:getTable("MissionType").MISSION_FAST_BATTLE then --快速挂机
        local locked,lockLv = model.AutoFightModel:getLockStateFastFight()
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_MISSION_31);
            return
        end

        UIManager:switch('FightPanel');
        UIManager:push('FastFightRewardPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_DAILY_BATTLE then 	--每日副本
        local locked,lockLv = model.HomeModel:getLockStateByType(model.HomeModel.HomeMenuTag.TAG_DAILYROUND);
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_MISSION_31);
            return;
        end
        UIManager:push('DailyRoundPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_LOGIN then --登录

    elseif bType == Enum:getTable("MissionType").MISSION_RANDOM_BOSS --随机boss
    or bType == Enum:getTable("MissionType").MISSION_RANDOM_BOSS_PURPLE --随机boss
    or bType == Enum:getTable("MissionType").MISSION_RANDOM_BOSS_YELLOW --随机boss
    or bType == Enum:getTable("MissionType").MISSION_RANDOM_BOSS_REFRESH then --随机boss刷新
        local locked,lockLv = model.RoundBossModel:getLockStateRoundBoss();
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_MISSION_31);
            return
        end
        
        UIManager:push('RoundBossPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_GOLD_COST then --游戏币消耗		
        UIManager:switch('CardListPanel')
    elseif bType == Enum:getTable("MissionType").MISSION_EQUIP_COMPOSE then --装备合成	
        UIManager:push('EquipComposePanel');
    elseif bType == Enum:getTable("MissionType").MISSION_HOME_SKILL then --基地科技			
        local locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_11)
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_MISSION_31);
            return
        end
        UIManager:push('HomeBaseSkillPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_CARD_COMPOSE then --卡牌合成
        local locked,lockLv = model.HomeModel:getLockStateByType(model.HomeModel.HomeMenuTag.TAG_CARD_COMPOSE);
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_MISSION_31);
            return
        end
        UIManager:push('CardComposePanel');
    elseif bType == Enum:getTable("MissionType").MISSION_GUILD_DONATE then --公会捐献
        if model.GuildModel:chackGuild() then
			if IsKr then
				UIManager:set('GuildDonatePanel', {'GuildPanel', 'GuildDonatePanel'})
			else
				UIManager:set('GuildDonatePanel', {'HomeBasePanel', 'GuildPanel', 'GuildDonatePanel'})
			end
       end
    elseif bType == Enum:getTable("MissionType").MISSION_ROLE_STAR_SEVEN --七星卡牌
    or bType == Enum:getTable("MissionType").MISSION_ROLE_STAR_TEN	--十星卡牌
    or bType == Enum:getTable("MissionType").MISSION_COST_PARTNER then --消耗卡牌
		UIManager:set('CardLevelUpStarCardListPanel', {'HomeBasePanel', 'CardLevelUpStarCardListPanel'})
    elseif bType == Enum:getTable("MissionType").MISSION_ITEM_COST then --道具使用
        local locked,lockLv = model.ItemModel:getLockStateFightItemUse()
        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_MISSION_31);
            return
        end

        UIManager:switch('FightPanel');
        UIManager:push('FightItemPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_TRIAL  --试炼
    or  bType == Enum:getTable("MissionType").MISSION_TRIAL_TIER then --试炼通关层
        local locked,lockLv = model.HomeModel:getLockStateByType(model.HomeModel.HomeMenuTag.TAG_TRIAL);

        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_MISSION_31);
            return
        end

		UIManager:set('TrialPanel', {'HomeBasePanel', 'TrialPanel'})
    elseif bType == Enum:getTable("MissionType").MISSION_RANDOM_SHOP then --刷新商店刷新
        local locked,lockLv = model.HomeModel:getLockStateByType(model.HomeModel.HomeMenuTag.TAG_RANDOMSHOP);

        if locked then
            --Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
            Prompt:Show(LANG.UI_MISSION_31);
            return
        end
        
		UIManager:set('RandomShopPanel', {'HomeBasePanel', 'RandomShopPanel'})
    elseif bType == Enum:getTable("MissionType").MISSION_ROLE_LEVEL then --玩家等级
        UIManager:switch('FightPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_MAIN_CHAPTER then --主线章节
        UIManager:switch('FightPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_MAIN_ROUND then --主线关卡
        UIManager:switch('FightPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_FIGHT_INCOME then --领取挂机收获
        UIManager:switch('FightPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_SHOP_BUY then --商店购买次数
        UIManager:push('ShopPanel');
    elseif bType == Enum:getTable("MissionType").MISSION_ARENA_CHALLENGE_NUM --竞技场挑战次数
    or bType == Enum:getTable("MissionType").MISSION_ARENA_WIN_NUM then --竞技场胜利次数
		UIManager:set('ArenaPanel', {'HomeBasePanel', 'ArenaPanel'})
    end
end

function MissionPanel:onClickBack()
	UIManager:pop('MissionPanel');

end

function MissionPanel:onLeave()

	if self.skeletonNode then
		self.skeletonNode:removeFromParent()
		self.skeletonNode = nil
	end
	
	EventManager:FireEvent(EventType.FightPanelBtnRedDot , 4);
	TimeManager:registUpdateEvent('MissionPanel',nil,true);

	self.root:setVisible(false);
end

function MissionPanel:guideRewardClick( )
	self:rewardClick(1 , 1);
end

-- 引导相关
function MissionPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 15 then
		local cell = self.roundRewardTableView:cellAtIndex(0);
		if cell then
			local templateNode = cell:getChildByTag(999)
			local btn = templateNode:getGuideBtn()
			-- pos = cc.p(btn:getPosition(),)
			pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
		end

	end

	return pos;
end

return MissionPanel;
