local OnlineRewardPanel = class("OnlineRewardPanel", require('app.layer.BaseLayer'))
-- local scheduler = cc.Director:getInstance():getScheduler();
-- local MessageBoxType = Enum:getTable('MessageBoxType')
-- local imgPath = 'image/fight/roundInfo/';
local fonts = Enum:getTable("SystemFont")
-- local FightType = Enum:getTable('FightType');

function OnlineRewardPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'OnlineRewardPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.haveSwallowLayer = true;
    self.isPopup = true;

    self.onlineRewardItems = {}
end

function OnlineRewardPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	
    self:initPanels();
    self:registEvent();
end

function OnlineRewardPanel:initPanels()
    
    local bgSprite1 = cc.Sprite:create('image/onlineReward/online_reward_1.png');
	bgSprite1:setPosition(cc.p(0,-16)); --26
	bgSprite1:addTo(self.root);

    local title = cc.Label:createWithTTF(LANG.UI_L_ONLINE_RWD,fonts.FONT_SIYUAN,18);
    title:addTo(self.root);
    title:setPosition(cc.p(0,270));

    local timeBg = cc.Sprite:create('image/commonImg/time_bg_1.png');
    timeBg:addTo(self.root);
    timeBg:setPosition(0,217);

    local timeImg = cc.Sprite:create('image/commonImg/time_1.png');
    timeImg:addTo(self.root);
    timeImg:setPosition(-147 , 218);

    local timeLabel = cc.Label:createWithTTF(LANG.UI_ACTIVITY_ONLINE_1 ,  fonts.FONT_SIYUAN , 15)
    timeLabel:addTo(self.root);
    timeLabel:setPosition(-47 , 217);
    timeLabel:setTextColor(cc.c3b(255,255,0));

    self.countDownTime = cc.Label:createWithTTF('00:00:00' ,  fonts.FONT_SIYUAN , 15)
    self.countDownTime:addTo(self.root);
    self.countDownTime:setAnchorPoint(0 , 0.5);
    self.countDownTime:setPosition(11 , 217);
    self.countDownTime:setTextColor(cc.c3b(255,255,0));

    local width = timeLabel:getContentSize().width;
    local cWidth = self.countDownTime:getContentSize().width;
    local posX = -cWidth/2;
    timeLabel:setPositionX(posX);
    self.countDownTime:setPositionX(posX + width/2 + 2);

	self.onlineRewardListView = ccui.ScrollView:create();
	self.onlineRewardListView:setTouchEnabled(true);
	self.onlineRewardListView:setBounceEnabled(true);
	self.onlineRewardListView:setDirection(ccui.ScrollViewDir.vertical);
	self.onlineRewardListView:setContentSize(cc.size(570 , 498));
	self.onlineRewardListView:setAnchorPoint(cc.p(0.5,0.5));
	self.onlineRewardListView:setScrollBarEnabled(false);
    self.onlineRewardListView:addTo(self.root);
    self.onlineRewardListView:setPosition(cc.p(0,-70));
end

function OnlineRewardPanel:registEvent(  )
    EventManager:RegisterEvent(EventType.NetworkRetOnlineData, handler(self, self.onlineDataRet));
    EventManager:RegisterEvent(EventType.NetworkRetOnlineReward, handler(self, self.retOnlineReward));

end

function OnlineRewardPanel:onlineDataRet( msg )
    self:onShow()
end

function OnlineRewardPanel:retOnlineReward( msg )
    -- dump(msg,'ret online reward = ')
    if msg.state == 0 then
        Prompt:Show(LANG.UI_FIGHT_83)
        self:onShow();
        return 
    end
    local itemId = msg.id;
 
    local status = model.OnlineModel:getStatusById(itemId);
    if status ~= -1 and self.onlineRewardItems[itemId] ~= nil then
        self.onlineRewardItems[itemId]:setStatus(status);
        UIManager:push('RewardPanel' , msg)
    end
    --弹出提示！！
    --UIManager:push('RewardPanel' , msg);
    
end

-- function OnlineRewardPanel:onlineItemCallback( id )
--     model.OnlineModel:reqOnlineReward(id);
-- end

function OnlineRewardPanel:showReward(  )
    local allRewards = model.OnlineModel:getOnlineRewards();
    self.onlineRewardListView:removeAllChildren();
    self.onlineRewardItems = {};
    local len = #allRewards;
    local column = 4
    
    local maxHeight = math.floor( (len-1)/column )*162
    if maxHeight < 498 then
        maxHeight = 498;
    end
    self.onlineRewardListView:setInnerContainerSize(cc.size(570,maxHeight))
    
    for i=1,len do
        local col = (i- 1) % column  -- 0,1,2,3
        local row = math.floor((i - 1) / column); --0,1.。

        local itemData = allRewards[i];

        -- local layout = ccui.Layout:create();
        -- layout:addTo(self.onlineRewardListView);
        -- layout:setPosition(62+col*114,426 - row * 165);
        
        local rewardItem = template.OnlineItemTemplate:create(); 
        rewardItem:InitData(itemData);
        rewardItem:addTo(self.onlineRewardListView);
        -- rewardItem:setItemCallback(handler(self,self.onlineItemCallback));
        rewardItem:setPosition(72+col*142,maxHeight - row * 162 - 75)
        self.onlineRewardItems[i] = rewardItem;
    end



end

function OnlineRewardPanel:update(  )
	local onlineSecond = model.OnlineModel:getOnlineSecondTotal()
	local nextId = model.OnlineModel:getNextId();
	local nextSecond = model.OnlineModel:getSecondById(nextId);
	-- print
	local secondOff = nextSecond - onlineSecond
	if secondOff < 0 then
		secondOff = 0
	end
	if self.onlineSecondOff ~= secondOff then
		self.onlineSecondOff = secondOff;
		if secondOff == 0 then
			self.countDownTime:setString('00:00:00');
		else
			self.countDownTime:setString(Sec2Time(math.floor( secondOff )));
		end
    end

    if nextId ~= self.nextId then
        local lastItemId = self.nextId;
        local lastStatus = model.OnlineModel:getStatusById(lastItemId);
        self.onlineRewardItems[lastItemId]:setStatus(lastStatus);

        self.nextId = nextId;
    end

end

function OnlineRewardPanel:onShow(  )

    self:showReward();

    self.nextId = model.OnlineModel:getNextId();

    self:update()
    TimeManager:registUpdateEvent('OnlineRewardPanle',handler(self,self.update),true);
    self.root:setVisible(true);

end

function OnlineRewardPanel:onEnter(key)
    if model.OnlineModel:hasInitOk() ~= true then
        model.OnlineModel:reqOnlineInfo();
    else
        self:onShow();
    end

    self:addSwallowCallback(handler(self , self.onClickBack))
end

function OnlineRewardPanel:onClickBack()
    UIManager:pop('OnlineRewardPanel')
end

function OnlineRewardPanel:onLeave()

    TimeManager:registUpdateEvent('OnlineRewardPanle',nil,true); -- 取消注册

    self.root:setVisible(false);

end

function OnlineRewardPanel:exitPanel(  )
    UIManager:pop("OnlineRewardPanel");
end

return OnlineRewardPanel;
