local PlayBallPanel = class("PlayBallPanel",require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local FightType = Enum:getTable('FightType');
local MessageBoxType = Enum:getTable('MessageBoxType')
local imgPath = 'image/playball/';
local CommonShopType = Enum:getTable('CommonShopType');

local posXList = {-240, -160, -80, 0, 80, 160, 240}

function PlayBallPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'PlayBallPanel');
    self.scene = scene;
	self.useCCreator = false;
    self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
    self.showFooter = false;

    self.selectedId = nil;
    
end

function PlayBallPanel:Init( root,scene )
    -- body
    self.root = root;
    self.root:setVisible(false);
    self.bShooting = false;
    self.playST = 0;

    self:initPannel();
    self:registEvent();

end

function PlayBallPanel:registEvent(  )
    EventManager:RegisterEvent('EGO_ContactEvent' , handler(self , self.onContactBegin));
	EventManager:RegisterEvent('PlayBallPanel:refreshAllBox' , handler(self , self.refreshAllBox));
    EventManager:RegisterEvent('PlayBallPanel:refreshTopItems' , handler(self , self.refreshTopItems));
end

function PlayBallPanel:initPannel(  )
	local blackBg = ccui.Layout:create();
	blackBg:setBackGroundImage('image/task/blackbg.png');
	blackBg:setBackGroundImageScale9Enabled(true);
	blackBg:setTouchEnabled(true);
	blackBg:setContentSize(StageSize);
	blackBg:setLocalZOrder(-2);
	blackBg:setAnchorPoint(cc.p(0.5,0.5));
	blackBg:setPosition(0, 0);
    blackBg:addTo(self.root);
    
    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);

    local bg1 = cc.Sprite:create('image/playball/pb_bg.png');
    bg1:addTo(bgNode);

    local roleSpr = cc.Sprite:create('image/role/R025_Bare.png')
    roleSpr:addTo(bgNode);
    roleSpr:setPosition(0, -150);
    roleSpr:setOpacity(130)
    -- roleSpr:setBlendFunc(cc.blendFunc(GL_ZERO, GL_SRC_COLOR));
    roleSpr:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA));

    local spine_res = 'pinball_light_spine';
    self.spine_res = 'pinball_collection_spine'
    if spine_res~=nil and cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
        local skAnimation3 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        skAnimation3:addTo(bgNode)
        skAnimation3:setAnimation(0, "light3", true)
    end

    local topS = cc.Sprite:create( imgPath..'pb_top_s.png' )
    topS:addTo(bgNode)
    topS:setPosition(0, StageSize.height/2)
    topS:setAnchorPoint(0.5,1)
    local btmS = cc.Sprite:create( imgPath..'pb_btm_s.png' )
    btmS:addTo(bgNode)
    btmS:setPosition(0, -StageSize.height/2)
    btmS:setAnchorPoint(0.5,0)

    self:initCannon()

    if true then
        local skAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        skAnimation:addTo(self.root)
        skAnimation:setPosition(0, StageSize.height/2)
        skAnimation:setAnimation(0, "light1", true)
    end

    local leftSpr = cc.Sprite:create('image/playball/pb_line.png')
    leftSpr:addTo(self.root)
    leftSpr:setPosition(-StageSize.width/2+10, 0)
    local rightSpr = cc.Sprite:create('image/playball/pb_line.png')
    rightSpr:addTo(self.root)
    rightSpr:setFlipX(true)
    rightSpr:setPosition(StageSize.width/2-10, 0)

    if true then
        local skAnimation2 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        skAnimation2:addTo(self.root)
        skAnimation2:setAnimation(0, "light2", true)
    end

    local topNode = cc.Node:create()
    topNode:addTo(self.root)
    topNode:setPosition(0, StageSize.height/2)
    local topBg1 = cc.Sprite:create( imgPath..'pb_topBg.png' )
    topBg1:addTo(topNode)
    topBg1:setAnchorPoint(0.5,1)

    self.itemList = {}
    self.BallItemIds = {}
    for i=1,3 do
        local itemNode = cc.Node:create()
        itemNode:addTo(topNode)
        itemNode:setPosition((i-2)*200, -90)

        local itemBg = cc.Sprite:create( 'image/commonImg/cm_fb_bg.png' )
        itemBg:addTo(itemNode)
        local itemIcon = cc.Sprite:create('image/icon/I10001.png')
        itemIcon:addTo(itemNode)
        itemIcon:setScale(0.4)
        itemIcon:setPosition(-50, 0)
        local itemLabel = cc.Label:createWithTTF('0' ,  fonts.FONT_SIYUAN , 27)
            :addTo(itemNode)
            :setPosition(10, 0)
            :enableOutline(cc.c3b(0,0,0), 1)

        if i == 2 then
            local exchangeBtn = ccui.Button:create('image/commonImg/cm_fb_bg.png')
            exchangeBtn:addTo(itemNode)
            exchangeBtn:setOpacity(0)
            exchangeBtn:addClickEventListener(handler(self , self.onOpenExchangePanel))
        end

        self.itemList[i] = {itemLabel=itemLabel, itemIcon=itemIcon}
    end

    --挑战
    self.fightBtn = ccui.Button:create('image/commonImg/common_item_select.png')
        :addTo(self.root)
        :setScale9Enabled(true)
    self.fightBtn:setPosition(0, -150);
    self.fightBtn:setContentSize(cc.size(StageSize.width, StageSize.height-300))
    self.fightBtn:setScale9Enabled(true)
    self.fightBtn:setOpacity(0)
    self.fightBtn:addClickEventListener(handler(self , self.onFight))

    self.bottomNode = cc.Node:create()
    self.bottomNode:addTo(self.root)

    local bottomNode = cc.Node:create()
    bottomNode:addTo(self.bottomNode)
    bottomNode:setPosition(0, -StageSize.height/2)
    local btmBg1 = cc.Sprite:create( imgPath..'pb_BtmBg.png' )
    btmBg1:addTo(bottomNode)
    btmBg1:setAnchorPoint(0.5,0)

    local boxSpBGNode = cc.Node:create()
    boxSpBGNode:addTo(self.bottomNode)
    boxSpBGNode:setPosition(0, -0.5*StageSize.height+50)
    self.boxBGSpList={}
    for i=1,7 do
        local boxSp = sp.SkeletonAnimation:create('spine/pinball_back_spine/pinball_back_spine.json', 'spine/pinball_back_spine/pinball_back_spine.atlas', 1)
        boxSp:addTo(boxSpBGNode)
        boxSp:setPosition(posXList[i], 20)
        self.boxBGSpList[i] = boxSp;

        boxSp:registerSpineEventHandler(function (event)
            if event.animation == 'catapult_shoot' then
                boxSp:setAnimation(0, "catapult_idle", true)

            elseif event.animation == 'collection1_collision1' or
                   event.animation == 'collection1_collision2' or
                   event.animation == 'collection1_collision3' or
                   event.animation == 'collection1_shoot' then

                boxSp:setAnimation(0, "collection1_idle", true)

            elseif event.animation == 'collection2_collision1' or
                   event.animation == 'collection2_collision2' or
                   event.animation == 'collection2_collision3' or
                   event.animation == 'collection2_shoot' then

                boxSp:setAnimation(0, "collection2_idle", true)
            end 
        end, sp.EventType.ANIMATION_COMPLETE)
    end

    self.ballNode = cc.Node:create()
    self.ballNode:addTo(self.bottomNode)
    self.ballNode:setPosition(-StageSize.width*0.5, -0.5*StageSize.height)
    self.boxNode = cc.Node:create()
    self.boxNode:addTo(self.bottomNode)
    self.boxNode:setPosition(0, -0.5*StageSize.height+50) ---StageSize.width*0.5
    local boxSpNode = cc.Node:create()
    boxSpNode:addTo(self.bottomNode)
    boxSpNode:setPosition(0, -0.5*StageSize.height+50)

    self.boxSpList={}
    self.boxSpSt={}
    for i=1,7 do
        local boxSp = sp.SkeletonAnimation:create('spine/'..self.spine_res.."/"..self.spine_res..".json", 'spine/'..self.spine_res.."/"..self.spine_res..".atlas", 1)
        boxSp:addTo(boxSpNode)
        boxSp:setPosition(posXList[i], 20)
        self.boxSpList[i] = boxSp;
        self.boxSpSt[i]=0

        boxSp:registerSpineEventHandler(function (event)
            if event.animation == 'catapult_shoot' then
                boxSp:setAnimation(0, "catapult_idle", true)
                self.boxSpSt[i]=0

            elseif event.animation == 'collection1_collision1' or
                   event.animation == 'collection1_collision2' or
                   event.animation == 'collection1_collision3' or
                   event.animation == 'collection1_shoot' then

                boxSp:setAnimation(0, "collection1_idle", true)
                self.boxSpSt[i]=0
                if event.animation == 'collection1_shoot' then
                    -- self.playST = 0;
                    -- self:shootEndBall()
                end

            elseif event.animation == 'collection2_collision1' or
                   event.animation == 'collection2_collision2' or
                   event.animation == 'collection2_collision3' or
                   event.animation == 'collection2_shoot' then

                boxSp:setAnimation(0, "collection2_idle", true)
                self.boxSpSt[i]=0
                if event.animation == 'collection2_shoot' then
                    -- self.playST = 0;
                    -- self:shootEndBall()
                end
            end 
        end, sp.EventType.ANIMATION_COMPLETE)

        boxSp:registerSpineEventHandler(function (event)
            if event.eventData.name == 'stop' then
                self.playST = 0;
                self:shootEndBall()
            end
        end, sp.EventType.ANIMATION_EVENT)
    end

    self.ballIdx = 0;
    self.totalScore = 0;

    self.ballList = {}
    self.boxList = {}
    
end

function PlayBallPanel:initCannon()
    self.cannonNode = cc.Node:create()
    self.cannonNode:addTo(self.root)
    self.cannonNode:setPosition(0 , StageSize.height*0.3)

    local spine_res = 'pinball_cannon_spine';
    local cannonSp = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
    cannonSp:addTo(self.cannonNode)
    cannonSp:setAnimation(0, "cannon_idle", true)
    self.cannonSp = cannonSp;

    cannonSp:registerSpineEventHandler(function (event)
        if event.animation == 'cannon_shoot' then
            cannonSp:setAnimation(0, "cannon_idle", true)
        end 
    end, sp.EventType.ANIMATION_COMPLETE)

    -- cannonSp:registerSpineEventHandler(function (event)
    --     if event.eventData.name == 'nandu_spine' then
    --     end     
    -- end, sp.EventType.ANIMATION_EVENT)

    -- self.cannonNode:setRotation(-17)

    self.cannonNode:setRotation(60-90)
    local act1 = cc.RotateTo:create(0.5,90-90);
    local act2 = cc.RotateTo:create(0.5,120-90);
    local act3 = cc.RotateTo:create(0.5,90-90);
    local act4 = cc.RotateTo:create(0.5,60-90);
    local act = cc.Sequence:create(act1,act2,act3,act4);
    self.cannonNode:runAction(cc.RepeatForever:create( act ))

end

function PlayBallPanel:shootEndBall()
    local act1 = cc.MoveTo:create(0.3, cc.p(0, -200))
    local endFunc = cc.CallFunc:create(function() self:refreshAllBox() end)
    self.bottomNode:runAction( cc.Sequence:create(act1, endFunc) )
end

function PlayBallPanel:refreshAllBox()
    if self.playST ~= 0 then
        return;
    end
    self.boxList = {}
    for i=1,7 do
        self.boxSpSt[i]=0
    end
    self.boxNode:removeAllChildren();
    self:initStaticBody()

    self.bottomNode:setPosition(0,-200)
    local act1 = cc.MoveTo:create(0.3, cc.p(0, 0))
    local endFunc = cc.CallFunc:create(function() self.bShooting = false; end)
    self.bottomNode:runAction( cc.Sequence:create(act1, endFunc) )
end

function PlayBallPanel:initStaticBody()

    local cellWidth = 62--70;

    local dataList = model.ItemModel:getPlayBallList(self.no);
    local extH = 60;
    for k,v in pairs(dataList) do
        -- self.boxSpList[v.id]:clearTracks();
        -- self.boxBGSpList[v.id]:clearTracks();
        if v.bucket_type == 3 then

            -- local boxSprite = cc.Sprite:create('image/playball/pb_spring.png');
            local boxSprite = cc.Scale9Sprite:create('image/commonImg/common_item_select.png');
            boxSprite:setContentSize(cc.size(70, 70))
            local boxBody = cc.PhysicsBody:createCircle(35,{density = 1.0, restitution = 1.0, friction = 0},cc.p(0,0))
            boxBody:setContactTestBitmask(0xFFFFFFFF)
            -- boxBody:applyImpulse(cc.p(0,10000))
            boxBody:setDynamic(false)
            boxSprite:setPhysicsBody(boxBody)
            boxSprite:setPosition(posXList[v.id] , 80*0.5+10)
            boxSprite:setTag(400+v.id)
            boxSprite:setOpacity(0)
            self.boxNode:addChild(boxSprite)

            self.boxSpList[v.id]:setAnimation(0, "catapult_idle", true)
            self.boxBGSpList[v.id]:setVisible(false)

        else
            local itemH = 76;
            if v.bucket_type == 1 then
                itemH = 76;
            elseif v.bucket_type == 2 then
                itemH = 124;
            end

            local line1Sprite = cc.Scale9Sprite:create('image/battlePass/battlepass_bg_12.png');
            line1Sprite:setContentSize(cc.size(6, itemH))

            -- local ptList = { {3, -itemH/2}, {-3, -itemH/2}, {-3, itemH/2}, {3, itemH/2-12} };
            -- local line1Body = cc.PhysicsBody:createPolygon(ptList ,cc.PHYSICSBODY_MATERIAL_DEFAULT,cc.p(0,0))  --矩形刚体   
            
            local line1Body = cc.PhysicsBody:createBox(line1Sprite:getContentSize(),cc.PHYSICSBODY_MATERIAL_DEFAULT,cc.p(0,0))  --矩形刚体   
            line1Body:setContactTestBitmask(0xFFFFFFFF)
            -- line1Body:applyImpulse(cc.p(0,10000))
            -- line1Body:setGroup(1)
            line1Body:setDynamic(false)
            line1Sprite:setPhysicsBody(line1Body)
            line1Sprite:setPosition(posXList[v.id]-cellWidth/2-3 , itemH*0.5)
            line1Sprite:setTag(100+v.id)
            line1Sprite:setOpacity(0)
            self.boxNode:addChild(line1Sprite)

            local boxSprite = cc.Scale9Sprite:create('image/commonImg/common_item_select.png');
            boxSprite:setContentSize(cc.size(cellWidth, itemH-extH))
            local boxBody = cc.PhysicsBody:createBox(boxSprite:getContentSize(),cc.PHYSICSBODY_MATERIAL_DEFAULT,cc.p(0,0))  --矩形刚体   
            boxBody:setContactTestBitmask(0xFFFFFFFF)
            -- boxBody:applyImpulse(cc.p(0,10000))
            boxBody:setDynamic(false)
            -- boxBody:setGroup(2)
            boxSprite:setPhysicsBody(boxBody)
            boxSprite:setPosition(posXList[v.id] , itemH*0.5-extH*0.5)
            boxSprite:setTag(200+v.id)
            boxSprite:setOpacity(0)
            self.boxNode:addChild(boxSprite)

            local socreItem = cc.Node:create();
            socreItem:addTo(self.boxNode)
            socreItem:setPosition(posXList[v.id] , 0)
            
            local spVal = 1;
            if v.bucket_type==1 then
                spVal = 2;
                self.boxSpList[v.id]:setAnimation(0, "collection2_idle", true)
                self.boxBGSpList[v.id]:setAnimation(0, "collection2_idle", true)
            else
                spVal = 1;
                self.boxSpList[v.id]:setAnimation(0, "collection1_idle", true)
                self.boxBGSpList[v.id]:setAnimation(0, "collection1_idle", true)

                -- local scoreIcon = cc.Sprite:create('image/playball/pb_heart.png')
                -- scoreIcon:addTo(socreItem)
                -- scoreIcon:setPosition(0, -15)
            end
            local scoreLabel = cc.Label:createWithTTF(v.score ,  fonts.FONT_SIYUAN , 27)
            scoreLabel:enableOutline(cc.c4b(193 , 3 , 115 , 255),1)
            scoreLabel:setPosition(0, -15)
            scoreLabel:addTo(socreItem)

            self.boxBGSpList[v.id]:setVisible(true)

            self.boxList[200+v.id] = { score=v.score, sp=spVal }

            local line2Sprite = cc.Scale9Sprite:create('image/battlePass/battlepass_bg_12.png');
            line2Sprite:setContentSize(cc.size(6, itemH))

            -- local ptList = { {3, -itemH/2}, {-3, -itemH/2}, {-3, itemH/2-12}, {3, itemH/2} };
            -- local line2Body = cc.PhysicsBody:createPolygon(ptList ,cc.PHYSICSBODY_MATERIAL_DEFAULT,cc.p(0,0))  --矩形刚体   
            
            local line2Body = cc.PhysicsBody:createBox(line2Sprite:getContentSize(),cc.PHYSICSBODY_MATERIAL_DEFAULT,cc.p(0,0))  --矩形刚体   
            line2Body:setContactTestBitmask(0xFFFFFFFF)
            -- line2Body:applyImpulse(cc.p(0,10000))
            -- line2Body:setGroup(1)
            line2Body:setDynamic(false)
            line2Sprite:setPhysicsBody(line2Body)
            line2Sprite:setPosition(posXList[v.id]+cellWidth/2+3 , itemH*0.5)
            line2Sprite:setTag(300+v.id)
            line2Sprite:setOpacity(0)
            self.boxNode:addChild(line2Sprite)

        end

    end
    
end

function PlayBallPanel:addBall( random )
    if self.root:isVisible() == false or self.bShooting==true then
        return;
    end
    self.cannonSp:setAnimation(0, "cannon_shoot", false)

    -- body
    self.ballIdx = self.ballIdx+1;
    local oneSprite = display.newSprite("image/playball/pb_ball.png")
    -- local oneBody = cc.PhysicsBody:createBox(oneSprite:getContentSize(),cc.PHYSICSBODY_MATERIAL_DEFAULT,cc.p(0,0))  --矩形刚体
    local oneBody = cc.PhysicsBody:createCircle(30,{density = 0.1, restitution = 1, friction = 0},cc.p(0,0))      --圆形刚体   
    oneBody:setContactTestBitmask(0xFFFFFFFF)
    -- oneBody:setGroup(2)
    -- oneBody:applyImpulse(cc.p(0,10000))

    local rotaVal = self.cannonNode:getRotation()+90
    local angle = math.rad(rotaVal);

    local offx = 200*math.cos(angle)
    local offy = -200*math.sin(angle)

    local speed = 2000
    oneBody:setVelocity(cc.p(math.cos(angle)*speed , -math.sin(angle)*speed))
    oneSprite:setPhysicsBody(oneBody)
    oneSprite:setPosition(StageSize.width*0.5+offx , StageSize.height*0.8+offy)
    oneSprite:setTag(10000+self.ballIdx)

    local sparticle = cc.ParticleSystemQuad:create("Effect/particle/pinball.plist")
    sparticle:setPosition(27,27)
    sparticle:addTo(oneSprite);

    self.ballNode:addChild(oneSprite)
    self.bShooting = true;

    self.ballList[10000+self.ballIdx] = oneSprite
end

function PlayBallPanel:onContactBegin(contact)
    local nodeA=contact:getShapeA():getBody():getNode()
    if not nodeA then
        return;
    end
    local tagA = nodeA:getTag()

    local tagB = contact:getShapeB():getBody():getNode():getTag()
    -- print(tagB)

    if (tagA>10000 and tagB>200 and tagB<300) or (tagB>10000 and tagA>200 and tagA<300) then --加分
        local spIdx = 0;
        if tagA>10000 then
            spIdx = tagB%100
            self.ballList[tagA]:removeFromParent()
            self.totalScore = self.boxList[tagB].score + self.totalScore
        else
            spIdx = tagA%100
            self.ballList[tagB]:removeFromParent()
            self.totalScore = self.boxList[tagA].score + self.totalScore
        end
        -- self.bShooting = false;

        if self.boxSpList[spIdx] then
            if self.boxList[200+spIdx].sp == 1 then
                self.boxSpList[spIdx]:setAnimation(0, "collection1_shoot", false)
                self.boxBGSpList[spIdx]:setAnimation(0, "collection1_shoot", false)
                self.boxSpSt[spIdx]=2
                self:onPlayRwdNum(self.boxList[200+spIdx].score , 'h', spIdx)
            else
                self.boxSpList[spIdx]:setAnimation(0, "collection2_shoot", false)
                self.boxBGSpList[spIdx]:setAnimation(0, "collection2_shoot", false)
                self.boxSpSt[spIdx]=2
                self:onPlayRwdNum(self.boxList[200+spIdx].score , 'l', spIdx)
            end
            self.playST = 1;
        end

        model.ItemModel:sendPlayBallOne( self.no, spIdx )

        -- self.timeLabel:setString( self.totalScore )

    elseif (tagA>10000 and tagB>400 and tagB<500) or (tagB>10000 and tagA>400 and tagA<500) then --弹簧
        local curNode = nil
        local body = nil
        local spIdx = 0;
        if tagA>10000 then
            curNode = contact:getShapeB():getBody():getNode()
            body = contact:getShapeA():getBody()
            spIdx = tagB - 400
        else
            curNode = contact:getShapeA():getBody():getNode()
            body = contact:getShapeB():getBody()
            spIdx = tagA - 400
        end
        if body then
            local vel = body:getVelocity()
            local length = cc.pGetLength(vel)
            -- print("old velX, velY:", vel.x, vel.y)
            body:setVelocity( cc.p(vel.x/length*1000, vel.y/length*1000) )
            -- body:setVelocity( cc.p(vel.x+(vel.x/math.abs(vel.x)* 50 ), vel.y+(vel.y/math.abs(vel.y)* 50 )) )
            -- print("cur velX, velY:", vel.x, vel.y)
            -- print('*****************************')
        end
        if self.boxSpList[spIdx] then
            self.boxSpList[spIdx]:setAnimation(0, "catapult_shoot", false)
            self.boxSpSt[spIdx]=3
        end
    else
        local spIdx = 0;
        if tagA>10000 then
            spIdx = tagB%100
        else
            spIdx = tagA%100
        end
        if self.boxSpList[spIdx] and self.boxSpSt[spIdx]==0 then
            local subIdx = math.random(1,3)
            if self.boxList[200+spIdx].sp == 1 then
                self.boxSpList[spIdx]:setAnimation(0, "collection1_collision"..subIdx, false)
                self.boxBGSpList[spIdx]:setAnimation(0, "collection1_collision"..subIdx, false)
                self.boxSpSt[spIdx]=1
            else
                self.boxSpList[spIdx]:setAnimation(0, "collection2_collision"..subIdx, false)
                self.boxBGSpList[spIdx]:setAnimation(0, "collection2_collision"..subIdx, false)
                self.boxSpSt[spIdx]=1
            end
        end
    end
end

function PlayBallPanel:retFightOverAuto( msg )
    --扫荡结果更新UI
	UIManager:push('RewardPanel', msg);
end

function PlayBallPanel:onClickBack( ... )
	UIManager:pop('PlayBallPanel');
end

function PlayBallPanel:refreshTopItems()
    for i=1,3 do
        local iconFile = GlobalFunctions:getItemIconFileAndNum( {self.BallItemIds[i], 0} );
        local num = model.ItemModel:getItemNum(self.BallItemIds[i])
        self.itemList[i].itemIcon:setTexture(iconFile);
        self.itemList[i].itemLabel:setString(num);
    end
end

function PlayBallPanel:onEnter( no )
    self.no = 1;
    local ballData = ResTable:getRowData('belle_ball', self.no)
    self.BallItemIds = {ballData.exchange_id, ballData.ball_id, ballData.score_id}
    self.shopId = ballData.shop_id;
    self.tempTime = 0
    self.ballIdx = 0;
    self.playST = 0;
    self.totalScore = 0;
    self.bShooting = false;
    self.ballList = {}
    self.boxList = {}
    for i=1,7 do
        self.boxSpSt[i]=0
    end
    self.ballNode:removeAllChildren()
    self.boxNode:removeAllChildren();
    -- self:initStaticBody()

    local DataList = model.ItemModel:getPlayBallList(self.no);
    if not DataList then
        local msg = {};
        msg.no = self.no;
        Network.NetworkManager:Send(Network.NetworkCmdType.req_play_ball_init, msg);
    else
        self:refreshAllBox();
    end

    self:onShow();
    self:refreshTopItems();
    AudioManager:playMusic(Conf.copyFight, 2, true);

    self.scene:getPhysicsWorld():setAutoStep(false)
    TimeManager:registUpdateEvent('PlayBallPanel',handler(self,self.updateTime));

end

function PlayBallPanel:getIsPlaying()
    return self.bShooting;
end

function PlayBallPanel:updateTime(dt)
    if self.bShooting == false then
        return false;
    end
    for i=1,3 do
        self.scene:getPhysicsWorld():step(1/180)
    end
end

function PlayBallPanel:onShow()
    self.root:setVisible(true)
end

function PlayBallPanel:onFight()
    local ballNum = model.ItemModel:getItemNum( self.BallItemIds[2] )
    if ballNum<=0 then
        Prompt:Show(LANG.ERROR_INFO[9063]);
        return;
    end
    self:addBall()
end

function PlayBallPanel:onLeave( ... )
    self.root:setVisible(false);
    TimeManager:registUpdateEvent('PlayBallPanel',nil);
    AudioManager:playMusic(Conf.main, 2, true);
end

function PlayBallPanel:onOpenExchangePanel()
    local ballNum = model.ItemModel:getItemNum( self.BallItemIds[2] )
    if ballNum>0 then
        return;
    end
    UIManager:push('TipsShopPanel' , CommonShopType.CLIENT , self.shopId);
end

function PlayBallPanel:onPlayRwdNum(score, typeH, idx)
    local num = score;
    local numInfo = tostring(num)

    local numSprList = {}

    local numNode = cc.Node:create()
    numNode:addTo(self.root)
    numNode:setCascadeOpacityEnabled(true);
    local posX = 0
    local strH = typeH;
    local addSpr = cc.Sprite:create('image/playball/'..strH..'plus.png')
    addSpr:addTo(numNode);
    addSpr:setPosition(posX, 0)
    posX = posX+addSpr:getContentSize().width/2 + 2

    table.insert(numSprList, addSpr)

    for i=1,string.len(numInfo) do
        local subStr = string.sub(numInfo, i, i)
        local numSpr = cc.Sprite:create('image/playball/'..strH..subStr..'.png')
        numSpr:addTo(numNode);
        posX = posX+numSpr:getContentSize().width/2;
        numSpr:setPosition(posX, 0)
        posX = posX+numSpr:getContentSize().width/2 + 2;

        table.insert(numSprList, numSpr)
    end
    local extH = 150
    if strH == 'h' then
        extH = extH+50
    end
    numNode:setPosition( -posX/2 + posXList[idx], -StageSize.height/2+extH )

    for i=1,#numSprList do
        local curSpr = numSprList[i]
        curSpr:setOpacity(0)
        local fadeIn = cc.FadeIn:create(0.2);
        local moveBy = cc.EaseBackOut:create( cc.MoveBy:create(0.5,cc.p(0, 50)) );
        local delayAct = cc.DelayTime:create( (i-1)*0.1 )
        curSpr:runAction(fadeIn)
        if i == #numSprList then
            local funAct = cc.CallFunc:create(function()
                local act1 = cc.DelayTime:create(0.3)
                local act2 = cc.FadeOut:create(0.2)
                local endFunc = cc.CallFunc:create(function() numNode:removeFromParent() end)
                numNode:runAction( cc.Sequence:create(act1, act2, endFunc) )
                end)
            curSpr:runAction( cc.Sequence:create( delayAct, fadeIn, moveBy, funAct ) )
        else
            curSpr:runAction( cc.Sequence:create( delayAct, fadeIn, moveBy ) )
        end
    end
end

return PlayBallPanel
