local Prompt = class("Prompt")
local scheduler = cc.Director:getInstance():getScheduler();
local PromptShowType = Enum:getTable('PromptShowType');
function Prompt:ctor()
	self:clearAll();
end
function Prompt:clearAll(  )
	self.root = nil;
	self.scene = nil;
	self.hasInit = false;
	self.showIndex = 0;
	self.textList = {};
	self.delayTime = 0.3;
	self.showType = PromptShowType.SHOW_TYPE_NONE;
end
--初始化面板
function Prompt:Init(root, scene)
	self.root = root;
	self.scene = scene;
	self.hasInit = true;

	self:InitPanel();

	self.root:setVisible(false);
end

function Prompt:InitPanel()
	self.promptNode = cc.Node:create();
	self.promptNode:setPosition(0, 80);
	self.promptNode:setCascadeOpacityEnabled(true);
	self.root:addChild(self.promptNode);

	local bg1 = cc.Sprite:create('image/commonImg/common_tip_bg.png');
	--bg1:setAnchorPoint(cc.p(1, 0.5));
	--bg1:setTextureRect(cc.rect(0,0,0,125));
	self.promptNode:addChild(bg1);

	self.label = cc.Label:createWithSystemFont(text, Enum:getTable("SystemFont").FONT_SIYUAN, 20);
	self.label:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 1);

	self.promptNode:addChild(self.label);
end

function Prompt:Show(text , showType)
	if self.hasInit ~= true then
		print('error : Prompt  hasInit == false   text = ',tostring(text))
		return;
	end

	local showType = showType or PromptShowType.SHOW_TYPE_ONE; --0:无类型，1，叭叭叭直接冒 2.一个个的出现

	if self.showType == PromptShowType.SHOW_TYPE_ONE or self.showType ~= showType then
		self.showIndex = 0;
		self.textList = {};
		self.promptNode:stopAllActions();
		self.root:setVisible(false);
	end

	self.showType = showType;
	
	if self.showType == PromptShowType.SHOW_TYPE_ONE then
		self.delayTime = 1;
		self:showAction(text);
	else
		self.delayTime = 0.3;
		table.insert(self.textList , text);
		if not self.root:isVisible() then
			self.showIndex = 0;
			self:showTypeTwoAction();
		end
	end
	self.root:setVisible(true);
end

function Prompt:showTypeTwoAction()
	self.showIndex = self.showIndex + 1;

	if not self.textList[self.showIndex] then
		self.showIndex = 0;
		self.showType = PromptShowType.SHOW_TYPE_NONE;
		self.textList = {};
		self.root:setVisible(false);
	end

	self:showAction(self.textList[self.showIndex]);
end

function Prompt:showAction(text)
	self.label:setString(tostring(text));
	self.promptNode:stopAllActions();
	self.promptNode:setScale(1 , 0);
	self.promptNode:setOpacity(255);
	self.promptNode:runAction(cc.Sequence:create(
		cc.ScaleTo:create(3/15 , 1 , 1.1) , 
		cc.ScaleTo:create(5/15 , 1 , 1) , 
		cc.DelayTime:create(self.delayTime) , 
		cc.Spawn:create(cc.FadeOut:create(3/15),cc.ScaleTo:create(3/15 , 1 , 0)),
		cc.CallFunc:create(function()
			if self.showType == PromptShowType.SHOW_TYPE_TWO then
				self:showTypeTwoAction();
			else
				self.showType = PromptShowType.SHOW_TYPE_NONE;
			end
		end)
	));
end

return Prompt;
