local RandomShopPanel = class('RandomShopPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')

function RandomShopPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'RandomShopPanel');

	self.useCCreator = false;


	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;

end

function RandomShopPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
      self.root:setPosition(StageSize.width/2,StageSize.height/2);
  
  
      self:initPanel();
  
      self:registEvent();
end

function RandomShopPanel:initPanel(  )

    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);
    
	local bgSprite1 = cc.Sprite:create('image/bg/Bg_3.png');
	bgSprite1:addTo(bgNode);

	local bgSprite2 = cc.Sprite:create('image/RandomShop/bg_top.png');
	bgSprite2:setPosition(cc.p(0,241));
	bgSprite2:addTo(bgNode);

    self:initSpineAni();



    local bgList = cc.Sprite:create('image/RandomShop/bg_list.png');
	bgList:setPosition(cc.p(4,-194));
    bgList:addTo(self.root);
    
    local bgListC9Sp = ccui.Scale9Sprite:create('image/common/c9sprite_gray.png')
    bgListC9Sp:setOpacity(100)
    bgListC9Sp:setContentSize(cc.size(587,600))
    -- local bgListGray = cc.Sprite :create('image/common/c9sprite_gray.png');
	bgListC9Sp:setPosition(cc.p(2,-154));
	bgListC9Sp:addTo(self.root);
    -- btn
    local btnNode = cc.Node:create()
    btnNode:addTo(self.root)
    btnNode:setPosition(cc.p(0,-497))

	self.btnRefresh = ccui.Button:create('image/common/common_button_53_1.png' , 'image/common/common_button_53_1.png');
    self.btnRefresh:addTo(btnNode);
	self.btnRefresh:addClickEventListener(handler(self , self.onRefreshShop));
    self.btnRefresh:setPosition(190,0)

	self.refreshLabel = cc.Label:createWithTTF(LANG.UI_SHOP_53 ,  fonts.FONT_SIYUAN , 20);
	self.refreshLabel:addTo(btnNode);
    self.refreshLabel:enableOutline(cc.c4b(19 , 93 , 188 , 255),2);
    self.refreshLabel:setPosition(194,2)

    -- self.refreshTimeSp = cc.Sprite:create('image/card/card_treatment_6.png')
    -- self.refreshTimeSp:addTo(btnNode)
    -- self.refreshTimeSp:setPosition(cc.p(-50,49))
    self.refreshTimeLabel1 = cc.Label:createWithTTF(LANG.UI_SHOP_54 ,  fonts.FONT_SIYUAN , 20);
	self.refreshTimeLabel1:addTo(btnNode);
    self.refreshTimeLabel1:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
    self.refreshTimeLabel1:setPosition(cc.p(-201 , 8));   
    self.refreshTimeLabel1:setTextColor(cc.c4b(50 ,50,50,255))

	self.refreshTimeLabel = cc.Label:createWithTTF('00:01:00' ,  fonts.FONT_SIYUAN , 20);
	self.refreshTimeLabel:addTo(btnNode);
    self.refreshTimeLabel:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
    self.refreshTimeLabel:setPosition(cc.p(-201 , -17));   
    self.refreshTimeLabel:setTextColor(cc.c4b(50 ,50,50,255))

    self.refreshCostLabel = cc.Label:createWithTTF('999/99', fonts.FONT_SIYUAN, 20);
    self.refreshCostLabel:addTo(btnNode);
    self.refreshCostLabel:setAnchorPoint(cc.p(0.5,0.5));
    self.refreshCostLabel:enableOutline(cc.c4b(19 , 93 , 188 , 255),2);
    self.refreshCostLabel:setPosition(cc.p(205,-2));

    self.refreshCostSp = cc.Sprite:create('image/icon/I10002.png');
    self.refreshCostSp:addTo(btnNode)
    self.refreshCostSp:setScale(0.5);
    self.refreshCostSp:setPosition(cc.p(144,-2));
    self.refreshCostSp:setScale(0.4);

    local initData = {
        width = 570,
        height = 570,
        cellWidth = 570,
        cellHeight = 310,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

    }
    
    self.shopTableView = template.TableViewTemplate:create()
    self.shopTableView:initWithSizeAndItem(initData) ;
    self.shopTableView:getView():setPosition(cc.p(-285,-439));
    self.shopTableView:getView():addTo(self.root)
    self.shopTableView:setCellSize(cc.size(570 , 310));

    -- list
    --self.shopListView = ccui.ScrollView:create();
	--self.shopListView:setTouchEnabled(true);
	--self.shopListView:setBounceEnabled(true);
	--self.shopListView:setDirection(ccui.ScrollViewDir.vertical);
	--self.shopListView:setContentSize(cc.size(570 , 570));
	--self.shopListView:setAnchorPoint(cc.p(0.5,0.5));
	--self.shopListView:setScrollBarEnabled(false);
    --self.shopListView:addTo(self.root);
    --self.shopListView:setPosition(cc.p(0,-154));

end

function RandomShopPanel:initSpineAni()

    if global_branch.branch_audit_event_showBg then
		
		if self.skeletonBg == nil then
			self.skeletonBg = cc.Sprite:create('image/shop/shop_bg.png')
                :addTo(self.root)
                :setPosition(114,105);
		end

		return 
    end
    
    local spine_res = 'NPC001_Spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then

		self.skeletonNode = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.skeletonNode:setPosition(cc.p(200,-30))

        self.skeletonNode:setMix('idle1','idle2',0.1);
		self.skeletonNode:setAnimation(0, "idle1", false)
		self.skeletonNode:addAnimation(0, "idle2", true)

        self.skeletonNode:addTo(self.root)
	
	else
		Prompt:Show(LANG.UI_CARD_2);
	end
end

function RandomShopPanel:registEvent(  )
    EventManager:RegisterEvent(EventType.UIRefreshRandomShopInfo , handler(self , self.retRandomShopInfo));
end

function RandomShopPanel:updateRedDotShow(  )
	--刷新按钮
	local redDotState = model.ShopModel:getRedDotStateRandomShop()
	tools.RedDotTools:setRedDotToNode(self.btnRefresh,redDotState,nil,cc.p(175,60))
end

function RandomShopPanel:showMoney(  )
    -- self.moneyNum:setString(tostring(model.MoneyModel:getMoney()));
	-- self.diamondNum:setString(tostring(model.ItemModel:getItemNum(Conf.REDDIAMOND)));
end

function RandomShopPanel:updateCountDown( dt )
    local freeCountDown = model.ShopModel:getRandomShopCountDown(); 
    if freeCountDown <= 0 then
        TimeManager:registUpdateEvent('RandomShopCountDown',nil,true);
        self:showRefreshBtn()
        return ;
    end

    local countDownInterval = model.ShopModel:getRandomShopCountDownInterVal()
    local countdown = freeCountDown % countDownInterval -- math.floor(  )
    if countdown <= 0  then
        -- 免费次数增加
        self:showRefreshBtn( true )
        return
    end
    -- print('============updateCountDown === freeCountDown = ',tostring(freeCountDown))

    self.refreshTimeLabel:setString(Sec2Time(countdown));

end

function RandomShopPanel:showRefreshBtn( fix )

    local freeCountDown = model.ShopModel:getRandomShopCountDown(); 
    local freeNum = model.ShopModel:getRandomShopFreeNum( fix );
    -- print('============showRefreshBtn === freeCountDown = ',tostring(freeCountDown)..'...freeNum === ',tostring(freeNum))

    --倒计时
    if freeCountDown <= 0 then
        self.refreshTimeLabel1:setVisible(false)
        self.refreshTimeLabel:setVisible(false)
    else
        self.refreshTimeLabel1:setVisible(true)
        self.refreshTimeLabel:setVisible(true)
        if not fix then
            self:updateCountDown();
            TimeManager:registUpdateEvent('RandomShopCountDown',handler(self,self.updateCountDown),true);
        end

    end

    local refreshCost = model.ShopModel:getRandomShopNextCoin()

    --钻石购买
    if freeNum <= 0  then
        self.refreshCostLabel:setVisible(true)
        self.refreshCostSp:setVisible(true)
        self.refreshLabel:setVisible(false)

        local moneyHave = 0;
        local moneyEnough = false;
        if refreshCost[1] == Conf.GAMEMONEY   then
            moneyHave = model.MoneyModel:getMoney()
            moneyEnough = model.MoneyModel:isEnough(refreshCost[2])
        elseif refreshCost[1] == Conf.REDDIAMOND then
            moneyHave = model.ItemModel:getItemNum(Conf.REDDIAMOND);
            moneyEnough = moneyHave > refreshCost[2]
        end
        
        self.refreshCostLabel:setString(tostring(moneyHave)..'/'..tostring(refreshCost[2]))
        self.refreshCostSp:setPosition(cc.p(180 - self.refreshCostLabel:getContentSize().width/2,0))
        if moneyEnough then --not
            self.refreshCostLabel:setTextColor(cc.c3b(255,255,255))
        else
            self.refreshCostLabel:setTextColor(cc.c3b(254,89,89))
            --local len = string.len( tostring(moneyHave) )
            --local labelSp  = nil
            --for i=1,len do
            --    -- 此方法尝试将每个字符作为sprite，然后操作sprite，不推荐使用！！！
            --    labelSp = self.refreshCostLabel:getLetter(i-1)
            --    if labelSp then
            --        labelSp:setColor(  cc.c3b(254,89,89)  )
            --    end
            --end
        end
    else
        self.refreshLabel:setVisible(true)
        self.refreshLabel:setString(string.format(LANG.UI_SHOP_53,freeNum,5 ))
        self.refreshCostLabel:setVisible(false)
        self.refreshCostSp:setVisible(false)
    end

    self:updateRedDotShow();

end

function RandomShopPanel:reloadCellPanel(cell , idx)
    local startNum = idx * 3 + 1;
    local curMaxNum = (idx+1) * 3;
    curMaxNum = curMaxNum > self.shopDataMaxNum and self.shopDataMaxNum or curMaxNum;
    local children = cell:getChildren();
    if #children <= 0 then
        for i = 1 , 3 do
            local x = 100+(i-1)*190;
            local y = 175;
            
            local itemTemplate = template.RandomShopItemTemplate:create();
            itemTemplate:setPosition(x , y);
            itemTemplate:addTo(cell);
            itemTemplate:addItemClickEventListener(handler(self , self.listItemClick));
            if startNum <= curMaxNum then
                local itemData = self.shoplist[startNum];
                itemTemplate:InitData(itemData);
                itemTemplate:setItemTag(startNum);

                startNum = startNum + 1;
            else
                itemTemplate:setVisible(false);
            end
        end
    else
        for i = 1 , 3 do
            local itemTemplate = children[i];
            if startNum <= curMaxNum then
                local itemData = self.shoplist[startNum];
                itemTemplate:InitData(itemData);
                itemTemplate:setItemTag(startNum);
                itemTemplate:setVisible(true);

                startNum = startNum + 1;
            else
                itemTemplate:setVisible(false);
            end
        end
    end
end

function RandomShopPanel:cellItemTouch(table , cell)
    if self.selectItemIdx then

        if not self.shoplist[self.selectItemIdx] then
            return
        end

        local data = self.shoplist[self.selectItemIdx];

        if data.buy <= 0 then
            return 
        end

        local costName = ResTable:getValue('item' , data.price[1] , 'name');
        local msg = string.format(LANG.UI_SHOP_61 , tostring(math.ceil( data.price[2]*data.discount/100 )), tostring(costName),tostring(data.name))
    
        MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
            model.ShopModel:reqRandomShopBuyItem(data.no,data.discount)
        end);
        self.selectItemIdx = nil;
    end
end

function RandomShopPanel:listItemClick(sender , event)
    AudioManager:playEffect(Conf.buttonClick);
    self.selectItemIdx = sender:getTag();
end

function RandomShopPanel:showShopList(  )
    self.shoplist = model.ShopModel:getRandomShopList()

    if not self.shoplist then
        return;
    end

    self.shopDataMaxNum = #self.shoplist;
    self.shopTableView:setDataCount(math.ceil(self.shopDataMaxNum / 3));
    self.shopTableView:reloadData();
end

function RandomShopPanel:retRandomShopInfo( msg )
    if self.root:isVisible() == false then
        return;
    end
    if model.ShopModel:hasRandomShopInit() then
        self:onShow()
    else
        self:onClickBack();
    end
end

function RandomShopPanel:onEnter()
    if model.ShopModel:hasRandomShopInit() then
        self:onShow()
    else
        model.ShopModel:reqRandomShopInfo();
    end
    self.root:setVisible(true)
end

function RandomShopPanel:onShow()

    self:showMoney()
    self:showRefreshBtn()
    self:showShopList()
end

function RandomShopPanel:onLeave( ... )
    self.root:setVisible(false);
    TimeManager:registUpdateEvent('RandomShopCountDown',nil,true);
end

function RandomShopPanel:onRefreshShop( sender,event )

    local freeNum = model.ShopModel:getRandomShopFreeNum(  );
    if freeNum <= 0  then
        local refreshCost = model.ShopModel:getRandomShopNextCoin()

        local moneyHave = 0;
        local moneyEnough = false;
        if refreshCost[1] == Conf.GAMEMONEY   then
            moneyHave = model.MoneyModel:getMoney()
            moneyEnough = model.MoneyModel:isEnough(refreshCost[2])
        elseif refreshCost[1] == Conf.REDDIAMOND then
            moneyHave = model.ItemModel:getItemNum(Conf.REDDIAMOND);
            moneyEnough = moneyHave > refreshCost[2]
        end
        
        if moneyEnough then --not
            local msg = string.format(LANG.UI_SHOP_55 , tostring(refreshCost[2]))

            MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
                model.ShopModel:reqRandomShopRefresh()
            end);
        else
            Prompt:Show(LANG.UI_SHOP_56);
        end
    else
        model.ShopModel:reqRandomShopRefresh()
    end


end

function RandomShopPanel:onClickBack()
    UIManager:pop('RandomShopPanel');
    tools.RedDotTools:pushHomeBaseRedDot(2,8)

end

function RandomShopPanel:guideItemClick(  )
    self.selectItemIdx = 1;
    self:cellItemTouch();
end
function RandomShopPanel:guideItemClickOK(  )
    MessageBox:closeBox()
    local data = self.shoplist[1];
    if data.buy > 0 then
        model.ShopModel:reqRandomShopBuyItem(data.no,data.discount)
    end
    self.root:runAction(cc.Sequence:create(
        cc.DelayTime:create(0.5),
        cc.CallFunc:create(function (  )
            UIManager:switch('MainPanel');
        end )
    ))
end

-- 引导相关
function RandomShopPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 29 then
		local cellChidrens = self.shopTableView:cellAtIndex(0):getChildren();
		local btn = cellChidrens[1];
        pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
    elseif guideNo == 30 then 
        local btn = MessageBox:getOKBtn();
        pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return RandomShopPanel

