local RankListPanel = class("RankListPanel", require('app.layer.BaseLayer'));
local fonts = Enum:getTable("SystemFont");
local imgPath = 'image/chouka/main/';
local RANK_ENUM = Enum:getTable('RANK_ENUM');

function RankListPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'RankListPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.loadWait = true;
	self.showFooter = true;

end

function RankListPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.curIdx = -1;  --当前排行榜类型

	self:initPanels();

	EventManager:RegisterEvent(EventType.UIRankListView, handler(self, self.onUpdateData));
	
end

function RankListPanel:initPanels(  )
	local mainbg = ccui.ImageView:create('image/bg/Bg_12.png')
	:addTo(self.root)
	-- :setScale9Enabled(true)
	-- :setContentSize(cc.size(604, 630))
	:setTouchEnabled(true);

	local topNode = cc.Node:create()
	:addTo(self.root)
	:setPosition(0,StageSize.height/2 - 250)

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(topNode)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 350))
	-- :setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, LANG.UI_L_RANK_1, '',  bg:getContentSize().width/2, bg:getContentSize().height -36 );

	self.rankBtns = {}
	local key = {RANK_ENUM.ENUM_1 , RANK_ENUM.ENUM_2,  RANK_ENUM.ENUM_3,  RANK_ENUM.ENUM_4}

	for _k , tag in ipairs(key) do
		local node = cc.Node:create()
		:addTo(topNode)
		:setPosition((_k-2)*200, -20)

		local selSpr = cc.Scale9Sprite:create('image/commonImg/select_1_20_20_93_117.png');
		selSpr:setContentSize(cc.size(200 , 286));
		selSpr:setVisible(false)
		selSpr:setPosition(0,-6)
	    selSpr:addTo(node);

	    local cellBg = ccui.Button:create('image/rank/rank_item_bg_'..tag..'.png');
		cellBg:addTo(node);
		cellBg:setTag(tag);
		cellBg:addClickEventListener(handler(self, self.onSelRankItem));

	    local headBg = cc.Sprite:create('image/rank/rank_head.png');
	    headBg:addTo(node);
	    headBg:setPosition(0, 25);

	    local headBg2 = cc.Sprite:create('image/rank/head_bg.png');
	    headBg2:addTo(node);
	    headBg2:setPosition(0, 25);

	    local headIcon = cc.Sprite:create();
	    headIcon:addTo(node);
	    headIcon:setPosition(0, 25);
	    headIcon:setScale(0.7);

	    local rankTitle = model.RankModel:getRankNameByType(tag)
	    local rankName = cc.Label:createWithTTF(rankTitle ,  fonts.FONT_SIYUAN , 17);
	    rankName:addTo(node);
	    rankName:enableOutline(cc.c4b(0 , 0 , 0 , 255),1);
	    rankName:setPosition(0 , 100);

	    local userName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 16);
	    userName:addTo(node);
	    userName:enableOutline(cc.c4b(0 , 0 , 0 , 255),1);
	    userName:setPosition(0 , -62);

	    local rankVal = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 15);
	    rankVal:addTo(node);
	    rankVal:enableOutline(cc.c4b(0 , 0 , 0 , 255),1);
	    rankVal:setPosition(0 , -105);

	    if _k == RANK_ENUM.ENUM_2 then
	    	local valIcon = cc.Sprite:create('image/arena/rankList/arena_rank_list_3.png');
		    valIcon:addTo(node);
		    valIcon:setPosition(-60,-105);
	    end

	    self.rankBtns[tag] = {node=node, selSpr=selSpr, headBg=headBg, headIcon=headIcon, userName=userName, rankVal=rankVal, btn=cellBg}

	end

	local topNodeX, topNodeY = topNode:getPosition()
	local bottomNodeY = topNodeY- bg:getContentSize().height/2 -25;

	local bottomNode = cc.Node:create()
	:addTo(self.root)
	:setAnchorPoint(cc.p(0.5, 1))
	:setPosition(0, bottomNodeY)

	local bottomHeight = StageSize.height/2+bottomNodeY-100;
	local bg1 = ccui.Scale9Sprite:create("image/commonImg/common_tips_bg.png");
	bg1:setContentSize(cc.size(604 , bottomHeight ));
	bg1:setPosition(cc.p(0 , 0));
	bg1:setAnchorPoint(cc.p(0.5, 1))
	bg1:addTo(bottomNode);

	self.rankName = cc.Label:createWithTTF(LANG.UI_L_RANK_2 ,  fonts.FONT_SIYUAN , 20);
    self.rankName:addTo(bottomNode);
    self.rankName:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.rankName:setPosition(0 , -40);

	self.selfCell = template.RankItem:create(bottomNode);
	self.selfCell:setPosition(-280, -140)

	local btmBg = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	btmBg:setContentSize(cc.size(580 , bottomHeight-150));
	btmBg:setAnchorPoint(cc.p(0.5,1))
	btmBg:addTo(bottomNode);
	btmBg:setPosition(0, -150)

	self.comNode = cc.Node:create()
	:addTo(bottomNode)
	:setPosition(0, -200);

	local comNodeBg = ccui.Scale9Sprite:create("image/commonImg/btn_2_103_36.png");
	comNodeBg:setContentSize(cc.size(560 , 60));
	comNodeBg:addTo(self.comNode);

	self.comName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20);
    self.comName:addTo(self.comNode);

	self.wbtnLabel = cc.Label:createWithTTF(LANG.UI_L_RANK_5 , fonts.FONT_SIYUAN , 20);
	self.wbtnLabel:enableOutline(cc.c4b(30 , 60 , 110 , 255) , 2);
	self.weekBtn = ccui.Button:create('image/commonImg/btn_4_103_36.png' , 'image/commonImg/btn_4_103_36.png');
	self.weekBtn:loadTextureDisabled( 'image/commonImg/btn_2_103_36.png' )
	self.weekBtn:addTo(bottomNode);
	self.weekBtn:setPosition(-140 , -200);
	self.weekBtn:setContentSize(cc.size(280, 60))
	self.weekBtn:setScale9Enabled(true)
	self.weekBtn:setEnabled(false);
	self.weekBtn:setTitleLabel(self.wbtnLabel);
	self.weekBtn:addClickEventListener(handler(self, self.onClickWeedRank));

	self.mbtnLabel = cc.Label:createWithTTF(LANG.UI_L_RANK_7 , fonts.FONT_SIYUAN , 20);
	self.mbtnLabel:enableOutline(cc.c4b(30 , 60 , 110 , 255) , 2);
	self.monthBtn = ccui.Button:create('image/commonImg/btn_4_103_36.png' , 'image/commonImg/btn_4_103_36.png');
	self.monthBtn:loadTextureDisabled( 'image/commonImg/btn_2_103_36.png' )
	self.monthBtn:addTo(bottomNode);
	self.monthBtn:setPosition(140 , -200);
	self.monthBtn:setContentSize(cc.size(280, 60))
	self.monthBtn:setScale9Enabled(true)
	self.monthBtn:setEnabled(true);
	self.monthBtn:setTitleLabel(self.mbtnLabel);
	self.monthBtn:addClickEventListener(handler(self, self.onClickMonthRank));


	local initData = {
		width = 560,
		height = bottomHeight - 260,
		cellWidth = 560,
		cellHeight = 80,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadCell),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

	}
	self.selListView = template.TableViewTemplate:create()
	self.selListView:initWithSizeAndItem(initData);
	self.selListView:getView():setPosition(-280, -bottomHeight+10);
	self.selListView:getView():addTo(bottomNode)
	self.selListView:getView():setVisible(true)

	self.initNo1List = false

end

function RankListPanel:onEnter(enterIndex)
	self.curIdx = -1;
	-- local tmpIdx = enterIndex or RANK_ENUM.ENUM_1;
	local tmpIdx = self:updateTitleNode();
	tmpIdx = enterIndex or tmpIdx;
	
	self.root:setVisible(true)

	if self.initNo1List==false then
		self.initNo1List = true
		self:initNo1Node();
	end

	self:changeSelect(tmpIdx);

end

function RankListPanel:updateTitleNode()
	-- body
	for k,v in pairs(self.rankBtns) do
		v.node:setVisible(false)
	end
	-- local key = {RANK_ENUM.ENUM_1, RANK_ENUM.ENUM_2,  RANK_ENUM.ENUM_4}
	local key = {RANK_ENUM.ENUM_2, RANK_ENUM.ENUM_4}
	if #key == 2 then
		for _k , tag in ipairs(key) do
			self.rankBtns[tag].node:setPosition(-150+(_k-1)*300, -20)
			self.rankBtns[tag].node:setVisible(true)
		end
	elseif #key >= 3 then
		for _k , tag in ipairs(key) do
			self.rankBtns[tag].node:setPosition((_k-2)*200, -20)
			self.rankBtns[tag].node:setVisible(true)
		end
	elseif #key == 1 then
		for _k , tag in ipairs(key) do
			self.rankBtns[tag].node:setPosition(0, -20)
			self.rankBtns[tag].node:setVisible(true)
		end
	end
	return key[1]
end

function RankListPanel:initNo1Node()
	for k,v in pairs(self.rankBtns) do
		local item = model.RankModel:getNo1RankByType(k)
		if item then
			v.userName:setString(item.name)
			v.rankVal:setString(item.value)

			if k == RANK_ENUM.ENUM_4 then
				v.headIcon:setTexture('image/guild/guild_icon/icon_'..item.role..'.png');
				v.headIcon:setVisible(true)
			else
				local headIconFile = GlobalFunctions:getHeadIconFile(item.role)
				v.headIcon:setTexture(headIconFile);
				v.headIcon:setVisible(true)
			end
		
			GlobalFunctions:removeSpriteGrey(v.headBg)

			if k == RANK_ENUM.ENUM_1 then
		        local tmpVal = ResTable:getValue('round', item.value , 'name');
		        v.rankVal:setString(string.format(LANG.UI_ROUND_23, tostring(tmpVal)));
		        if tmpVal == '9999' then
		            v.rankVal:setString(LANG.UI_L_PASS)
		        end

		    elseif k == RANK_ENUM.ENUM_2 then
		        v.rankVal:setString(item.value)

		    elseif k == RANK_ENUM.ENUM_3 then
		        local tmpVal = ResTable:getValue('trial_round', item.value , 'no');
		        v.rankVal:setString(string.format(LANG.UI_MAZE_4, tostring(tmpVal)));

		    elseif k == RANK_ENUM.ENUM_4 then
		        v.rankVal:setString( tostring(ConvertStrToDigitUnit(item.value)) );
		    end

		else
			GlobalFunctions:setSpriteGrey(v.headBg)
			v.headIcon:setVisible(false)
			v.userName:setString('')
			v.rankVal:setString('')
		end

	end
end

function RankListPanel:onIsRequsetData()
	local list = model.RankModel:getRankListByType( self.curIdx )
	if list == nil or #list==0 then
		model.RankModel:reqRankListByType( self.curIdx )
		return true
	else
		if model.RankModel:canRequestRankListByType( self.curIdx ) then --需要更新了
			model.RankModel:reqRankListByType( self.curIdx )
			return true
		end
	end
	return false
end

function RankListPanel:onUpdateData()
	local list = model.RankModel:getRankListByType( self.curIdx )

	local item = model.RankModel:getNo1RankByType(self.curIdx)
	if item then
		if self.curIdx == RANK_ENUM.ENUM_1 or self.curIdx == RANK_ENUM.ENUM_2 
			or self.curIdx == RANK_ENUM.ENUM_3 or self.curIdx == RANK_ENUM.ENUM_4 then
			self.rankBtns[self.curIdx].userName:setString(item.name)
			self.rankBtns[self.curIdx].rankVal:setString(item.value)

			if self.curIdx == RANK_ENUM.ENUM_4 then
				self.rankBtns[self.curIdx].headIcon:setTexture('image/guild/guild_icon/icon_'..item.role..'.png');
				self.rankBtns[self.curIdx].headIcon:setVisible(true)
			else
				local roleData = ResTable:getRowData('role' , item.role);
				if roleData then
					local imagePath = ResTable:getValue('role_resource', roleData.resource_id , 'icon');
				    if imagePath then
				    	self.rankBtns[self.curIdx].headIcon:setTexture('image/icon/'..imagePath..'.png');
				    	self.rankBtns[self.curIdx].headIcon:setVisible(true)
			        end
				end
			end
			
			GlobalFunctions:removeSpriteGrey(self.rankBtns[self.curIdx].headBg)
		end

		if self.curIdx == RANK_ENUM.ENUM_1 then
	        local tmpVal = ResTable:getValue('round', item.value , 'name');
	        self.rankBtns[self.curIdx].rankVal:setString(string.format(LANG.UI_ROUND_23, tostring(tmpVal)));
	        if tmpVal == '9999' then
	            self.rankBtns[self.curIdx].rankVal:setString(LANG.UI_L_PASS)
	        end

	    elseif self.curIdx == RANK_ENUM.ENUM_2 then
	        self.rankBtns[self.curIdx].rankVal:setString(item.value)

	    elseif self.curIdx == RANK_ENUM.ENUM_3 then
	        local tmpVal = ResTable:getValue('trial_round', item.value , 'no');
	        self.rankBtns[self.curIdx].rankVal:setString(string.format(LANG.UI_MAZE_4, tostring(tmpVal)));

	    elseif self.curIdx == RANK_ENUM.ENUM_4 then
	        local tmpVal = item.value;
	        self.rankBtns[self.curIdx].rankVal:setString( tostring(ConvertStrToDigitUnit(tmpVal)) );
	    end
	end

	local selfData = model.RankModel:getSelfRankByType(self.curIdx)
	if selfData and next(selfData) then
		self.selfCell:initData(selfData, self.curIdx);
	else
		local tempName = model.UserModel:getUserName();
		local tempRole = model.UserModel:getHeadIcon();
		if self.curIdx == RANK_ENUM.ENUM_4 then
	        tempName = model.GuildModel:getGuildName() or LANG.UI_GUILD_127;
	        tempRole = model.GuildModel:getGuildIcon() or 1;
	    end
		self.selfCell:initData( {rank=-1, name=tempName, role=tempRole, value=0} );
	end

	self.dataList = list;

	self.selListView:reloadData(self.dataList);

	if self.curIdx ~= RANK_ENUM.ENUM_201 then
		self.rankName:setString( model.RankModel:getRankNameByType(self.curIdx) )
	end

	if self.curIdx==RANK_ENUM.ENUM_1 then
		self.comName:setString(LANG.UI_L_RANK_8)
	elseif self.curIdx==RANK_ENUM.ENUM_2 then
		self.comName:setString(LANG.UI_L_RANK_5)
	elseif self.curIdx==RANK_ENUM.ENUM_3 then
		self.comName:setString(LANG.UI_L_RANK_9)
	elseif self.curIdx==RANK_ENUM.ENUM_201 then
		if model.RankModel:IsLastMonthRank() then
			self.mbtnLabel:setString(LANG.UI_L_RANK_7)
		else
			self.mbtnLabel:setString(LANG.UI_L_RANK_7)
		end
	end

end

function RankListPanel:onClickBack()
	UIManager:pop('RankListPanel');
end

function RankListPanel:onLeave()
	self.root:setVisible(false);
end

function RankListPanel:onSelRankItem(sender , event)
	local index = sender:getTag();
	local item = model.RankModel:getNo1RankByType(index)
	if not item then
		return;
	end
	self:changeSelect(index);
end

function RankListPanel:changeSelect( index )
	if self.curIdx == index then
		return
	end

	for k,v in pairs(self.rankBtns) do
		if k == index then
			v.selSpr:setVisible(true)
		else
			v.selSpr:setVisible(false)
		end
	end

	if index == RANK_ENUM.ENUM_4 then -- index == RANK_ENUM.ENUM_2 or 
		self.weekBtn:setVisible(true)
		self.monthBtn:setVisible(true)
		if index == RANK_ENUM.ENUM_2 then
			self.wbtnLabel:setString(LANG.UI_L_RANK_5)
			if model.RankModel:IsLastMonthRank() then
				self.mbtnLabel:setString(LANG.UI_L_RANK_7)
			else
				self.mbtnLabel:setString(LANG.UI_L_RANK_7)
			end
		else
			self.wbtnLabel:setString(LANG.UI_GUILD_RAID_RANK_MENU[1])
			self.mbtnLabel:setString(LANG.UI_GUILD_RAID_RANK_MENU[2])
		end

		self.comNode:setVisible(false)
		self:onWeedRank(index);
	else
		self.curIdx = index;

		self.weekBtn:setVisible(false)
		self.monthBtn:setVisible(false)

		self.comNode:setVisible(true)

		if self:onIsRequsetData() == false then
			self:onUpdateData()
		end
	end
end

function RankListPanel:onClickWeedRank() --按钮点击
	if self.curIdx == RANK_ENUM.ENUM_2 or self.curIdx == RANK_ENUM.ENUM_4 then
		return
	end
	self:onWeedRank();
end

function RankListPanel:onClickMonthRank() --按钮点击
	if self.curIdx == RANK_ENUM.ENUM_201 or self.curIdx == RANK_ENUM.ENUM_401 then
		return
	end
	self:onMonthRank()
end

function RankListPanel:onWeedRank( key )
	if key == nil then
		if self.curIdx == RANK_ENUM.ENUM_201 then
			self.curIdx = RANK_ENUM.ENUM_2;
		elseif self.curIdx == RANK_ENUM.ENUM_401 then
			self.curIdx = RANK_ENUM.ENUM_4;
		end
	else 
		self.curIdx = key
	end

	self:refreshWeekAndMonthBtns(1)
	if self:onIsRequsetData() == false then
		self:onUpdateData()
	end
end

function RankListPanel:onMonthRank()
	if self.curIdx == RANK_ENUM.ENUM_2 then
		self.curIdx = RANK_ENUM.ENUM_201;
	elseif self.curIdx == RANK_ENUM.ENUM_4 then
		if not model.GuildModel:isJoinGuild() then
			return;
		end
		self.curIdx = RANK_ENUM.ENUM_401;
	end
	
	self:refreshWeekAndMonthBtns(2)
	if self:onIsRequsetData() == false then
		self:onUpdateData()
	end
end

function RankListPanel:refreshWeekAndMonthBtns( st )
	if st == 1 then
		self.weekBtn:setEnabled(false);
		self.wbtnLabel:setOpacity(255)

		self.monthBtn:setEnabled(true);
		self.mbtnLabel:setOpacity(120)
	else
		self.weekBtn:setEnabled(true);
		self.wbtnLabel:setOpacity(120)

		self.monthBtn:setEnabled(false);
		self.mbtnLabel:setOpacity(255)
	end
end

function RankListPanel:reloadCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.RankItem:create(cell);
		cellNode:setTag(999);
    end

    if self.dataList[index+1] then
    	cellNode:initData( self.dataList[index+1], self.curIdx );
    end
end

function RankListPanel:cellItemTouch(table,cell)
	-- local cellNode  = cell:getChildByTag(999);
	-- if cellNode then
 --    end
end

return RankListPanel;
