local RechargeTaskPanel = class('RechargeTaskPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/activity/three_day/'

function RechargeTaskPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'RechargeTaskPanel');

	self.useCCreator = false;
    self.isPopup = true;

end

function RechargeTaskPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel();
end


function RechargeTaskPanel:initPanel(  )
    local bg = ccui.ImageView:create(imagePath..'re_task_bg.png')
    :addTo(self.root)
    :setTouchEnabled(true);

    local bg = cc.Sprite:create(imagePath..'re_task_bg2.png')
    bg:addTo(self.root)
    bg:setPosition(15, 180)

    -- GlobalFunctions:createTitleNode( bg, LANG.UI_EVENT_2, '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );

    -- local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
    -- bg:addTo(self.root);
    -- bg:setCapInsets(cc.rect(11,11,34,28));
    -- bg:setContentSize(cc.size(582 , 680));
    -- bg:setPosition(0, 10)

    local initData = {
        width = 400,
        height = 530,
        cellWidth = 400,
        cellHeight = 150,
        cellReloadFunc = handler(self,self.reloadCell),
        cellTouchFunc = handler(self,self.cellItemTouch) ,
    }
    
    self.tableView = template.TableViewTemplate:create()
    self.tableView:initWithSizeAndItem(initData) ;
    self.tableView:getView():setPosition(cc.p(-137,-415));
    self.tableView:getView():addTo(self.root)

    self.priceLabel = cc.Label:createWithTTF('1000' , fonts.FONT_SIYUAN , 18);
	self.priceLabel:setPosition(185 , 145);
	self.priceLabel:setAnchorPoint(0.5 , 0.5);
	self.priceLabel:enableOutline(cc.c3b(0 , 0 , 0) , 1);
	self.priceLabel:addTo(self.root);

	self.timeLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 15)
        -- :setTextColor(cc.c3b(255,255,0))
        :addTo(self.root)
        :setPosition(185 , 145+150)
        :enableOutline(cc.c3b(0,0,0), 1)

end

function RechargeTaskPanel:onEnter(tp)
    self.tp = tp or self.tp;
    self:addSwallowCallback(handler(self , self.onClickBack));
    self:onShow();
    self.root:setVisible(true);
end

function RechargeTaskPanel:onShow()
	self.data = model.RechargeModel:getRechargeTaskData(self.tp)
	print_ro(self.data, 'fubin--taskPanel')
	if not self.data then
		return;
	end

	self.priceLabel:setString(self.data.price)
	local startTime = self.data.open_time
    local endTime = self.data.close_time
    if startTime ~= 0 then
        local startTable = os.date('*t', startTime)
        local endTable = os.date('*t', endTime)
        local msg = string.format( LANG.UI_EVENT_29,startTable.month,startTable.day ).."~"..string.format( LANG.UI_EVENT_29,endTable.month,endTable.day )
        self.timeLabel:setString(msg);
    else
        self.timeLabel:setString('');
    end

 --    self.dataList = {}
 --    local tmpData = model.RoundModel:getRoundMissionById( self.season_id );
 --    if not tmpData then
 --    	return;
 --    end

	-- self.dataList = tmpData.round_bank_missions;
	-- table.sort( self.dataList, function(first , second)
	-- 	return first.no < second.no;
	-- end )
	self.tableView:reloadData(self.data.list);

end

function RechargeTaskPanel:reloadCell(cell , idx)
    if self.data.list[idx + 1] then
        local child = cell:getChildByTag(999);
        if not child then
            child = template.RechargeTaskCell:create();
            child:addTo(cell);
            child:setPosition(200 , 75);
            child:addBtnClickEventListener(handler(self , self.rewardClick))
            child:setTag(999);
        end
        local task = self.data.list[idx + 1];
        child:Init(task.id, 'recharge_task', task);
        child:setBtnTag(task.id);
    end
    
    return cell;
end

function RechargeTaskPanel:rewardClick(no, idxBtn)
    local msg = {};
    msg.operate_id = self.data.operate_id;
    msg.id = no;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_task_rwd, msg);
end

function RechargeTaskPanel:cellItemTouch( table,cell )
	-- local tag = cell:getTag()
end

function RechargeTaskPanel:onLeave()
    self.root:setVisible(false);
end
function RechargeTaskPanel:onClickBack()
    UIManager:pop('RechargeTaskPanel');
end

return RechargeTaskPanel
