local ReconnectionPanel = class("ReconnectionPanel")
local fonts = Enum:getTable("SystemFont")
function ReconnectionPanel:ctor()
	self:clearAll();
end
function ReconnectionPanel:clearAll(  )
	self.root = nil;
	self.scene = nil;
end
--初始化面板
function ReconnectionPanel:Init(root, scene)
	self.root = root;
	self.scene = scene;
	self:initPanel();
	self.root:setVisible(false);
end
function ReconnectionPanel:initPanel()
	local bg = ccui.Layout:create();
	bg:setTouchEnabled(true);
	bg:setContentSize(StageSize);
	bg:setLocalZOrder(-10);
	bg:setAnchorPoint(cc.p(0.5,0.5));
	bg:setPosition(0, 0);
	bg:addTo(self.root);
	
	local blackBg = cc.LayerColor:create(cc.c4b(0, 0, 0, 210), StageSize.width, StageSize.height);
    blackBg:setLocalZOrder(-100);
	blackBg:setPosition(-StageSize.width/2, -StageSize.height/2);
    blackBg:addTo(self.root);

	local rotateBg = cc.Sprite:create('image/loading/reconnection_bg_1.png')
		:addTo(self.root)
		:setPosition(0,65)

	self.rotateImg = cc.Sprite:create('image/loading/reconnection_bg_2.png')
		:addTo(self.root)
		:setPosition(0,65)

	local reconnectionLabel = cc.Label:createWithTTF(LANG.UI_NETWORK_1,fonts.FONT_SIYUAN,20)
		:addTo(self.root)
		:setPosition(0,-43)

	self.countDown = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
		:addTo(self.root)
		:setPosition(0,65)
		:setTextColor(cc.c3b(60,220,255))

	self.lastReconnectionTimes = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
		:addTo(self.root)
		:setPosition(0,-72)
end

function ReconnectionPanel:Show(reqcode,reqTimes,reqTime)
	if self.curRecode then
		if self.curRecode == reqcode then
			self.curCountDown = 6;
			self.lastReconnectionTimes:setString(string.format(LANG.UI_NETWORK_2,reqTimes,5));
		end
		return;
	end
	self.curRecode = reqcode;
	self.curCountDown = 6;
	self.lastReconnectionTimes:setString(string.format(LANG.UI_NETWORK_2,reqTimes,5));

	self.rotateImg:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(function()
		local curRotation = self.rotateImg:getRotation();
		curRotation = curRotation+36;
		curRotation = curRotation > 360 and (curRotation-360) or curRotation;
		self.rotateImg:setRotation(curRotation);
	end))));
	
	self.root:setVisible(true);
end

function ReconnectionPanel:updateReconnectionTime(reqcode)
	if self.curRecode and self.curRecode == reqcode then
		self.curCountDown = self.curCountDown-1;
		self.curCountDown = self.curCountDown <= 0 and 0 or self.curCountDown
		self.countDown:setString(self.curCountDown);
	end
end

function ReconnectionPanel:Hide(reqcode)
	if self.curRecode and self.curRecode == reqcode then
		self.curRecode = nil;
		if self.root:isVisible() == false then
			return
		end

		self.root:setVisible(false);
		self.rotateImg:stopAllActions();
	end
end	
return ReconnectionPanel;
