local RoleShowPanel = class("RoleShowPanel" , require('app.layer.BaseLayer'))
local imgPath = 'image/chouka/result/';
local fonts = Enum:getTable('SystemFont');

local RestrainType = Enum:getTable("FightRestraintType")
local cvTypeEnum = Enum:getTable("cvTypeEnum");

local def_type_name = 
{
	[RestrainType.RED_BASE] = 'red',
	[RestrainType.GREEN_BASE] = 'green',
	[RestrainType.BLUE_BASE] = 'blue',
}
 local STEP = {
	SHOW_ROLE = 1,
	SHOW_ROLE_END = 2,
	SHOW_RESUTL = 3,
	SHOW_RESULT_END = 4,
	SHOW_ACIEVEMENT = 5,
	SHOW_ACIEVEMENT_ING = 6,
	SHOW_ACIEVEMENT_END = 7,

	
	SHOW_END = 0,
	SHOW_NULL = -1,

	TEST = 100,

}


function RoleShowPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'RoleShowPanel');
	self.step = STEP.SHOW_NULL;
	self.useCCreator = false;
	self.isPopup = true;
end

function RoleShowPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function RoleShowPanel:initPanels()

	local touchEvent = 	function ( sender,eventType )
		if eventType == ccui.TouchEventType.ended then
			self:stepEventCall();
		end
	end

	local bg1 = ccui.ImageView:create(imgPath .. 'bg1.png');
	bg1:addTo(self.root);
	bg1:addTouchEventListener(touchEvent)
	bg1:setTouchEnabled(true);

	do
		self.resultRoleNode = cc.Node:create();
		self.resultRoleNode:addTo(self.root) 
		
		self.quSpBg = cc.Sprite:create(imgPath .. 'qu_sp2.png');
		self.quSpBg:setPosition(0, 0);
		self.quSpBg:addTo(self.resultRoleNode);
		self.quSpBg:setVisible(false);

		local rotation = {-123,-67,29,85};
		local linePos = {
			cc.p(0,-308),
			cc.p(0,-398),
			cc.p(-268,400),
			cc.p(0,470),

		}
		self.lineAni = {}
		for i=1,4 do
			self.lineAni[i] = cc.Sprite:create();
			self.lineAni[i]:addTo(self.resultRoleNode);
			self.lineAni[i]:setPosition(linePos[i]);
			self.lineAni[i]:setRotation(rotation[i]);
			self.lineAni[i]:setVisible(false);
		end

		local quNode = cc.Node:create();
		quNode:setPosition(106, 408);
		quNode:addTo(self.resultRoleNode);

		self.qu_bg = {}
		for i=1,3 do
			self.qu_bg[i] = cc.Sprite:create(imgPath .. 'sp_qua'..(i+1).. '.png');
			self.qu_bg[i]:addTo(quNode);
			self.qu_bg[i]:setVisible(false);
		end

		self.quality = cc.Sprite:create('image/card/card_quality_3.png');
		self.quality:addTo(quNode);
		self.quality:setVisible(false);

		self.starbg = cc.Sprite:create(imgPath..'starBg1.png');
		self.starbg:addTo(quNode);
		self.starbg:setPosition(cc.p(-68,-47))
		self.starbg:setVisible(false);

		self.star = cc.Node:create();
		self.star:addTo(quNode);
		self.star:setPosition(cc.p(-86,-42))

		local colorNode = cc.Node:create();
		colorNode:setPosition(219, 370);
		colorNode:addTo(self.resultRoleNode);

		self.qu_color = {};
		for i=1, 5 do
			self.qu_color[i] = cc.Sprite:create(imgPath .. 'color_red'..i..'.png');
			self.qu_color[i]:addTo(colorNode);
			self.qu_color[i]:setVisible(false);
		end

		self.qu_color[6] = cc.Sprite:create();
		self.qu_color[6]:addTo(colorNode);
		self.qu_color[6]:setVisible(false);

		self.role = cc.Sprite:create();
		self.role:setScale(0.7);
		self.role:addTo(self.resultRoleNode);
		self.role:setVisible(false);

		self.name_bg = cc.Sprite:create(imgPath .. 'name_bg.png')
		self.name_bg:setPosition(0, -StageSize.height/2+80);
		self.name_bg:addTo(self.resultRoleNode);
		self.name_bg:setVisible(false);

		self.labelName = cc.Label:createWithTTF('name', fonts.FONT_HUAKANG, 28);
		self.labelName:setTextColor(cc.c3b(255, 255, 255));
		self.labelName:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
		self.labelName:setPosition(-20, -StageSize.height/2+90);
		self.labelName:setSkewY(6);
		self.labelName:addTo(self.resultRoleNode);
		self.labelName:setVisible(false);

		self.wordBg = cc.Sprite:create(imgPath .. 'word1.png');
		self.wordBg:setPosition(0, -StageSize.height/2+175);
		self.wordBg:addTo(self.resultRoleNode);
		self.wordBg:setVisible(false);

		self.wordLabel = cc.Label:createWithTTF('', fonts.FONT_CV, 24)
			:setPosition(0, -StageSize.height/2+160)
			:setTextColor(cc.c4b(56, 56, 56))
			:setDimensions(500, 80)
			:setRotation(-7)
			:addTo(self.resultRoleNode)
			:setVisible(false)
			:setVerticalAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER)

		self.role_new_mark = cc.Sprite:create(imgPath .. 'new_mark.png');
		self.role_new_mark:setPosition(-163, -362);
		self.role_new_mark:addTo(self.resultRoleNode);
		self.role_new_mark:setVisible(false);
	end

	do
		self.resultShowNode = cc.Node:create();
		self.resultShowNode:addTo(self.root) --(self.panel['result']);
	
		self.result_bg = cc.Sprite:create(imgPath .. 'bg4.png');
		-- self.result_bg:setPosition(0, 0);
		self.result_bg:addTo(self.resultShowNode);
		self.result_bg:setVisible(false);

		self.resultItemList = {};
		for i=1, 10 do
			local x,y = 0,0;
			if i <= 5 then
				x = -254 + (i-1)*127;
				y = 160;
			else
				x = -254 + (i-6)*127;
				y = -180;
			end
			self.resultItemList[i] = template.CardTemplate:create(self.resultShowNode);
			self.resultItemList[i]:setPosition(x, y);
			self.resultItemList[i]:setVisible(false);
		end
	end 

	--
	self.btnSkip = ccui.Button:create(imgPath .. 'btnSkip.png');
	self.btnSkip:setPosition(StageSize.width/2-65, StageSize.height/2-65);
	self.btnSkip:setZoomScale(0);
	self.btnSkip:addClickEventListener(handler(self, self.skip));
	self.btnSkip:addTo(self.root)

	self.btnBack = ccui.Button:create(imgPath .. 'btnBack.png');
	self.btnBack:setPosition(-StageSize.width/2+39, -StageSize.height/2+36);
	self.btnBack:setZoomScale(0);
	self.btnBack:addClickEventListener(handler(self, self.backToInfo));
	self.btnBack:addTo(self.root) 
	
	self.count = 1
end

function RoleShowPanel:showGachaInfo()

	self.curShowNum = 1;
	
	self.btnBack:setVisible(false);
	self.btnSkip:setVisible(false);
	self.resultShowNode:setVisible(false);
	if self.count == 1 then
		self.btnBack:setVisible(true);
	else
		self.btnSkip:setVisible(true);
	end

	self.step = STEP.SHOW_ROLE,
	self:showNextGacha();
end

function RoleShowPanel:skip()
	self.root:stopAllActions();

	self.step = STEP.SHOW_ROLE_END
	self:showResult()
end

function RoleShowPanel:showNextGacha()
	local num = self.curShowNum;
	-- print('showNextGacha============curShowNum == '..tostring(num));

	if self.gachaResultInfo[num] then
		self.resultRoleNode:setVisible(true);
		self:showRole(self.gachaResultInfo[num]);

		self.curShowNum = self.curShowNum + 1;
	else
		self:showResult()
	end
end

function RoleShowPanel:showResult(  )
	self.btnSkip:setVisible(false);
	-- self.endFlag = true;
	if self.count == 1 then
		-- do nothing
		self.step = STEP.SHOW_RESULT_END
	else
		self.step = STEP.SHOW_RESUTL
		self.resultRoleNode:setVisible(false);

		self.resultShowNode:setVisible(true);
		self.resultShowNode:setPosition(cc.p(0,0))
		self.btnBack:setVisible(true);
		self:showResultAction();
	end

end

function RoleShowPanel:setGachaResult(result)

	self.gachaResultInfo = {};
	local preloadCVList = {};
	local count = 0;
	for i=1, #result do
		local info = {};
		local gachaItem = result[i];
		if gachaItem then
			info.no = gachaItem.no;
			table.insert(preloadCVList, info.no)
			if count < 10 then
				-- 目前只能显示10条
				self.resultItemList[i]:InitByNo(info.no)
			end
			count = count + 1;
			self.gachaResultInfo[i] = info;
		end
	end
	self.count = count;
	for _, v in pairs(preloadCVList) do
		AudioManager:loadCV(v, cvTypeEnum.CV_GACHA);
	end
end

function RoleShowPanel:showRole(info)

	local no = info.no;
	local role_data = ResTable:getRowData('role', no);
	local role_re = ResTable:getRowData('role_resource', role_data.role_id);
	local role_pre = ResTable:getRowData('role_pre' , role_data.role_id);
	local role_info = ResTable:getRowData('role_info' , role_data.role_id);

	-- dump(role_data);

	self.role:setTexture('image/role/'..role_re['card']..'.png');

	self.labelName:setString(tostring(role_info['name']));

	local qu = role_data['quality'];
	self.quality:setTexture('image/card/card_quality_'..qu..'.png');

	self.quSpBg:setTexture(imgPath..'qu_sp'..qu..'.png');

	for i=1, 5 do
		self.qu_color[i]:setTexture(imgPath .. 'color_' .. def_type_name[role_pre['def_type']] .. i .. '.png');
	end
	self.qu_color[6]:setTexture('image/commonImg/def_type_' .. role_pre['def_type'] .. '.png');

	local cvInfo = model.UserModel:getRoleCvInfo(role_data.resource_id,cvTypeEnum.CV_GACHA);
	self.wordLabel:setString(tostring(cvInfo));

	AudioManager:playCVStopBefor(role_data.role_id,nil ,cvTypeEnum.CV_GACHA );

	if not info.num then
		local cardNoList = model.CardModel:getCardByNo(no);
		local num = cardNoList.num or 0
		self.role_new_mark:setVisible(num == 1);
	else
		self.role_new_mark:setVisible(false);
	end

	local starLv = role_pre['rank'];
	self.star:removeAllChildren()
	local color = math.ceil(starLv / 5);
	local num = starLv % 5;
	num = num == 0 and 5 or num;
	for i=1,5 do
		if i <= num then
			local sp = cc.Sprite:create('image/card/star_level_'..color..'.png')
			sp:addTo(self.star);
			sp:setPosition(cc.p(34*(i-1),0));
			sp:setOpacity(0);
		end
	end

	self.resultRoleNode:setVisible(fale);

	self.root:runAction(cc.Sequence:create(cc.DelayTime:create(0.1),cc.CallFunc:create(function (  )
		self:showRoleAction(true);
	end)))

end

function RoleShowPanel:showRoleAction( showVisible )
	self.resultRoleNode:setVisible(true);

	local showIn = showVisible or false 

	if showIn then
		local animation = FrameEffectManager:createFrameAnimation('tiao_wen', 30, 60)
		for i=1,4 do
			self.lineAni[i]:setVisible(true);
			self.lineAni[i]:setOpacity(255);
			self.lineAni[i]:runAction(cc.Animate:create(animation)); 
		end
	else
		for i=1,4 do
			local actOut = cc.FadeOut:create(4/60);
			self.lineAni[i]:runAction(actOut);
		end
	end

	if showIn then
		local quSpAct1 = cc.FadeIn:create(4/60);
		self.quSpBg:setVisible(true);
		self.quSpBg:runAction(quSpAct1);
	else
		local actOut = cc.FadeOut:create(4/60);
		self.quSpBg:runAction(actOut);
	end

	local rolePos = {
		cc.p(-725 - 320,568 - 568),
		cc.p(328 - 320,568 - 568),
		cc.p(320 - 320,568 - 568)
	}

	if showIn then
		local roleAct1 = cc.DelayTime:create(25/60)
		local roleAct2 = cc.MoveTo:create(12/60,rolePos[2])	
		local roleAct3 = cc.MoveTo:create(6/60,rolePos[3])	
		local roleAct = cc.Sequence:create(roleAct1,roleAct2,roleAct3)
		self.role:setVisible(true);
		self.role:setPosition(rolePos[1])
		self.role:runAction(roleAct);
	else
		local actOut = cc.MoveTo:create(4/60,rolePos[1]);
		self.role:runAction(actOut);
	end


	local nameBgPos = {
		cc.p(823 - 320,568 - 1041 ),
		cc.p(351 - 320,568 - 1065),
		cc.p(374 - 320,568 - 1063 ),
	}
	if showIn then
		local nameBgAct1 = cc.DelayTime:create(42/60);
		local nameBgAct2 = cc.MoveTo:create(5/60,nameBgPos[2])	
		local nameBgAct3 = cc.MoveTo:create(2/60,nameBgPos[3])	
		local nameBgAct = cc.Sequence:create(nameBgAct1,nameBgAct2,nameBgAct3)	
		self.name_bg:setVisible(true);
		self.name_bg:setPosition(nameBgPos[1]);
		self.name_bg:runAction(nameBgAct)
	else
		local actOut = cc.MoveTo:create(4/60,rolePos[1]);
		self.name_bg:runAction(actOut);
	end

	local namePosOff = cc.p(-20,10);
	if showIn then
		local nameAct1 = cc.DelayTime:create(42/60);
		local nameAct2 = cc.MoveTo:create(5/60,cc.pAdd(nameBgPos[2],namePosOff))	
		local nameAct3 = cc.MoveTo:create(2/60,cc.pAdd(nameBgPos[3],namePosOff))	
		self.labelName:setVisible(true);
		self.labelName:setPosition(cc.pAdd(nameBgPos[1],namePosOff));
		self.labelName:runAction(cc.Sequence:create(nameAct1,nameAct2,nameAct3));
	else
		local actOut = cc.MoveTo:create(4/60,cc.pAdd(nameBgPos[1],namePosOff));
		self.labelName:runAction(actOut);
	end

	local wordBgPos = {
		cc.p(-322 - 320,568 - 10440),
		cc.p(350 - 320,568 - 961),
		cc.p(320 - 320,568 - 964)
	}
	if showIn then
		local wordBgAct1 = cc.DelayTime:create(42/60);
		local wordBgAct2 = cc.MoveTo:create(5/60,wordBgPos[2])	
		local wordBgAct3 = cc.MoveTo:create(2/60,wordBgPos[3])	
		self.wordBg:setVisible(true);
		self.wordBg:setPosition(wordBgPos[1]);
		self.wordBg:runAction(cc.Sequence:create(wordBgAct1,wordBgAct2,wordBgAct3))	
	else
		local actOut = cc.MoveTo:create(4/60,wordBgPos[1]);
		self.wordBg:runAction(actOut);
	end

	local worldPosOff = cc.p(0,0);
	if showIn then
		local wordAct1 = cc.DelayTime:create(42/60);
		local wordAct2 = cc.MoveTo:create(5/60,ccpAdd(wordBgPos[2],worldPosOff))	
		local wordAct3 = cc.MoveTo:create(2/60,ccpAdd(wordBgPos[3],worldPosOff))
		self.wordLabel:setVisible(true);	
		self.wordLabel:setPosition(ccpAdd(wordBgPos[1],worldPosOff));
		self.wordLabel:runAction(cc.Sequence:create(wordAct1,wordAct2,wordAct3));
	else
		local actOut = cc.MoveTo:create(4/60,cc.pAdd(wordBgPos[1],worldPosOff));
		self.wordLabel:runAction(actOut);
	end

	for i=1,3 do
		if showIn then
			local qualityBgAct1 = cc.DelayTime:create(45/60);
			local qualityBgAct2 = cc.FadeIn:create(35/60);
			self.qu_bg[i]:setVisible(true);
			self.qu_bg[i]:setOpacity(0);
			self.qu_bg[i]:runAction(cc.Sequence:create(qualityBgAct1,qualityBgAct2));
		else
			local actOut = cc.FadeOut:create(4/60);
			self.qu_bg[i]:runAction(actOut);
		end

	end

	local qualityPos = {
		cc.p(816 - 420,0),
		cc.p(406 - 420,0),
		cc.p(420 - 420,0)
	}
	if showIn then
		local qualityAct1 = cc.DelayTime:create(44/60)
		local qualityAct2 = cc.MoveTo:create(4/60,qualityPos[2] )	
		local qualityAct3 = cc.MoveTo:create(6/60,qualityPos[3] )	
		self.quality:setVisible(true);
		self.quality:setPosition(qualityPos[1] );
		self.quality:runAction(cc.Sequence:create(qualityAct1,qualityAct2,qualityAct3))
	else
		local actOut = cc.MoveTo:create(4/60,qualityPos[1]);
		self.quality:runAction(actOut);
	end

	if showIn then
		local starBgAct1 = cc.DelayTime:create(48/60);
		local starBgAct2 = cc.FadeIn:create(14/60);
		self.starbg:setVisible(true);
		self.starbg:setOpacity(0);
		self.starbg:runAction(cc.Sequence:create(starBgAct1,starBgAct2));
	else
		local actOut = cc.FadeOut:create(4/60);
		self.starbg:runAction(actOut);
	end

	local children = self.star:getChildren();
	if showIn then
		for i=1,#children do
			local starAct1 = cc.DelayTime:create(48/60);
			local starAct2 = cc.ScaleTo:create(3/60,0.93);
			local starAct3 = cc.ScaleTo:create(3/60,1);
			local starAct4 = cc.FadeIn:create(3/60)
		
			local item = children[i];
			item:setScale(6.6);
			item:setOpacity(0);
			item:runAction(cc.Sequence:create(starAct1, cc.Spawn:create(starAct2,starAct4),starAct3))
		end
	else
		for i=1,#children do
			local actOut = cc.FadeOut:create(4/60);

			local item = children[i];
			item:runAction(actOut);
		end
	end

	if showIn then
		for i=1,5 do
			local colorAct1 = cc.DelayTime:create(50/60);
			local colorAct2 = cc.FadeIn:create(20/60);

				local colorAct3 = cc.CallFunc:create(function (  )
					local angle = (i % 2 == 1) and 360 or -360;
					local repeatAct = cc.RepeatForever:create(cc.RotateBy:create(10, angle))	
					self.qu_color[i]:runAction(repeatAct);
			end)
			self.qu_color[i]:setVisible(true);
			self.qu_color[i]:setOpacity(0);
			self.qu_color[i]:runAction(cc.Sequence:create(colorAct1,colorAct2,colorAct3));

		end
		local colorAct3 = cc.DelayTime:create(46/60);
		local colorAct4 = cc.FadeIn:create(4/60);
		local colorAct5 = cc.ScaleTo:create(4/60,1);
		self.qu_color[6]:setVisible(true);
		self.qu_color[6]:setScale(1.73);
		self.qu_color[6]:setOpacity(0);
		self.qu_color[6]:runAction(cc.Sequence:create(colorAct3,cc.Spawn:create(colorAct4,colorAct5)));
	else
		for i=1,6 do
			local actOut = cc.FadeOut:create(4/60)
			self.qu_color[i]:runAction(actOut);
		end
	end

	if showIn then
		self.root:stopAllActions();
		local rootAct1 = cc.DelayTime:create(82/60 + 1);
		local rootAct2 = cc.CallFunc:create(function (  )
			if self.count == 1 then
				self:showNextGacha()
			else
				self:showRoleAction(false)
			end
		end)
		self.root:runAction(cc.Sequence:create(rootAct1,rootAct2))
	else
		self.root:stopAllActions();
		local rootAct1 = cc.DelayTime:create(4/60);
		local rootAct2 = cc.CallFunc:create(function (  )
			self:showNextGacha();
		end)
		self.root:runAction(cc.Sequence:create(rootAct1,rootAct2))
	end

end

function RoleShowPanel:showResultAction(  )
	-- body
	self.resultShowNode:stopAllActions();

	for i=1,10 do
		local item =self.resultItemList[i]
		if item then
			item:setVisible(false);
		end
	end
	self.resultActIndex = 1;
	local resultBgAct1 = cc.FadeIn:create(15/60);
	local resultBgAct2 = cc.CallFunc:create(handler(self,self.showNextReultAct))

	self.result_bg:setVisible(true);
	self.result_bg:setOpacity(0);
	self.result_bg:runAction(cc.Sequence:create(resultBgAct1,resultBgAct2));

end

function RoleShowPanel:showNextReultAct(  )
	
	local index = self.resultActIndex;
	self.resultActIndex = self.resultActIndex + 1;
	local item = self.resultItemList[index];
	if index <= self.count and item then

		local itemAct1 = cc.FadeIn:create(7/60);
		local itemAct2 = cc.ScaleTo:create(7/60 ,0.55);
		local itemAct3 = cc.ScaleTo:create(15/60,0.6);
		item:setOpacity(0);
		item:setScale(1.3);
		item:setVisible(true);
		item:runAction(cc.Sequence:create(cc.Spawn:create(itemAct1,itemAct2),itemAct3));


		local detail = 3;
		if index == 5 then
			detail = 15
		end
		local rsultAct1 = cc.DelayTime:create(detail/60)
		local rsultAct2 = cc.CallFunc:create(handler(self,self.showNextReultAct))
		self.resultShowNode:runAction(cc.Sequence:create(rsultAct1,rsultAct2))

	else
		self.step = STEP.SHOW_RESULT_END
	end

end


function RoleShowPanel:stepEventCall( )
	if self.step == STEP.SHOW_END then
		model.CardModel:showNewCardIcon();
		self:onClickBack()
	elseif self.step == STEP.SHOW_RESULT_END then 
		self.step = STEP.SHOW_NULL;
		model.CardModel:showNewCardIcon();
		self:onClickBack();
	elseif self.step == STEP.SHOW_NULL then 
	end
end


function RoleShowPanel:onEnter(partners)
	
	if not partners or #partners == 0 then
		return;
	end
	self.root:setVisible(true);

	self:setGachaResult(partners);
	self:showGachaInfo()

end

function RoleShowPanel:onClickBack()
	UIManager:pop('RoleShowPanel');
end

function RoleShowPanel:onLeave()
	self.root:setVisible(false);
end

function RoleShowPanel:backToInfo()
	self:stepEventCall()
end

return RoleShowPanel;
