local RoundBossPanel = class("RoundBossPanel", require('app.layer.BaseLayer'))
local scheduler = cc.Director:getInstance():getScheduler();
local MessageBoxType = Enum:getTable('MessageBoxType')
-- local imgPath = 'image/fight/roundInfo/';
local imgPath = 'image/randomBoss/';
local fonts = Enum:getTable("SystemFont")
local FightType = Enum:getTable('FightType');


function RoundBossPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'RoundBossPanel');

	self.scene = scene;
	self.useCCreator = false;
	-- self.isPopup = true;
	self.haveSwallowLayer = false;

	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = true;
end

function RoundBossPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self.root:setPosition(cc.p(StageSize.width/2,StageSize.height/2))

	self.select_key = -1;
	self.delayRefresh = 0

	self:initPanels();
	self:initRandomBossSpine();

	self:registEvent();
end

function RoundBossPanel:initPanels( ... )

	
	local background = ccui.Layout:create();
	background:setContentSize(cc.size(StageSize.width,StageSize.height))
	background:setAnchorPoint(cc.p(0.5,0.5))
	background:addTo(self.root)
  	background:setTouchEnabled(true);
	-- background:addTouchEventListener(handler(self , self.onExitRoundBossPanel));
	
	local backBg = cc.Sprite:create( imgPath .. 'random_bg.png')
	backBg:addTo(self.root)

	local bg2 = cc.Sprite:create( imgPath .. 'random_bg2.png' )
		-- :setContentSize(cc.size(625,680))
		:setPosition(0, 39)
		:addTo(self.root)

	-- topNode
	local topNode = cc.Node:create();
	topNode:addTo(self.root);
	topNode:setPosition(cc.p(0,463))

	local haveCoinNode = cc.Node:create();
	haveCoinNode:setPosition(-195, 0)
	haveCoinNode:addTo(topNode)
	if haveCoinNode then
		local titleBg = cc.Scale9Sprite:create('image/commonImg/edit_bg_28_0_177_49.png')
			:addTo(haveCoinNode)
			:setCapInsets(cc.rect(28,0,177,49))
			:setContentSize(cc.size(214 , 49))
	
		local moneyIcon = cc.Sprite:create('image/icon/I10007.png');
		moneyIcon:setPosition(cc.p(-78, 0));
		moneyIcon:addTo(haveCoinNode);
		moneyIcon:setScale(0.5)

		local title = cc.Label:createWithTTF(LANG.UI_ROUNDBOSS_3, fonts.FONT_SIYUAN, 20);
		title:addTo(haveCoinNode);
		title:setPosition(cc.p(-25,0))

		local moneyTitle = cc.Label:createWithTTF('5000', fonts.FONT_SIYUAN, 18);
		moneyTitle:addTo(haveCoinNode);
		moneyTitle:setPosition(cc.p(86,0))
		moneyTitle:setAnchorPoint(cc.p(1,0.5));
		self.haveCoinLabel = moneyTitle;
	end
	self.haveCoinNode = haveCoinNode;

	local needCoinNode = cc.Node:create();
	needCoinNode:setPosition(35, 0)
	needCoinNode:addTo(topNode)
	if needCoinNode then
		self.bossBuyBtn = ccui.Button:create('image/commonImg/btn_11.png');
		self.bossBuyBtn:setPosition(0, 0);
		self.bossBuyBtn:addClickEventListener(handler(self, self.onBuyBoss));
		self.bossBuyBtn:addTo(needCoinNode);
		self.bossBuyBtn:setScale9Enabled(true)
		self.bossBuyBtn:setContentSize(cc.size(228, 55))
		local bossBuySize = self.bossBuyBtn:getContentSize();
		local btnLabel = cc.Label:createWithTTF(LANG.UI_ROUNDBOSS_5, fonts.FONT_SIYUAN, 20) 
			:addTo(self.bossBuyBtn)
			:setPosition(cc.p(210,bossBuySize.height/2))
			:setAnchorPoint(cc.p(1,0.5))
			:enableShadow(cc.c4b(0 , 25 , 70 , 255), cc.size(0,0));
			
		local bossBuyIcon = cc.Sprite:create( imgPath .. 'random_bg3.png')
			:addTo(self.bossBuyBtn)
			:setPosition(cc.p(130,bossBuySize.height/2))

		local titleBg = cc.Scale9Sprite:create('image/commonImg/edit_bg_28_0_177_49.png')
			:addTo(needCoinNode)
			:setContentSize(cc.size(90 , 30))
			:setPosition(-50,0)
	
		local moneyIcon = cc.Sprite:create('image/icon/I10007.png');
		moneyIcon:setPosition(cc.p(-88, 0));
		moneyIcon:addTo(needCoinNode);
		moneyIcon:setScale(0.35)

		local moneyTitle = cc.Label:createWithTTF('5000', fonts.FONT_SIYUAN, 18);
		moneyTitle:addTo(needCoinNode);
		moneyTitle:setPosition(cc.p(-13,0))
		moneyTitle:setAnchorPoint(cc.p(1,0.5));
		self.needCoinLabel = moneyTitle;
	end
	self.needCoinNode = needCoinNode;

	local dobleNode = cc.Node:create();
	dobleNode:setPosition(230, 0)
	dobleNode:addTo(topNode)
	if dobleNode then
		local titleBg = cc.Scale9Sprite:create('image/commonImg/edit_box.png')
			:addTo(dobleNode)
			:setContentSize(cc.size(144 , 49))

		local title = cc.Label:createWithTTF(LANG.UI_ROUNDBOSS_7, fonts.FONT_SIYUAN, 20);
		title:addTo(dobleNode);
		title:setAnchorPoint(0, 0.5)
		title:setPosition(cc.p(-55,0))

		local moneyTitle = cc.Label:createWithTTF('5', fonts.FONT_SIYUAN, 18);
		moneyTitle:addTo(dobleNode);
		moneyTitle:setPosition(cc.p(50,0))
		moneyTitle:setAnchorPoint(cc.p(1,0.5));
		self.dbTimesLabel = moneyTitle;

		local spine_res = 'double_appear_spine'
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			self.dbSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			self.dbSpine:addTo(dobleNode)
			self.dbSpine:registerSpineEventHandler(function (event)
	            if event.animation == 'appear' then
	                self.dbSpine:setAnimation(0, "idle", true)
	            end 
	        end, sp.EventType.ANIMATION_COMPLETE)
		else
			print('error : 缺少spine 资源')
		end
		
	end
	self.dobleNode = dobleNode;

	-- self.bossBuyCoinSp = {}		--持有/消耗 道具icon 
	-- self.bossBuyCoinLabel = {} 	-- 持有/消耗 道具数量
	-- local titleName = {LANG.UI_ROUNDBOSS_3,LANG.UI_ROUNDBOSS_4}
	-- for i=1,2 do
	-- 	local titleBg = cc.Scale9Sprite:create('image/commonImg/edit_bg_28_0_177_49.png')
	-- 		:addTo(topNode)
	-- 		:setPosition(-188 +230 * (i - 1) , 0)
	-- 		:setCapInsets(cc.rect(28,0,177,49))
	-- 		:setContentSize(cc.size(214 , 49))
	
	-- 	local moneyIcon = cc.Sprite:create('image/icon/I10007.png');
	-- 	moneyIcon:setPosition(cc.p(-266 + 230*(i-1) , 0));
	-- 	moneyIcon:addTo(topNode);
	-- 	moneyIcon:setScale(0.5)
	-- 	self.bossBuyCoinSp[i] = moneyIcon;

	-- 	local title = cc.Label:createWithTTF(titleName[i], fonts.FONT_SIYUAN, 20);
	-- 	title:addTo(topNode);
	-- 	-- title:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 2);
	-- 	title:setPosition(cc.p(-213 + 230*(i-1),0))

	-- 	local moneyTitle = cc.Label:createWithTTF('5000', fonts.FONT_SIYUAN, 18);
	-- 	moneyTitle:addTo(topNode);
	-- 	-- moneyTitle:setTextColor(cc.c4b(50 , 50 , 50 , 255));
	-- 	moneyTitle:setPosition(cc.p(-102 + 230*(i-1),0))
	-- 	moneyTitle:setAnchorPoint(cc.p(1,0.5));
	-- 	self.bossBuyCoinLabel[i] = moneyTitle;
	-- end

	-- bottom 刷新boss
	local bottomNode = cc.Node:create();
	bottomNode:addTo(self.root)
	bottomNode:setPosition(cc.p(0,-379))

	self.refreshBtn = ccui.Button:create('image/commonImg/btn_269_55_2.png');
	self.refreshBtn:addClickEventListener(handler(self, self.onRefreshBoss));
	self.refreshBtn:addTo(bottomNode);

	self.refreshLabel = cc.Label:createWithTTF(LANG.UI_ROUNDBOSS_6, fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c4b(100 , 100 , 100 , 255) , 1)
		-- btnLabel:setTextColor(cc.c4b(50 , 50 , 50 , 255));
		:setPosition(cc.p(40,0))
		:addTo(bottomNode)

	self.refreshBg = cc.Sprite:create( imgPath .. 'refresh_bg.png')
		:addTo(bottomNode)
		:setPosition(cc.p(-68,0))

	local itemIcon = ResTable:getValue('item' , COLOR_DIA , 'icon');
	self.refreshMoney = cc.Sprite:create('image/icon/I'..itemIcon..'.png')
		-- :setContentSize(COST_ITEM_SIZE)
		:setScale(0.4)
		:setPosition(cc.p(-105,0))
		:addTo(bottomNode);

	self.refreshCost = cc.Label:createWithTTF('999' , fonts.FONT_SIYUAN , 16)
		:setAnchorPoint(cc.p(0.5,0.5))
		:addTo(bottomNode)
		:setPosition(-80 , 0)
		:setAnchorPoint(0, 0.5)
	-- mid
	-- self.mainRoot = cc.Node:create();
	-- self.mainRoot:addTo(self.root)

	local midNode = cc.Node:create();
	midNode:addTo(self.root)
	-- midNode:setPosition(cc.p(0,-62))

    local initData = {
        width = 582,
        height = 746,
        cellWidth = 560 ,
        cellHeight = 180,
		cellReloadFunc = handler(self,self.reloadCellPanel),
		cellTouchFunc = handler(self,self.cellItemTouch) ,

    }
    self.bossListView = template.TableViewTemplate:create()
    self.bossListView:initWithSizeAndItem(initData) ;
    self.bossListView:getView():setPosition(cc.p(-297,-333));
	self.bossListView:getView():addTo(midNode)

	self.noBossNode = cc.Node:create();
	self.noBossNode:addTo(midNode)

	local noBossInfo1 = {
		LANG.UI_ROUND_8,
		LANG.UI_ROUND_9,
		LANG.UI_ROUND_10,
		LANG.UI_ROUND_11,
		LANG.UI_ROUND_12,
	};
	for i=1,#noBossInfo1 do
		local label = cc.Label:createWithTTF(noBossInfo1[i], fonts.FONT_JP, 20);
		label:addTo(self.noBossNode)
		-- label:setTextColor(cc.c3b(181,181,181))
		label:setPosition(cc.p(0,139 - 32 * (i-1)))
		label:setAnchorPoint(cc.p(0.5,0.5))
	end

end

function RoundBossPanel:initRandomBossSpine( ... )
	local spine_res = 'boss_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.randomBossSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.randomBossSpine:addTo(self.root)
		self.randomBossSpine:setPosition(cc.p(320 , 124))
		self.randomBossSpine:registerSpineEventHandler(handler(self,self.showNextBossCommingAni),sp.EventType.ANIMATION_COMPLETE)

	else
		print('error : 缺少spine 资源')
	end  
end

function RoundBossPanel:registEvent( ... )
	EventManager:RegisterEvent(EventType.RoundBossBuy, handler(self, self.retBossBuy));
	EventManager:RegisterEvent(EventType.RoundBossRefreshAll, handler(self, self.retRefreshAll));
	EventManager:RegisterEvent('RoundBossPanel:onUpdateDbInfo', handler(self, self.onUpdateDbInfo));
end

function RoundBossPanel:showBossList(  )
	local bossList = model.RoundBossModel:getroundBossList()
	self.bossListView:reloadData(bossList);
end

function RoundBossPanel:updateBtnRedDot(  )
	-- local show = model.RoundBossModel:getRedDotStateRoundBoss();
	-- tools.RedDotTools:setRedDotToNode(self.bossBuyBtn,show,nil,cc.p(0 , 0))
end

function RoundBossPanel:onEnter(key)

	self:show()
	if model.RoundBossModel:reqDoubleActInfo() then
		self:onUpdateDbInfo();
	end
	-- self:showFireAct();
	self.root:setVisible(true);
end

function RoundBossPanel:show(  )
	-- local 
	self.select_key = -1;
	self.diamondNum = 0;

	local buyBoss = model.RoundBossModel:getCurrentBuy()
	local refresh = model.RoundBossModel:getCurrentRefresh();
	-- self.bossBuyCoinLabel[1]:setString(tostring(buyBoss[1]))
	-- self.bossBuyCoinLabel[2]:setString(tostring(buyBoss[2]))
	self.haveCoinLabel:setString(tostring(buyBoss[1]))
	self.needCoinLabel:setString(tostring(buyBoss[2]))
	
	local buyEnough = tonumber(buyBoss[1]) > tonumber(buyBoss[2])

	local moneyEnough = false
	local	guideStep = model.GuideModel:getGuideStep() ; -- 新手引导阶段
	if guideStep == model.GuideModel.GUIDE_STEP_ENUM.GUIDE_ENUM_ROUNDBOSS or refresh[1] == 0 then
		moneyEnough = true;
		self.refreshBg:setVisible(false);
		self.refreshCost:setVisible(false);
		self.refreshMoney:setVisible(false);

		self.refreshLabel:setPosition(0,0)
		self.refreshLabel:setString(LANG.UI_FIGHT_65);
	else

		self.refreshBg:setVisible(true);
		self.refreshCost:setVisible(true);
		self.refreshMoney:setVisible(true);

		self.refreshLabel:setPosition(40,0)
		self.refreshLabel:setString(LANG.UI_ROUNDBOSS_6);

		local itemIcon = ResTable:getValue('item' , refresh[3] , 'icon');
		self.refreshMoney:setTexture('image/icon/I'..itemIcon..'.png');
		if MONEY_ID~=refresh[3] and COLOR_DIA~=refresh[3] then
			local itemNum = model.ItemModel:getItemNum(refresh[3]);
			self.refreshCost:setString(tostring(itemNum)..' / '..tostring(refresh[2]))
		else
			self.refreshCost:setString(tostring(refresh[2]))
		end

		if type(refresh[1] == 'string') then
			moneyEnough = model.MoneyModel:isEnough(refresh[2])
		else
			moneyEnough = refresh[1] > refresh[2]
		end

		if refresh[3] == COLOR_DIA then
	        self.diamondNum = refresh[2];
	    end
	end

	local hasBoss = model.RoundBossModel:hasBoss()
	self.noBossNode:setVisible(not hasBoss)

    self.refreshBtn:setTouchEnabled(hasBoss and moneyEnough );
	self.refreshBtn:setBright(hasBoss and moneyEnough) 
	
	self:updateBtnRedDot()
	self:showBossList()

end

function RoundBossPanel:onUpdateDbInfo()
	if model.RoundBossModel:isValidDBAct() then
		self.haveCoinNode:setPosition(-195, 0)
		self.needCoinNode:setPosition(35, 0)
		self.dobleNode:setVisible(true)
		self.dbTimesLabel:setString( model.RoundBossModel:getDBTimes() )
		self.dbSpine:setAnimation(0, "appear", false)
	else
		self.haveCoinNode:setPosition(-138, 0)
		self.needCoinNode:setPosition(138, 0)
		self.dobleNode:setVisible(false)
	end
end

function RoundBossPanel:onClickBack()
	self:onExitRoundBossPanel(); 
end

function RoundBossPanel:onLeave()
	tools.RedDotTools:pushFightSceneRedDot(5)

	self.root:setVisible(false);
end

function RoundBossPanel:onExitRoundBossPanel(  )
    UIManager:pop("RoundBossPanel");
end

function RoundBossPanel:onRefreshBoss( sender,eventType )
	if self.diamondNum ~= 0 then
		MessageBox:create(string.format(LANG.UI_NOTICE_1,tostring(self.diamondNum)) , MessageBoxType.CANCEL_OK,function()
			model.RoundBossModel:reqRefreshAll();
		end);
	else
		model.RoundBossModel:reqRefreshAll();
	end
end

function RoundBossPanel:retRefreshAll( msg )
	self.refreshCellRun = true 
	self.delayRefresh = 0
	self:show()
	self.refreshCellRun = false 
	self:roundBossIncome(msg)
end

function RoundBossPanel:onBuyBoss( sender,eventType )
	model.RoundBossModel:reqBuyBoss()
end

function RoundBossPanel:retBossBuy( msg )
	self.delayRefresh = 0

	local _k,newBoss = next(msg.newRoundBoss,_k)
	if _k ~= nil then
		self.showPid = newBoss.pid
	end
	self:show()
	self:roundBossIncome(msg)
	self.showPid  = -1;
end

function RoundBossPanel:reloadCellPanel( cell,index )
	local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
		cellNode = template.RoundBossItemTemplate:create();
		cellNode:setTag(999);
		cellNode:addTo(cell)
		cellNode:setPosition(cc.p(295,86));
	end
	local itemData = model.RoundBossModel:getBossDataByKey(index+1);
	cell:setTag(index+1);
	cellNode:initData(itemData);

	if self.refreshCellRun == true or itemData.pid == self.showPid  then
		cellNode:runRefresh(true ,self.delayRefresh)
		self.delayRefresh = self.delayRefresh + 2
	end

end

function RoundBossPanel:cellItemTouch( table,cell )
	-- body
	-- print("cell touched at tag: " .. cell:getTag())
	self.select_key = cell:getTag()

	local option = {
		fromPanel = 'RoundBossPanel',
		select_key = cell:getTag(),
		fightType = FightType.RandomBoss,
	}
	UIManager:push('RoundInfoPanel',option);

end

------act ----

function RoundBossPanel:showNextBossCommingAni(  )
	if self.bossComeList == nil or next(self.bossComeList) == nil then
		return 
	end

	local k,difficulty = next(self.bossComeList)
	if difficulty == nil then
		return 
	end
	self.bossComeList[k] = nil;

	if self.randomBossSpine == nil then
		self:initRandomBossSpine();
	end
	if  difficulty < 4  then
		self:showNextBossCommingAni()
		return 
	end
	if difficulty == 4 then
		difficulty = 5;
	elseif difficulty == 5 then
		difficulty = 4;
	end
	local animationName = 'boss'..difficulty
	self.randomBossSpine:setAnimation(0, GlobalFunctions:lAnimationName(animationName), false)
end

function RoundBossPanel:roundBossIncome( msg )
	local newRoundBoss = msg.newRoundBoss
	if newRoundBoss == nil or next(newRoundBoss) == nil then
		return 
	end
	local _k,newBoss = next(newRoundBoss,_k)
	self.bossComeList = {}
	while newBoss ~= nil do
		local bossData = model.RoundBossModel:getBossDataByPid( newBoss.pid  )
		if bossData ~= nil and bossData.boss_difficulty >= 4  then
			if self.bossComeList[bossData.boss_difficulty] == nil then
				self.bossComeList[bossData.boss_difficulty] = bossData.boss_difficulty;
			end
		end
		_k,newBoss = next(newRoundBoss,_k)
	end

	self:showNextBossCommingAni()

end

function RoundBossPanel:guideItemClick( ... )
	local node = cc.Node:create();
	node:setTag(1)
	self:cellItemTouch(null,node)
end

-- 引导相关
function RoundBossPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 79 then
		local btn = self.bossBuyBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 80 then 
		local btn = self.refreshBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 81 then 
		local btn = self.bossListView:cellAtIndex(0):getChildByTag(999);
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end


return RoundBossPanel;
