local RoundInfoPanel = class("RoundInfoPanel", require('app.layer.BaseLayer'))

local imgPath = 'image/fight/roundInfo/';
local fonts = Enum:getTable("SystemFont")
local FightType = Enum:getTable('FightType');
local TeamType = Enum:getTable('TeamType');
local restrainType = Enum:getTable("FightRestraintType")

local bossPos = {
	[1] = cc.p(-196, 127),
	[2] = cc.p(-65, 127),
	[3] = cc.p(65, 127),
	[4] = cc.p(196, 127),
}

local scheduler = cc.Director:getInstance():getScheduler()

function RoundInfoPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'RoundInfoPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.haveSwallowLayer = true;
	self.isPopup = true;
end

function RoundInfoPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self.fightType = -1;

	self.bossHpList = {}
	self:initPanels();
end

function RoundInfoPanel:initPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,591));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 23);

	local titleNode =  GlobalFunctions:createTitle('' , 606 , 63 , LANG.UI_ROUND_6);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 349);

	self.title = titleNode:getChildByName('title');

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , 70);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(582 , 476));

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(-60 , 270);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(437 , 42));

	local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
	arrow:addTo(self.root);
    arrow:setPosition(-245,270);
    
	local label = cc.Label:createWithTTF(LANG.UI_ROUND_26 , fonts.FONT_SIYUAN , 22);
	label:addTo(self.root);
	label:setAnchorPoint(0 , 0.5);
	label:setPosition(-217 , 270);
	label:setTextColor(cc.c4b(160 , 200 , 255 , 255));

	self.fpNum = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 22)
		:setAnchorPoint(1 , 0.5)
		:setPosition(129, 270)
		:addTo(self.root)
		:setVisible(false);
	
	local label = cc.Label:createWithTTF(LANG.UI_L_RESTRAINT_TITLE , fonts.FONT_SIYUAN , 17);
	label:enableOutline(cc.c3b(55 , 85 , 155) , 2);
	local restraintBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png','image/commonImg/btn_2_103_36.png');
	restraintBtn:addTo(self.root);
	restraintBtn:setPosition(230 , 270);
	restraintBtn:setTitleLabel(label);
	restraintBtn:addClickEventListener(function()
		EventManager:FireEvent(EventType.UITipsMessage);
		UIManager:push('TeamRestraintPanel',self.fightType , self.enemyRestraintString);
	end);
	-- sp
	for i = 1 , 2 do
		local bg = cc.Sprite:create(imgPath .. 'round_info_1.png')
			:setPosition(0, i == 1 and 144 or -58)
			:addTo(self.root)

		local bg = cc.Sprite:create(imgPath .. 'round_info_2.png')
			:setPosition(2, i == 1 and 210 or 8)
			:addTo(self.root)

		local label = cc.Label:createWithTTF(i == 1 and LANG.UI_FIGHT_34 or LANG.UI_FIGHT_35, fonts.FONT_SIYUAN, 20)
			:setPosition(2,i == 1 and 210 or 8)
			:addTo(self.root)
	end

	-- boss
	self.bossList = {}
	for i=1, 4 do

		local bossInfo = {}
		self.bossList[i] = bossInfo

		local bg = cc.Sprite:create('image/commonImg/icon_enemy_empty.png')
			:addTo(self.root)
			:setPosition(bossPos[i])

		bossInfo.node = cc.Node:create()
			:setPosition(bossPos[i])
			:addTo(self.root)

		bossInfo.bg = cc.Sprite:create('image/commonImg/icon_enemy.png')
			:addTo(bossInfo.node)

		bossInfo.bareFlag = cc.Scale9Sprite:create('image/commonImg/common_item_select.png');
		bossInfo.bareFlag:addTo(bossInfo.node);
		bossInfo.bareFlag:setContentSize(cc.size(112 , 112));
		bossInfo.bareFlag:setVisible(false)

		bossInfo.icon = cc.Sprite:create()
		local stencil = cc.Sprite:create('image/commonImg/icon_clipping_bg.png');
		stencil:setScale(1.05);
		local clippingNode = cc.ClippingNode:create();
		clippingNode:setStencil(stencil);
		clippingNode:addChild(bossInfo.icon);
		clippingNode:setInverted(false);
		clippingNode:setAlphaThreshold(0);
		clippingNode:addTo(bossInfo.node);

		bossInfo.restraint = cc.Sprite:create('image/commonImg/def_type_1.png')
			:setPosition(-31, 32)
			:setScale(0.55)
			:addTo(bossInfo.node)

		bossInfo.starNode = cc.Node:create()
			:setPosition(-26, -37)
			:addTo(bossInfo.node)

		bossInfo.level = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16)
			:setAnchorPoint(1, 0.5)
			:setPosition(44, 37)
			:enableOutline(cc.c3b(60,60,60),2)
			:addTo(bossInfo.node)
	end

	-- drop
	self.dropListView = ccui.ListView:create();
	self.dropListView:setTouchEnabled(true); 
	self.dropListView:setBounceEnabled(true);
	self.dropListView:setDirection(ccui.ScrollViewDir.horizontal);
	self.dropListView:setContentSize(cc.size(480, 110));
	self.dropListView:setAnchorPoint(0.5 , 0.5);
	self.dropListView:setPosition(-2, -72);
	self.dropListView:setScrollBarEnabled(false);
	self.dropListView:addTo(self.root);
	self.dropListView:setItemsMargin(22);
	self.dropListView:setCascadeOpacityEnabled(true);

	local spine_res = 'boss_double_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.dbSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.dbSpine:addTo(self.root)
		self.dbSpine:setPosition(cc.p(220,20))
		self.dbSpine:setAnimation(0, 'boss_double_spine', true)
	else
		print('error : 缺少spine 资源')
	end 

	-- role list
	self.roleNode = cc.Node:create()
		:setPosition(0, -330)
		:addTo(self.root)

	--btn
	self.btnTeam = ccui.Button:create('image/commonImg/btn_1_219_55_2.png','image/commonImg/btn_1_219_55_2.png');
	self.btnTeam:setPosition(-120, -225);
	self.btnTeam:addClickEventListener(handler(self,self.onTeamClick))
	self.btnTeam:addTo(self.root);
	local labelTeam = cc.Label:createWithTTF(LANG.UI_FIGHT_36, fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2)
	self.btnTeam:setTitleLabel(labelTeam)

	self.btnChallenge = ccui.Button:create('image/commonImg/btn_1_219_55.png','image/commonImg/btn_1_219_55.png');
	self.btnChallenge:setPosition(120, -225);
	self.btnChallenge:addClickEventListener(handler(self, self.challengeBoss));
	self.btnChallenge:addTo(self.root);
	local labelChallenge = cc.Label:createWithTTF(LANG.UI_FIGHT_37, fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2)
	self.btnChallenge:setTitleLabel(labelChallenge)

	self.loadingMsg = cc.Label:createWithTTF('资源加载中...', fonts.FONT_SIYUAN, 20)
		:setTextColor(cc.c3b(255, 0, 0))
		:setPosition(0, 127)
		:setAnchorPoint( cc.p(0, 0.5) )
		:addTo(self.root)
		:setVisible(false)

	EventManager:RegisterEvent(EventType.FightEnableChallenge, handler(self, self.enableBtnChallenge));

	self:initBareTipNode();
end

function RoundInfoPanel:initBareTipNode()
	-- body
	self.bareTipNode = cc.Node:create()
	self.bareTipNode:addTo(self.root)
	self.bareTipNode:setPosition(-55, 45)
	self.bareTipNode:setVisible(false)

	local spine_res = 'dapokuang_spine';
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(self.bareTipNode)
		spine:setPosition(-140, 25)
		self.bareSpine1 = spine
		self.bareSpine1:registerSpineEventHandler(function (event)
				if event.eventData.name == 'appear' then
					self.bareInfoNode:setVisible(true)
				end
			end, sp.EventType.ANIMATION_EVENT);
	end

	self.bareInfoNode = cc.Node:create()
	self.bareInfoNode:addTo(self.bareTipNode)

	local spine_res = 'dapokuang_spine';
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(self.bareTipNode)
		spine:setPosition(-140, 25)
		self.bareSpine2 = spine
	end

	local tipIcon = cc.Sprite:create('image/commonImg/tip_2.png')
	tipIcon:addTo(self.bareInfoNode)
	tipIcon:setPosition(-170, -7)

	-- local tagRect = cc.Scale9Sprite:create('image/commonImg/common_item_select.png')
	-- tagRect:addTo(self.bareTipNode)
	-- tagRect:setContentSize(cc.size(116,116))
	-- tagRect:setPosition(-142, 84)

	local label = cc.Label:createWithTTF(LANG.UI_FIGHT_99, fonts.FONT_SIYUAN, 18)
		:setAnchorPoint(0 , 0.5)
		:setPosition(-150, -7)
		:setTextColor(cc.c3b(255,255,0))
		:addTo(self.bareInfoNode)

end

function RoundInfoPanel:showLoading()
	-- body
	local d1 = cc.DelayTime:create(0.5)
	local a1 = cc.CallFunc:create(function()
			self.loadingMsg:setString('资源加载中.')
		end)
	local d2 = cc.DelayTime:create(0.5)
	local a2 = cc.CallFunc:create(function()
			self.loadingMsg:setString('资源加载中..')
		end)
	local d3 = cc.DelayTime:create(0.5)
	local a3 = cc.CallFunc:create(function()
			self.loadingMsg:setString('资源加载中...')
		end)
	local seqact = cc.Sequence:create(d1, a1, d2, a2, d3, a3 );
	self.loadingMsg:runAction( cc.RepeatForever:create(seqact) );
	self.loadingMsg:setVisible(true)
end

function RoundInfoPanel:showBossList( enemyInfo, hp )
	for k, v in pairs(self.bossHpList) do
		v:removeFromParent()
	end
	enemyInfo = clone(enemyInfo);  -- 防止修改ResTable原始数据顺序
	table.sort(enemyInfo, function(first, second)
		local data1 = ResTable:getRowData('monster', first[1])
		local data2 = ResTable:getRowData('monster', second[1])
		if data1.show > data2.show then
			return true
		elseif data1.show < data2.show then
			return false
		end

		if data1.ifboss == 1 and data2.ifboss == 0 then
			return true
		elseif data1.ifboss == 0 and data2.ifboss == 1 then
			return false
		else
			return first[1] < second[1]
		end
	end)
	self.bossHpList = {}

	self.needLoadRes = {}
	self.resEnd = true

	self.enemyRestraintString = '000';
	--local restraint = {}
	--restraint[restrainType.RED_BASE] = 0;
	--restraint[restrainType.GREEN_BASE] = 0;
	--restraint[restrainType.BLUE_BASE] = 0;

	local index = 0
	local bareIdx = -1;
	for i=1,#enemyInfo do
		local bossInfo = enemyInfo[i];
		if bossInfo and bossInfo[1] then
			index = index + 1
			local bossId = bossInfo[1];
			local data = ResTable:getRowData('monster', bossId);
			--restraint[data['def_type']] = restraint[data['def_type']] + 1;
			self.bossList[i].bareFlag:setVisible(false)
			if data then
				self.bossList[i].icon:setTexture('image/icon/'..data.icon..'.png')
				self.bossList[i].restraint:setTexture('image/commonImg/def_type_'..data['def_type']..'.png');

				if data.show > 0 then
					bareIdx = i;
					self.bossList[i].bareFlag:setVisible(true)
				end
			end
			if hp and hp[i] then
				self.bossHpList[i] = require('app.template.BloodVolume'):create(self.bossList[i].node, 2)
				self.bossHpList[i]:setPercent(hp[i]/100)
				self.bossHpList[i]:setPosition(15, -30)
			end

			self.bossList[i].node:setVisible(true)

			local attributeData = ResTable:getRowData('monster_attribute', bossInfo[2]);
			self.bossList[i].level:setString('Lv.'..tostring(attributeData.lv));

			self.bossList[i].starNode:removeAllChildren();
			local color = math.ceil(attributeData.star / 5);
			local num = attributeData.star % 5;
			num = num == 0 and 5 or num;
			for j = 1 , 5 do
				if j <= num then
					local star = cc.Sprite:create('image/card/star_level_'..color..'.png');
					star:addTo(self.bossList[i].starNode);
					star:setPosition(14*(j-1),0)
					star:setScale(0.55);
				end
			end

			-- local resName = 'rolemodel0320'
			-- local modelName = data.model--'M003_Model'--'M024_Model' R021_Model  R023_Model
			-- if not cc.FileUtils:getInstance():isFileExist('RoleModel/'..modelName.."/"..modelName.."_tex.json") then --判断是否需要加载
			-- 	if self.needLoadRes[ modelName ] == nil then
			-- 		self.needLoadRes[ modelName ] = 1
			-- 	end
			-- end
			if self.needLoadRes[ bossId ] == nil then
				self.needLoadRes[ bossId ] = 1
			end

			if index == 4 then
				break;
			end
		end
	end

	--self.enemyRestraintString = tostring(restraint[restrainType.BLUE_BASE])..tostring(restraint[restrainType.RED_BASE])..tostring(restraint[restrainType.GREEN_BASE]);

	local totalFp = '0';
	local restraintFactor,enemyRestraintString = CardProManager:GetMonsterRestraintFactor(enemyInfo);
	for _k , data in pairs(enemyInfo) do
		local pro = CardProManager:GenMonsterPro(data[1], data[2],restraintFactor);
		if pro then
			totalFp = HpPlus(totalFp, ConvertDigitUnitToStr(pro.fp));
		end
	end

	if self.fightType == FightType.Boss then
		self.fpNum:setString(HpMultiply(tostring(totalFp),1.1));
	else
		self.fpNum:setString(tostring(totalFp));
	end
	
	self.enemyRestraintString = enemyRestraintString;

	for i=index+1, 4 do
		self.bossList[i].node:setVisible(false)
	end

	self.loadresList = {}
	for k,v in pairs(self.needLoadRes) do
		table.insert( self.loadresList, k )
	end

	self.loadingMsg:setVisible(false)
	self.loadingMsg:stopAllActions()
	if DownloadControler:checkNeedMonsterRes(self.loadresList) then
		self.resEnd = true
	else
		self.resEnd = false
		self:showLoading()
	end

	if bareIdx > 0 then
		-- local lx, ly = self.bossList[bareIdx].node:getPosition();
		-- local wpt = self.bossList[bareIdx].node:getParent():convertToWorldSpace(cc.p(lx, ly+40));
		-- EventManager:FireEvent(EventType.UITipsMessage, wpt, LANG.UI_FIGHT_99);

		self.bareTipNode:setVisible(true)
		self.bareInfoNode:setVisible(false)
		self.bareSpine1:setAnimation(0, "appear1", false)
		self.bareSpine2:setAnimation(0, "appear2", false)
	else
		self.bareTipNode:setVisible(false)
	end

	-- self.loadingMsg:setVisible(false)
	-- if #loadresList > 0 then
	-- 	self.resEnd = false
	-- 	self:showLoading()
	-- 	for i,v in ipairs(loadresList) do
	-- 		DownloadControler:addDownLoadList(v,  function()
	-- 			self.loadingMsg:stopAllActions()
	-- 			self.loadingMsg:setString( '资源下载完成: '..v )
	-- 			self.resEnd = true
	-- 		end)
	-- 	end
		
	-- end

end

function RoundInfoPanel:showDropList( rewardList )
	self.dropListView:removeAllChildren()
	local dropSpace = 103;
	local index = 1;
	for i=1, #rewardList do
		local dropInfo = rewardList[i];
		if dropInfo and dropInfo[1] then
			local layout = ccui.Layout:create();
			layout:setContentSize(cc.size(103,103))
			local icon = template.ItemTemplate:create(2);
			icon:addTo(layout);
			icon:Init(dropInfo[1], dropInfo[2]);
			icon:setPosition(51.5, 51.5)
			self.dropListView:pushBackCustomItem(layout)
		end
	end	
end

function RoundInfoPanel:showDefault(  )
	local roundId = model.RoundModel:getRoundIndex();
	local roundData = ResTable:getRowData('round', roundId);
	self.title:setString(string.format(LANG.UI_ROUND_23, tostring(roundData['name'])));
	--self.fpNum:setString(tostring(roundData['fp']));

	self:showBossList(roundData['boss'])

	local rewardList = clone(roundData['drop_boss'])	
	table.insert( rewardList,1, {MONEY_ID,roundData['coin_boss']})
	table.insert( rewardList,1, {EXP_ID,roundData['exp_boss']})
	self:showDropList(rewardList)

end

function RoundInfoPanel:showRandomBoss(  )
	local itemData = model.RoundBossModel:getBossDataByKey(self.select_key);
	self.title:setString(tostring(itemData['boss_name']));
	--self.fpNum:setString(tostring(itemData['fp']));
	local boss = { 
		{itemData.monster_id,itemData.attribute_id}
	}
	self:showBossList(boss)
	self:showDropList(itemData.reward)
end

function RoundInfoPanel:showEventInfo()
	local fightInfo = model.EventModel:getMapMonsterInfo(self.select_key)
	local title_index = 1
	-- if fightInfo.isKey == 1 then
	-- 	if fightInfo.tier < 5 then
	-- 		title_index = 2
	-- 	else
	-- 		title_index = 3
	-- 	end
	-- end
	self.title:setString(LANG.UI_EVENT_ROUND_INFO_TITLE[title_index]);
	local monster = {}
	for k, v in pairs(fightInfo.monster) do
		table.insert(monster, {[1] = v, [2] = fightInfo.att})
	end
	self:showBossList(monster, fightInfo.monster_hp) --fightInfo.monster_hp 血量百分比数组
	local data = ResTable:getRowData('maze_box', fightInfo.rwd);
	self:showDropList(data.box_drop)
	-- self:showDropList({{[1]=EVENT_BUFF}})

	self.roleNode:removeAllChildren()
	local team = model.TeamModel:getEventTeam()
	for i=1, TEAM_MAX_MEMBER do
		if team[i] ~= -1 then
			local card = model.CardModel:GetCard(team[i])
			local icon = require('app.template.ItemTemplate'):create();
			icon:addTo(self.roleNode);
			icon:Init(ROLE_TYPE, card.no, card.star_lv, card.level, team[i])
			icon:updateAltarLevelColor(card.oriLv)
			icon:setPosition((i-1)*126-189, 0)

			local hp = model.CardModel:getEventHp(team[i])
			local blood = require('app.template.BloodVolume'):create(self.roleNode, 3)
			blood:setPercent(hp/100)
			blood:setPosition((i-1)*126-189, -63)
		else
			local sp = cc.Sprite:create('image/event/event_buff_team_empty.png')
				:setPosition((i-1)*126-189, 0)
				:addTo(self.roleNode)
		end
	end
end

function RoundInfoPanel:updateRedDotShow()
	local show = model.TeamModel:checkTeamFormationRedDotState();
	tools.RedDotTools:setRedDotToNode(self.btnTeam,show,nil,nil)
end

function RoundInfoPanel:onEnter( option )
	self.root:setVisible(true);
	self:addSwallowCallback(handler(self, self.onClickBack));

	self:updateRedDotShow()
	--self.panelBg:setVisible(true)
	--self.panelEventBg:setVisible(false)
	self.btnTeam:setPosition(-120, -225)
	self.btnChallenge:setPosition(120, -225)
	self.roleNode:setVisible(false)

	option = option or {fightType = FightType.Boss}
	
	self.fightType = option.fightType;
	self.select_key = option.select_key;
	self.blook = false;
	if option.blook then
		self.blook = option.blook
	end

	self.enemyRestraintString = '000';

	self.dbSpine:setVisible(false)
	if self.fightType == FightType.RandomBoss then
		self:showRandomBoss()
		if model.RoundBossModel:isValidDBAct() and model.RoundBossModel:getDBTimes()>0 then
			self.dbSpine:setVisible(true)
		end
	elseif self.fightType == FightType.Event then
		--self.panelEventBg:setVisible(true)
		--self.panelBg:setVisible(false)
		self.btnTeam:setPosition(-120, -190)
		self.btnChallenge:setPosition(120, -190)
		self.roleNode:setVisible(true)
		self:showEventInfo()
	elseif self.fightType == FightType.Boss then
		self:showDefault()
	end	

	self.loadresList = {}
	self.m_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.onEnterFrame), 1, false);
end

function RoundInfoPanel:onLeave()
	self.root:setVisible(false);
	EventManager:FireEvent(EventType.UITipsMessage);
	if self.m_scheduleHandler then 
        scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
        self.m_scheduleHandler = nil 
    end
end

function RoundInfoPanel:clearData(  )
	self.fightType = -1;
	self.onFightCallback = nil;
	self.onTeamCallback = nil;
end

function RoundInfoPanel:onExitPanel(  )
	self:clearData()
	UIManager:pop('RoundInfoPanel');
end

function RoundInfoPanel:onClickBack()
	self:onExitPanel()
end

function RoundInfoPanel:onTeamClick(sender,eventType)
	-- if true then
	-- 	local modelNode = DragonBonesManager:GetArmature( 'M003_Model' )
	-- 	modelNode:addTo(self.root)
	-- 	return;
	-- end
	AudioManager:playEffect(Conf.confirmButton)
	if self.blook then
		Prompt:Show(LANG.UI_EVENT_CLICK);
		return;
	end
	
	if self.fightType == FightType.Event then
		UIManager:push('TeamPanel', TeamType.EVENT)
	else
		UIManager:push('TeamPanel')
	end
	EventManager:FireEvent(EventType.UITeamUpdateRoundInfoOption , {fightType = self.fightType , select_key = self.select_key});
end

function RoundInfoPanel:challengeBoss()
	AudioManager:playEffect(Conf.buttonClick);
	if self.blook then
		Prompt:Show(LANG.UI_EVENT_CLICK);
		return;
	end

	if self.resEnd == false then
		Prompt:Show('resource is loading....');
		return
	end
	-- AudioManager:playCVStopBefor(model.UserModel:getKanban(), 'Joy');

	local option = {}
	if self.fightType == FightType.RandomBoss then
		local itemData = model.RoundBossModel:getBossDataByKey(self.select_key);
		if itemData ~= nil then
			option.pid = itemData.pid 
		end
	
	elseif self.fightType == FightType.Boss then 
		option.round_id = model.RoundModel:getRoundIndex()
	elseif self.fightType == FightType.DailyRound then
		option.id = self.select_key
		option.auto = false
	elseif self.fightType == FightType.Event then
		option.id = self.select_key
		if not model.TeamModel:checkEventTeam() then
			Prompt:Show(LANG.UI_TEAM_28);
			return;
		end
	end
		

	if FightManager:enterFight(self.fightType, option) then 
		UIManager:pop('RoundInfoPanel')
		self.btnChallenge:setTouchEnabled(false);
		self.btnChallenge:runAction(cc.Sequence:create(
			cc.DelayTime:create(5),
			cc.CallFunc:create(function()
				self.btnChallenge:setTouchEnabled(true)
			end)))
	end
end

function RoundInfoPanel:enableBtnChallenge()
	self.btnChallenge:setTouchEnabled(true);
end

function RoundInfoPanel:onEnterFrame()
	if self.loadresList==nil then
		return;
	end
    
	if self.resEnd==false and DownloadControler:checkNeedMonsterRes(self.loadresList) then
		self.resEnd = true
		self.loadingMsg:setVisible(false)
		self.loadingMsg:stopAllActions()
	end
end

function RoundInfoPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 8 or guideNo == 41 then
		local btn = self.btnTeam;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	elseif guideNo == 11 or guideNo == 25 or guideNo == 44 or guideNo == 52 or guideNo == 63 or guideNo == 82 then 
		local btn = self.btnChallenge;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end

	return pos;
end
return RoundInfoPanel;
