local SelectServerPanel = class("SelectServerPanel" , function (  )
	return cc.Node:create()
end)
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/setup/'

function SelectServerPanel:ctor(scene, sceneName, name)
	self:Init();
end

function SelectServerPanel:Init()
	self:initPanels()
end

function SelectServerPanel:initPanels()

	local accountLayout = ccui.Layout:create()
		:setBackGroundImage('image/task/blackbg.png')
		:setBackGroundImageScale9Enabled(true)
		:setTouchEnabled(true)
		:setContentSize(StageSize)
		:setLocalZOrder(-1)
		:setAnchorPoint(cc.p(0.5,0.5))
		:addTo(self)
	accountLayout:addClickEventListener(handler(self, self.onClickBack));

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self)
	:setScale9Enabled(true)
	:setContentSize(cc.size(514, 500))
	:setTouchEnabled(true);

	--'选服'
	GlobalFunctions:createTitleNode( bg, LANG.UI_TITLE_SERVER_6, LANG.UI_TITLE_SERVER_7,  bg:getContentSize().width/2, bg:getContentSize().height -36 );

	local bg1 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg1:setContentSize(cc.size(137 , 360));
	bg1:setPosition(cc.p(-172 , 0));
	bg1:addTo(self);

	local bg2 = ccui.Scale9Sprite:create("image/commonImg/bg_1_11_11_34_28.png");
	bg2:setContentSize(cc.size(330 , 360));
	bg2:setPosition(cc.p(75 , 0));
	bg2:addTo(self);
	
	self.serBtn = ccui.Button:create('image/commonImg/top_2_bg_59_30.png' , 'image/commonImg/top_2_bg_59_30.png')
	self.serBtn:loadTextureDisabled( 'image/commonImg/top_1_bg_59_30.png' )
	self.serBtn:addTo(self)
	self.serBtn:setPosition(-172 , 130)
	self.serBtn:addClickEventListener(handler(self , self.clickServerBtn));
	self.serBtn:setEnabled(false)
	self.serBtn:setContentSize(cc.size(114, 56))
	self.serBtn:setScale9Enabled(true)

	self.label1 = cc.Label:createWithTTF(LANG.UI_TITLE_SERVER_4 , fonts.FONT_SIYUAN , 20)--'服务器'
		:addTo(self)
		:setPosition(-172 , 130)

	for i=1,4 do
		local node = cc.Node:create()
		:addTo(self)
		:setPosition( 120*(i-2)-80, -210 )

		local rbg = cc.Sprite:create('image/commonImg/ric_27.png')
		:addTo(node)

		local tbgName = ''
		local tmsg = ''
		if i==1 then
			tbgName = 'ric_green.png'
			tmsg = LANG.UI_TITLE_SERVER_1--'流畅'
		elseif i== 2 then
			tbgName = 'ric_green.png'
			tmsg = LANG.UI_TITLE_SERVER_8--'推荐'
		elseif i==3 then
			tbgName = 'ric_red.png'
			tmsg = LANG.UI_TITLE_SERVER_2--'爆满'
		else
			tbgName = 'ric_grey.png'
			tmsg = LANG.UI_TITLE_SERVER_3--'维护'
		end

		local tbg = cc.Sprite:create('image/commonImg/'..tbgName)
		:addTo(node)

		local msgLabel = cc.Label:createWithTTF(tmsg , fonts.FONT_SIYUAN , 20)
		:addTo(node)
		:setAnchorPoint(0,0.5)
		:setPosition(20 , 0)

	end


	local initData = {
		width = 320,
		height = 350,
		cellWidth = 310 ,
		cellHeight = 70,
		direction = 1,
		cellReloadFunc = handler(self,self.reloadServerCell),
		cellTouchFunc = handler(self,self.cellServerItemTouch) ,

	}
	self.serverListView = template.TableViewTemplate:create()
	self.serverListView:initWithSizeAndItem(initData);
	self.serverListView:getView():setPosition(-80, -175);
	self.serverListView:getView():addTo(self)
	self.serverListView:getView():setVisible(true)

	self.serverList = {}
	
end

function SelectServerPanel:clickServerBtn()
	-- body
	self.serBtn:setEnabled(false)
	self.roleBtn:setEnabled(true)
	self.label1:setTextColor(cc.c3b(255 , 255 , 255))
	self.label2:setTextColor(cc.c3b(120 , 120 , 120))

	self.serverListView:getView():setVisible(true)

	AudioManager:playEffect(Conf.buttonClick);
end

function SelectServerPanel:onEnter()
	self:setVisible(true);

	--[[self.serverList = { {serverId=1, serverName='s1', st=1},
						{serverId=2, serverName='s2', st=1},
						{serverId=3, serverName='s3', st=2},
						{serverId=4, serverName='s4', st=2},
						{serverId=5, serverName='s5', st=3},
						{serverId=6, serverName='s6', st=3, roleInfo = {
							'name' => string,
							'uid'	=> int,
							'lv'	=> int,
							'head'	=> 1,
						}} 
					}
	self.serverListView:reloadData(self.serverList);
	-- self.serverListView:scrollToCellIndex(2);
	]]

	local serverInfo = model.AccountModel:getServerInfo()
	self:setServerList(serverInfo)

end

function SelectServerPanel:setServerList(serverList)
	self.serverList = {}
	if not serverList or (not type(serverList) == 'table') then
		return
	end
	for k, v in pairs(serverList) do
		table.insert(self.serverList, {serverId = v.server, serverName = tostring(v.name), st=v.state});
	end
	self.serverListView:reloadData(self.serverList);
end

function SelectServerPanel:onClickBack()
	self:setVisible(false);
end

function SelectServerPanel:onLeave()
	self:setVisible(false);
end

function SelectServerPanel:reloadServerCell(cell , index)
    local cellNode  = cell:getChildByTag(999);
	if nil == cellNode then
	 	cellNode = template.ServerCellTemplate:create(cell);
		cellNode:setTag(999);
    end

    if self.serverList[index+1] then
    	cellNode:initData( self.serverList[index+1] );
    end
end

function SelectServerPanel:cellServerItemTouch(table,cell)
	local cellNode  = cell:getChildByTag(999);
	if cellNode then
		local server = cellNode:getServer()
		if not model.AccountModel:reqEnterServer(server) then
			print('error, platform type')
		end
    end
end

return SelectServerPanel;
