local SettingCDKPanel = class("SettingCDKPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")

local EDIT_INPUT_LIMIT = 30;

function SettingCDKPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SettingCDKPanel');

	self.useCCreator = false;
	self.isPopup = true;

	self.editInputStr = ''
end

function SettingCDKPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
	self:registEvent();

end

function SettingCDKPanel:initPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(484,177));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -11);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_USER_CDKEY_1 , 484 , 46 , LANG.UI_L_USER_CDKEY_2);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 100);

	local inputNode = cc.Node:create();
	inputNode:addTo(self.root);

	local editBg = cc.Scale9Sprite:create('image/commonImg/edit_bg_28_0_177_49.png')
		:addTo(inputNode)
		:setPosition(0 , 33)
		:setCapInsets(cc.rect(28,0,177,49))
		:setContentSize(cc.size(334 , 49))

	local editImg = cc.Sprite:create('image/commonImg/edit_img.png')
		:addTo(inputNode)
		:setPosition(cc.p(134,33))

	self.tipNode = cc.Node:create()
		:addTo(inputNode)


	local label1 = cc.Label:createWithTTF(LANG.UI_SETTING_28, fonts.FONT_SIYUAN, 20) --'CDKEY码无效，请重新输入'
		:setTextColor(cc.c4b(254 , 4 , 104 , 255))
		:addTo(self.tipNode)
		:setPosition(cc.p(0,-20))
	local tipImg = cc.Sprite:create('image/commonImg/tip_3.png')
		:addTo(self.tipNode)
		:setPosition(cc.p(-label1:getContentSize().width/2-15,-20))

	local btnLabel = cc.Label:createWithTTF(LANG.COMMON_OK, fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c4b(40 , 40 , 100 , 255) , 1)
	local sendBtn = ccui.Button:create('image/commonImg/btn_9_219_55.png')
		:addTo(inputNode)
		:setPosition(cc.p(0,-47))
		:setTitleLabel(btnLabel)
		:addClickEventListener(handler(self , self.sendBtnClick));

	self.logEditInput = ccui.EditBox:create(cc.size(263,49), cc.Scale9Sprite:create())
		:setFontColor(cc.c4b(255, 255, 255, 255))
		:setMaxLength(EDIT_INPUT_LIMIT) 
		:addTo(inputNode)
		:setPlaceHolder(LANG.UI_SETTING_27)
		:setPlaceholderFontColor(cc.c4b(255,255,255,255))
		:setPlaceholderFont(fonts.FONT_SIYUAN,20)
		:setFont(fonts.FONT_SIYUAN,20)
		:setPosition(cc.p(-14,33))
		:setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
		:setInputMode(cc.EDITBOX_INPUT_MODE_SINGLELINE)
	self.logEditInput:registerScriptEditBoxHandler(function(event)
		if event == "began" then
			-- self.logEditInput:setText(self.editInputStr or "");
			self.isEdit = true
		end
		if event == "return" then
			self.isEdit = false

			local str =  self.logEditInput:getText()
			self.editInputStr = str;
			-- local str2,bRet = tools.SensitiveTools:checkSensitive( str )
			self.logEditInput:setText(str)
			-- if bRet == true then
			-- 	Prompt:Show(LANG.UI_SENSITIVE);
			-- 	return 
			-- end
		end
	end);
	-- local inputBg3 = cc.Sprite:create('image/commonImg/edit_img.png')
	-- 	:addTo(inputNode)
	-- 	:setPosition(cc.p(110,-397));
	
end
function SettingCDKPanel:registEvent()
	EventManager:RegisterEvent(EventType.NetworkRetCDKGift,handler(self,self.retCDKGift));
end
function SettingCDKPanel:sendBtnClick(sender , event)
	local text = self.editInputStr 
	if not text or text == '' then
		Prompt:Show(LANG.CHAT_9);
		return;
	end
	-- local _,bRet = tools.SensitiveTools:checkSensitive( text )
	-- if bRet == true then
	-- 	Prompt:Show(LANG.UI_SENSITIVE);
	-- 	return 
	-- end

	if #text > EDIT_INPUT_LIMIT then
		Prompt:Show(string.format( LANG.CHAT_8,EDIT_INPUT_LIMIT ));
		return;
	end
	self.editInputStr = '';
	self.logEditInput:setText('');
	model.UserModel:reqCDKGift(text);
	AudioManager:playEffect(Conf.confirmButton);
end

function SettingCDKPanel:onClickBack()
	if self.isEdit == true  then
		self.isEdit = false 
		return 
	end
	UIManager:pop('SettingCDKPanel');
end

function SettingCDKPanel:retCDKGift(msg)
	if msg == nil then
		return ;
	end
	self.logEditInput:setText('');
	self.editInputStr = '';
	
	UIManager:push('RewardPanel',msg)
end

function SettingCDKPanel:onEnter()
	self:addSwallowCallback(handler(self , self.onClickBack));
	self.logEditInput:setText('');
	self.editInputStr = '';
	self.tipNode:setVisible(false)
	self.root:setVisible(true);
end

function SettingCDKPanel:onLeave()
	self.root:setVisible(false);
end
return SettingCDKPanel;
