local SettingPanel = class("SettingPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local SDKLoginType = Enum:getTable("SDKLoginType")
local MessageBoxType = Enum:getTable('MessageBoxType')

function SettingPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SettingPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function SettingPanel:registEvent(  )
	-- 监听SDK注销事件
	EventManager:RegisterEvent(EventType.LoginUnregister, handler(self, self.retLoginUnregist));
end

function SettingPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
	self:initAccountBindNode()

	self:registEvent();
end

function SettingPanel:initAccountBindNode(  )
	self.accountBindNode = require('app.layer.MainScene.AccountBindNode'):create()
	if self.accountBindNode then
		self.accountBindNode:addTo(self.root)
			:setVisible(false)	
	end
end

function SettingPanel:initPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(604,607));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0,-56.5);

	local titleNode =  GlobalFunctions:createTitle(LANG.UI_L_PLAYERINFO_1 , 604 , 46 , LANG.UI_L_PLAYERINFO_2);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 270);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(0 , -50);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(582 , 578));

	local iconNode = cc.Node:create();
	iconNode:addTo(self.root);
	iconNode:setPosition(cc.p(-222,171)); --185

	self.qualityBg = cc.Sprite:create();
	self.qualityBg:addTo(iconNode);

	self.headIcon = cc.Sprite:create();
	local stencil = cc.Sprite:create('image/commonImg/icon_clipping_bg.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:addChild(self.headIcon);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:addTo(iconNode);

	self.level = cc.Label:createWithTTF('999' , Enum:getTable('SystemFont').FONT_SIYUAN , 13);
	self.level:addTo(iconNode);
	self.level:setAnchorPoint(0 , 0.5);
	self.level:setPosition(-39 , -30);
	self.level:enableOutline(cc.c4b(0 , 0 , 0 , 255) , 2);
	self.level:setCascadeOpacityEnabled(true);

	local expProgressBg = cc.Sprite:create("image/setup/ui_setting_exp_bg.png");
	expProgressBg:addTo(iconNode);
	expProgressBg:setPosition(cc.p(0 , -39));

	self.expProgress = cc.Scale9Sprite:create('image/setup/ui_setting_exp.png');
	self.expProgress:addTo(iconNode);
	self.expProgress:setAnchorPoint(0, 0.5);
	self.expProgress:setCapInsets(cc.rect(1,0,1,2));
	self.expProgress:setPosition(-39.5 , -39);

	local title1 = {LANG.UI_SETTING_9,LANG.UI_SETTING_10} -- 
	local infoLable = {}
	for i=1,2 do
		
		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(58 , i == 1 and 196 or 146);

		local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
		bg:addTo(node);
    	bg:setCapInsets(cc.rect(11,11,34,28));
		bg:setContentSize(cc.size(432 , 42));

		local arrow = cc.Sprite:create('image/commonImg/arrow_bg.png');
		arrow:addTo(node);
		arrow:setPosition(-187,0);
		
		local label = cc.Label:createWithTTF(title1[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setAnchorPoint(0 , 0.5);
		label:setPosition(-164 , 0);
		label:setTextColor(cc.c4b(160 , 200 , 255 , 255));

		infoLable[i] = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20)
			:addTo(node)
			:setAnchorPoint(cc.p(1,0.5))
			:setPosition(cc.p(205 , 0))
	end
	self.userName = infoLable[1];
	self.userID = infoLable[2];

	self.btnsNode = cc.Node:create()
	self.btnsNode:addTo(self.root)

	self.btnList = {};
	for i = 1 , 8 do

		local row = math.ceil(i/2);
		local col = i%2;

		local node = cc.Node:create();
		node:addTo(self.btnsNode);
		node:setPosition(col == 1 and -139 or 139 , 51 - 106 * (row-1));
		self.btnList[i] = node;

		local btn = ccui.Button:create('image/setup/ui_setting_bg_btn.png' , 'image/setup/ui_setting_bg_btn.png');
		btn:addTo(node);
		btn:setTag(i);
		btn:addClickEventListener(handler(self , self.btnListClick));
		btn:setAlphaTouchEnable(true);
	
		local icon = cc.Sprite:create('image/setup/ui_setting_bg_'..i..'.png');
		icon:addTo(node);
		icon:setPosition(-77 , -4);

		local line = cc.Sprite:create('image/setup/ui_setting_bg_btn_img.png');
		line:addTo(node);
		line:setPosition(48 , -3);

		local label = cc.Label:createWithTTF(LANG.UI_SETTING[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setPosition(51 , 15);

		label = cc.Label:createWithTTF(LANG.UI_SETTING_EN[i] , fonts.FONT_SIYUAN , 10);
		label:addTo(node);
		label:setPosition(51 , -17);
	end

	-- EventManager:RegisterEvent(EventType.UICardChangeIcon,handler(self,self.setData));
end
--[[
function SettingPanel:updateCardBookRedDot()
    local state = model.CardModel:getCardBookActiveState();
    tools.RedDotTools:setRedDotToNode(self.cardBookRedDot,state,nil,cc.p(110 , 37));
end
]]
function SettingPanel:btnListClick(sender , event)
	local index = sender:getTag();

	if index == 1 then
		UIManager:push('HeadSelectPanel');
	elseif index == 2 then
		UIManager:push('KanBanSelectPanel');
	elseif index == 3 then
		print('cdkey 兑换')
		UIManager:push('SettingCDKPanel');
	elseif index == 4 then
		print('音效设置');
		--Prompt:Show(LANG.COMMON_CLOSE);
		UIManager:push('SettingAudioPanel');
	elseif index == 5 then
		--UIManager:push('BgSelectPanel');
		self:showAccount()
	elseif index == 6 then
		self:playVideo()
	elseif index == 7 then
		self:customerService()
	elseif index == 8 then
		autolua.SDKCToollua:naverCafeStart( )
	end
end

function SettingPanel:customerService()
	local user_app_id = model.UserModel:getUserUid()
	local nickname = model.UserModel:getUserName()
	local device_info = model.AccountModel:getDeviceModel()
	local game_ver = model.AccountModel:getGameVersion();
	local os_ver = model.AccountModel:getOSVersion()
	local platform = model.AccountModel:getGameCode();
	local game_server = model.UserModel:getServer();

	local url = string.format(GlobalFunctions:getURLbyLanguage()..'&user_app_id=%s&nickname=%s&device_info=%s&game_ver=%s&os_ver=%s&platform=%s&game_server=%s',
		tostring(user_app_id),tostring(nickname),tostring(device_info),tostring(game_ver),tostring(os_ver),tostring(platform),tostring(game_server));

	cc.Application:getInstance():openURL(url)
end

function SettingPanel:showAccount(  )
	if self.accountBindNode then
		self.accountBindNode:onEnter(handler(self,self.loginOut));
	end
end

function SettingPanel:loginOut( sender,event )
	TimeManager:clearAll();
	self.platform_type = model.UserDefaultModel:getPlatformType(  );

	MessageBox:create(LANG.UI_SETTING_25 , MessageBoxType.CANCEL_OK,function()

		if self.platform_type == SDKLoginType.LOGIN_ACCOUNT or self.platform_type == SDKLoginType.LOGIN_GUEST then
			model.UserDefaultModel:setPlatformType( 0 ) 
			EventManager:FireEvent(EventType.MainSceneReplaceTitleScene);

			return;
		end
		sdkManager.SDKLuaHelper:signOut(self.platform_type,handler(self,self.retSDKLoginOut));

	end);

end

function SettingPanel:retSDKLoginOut( strData )
	TimeManager:clearAll();
	-- print("sdkLoginOutCallback === "..tostring(strData));
	local jsonData = Cjson.decode(strData)
	if jsonData == nil or jsonData.code ~= 0 then
		return 
	end

	model.AccountModel:setSDKLoginInfo({})
	model.UserDefaultModel:setPlatformType( 0 ) 
	EventManager:FireEvent(EventType.MainSceneReplaceTitleScene);

end

function SettingPanel:retLoginUnregist( msg )
	TimeManager:clearAll();
	local msgBox = MessageBox:create(LANG.ACCOUNT_5, MessageBoxType.OK, function()
		local platformType = model.UserDefaultModel:getPlatformType()
		model.AccountModel:sdkSignOut(platformType, function()
			model.AccountModel:setSDKLoginInfo({})
			model.UserDefaultModel:setPlatformType( 0 ) 
			EventManager:FireEvent(EventType.MainSceneReplaceTitleScene);
		end)
	end,function()
	end,function()
		local platformType = model.UserDefaultModel:getPlatformType()
		model.AccountModel:sdkSignOut(platformType, function()
			model.AccountModel:setSDKLoginInfo({})
			model.UserDefaultModel:setPlatformType( 0 ) 
			EventManager:FireEvent(EventType.MainSceneReplaceTitleScene);
		end)
	end);
	msgBox:setTitle(LANG.UI_TITLE_NOTICE);
end

function SettingPanel:playVideo()
	-- body
	if self.notPlayVideo then
		return;
	end
	if self.videoBg then
		return
	end

	local targetPlatform = cc.Application:getInstance():getTargetPlatform()
	if (cc.PLATFORM_OS_IPHONE == targetPlatform) or (cc.PLATFORM_OS_ANDROID == targetPlatform) then

		self.videoBg = cc.LayerColor:create(cc.c4b(0, 0, 0, 255),StageSize.width*3, StageSize.height*3)
		:addTo(self.root)
		self.videoBg:setPosition( -self.videoBg:getContentSize().width/2, -self.videoBg:getContentSize().height/2-200 )
		self.btnsNode:setVisible(false)

		local videoPlayer = ccexp.VideoPlayer:create();
		local onVideoEventCallback = function(sener, eventType)
			if eventType == ccexp.VideoPlayerEvent.COMPLETED then
				videoPlayer:stop()
				-- IOS端直接移除会导致崩溃，
				videoPlayer:runAction(cc.Sequence:create(cc.RemoveSelf:create()))
				AudioManager:resumeMusic()

				if self.videoBg then
					self.videoBg:removeFromParent();
					self.videoBg = nil;
					self.btnsNode:setVisible(true)
				end
			end
		end
		videoPlayer:setAnchorPoint(cc.p(0.5, 0.5))
		videoPlayer:setContentSize(cc.size(StageSize.width, StageSize.height))
		videoPlayer:setFileName('pv_res.mp4')
		videoPlayer:setKeepAspectRatioEnabled(true)
		videoPlayer:setTouchEnabled(false)
		videoPlayer:setFullScreenEnabled(true)
		videoPlayer:setVisible(true)
		videoPlayer:addEventListener(onVideoEventCallback)
		videoPlayer:addTo(self.root)

		AudioManager:pauseMusic()

		videoPlayer:play()
	else
		Prompt:Show('Only Android and IOS platforms are supported');
	end
	self.notPlayVideo = true;
	self.btnList[6]:runAction(cc.Sequence:create(cc.DelayTime:create(1),cc.CallFunc:create(function() 
		self.notPlayVideo = false;
	end)))
end

function SettingPanel:onClickBack()
	if self.btnsNode:isVisible() == false then
		return
	end
	UIManager:pop('SettingPanel');
end

function SettingPanel:showUserInfo(  )
	local no = model.UserModel:getHeadIcon() or 1;

	local resourceId = no
	local quality = 3;
	if no < 1000 then
		local roleData = ResTable:getRowData('role' , no);
		resourceId = roleData.resource_id;
		local cardNos=model.CardModel:getCardByNo(no);
		local maxQuality = nil;
		for pid,_v in pairs(cardNos) do
			local card = model.CardModel:GetCard(pid);
			if card and (not maxQuality or card.quality > maxQuality) then
				maxQuality = card.quality;
			end
		end
		quality = maxQuality or roleData.quality;
	else
		local roleAvatar = ResTable:getRowData('role_avatar' , no);
		resourceId = roleAvatar.resource_id;
		quality = ResTable:getValue('role' , roleAvatar.role_id , 'quality');
	end

	self.qualityBg:setTexture('image/commonImg/item_quality_'..(quality-1)..'.png');

	local imagePath = ResTable:getValue('role_resource', resourceId, 'icon');
	self.headIcon:setTexture('image/icon/'..imagePath..'.png');

	local percent = model.UserModel:getExpPercent() or 0
	local width = 79 * percent / 100;
	if width > 0 then
		width = width < 3 and 3 or width;
	end
	self.expProgress:setContentSize(cc.size(width,2));

	self.level:setString('Lv'..tostring(model.UserModel:getUserLevel()));

	local name = model.UserModel:getUserName()
	self.userName:setString(name);

	local userId = model.UserModel:getUserUid()
	self.userID:setString(userId);
end
function SettingPanel:onEnter()
	self.notPlayVideo = false;
	self:addSwallowCallback(handler(self , self.onClickBack));
	--self:updateCardBookRedDot();
	self:showUserInfo()

	self:updateVisible();

	if GlobalFunctions:isKorean() then
		self.btnList[8]:setVisible(true)
	else
		local lg = model.UserDefaultModel:getLanguageSet();
		if lg == 'jp' then
			self.btnList[8]:setVisible(true)
		else
			self.btnList[8]:setVisible(false)
		end
	end

	self.root:setVisible(true);
end

function SettingPanel:updateVisible()
	tools.ConfigStateTools:setVisibleByType(Enum:getTable('ConfigStateType').SETTING,self.btnList);
end

function SettingPanel:onLeave()
	self.root:setVisible(false);
end
return SettingPanel;
