local ShopAvatarInfoPanel = class("ShopAvatarInfoPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local CommonShopType = Enum:getTable('CommonShopType');

function ShopAvatarInfoPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ShopAvatarInfoPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function ShopAvatarInfoPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
	  self.curBuyCount = 0;
      self:InitPanels();
end

function ShopAvatarInfoPanel:InitPanels()

	self.navi = cc.Sprite:create();
	self.navi:addTo(self.root);
	self.navi:setPosition(0 , -10);

	local bg = cc.Sprite:create('image/shop/avatar_bg_4.png');
	bg:addTo(self.root);
	bg:setPosition(11 , 399);

	self.avatarName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.avatarName:addTo(self.root);
	self.avatarName:setPosition(-6 , 393);

	local haveImg = cc.Sprite:create('image/shop/avatar_bg_1.png');
	haveImg:addTo(self.root);
	haveImg:setPosition(0 , -10);


	local headNode = cc.Node:create()
		:setPosition(-210,390)
		:addTo(self.root)
	local cricleSprBG = cc.Sprite:create('image/shop/shop_avatar_cricle_bg.png');
	cricleSprBG:addTo(headNode)

	local stencil = cc.Sprite:create('image/shop/shop_avatar_stencil.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:addTo(headNode);

	self.headIcon = cc.Sprite:create();
	self.headIcon:addTo(clippingNode)

	local cricleSpr = cc.Sprite:create('image/shop/shop_avatar_cricle.png');
	cricleSpr:addTo(headNode)

end

function ShopAvatarInfoPanel:onEnter(id)
	self:addSwallowCallback(handler(self , self.onClickBack));
	
	local shopData = model.ShopModel:getShopDataByIndex(CommonShopType.AVATAR);
	if not shopData then
		return;
	end

	local avatarId = shopData[id].item[2];

	local roleAvatar = ResTable:getRowData('role_avatar', avatarId);
	local roleData = ResTable:getRowData('role',roleAvatar.role_id);
	print_ro(roleData, 'fubin')

	local iconPath = ResTable:getValue('role_resource', roleData.resource_id , 'icon');
	local roleName = ResTable:getValue('role_info', roleAvatar.role_id , 'name');

	self.avatarName:setString(roleName..'['..tostring(roleAvatar.name)..']');
	self.navi:setTexture('image/shop/avatar_icon/'..shopData[id].show..'.png');

	self.headIcon:setTexture('image/icon/'..iconPath..'.png')

	self.root:setVisible(true);
end

function ShopAvatarInfoPanel:onLeave()
	self.root:setVisible(false);
end

function ShopAvatarInfoPanel:onClickBack()
	UIManager:pop('ShopAvatarInfoPanel');
end

return ShopAvatarInfoPanel;
