local ShopGiftShowPanel = class("ShopGiftShowPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local imagePath = 'image/event/';
local MessageBoxType = Enum:getTable('MessageBoxType')
local CommonShopType = Enum:getTable('CommonShopType');

function ShopGiftShowPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ShopGiftShowPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function ShopGiftShowPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function ShopGiftShowPanel:initPanels()

	local bg = cc.Scale9Sprite:create('image/commonImg/common_tips_bg.png');
	bg:addTo(self.root);
	bg:setContentSize(cc.size(484 , 670));
	bg:setPosition(0,-10)

	-- GlobalFunctions:createTitleNode( bg, LANG.UI_MAZE_10, '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );

	self.itemName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
        :addTo(self.root)
        :setPosition(cc.p(0,280))
        :enableOutline(cc.c3b(55, 70, 100), 2)

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.root);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(462 , 512));

	self.itemView = ccui.ScrollView:create();
	self.itemView:setTouchEnabled(true);
	self.itemView:setBounceEnabled(true);
	self.itemView:setDirection(ccui.ScrollViewDir.vertical);
	self.itemView:setContentSize(cc.size(462, 500));
	self.itemView:setAnchorPoint(cc.p(0.5, 0.5));
	self.itemView:setScrollBarEnabled(false);
	self.itemView:addTo(self.root);

	local btnNode = cc.Node:create()
	btnNode:addTo(self.root)
	btnNode:setPosition(0, -300)

	local btn = ccui.Button:create('image/commonImg/btn_1_219_55.png' ,'image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	btn:addTo(btnNode);
	btn:addClickEventListener(handler(self , self.onClickBuy));

	local btnIcon = cc.Sprite:create('image/shop/currency_icon.png')
	btnIcon:addTo(btnNode)
	btnIcon:setPosition(-50, 0)

	self.priceLabel = cc.Label:createWithTTF(LANG.UI_MAZE_12, fonts.FONT_SIYUAN, 20)
		:enableOutline(cc.c3b(55,85,155), 2)
		:setPosition(10, 0)
		:addTo(btnNode)
	-- local tipSpr = cc.Sprite:create('image/commonImg/tip_2.png')
	-- tipSpr:addTo(self.root)
	-- tipSpr:setPosition( -10-self.infoLabel:getContentSize().width/2, -440 )
end

function ShopGiftShowPanel:onEnter( shopType, itemId, callback )

	local shopData = model.ShopModel:getShopDataByIndex(shopType);
	local data = shopData[itemId]
	self.itemData = data;
	self.itemId = itemId;
	self.callback = callback;

	local name = data.giftname or ResTable:getLangByNum(data.giftname_no);
    self.itemName:setString(tostring(name));
    self.priceLabel:setString(tostring(data.price));

    local itemNum = #data.item;
	local maxWidth = 462;
	local maxHeight = itemNum*90;
	maxHeight = maxHeight < 500 and 500 or maxHeight;

	self.itemView:removeAllChildren();
	self.itemView:setInnerContainerSize(cc.size(maxWidth , (maxHeight)));

	for i=1, itemNum do
		local cellData = data.item[i];
		local img,num,name = GlobalFunctions:getItemIconFileAndNum(data.item[i]);

		local cellNode = cc.Node:create()
		cellNode:addTo(self.itemView)
		cellNode:setPosition(maxWidth/2, maxHeight-(i-1)*90-45)

		local cellbg = cc.Scale9Sprite:create('image/commonImg/exit_bg.png');
		cellbg:addTo(cellNode);
		cellbg:setContentSize(cc.size(450 , 84));

		local template = template.ItemTemplate:create();
        template:addTo(cellNode);
        template:setPosition(-170 , 0);
        template:setScale(0.6)
        template:Init(cellData[1], cellData[2])

        local cellName = cc.Label:createWithTTF(name , fonts.FONT_SIYUAN , 20)
        :addTo(cellNode)
        :setPosition(cc.p(-120,0))
        :setAnchorPoint(0, 0.5)
        :enableOutline(cc.c3b(50, 50, 50), 2)

        local cellNum = cc.Label:createWithTTF(tostring(num) , fonts.FONT_SIYUAN , 20)
        :addTo(cellNode)
        :setPosition(cc.p(150,0))
        :enableOutline(cc.c3b(50, 50, 50), 2)
		
	end

	self.root:setVisible(true);
	self:addSwallowCallback(handler(self , self.onClickBack));

end

function ShopGiftShowPanel:onClickBack()
	UIManager:pop('ShopGiftShowPanel');
end

function ShopGiftShowPanel:onClickBuy()
	local costItemName = LANG.UI_RECHARGE_7
    local nameStr = self.itemData.giftname or ResTable:getLangByNum(self.itemData.giftname_no);
    local msg = string.format(LANG.UI_SHOP_67 , self.itemData.price ,costItemName, nameStr , 1)
    MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
        local buyItem = {
            no = self.itemId,
            type = 3
        }
        sdkManager.PaymentHelper:onPayment(buyItem,handler(self,self.giftPaymentCallback));
    end);

end

function ShopGiftShowPanel:giftPaymentCallback( msg )
	UIManager:pop('ShopGiftShowPanel');
    if self.callback then
    	self.callback(msg)
    end
end

function ShopGiftShowPanel:onLeave()
	self.root:setVisible(false);
end

return ShopGiftShowPanel;
