local ShopPanel = class('ShopPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local CommonShopType = Enum:getTable('CommonShopType');
local imagePath = 'image/shop/'

local boxWidth = {
    [1] = 150,
    [2] = 200,
    [3] = 300,
    [4] = 400,
    [5] = 600
}

local SCROLL_VIEW_WIDTH = 600
local SCROLL_VIEW_HEIGHT = 628;

function ShopPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ShopPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = false;
end

function ShopPanel:Init(root)
	-- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel();

    -- monthCard
    self:initMonthCard()
    --growup
    self:initGrowup();

    self:initGiftMenuBar();

    self:registEvent();
end

function ShopPanel:initPanel(  )

    self.commonNode = cc.Node:create();
    self.commonNode:addTo(self.root);
    
	self.bg = cc.Sprite:create('image/bg/Bg_5.png');
	self.bg:addTo(self.commonNode);

    local topHeight = NOTCH_HEIGHT+154
	self.topBg = cc.Sprite:create('image/shop/shop_top_bg.png')
        :setPosition(cc.p(0,StageSize.height/2-topHeight))
        :addTo(self.commonNode)

    local titleHeight = 46;
    local topBgHeight = self.topBg:getContentSize().height;
    local titltPosY = StageSize.height/2-topHeight-topBgHeight/2-titleHeight/2;

	self.shopTitleNode = GlobalFunctions:createTitle(LANG.UI_SHOP_FOOTER[1],640,46);
    self.shopTitleNode:addTo(self.commonNode);
    self.shopTitleNode:setPosition(0 , titltPosY);

	self.shopTitle = self.shopTitleNode:getChildByName('title');

    local bgHeight = StageSize.height-topHeight-topBgHeight/2-titleHeight-FOOTER_HEIGHT;
    local bgPosY = titltPosY-titleHeight/2-bgHeight/2;
    local bgList = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
    bgList:addTo(self.commonNode);
    bgList:setPosition(0 , bgPosY);
    bgList:setCapInsets(cc.rect(11,4,18,21));
    bgList:setContentSize(cc.size(640 , bgHeight));
    self.oldBgHeight = bgHeight;
    self.oldBgY = bgPosY;
    self.bgList = bgList;

    SCROLL_VIEW_HEIGHT = bgHeight-62;
    
    local scrollPosY = bgPosY - bgHeight/2 + 51;
    self.shopScrollView = ccui.ScrollView:create();
	self.shopScrollView:setTouchEnabled(true);
	self.shopScrollView:setBounceEnabled(true);
	self.shopScrollView:setDirection(ccui.ScrollViewDir.vertical);
    self.shopScrollView:setScrollBarEnabled(false);
    self.shopScrollView:addTo(self.root);
    self.shopScrollView:setContentSize(cc.size(600 , SCROLL_VIEW_HEIGHT));
    self.shopScrollView:setPosition(-300 , scrollPosY);
    self.oldShopScrollVPosY = scrollPosY;
    --self.shopScrollView:setLocalZOrder(50);

    self.bottomNode = cc.Node:create()
    :addTo(self.root)
    :setPosition(0,bgPosY - bgHeight/2)
    self.oldBottomPosY = bgPosY - bgHeight/2;

    local bg = cc.Scale9Sprite:create('image/commonImg/list_mask_1_4_0__23_34.png')
    :addTo(self.bottomNode)
    :setCapInsets(cc.rect(4,0,27,34))
	:setContentSize(cc.size(640 , 34))
    :setPosition(0,57)

    local line = cc.Sprite:create('image/commonImg/line.png');
	line:addTo(self.bottomNode);
	line:setContentSize(cc.size(640,1))
    line:setPosition(cc.p(0,41));
    
    --退款声明
    self.refundNode = cc.Node:create()
    :addTo(self.bottomNode)
    :setVisible(false)
    :setPosition(0,20)

    local refundLable = cc.Label:createWithTTF(LANG.UI_SHOP_80..LANG.UI_SHOP_81, fonts.FONT_SIYUAN , 16)
        :setTextColor(cc.c3b(255 , 200 , 55))
        :setAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER,cc.TEXT_ALIGNMENT_CENTER)
        :setDimensions(600,30)

    local refundBtn = cc.ControlButton:create(refundLable,ccui.Scale9Sprite:create())
        :addTo(self.refundNode)
        -- :setAnchorPoint(cc.p(1,0.5))
        :setColor(cc.c3b(255 , 200 , 55))
        :setTitleColorForState(cc.c3b(255 , 200 , 55),cc.CONTROL_STATE_NORMAL)
    refundBtn:setZoomOnTouchDown(false)

    refundBtn:registerControlEventHandler(function (touch, event)
        local url = 'https://ramengo.nanisoft.co.kr/policy/cancel.html';
        cc.Application:getInstance():openURL(url)
    end, cc.CONTROL_EVENTTYPE_TOUCH_UP_INSIDE )


    self.haveMoneyNode = cc.Node:create()
        :addTo(self.root)
        :setPosition(193 , titltPosY)
        :setLocalZOrder(100)

    local bg = cc.Sprite:create('image/commonImg/bg_3_200_42.png')
        :addTo(self.haveMoneyNode)

    self.moneyIcon = cc.Sprite:create()
        :addTo(self.haveMoneyNode)
        :setPosition(-71 , 0)
        :setScale(0.35)

    local moneyLabel = cc.Label:createWithTTF(LANG.UI_CARD_19 , fonts.FONT_SIYUAN , 20)
        :addTo(self.haveMoneyNode)
        :setPosition(-26 , 0)
        :setTextColor(cc.c3b(160 , 200 , 255))

    self.moneyNum = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
        :addTo(self.haveMoneyNode)
        :setAnchorPoint(1 , 0.5)
        :setPosition(86 , 0)

    -- menuNode
    local menuNode = cc.Node:create();
    menuNode:addTo(self.root);
    menuNode:setLocalZOrder(10);
    menuNode:setPosition(0 , 49 - StageSize.height / 2);
    self.menuNode = menuNode;

    local menuBg = cc.Sprite:create('image/footer/footer_bg_1.png');
    menuBg:addTo(menuNode);

    self.menuSelectImg = cc.Scale9Sprite:create('image/footer/footer_bg_2.png');
    self.menuSelectImg:addTo(menuNode);
    self.menuSelectImg:setContentSize(cc.size(128, 93))

    local light = cc.Sprite:create('image/footer/footer_bg_4.png');
	light:addTo(menuNode);
    light:setPosition(0,43)
    
    self.lineList = {};
	for i = 1 , 4 do
		local line = cc.Sprite:create('image/footer/footer_bg_3.png')
		line:addTo(menuNode);
		-- line:setPosition(-217 + (i-1)*108 , 0);
        line:setPosition(-192 + (i-1)*128 , 0);

		self.lineList[i] = line;
	end
    
    self.menuBtnList = {};
    self.menuLabelList = {};
    self.shopTypePos = {};
    
    local shopTypes = {
        CommonShopType.SHOP,
        CommonShopType.GIFT,
        --CommonShopType.GROWUP,
        CommonShopType.MONTH_CARD,
        CommonShopType.RECHARGE,
        CommonShopType.AVATAR};
    for i , shopType in ipairs(shopTypes) do
        -- self.shopTypePos[shopType] = cc.p(-268 + 108*(i-1),5)
        self.shopTypePos[shopType] = cc.p(-156 + 128*(i-1),5)
        local node = cc.Node:create();
        node:addTo(menuNode);
        node:setPosition(self.shopTypePos[shopType]);
        node:setCascadeOpacityEnabled(true);
        self.menuBtnList[shopType] = node;

        local menuBtn = ccui.Button:create(imagePath..'shop_footer_bg_'..shopType..'.png',imagePath..'shop_footer_bg_'..shopType..'.png');
        menuBtn:addTo(node);
        menuBtn:setTag(shopType);
        menuBtn:addClickEventListener(handler(self , self.menuBtnClick));

        local label = cc.Label:createWithTTF(LANG.UI_SHOP_FOOTER[shopType] , fonts.FONT_SIYUAN , 16);
        label:addTo(node);
        label:setPosition(cc.p(0 , -39));
        label:enableOutline(cc.c3b(0 , 0 , 0),2);
        self.menuLabelList[shopType] = label;
    end
    self:initGrowupMenuNode();
end

function ShopPanel:initGrowupMenuNode()
    -- menuNode
    local menuNode = cc.Node:create();
    menuNode:addTo(self.root);
    menuNode:setLocalZOrder(10);
    menuNode:setPosition(0 , 49 - StageSize.height / 2);
    self.growupMenuNode = menuNode;

    local menuBg = cc.Sprite:create('image/footer/footer_bg_1.png');
    menuBg:addTo(menuNode);

    self.GpMenuSelectImg = cc.Scale9Sprite:create('image/footer/footer_bg_2.png');
    self.GpMenuSelectImg:addTo(menuNode);
    self.GpMenuSelectImg:setContentSize(cc.size(128, 93))

    local light = cc.Sprite:create('image/footer/footer_bg_4.png');
    light:addTo(menuNode);
    light:setPosition(0,43)
    
    for i = 1 , 4 do
        local line = cc.Sprite:create('image/footer/footer_bg_3.png')
        line:addTo(menuNode);
        line:setPosition(-192 + (i-1)*128 , 0);
    end
    
    self.GpMenuBtnList = {};
    local shopTypes = {
        CommonShopType.GROWUP,
        CommonShopType.GROWUP_SP};
    for i , shopType in pairs(shopTypes) do
        -- self.shopTypePos[shopType] = cc.p(-268 + 108*(i-1),5)
        self.shopTypePos[shopType] = cc.p(-256 + 128*(i-1),5)
        local node = cc.Node:create();
        node:addTo(menuNode);
        node:setPosition(self.shopTypePos[shopType]);
        node:setCascadeOpacityEnabled(true);
        self.GpMenuBtnList[shopType] = node;

        local menuBtn = ccui.Button:create(imagePath..'shop_footer_bg_'..shopType..'.png',imagePath..'shop_footer_bg_'..shopType..'.png');
        menuBtn:addTo(node);
        menuBtn:setTag(shopType);
        menuBtn:addClickEventListener(handler(self , self.menuBtnClick));

        local label = cc.Label:createWithTTF(LANG.UI_SHOP_FOOTER[shopType] , fonts.FONT_SIYUAN , 16);
        label:addTo(node);
        label:setPosition(cc.p(0 , -39));
        label:enableOutline(cc.c3b(0 , 0 , 0),2);
        self.menuLabelList[shopType] = label;
    end
end

function ShopPanel:initGrowup()
    self.growupNode = cc.Node:create()
        :addTo(self.root)

    self.growupBtnNode = cc.Node:create()
        :addTo(self.growupNode)
        :setPosition(-108,StageSize.height/2-234-NOTCH_HEIGHT)
    local growupBuyBtn = ccui.Button:create(imagePath..'grow_up_1.png',imagePath..'grow_up_1.png');
    growupBuyBtn:addTo(self.growupBtnNode);
    growupBuyBtn:addClickEventListener(function() 
        local buyItem = {
            no = 1,
            type = 5
        }
        if self.curShopType == CommonShopType.GROWUP_SP then
            buyItem.no = 58;
            buyItem.type = 5;
        end
        sdkManager.PaymentHelper:onPayment(buyItem,handler(self,self.rechargePaymentCallback));
    end);

    local bg = cc.Sprite:create(imagePath..'grow_up_2.png');
    bg:addTo(self.growupBtnNode)
    bg:setPosition(0,-14)

    local growupBuyLabel = cc.Label:createWithTTF(LANG.UI_SHOP_101,fonts.FONT_SIYUAN,13)
        :setPosition(0,-14)
        :addTo(self.growupBtnNode)

    self.growupPrice = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
        :setPosition(0,13)
        :enableOutline(cc.c3b(145,40,40),2)
        :addTo(self.growupBtnNode)
end

function ShopPanel:initMonthCard( ... )
    self.monthCardNode = cc.Node:create();
    self.monthCardNode:addTo(self.root);

    local titlePosY = self.shopTitleNode:getPositionY();
    -- 坐标
    local monthPos = {--254
        cc.p(-148,titlePosY-145), 
        cc.p(148,titlePosY-145),
        cc.p(-148,titlePosY-390),
    }
    self.monthCard = {}
    local idx = 1;
    local mcardList = GlobalFunctions:sortTableByKey(ResTable:getTable('month_card').contain);
    -- for i=1,3 do
    for k,v in pairs(mcardList) do
       	-- local data = ResTable:getRowData('month_card', i);
        local data = v;
        if data.hidden ~= 1 then
            local i = v.id;
            self.monthCard[i] = {}

            self.monthCard[i].node = cc.Node:create()
                :addTo(self.monthCardNode)
                -- :setPosition(monthPos[i])
                :setPosition((1-idx%2)*148*2-148, titlePosY-(((math.floor((idx-1)/2))*245+145)))
            idx = idx + 1
            local bg = ccui.ImageView:create(imagePath.. 'month_bg1.png')
                :addTo(self.monthCard[i].node)
                :setAnchorPoint(cc.p(0.5,0.5))
                :setTouchEnabled(true)
                :setTag(i)
            bg:addClickEventListener(handler(self,self.onBuyMonthCard));
            local item_bg = cc.Sprite:create( imagePath.. 'month_item_'.. i ..'.png')
                :addTo(self.monthCard[i].node)
                --:setPosition(cc.p(0,17))
            
            local currency_icon = cc.Sprite:create( imagePath.. 'currency_icon.png')
                :addTo(self.monthCard[i].node)
                :setPosition(cc.p(-115,-85))

            local price = ResTable:getValue('price', data.price, CURRENCY) or 0;
            self.monthCard[i].money = cc.Label:createWithTTF(tostring(price) , fonts.FONT_SIYUAN , 16)
                :addTo(self.monthCard[i].node)
                :setPosition(cc.p(90,-98))
                :setAnchorPoint(cc.p(1,0))

            self.monthCard[i].activity = cc.Node:create()
                :addTo(self.monthCard[i].node)
                :setVisible(false)    
            local activityBg = cc.Sprite:create( imagePath.. 'month_bg1_2.png')
                :addTo(self.monthCard[i].activity)
           
            self.monthCard[i].rewardTitle = cc.Label:createWithTTF(LANG.UI_ACTIVITY_13, fonts.FONT_SIYUAN, 14)
                :enableOutline(cc.c3b(55, 85, 155), 2)
            self.monthCard[i].rewardBtn = ccui.Button:create('image/commonImg/btn_55_22_1.png')
    		    :setTitleLabel(self.monthCard[i].rewardTitle)
                :addTo(self.monthCard[i].activity)
                :setPosition(cc.p(-91,-48))
    			:setTag(i)
    		self.monthCard[i].rewardBtn:addClickEventListener(handler(self, self.onGetMonthCardReward))
            
            local activityTimeBg = cc.Sprite:create( imagePath.. 'month_item_time.png')
                :addTo(self.monthCard[i].activity)
                :setPosition(cc.p(0,57))
            local activityTimeBg2 = cc.Sprite:create('image/commonImg/btn_52_23_1.png')
                :addTo(self.monthCard[i].activity)
                :setPosition(cc.p(-33,56))
            local activityLabel1 = cc.Label:createWithTTF(LANG.UI_SHOP_77 , fonts.FONT_SIYUAN , 11)
                :addTo(self.monthCard[i].activity)
                :setPosition(cc.p(-33,56))
                :enableOutline(cc.c3b(235, 170, 0), 2)
            self.monthCard[i].activityDay = cc.Label:createWithTTF(string.format(LANG.UI_ACTIVITY_38, 30) , fonts.FONT_SIYUAN , 14)
                :addTo(self.monthCard[i].activity)
                :setPosition(cc.p(0,56))
                :setAnchorPoint(cc.p(0,0.5))
                :enableOutline(cc.c3b(60, 60, 60), 2)

            local spine_res = 'shop_bg_effect'
            if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
                local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
                spine:addTo(self.monthCard[i].node)
                spine:setAnimation(0,'month1',true);
            end
        end
    end

end

function ShopPanel:initGiftMenuBar()
    self.giftMenuIdx = 1;
    self.giftMenuNode = cc.Node:create();
    self.giftMenuNode:addTo(self.commonNode);
    local posY = self.shopTitleNode:getPositionY()
    self.giftMenuNode:setPosition(0 , posY-40);

    local labelName = {
        LANG.UI_SHOP_GIFT_0,
        LANG.UI_SHOP_GIFT_TITLES[1],
        LANG.UI_SHOP_GIFT_TITLES[2],
        LANG.UI_SHOP_GIFT_TITLES[3],
    }

    self.giftMenuList = {};
    local menuWidth = 640 / 4;
    local menuStartPosX = menuWidth/2 - 640/2;
    for i=1,4 do

        local label = cc.Label:createWithTTF(labelName[i] , fonts.FONT_SIYUAN , 18);
        label:setScaleX(i == 4 and -1 or 1);

        local texture = 'image/commonImg/menu_left_71_46.png';
        local unTexture = 'image/commonImg/menu_left_71_46_u.png';

        if i == 2 or i == 3 then
            texture = 'image/commonImg/menu_mid_71_46.png';
            unTexture = 'image/commonImg/menu_mid_71_46_u.png';
        end
        local bgBtn = ccui.Button:create(texture,texture,unTexture);
        bgBtn:addTo(self.giftMenuNode);
        bgBtn:setTag(i);
        bgBtn:setTitleLabel(label)
        bgBtn:setScale9Enabled(true);
        bgBtn:setScaleX(i == 4 and -1 or 1);
        bgBtn:setCapInsets(cc.rect(10 , 0 , 51 , 46));
        bgBtn:setContentSize(cc.size(menuWidth , 46));
        bgBtn:setPosition(menuStartPosX + menuWidth*(i-1) , 0)
        bgBtn:addClickEventListener(handler(self , self.giftMenuClick));
        self.giftMenuList[i] = bgBtn;
    end

    self.giftlight = cc.Sprite:create('image/commonImg/menu_light_1.png');
    self.giftlight:addTo(self.giftMenuNode);
    self.giftlight:setPosition(cc.p(-266.5, 23));
end

function ShopPanel:registEvent(  )
    EventManager:RegisterEvent(EventType.UIRetShopInfo, handler(self, self.onShow));
    EventManager:RegisterEvent(EventType.UIBuyShopItemSuccess, handler(self, self.retShopBuy));
    EventManager:RegisterEvent(EventType.NetworkRetRechargeRewardMonthCard , handler(self,self.retMonthCardReward));
    EventManager:RegisterEvent(EventType.NetworkRetRechargeInfo,handler(self,self.onShow));
    EventManager:RegisterEvent(EventType.NetworkRetRechargeGrowupReward,handler(self,self.retGetGrowupRreward));
    EventManager:RegisterEvent(EventType.NetworkRetRechargeGiftFree,handler(self,self.retGetGiftFree));
end

function ShopPanel:menuBtnClick(sender , event)
    local tag = sender:getTag();
    if tools.ConfigStateTools:checkLockByType(Enum:getTable('ConfigStateType').SHOP , tag) then
        Prompt:Show(LANG.COMMON_CLOSE);
        return;
    end

    self:changeMenuIndex(tag);

end

function ShopPanel:changeMenuIndex( index )
    
    if index == nil or self.curShopType == index  then
        return 
    end

	if index == CommonShopType.MONTH_CARD and model.RechargeModel:hasInitOk() ~= true then
        self.reqChangeIndex = index;
        model.RechargeModel:reqRechargeInfo()
        return
    elseif index == CommonShopType.GROWUP or index == CommonShopType.GROWUP_SP then
        self.curShopType = index;
        self.reqChangeIndex = nil;

	elseif not model.ShopModel:shopHasInit(index) then
        self.reqChangeIndex = index;
        model.ShopModel:reqShopInfo(index);
        return
    end

    self.curShopType = index;
    self:onShow();
end

function ShopPanel:onShow()
    if self.reqChangeIndex then
        self.curShopType = self.reqChangeIndex;
        self.reqChangeIndex = nil;
    end

    self:swtichShopList()
end

function ShopPanel:updateShopData()
    self.shopData = {};
    if self.curShopType == CommonShopType.GROWUP then
        local growupData = model.RechargeModel:getGrowupData();
        local growupState = model.RechargeModel:getGrowupState();
        local growupPrice = model.RechargeModel:getGrowupPrice();
    
        self.growupBtnNode:setVisible(growupState ~= 1);

        local price = ResTable:getValue('price', growupPrice, CURRENCY) or 0;
        self.growupPrice:setString(string.format(LANG.UI_SHOP_72,tostring(price)));

        for _k , data in pairs(growupData) do
            table.insert(self.shopData,data);
        end
    
        local totalNum = #self.shopData;
        if totalNum > 1 then
            table.sort(self.shopData, function(first , second) 
                return  first.no < second.no;
            end);
        end
    elseif self.curShopType == CommonShopType.GROWUP_SP then
        local growupData = model.RechargeModel:getGrowupSpData();
        local growupState = model.RechargeModel:getGrowupSpState();
        local growupPrice = model.RechargeModel:getGrowupSpPrice();
    
        self.growupBtnNode:setVisible(growupState ~= 1);

        local price = ResTable:getValue('price', growupPrice, CURRENCY) or 0;
        self.growupPrice:setString(string.format(LANG.UI_SHOP_72,tostring(price)));

        for _k , data in pairs(growupData) do
            table.insert(self.shopData,data);
        end
    
        local totalNum = #self.shopData;
        if totalNum > 1 then
            table.sort(self.shopData, function(first , second) 
                return  first.no < second.no;
            end);
        end
    else
        local shopData = model.ShopModel:getShopDataByIndex(self.curShopType);
        if not shopData then
            return;
        end
    
        if self.curShopType == CommonShopType.RECHARGE then
            local shopDatas = {};
            for _k , data in pairs(shopData) do
                table.insert(self.shopData , data);
            end
    
            local shopNum = #self.shopData;
            if shopNum > 1 then
                table.sort(self.shopData , function(first , second)
                    return first.diamond < second.diamond;
                end);
            end
        elseif self.curShopType == CommonShopType.AVATAR then
            for _k , data in pairs(shopData) do
                table.insert(self.shopData , data);
            end
    
            if #self.shopData > 1 then
                table.sort(self.shopData , function(first , second)
                    if first.times > 0 and second.times == 0 then
                        return true
                    elseif first.times == 0 and second.times > 0 then
                        return false
                    end
                    return (first.order or first.no) <(second.order or second.no);
                end);
            end
        elseif self.curShopType == CommonShopType.GIFT then
            for _k , data in pairs(shopData) do
                if data.type == (self.giftMenuIdx-1) then
                    if data.type == 0 then
                        if data.times>0 then
                            table.insert(self.shopData , data);
                        end
                    else
                        table.insert(self.shopData , data);
                    end
                end
            end
    
            if #self.shopData > 1 then
                table.sort(self.shopData , function(first , second) 
                    return (first.order or first.no) <(second.order or second.no);
                end);
            end
        else
            for _k , data in pairs(shopData) do
                table.insert(self.shopData , data);
            end
    
            if #self.shopData > 1 then
                table.sort(self.shopData , function(first , second) 
                    return (first.order or first.no) <(second.order or second.no);
                end);
            end
        end
    end
end

function ShopPanel:swtichNode(curShopType)
    self.monthCardNode:setVisible(curShopType == CommonShopType.MONTH_CARD)
    self.shopScrollView:setVisible(curShopType ~= CommonShopType.MONTH_CARD);
    self.haveMoneyNode:setVisible(curShopType == CommonShopType.AVATAR);
    self.growupNode:setVisible(curShopType == CommonShopType.GROWUP or curShopType == CommonShopType.GROWUP_SP);

    self.giftMenuNode:setVisible(curShopType == CommonShopType.GIFT);
    if curShopType == CommonShopType.GIFT then
        self.shopScrollView:setContentSize(cc.size(600 , SCROLL_VIEW_HEIGHT-30));
        self.shopScrollView:setPosition(-300 , self.oldShopScrollVPosY-0);
    elseif curShopType == CommonShopType.GROWUP then
        -- self.shopScrollView:setContentSize(cc.size(600 , SCROLL_VIEW_HEIGHT+100));
        -- self.shopScrollView:setPosition(-300 , self.oldShopScrollVPosY-100);
        self.shopScrollView:setContentSize(cc.size(600 , SCROLL_VIEW_HEIGHT));
        self.shopScrollView:setPosition(-300 , self.oldShopScrollVPosY);
    else
        self.shopScrollView:setContentSize(cc.size(600 , SCROLL_VIEW_HEIGHT));
        self.shopScrollView:setPosition(-300 , self.oldShopScrollVPosY);
    end

    if curShopType == CommonShopType.AVATAR then
        self.bg:setTexture('image/bg/Bg_14.png');
    else
        self.bg:setTexture('image/bg/Bg_5.png');
    end
end

function ShopPanel:swtichShopList()
    if self.menuBtnList[self.curShopType] then
        local posX = self.menuBtnList[self.curShopType]:getPositionX();
        self.menuSelectImg:setPosition(posX , -1);
    end
    if self.GpMenuBtnList[self.curShopType] then
        local posX = self.GpMenuBtnList[self.curShopType]:getPositionX();
        self.GpMenuSelectImg:setPosition(posX , -1);
    end

    for _k , label in ipairs(self.menuLabelList) do
        label:enableOutline(_k==self.curShopType and cc.c3b(30 , 80 , 140) or cc.c3b(0 , 0 , 0),2);
    end

    self:swtichNode(self.curShopType);
    self.refundNode:setVisible(false)
    if GlobalFunctions:isKorean() then
        self.refundNode:setVisible(true)
    end
    if self.curShopType == CommonShopType.SHOP then
        --self.topBg:setPosition(cc.p(0,StageSize.height/2-165))
        self.topBg:setTexture('image/shop/shop_top_bg.png')
        self.shopTitle:setString(LANG.UI_SHOP_FOOTER[self.curShopType])
        self:shopList();
    elseif self.curShopType == CommonShopType.GIFT then
        --self.topBg:setPosition(cc.p(0,StageSize.height/2-165))
        self.topBg:setTexture('image/shop/shop_top_bg_gift.png')
        self.shopTitle:setString(LANG.UI_SHOP_FOOTER[self.curShopType])
        self:giftSwitchList(self.giftMenuIdx)
        self:showGiftList();
    elseif self.curShopType == CommonShopType.MONTH_CARD then
        --self.topBg:setPosition(cc.p(0,StageSize.height/2-165))
        self.shopTitle:setString(LANG.UI_SHOP_FOOTER[self.curShopType])
        self.topBg:setTexture('image/shop/shop_top_bg_month.png')
        --self.refundNode:setVisible(true)
        self:showMonthCard()
    elseif self.curShopType == CommonShopType.RECHARGE then
        --self.topBg:setPosition(cc.p(0,StageSize.height/2-165))
        self.topBg:setTexture('image/shop/shop_top_recharge.png')
        self.shopTitle:setString(LANG.UI_SHOP_96)
        --self.refundNode:setVisible(true)
        self:shopList();
    elseif self.curShopType == CommonShopType.AVATAR then
        --self.topBg:setPosition(cc.p(0,StageSize.height/2-165))
        self.topBg:setTexture('image/shop/shop_top_avatar.png')
        self.shopTitle:setString(LANG.UI_SHOP_FOOTER[self.curShopType])
        self:showAvatarList();
    elseif self.curShopType == CommonShopType.GROWUP then
        --self.topBg:setPosition(cc.p(0,StageSize.height/2-154))
        self.topBg:setTexture('image/shop/shop_top_growup.png')
        self.shopTitle:setString(LANG.UI_SHOP_FOOTER[self.curShopType])
        self:shopList();
    elseif self.curShopType == CommonShopType.GROWUP_SP then
        --self.topBg:setPosition(cc.p(0,StageSize.height/2-154))
        self.topBg:setTexture('image/shop/shop_top_growup_sp.png')
        self.shopTitle:setString(LANG.UI_SHOP_FOOTER[self.curShopType])
        self:shopList();
    end

    self:updateHaveMoney();
end

function ShopPanel:showGiftList()
    self:updateShopData();

    self.shopItems = {};
    self.shopScrollView:removeAllChildren();
    
    local heightNum = 1;
    local widthRow = 0;
    local dataRow = {};
    for _k , data in ipairs(self.shopData) do
        local item = template.ShopGiftTemplate:create();
        item:Init(data);
      
        local posX = 0;
        -- local bWidth = boxWidth[data.icon_type];
        local bWidth = boxWidth[2];
        local curWitdh = widthRow + bWidth;
        if curWitdh > SCROLL_VIEW_WIDTH then
            posX = bWidth / 2;
            widthRow = bWidth;
            heightNum = heightNum + 1;
        else
            posX = widthRow + bWidth / 2;
            widthRow = curWitdh;
        end

        dataRow[_k] = heightNum;

        item:setPositionX(posX);
        item:addTo(self.shopScrollView);
        item:setItemTag(data.no);
        item:addItemClickEventListener(handler(self , self.listItemClick));
        self.shopItems[data.no] = item;
    end

    local maxHeight = heightNum * 229;
    if maxHeight < SCROLL_VIEW_HEIGHT then
        maxHeight = SCROLL_VIEW_HEIGHT;
    end

    self.shopScrollView:setInnerContainerSize(cc.size(SCROLL_VIEW_WIDTH,maxHeight))

    for _k , data in ipairs(self.shopData) do
        local posY = maxHeight - 114.5 - (dataRow[_k]-1) * 229;
        self.shopItems[data.no]:setPositionY(posY);
    end
end

function ShopPanel:shopList()
    self:updateShopData();

    self.shopItems = {};
    self.shopScrollView:removeAllChildren();
    local num = math.ceil(#self.shopData/3);
    local maxHeight = num * 203+5;
    local extH = 0 --self.curShopType == CommonShopType.GROWUP and 100 or 0
    if maxHeight < SCROLL_VIEW_HEIGHT+extH then
        maxHeight = SCROLL_VIEW_HEIGHT+extH;
    end

    self.shopScrollView:setInnerContainerSize(cc.size(600,maxHeight))

    for _k , data in ipairs(self.shopData) do
        local row = math.ceil(_k / 3);
        local col = _k % 3;
        col = col == 0 and 3 or col;
      
        local item = nil;
        if self.curShopType == CommonShopType.SHOP then
            item = template.ShopItemTemplate:create();
        elseif self.curShopType == CommonShopType.RECHARGE then
            item = template.ShopRechargeItemTemplate:create();
        elseif self.curShopType == CommonShopType.GROWUP or self.curShopType == CommonShopType.GROWUP_SP then
            item = template.ShopGrowupTemplate:create();
        end
        item:Init(data, self.curShopType);
        item:setPosition(101 + (col-1) * 198 , maxHeight-100-(row - 1)*203);
        item:addTo(self.shopScrollView);
        item:setItemTag(data.no);
        item:addItemClickEventListener(handler(self , self.listItemClick));
        self.shopItems[data.no] = item;
    end
end

function ShopPanel:showAvatarList()
    self:updateShopData();

    self.shopItems = {};
    self.shopScrollView:removeAllChildren();
    --self.shopScrollView:setPosition(0 , -106);

    local totalNum = #self.shopData;
    totalNum = totalNum < 12 and 12 or totalNum;
    local num = math.ceil(totalNum/4);
    local maxHeight = num * 240;
    if maxHeight < SCROLL_VIEW_HEIGHT then
        maxHeight = SCROLL_VIEW_HEIGHT;
    end
    local inEvent = model.OperateModel:isValidByType(13);
    self.shopScrollView:setInnerContainerSize(cc.size(600,maxHeight))
    for i = 1 , totalNum do
        local row = math.ceil(i / 4);
        local col = i % 4;
        col = col == 0 and 4 or col;
      
        local data = self.shopData[i];
        local item = template.ShopAvatarTemplate:create();
        item:Init(data,inEvent);
        item:setPosition(75 + (col-1) * 150 , maxHeight-114-(row - 1)*240);
        item:addTo(self.shopScrollView);
        if data then
            item:addItemClickEventListener(handler(self , self.showAvatarInfo));
            item:addBuyClickEventListener(handler(self , self.listItemClick));
            item:setItemTag(data.no);
            item:setBuyTag(data.no);
            self.shopItems[data.no] = item;
        end
    end

end

function ShopPanel:showAvatarInfo(sender , event)
    local tag = sender:getTag();

    UIManager:push('ShopAvatarInfoPanel',tag);
end

function ShopPanel:updateHaveMoney()
    if self.curShopType == CommonShopType.AVATAR then
        local iconFile , num = GlobalFunctions:getItemIconFileAndNum({10020,1});
        self.moneyIcon:setTexture(iconFile);
        local haveNum = model.ItemModel:getItemNum(10020);
        self.moneyNum:setString(haveNum);
    end
end

function ShopPanel:listItemClick(sender , event)
    AudioManager:playEffect(Conf.buttonClick)
    local id = sender:getTag();

    if self.curShopType == CommonShopType.GROWUP or self.curShopType == CommonShopType.GROWUP_SP then
        Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_growup_reward, {no=id, type=self.curShopType});
        return;
    end
   
    local shopData = model.ShopModel:getShopDataByIndex(self.curShopType); --如果不是礼包和充值menuType = nil;
    if not shopData then
        return;
    end
    local itemData = shopData[id]
    if not itemData then
        return;
    end
    if itemData.times and itemData.times == 0 then
        Prompt:Show(LANG.UI_SHOP_102)
        return;
    end
    if itemData.buytype and itemData.buytype ~= 0 then
        local buytype = itemData.buytype or 0
        local buyvalue = itemData.buyvalue or 0
        local match = false
        if buytype == 4 and buyvalue == 1 then
            local monthData = model.RechargeModel:getMonthData()
            if monthData[4] and monthData[4].state and monthData[4].state == 4 then
                match = true
            end
        elseif buytype == 4 and buyvalue == 2 then
            local monthData = model.RechargeModel:getMonthData()
            if monthData[5] and monthData[5].state and monthData[5].state == 4 then
                match = true
            end
        elseif buytype == 7 then
            local battlepass_state = model.BattlepassEventModel:getSpecialState()
            if battlepass_state and battlepass_state == 1 then
                match = true
            end
        elseif buytype == 8 then
            local mazeData = model.EventModel:getBPData()
            if mazeData and mazeData.special_state and mazeData.special_state == 1 then
                match = true
            end
        end
        if not match then
            Prompt:Show(LANG.UI_SHOP_104)
            return
        end
    end
    if self.curShopType == CommonShopType.SHOP  then --商店
        UIManager:push('TipsShopPanel' , self.curShopType , id);
    elseif self.curShopType == CommonShopType.GIFT
        or self.curShopType == CommonShopType.GIFT_ACTIVITY then
        -- model.ShopModel:sendBuyGift(id,self.curShopType)
        if itemData.price > 0 then
            UIManager:push('ShopGiftShowPanel', self.curShopType, id, handler(self,self.giftPaymentCallback))
            -- local costItemName = '원'
            -- local nameStr = itemData.giftname or ResTable:getLangByNum(itemData.giftname_no);
            -- local msg = string.format(LANG.UI_SHOP_67 , itemData.price ,costItemName, nameStr , 1)
            -- MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
            --     local buyItem = {
            --         no = id,
            --         type = 3 -- 3 shop_gift 
            --     }
            --     sdkManager.PaymentHelper:onPayment(buyItem,handler(self,self.giftPaymentCallback));
            -- end);
        else
            Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_gift_free, {no=id});
        end
    elseif self.curShopType == CommonShopType.RECHARGE then

        local costItemName = LANG.UI_RECHARGE_7
        local nameStr = itemData.name or ResTable:getLangByNum(itemData.name_no) ;
        local diamondNum = itemData.diamond
        local msg = string.format(LANG.UI_SHOP_61 , itemData.price ,costItemName, nameStr)
        MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
            local buyItem = {
                no = id,
                type = 1 -- 1 recharge 2 recharge_online
            }
            sdkManager.PaymentHelper:onPayment(buyItem,handler(self,self.rechargePaymentCallback));
	    end);
    elseif self.curShopType == CommonShopType.AVATAR then
        local costItemName = ResTable:getValue('item' , itemData.price[1] , 'name');
        local nameStr = itemData.name;
        if nameStr == nil then
            nameStr = ResTable:getLangByNum(itemData.name_no)
        end

        local price = itemData.price[2];
        if model.OperateModel:isValidByType(13) then
            price = itemData.price_event[2];
        end

        local msg = string.format(LANG.UI_SHOP_67 , tostring(price) ,costItemName, nameStr , 1)
        local msgBox = MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
            model.ShopModel:reqBuyAvatar(id);
        end);
    end
end

function ShopPanel:getGrowupReward(sender , event)
    local tag = sender:getTag();
    Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_growup_reward, {no=tag, type=self.curShopType});
end

function ShopPanel:retGetGrowupRreward(msg)
    if self.shopItems[msg.no] then
        if self.curShopType==CommonShopType.GROWUP_SP then
            local data = model.RechargeModel:getGrowupSpData()[msg.no];
            self.shopItems[msg.no]:Init(data)
        else
            local data = model.RechargeModel:getGrowupData()[msg.no];
            self.shopItems[msg.no]:Init(data)
        end
    end
    Prompt:Show(LANG.UI_SHOP_100);
    self:updateRedDot(self.curShopType)
    UIManager:push('RewardPanel',msg)
end

function ShopPanel:showMonthCard()
    local data = model.RechargeModel:getMonthData();
	if not data then
		return;
    end
    for k,v in pairs(self.monthCard) do
        local i = k;
		local monthState = data[i].state
        local day = data[i].remain_time
        tools.RedDotTools:setRedDotToNode(self.monthCard[i].node,false,nil);
        if monthState == 1 then
            -- 可领取

            self.monthCard[i].activity:setVisible(true)
            if self.monthCard[i].rewardBtn then
                self.monthCard[i].rewardBtn:setVisible(true)
                tools.RedDotTools:setRedDotToNode(self.monthCard[i].node,true,nil,cc.p(130,100));
            end
            self.monthCard[i].activityDay:setString(string.format(LANG.UI_ACTIVITY_38, day))

		elseif monthState == 2 then
            -- 已领取
            self.monthCard[i].activity:setVisible(true)
            if self.monthCard[i].rewardBtn then
                self.monthCard[i].rewardBtn:setVisible(false)
            end
            self.monthCard[i].activityDay:setString(string.format(LANG.UI_ACTIVITY_38, day))

		elseif monthState == 4 then
			-- 新状态
            self.monthCard[i].activity:setVisible(true)
            if self.monthCard[i].rewardBtn then
                self.monthCard[i].rewardBtn:setVisible(false)
            end
            self.monthCard[i].activityDay:setString(string.format(LANG.UI_ACTIVITY_38, day))

        else
            -- 未激活
            self.monthCard[i].activity:setVisible(false)
		end
	end
end

function ShopPanel:onBuyMonthCard(sender, event)
    local tag = sender:getTag()
    local itemData = ResTable:getRowData('month_card', tag)
    if not itemData then
        return;
    end

    local monthState = self:getMonthCardReward(tag);

    if monthState ~= 1 and monthState ~= 2 then
        local costItemName = LANG.UI_RECHARGE_7
        local price = ResTable:getValue('price', itemData.price, CURRENCY) or 0;
        local nameStr = itemData.name or ResTable:getLangByNum(itemData.name_no) ;
        local msg = string.format(LANG.UI_SHOP_67 , price ,costItemName, nameStr , 1)
        MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
            local buyItem = {
                no = tag,
                type = 4
            }
            sdkManager.PaymentHelper:onPayment(buyItem,handler(self,self.monthCardPaymentCallback));
        end);
    end
end

function ShopPanel:monthCardPaymentCallback( msg )
	if msg and msg.code == 2 then
		MessageBox:create(LANG.UI_SHOP_85 , MessageBoxType.OK, function()
		end);
	elseif msg and msg.code ~= 0 then
		MessageBox:create(LANG.UI_SHOP_84 , MessageBoxType.OK, function()
		end);
	end
    if msg == nil or msg.recharge == nil or msg.recharge.month == nil then
        return
    end
    local month = msg.recharge.month;
    if month.state == nil or next(month.state) == nil then
        return 
    end

    if msg and msg.code == 0 then 
        Prompt:Show(LANG.UI_ACTIVITY_40);
	    self:showMonthCard()
		self:updateRedDot(CommonShopType.MONTH_CARD);
        UIManager:push('RewardPanel',msg)
    end
end

function ShopPanel:getMonthCardReward(index)
    local data = model.RechargeModel:getMonthData();
	if not data then
		return;
    end

    local monthState = data[index].state

    if monthState == 1 then
	    local msg = {}
	    msg.no = index
        Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_reward_month , msg);
    elseif monthState == 2 then
        Prompt:Show(LANG.UI_SHOP_97);
    end
    return monthState;
end

function ShopPanel:onGetMonthCardReward(sender, event)
    local tag = sender:getTag()
	self:getMonthCardReward(tag)
end


function ShopPanel:retMonthCardReward( msg )
    if msg == nil or msg.recharge == nil then
        return 
    end
    self:showMonthCard()
    
    Prompt:Show(LANG.UI_SHOP_100);
    self:updateRedDot(CommonShopType.MONTH_CARD);

    UIManager:push('RewardPanel',msg)
end

function ShopPanel:onEnter(shopType)
    model.ShopModel:resetShopInit()
    model.RechargeModel:resetRechargeInit()
    self:checkCommon( shopType )
    self:updateRedDot()
    self:swtichNode(-1);
    self.curShopType = nil;
    self.reqChangeIndex = nil;
    
    shopType = shopType or CommonShopType.SHOP;
    if shopType == CommonShopType.GROWUP then
    else 
        shopType = self:updateVisible(shopType);
        local posX = self.menuBtnList[shopType]:getPositionX();
        self.menuSelectImg:setPosition(posX,-1);
    end
    self.menuBtnList[CommonShopType.AVATAR]:setVisible( not tools.ConfigStateTools:checkLockById(2803) )
    self:changeMenuIndex(shopType)
   
    self.root:setVisible(true)
    self:runFooterAction();
end

function ShopPanel:checkCommon( shopType )
    self.menuNode:setVisible(false);
    self.growupMenuNode:setVisible(false);
    if shopType == CommonShopType.GROWUP then
        self.growupMenuNode:setVisible(true);
    else
        self.menuNode:setVisible(true);
        self.bottomNode:setPosition(0,self.oldBottomPosY)
        self.bgList:setPosition(0,self.oldBgY)
        self.bgList:setContentSize(cc.size(640 , self.oldBgHeight));
    end
end

function ShopPanel:updateVisible(shopType)
    local openMenuList =  tools.ConfigStateTools:setVisibleByType(Enum:getTable('ConfigStateType').SHOP , self.menuBtnList);
    if not openMenuList or #openMenuList <= 0 then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('ShopPanel');
        return
    end

    local visibleNum = #openMenuList;
    if visibleNum > 1 then
        table.sort(openMenuList , function(first , second)
            return first.index < second.index;
        end);
    end

    for _k , line in ipairs(self.lineList) do
        line:setVisible(_k <= visibleNum)
    end

    local openType = nil;
    self.shopTypePos = {};
    self.openMenuList = {};
    for _k , openData in ipairs(openMenuList) do
        table.insert(self.openMenuList,openData.index);
        self.shopTypePos[openData.index] = cc.p(-256 + 128*(_k-1),5);
        self.menuBtnList[openData.index]:setPosition(self.shopTypePos[openData.index]);
        
        if not openType and openData.state == 0 then
            openType = openData.index;
        end
        if shopType == openData.index and openData.state == 0 then
            openType = shopType;
        end
        tools.LevelLockTools:setLockToNode(self.menuBtnList[openData.index],openData.state==1,1,1,cc.p(0,0))
    end

    if not openType then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('ShopPanel');
        return
    end

    return openType;
end

function ShopPanel:updateRedDot(shopType)
    if shopType == nil or shopType == CommonShopType.GIFT then
        if self.menuBtnList[CommonShopType.GIFT] then
            local state = model.ShopModel:getShopActiveState(CommonShopType.GIFT)
            tools.RedDotTools:setRedDotToNode(self.menuBtnList[CommonShopType.GIFT],state,nil,cc.p(34,30));
        end
    end

    if shopType == nil or shopType == CommonShopType.GROWUP then
        if self.menuBtnList[CommonShopType.GROWUP] then
            local state = model.ShopModel:getShopActiveState(CommonShopType.GROWUP)
            tools.RedDotTools:setRedDotToNode(self.menuBtnList[CommonShopType.GROWUP],state,nil,cc.p(34,30));
        end
    end

    if shopType == nil or shopType == CommonShopType.MONTH_CARD then
        if self.menuBtnList[CommonShopType.MONTH_CARD] then
            local state = model.ShopModel:getShopActiveState(CommonShopType.MONTH_CARD)
            tools.RedDotTools:setRedDotToNode(self.menuBtnList[CommonShopType.MONTH_CARD],state,nil,cc.p(34,30));
        end
    end
end

function ShopPanel:runFooterAction()
    -- for i,btnIdxs in ipairs({{3,4},{2,5},{1,6}}) do
    for i,btnIdxs in ipairs({{3},{2,4},{1,5}}) do
        for _k , idx in ipairs(btnIdxs) do
            if self.openMenuList and self.openMenuList[idx] then
                local shopType = self.openMenuList[idx];
			    self.menuBtnList[shopType]:stopAllActions();
			    self.menuBtnList[shopType]:setPosition(self.shopTypePos[shopType].x , self.shopTypePos[shopType].y-91);
			    self.menuBtnList[shopType]:setOpacity(0);

			    local action1 = cc.MoveTo:create(10/25 , cc.p(self.shopTypePos[shopType].x , self.shopTypePos[shopType].y+5));
			    local action2 = cc.FadeIn:create(7/25);
			    local actionSpawn = cc.Spawn:create(action1,action2);
			    local action3 = cc.MoveTo:create(2/25 , self.shopTypePos[shopType]);
                
			    self.menuBtnList[shopType]:runAction(cc.Sequence:create(cc.DelayTime:create((5+4*(i-1))/25) , actionSpawn , action3));
            end
        end
	end
end

function ShopPanel:rechargePaymentCallback( msg )
	if msg and msg.code == 0 then 
	    MessageBox:create(LANG.UI_SHOP_82 , MessageBoxType.OK,function () end);
		if self.curShopType == CommonShopType.GROWUP or self.curShopType == CommonShopType.GROWUP_SP then
			self:shopList();
	        self:updateRedDot(self.curShopType)
		else
			self:retShopBuy(msg)
	    end
	elseif msg and msg.code == 2 then
		MessageBox:create(LANG.UI_SHOP_85 , MessageBoxType.OK, function()
		end);
	else
		MessageBox:create(LANG.UI_SHOP_84 , MessageBoxType.OK, function()
		end);
	end
end

function ShopPanel:giftPaymentCallback( msg )
    --MessageBox:create(LANG.UI_SHOP_82 , MessageBoxType.OK,function () end);
    if msg and msg.code == 0 then 
        Prompt:Show(LANG.UI_SHOP_100);
        self:retShopBuy(msg.recharge.gift)
	elseif msg and msg.code == 2 then
		MessageBox:create(LANG.UI_SHOP_85 , MessageBoxType.OK, function()
		end);
	else
		MessageBox:create(LANG.UI_SHOP_84 , MessageBoxType.OK, function()
		end);
	end
    --UIManager:push('RewardPanel',msg)
end

function ShopPanel:retGetGiftFree(msg)
    Prompt:Show(LANG.UI_SHOP_100);
    self:retShopBuy(msg.recharge.gift)
    self:updateRedDot(CommonShopType.GIFT)
end

function ShopPanel:retShopBuy(msg)
    if msg.shop then
        Prompt:Show(LANG.UI_SHOP_68)
        if self.curShopType == CommonShopType.GIFT then
            self:giftSwitchList(self.giftMenuIdx)
            self:showGiftList();
        else
            self:shopList();
        end
        return;
    end
    self:updateHaveMoney()
    UIManager:push('RewardPanel',msg,{effectName = 'RewardGoods'})

    if self.curShopType == CommonShopType.AVATAR then
        self:showAvatarList();
        return;
    end

    if self.curShopType == CommonShopType.GIFT and self.giftMenuIdx==1 then
        self:giftSwitchList(self.giftMenuIdx)
        self:showGiftList();
        return;
    end
        

    local shopData = model.ShopModel:getShopDataByIndex(self.curShopType);
    if not shopData then
        return;
    end

    local id = msg.id or msg.item_id;

    local itemData = shopData[id]
    if not itemData then
        return;
    end
    if self.curShopType == CommonShopType.SHOP then
        self.shopItems[id]:Init(itemData , true);
    else
        self.shopItems[id]:Init(itemData);
    end
    --GlobalFunctions:showRewardPrompt(msg , LANG.UI_SHOP_45);
end

function ShopPanel:onLeave( ... )
    tools.RedDotTools:pushMainPanelRedDot(11); -- 首冲红点刷新

    self.root:setVisible(false);
end

function ShopPanel:onClickBack()
    UIManager:pop('ShopPanel');
end

function ShopPanel:giftMenuClick(sender , event)
    local tag = sender:getTag()
    self:giftSwitchList(tag);
    self:showGiftList();
end

function ShopPanel:giftSwitchList(index)

    for _k , btn in pairs(self.giftMenuList) do
        local label = btn:getTitleLabel();
        if _k == index then
            btn:setBright(true)
            label:setTextColor(cc.c3b(255 , 255 , 255));
            self.giftlight:setPositionX(btn:getPositionX());
            self.giftMenuIdx = index;
        else
            btn:setBright(false)
            label:setTextColor(cc.c3b(180 , 180 , 180));
        end
    end

end

return ShopPanel

