local SkillBuffPanel = class("SkillBuffPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")

function SkillBuffPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SkillBuffPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function SkillBuffPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
	  
      self:InitPanels();
end

function SkillBuffPanel:InitPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(604,451));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , 22.5);

	local titleNode = GlobalFunctions:createTitle( LANG.UI_CARD_63,604);
	titleNode:addTo(self.root);
	titleNode:setPosition(0,271);

	self.buffScrollView = ccui.ScrollView:create();
	self.buffScrollView:setTouchEnabled(true);
	self.buffScrollView:setBounceEnabled(true);
	self.buffScrollView:setDirection(ccui.ScrollViewDir.vertical);
    self.buffScrollView:setScrollBarEnabled(false);
    self.buffScrollView:addTo(self.root);
    self.buffScrollView:setContentSize(cc.size(529 , 314));
    self.buffScrollView:setAnchorPoint(0.5 , 0.5);
	self.buffScrollView:setPosition(0 , 64);
	
	-- local label = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20);
	-- label:enableOutline(cc.c3b(40 , 130 , 230) , 2);

	-- self.okBtn = ccui.Button:create('image/commonImg/btn_bg1.png' , 'image/commonImg/btn_bg1.png');
	-- self.okBtn:addTo(self.root);
	-- self.okBtn:setPosition(0 , -140);
	-- self.okBtn:setTitleLabel(label);
	-- self.okBtn:addClickEventListener(handler(self , self.onClickBack));

end

function SkillBuffPanel:onEnter(skillData)

	self:addSwallowCallback(handler(self , self.onClickBack));

	if not skillData then 
		return
	end

	local buffs = {};
	
	if skillData.buff ~= '' and #skillData.buff > 0 then
		for _k , buff in ipairs(skillData.buff) do 
			buffs[buff[2]] = 1;
		end
	end

	if skillData.buff_2 ~= '' and #skillData.buff_2 > 0 then
		for _k , buff in ipairs(skillData.buff_2) do
			buffs[buff[2]] = 1;
		end
	end

	if skillData.follow_result ~= '' and #skillData.follow_result > 0 then
		for _k , followData in ipairs(skillData.follow_result) do
			if followData[1] == 1 then
				buffs[followData[4]] = 1;
			end
		end
	end

	local buffList = {};
	local maxHeight = 0;
	self.buffScrollView:removeAllChildren();
	for buff , _ in pairs(buffs) do
		local template = template.SkillBuffTemplate:create();
		template:addTo(self.buffScrollView);
		template:Init(buff);
		maxHeight = maxHeight + template:getBuffContentSize().height + 20;
		table.insert(buffList , template);
	end

	maxHeight = maxHeight < 314 and 314 or maxHeight;
	
	self.buffScrollView:setInnerContainerSize(cc.size(529 ,maxHeight));

	local height = 0;
	for _k , tmp in ipairs(buffList) do
		local tHeight = tmp:getBuffContentSize().height + 20;
		local posY = maxHeight - height - tHeight / 2;
		tmp:setPosition(264.5 , posY); 
		height = height + tHeight;
	end

	self.root:setVisible(true);
end

function SkillBuffPanel:onLeave()
	self.root:setVisible(false);
end

function SkillBuffPanel:onClickBack()
	UIManager:pop('SkillBuffPanel');
end

return SkillBuffPanel;
