local SpecialOfferPanel = class("SpecialOfferPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/specialOffer/'

function SpecialOfferPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'SpecialOfferPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function SpecialOfferPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function SpecialOfferPanel:initPanels()

	self.winNode = cc.Node:create()
	self.winNode:addTo(self.root)

	local w1bg = cc.Sprite:create(imagePath..'special_offer_win1.png')
		:addTo(self.winNode)
		:setPosition(0 , 45)
	local w2bg = cc.Sprite:create(imagePath..'special_offer_win2.png')
		:addTo(self.winNode)
		:setPosition(0 , -60)

	self.loseNode = cc.Node:create()
	self.loseNode:addTo(self.root)
	local l1bg = cc.Sprite:create(imagePath..'special_offer_lose1.png')
		:addTo(self.loseNode)
		:setPosition(0 , 45)
	local l2bg = cc.Sprite:create(imagePath..'special_offer_lose2.png')
		:addTo(self.loseNode)
		:setPosition(0 , -60)

	--[[
	local bg = cc.Sprite:create('image/commonImg/cv_info_bg.png')
		:addTo(self.root)
		:setPosition(0 , 297)

	self.title = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
		:addTo(self.root)
		:setPosition(0,297)
	]]
	--local bg = cc.Sprite:create(imagePath..'special_offer_1.png')
	--	:addTo(self.root)
	--	:setPosition(149 , -7)

	local bg = cc.Sprite:create(imagePath..'special_offer_3.png')
		:addTo(self.root)
		:setPosition(0 , -177)

	local label = cc.Label:createWithTTF(LANG.UI_SHOP_98,fonts.FONT_SIYUAN,18)
		:addTo(self.root)
		:setPosition(5,-176)

	local closeBtn = ccui.Button:create('image/commonImg/close_btn_1.png' , 'image/commonImg/close_btn_1.png');
	closeBtn:addTo(self.root);
	closeBtn:setPosition(240 , 366);
	closeBtn:addClickEventListener(function()
		UIManager:pop('SpecialOfferPanel')
		if self.callback then
			self.callback();
		end
		if self.dataIdx and self.dataIdx > 0 then
			model.ShopModel:showFightGift(self.dataIdx);
		end
	end);

	self.itemScrollView = ccui.ScrollView:create();
	self.itemScrollView:setTouchEnabled(true);
	self.itemScrollView:setBounceEnabled(true);
	self.itemScrollView:setDirection(ccui.ScrollViewDir.horizontal);
	self.itemScrollView:setContentSize(cc.size(285, 93));
	self.itemScrollView:setAnchorPoint(cc.p(0.5, 0.5));
	self.itemScrollView:setPosition(0 , -245);
	self.itemScrollView:setScrollBarEnabled(false);
	self.itemScrollView:addTo(self.root);
	
	self.priceLabel = cc.Label:createWithTTF('' , 'font/SourceHanSansCN-Medium.otf' , 20);
	self.priceLabel:enableOutline(cc.c3b(50 , 85 , 150) , 2);

	self.priceBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.priceBtn:addTo(self.root);
	self.priceBtn:setPosition(0 , -363);
	self.priceBtn:addClickEventListener(handler(self , self.priceBtnClick));
	self.priceBtn:setTitleLabel(self.priceLabel);

	self.arrowNode = cc.Node:create()
	self.arrowNode:addTo(self.root)
	self.arrowNode:setPosition(0, -248)
	local a1Spr = cc.Sprite:create('image/commonImg/big_ar1.png')
	a1Spr:addTo(self.arrowNode)
	a1Spr:setPosition(-165, 0)
	local a2Spr = cc.Sprite:create('image/commonImg/big_ar1.png')
	a2Spr:addTo(self.arrowNode)
	a2Spr:setPosition(165, 0)
	a2Spr:setFlipX(true)

end

function SpecialOfferPanel:onEnter(win , option, idx)
	self.dataIdx = idx;
	self.callback = option and option.callback or nil;
	local delayTime = option and option.delayTime or (win and 3.5 or 1);
	self.winNode:setVisible(win)
	self.loseNode:setVisible(not win)

	-- self.root:setVisible(true);
	
	self.root:runAction(cc.Sequence:create(cc.DelayTime:create(0.5),cc.CallFunc:create(function() self:onShow() end)));
end

function SpecialOfferPanel:onShow()
	local giftData = nil;
	if self.dataIdx then
		local list = model.ShopModel:getFightGiftList();
		if list[self.dataIdx] then
			giftData = list[self.dataIdx].gift_data;
		end
	else
		local specialOfferData = model.RechargeModel:getSpecialOfferGiftData()
		giftData = specialOfferData.giftData;
	end
	if not giftData then
		return;
	end

	local name = ResTable:getLangByNum(giftData.giftname_no) or '';
	local info = ResTable:getLangByNum(giftData.info_no) or '';
	--self.title:setString(tostring(info));

	local itemNum = #giftData.item;
	local maxWidth = 96 * itemNum;
    maxWidth = maxWidth < 285 and 285 or maxWidth;

    self.itemScrollView:removeAllChildren();
    self.itemScrollView:setInnerContainerSize(cc.size(maxWidth,93));
	local startPosX = 48;
	if maxWidth <= 285 then 
		startPosX = (285-96*(itemNum-1))/2+3;
	end
	local idx = 0
    for _k , reward in pairs(giftData.item) do
        local itemTemplate = template.ItemTemplate:create();
        itemTemplate:addTo(self.itemScrollView);
        itemTemplate:setPosition(startPosX+96*(_k-1),46.5);
        itemTemplate:Init(reward[1],reward[2]);
        itemTemplate:setScale(0.9);

        idx = idx+1
    end
    self.arrowNode:setVisible( idx > 3 )

	self.priceBtn:setTag(giftData.no);
	self.priceLabel:setString(string.format(LANG.UI_SHOP_72,giftData.price));

	model.RechargeModel:setSpecialOfferFightShow(false)
	
	self.root:setVisible(true);
end

function SpecialOfferPanel:priceBtnClick(sender , event)
	local no = sender:getTag();
	self.itemId = no;
	local buyItem = {
		no = no,
		type = 6
	}
	sdkManager.PaymentHelper:onPayment(buyItem,handler(self,self.retBuy));
end

function SpecialOfferPanel:retBuy()
	Prompt:Show(LANG.UI_SHOP_100);
	model.ShopModel:removeFightGift(self.itemId)
	EventManager:FireEvent('FightPanel:noticeShowNewGiftNode');
	UIManager:pop('SpecialOfferPanel')
	if self.callback then
		self.callback();
	end
end

function SpecialOfferPanel:onClickBack()
	--UIManager:pop('SpecialOfferPanel')
end

function SpecialOfferPanel:onLeave()
	self.root:setVisible(false);
end

return SpecialOfferPanel;
