local StarAndBreakComplatePanel = class("StarAndBreakComplatePanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont");
local imagePath = 'image/card/starAndBreakComplete/'
local MessageBoxType = Enum:getTable('MessageBoxType')
local animationName = {
	[1] = 'shengxing',
	[2] = 'tupo',
};

function StarAndBreakComplatePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'StarAndBreakComplatePanel');

	self.isPopup = true;

	self.useCCreator = false;
end

function StarAndBreakComplatePanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function StarAndBreakComplatePanel:initPanels()
	local spine_res = 'up_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.topAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.topAnimation:addTo(self.root)
		self.topAnimation:setLocalZOrder(10)
		self.topAnimation:registerSpineEventHandler(function (event)
			if event.eventData.name == 'appear' then
				self.infoNode:runAction(cc.FadeIn:create(0.15));
				self.roleImg:runAction(cc.FadeIn:create(0.15));
			end
		end, sp.EventType.ANIMATION_EVENT);
	else
		print('error : 缺少spine 资源')
    end
    
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.midAnimation = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.midAnimation:addTo(self.root)
		self.midAnimation:setLocalZOrder(10)
	else
		print('error : 缺少spine 资源')
	end

	self.roleImg = cc.Sprite:create();
	self.roleImg:addTo(self.root);
	self.roleImg:setPosition(0,239);
	self.roleImg:setScale(0.7);

	local activeSp = cc.Sprite:create('image/card/starAndBreakComplete/star_break_bg_7.png');
	local activeSp = cc.Sprite:createWithSpriteFrame(activeSp:getSpriteFrame());
	local spSize = activeSp:getContentSize();
	activeSp:setPosition(StageSize.width/2,StageSize.height/2+209);
	activeSp:setBlendFunc(cc.blendFunc(GL_ZERO, GL_ONE_MINUS_SRC_ALPHA));
	local renderTexture = cc.RenderTexture:create(StageSize.width,StageSize.height,cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888);
	renderTexture:beginWithClear(0,0,0,1);
	activeSp:visit();
	renderTexture:endToLua();
	renderTexture:addTo(self.root);

	--local stencil = cc.Sprite:create(imagePath..'star_break_bg_7.png');
	--local clippingNode = cc.ClippingNode:create();
	--clippingNode:setStencil(stencil);
	--clippingNode:addChild(self.roleImg);
	--clippingNode:setInverted(false);
	--clippingNode:setAlphaThreshold(0.1);
	--clippingNode:addTo(self.infoNode);
	--clippingNode:setPosition(0,239);
	--clippingNode:setCascadeOpacityEnabled(true)

	self.infoNode = cc.Node:create();
	self.infoNode:addTo(self.root);
	self.infoNode:setCascadeOpacityEnabled(true);

	self.title = cc.Sprite:create();
	self.title:setPosition(0,74);
	self.title:addTo(self.infoNode);

	self.starNode = cc.Node:create();
	self.starNode:addTo(self.infoNode);
	self.starNode:setPosition(0,1);
	self.starNode:setCascadeOpacityEnabled(true);
	self.starList = {};

	self.breakNode = cc.Node:create();
	self.breakNode:addTo(self.infoNode);
	self.breakNode:setCascadeOpacityEnabled(true);
	self.breakNode:setPosition(0,1);
	self.breakList = {};

	for i = 1 , 6 do
		if i < 6 then
			local starBg = cc.Sprite:create('image/card/star_level_bg.png');
			starBg:addTo(self.starNode);
			starBg:setPosition(-50 + 25*(i-1),0);

			local star = cc.Sprite:create();
			star:addTo(self.starNode);
			star:setPosition(-50 + 25*(i-1),0);

			self.starList[i] = star;
		end

		local breakBg = cc.Sprite:create('image/card/card_break_level_light_bg.png');
		breakBg:addTo(self.breakNode);
		breakBg:setPosition(-50 + 25*(i-1),0);

		local breakImg = cc.Sprite:create('image/card/card_break_level.png');
		breakImg:addTo(self.breakNode);
		breakImg:setPosition(-50 + 25*(i-1),0);

		self.breakList[i] = breakImg;
	end

	self.attList = {};
	for i = 1 , 3 do
		self.attList[i] = {};

		local node = cc.Node:create();
		node:addTo(self.infoNode);
		node:setPosition(0 , -57 - 60 * (i - 1));
		node:setCascadeOpacityEnabled(true);
		

		local bg = cc.Sprite:create(imagePath..'star_break_bg_2.png');
		bg:addTo(node);

		local label = cc.Label:createWithTTF(LANG.UI_CARAD_BREAK_SUCCESS_ATT_TYPE[i] , fonts.FONT_SIYUAN , 20);
		label:addTo(node);
		label:setPosition(-135 , 1);

		self.attList[i].att = cc.Label:createWithTTF('0', fonts.FONT_SIYUAN , 20);
		self.attList[i].att:addTo(node);
		self.attList[i].att:setPosition(-21 , 1);

		local bg = cc.Sprite:create(imagePath..'star_break_bg_1.png');
		bg:addTo(node);
		bg:setPosition(57 , 1);

		self.attList[i].nextAtt = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
		self.attList[i].nextAtt:addTo(node);
		self.attList[i].nextAtt:setTextColor(cc.c3b(255 , 255 , 0));
		self.attList[i].nextAtt:setPosition(129 , 1);
	end
end

function StarAndBreakComplatePanel:onEnter(enterType)
	self:addSwallowCallback(handler(self, self.onClickBack));
	self.root:setVisible(true);
	if not enterType then
		return
	end

	self.infoNode:stopAllActions();
	self.infoNode:setOpacity(0);
	self.roleImg:stopAllActions();
	self.roleImg:setOpacity(0);

	self.enterType = enterType;

	local tempMsg , oldPro = model.CardModel:getStarBreakTempData();
	--local tempMsg = {pid = 38};
	--local oldPro = {fp='10',hp='20',atk='30'}
	self.tempMsg = tempMsg;
	self.oldPro = oldPro;
	self.pid = tempMsg.pid;
	self.data = model.CardModel:GetCard(self.pid);
	if not self.data then
		return;
	end

	local resId = model.CardModel:getCardResIdByPid(self.pid);
	local role = ResTable:getRowData('role_resource', resId);
	self.roleImg:setTexture('image/role/'..role.card..'.png');
	local x,y = role.navi_show[1],role.navi_show[2];
	self.roleImg:setPosition(-x*0.7,209-y*0.7);

	local curLn = model.UserDefaultModel:getLanguageSet();
	local curAnimationName = animationName[enterType];
	self.topAnimation:setAnimation(0, string.format('%s_%s_start_1',curLn,curAnimationName), false);
	self.midAnimation:setAnimation(0, string.format('%s_%s_start_2',curLn,curAnimationName), false);
	self.topAnimation:addAnimation(0, string.format('%s_%s_idle_1',curLn,curAnimationName), true);
	self.midAnimation:addAnimation(0, string.format('%s_%s_idle_2',curLn,curAnimationName), true);

	if self.enterType == 1 then
		self.starNode:setVisible(true);
		self.breakNode:setVisible(false);
		--self.title:setTexture(imagePath..'star_break_bg_4.png');

		local color = math.ceil(self.data.star_lv / 5);
		local num = self.data.star_lv % 5;
		num = num == 0 and 5 or num;
		for i = 1 , 5 do
			if i <= num then
				self.starList[i]:setTexture('image/card/star_level_'..color..'.png');
			end
			self.starList[i]:setVisible(i <= num);
		end
	else
		self.starNode:setVisible(false);
		self.breakNode:setVisible(true);
		--self.title:setTexture(imagePath..'star_break_bg_6.png');

		for i = 1 , 6 do
			self.breakList[i]:setVisible(i <= self.data.break_lv);
		end
	end

	local pro = CardProManager:GetCardPro(self.pid);
	if not pro then
		return;
	end
	
	local index = 1;
	for _k , attName in pairs({'fp' , 'hp' , 'atk'}) do
		if oldPro[attName] then
			self.attList[index].att:setString(tostring(oldPro[attName]));
			if pro[attName] then
				self.attList[index].nextAtt:setString(tostring(pro[attName]));
			end
			index = index + 1;
		end
	end
end

function StarAndBreakComplatePanel:onLeave()
	self.root:setVisible(false);
end

function StarAndBreakComplatePanel:onClickBack()
	if self.enterType == 1 then

		local option = {
			effectName = 'Reback',
			rewardType = Enum:getTable('RewardType').REWARD_TYPE_COMMON,
		}

		UIManager:push('RewardPanel' , self.tempMsg , option);
	elseif self.enterType == 2 then
		local breakData = model.CardModel:getCardBreakTableData(self.data.break_lv);
		if breakData and breakData.skill_open and breakData.skill_open ~= '' then
			local skillId = model.CardModel:getCardSkillIdByPid(self.pid);
			local roleSkillData = ResTable:getRowData('role_skill' , skillId);
			if roleSkillData[tostring(breakData.skill_open)..'_no'] then
				UIManager:push('CardBreakOpenSkillPanel' , roleSkillData[tostring(breakData.skill_open)..'_no']);
			end
		end
	end

	local newFp = CardProManager:GetCardPro(self.pid).fp;
	newFp = ConvertDigitUnitToStr(tostring(newFp));
	local oldFp = ConvertDigitUnitToStr(tostring(self.oldPro.fp));
	if true or HpCompare(newFp , '>' , oldFp) then
		FpUpPanel:Show(oldFp , newFp);
	end

	UIManager:pop('StarAndBreakComplatePanel');
end

return StarAndBreakComplatePanel;
