local StorePanel = class('StorePanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local CommonShopType = Enum:getTable('CommonShopType');
local imagePath = 'image/shop/'

local SCROLL_VIEW_HEIGHT = 0;

local footerMenuPos = {
    --[1] = cc.p(-239 , 3),
    [8] = cc.p(-70 , 7),
    [9] = cc.p(96 , 3),
    --[4] = cc.p(262 , 4),
}

local menuLabelPos = {
    --[1] = cc.p(-239 , -30);
    [8] = cc.p(0 , -37);
    [9] = cc.p(0 , -33);
    --[4] = cc.p(262 , -30);
}

local menuSelectPos = {
    --[1] = cc.p(-239 , 0);
    [8] = cc.p(-70 , 0);
    [9] = cc.p(96 , 0);
    --[4] = cc.p(262 , 0);
}

local boxWidth = {
    [1] = 153,
    [2] = 306,
    [3] = 301,
}

local SCROLL_VIEW_WIDTH = 612

function StorePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'StorePanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = false;
end

function StorePanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
      self.root:setPosition(StageSize.width/2,StageSize.height/2);
  
      self:initPanel();

      self:initRslMenuBar();
  
      self:registEvent();
end

function StorePanel:initPanel(  )

    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);
    
    local bgSprite1 = cc.Sprite:create('image/bg/Bg_5.png');
	bgSprite1:addTo(bgNode);

    self.topHeight = NOTCH_HEIGHT+154
	self.topBg = cc.Sprite:create('image/shop/shop_top_bg.png');
	self.topBg:setPosition(cc.p(0,StageSize.height/2-self.topHeight));
    self.topBg:addTo(bgNode);
    
    self.titleHeight = 46;
    self.topBgHeight = self.topBg:getContentSize().height;
    self.titltPosY = StageSize.height/2-self.topHeight-self.topBgHeight/2-self.titleHeight/2;

    self.roleStoreNode = cc.Node:create();
    self.roleStoreNode:addTo(self.root);
    self.roleStoreNode:setPosition(0,self.titltPosY);

    local menuPos = {-226 , -75 , 76 , 226}
    self.roleMenuList = {};
    for i = 0 , 3 do
        self.roleMenuList[i] = {};

        local unTexture = 'image/commonImg/menu_1_151_46_u.png';
        local texture = 'image/commonImg/menu_1_151_46.png';

		local unSelect = ccui.Button:create(unTexture , unTexture);
		unSelect:addTo(self.roleStoreNode);
		unSelect:setTag(i);
		unSelect:addClickEventListener(handler(self , self.roleMenuClick));
		unSelect:setPosition(menuPos[i+1] , 0);
		self.roleMenuList[i].unselect = unSelect;

		local select = ccui.Button:create(texture , texture);
		select:addTo(self.roleStoreNode);
		select:setPosition(menuPos[i+1] , 0);
		self.roleMenuList[i].select = select;

		local light = cc.Sprite:create('image/commonImg/menu_light_1.png');
		light:addTo(select);
		light:setPosition(select:getContentSize().width/2 , select:getContentSize().height/2+23);

		if i == 0 then
			local label = cc.Label:createWithTTF(LANG.UI_CARD_44 , fonts.FONT_SIYUAN , 20);
			label:addTo(unSelect);
			label:setPosition(unSelect:getContentSize().width / 2 , unSelect:getContentSize().height/2);
			label:setTextColor(cc.c3b(180 , 180 , 180));

			label = cc.Label:createWithTTF(LANG.UI_CARD_44 , fonts.FONT_SIYUAN , 20);
			label:addTo(select);
			label:setPosition(select:getContentSize().width / 2 , select:getContentSize().height/2);
		else
			local defType = cc.Sprite:create('image/commonImg/def_type_'..i..'.png');
			defType:addTo(self.roleStoreNode);
			defType:setScale(0.5);
			defType:setPosition(menuPos[i+1] , 0);
        end
    end

    self.equipStoreNode = cc.Node:create();
    self.equipStoreNode:addTo(self.root);
    self.equipStoreNode:setPosition(0,self.titltPosY)
    
    self.equipMenuList = {};
    for i = 1 , 4 do
        self.equipMenuList[i] = {};
        
        local texture = 'image/commonImg/menu_left_71_46.png';
		local unTexture = 'image/commonImg/menu_left_71_46_u.png';

		if i == 2 or i == 3 then
			texture = 'image/commonImg/menu_mid_71_46.png';
			unTexture = 'image/commonImg/menu_mid_71_46_u.png';
		end

		local btn = ccui.Button:create(texture , texture , unTexture);
		btn:addTo(self.equipStoreNode);
		btn:setTag(i);
		btn:addClickEventListener(handler(self , self.equipMenuClick));
        btn:setPosition(-240+160*(i-1)  , 0);
        btn:setScale9Enabled(true);
		btn:setCapInsets(cc.rect(10 , 0 , 39 , 46));
		btn:setContentSize(cc.size(160 , 46));
        self.equipMenuList[i].btn = btn;
        
        local light = cc.Sprite:create('image/commonImg/menu_light_1.png');
		light:addTo(btn);
		light:setPosition(btn:getContentSize().width/2 , btn:getContentSize().height/2+23);
		self.equipMenuList[i].light = light;

        local label = cc.Label:createWithTTF(LANG.UI_STORE_MENU[i] , fonts.FONT_SIYUAN , 20);
        label:setTextColor(cc.c3b(180 , 180 , 180));
        btn:setTitleLabel(label);
        self.equipMenuList[i].label = label;
    end
    
    self.scrollViewBg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	self.scrollViewBg:addTo(self.root);
	self.scrollViewBg:setPosition(0 , -113);
	self.scrollViewBg:setCapInsets(cc.rect(11,4,18,21));
    self.scrollViewBg:setContentSize(cc.size(640,690));

    self.storeScrollView = ccui.ScrollView:create();
	self.storeScrollView:setTouchEnabled(true);
	self.storeScrollView:setBounceEnabled(true);
	self.storeScrollView:setDirection(ccui.ScrollViewDir.vertical);
    self.storeScrollView:setScrollBarEnabled(false);
    self.storeScrollView:addTo(self.root);
    self.storeScrollView:setContentSize(cc.size(581 , 640));
    --self.storeScrollView:setAnchorPoint(0.5 , 0.5);
    self.storeScrollView:setPosition(0 , -90);
    self.oldShopScrollVPosY = -90;

    self.shopTitleNode = GlobalFunctions:createTitle(LANG.UI_SHOP_FOOTER[1],640,46);
    self.shopTitleNode:addTo(self.root);
    self.shopTitleNode:setPosition(0 , self.titltPosY);

	self.shopTitle = self.shopTitleNode:getChildByName('title');

    self.haveMoneyNode = cc.Node:create();
    self.haveMoneyNode:addTo(self.root);
    self.haveMoneyNode:setPosition(188 , self.titltPosY);

    local bg = cc.Sprite:create('image/commonImg/bg_3_200_42.png');
    bg:addTo(self.haveMoneyNode);

    self.moneyIcon = cc.Sprite:create();
    self.moneyIcon:addTo(self.haveMoneyNode);
    self.moneyIcon:setPosition(-71 , 0);
    self.moneyIcon:setScale(0.35);

    local moneyLabel = cc.Label:createWithTTF(LANG.UI_CARD_19 , fonts.FONT_SIYUAN , 20);
	moneyLabel:addTo(self.haveMoneyNode);
	moneyLabel:setPosition(-26 , 0);
	moneyLabel:setTextColor(cc.c3b(160 , 200 , 255));

    self.moneyNum = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
    self.moneyNum:addTo(self.haveMoneyNode);
    self.moneyNum:setAnchorPoint(1 , 0.5);
    self.moneyNum:setPosition(86 , 0);


    -- local shopTip = cc.Node:create();
	-- shopTip:addTo(self.root);
	-- shopTip:setPosition(0 , -433);
    -- shopTip:setLocalZOrder(110);
    
    -- local shopBg = cc.Sprite:create('image/commonImg/line_1_602_1.png');
    -- shopBg:addTo(shopTip);
    -- shopBg:setPosition(0 , 23);

	-- local shopImg = cc.Sprite:create('image/commonImg/tip_2.png');
	-- shopImg:addTo(shopTip);

	-- local shopLabel = cc.Label:createWithTTF(ResTable:getLangByNum(11636) , fonts.FONT_SIYUAN , 20);
	-- shopLabel:addTo(shopTip);
	-- shopLabel:setTextColor(cc.c3b(255 , 200 , 0));

	--local width = shopImg:getContentSize().width+10;
	--local labelWidth = shopLabel:getContentSize().width;
	--local posX = -labelWidth / 2;
	--shopImg:setPosition(posX , 0);
	--shopLabel:setPosition(posX + width/2+labelWidth/2 , 0);

    self.menuNode = cc.Node:create();
    self.menuNode:addTo(self.root);
    self.menuNode:setPosition(0 , 49 - StageSize.height / 2);

    local menuBg = cc.Sprite:create('image/footer/footer_bg_1.png');
    menuBg:addTo(self.menuNode);

    self.menuSelectImg = cc.Sprite:create('image/footer/footer_bg_2.png');
    self.menuSelectImg:addTo(self.menuNode);
    
    self.menuBtnList = {};
    self.menuInfo = {};
    self.menuIndexBtnList = {};
    
    local shopTag = {CommonShopType.ROLE , CommonShopType.EQUIP}
    for i = 1 , 2 do

        self.menuInfo[i] = {};
        local tag = shopTag[i];
        local node = cc.Node:create();
        node:addTo(self.menuNode);
        node:setPosition(-268 + 108*(i-1),5)
        self.menuIndexBtnList[i] = node;

        local menuBtn = ccui.Button:create(imagePath..'shop_footer_bg_'..tag..'.png',imagePath..'shop_footer_bg_'..tag..'.png');
        menuBtn:addTo(node);
        menuBtn:setTag(tag);
        menuBtn:addClickEventListener(handler(self , self.menuBtnClick));
        self.menuInfo[i].menuBtn = menuBtn;

        local label = cc.Label:createWithTTF(LANG.UI_STORE_FOOTER[tag] , fonts.FONT_SIYUAN , 16);
        label:addTo(node);
        label:setPosition(0 , -39);
        label:enableOutline(cc.c3b(0 , 0 , 0),2);
        self.menuInfo[i].label = label;
    end
end

function StorePanel:initSpineAni()

    if global_branch.branch_audit_event_showBg then
		
		if self.skeletonBg == nil then
			self.skeletonBg = cc.Sprite:create('image/shop/shop_bg.png')
                :addTo(self.root)
                :setPosition(114,105);
		end

		return 
    end
    
    local spine_res = 'NPC001_Spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then

		self.skeletonNode = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.skeletonNode:setPosition(cc.p(200,-30))

        self.skeletonNode:setMix('idle1','idle2',0.1);
		self.skeletonNode:setAnimation(0, "idle1", false)
		self.skeletonNode:addAnimation(0, "idle2", true)

        self.skeletonNode:addTo(self.root)
	
	else
		Prompt:Show(LANG.UI_CARD_2);
	end
end

function StorePanel:initRslMenuBar()
    self.rslMenuNode = cc.Node:create();
    self.rslMenuNode:addTo(self.root)
    self.rslMenuNode:setPosition(0,self.titltPosY-40)

    local labelName = {
        LANG.UI_SHOP_RSL_TITLES[1],
        LANG.UI_SHOP_RSL_TITLES[2]
    }

    self.rslMenuList = {};
    local menuWidth = 640 / 2;
    local menuStartPosX = menuWidth/2 - 640/2;
    for i=1,2 do

        local label = cc.Label:createWithTTF(labelName[i] , fonts.FONT_SIYUAN , 18);
        label:setScaleX(i == 2 and -1 or 1);

        local texture = 'image/commonImg/menu_left_71_46.png';
        local unTexture = 'image/commonImg/menu_left_71_46_u.png';

        -- if i == 2 or i == 3 then
        --     texture = 'image/commonImg/menu_mid_71_46.png';
        --     unTexture = 'image/commonImg/menu_mid_71_46_u.png';
        -- end
        local bgBtn = ccui.Button:create(texture,texture,unTexture);
        bgBtn:addTo(self.rslMenuNode);
        bgBtn:setTag(i);
        bgBtn:setTitleLabel(label)
        bgBtn:setScale9Enabled(true);
        bgBtn:setScaleX(i == 2 and -1 or 1);
        bgBtn:setCapInsets(cc.rect(10 , 0 , 51 , 46));
        bgBtn:setContentSize(cc.size(menuWidth , 46));
        bgBtn:setPosition(menuStartPosX + menuWidth*(i-1) , 0)
        bgBtn:addClickEventListener(handler(self , self.rslMenuClick));
        self.rslMenuList[i] = bgBtn;
    end

    self.rsllight = cc.Sprite:create('image/commonImg/menu_light_1.png');
    self.rsllight:addTo(self.rslMenuNode);
    self.rsllight:setPosition(cc.p(-266.5, 23));
end

function StorePanel:registEvent(  )
    EventManager:RegisterEvent(EventType.UIRetStoreInfo, handler(self, self.onShow));
    EventManager:RegisterEvent(EventType.UIBuyStoreItemSuccess, handler(self, self.retStoreBuy));
end

function StorePanel:menuBtnClick(sender , event)
    local tag = sender:getTag();
    self:changeMenuIndex(tag);

end

function StorePanel:changeMenuIndex( index )
    
    if index == nil or self.curStoreType == index  then
        return 
    end

    self:autoUiHeight(index)
    self:swtichNode(index);

	if not model.ShopModel:shopHasInit(index) then
        self.reqChangeIndex = index;
        model.ShopModel:reqShopInfo(index);
        return
    end

    self.curStoreType = index;
    self:onShow();
end

function StorePanel:onShow()
    if self.reqChangeIndex then
        self.curStoreType = self.reqChangeIndex;
        self.reqChangeIndex = nil;
    end

    self:swtichStoreList()
end

function StorePanel:updateStoreData()
    local shopData = model.ShopModel:getShopDataByIndex(self.curStoreType);
    if not shopData then
        return;
    end

    self.shopData = {};

    if self.curStoreType == CommonShopType.ROLE then
        self.shopData[0] = {};
        for _k , data in pairs(shopData) do
            local id = data.item[2];
            local role = ResTable:getRowData('role' , id);
            local rolePre = ResTable:getRowData('role_pre', role.role_id);
		    if not self.shopData[rolePre.def_type] then
		    	self.shopData[rolePre.def_type] = {};
		    end

            table.insert(self.shopData[rolePre.def_type] , data);
            table.insert(self.shopData[0] , data);
        end

        for _df , shopData in pairs(self.shopData) do
            if #shopData > 1 then
                table.sort(shopData , function(first , second) 
                    return (first.order or first.no) < (second.order or second.no);
                end);
            end
        end
    elseif self.curStoreType == CommonShopType.EQUIP then
        for _k , data in pairs(shopData) do
            local id = data.item[1];
            local equip = ResTable:getRowData('equip' , id);
		    if not self.shopData[equip.type] then
		    	self.shopData[equip.type] = {};
		    end

            table.insert(self.shopData[equip.type] , data);
        end

        for _df , shopData in pairs(self.shopData) do
            if #shopData > 1 then
                table.sort(shopData , function(first , second) 
                    return (first.order or first.no) < (second.order or second.no);
                end);
            end
        end
    elseif self.curStoreType == CommonShopType.RESOLVE then
        self.shopData[1] = {};
        self.shopData[2] = {};
        for _k , data in pairs(shopData) do
            if data.tab then
                if not self.shopData[data.tab] then
                    self.shopData[data.tab] = {}
                end
                table.insert(self.shopData[data.tab] , data);
            else
                table.insert(self.shopData[1] , data);
            end
        end

        for _df , shopData in pairs(self.shopData) do
            if #shopData > 1 then
                table.sort(shopData , function(first , second) 
                    return (first.order or first.no) < (second.order or second.no);
                end);
            end
        end
    else
        for _k , data in pairs(shopData) do
            table.insert(self.shopData , data);
        end

        if #self.shopData > 1 then
            table.sort(self.shopData , function(first , second) 
                return (first.order or first.no) <(second.order or second.no);
            end);
        end
    end
end

function StorePanel:swtichNode(curStoreType)
    self.roleStoreNode:setVisible(curStoreType == CommonShopType.ROLE);
    self.equipStoreNode:setVisible(curStoreType == CommonShopType.EQUIP);
    if curStoreType == CommonShopType.ADVENTURE1 then
        EventManager:FireEvent(EventType.HeaderUpdateTitle, 'Adventure1StorePanel')
    elseif curStoreType == CommonShopType.ADVENTURE2 then
        EventManager:FireEvent(EventType.HeaderUpdateTitle, 'Adventure2StorePanel')
    end
    
    self:updateShopTitle(curStoreType);
end

function StorePanel:updateShopTitle(curStoreType)
    local image = imagePath..'shop_top_bg.png';
    if curStoreType == CommonShopType.GUILD then
        self.haveMoneyNode:setVisible(true);
        self.shopTitleNode:setVisible(true);
        self.shopTitle:setString(tostring(LANG.UI_STORE_FOOTER[curStoreType]));
        local num = model.ItemModel:getItemNum(GUILD_MONEY);
        self.moneyNum:setString(tostring(num));
        local itemIcon = ResTable:getValue('item' , GUILD_MONEY , 'icon');
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        image = imagePath..'shop_top_bg_guild.png';
    elseif curStoreType == CommonShopType.RESOLVE then
        self.haveMoneyNode:setVisible(true);
        self.shopTitleNode:setVisible(true);
        self.shopTitle:setString(tostring(LANG.UI_STORE_FOOTER[curStoreType]));
        local num = model.ItemModel:getItemNum(RESOLVE_ITEM);
        local itemIcon = ResTable:getValue('item' , RESOLVE_ITEM , 'icon');
        self.moneyNum:setString(tostring(num));
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        image = imagePath..'shop_top_bg_resolve.png';
    elseif curStoreType == CommonShopType.MAZE then
        self.haveMoneyNode:setVisible(true);
        self.shopTitleNode:setVisible(true);
        self.shopTitle:setString(tostring(LANG.UI_STORE_FOOTER[curStoreType]));
        local num = model.ItemModel:getItemNum(MAZE_ITEM);
        local itemIcon = ResTable:getValue('item' , MAZE_ITEM , 'icon');
        self.moneyNum:setString(tostring(num));
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
    elseif curStoreType == CommonShopType.ARENA then
        self.haveMoneyNode:setVisible(true);
        self.shopTitleNode:setVisible(true);
        self.shopTitle:setString(tostring(LANG.UI_STORE_FOOTER[curStoreType]));
        local num = model.ItemModel:getItemNum(ARENA_MONEY);
        local itemIcon = ResTable:getValue('item' , ARENA_MONEY , 'icon');
        self.moneyNum:setString(tostring(num));
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        image = imagePath..'shop_top_bg_arena.png';
    elseif curStoreType == CommonShopType.MULT_ARENA then
        self.haveMoneyNode:setVisible(true);
        self.shopTitleNode:setVisible(true);
        self.shopTitle:setString(tostring(LANG.UI_STORE_FOOTER[curStoreType]));
        local num = model.ItemModel:getItemNum(ARENA_MULT_MONEY);
        local itemIcon = ResTable:getValue('item' , ARENA_MULT_MONEY , 'icon');
        self.moneyNum:setString(tostring(num));
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        image = imagePath..'shop_top_bg_arena.png';
    elseif curStoreType == CommonShopType.ADVENTURE1 then
        self.haveMoneyNode:setVisible(true);
        self.shopTitleNode:setVisible(true);
        self.shopTitle:setString(tostring(LANG.UI_STORE_FOOTER[curStoreType]));
        local num = model.ItemModel:getItemNum(ADVENTURE1_MONEY);
        local itemIcon = ResTable:getValue('item' , ADVENTURE1_MONEY , 'icon');
        self.moneyNum:setString(tostring(num));
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        image = imagePath..'shop_top_bg_adventure1.png';
    elseif curStoreType == CommonShopType.ADVENTURE2 then
        self.haveMoneyNode:setVisible(true);
        self.shopTitleNode:setVisible(true);
        self.shopTitle:setString(tostring(LANG.UI_STORE_FOOTER[curStoreType]));
        local num = model.ItemModel:getItemNum(ADVENTURE2_MONEY);
        local itemIcon = ResTable:getValue('item' , ADVENTURE2_MONEY , 'icon');
        self.moneyNum:setString(tostring(num));
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        image = imagePath..'shop_top_bg_adventure2.png';
    elseif curStoreType == CommonShopType.EQUIP then
        image = imagePath..'shop_top_bg_equip.png';
    else
        self.haveMoneyNode:setVisible(false);
        self.shopTitleNode:setVisible(false);
    end
    self.topBg:setTexture(image);
end

function StorePanel:swtichStoreList()

    if self.menuBtnList[self.curStoreType] then
        self.menuSelectImg:setPositionX(self.menuBtnList[self.curStoreType]:getPositionX());
    end

    self.menuType = nil;

    self:updateStoreData();
    if self.curStoreType == CommonShopType.ROLE then
        self:showRoleList(0)
    elseif self.curStoreType == CommonShopType.EQUIP then
        self:showEquipList(1);
    elseif self.curStoreType == CommonShopType.RESOLVE then
        self.menuType = 1;
        self:rslSwitchList(1);
        self:showStoreList();
    else
        self:showStoreList();
    end
end

function StorePanel:autoUiHeight(index)
    local footerHeight = 0
    if index == CommonShopType.ROLE or index == CommonShopType.EQUIP
    or index == CommonShopType.ADVENTURE1 or index == CommonShopType.ADVENTURE2 then
        footerHeight = FOOTER_HEIGHT;
    end

    local bgHeight = StageSize.height-self.topHeight-self.topBgHeight/2-self.titleHeight-footerHeight;
    local bgPosY = self.titltPosY-self.titleHeight/2-bgHeight/2+2;

    SCROLL_VIEW_HEIGHT = bgHeight-62;
    
    local scrollPosY = bgPosY - bgHeight/2 + 51;

    self.scrollViewBg:setPosition(0 , bgPosY-1);
    self.scrollViewBg:setContentSize(cc.size(640,bgHeight));

    local offH = 0;
    if index == CommonShopType.RESOLVE then
        offH = 36;
    end
    self.rslMenuNode:setVisible(index == CommonShopType.RESOLVE);

    self.storeScrollView:setPosition(-290.5 , scrollPosY);
    self.storeScrollView:setContentSize(cc.size(581 , SCROLL_VIEW_HEIGHT - offH));
    self.haveMoneyNode:setPositionY(scrollPosY-25)
end

function StorePanel:equipMenuClick(sender , event)
    local tag = sender:getTag();
    self:showEquipList(tag);
end

function StorePanel:showEquipList(mType)
    if mType == self.menuType then
        return;
    end
    for _menuType , menu in pairs(self.equipMenuList) do
		if _menuType == mType then
			menu.label:setTextColor(cc.c3b(255 , 255 , 255));
        else
			menu.label:setTextColor(cc.c3b(180 , 180 , 180));
		end
		menu.btn:setBright(_menuType == mType);
		menu.light:setVisible(_menuType == mType);
	end
   
    self.menuType = mType;
    self:showStoreList();
end

function StorePanel:roleMenuClick(sender , event)
    local tag = sender:getTag();
    self:showRoleList(tag);
end

function StorePanel:showRoleList(mType)
    if mType == self.menuType then
        return;
    end

    for _menuType , menu in pairs(self.roleMenuList) do
        menu.unselect:setVisible(mType ~= _menuType);
        menu.select:setVisible(mType == _menuType);
    end

    self.menuType = mType;
    self:showStoreList();
end

function StorePanel:showStoreList()
    local shopDatas = {};
    if self.curStoreType == CommonShopType.ROLE 
        or self.curStoreType == CommonShopType.EQUIP
        or self.curStoreType == CommonShopType.RESOLVE then
        shopDatas = self.shopData[self.menuType];
    else
        shopDatas = self.shopData;
    end

    self.shopItems = {};
    self.storeScrollView:removeAllChildren();

    local num = math.ceil(#shopDatas/3);
    local maxHeight = num * 203+5;
    if maxHeight < SCROLL_VIEW_HEIGHT then
        maxHeight = SCROLL_VIEW_HEIGHT;
    end

    self.storeScrollView:setInnerContainerSize(cc.size(581,maxHeight))

    local index = 0
    for _k , data in ipairs(shopDatas) do
        if data.hide and data.hide == 1 then
        else
            index = index + 1;
            local row = math.ceil(index / 3);
            local col = index % 3;
            col = col == 0 and 3 or col;
        
            local item = template.ShopItemTemplate:create();
            item:Init(data);
            item:setPosition(94.5 + (col-1) * 198 , maxHeight-100-(row - 1)*203);
            item:addTo(self.storeScrollView);
            item:setItemTag(data.no);
            item:addItemClickEventListener(handler(self , self.listItemClick));
            self.shopItems[data.no] = item;
        end
    end
end

function StorePanel:listItemClick(sender , event)
    AudioManager:playEffect(Conf.buttonClick)
    local id = sender:getTag();
    
    local shopData = model.ShopModel:getShopDataByIndex(self.curStoreType); --如果不是礼包和充值menuType = nil;
        
    if not shopData then
        return;
    end

    local itemData = shopData[id]

    if not itemData then
        return;
    end
    if itemData.times and itemData.times == 0 then
        Prompt:Show(LANG.UI_SHOP_102)
        return;
    end
    if itemData.buytype and itemData.buytype ~= 0 then
        local buytype = itemData.buytype or 0
        local buyvalue = itemData.buyvalue or 0
        local match = false
        if buytype == 4 and buyvalue == 1 then
            local monthData = model.RechargeModel:getMonthData()
            if monthData[4] and monthData[4].state and monthData[4].state == 4 then
                match = true
            end
        elseif buytype == 4 and buyvalue == 2 then
            local monthData = model.RechargeModel:getMonthData()
            if monthData[5] and monthData[5].state and monthData[5].state == 4 then
                match = true
            end
        elseif buytype == 7 then
            local battlepass_state = model.BattlepassEventModel:getSpecialState()
            if battlepass_state and battlepass_state == 1 then
                match = true
            end
        elseif buytype == 8 then
            local mazeData = model.EventModel:getBPData()
            if mazeData and mazeData.special_state and mazeData.special_state == 1 then
                match = true
            end
        end
        if not match then
            Prompt:Show(LANG.UI_SHOP_104)
            return
        end
    end

    if itemData.times ~= 0 then
        UIManager:push('TipsShopPanel' , self.curStoreType , id);
    else
        Prompt:Show(LANG.UI_SHOP_37);
    end
end

function StorePanel:onEnter(storeType)
    model.ShopModel:resetShopInit()

    self:swtichNode(-1);
    self.storeScrollView:removeAllChildren();
    
    self.curStoreType = nil;
    self.reqChangeIndex = nil;
    self.menuBtnList = {};
    
    storeType = storeType or CommonShopType.ROLE;
    
    if storeType == CommonShopType.ROLE or storeType == CommonShopType.EQUIP then
        self.menuNode:setVisible(true);
        local shopTag = {CommonShopType.ROLE , CommonShopType.EQUIP};
        for i = 1 , 2 do
            self.menuBtnList[shopTag[i]] = self.menuIndexBtnList[i];
            self.menuInfo[i].menuBtn:setTag(shopTag[i]);
            self.menuInfo[i].menuBtn:loadTextures(imagePath..'shop_footer_bg_'..shopTag[i]..'.png',imagePath..'shop_footer_bg_'..shopTag[i]..'.png');
            self.menuInfo[i].label:setString(LANG.UI_STORE_FOOTER[shopTag[i]]);
        end
        storeType = self:updateVisible(storeType);
    elseif storeType == CommonShopType.ADVENTURE1 or storeType == CommonShopType.ADVENTURE2 then
        self.menuNode:setVisible(true);
        local shopTag = {CommonShopType.ADVENTURE2,CommonShopType.ADVENTURE1};
        for i = 1 , 2 do
            self.menuBtnList[shopTag[i]] = self.menuIndexBtnList[i];
            self.menuInfo[i].menuBtn:setTag(shopTag[i]);
            self.menuInfo[i].menuBtn:loadTextures(imagePath..'shop_footer_bg_'..shopTag[i]..'.png',imagePath..'shop_footer_bg_'..shopTag[i]..'.png');
            self.menuInfo[i].label:setString(LANG.UI_STORE_FOOTER[shopTag[i]]);
        end
        self.menuSelectImg:setPositionX(-268);
    else
        self.menuNode:setVisible(false);
    end

    local panelName = 'StorePanel'
    if storeType == CommonShopType.GUILD then
        panelName = 'GuildStorePanel';
    elseif storeType == CommonShopType.RESOLVE then
        panelName = 'ResolveStorePanel';
    elseif storeType == CommonShopType.MAZE then
        panelName = 'MazeStorePanel';
    elseif storeType == CommonShopType.ARENA then
        panelName = 'ArenaStorePanel';
    elseif storeType == CommonShopType.MULT_ARENA then
        panelName = 'ArenaMultStorePanel';
    elseif storeType == CommonShopType.ADVENTURE1 then
        panelName = 'Adventure1StorePanel';
    elseif storeType == CommonShopType.ADVENTURE2 then
        panelName = 'Adventure2StorePanel';
    elseif storeType == CommonShopType.SPECIAL then
        panelName = 'SpecialStorePanel';
    end
    EventManager:FireEvent(EventType.HeaderUpdateTitle, panelName)

   --if menuSelectPos[storeType] then
   --    self.menuSelectImg:setPosition(menuSelectPos[storeType]);
   --end

    self:changeMenuIndex(storeType)
    self.root:setVisible(true)

end

function StorePanel:updateVisible(shopType)
    local openMenuList = tools.ConfigStateTools:setVisibleByType(Enum:getTable('ConfigStateType').STORE , self.menuBtnList);

    if not openMenuList or #openMenuList <= 0 then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('StorePanel');
        return;
    end

    local visibleNum = #openMenuList;
    if visibleNum > 1 then
        table.sort(openMenuList , function(first , second)
            return first.index < second.index;
        end);
    end

    local openType = nil;
    for _k , openData in ipairs(openMenuList) do
        local posX = -268 + 108*(_k-1)
        self.menuBtnList[openData.index]:setPosition(posX,5);
        if not openType and openData.state == 0 then
            openType = openData.index;
            self.menuSelectImg:setPositionX(posX);
        end
        if shopType == openData.index and openData.state == 0 then
            openType = shopType;
            self.menuSelectImg:setPositionX(posX);
        end
    end

    if not openType then
        Prompt:Show(LANG.COMMON_CLOSE);
        UIManager:pop('StorePanel');
        return
    end

    return openType;
end

function StorePanel:retStoreBuy(msg)
    if msg.shop then
        Prompt:Show(LANG.UI_SHOP_68)
        self:swtichStoreList();
        return;
    end

    local id = msg.id or msg.item_id;

    if msg.rest_times and msg.rest_times >= 0 then
        if self.curStoreType == CommonShopType.ROLE 
            or self.curStoreType == CommonShopType.EQUIP
            or self.curStoreType == CommonShopType.RESOLVE then
            
            for _type , shopData in pairs(self.shopData) do
                for _idx , data in pairs(shopData) do
                    if data.no == id then
                        data.times = msg.rest_times;
                        self.shopItems[id]:Init(data);
                        break;
                    end
                end
            end
        else
            for _idx , data in pairs(self.shopData) do
                if data.no == id then
                    data.times = msg.rest_times;
                    self.shopItems[id]:Init(data);
                    break;
                end
            end
        end
    end
    self:updateShopTitle(self.curStoreType);
    UIManager:push('RewardPanel',msg,{effectName = 'RewardGoods'})
    --GlobalFunctions:showRewardPrompt(msg , LANG.UI_SHOP_45);
end

function StorePanel:rslMenuClick(sender , event)
    local tag = sender:getTag()
    if tag == self.menuType then
        return;
    end
    self:rslSwitchList(tag);
    self.menuType = tag;
    self:showStoreList();
end

function StorePanel:rslSwitchList(index)

    for _k , btn in pairs(self.rslMenuList) do
        local label = btn:getTitleLabel();
        if _k == index then
            btn:setBright(true)
            label:setTextColor(cc.c3b(255 , 255 , 255));
            self.rsllight:setPositionX(btn:getPositionX());
        else
            btn:setBright(false)
            label:setTextColor(cc.c3b(180 , 180 , 180));
        end
    end

end

function StorePanel:onLeave( ... )
    self.root:setVisible(false);
end

function StorePanel:onClickBack()
    UIManager:pop('StorePanel');
end

return StorePanel

