local StoryLinePanel = class("StoryLinePanel",require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local imgPath = 'image/storyLine/';

local cellW = 73;
local cellH = 73;

local mapWidth = 720*2;
local mapHeight = 1150*2;
local minScale = 0.7;
local maxScale = 1.5;
local minX, minY, maxX, maxY = 0,0,0,0;

function StoryLinePanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'StoryLinePanel');

    self.useCCreator = false;
	self.isPopup = false;
	self.haveSwallowLayer = false;
    self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	-- self.showFooter = true;
    
end

function StoryLinePanel:Init( root )
    -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPannel();
    self:registEvent();
    self:addTouchEvent();

end

function StoryLinePanel:registEvent(  )
 --    EventManager:RegisterEvent('EGO_ContactEvent' , handler(self , self.onContactBegin));
	-- EventManager:RegisterEvent('PlayBallPanel:refreshAllBox' , handler(self , self.refreshAllBox));
 --    EventManager:RegisterEvent('PlayBallPanel:refreshTopItems' , handler(self , self.refreshTopItems));
end

function StoryLinePanel:initPannel(  )
    
    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);

    local bg1 = cc.Sprite:create('image/playball/bb_bg.png');
    bg1:addTo(bgNode);


    self.allBgNode = cc.Node:create()
    self.allBgNode:addTo(self.root)
    self.allBgNode:setContentSize(cc.size(20000,20000))

    local shadow = cc.Scale9Sprite:create('image/storyLine/all_shadowbg.png')
    shadow:setContentSize(StageSize)
	shadow:addTo(self.root)

    self.cellList = {}
    self.mainNode = cc.Node:create()
    self.mainNode:addTo(self.root)
    self.mainNode:setContentSize(cc.size(20000,20000))

    self.bgRoleList = {}
    local lineBgNode = cc.Node:create()
    lineBgNode:addTo(self.allBgNode)
    -- lineBgNode:setPosition(359, -433)
    local roleBgNode = cc.Node:create()
    roleBgNode:addTo(self.allBgNode)
    -- roleBgNode:setPosition(359, -433)
    for i=1,4 do
    	local node = cc.Node:create()
    	node:addTo(lineBgNode)
    	node:setPosition((i-1)%2*719-360, -math.floor((i-1)/2)*1150+575)
    	local lbg = cc.Sprite:create('image/storyLine/map_bg.png')
    	lbg:addTo(node)

    	local role = cc.Sprite:create()
    	role:addTo(roleBgNode)
    	role:setPosition((i-1)%2*719-360, -math.floor((i-1)/2)*1150+575)
    	self.bgRoleList[i] = role

    	-- local shadow = cc.Sprite:create('image/storyLine/all_shadowbg.png')
    	-- shadow:addTo(node)

    end

    local subNode = cc.Node:create()
    subNode:setPosition(-720,1010)
    subNode:addTo(self.mainNode)

    self.bgPathNode = cc.Node:create()
    self.bgPathNode:addTo(subNode)

    self.pathNode = cc.Node:create()
    self.pathNode:addTo(subNode)

    self.cellNode = cc.Node:create()
    self.cellNode:addTo(subNode)

    -- self.bottomNode = cc.Node:create()
    -- self.bottomNode:addTo(self.root)
    -- local bottomNode = cc.Node:create()
    -- bottomNode:addTo(self.bottomNode)
    -- bottomNode:setPosition(0, -StageSize.height/2)

    -- local btmBg1 = cc.Sprite:create( imgPath..'bb_light.png' )
    -- btmBg1:addTo(bottomNode)
    -- btmBg1:setAnchorPoint(0.5,0)
    -- -- btmBg1:setBlendFunc(cc.blendFunc(GL_ZERO, GL_SRC_COLOR));
    -- -- btmBg1:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA));
    -- btmBg1:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE));



    self.storyId = 0;
    local sc1 = StageSize.width/mapWidth;
    local sc2 = StageSize.height/mapHeight;
	minScale = sc1>sc2 and sc1 or sc2;
    -- self.mainNode:setScale(0.7);
    -- self.allBgNode:setScale(0.7);

    local btmNode = cc.Node:create()
    btmNode:addTo(self.root)
    btmNode:setPosition(-StageSize.width/2+30, -StageSize.height/2+130)
    local btmBg = cc.Sprite:create('image/storyLine/sc_bg.png')
    btmBg:addTo(btmNode)
    local scMin = cc.Sprite:create('image/storyLine/sc_min.png')
    scMin:addTo(btmNode)
    scMin:setPosition(0, 80)
    local scMax = cc.Sprite:create('image/storyLine/sc_max.png')
    scMax:addTo(btmNode)
    scMax:setPosition(0, -80)
    self.scPt = cc.Sprite:create('image/storyLine/sc_pt.png')
    self.scPt:addTo(btmNode)


    local castNode = cc.Node:create()
	castNode:addTo(self.root)
	castNode:setPosition(0, StageSize.height/2-100-NOTCH_HEIGHT)
	local castBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
	castBg:addTo(castNode)
	castBg:setContentSize(cc.size(600, 100))
	local expProgressBg = cc.Scale9Sprite:create("image/commonImg/pgs_bg_1_223_12.png")
		:addTo(castNode)
		:setPosition(-60,-20)
		:setCapInsets(cc.rect(10,0,203,12))
		:setContentSize(cc.size(439 , 15))
	local progress = cc.Scale9Sprite:create("image/commonImg/pgs_1_445_21.png")
	self.expProgress = cc.ProgressTimer:create(progress);
	self.expProgress:setType(cc.PROGRESS_TIMER_TYPE_BAR);
	self.expProgress:setMidpoint(cc.p(0, 0));
	self.expProgress:setBarChangeRate(cc.p(1, 0));
	self.expProgress:setPosition(expProgressBg:getContentSize().width/2,expProgressBg:getContentSize().height/2);
	self.expProgress:setPercentage(10);
	self.expProgress:addTo(expProgressBg);
	self.proLabel = cc.Label:createWithTTF('10/15', fonts.FONT_SIYUAN, 18)
		:addTo(castNode)
		:setPosition(-60,-20)
		:setAnchorPoint(0.5 , 0.5)
		:enableOutline(cc.c3b(50 , 20 , 0),2)

	self.rwdBg = cc.Sprite:create('image/storyLine/gold_shine.png')
	self.rwdBg:setPosition(250, 0)
	self.rwdBg:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE));
	self.rwdBg:addTo(castNode);

	self.rwdBtn = ccui.Button:create('image/icon/I18003.png');
	self.rwdBtn:addTo(castNode);
	self.rwdBtn:setPosition(250, 0)
	self.rwdBtn:addClickEventListener(handler(self, self.clickRwdBtn));

	local icon1 = cc.Sprite:create('image/randomBoss/random_bg3.png')
    icon1:addTo(castNode)
    icon1:setPosition(-270,20)
    local label1 = cc.Label:createWithTTF('关卡完成进度总览' ,  fonts.FONT_SIYUAN , 20)
        :addTo(castNode)
        :setPosition(-250 , 20)
        :setAnchorPoint(0, 0.5)
        :enableOutline(cc.c3b(0 , 0 , 0),2)
    
end

function StoryLinePanel:addTouchEvent()

	self.distance = 0;
	self.deltax = 0;
	self.deltay = 0;
	self.mscale = 1.0;

	if self.touchListener then
		local eventDispatcher = cc.Director:getInstance():getEventDispatcher();
		eventDispatcher:removeEventListener(self.touchListener);
	end
	-- listener
	local touchesBegan = function(touches, event)
		if self.root:isVisible() == false then
			return
		end
		-- self:resetOpenActivityNode();
    end

	local touchesMoved = function(touches, event)
		if self.root:isVisible() == false then
			return
		end

		if #touches >= 2 then
    	
        	local touch = touches[1];
			local pos = touch:getLocation();
			local pos1 = self.root:convertToNodeSpace(pos);

			touch = touches[2];
			pos = touch:getLocation();
			local pos2 = self.root:convertToNodeSpace(pos);

			local mdistance=math.sqrt((pos2.x-pos1.x)*(pos2.x-pos1.x)+(pos2.y-pos1.y)*(pos2.y-pos1.y));

			if self.distance == 0 then
				self.distance = mdistance
				self.deltax = (pos1.x+ pos2.x)/2 - self.mainNode:getPositionX();
				self.deltay = (pos2.y + pos1.y)/2 - self.mainNode:getPositionY();
				return
			end

			self.mscale = mdistance/self.distance * self.mscale;
			
			if self.mscale > maxScale then
				self.mscale = maxScale;
			elseif self.mscale < minScale then
				self.mscale = minScale;
			end

			self.distance = mdistance;
		
        	self.mainNode:setScale(self.mscale);
        	self.allBgNode:setScale(self.mscale);
        	self:checkMoveArea(self.mscale)
			
        	local x = (pos2.x+pos1.x)/2 - self.deltax;
			local y = (pos2.y+pos1.y)/2 - self.deltay;

			x,y = self:checkMovePos(x, y);
			self:updateScPtPos()
        	self.mainNode:setPosition(ccp(x,y));
        	self.allBgNode:setPosition(ccp(x,y));
        	self.deltax = (pos1.x+ pos2.x)/2 - self.mainNode:getPositionX();
			self.deltay = (pos2.y + pos1.y)/2 - self.mainNode:getPositionY();
		elseif #touches == 1 then
			local x , y = self.mainNode:getPosition();
			local delta = touches[1]:getDelta();

			local px,py = self:checkMovePos(x + delta.x , y + delta.y);
			self.mainNode:setPosition(px , py);
			self.allBgNode:setPosition(px , py);

			-- print('fubin--move: x, y: ', px , py , StageSize.width, StageSize.height)
        end
    end

    local touchesEnded = function(touches, event)
    	if self.root:isVisible() == false then
			return
		end
    	if #touches == 1 then
    		local touch = touches[1];
			local posEnd = touch:getLocation();
			local posStart = touch:getStartLocation()
			local dis = cc.pGetDistance(posStart,posEnd)
			if dis < 20 then
	    	end
	    end
		self.distance = 0;
		self.deltax = 0;
		self.deltay = 0;
    end

    local touchesCancelled = function(touch, event)
		self.distance = 0;
		self.deltax = 0;
		self.deltay = 0;
	end
	
	self.touchListener = cc.EventListenerTouchAllAtOnce:create()
    self.touchListener:registerScriptHandler(touchesBegan, cc.Handler.EVENT_TOUCHES_BEGAN)
    self.touchListener:registerScriptHandler(touchesMoved, cc.Handler.EVENT_TOUCHES_MOVED)
    self.touchListener:registerScriptHandler(touchesEnded, cc.Handler.EVENT_TOUCHES_ENDED)
    self.touchListener:registerScriptHandler(touchesCancelled, cc.Handler.EVENT_TOUCHES_CANCELLED)

    local eventDispatcher = cc.Director:getInstance():getEventDispatcher()
    eventDispatcher:addEventListenerWithSceneGraphPriority(self.touchListener, self.mainNode)
end

function StoryLinePanel:checkMoveArea( scale )
	local sa = scale or 1;
	local mx = mapWidth*sa - StageSize.width;
	local my = mapHeight*sa - StageSize.height;
	minX, minY, maxX, maxY = -mx/2, -my/2, mx/2, my/2;
end

function StoryLinePanel:checkMovePos(x, y)
	x = x>maxX and maxX or x;
	x = x<minX and minX or x;
	y = y>maxY and maxY or y;
	y = y<minY and minY or y;
	return x,y;
end

function StoryLinePanel:updateScPtPos()
	local pro = (self.mscale-minScale)/(maxScale-minScale);
	self.scPt:setPosition(0, 60-(pro*110) )
end

function StoryLinePanel:onClickBack( ... )
	UIManager:pop('StoryLinePanel');
end

function StoryLinePanel:refreshTopItems()
end

function StoryLinePanel:onEnter( no )
	self.storyId = no;

	local storyData = model.StoryModel:getStoryDataById( self.storyId )
	self.mapData = storyData.mapStatus;
	self.crossCnt = storyData.storyPro;
	self.totalCnt = storyData.storyTotal;

	self.mscale = 1;
	self.mainNode:setScale(1);
	self.allBgNode:setScale(1);
	self.mainNode:setPosition(0,0);
	self.allBgNode:setPosition(0,0);
	self:checkMoveArea(1)
	self:updateScPtPos()

    self:onShow();

    self:refreshTopItems();

end

function StoryLinePanel:createOneCell( cellId )
	-- body
	local cellData = ResTable:getRowData('dungeon_map', cellId);

	local px = math.floor(cellData.coordinate / 1000)
	local py = cellData.coordinate % 1000

	local tileNode = cc.Node:create()
	tileNode:addTo(self.cellNode)
	tileNode:setPosition(px*cellW, -py*cellH)
	self.cellList[ cellId ] = tileNode;

	local st = 0;
	for k,v in pairs(self.mapData) do
		if cellId == v.no then
			st = v.status;
			break;
		end
	end

	local iconName = 'close_icon.png'
	if st==1 then
		iconName = 'cross_icon.png'
	elseif st==2 then
		iconName = 'cur_icon.png'
	end

	local numY = -40;
	local sprY = 0;
	local curTileName = 'cell_2bg_cur.png';
	if cellData.type == 2 or cellData.type == 3 then
		local tileBgName = 'cell_1bg.png'
		curTileName = 'cell_1bg_cur.png';
		if cellData.type == 3 then
			tileBgName = 'cell_endbg.png'
			curTileName = 'cell_endbg_cur.png';
		end

		if st == 2 then
			local curBg = cc.Sprite:create(imgPath..curTileName);
			curBg:addTo(tileNode)
		end

		local plotIcon = cc.Sprite:create(imgPath..'plot_icon.png')
		plotIcon:addTo(tileNode)

		local tileBg = cc.Sprite:create(imgPath..tileBgName)
		tileBg:addTo(tileNode)
		numY = -70;
		sprY = -40;
		
		local plotData = ResTable:getRowData('dungeon_plot', cellData.plot_id);
		local nameLabel = cc.Label:createWithTTF(plotData.name ,  fonts.FONT_SIYUAN , 16)
	        :addTo(tileNode)
	        :setPosition(0 , -15)
	        :enableOutline(cc.c3b(0 , 0 , 0),1)
	else
		if st == 2 then
			local curBg = cc.Sprite:create(imgPath..curTileName);
			curBg:addTo(tileNode)
		end
		
		local tileBg = cc.Sprite:create(imgPath..'cell_2bg.png')
		tileBg:addTo(tileNode)
	end

	local stSpr = cc.Sprite:create(imgPath..iconName)
	stSpr:addTo(tileNode)
	stSpr:setPosition(0, sprY)

	local numBg = cc.Sprite:create(imgPath..'num_bg.png')
	numBg:addTo(tileNode)
	numBg:setPosition(0, numY)
	local numLabel = cc.Label:createWithTTF(cellData.name ,  fonts.FONT_SIYUAN , 16)
        :addTo(tileNode)
        :setPosition(0 , numY+5)
        :enableOutline(cc.c3b(0 , 0 , 0),1)

	if cellData.link_way then
		for k,v in pairs(cellData.link_way) do
			if v[1] and v[2] then
				local lineSpr = cc.Sprite:create(imgPath..'line_'..v[1]..'.png')
				lineSpr:addTo(self.pathNode)
				lineSpr:setPosition(px*cellW, -py*cellH)
				lineSpr:setRotation(-v[2])
			end
		end
	end

	if cellData.next then
		for k,v in pairs(cellData.next) do
			self:createOneCell( v )
		end
	end

end

function StoryLinePanel:onShow()
	local storyData = ResTable:getRowData('dungeon', self.storyId);
	local idx = 1
	-- for k,v in pairs(storyData.bg_show) do
	-- 	self.bgRoleList[idx]:setTexture('image/role/'..v..'.png')
	-- 	GlobalFunctions:setSpriteGrey(self.bgRoleList[idx])
	-- 	self.bgRoleList[idx]:setOpacity(50)
	-- 	idx = idx+1;
	-- end

	for i=1,4 do
		self.bgRoleList[i]:setTexture('image/role/'..storyData['bg_show_'..i]..'.png')
		GlobalFunctions:setSpriteGrey(self.bgRoleList[i])
		self.bgRoleList[i]:setOpacity(50)
	end

	self.bgPathNode:removeAllChildren();
	self.pathNode:removeAllChildren();
	self.cellNode:removeAllChildren();

	local roundData = ResTable:getRowData('dungeon_round', storyData.start_round);
	self:createOneCell( roundData.map_id )

	local proInfo = math.floor(self.crossCnt*100/self.totalCnt);
	self.proLabel:setString(proInfo..'%')
	self.expProgress:setPercentage(proInfo);

	local curIdx = 7;
	-- local wpPos = self.cellNode:convertToWorldSpace(cc.p(self.cellList[curIdx]:getPosition()));
	-- print('fubin: wp:', wpPos.x, wpPos.y)

	-- local wpPos1 = self.mainNode:getParent():convertToWorldSpace(cc.p(self.mainNode:getPosition()));
	-- print('fubin: wp1:', wpPos1.x, wpPos1.y)

	local localPos = self.cellNode:convertToNodeSpace(cc.p(StageSize.width/2, StageSize.height/2));
	-- print('fubin: localPos:', localPos.x, localPos.y)

	local addPt = cc.pSub(localPos , cc.p(self.cellList[curIdx]:getPosition()))
	local curPt = cc.p(self.mainNode:getPosition());
	local tmpPt = cc.pAdd(curPt, addPt);
	local x,y = self:checkMovePos(tmpPt.x, tmpPt.y);
	self.mainNode:setPosition(x,y)
	self.allBgNode:setPosition(x,y)


    self.root:setVisible(true)
end

function StoryLinePanel:clickRwdBtn(sender , event)
	UIManager:push('StoryRwdPanel', self.storyId);
end

function StoryLinePanel:onLeave( ... )
    self.root:setVisible(false);
end

return StoryLinePanel
