local StoryPanel = class('StoryPanel' , require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/battlePass/'
local CommonShopType = Enum:getTable('CommonShopType');
local BATTLEPASS_MOVE_Y = 251;
local BATTLEPASS_VIEW_HEIGHT = StageSize.height-80 + BATTLEPASS_MOVE_Y;
local SHOP_SCROLL_VIEW_HEIGHT = 0;

function StoryPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'StoryPanel');

	self.useCCreator = false;
	self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
	self.showFooter = false;
end

function StoryPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
  
      self:initPanel();
  
      self:registEvent();
end

function StoryPanel:initPanel()
    -- body
    local newRoot = cc.Node:create()
    newRoot:addTo(self.root)
    newRoot:setLocalZOrder(0)

    local bg = cc.Sprite:create('image/title/bg.png')
    bg:addTo(newRoot)

    local bottomHeight = StageSize.height- NOTCH_HEIGHT;
    local scorllWidth = StageSize.width

    self.scorllview = ccui.ScrollView:create();
    self.scorllview:setTouchEnabled(true);
    self.scorllview:setBounceEnabled(true);
    self.scorllview:setDirection(ccui.ScrollViewDir.vertical);
    self.scorllview:setContentSize(cc.size(scorllWidth , bottomHeight));
    self.scorllview:setAnchorPoint(cc.p(0,0));
    self.scorllview:setScrollBarEnabled(false);
    self.scorllview:setPosition(-scorllWidth/2 , -bottomHeight/2);
    self.scorllview:addTo(newRoot);

    local topShadowSpr = cc.Sprite:create('image/storyLine/shadow.png');
    topShadowSpr:addTo(self.root);
    -- topShadowSpr:setContentSize(cc.size(StageSize.width, 366))
    topShadowSpr:setAnchorPoint(0.5, 1)
    topShadowSpr:setFlipY(true)
    topShadowSpr:setPosition(0, StageSize.height/2)

    local btmShadowSpr = cc.Sprite:create('image/storyLine/shadow.png');
    btmShadowSpr:addTo(self.root);
    -- btmShadowSpr:setContentSize(cc.size(StageSize.width, 366))
    btmShadowSpr:setAnchorPoint(0.5, 0)
    btmShadowSpr:setPosition(0, -StageSize.height/2)
    
    self.cellList = {}

end

function StoryPanel:registEvent()
    -- EventManager:RegisterEvent(EventType.NetworkRetBattlepassData, handler(self, self.onShow));
    -- EventManager:RegisterEvent('EventBattlePassPanel:retBattlepassReward', handler(self, self.retBattlepassReward));
    -- EventManager:RegisterEvent('EventBattlePassPanel:buyBattlepassSpecial', handler(self, self.buyBattlepassSpecial));
end

function StoryPanel:onEnter()
    if #self.cellList == 0 then
        self:initList();
    end
    self.root:setVisible(true)
end

function StoryPanel:initList()
    local totalH = 400
    local baseBagPos = 0;
    local scorllWidth = StageSize.width;

    local dataList = model.StoryModel:getAllStoryList();

    local cnt = 0;
    local cellNodeList = {}
    for k,v in pairs(dataList) do

        local cell = cc.Node:create()
        cell:setPosition(scorllWidth/2, totalH)
        cell:addTo(self.scorllview)

        local cellNode = template.StoryCell:create(cell);
        -- cellNode:addTo(cell)
        cellNode:initData(k);
        self.cellList[k] = cellNode;

        totalH = totalH + 800
        if false then 
            baseBagPos = totalH;
        end

        cnt = cnt+1;
        cellNodeList[cnt] = cell;
    end
   
    totalH = totalH-400

    local footerHeight = 0
    -- local tmpTop = StageSize.height/2 -120 - NOTCH_HEIGHT
    local tmpTop = StageSize.height/2 -537 - 97 - NOTCH_HEIGHT
    local lastHeight = tmpTop + StageSize.height/2 - footerHeight; --剩余高度空间 120是footer高度

    self.scorllview:setInnerContainerSize(cc.size(scorllWidth, totalH));

    if cnt == 1 then
        cellNodeList[1]:setPosition(scorllWidth/2, StageSize.height/2)
        self.scorllview:setTouchEnabled(false)
    elseif cnt == 2 then
    else
    end

    -- self.baseBagPos = 0;
    -- if totalH > lastHeight then
    --     self.scorllview:setPosition(-scorllWidth/2 , -StageSize.height/2 + footerHeight);
    --     self.scorllview:setContentSize(cc.size(scorllWidth , lastHeight));
    --     if baseBagPos >= lastHeight then
    --         self.baseBagPos = (totalH-baseBagPos)/(totalH-lastHeight)*100;
    --     else
    --         self.baseBagPos = 100;
    --     end

    -- else
    --     -- for k,v in pairs(self.battlePassCell) do
    --     --     local x,y = v.cellNode:getPosition()
    --     --     v.cellNode:setPosition(x, y+(lastHeight-totalH))
    --     -- end
    --     totalH = lastHeight
    --     self.scorllview:setPosition(-scorllWidth/2 , -StageSize.height/2+(lastHeight-totalH) + footerHeight);
    --     self.scorllview:setContentSize(cc.size(scorllWidth , totalH));
    --     self.scorllview:setInnerContainerPosition(cc.p(0,0))
        
    -- end
    
    -- if false then
    --     self.scorllview:jumpToPercentVertical( self.baseBagPos );
    -- end

end

function StoryPanel:onLeave()
    self.root:setVisible(false);
end

function StoryPanel:onClickBack()
    UIManager:pop('StoryPanel');
end

return StoryPanel