local StoryRoundPanel = class("StoryRoundPanel",require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local imgPath = 'image/trial/';
local TeamType = Enum:getTable('TeamType')
local FightType = Enum:getTable('FightType');

function StoryRoundPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'StoryRoundPanel');
	self.useCCreator = false;
    self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
    -- self.showFooter = true;
    
end

function StoryRoundPanel:Init( root,scene )
    -- body
    self.root = root;
    self.scene = scene;
    self.root:setVisible(false);
    self.curTeamType = TeamType.STORY;
    -- self.root:setPosition(StageSize.width/2,StageSize.height/2);

    self:initPannel();
    self:initTeam()
    self:initMonster()
    self:registEvent();

    self:initCardList();
    self:initTopNode();

end

function StoryRoundPanel:registEvent(  )
	EventManager:RegisterEvent(EventType.UITrialPanelFightOver , handler(self , self.retFightOverAuto));

    EventManager:RegisterEvent('StorySaveCard' , handler(self , self.retSaveCard));
end

function StoryRoundPanel:initPannel(  )

	local blackBg = ccui.Layout:create();
	blackBg:setBackGroundImage('image/task/blackbg.png');
	blackBg:setBackGroundImageScale9Enabled(true);
	blackBg:setTouchEnabled(true);
	blackBg:setContentSize(StageSize);
	blackBg:setLocalZOrder(-2);
	blackBg:setAnchorPoint(cc.p(0.5,0.5));
	blackBg:setPosition(0, 0);
    blackBg:addTo(self.root);
    
    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);

    local bg1 = cc.Sprite:create('image/round/BG_chapter_0.png');
    bg1:addTo(bgNode);
    --bg1:setPosition(cc.p(0,72));

    -- local bg4 = cc.Sprite:create('image/fight/scene/scene61.png');
    -- bg4:addTo(bgNode);
    -- bg4:setPosition(cc.p(0,-160));

    local btmBg = cc.Sprite:create('image/storyLine/round_btm.png')
    btmBg:setAnchorPoint(0.5, 0)
    btmBg:addTo(bgNode)
    btmBg:setPosition(0, -StageSize.height/2)

    -- topPower
    -- local topPowerNode = cc.Node:create()
    --     :addTo(self.root)
    --     :setPosition(cc.p(0,403))

    -- local powerBg = cc.Sprite:create( imgPath .. 'power_bg.png')
    --     :addTo(topPowerNode)
    -- local powerBg2 = cc.Sprite:create( imgPath .. 'power_bg2.png')
    --     :addTo(topPowerNode)
    --     :setPosition(cc.p(-130,-1))
    -- local powerBg3 = cc.Sprite:create( imgPath .. 'power_bg3.png')
    --     :addTo(topPowerNode)
    --     :setPosition(cc.p(-103,-1))
    --     :setAnchorPoint(cc.p(0,0.5))
    
    -- self.curItemPowerLabel = cc.Label:createWithTTF('9999',fonts.FONT_SIYUAN,20)
    --     :addTo(topPowerNode)
    --     :setPosition(cc.p(121,2))
    --     :setAnchorPoint(cc.p(1,0.5))
    --     :enableShadow(cc.c4b(0,0,0,255),cc.size(0,0))

     --编队 挑战
    local btmNode = cc.Node:create()
    btmNode:setPosition(0, -StageSize.height/2)
    btmNode:addTo(self.root)

    -- local btmBg = cc.Scale9Sprite:create('image/commonImg/top_2_bg_71_46.png')
    -- btmBg:setAnchorPoint(0.5, 0)
    -- btmBg:addTo(btmNode)
    -- btmBg:setContentSize(cc.size(640, 500))

    local btnY = 422;
    local label = cc.Label:createWithTTF(LANG.UI_TRIAL_3 ,  fonts.FONT_SIYUAN , 18)
        :enableOutline(cc.c4b(163 , 0 , 0 , 255),2)
    self.fightBtn = ccui.Button:create('image/storyLine/fight_btn.png' , 'image/storyLine/fight_btn.png')
        :addTo(btmNode)
        :setPosition(200, btnY)
        :setTitleLabel(label)
    self.fightBtn:addClickEventListener(handler(self , self.onFight))

    local label = cc.Label:createWithTTF(LANG.UI_FIGHT_36 ,  fonts.FONT_SIYUAN , 18)
        :enableOutline(cc.c3b(55 , 85 , 155) , 2)
	self.teamBtn = ccui.Button:create('image/commonImg/team_icon.png' , 'image/commonImg/team_icon.png')
        :addTo(btmNode)
        :setPosition(0,btnY)
	self.teamBtn:addClickEventListener(handler(self , self.onTeam))

    local label = cc.Label:createWithTTF(LANG.UI_L_SAVE ,  fonts.FONT_SIYUAN , 18)
        :enableOutline(cc.c3b(55 , 85 , 155) , 2)
    self.saveBtn = ccui.Button:create('image/storyLine/b_btn.png' , 'image/storyLine/b_btn.png')
        :addTo(btmNode)
        :setPosition(200, btnY)
        :setTitleLabel(label)
    self.saveBtn:addClickEventListener(handler(self , self.onSave))

    local label = cc.Label:createWithTTF('查看技能' , fonts.FONT_SIYUAN , 18)
    :enableOutline(cc.c3b(55 , 85 , 155) , 2)
    self.skillbtn = ccui.Button:create('image/storyLine/b_btn.png');
    self.skillbtn:addTo(btmNode);
    self.skillbtn:setPosition(-200, btnY)
    self.skillbtn:addClickEventListener(handler(self, self.clickSkillBtn));
    self.skillbtn:setTitleLabel(label);

    self.scorllview = ccui.ScrollView:create();
    self.scorllview:setTouchEnabled(true);
    self.scorllview:setBounceEnabled(true);
    self.scorllview:setDirection(ccui.ScrollViewDir.horizontal);
    self.scorllview:setContentSize(cc.size(StageSize.width , 360));
    self.scorllview:setAnchorPoint(cc.p(0,0));
    self.scorllview:setScrollBarEnabled(false);
    self.scorllview:setPosition(-StageSize.width/2 , 30);
    self.scorllview:addTo(btmNode);

    self.openCardNode = cc.Node:create()
    self.openCardNode:addTo(btmNode)
    self.openCardNode:setPosition(0, 210);
    local openBtn = ccui.Button:create('image/commonImg/bg_1_11_11_34_28.png');
    openBtn:addTo(self.openCardNode);
    openBtn:setScale9Enabled(true);
    openBtn:setContentSize(cc.size(StageSize.width , 100))
    openBtn:addClickEventListener(handler(self, self.cardClick));
    openBtn:setOpacity(0)
    local openBg = cc.Sprite:create('image/commonImg/big_tip_rect.png')
    openBg:addTo(self.openCardNode)
    local openLabel = cc.Label:createWithTTF('点击添加角色' , fonts.FONT_SIYUAN , 20)
    -- openLabel:enableOutline(cc.c3b(55 , 85 , 155) , 2)
    openLabel:addTo(self.openCardNode)

    self.memberLabel = cc.Label:createWithTTF('0/8' , fonts.FONT_SIYUAN , 18)
    self.memberLabel:enableOutline(cc.c3b(55 , 85 , 155) , 2)
    self.memberLabel:addTo(btmNode)
    self.memberLabel:setAnchorPoint(1,0.5)
    self.memberLabel:setPosition(StageSize.width/2-20,17)

    self.teamNode = cc.Node:create();
    self.teamNode:addTo(self.root);
    self.teamNode:setPosition(0,-StageSize.height/2+850);

    self.monsterNode = cc.Node:create();
    self.monsterNode:addTo(self.root);
    self.monsterNode:setPosition(0,-StageSize.height/2+850);

end


function StoryRoundPanel:initTeam(  )
    self.teamList = {}
    for i=1,TEAM_MAX_MEMBER do
        local roleNode = cc.Node:create();
        roleNode:addTo(self.teamNode)
        roleNode:setVisible(false)

        local bloodVolume = require('app.template.BloodVolume'):create(roleNode);
        bloodVolume:setPosition(0, 55);
        bloodVolume:setLevel(99)

        self.teamList[i] = {}
        self.teamList[i].roleNode = roleNode;
        self.teamList[i].bloodVolume = bloodVolume;
        self.teamList[i].armature = nil;
        self.teamList[i].pid = -1;

    end
end

function StoryRoundPanel:initMonster(  )
    self.monsterList = {}
    
    for i=1,6 do
        local roleNode = cc.Node:create();
        roleNode:addTo(self.monsterNode)
        roleNode:setVisible(false);

        local bloodVolume = require('app.template.BloodVolume'):create(roleNode);
        bloodVolume:setPosition(0, 55);
        bloodVolume:setLevel(99)

        -- local monsterFrameAni = cc.Sprite:create();
        -- monsterFrameAni:addTo(roleNode);
        -- monsterFrameAni:setLocalZOrder(1)
        -- monsterFrameAni:setScale(1.4)
        -- monsterFrameAni:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
        self.monsterList[i] = {}
        self.monsterList[i].roleNode = roleNode;
        self.monsterList[i].bloodVolume = bloodVolume;
        self.monsterList[i].armature = nil;
        self.monsterList[i].monster_id = -1;
        self.monsterList[i].monster_lv = -1;
        -- self.monsterList[i].monsterFrameAni = monsterFrameAni;
    end
end

function StoryRoundPanel:initCardList()
    self.cardItemList = {}
    for i=1,8 do
        local cellNode = template.CardTemplate:create(self.scorllview);
        -- cellNode:setTouchEnabled(false);
        cellNode:setPosition((i-1)*160+80, 180);
        cellNode:setTag(999);
        cellNode:setScale(0.81);

        cellNode:setState('none');
        cellNode:setSelect(false);
        cellNode:setVisible(false);

        cellNode:setCardTouchEnabled()

        -- cellNode:addCardClickEventListener(handler(self, self.cardClick));

        self.cardItemList[i] = cellNode;

        -- local allCardData = self:getRoleDataByType(self.curDefType);
        -- local tempCardData = allCardData[index + 1];
        -- local pid = tempCardData.pid;
        -- cellNode:Init(pid);
        -- if self:checkInTeam(pid) > 0 then
        --     if self.teamType == TeamType.EVENT then
        --         cellNode:setState('eventTeamChange')
        --     else
        --         cellNode:setState('teamChange');
        --     end
        --     cellNode:setSelect(true);
        -- else
        --     cellNode:setState('none');
        --     cellNode:setSelect(false);
        -- end
        -- local lastTag = cell:getTag();
        -- cell:setTag(pid);

        -- if self.teamType == TeamType.EVENT then
        --     local hpPercent = model.CardModel:getEventHp(pid) or 0;
        --     local hp = CardProManager:GetCardPro(pid).hp;
        --     cellNode:updateHp(hpPercent/10000, hp)
        -- else
        --     cellNode:hideHpNode()
        -- end
    end

    self.scorllview:setInnerContainerSize(cc.size(160*8 , 360));

end

function StoryRoundPanel:initTopNode()
    local topNode = cc.Node:create()
    topNode:addTo(self.root)
    topNode:setPosition(0, StageSize.height/2 - 200)

    local topBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
    topBg:setContentSize(cc.size(632, 164))
    topBg:addTo(topNode)

    local line = cc.Scale9Sprite:create('image/commonImg/line4.png')
    line:setContentSize(cc.size(164, 5))
    line:addTo(topNode)
    line:setPosition(150,0)
    line:setRotation(90)

    local icon1 = cc.Sprite:create('image/randomBoss/random_bg3.png')
    icon1:addTo(topNode)
    icon1:setPosition(-290,60)

    local label1 = cc.Label:createWithTTF('艾莎的初夜 - 第99关礼包' ,  fonts.FONT_SIYUAN , 20)
        :addTo(topNode)
        :setPosition(-270 , 60)
        :setAnchorPoint(0, 0.5)
        :enableOutline(cc.c3b(0 , 0 , 0),2)
    self.storyName = label1;

    local icon2 = cc.Sprite:create('image/commonImg/tip_2.png')
    icon2:addTo(topNode)
    icon2:setPosition(-290,30)

    local label2 = cc.Label:createWithTTF('普通关卡 - 艾莎的初夜哈哈哈哈哈哈艾莎的初夜哈哈哈哈哈哈艾莎的初夜哈哈哈哈哈哈艾莎的初夜哈哈哈哈哈哈' ,  fonts.FONT_SIYUAN , 16)
        :addTo(topNode)
        :setPosition(-270 , 45)
        :setAnchorPoint(0, 1)
        :setTextColor(cc.c3b(255,214,0))
        :setDimensions(300, 120)
        :setContentSize(cc.size(300, 120))
        :enableOutline(cc.c3b(0 , 0 , 0),1)
    self.storyInfo = label2;

    local castNode = cc.Node:create()
    castNode:addTo(topNode)
    castNode:setPosition(-100, -50)

    local expProgressBg = cc.Scale9Sprite:create("image/commonImg/pgs_bg_1_223_12.png")
        :addTo(castNode)
        :setCapInsets(cc.rect(10,0,203,12))
        :setContentSize(cc.size(362 , 24))
    local progress = cc.Scale9Sprite:create("image/commonImg/pgs_1_445_21.png")
    progress:setContentSize(cc.size(360,21))
    progress:setAnchorPoint(0, 0.5)
    progress:setPosition(-180, 0)
    progress:addTo(castNode)
    -- progress:setContentSize( cc.size(498*0.8,21) )
    self.expProgress = progress;

    self.proLabel = cc.Label:createWithTTF('10/15', fonts.FONT_SIYUAN, 18)
        :addTo(castNode)
        :setAnchorPoint(0.5 , 0.5)
        :enableOutline(cc.c3b(50 , 20 , 0),2)

    self.mapBtn = ccui.Button:create('image/storyLine/map_icon.png');
    self.mapBtn:addTo(castNode);
    self.mapBtn:setPosition(220, 0)
    self.mapBtn:addClickEventListener(handler(self, self.clickMapBtn));


    local icon3 = cc.Sprite:create('image/commonImg/arrow_bg.png')
    icon3:addTo(topNode)
    icon3:setPosition(170,60)

    local label3 = cc.Label:createWithTTF('获得奖励' ,  fonts.FONT_SIYUAN , 20)
        :setTextColor(cc.c3b(164,200,255))
        :addTo(topNode)
        :setPosition(200 , 60)
        :setAnchorPoint(0, 0.5)

    self.rewardView = ccui.ScrollView:create();
    self.rewardView:setTouchEnabled(true); 
    self.rewardView:setBounceEnabled(true);
    self.rewardView:setDirection(ccui.ScrollViewDir.horizontal);
    self.rewardView:setContentSize(cc.size(170, 87));
    self.rewardView:setAnchorPoint(cc.p(0.5, 0.5));
    self.rewardView:setPosition(240 , -20);
    self.rewardView:setScrollBarEnabled(false);
    self.rewardView:addTo(topNode);

end

function StoryRoundPanel:showTeamNode(  )
    self.team  = model.TeamModel:getTeamById(self.curTeamType);
    local curFormation = model.TeamModel:getCurrentTeamFormation(self.curTeamType)
	local teamPos = model.TeamModel:getTeamFormationPosById(curFormation);
    self.haveTeam = false;
    for i=TEAM_MAX_MEMBER, 1, -1 do
        local formationIndex = teamPos[i];
        local pos = FightManager:getRolePosByFormationIndex(formationIndex);
        self.teamList[i].roleNode:setPosition(pos.x, pos.y);
        self.teamList[i].roleNode:setLocalZOrder(100 + pos.z);

        local pid = self.team[i];
        local card = model.CardModel:GetCard(pid);
        if pid ~= -1 then
            local hp, cd = model.StoryModel:getCardHpAndCd(pid)

            self.haveTeam = true;
            if true then --self.teamList[i].pid ~= pid
                if self.teamList[i].armature~= nil then
                    self.teamList[i].armature:removeFromParent()
					DragonBonesManager:RemoveDisplay(self.teamList[i].armature_id)
                    self.teamList[i].armature = nil;
                    self.teamList[i].pid = -1;
                end
    
                local no = card.no;
                local roleData = ResTable:getRowData('role', no);
                local rolePreData = ResTable:getRowData('role_pre', roleData.role_id);
                local resId = model.CardModel:getCardResIdByPid(pid);
                local roleResData = ResTable:getRowData('role_resource', resId);
                
                local modelPath = roleResData.model;
                if modelPath then 
                    local armature, id = DragonBonesManager:GetArmature(modelPath);
                    armature:getAnimation():play('idle');
                    armature:addTo(self.teamList[i].roleNode);
                    armature:setScale(0.4);
                    armature:setLocalZOrder(-1);
                    self.teamList[i].armature = armature;
                    self.teamList[i].armature_id = id;
                    self.teamList[i].pid = pid;
    
                    self.teamList[i].bloodVolume:setPercent(math.floor(hp/100));
                    self.teamList[i].bloodVolume:setDefType(rolePreData.def_type);
                    self.teamList[i].bloodVolume:setLevel(card.level);
                    
                    self.teamList[i].roleNode:setVisible(true);
                else
                    print("====================error==========showTeamNode==no armature============pid == "..tostring(pid))
                end
            else
                self.teamList[i].bloodVolume:setPercent(math.floor(100));
            end

        else
            if self.teamList[i].armature~= nil then
                self.teamList[i].armature:removeFromParent()
				DragonBonesManager:RemoveDisplay(self.teamList[i].armature_id)
                self.teamList[i].armature = nil;
                self.teamList[i].pid = -1;
            end
            self.teamList[i].roleNode:setVisible(false);

        end
	end

end

function StoryRoundPanel:showMonsterNode(  )
    local storyData = model.StoryModel:getStoryDataById( self.storyId )
    self.roundId = storyData.storyRoundId;
    local itemData = ResTable:getRowData('dungeon_round', storyData.storyRoundId);
    if itemData == nil then
        return 
    end
    self.monsterDatas = itemData.monster;
    if itemData.position == nil or next(itemData.position) == nil then
        itemData.position = {1,2,3,4}
    end
    local formation = itemData.position --fighter:getFormationIndex()

    local hpcdList = model.StoryModel:getCurMonsterHpList(self.storyId);

    for i=1, 6 do 

		local data = self.monsterDatas[i];
        if data and data[1] then
            local hp = 100;
            if hpcdList[i] then
                hp = math.floor(hpcdList[i].hp/100);
            end
            local role_pos = FightManager:getEnemyPosByFormaitionIndex(formation[i] or i);
            if self.monsterList[i].monster_id ~= data[1] then
                if self.monsterList[i].armature~= nil then
                    self.monsterList[i].armature:removeFromParent()
					DragonBonesManager:RemoveDisplay(self.monsterList[i].armature_id)
                    self.monsterList[i].armature = nil;
                    self.monsterList[i].monster_id = -1;
                    self.monsterList[i].monster_lv = -1;
                end
    

                -- local posData = self.monsterCoordination[i];
                local monsterData = ResTable:getRowData('monster', data[1]);
                local modelPath = monsterData['model'];
                local armature, id = DragonBonesManager:GetArmature(modelPath);
                if armature then 
                    armature:getAnimation():play('idle');
                    armature:setScale(0.4);
                    armature:addTo(self.monsterList[i].roleNode);
                    armature:getArmature():setFlipX(true);
                    armature:setLocalZOrder(-1);
                    self.monsterList[i].armature = armature;
                    self.monsterList[i].armature_id = id;
                    self.monsterList[i].monster_id = data[1];
                    self.monsterList[i].monster_lv = data[2];
    
                    self.monsterList[i].bloodVolume:setPercent(hp);
                    self.monsterList[i].bloodVolume:setDefType(monsterData.def_type);

                    -- local monsterLv = ResTable:getValue('monster_attribute',data[2],'lv')
                    -- self.monsterList[i].bloodVolume:setLevel(monsterLv );

                    self.monsterList[i].roleNode:setPosition(cc.p(role_pos.x,role_pos.y));
                    self.monsterList[i].roleNode:setVisible(true);
                    self.monsterList[i].roleNode:setLocalZOrder(role_pos.z)
                end
            else
                if self.monsterList[i].monster_lv ~= data[2] then
                    local monsterLv = ResTable:getValue('monster_attribute',data[2],'lv')
                    self.monsterList[i].bloodVolume:setLevel(monsterLv );
                    self.monsterList[i].monster_lv = data[2];
                end
                self.monsterList[i].roleNode:setPosition(cc.p(role_pos.x,role_pos.y));
                self.monsterList[i].roleNode:setLocalZOrder(role_pos.z)
                self.monsterList[i].bloodVolume:setPercent(hp);
            end

        else
            if self.monsterList[i].armature~= nil then
                self.monsterList[i].armature:removeFromParent()
				DragonBonesManager:RemoveDisplay(self.monsterList[i].armature_id)
                self.monsterList[i].armature = nil;
                self.monsterList[i].monster_id = -1;
                self.monsterList[i].monster_lv = -1;
            end
            self.monsterList[i].roleNode:setVisible(false);

		end
	end
end

function StoryRoundPanel:showCardList()
    -- body
    self.cardCnt = 0;
    local actStoryId = model.StoryModel:getCurStoryId();
    local cardList = {}
    if actStoryId==0 or actStoryId ~= self.storyId then
        cardList = model.StoryModel:getTempCardList()

        self.teamBtn:setVisible(false)
        self.fightBtn:setVisible(false)
        self.saveBtn:setVisible(true)
        self.openCardNode:setVisible(true)

    else
        local storyData = model.StoryModel:getStoryDataById( self.storyId )
        cardList = storyData.cardList;

        self.teamBtn:setVisible(true)
        self.fightBtn:setVisible(true)
        self.saveBtn:setVisible(false)
        self.openCardNode:setVisible(false)
    end

    for i=1,8 do
        self.cardItemList[i]:setVisible(false)
    end

    local idx = 1;
    for k,v in pairs(cardList) do
        local cellNode = self.cardItemList[idx]
        if cellNode then
            cellNode:setVisible(true)
            if type(v) ~= 'table' then
                cellNode:Init( v );
                cellNode:updateHp(1, 10000)
            else
                cellNode:Init( v.pid );
                cellNode:updateHp(v.hp/10000, v.hp)
            end
            
            -- if self.teamType == TeamType.EVENT then
            --     local hpPercent = model.CardModel:getEventHp(pid) or 0;
            --     local hp = CardProManager:GetCardPro(pid).hp;
            --     cellNode:updateHp(hpPercent/10000, hp)
            -- else
            --     cellNode:hideHpNode()
            -- end
        end

        idx = idx+1
        self.cardCnt = self.cardCnt+1;
    end

    self.memberLabel:setString(self.cardCnt..'/8')

    self.scorllview:jumpToPercentVertical( 0 );
end

function StoryRoundPanel:showTopNode()

    local storyData = model.StoryModel:getStoryDataById( self.storyId )
    local plotName = ResTable:getValue( 'dungeon_plot', storyData.storyPlotId, 'name' )
    local roundData = ResTable:getRowData('dungeon_round', storyData.storyRoundId)

    self.storyName:setString( plotName..' - '..roundData.name );

    local crossCnt = 0
    for k,v in pairs(storyData.mapStatus) do
        if v.st == 1 then
            crossCnt = crossCnt + 1;
        end
    end
    local proInfo = math.floor(crossCnt*100/storyData.storyTotal);
    self.proLabel:setString(proInfo..'%')
    self.expProgress:setContentSize( cc.size(498*proInfo/100,21) )

    self.storyInfo:setString( roundData.explain )

    if roundData.plot_id then
        local rewardList = ResTable:getValue( 'dungeon_plot', storyData.storyPlotId, 'reward' )
        self:setReward(rewardList)
    else
        self:setReward({})
    end

end

function StoryRoundPanel:retSaveCard()
    self.teamBtn:setVisible(true)
    self.fightBtn:setVisible(true)
    self.saveBtn:setVisible(false)
    self.openCardNode:setVisible(false)
end

function StoryRoundPanel:setReward(reward)
    local rewardNum = #reward;

    local maxWidth = rewardNum * 82.4;
    maxWidth = maxWidth < 185 and 185 or maxWidth;

    self.rewardView:removeAllChildren();
    self.rewardView:setInnerContainerSize(cc.size(maxWidth, 87));

    for i=1, rewardNum do
        local r = reward[i];
        local layout = ccui.Layout:create();
        layout:addTo(self.rewardView);
        local icon = template.ItemTemplate:create(2);
        icon:addTo(layout);
        icon:Init(r[1] , r[2]);
        icon:setScale(0.8);
        icon:setPosition(41.2 + 82.4 * (i - 1) , 43.5);
    end
    -- self.rewardView:setTouchEnabled(rewardNum > 2);
end

function StoryRoundPanel:cardClick(sender , event)
    if not self.saveBtn:isVisible() then
        return;
    end
    UIManager:push('StoryCardPanel')
end


function StoryRoundPanel:retFightOverAuto( msg )
    --扫荡结果更新UI
	UIManager:push('RewardPanel', msg);
end

function StoryRoundPanel:clickMapBtn()
    UIManager:push('StoryLinePanel', self.storyId);
end

function StoryRoundPanel:onTeam(  )
    AudioManager:playEffect(Conf.buttonClick);
    UIManager:push('TeamPanel',self.curTeamType)
end

function StoryRoundPanel:onFight( )
    AudioManager:playEffect(Conf.confirmButton);
    if self.haveTeam == false then
        Prompt:Show(LANG.UI_TRIAL_24);
        return;
    end
    -- if model.TrialModel:getLimitFightNum(self.trialType) == 0 then
    --     Prompt:Show(LANG.UI_TRIAL_26);
    --     return;
    -- end

    FightManager:enterFight(FightType.Story, {resid = self.roundId, storyid = self.storyId})
end

function StoryRoundPanel:onSave()
    if self.cardCnt == 0 then
        Prompt:Show('未选择卡牌');
        return;
    end
    if self.cardCnt<8 then
        MessageBox:create('卡牌未选择满，是否继续？' , MessageBoxType.CANCEL_OK,function()
            model.StoryModel:saveCardList(self.storyId);
        end);
        return;
    end
    model.StoryModel:saveCardList(self.storyId);
end


function StoryRoundPanel:onClickBack( ... )
	UIManager:pop('StoryRoundPanel');
end

function StoryRoundPanel:onEnter(storyId)
    self.storyId = storyId or self.storyId;

    self:onShow();
    EventManager:FireEvent(EventType.UIFooterUpdateSelect,5);

end

function StoryRoundPanel:onShow()

    -- self.curItemPowerLabel:setString(ConvertStrToDigitUnit(model.TeamModel:getCurrentTeamFp(self.curTeamType)));
    self.fightBtn:setTouchEnabled(true);

    self:showTeamNode();
    self:showMonsterNode();
    self:showCardList();
    self:showTopNode();

    self.root:setVisible(true)
end

function StoryRoundPanel:onLeave( ... )
    self.root:setVisible(false);
end

return StoryRoundPanel
