local StoryRwdPanel = class('StoryRwdPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/activity/three_day/'

function StoryRwdPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'StoryRwdPanel');

	self.useCCreator = false;
    self.isPopup = true;

end

function StoryRwdPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel();
end


function StoryRwdPanel:initPanel(  )
    local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
    :addTo(self.root)
    :setScale9Enabled(true)
    :setContentSize(cc.size(604, 850))
    :setTouchEnabled(true);

    -- GlobalFunctions:createTitleNode( bg, LANG.UI_EVENT_2, '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );
    local topNode = cc.Node:create()
    topNode:addTo(self.root)
    topNode:setPosition(0, 200)

    local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
    bg:addTo(topNode);
    bg:setCapInsets(cc.rect(11,11,34,28));
    bg:setContentSize(cc.size(582 , 380));

    local arrIcon = cc.Sprite:create('image/commonImg/arrow_bg.png')
    arrIcon:addTo(topNode)
    arrIcon:setPosition(-250, 160)

    local topName = cc.Label:createWithTTF('探索度礼包' ,  fonts.FONT_SIYUAN , 20)
        :setTextColor(cc.c3b(164,200,255))
        :addTo(topNode)
        :setPosition(-220 , 160)
        :setAnchorPoint(0, 0.5)

    self.proListView = ccui.ScrollView:create();
    self.proListView:setTouchEnabled(true); 
    self.proListView:setBounceEnabled(true);
    self.proListView:setDirection(ccui.ScrollViewDir.horizontal);
    self.proListView:setContentSize(cc.size(580, 140));
    self.proListView:setAnchorPoint(cc.p(0.5, 0.5));
    self.proListView:setPosition(0 , 84);
    self.proListView:setScrollBarEnabled(false);
    self.proListView:addTo(topNode);

    local proRwdNode = cc.Node:create()
    proRwdNode:addTo(self.proListView)
    proRwdNode:setPosition(0, 80)
    local expProgressBg = cc.Scale9Sprite:create("image/commonImg/pgs_bg_1_223_12.png")
        :addTo(proRwdNode)
        :setCapInsets(cc.rect(10,0,203,12))
        :setContentSize(cc.size(540 , 24))
        :setPosition(0, 0)
        :setAnchorPoint(0,0.5)
    local progress = cc.Scale9Sprite:create("image/commonImg/pgs_1_445_21.png")
    progress:setContentSize(cc.size(530,21))
    progress:setAnchorPoint(0, 0.5)
    progress:setPosition(5, 0)
    progress:addTo(proRwdNode)
    self.expProBg = expProgressBg;
    self.expProgress = progress;

    self.rwdListNode = cc.Node:create()
    self.rwdListNode:addTo(self.proListView)
    self.rwdListNode:setPosition(0, 80)

    local rwdNode = cc.Node:create()
    rwdNode:addTo(topNode)
    rwdNode:setPosition(0, -40)
    local rwdBg = cc.Sprite:create('image/storyLine/rwd_list_bg.png')
    rwdBg:addTo(rwdNode)
    self.rwdArr = cc.Sprite:create('image/storyLine/rwd_arrow.png')
    self.rwdArr:addTo(rwdNode)
    self.rwdArr:setPosition( -250 , 75)

    self.storyProName = cc.Label:createWithTTF('探索20%达成礼包' ,  fonts.FONT_SIYUAN , 18)
        :addTo(rwdNode)
        :setPosition(-250 , 50)
        :setAnchorPoint(0, 0.5)

    self.storyProInfo = cc.Label:createWithTTF('已经领取' ,  fonts.FONT_SIYUAN , 18)
        :setTextColor(cc.c3b(164,200,255))
        :addTo(rwdNode)
        :setPosition(250 , 50)
        :setAnchorPoint(1, 0.5)

    self.rewardView = ccui.ScrollView:create();
    self.rewardView:setTouchEnabled(true); 
    self.rewardView:setBounceEnabled(true);
    self.rewardView:setDirection(ccui.ScrollViewDir.horizontal);
    self.rewardView:setContentSize(cc.size(500, 100));
    self.rewardView:setAnchorPoint(cc.p(0.5, 0.5));
    self.rewardView:setPosition(0 , -17);
    self.rewardView:setScrollBarEnabled(false);
    self.rewardView:addTo(rwdNode);

    self.rwdBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png');
    self.rwdBtn:setPosition(0, -150);
    self.rwdBtn:addTouchEventListener(handler(self, self.clickRwdBtn));
    self.rwdBtn:addTo(topNode);
    local label = cc.Label:createWithTTF('领取奖励', fonts.FONT_SIYUAN, 20)
        -- :enableOutline(cc.c3b(50 , 85 , 150))
    self.rwdBtn:setTitleLabel(label)

    -- self.rwdOneKeyBtn = ccui.Button:create('image/commonImg/btn_9_219_55.png');
    -- self.rwdOneKeyBtn:setPosition(130, -150);
    -- self.rwdOneKeyBtn:addTouchEventListener(handler(self, self.clickOneKeyRwdBtn));
    -- self.rwdOneKeyBtn:addTo(topNode);
    -- local label = cc.Label:createWithTTF('一键领取', fonts.FONT_SIYUAN, 20)
    --     -- :enableOutline(cc.c3b(50 , 85 , 150))
    -- self.rwdOneKeyBtn:setTitleLabel(label)



    local btmNode = cc.Node:create()
    btmNode:addTo(self.root)
    btmNode:setPosition(0, -210)

    local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
    bg:addTo(btmNode);
    bg:setCapInsets(cc.rect(11,11,34,28));
    bg:setContentSize(cc.size(582 , 380));

    local arrIcon = cc.Sprite:create('image/commonImg/arrow_bg.png')
    arrIcon:addTo(btmNode)
    arrIcon:setPosition(-250, 160)

    local btmName = cc.Label:createWithTTF('剧情礼包' ,  fonts.FONT_SIYUAN , 20)
        :setTextColor(cc.c3b(164,200,255))
        :addTo(btmNode)
        :setPosition(-220 , 160)
        :setAnchorPoint(0, 0.5)

    self.storyListView = ccui.ScrollView:create();
    self.storyListView:setTouchEnabled(true); 
    self.storyListView:setBounceEnabled(true);
    self.storyListView:setDirection(ccui.ScrollViewDir.horizontal);
    self.storyListView:setContentSize(cc.size(560, 180));
    self.storyListView:setAnchorPoint(cc.p(0.5, 0.5));
    self.storyListView:setPosition(0 , 50);
    self.storyListView:setScrollBarEnabled(false);
    self.storyListView:addTo(btmNode);

    

    local rwdStoryNode = cc.Node:create()
    rwdStoryNode:addTo(btmNode)
    rwdStoryNode:setPosition(0, -100)
    local rwdBg = cc.Sprite:create('image/storyLine/rwd_list_bg.png')
    rwdBg:addTo(rwdStoryNode)

    self.storyLineName = cc.Label:createWithTTF('艾莎的初夜 - 第99关礼包' ,  fonts.FONT_SIYUAN , 18)
        :addTo(rwdStoryNode)
        :setPosition(-250 , 50)
        :setAnchorPoint(0, 0.5)

    self.storyRwdInfo = cc.Label:createWithTTF('已经领取' ,  fonts.FONT_SIYUAN , 18)
        :setTextColor(cc.c3b(164,200,255))
        :addTo(rwdStoryNode)
        :setPosition(250 , 50)
        :setAnchorPoint(1, 0.5)

    self.rewardStoryView = ccui.ScrollView:create();
    self.rewardStoryView:setTouchEnabled(true); 
    self.rewardStoryView:setBounceEnabled(true);
    self.rewardStoryView:setDirection(ccui.ScrollViewDir.horizontal);
    self.rewardStoryView:setContentSize(cc.size(500, 100));
    self.rewardStoryView:setAnchorPoint(cc.p(0.5, 0.5));
    self.rewardStoryView:setPosition(0 , -17);
    self.rewardStoryView:setScrollBarEnabled(false);
    self.rewardStoryView:addTo(rwdStoryNode);

end

function StoryRwdPanel:onEnter(storyId)
    self.storyId = storyId;
    self:addSwallowCallback(handler(self , self.onClickBack));
    self:onShow();
    self.root:setVisible(true);
end

function StoryRwdPanel:showProList( )
    -- body
    self.rwdList = {}
    self.rwdListNode:removeAllChildren();
    self.totalWidth = 530;
    self.proListView:setInnerContainerSize(cc.size(580, 140));

    -- self.proRwdData = {}
    -- self.proRwdData[data.percent] = data.reward

    local storyData = model.StoryModel:getStoryDataById( self.storyId )
    local cnt = #storyData.percentStatus;
    if cnt > 5 then
        self.totalWidth = self.totalWidth + (cnt-5)*112;
        self.proListView:setInnerContainerSize(cc.size(580 + (cnt-5)*112, 140));
    end
    self.expProBg:setContentSize(cc.size(self.totalWidth+10 , 24))
    self.expProgress:setContentSize(cc.size(self.totalWidth , 21))

    local tag = 0;
    local lastTag = 0;
    for i=1,cnt do
        local proData = storyData.percentStatus[i];
        local data = ResTable:getRowData('dungeon_reward', proData.no)
        local posX = math.floor(data.percent*self.totalWidth/100);

        local cellNode = cc.Node:create()
        cellNode:addTo(self.rwdListNode)
        cellNode:setPosition(posX, 0)

        local cellBtn = ccui.Button:create('image/storyLine/rwd_bg.png')
        cellBtn:addClickEventListener(handler(self, self.clickProRwdBtn));
        cellBtn:addTo(cellNode)
        cellBtn:setTag(proData.no)
        cellBtn:setSwallowTouches(false)
        local cellSel = cc.Sprite:create('image/storyLine/rwd_sel.png')
        cellSel:addTo(cellNode)
        cellSel:setVisible(false)
        local rwdIcon = cc.Sprite:create('image/icon/I18003.png')
        rwdIcon:addTo(cellNode)
        rwdIcon:setScale(0.6)
        local getedIcon = cc.Sprite:create('image/commonImg/geted.png')
        getedIcon:addTo(cellNode)
        getedIcon:setVisible(proData.status == 1)

        if tag==0 and proData.status==0 then
            tag = proData.no;
        end
        lastTag = proData.no;

        local proLabel = cc.Label:createWithTTF(tostring(data.percent)..'%' ,  fonts.FONT_SIYUAN , 18)
            :setTextColor(cc.c3b(216,216,216))
            :addTo(cellNode)
            :setPosition(0 , -50)
            :enableOutline(cc.c3b(60 , 60 , 60) , 2);

        self.rwdList[proData.no] = {cellSel=cellSel, getedIcon=getedIcon, proLabel=proLabel, reward=data.reward, st=proData.status}
    end
    if tag==0 then
        tag = lastTag;
    end
    self.rwdList[tag].cellSel:setVisible(true)
    self:setReward( self.rwdList[tag].reward, self.rwdList[tag].st )

end

function StoryRwdPanel:setReward(reward, st)
    local rewardNum = #reward;

    local maxWidth = rewardNum * 100;
    maxWidth = maxWidth < 500 and 500 or maxWidth;

    self.rewardView:removeAllChildren();
    self.rewardView:setInnerContainerSize(cc.size(maxWidth, 100));

    for i=1, rewardNum do
        local r = reward[i];
        local layout = ccui.Layout:create();
        layout:addTo(self.rewardView);
        local icon = template.ItemTemplate:create(2);
        icon:addTo(layout);
        icon:Init(r[1] , r[2]);
        icon:setScale(0.8);
        icon:setPosition(42 + 100 * (i - 1) , 50);
    end

    if st==1 then
        self.storyProInfo:setString(LANG.UI_ACTIVITY_20)
    elseif st==2 then
        self.storyProInfo:setString(LANG.UI_ACTIVITY_19)
    else
        self.storyProInfo:setString(LANG.UI_ROUND_21)
    end
    self.rwdBtn:setVisible(st==1)
    -- self.rewardView:setTouchEnabled(rewardNum > 2);
end

function StoryRwdPanel:setStoryReward(reward, st)
    local rewardNum = #reward;

    local maxWidth = rewardNum * 100;
    maxWidth = maxWidth < 500 and 500 or maxWidth;

    self.rewardStoryView:removeAllChildren();
    self.rewardStoryView:setInnerContainerSize(cc.size(maxWidth, 100));

    for i=1, rewardNum do
        local r = reward[i];
        local layout = ccui.Layout:create();
        layout:addTo(self.rewardStoryView);
        local icon = template.ItemTemplate:create(2);
        icon:addTo(layout);
        icon:Init(r[1] , r[2]);
        icon:setScale(0.8);
        icon:setPosition(42 + 100 * (i - 1) , 50);
    end
    -- self.rewardStoryView:setTouchEnabled(rewardNum > 2);
    if st==1 then
        self.storyRwdInfo:setString(LANG.UI_ACTIVITY_19)
    else
        self.storyRwdInfo:setString(LANG.UI_ROUND_21)
    end
end

function StoryRwdPanel:showStoryList()

    local storyData = model.StoryModel:getStoryDataById( self.storyId )

    local plotCnt = #storyData.rewardStatus;
    local maxWidth = plotCnt * 150;
    maxWidth = maxWidth < 560 and 560 or maxWidth;
    self.storyListView:removeAllChildren();
    self.storyListView:setInnerContainerSize(cc.size(maxWidth, 150));

    self.plotRwdList = {}
    local tag = 0;
    local lastTag =0;
    for i=1,plotCnt do
        local plotRwd = storyData.rewardStatus[i];

        local plotNode = cc.Node:create()
        plotNode:addTo(self.storyListView)
        plotNode:setPosition(65 + 150 * (i - 1),90)

        local plotIcon = cc.Sprite:create('image/storyLine/plot_icon.png')
        plotIcon:addTo(plotNode)
        plotIcon:setScale(0.8)

        local btn = ccui.Button:create('image/storyLine/cell_1bg.png');
        btn:addTouchEventListener(handler(self, self.clickPlotRwdBtn));
        btn:addTo(plotNode);
        btn:setTag(plotRwd.no);
        btn:setSwallowTouches(false)
        btn:setScale(0.8);

        local btnLight = cc.Sprite:create('image/storyLine/cell_1bg_cur.png')
        btnLight:addTo(plotNode)
        btnLight:setScale(0.8)
        btnLight:setVisible(false)

        local data = ResTable:getRowData('dungeon_plot', plotRwd.no)

        self.plotRwdList[plotRwd.no] = {reward=data.reward, light=btnLight, st=plotRwd.status}

        local label = cc.Label:createWithTTF(data.name, fonts.FONT_SIYUAN, 16)
            :enableOutline(cc.c3b(0 , 0 , 0), 1)
            :setPosition(0, -10)
        label:addTo(plotNode)

        local label = cc.Label:createWithTTF('01', fonts.FONT_SIYUAN, 16)
            :enableOutline(cc.c3b(0 , 0 , 0), 1)
            :setPosition(0, -30)
        label:addTo(plotNode)

        if plotRwd.status ~=0 then
            local spr = cc.Sprite:create('image/commonImg/geted.png')
            spr:addTo(plotNode)
        end
        if tag == 0 and plotRwd.status == 0 then
            tag = plotRwd.no;
        end
        lastTag = plotRwd.no;
    end
    if tag == 0 then
        tag = lastTag;
    end

    self.plotRwdList[tag].light:setVisible(true)
    self:setStoryReward( self.plotRwdList[tag].reward, self.plotRwdList[tag].st )

end

function StoryRwdPanel:onShow()

    local storyData = model.StoryModel:getStoryDataById( self.storyId )

    self:showProList();
    
    self.expProgress:setContentSize( cc.size(520*storyData.storyPro/storyData.storyTotal,21) )

    self:showStoryList()

end

function StoryRwdPanel:clickProRwdBtn(sender , event)
    if GlobalMove then
        return;
    end
    local tag = sender:getTag()
    for k,v in pairs(self.rwdList) do
        self.rwdList[k].cellSel:setVisible(false)
    end
    self.rwdList[tag].cellSel:setVisible(true)
    self:setReward( self.rwdList[tag].reward, self.rwdList[tag].st )
end

function StoryRwdPanel:clickPlotRwdBtn(sender , event)
    if GlobalMove then
        return;
    end
    local tag = sender:getTag()
    for k,v in pairs(self.plotRwdList) do
        self.plotRwdList[k].light:setVisible(false)
    end
    self.plotRwdList[tag].light:setVisible(true)
    self:setStoryReward( self.plotRwdList[tag].reward, self.plotRwdList[tag].st )
end


function StoryRwdPanel:rewardClick()
    -- local msg = {};
    -- msg.operate_id = self.data.operate_id;
    -- msg.id = no;
    -- Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_task_rwd, msg);
end

function StoryRwdPanel:clickOneKeyRwdBtn()
    local msg = {};
    -- msg.operate_id = self.data.operate_id;
    -- msg.id = no;
    -- Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_task_rwd, msg);
end

function StoryRwdPanel:onLeave()
    self.root:setVisible(false);
end
function StoryRwdPanel:onClickBack()
    UIManager:pop('StoryRwdPanel');
end

return StoryRwdPanel
