local StorySkillListPanel = class("StorySkillListPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');
local imagePath = 'image/event/';


function StorySkillListPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'StorySkillListPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function StorySkillListPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:initPanels()
end

function StorySkillListPanel:initPanels()

	local bg = cc.Scale9Sprite:create('image/commonImg/common_tips_bg.png');
	bg:addTo(self.root);
	bg:setContentSize(cc.size(604 , 950));

	GlobalFunctions:createTitleNode( bg, LANG.UI_MAZE_10, '',  bg:getContentSize().width/2, bg:getContentSize().height -40 );

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.root);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(582 , 606));
	bg:setPosition(0, 100)

	local bg1 = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg1:addTo(self.root);
    bg1:setCapInsets(cc.rect(11,11,34,28));
	bg1:setContentSize(cc.size(582 , 180));
	bg1:setPosition(0, -340)

	self.buffView = ccui.ScrollView:create();
	self.buffView:setTouchEnabled(true);
	self.buffView:setBounceEnabled(true);
	self.buffView:setDirection(ccui.ScrollViewDir.vertical);
	self.buffView:setContentSize(cc.size(582, 606));
	self.buffView:setAnchorPoint(cc.p(0.5, 0.5));
	self.buffView:setScrollBarEnabled(false);
	self.buffView:addTo(self.root);
	self.buffView:setPosition(0, 100);

	self.nameLabel = cc.Label:createWithTTF('技能名称', fonts.FONT_SIYUAN, 20)
		:setTextColor(cc.c3b(250, 255, 0))
		:setPosition(-230, -280)
		:addTo(self.root)
		:setAnchorPoint(0,0.5)
	local tipSpr = cc.Sprite:create('image/commonImg/arrow_bg.png')
	tipSpr:addTo(self.root)
	tipSpr:setPosition( -250, -280 )

	local testInfo = '技能名称肥而不腻的很多很多很多啊打发士大夫进去二觉哦打诶【】在【小车大是大非技能名称肥而不腻的很多很多很多啊打发士大夫进去二觉哦打诶【】在【小车大是大非'
	self.infoLabel = cc.Label:createWithTTF(testInfo, fonts.FONT_SIYUAN, 20)
		-- :setTextColor(cc.c3b(250, 255, 0))
		:setPosition(-230, -300)
		:setAnchorPoint(0 , 1)
		:setContentSize(cc.size(500 , 120))
		:setDimensions(500 , 120)
		:setLineBreakWithoutSpace(true)
		-- :setLineHeight(23)
		:addTo(self.root)

	EventManager:RegisterEvent('EventBattlePassPanel:retBattlepassReward', handler(self, self.retBattlepassReward));

end

function StorySkillListPanel:onEnter()

	self:updateList()
	self.root:setVisible(true);
	self:addSwallowCallback(handler(self , self.onClickBack));
end

function StorySkillListPanel:updateList( idx )
	-- local buffs = model.StoryModel:getBuff();

	-- if not buffs then
	-- 	self:onClickBack();
	-- 	return;
	-- end

	local buffNum = 20--#buffs;
	-- if buffNum > 1 then
	-- 	table.sort(buffs,function(first , second) 
	-- 		local firstData = ResTable:getRowData('maze_buff',first);
	-- 		local secondData = ResTable:getRowData('maze_buff',second);
	-- 		if firstData.quality ~= secondData.quality then
	-- 			return firstData.quality > secondData.quality;
	-- 		end
	-- 		return first > second;
			
	-- 	end);
	-- end
	
	local maxWidth = 582;
	local maxHeight = math.ceil(buffNum / 4)*140;
	maxHeight = maxHeight < 606 and 606 or maxHeight;

	self.buffView:removeAllChildren();
	self.buffView:setInnerContainerSize(cc.size(maxWidth , (maxHeight)));

	for i=1, buffNum do
		local col = (i-1) % 4;
		local row = math.floor((i-1) / 4);

		-- local buff = buffs[i];
		local icon = template.StorySkillCell:create();
		icon:Init(1, 1001);
		icon:addTo(self.buffView);

		icon:setItemTag(i)
		icon:addItemClickEventListener(handler(self , self.clickBtn));
		-- icon:setScale(0.8)
		icon:setPosition(80 + 140 * col , maxHeight - 70 - 140 *row);
	end
end

function StorySkillListPanel:clickBtn(sender , event)
	local tag = sender:getTag();
	self.nameLabel:setString('技能名称：'..tag)
	EventManager:FireEvent('StorySkillCell:clickSelCell', tag);
	-- if self.callback then
	-- 	self.callback( self.data[tag] )
	-- end
end

function StorySkillListPanel:onClickBack()
	UIManager:pop('StorySkillListPanel');
end

function StorySkillListPanel:onLeave()
	self.root:setVisible(false);
end

return StorySkillListPanel;
