local TeamFormationPanel = class('TeamFormationPanel',require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local TeamType = Enum:getTable('TeamType')

local rolePosX = {-192,0,191}
local rolePosY = {248,85,-78}


function TeamFormationPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'TeamFormationPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.isPopup = true;
	self.haveSwallowLayer = true;
	self.select_id = -1;
	self.teamRole = {};
	self.formationItemList = {}
end

function TeamFormationPanel:Init( root )
    -- body
    self.root = root;
    self.root:setVisible(false);
    self.root:setPosition(StageSize.width/2,StageSize.height/2);


    self:initPanel();
    self:registEvent();

end

function TeamFormationPanel:initPanel(  )

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_2_11_4_18_21.png');
	bg:addTo(self.root);
	bg:setPosition(0 , 5);
    bg:setCapInsets(cc.rect(11,4,18,21));
	bg:setContentSize(cc.size(604 , 812));

	local titleNode = GlobalFunctions:createTitle(LANG.UI_L_FORMATION_1);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 432);

	local teamBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	teamBg:addTo(self.root);
	teamBg:setPosition(0 , 86);
    teamBg:setCapInsets(cc.rect(11,11,34,28));
	teamBg:setContentSize(cc.size(580 , 616));

	local roleBgNode = cc.Node:create();
	roleBgNode:addTo(self.root)

	for i=1,3 do
		for j=1,3 do
			local sp = cc.Sprite:create('image/team/formation/role_bg_1.png')
			sp:setPosition(cc.p(rolePosX[i],rolePosY[j]));
			sp:addTo(roleBgNode);
		end
	end

	self.roleNode = cc.Node:create();
	self.roleNode:addTo(roleBgNode)

	local formationName = {
		[1] = LANG.UI_TEAM_38;
		[2] = LANG.UI_TEAM_37;
		[3] = LANG.UI_TEAM_36;
	}

	for i=1,3 do
		local rowNameSp = cc.Label:createWithTTF(formationName[i] , fonts.FONT_SIYUAN , 20);
		rowNameSp:setPosition(cc.p(rolePosX[i],-156));
		rowNameSp:enableOutline(cc.c3b(25,30,40),2);
		rowNameSp:addTo(roleBgNode);
	end

	local line = cc.Sprite:create('image/commonImg/line.png')
		:addTo(self.root)
		:setPosition(0 , -182)

	local listBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	listBg:addTo(self.root);
	listBg:setPosition(0 , -309);
    listBg:setCapInsets(cc.rect(11,11,34,28));
	listBg:setContentSize(cc.size(580 , 148));

	self.formationList = ccui.ScrollView:create();
	self.formationList:setDirection(ccui.ScrollViewDir.horizontal)
					:setContentSize(cc.size(570, 148))
					:setPosition(0,-309)
					:setScrollBarEnabled(false)
					:setBounceEnabled(true)
					:addTo(self.root)
					:setAnchorPoint(cc.p(0.5,0.5))
					:setCascadeOpacityEnabled(true)


	local dropTip = cc.Node:create();
	dropTip:addTo(self.root);
	dropTip:setPosition(0 , -201);
	dropTip:setLocalZOrder(110);

	local dropBg = cc.Sprite:create('image/commonImg/tip_bg_1_547_33.png');
	dropBg:addTo(dropTip);

	local dropImg = cc.Sprite:create('image/commonImg/tip_2.png');
	dropImg:addTo(dropTip);

	local dropLabel = cc.Label:createWithTTF(LANG.UI_SETTING_24 , fonts.FONT_SIYUAN , 20);
	dropLabel:addTo(dropTip);
	dropLabel:setTextColor(cc.c3b(255 , 200 , 0));

	local width = dropImg:getContentSize().width+10;
	local labelWidth = dropLabel:getContentSize().width;
	local posX = -labelWidth / 2;
	dropImg:setPosition(posX , 0);
	dropLabel:setPosition(posX + width/2+labelWidth/2 , 0);

	self:addTouchEvent();
end

function TeamFormationPanel:registEvent(  )
    -- EventManager:RegisterEvent(EventType.UIRefreshRandomShopInfo , handler(self , self.retRandomShopInfo));
end

function TeamFormationPanel:addTouchEvent()
	local touchListener = cc.EventListenerTouchOneByOne:create()
	touchListener:registerScriptHandler(function(touch, event)
		if not self.root:isVisible() then
			return false
		end
		local locationInNode = self.roleNode:convertToNodeSpace(touch:getLocation());
		for i=1, TEAM_MAX_MEMBER do
			local rectR = cc.rect(self.rolePos[i].x-50, self.rolePos[i].y, 100, 100)
			if cc.rectContainsPoint(rectR, locationInNode) then
				if self.teamInfo[i] ~= -1 then
					self.touchRole = i
					self.touchOffsetX = locationInNode.x - self.rolePos[i].x
					self.touchOffsetY = locationInNode.y - self.rolePos[i].y
					self.teamRole[self.touchRole]:setLocalZOrder(200)
					self.moveOutPos = false
					self.isTouchRole = true;
					return true
				end
			end
		end
		return false
	end, cc.Handler.EVENT_TOUCH_BEGAN)
	touchListener:registerScriptHandler(function(touch, event)
		local locationInNode = self.roleNode:convertToNodeSpace(touch:getLocation())
		if self.teamRole[self.touchRole] then
			self.teamRole[self.touchRole]:move(locationInNode.x-self.rolePos[self.touchRole].x-self.touchOffsetX, locationInNode.y-self.rolePos[self.touchRole].y-self.touchOffsetY)
		end
		if math.abs((self.rolePos[self.touchRole].x + self.touchOffsetX) - locationInNode.x) > 7 or
			math.abs((self.rolePos[self.touchRole].y + self.touchOffsetY) - locationInNode.y) > 7 then
			self.moveOutPos = true
		end
	end, cc.Handler.EVENT_TOUCH_MOVED)
	touchListener:registerScriptHandler(function(touch, event)
		if not self.teamRole[self.touchRole] then
			return
		end
		local locationInNode = self.roleNode:convertToNodeSpace(touch:getLocation())
		local changePos
		for i=1, TEAM_MAX_MEMBER do
			if i ~= self.touchRole then
				if math.abs((self.rolePos[i].x + self.touchOffsetX) - locationInNode.x) <= 30 and
					math.abs((self.rolePos[i].y + self.touchOffsetY) - locationInNode.y) <= 30 then
					changePos = i
					break
				end
			end
		end
		if changePos then
			AudioManager:playEffect(Conf.teamingSwipe);
			self:switchRole(self.touchRole, changePos)
		end
		self.teamRole[self.touchRole]:move(0, 0)
		self.teamRole[self.touchRole]:setLocalZOrder(10)
	end, cc.Handler.EVENT_TOUCH_ENDED)
	local eventDispatcher = self.roleNode:getEventDispatcher()
	eventDispatcher:addEventListenerWithSceneGraphPriority(touchListener, self.roleNode)
end

function TeamFormationPanel:switchRole(pos1, pos2)
	if not self.teamRole[pos1] or not self.teamRole[pos2] then
		return
	end
	local pid1 = self.teamRole[pos1]:getPid();
	local pid2 = self.teamRole[pos2]:getPid();

	if self.teamType == TeamType.EVENT then
		self.teamRole[pos1]:setInfo(pid2, model.CardModel:getEventHp(pid2));
		self.teamRole[pos2]:setInfo(pid1, model.CardModel:getEventHp(pid1));
	else
		self.teamRole[pos1]:setInfo(pid2);
		self.teamRole[pos2]:setInfo(pid1);
	end

	self.teamInfo[pos1] = pid2;
	self.teamInfo[pos2] = pid1;
end

function TeamFormationPanel:onFormationItemSelected( sender,eventType )
	local tag = sender:getTag()
	AudioManager:playEffect(Conf.confirmButton);
	print('tag ===== '..tostring(tag))
	if self.select_id ~= tag then
		self:selectedFormation(tag);
	end
end

function TeamFormationPanel:getFormationItem(  )
	-- 闭包 实现 item ,需要注意self作用域
	local teamFormamtion = self; 

	local item = cc.Node:create();
	
	local itemSelect = cc.Sprite:create('image/team/formation/item_formation_select.png')
	itemSelect:addTo(item);
	itemSelect:setVisible(false);

	local itemBg = ccui.ImageView:create('image/team/formation/team_formation_1.png')
	itemBg:addTo(item)
	itemBg:setTouchEnabled(true);
	itemBg:setSwallowTouches(false);
	itemBg:addClickEventListener(handler(self, self.onFormationItemSelected));

	local itemImg = cc.Sprite:create();
	itemImg:addTo(item);
	itemImg:setPosition(0,10);

    local itemName =  cc.Label:createWithTTF('formationName', fonts.FONT_SIYUAN, 20);
	itemName:addTo(item);
    itemName:setPosition(cc.p(0,-35))
	itemName:setTextColor(cc.c4b(60, 60, 60, 255));
	itemName:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);

	function item:setData( itemData )
		-- self == item
		self.id = itemData.id;
		self.name = itemData.name;
		self.position = itemData.position;
		self.lv = itemData.lv;
		self.lock = self.lv > model.UserModel:getUserLevel();

		local formationTexture = 'image/team/formation/item_formation_'..self.id..'_2.png'
		itemImg:setTexture(formationTexture)

		itemBg:setTag(self.id);
		itemBg:setTouchEnabled(not self.lock);
		itemName:setString(tostring(self.name))
		tools.LevelLockTools:setLockToNode(item,self.lock,self.lv,5,cc.p(0,0))
	end
	function item:setSelect( selected )
		itemSelect:setVisible(selected);
	end 

	return item;
end

function TeamFormationPanel:showFormationList(curFormation)
	local formationList = model.TeamModel:getTeamFormationList();
	--local curFormation = model.TeamModel:getCurrentTeamFormation()
	self.formationItemList = {}
	self.formationList:removeAllChildren();
	local count2 = 0
	for _k , itemData in pairs(formationList) do
		local formationItem = self:getFormationItem();
		formationItem:setData(itemData)
		formationItem:setSelect(itemData.id == curFormation)
		formationItem:setPosition(cc.p(count2*130+65,74));
		formationItem:addTo(self.formationList);
		count2 = count2 +1
		self.formationItemList[itemData.id] = formationItem
	end
	local maxWidth = count2*130
	if maxWidth < 570 then
		maxWidth = 570
	end
	self.formationList:setInnerContainerSize(cc.size(maxWidth,148))
	
end

function TeamFormationPanel:selectedFormation( formation )
	-- print('======selectedFormation === formation =' ..tostring(formation))
	local teamPos = model.TeamModel:getTeamFormationPosById(formation);

	if teamPos == nil then
		return 
	end

	local lastFormationItem = self.formationItemList[self.select_id]
	if lastFormationItem then
		lastFormationItem:setSelect(false)
	end
	self.select_id = formation;
	local nowFormation = self.formationItemList[self.select_id]
	if nowFormation then
		nowFormation:setSelect(true)
	end

	local teamRole = self.teamInfo --model.TeamModel:getCurrentTeam()
	-- dump(teamPos,'teamPos ======== ')
	-- dump(teamRole,'teamRole ==== ')
	--[[ teamPos ---> rolePos
		7 4 1
		8 5 2
		9 6 3
	--]]
	self.rolePos = {};
	for i=1,TEAM_MAX_MEMBER do
		local pid = teamRole[i];
		local pos = teamPos[i]

		if self.teamRole[i] == nil then
			local template = require('app.template.TeamRoleTemplate'):create(self.roleNode);
			template:Init(i);
			template:setInfo(pid)
			self.teamRole[i] = template;
		end
		local x = 3 -  math.floor( (pos -1)/3 )
		local y = (pos - 1)  %3 + 1
		self.rolePos[i] = cc.p(rolePosX[x] , rolePosY[y]);
		self.teamRole[i]:setPosition( rolePosX[x],rolePosY[y] );
	end

end
function TeamFormationPanel:updateRedDotShow()
	local userLv = model.UserModel:getUserLevel();
	local formationRedDotState = model.TeamModel:getTeamFormationRedDotState();
	for k,itemData in pairs(self.formationItemList) do
		local show = formationRedDotState[itemData.id]~=nil;
		tools.RedDotTools:setRedDotToNode(self.formationItemList[itemData.id],show,nil,cc.p(0,50))
	end


end
function TeamFormationPanel:onEnter( teamInfo, teamType )

	self.teamType = teamType or TeamType.COMMON

	self:addSwallowCallback(handler(self, self.onClickBack));

	if teamInfo == nil then
		teamInfo = model.TeamModel:getCurrentTeam()
	end
	--dump(teamInfo)
	self.teamInfo = teamInfo
	self.oldTeamInfo = {}
	for i=1, TEAM_MAX_MEMBER do
		self.oldTeamInfo[i] = self.teamInfo[i];
	end

	self:onShow()
end

function TeamFormationPanel:onShow()

	self.teamRole = {}
	self.roleNode:removeAllChildren()

	local curFormation
	if self.teamType == TeamType.EVENT then
		curFormation = model.TeamModel:getEventTeamFormation()
	elseif self.teamType == TeamType.ARENA then
		curFormation = model.TeamModel:getCurrentTeamFormation(6);
	elseif self.teamType == TeamType.GUILD_BOSS then
		curFormation = model.TeamModel:getCurrentTeamFormation(2)
	elseif self.teamType == TeamType.TRIAL_R or self.teamType == TeamType.TRIAL_G 
		or self.teamType == TeamType.TRIAL_B or self.teamType == TeamType.ARENA_1
		or self.teamType == TeamType.ARENA_2 or self.teamType == TeamType.ARENA_3 then
		curFormation = model.TeamModel:getCurrentTeamFormation(self.teamType)
	else
		curFormation = model.TeamModel:getCurrentTeamFormation()
	end
	self:showFormationList(curFormation)
	self:selectedFormation(curFormation);

	self:updateRedDotShow();

    self.root:setVisible(true)
end

function TeamFormationPanel:onLeave( ... )
    self.root:setVisible(false);
end


function TeamFormationPanel:onClickBack()

	if self.isTouchRole then
		self.isTouchRole = false;
		return
	end

	local curFormation
	if self.teamType == TeamType.EVENT then
		curFormation = model.TeamModel:getEventTeamFormation()
	elseif self.teamType == TeamType.ARENA then
		curFormation = model.TeamModel:getCurrentTeamFormation(6)
	elseif self.teamType == TeamType.GUILD_BOSS then
		curFormation = model.TeamModel:getCurrentTeamFormation(2)
	elseif self.teamType == TeamType.TRIAL_R or self.teamType == TeamType.TRIAL_G
		or self.teamType == TeamType.TRIAL_B or self.teamType == TeamType.ARENA_1
		or self.teamType == TeamType.ARENA_2 or self.teamType == TeamType.ARENA_3 then
		curFormation = model.TeamModel:getCurrentTeamFormation(self.teamType)
	else
		curFormation = model.TeamModel:getCurrentTeamFormation()
	end

	model.TeamModel:clearTeamFormationRedDotState();
	EventManager:FireEvent(EventType.UITeamFormationChange);

	local formationChange = false;
	local teamChange = false;

	if self.select_id ~= nil and self.select_id ~= -1 and  self.select_id ~= curFormation then
		formationChange = true;
	end

	for i = 1 , TEAM_MAX_MEMBER do
		if self.oldTeamInfo[i] ~= self.teamInfo[i] then
			teamChange = true
			break;
		end
	end

	if formationChange or teamChange then
		EventManager:FireEvent(EventType.UITeamOnShow, {formation=self.select_id, team=self.teamInfo, fchange=formationChange, tchange=teamChange });
	end

	UIManager:pop('TeamFormationPanel');
end




return TeamFormationPanel;
