local TeamRestraintPanel = class("TeamRestraintPanel", require('app.layer.BaseLayer'))

local fonts = Enum:getTable("SystemFont");
local restrainType = Enum:getTable("FightRestraintType")
local FightType = Enum:getTable('FightType');

function TeamRestraintPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'TeamRestraintPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.isPopup = true;
	self.haveSwallowLayer = true;
end

function TeamRestraintPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);

	self:InitPanel();

	self:registEvent()

end

function TeamRestraintPanel:InitPanel(  )

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setBackGroundImageCapInsets(cc.rect(11,4,18,21));
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(606,889));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(0 , -16);

	local titleNode = GlobalFunctions:createTitle(LANG.UI_TEAM_39);
	titleNode:addTo(self.root);
	titleNode:setPosition(0 , 450);

	local restraintTopBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	restraintTopBg:addTo(self.root);
	restraintTopBg:setPosition(0 , 288);
    restraintTopBg:setCapInsets(cc.rect(11,11,34,28));
	restraintTopBg:setContentSize(cc.size(580 , 278));

	local restraintTopImg = cc.Sprite:create('image/fight/restraint/restraint_bg_1.png')
		:addTo(self.root)
		:setPosition(cc.p(0, 311))

	for i=1,3 do
		local tmpLabel = cc.Label:createWithTTF(LANG.UI_GROUP_NAME[i] ,  fonts.FONT_IMPACT , 20);
		tmpLabel:addTo(self.root);
		if i==1 then
			tmpLabel:setPosition(cc.p(0, 331));
			tmpLabel:enableOutline(cc.c4b(20, 120, 160 , 255) , 2);
		elseif i==2 then
			tmpLabel:setPosition(cc.p(108, 226));
			tmpLabel:enableOutline(cc.c4b(210, 60, 60 , 255) , 2);
		else
			tmpLabel:setPosition(cc.p(-108, 226));
			tmpLabel:enableOutline(cc.c4b(0, 160, 110 , 255) , 2);
		end
	end

	local line = cc.Sprite:create('image/commonImg/line.png')
		:addTo(self.root)
		:setPosition(0 , 187)

	local sp2 = cc.Sprite:create('image/commonImg/tip_2.png')
		:addTo(self.root)

	local label = cc.Label:createWithTTF(string.format(LANG.UI_TEAM_34, tostring(Conf.restraintNum)), fonts.FONT_SIYUAN, 20)
		:setTextColor(cc.c3b(255 , 200 , 0))
		:addTo(self.root)

	local width = sp2:getContentSize().width+10;
	local labelWidth = label:getContentSize().width;
	local posX = -labelWidth/2;
	sp2:setPosition(posX,167);
	label:setPosition(posX+width/2+labelWidth/2,167);

	local restraintItemBg = cc.Scale9Sprite:create('image/commonImg/bg_3_11_4_33_20.png');
	restraintItemBg:addTo(self.root);
	restraintItemBg:setPosition(0 , -129);
    restraintItemBg:setCapInsets(cc.rect(11,4,33,20));
	restraintItemBg:setContentSize(cc.size(580 , 461));

	local menuName = {
		[1] = LANG.UI_TEAM_40,
		[2] = LANG.UI_TEAM_41,
	}
	self.menuList = {};
	for i = 1 , 2 do
		local unTexture = 'image/commonImg/top_2_bg_59_30.png';
		local texture = 'image/commonImg/top_1_bg_59_30.png';
		
		local label = cc.Label:createWithTTF(menuName[i] , fonts.FONT_SIYUAN , 20);

		local bgBtn = ccui.Button:create(texture,texture,unTexture);
		bgBtn:addTo(self.root);
		bgBtn:setTag(i);
		bgBtn:setTitleLabel(label)
		bgBtn:setScale9Enabled(true);
		bgBtn:setPosition(i == 1 and -145 or 145 , 116)
		bgBtn:setCapInsets(cc.rect(10 , 0 , 39 , 30));
		bgBtn:setContentSize(cc.size(290 , 30));
		bgBtn:addClickEventListener(handler(self , self.menuClick));
		self.menuList[i] = bgBtn;
	end
	--[[
	for i = 1 , 2 do
		local unTexture = 'image/commonImg/top_2_bg_59_30.png';
		local texture = 'image/commonImg/top_1_bg_59_30.png';

		local node = cc.Node:create();
		node:addTo(self.root);
		node:setPosition(-135 + 270 * (i - 1) , 110);
		self.menuList[i] = node;
		
		local bgBtn = ccui.Button:create(unTexture , unTexture);
		bgBtn:addTo(node);
		bgBtn:setTag(i);
		bgBtn:setName('unBtn');
		bgBtn:setScaleX(i == 2 and -1 or 1);
		bgBtn:addClickEventListener(handler(self , self.menuClick));

		local label = cc.Label:createWithTTF(menuName[i] , fonts.FONT_SIYUAN , 20);
		label:setTextColor(cc.c3b(50 , 50 , 50));
		label:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
		label:setScaleX(i == 2 and -1 or 1);
		bgBtn:setTitleLabel(label)        

		bgBtn = ccui.Button:create(texture , texture);
		bgBtn:addTo(node);
		bgBtn:setName('btn');
		bgBtn:setScaleX(i == 2 and -1 or 1);

		label = cc.Label:createWithTTF(menuName[i] , fonts.FONT_SIYUAN , 20);
		label:enableOutline(cc.c4b(19 , 93 , 188 , 255) , 2);
		label:setScaleX(i == 2 and -1 or 1);
		bgBtn:setTitleLabel(label);
	end
	]]

	local datas = {};
	for k, v in pairs(ResTable:getTable('formation_attribute').contain) do
		if not datas[v.color] then
			datas[v.color] = {};
		end
		table.insert(datas[v.color] , v);
	end

	for _k , data in pairs(datas) do
		if #data > 1 then
			table.sort(data , function(first , second) 
				return first.value < second.value;
			end);
		end
	end


	self.restraintItem = {}
	for i=1,3 do
		self.restraintItem[i] = {}
		local restraintNode = cc.Node:create();
		restraintNode:addTo(self.root);
		restraintNode:setPosition(cc.p(0,17 - 145*(i-1)))
		self.restraintItem[i].node = restraintNode;

		local itemBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
		itemBg:addTo(restraintNode);
    	itemBg:setCapInsets(cc.rect(11,11,34,28));
		itemBg:setContentSize(cc.size(550 , 134));

		local itemTitleSp = cc.Sprite:create('image/fight/restraint/restraint_type_'..i..'.png')
		itemTitleSp:addTo(restraintNode);
		itemTitleSp:setPosition(cc.p(-33,50));

		local tmpLabel = cc.Label:createWithTTF(LANG.UI_GROUP_NAME[i] ,  fonts.FONT_IMPACT , 20);
		tmpLabel:addTo(restraintNode);
		tmpLabel:setAnchorPoint(cc.p(0,0.5));
		tmpLabel:setPosition(cc.p(-252 , 49));
		if i==1 then
			tmpLabel:enableOutline(cc.c4b(30, 115, 170 , 255) , 2);
		elseif i==2 then
			tmpLabel:enableOutline(cc.c4b(160, 70, 55 , 255) , 2);
		else 
			tmpLabel:enableOutline(cc.c4b(20, 150, 60 , 255) , 2);
		end 
		
		local icon = cc.Sprite:create('image/commonImg/def_type_'..i..'.png')
		icon:addTo(restraintNode)
		icon:setPosition(cc.p(-229,-18))

		local activitySp = cc.Sprite:create('image/fight/restraint/restraint_bg_4.png')
		activitySp:addTo(restraintNode);
		activitySp:setPosition(cc.p(239,46));
		local aSize = activitySp:getContentSize();
		local aLabel = cc.Label:createWithTTF(LANG.UI_CARD_42 ,  fonts.FONT_IMPACT , 20);
	    aLabel:addTo(activitySp);
	    aLabel:setPosition( aSize.width/2, aSize.height/2 );
	    aLabel:enableOutline(cc.c4b(0 , 100 , 200 , 255) , 2);
		self.restraintItem[i].activitySp = activitySp;

		local restraintView = ccui.ScrollView:create();
		restraintView:setTouchEnabled(true);
		restraintView:setBounceEnabled(true);
		restraintView:setDirection(ccui.ScrollViewDir.vertical);
		restraintView:setContentSize(cc.size(450, 90));
		restraintView:setAnchorPoint(cc.p(0.5, 0.5));
		restraintView:setPosition(41 , -17);
		restraintView:setScrollBarEnabled(false);
		restraintView:addTo(restraintNode);


		local height = 0;
		local infoHeight = {0};
		self.restraintItem[i].info = {};
		for j=1,3 do
			self.restraintItem[i].info[j] = {};

			local lightSp = cc.Sprite:create()
			lightSp:addTo(restraintView);
			lightSp:setPosition(cc.p(14,0));
			self.restraintItem[i].info[j].light = lightSp;

			local label = cc.Label:createWithTTF(datas[i][j].info,fonts.FONT_SIYUAN,18)
			label:setPosition(24, 0);
			label:setAnchorPoint(cc.p(0,1))
			label:addTo(restraintView);
			label:setContentSize(cc.size(416 , 0))
			label:setLineBreakWithoutSpace(true)
			label:setMaxLineWidth(416)
			self.restraintItem[i].info[j].label = label;

			infoHeight[j+1] = infoHeight[j] + label:getContentSize().height;
			height = label:getContentSize().height + height;
		end
		height = height + 15;
		height = height < 90 and 90 or height;
		restraintView:setInnerContainerSize(cc.size(450,height));
		for j = 1 , 3 do
			self.restraintItem[i].info[j].light:setPositionY(height - infoHeight[j] - 14 - 5*(j-1))
			self.restraintItem[i].info[j].label:setPositionY(height - infoHeight[j] - 3 - 5*(j-1));
		end

	end

	local btnLabel = cc.Label:createWithTTF(LANG.COMMON_OK , fonts.FONT_SIYUAN , 20);
	btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);

	self.okBtn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.okBtn:addTo(self.root);
	self.okBtn:setPosition(0 , -410);
	self.okBtn:addClickEventListener(handler(self,self.onClickBack));
	self.okBtn:setTitleLabel(btnLabel);
end

function TeamRestraintPanel:registEvent( )
end

function TeamRestraintPanel:menuClick(sender , event)
	local tag = sender:getTag()
	self:switchList(tag);
end

function TeamRestraintPanel:switchList(index)

	for _k , btn in pairs(self.menuList) do
		local label = btn:getTitleLabel();
        -- self.rechargeBtn:setTouchEnabled(true);
		--btn:setBrightStyle(ccui.BrightStyle.normal)
		--btn:setBrightStyle(ccui.BrightStyle.highlight)
		if _k == index then
			btn:setBright(true)
			label:setTextColor(cc.c3b(255 , 255 , 255));
		else
			btn:setBright(false)
			label:setTextColor(cc.c3b(180 , 180 , 180));
		end
	end

	local restraintStr = '';
	if index == 1 then
		-- [0-4][0-4][0-4] 每位相加小于4
		restraintStr = self.ourRestraintString;
	else
		restraintStr = self.enemyRestraintString;
	end

	local restraintType = model.TeamModel:getTeamRestaintTypeByString(restraintStr);

	self:showRestraintNode(1,string.sub(restraintStr,1,1),restraintType)
	self:showRestraintNode(2,string.sub(restraintStr,2,2),restraintType)
	self:showRestraintNode(3,string.sub(restraintStr,3,3),restraintType)
end

function TeamRestraintPanel:showRestraintNode( index,CountStr,restraintType )
	local restrainNode = self.restraintItem[index]
	local restrainCount = tonumber(CountStr);

	print('restrainCount==== ',restrainCount,'===========index == ',index,'........restraintType = ',restraintType)
	if restraintType == -1 then
	-- 	-- restrainNode.mask:setVisible(true);
		restrainNode.activitySp:setVisible(false);
		for i=2,4 do
			restrainNode.info[i-1].label:setTextColor(cc.c4b(60, 60, 60, 125));
			restrainNode.info[i-1].light:setTexture('image/fight/restraint/restraint_bg_2.png');
		end
		return ;
	end

	if restrainCount < 2 then
		-- restrainNode.mask:setVisible(true);
		restrainNode.activitySp:setVisible(false);
		for i=2,4 do
			restrainNode.info[i-1].label:setTextColor(cc.c4b(60, 60, 60, 125));
			restrainNode.info[i-1].light:setTexture('image/fight/restraint/restraint_bg_2.png');
		end
	else
		-- restrainNode.mask:setVisible(false);
		restrainNode.activitySp:setVisible(true);
		for i=2,4 do
			if restrainCount == i then
				restrainNode.info[i-1].label:setTextColor(cc.c4b(255, 255, 255, 255));
				restrainNode.info[i-1].light:setTexture('image/fight/restraint/restraint_bg_3.png');
			else
				restrainNode.info[i-1].label:setTextColor(cc.c4b(60, 60, 60, 125));
				restrainNode.info[i-1].light:setTexture('image/fight/restraint/restraint_bg_2.png');
			end
		end
		
	end

end

function TeamRestraintPanel:onEnter(fightType , enemyRestraintString, data)

	self.root:setVisible(true);
	-- self.isVisible = true;
	self:addSwallowCallback(handler(self, self.onClickBack));

	local tid = model.TeamModel:getTeamIdByFightType( fightType, data );
	self.ourRestraintString = model.TeamModel:getTeamRestaintString(tid) or '000';

	self.enemyRestraintString = enemyRestraintString or '000';

	self:switchList(1);
end

function TeamRestraintPanel:onLeave()
	self.root:setVisible(false);
end


function TeamRestraintPanel:onClickBack()
	UIManager:pop('TeamRestraintPanel');
end


return TeamRestraintPanel;
