

local ThreeDayActivityPanel = class('ThreeDayActivityPanel' , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local imagePath = 'image/activity/three_day/'

function ThreeDayActivityPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'ThreeDayActivityPanel');

	self.useCCreator = false;
    self.isPopup = true;

end

function ThreeDayActivityPanel:Init(root)
	  -- body
    self.root = root;
    self.root:setVisible(false);

    self:initPanel();
    self:registEvent();
end


function ThreeDayActivityPanel:initPanel(  )

    local bg = cc.Sprite:create(imagePath..'three_day_bg_1.png');
    bg:addTo(self.root);
    bg:setPosition(0 , 88);

    bg = cc.Sprite:create(imagePath..'three_day_bg_5.png');
    bg:addTo(self.root);
    bg:setPosition(98 , 88);

    bg = cc.Sprite:create(imagePath..'three_day_bg_2.png');
    bg:addTo(self.root);
    bg:setPosition(-9 , -222);

    self.threeDayMission = {};
    for i = 1 , 3 do
        local temp = template.ThreeDayTemplate:create();
        temp:addTo(self.root)
        temp:setPosition(0,-120-105*(i-1))
        temp:setScale(0.8);
        temp:setThreeDayTag(i);
        temp:addThreeDayClickEventListener(handler(self , self.getReward));
        self.threeDayMission[i] = temp;
    end

    bg = cc.Sprite:create(imagePath..'three_day_bg_4.png');
    bg:addTo(self.root);
    bg:setPosition(-103 , -133);

    bg = cc.Sprite:create(imagePath..'three_day_bg_3.png');
    bg:addTo(self.root);
    bg:setPosition(-102 , -35);
end

function ThreeDayActivityPanel:registEvent(  )
    EventManager:RegisterEvent(EventType.NetworkRetThreeDayGetReward,handler(self,self.retGetReward));
end

function ThreeDayActivityPanel:onEnter()
    self:addSwallowCallback(handler(self , self.onClickBack));
    self:onShow();
    self.root:setVisible(true);
end

function ThreeDayActivityPanel:onShow()
    local completeState = model.ActivityModel:getThreeDayState()
    local threeDay = model.ActivityModel:getThreeDay()
    local rewards = {{90001,2101},{14003,2},{10020,10}}; 
    for i = 1 , 3 do
        local num = 0;
        local times = 0;
        if i == 1 then
            num = model.UserModel:getUserLoginDays();
            times = 3;
        elseif i == 2 then
            num = model.TrialModel:getFinshTrialId();
            times = 20;
        elseif i == 3 then
            num = model.UserModel:getUserLevel();
            times = 35;
        end

        local state = 0;
        if completeState[i] == 1 then
            if not threeDay[i] then
                state = 2;
            else
                state = 1;
            end
        end

        local data = {
            reward = {rewards[i]},
            name = LANG.UI_ACTIVITY_THREE_DAY[i],
            num = num,
            times = times,
            percent = num/times,
            state = state,
        };

        self.threeDayMission[i]:Init(data);
    end
end

function ThreeDayActivityPanel:getReward(sender , event)
    local no = sender:getTag();
    local threeDay = model.ActivityModel:getThreeDay();
    if threeDay[no] then
        return;
    end

    Network.NetworkManager:Send(Network.NetworkCmdType.req_tree_day_reward , {no = no});
end

function ThreeDayActivityPanel:retGetReward(msg)
    self:onShow();
    UIManager:push('RewardPanel',msg);
end

function ThreeDayActivityPanel:onLeave()
    tools.RedDotTools:pushMainPanelRedDot(13);
    
    self.root:setVisible(false);
end
function ThreeDayActivityPanel:onClickBack()
    TimeManager:registUpdateEvent('ThreeDayActivityPanel',nil,true);
    UIManager:pop('ThreeDayActivityPanel');
end

return ThreeDayActivityPanel
