local TipsOfflineRewardPanel = class("TipsOfflineRewardPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")

function TipsOfflineRewardPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'TipsOfflineRewardPanel');

	self.useCCreator = false;
	self.isPopup = true;
end

function TipsOfflineRewardPanel:Init(root)
	self.root = root;
	self.root:setVisible(false);
	self:initPanels()
end

function TipsOfflineRewardPanel:initPanels()

	local blackBg = ccui.Layout:create();
	blackBg:setBackGroundImage('image/task/blackbg.png');
	blackBg:setBackGroundImageScale9Enabled(true);
	blackBg:setTouchEnabled(true);
	blackBg:setContentSize(cc.size(StageSize.width,StageSize.height));
	blackBg:setLocalZOrder(-2);
	blackBg:setAnchorPoint(cc.p(0.5,0.5));
	blackBg:setPosition(0, 0);
	blackBg:addTo(self.root);
	
	local bg = cc.Sprite:create('image/common/offline_reward_bg.png');
	bg:addTo(self.root);

	local label = cc.Label:createWithTTF(LANG.UI_FIGHT_75 , fonts.FONT_SIYUAN , 20);
	label:setPosition(0 , 189);
	label:addTo(self.root);

	label = cc.Label:createWithTTF('- OFFLINE PROFIT -' , fonts.FONT_SIYUAN , 9);
	label:setPosition(0 , 171);
	label:setTextColor(cc.c4b(0 , 142 , 219 , 255));
	label:addTo(self.root);

	label = cc.Label:createWithTTF(LANG.UI_FIGHT_76 , fonts.FONT_SIYUAN , 20);
	label:setPosition(0 , 36);
	label:setTextColor(cc.c4b(60 , 60 , 60 , 255));
	label:addTo(self.root);

	local btn = ccui.Button:create('image/commonImg/btn_bg2.png' , 'image/commonImg/btn_bg2.png');
	btn:addTo(self.root);
	btn:setPosition(-118 , -147);
	btn:addClickEventListener(function() 
		AudioManager:playEffect(Conf.cancleButton);
		self:onClickBack()
	end);

	label = cc.Label:createWithTTF(LANG.COMMON_CANCEL , fonts.FONT_SIYUAN , 20);
	label:addTo(btn);
	label:setPosition(btn:getContentSize().width/2 , btn:getContentSize().height/2);
	label:setTextColor(cc.c3b(60 , 60 , 60));
	label:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);

	btn = ccui.Button:create('image/commonImg/btn_bg1.png' , 'image/commonImg/btn_bg1.png');
	btn:addTo(self.root);
	btn:setPosition(118 , -147);
	btn:addClickEventListener(function()
		self:onClickBack()
		AudioManager:playEffect(Conf.confirmButton);
		EventManager:FireEvent(EventType.UIFooterChooseFooter , 3);
	end);

	label = cc.Label:createWithTTF(LANG.COMMON_GO , fonts.FONT_SIYUAN , 20);
	label:addTo(btn);
	label:setPosition(btn:getContentSize().width/2 , btn:getContentSize().height/2);
	label:setTextColor(cc.c3b(255 , 255 , 255));
	label:enableOutline(cc.c4b(19 , 93 , 188 , 255) , 2);
end

function TipsOfflineRewardPanel:onEnter()

	self.root:setVisible(true);
end

function TipsOfflineRewardPanel:onClickBack()
	UIManager:pop('TipsOfflineRewardPanel');
end
function TipsOfflineRewardPanel:onLeave()
	self.root:setVisible(false);
end
return TipsOfflineRewardPanel;
