local TipsShopPanel = class("TipsShopPanel" , require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local CommonShopType = Enum:getTable('CommonShopType');
local shopName = {
	[CommonShopType.SHOP] = 'shop',
	--[CommonShopType.GUILD] = 'guild_rewardshop',
	[CommonShopType.RECHARGE] = 'recharge',
	[CommonShopType.GIFT] = 'shop_gift',
}

function TipsShopPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'TipsShopPanel');

	self.useCCreator = false;
	self.isPopup = true;

end

function TipsShopPanel:Init(root)
	  -- body
      self.root = root;
      self.root:setVisible(false);
	  self.curBuyCount = 0;
      self:InitPanels();
end

function TipsShopPanel:InitPanels()

	local bg = ccui.Layout:create();
	bg:addTo(self.root);
	bg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png');
	bg:setBackGroundImageScale9Enabled(true);
	bg:setTouchEnabled(true);
	bg:setContentSize(cc.size(484,563));
	bg:setAnchorPoint(0.5,0.5);
	bg:setPosition(6 , 8.5);

	local titleNode = GlobalFunctions:createTitle(LANG.UI_L_BUYTOOLS_1,484);
	titleNode:addTo(self.root);
	titleNode:setPosition(6,312.5);

	local itemNameBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	itemNameBg:addTo(self.root);
	itemNameBg:setPosition(5 , 245);
    itemNameBg:setCapInsets(cc.rect(11,11,34,28));
	itemNameBg:setContentSize(cc.size(462 , 59));

	local nameImg = cc.Sprite:create('image/commonImg/arrow_bg.png');
	nameImg:addTo(self.root);
	nameImg:setPosition(-188 , 245);

	self.itemName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 23);
	self.itemName:addTo(self.root);
	self.itemName:setAnchorPoint(0 , 0.5);
	self.itemName:setPosition(-169 , 245);
	self.itemName:setTextColor(cc.c3b(160 , 200 , 255));

	self.itemIcon = template.ItemTemplate:create();
	self.itemIcon:setPosition(6 , 149);
	self.itemIcon:addTo(self.root);

	local infoBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	infoBg:addTo(self.root);
	infoBg:setPosition(8 , -49);
    infoBg:setCapInsets(cc.rect(11,11,34,28));
	infoBg:setContentSize(cc.size(462 , 257));

	self.itemInfo = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.itemInfo:addTo(self.root);
	self.itemInfo:setAnchorPoint(0 , 1);
	self.itemInfo:setContentSize(cc.size(423 , 124));
	self.itemInfo:setLineBreakWithoutSpace(true);
	self.itemInfo:setMaxLineWidth(423);
	self.itemInfo:setLineHeight(30);
	self.itemInfo:setPosition(-206 , 66);

	local bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	bg:addTo(self.root);
	bg:setPosition(8 , -115);
    bg:setCapInsets(cc.rect(11,11,34,28));
	bg:setContentSize(cc.size(462 , 125));

	local haveBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	haveBg:addTo(self.root);
	haveBg:setPosition(5 , -88);
    haveBg:setCapInsets(cc.rect(11,11,34,28));
	haveBg:setContentSize(cc.size(435 , 42));

	local haveImg = cc.Sprite:create('image/commonImg/arrow_3_bg.png');
	haveImg:addTo(self.root);
	haveImg:setPosition(-181 , -88);

	local haveLabel = cc.Label:createWithTTF(LANG.UI_CARD_19 , fonts.FONT_SIYUAN , 20);
	haveLabel:addTo(self.root);
	haveLabel:setAnchorPoint(0 , 0.5);
	haveLabel:setPosition(-168 , -88);

	self.haveMoney = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.haveMoney:addTo(self.root);
	self.haveMoney:setPosition(4 , -88);

	self.haveArrowImg = cc.Sprite:create('image/shop/shop_tips_bg_6.png');
	self.haveArrowImg:addTo(self.root);
	self.haveArrowImg:setPosition(80 , -88);

	self.lastMoney = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.lastMoney:addTo(self.root);
	self.lastMoney:setPosition(147 , -88);

	-- local buyNumBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	-- buyNumBg:addTo(self.root);
	-- buyNumBg:setPosition(4 , -141);
 --    buyNumBg:setCapInsets(cc.rect(11,11,34,28));
	-- buyNumBg:setContentSize(cc.size(435 , 42));

	self.subBtn = ccui.Button:create('image/shop/shop_tips_1.png');
	self.subBtn:setPosition(-94, -141);
	self.subBtn:setTag(1);
	self.subBtn:addClickEventListener(handler(self, self.chooseNums));
	self.subBtn:addTo(self.root);

	self.addBtn = ccui.Button:create('image/shop/shop_tips_2.png');
	self.addBtn:setPosition(108, -141);
	self.addBtn:setTag(2);
	self.addBtn:addClickEventListener(handler(self, self.chooseNums));
	self.addBtn:addTo(self.root);

	self.buyNum = cc.Label:createWithTTF('1/7', fonts.FONT_SIYUAN, 20);
	self.buyNum:setPosition(4, -141);
	self.buyNum:addTo(self.root);
	self.buyNum:setVisible(false);

	self.editBox = ccui.EditBox:create(cc.size(95, 49), cc.Scale9Sprite:create('image/commonImg/edit_box.png'));
	-- self.editBox:setFontColor(cc.c4b(150, 150, 150, 255));
	self.editBox:setFontSize(20);
	self.editBox:setTextHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
	self.editBox:setMaxLength(7); 
	self.editBox:setText('1');
	self.editBox:setInputMode(cc.EDITBOX_INPUT_MODE_NUMERIC);
	self.editBox:setInputFlag(cc.EDITBOX_INPUT_FLAG_SENSITIVE);
	self.editBox:setReturnType(cc.KEYBOARD_RETURNTYPE_DONE);
	self.editBox:setPosition(4, -141);
	self.editBox:addTo(self.root);
	self.editBox:registerScriptEditBoxHandler(function(event)
			if event == "began" then
				-- self.editBox:setPosition(4+160, -141);
				-- self.editBox:setText( self.buyNum:getString() )
				-- self.buyNum:setVisible(false)
			end
			
			if event == "return" then
				local str =  self.editBox:getText()
				self.curBuyCount = tonumber(str)
				if self.curBuyCount < 1 then
					self.curBuyCount = 1;
				end
				self.editBox:setText( tostring(self.curBuyCount) )
				
				if self.curBuyCount > self.totalCount then
					if self.beyondType == 1 then
						Prompt:Show(LANG.UI_SHOP_56);
					else
						Prompt:Show(LANG.UI_SHOP_58);
					end
					return;
				end

				if self.curBuyCount < 1 then
					self.curBuyCount = 1;
				elseif self.curBuyCount > self.totalCount then
					self.curBuyCount = self.totalCount;
				end

				self:updateCount();
				self.editBox:setText( tostring(self.curBuyCount) )

				-- self.editBox:setText('')
				-- self.editBox:setPosition(4, -141);
				-- self.buyNum:setVisible(true)
			end
		end);

	local costBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png');
	costBg:addTo(self.root);
	costBg:setPosition(-114 , -224);
    costBg:setCapInsets(cc.rect(11,11,34,28));
	costBg:setContentSize(cc.size(217 , 42));

	self.costMoneyIcon = cc.Sprite:create();
	self.costMoneyIcon:setPosition(cc.p(-195,-223));
	self.costMoneyIcon:setScale(0.4);
	self.costMoneyIcon:addTo(self.root);

	self.costNum = cc.Label:createWithTTF('0', fonts.FONT_SIYUAN, 20);
	self.costNum:setAnchorPoint(1, 0.5);
	self.costNum:setPosition(-21, -224);
	self.costNum:addTo(self.root);

	local btnLabel = cc.Label:createWithTTF(LANG.UI_SETTING_21 , fonts.FONT_SIYUAN , 20);
	btnLabel:enableOutline(cc.c3b(50 , 85 , 150) , 2);

	self.btn = ccui.Button:create('image/commonImg/btn_1_219_55.png' , 'image/commonImg/btn_1_219_55.png');
	self.btn:addTo(self.root);
	self.btn:setPosition(116 , -225);
	self.btn:addClickEventListener(handler(self , self.buyButtonClick));
	self.btn:setTitleLabel(btnLabel);
end

function TipsShopPanel:chooseNums(sender, event)
	local tag = sender:getTag();
	
	if tag == 1 then
		self.curBuyCount = self.curBuyCount - 1;
	elseif tag == 2 then
		if self.curBuyCount > self.totalCount then
			if self.beyondType == 1 then
				Prompt:Show(LANG.UI_SHOP_56);
			else
				Prompt:Show(LANG.UI_SHOP_58);
			end
			return;
		end
		self.curBuyCount = self.curBuyCount + 1;
	end

	if self.curBuyCount < 1 then
		self.curBuyCount = 1;
	elseif self.curBuyCount > self.totalCount then
		self.curBuyCount = self.totalCount;
	end

	self:updateCount();
end

function TipsShopPanel:updateCount()
	if self.curBuyCount < 1 then
		self.curBuyCount = 1
	end
	self.buyNum:setString(self.curBuyCount);
	self.editBox:setText(self.curBuyCount);
	local costNum = self.curBuyCount * self.price;

	if self.costType == MONEY_ID then
		self.costNum:setString(ConvertStrToDigitUnit(tostring(costNum)));
		local haveMoney = model.MoneyModel:getWholeMoney();
		local lastNum = HpMinus(haveMoney,costNum);
		self.lastMoney:setString(tostring(ConvertStrToDigitUnit(tostring(lastNum))));
	else
		self.costNum:setString(tostring(costNum));
		local lastNum = self.haveMoneyNum - costNum;
		self.lastMoney:setString(tostring(lastNum));
	end
end

function TipsShopPanel:onEnter(shopType , id)

	self:addSwallowCallback(handler(self , self.onClickBack));
	
	if shopType == nil or id == nil then
		return;
	end
	
	self.shopType = shopType;
	self.id = id;
	self.root:setVisible(true);

	if self.shopType == CommonShopType.CLIENT then
		self.shopData = ResTable:getRowData('shop', self.id);
	else
		self.shopData = model.ShopModel:getShopDataByIndex(shopType)[id];
	end
	--local iTableData = ResTable:getRowData('item', self.shopData.item[1]); --item table data

	if not self.shopData then
		return
	end

	local nameStr = self.shopData.name;
    if nameStr == nil then
        nameStr = ResTable:getLangByNum(self.shopData.name_no)
    end

	local times = tonumber(self.shopData.times);
	local discount = self.shopData.discount or 100;

	self.costType = self.shopData.price[1]
	self.price = discount ~= nil and self.shopData.price[2]*(discount / 100) or self.shopData.price[2];

	local isEnough = true;
	if self.costType == MONEY_ID then
		self.haveMoneyNum = model.MoneyModel:getMoney();
		local haveMoney = model.MoneyModel:getWholeMoney();
		self.totalCount = math.floor(haveMoney / self.price);

		local haveMoney = model.MoneyModel:getWholeMoney();
		if HpCompare(haveMoney, '<', tostring(self.price)) then
			isEnough = false;
		end
	else
		self.haveMoneyNum = model.ItemModel:getItemNum(self.costType);
		self.totalCount = math.floor(self.haveMoneyNum / self.price);

		if self.haveMoneyNum < self.price then
			isEnough = false;
		end
	end

	if not isEnough then
		self.haveArrowImg:setVisible(false);
		self.lastMoney:setVisible(false);
		self.haveMoney:setTextColor(cc.c3b(255,0,0));
	else
		self.haveArrowImg:setVisible(true);
		self.lastMoney:setVisible(true);
		self.haveMoney:setTextColor(cc.c3b(255,255,255));
	end

	self.beyondType = 1;--货币不足超出限制
	if times ~= -1 then
		if self.totalCount > times then
			self.beyondType = 2;--总数超出限制
			self.totalCount = times;
		end
	end
	
	self.curBuyCount = 1;

	self.itemIcon:Init(self.shopData.item[1] , self.shopData.item[2]);
	self.itemName:setString(nameStr);

	local itemInfo = ResTable:getValue('item',self.shopData.item[1],'info');
	self.itemInfo:setString(tostring(itemInfo));

	local icon = ResTable:getValue('item',self.costType,'icon');
	self.costMoneyIcon:setTexture('image/icon/I'..icon..'.png');
	self.haveMoney:setString(tostring(self.haveMoneyNum));

	self:updateCount();
end

function TipsShopPanel:buyButtonClick(sender , event)
	
	local costItemName = ResTable:getValue('item' , self.shopData.price[1] , 'name');
	if self.curBuyCount < 1 then
		self.curBuyCount = 1
	end
	local costNum = self.price * self.curBuyCount;
	local strCost = tostring(costNum);

	if self.costType == MONEY_ID then
		local haveMoney = model.MoneyModel:getWholeMoney();
		if HpCompare(haveMoney, '<', tostring(costNum)) then
			Prompt:Show(LANG.UI_SHOP_56);
			return
		end
		strCost = ConvertStrToDigitUnit(strCost);
	else
		if self.haveMoneyNum < costNum then
			Prompt:Show(LANG.UI_SHOP_56);
			return
		end
	end

	local nameStr = self.shopData.name;
    if nameStr == nil then
        nameStr = ResTable:getLangByNum(self.shopData.name_no)
	end
	
	local msg = string.format(LANG.UI_SHOP_67 , strCost ,costItemName, nameStr , self.curBuyCount)
	
	local msgBox = MessageBox:create(msg , MessageBoxType.CANCEL_OK,function()
		if self.shopType == CommonShopType.SHOP then
			model.ShopModel:sendBuyShopItem(self.id , self.curBuyCount,self.price)
		elseif self.shopType == CommonShopType.BATTLEPASS_1 or 
			self.shopType == CommonShopType.BATTLEPASS_2 then
				model.ShopModel:reqBattlepassBuy(self.shopType , self.id , self.curBuyCount);
		else
			model.ShopModel:reqStoreBuy(self.shopType , self.id , self.curBuyCount , self.price);
		end
		UIManager:pop('TipsShopPanel');
	end);

	msgBox:setTitle(LANG.UI_SHOP_78);
end
function TipsShopPanel:onLeave()
	self.root:setVisible(false);
end

function TipsShopPanel:onClickBack()
	UIManager:pop('TipsShopPanel');
end

return TipsShopPanel;
