local TrialPanel = class("TrialPanel",require('app.layer.BaseLayer'))
local fonts = Enum:getTable("SystemFont")
local MessageBoxType = Enum:getTable('MessageBoxType')
local imgPath = 'image/trial/';
local TeamType = Enum:getTable('TeamType')

function TrialPanel:ctor(scene, sceneName, name)
	self.super.ctor(self, scene, sceneName, 'TrialPanel');
	self.useCCreator = false;
    self.showHeaderType = Enum:getTable('HeaderType').HEAD_TITLE;
    self.showFooter = true;

    self.selectedId = nil;

    self.allyPosition = 
    {
        [1] = {
            x = -100,	y = -240,	roa = -5.9,		zorder = 22,
        },
        [2] = {
            x = -120,	y = -340,	roa = -20.6,	zorder = 28,
        },
        [3] = {
            x = -220,	y = -250,	roa = -13.7,	zorder = 21,
        },
        [4] = {
            x = -240,	y = -350,	roa = -31.7,	zorder = 27,
        },

    };
    
end

function TrialPanel:Init( root,scene )
    -- body
    self.root = root;
    self.scene = scene;
    self.root:setVisible(false);
    self.curTeamType = TeamType.COMMON;
    -- self.root:setPosition(StageSize.width/2,StageSize.height/2);

    self:initPannel();
    self:initTeam()
    self:initMonster()
    self:registEvent();

end

function TrialPanel:registEvent(  )
	EventManager:RegisterEvent(EventType.UITrialPanelFightOver , handler(self , self.retFightOverAuto));
	-- EventManager:RegisterEvent(EventType.UITrialPanelBuyAutoNum , handler(self , self.retBuyAutoNum));
	EventManager:RegisterEvent(EventType.UITrialPanelUpdateRewardTips , handler(self , self.updateRewardTips));
end

function TrialPanel:initPannel(  )

	local blackBg = ccui.Layout:create();
	blackBg:setBackGroundImage('image/task/blackbg.png');
	blackBg:setBackGroundImageScale9Enabled(true);
	blackBg:setTouchEnabled(true);
	blackBg:setContentSize(StageSize);
	blackBg:setLocalZOrder(-2);
	blackBg:setAnchorPoint(cc.p(0.5,0.5));
	blackBg:setPosition(0, 0);
    blackBg:addTo(self.root);
    
    local bgNode = cc.Node:create();
    bgNode:addTo(self.root);

    local bg1 = cc.Sprite:create('image/round/BG_chapter_0.png');
    bg1:addTo(bgNode);
    --bg1:setPosition(cc.p(0,72));

    local bg4 = cc.Sprite:create('image/fight/scene/scene61.png');
    bg4:addTo(bgNode);
    bg4:setPosition(cc.p(0,-400));

    local rightNode = cc.Node:create()
        :addTo(self.root)
        :setPosition(cc.p(182,171))
    self.trialItem = {}
    for i=1,3 do

        self.trialItem[i] = {}
        self.trialItem[i].node = cc.Node:create()
            :addTo(rightNode)

        local itemBg = cc.Sprite:create( imgPath..'item_bg_1.png')
            :addTo(self.trialItem[i].node);
    
        local arrow1 = cc.Sprite:create( imgPath..'item_arrow.png')
            :addTo(self.trialItem[i].node)
            :setPosition(cc.p(-70,15))

        local arrow2 = cc.Sprite:create( imgPath..'item_arrow.png')
            :addTo(self.trialItem[i].node)
            :setPosition(cc.p(70,15))
            :setScale(-1,1)

        self.trialItem[i].title = cc.Label:createWithTTF(string.format( LANG.UI_TRIAL_17,1 ),fonts.FONT_SIYUAN,30)
            :addTo(self.trialItem[i].node)
            :setPosition(cc.p(0,15))

        local powerLable1 = cc.Label:createWithTTF(LANG.UI_TRIAL_2,fonts.FONT_SIYUAN,16)
            :addTo(self.trialItem[i].node)
            :setPosition(cc.p(-79,-34))
            :setAnchorPoint(cc.p(0,0.5))
            :setVisible(false)
        
        self.trialItem[i].power = cc.Label:createWithTTF('9999',fonts.FONT_SIYUAN,16)
            :addTo(self.trialItem[i].node)
            :setPosition(cc.p(103,-36))
            :setAnchorPoint(cc.p(1,0.5))
            :setVisible(false)
    end

    -- topItem
    self.trialItem[3].node:setScale(0.9)
        :setPosition(cc.p(17,117))
    local topMask = cc.Sprite:create( imgPath..'item_mask_top.png')
        :setPosition(cc.p(0,-6))
        :addTo(self.trialItem[3].node);
    -- midItem
    self.trialItem[2].node:setPosition(cc.p(0,0))
    self.trialItem[2].complete = cc.Node:create()
        :addTo(self.trialItem[2].node)
        :setVisible(false)
    local midMask = cc.Sprite:create( imgPath..'item_mask_bottom.png')
        :addTo(self.trialItem[2].complete);
    local midComplete = cc.Sprite:create( imgPath..'item_all_complete.png')
        :addTo(self.trialItem[2].complete);
    -- bottomItem
    self.trialItem[1].node:setScale(0.9)
        :setPosition(cc.p(17,-121))
    local bottomMask = cc.Sprite:create( imgPath..'item_mask_bottom.png')
        :addTo(self.trialItem[1].node);
    local challengeOver = cc.Sprite:create( imgPath..'item_chanllenge_over.png')
        :addTo(self.trialItem[1].node);

    -- topPower
    local topPowerNode = cc.Node:create()
        :addTo(self.root)
        :setPosition(cc.p(3,403))

    local powerBg = cc.Sprite:create( imgPath .. 'power_bg.png')
        :addTo(topPowerNode)
    local powerBg2 = cc.Sprite:create( imgPath .. 'power_bg2.png')
        :addTo(topPowerNode)
        :setPosition(cc.p(-130,-1))
    local powerBg3 = cc.Sprite:create( imgPath .. 'power_bg3.png')
        :addTo(topPowerNode)
        :setPosition(cc.p(-103,-1))
        :setAnchorPoint(cc.p(0,0.5))
    
    self.curItemPowerLabel = cc.Label:createWithTTF('9999',fonts.FONT_SIYUAN,20)
        :addTo(topPowerNode)
        :setPosition(cc.p(121,2))
        :setAnchorPoint(cc.p(1,0.5))
        :enableShadow(cc.c4b(0,0,0,255),cc.size(0,0))

    --目标奖励按钮
    self.rewardBtn = ccui.Button:create( imgPath .. "trial_reward_bg.png")
        :addTo(self.root)
        :setPosition(cc.p(259,-65))
    self.rewardBtn:addClickEventListener(handler(self , self.onRewardPanel));	

    local size = self.rewardBtn:getContentSize()
    local btnName = cc.Sprite:create('image/main/main_btn_4.png')
	if btnName then
		btnName:addTo(self.rewardBtn)
			:setPosition(size.width/2 , size.height/2)
    end
    
    local btnName = cc.Label:createWithTTF( LANG.UI_TITLE_MUBIAO, fonts.FONT_SIYUAN, 20)
			:enableOutline(cc.c3b(60, 60, 60), 2)
			:setPosition(size.width / 2 , 5)
			:addTo(self.rewardBtn)

    --关卡奖励
    self.pointRewardNode = cc.Node:create()
        :addTo(self.root)
        :setPosition(cc.p(-131,162))

    local pointRewardBg = cc.Sprite:create( imgPath..'reward_bg.png')
        :addTo(self.pointRewardNode);
    -- local pointRewardTitleSp = cc.Sprite:create( imgPath..'trial_title.png')
    --     :addTo(self.pointRewardNode)
    --     :setPosition(cc.p(0,151))
    self.trialIcon = cc.Sprite:create()
        :addTo(self.pointRewardNode)
        :setScale(0.5)
    self.trialName = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,25) 
        :addTo(self.pointRewardNode)
        :setPosition(cc.p(0,151))
        :enableOutline(cc.c4b(0 , 0 , 0 , 255),2);

        -- 已通关
    self.pointRewardComplete = cc.Node:create()
        :addTo(self.pointRewardNode)
        :setVisible(false)
    local completeLabel = cc.Label:createWithTTF( LANG.UI_TRIAL_23,fonts.FONT_SIYUAN,26) 
        :addTo(self.pointRewardComplete)
        :setPosition(cc.p(0,-7))
        :enableOutline(cc.c4b(10 , 10 , 10 , 255),2);

        -- 未通过
    self.pointRewardUnComplete = cc.Node:create()
        :addTo(self.pointRewardNode)

    self.pointTitle = cc.Label:createWithTTF( LANG.UI_TRIAL_17,fonts.FONT_SIYUAN,26) -- LANG.UI_TRIAL_21
        :addTo(self.pointRewardUnComplete)
        :setPosition(cc.p(1,92))
        :enableOutline(cc.c4b(10 , 10 , 10 , 255),2);
    local pointTitle2 = cc.Label:createWithTTF( LANG.UI_TRIAL_21,fonts.FONT_SIYUAN,20) -- 
        :addTo(self.pointRewardUnComplete)
        :setPosition(cc.p(0,56))
        :enableShadow(cc.c4b(0,0,0,255),cc.size(0,0))

    self.pointReward = {}
    for i=1,2 do
        self.pointReward[i] = template.ItemTemplate:create()
        self.pointReward[i]:addTo(self.pointRewardUnComplete)
        self.pointReward[i]:setPosition(cc.p(-47 + 100 * (i-1),-8))
        self.pointReward[i]:setScale(0.8)
        self.pointReward[i]:setCanShowInfo(true,true);   
     end
     --编队 挑战
    local label = cc.Label:createWithTTF(LANG.UI_TRIAL_3 ,  fonts.FONT_SIYUAN , 20)
        :enableOutline(cc.c4b(130 , 15 , 0 , 255),2)
    self.fightBtn = ccui.Button:create('image/commonImg/btn_10.png' , 'image/commonImg/btn_10.png')
        :addTo(self.pointRewardUnComplete)
        :setPosition(1, -91)
        :setTitleLabel(label)
    self.fightBtn:addClickEventListener(handler(self , self.onFight))

	self.teamBtn = ccui.Button:create('image/commonImg/team_icon.png' , 'image/commonImg/team_icon.png')
        :addTo(self.pointRewardNode)
        :setPosition(104,91)
	self.teamBtn:addClickEventListener(handler(self , self.onTeam))

    self.teamNode = cc.Node:create();
    self.teamNode:addTo(self.root);
    self.teamNode:setPosition(0,-50);

    self.monsterNode = cc.Node:create();
    self.monsterNode:addTo(self.root);
    self.monsterNode:setPosition(0,-50);

end


function TrialPanel:initTeam(  )
    self.teamList = {}
    for i=1,TEAM_MAX_MEMBER do
        local roleNode = cc.Node:create();
        roleNode:addTo(self.teamNode)
        roleNode:setVisible(false)

        local bloodVolume = require('app.template.BloodVolume'):create(roleNode);
        bloodVolume:setPosition(0, 55);
        bloodVolume:setLevel(99)

        self.teamList[i] = {}
        self.teamList[i].roleNode = roleNode;
        self.teamList[i].bloodVolume = bloodVolume;
        self.teamList[i].armature = nil;
        self.teamList[i].pid = -1;

    end
end

function TrialPanel:initMonster(  )
    self.monsterList = {}
    
    for i=1,6 do
        local roleNode = cc.Node:create();
        roleNode:addTo(self.monsterNode)
        roleNode:setVisible(false);

        local bloodVolume = require('app.template.BloodVolume'):create(roleNode);
        bloodVolume:setPosition(0, 55);
        bloodVolume:setLevel(99)

        -- local monsterFrameAni = cc.Sprite:create();
        -- monsterFrameAni:addTo(roleNode);
        -- monsterFrameAni:setLocalZOrder(1)
        -- monsterFrameAni:setScale(1.4)
        -- monsterFrameAni:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
        self.monsterList[i] = {}
        self.monsterList[i].roleNode = roleNode;
        self.monsterList[i].bloodVolume = bloodVolume;
        self.monsterList[i].armature = nil;
        self.monsterList[i].monster_id = -1;
        self.monsterList[i].monster_lv = -1;
        -- self.monsterList[i].monsterFrameAni = monsterFrameAni;
    end
end

function TrialPanel:showTeamNode(  )
    self.team  = model.TeamModel:getTeamById(self.curTeamType);
    local curFormation = model.TeamModel:getCurrentTeamFormation(self.curTeamType)
	local teamPos = model.TeamModel:getTeamFormationPosById(curFormation);
    self.haveTeam = false;
    for i=TEAM_MAX_MEMBER, 1, -1 do
        local formationIndex = teamPos[i];
        local pos = FightManager:getRolePosByFormationIndex(formationIndex);
        self.teamList[i].roleNode:setPosition(pos.x, pos.y);
        self.teamList[i].roleNode:setLocalZOrder(100 + pos.z);

        local pid = self.team[i];
        local card = model.CardModel:GetCard(pid);
        if pid ~= -1 then
            self.haveTeam = true;
            if true then --self.teamList[i].pid ~= pid
                if self.teamList[i].armature~= nil then
                    self.teamList[i].armature:removeFromParent()
					DragonBonesManager:RemoveDisplay(self.teamList[i].armature_id)
                    self.teamList[i].armature = nil;
                    self.teamList[i].pid = -1;
                end
    
                local no = card.no;
                local roleData = ResTable:getRowData('role', no);
                local rolePreData = ResTable:getRowData('role_pre', roleData.role_id);
                local resId = model.CardModel:getCardResIdByPid(pid);
                local roleResData = ResTable:getRowData('role_resource', resId);
                
                local modelPath = roleResData.model;
                if modelPath then 
                    local armature, id = DragonBonesManager:GetArmature(modelPath);
                    armature:getAnimation():play('idle');
                    armature:addTo(self.teamList[i].roleNode);
                    armature:setScale(0.4);
                    armature:setLocalZOrder(-1);
                    self.teamList[i].armature = armature;
                    self.teamList[i].armature_id = id;
                    self.teamList[i].pid = pid;
    
                    self.teamList[i].bloodVolume:setPercent(math.floor(100));
                    self.teamList[i].bloodVolume:setDefType(rolePreData.def_type);
                    self.teamList[i].bloodVolume:setLevel(card.level);
                    
                    self.teamList[i].roleNode:setVisible(true);
                else
                    print("====================error==========showTeamNode==no armature============pid == "..tostring(pid))
                end
            else
                self.teamList[i].bloodVolume:setPercent(math.floor(100));
            end

        else
            if self.teamList[i].armature~= nil then
                self.teamList[i].armature:removeFromParent()
				DragonBonesManager:RemoveDisplay(self.teamList[i].armature_id)
                self.teamList[i].armature = nil;
                self.teamList[i].pid = -1;
            end
            self.teamList[i].roleNode:setVisible(false);

        end
	end

end

function TrialPanel:showMonsterNode(  )
    if self.selectedId == nil then
        return 
    end
    local itemData = model.TrialModel:getItemDataById(self.selectedId, self.trialType);
    if itemData == nil then
        return 
    end
    self.monsterDatas = itemData.monster;
    if itemData.formation == nil or next(itemData.formation) == nil then
        itemData.formation = {1,2,3,4}
    end
    local formation = itemData.formation --fighter:getFormationIndex()

    for i=1, 6 do 

		local data = self.monsterDatas[i];
        if data and data[1] then
            local role_pos = FightManager:getEnemyPosByFormaitionIndex(formation[i] or i);
            if self.monsterList[i].monster_id ~= data[1] then
                if self.monsterList[i].armature~= nil then
                    self.monsterList[i].armature:removeFromParent()
					DragonBonesManager:RemoveDisplay(self.monsterList[i].armature_id)
                    self.monsterList[i].armature = nil;
                    self.monsterList[i].monster_id = -1;
                    self.monsterList[i].monster_lv = -1;
                end
    

                -- local posData = self.monsterCoordination[i];
                local monsterData = ResTable:getRowData('monster', data[1]);
                local modelPath = monsterData['model'];
                local armature, id = DragonBonesManager:GetArmature(modelPath);
                if armature then 
                    armature:getAnimation():play('idle');
                    armature:setScale(0.4);
                    armature:addTo(self.monsterList[i].roleNode);
                    armature:getArmature():setFlipX(true);
                    armature:setLocalZOrder(-1);
                    self.monsterList[i].armature = armature;
                    self.monsterList[i].armature_id = id;
                    self.monsterList[i].monster_id = data[1];
                    self.monsterList[i].monster_lv = data[2];
    
                    self.monsterList[i].bloodVolume:setPercent(100);
                    self.monsterList[i].bloodVolume:setDefType(monsterData.def_type);

                    local monsterLv = ResTable:getValue('monster_attribute',data[2],'lv')
                    self.monsterList[i].bloodVolume:setLevel(monsterLv );

                    self.monsterList[i].roleNode:setPosition(cc.p(role_pos.x,role_pos.y));
                    self.monsterList[i].roleNode:setVisible(true);
                    self.monsterList[i].roleNode:setLocalZOrder(role_pos.z)
                end
            else
                if self.monsterList[i].monster_lv ~= data[2] then
                    local monsterLv = ResTable:getValue('monster_attribute',data[2],'lv')
                    self.monsterList[i].bloodVolume:setLevel(monsterLv );
                    self.monsterList[i].monster_lv = data[2];
                end
                self.monsterList[i].roleNode:setPosition(cc.p(role_pos.x,role_pos.y));
                self.monsterList[i].roleNode:setLocalZOrder(role_pos.z)
            end

        else
            if self.monsterList[i].armature~= nil then
                self.monsterList[i].armature:removeFromParent()
				DragonBonesManager:RemoveDisplay(self.monsterList[i].armature_id)
                self.monsterList[i].armature = nil;
                self.monsterList[i].monster_id = -1;
                self.monsterList[i].monster_lv = -1;
            end
            self.monsterList[i].roleNode:setVisible(false);

		end
	end
end

function TrialPanel:showTrialPointInfo(  )
    if self.selectedId == nil  then
        self.pointRewardComplete:setVisible(true)
        self.pointRewardUnComplete:setVisible(false)
        return 
    end
    local data = model.TrialModel:getItemDataById(self.selectedId, self.trialType);
    if data == nil then
        self.pointRewardComplete:setVisible(true)
        self.pointRewardUnComplete:setVisible(false)
        return 
    end

    self.pointRewardComplete:setVisible(false)
    self.pointRewardUnComplete:setVisible(true)
    --关卡奖励
	local complete_reward_list = data.first_drop or {};
    local count2 = 1;
    for itemID , item in pairs(complete_reward_list) do
        if count2 > 2 then
            break;
        end
        self.pointReward[count2]:Init(tonumber(item[1]) , tonumber(item[2]));
        count2 = count2 +1
    end
    if count2 ~= 2 then
        for i=count2,2 do
            self.pointReward[i]:setVisible(false)
        end
    end
    self.pointTitle:setString(string.format( LANG.UI_TRIAL_17,data.no ))

    self.fightBtn:setTouchEnabled(true);
end

function TrialPanel:showTrialList(  )
    local trialId = model.TrialModel:getFinshTrialId(self.trialType);
    self.selectedId = nil 

    local tempTrialId = trialId;
    for i=1,3  do
        tempTrialId = trialId + i - 1
        local itemData = model.TrialModel:getItemDataById(tempTrialId, self.trialType);
        if itemData == nil then
            if i ~= 2 then
                self.trialItem[i].node:setVisible(false);
            else
                self.trialItem[i].complete:setVisible(true);
            end
        else
            if i == 2 then
                self.selectedId = tempTrialId

            end
            self.trialItem[i].node:setVisible(true);
            self.trialItem[i].title:setString(string.format( LANG.UI_TRIAL_17,itemData.no ))
            self.trialItem[i].power:setString(itemData.fp)
        end
        -- 
    end
    
    self.curItemPowerLabel:setString(ConvertStrToDigitUnit(model.TeamModel:getCurrentTeamFp(self.curTeamType)));

    self:showTrialPointInfo()
    self:showTeamNode();
    self:showMonsterNode();
end


function TrialPanel:retFightOverAuto( msg )
    --扫荡结果更新UI
	UIManager:push('RewardPanel', msg);
end

function TrialPanel:updateRewardTips()
    local state = model.TrialModel:getActiveState();
    tools.RedDotTools:setRedDotToNode(self.rewardBtn,state,nil,cc.p(10,65));
end

function TrialPanel:updateTeamBtnRedDot()
    local show = model.TeamModel:checkTeamFormationRedDotState();
	tools.RedDotTools:setRedDotToNode(self.teamBtn,show,nil,cc.p(36,44))
end

function TrialPanel:onRewardPanel(  )
    UIManager:push('RoundTargetRewardPanel',Enum:getTable("RoundTargetRewardType").TRIAL)
end

function TrialPanel:onTeam(  )
    AudioManager:playEffect(Conf.buttonClick);
    UIManager:push('TeamPanel',self.curTeamType)
end

function TrialPanel:onFight( )
    AudioManager:playEffect(Conf.confirmButton);
    if self.haveTeam == false then
        Prompt:Show(LANG.UI_TRIAL_24);
        return;
    end
    if model.TrialModel:getLimitFightNum(self.trialType) == 0 then
        Prompt:Show(LANG.UI_TRIAL_26);
        return;
    end
    local trial_id = model.TrialModel:getCurrentTrialId(self.trialType)
    -- print("==========trial_id ===== "..tostring(trial_id).."=============self.selected === "..tostring(self.selectedId))
    if self.selectedId == trial_id then
        model.TrialModel:reqTrialFight(self.trialType);
    end
end


function TrialPanel:onClickBack( ... )
	UIManager:pop('TrialPanel');
end

function TrialPanel:onEnter(trialType)
    self.trialType = trialType or 1;

    local data = ResTable:getRowData('trial_type', self.trialType);
    self.trialName:setString(data.name)
    if self.trialType~=1 then
        self.trialIcon:setTexture('image/commonImg/'..data.color_icon..'.png')
        self.trialIcon:setVisible(true)
        self.trialIcon:setPosition(-20-self.trialName:getContentSize().width/2, 151)
        self.rewardBtn:setVisible(false)
        self.curTeamType = data.team_type
    else
        self.trialIcon:setVisible(false)
        self.rewardBtn:setVisible(true)

        self.curTeamType = TeamType.COMMON;
    end

    self:onShow();
    EventManager:FireEvent(EventType.UIFooterUpdateSelect,5);

end

function TrialPanel:onShow()
    self:showTrialList()
    self:updateRewardTips();
    self:updateTeamBtnRedDot();
    self.root:setVisible(true)
end

function TrialPanel:onLeave( ... )
    self.root:setVisible(false);
    self:clearData();
end

function TrialPanel:clearData(  )
    self.selectedId = nil;
end

function TrialPanel:getGuidePosition( guideNo )
	local pos = cc.p(0,0);
	if guideNo == 69 then
		local btn = self.fightBtn;
		pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
    elseif guideNo == 89 then
        local btn = self.teamBtn;
        pos = btn:getParent():convertToWorldSpace(cc.p(btn:getPosition()));
	end
	return pos;
end

return TrialPanel
