local WaitingPanel = class("WaitingPanel")

function WaitingPanel:ctor()
	self:clearAll();
end
function WaitingPanel:clearAll(  )
	self.root = nil;
	self.scene = nil;
	self.hasInit = false;
	self.showCount = 0
	self.time = 0
	self.showAni = false
end
--初始化面板
function WaitingPanel:Init(root, scene)
	self.root = root;
	self.scene = scene;
	self.hasInit = true ;
	self:initPanel();
	self.root:setVisible(false);
end
function WaitingPanel:initPanel()
	local bg = ccui.Layout:create();
	bg:setTouchEnabled(true);
	bg:setContentSize(StageSize);
	bg:setLocalZOrder(-10);
	bg:setAnchorPoint(cc.p(0.5,0.5));
	bg:setPosition(0, 0);
	bg:addTo(self.root);

	self.waitNode = cc.Node:create();
	self.waitNode:addTo(self.root);
	
	self.blackBg = cc.LayerColor:create(cc.c4b(0, 0, 0, 210), StageSize.width, StageSize.height);
    self.blackBg:setLocalZOrder(-100);
	self.blackBg:setPosition(-StageSize.width/2, -StageSize.height/2);
    self.blackBg:addTo(self.waitNode);

	self.imgList = {};
	for i = 1 , 4 do
		self.imgList[i] = cc.Sprite:create('image/loading/c'..i..'.png');
		--self.imgList[i]:setPosition(0 , 0);
		self.imgList[i]:addTo(self.waitNode);
	end

	TimeManager:registUpdateEvent('WaitingPanel',handler(self,self.timeOut),true);
end

function WaitingPanel:timeOut()
	if self.hasInit ~= true then
		return;
	end
	if self.waitNode:isVisible()==false then
		return;
	end
	self.time = self.time + 1
	if self.time > 5 then
		Prompt:Show(LANG.NETWORK_1);-- 连接超时
		self:Hide()
	end
end
function WaitingPanel:Show()
	if self.hasInit ~= true then
		print('error : WaitingPanel  hasInit == false ')
		return;
	end
	self.showCount = self.showCount + 1
	if self.showCount > 1  then
		return
	end
	self.time = 0
	self.waitNode:setVisible(false);
	self.root:runAction(cc.Sequence:create(cc.DelayTime:create(1) , cc.CallFunc:create(function() 
		if self.showAni then
			return
		end
		self.waitNode:setVisible(true);
		self.imgList[2]:runAction(cc.RepeatForever:create(cc.RotateBy:create(2,-360)));
		self.imgList[3]:runAction(cc.RepeatForever:create(cc.RotateBy:create(2,360)));
		self.imgList[4]:runAction(cc.RepeatForever:create(cc.RotateBy:create(1,360)));
	end)))
	
	self.root:setVisible(true);
end

function WaitingPanel:HideAni()
	self.showAni = true
	self.waitNode:setVisible(false);
end

function WaitingPanel:Hide()
	if self.hasInit ~= true then
		return;
	end
	self.showCount = self.showCount - 1
	if self.showCount > 0  then
		return
	end
	if self.root:isVisible() == false then
		return
	end
	self.waitNode:setVisible(false);
	self.root:setVisible(false);
	self.root:stopAllActions();
	self.imgList[2]:stopAllActions();
	self.imgList[3]:stopAllActions();
	self.imgList[4]:stopAllActions();
	self.imgList[2]:setRotation(0);
	self.imgList[3]:setRotation(0);
	self.imgList[4]:setRotation(0);
	self.showAni = false
end
return WaitingPanel;
