local ZfUpPanel = class('ZfUpPanel', require('app.layer.BaseLayer'))
local fonts = Enum:getTable('SystemFont');

function ZfUpPanel:ctor(scene, sceneName)
	self.super.ctor(self, scene, sceneName, 'ZfUpPanel');

	self.scene = scene;
	self.useCCreator = false;
	self.isPopup = true;
end

function ZfUpPanel:Init(root)
	self.root = root;
	self.root:setVisible(false)

	self:InitPanel()
end

function ZfUpPanel:InitPanel()

	local bg = ccui.ImageView:create('image/commonImg/common_tips_bg.png')
	:addTo(self.root)
	:setScale9Enabled(true)
	:setContentSize(cc.size(604, 560))
	:setTouchEnabled(true);

	GlobalFunctions:createTitleNode( bg, LANG.UI_BARE_ZF_1, '',  bg:getContentSize().width/2, bg:getContentSize().height -50 );

	local mbg = cc.Sprite:create('image/bareCollect/zf_bg.png')
	mbg:setPosition(0, 50)
	mbg:addTo(self.root)

	local spine_res = 'jiushizhufu_spine';
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(self.root)
		spine:setPosition(0, 50)
		spine:setAnimation(0, "bg", true)
		-- self.dbTimeSp = spine

		local spine1 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine1:addTo(self.root)
		spine1:setPosition(90, 90)
		spine1:setAnimation(0, "level", true)
	end

	local infoNode = cc.Node:create()
	infoNode:addTo(self.root)
	infoNode:setPosition(50, 0)

	self.tlabel = cc.Label:createWithTTF(LANG.UI_BARE_ZF_2 ,  fonts.FONT_SIYUAN , 25)
    self.tlabel:enableOutline(cc.c3b(20 , 35 , 90 ),2);
    self.tlabel:addTo(infoNode)
    self.tlabel:setPosition(0, 110)
    self.tlabel:setAnchorPoint(cc.p(0,0.5));

    local hpBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
    hpBg:addTo(infoNode)
    hpBg:setPosition(90, 50)
    local hpTLabel = cc.Label:createWithTTF(LANG.UI_BARE_ZF_3, fonts.FONT_SIYUAN, 20)
		:addTo(infoNode)
		:setPosition(0, 50)
		:setAnchorPoint(cc.p(0,0.5))
		:setTextColor(cc.c3b(90 , 255 , 120))
    self.hpLabel = cc.Label:createWithTTF('+0', fonts.FONT_SIYUAN, 18)
		:addTo(infoNode)
		:setPosition(180, 50)
		:setAnchorPoint(cc.p(1,0.5))
		:setTextColor(cc.c3b(90 , 255 , 120))

	local atkBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
    atkBg:addTo(infoNode)
    atkBg:setPosition(90, -10)
    local atkTLabel = cc.Label:createWithTTF(LANG.UI_BARE_ZF_4, fonts.FONT_SIYUAN, 20)
		:addTo(infoNode)
		:setPosition(0, -10)
		:setAnchorPoint(cc.p(0,0.5))
		:setTextColor(cc.c3b(255 , 75 , 75))
    self.atkLabel = cc.Label:createWithTTF('+0', fonts.FONT_SIYUAN, 18)
		:addTo(infoNode)
		:setPosition(180, -10)
		:setAnchorPoint(cc.p(1,0.5))
		:setTextColor(cc.c3b(255 , 75 , 75))

	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(infoNode)
		spine:setPosition(90, 50)
		self.l1Spine = spine;

		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(infoNode)
		spine:setPosition(90, -10)
		self.l2Spine = spine;
	end

	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(self.root)
		spine:setPosition(-140, 50)
		self.starSpine = spine;

		self.starSpine:registerSpineEventHandler(function (event)
            if event.animation == 'star1_appear' then
                self.starSpine:setAnimation(0, "star1_idle", true)
            elseif event.animation == 'star2_appear' then
                self.starSpine:setAnimation(0, "star2_idle", true)
            elseif event.animation == 'star3_appear' then
                self.starSpine:setAnimation(0, "star3_idle", true)
            elseif event.animation == 'star4_appear' then
                self.starSpine:setAnimation(0, "star4_idle", true)
            elseif event.animation == 'star5_appear' then
                self.starSpine:setAnimation(0, "star5_idle", true)
            elseif event.animation == 'dissappear' then
                self.starSpine:setAnimation(0, "star1_appear", false)
            end 
        end, sp.EventType.ANIMATION_COMPLETE)
        self.starSpine:registerSpineEventHandler(function (event)
			if event.eventData.name == 'change' then
				self:playAllSpine();
			end
		end, sp.EventType.ANIMATION_EVENT);
	end


	-- self.midText = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
	-- self.midText:addTo(self.root);
	-- self.midText:setPosition(0,70);
	-- self.midText:setMaxLineWidth(450);
	-- self.midText:setTextColor(cc.c3b(165, 200, 255));
	-- self.midText:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)


	local barNode = cc.Node:create()
	barNode:addTo(self.root)
	barNode:setPosition(0, -115)
	self.barNode = barNode;

	local barBg = cc.Scale9Sprite:create('image/chouka/main/bar_bg.png')
	barBg:addTo(barNode);
	barBg:setContentSize(cc.size(550, 16))
	barBg:setPosition(0, 0)

	local clipNode = cc.ClippingRectangleNode:create( cc.rect(-275,-10,550,20) )
    clipNode:addTo(barNode)
    clipNode:setPosition(0, 0)
    -- clipNode:setClippingRegion( cc.rect(-275,-10,550,20) )
    self.barClipNode = clipNode;

	self.barSpr = cc.Scale9Sprite:create('image/chouka/main/bar.png');
	self.barSpr:setContentSize(cc.size(544, 12))
	self.barSpr:addTo(clipNode);
	self.barSpr:setColor(cc.c3b(255,255,0))

	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(clipNode)
		spine:setPosition(0, 0)
		spine:setAnimation(0, "loading", true)

		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(barNode)
		spine:setPosition(0, 0)
		self.barSp = spine;
	end

	local barIcon = cc.Sprite:create('image/icon/I14005.png')
	barIcon:addTo(barNode)
	barIcon:setPosition(-55, -10)
	barIcon:setScale(0.5)

	self.barLabel = cc.Label:createWithTTF('0/1', fonts.FONT_SIYUAN, 20)
		:addTo(barNode)
		:setPosition(5, -10)
		:setAnchorPoint(cc.p(0.5,0.5))
		:enableOutline(cc.c3b(60 , 60 , 60) , 2)

	

	self.okBtn = ccui.Button:create('res/image/commonImg/btn_1_219_55.png' , 'res/image/commonImg/btn_1_219_55.png');
	self.okBtn:addTo(self.root);
	self.okBtn:addClickEventListener(handler(self, self.OkClick));
	self.okBtn:setPosition(0, -180);
	local okLabel = cc.Label:createWithTTF(LANG.UI_HOME_41 , fonts.FONT_SIYUAN , 20);
	okLabel:enableOutline(cc.c3b(55 , 85 , 155) , 2);
	self.okBtn:setTitleLabel(okLabel);


	local itemNode = cc.Node:create();
	itemNode:addTo(self.root)
	itemNode:setPosition(0, -240);
	local itemBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
	itemBg:addTo(itemNode)
	local itemIcon = cc.Sprite:create('image/icon/I14005.png')
	itemIcon:addTo(itemNode)
	itemIcon:setPosition(-80, 0)
	itemIcon:setScale(0.5)
	local itemL = cc.Label:createWithTTF(LANG.UI_HOME_37, fonts.FONT_SIYUAN, 20)
		:addTo(itemNode)
		:setPosition(-50, 0)
		:setAnchorPoint(cc.p(0,0.5))
		:enableOutline(cc.c3b(60 , 60 , 60) , 2)
	self.itemLabel = cc.Label:createWithTTF('0', fonts.FONT_SIYUAN, 20)
		:addTo(itemNode)
		:setPosition(80, 0)
		:setAnchorPoint(cc.p(1,0.5))
		:enableOutline(cc.c3b(60 , 60 , 60) , 2)

	EventManager:RegisterEvent('ZfUpPanel:updateInfo', handler(self, self.updateInfo));

end

function ZfUpPanel:onEnter()
	self.toPosW = 0;
	self.curPosW = 0;
	self.aniFrameNum = 0;
	self:addSwallowCallback(handler(self, self.onClickBack));
	self.root:setVisible(true)

	self:updateInfo(false);
	TimeManager:registUpdateEvent('ZfUpPanel',handler(self,self.onEnterFrame),false);
end

function ZfUpPanel:onLeave()
	self.root:setVisible(false)
	TimeManager:registUpdateEvent('ZfUpPanel',nil,false);
end

function ZfUpPanel:onClickBack()
	UIManager:pop('ZfUpPanel');
end

function ZfUpPanel:updateInfo(bUp)

	local blessInfo = model.BareCollectModel:getBlessInfo()
	
	local blessId = blessInfo.no;
	local costNum = blessInfo.cost;
	local curBlessInfo = nil;

	local needCostNum = 0;
	local haveCostNum = 0;

	if blessId>0 then
		curBlessInfo = ResTable:getRowData('bless_lv', blessId)
	end
	local nextBlessInfo = ResTable:getRowData('bless_lv', blessId+1)

	self.tlabel:setString(string.format(LANG.UI_COMMENT_4,blessId))
	if nextBlessInfo==nil then --maxLv
		self.barNode:setVisible(false)
	else
		self.barNode:setVisible(true)
		if curBlessInfo then
			needCostNum = nextBlessInfo.cost - curBlessInfo.cost;
			haveCostNum = costNum - curBlessInfo.cost;
			self.hpLabel:setString('+'..curBlessInfo.hp)
			self.atkLabel:setString('+'..curBlessInfo.atk)
		else --Lv.0
			needCostNum = nextBlessInfo.cost;
			haveCostNum = costNum;
			self.hpLabel:setString('+0')
			self.atkLabel:setString('+0')
		end
		self.barLabel:setString(haveCostNum..'/'..needCostNum)

		-- self.barClipNode:setClippingRegion( cc.rect(-275,-10,550*(haveCostNum/needCostNum),20) )
		if bUp then
			self.toPosW = 550*(haveCostNum/needCostNum);
			if self.toPosW == 0 then
				self.toPosW = 1
			end
			self.aniFrameNum = 0;
		else
			self.curPosW = 550*(haveCostNum/needCostNum);
			self.toPosW = self.curPosW;
			self.barClipNode:setClippingRegion( cc.rect(-275,-10,550*(haveCostNum/needCostNum),20) )
		end
	end

	if bUp then
		if blessId>0 and self.blessId ~= blessId then
			local aniIdx = blessId%5 == 0 and 5 or blessId%5
			if aniIdx > 1 then
				self.starSpine:setAnimation(0, 'star'..aniIdx..'_appear', false)
			else
				if blessId > 1 then
					self.starSpine:setAnimation(0, "dissappear", false)
				else
					self.starSpine:setAnimation(0, 'star'..aniIdx..'_appear', false)
				end
			end
		end
	else
		if blessId>0 then
			local aniIdx = blessId%5 == 0 and 5 or blessId%5
			self.starSpine:setAnimation(0, 'star'..aniIdx..'_idle', true)
		else
			self.starSpine:setAnimation(0, 'star0_idle', true)
		end
	end
	self.blessId = blessId;


	local num = model.ItemModel:getItemNum(14005);
	self.itemLabel:setString(num);
end

function ZfUpPanel:OkClick()
	AudioManager:playEffect(Conf.confirmButton)

	local num = model.ItemModel:getItemNum(14005);
	if num <= 0 then
		Prompt:Show(LANG.ERROR_INFO[9063]);
		return
	end

	local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_bare_bless_up, msg);
	
end

function ZfUpPanel:playAllSpine()
	self.l1Spine:setAnimation(0, "number", false)
	self.l2Spine:setAnimation(0, "number", false)

	local blessInfo = model.BareCollectModel:getBlessInfo()
	model.TeamModel:checkTeamFpUp(blessInfo.oldFp);
end

function ZfUpPanel:onEnterFrame()
	if self.toPosW ~= self.curPosW then
		self.curPosW = self.curPosW + 10;
		if math.abs(self.curPosW-self.toPosW) <= 11 and self.aniFrameNum>3 then
			self.curPosW = self.toPosW
			if self.toPosW == 1 then
				self.toPosW = 0
				self.curPosW = 0
			end
		end
		self.barClipNode:setClippingRegion( cc.rect(-275,-10,self.curPosW,20) )
		if self.curPosW >= 550 and self.toPosW~=550 then
			self.curPosW = 0
			self.barSp:setAnimation(0, "loadshine", false)
		end
		self.aniFrameNum = self.aniFrameNum + 1;
	end
end

return ZfUpPanel
