local UIManager = class("UIManager")

local makedList = {
	TeamPanel = true,
	OfflineRewardPanel = true,
	FightPanel = true,
	PreparePanel = true,
};

local MainPanels = {
	MainPanel		= true,
	CardListPanel	= true,
	FightPanel		= true,
	GuildPanel		= false,
	BelleBallMainPanel		= true,
	HomeBasePanel	= true,
}

function UIManager:ctor()
	if IsKr then
		MainPanels['GuildPanel'] = true;
	end
	self.layerList = {
		ActivityPanel = 5,
		ActivityRechargePanel = 5,
		ArenaPanel = 3,
		ArenaRankListInfoPanel = 5,
		ArenaRankListPanel = 4,
		ArenaRewardPanel = 4,

		ArenaMultPanel = 3,
		ArenaMultFightPanel = 4,
		ArenaMultTeamPanel = 5,
		ArenaMultListPanel = 5,
		ArenaMultRewardPanel = 6,
		ArenaMultRwdListPanel = 7,
		ArenaMultFightResult = 19,
		ArenaMultHistoryPanel = 18,

		BattlePassGiftPanel = 4,
		BattlepassEventPanel = 3,
		BattlePassRewardPanel = 3,
		BareCollectPanel = 5,
		BareCollectViewPanel = 6,
		BareCollectActiveTipPanel = 6,
		BareCollectSelectPanel = 5,
		BgSelectPanel = 13,
		ZfUpPanel = 17,

		CardAvatarUsePanel = 12,
		CardBookPanel = 6,
		CardBookViewPanel = 7,
		CardBreakOpenSkillPanel = 15,
		--CardBreakSuccessPanel = 14,
		CardComposePanel = 2,
		CardCvPanel = 3,
		CardLevelUpStarCardListPanel = 4,
		CardLevelUpStarComplatePanel = 15,
		CardLevelUpStarPanel = 5,
		CardLevelUpStarSelectCardPanel = 6,
		CardLevelUpStarSuccessPanel = 14,
		CardListPanel = 1,
		CardLivePanel = 3,
		TeamListPanel = 3,
		CardLoveActiveTipPanel = 5,
		CardLoveListPanel = 3,
		CardLoveLivePanel = 5,
		CardLovePanel = 4,
		CardPanel = 2,			-- 卡牌界面
		CardResolvePanel = 2,
		CardResolveRewardPanel = 3,
		ChatPanel = 15,
		CommonInfoPanel = 100,
		CardCommentPanel = 5,

		DailyRoundPanel = 3,

		FutureCardPanel = 3,

		EquipComposePanel = 4,
		EquipOneKeyComposePanel = 5,
		EquipPanel = 2,
		EquipWearPanel = 4,
		EquipWearBareLoveSelectPanel = 5,
		EquipWearSelectPanel = 5,
		EventBuffPanel = 10,
		EventBuffSelectPanel = 6,
		EventMainPanel = 3,
		EventMapPanel = 5,
		EventRoleStatePanel = 6,
		EventShopPanel = 4,

		FastFightRewardPanel = 10, --快速战斗界面
		--FightFooterPanel = 5,	-- 战斗底部界面
		FightIncomePanel = 10,
		FightMapPanel = 1,
		FightItemPanel = 10,
		FightOverPanel = 15,
		FightPanel = 4,			-- 战斗界面 
		FightRoundBreakPanel = 10,
		FightScenePanel = 2,
		FooterPanel = 13,
		FpUpPanel = 22,

		GachaListPanel	= 2,	-- 抽卡列表
		GachaProbabilityPanel = 4,
		ItemProbabilityPanel = 18,
		GachaResultPanel = 4,
		GuildeNoticePanel = 8,
		GuidePanel	= 9999,		-- 新手引导
		GuildBossBonusListPanel = 8,
		GuildBossPanel	= 7,
		GuildChatPanel = 8,
		GuildCreatePanel = 7,
		GuildDonatePanel = 7,
		GuildIconSelectPanel = 8,
		GuildSearchPanel = 7,
		GuildMainPanel = 7.5,
		GuildMemberPanel= 8,
		GuildMemberDetailPanel = 9,
		GuildNotJoinPanel = 6,
		GuildPanel = 5,			-- 公会界面
		GuildRaidRankPanel = 8,
		GuildRaidRankRewardPanel = 9,

		RankListPanel = 3,
	
		HarvestPanel = 6,		-- 欢乐时光界面 
		HeaderPanel = 11,		
		--HeaderMainPanel = 11,
		HeadSelectPanel = 13,
		HelpPanel = 15,
		HomeBasePanel = 2,
		HomeBaseSkillPanel = 2,
		AnnouncePanel = 15,

		KanBanSelectPanel = 13,

		LevelUpPanel = 21,
		LoadingPanel = 32,
		Login7RewardPanel = 5,
		Login7CtnRwdPanel = 6,
		LoginConRewardPanel = 5,

		MainPanel = 1,			-- 主界面
		MailPanel = 12,
		MissionPanel = 3,

		OnlineRewardPanel = 13;

		-- PaymentHelperPanel = 15, -- 支付处理页面
		PlotPanel = 4,			-- 剧情界面
		PreparePanel = 31,
		Prompt = 20,			-- 提示信息界面

		RandomShopPanel = 10;
		RewardPanel = 50, 
		RoleShowPanel = 100,
		RoundBossPanel = 15,
		RoundInfoPanel = 16,
		EventRoundInfoPanel = 16,
		NewRoundInfoPanel = 16,
		RoundTargetRewardPanel = 13,

		ReconnectionPanel = 90,

		ScreenEffectPanel = 30,
		SettingAudioPanel = 12,
		SettingPanel = 12,
		StarAndBreakComplatePanel = 14,
		FutureCardSelPanel = 12,
		FutureCardTakeOffPanel = 12,
		EventShopOncePanel = 12,
		EventNpcSelPanel = 12,
		EventItemPanel = 12,
		EventItemUsePanel = 12,
		EventMsgTipPanel = 12,
		EventResultPanel = 12,
		EventBattlePassPanel = 5,
		EventBattlePassGiftPanel = 6,
		-- AccountBindPanel = 12,
		SettingCDKPanel = 12,
		ShopPanel = 10,			-- 商店界面
		ShopAvatarInfoPanel = 11,
		SkillBuffPanel = 3,
		StorePanel = 10,
		ShowAnimationPanel = 10,
		SpecialOfferPanel = 16,
		ShopGiftShowPanel = 17,

		TeamFormationPanel = 12,
		TeamPanel = 10,			-- 编队界面
		TeamRestraintPanel = 17,
		ThreeDayActivityPanel = 3,
		TipsEquipPanel = 6,
		TipsOfflineRewardPanel = 17,
		TipsShopPanel = 12,
		ComTipsItemPanel = 12,
		EventTireSelPanel = 12,
		TrialPanel = 5;
		TrialRewardPanel = 6,
		TrialSelPanel = 7,
		CopyRoundPanel = 5,
		BankPanel = 17,
		ComTaskPanel = 17,
		RechargeTaskPanel = 17,

		FightStatisticsPanel = 17,

		GemListPanel = 12,
		GemSkillPanel = 12,
		GemComposePanel = 12,
		GemRecastPanel = 12,
		GemInfoPanel = 12,

		PlayBallPanel = 6,
		BelleBallMainPanel = 5,

		StoryLinePanel = 6,
		StoryPanel = 5,
		StoryRoundPanel = 7,
		StoryCardPanel = 8,
		StoryRwdPanel = 9,
		StoryPlotPanel = 10,
		StorySkillSelPanel = 11,
		StorySkillListPanel = 12,

		ShopGiftRecommendPanel = 40,

		WaitingPanel = 10000,
	};

	self.callOnClickBackHandlerList = {
		CardLevelUpStarSelectCardPanel = 1,
		HeadSelectPanel = 1,
		KanBanSelectPanel = 1,
		BgSelectPanel = 1,
	}

	self.panelList = {};
	self.panelHandlerList = {};
	self.headerList = {}
	self.panelStack = {};

	self.popupList = {}
end

function UIManager:Init()
	self:clearAll();
	self:registEvent();
end

function UIManager:registEvent( regist )
end

function UIManager:clearAll(  )
	self:registEvent(false);
	local panel = table.remove(self.panelStack);
	local count = 1
	while panel and count < 100  do
		-- print('clear panel ===== ',panel,'...len = ',#self.panelStack)
		if self.panelHandlerList[panel] and self.panelHandlerList[panel].hasBase then
			self.panelHandlerList[panel]:onBaseLeave();
		else
			EventManager:FireEvent(EventType.MainSceneLeavePanel, panel);
		end
		panel = table.remove(self.panelStack);
		count = count + 1;
	end

	-- popup
	self:clearPopPanel()
	self.popupList = {}
	self.panelStack = {};

	self.panelHandlerList = {}
end
function UIManager:clearPopPanel( ... )
	local popPanel = nil;
	for i=#self.popupList, 1, -1 do
		popPanel = self.popupList[i].panel
		if popPanel ~= 'HeaderPanel' and popPanel ~= 'FooterPanel' then
			-- print('========= 111 swich popup ==== ',popPanel);
			if popPanel and self.panelHandlerList[popPanel] then
				self:stackout(self.panelHandlerList[popPanel])
			end
		end

	end
end

function UIManager:InitPanelZorder( panel, panelRoot )
	if not self:checkLegal(panel) then
		return;
	end
	panelRoot:setLocalZOrder(self.layerList[panel] * PANEL_ZORDER);
end

function UIManager:AddLayer( panelName, panelHandler)
	print('add layer', panelName)
	self.panelHandlerList[panelName] = panelHandler;
end

function UIManager:getLayer( panelName )
	if self.panelHandlerList[panelName] then
		return self.panelHandlerList[panelName]
	else
		print('no such panel named', panelName)
		return nil
	end
end

-- 未继承BaseLayer 的layer，会调用此方法
function UIManager:InitPanelGlobalFunction( name, panelHandler, scene, layerList )
	if not self:checkLegal(name) then
		return;
	end
	self.panelHandlerList[name] = panelHandler;
	panelHandler.haveInitialize = false;

	local callback = handler(self, self.InitPanelZorder);

	panelHandler.Initialize = function(self, callback2)
		self.haveInitialize = true;
		local root;
		-- local creatorFileName = 'creator/Scene/main_scene.ccreator';
		-- local reader = creator.CreatorReader:createWithFilename(creatorFileName);
		-- --reader:setupSpriteFrames();
		-- reader:setup();

		local loadAnim = false;
		if makedList[name] then
			root = cc.Node:create();
			root:setName(name);
		else
			root = cc.Node:create();
			root:setName(name);
		end
		layerList[name] = root;
		root:addTo(scene);
		self:Init(root, scene);
		callback(name, root);
		scene:addSwallowLayer(root, name);
		self.initializeCallBack = callback2;
	end

	panelHandler.setVisible = function(self, flag)
		if name == 'MainPanel' then
			return;
		end
		if self.root then
			self.root:setVisible(flag);
		end
	end
end

function UIManager:preInit( panel )
	if not self:checkLegal(panel) then
		return;
	end

	if self.panelHandlerList[panel] then
		if not self.panelHandlerList[panel].haveInitialize then
			self.panelHandlerList[panel]:Initialize();
		end
	end
end

function UIManager:InitMainPanels()
	for k, v in pairs(MainPanels) do
		if self.panelHandlerList[k] and not self.panelHandlerList[k].haveInitialize then
			self.panelHandlerList[k]:Initialize();
		end
	end
end

function UIManager:InitMainPanelsByKey( key )
	if self.panelHandlerList[key] and not self.panelHandlerList[key].haveInitialize then
		self.panelHandlerList[key]:Initialize();
	end
end

function UIManager:switch( panel, ...)
	if not self:checkLegal(panel) then
		return;
	end

	if not self.panelHandlerList[panel] then
		return;
	end

	if tools.ConfigStateTools.checkLock and tools.ConfigStateTools:checkLock(panel , ...) then
		Prompt:Show(LANG.COMMON_CLOSE);
		return;
	end

	if tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemNameId')[panel]) then
		Prompt:Show(LANG.COMMON_CLOSE);
		return;
	end

	if not MainPanels[panel] then
		print(panel .. ' is not MainPanel')
		return
	end

	local stackNum = #self.panelStack;
	--local topPanel = self.panelStack[stackNum];
--
	--if (panel == topPanel) or 
	--	(panel == 'GuildPanel' and (topPanel == 'GuildMainPanel' or topPanel == 'GuildNotJoinPanel')) then
	--	return
	--end

	self.panelHandlerList[panel].args = {};

	self:clearPopPanel();
	for i = stackNum , 1 , -1 do
		self:kick(self.panelStack[i]);
	end
	self:catch(panel, ...)
	self.panelStack = {}
	table.insert(self.panelStack, panel)
end

function UIManager:push( panel, ... )
	print('push', panel)
	if not self:checkLegal(panel) then
		return;
	end

	if not self.panelHandlerList[panel] then
		return;
	end

	if RemoveFeatures[panel] then
		Prompt:Show(LANG.COMMON_CLOSE);
		return;
	end

	if tools.ConfigStateTools:checkLock(panel , ...) then
		Prompt:Show(LANG.COMMON_CLOSE);
		return;
	end

	if tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemNameId')[panel]) then
		Prompt:Show(LANG.COMMON_CLOSE);
		return;
	end

	if not self.panelHandlerList[panel] then
		return;
	end
	if MainPanels[panel] then
		return
	end
	if not self.panelHandlerList[panel].haveInitialize then
		self.panelHandlerList[panel]:Initialize();
	end
	
	self.panelHandlerList[panel].args = {};

	if self.panelHandlerList[panel].isPopup then
		self:stackin(self.panelHandlerList[panel], panel, ...);
		return;
	end

	self:clearPopPanel()

	self:kick(self.panelStack[#self.panelStack])

	table.insert(self.panelStack, panel)
	
	self:catch(panel, ...);
end

function UIManager:popTop( ... )
	if #self.panelStack == 1 then
		return
	end

	self:clearPopPanel()

	self:kick(self.panelStack[#self.panelStack], ... )

	table.remove(self.panelStack)
	
	local topPanel = self.panelStack[#self.panelStack];
	if self.panelHandlerList[topPanel].onResume then
		self:resume(topPanel);
	else
		self:catch(topPanel)
	end
end

function UIManager:pop( panel, ... )
	if not self:checkLegal(panel) then
		return;
	end
	if not self.panelHandlerList[panel] then
		return;
	end
	if not self.panelHandlerList[panel].haveInitialize then --未初始化
		return;
	end
	if MainPanels[panel] then
		return
	end
	if self.panelHandlerList[panel].isPopup then
		self:stackout(self.panelHandlerList[panel], panel, ...);
	else
		self:popTop( ... )
	end
end

function UIManager:set( panel, tableList, ... )

	if RemoveFeatures[panel] then
		Prompt:Show(LANG.COMMON_CLOSE);
		return;
	end
	
	if tools.ConfigStateTools:checkLock(panel , ...) then
		Prompt:Show(LANG.COMMON_CLOSE);
		return;
	end

	if not self:checkLegal(panel) then
		return;
	end
	if not self.panelHandlerList[panel] then
		return;
	end
	if MainPanels[panel] then
		return
	end
	if not self.panelHandlerList[panel].haveInitialize then
		self.panelHandlerList[panel]:Initialize();
	end

	self:clearPopPanel()

	self:kick(self.panelStack[#self.panelStack])

	self:catch(panel, ... )

	self.panelStack = tableList
end

function UIManager:checkLegal(panel)
	if type(panel) ~= 'string' then
		print(debug.traceback())
		print(type(panel))
		print('UIManager check error, panel type should be string'); return false;
	end
	if not self.layerList[panel] then
		print(debug.traceback())
		print('No panel named', panel);
		return false;
	end
	return true;
end

function UIManager:updatePanel(panel, ...)
	if not self:checkLegal(panel) then
		return;
	end

	EventManager:FireEvent(EventType.MainSceneEnterPanel, panel, ...);
end

function UIManager:kick( panel, ... )
	if self.panelHandlerList[panel] and self.panelHandlerList[panel].hasBase then
		self.panelHandlerList[panel]:onBaseLeave( ... );
	else
		EventManager:FireEvent(EventType.MainSceneLeavePanel, panel, ...);
	end
end

function UIManager:catch( panel, ... )
	if self.panelHandlerList[panel] and self.panelHandlerList[panel].hasBase then
		self.panelHandlerList[panel]:onBaseEnter( ... );
	else
		EventManager:FireEvent(EventType.MainSceneEnterPanel, panel, ...);
	end
end

function UIManager:resume(panel , ...)
	if self.panelHandlerList[panel] and self.panelHandlerList[panel].hasBase and self.panelHandlerList[panel].onResume then
		self.panelHandlerList[panel]:onBaseResume( ... );
	end
end

function UIManager:recordHeaderEvent(callback , panelName)
	print('record', self.panelList[#self.panelList].panel)
	self.panelList[#self.panelList].headerCallback = callback;
	self.panelList[#self.panelList].panelName = panelName;
end

function UIManager:stackin( handler, panel, ... )
	local panelData = {};
	panelData.panel = panel;
	if panel ~= 'ScreenEffectPanel' then
		table.insert(self.popupList, panelData);
	end
	if handler.hasBase then
		handler:onBaseEnter( ... );
	else
		handler:onEnter( ... );
	end
end

function UIManager:stackout( handler, panel, ... )
	for k,v in pairs(self.popupList) do
		if v.panel == panel then
			table.remove(self.popupList,k);
			break;
		end
	end

	if handler.hasBase then
		handler:onBaseLeave( ... );
	else
		handler:onLeave( ... );
	end
end

function UIManager:panelIsVisible(panel)
	local isVisible = false;
	if self.panelHandlerList[panel] and self.panelHandlerList[panel].haveInitialize then
		isVisible = self.panelHandlerList[panel].root:isVisible();
	end
	return isVisible;
end

function UIManager:getPanelHandler(panel)
	return self.panelHandlerList[panel];
end

function UIManager:getPanelLocalZOrder(name)
	return self.layerList[name]
end

function UIManager:getTopPanelName()
	return self.panelStack[#self.panelStack]
end

function UIManager:isCallOnClickBack(name)
	return self.callOnClickBackHandlerList[name];
end

function UIManager:keyboardBack()
	local isClose = MessageBox:closeBox()
	if isClose then
		return true; 
	end
	local popListNum = #self.popupList;
	if popListNum > 0 then
		local panelData = self.popupList[popListNum];
		if panelData and panelData.panel ~= 'FooterPanel' and panelData.panel ~= 'HeaderPanel' then
			print('back------popupList--------->',panelData.panel);
			local handler = self.panelHandlerList[panelData.panel];
			if panelData.panel == 'FightScenePanel' then
				if FightManager:getIsNotFight() then
					return false
				end
			elseif handler and handler.onClickBack then
				handler:onClickBack();
			end
			return true
		end
	end

	local panelNum = #self.panelStack;
	if panelNum > 1 then
		local panel = self.panelStack[panelNum];
		local handler = self.panelHandlerList[panel];
		print('back------panelStack--------->',panel);
		if panel == 'GuildMainPanel' or panel == 'GuildNotJoinPanel' then 
			return false;
		end
		if handler and handler.onClickBack then
			handler:onClickBack();
		end
		return true;
	end

	return false;
end

cc.exports.UIManager = UIManager:create();
