local ActivityModel = class("ActivityModel")
ActivityModel.ActivityMenuIndex = Enum:getTable('ActivityIndex')
function ActivityModel:ctor()

    self:clearAll()
   
end

function ActivityModel:clearAll(  )
    self.HasInit = {}

    self.sign = nil;            -- 签到
    self.levelGift = nil;       -- 等级礼包
    self.fpGift = nil;          -- 战力礼包
    self.sevenSign = nil        -- 七日登录
    self.continueRwd = nil      -- 连续登录奖励
    self.threeDay = {};
    -- self.recharge = nil;        -- 充值奖励<首充，百元奖励>

    self.loginConInfo = nil; --累计登录信息
    self.loginConList = nil; --累计登录奖励列表信息
end

function ActivityModel:upDateRedDotState(state)
    if not state then
        return
    end

    if state.signRedDot then
        if not self:hasInitIndex(ActivityModel.ActivityMenuIndex.SIGN) then
            self.sign = {};
            self.sign.redDotState = state.signRedDot == 1;
        end
    end

    if state.levelGiftRedDot then
        if not self:hasInitIndex(ActivityModel.ActivityMenuIndex.LEVEL_GIFT) then
            self.levelGift = {};
            self.levelGift.redDotState = state.levelGiftRedDot == 1;
        end
    end

    if state.fpGiftRedDot then
        if not self:hasInitIndex(ActivityModel.ActivityMenuIndex.FP_GIFT) then
            self.fpGift = {};
            self.fpGift.redDotState = state.fpGiftRedDot == 1;
        end
    end

    if state.sevenRedDot then
        if not self:hasInitIndex(ActivityModel.ActivityMenuIndex.SEVEN_DAY) then
            self.sevenSign = {};
            self.sevenSign.redDotState = state.sevenRedDot == 1;
        end
    end

    if state.threeDayRedDot then
        if not self:hasInitIndex(ActivityModel.ActivityMenuIndex.SEVEN_DAY) then
            self.sevenSign = {};
            self.sevenSign.data = {};
            self.sevenSign.data[2] = state.threeDayRedDot.three_seven_data;
            
            self.sevenSign.state = state.threeDayRedDot.seven_state;
            --self.threeDay = state.threeDayRedDot.three_day;
            self:updateRedDotStateSevenSign();
        end
    end
end

function ActivityModel:Init(activity)
    if activity.three_day then
        self.threeDay = {};
        for _k , no in pairs(activity.three_day) do
            self.threeDay[no] = 1;
        end
    end

    if activity.seven_state then
        self.sevenSign = {};
        self.sevenSign.state = activity.seven_state;
        self:updateRedDotStateSevenSign();
    end
end

function ActivityModel:hasInitIndex( index )
    return self.HasInit[index]
end

function ActivityModel:resetInit()
    self.HasInit = {};
end
--- ------------------------------req and ret--------------------------------------------------
function ActivityModel:reqActivityAllData()
   self:reqActivityByIndex(0)
end
-- index = 0  获取所有 否则 获取单个信息
function ActivityModel:reqActivityByIndex( index )
	local msg = {};
	msg.index = index;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_activity_all_info_4700 , msg);
end

function ActivityModel:retActivityData(msg)
	if not msg then
		return;
    end
    if msg.sign then
        self:retActivitySign(msg.sign); -- msg.sign
    end

    if msg.level_event then
        self:retActivityLevelGift(msg.level_event)
    end
    if msg.fp_event then
        self:retActivityFpGift(msg.fp_event)
    end

    if msg.continuous_list then
        self.continueRwd = msg.continuous_list;
    end

    if msg.seven_list then
        self:retActivitySevenSign(msg.seven_list);
    end
end
function ActivityModel:retActivitySign( msg )

    if msg == nil or msg.month == nil  then
        return
    end
    -- dump(msg,'ActivitySign === ');
    -- print('sign_month == ',msg.sign_month)

    self.HasInit[ActivityModel.ActivityMenuIndex.SIGN] = true;

    self.sign = {}
    self.sign.signRepaired = msg.repaired_sign
    self.sign.signMonth = tonumber(msg.month);
    self.sign.signDay = tonumber(msg.day);
    local signedArr = msg.sign[tostring(msg.month)]
    self.sign.signState = GlobalFunctions:sortTableByKey(signedArr) -- 转有序数组 ( 0 未到时间，1 未签到 2 已签到)


    local currentSignData = {};
    local signData = ResTable:getTable('loginmaster').contain
    for k,signData in pairs(signData) do
        if signData.month == tonumber(msg.month) then
            currentSignData[tostring(signData.login)] = signData.reward
        end
    end
    self.sign.signData = GlobalFunctions:sortTableByKey(currentSignData)

    local today = 1;
    for i=1,#self.sign.signState do
        if self.sign.signState[i] == 0 or self.sign.signState[i] == 3 then
            break
        end
        today = i;
    end
    self.sign.signToday = today;    
    self.sign.redDotState = false;

    self.sign.repairedDay = -1;
    self:updateSignRepairedDay()
    self:updateRedDotStateSign()
    tools.RedDotTools:pushMainPanelRedDot(2);
end

function ActivityModel:retActivityLevelGift( msg )
    if msg == nil then
        return 
    end
    -- print('levelGift == ',msg.level_gift_activity_list)
    self.HasInit[ActivityModel.ActivityMenuIndex.LEVEL_GIFT] = true;

    self.levelGift = {}
    self.levelGift.state =  msg.level_gift_state;
    self.levelGift.data = GlobalFunctions:sortTableByKey(msg.level_gift_activity_list);
    self.levelGift.redDotState = false;
    self:updateRedDotStateLevelGift()
    tools.RedDotTools:pushMainPanelRedDot(2);
end
--[[
    fp_gift_state = {
        'id1':1,...
    }
    fp_gift_activity_list = {
        {
            id,operate_id,type,value，reward_item
        }
    }
]]
function ActivityModel:retActivityFpGift( msg )
    if msg == nil then
        return 
    end
    -- print('levelGift == ',msg.fp_gift_activity_list)
    self.HasInit[ActivityModel.ActivityMenuIndex.FP_GIFT] = true;


    self.fpGift = {}
    self.fpGift.state =  msg.fp_gift_state;
    self.fpGift.data = GlobalFunctions:sortTableByKey(msg.fp_gift_activity_list); 
    self.fpGift.redDotState = false;
    self:updateRedDotStateFpGift()
    tools.RedDotTools:pushMainPanelRedDot(2);
end
--[[
    activity_list = {
        'id1':1,...
    }
    activity_list = {
        {
            id,value，reward_item,reward_role,description,time_id
        }
    }
]]
function ActivityModel:retActivitySevenSign( msg )
    if msg == nil then
        return 
    end
    -- print_ro(msg,'SevenList= =fubin== ');
    -- print('seven_list == ',msg.seven_list)
    self.HasInit[ActivityModel.ActivityMenuIndex.SEVEN_DAY] = true;

    self.sevenSign = {}
    self.sevenSign.state =  msg.activity_state;
    self.sevenSign.data = GlobalFunctions:sortTableByKey(msg.activity_list); 
    self.sevenSign.redDotState = false;
    self.sevenSign.closeState = false;
    self:updateRedDotStateSevenSign();

    EventManager:FireEvent(EventType.UIUpdateBtnShow,3);
    EventManager:FireEvent(EventType.UIUpdateBtnShow,13);
    EventManager:FireEvent(EventType.UIUpdateBtnShow,15);
    tools.RedDotTools:pushMainPanelRedDot(15);
end

function ActivityModel:reqActivitySignReward( dayIndex )
	local msg = {};
	msg.pos = dayIndex;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_sign_get_reward , msg);

end

function ActivityModel:retSignGetReward(msg)
    if self.sign and self.sign.signState then
        self.sign.signState[tonumber(msg.pos)] = msg.state;
    end

	if msg.repaired_sign then
        self.sign.signRepaired = msg.repaired_sign;
        self:updateSignRepairedDay()


    end
    self:updateRedDotStateSign()

end

function ActivityModel:reqActivityItemReward(index,id)
	local msg = {};
	msg.id = id;
    
    if index == ActivityModel.ActivityMenuIndex.SEVEN_DAY then
        msg.operate_id = 1;
        msg.value = id;
        Network.NetworkManager:Send(Network.NetworkCmdType.req_activity_get_reward_4714 , msg);

    elseif index == ActivityModel.ActivityMenuIndex.SEVEN_CON then
        msg.operate_id = 14;
        msg.value = id;
        Network.NetworkManager:Send(Network.NetworkCmdType.req_activity_get_reward_4714 , msg);

    end

end

function ActivityModel:retLimitActivityReward(msg)
	if not msg then
		return;
	end

    if msg.activity_index == ActivityModel.ActivityMenuIndex.SEVEN_DAY then 
        if self.sevenSign and self.sevenSign.state then
            self.sevenSign.state[tostring(msg.id)] = msg.state;
        end
        self:updateRedDotStateSevenSign()

    elseif msg.activity_index == ActivityModel.ActivityMenuIndex.SEVEN_CON then 
        if msg.continuous_list then
            self.continueRwd = msg.continuous_list;
        end
        self:updateRedDotStateSevenSign()

	else

	end
	
	
end

function ActivityModel:retLevelGiftGetReward(msg)

    if msg == nil or msg.id == nil then
        return 
    end
    
    if type(msg.id) == 'table' then
        local _k,itemId = next(msg.id,_k);
        while itemId do
            self.levelGift.state[tostring(itemId)] = 2;
            _k,itemId = next(msg.id,_k);
        end
    else
        self.levelGift.state[tostring(msg.id)] = 2;
    end
    self:updateRedDotStateLevelGift();
end

function ActivityModel:retFpGiftGetReward(msg)
    
    if msg == nil or msg.id == nil then
        return 
    end
    
    if type(msg.id) == 'table' then
        local _k,itemId = next(msg.id,_k);
        while itemId do
            self.fpGift.state[tostring(itemId)] = 2;
            _k,itemId = next(msg.id,_k);
        end
    else
        self.fpGift.state[tostring(msg.id)] = 2;
    end
    self:updateRedDotStateFpGift();

end

function ActivityModel:updateSignRepairedDay(  )
    if self.sign == nil or self.sign.signToday == nil then
        return 
    end



    self.sign.signReparedDay = -1;
    local nextRepairedDay = self.sign.signToday + 1;
    local state = self.sign.signState[nextRepairedDay]
    while state ~= nil and state ~= 0 do
        if state == 3 then
            self.sign.signReparedDay = nextRepairedDay;
            break;
        end
        nextRepairedDay = nextRepairedDay + 1;
        state = self.sign.signState[nextRepairedDay]
    end


end

function ActivityModel:updateRedDotStateSign(  )
    if self.sign == nil  then
        return ;
    end
    if self.sign.signState == nil then
        self.sign.redDotState = false;
        return ;
    end
    self.sign.redDotState = false;

    for i=1,#self.sign.signState do
        if self.sign.signState[i] == 1 then
            self.sign.redDotState = true;
            return ;
        elseif self.sign.signState[i] == 3 and self.sign.signRepaired > 0 then 
            self.sign.redDotState = true;
            return ;
        end
    end

end

function ActivityModel:updateRedDotStateLevelGift(  )
    if self.levelGift == nil then
        return ;
    end

    if not self:hasInitIndex(ActivityModel.ActivityMenuIndex.LEVEL_GIFT) then
        return ;
    end

    if self.levelGift.state == nil then
        self.levelGift.redDotState = false;
        return ;
    end
    self.levelGift.redDotState = false;

    local maxValue = self:getActivityProgressValueByType(ActivityModel.ActivityMenuIndex.LEVEL_GIFT);
    for i=1,#self.levelGift.data do
        local item = self.levelGift.data[i];
        local id = item.id;
        local state = self.levelGift.state[tostring(id)];
        local value = item.value;
        if state == 0 then 
            if maxValue >= value then
                state = 1;
                self.levelGift.redDotState = true;
                self.levelGift.state[tostring(id)] = 1
            else
                return;
            end
        elseif state == 1 then
            self.levelGift.redDotState = true;
        end
    end

end

function ActivityModel:updateRedDotStateFpGift(  )
    if self.fpGift == nil then
        return ;
    end

    if not self:hasInitIndex(ActivityModel.ActivityMenuIndex.FP_GIFT) then
        return ;
    end

    if self.fpGift.state == nil then
        self.fpGift.redDotState = false;
        return ;
    end
    self.fpGift.redDotState = false;

    local maxValue = self:getActivityProgressValueByType(ActivityModel.ActivityMenuIndex.FP_GIFT);
    for i=1,#self.fpGift.data do
        local item = self.fpGift.data[i];
        local id = item.id;
        local state = self.fpGift.state[tostring(id)];
        local value = item.value;
        if state == 0 then 
            if compareTwoNumGreaterAndEqual(maxValue, value,true) then
                state = 1;
                self.fpGift.redDotState = true;
                self.fpGift.state[tostring(id)] = 1
            else
                return;
            end
        elseif state == 1 then
            self.fpGift.redDotState = true;
        end
    end

end

function ActivityModel:updateRedDotStateSevenSign(  )
    -- dump(self.sevenSign,'seven_list === ');

    if self.sevenSign == nil then
        return ;
    end
    if self.sevenSign.state == nil then
        self.sevenSign.redDotState = false;
        return ;
    end
    self.sevenSign.redDotState = false;
    self.sevenSign.closeState = false;
    for k,v in pairs(self.sevenSign.state) do
        if v == 1 then
            self.sevenSign.redDotState = true;
            --return ;
        end
        if v ~= 2 then
            self.sevenSign.closeState = true;
        end
    end
end
--- -------------------------  get -----------------------------------

function ActivityModel:getSignRepaired()
    if self.sign == nil then
        return 0;
    end
	return self.sign.signRepaired or 0;
end

function ActivityModel:getSignRepairedDay(  )
    if self.sign == nil then
        return 0;
    end
	return self.sign.signReparedDay
end
-- 
function ActivityModel:getActivityProgressValueByType( index )
    if index == ActivityModel.ActivityMenuIndex.LEVEL_GIFT then
        return model.UserModel:getUserLevel();
    elseif index == ActivityModel.ActivityMenuIndex.FP_GIFT then
        return model.TeamModel:getCurrentTeamFp();
    end
end

-- 0 不可领取   1 可领取  2 已领取
function ActivityModel:getActivityStateByTypeAndId( index,id ,value)
    local state = 0;
    if index == ActivityModel.ActivityMenuIndex.LEVEL_GIFT then
        state = self.levelGift.state[tostring(id)];
    elseif index == ActivityModel.ActivityMenuIndex.FP_GIFT then
        state = self.fpGift.state[tostring(id)];
    end

    return state;
end

function ActivityModel:getContinueRwd()
    return self.continueRwd;
end

function ActivityModel:getActivityDataByIndex( menuIndex,key2 )

    if menuIndex == ActivityModel.ActivityMenuIndex.SIGN then
        return self.sign;
    elseif menuIndex == ActivityModel.ActivityMenuIndex.LEVEL_GIFT then
        return self.levelGift;
    elseif menuIndex == ActivityModel.ActivityMenuIndex.FP_GIFT then
        return self.fpGift;
    elseif menuIndex == ActivityModel.ActivityMenuIndex.SEVEN_DAY then
        return self.sevenSign;
    -- elseif menuIndex == ActivityModel.ActivityMenuIndex.RECHARGE then
    --     if key2 == 1 then
    --         return self.recharge.first;
    --     elseif key2 == 2 then 
    --         return self.recharge.hundred;
    --     end
    end

end

-- function ActivityModel:getActivityRechargeTotalMoney( ... )
--     return self.recharge.totalMoney;
-- end

-- redDot   locKState----- 

function ActivityModel:getRedDotStateActivityByIndex( index )
   
    --if not self:hasInitIndex(index) then
    --    --self:reqActivityByIndex(index)
    --    return true --默认显示红点
    --end

    if tools.ConfigStateTools:checkLockByType(Enum:getTable('ConfigStateType').ACTIVITY , index) then
        return false;
    end

    if self:getLockStateActivityByIndex(index) == true then
        return false;
    end
    
    if index == ActivityModel.ActivityMenuIndex.SIGN then
        return self.sign.redDotState;
    elseif index == ActivityModel.ActivityMenuIndex.FP_GIFT then
        return false --self.fpGift.redDotState;
    elseif index == ActivityModel.ActivityMenuIndex.LEVEL_GIFT then
        return false --self.levelGift.redDotState;
    elseif index == ActivityModel.ActivityMenuIndex.SEVEN_DAY then
        return self.sevenSign.redDotState;
    end
    return false;
end

function ActivityModel:getRedDotStateActivity(  )
    if self:getLockStateActivity() then
        return false;
    end
    
    return  self:getRedDotStateActivityByIndex(ActivityModel.ActivityMenuIndex.SIGN) 
        or self:getRedDotStateActivityByIndex(ActivityModel.ActivityMenuIndex.FP_GIFT)
        or self:getRedDotStateActivityByIndex(ActivityModel.ActivityMenuIndex.LEVEL_GIFT)

end

-- bool,lockLv
function ActivityModel:getLockStateActivityByIndex( index )
    if index == ActivityModel.ActivityMenuIndex.SIGN then
        return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_4);
    elseif index == ActivityModel.ActivityMenuIndex.SEVEN_DAY then
        local locked , lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_3);
        if not locked then
            locked = true;
            if self.sevenSign then
                if self.sevenSign.closeState then
                    locked = false;
                end
            end
        end
        return locked , lockLv;	
    -- elseif index == ActivityModel.ActivityMenuIndex.FIRST_RECHARGE then
    --     return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_6);	
    end
    return tools.LevelLockTools:checkLockById(1000);		
end

function ActivityModel:getLockStateActivity(  )
    return tools.LevelLockTools:checkLockById(1000);		
end

function ActivityModel:getRedDotStateLogin7(  )
    return self:getRedDotStateActivityByIndex(ActivityModel.ActivityMenuIndex.SEVEN_DAY)
end

function ActivityModel:getLockStateLogin7(  )
    return self:getLockStateActivityByIndex(ActivityModel.ActivityMenuIndex.SEVEN_DAY);
end

function ActivityModel:getRedDotSign()
    return self:getRedDotStateActivityByIndex(ActivityModel.ActivityMenuIndex.SIGN)
end

function ActivityModel:getOpenActivityLocked()
    if not self:getLockStateActivityByIndex(ActivityModel.ActivityMenuIndex.SEVEN_DAY) or not self:getThreeDayLocked() then
        return false;
    end
    return true;
end

function ActivityModel:getRedDotThreeDay()
    --if self:getThreeDayLastTime() > 0 then
        local state = self:getThreeDayState();
        local completeNum = 0;
        for _k , v in pairs(state) do
            if not self.threeDay[_k] and v == 1 then
                return true;
            end
        end
    --end

    return false;
end

function ActivityModel:getThreeDay()
    return self.threeDay;
end

function ActivityModel:updateThreeDay(no)
    self.threeDay[no] = 1;
end

function ActivityModel:getThreeDayLocked()
    --if self:getThreeDayLastTime() <= 0 then
    --    return true
    --else
        local state = self:getThreeDayState();
        local completeNum = 0;
        for _k , v in pairs(state) do
            if not self.threeDay[_k] then
                return false;
            end
        end
    --end
    return true;
end

function ActivityModel:getThreeDayState()
    local trialNo = model.TrialModel:getFinshTrialId()

    local complateState = {0,0,0};

    if model.UserModel:getUserLoginDays() >= 3 then
        complateState[1] = 1;
    end

    if trialNo>=20 then
        complateState[2] = 1;
    end

    if model.UserModel:getUserLevel() >= 35 then
        complateState[3] = 1;
    end

    return complateState;
end

function ActivityModel:getThreeDayLastTime()
    local serverTime = math.floor(TimeManager:getCurTime());
    local createTime = model.UserModel:getCreateTime();
    local lastTime =  createTime + 259200 - serverTime;
    lastTime = lastTime < 0 and 0 or lastTime;
    return lastTime;
end

function ActivityModel:initLoginConInfo( info )
    if info and next(info) then
        self.loginConInfo = info; --累计登录信息
    end
end

function ActivityModel:loginConUnAvailable()
    if self.loginConInfo == nil then
        return true;
    end
    local curTime = TimeManager:getCurTime();
    if curTime>=self.loginConInfo.open_time and curTime<=self.loginConInfo.close_time then
        return false;
    else
        return true;
    end
end

function ActivityModel:getLoginConAllInfo()
    return self.loginConInfo, self.loginConList;
end

function ActivityModel:retLoginConList( msg )
    self.loginConList = msg.login_list;
    self.loginConInfo.per_cycle_day = msg.per_cycle_day;
    self.loginConInfo.cumulative_days = msg.cumulative_days;

    EventManager:FireEvent('LoginConRewardPanel:updateData');
end

function ActivityModel:retGetRwdLoginCon( msg )
    -- body
    self.loginConList[msg.cumulative_days].state = msg.state;
    EventManager:FireEvent('LoginConRewardPanel:retUpdateReward', msg);
    tools.RedDotTools:pushMainPanelRedDot(26);
end

function ActivityModel:getRedDotStateLoginCon()
    if self.loginConList then
        for k,v in pairs(self.loginConList) do
            if v.state == 1 then
                return true;
            end
        end
        return false;
    end

    if self.loginConInfo then
        return self.loginConInfo.has_available_reward;
    end
    return false;
end

return ActivityModel
