local AdmobModel = class("AdmobModel")
local scheduler = cc.Director:getInstance():getScheduler();
function AdmobModel:ctor()
    self:init();
end

function AdmobModel:init()
    self.hasInit = false;

    local platform = cc.Application:getInstance():getTargetPlatform()
        
    self.admob = nil
    self.admob_state = nil;

    self.bIsPlayAdmob = false;
    self.selectAdmobId = nil ;

    if self.m_scheduleHandler then
        scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
        self.m_scheduleHandler = nil
    end
    self.m_time = -1;
    self.m_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.Update), 0.5, false);
end

function AdmobModel:Update(dt)
    -- body
    if self.m_time>=0 then
        self.m_time = self.m_time+1
        if self.m_time>=1 then
            self.m_time = -1
        end
    end
end

function AdmobModel:initAdmob( msg_admob )
    self:init();
    if self.admobData == nil then
        self.admobData = {};
        local admobData = ResTable:getTable('admob').contain
        for k,v in pairs(admobData) do
            if v.id == 3 then
                v.max_time = v.time
                v.next_time = 0
            else
                v.remain_times = v.limit; -- 剩余使用次数： -1 不限制
            end
            self.admobData[v.id] = v 
        end
    end
    -- 重置次数！！！
    for k,v in pairs(self.admobData) do
        v.remain_times = v.limit; 
     end
    self:onRetAdmobInfo(msg_admob);
    self.hasInit = true ;
end

function AdmobModel:hasInitOk(  )
    return self.hasInit;
end

function AdmobModel:getAdmobItem( admobId )
    if self.admobData == nil then
        return nil
    end
    return self.admobData[admobId]
end

function AdmobModel:reqAdmobInfo(  )
    local msg = {}
    -- msg.admob_id = admobId;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_admob_info, msg)	  
end

function AdmobModel:reqAdmobReward( admobId )

    local msg = {}
    msg.admob_id = admobId;
    msg.is_release = sdkManager.SDKLuaHelper:retApkRelease();
    Network.NetworkManager:Send(Network.NetworkCmdType.req_admob_reward, msg)	        
end

function AdmobModel:onRetAdmobInfo( msg_admob )
    if msg_admob == nil then
        return 
    end
    if self.admobData == nil then
        return;
    end
    for k,v in pairs(msg_admob) do
        local admobId = v.admob_id;
        if admobId == 3 then
            self.admobData[admobId].next_time = v.last_reward_time + self.admobData[admobId].max_time
            self.admobData[admobId].remain_times = -1
        else
            if v.today_times ~= nil and self.admobData[admobId] and tonumber(self.admobData[admobId].limit) ~= -1 then
                print('=====================')
                self.admobData[admobId].remain_times = self.admobData[admobId].limit - v.today_times;
            end
        end
    end
    -- dump(self.admobData,'self.admobData[admobI===')
end

function AdmobModel:onAdmobClick( admobId )
    if self.m_time>=0 then
        return
    end
    self.m_time = 0;
    if self.bIsPlayAdmob == true  then
        return ;
    end
    local admobItem = self:getAdmobItem(admobId)
    if admobItem == nil then
        GlobalFunctions:showErrorPromt('error --- not found admob info by id '..tostring(admobId));
        return 
    end
    if admobId == 3 then
        if admobItem.next_time > TimeManager:getCurTime() then
            local time = GlobalFunctions:ChangeTime(math.floor(admobItem.next_time - TimeManager:getCurTime()))
            Prompt:Show(string.format(LANG.UI_ADMOB_8, time))
            return
        end
    end
    self.bIsPlayAdmob = true;
    -- 1 请求服务器获取广告次数，2 请求SDK播放广告，3 请求服务器获取奖励
    local remainTimes = admobItem.remain_times;
    print('remainTimes ====     ' ,remainTimes );
    if remainTimes == 0  then
        -- Prompt:Show(LANG.UI_DAILY_ROUND_4);
        self.selectAdmobId = admobId;
        self:reqAdmobInfo()
        return 
    end

    self:onAdmobSDKCall(admobId)
end

function AdmobModel:retAdmobInfo( msg )
    if self.selectAdmobId ~= nil then
        local admobId = self.selectAdmobId;
        
        local admobItem = model.AdmobModel:getAdmobItem(admobId)
        if admobItem == nil then
            GlobalFunctions:showErrorPromt('error --- not found admob info by id '..tostring(admobId));
            self.bIsPlayAdmob = false;
            return 
        end
    
        local remainTimes = admobItem.remain_times;
        if remainTimes == 0  then
            Prompt:Show(LANG.UI_DAILY_ROUND_4);
            self.bIsPlayAdmob = false;
            return 
        end
    
        print('admobId', admobId)
        self:onAdmobSDKCall(admobId)
    end
end

function AdmobModel:onAdmobSDKCall( admobId )
    self.selectAdmobId = nil;
    local function sdkPlayAdmobCallback( strData )

        local jsonData = Cjson.decode(strData)
		jsonData.code = tonumber(jsonData.code)
        if jsonData.code and jsonData.code ~= 0 and jsonData.code ~= 100 then
            if jsonData.code == 3 then
                Prompt:Show(LANG.UI_ADMOB_9)
            else
                Prompt:Show(LANG.UI_ADMOB_10)
            end
            return
        end
        if jsonData.info_code and (jsonData.info_code==2 or jsonData.info_code==3) then
            --创建广告的 可能的回调函数 不做处理
        else
            self.bIsPlayAdmob = false;
            WaitingPanel:Hide()
        end
		print_ro(jsonData)
		--[[
        if jsonData.code ~= 0 then
            print("  sdk callback error  msg: "..tostring(jsonData.code))
            print("==== play admob over ==== ")
            self.bIsPlayAdmob = false;
            Prompt:Show(LANG.UI_ADMOB_5)
            return ;
        end
		--]]
		if jsonData.code and jsonData.code == 0 then
			self:reqAdmobReward(admobId)
		end
    end
    local args = {
        admob_index = admobId
    }
    WaitingPanel:Show()
    sdkManager.SDKLuaHelper:playAdMob(args, sdkPlayAdmobCallback);
end




return AdmobModel;
