local AutoFightModel = class("AutoFightModel")
local AutoBattleBuff = Enum:getTable('AutoBattleBuff')

function AutoFightModel:ctor()
	self:clearAll()
end

function AutoFightModel:clearAll(  )
	self.maxIncomeTime =  60*60*12 -- 43200;
	self.income_items = {};
	self.income_buffs = {};

	EventManager:UnregisterEvent(EventType.FightIncomeChange)

end

function AutoFightModel:Init(msg)
	self:clearAll()
	self:removeAllItmes();
	self:setIncome(msg)
	if msg.ori_buff then
		self:setBuff(msg.ori_buff)
	end
	self.hasPostIncomeEvent = false;
end

function AutoFightModel:InitFastInfo(msg)
	self:initFastReward(msg);
end

-- 快速战斗：[货币类型，消耗货币数量，今日已使用战斗次数，快速战斗总次数，免费次数倒计时]
function AutoFightModel:initFastReward(msg)
	-- print_ro(msg);
	if msg.buyNextFastInfo then
		self.fastInfo = msg.buyNextFastInfo;
	end
	self.fastInfo.timeCountDownStart = TimeManager:getCurTime();
end

-- function AutoFightModel:updateFastTime(dt)
-- 	if self.fastInfo and self.fastInfo[5] then
-- 		self.fastInfo[5] = self.fastInfo[5] - dt;
-- 		if self.fastInfo[5] <= 0 then
-- 			self.fastInfo[5] = 0;
-- 		end
-- 	end
-- end

function AutoFightModel:getFastRewardCountDown(  )
	if self.fastInfo == nil or self.fastInfo[5] == nil  or self.fastInfo[5] < 0 then
		return 0;
	end

	local curTime = TimeManager:getCurTime();
	local fastStartTime = self.fastInfo.timeCountDownStart ;
	local countDown = self.fastInfo[5] - (curTime - fastStartTime)
	if countDown < 0 then
		countDown = 0
		self.fastInfo[5] = 0;
	end

	return countDown;
end


function AutoFightModel:setIncome(msg)
	self.incomeMoney = msg.money;
	self.incomeExp = msg.exp;
--[[
	if msg.buff and type(msg.buff) == 'table' then
		self:setBuff(msg.buff)
	end
	--]]
	self:setIncomeItem(msg.reward)
	self.lastGetRewardTime = msg.incomeBeginTime
	EventManager:FireEvent(EventType.FightIncomeChange, self.incomeMoney, self.incomeExp);
end

function AutoFightModel:setIncomeItem( rewards )
	if rewards and type(rewards) == 'table' then
		--[[
		-- 服务器返回新增数据
		for k,v in pairs(rewards) do
			if v.id ~= ROLE_TYPE then
				if self.income_items[v.id] == nil  then
					self.income_items[v.id] = 0
				end
				self.income_items[v.id] = self.income_items[v.id] + v.num;
			else 
				-- 卡牌
				self.income_items[v.id] = self.income_items[v.id] or {}
				table.insert( self.income_items[v.id]	,v.num )
			end

		end
		--]]

		-- 服务器返回全部数据
		for k,v in pairs(rewards) do
			self.income_items[v[1]] = v[2]
		end
	end
end

function AutoFightModel:removeAllItmes(  )
	self.income_items = {};
	
end
function AutoFightModel:getIncomeMoney()
	return self.incomeMoney;
end

function AutoFightModel:getIncomeExp()
	return self.incomeExp;
end
--[[
	{
		id1 = num1,
		id2 = num2,
		ROLE_TYPE = {no1，no2,no3,no1,no1,no4...}
	}
]]
function AutoFightModel:getIncomeItems( )
	return self.income_items;
end

function AutoFightModel:getMaxIncomeTime()
	return self.maxIncomeTime;
end

function AutoFightModel:getLastGetRewardTime()
	return self.lastGetRewardTime;
end

function AutoFightModel:getIncomeTime()
	local currentTime = TimeManager:getCurTime()
	local incomeTime = math.floor(currentTime - self.lastGetRewardTime);
	local incomeTimeMax = self.maxIncomeTime
	if incomeTime > self.maxIncomeTime then
		return self.maxIncomeTime
	else
		return incomeTime
	end
end

function AutoFightModel:IsFull()
	local currentTime = TimeManager:getCurTime()
	return math.floor(currentTime - self.lastGetRewardTime) > self.maxIncomeTime;
end

function AutoFightModel:reqIncomeReward(  )
	local msg = {};
	Network.NetworkManager:Send(Network.NetworkCmdType.req_income_reward, msg);
end

function AutoFightModel:retIncomeReward( msg )
	self:removeAllItmes();
	self:setIncome(msg)
end

function AutoFightModel:getFastInfoData(index)
	return self.fastInfo[index];
end

function AutoFightModel:getFastFightActiveState()
	if self:getLockStateFastFight() then
		return false;
	end

	local haveTimes = self:getFastInfoData(3);
	if haveTimes < 6 then
		return true;
	end

	local lastTime = self:getFastInfoData(5) or 0;
	lastTime = math.floor(lastTime);
	if lastTime <= 0 then
		return true;
	end

	return false;
end

function AutoFightModel:getFightIncomeState(  )
	
	if condition then
		-- body
	end

end

function AutoFightModel:getFastFightRedDotState()

	local lastTime = self:getFastRewardCountDown();
	if lastTime > 0 then
		local haveTimes = self:getFastInfoData(3)
		local costNum = self:getFastInfoData(2) or 0;
		local haveNum = model.ItemModel:getItemNum(FAST_FIGHT_ITEM);
		return haveNum >= costNum and haveTimes<5;
	else
		return true;
	end
	
	return false
end	

function AutoFightModel:getLockStateFastFight(  )
    return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_2);		
end

function AutoFightModel:checkBuff()
	local haveBuff = false;
	local curTime = math.floor(TimeManager:getCurTime())
	for k, v in pairs(self.income_buffs) do
		if v.overTime < curTime then
			self.income_buffs[k] = nil;
		else
			haveBuff = true
		end
	end
	local timeScale = haveBuff and 2 or 1;
	EventManager:FireEvent(EventType.AutoFightTimeScale, timeScale);
end

function AutoFightModel:addBuff(buff)
	if self.income_buffs[buff.buffType] then
		local info = self.income_buffs[buff.buffType]
		if info.overTime < math.floor(TimeManager:getCurTime()) then
			info.overTime = math.floor(TimeManager:getCurTime()) + buff.time
			info.incomeType = buff.incomeType
			info.times = buff.times
		else
			info.overTime = info.overTime + buff.time
			info.incomeType = buff.incomeType
			info.times = buff.times
		end
	else
		self.income_buffs[buff.buffType] = {
			overTime = math.floor(TimeManager:getCurTime()) + buff.time,
			incomeType = buff.incomeType,
			times = buff.times,
		}
	end
end

function AutoFightModel:setBuff(buffs)
	self.income_buffs = {}
	for k, v in pairs(buffs) do
		self.income_buffs[v[1]] = {
			incomeType 	= v[2],
			times 		= v[3],
			overTime 	= v[4],
		};
	end
end

function AutoFightModel:getBuff()
	return self.income_buffs;
end

function AutoFightModel:getBuffTimestampAndTimes(buffType)
	local buffInfo = self.income_buffs[buffType]

	local timeReset = 0
	local times = 0
	if buffInfo and buffInfo.overTime then
		timeReset = buffInfo.overTime - math.floor(TimeManager:getCurTime())
		times = buffInfo.times
	end

	return timeReset, times
end

return AutoFightModel;
