local BareCollectModel = class("BareCollectModel")

function BareCollectModel:ctor()
	self:clearAll();
end

function BareCollectModel:clearAll()
	self.bareCollectRoleId = {};
	self.bareCollectData={};
	self.initAddNewFlag = false;

	self.blessInfo = nil;
end

function BareCollectModel:Init(data, blessInfo)
	self:clearAll();
	local bareCollect = {};
	local bareCollectActiveNum = {};
	local wearPid = {};
	if data then
		for bare_id , bareData in pairs(data) do
			bare_id = tonumber(bare_id);
			wearPid[bare_id] = bareData.pid;
			bareCollect[bare_id] = {};
			local num = bareData.map_state and #bareData.map_state or 0;
			bareCollectActiveNum[bare_id] = num;
			if num > 0 then
				for _k , pos in pairs(bareData.map_state) do
					bareCollect[bare_id][pos] = 1;
				end
			end
		end
	end

	local bareCollectTableData = ResTable:getTable('bare_collect').contain;

	for _k , bareData in pairs(bareCollectTableData) do
		self.bareCollectData[bareData.bare_id] = bareData;
		self.bareCollectData[bareData.bare_id].activeState = bareCollect[bareData.bare_id] and 1 or 0;
		self.bareCollectData[bareData.bare_id].mapState = bareCollect[bareData.bare_id] or {};
		self.bareCollectData[bareData.bare_id].activeNum = bareCollectActiveNum[bareData.bare_id] or 0;
		self.bareCollectData[bareData.bare_id].pid = wearPid[bareData.bare_id] and wearPid[bareData.bare_id] or 0;
		self.bareCollectData[bareData.bare_id].needInit = true

		if not self.bareCollectRoleId[bareData.role_id] then
			self.bareCollectRoleId[bareData.role_id] = {};
		end
		table.insert(self.bareCollectRoleId[bareData.role_id] , bareData.bare_id);
	end

	if blessInfo then
		self.blessInfo = blessInfo;
		self.blessInfo.hp = 0;
		self.blessInfo.atk = 0;
		if self.blessInfo and self.blessInfo.no > 0 then
			local blessData = ResTable:getRowData('bless_lv', self.blessInfo.no)
			self.blessInfo.hp = blessData.hp;
			self.blessInfo.atk = blessData.atk;
		end
	end
end

function BareCollectModel:getBlessInfo()
	return self.blessInfo;
end

function BareCollectModel:retUpdateBless( data )
	local oldFp = model.TeamModel:getCurrentTeamFp();
	self.blessInfo = data.bless_info;
	if self.blessInfo and self.blessInfo.no > 0 then
		local blessData = ResTable:getRowData('bless_lv', self.blessInfo.no)
		self.blessInfo.hp = blessData.hp;
		self.blessInfo.atk = blessData.atk;
		self.blessInfo.oldFp = oldFp;
		CardProManager:setNeedUpdateAllGenPro();
	end
	EventManager:FireEvent('ZfUpPanel:updateInfo', true);
end

function BareCollectModel:getBlessHpAndAtk()
	if self.blessInfo and self.blessInfo.no > 0 then
		return self.blessInfo.hp, self.blessInfo.atk;
	else
		return 0, 0;
	end
end

function BareCollectModel:getBareData(bareId)
	if bareId then
		return self.bareCollectData[bareId];
	end
	return self.bareCollectData;
end

function BareCollectModel:setBareDataInitEnd(bareId, v)
	if self.bareCollectData[bareId] then
		self.bareCollectData[bareId].needInit = v
	end
end

function BareCollectModel:updateBareCollect(bareId,mapState)
	if self.bareCollectData[bareId] then
		if mapState then
			for _k , pos in pairs(mapState) do
				self.bareCollectData[bareId].mapState[pos] = 1;
			end
		end
		self.bareCollectData[bareId].activeNum = #mapState;
	end
end

function BareCollectModel:addBareCollect(bareCollects)
	if bareCollects then
		for _k , bareId in pairs(bareCollects) do
			if self.bareCollectData[bareId] then
				self.bareCollectData[bareId].activeState = 1;
				self.bareCollectData[bareId].needInit = true
			end
		end
	end
end

function BareCollectModel:getBareDataByRoleId(roleId)

	local bareData = {};
	if self.bareCollectRoleId[roleId] then
		local bareIds = self.bareCollectRoleId[roleId];
		for i , bareId in pairs(bareIds) do
			if self.bareCollectData[bareId] then
				table.insert(bareData , self.bareCollectData[bareId]);
			end
		end
	end

	return bareData;
end

function BareCollectModel:isHaveAllActiveBare()
	local allActiveBare,haveCanWear = false,false;
	for _k , bare in pairs(self.bareCollectData) do
		if bare.activeNum >= 12 then
			allActiveBare = true;
			if bare.pid == 0 then
				haveCanWear = true;
			end
		end
	end
	return allActiveBare , haveCanWear;
end

function BareCollectModel:isHaveBare(roleId)
	if self.bareCollectRoleId[roleId] then
		if #self.bareCollectRoleId[roleId] > 0 then
			return true , self.bareCollectRoleId[roleId][1];
		end
	end

	return false , -1;
end

function BareCollectModel:setInitAddNew(isInit)
	self.initAddNewFlag = isInit;
end

function BareCollectModel:isInitAddNew()
	return self.initAddNewFlag;
end

function BareCollectModel:updateBareCollectWear(bareId,pid)
	if self.bareCollectData[bareId] then
		self.bareCollectData[bareId].pid = pid;
	end
end

return BareCollectModel;
