local BattlepassEventModel = class("BattlepassEventModel")
local scheduler = cc.Director:getInstance():getScheduler();

BattlepassEventModel.BattlepassMenuType = {
	DAILY 	= 1,
	WEEK 	= 2,
	ULTIMATE= 3,
}

function BattlepassEventModel:ctor()
	self:clearAll()
end

function BattlepassEventModel:clearAll(  )
	self.hasInit = false;
	self.battlepassId = 0;
	self.rewardState = {};
	self.battlepassMissionData = {};
	self.battlepassRedDot = {};
	self.rewardData = {};
	self.battlepassOpenTime = 0;
	self.battlepassCloseTime = 0;
	self.battlepassShowTime = 0;
	self.specialState = 0;
	self.curBattlepassRewardNo = 0;
	self.curBattlepassPoint = 0;
end

function BattlepassEventModel:isInit()
	return self.hasInit;
end

function BattlepassEventModel:setInit(Init)
	self.hasInit = init
end

function BattlepassEventModel:Init(data)
	if data.battlepass_id then
		self.battlepassId = data.battlepass_id;
	end

	if data.special_state then
		self.specialState = data.special_state;
	end

	if data.battlepass_open_time then
		self.battlepassOpenTime = data.battlepass_open_time
	end

	if data.battlepass_close_time then
		self.battlepassCloseTime = data.battlepass_close_time
	end

	if data.battlepass_show_time then
		self.battlepassShowTime = data.battlepass_show_time
	end

	if data.battlepass_point then
		self.curBattlepassPoint = data.battlepass_point
	end

	local rewardFreeState = {};
	if data.reward_free_state then
		for _k,no in pairs(data.reward_free_state) do
			rewardFreeState[no] = 1;
		end
	end

	local rewardSpecialState = {};
	if data.reward_special_state then
		for _k,no in pairs(data.reward_special_state) do
			rewardSpecialState[tonumber(no)] = 1;
		end
	end

	local reward = ResTable:getTable('battlepass_reward').contain;
	local rewardData = {};
	local num = 0;
	for _k,data in pairs(reward) do
		if data.battlepass_id == self.battlepassId then
			table.insert(rewardData,data);
			num = num + 1;
		end
	end

	if num > 1 then
		table.sort(rewardData , function(first , second)
			return first.total_point < second.total_point;
		end)
	end

	self.rewardData = {};
	self.battlepassRedDot = {};
	self.battlepassRedDot['battlepass'] = false;
	for _k , data in pairs(rewardData) do
		if not self.rewardData[data.no] then
			self.rewardData[data.no] = {};
		end
	
		self.rewardData[data.no] = data;
		self.rewardData[data.no].reward_free_state = rewardFreeState[data.no] or 0;
		self.rewardData[data.no].reward_special_state = rewardSpecialState[data.no] or 0;
		self.rewardData[data.no].level = _k;

		if self.curBattlepassPoint >= data.total_point
			and not self.battlepassRedDot['battlepass'] then
			if #self.rewardData[data.no].reward > 0 and self.rewardData[data.no].reward_free_state == 0 then
				self.battlepassRedDot['battlepass'] = true;
			end

			if self.specialState == 1 and self.rewardData[data.no].reward_special_state == 0 then
				self.battlepassRedDot['battlepass'] = true;
			end
		end
	end

	local battlePass = {};
	if data.battlepass_mission then
		for _k , bPass in pairs(data.battlepass_mission) do
			if bPass then
				for no , data in pairs(bPass) do
					battlePass[tonumber(no)] = data;
				end
			end
		end
	end

	self.battlepassRedDot['mission'] = {}; 
	self.battlepassMissionData = {};
	local mission = ResTable:getTable('battlepass_mission').contain;
	for _k , data in pairs(mission) do
		if not self.battlepassMissionData[data.time_type] then
			self.battlepassMissionData[data.time_type] = {};
			self.battlepassRedDot['mission'][data.time_type] = false;
		end
		self.battlepassMissionData[data.time_type][data.no] = data;
		self.battlepassMissionData[data.time_type][data.no].num = 0;
		self.battlepassMissionData[data.time_type][data.no].state = 0; --0不能领取，1可领取，2已领取
		if battlePass[data.no] then
			self.battlepassMissionData[data.time_type][data.no].num = battlePass[data.no][1] or 0;
			self.battlepassMissionData[data.time_type][data.no].state = battlePass[data.no][2] or 0;
		end
		local tData = self.battlepassMissionData[data.time_type][data.no];
		if tData.state ~= 1 then
			if tData.type == Enum:getTable("MissionType").MISSION_GOLD_COST then
				local curNum = ConvertDigitUnitToStr(tostring(tData.num));
				local comp = HpCompare(curNum , ">=" , tostring(tData.times));
				if comp then
					if not self.battlepassRedDot['mission'][tData.time_type] then
						self.battlepassRedDot['mission'][tData.time_type] = true;
					end
					self.battlepassMissionData[tData.time_type][tData.no].state = 2;
				end
			else
				if tData.num >= tData.times then
					if not self.battlepassRedDot['mission'][tData.time_type] then
						self.battlepassRedDot['mission'][tData.time_type] = true;
					end
					self.battlepassMissionData[tData.time_type][tData.no].state = 2;
				end
			end
		end

		if tData.type == Enum:getTable("MissionType").MISSION_GOLD_COST then
			local curNum = ConvertDigitUnitToStr(tostring(tData.num));
			self.battlepassMissionData[tData.time_type][tData.no].percent = HpDivide(curNum,tData.times);
		else
			self.battlepassMissionData[tData.time_type][tData.no].percent = tData.num/tData.times;
		end
	end

	if data.lastTime then
		self.lastTime = data.lastTime;
	end

	self:updateCurBattlepassRewardNo()

	self.nextDayRefreshTime = TimeManager:getNextDayTime();
	self.hasInit = true;
	
	tools.RedDotTools:pushMainPanelRedDot(12);
	--tools.RedDotTools:pushMainPanelRedDot(14);
	--EventManager:FireEvent(EventType.UIUpdateBtnShow,14);
	--EventManager:FireEvent(EventType.UIUpdateBattlepassRewardLevel);
end

function BattlepassEventModel:getBattlepassMissionData(timeType , no)
	if self.battlepassMissionData[timeType] then
		return self.battlepassMissionData[timeType][no];
	end
	return nil;
end

function BattlepassEventModel:updateCurBattlepassRewardNo()
	local maxNo = 0;
	self.curBattlepassRewardNo = 0;
	for _k , data in pairs(self.rewardData) do
		if self.curBattlepassPoint < data.total_point then
			if self.curBattlepassRewardNo == 0 or self.rewardData[self.curBattlepassRewardNo].total_point > data.total_point then
				self.curBattlepassRewardNo = data.no;
			end
		end
		if maxNo < data.no then
			maxNo = data.no;
		end
	end

	if self.curBattlepassRewardNo == 0 then
		self.curBattlepassRewardNo = maxNo;
	end
end

function BattlepassEventModel:getCurBattlepassRewardNo()
	return self.curBattlepassRewardNo;
end

function BattlepassEventModel:getSpecialState()
	return self.specialState;
end

function BattlepassEventModel:updateSpecialState(state)
	self.specialState = state;
end

function BattlepassEventModel:updateBattlepassPoint(battlepassPoint)
	if battlepassPoint then
		for _k , addNum in pairs(battlepassPoint) do
			self.curBattlepassPoint = self.curBattlepassPoint+addNum
		end
		self:updateCurBattlepassRewardNo();
		self:updateBattlepassRedDot();
	end
end

function BattlepassEventModel:getCurBattlepassPoint()
	return self.curBattlepassPoint;
end

function BattlepassEventModel:updateBattlepassMission(battlepassMission)
	if battlepassMission then
		for _k , data in pairs(battlepassMission) do
			if self.battlepassMissionData[data[1]] and self.battlepassMissionData[data[1]][data[2]] then
				self.battlepassMissionData[data[1]][data[2]].num = data[3][1];
				self.battlepassMissionData[data[1]][data[2]].state = data[3][2];
				local tData = self.battlepassMissionData[data[1]][data[2]];
				if tData.state ~= 1 then
					if tData.type == Enum:getTable("MissionType").MISSION_GOLD_COST then
						local curNum = ConvertDigitUnitToStr(tostring(tData.num));
						local comp = HpCompare(curNum , ">=" , tostring(tData.times));
						if comp then
							if not self.battlepassRedDot['mission'][tData.time_type] then
								self.battlepassRedDot['mission'][tData.time_type] = true;
							end
							self.battlepassMissionData[tData.time_type][tData.no].state = 2;
						end
					else
						if tData.num >= tData.times then
							if not self.battlepassRedDot['mission'][tData.time_type] then
								self.battlepassRedDot['mission'][tData.time_type] = true;
							end
							self.battlepassMissionData[tData.time_type][tData.no].state = 2;
						end
					end
				end

				if tData.type == Enum:getTable("MissionType").MISSION_GOLD_COST then
					local curNum = ConvertDigitUnitToStr(tostring(tData.num));
					self.battlepassMissionData[tData.time_type][tData.no].percent = HpDivide(curNum,tData.times);
				else
					self.battlepassMissionData[tData.time_type][tData.no].percent = tData.num/tData.times;
				end
			end
		end
	end
end

function BattlepassEventModel:getBattlepassReward(no)
	if no then
		return self.rewardData[no]
	end
	return self.rewardData;
end

function BattlepassEventModel:updateBattlepassReward(rewardType , no)
	if self.rewardData[no] then
		if rewardType == 2 then
			self.rewardData[no].reward_special_state = 1;
		else
			self.rewardData[no].reward_free_state = 1;
		end
		self:updateBattlepassRedDot();
	end
end

function BattlepassEventModel:getBattlepassId()
	return self.battlepassId;
end

function BattlepassEventModel:getBattlepassCountDown(countDownType)
	if self.battlepassId ~= 0 then
		local serverTime = math.floor(TimeManager:getCurTime());
		if countDownType == 1 then --每日
			local nextDayTime = self.nextDayRefreshTime - serverTime;
			return nextDayTime < 0 and 0 or nextDayTime;
		elseif countDownType == 2 then --每周
			local weekTime = TimeManager:GetNextWeekTime();
			weekTime = weekTime - serverTime;
			return weekTime < 0 and 0 or weekTime;
		else
			local closeTime = self.battlepassCloseTime - serverTime;
			return closeTime < 0 and 0 or closeTime;
		end
	end
	return 0;
end

function BattlepassEventModel:getBattlepassByTimeType(timeType)
	return self.battlepassMissionData[timeType];
end

function BattlepassEventModel:updateBattlepassState(timeType , no ,state)
	if self.battlepassMissionData[timeType] and self.battlepassMissionData[timeType][no] then
		self.battlepassMissionData[timeType][no].state = state;
		self.battlepassRedDot['mission'][timeType] = false
		for _k , data in pairs(self.battlepassMissionData[timeType]) do
			if data.state == 2 then
				self.battlepassRedDot['mission'][timeType] = true;
			end
		end
	end
end

function BattlepassEventModel:updateBattlepassRedDot()
	self.battlepassRedDot['battlepass'] = false;
	for _k , data in pairs(self.rewardData) do
		if self.curBattlepassPoint >= data.total_point then
			if #data.reward > 0 and data.reward_free_state == 0 then
				self.battlepassRedDot['battlepass'] = true;
				break;
			end

			if self.specialState == 1 and data.reward_special_state == 0 then
				self.battlepassRedDot['battlepass'] = true;
				break;
			end
		end
	end
end

function BattlepassEventModel:getBattlepassActiveState()

	if not self.hasInit then
		return false;
	end

	if self.battlepassId == -1 then
		return false;
	end

	--if self:getLockStateBattlepass() then
	--	return false 
	--end
	if self:getBattlepassRedDot() then
		return true;
	end

	for _k , state in pairs(self:getBattlepassMissionRedDot()) do
		if state then
			return true;
		end
	end

	return false;
end

function BattlepassEventModel:getBattlepassRedDot()
	return self.battlepassRedDot['battlepass'];
end

function BattlepassEventModel:getBattlepassMissionRedDot()
	local stateData = {false,false,false};
	for timeType,state in pairs(self.battlepassRedDot['mission']) do
		if not tools.ConfigStateTools:checkLockByType(Enum:getTable('ConfigStateType').BATTLEPASS , timeType) then
			stateData[timeType] = state;
		end
	end
	return stateData;
end

function BattlepassEventModel:isShowBattlepass()
	return (self.battlepassId ~= -1 and TimeManager:getCurTime() < self.battlepassShowTime);
end


function BattlepassEventModel:getLockStateBattlepass(  )
	return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_19);		
end

function BattlepassEventModel:getLockStateBattlepassReward()
	return self:getBattlepassCountDown() <= 0;
end

return BattlepassEventModel;
