local CardModel = class("CardModel")
local CardTeamState = Enum:getTable('CardTeamState');
local TeamType = Enum:getTable('TeamType')
function CardModel:ctor()
	self:clearAll()
end

function CardModel:clearAll(  )
	self.cardList = {};
	self.cardNoList = {};
	self.cardDefTypeList = {};
	self.cardRecord = {};
	self.cardLvAllTableData = {};
	self.allGetCard = {};
	self.allGetCardRewardState = {};
	self.cardStarConditionTableData = {};
	self.cardBreakTableData = {};
	self.tempMsg = {};
	self.tempOldPro = {};
	self.newCardNo = {}; --新获得的角色no
	self.maxLevel = 0;
	self.cardAvatarList = {};
	self.cardAvatarNo2Aid = {};
	self.cardLoveData = {};
	self.cardLoveIdByRoleId = {};
end
function CardModel:Init(msg)
	self:clearAll();
	for k, v in pairs(msg) do
		self.cardList[v.pid] = v;
		if self.cardList[v.pid].quality == 0 then
			local quality = ResTable:getValue('role', v.no,'quality');
			self.cardList[v.pid].quality = quality or 3;
		end
		self:addCardStarActiveStateList(v);
	end

	self.maxLevel = 0;
	self.cardBreakTableData = {};
	for _k , breakData in pairs(ResTable:getTable('role_grade').contain) do
		self.cardBreakTableData[breakData.grade] = breakData;
		if self.maxLevel < breakData.lv_limit then
			self.maxLevel = breakData.lv_limit;
		end
	end

	ResTable:getTable('role_lv')
	ResTable:getTable('role_star_attribute')
	ResTable:getTable('role_grade_attribute')

	self.cardStarConditionTableData = {};
	for _k , conditionData in pairs(ResTable:getTable('role_star').contain) do
		if not self.cardStarConditionTableData[conditionData.def_type] then
			self.cardStarConditionTableData[conditionData.def_type] = {};
		end

		self.cardStarConditionTableData[conditionData.def_type][conditionData.star] = conditionData;
	end

end

function CardModel:changeCardFutureLv(pid, flv)
	if self.cardList[pid] then
		if flv<1 then
			if self.cardList[pid].oriLv then
				self.cardList[pid].level = self.cardList[pid].oriLv
				self.cardList[pid].oriLv = nil
			end
		else
			if self.cardList[pid].oriLv==nil then
				self.cardList[pid].oriLv = self.cardList[pid].level
			end
			local minLv = 1
			if self.cardList[pid].quality==3 then
				minLv = QUALITY_3_MAX_LEVEL
			elseif self.cardList[pid].quality==4 then
				minLv = QUALITY_4_MAX_LEVEL
			elseif self.cardList[pid].quality >=5 then
				minLv = QUALITY_5_MAX_LEVEL
			end
			self.cardList[pid].level = flv>minLv and minLv or flv;
		end

	end
end

function CardModel:changeCardFutureBreakLv(pid, blv,flv)
	if self.cardList[pid] then
		if blv<1 then
			if self.cardList[pid].oriBLv then
				self.cardList[pid].break_lv = self.cardList[pid].oriBLv
				self.cardList[pid].oriBLv = nil
			end
		else
			if self.cardList[pid].oriBLv==nil then
				self.cardList[pid].oriBLv = self.cardList[pid].break_lv
			end

			-- local minLv = 1
			-- if self.cardList[pid].quality==3 then
			-- 	minLv = QUALITY_3_MAX_LEVEL
			-- elseif self.cardList[pid].quality==4 then
			-- 	minLv = QUALITY_4_MAX_LEVEL
			-- elseif self.cardList[pid].quality >=5 then
			-- 	minLv = QUALITY_5_MAX_LEVEL
			-- end

			-- blv = 0;
			-- local level = flv>minLv and minLv or flv;
			-- for _k , gradeData in pairs(ResTable:getTable('role_grade').contain) do
			-- 	if gradeData.lv_min < level and level <= gradeData.lv_limit then
			-- 		blv = gradeData.grade
			-- 		break;
			-- 	end
			-- end
			self.cardList[pid].break_lv = blv;
		end

	end
end

function CardModel:setFutureOriLeveAndBreak(pid,oriLv,oriBLv)
	if self.cardList[pid] then
		self.cardList[pid].oriLv = oriLv
		self.cardList[pid].oriBLv = oriBLv
	end
end

function CardModel:isFutureCard(pid)
	if self.cardList[pid] then
		if self.cardList[pid].oriLv and self.cardList[pid].oriLv>=1 then
			return true;
		end
	end
	return false;
end

function CardModel:getMax4LvCard()
	local tmpList = {}
	for k,v in pairs(self.cardList) do
		table.insert(tmpList, v)
	end
	if #tmpList > 1 then
		table.sort(tmpList , function(first , second)
			local firstLv = first.oriLv and first.oriLv or first.level;
			local secondLv = second.oriLv and second.oriLv or second.level;
			local firstBLv = first.oriBLv and first.oriBLv or first.break_lv;
			local secondBLv = second.oriBLv and second.oriBLv or second.break_lv;

			if firstLv == secondLv then
				return firstBLv > secondBLv;
			else
				return firstLv > secondLv;
			end

			-- if first.level == second.level then
			-- 	return first.break_lv > second.break_lv;
			-- else
			-- 	return first.level > second.level;
			-- end
		end);
	end
	local ret = {}
	local level = 0
	for i=1,4 do
		if tmpList[i] then
			table.insert(ret, tmpList[i].pid)
			if tmpList[i].oriLv then
				level = tmpList[i].oriLv
				self:changeCardFutureLv(tmpList[i].pid, 0)
			else
				level = tmpList[i].level
			end
		else
			table.insert(ret, -1)
		end
	end
	return ret, level

end

function CardModel:InitAllGetCard(msg)
	if msg then
		self.allGetCard = {};                                                                                                                                                                                                                                                                                                                            
		self.allGetCardRewardState = {};
		if msg.get_card then
			for index , roleId in pairs(msg.get_card) do
				self.allGetCard[tonumber(roleId)] = 1;
			end
		end

		if msg.get_card_reward_state then
			for index , roleId in pairs(msg.get_card_reward_state) do
				self.allGetCardRewardState[tonumber(roleId)] = 1;
			end
		end
	end
end


function CardModel:InitGetCardRecord(getCardRecord)
	if getCardRecord then
		for rank , data in pairs(getCardRecord) do 
			self.cardRecord[tonumber(rank)] = data;
		end
	end
	for _k , data in pairs(ResTable:getTable('role').contain) do
		local rank = ResTable:getValue('role_pre' , data.role_id , 'rank');
		if not self.cardLvAllTableData[rank] then
			self.cardLvAllTableData[rank] = {};
			self.cardLvAllTableData[rank].num = 0;
			self.cardLvAllTableData[rank].idList = {};
		end
		if not self.cardLvAllTableData[rank].idList[data.role_id] then
			self.cardLvAllTableData[rank].num = self.cardLvAllTableData[rank].num + 1;
			self.cardLvAllTableData[rank].idList[data.role_id] = data;
		end
	end
end

function CardModel:addEventRobotCard( cards )
	if not cards then
		return;
	end
	
	for _k , card in pairs(cards) do
		self.cardList[card.pid] = card;
		self:addCardStarActiveStateList(card);
		local roleData = ResTable:getRowData('role' , card.no);

		if card.quality == nil then
			self.cardList[card.pid].quality = roleData.quality;
		end

		local roleResData = ResTable:getRowData('role_resource', roleData.resource_id)
		DownloadControler:checkNeedDownloadSpineModel(roleResData.model)

	end
end

function CardModel:removeAllEventRobotCard()
	local ret = {}
	for k,v in pairs(self.cardList) do
		if k>=5000 and k<6000 then
			table.insert(ret, v)
			self.cardList[k] = nil;
		end
	end
	return ret;
end

function CardModel:isEventRobotCard(pid)
	if pid and pid >= 5000 and pid < 6000 then
		return true;
	end
	return false;
end

function CardModel:onAddCard(cards)
	if not cards then
		return;
	end
	
	self.newCardNo = {};
	for _k , card in pairs(cards) do
		self.cardList[card.pid] = card;
		self:addCardStarActiveStateList(card);
		local roleData = ResTable:getRowData('role' , card.no);
		local roleRank = ResTable:getValue('role_pre' , roleData['role_id'] , 'rank');

		self.cardList[card.pid].quality = roleData.quality;

		local haveLvCard = false;
		if self.cardRecord[roleRank] then
			for _ , rId in pairs(self.cardRecord[roleRank]) do
				if rId == roleData['role_id'] then
					haveLvCard = true;
					break;
				end
			end
		end

		if not haveLvCard then
			if not self.cardRecord[roleRank] then
				self.cardRecord[roleRank] = {};
			end

			table.insert(self.cardRecord[roleRank] , roleData['role_id']);
		end

		if not self.allGetCard[roleData['role_id']] then
			self.allGetCard[tonumber(roleData['role_id'])] = 1;
			table.insert(self.newCardNo , roleData['role_id']);
			--local name = ResTable:getValue('role_info' , roleData['role_id'] , 'name');
			--Prompt:Show(string.format(LANG.UI_CARD_48 , (name and tostring(name) or '')));
		end

		local roleResData = ResTable:getRowData('role_resource', roleData.resource_id)
		DownloadControler:checkNeedDownloadSpineModel(roleResData.model)

	end

	local num = 0
	for k,v in pairs(self.cardList) do
		num = num + 1
		if num >=5 then
			break;
		end
	end
	if num<=4 then
		model.FutureCardModel:makeMax4Card()
	end

	EventManager:FireEvent(EventType.UIHeadeUpdateCardBookRedDot);
end

function CardModel:showNewCardIcon()
	for _k , no in ipairs(self.newCardNo) do
		local name = ResTable:getValue('role_info' , no , 'name');
		Prompt:Show(string.format(LANG.UI_CARD_48 , (name and tostring(name) or '')) , Enum:getTable('PromptShowType').SHOW_TYPE_TWO);
	end
	self.newCardNo = {};
end
 
function CardModel:onAddNewCard(msg)
	if not msg then
		return;
	end
	print('fubin---这个函数没用了2')
	for k, v in pairs(msg) do
		for _k , card in pairs(v) do
			self.cardList[card.pid] = card;
			self:addCardStarActiveStateList(card);
		end
	end
end

function CardModel:getCardMaxLevel()
	return self.maxLevel;
end

function CardModel:getMinimumPidCard()
	local curPid = -1;
	for pid , card in pairs(self.cardList) do
		if curPid == -1 or curPid > pid then
			curPid = pid;
		end
	end
	return self.cardList[curPid];
end

function CardModel:GetCard(pid)
	if pid == nil  then
		return nil;
	end
	return self.cardList[pid];
end

function CardModel:GetAllCard()
	return self.cardList;
end

function CardModel:GetFirstCard()
	local pid = 99999;
	for k, v in pairs(self.cardList) do
		if k < pid then
			pid = k;
		end
	end
	return pid;
end

function CardModel:getCardListById( aimRoleId ,sortedByQuality)
	sortedByQuality = sortedByQuality or false;
	local roleList = {};
	local quality = {};
	for k, v in pairs(self.cardList) do
		local role_id = ResTable:getValue('role', v.no, 'role_id');
		if role_id == aimRoleId then
			if sortedByQuality  then
				--local role_quality = ResTable:getValue('role', v.no, 'quality');
				table.insert( roleList,{
					pid = v.pid,
					quality = v.quality
					--quality = role_quality
				} )
			else
				table.insert(roleList,{
					pid =  v.pid
				});
			end
		end

	end
	if sortedByQuality then
		table.sort( roleList,function ( item1,item2 )
			return item1.quality > item2.quality;
		end )
	end
	return roleList;
end

function CardModel:HaveCard(pid)
	if self.cardList[pid] then
		return true;
	else
		return false;
	end
end

--カードの入手
function CardModel:AddCard(msg)
	if not msg then
		return;
	end
	print('fubin---这个函数没用了1')
	for k, v in pairs(msg) do
		self.cardList[v.pid] = v;
		self:addCardStarActiveStateList(v);
	end
end

function CardModel:addCardStarActiveStateList(card)
	if not self.cardNoList[card.no] then
		self.cardNoList[card.no] = {};
		self.cardNoList[card.no].num = 0;
	end
	self.cardNoList[card.no][card.pid] = 1;
	self.cardNoList[card.no].num = self.cardNoList[card.no].num + 1;

	self:updateCardDefTypeList(card);
end

function CardModel:removeCardStarActiveStateList(card)
	if self.cardNoList[card.no] then
		self.cardNoList[card.no][card.pid] = nil;
		self.cardNoList[card.no].num = self.cardNoList[card.no].num - 1;
	end
	self:updateCardDefTypeList(card , true);
end

function CardModel:updateCardDefTypeList(card , remove)
	local rolePreData = ResTable:getRowData('role_pre', card.no);

	if remove then
		if self.cardDefTypeList[card.star_lv] and self.cardDefTypeList[card.star_lv][rolePreData.def_type] and self.cardDefTypeList[card.star_lv][rolePreData.def_type][card.pid] then
			self.cardDefTypeList[card.star_lv][rolePreData.def_type][card.pid] = nil;
		end
	else
		if not self.cardDefTypeList[card.star_lv] then
			self.cardDefTypeList[card.star_lv] = {};
		end
		if not self.cardDefTypeList[card.star_lv][rolePreData.def_type] then
			self.cardDefTypeList[card.star_lv][rolePreData.def_type] = {};
		end
		self.cardDefTypeList[card.star_lv][rolePreData.def_type][card.pid] = 1;
	end
end

function CardModel:removeCard(pid)
	if self.cardList[pid] then
		self:removeCardStarActiveStateList(self.cardList[pid]);
		self.cardList[pid] = nil;
	end
end

function CardModel:setCardPromotion(pid , promotion)
	if self.cardList[pid] then
		self.cardList[pid].promotion = promotion;
	end
end

function CardModel:setHp(pid , hp)
	if self.cardList[pid] then
		self.cardList[pid].hp = hp;
	end
end

function CardModel:updateHps(data)
	for k, v in pairs(data) do
		self:setHp(v.pid, v.hp);
	end
end

function CardModel:updateEventHps(data)
	for k, v in pairs(data) do
		self:setEventHp(v.pid, v.event_hp, v.event_cd);
	end
end

function CardModel:setEventHp(pid , event_hp, event_cd)
	local ret = false;
	if self.cardList[pid] then
		if self.cardList[pid].event_hp <= 0 then
			ret = true;
		end
		self.cardList[pid].event_hp = event_hp;
		if event_cd then
			self.cardList[pid].event_cd = event_cd;
		end
	end
	return ret;
end

function CardModel:resetEventALLCardHP()
	for k,v in pairs(self.cardList) do
		self.cardList[k].event_hp = 10000;
	end
end

function CardModel:getEventHp(pid)
	if self.cardList[pid] then
		return self.cardList[pid].event_hp or 0;
	end
	return 0;
end	

function CardModel:setEventCD(pid , cd)
	if self.cardList[pid] then
		self.cardList[pid].event_cd = cd;
	end
end

function CardModel:getEventCD(pid)
	if self.cardList[pid] then
		return self.cardList[pid].event_cd or 0;
	end
	return 0;
end	

function CardModel:getCardRecord(rank)
	return self.cardRecord[rank];
end

function CardModel:getCardLvAllTableData(rank)
	return self.cardLvAllTableData[rank];
end

function CardModel:getAllGetCard()
	return self.allGetCard;
end

function CardModel:getAllGetCardRewardState()
	return self.allGetCardRewardState;
end

function CardModel:updateCardGetRewardState(no)
	self.allGetCardRewardState[no] = 1;
end

function CardModel:updateLevel(pid , level)
	if self.cardList[pid] and level then
		self.cardList[pid].level = level;
	end
end

function CardModel:updateCardQuality(pid , quality)
	if self.cardList[pid] and quality then
		self.cardList[pid].quality = quality;
	end
end

function CardModel:updateStarLevel(pid , star_lv)
	if self.cardList[pid] and star_lv then
		if self.cardList[pid].star_lv ~= star_lv then
			self:updateCardDefTypeList(self.cardList[pid] , true);
			self.cardList[pid].star_lv = star_lv;
			self:updateCardDefTypeList(self.cardList[pid]);
		end
	end
end

function CardModel:setStarBreakTempData(msg , oldPro)
	if msg then
		self.tempMsg = msg;
	end

	if oldPro then
		self.tempOldPro = oldPro;
	end
end

function CardModel:getStarBreakTempData()
	return self.tempMsg , self.tempOldPro;
end

function CardModel:getCardStarConditionTableData(defType , star)
	if self.cardStarConditionTableData[defType] then
		return self.cardStarConditionTableData[defType][star];
	end
	return nil;
end

function CardModel:getCardBreakTableData(lv)
	return self.cardBreakTableData[lv];
end

function CardModel:updateBreakLevel(pid , break_lv)
	if self.cardList[pid] and break_lv then
		if self.cardList[pid].oriBLv then
			self.cardList[pid].oriBLv = break_lv
		else
			self.cardList[pid].break_lv = break_lv;
		end
	end
end

function CardModel:getCardBookActiveState()

	for no , v in pairs(self.allGetCard) do
		if not self.allGetCardRewardState[no] then
			return true;
		end
	end
	return false;
end

function CardModel:getCardAcitveState()
	local show = self:getTeamActiveState();
	if not show then
		show = model.EquipModel:getTeamSlotEquipActiveState();
	end
	if not show then
		show = self:IsHaveLive2dInAll();
	end
	return show
end

function CardModel:getTeamActiveState(pid)
	local team = model.TeamModel:getCurrentTeam();
	for pos , teamPid in pairs(team) do
		if teamPid ~= -1 then
			if nil ~= pid then
				if teamPid == pid then
					return self:getActiveState(pid , pos);
				end
			else
				local curState = self:getActiveState(teamPid , pos);
				if curState then
					return true;
				end
			end
		end
	end
	return false;
end

function CardModel:getActiveState(pid , pos)
	if pid then
		local data = self.cardList[pid];
		if not data then
			return;
		end

		local isBreak = false;
		local nextBreakData = self:getCardBreakTableData(data.break_lv+1);
		if data.break_lv < 6 and nextBreakData then
			if data.level >= nextBreakData.lv_needed and data.level <= nextBreakData.lv_limit then
				if data.star_lv >= nextBreakData.star_needed then
					if model.MoneyModel:isEnough(nextBreakData.coin_cost) and model.ItemModel:getItemNum(BREAK_MONEY) >= nextBreakData.item_cost then
						return true;
					end
				end
				isBreak = true;
			end
		end

		if not isBreak then
			local curBreakData = self:getCardBreakTableData(data.break_lv);
			local lvUpData = ResTable:getMultiValue('role_lv', data.no, (data.level+1))
			if data.break_lv == 0 or data.level < curBreakData.lv_limit then
				if model.MoneyModel:isEnough(lvUpData.cost) and model.ItemModel:getItemNum(CARD_LEVEL_UP_EXP) >= lvUpData.exp then
					return true;
				end
			end
		end

	end
	return false;
end

function CardModel:getCardStarActiveState(pid)

	if not self.cardList[pid] then
		return false , 0 , 0 , 0;
	end

	local card = self.cardList[pid];

	if card.quality < 4 or
	  (card.quality < 5 and card.star_lv >= CARD_STAR_SSR_MAX_LEVEL) or
	  (card.quality >= 5 and card.star_lv >= CARD_STAR_MAX_LEVEL) then
		return false,0,0,0;
	end
	
	local mainNum , secondNum = 0 , 0;
	
	local rolePreData = ResTable:getRowData('role_pre', card.no);
	local starConditionData = model.CardModel:getCardStarConditionTableData(rolePreData.def_type , card.star_lv + 1);

	local isEnough = true;
	local mainTotalNum = 0;
	local secondTotalNum = 0;
	if starConditionData then

		if starConditionData.cost_item then
			for _k , item in ipairs(starConditionData.cost_item) do
				local haveNum = model.ItemModel:getItemNum(item[1]);
				if haveNum < item[2] then
					isEnough = false;
					break;
				end
			end
		end

		local pidList = {};
		if starConditionData.cost_main and starConditionData.cost_main[1] then
			mainTotalNum = starConditionData.cost_main[1][2];
			local star = starConditionData.cost_main[1][1];
			if self.cardNoList[card.no] then
				for _pid , _ in pairs(self.cardNoList[card.no]) do
					local card = self:GetCard(_pid);
					if card and card.star_lv == star and _pid ~= pid and not self:isInOtherModule(_pid) then
						pidList[_pid] = 1;
					end
				end
			end
		end

		if starConditionData.cost_other and starConditionData.cost_other[1] then
			for _k , costOtner in pairs(starConditionData.cost_other) do
				local defType = costOtner[1];
				local star = costOtner[2];
				local num = costOtner[3];
				secondTotalNum = secondTotalNum + num;
				local curNum = 0;
				local samePid = {};
				
				if self.cardDefTypeList[star] then
					local allPids = {};
					if defType == 0 then --任意类型
						for _k , starPids in pairs(self.cardDefTypeList[star]) do
							for _pid , _k in pairs(starPids) do
								allPids[_pid] = _k;
							end
						end
					elseif self.cardDefTypeList[star][defType] then
						allPids = self.cardDefTypeList[star][defType];
					end
					
					for defTypePid , _ in pairs(allPids) do
						if pid ~= defTypePid and not self:isInOtherModule(defTypePid) then
							if not pidList[defTypePid] then --不属于主卡列表里
								curNum = curNum + 1;
							else --属于主卡列表里
								table.insert(samePid , defTypePid);
							end

							if curNum >= num then
								break;
							end
						end
					end
				end

				if curNum < num then
					for _k , sPid in pairs(samePid) do --副卡不够用主卡补满
						curNum = curNum + 1;
						pidList[sPid] = nil;
						if curNum >= num then
							break;
						end
					end
				end
				secondNum = secondNum + curNum;
			end
		end

		mainNum = #table.keys(pidList); --重新计算主卡数量
		mainNum  = mainNum > mainTotalNum and mainTotalNum or mainNum;
	end



	if isEnough then
		if mainTotalNum == 0 and secondTotalNum == 0 then
			isEnough = false;
		elseif mainTotalNum > 0 and secondTotalNum > 0 then
			isEnough = mainNum >= mainTotalNum and secondNum >= secondTotalNum;
		elseif mainTotalNum > 0 and secondTotalNum <= 0 then
			isEnough = mainNum >= mainTotalNum;
		elseif mainTotalNum <= 0 and secondTotalNum > 0 then
			isEnough = secondNum >= secondTotalNum;
		end
	end
	print(isEnough , mainNum , secondNum , mainTotalNum , secondTotalNum);
	return isEnough , mainNum , secondNum , (mainTotalNum+secondTotalNum);

end

function CardModel:getCardByNo(no)
	return self.cardNoList[no] or {};
end

function CardModel:getCardDefTypeList(star , defType)
	if not star or not defType then
		return {};
	end

	if defType == 0 then
		return self.cardDefTypeList[star] or {};
	else
		if self.cardDefTypeList[star] and self.cardDefTypeList[star][defType] then
			return self.cardDefTypeList[star][defType];
		end
	end

	return {};
end

function CardModel:getRedDotStateCardFooter(  )
	-- if self:getLockStateCard() then
	-- 	return false;
	-- end

	return self:getTeamActiveState()
end

function CardModel:getRedDotStateCard( ... )
	if self:getLockStateCard() then
		return false;
	end
    print("未完成！！！！！！！！！！！！！")

	return true;
end
-- 融合中心
function CardModel:getLockStateCard(  )
    return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_15);		
end
--重构中心
function CardModel:getLockStateCardCompose(  )
    return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_17);		
end

function CardModel:checkFpUp(pid , oldFp  , notShowFpUp)

	if not pid or not oldFp then
		return;
	end

	if not notShowFpUp then
		local newFp = CardProManager:GetCardPro(pid).fp;
		newFp = ConvertDigitUnitToStr(tostring(newFp));
		oldFp = ConvertDigitUnitToStr(tostring(oldFp));
		
		if true or HpCompare(newFp , '>' , oldFp) then
			FpUpPanel:Show(oldFp , newFp);
		end
	end

	local newTeamFp = model.TeamModel:getCurrentTeamFp()
	model.UserModel:checkTopPower(newTeamFp);

end

function CardModel:isInOtherModule(pid)
	local cardTeamState = {};
	if model.TeamModel:isRoleInTeam(pid) then
		table.insert(cardTeamState , CardTeamState.FIGHT)
	end

	if model.TeamModel:isRoleInEventTeam(pid) then
		table.insert(cardTeamState , CardTeamState.EVENT)
	end

	if model.TeamModel:isRoleInArenaTeam(pid) then
		table.insert(cardTeamState , CardTeamState.ARENA)
	end

	if model.TeamModel:isRoleInGuildTeam(pid) then
		table.insert(cardTeamState , CardTeamState.GUILD_BOSS)
	end

	if model.TeamModel:isRoleInTrialTeam(pid) then
		table.insert(cardTeamState , CardTeamState.TRIAL)
	end

	if self:isFutureCard(pid) then
		table.insert(cardTeamState , CardTeamState.Future)
	end

	return #cardTeamState > 0 , cardTeamState;
end

function CardModel:isHaveAvatar( no )
	local role_avatar = ResTable:getValue('role', no, 'avatar_id');
	if role_avatar and next(role_avatar) ~= nil then
		return true;
	end
	return false;
end

function CardModel:getAvatarResList( roleId , isGetedAvatar)
	local ret = {};
	local roleData = ResTable:getRowData('role', roleId);
	if roleData then

		table.insert(ret, roleData.resource_id)

		if roleData.avatar_id and next(roleData.avatar_id) ~= nil then

			for i,v in ipairs(roleData.avatar_id) do
				local isInsert = true
				local avatar_resId = ResTable:getValue('role_avatar', v, 'resource_id');
				if isGetedAvatar then
					isInsert = self:onIsHaveAvatarByAvatarItemId(avatar_resId);
				end
				if isInsert then
					table.insert(ret, avatar_resId)
				end
			end
		end
	end

	return ret;
	
end

function CardModel:IsHaveNewAvatar( roleId )
	-- body
	local checkList = self:getAvatarResList( roleId, true )
	for k,v in pairs(checkList) do
		if k ~= 1 then
			local ret = model.UserDefaultModel:getDataByKey( 'avatar_'..v )
			if ret ~= 1 then
				return true
			end
		end
	end
	return false;

end

function CardModel:IsHaveLive2d(pid)
	-- body
	local resId = self:getCardResIdByPid(pid)
	if resId>0 then
		local spinePath = ResTable:getValue('role_resource', res_id, 'spine')
		if spinePath then
			if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
				return true
			else
				return false
			end
		end
	end
	return true
end

function CardModel:IsHaveLive2dInAll()
	for k,v in pairs(self.cardList) do
		if self:IsHaveLive2d(k) then
			return false
		end
	end
	return true
end

function CardModel:getCardResIdByPid( pid )
	-- body
	if not self.cardList[pid] then
		return 0;
	end

	if self.cardList[pid].aid and self.cardList[pid].aid ~= 0 then
		--返回avatar皮肤的资源id
		if self:onIsHaveAvatarId(self.cardList[pid].aid) then
			local avatarItemId = self.cardAvatarList[ self.cardList[pid].aid ].no;
			return ResTable:getValue('role_avatar', avatarItemId, 'resource_id')
		end
	end

	local resource_id = ResTable:getValue('role', self.cardList[pid].no, 'resource_id');
	return resource_id;

end

function CardModel:getCardAvatar(aid)
	return self.cardAvatarList[aid];
end

function CardModel:getAllAvatar()
	return self.cardAvatarList;
end

function CardModel:getCardSkillIdByPid( pid )
	-- body
	if not self.cardList[pid] then
		return 0;
	end

	if self.cardList[pid].aid and self.cardList[pid].aid ~= 0 then
		--返回avatar皮肤的资源id
		if self:onIsHaveAvatarId(self.cardList[pid].aid) then
			local avatarItemId = self.cardAvatarList[ self.cardList[pid].aid ].no;
			return ResTable:getValue('role_avatar', avatarItemId, 'skill_id')
		end
	end

	local skill_id = ResTable:getValue('role', self.cardList[pid].no, 'skill_id');
	return skill_id;

end

function CardModel:getCardResIdByRoldId( roleId )
	-- body
	local resource_id = ResTable:getValue('role', roleId, 'resource_id');
	return resource_id;
end

function CardModel:initAvatarData( avatarDatas )
	-- body
	for k, v in pairs(avatarDatas) do
		self.cardAvatarList[v.aid] = v;

		if self.cardAvatarNo2Aid[v.no] then
			if self.cardAvatarNo2Aid[v.no].overdue_time < v.overdue_time or v.overdue_time==0 then
				self.cardAvatarNo2Aid[v.no] = v;
			end
		else
			self.cardAvatarNo2Aid[v.no] = v;
		end
		
	end
end

function CardModel:onAddAvatar( avatarDatas )
	-- body
	if not avatarDatas then
		return;
	end
	-- self.newAvatarNo = {};
	-- 可能会提示 获得了新的 皮肤， 查看后 去掉提示 
	for k, v in pairs(avatarDatas) do
		self.cardAvatarList[v.aid] = v;

		if self.cardAvatarNo2Aid[v.no] then
			if self.cardAvatarNo2Aid[v.no].overdue_time < v.overdue_time or v.overdue_time==0 then
				self.cardAvatarNo2Aid[v.no] = v;
			end
		else
			self.cardAvatarNo2Aid[v.no] = v;
		end
	end
	
end

function CardModel:onAvatarChange( msg )
	-- body
	if msg then
		if msg.pid and self.cardList[msg.pid] then
			self.cardList[msg.pid].aid = msg.aid;
		end
	end
end

function CardModel:onGetAvatarData( avatarItemId )
	-- body
	local aid = self:getMaxAvatarByItemId( avatarItemId );
	if self.cardAvatarList[aid] then
		return self.cardAvatarList[aid];
	end
	return nil;
end

function CardModel:onIsHaveAvatarId( aid )
	
	if self.cardAvatarList[aid] and (self.cardAvatarList[aid].overdue_time > os.time() or self.cardAvatarList[aid].overdue_time==0) then
		return true;
	end
	return false;
end

function CardModel:onIsHaveAvatarByAvatarItemId( no )
	-- body
	if self.cardAvatarNo2Aid[no] then
		return self:onIsHaveAvatarId( self.cardAvatarNo2Aid[no].aid );
	else
		return false;
	end

end

function CardModel:getMaxAvatarByItemId( itemId )
	-- body
	if self.cardAvatarNo2Aid[itemId] then
		return self.cardAvatarNo2Aid[itemId].aid;
	else
		return -1;
	end
end

function CardModel:updateCardBareCollect(pid,bareId, idx)
	if self.cardList[pid] then
		if idx == 2 then
			self.cardList[pid].bare_id_2 = bareId;
		else
			self.cardList[pid].bare_id = bareId;
		end
	end
end

function CardModel:getCanLevelUpAndSoOn( pid )
	-- body
	local card = self:GetCard(pid);
	local curBreakData = model.CardModel:getCardBreakTableData(card.break_lv);
	local isBreak = false;
	local nextBreakData = model.CardModel:getCardBreakTableData(card.break_lv+1);
	if card.break_lv < 6 and nextBreakData then
		if card.level >= nextBreakData.lv_needed and card.level <= nextBreakData.lv_limit then
			-- if card.star_lv >= nextBreakData.star_needed then
			-- end
			isBreak = true;--可以突破
		end
	end

	local maxLevel = 0;
	if curBreakData then
		maxLevel = curBreakData.lv_limit;
	else
		maxLevel = nextBreakData.lv_needed;
	end

	if card.level < maxLevel then --可以升级
		return 1
	end
	if isBreak then --可以突破
		return 2
	end
	return 3 --可以升星

end

function CardModel:initLove(loveData)
	loveData = loveData or {};
	local haveLoveData = {};
	for _k , data in pairs(loveData) do
		haveLoveData[data[1]] = data;
	end

	local loveTableData = ResTable:getTable('role_love').contain;

	self.cardLoveData = {};
	self.cardLoveIdByRoleId = {};
	local haveLoveId = {};
	for _k , data in pairs(loveTableData) do
		if not haveLoveId[data.love_id] then
			haveLoveId[data.love_id] = 1;
			if not self.cardLoveIdByRoleId[data.role_id] then
				self.cardLoveIdByRoleId[data.role_id] = {};
			end
			table.insert(self.cardLoveIdByRoleId[data.role_id],data.love_id);
		end
		if not self.cardLoveData[data.love_id] then
			self.cardLoveData[data.love_id] = {};
			self.cardLoveData[data.love_id].loveId = data.love_id;
			self.cardLoveData[data.love_id].roleId = data.role_id;
			self.cardLoveData[data.love_id].loveLevel = haveLoveData[data.love_id] and haveLoveData[data.love_id][2] or 0;
			self.cardLoveData[data.love_id].loveValue = haveLoveData[data.love_id] and haveLoveData[data.love_id][3] or 0;
			self.cardLoveData[data.love_id].loveData = {};

			self.cardLoveData[data.love_id].love_state = haveLoveData[data.love_id] and haveLoveData[data.love_id][4] or {};
			
		end
		self.cardLoveData[data.love_id].loveData[data.love_lv] = data;
	end
end

function CardModel:getLoveData(lovelId)
	if lovelId then
		return self.cardLoveData[lovelId];
	end
	return self.cardLoveData;
end

function CardModel:getLoveDataByRoleId(roleId , loveId)
	local loveIds = self.cardLoveIdByRoleId[roleId];
	if not loveIds then
		return nil;
	end
	
	if loveId then
		for _k , id in pairs(loveIds) do
			if loveId == id then
				return self.cardLoveData[id];
			end
		end
	else
		local data = {};
		for _k , id in pairs(loveIds) do
			table.insert(data,self.cardLoveData[id]);
		end
		return data;
	end

	return nil;
end

function CardModel:updateLoveValue(lovelId , loveLevel , loveValue, pos)
	if self.cardLoveData[lovelId] then
		self.cardLoveData[lovelId].loveLevel = loveLevel;
		self.cardLoveData[lovelId].loveValue = loveValue;
		if pos > 0 then
			table.insert( self.cardLoveData[lovelId].love_state, pos )
		else
			self.cardLoveData[lovelId].love_state = {}
		end
	end
end

function CardModel:updateCardLoveWear(pid,loveId)
	if self.cardList[pid] then
		self.cardList[pid].love_id = loveId;
	end
end

function CardModel:sortPid(pid1, pid2, teamType)
	--优先级：特殊功能l临时加入（如雇佣）>队伍中>等级>突破等级>星级>品质>颜色>role_id倒序
	-- 0 比较是否是雇佣的机器人（event活动）
	local isRob1 = pid1>=5000 and pid1<6000;
	local isRob2 = pid2>=5000 and pid2<6000;
	if isRob1 ~= isRob2 then
		return isRob1;
	end

	-- 1 比较是否在编队，在编队返回index，不在编队返回-1
	local pidInTeam1 = false;
	local pidInTeam2 = false;
	if teamType == TeamType.EVENT then
		pidInTeam1 = model.TeamModel:isRoleInEventTeam(pid1)
		pidInTeam2 = model.TeamModel:isRoleInEventTeam(pid2)
	elseif teamType == TeamType.ARENA then
		pidInTeam1 = model.TeamModel:isRoleInArenaTeam(pid1)
		pidInTeam2 = model.TeamModel:isRoleInArenaTeam(pid2)
	elseif teamType == TeamType.GUILD_BOSS then
		pidInTeam1 = model.TeamModel:isRoleInGuildTeam(pid1)
		pidInTeam2 = model.TeamModel:isRoleInGuildTeam(pid2)
	elseif teamType == TeamType.TRIAL_R or teamType == TeamType.TRIAL_G or teamType == TeamType.TRIAL_B then
		pidInTeam1 = model.TeamModel:isRoleInTrialTeam(pid1)
		pidInTeam2 = model.TeamModel:isRoleInTrialTeam(pid2)
	elseif teamType == TeamType.ARENA_1 or teamType == TeamType.ARENA_2 or teamType == TeamType.ARENA_3 then
		pidInTeam1 = model.TeamModel:isRoleInArenaMulTeam(pid1)
		pidInTeam2 = model.TeamModel:isRoleInArenaMulTeam(pid2)
	elseif teamType == TeamType.STORY then
		pidInTeam1 = model.TeamModel:isRoleInTeam(pid1, TeamType.STORY)
		pidInTeam2 = model.TeamModel:isRoleInTeam(pid2, TeamType.STORY)
	else
		pidInTeam1 = model.TeamModel:isRoleInTeam(pid1)
		pidInTeam2 = model.TeamModel:isRoleInTeam(pid2)
	end
	if teamType ~= -1 then --等于 -1 是 不使用这个判断
		if pidInTeam1 ~= pidInTeam2 then
			return pidInTeam1;
		end
	end

	local card1Data = self:GetCard(pid1);
	local card2Data = self:GetCard(pid2);

	if card1Data.level ~= card2Data.level then
		return card1Data.level >  card2Data.level
	end

	if card1Data.break_lv ~= card2Data.break_lv then
		return card1Data.break_lv >  card2Data.break_lv
	end

	if card1Data.star_lv ~= card2Data.star_lv then
		return card1Data.star_lv >  card2Data.star_lv
	end

	if card1Data.quality ~= card2Data.quality then
		return card1Data.quality >  card2Data.quality
	end

	local role1Data = ResTable:getRowData('role', card1Data.no);
	local role2Data = ResTable:getRowData('role', card2Data.no);
	local role1Pre = ResTable:getRowData('role_pre', role1Data.role_id);
	local role2Pre = ResTable:getRowData('role_pre', role2Data.role_id);
	if role1Pre.def_type ~= role2Pre.def_type then
		return role1Pre.def_type <  role2Pre.def_type
	end

	return card1Data.no > card2Data.no;
end

function CardModel:sortFuc( cardlist, teamType )
	table.sort( cardlist, function ( pid1, pid2 )
		return self:sortPid( pid1, pid2, teamType )
	end )
	
end

function CardModel:sortFuc2( cardlist, teamType )
	table.sort( cardlist, function ( card1, card2 )
		local pid1 = card1.pid
		local pid2 = card2.pid
		return self:sortPid( pid1, pid2, teamType )
	end )
	
end

return CardModel;
