local ConfigStateModel = class("ConfigStateModel")
local ConfigState = Enum:getTable('ConfigState');
function ConfigStateModel:ctor()
    self:clearAll();
end

function ConfigStateModel:clearAll()
    self.configState = {};
end

function ConfigStateModel:Init(states)
    self:clearAll();
    if states then
        for _k , state in pairs(states) do
            self.configState[state.no] = state.state;
        end
    end
end
--0正常，1关闭，2隐藏
function ConfigStateModel:getStateByName(name)
    if ConfigState[name] then
        local id = ConfigState[name];
        return self:getStateById(id);
    end
    return 0;
end

function ConfigStateModel:getStateById(id)
    if self.configState[id] then
        return self.configState[id];
    end
    return 0;
end

function ConfigStateModel:isVisibleByName(name)
    if ConfigState[name] then
        local id = ConfigState[name];
        return self:isVisibleById(id);
    end
    return true;
end

function ConfigStateModel:isOpenByName(name)
    if ConfigState[name] then
        local id = ConfigState[name];
        return self:isOpenById(id);
    end
    return true;
end

function ConfigStateModel:isOpenById(id)
    if self.configState[id] then
        return self.configState[id] == 0;
    end
    return true;
end

function ConfigStateModel:isVisibleById(id)
    if self.configState[id] then
        return self.configState[id] ~= 2;
    end
    return true;
end
return ConfigStateModel
