local DailyRoundModel = class("DailyRoundModel")

function DailyRoundModel:ctor()
	self.beenInit = false
end

function DailyRoundModel:InitData(msg)
	self.beenInit = true

	self.times = {}
	self.times[1] = msg.num1
	self.times[2] = msg.num2
	self.times[3] = msg.num3

	self.roundPass = {}
	self.roundPass[1] = msg.type1
	self.roundPass[2] = msg.type2
	self.roundPass[3] = msg.type3

	self.isPass = false
	self.fight_type = 1
	self.fight_id = 0
end

function DailyRoundModel:isInit()
	return self.beenInit
end

function DailyRoundModel:reqDailyRoundInfo(  )
	local msg = {}
	Network.NetworkManager:Send(Network.NetworkCmdType.req_daily_round_info, msg);
end

function DailyRoundModel:setCurrentFightInfo( fight_type, isPass, fight_id )
	self.isPass = isPass
	self.fight_type = fight_type
	self.fight_id = fight_id
end

function DailyRoundModel:isCurrentFightPass()
	return self.isPass;
end

function DailyRoundModel:setFightExitData(msg)
	if msg.num1 then
		self.times[1] = msg.num1
	elseif msg.num2 then
		self.times[2] = msg.num2
	elseif msg.num3 then
		self.times[3] = msg.num3
	end

	if msg.new_round > self.roundPass[self.fight_type] then
		self.roundPass[self.fight_type] = msg.new_round
	end
end

function DailyRoundModel:getTimes(index)
	if self.times[index] then
		return self.times[index]
	else
		return 0
	end
end

function DailyRoundModel:setTimes(index, times)
	if self.times[index] then
		self.times[index] = times
	end
end

function DailyRoundModel:getRoundPass(index)
	if self.roundPass[index] then
		return self.roundPass[index]
	else
		return 0
	end
end

function DailyRoundModel:setRoundPass(index, id)
	if self.roundPass[index] then
		self.roundPass[index] = id
	end
end

function DailyRoundModel:getRedDotByTag( tag )
	if self:getLockStateByTag(tag) then
		return false;
	end
	if not self:isInit() then
		self:reqDailyRoundInfo();
		return false;
	end
	if self.times and self.times[tag] and  self.times[tag] > 0 then
		return true; 
	end
	return false;
end

function DailyRoundModel:getRedDotStateDailyRound()

	if RemoveFeatures['DailyRoundPanel'] then
		return false;
	end

	if self:getLockStateDailyRound() then
		return false;
	end
	if not self:isInit() then
		self:reqDailyRoundInfo();
		return false;
	end
	return self:getRedDotByTag(1) or self:getRedDotByTag(2) or self:getRedDotByTag(2);
end

function DailyRoundModel:getLockStateByTag( tag )
	local locked = false;
	local lockLv = 0;

	if tag == nil or tag == -1 then
		return locked,lockLv;
	end
	
	if tag == 1 then
		locked,lockLv = tools.LevelLockTools:checkLockById(1000)

	elseif tag == 2 then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_12)

	elseif tag == 3 then 
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_16)

	end

	return locked,lockLv;
end

function DailyRoundModel:getLockStateDailyRound(  )
    return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_8);		
end


return DailyRoundModel;
