local FutureCardModel = class("FutureCardModel")

function FutureCardModel:ctor()
	self:clearAll();
end
function FutureCardModel:clearAll(  )
	self.futureCardList = {};
	self.futureLevel = 1;
	self.futureBreakLv = 0

	self.max4Cards = {}

end
function FutureCardModel:Init(msg)
	if tools.ConfigStateTools:checkLockByName('FutureCardPanel') then
		return
	end
	self:clearAll();
	self:makeMax4Card();

	for _k , slotData in pairs(ResTable:getTable('altar').contain) do
		local no = slotData.no;
		self.futureCardList[no] = slotData
		if msg.altar_slot[tostring(no)] then
			self.futureCardList[no].unlock = 1
			self.futureCardList[no].pid = msg.altar_slot[tostring(no)]
			self.futureCardList[no].time = 0
			if msg.altar_cd[tostring(no)] then
				self.futureCardList[no].time = msg.altar_cd[tostring(no)]
			end
			if self.futureCardList[no].pid > 0 then
				model.CardModel:changeCardFutureLv( self.futureCardList[no].pid , self.futureLevel)
				model.CardModel:changeCardFutureBreakLv( self.futureCardList[no].pid , self.futureBreakLv,self.futureLevel)
			end
		else
			self.futureCardList[no].unlock = 0
			self.futureCardList[no].pid = -1
			self.futureCardList[no].time = 0
		end
	end
	
end

function FutureCardModel:makeFutureBreakLv()
	-- body
	self.futureBreakLv = 99999;
	-- for _k , gradeData in pairs(ResTable:getTable('role_grade').contain) do
	-- 	if gradeData.lv_min < self.futureLevel and self.futureLevel <= gradeData.lv_limit then
	-- 		self.futureBreakLv = gradeData.grade
	-- 		break;
	-- 	end
	-- end

	for _,v in pairs(self.max4Cards) do
		if v == -1 then
			self.futureBreakLv = 0;
			break;
		else
			local data = model.CardModel:GetCard(v);
			if data and data.break_lv < self.futureBreakLv then
				self.futureBreakLv = data.break_lv;
			end
		end
	end
end

function FutureCardModel:getFutureCardList()
	return self.futureCardList;
end

function FutureCardModel:getFutureCardById(sid)
	return self.futureCardList[sid];
end

function FutureCardModel:makeMax4Card()
	-- body
	if tools.ConfigStateTools:checkLockByName('FutureCardPanel') then
		return
	end
	self.max4Cards, self.futureLevel = model.CardModel:getMax4LvCard()
	self:makeFutureBreakLv()
end

function FutureCardModel:updateFutureCardListLv()
	-- body
	if tools.ConfigStateTools:checkLockByName('FutureCardPanel') then
		return
	end
	for k,v in pairs(self.futureCardList) do
		if v.pid > 0 then
			model.CardModel:changeCardFutureLv( v.pid , self.futureLevel)
			model.CardModel:changeCardFutureBreakLv( v.pid , self.futureBreakLv,self.futureLevel)
		end
	end
end

function FutureCardModel:getMax4LvCard()
	-- body
	if self.max4Cards and next(self.max4Cards) then
		return self.max4Cards, self.futureLevel
	else
		self:makeMax4Card()
		return self.max4Cards, self.futureLevel
	end
end

function FutureCardModel:checkCardRemoveOrRestMax4Cards(pidList)
	-- body
	local st = false
	for _,v in pairs(pidList) do
		if v==self.max4Cards[1] or v==self.max4Cards[2] or v==self.max4Cards[3] or v==self.max4Cards[4] then
			--第一梯队卡 有销毁 或者 重置， 要从 第二梯队 和 第三梯队 补位
			st = true
			break;
		end
	end
	if st == false then
		return
	end

	local oldFutureLevel = self.futureLevel
	self:makeMax4Card()

	for _,v in pairs(self.max4Cards) do
		for k,fcard in pairs(self.futureCardList) do
			if v~=nil and v == fcard.pid and fcard.pid > 0 then
				self:reqUpdateSlot(3, k, fcard.pid)
			end
		end
	end

	self:updateFutureCardListLv()
	if oldFutureLevel ~= self.futureLevel then --更新等级
		self:reqUpdateSlot(4, 0, -1) --只向后台存储当前等级
	end
end

function FutureCardModel:checkUpdateMax4Cards(pid, lv)
	-- body
	if lv > self.futureLevel then
		if pid==self.max4Cards[1] or pid==self.max4Cards[2] or pid==self.max4Cards[3] then
			return
		else
			local oldFutureLevel = self.futureLevel
			self:makeMax4Card()
			if oldFutureLevel ~= self.futureLevel then --更新等级
				self:updateFutureCardListLv()
				self:reqUpdateSlot(4, 0, -1) --只向后台存储当前等级
			end
		end
	end
end

function FutureCardModel:unLockSlot(sid)
	local msg = {};
	msg.altarSlot = sid;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_future_card_unlock , msg);
end

function FutureCardModel:retUnLockSlot(sid)
	if self.futureCardList[sid] then
		self.futureCardList[sid].unlock = 1
		EventManager:FireEvent(EventType.UIFutureCardUpdate,sid);
	end
end

function FutureCardModel:clearSlot(sid)
	local msg = {};
	msg.altarSlot = sid;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_future_card_clear , msg);
end

function FutureCardModel:retClearSlot(sid)
	if self.futureCardList[sid] then
		self.futureCardList[sid].time = 0
		EventManager:FireEvent(EventType.UIFutureCardUpdate,sid);
	end
end

function FutureCardModel:reqUpdateSlot(altarType, altarSlot, pid)
	-- req = {
	-- 	altarType = 1;// 1:往槽上放人，2:正常下人，3:第二梯队变成第一梯队的下人 4：存储等级
	-- 	altarSlot = 1;// 变更槽位
	-- 	pid = 1;//网槽上放人时的pid
	-- 	altarLevel = 1;//祭坛等级
	-- }
	local msg = {};
	msg.altarType = altarType;
	msg.altarSlot = altarSlot;
	msg.pid = pid;
	msg.altarLevel = self.futureLevel;
	msg.breakLevel = self.futureBreakLv;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_future_card_update , msg);
end

function FutureCardModel:retUpdateSlot(msg)
	-- msg = {
	-- 	altar_slot => altarSlot,
	-- 	altar_cd => 0,//正常下人后cd
	-- 	pid => pid,
	-- 	altarType => altarType
	-- }

	if msg.altarType == 1 then
		self:addFutureCard(msg.altar_slot, msg.pid)
		self:showFutureCard(msg.pid)
	elseif msg.altarType == 2 then
		self:removeFutureCard(msg.altar_slot, msg.altar_cd)
	elseif msg.altarType == 3 then
		self:removeFutureCard(msg.altar_slot, msg.altar_cd)
	elseif msg.altarType == 4 then
		--存储等级返回
	end
	
end

function FutureCardModel:showFutureCard(pid)
	local data = model.CardModel:GetCard(pid);
	local name = ResTable:getValue('role_info',data.no,'name');
	local maxRoleList, maxLv = self:getMax4LvCard();
	Prompt:Show(string.format(LANG.UI_CARD_69,name,maxLv));
end

function FutureCardModel:addFutureCard(sid, pid)
	if self.futureCardList[sid] then
		self.futureCardList[sid].pid = pid
		model.CardModel:changeCardFutureLv(pid, self.futureLevel)
		model.CardModel:changeCardFutureBreakLv(pid , self.futureBreakLv,self.futureLevel)
		CardProManager:setNeedUpdateGenPro(pid);
		EventManager:FireEvent(EventType.UIFutureCardUpdate,sid);
	end
end

function FutureCardModel:removeFutureCard(sid, cd)
	if self.futureCardList[sid] then
		local lastpid = self.futureCardList[sid].pid;
		self.futureCardList[sid].pid = -1;
		self.futureCardList[sid].time = cd;
		model.CardModel:changeCardFutureLv(lastpid, 0)
		model.CardModel:changeCardFutureBreakLv(lastpid , 0)
		CardProManager:setNeedUpdateGenPro(lastpid);
		EventManager:FireEvent(EventType.UIFutureCardUpdate,sid);
	end
end

return FutureCardModel;
