local GachaAdmobModel = class("GachaAdmobModel")

function GachaAdmobModel:ctor()
	self.rest_times = {};
	self.max_times = {};
end

function GachaAdmobModel:init(data)
	if not data then
		return;
	end

	for k, v in pairs(data) do
		self.rest_times[tonumber(k)] = v.rest_times;
		self.max_times[tonumber(k)] = v.max_times;
	end
end

function GachaAdmobModel:getRestTimes(t)
	return self.rest_times[t];
end

function GachaAdmobModel:consume(t)
	self.rest_times[t] = self.rest_times[t] - 1
end

function GachaAdmobModel:getMaxTimes(t)
	return self.max_times[t];
end

function GachaAdmobModel:reset()
	for k, v in pairs(self.max_times) do
		if self.rest_times[k] then
			self.rest_times[k] = v
		end
	end
end

return GachaAdmobModel;


