local GuildModel = class("GuildModel")
local CommonShopType = Enum:getTable('CommonShopType');

function GuildModel:ctor()
    self:clearAll()
end

function GuildModel:clearAll(  )
    self.guildInfo = nil;
    self.allGuildList = {};
    self.retGuildLsit = {};
    self.searchGuild = {};

    self.guildMemberList = {};
    self.guildMemberHashList = {} -- key:uid 

    self.guildApplyList = {};

    self.guildDonateInfo = nil;

    self.retGuildRankList = {};
    self.allGuildRankList = {};
    self.guildMessInfo = {};
    self.guildSysInfo = {};
    self.teamSet = {};
    self.getInfoFlag = false;
    self.initData = false;
    self.initGuiildMission = false;
    self.maxId = 0;

    self.guildShopData = {};

    self.guildRaidRankRewardTableSortData = {};

    self.guildBossRwdList = {};
end

-- function GuildModel:getData()
--     local msg = {};
--     -- msg.uid = model.UserModel:getUserUid();
--     Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_info_t , msg);
-- end

function GuildModel:reqGuildInfo(  )
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_info_t , {});
end

function GuildModel:reqAllGuildJoinList(maxId)
    local msg = {};
    msg.max_id = maxId;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_all_guild_list_t , msg);
end
function GuildModel:applyJoinGuild(gid)
    if not gid then
        return;
    end
    local msg = {};
    msg.apply_gid = gid;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_join_guild_t , msg);
end
function GuildModel:reqGuildSearchList(searchText)
    local msg = {};
    msg.search_text = searchText;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_search_guild_t , msg);
end

function GuildModel:createGuild(guildName , icon)
    local msg = {};
    msg.icon = icon;
    msg.guild_name = guildName;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_create_guild_t , msg);
end
function GuildModel:reqGuildMember()
    local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_member_t , msg);
end
function GuildModel:reqApplyList(guildName)
    local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_apply_list_t , msg);
end
function GuildModel:reqGuildAppoint(uid)
    local msg = {};
    msg.appoint_uid = uid;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_appoint_t , msg);
end
function GuildModel:reqGuildFired(uid)
    local msg = {};
    msg.fired_uid = uid;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_fired_t , msg);
end
function GuildModel:reqGuildDepose(uid)
    local msg = {};
    msg.depose_uid = uid;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_depose_t , msg);
end
function GuildModel:reqGuildQuit()
    local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_quit_t , msg);
end

function GuildModel:reqGuildDismiss()
    local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_Dismiss_t , msg);
end

function GuildModel:reqGuildApply(uidList)
    local msg = {};
    msg.apply_uid_list = uidList;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_apply_t , msg);
end
function GuildModel:reqGuildNotApply(uidList)
    local msg = {};
    msg.refuse_apply_uid_list = uidList;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_not_apply_t , msg);
end
function GuildModel:reqGuildDonateInfo()
    local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_donate_info_t , msg);
end
function GuildModel:reqGuildDonate(donateType)
    local msg = {};
    msg.donate_type = donateType;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_donate_t , msg);
end
function GuildModel:reqGetDonateReward(rewardId)
    local msg = {};
    msg.reward_id= rewardId;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_get_donate_reward_t , msg);
end

function GuildModel:reqGetGuildRank()
    local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_rank_t , msg);
end
function GuildModel:reqGuildMessInfo()
    local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_mess_info_t , msg);
end

function GuildModel:reqSendGuildMess(text)
    local msg = {};
    msg.message = text;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_mess_send_t , msg);
end
function GuildModel:reqGuildNotice(text)
    local msg = {};
    msg.notice = text;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_notice_t , msg);
end

function GuildModel:reqGuildIcon(icon)
    local msg = {};
    msg.icon = icon;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_icon_t , msg);
end

function GuildModel:reqGuildSetAuditState()
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_set_audit_t , {});
end

function GuildModel:reqGuildTransfer(transferUid)
    local msg = {};
    msg.transferUid = transferUid;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_transfer_t , msg);
end

function GuildModel:reqGuildImpeach()
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_impeach_t , {});
end

function GuildModel:isInit()
    return self.initData;
end

function GuildModel:retGuildInfo(msg)
    -- dump(msg);
    -- self:clearAll()
    if not msg then
        return;
    end

    --有未加入到加入公会重算属性
    if self.guildInfo
      and self.guildInfo.gid == 0 
      and msg.guild_info.gid > 0 then
        CardProManager:setNeedUpdateAllGenPro();  
    end

    self.guildInfo = msg.guild_info;
    if msg.guild_info.level ~= nil then
        local maxCount = ResTable:getValue('guild_lv',msg.guild_info.level,'num');
        self.guildInfo.member_max = maxCount;
    end
    -- dump(self.guildInfo);
    self.guildSysInfo = msg.guild_info.guild_system_message;

    if self.guildSysInfo and #self.guildSysInfo > 1 then
        table.sort(self.guildSysInfo , function (infoA , infoB)
            return infoA.message_time > infoB.message_time;
        end);
    end

    if msg.guild_apply_list then
        self.guildApplyList = msg.guild_apply_list;
    end

    self.initData = true;

    self.guildRaidRankRewardTableSortData = {};
    local rankReward = ResTable:getTable('guild_raid_ranking').contain;
    if rankReward then
        for _k , reward in pairs(rankReward) do
            table.insert(self.guildRaidRankRewardTableSortData , reward);
        end

        if #self.guildRaidRankRewardTableSortData > 1 then
            table.sort(self.guildRaidRankRewardTableSortData , function(first , second) 
                return first.no < second.no;
            end);
        end
    end
end
function GuildModel:retAllGuildList(msg)
    if not msg then
        return;
    end

    self.retGuildLsit = {};
    if msg.guilds then
        local totalNum =  #msg.guilds;
        if totalNum > 0 then
            local randList = {};
            for i = 1 , totalNum do
                table.insert(randList,i);
            end
            for _k , guild in pairs(msg.guilds) do
                local num = #randList;
                local randIndex = math.random(1,num);
                local index = randList[randIndex]
                table.remove(randList, randIndex);
                self.retGuildLsit[index] = guild;
                table.insert(self.allGuildList , guild);
            end
        end
    end
    self.maxId = msg.max_id;
end
function GuildModel:retJoinGuild(msg)
    if not msg then
        return;
    end

    for _k , guild in pairs(self.allGuildList) do
        if guild.gid == msg.gid then
            guild.is_apply = 1;
            guild.apply_time = msg.apply_time or guild.apply_time;
            break;
        end
    end

end
function GuildModel:retSearchGuild(msg)
    if not msg then
        return;
    end
    self.searchGuild = msg.guild;
    dump(self.searchGuild,'retSearchGuild = ')
end

function GuildModel:retCreateGuild(msg)
    if not msg then
        return;
    end
    self.guildInfo = msg.guild_info;
end

function GuildModel:retGuildMember(msg)
    if not msg then
        return;
    end

    self.guildMemberList = msg.guild_member_list;
    self.guildMemberHashList = {}
    table.sort(self.guildMemberList , function(member1 , member2)
        if member1.guild_flag ~= member2.guild_flag then
            return member1.guild_flag < member2.guild_flag;
        end
        if member1.level ~= member2.level then
            return member1.level > member2.level;
        end
        return member1.top_power > member2.top_power;
    end);
    for i=1,#self.guildMemberList do
        local item = self.guildMemberList[i];
        self.guildMemberHashList[tostring(item.uid)] = item;
    end
end

function GuildModel:retGuildMemberTeam(msg)
    if msg and self.guildMemberHashList[tostring(msg.uid)] then
        self.guildMemberHashList[tostring(msg.uid)].teamInfo = msg.team_info;
    end
end

function GuildModel:updateMemberList( uid,guildFlag )
    -- for _k , member in pairs(self.guildMemberList) do
    --     if member.uid == msg.uid then
    --         member.guild_flag = msg.guild_flag;
    --         break;
    --     end
    -- end
    local member = self.guildMemberHashList[tostring(uid)];
    if member then
        member.guild_flag = guildFlag;
    end
end

function GuildModel:removeMemberListItem( uid )
    for index , member in pairs(self.guildMemberList) do
        if member.uid == uid then
            table.remove(self.guildMemberList , index);
            break;
        end
    end
    self.guildMemberHashList[tostring(uid)] = nil
end


function GuildModel:retApplyList(msg)
    if not msg then
        return;
    end

    self.guildApplyList = msg.guild_apply_list;
end
function GuildModel:retGuildAppoint(msg)
    if not msg then
        return;
    end
    self:updateMemberList(msg.uid,msg.guild_flag)
   
end
function GuildModel:retGuildFired(msg)
    if not msg then
        return;
    end

    self:removeMemberListItem(msg.uid)
  

end
function GuildModel:retGuildDepose(msg)
    if not msg then
        return;
    end
    self:updateMemberList(msg.uid,msg.guild_flag)
end
function GuildModel:retGuildQuit(msg)
    if not msg then
        return;
    end

    self.guildInfo.gid = msg.gid;
    self.guildInfo.guild_flag = msg.guild_flag;

end
function GuildModel:retGuildDismiss(msg)
    if not msg then
        return;
    end
    self.guildInfo.gid = msg.gid;
    self.guildInfo.guild_flag = msg.guild_flag;
end
function GuildModel:retGuildApply(msg)
    if not msg then
        return;
    end
    for _k1 , uid in pairs(msg.applyList) do
        for _k , apply in pairs(self.guildApplyList) do
            if uid == apply.uid then
                Prompt:Show(string.format(LANG.UI_GUILD_42 , tostring(apply.name)));
                table.remove(self.guildApplyList , _k);
            end
        end
    end
    for _k1 , uid in pairs(msg.refuseList) do
        for _k , apply in pairs(self.guildApplyList) do
            if uid == apply.uid then
                Prompt:Show(string.format(LANG.UI_GUILD_44 , tostring(apply.name)));
                table.remove(self.guildApplyList , _k);
            end
        end
    end
    
end
function GuildModel:retGuildNotApply(msg)
    if not msg then
        return;
    end
    for _k1 , uid in pairs(msg.applyList) do
        for _k , apply in pairs(self.guildApplyList) do
            if uid == apply.uid then
                table.remove(self.guildApplyList , _k);
            end
        end
    end

end

function GuildModel:updateGuildFlag(msg)
    if not msg then
        return;
    end

    if msg.guild_flag then
        self.guildInfo.guild_flag = msg.guild_flag;
    end

    if msg.transfer_name then
        self.guildInfo.master_name = msg.transfer_name;
    end
end

--- ---- guild donate  ---
function GuildModel:getGuildDonateTimes(  )
    if self.guildDonateInfo == nil then
        -- self:reqGuildDonateInfo();
        return 0;
    end
    return self.guildDonateInfo.donate or 0
end

function GuildModel:getGuildDonateRewardState(  )
    if self.guildDonateInfo == nil   then
        -- self:reqGuildDonateInfo();

        return false;
    end

    for k,donateTarget in pairs(self.guildDonateInfo.donate_reward_target) do
        local targetExp = tonumber(donateTarget[2])
        local reward = tonumber(self.guildDonateInfo.donate_reward[k])
        if targetExp < self.guildDonateInfo.donate_exp and reward ~= 1 then
            return true 
        end
    end
    return false;
end

function GuildModel:retGuildDonateInfo(msg)
    if not msg then
        return
    end
    
    self.guildDonateInfo = {};
    self.guildDonateInfo.donate_reward = msg.donate_reward;
    self.guildDonateInfo.donate = msg.donate;
    self.guildDonateInfo.donate_exp = msg.donate_exp;
    self.guildDonateInfo.donate_reward_target = msg.donate_reward_target;
end
function GuildModel:retGuildDonate(msg)
    if not msg then
        return;
    end
    if msg.level ~= self.guildInfo.level then
        self.guildInfo.level = msg.level;
        local maxCount = ResTable:getValue('guild_lv',msg.level,'num');
        self.guildInfo.member_max = maxCount;
    end
    self.guildInfo.exp = msg.exp;
    self.guildDonateInfo.donate = msg.donate;
    self.guildDonateInfo.donate_exp = msg.donate_exp;

    if msg.donate_reward_target then
        self.guildDonateInfo.donate_reward_target = msg.donate_reward_target;
    end
    if msg.donate_reward then
        self.guildDonateInfo.donate_reward = msg.donate_reward;
    end
end
function GuildModel:retGetDonateReward(msg)
    if not msg then
        return;
    end
    -- dump(msg);
    if msg.donate_reward then
        self.guildDonateInfo.donate_reward = msg.donate_reward;
    end
    if msg.donate_exp then
        self.guildDonateInfo.donate_exp = msg.donate_exp;
    end
    if msg.donate then
        self.guildDonateInfo.donate = msg.donate;
    end
    if msg.donate_reward_target then
        self.guildDonateInfo.donate_reward_target = msg.donate_reward_target;
    end
end
function GuildModel:retGuildRank(msg)
    if not msg then
        return;
    end
    self.retGuildRankList = {};
    for _k , guild in pairs(msg.guilds) do
        table.insert(self.retGuildRankList , guild);
        table.insert(self.allGuildRankList , guild);
    end
end
function GuildModel:retGuildMessInfo(msg)
    if not msg then
        return;
    end
    self.guildMessInfo = msg.guild_message_info;
end
function GuildModel:retGuildSysMess(msg)
    if not msg then
        return;
    end
    self.guildSysInfo = msg.guild_system_info;
end

function GuildModel:retGuildMessSend(msg)
    if not msg then
        return;
    end
    self.guildMessInfo = msg.guild_message_info;
    if #self.guildMessInfo > 1 then
        table.sort(self.guildMessInfo , function(messA , messB)
            return messA.message_time < messB.message_time;
        end);
    end
end
function GuildModel:retGuildNotice(msg)
    if not msg then
        return;
    end
    self.guildInfo.notice = msg.notice;
end

function GuildModel:retGuildIcon(msg)
    if not msg then
        return;
    end
    self.guildInfo.icon = msg.icon;
end

function GuildModel:updateAuditState(state)
    if state then
        self.guildInfo.audit_state = state;
    end
end

function GuildModel:resetGuildListPageIndex()
    self.maxId = 0;
end
function GuildModel:getGuildMember()
    return self.guildMemberList
end
function GuildModel:getGuildMemberWithOutSelf(  )
    if self.guildMemberListWithOutSelf == nil then
        
    end
end

function GuildModel:getGuildMemberByUid(uid)
    -- for _k , member in pairs(self.guildMemberList) do
    --     if member.uid == uid then
    --         return member;
    --     end
    -- end
    -- return nil;

    return self.guildMemberHashList[tostring(uid)]
end
function GuildModel:getApplyList()
    return self.guildApplyList;
end
function GuildModel:getApplyByUid(uid)
    for _k , apply in pairs(self.guildApplyList) do
        if apply.uid == uid then
            return apply;
        end
    end
    return nil;
end
function GuildModel:getGuildInfo()
    return self.guildInfo;
end
function GuildModel:getGuildIcon(  )
    if self.guildInfo == nil then
        return nil;
    end
    return self.guildInfo.icon;
end
function GuildModel:getGuildName(  )
    if self.guildInfo == nil then
        return nil;
    end
    return self.guildInfo.name;
end
function GuildModel:getGuildNotice(  )
    if self.guildInfo == nil then
        return nil;
    end
    return self.guildInfo.notice;
end
function GuildModel:getGuildLevel()
    return self.guildInfo.level;
end
function GuildModel:isJoinGuild()
    return self.guildInfo.gid ~= 0;
end
function GuildModel:getSearchGuild()
    return self.searchGuild;
end
function GuildModel:resetAllGuildList()
    self.retGuildLsit = {};
end
function GuildModel:getAllGuildData()
    return self.retGuildLsit;
end
function GuildModel:getGuildDonateInfo()
    return self.guildDonateInfo;
end

function GuildModel:getGuildRankList()
    return self.retGuildRankList;
end

function GuildModel:getGuildMessInfo()
    return self.guildMessInfo;
end

function GuildModel:getGuildSysMess()
    return self.guildSysInfo;
end

function GuildModel:getGuildAuditState()
    return self.guildInfo.audit_state;
end

function GuildModel:getGuildShopData(type)

    return self.guildShopData;


    -- local retData = {};
    -- if type == 11 then
    --     for _k , _v in pairs(self.guildShopData.guild_reward_items) do
    --         table.insert(retData , tonumber(_k));
    --     end
    -- elseif type == 12 then
    --     for _k , _v in pairs(self.guildShopData.guild_items) do
    --         table.insert(retData , tonumber(_k));
    --     end
    -- end
    -- if #retData > 1 then
    --     table.sort(retData , function(a , b)
    --         return a < b;
    --     end);
    -- end

    -- return retData;
end
function GuildModel:getGuildShopTimes(type , id)

    return self.guildShopData[tostring(id)];

    -- if type == 11 then
    --     return self.guildShopData.guild_reward_items[tostring(id)];
    -- elseif type == 12 then
    --     return self.guildShopData.guild_items[tostring(id)];
    -- end
end

---------------new guild boss  start------------------
function GuildModel:reqGuildBossInfo()
    local msg = {};

    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_boss_info_5850 , msg);
end

function GuildModel:retGuildBossInfo( msg )

    if not msg or not msg.guildRaid then
        return
    end

    self.guildNewBossInfo = {};
    self.guildNewBossInfo.raid = msg.guildRaid;

    self.guildNewBossInfo.raidUser = {};
    if msg.guildRaidUser then
        self.guildNewBossInfo.raidUser = msg.guildRaidUser;

        self.guildBossRwdList = {}
        if msg.guildRaidUser.guild_raid_point_reward then
            for k,v in pairs(msg.guildRaidUser.guild_raid_point_reward) do
                self.guildBossRwdList[v] = 1
            end
        end
    end

    EventManager:FireEvent(EventType.UpdateGuildBossInfoPanel);

end

function GuildModel:getGuildBossOpenState()
    if self.guildNewBossInfo then
        return self.guildNewBossInfo.raid.open or -1;
    end
    return - 1
end

function GuildModel:IsFightBossBody()
    return self.guildNewBossInfo.raid.armor_cd > 0
end

function GuildModel:getHasRecBossRwd()
    return self.guildBossRwdList or {};
end

function GuildModel:getRaidNo()
    return self.guildNewBossInfo.raid.raid_no
end

function GuildModel:getPreRaidNo()
    return self.guildNewBossInfo.raid.pre_raid_no;
end

function GuildModel:getOrderNo()
    return self.guildNewBossInfo.raid.order_no
end

function GuildModel:getGuildBossInfo()
    return self.guildNewBossInfo
end

function GuildModel:getGuildBossAllDamage()
    return self.guildNewBossInfo.raid.all_damage;
end

function GuildModel:reqGuildBossFightTimes()
    local msg = {};
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_fight_times , msg);
end

function GuildModel:retGuildBossFightTimes( msg )
    -- body
    self.guildNewBossInfo.raidUser.guild_raid_challenge_num = msg.guild_raid_challenge_num
    self.guildNewBossInfo.raidUser.guild_raid_last_buy_num = msg.guild_raid_last_buy_num
    EventManager:FireEvent(EventType.NetworkGuildBossBuyChallengeNum,msg);
end

function GuildModel:getGuildBossRwd(no)
    local raidNo = self:getRaidNo()
    if self:getGuildBossOpenState() ~= 1 then
        raidNo = self:getPreRaidNo();
    end
    local msg = {};
    msg.no = no;
    msg.raid_no = raidNo;
    self.willGetBossRwdNo = no;
    Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_boss_rwd , msg);
end

function GuildModel:retGuildBossRwd(msg)
    self.guildBossRwdList[self.willGetBossRwdNo] = 1
    
    EventManager:FireEvent(EventType.NetworkGuildBossBonusStage, self.willGetBossRwdNo);
end

function GuildModel:getNewGuildBossRewardState()
    if self.guildNewBossInfo == nil then
        return false
    end

    local curDamage = self.guildNewBossInfo.raid.all_damage;
    local allRwdList = ResTable:getTable("guild_raid_point").contain;
    for _k , data in pairs(allRwdList) do
        if self.guildBossRwdList[ data.no ] == nil then
            if data.point <= curDamage then
                return true
            end
        end
    end

    return false;
end

function GuildModel:getNewGuildBossFightState()
    if not self:isJoinGuild() then
        return false;
    end

    return self:getGuildBossOpenState() == 1 and (self.guildNewBossInfo and self.guildNewBossInfo.raidUser.guild_raid_challenge_num > 0)
end

---------------new guild boss   end------------------


--[[
    donate_money
    mission_id
    chapter
    stage
    open
    cd
    boss_hp
    team{'pid':{cd , pos}}
]]
function GuildModel:initGuildBossData(msg)
    -- print_ro(msg,"====GuildModel:initGuildBossData==");

    self.guildBossInfo = {};

    self.guildBossInfo.open = 1;--msg.open
    self.guildBossInfo.boss_hp = msg.boss_hp
    self.guildBossInfo.boss_completed_stage = msg.boss_completed_stage;
    self.guildBossInfo.boss_stage = msg.boss_stage
    self.guildBossInfo.boss_no = msg.boss_no
    self.guildBossInfo.boss_kill_bonus = msg.boss_kill_bonus
    self.guildBossInfo.challenge_num = msg.challenge_number or 0;
    self.guildBossInfo.challenge_time = msg.challenge_time
    self.guildBossInfo.boss_allBonus_received = msg.boss_allBonus_received or {}
    self.guildBossInfo.buy_next_coin = msg.buy_next_coin;
    self.guildBossInfo.check_point_damage = msg.check_point_damage;
    

    
    self.getInfoFlag = false;
    self.initGuiildMission = true;

    self:getBossBonusReceived();
end

function GuildModel:retGuildBossCheckPoint( msg )
    self.guildBossInfo.boss_hp              = msg.boss_hp
    self.guildBossInfo.challenge_num        = msg.challenge_number

    -- 扫荡击杀boss
    self.guildBossInfo.open                 = msg.open or self.guildBossInfo.open 
    self.guildBossInfo.boss_completed_stage = msg.boss_completed_stage or self.guildBossInfo.boss_completed_stage;
    self.guildBossInfo.boss_stage           = msg.boss_stage or self.guildBossInfo.boss_stage;
    self.guildBossInfo.boss_no              = msg.boss_no or  self.guildBossInfo.boss_no;

end

function GuildModel:setTeamSet(team)
	self.teamSet = team;
end

function GuildModel:getTeamSet()
	return self.teamSet;
end

function GuildModel:retGuildMissionRank(msg)
    self.guildBossInfo.rank = msg.damage_list;
end

function GuildModel:getBossBonusReceived(  )
    if self.guildBossInfo == nil then
        return nil ;
    end
    if self.guildBossBonusReceived == nil  then
        self.guildBossBonusReceived = {};
        local guild_bonus_received = self.guildBossInfo.boss_allBonus_received or {};
        for k,v in pairs(guild_bonus_received) do
            self.guildBossBonusReceived[v] = 1;
        end
        self:updateGuildBossBonusState()

    end
    return self.guildBossBonusReceived;
end

function GuildModel:getBossMonster(  )
    return self.guildBossInfo.boss_no;
end
function GuildModel:getBossStage(  )
    return self.guildBossInfo.boss_stage;
end
function GuildModel:getBossCompletedStage(  )
    return self.guildBossInfo.boss_completed_stage;
end

function GuildModel:getChallengeTime(  )
    return self.guildBossInfo.challenge_time;
end

function GuildModel:getChallengeNum(  )
    return self.guildBossInfo.challenge_num;
end

function GuildModel:getBossCheckPointDamage(  )
    return self.guildBossInfo.check_point_damage;
end
--{ 货币类型，本次消耗，剩余次数 }
function GuildModel:getNextCoin()
    return self.guildBossInfo.buy_next_coin;
end

function GuildModel:getKillBonusState(  )
    return self.guildBossInfo.boss_kill_bonus == 1 ;
end

function GuildModel:getBossAllBonusList(  )
    if self.guildBossInfo.boss_allBonus_received == nil or type(self.guildBossInfo.boss_allBonus_received) ~= 'table' then
        self.guildBossInfo.boss_allBonus_received = {}
    end
    return self.guildBossInfo.boss_allBonus_received;

end

function GuildModel:getGuildBossOpen()
    return self.guildBossInfo.open;
end

function GuildModel:getBossHp()
    return self.guildBossInfo.boss_hp;
end

function GuildModel:getGuildMissionRank()
    if self.guildBossInfo.rank and #self.guildBossInfo.rank > 1 then
        table.sort(self.guildBossInfo.rank , function(rankA , rankB)
             return rankA.damage > rankB.damage
        end);
    end
    return self.guildBossInfo.rank;
end



-- 红点  等级解锁状态 
function GuildModel:updateGuildBossBonusState(  )
    self.redDotBossBonus = false;

    for i=self:getBossCompletedStage(),1,-1 do
        if self.guildBossBonusReceived[i] == nil or self.guildBossBonusReceived[i] == 0 then
            self.redDotBossBonus = true
            return  
        end        
    end

end
-- 通关奖励状态
function GuildModel:getGuildBossBonusState(  )
    -- body
    if self.redDotBossBonus == nil then
        self:getBossBonusReceived()
    end

    return self.redDotBossBonus == true;
end
-- 挑战状态
function GuildModel:getGuildBossChallengeState(  )
    -- body
    local challengeNum = self:getChallengeNum()             -- 挑战次数
    local open_state = tonumber(self:getGuildBossOpen());   -- 0 未开启 1 已开启 2 已击杀
    return open_state == 1 and challengeNum > 0
end
-- 击杀奖励状态
function GuildModel:getGuildBossKillBonusState(  )
    -- body
    local open_state = tonumber(self:getGuildBossOpen());   -- 0 未开启 1 已开启 2 已击杀
    local killBonusState = self:getKillBonusState()         -- 击杀奖励状态
    return open_state == 2 and killBonusState
end

function GuildModel:getRedDotStateGuildDonate(  )
    -- 1 捐献次数大于0
    -- 2 有活跃奖励
    if not self:isJoinGuild() then
        return false;
    end
    if self.guildDonateInfo == nil  then
        self:reqGuildDonateInfo();
        return false;
    end
    print('self:getGuildDonateTimes() === '..tostring(self:getGuildDonateTimes()))
    print('  reward == '..tostring(self:getGuildDonateRewardState()))
    return self:getGuildDonateTimes() > 0 or  self:getGuildDonateRewardState()
end

function GuildModel:getRedDotStateGuild(  )
    if self:getLockStateGuild() then
        return false;
    end
    if self.guildInfo == nil then
        self:reqGuildInfo()
        return false;
    end
    if not self:isJoinGuild() then
        return false;
    end

    --公会副本状态 or 公会捐献状态 or 科研所
    return  self:getNewGuildBossFightState() or self:getRedDotStateGuildDonate() or model.HomeModel:getRedDotStateSkill()
end

function GuildModel:getRedDotStateGuildApply()
    return self.guildInfo.guild_flag < 2 and self.guildApplyList and #self.guildApplyList > 0;
end

-- bool,lockLv
function GuildModel:getLockStateGuild(  )
    if not tools.ConfigStateTools:checkLockByName('GuildPanel') then
        return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_10);
    end
    return true
end

function GuildModel:chackGuild(notShowPrompt)
    local locked ,lockLv = self:getLockStateGuild();
    if locked then
        if not notShowPrompt then
            Prompt:Show(string.format(LANG.UI_GUILD_43 , lockLv));
        end
        return false;
    end
    if not self:isJoinGuild() then
        if not notShowPrompt then
            Prompt:Show(LANG.UI_SHOP_57);
        end
        return false;
    end
    return true;
end

function GuildModel:getGuildRaidRank()
    if self.guildRaidRank then
        return self.guildRaidRank;
    else
        local raidNo = self:getRaidNo()
        if self:getGuildBossOpenState() ~= 1 then
            raidNo = self:getPreRaidNo();
        end
        if raidNo == nil then
            Prompt:Show(LANG.UI_GUILD_128);
            return nil;
        else
            local msg = {};
            msg.raid_no = raidNo;
            Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_raid_rank , msg);
            return nil;
        end
    end
end

function GuildModel:getGuildRaidDamageRank()
    if self.guildRaidDamageRank then
        return self.guildRaidDamageRank;
    else
        local raidNo = self:getRaidNo()
        if self:getGuildBossOpenState() ~= 1 then
            raidNo = self:getPreRaidNo();
        end
        if raidNo == nil then
            Prompt:Show(LANG.UI_GUILD_128);
            return nil;
        else
            local msg = {};
            msg.raid_no = raidNo;
            Network.NetworkManager:Send(Network.NetworkCmdType.req_guild_raid_damage_rank , msg);
            return nil;
        end
    end
end

function GuildModel:getGuildRaidDamage()
    return self.guildRaidDamage
end

function GuildModel:resetGuildRaidRank()
    self.guildRaidRank = nil;
    self.guildRaidDamageRank = nil;
    self.guildRaidDamage = 0;
end

function GuildModel:updateGuildRaidRank(msg)
    if msg.guild_list then
        self.guildRaidRank = msg.guild_list;
    end
    if msg.damage then
        self.guildRaidDamage = msg.damage
    end
end

function GuildModel:updateGuildRaidDamageRank(msg)
    if msg.damage_list then
        self.guildRaidDamageRank = msg.damage_list;
    end
end

function GuildModel:getGuildRaidRankRewardSortData()
    return self.guildRaidRankRewardTableSortData;
end

return GuildModel;
