local HomeModel = class("HomeModel")

-- local homeType = {
-- 	[1] = 'equip',
-- 	[2] = 'skill',
-- 	[3] = 'library',
-- 	[4] = 'card',
-- 	[5] = 'treatment',
-- }

HomeModel.HomeMenuTag = {
	TAG_EQUIP 			= 1,	-- 军械库
	TAG_LOVE 			= 2,	-- 爱恋 
	TAG_LIBRARY 		= 3,	-- 图书馆
	TAG_CARD_COMPOSE 	= 4,	-- 重构中心
	TAG_ARENA 			= 5,	-- 竞技场--TAG_TREATMENT
	TAG_TRIAL 			= 6,	-- 试炼之战
	TAG_CARD 			= 7,	-- 融合中心
	TAG_RANDOMSHOP 		= 8,	-- 随机商店
	TAG_MAZE	 		= 9,	-- 迷宫
	TAG_FUTURECARD 		= 10,	-- 共鸣水晶
	TAG_MULTARENA 		= 11,	-- 多队竞技
	TAG_GUILD	 		= 12,	-- 公会
}
function HomeModel:ctor()
	self:clearAll()
end

function HomeModel:clearAll(  )
	self.skillCd = 0;
	self.skillCdOverTime = 0;
	self.skillLevels = {};
	self.homeData = {};
end

function HomeModel:InitHomeData(msg)
	self:clearAll()

	msg = msg or {}
	self.homeData.skill = {}
	self.homeData.skill.level 		= msg.skill_lv or 1;
	self.homeData.skill.state 		= msg.skill_lv_state or 0;
	self.homeData.skill.time 		= msg.skill_lv_time or 0;
	self.homeData.skill.send 		= false;
end

-- function HomeModel:updateHomeTime(dt)
-- 	for i = 1 , 5 do
-- 		if self.homeData[homeType[i]] and self.homeData[homeType[i]].state == 1 and self.homeData[homeType[i]].time > 0 then
-- 			self.homeData[homeType[i]].time = self.homeData[homeType[i]].time - dt;
-- 			if self.homeData[homeType[i]].time < 0 then
-- 				self.homeData[homeType[i]].time = 0;
-- 			end
-- 		end
-- 	end
-- end

function HomeModel:getHomeBase()
	return self.homeData;
end

function HomeModel:getHomeBaseByKey(key)
	return self.homeData[key]
end

function HomeModel:setSend(key , send)
	if self.homeData[key] then
		self.homeData[key].send = send or false;
	end
end

-- function HomeModel:sendLevelUpComplete(baseType)
-- 	if baseType == nil or baseType == -1  then
-- 		return ;
-- 	end
-- 	if baseType ==  model.HomeModel.HomeMenuTag.TAG_EQUIP then
-- 		Network.NetworkManager:Send(Network.NetworkCmdType.req_base_equip_level_up_complete , {});
-- 	elseif baseType ==  model.HomeModel.HomeMenuTag.TAG_SKILL then
-- 		Network.NetworkManager:Send(Network.NetworkCmdType.req_base_skill_level_up_complete , {});
-- 	elseif baseType == model.HomeModel.HomeMenuTag.TAG_CARD then
-- 		Network.NetworkManager:Send(Network.NetworkCmdType.req_base_card_level_up_complete , {});
-- 	elseif baseType == model.HomeModel.HomeMenuTag.TAG_TREATMENT then
-- 		Network.NetworkManager:Send(Network.NetworkCmdType.req_base_treatment_level_up_complete , {});
-- 	end
-- end


function HomeModel:updateHomeData(key , time , state)
	if self.homeData[key] then
		self.homeData[key].state = state or 0;
		self.homeData[key].time = time or 0;
	end
end

function HomeModel:updateHomeAllData(key , state , time , level , send)
	if self.homeData[key] then
		self.homeData[key].level = level or self.homeData[key].level;
		self.homeData[key].state = state or 0;
		self.homeData[key].time = time or 0;
		self.homeData[key].send = send or false;
	end
end

function HomeModel:InitSkillData(skillData)
	ResTable:getTable('base_skill_lv');
	self.skillLevels = {};
	if skillData.skillLevels then
		for skillId , level in pairs(skillData.skillLevels) do
			self.skillLevels[tonumber(skillId)] = level;
		end
	end
	if skillData.skillCd then
		-- self.skillCd = skillData.skillCd;
		self:setSkillCdOverTime(skillData.skillCd);
	end
end
function HomeModel:setSkillCdOverTime( skillCd )
	self.skillCd = skillCd;
	local curTime = TimeManager:getCurTime()
	self.skillCdOverTime = curTime + self.skillCd
end

function HomeModel:retBaseSkillInfo(msg)
	self.skillLevels = {};
	-- self.skillCd 	 = msg.skillCd;
	self:setSkillCdOverTime(msg.skillCd);

	for skillId , level in pairs(msg.skillLevels) do
		self.skillLevels[tonumber(skillId)] = level;
	end
end

function HomeModel:retBaseSkillLevelUp(msg)

	if self.skillLevels[msg.skillId] then
		self.skillLevels[msg.skillId] = msg.skillLevel;
	end

	-- self.skillCd = msg.skillCd;
	self:setSkillCdOverTime(msg.skillCd);

end

function HomeModel:retBaseSkillClaerCd(msg)
	-- self.skillCd = msg.skillCd;
	self:setSkillCdOverTime(msg.skillCd);

end

function HomeModel:getBaseSkillLevel()
	return self.skillLevels;
end

-- function HomeModel:upDateSkillCd()
-- 	self.skillCd = self.skillCd - 1;
--     if self.skillCd < 0 then
--         self.skillCd = 0;
--     end
-- end
function HomeModel:getSkillCd()
	-- return self.skillCd;
	local curTime = TimeManager:getCurTime()
	local cd = self.skillCdOverTime - curTime;
	if cd < 0 then
		cd = 0
	end
	return cd;
end

function HomeModel:getSkillValue( skillKey )
	local curSkillLevel = self.skillLevels[skillKey];
	if skillKey ~= nil and curSkillLevel ~= nil then
		if skillKey == 0 or curSkillLevel == 0  then
			return 0;
		end
		local baseSkillData = ResTable:getMultiValue('base_skill_lv' , skillKey , curSkillLevel);
		if baseSkillData then
			return baseSkillData['value'];
		end
	end

	return nil ;

end

function HomeModel:setBaseSkillMaxLevel(maxLevel)
	self.baseSkillMaxLevel = maxLevel;
end

function HomeModel:getBaseSkillMaxLevel(skillId)
	return self.baseSkillMaxLevel[skillId];
end


function HomeModel:getRedDotStateTrialPanel(  )
	local redDotState = false
	return redDotState
end


function HomeModel:getRedDotStateRandomShop(  )
	local redDotState = model.ShopModel:getRedDotStateRandomShop()
	return redDotState
end

function HomeModel:getRedDotStateArena(  )
	local redDotState = model.ArenaModel:getRedDotStateArena()
	return redDotState
end

function HomeModel:getRedDotStateHome(  )
	
	local ret = false ;

	return ret or self:getRedDotStateTrialPanel() 
	 or self:getCardStarActiveState() 
	 or self:getEquipActiveState() 
	 or self:getRedDotStateArena()
	 --or self:getRedDotStateRandomShop()
	 --or self:getRedDotStateSkill()
	 --or self:getRedDotStateLibraryCollection()
end
function HomeModel:getRedDotStateLibraryCollection()
	return false;
end

function HomeModel:getRedDotStateSkill()
	local skillState = self:getSkillActiveState();
	for skillId , state in pairs(skillState) do
		if state then
			return true;
		end
	end
	return false
end

function HomeModel:getSkillActiveState(skillId)
	local skillState = {};
	local skillCd = self:getSkillCd();

	for skId , level in pairs(self:getBaseSkillLevel()) do
		if skillId then
			if skId == skillId then
				local maxLevel = self:getBaseSkillMaxLevel(skillId);
				local nextBaseSkillData = ResTable:getMultiValue('base_skill_lv' , skId , (level + 1));
				if level < maxLevel and nextBaseSkillData and model.ItemModel:getItemNum(SKILL_MONEY) >= nextBaseSkillData.cost and skillCd <= 0 then
					skillState[skId] = true;
				else
					skillState[skId] = false;
				end
				break;
			end
		else
			local nextBaseSkillData = ResTable:getMultiValue('base_skill_lv' , skId , (level + 1));
			local maxLevel = self:getBaseSkillMaxLevel(skId);
			if level < maxLevel and nextBaseSkillData and model.ItemModel:getItemNum(SKILL_MONEY) >= nextBaseSkillData.cost and skillCd <= 0 then
				skillState[skId] = true;
			else
				skillState[skId] = false;
			end
		end
	end
	return skillState;
end

function HomeModel:getCardStarActiveState()
	local locked,lockLv = model.CardModel:getLockStateCard();
	if not locked then
		local curDefTypeCards = {};
		for k, v in pairs(model.CardModel:GetAllCard()) do
			local quality = v.quality;
			if v.star_lv > 3 and ((quality < 5 and v.star_lv < CARD_STAR_SSR_MAX_LEVEL) or (quality >= 5 and v.star_lv < CARD_STAR_MAX_LEVEL)) then
				local rolePre = ResTable:getRowData('role_pre', v.no);
				if not curDefTypeCards[rolePre.def_type] then
					curDefTypeCards[rolePre.def_type] = {};
				end

				if not curDefTypeCards[rolePre.def_type][v.no] then
					curDefTypeCards[rolePre.def_type][v.no] = {};
				end

				if not curDefTypeCards[rolePre.def_type][v.no][v.star_lv] then
					curDefTypeCards[rolePre.def_type][v.no][v.star_lv] = v;
				else 
					local card = curDefTypeCards[rolePre.def_type][v.no][v.star_lv];
					local cardInTeam = model.TeamModel:isRoleInTeam(card.pid);
					local vInTeam = model.TeamModel:isRoleInTeam(v.pid);

					if vInTeam and not cardInTeam then
						curDefTypeCards[rolePre.def_type][v.no][v.star_lv] = v;
					elseif (vInTeam and cardInTeam) or (not vInTeam and not cardInTeam) then
						if v.level > card.level then
							curDefTypeCards[rolePre.def_type][v.no][v.star_lv] = v;
						end
					end
				end
			end
		end

		for _defType , noCards in pairs(curDefTypeCards) do
			for _no , starCards in pairs(noCards) do
				for _star , v in pairs(starCards) do
					local isEnough= model.CardModel:getCardStarActiveState(v.pid);
					if isEnough then
						return true;
					end
				end
			end
		end
	end
	
	return false;
end

function HomeModel:getEquipActiveState()
	if self:getLockStateByType( HomeModel.HomeMenuTag.TAG_EQUIP ) then
		return false;
	end
	for i = 1 , 4 do
		local state = model.EquipModel:getEquipComposeActiveState(i);
		if state[i] then
			return true;
		end
	end
	return false;
end

function HomeModel:getLockStateByType( baseType )
	local locked = false;
	local lockLv = 0;

	if baseType == nil or baseType == -1 then
		return locked,lockLv;
	end

	if baseType == HomeModel.HomeMenuTag.TAG_EQUIP then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_18)
	elseif baseType == HomeModel.HomeMenuTag.TAG_LIBRARY then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_14)
	elseif baseType == HomeModel.HomeMenuTag.TAG_CARD then
		locked,lockLv = model.CardModel:getLockStateCard()
	elseif baseType == HomeModel.HomeMenuTag.TAG_ARENA then
		locked,lockLv = model.ArenaModel:getLockLevelStateArena()
	elseif baseType == HomeModel.HomeMenuTag.TAG_TRIAL then
		locked,lockLv = model.TrialModel:getLockStateTrial()
	--elseif baseType ==HomeModel.HomeMenuTag.TAG_CARD_COMPOSE then
	--	locked,lockLv = model.CardModel:getLockStateCardCompose()
	elseif baseType == HomeModel.HomeMenuTag.TAG_RANDOMSHOP then
		locked,lockLv = model.ShopModel:getLockStateRandomShop()
	elseif baseType == HomeModel.HomeMenuTag.TAG_MAZE then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_23)
	elseif baseType == HomeModel.HomeMenuTag.TAG_FUTURECARD then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_21)
	elseif baseType == HomeModel.HomeMenuTag.TAG_MULTARENA then
		locked,lockLv = tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_25)
	elseif baseType == HomeModel.HomeMenuTag.TAG_GUILD then
		locked ,lockLv = model.GuildModel:getLockStateGuild();
	end

	return locked,lockLv;
end

return HomeModel
