local ItemModel = class("ItemModel")

function ItemModel:ctor()
	self:clearAll()
end
function ItemModel:clearAll(  )
	self.itemList = {};
	self.playBallList = {}
end
function ItemModel:initItems(items)
	self:clearAll()

	for k, v in pairs(items) do
		self.itemList[v.no] = v;
		self.itemList[v.no].resid = v.no;
	end
	local data = ResTable:getTable("item");

	for k, v in pairs(data.contain) do
		if not self.itemList[v.no] and v['type'] ~= 8 and v['type'] ~= 9 then
			self.itemList[v.no] = {};
			self.itemList[v.no].itid = 0;
			self.itemList[v.no].no = v.no;
			self.itemList[v.no].num = 0;
			self.itemList[v.no].resid = v.no;
		end
	end

end

function ItemModel:AddItem(no, num)
	if not self.itemList[no] then
		self.itemList[no] = {}
		self.itemList[no].no = no
		self.itemList[no].num = num
		self.itemList[no].resid = no
	else
		self.itemList[no].num = self.itemList[no].num + num
	end
end

function ItemModel:getItem(eid)
	return self.itemList[eid];
end
function ItemModel:updateItem(no , num)
	if self.itemList[no] then
		self.itemList[no].num = num;
	end
end
-- only = nil 获取钻石时，默认同时获取付费+免费数量 
function ItemModel:getItemNum(resid,only)
	if resid == COLOR_DIA then
		local freeDia = self.itemList[resid]
		local freeDiaNum = freeDia == nil and 0 or freeDia['num']

		local payDiaNum = 0;
		if only ~= true then
			local payDia = self.itemList[COLOR_DIA_PAY];
		 	payDiaNum = payDia == nil and 0 or payDia['num']
		end

		return freeDiaNum + payDiaNum
	else
		if self.itemList[resid] then
			return self.itemList[resid].num;
		else
			return 0;
		end
	end

end
-- function ItemModel:getItemByNo(no)
-- 	for _k , item in pairs(self.itemList) do
-- 		if item.no == no then
-- 			return item;
-- 		end
-- 	end
-- 	return nil;
-- end
function ItemModel:getItemsByType(itemType)
	local itemList = {};
	for _k , item in pairs(self.itemList) do
		if ResTable:getValue('item' , item.no , 'type') == itemType and item.num > 0 then
			table.insert(itemList , item);
		end
	end
	return itemList;
end

function ItemModel:removeItem(no, num)

	if self.itemList[no] then
		self.itemList[no].num = self.itemList[no].num - num
		if self.itemList[no].num <= 0 then
			self.itemList[no].num = 0
		end
	end
end

function ItemModel:getAllItem()
	return self.itemList;
end

function ItemModel:updateItemByNo( item )
	if item == nil or item.no == nil then 
		print("error ===============   updateItemByNo ");
		dump(item);
		return 
	end 

	if not self.itemList[item.no] then
		self.itemList[item.no] = {}
		self.itemList[item.no].no = item.no;
	end
	if item.addNum then
		self.itemList[item.no].num = self.itemList[item.no].num + tonumber(item.addNum);
	else
		self.itemList[item.no].num = item.num;
	end
end

--==============================--
--desc:
--time:2019-09-12 11:38:38
--@item:
--@bReturn: 不直接触发通知，而是传递到参数eventList中
--@return 
--==============================--
function ItemModel:onItemChangeTriggerEvent( item ,bReturn ,trigerEventList)
	if item == nil then
		return 
	end
	local eventList = {}
	local headItem = UIManager:getPanelHandler('HeaderPanel'):getHeadItem();
	if headItem[item.no] or item.no == COLOR_DIA_PAY then
		table.insert( eventList,{EventType.UIHeadeMoneyUpdate} )
	elseif item.no == BREAK_MONEY then
		table.insert( eventList,{EventType.FightPanelBtnRedDot,1} )
	elseif item.no == 10007 then 
		-- 随机boss感知点
		table.insert( eventList,{EventType.FightPanelRandomBossPoint} )
		table.insert( eventList,{EventType.FightPanelBtnRedDot,5} )
	end
	-- 
	if bReturn == true and trigerEventList ~= nil then
		for k,eventItem in pairs(eventList) do
			if eventItem[2] ~= nil then
				trigerEventList[eventItem[1]] = trigerEventList[eventItem[1]] or {}
				trigerEventList[eventItem[1]][eventItem[2]] = true;
			else
				trigerEventList[eventItem[1]] = true
			end
		end
	else
		for k,eventItem in pairs(eventList) do
			if eventItem then
				EventManager:FireEvent(eventItem[1],eventData[2]);
			end
		end
	end
end

function ItemModel:onChangeTriggerEvent( items )

	local trigerEventList = {}
	for k, v in pairs(items) do
		self:onItemChangeTriggerEvent(v,true,trigerEventList);
	end

	for eventKey,v in pairs(trigerEventList) do
		if type(v) == 'table' then
			for eventKey2,v in pairs(v) do
				EventManager:FireEvent(eventKey,eventKey2);
			end
		else
			EventManager:FireEvent(eventKey);
		end
	end
end

function ItemModel:onChangeItems( msg )
	local items = msg;
	if items~= nil and  items['items'] ~= nil  then
		items = items['items'];
	end

	-- local updateHead = false
	-- local updateCardLevel = false;
	for k, v in pairs(items) do
		self:updateItemByNo(v);
		-- self:onItemChangeTriggerEvent(v);
		-- if v.no == COLOR_DIA and not updateHead then
		-- 	updateHead = true;
		-- end
		-- if v.no == BREAK_MONEY then
		-- 	updateCardLevel = true
		-- end
	end
	self:onChangeTriggerEvent(items);
	-- if updateCardLevel and UIManager:panelIsVisible('FightPanel') then
	-- 	EventManager:FireEvent(EventType.FightPanelBtnRedDot , 4);
	-- end
	
	-- if updateHead then
	-- 	EventManager:FireEvent(EventType.UIHeadeMoneyUpdate);
	-- end
end

function ItemModel:updateBag( msg )
	local items = msg ;
	if msg == nil then
		return 
	end
	if items~= nil and  items['items'] ~= nil  then
		items = items['items'];
	end
	local noticeHeaderFlag = false;
	for key, val in pairs(items) do
		if val.no == Conf.GAMEMONEY or
			val.no == Conf.REDDIAMOND or
			val.no == Conf.OIL then
			noticeHeaderFlag = true;
		end
		if val.no ==nil  then
			dump(items,"=====error==========");
		end
		if val.no > 80000 and val.no < 100000 then
		else
			self:updateItemByNo(val);
		end
	end
	if noticeHeaderFlag then
		EventManager:FireEvent(EventType.UIHeaderPanelUpdate);
	end
	EventManager:FireEvent(EventType.UIBagPanelUpdate, info);

end

function ItemModel:getLockStateFightItemUse(  )
    return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_5);		
end

function ItemModel:getPlayBallList( no )
	if self.playBallList[no] and self.playBallList[no].list then
		return self.playBallList[no].list, self.playBallList[no].token;
	else
		return nil;
	end
end

function ItemModel:sendPlayBallOne( no, idx )
	if self.playBallList[no] and self.playBallList[no].token then
		local msg = {};
	    msg.no = no;
	    msg.token = self.playBallList[no].token;
	    msg.id = idx;
		Network.NetworkManager:Send(Network.NetworkCmdType.req_play_ball_shoot, msg);
	end
end
function ItemModel:retPlayBallList( data )
	-- print_ro(data, 'fubin')
	if data.list and data.no then
		self.playBallList[ data.no ] = {list=data.list, token=data.token};
		EventManager:FireEvent('PlayBallPanel:refreshAllBox');
	end

	if data.itemChange then
		EventManager:FireEvent('PlayBallPanel:refreshTopItems');
	end
end


return ItemModel;
