local LibraryCollectionModel = class("LibraryCollectionModel")

function LibraryCollectionModel:ctor(  )
    self:clearAll()
end

function LibraryCollectionModel:clearAll(  )
    self.rAchievements = nil;
    self.hasInit = false;
    self.curTime = 0;
end

function LibraryCollectionModel:init(  )
    -- body
end

function LibraryCollectionModel:isInit(  )
    -- body
    return self.hasInit;
end

function LibraryCollectionModel:getLibraryAchievementDatas(  )
    -- body
    return self.rAchievements;
end

function LibraryCollectionModel:getLibraryDataByAchId( achievementId  )
    -- body
    -- return self.rAchievements;
    for k,v in pairs(self.rAchievements.contain) do
        -- print(k,v)
        if v.achievement_id == achievementId then
            return v;
        end
    end

    return nil ;
end


--==============================--
--desc:请求 成就列表
--time:2019-05-17 10:27:30
--@return 
--==============================--
function LibraryCollectionModel:reqAchievementInfo(  )
    Network.NetworkManager:Send(Network.NetworkCmdType.req_library_achivement_info,{}); 
end

function LibraryCollectionModel:initLibraryAchievementInfo(userArchive)
    self.hasInit = true ;
    self.rAchievements = ResTable:getTable("achievement");
    local myAchievement = userArchive;
    -- dump(myAchievement);

    local totalCount = 0;
    local completeCount = 0;
    for k,v in pairs(self.rAchievements.contain) do
        totalCount = totalCount + 1;
        local achId = v['id']; 
        local row,col = unpack(v['row_column']);
        v['completed'] = 0;
        v['rewarded']  = 0;
        v['piece_state'] = {};
        if myAchievement[tostring(achId)] then
            v['rewarded'] = myAchievement[tostring(achId)]['rewarded'];
            local piece_state_update = myAchievement[tostring(achId)]['piece_state'];
            v['completed'] = 1;
            for i=1,row*col do
                v['piece_state'][i] = piece_state_update[i] or 0;
                if v['piece_state'][i] == 0 then
                    v['completed'] = 0;
                end
            end
        else
            for i=1,row*col do
                v['piece_state'][i] =  0;
            end          
        end
        completeCount =completeCount + v['completed'];
        v['achievement_id'] = achId;

    end
    self.rAchievements["totalCount"] = totalCount;
    self.rAchievements["completeCount"] = completeCount;

    EventManager:FireEvent(EventType.NetWorkLibraryAchievementInfo);
end

function LibraryCollectionModel:retLibraryAchievementInfo(msg)
    self:initLibraryAchievementInfo(msg.contain);
end
--==============================--
--desc:查看成就，改变所有碎片状态2--->1 碎片高亮变为普通
--time:2019-05-20 03:58:06
--@args:
--@return 
--==============================-
function LibraryCollectionModel:changeAchievementStateNoramal( achieveId )
    -- body
    local achieveData = {
        achievement_id = achieveId,
        change_state = 1,
    }
    Network.NetworkManager:Send(Network.NetworkCmdType.req_library_achievement_change_state,achieveData); 

end

function LibraryCollectionModel:retLibraryAchievementSaveState(  msg  )
    -- body
    -- dump(msg);
    -- 请求数据时，已做处理
end
--==============================--
--desc:请求成就奖励
--time:2019-05-27 10:50:50
--@tag:
--@return 
--==============================-----
function LibraryCollectionModel:reqAchievementReward( tag )
    if  tag == nil  then
        return ;
    end    
    local data = self.rAchievements.contain[tostring(tag)];
    if data == nil then
        return 
    end
    -- dump(data);
    if data.rewarded and data.rewarded ~= 0 then
        Prompt:Show(LANG.UI_LIBRARY_6);
        return ;
    end
    if self.reqReward then
        Prompt:Show(LANG.UI_LIBRARY_5);
        return ;
    end
    self.reqReward = true ;

    local seq = {
        achievement_id = data.achievement_id;
    }
    Network.NetworkManager:Send(Network.NetworkCmdType.req_library_achievement_get_reward,seq); 
end

function LibraryCollectionModel:retAchievementReward( msg )
    -- body
    -- dump(msg);

    local achievement_id = msg.achievement_id;
    local data = self.rAchievements.contain[tostring(achievement_id)];
    if data == nil then
        return 
    end

    local achievement_name = data.name or 'unknowName'
    local show_msg = string.format( LANG.UI_LIBRARY_7,achievement_name );
    Prompt:Show(show_msg);

    data.rewarded = 1;

    self.reqReward = false ;

end

function LibraryCollectionModel:updateAchievement( updateAchievementStates )
    print_ro(updateAchievementStates,"LibraryCollectionModel:updateAchievement。。。154---");
    if self.hasInit == false or updateAchievementStates == nil  then
        return ;
    end
    -- local updateFlag = false;
    local completeCount = self.rAchievements['completeCount'];
    for k,v in pairs(self.rAchievements.contain) do
        local achId = v['id']; 
        local completed = v['completed'];

        if completed == 0 and updateAchievementStates[tostring(achId)] then
            local piece_state_local = v['piece_state'];
            local piece_state_update = updateAchievementStates[tostring(achId)]['piece_state'];

            v['completed'] = 1;
            for i=1,#piece_state_local do
                if piece_state_update[i] ~= nil and piece_state_local[i] ~= piece_state_update[i]  then
                    v['refrush'] = true;
                    -- updateFlag = true ;
                end
                v['piece_state'][i] = piece_state_update[i] or v['piece_state'][i] or 0;
                if  v['piece_state'][i]  == 0  then
                    v['completed'] = 0;
                end
            end
            completeCount = completeCount +  v['completed'];
        end
    end
    self.rAchievements['completeCount'] = completeCount;
    -- if updateFlag == true  then
    --     EventManager:FireEvent(EventType.NetWorkLibraryAchievementInfoUpdate);
    -- end


end

return LibraryCollectionModel; 