local MailModel = class("MailModel")

function MailModel:ctor()
	self:clearAll()
end

function MailModel:clearAll(  )
	self.mailData = {};
	--self.isGetData = false;
	self.reqMailTime = 0;
	self.newMailState = false;
	-- self.curTime = 0;
end

function MailModel:init()
	
end

function MailModel:initMailData(mails)
	self:clearAll()

	if mails == nil then
		self.reqMailTime = 0;
		return
	end
	self.mailData = mails
	self:sortMails()
	self.reqMailTime = TimeManager:getCurTime();
	self.newMailState = false;
end

function MailModel:isReqMail()
	local curTime = TimeManager:getCurTime();
	return (curTime - self.reqMailTime) > 5;
end

function MailModel:sendGetAllMail()
	Network.NetworkManager:Send(Network.NetworkCmdType.req_gmail_list_t , {});
end

function MailModel:sendOpenMail(id)
	local req = {
		id = id,
	}
	Network.NetworkManager:Send(Network.NetworkCmdType.req_open_mail_t ,req);
end
function MailModel:sendGetReward(id)
	local req = {
		id = id,
	}
	Network.NetworkManager:Send(Network.NetworkCmdType.req_gmail_reward_t ,req);
end

function MailModel:onRetMailReward( msg )
	self:setMailReward(msg);
end

function MailModel:sendGetAllReward()
	Network.NetworkManager:Send(Network.NetworkCmdType.req_gmail_getallreward_t ,{});
end

function MailModel:onRetMailGetAllReward( msg )
	print("获取全部")
	self:setMailAllReward(msg);
end
--プレゼント一括処理
function MailModel:sendGetAllRewardDel()
	Network.NetworkManager:Send(Network.NetworkCmdType.req_gmail_delallmail_t ,{});
end

function MailModel:onRetMailDelAll( msg )
	print("删除全部")
	if not msg or not msg.ids then
		return;
	end
	for _k, id in pairs(msg.ids) do
		self:removeMail(id);
	end
end

function MailModel:isHaveMail(  )

	local mailKey,value = next(self.mailData);
	return mailKey ~= nil and true or false;
	
end
--判断是否有奖励
function MailModel:isHaveNotRewardGet()
	for _k , mail in pairs(self.mailData) do
		if mail.rewarded == 1  then --mail.flag == 2
			return true;
		end
	end
	return false;
end

function MailModel:isHaveNotOpenedMail()
	for _k , mail in pairs(self.mailData) do
		if mail.opened == 0  then
			return true;
		end
	end
	return false;
end
function MailModel:removeMail(id)
	for _k , mail in pairs(self.mailData) do
		if  mail.id == id then --mail.flag == 2 and
			table.remove(self.mailData , _k);
			return true;
		end
	end
	return false;
end
function MailModel:getMail(id)

	if not self.mailData then
		return
	end 

	for _k, mail in pairs(self.mailData) do
		if mail.id == id then
			return mail;
		end
	end
	return nil;
end
function MailModel:getMailData()
	return self.mailData;
end

function MailModel:sortMails()

	if not self.mailData then
		return;
	end
	if(#self.mailData > 1) then
		table.sort(self.mailData, function(mail_1 , mail_2)
			if mail_1.opened ~= mail_2.opened then
				return mail_1.opened < mail_2.opened; 
			end
			return mail_1.stamp < mail_2.stamp;
		end);
	end
end
function MailModel:setMailData(msg)
	if not msg or not msg.mails then
		self.reqMailTime = 0;
		return
	end
	self:initMailData(msg.mails)

end
function MailModel:setOpenMail(msg)
	if not msg then
		return
	end
	local mail = self:getMail(msg.id)
	if mail then
		mail.opened = 1;
	end
end
function MailModel:setMailReward(msg)
	if not msg then
		return;
	end
	self:removeMail(msg.id);
end
function MailModel:setMailAllReward(msg)
	if not msg or not msg.ids then
		return;
	end
	for _k, id in pairs(msg.ids) do
		self:removeMail(id);
	end
end

function MailModel:setNtNewMail(mails)
	if mails == nil  then
		return 
	end
	self.reqMailTime = 0;
	self.newMailState = true;
	Prompt:Show(LANG.UI_MAIL_13)
	EventManager:FireEvent(EventType.NetworkMailNtNewMail);
end

function MailModel:getRedDotStateMail( ... )
	if self:getLockStateMail() then
		return false;
	end

	if self.newMailState then
		return true;
	end

	return self:isHaveNotOpenedMail();
end
-- bool,lockLv
function MailModel:getLockStateMail(  )
    return tools.LevelLockTools:checkLockById(1000);		
end

return MailModel
