local OperateModel = class("OperateModel")

function OperateModel:ctor()
	self:clearAll()
end

function OperateModel:clearAll(  )
	self.operates = {};
end

function OperateModel:Init(operateData)
	self:clearAll()

	if operateData then
		for _k , operate in pairs(operateData) do
			if not self.operates[operate.type] then
				self.operates[operate.type] = {};
			end
			table.insert(self.operates[operate.type] , operate);
		end
	end
end

function OperateModel:updateData( operateData )
	if operateData then
		for _k , operate in pairs(operateData) do
			if self.operates[operate.type] then
				self.operates[operate.type] = nil;
			end
		end

		for _k , operate in pairs(operateData) do
			if not self.operates[operate.type] then
				self.operates[operate.type] = {};
			end
			table.insert(self.operates[operate.type] , operate);
		end
	end
end

function OperateModel:getOperateByType(operateType)
	return self.operates[operateType];
end

function OperateModel:isValidByType( oType )
	if self.operates[oType] then
		local curTime = TimeManager:getCurTime()
		for k,v in pairs(self.operates[oType]) do
			if curTime<=v.close_time and curTime>=v.open_time then
				return true
			end
		end
	end
	return false;
end


return OperateModel;



--- 1 
