local RechargeModel = class('RechargeModel')

function RechargeModel:ctor(  )
    self:clearAll()
    self.rechargeTaskData = {};
end

function RechargeModel:clearAll( ... )
    self.hasInit = false ;
    self.growupData = {
        growupPrice = 0;
        growupRedDot = false;
        growupState = 0,
        growupData = {},
    };
    self.growupSpData = {
        growupPrice = 0;
        growupRedDot = false;
        growupState = 0,
        growupData = {},
    };

    self.specialOfferGift = {
        giftNo = 0,
        endTime = 0,
        giftData = {},
        isFightShow = false
    };

end

function RechargeModel:Init( msg )
    self:clearAll();
    if msg.recharge == nil then
        return ;
    end
    self.hasInit = true ;
    self.cumulative_money = 0;
    self.first = {
        data = {},
        complete_day = 0,   -- 达成当日零点时间
        reward_stage = {},   -- 已领取阶段
        get_state = 0,      -- 0 前往充值，1 领取奖励，2 明日再来，其他 已全部领取
    }
    self.hundred = {
        data = {},
        complete_day = 0,
        reward_stage = 0, 
        get_state = 0, -- 0 前往充值，1 领取奖励，2 明日再来，其他 已全部领取
    }
	self.month = {}
    for k,v in pairs(ResTable:getTable('month_card').contain) do
		local data = v;
        local i = v.id;
        local price = ResTable:getValue('price', data.price, CURRENCY) or 0;
		self.month[i] = {}
		self.month[i].state =  3
		self.month[i].close_time =  0
		self.month[i].reward_time =  0
		self.month[i].price = price
    end    
    self:retRecharge(msg)
    -- 首冲/百元充值达成，三日奖励内容
    local rechargeData = ResTable:getTable('recharge_first');
    if rechargeData and rechargeData.contain then
        for k,item in pairs(rechargeData.contain) do
            if item.no == 1 then
                self.first.data[item.times] = item;
            elseif item.no == 2 then 
                self.hundred.data[item.times] = item;
            end
        end
    end

    
    local growupData = {};
    if msg.recharge.growup_reward then
        if msg.recharge.growup_reward.growup_reward then
            for _k , rewardNo in pairs(msg.recharge.growup_reward.growup_reward) do
                growupData[tonumber(rewardNo)] = 1;
            end
        end
        if msg.recharge.growup_reward.growup_state then
            self.growupData.growupState = msg.recharge.growup_reward.growup_state
        end

        if msg.recharge.growup_reward.price then
            self.growupData.growupPrice = msg.recharge.growup_reward.price
        end
    end

    self.growupData.growupRedDot = false;
    local curLevel = model.UserModel:getUserLevel();
    local rechargeData = ResTable:getTable('recharge_growup').contain;
    for _k , data in pairs(rechargeData) do
        local state = growupData[data.no];
        data.state = state ~= nil and state or 0;
        self.growupData.growupData[data.no] = data;
        if self.growupData.growupState == 1 and curLevel >= data.lv and data.state==0 then
            self.growupData.growupRedDot = true;
        end
    end


    local growupSpData = {};
    if msg.recharge.growup_sp_reward then
        if msg.recharge.growup_sp_reward.growup_reward then
            for _k , rewardNo in pairs(msg.recharge.growup_sp_reward.growup_reward) do
                growupSpData[tonumber(rewardNo)] = 1;
            end
        end
        if msg.recharge.growup_sp_reward.growup_state then
            self.growupSpData.growupState = msg.recharge.growup_sp_reward.growup_state
        end

        if msg.recharge.growup_reward.price then
            self.growupSpData.growupPrice = msg.recharge.growup_sp_reward.price
        end
    end

    self.growupSpData.growupRedDot = false;
    local curLevel = model.UserModel:getUserLevel();
    local rechargeData = ResTable:getTable('recharge_growup_sp').contain;
    for _k , data in pairs(rechargeData) do
        local state = growupSpData[data.no];
        data.state = state ~= nil and state or 0;
        self.growupSpData.growupData[data.no] = data;
        if self.growupSpData.growupState == 1 and curLevel >= data.lv and data.state==0 then
            self.growupSpData.growupRedDot = true;
        end
    end
end

function RechargeModel:retRecharge( msg )
    if msg == nil or msg.recharge == nil then
        return 
    end
    local recharge = msg.recharge;
    -- dump(recharge,'recharge= === ');
    if recharge.cumulative_money then
        self.cumulative_money = recharge.cumulative_money 
    end
    -- 首充
    local updateGetState = false;
    if recharge.first_day and recharge.first_day ~= 0 then
        self.first.complete_day = recharge.first_day;
        updateGetState = true;
    end

    if recharge.first_reward_stage then
        self.first.reward_stage = recharge.first_reward_stage;
        updateGetState = true;
    end
    if updateGetState then
        if self.first.complete_day == 0 then 
            self.first.get_state = 0
        else
            self.first.get_state = 1
        end
    end
    -- 百元赠礼
    updateGetState = false;
    if recharge.hundred_day and recharge.hundred_day ~= 0 then
        self.hundred.complete_day = recharge.hundred_day;
        updateGetState = true;
    end
    if recharge.hundred_reward_stage then
        self.hundred.reward_stage = recharge.hundred_reward_stage;
        updateGetState = true;
    end
    if updateGetState then
        if self.hundred.reward_stage >= 3 then
            self.hundred.get_state = 3
        elseif self.hundred.complete_day == 0 then 
            self.hundred.get_state = 0
        else
            local curTime = TimeManager:getCurTime();
            local offTime = curTime - self.hundred.complete_day 
            local day = math.floor( tonumber(offTime) /(60*60*24) ) + 1;
            if day > self.hundred.reward_stage then
                self.hundred.get_state = 1
            else
                self.hundred.get_state = 2
            end
        end
    end

    -- 月卡
    if recharge.month then
        local curTime = TimeManager:getCurTime();
        if recharge.month.state == nil then
            recharge.month.state = {}
        end
        if recharge.month.close_time == nil then
            recharge.month.close_time = {}
        end
        if recharge.month.reward_time == nil then
            recharge.month.reward_time = {}
        end
        for k,v in pairs(self.month) do
            local i = k;
            self.month[i].state = recharge.month.state[tostring(i)] or self.month[i].state
            self.month[i].close_time = recharge.month.close_time[tostring(i)] or self.month[i].close_time
            self.month[i].reward_time = recharge.month.reward_time[tostring(i)] or self.month[i].reward_time
            local offTime = self.month[i].close_time - curTime
            self.month[i].remain_time = offTime < 0 and 0 or math.floor( tonumber(offTime) /(60*60*24) ) ;
        end
        -- for i=1, 3 do
        --     self.month[i].state = recharge.month.state[tostring(i)] or self.month[i].state
        --     self.month[i].close_time = recharge.month.close_time[tostring(i)] or self.month[i].close_time
        --     self.month[i].reward_time = recharge.month.reward_time[tostring(i)] or self.month[i].reward_time
        --     local offTime = self.month[i].close_time - curTime
        --     self.month[i].remain_time = offTime < 0 and 0 or math.floor( tonumber(offTime) /(60*60*24) ) ;
        -- end

        -- dump(self.month,'month === ');
    end

    -- rechage_online
    if recharge.recharge_online then
        model.ShopModel:retRechageOnlineTimes(recharge.recharge_online);
    end

    -- shop_gift
    if recharge.gift then
        model.ShopModel:retBuyGift(recharge.gift);
    end

    if recharge.recharge_state then
        --更新商店 充值页签 首充状态
        model.ShopModel:changeFstBuyState(recharge.recharge_state);
    end

    if recharge.growup_state then
        self.growupData.growupState = msg.recharge.growup_state;
        self:updateGrowupRedDot()
    end

    if recharge.growup_sp_state then
        self.growupSpData.growupState = msg.recharge.growup_sp_state;
        self:updateGrowupSpRedDot()
    end

    if recharge.special_offer_gift then
        self:updateSpecialOfferGift(recharge.special_offer_gift)
    end

    if recharge.special_state then
        model.BattlepassEventModel:updateSpecialState(recharge.special_state);
    end

    if recharge.maze_bp_special_state then
        model.EventModel:updateMazeBPActiveState(recharge.maze_bp_special_state);
    end

    if recharge.user_bank_season_id then
        model.RoundModel:retBuyRoundMission( recharge.user_bank_season_id )
    end

    if msg.operate_opens_recharge_task_done then
        for k,v in pairs(msg.operate_opens_recharge_task_done) do
            self:updateRechargeTaskData(v)
        end
    end
end

function RechargeModel:retMonthCardActive(msg)
	for k, v in pairs(msg.recharge.month_state) do
		self.month[tonumber(k)].state = v
	end
    local curTime = TimeManager:getCurTime();
	for k, v in pairs(msg.recharge.month_close_time) do
		self.month[tonumber(k)].close_time = v
        local offTime = self.month[tonumber(k)].close_time - curTime
		self.month[tonumber(k)].remain_time = offTime < 0 and 0 or math.floor( tonumber(offTime) /(60*60*24) ) ;
	end
end

function RechargeModel:retMonthCardGetReward(msg)
	for k, v in pairs(msg.recharge.month_state) do
		self.month[tonumber(k)].state = v
	end
end

function RechargeModel:reqRechargeInfo( callback )
	local msg = {};
	Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_info , msg, callback);
end

function RechargeModel:reqRechargeGetReward( no ,idx)
    local msg = {};
    msg.no = no;
    msg.time_id = idx;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_recharge_reward , msg);
end

function RechargeModel:hasInitOk( ... )
    return self.hasInit;
end

function RechargeModel:resetRechargeInit(  )
    self.hasInit = false;
end

function RechargeModel:getRechargeInfoByNo( no )
    if no == 1 then
        return self.first;
    elseif no == 2 then 
        return self.hundred;
    end
end

function RechargeModel:getMonthData(  )
    return self.month;
end

function RechargeModel:getRechargeTotalMoney( ... )
    return self.cumulative_money;
end

function RechargeModel:getIsMonthUser( ... )
	return false
	--[[
    if self.month == nil then
        return false;
    end
    return self.month.close_time > 0 ; 
	--]]
end

function RechargeModel:getGrowupData()
    return self.growupData.growupData;
end

function RechargeModel:getGrowupState()
    return self.growupData.growupState;
end

function RechargeModel:getGrowupPrice()
    return self.growupData.growupPrice
end

function RechargeModel:updateGrowupState(no,state)
    if self.growupData.growupData[no] then
        self.growupData.growupData[no].state = state;
    end
    self:updateGrowupRedDot()
end

function RechargeModel:updateGrowupRedDot()
    self.growupData.growupRedDot = false;
    local curLevel = model.UserModel:getUserLevel();
    for _k , data in pairs( self.growupData.growupData) do
        if self.growupData.growupState == 1 and curLevel >= data.lv and data.state==0 then
            self.growupData.growupRedDot = true;
            break;
        end
    end
end

function RechargeModel:getGrowupRedDot()
    return self.growupData.growupRedDot
end




function RechargeModel:getGrowupSpData()
    return self.growupSpData.growupData;
end

function RechargeModel:getGrowupSpState()
    return self.growupSpData.growupState;
end

function RechargeModel:getGrowupSpPrice()
    return self.growupSpData.growupPrice
end

function RechargeModel:updateGrowupSpState(no,state)
    if self.growupSpData.growupData[no] then
        self.growupSpData.growupData[no].state = state;
    end
    self:updateGrowupSpRedDot()
end

function RechargeModel:updateGrowupSpRedDot()
    self.growupSpData.growupRedDot = false;
    local curLevel = model.UserModel:getUserLevel();
    for _k , data in pairs( self.growupSpData.growupData) do
        if self.growupSpData.growupState == 1 and curLevel >= data.lv and data.state==0 then
            self.growupSpData.growupRedDot = true;
            break;
        end
    end
end

function RechargeModel:getGrowupSpRedDot()
    return self.growupSpData.growupRedDot
end





function RechargeModel:getMonthRedDot()
    for _k , v in pairs(self.month) do
        if v.state == 1 then
            return true;
        end
    end
    return false;
end

function RechargeModel:updateSpecialOfferGift(giftData,isFightShow)
    
    if giftData.gift_end_time then
        self.specialOfferGift.endTime=giftData.gift_end_time;
    end

    if giftData.gift_data then
        self.specialOfferGift.giftData=giftData.gift_data;
    end

    if isFightShow then
        self.specialOfferGift.isFightShow = true;
    end
    if giftData and next(giftData.gift_data) and giftData.gift_end_time>0 then
        model.ShopModel:insertShopGiftData(giftData)
    end
end

function RechargeModel:getSpecialOfferGiftData()
    return self.specialOfferGift;
end

function RechargeModel:setSpecialOfferFightShow(isShow)
    self.specialOfferGift.isFightShow = isShow;
end

function RechargeModel:getSpecialOfferFightShow()
    return self.specialOfferGift.isFightShow
end

function RechargeModel:getRedDotStateRechargeByIndex( index )
    if index == 1 then
        if self.first.get_state == 1 then
            local rewardState = {};
            for _k , v in pairs(self.first.reward_stage or {}) do
                rewardState[v] = _k;
            end

            local curTime = TimeManager:getCurTime();
            local offTime = curTime - self.first.complete_day;
            local rechargeDays = math.floor( tonumber(offTime) /(60*60*24) ) + 1;

            for i = 1 , 3 do
                if i <= rechargeDays and not rewardState[i] then
                    return true;
                end
            end
        end
        return false;
    elseif index == 2 then 
        return self.hundred.get_state == 1;
    elseif index == 3 then 
        return false;
    end
end

function RechargeModel:getRedDotStateRecharge( ... )
    if self:getLockStateRecharge() then
        return false;
    end
    return self:getRedDotStateRechargeByIndex(1)
        --or  self:getRedDotStateRechargeByIndex(2)

end

function RechargeModel:getLockStateRecharge()
    if not self:getLockLevelStateRecharge() then
        if #self.first.reward_stage < 3 then
            return false;
        end
    end
    return true;
end

function RechargeModel:getLockLevelStateRecharge( )
    return tools.LevelLockTools:checkLockById(Enum:getTable('levelLockItemIds').LEVLE_LOCK_6);
end

function RechargeModel:initRechargeTaskData( data )
    if data then
        for k,v in pairs(data) do
            self.rechargeTaskData[v.type] = v;
        end
    end
end

function RechargeModel:updateRechargeTaskData( data )
    local tp = data.type or 0;
    if data and self.rechargeTaskData[tp] then
        self.rechargeTaskData[tp].price = data.price;
        for k,v in pairs(data.list) do
            local st = 1
            for sk,sv in pairs(self.rechargeTaskData[tp].list) do
                if sv.id == v.id then
                    sv.status = v.status;
                    sv.value = v.value;
                    st = 0;
                    break;
                end
            end
            if st == 1 then
                table.insert(self.rechargeTaskData[tp].list, clone(v))
            end
        end
    end
end

function RechargeModel:retGetRechargeTaskRwd( msg )
    -- body
    self:updateRechargeTaskData(msg.operate_opens_recharge_task)
    UIManager:push('RewardPanel',msg)
end

function RechargeModel:getRechargeTaskData(tp)
    return self.rechargeTaskData[tp];
end

function RechargeModel:isOpenRechargeTask(tp)
    if self.rechargeTaskData[tp] == nil then
        return false;
    end
    local curTime = TimeManager:getCurTime();
    if curTime>=self.rechargeTaskData[tp].open_time and curTime<=self.rechargeTaskData[tp].close_time then
        return true;
    else
        return false;
    end
end

return RechargeModel;
