local StoryModel = class("StoryModel")

function StoryModel:ctor()
	self:clearAll();
end
function StoryModel:clearAll(  )
	self.storyDataList = {}

	self.curStoryId = 0; --当前故事id


	self.storyRoundId = 0; --当前故事 关卡id

	self.storyPlotId = 0; --当前故事剧情id
	self.storyPlotSt = 0; --当前故事剧情的状态 1可战斗 2播放剧情 3选择技能

	self.cardList = {}; --当前选中的角色 pid hp cd 
	self.skillList = {}; --当前获得的技能

	self.witeSelSkillList = {}; --当前等待选择的技能列表

	self.storyList = {}; --故事列表数据， 记录每个故事 里面奖励的领取状态 和 地图开启状态

	self.tempCardList = {}

end

function StoryModel:getAllStoryList()
	return self.storyDataList;
end
function StoryModel:Init(msg)
	-- if tools.ConfigStateTools:checkLockByName('FutureCardPanel') then
	-- 	return
	-- end
	self:clearAll();

	print_ro(msg, 'fubin--dungeon_information')
	if not msg then
		return
	end

	for k,v in pairs(msg) do
		self.storyDataList[v.storyId] = v;

		if v.cardList and #v.cardList>0 then
			self.curStoryId = v.storyId;
			self:updateCardList( v.cardList )
		end
	end
	
end

function StoryModel:updateRetFight( msg )
	if msg.win == 1 then
		self.storyDataList[ self.curStoryId ].monsterTeam = {}
		if msg.storyPlotId and msg.storyPlotId>0 then
			self.storyDataList[ self.curStoryId ].storyPlotId = msg.storyPlotId;
		end
		self.storyDataList[ self.curStoryId ].storyPlotSt = msg.storyPlotSt;

		self.storyDataList[ self.curStoryId ].witeSelSkillList = msg.witeSelSkillList;
	else

		if msg.storyPlotId and msg.storyPlotId>0 then
			self.storyDataList[ self.curStoryId ].storyPlotId = msg.storyPlotId;
		end
		self.storyDataList[ self.curStoryId ].storyPlotSt = msg.storyPlotSt;

		self.storyDataList[ self.curStoryId ].witeSelSkillList = msg.witeSelSkillList;

		self.storyDataList[ self.curStoryId ].monsterTeam = msg.monsterTeam;
	end

	if msg.cardList then
		self.storyDataList[ self.curStoryId ].cardList = msg.cardList;
		self:updateCardList( msg.cardList )
	end
end

function StoryModel:getCurMonsterHpList(storyId)
	if storyId then
		return self.storyDataList[ storyId ].monsterTeam;
	else
		if self.curStoryId>0 then
			return self.storyDataList[ self.curStoryId ].monsterTeam;
		else
			return {}
		end
	end
end

function StoryModel:checkShowPanel( storyid )
	storyid = storyid or self.curStoryId;
	if storyid == self.curStoryId and self.storyDataList[ self.curStoryId ].storyPlotSt == 2 then
		UIManager:push('StoryPlotPanel' , self.storyDataList[ self.curStoryId ].storyPlotId );

	elseif storyid == self.curStoryId and self.storyDataList[ self.curStoryId ].storyPlotSt == 3 then
		UIManager:push('StorySkillSelPanel');

	elseif storyid == self.curStoryId and self.storyDataList[ self.curStoryId ].storyPlotSt == 4 then --完结
		Prompt:Show('已经完结了');

	else
		if self.curStoryId>0 and self.curStoryId~=storyid then
			return;
		end
		UIManager:push('StoryRoundPanel', storyid);
	end
end

function StoryModel:getCardHpAndCd( pid )
	if self.storyDataList[ self.curStoryId ] then
		local cardList = self.storyDataList[ self.curStoryId ].cardList;
		for k,v in pairs(cardList) do
			if pid == v.pid then
				return v.hp, v.cd;
			end
		end
	end
	return 10000, 10000;
end

function StoryModel:getRoundDataById( resId )
	return {}
end

function StoryModel:isInCardList( pid )
	if self.cardList[pid] then
		return true, self.cardList[pid].hp;
	else
		return false, 0;
	end
	-- body
end

function StoryModel:setTempCardList( pid )
	local no1 = model.CardModel:GetCard(pid).no;
	for k,v in pairs(self.tempCardList) do
		local no2 = model.CardModel:GetCard(v).no;
		if pid == v then
			table.remove(self.tempCardList, k)
			return 2, #self.tempCardList;
		end
		if no1 == no2 then
			Prompt:Show('不能选择相同角色的卡牌。')
			return 0, #self.tempCardList;
		end
	end
	if #self.tempCardList >= 8 then
		return 0, #self.tempCardList;
	end

	table.insert(self.tempCardList, pid);
	return 1, #self.tempCardList;
end

function StoryModel:isInTempCardList( pid )
	for k,v in pairs(self.tempCardList) do
		if pid == v then
			return true;
		end
	end
	return false;
end

function StoryModel:getTempCardList()
	return self.tempCardList;
end

function StoryModel:getCurStoryId()
	return self.curStoryId;
end

function StoryModel:getStoryDataById( storyId )
	return self.storyDataList[ storyId ]
end

function StoryModel:saveCardList( storyId )
	local msg = {};
	msg.cardlist = self.tempCardList;
	msg.storyid = storyId;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_story_save_card , msg);
end


function StoryModel:retStoryReset(msg)
	self.curStoryId = 0;
	local sid = msg.storyId
	if self.storyDataList[ sid ] then
		self.storyDataList[ sid ].storyRoundId = msg.storyRoundId

		self.storyDataList[ sid ].monsterTeam = msg.monsterTeam;
		self.storyDataList[ sid ].witeSelSkillList = msg.witeSelSkillList;
		self.storyDataList[ sid ].storyPro = msg.storyPro;
		self.storyDataList[ sid ].storyPlotSt = msg.storyPlotSt;
		if msg.storyPlotId and msg.storyPlotId>0 then
			self.storyDataList[ sid ].storyPlotId = msg.storyPlotId;
		end

		self.storyDataList[ sid ].cardList = msg.cardList;
		self.storyDataList[ sid ].skillList = msg.skillList;

		self:updateCardList( {} )
	end
end

function StoryModel:retSaveCard(msg)
	self.curStoryId = msg.storyId;
	if self.storyDataList[ self.curStoryId ] then
		self.storyDataList[ self.curStoryId ].storyRoundId = msg.storyRoundId;

		self.storyDataList[ self.curStoryId ].storyPlotSt = msg.storyPlotSt;

		if msg.storyRoundId then
			self.storyDataList[ self.curStoryId ].storyRoundId = msg.storyRoundId;
		end
		if msg.storyPlotId and msg.storyPlotId>0 then
			self.storyDataList[ self.curStoryId ].storyPlotId = msg.storyPlotId;
		end
		if msg.storyPlotSt then
			self.storyDataList[ self.curStoryId ].storyPlotSt = msg.storyPlotSt;
		end

		if msg.cardList then
			self.storyDataList[ self.curStoryId ].cardList = msg.cardList;
			self:updateCardList( msg.cardList )
		end

		EventManager:FireEvent('StorySaveCard');

	end
end

function StoryModel:updateCardList( list )
	self.cardList = {};
	for k,v in pairs(list) do
		self.cardList[v.pid] = v;
	end
end

function StoryModel:retStoryData(msg)
end

function StoryModel:retStoryRwd(msg)
end

function StoryModel:retStoryPlot(msg)
	if self.storyDataList[ self.curStoryId ] then
		if msg.storyRoundId then
			self.storyDataList[ self.curStoryId ].storyRoundId = msg.storyRoundId;
		end
		if msg.storyPlotId and msg.storyPlotId>0 then
			self.storyDataList[ self.curStoryId ].storyPlotId = msg.storyPlotId;
		end
		if msg.storyPlotSt then
			self.storyDataList[ self.curStoryId ].storyPlotSt = msg.storyPlotSt;
		end

	end

	UIManager:push('RewardPanel',msg, {callback=handler(self,self.checkShowPanel)})
end

function StoryModel:retStorySkill(msg)
	if self.storyDataList[ self.curStoryId ] then
		if msg.storyRoundId then
			self.storyDataList[ self.curStoryId ].storyRoundId = msg.storyRoundId;
		end
		if msg.storyPlotId and msg.storyPlotId>0 then
			self.storyDataList[ self.curStoryId ].storyPlotId = msg.storyPlotId;
		end
		if msg.storyPlotSt then
			self.storyDataList[ self.curStoryId ].storyPlotSt = msg.storyPlotSt;
		end

		if msg.skillList then
			self.storyDataList[ self.curStoryId ].skillList = msg.skillList;
		end

		self:checkShowPanel()

	end
end


return StoryModel;
