local ConnectManager = class("ConnectManager")

function ConnectManager:ctor()
	self._httpList = {};
end

function ConnectManager:Init(msg)
	self.url = msg.ip .. ':' .. msg.port .. '/' .. msg.php;
end

function ConnectManager:connect(address, port, name)
	local tcp = self:getTcp(name)
	self.lastServer = name;
	return tcp:connect(address, port)
end

function ConnectManager:sendRequest(id, msg, callback)
	if not msg then
		msg = {};
	end
	local http = self:getHttp()
	msg.reqcode = id;
	if not msg.uid then
		msg.uid = model.UserModel:getUserUid();
	end
	http:postRequest(json.encode(msg), callback);
end

function ConnectManager:getHttp()
	if not self.http then 
		self.http = require("app.network.Http"):create()
		self.http:Init(self.url);
		self.http:RegisterErrorHandler(self.callback);
	end

	return self.http;
end

function ConnectManager:RegisterErrorHandler(handler)
	self.callback = handler;
end

function ConnectManager:heartbeatCallback(serverName)
	--self:sendRequest('Actions.Heartbeat')
end

return ConnectManager;
