local Http = class("Http")

function Http:ctor()
end

function Http:Init(url)
	self.url = url;
	self.xhr = cc.XMLHttpRequest:new();
end

function Http:postRequest(msg, onCallbackFunc, option)
	-- 1.通信先指定 ---------------------------------------------------
	self.xhr:open("POST", self.url);
	
	-- 2.CallBack登録 -------------------------------------------------
	self.xhr:registerScriptHandler(function()
	--	print("\t_onReadyStateChange");
		
		-- 通信失敗？
		if( self.xhr.readyState ~= 4
		or  self.xhr.status < 200
		or  self.xhr.status >= 207)then
			print("通信失敗");
		end
		local response = json.decode(self.xhr.response);-- phpでechoしたものが入ってる
		if response['error_code'] then
			self:handlerError(response);
			return;
		end
		
		-- 指定したcallbackがあれば実行
		if onCallbackFunc then
			local response = json.decode(self.xhr.response);-- phpでechoしたものが入ってる
			onCallbackFunc(response);
		end
	end)
	
	-- 3.通信実行
	local sendpost = "data="..msg;
	self.xhr:send(sendpost);
end

function Http:RegisterErrorHandler(callback)
	self.errorHandler = callback;
end

function Http:handlerError(msg)
	if self.errorHandler then
		self.errorHandler(msg);
	end
end

return Http;
