local Webproxy = class("Webproxy")
-- local Cjson = require('Cjson')
local scheduler = cc.Director:getInstance():getScheduler();

function Webproxy:ctor()
	self.ws = nil
	self.connectFlag = false
	self.callback = {}
end

function Webproxy:Init(url)
	local visible = tools.ConfigStateTools:checkVisibleByName('ChatPanel');
	if visible ~= true then
		return 
	end
	self.url = url or self.url
	self.ws = cc.WebSocket:create(self.url);

    if nil ~= self.ws then
        self.ws:registerScriptHandler(handler(self, self.open), cc.WEBSOCKET_OPEN)
        self.ws:registerScriptHandler(handler(self, self.handlerMessage), cc.WEBSOCKET_MESSAGE)
        self.ws:registerScriptHandler(handler(self, self.handlerClose), cc.WEBSOCKET_CLOSE)
        self.ws:registerScriptHandler(handler(self, self.sendError), cc.WEBSOCKET_ERROR)
    end
end

function Webproxy:close()
	if self.ws then
		self.ws:close()
		self.ws = nil
	end
end

function Webproxy:open(strData)
	print("Websocket was opened, url: " .. self.ws.url);
	self.connectFlag = true
	model.ChatModel:sendBaseInfo()
end

function Webproxy:handlerMessage(info)
	EventManager:FireEvent(EventType.ChatReceiveMsg, Cjson.decode(info));
end

function Webproxy:handlerClose()
	if self.ws then
		print("Websocket instance closed.");
		self.ws = nil
	end
end

function Webproxy:sendError(strData)
	print("Websocket Error: ");
	print(strData);
end

function Webproxy:sendMessage(msg)
	if msg then
		msg = Cjson.encode(msg);
	else
		print('Websocket send msg nil error');
		return;
	end
	if self.ws and cc.WEBSOCKET_STATE_OPEN == self.ws:getReadyState() then
		self.ws:sendString(msg);
	else
		print("Websocket instance wasn't ready...");
	end
end

return Webproxy;
