local XMLHttp = class("XMLHttp")

function XMLHttp:ctor()
end

function XMLHttp:Init(url)
	self.url = url;
	self.xhr = cc.XMLHttpRequest:new();
end

function XMLHttp:postRequest(msg, onCallbackFunc, option)
	-- 1.通信先指定 ---------------------------------------------------
	self.xhr:open("POST", self.url, true);
	
	-- 2.CallBack登録 -------------------------------------------------
	self.xhr:registerScriptHandler(function()
		local response = Cjson.decode(self.xhr.response);
		if response['error_code'] then
			self:handlerError(response);
			return;
		end
		
		if onCallbackFunc then
			onCallbackFunc(response);
		end
	end)
	
	-- 3.通信実行
	msg = json.encode(msg);
	local sendpost = "data="..msg;
	self.xhr:send(sendpost);
end

function XMLHttp:RegisterErrorHandler(callback)
	self.errorHandler = callback;
end

function XMLHttp:handlerError(msg)
	if self.errorHandler then
		self.errorHandler(msg);
	end
end

return Http;
