--NetworkMsg_Card.lua

--========================================================================
--网络消息_卡牌

local NetworkMsg_Card = class("NetworkMsg_Card")

function NetworkMsg_Card:ctor()
  --print('NetworkMsg_Card:ctor')
end

---------------------------------------------------
--卡牌锁返回
-- @req
-- int pid
-- int lock 1 for set lock, 0 for setUnlock
-- @ret
-- int code
-- int pid
-- int lock
---------------------------------------------------
function NetworkMsg_Card:onRetLock( msg )
    -- @ret
    -- int code
    -- int pid
    -- int lock
    model.CardModel:setLock(msg.pid,msg.lock)
end

function NetworkMsg_Card:onRetCardLevelUp(msg)
  model.CardModel:updateLevel(msg.pid , msg.level)
  model.FutureCardModel:checkUpdateMax4Cards(msg.pid, msg.level)

  local oldFp = CardProManager:GetCardPro(msg.pid).fp;
  CardProManager:setNeedUpdateGenPro(msg.pid)
  model.CardModel:checkFpUp(msg.pid , oldFp);
  
  --model.TeamModel:checkTeamFpUp(msg.pid);
	--EventManager:FireEvent(EventType.NetworkRetLevelUp , msg);
  EventManager:FireEvent(EventType.NetworkCardListRetLevelUp , msg);
  tools.RedDotTools:pushCardRedDot(1);
end

function NetworkMsg_Card:onRetCardStarLevelUp(msg)
  local tmpPidList = {}
  if msg.main_cards then
    for _k , pid in pairs(msg.main_cards) do
       model.CardModel:removeCard(pid)
       table.insert(tmpPidList, pid)
    end
  end

  if msg.second_cards then
    for _k , pid in pairs(msg.second_cards) do
       model.CardModel:removeCard(pid)
       table.insert(tmpPidList, pid)
    end
  end

  if msg.break_lv then
    model.CardModel:updateBreakLevel(msg.pid , msg.break_lv);
  end

  if msg.quality then
    model.CardModel:updateCardQuality(msg.pid , msg.quality);
  end

  if msg.takeoff_bare_ids then
    for _k , bareId in pairs(msg.takeoff_bare_ids) do
        model.BareCollectModel:updateBareCollectWear(bareId,0);
    end
  end

  local oldPro = CardProManager:GetCardPro(msg.pid);
  model.CardModel:updateStarLevel(msg.pid , msg.star_lv)
  CardProManager:setNeedUpdateGenPro(msg.pid)
  model.CardModel:checkFpUp(msg.pid , oldPro.fp,true);

  model.CardModel:setStarBreakTempData(msg,oldPro);

  UIManager:push('CardLevelUpStarSuccessPanel');

  model.FutureCardModel:checkCardRemoveOrRestMax4Cards(tmpPidList)
end

function NetworkMsg_Card:onRetCardBreak(msg)
  model.CardModel:updateBreakLevel(msg.pid , msg.break_lv)

  local oldPro = CardProManager:GetCardPro(msg.pid);
  CardProManager:setNeedUpdateGenPro(msg.pid)
  model.CardModel:checkFpUp(msg.pid , oldPro.fp , true);

  --EventManager:FireEvent(EventType.NetworkRetCardBreak , msg);
  EventManager:FireEvent(EventType.NetworkCardListRetLevelBreak , msg);

  model.CardModel:setStarBreakTempData(msg,oldPro);
  UIManager:push('StarAndBreakComplatePanel',2);
  --UIManager:push('CardBreakSuccessPanel' , oldPro , msg.pid);
  model.FutureCardModel:checkCardRemoveOrRestMax4Cards({msg.pid})
end

function NetworkMsg_Card:onRetCardBookGetReward(msg)
  model.CardModel:updateCardGetRewardState(msg.no);
  EventManager:FireEvent(EventType.NetworkCardBookGetReward , msg);
  EventManager:FireEvent(EventType.UIHeadeUpdateCardBookRedDot);
end

function NetworkMsg_Card:onRetCardResolve(msg)

    if msg.cardList then
        for _k , pid in pairs(msg.cardList) do
           model.CardModel:removeCard(pid)
        end
    end

    if msg.takeoff_bare_ids then
      for _k , bareId in pairs(msg.takeoff_bare_ids) do
          model.BareCollectModel:updateBareCollectWear(bareId,0);
      end
    end

    EventManager:FireEvent(EventType.NetworkRetCardResolve,msg);
    model.FutureCardModel:checkCardRemoveOrRestMax4Cards(msg.cardList)
end

function NetworkMsg_Card:onRetCardReset(msg)
    if msg.cardList then
        for _k , pid in pairs(msg.cardList) do
            if model.CardModel:isFutureCard(pid) then
              model.CardModel:setFutureOriLeveAndBreak(pid,1,0);
            else
              model.CardModel:updateLevel(pid , 1);
              model.CardModel:updateBreakLevel(pid , 0);
              CardProManager:setNeedUpdateGenPro(pid)
            end
        end

        local newTeamFp = model.TeamModel:getCurrentTeamFp()
	      model.UserModel:checkTopPower(newTeamFp);
    end
    EventManager:FireEvent(EventType.NetworkRetCardReset,msg);

    model.FutureCardModel:checkCardRemoveOrRestMax4Cards(msg.cardList)
end

function NetworkMsg_Card:onRetCardAvatarChange( msg )
  local oldResId = model.CardModel:getCardResIdByPid(msg.pid);
  model.CardModel:onAvatarChange(msg)
  EventManager:FireEvent(EventType.NetworkRetCardAvatarChange,msg,oldResId);
  EventManager:FireEvent(EventType.NetworkCardAvatarRetUse);
end

function NetworkMsg_Card:onRetLoveLevelUp(msg)
    --local oldFp = model.TeamModel:getCurrentTeamFp();
--
    local oldLevel = 0
    local data = model.CardModel:getLoveData(msg.love_id);
    if data then
      oldLevel = data.loveLevel;
    end

    model.CardModel:updateLoveValue(msg.love_id , msg.level , msg.love_value, msg.level > oldLevel and 0 or msg.pos)

    --if msg.level > oldLevel then
    --    CardProManager:setNeedUpdateGenProByNo(msg.role_id);
    --end
    --model.TeamModel:checkTeamFpUp(oldFp)
    
    EventManager:FireEvent(EventType.NetworkLoveLevelUp , msg.level > oldLevel, msg.pos);
end

function NetworkMsg_Card:onRetLoveWear(msg)
    --local oldFp = model.TeamModel:getCurrentTeamFp();
	  model.CardModel:updateCardLoveWear(msg.pid , msg.love_id);
	  --model.TeamModel:checkTeamFpUp(oldFp)
    EventManager:FireEvent(EventType.NetworkRetLoveChange);
end

function NetworkMsg_Card:onRetLovetakeoff(msg)
    --local oldFp = model.TeamModel:getCurrentTeamFp();
    model.CardModel:updateCardLoveWear(msg.pid , 0);
    --model.TeamModel:checkTeamFpUp(oldFp)
    EventManager:FireEvent(EventType.NetworkRetLoveChange);
end

function NetworkMsg_Card:onRetUnlockFutureCardSlot(msg)
  model.FutureCardModel:retUnLockSlot(msg.open_slot)
end

function NetworkMsg_Card:onRetUpdateFutureCardSlot(msg)
  model.FutureCardModel:retUpdateSlot(msg)
end

function NetworkMsg_Card:onRetClearFutureCardSlot(msg)
  model.FutureCardModel:retClearSlot(msg.altar_slot)
end

function NetworkMsg_Card:onRetCardAvatarGet(msg)
    EventManager:FireEvent(EventType.NetworkRetCardAvatarGet,msg);
end

function NetworkMsg_Card:onRetCardAvatarCheck(msg)
  EventManager:FireEvent(EventType.NetworkRetCardAvatarCheck,msg);
end

return NetworkMsg_Card;
