--NetworkMsg_Fight.lua

--========================================================================
--网络消息_战斗

local NetworkMsg_Fight = class("NetworkMsg_Fight")
local FightType = Enum:getTable('FightType');	

function NetworkMsg_Fight:ctor()
end

-----------------------------
--返回开始战斗信息
--@req
-- int: resid
-- int: flag
--@ret
------------------------------
function NetworkMsg_Fight:onRetEnterFight(msg)
	UIManager:push('ScreenEffectPanel', 'door', {callback = function()
		FightManager:setDoorCloseFlag(true)

		FightManager:setWillFightSt(); --下面的面板初始化 用到了是否再战斗中的状态

		if msg.flag == FightType.Boss then
			UIManager:pop('RoundInfoPanel');
			local guideData = model.GuideModel:getGuideStepData();
			local g_id = guideData and guideData.id or 0
			self.funnel_flag = 0
			if g_id == 11 then
				self.funnel_flag = 1
				GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu7_stage1);
			elseif g_id == 25 then 
				self.funnel_flag = 2
				GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu22_stage2);
			elseif g_id == 44 then 
				self.funnel_flag = 3
				GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu37_stage3);
			elseif g_id == 52 then 
				self.funnel_flag = 4
				GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu43_stage4);
			end
		elseif msg.flag == FightType.RandomBoss then
			UIManager:switch('FightPanel');
		elseif msg.flag == FightType.GuildBoss then
			UIManager:switch('FightPanel');
		elseif msg.flag == FightType.TrialTower then 
			UIManager:switch('FightPanel');
		elseif msg.flag == FightType.Story then 
			UIManager:switch('FightPanel');
		elseif msg.flag == FightType.DailyRound then
			UIManager:switch('FightPanel')
		elseif msg.flag == FightType.Event then
			UIManager:switch('FightPanel')
		elseif msg.flag == FightType.Arena then
			UIManager:switch('FightPanel')
			model.ArenaModel:updateChallengeNum(msg.challenge_num);
		elseif msg.flag == FightType.MultArena then
			UIManager:switch('FightPanel')
			-- model.ArenaModel:updateChallengeNum(msg.challenge_num);
		elseif msg.flag == FightType.CopyRound then
			UIManager:switch('FightPanel')
		end

		FightManager:BeginFight(msg); -- 需要先设置状态FightManager:getIsNotFight()
		EventManager:FireEvent(EventType.FightBegin);
	end});
end

-----------------------------
--返回结束战斗信息
--@req
-- int: resid
-- int: flag
-- int: win
--@ret
-- int: resid
-- int: flag
-- int: win
-- TODO star info
function NetworkMsg_Fight:onRetExitFight(msg)
	print('fubin======onRetExitFight:', msg.flag);

	if msg.special_offer_gift then
		model.RechargeModel:updateSpecialOfferGift(msg.special_offer_gift,true)
	end

	if msg.flag == FightType.Boss then
		if msg.new_round ~= msg.resid then
			model.RoundModel:setNewRound(msg.new_round);
		end
		if msg.newRoundBoss then
			model.RoundBossModel:retFightOver(msg);
		end
		UIManager:push('FightOverPanel', msg);
		EventManager:FireEvent(EventType.FightUpdateFooterRedDot,2);
		if self.funnel_flag == 1 then
			GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu9);
		elseif self.funnel_flag == 2 then 
			GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu24);
		elseif self.funnel_flag == 3 then 
			GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu38);
		elseif self.funnel_flag == 4 then 
			GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu44);
		end
	elseif msg.flag == FightType.RandomBoss then
		UIManager:push('FightOverPanel', msg);
		model.RoundBossModel:retFightOver(msg);

	elseif msg.flag == FightType.GuildBoss then
		UIManager:push('FightOverPanel', msg);
	elseif msg.flag == FightType.TrialTower then 
		-- UIManager:push('FightOverPanel', msg);
		model.TrialModel:retTrialFightOver(msg);
		if msg.auto == 0 then
			UIManager:push('FightOverPanel', msg);
		else
			EventManager:FireEvent(EventType.UITrialPanelFightOver,msg);
		end
	elseif msg.flag == FightType.DailyRound then
		if msg.win == 1 then
			model.DailyRoundModel:setFightExitData(msg)
		end
		UIManager:push('FightOverPanel', msg);
	elseif msg.flag == FightType.Event then
		model.EventModel:retFightExitData(msg);
		-- if msg.win == 1 then
		-- 	EventManager:FireEvent(EventType.NetworkEventMapItemFight,msg);
		-- end

		UIManager:push('FightOverPanel', msg)
	elseif msg.flag == FightType.Arena then
		if msg.arena then
			if msg.win == 1 then
				model.ArenaModel:updateRankList(msg.arena.rankList);
				model.ArenaModel:updateScore(msg.arena.score);
			end
			model.ArenaModel:updateChallengeNum(msg.arena.challenge_num);
		end

		UIManager:push('FightOverPanel', msg)
	elseif msg.flag == FightType.MultArena then
		-- if msg.arena then
		-- 	if msg.win == 1 then
		-- 		model.ArenaModel:updateRankList(msg.arena.rankList);
		-- 		model.ArenaModel:updateScore(msg.arena.score);
		-- 	end
		-- 	model.ArenaModel:updateChallengeNum(msg.arena.challenge_num);
		-- end
		model.ArenaModel:setMultAFightResult(msg);
		model.ArenaModel:setMultArenaResult(msg.win);

	elseif msg.flag == FightType.CopyRound then
		if msg.user_adventure_record then
			model.RoundModel:updateCopyRoundInfo(msg.user_adventure_record)
		end
		if msg.win == 1 then
			model.RoundModel:setCopyRoundNewWin(true)
		end

		UIManager:push('FightOverPanel', msg)

	elseif msg.flag == FightType.Story then 
		model.StoryModel:updateRetFight(msg)
		UIManager:push('FightOverPanel', msg)
	end

	tools.RedDotTools:pushFightSceneRedDot(4)

	FightManager:ExitFight(msg);

	if msg.flag == FightType.MultArena then
		EventManager:FireEvent('FightPanel:showMultArenaSubRt',msg);
	end
end

function NetworkMsg_Fight:onRetGetChapterReward(msg)
	if not msg then
		return;
	end

	if msg.code ~= 0 then
		return;
	end

	model.RoundModel:updateChapterReward(msg);
	EventManager:FireEvent(EventType.FightPanelGetChapterReward , msg);
end

function NetworkMsg_Fight:onFastInfo(msg)
	model.AutoFightModel:initFastReward(msg);
	EventManager:FireEvent(EventType.FightFastInfo, msg);
end

function NetworkMsg_Fight:onRetRoundBossGiveUp( msg )
	
	-- model.RoundBossModel:retGiveUpMsg(msg);
	
end

function NetworkMsg_Fight:onRetRoundBossBuy( msg )
	model.RoundBossModel:retbuyBoss(msg)
	EventManager:FireEvent(EventType.RoundBossBuy, msg);

end

function NetworkMsg_Fight:onRetRoundBossRefreshAll( msg )
	model.RoundBossModel:retRefreshAll(msg)
	EventManager:FireEvent(EventType.RoundBossRefreshAll, msg);

end

function NetworkMsg_Fight:onRetRoundBossDBInfo( msg )
	model.RoundBossModel:retRoundBossDBInfo(msg)

end

function NetworkMsg_Fight:onRetDailyRoundInfo(msg)
	model.DailyRoundModel:InitData(msg)
	EventManager:FireEvent(EventType.DailyRoundInfo, model.HomeModel.HomeMenuTag.TAG_DAILYROUND)
end

function NetworkMsg_Fight:onRetGetRoundBreakReward( msg )

	EventManager:FireEvent(EventType.FightRoundBreakGetReward, msg);

end
return NetworkMsg_Fight;
