--NetworkMsg_Guild.lua

--========================================================================
--网络消息_公会

local NetworkMsg_Guild = class("NetworkMsg_Guild")
local MessageBoxType = Enum:getTable('MessageBoxType')
function NetworkMsg_Guild:ctor()
  
end
-----------------------------
--返回公会信息
--@req
-- 
-- 
--@ret
-- code
-- gid
-- name
-- master_name
-- number
-- level
-- exp
-- icon
-- guild_flag
-- 
-- 
-- 
-- 
-- 
-- 
-- 
------------------------------
function NetworkMsg_Guild:onRetGuildInfo(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retGuildInfo(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildInfo , msg);
end
function NetworkMsg_Guild:onRetAllGuildList(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retAllGuildList(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetAllGuildList , msg);
end

function NetworkMsg_Guild:onRetJoinGuild(msg)
    if msg.code ~= 0 then
        return;
    end

    if msg.audit_state == 0 then
        if IsKr then
            UIManager:switch('GuildPanel');
        else
            UIManager:set('GuildPanel', {'HomeBasePanel', 'GuildPanel'})
        end
    else
        model.GuildModel:retJoinGuild(msg);
        EventManager:FireEvent(EventType.NetworkGuildRetJoinGuild , msg);
    end
end

function NetworkMsg_Guild:onRetSearchGuild(msg)
    if msg.code ~= 0 then
        if LANG.ERROR_INFO[msg.code] then
            MessageBox:create(LANG.ERROR_INFO[msg.code],MessageBoxType.OK);
        end
        return;
    end
    model.GuildModel:retSearchGuild(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetSearchGuild , msg);
end

function NetworkMsg_Guild:onRetCreateGuild(msg)
    if msg.code ~= 0 then
        if LANG.ERROR_INFO[msg.code] then
            MessageBox:create(LANG.ERROR_INFO[msg.code],MessageBoxType.OK);
        end
        return;
    end
    
    model.GuildModel:retCreateGuild(msg);
    --创建公会重算属性
    CardProManager:setNeedUpdateAllGenPro();
    EventManager:FireEvent(EventType.NetworkGuildRetCreateGuild , msg);
end
--[[

ret:
    uid;
    name;
    guild_flag;
    level;
    fp;
    donate;
    state;
    leaveTime;--不在线时长
    role_count;
    
]]
function NetworkMsg_Guild:onRetGuildMember(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retGuildMember(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildMember , msg);
end

function NetworkMsg_Guild:onRetApplyList(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retApplyList(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetApplyList , msg);
end

function NetworkMsg_Guild:onRetGuildAppoint(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retGuildAppoint(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildAppoint , msg);
end

function NetworkMsg_Guild:onRetGuildFired(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retGuildFired(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildFired , msg);
end

function NetworkMsg_Guild:onRetGuildDepose(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGuildDepose(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildDepose , msg);
end

function NetworkMsg_Guild:onRetGuildQuit(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGuildQuit(msg);
    --退出公会重算属性
    CardProManager:setNeedUpdateAllGenPro();
    EventManager:FireEvent(EventType.NetworkGuildRetGuildQuit , msg);
end

function NetworkMsg_Guild:onRetGuildDismiss(msg)
     if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retGuildDismiss(msg);
     --解散公会重算属性
     CardProManager:setNeedUpdateAllGenPro();
    EventManager:FireEvent(EventType.NetworkGuildRetGuildDismiss , msg);
end

function NetworkMsg_Guild:onRetGuildApply(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGuildApply(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildApply , msg);
end

function NetworkMsg_Guild:onRetGuildNotApply(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGuildNotApply(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildNotApply , msg);
end

function NetworkMsg_Guild:onRetGuildDonateInfo(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGuildDonateInfo(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildDonateInfo , msg);
end

function NetworkMsg_Guild:onRetGuildDonate(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGuildDonate(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildDonate , msg);
end
function NetworkMsg_Guild:onRetGetDonateReward(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGetDonateReward(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGetDonateReward , msg);
end
function NetworkMsg_Guild:onRetGuildRank(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGuildRank(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildRank , msg);
end

function NetworkMsg_Guild:onRetGuildMessInfo(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retGuildMessInfo(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildMessInfo , msg);
end

function NetworkMsg_Guild:onRetGuildMessSend(msg)
    if msg.code ~= 0 then
        return;
    end

    model.GuildModel:retGuildMessSend(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildMess , msg);
end

function NetworkMsg_Guild:onRetGuildNotice(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retGuildNotice(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetGuildNotice , msg);
end
function NetworkMsg_Guild:onRetGuildIconChange(msg)
    if msg.code ~= 0 then
        return;
    end
    model.GuildModel:retGuildIcon(msg);
    -- EventManager:FireEvent(EventType.NetworkGuildRetGuildIcon , msg);
end

function NetworkMsg_Guild:onRetGuildSetAuditState(msg)
    model.GuildModel:updateAuditState(msg.audit_state);
    EventManager:FireEvent(EventType.NetworkGuildRetSetAudit , msg);
end

function NetworkMsg_Guild:onRetGuildMemberTeam(msg)
    model.GuildModel:retGuildMemberTeam(msg);
    EventManager:FireEvent(EventType.NetworkGuildRetMemberTeam , msg.uid);
end

function NetworkMsg_Guild:onRetGuildTransfer(msg)
    model.GuildModel:updateGuildFlag(msg);
    EventManager:FireEvent(EventType.NetworkGuildUpdateMemberList);
end

function NetworkMsg_Guild:onRetGuildImpeach()
    model.GuildModel:updateGuildFlag(msg);
    EventManager:FireEvent(EventType.NetworkGuildUpdateMemberList);
end

function NetworkMsg_Guild:onRetGuildBossCheckPoint(msg)
    model.GuildModel:retGuildBossCheckPoint(msg);
    EventManager:FireEvent(EventType.NetworkGuildBossCheckPoint,msg);

end

function NetworkMsg_Guild:onRetGuildBossInfo(msg)
    model.GuildModel:retGuildBossInfo(msg);
end

function NetworkMsg_Guild:onRetGuildBossFightTimes(msg)
    model.GuildModel:retGuildBossFightTimes(msg);
end

function NetworkMsg_Guild:onRetGuildBossRwd(msg)
    model.GuildModel:retGuildBossRwd(msg)
end

function NetworkMsg_Guild:onRetGuildRaidRank(msg)
    model.GuildModel:updateGuildRaidRank(msg);
    EventManager:FireEvent(EventType.NetworkGuildRaidRank,1);
end

function NetworkMsg_Guild:onRetGuildRaidDamageRank(msg)
    model.GuildModel:updateGuildRaidDamageRank(msg);
    EventManager:FireEvent(EventType.NetworkGuildRaidDamageRank,2);
end

return NetworkMsg_Guild;
