--networkMsg_login.lua

--========================================================================
--网络消息_登陆类

local NetworkMsg_Login = class("NetworkMsg_Login");

function NetworkMsg_Login:ctor()
end

--获取服务器列表成功
function NetworkMsg_Login:onRetServerInfo( msg )
	model.AccountModel:retServerInfo(msg)
	EventManager:FireEvent(EventType.UILoginShowServerInfo, msg);
end

--获取进入服务器成功
function NetworkMsg_Login:onRetEnterServer( msg )
	model.AccountModel:retServerLoginUID(msg) 
	model.AccountModel:retAccountInfo(msg)
	if msg.unregState == 1 then
		EventManager:FireEvent(EventType.UILoginShowUnregInfo, msg);
	else
		EventManager:FireEvent(EventType.UILoginWithUID, msg);
	end
end

-- 返回注销平台账号
function NetworkMsg_Login:onRetUnregisterPlatform( msg )
	-- body
	model.AccountModel:retServerUnregister(msg);
	if msg.state == 1 then
		EventManager:FireEvent(EventType.LoginUnregister, msg);
	elseif msg.state == 0 then
		EventManager:FireEvent(EventType.LoginRevertUnreg, msg);
	end
end

-- 游客绑定第三方返回
function NetworkMsg_Login:onRetGuestBindPlatform( msg )
	model.AccountModel:retGuestBindPlatform(msg);
end

--请求公告
function NetworkMsg_Login:onRetAnnouncement(msg)
	EventManager:FireEvent(EventType.UILoginAnnouncement,msg);
end

function NetworkMsg_Login:onRetCreateNewUser(msg)
	model.AccountModel:retServerLoginUID(msg) 
	EventManager:FireEvent(EventType.UILoginCreateNewUser,msg);
end

function NetworkMsg_Login:onRetEnterGame(msg)
	if msg.mission then
		model.MissionModel:Init(msg.mission)
	end

	if msg.battlepass then
		model.BattlepassEventModel:Init(msg.battlepass)
	end
	
	EventManager:FireEvent(EventType.UIRetEnterGame,msg);
end

--请求改名
function NetworkMsg_Login:onRetChangeName(msg)
	EventManager:FireEvent(EventType.UILoginChangeName,msg);
end

function NetworkMsg_Login:onRetRecoverAccount(msg)
	EventManager:FireEvent(EventType.UILoginRecoverAccount,msg);
end

return NetworkMsg_Login;
