--networkMsg_Skill.lua

--========================================================================
--网络消息_研究所

local NetworkMsg_Skill = class("NetworkMsg_skill")

function NetworkMsg_Skill:ctor() end

-----------------------------
--返回技能升级数据
--@req
--@ret
-- table:
--		int32_t pid;
--		int32_t slot_id;
--		int32_t skill_id;
--		int32_t skill_resid;
--		int32_t skill_lvl;			// 当前技能的等级                                          
--		int32_t skill_exp;			// 当前总经验                                              
--		int32_t skill_state;		// 3:学习完成，并且升级了 2: 学习完成，但是没升级，1:学习中
--		uint32_t skill_learn_time;	// 还剩多长时间学习完成                                    
--		int32_t consume_item;		// 消耗道具的ID，只消耗1个
------------------------------
function NetworkMsg_Skill:onRetSkillLevelUpInfo(msg)
	--EventManager:FireEvent(EventType.UIUpdateCollegeIndicator, msg.skill_lvlup_info)

	--local info = model.CollegeModel:getSkillUpgradeInfo(msg.skill_lvlup_info)
	--model.CollegeModel:updatePartnerSkillInfo(msg.skill_lvlup_info);
	--EventManager:FireEvent(EventType.UIRetSkillLevelUpInfo, info, msg.is_up_level)
	model.SkillLevelUpModel:initSlotData(msg);
	EventManager:FireEvent(EventType.UIRetSkillLevelUpInfo);
end

-----------------------------
--返回可升级角色列表
--@req
-- table:
--		int32_t slot_id;
--@ret
-- table:
--		int32_t can_lvlup_pid;
------------------------------
-- function NetworkMsg_Skill:onRetPartnerCanLevelUp(msg)
-- 	--local info = model.CollegeModel:getUpgradableCardInfo(msg.can_lvlup_pid)
-- 	local info = model.CollegeModel:getUpgradablePartner()
-- 	EventManager:FireEvent(EventType.UIRetUpgradableCardInfo, info)
-- end

-----------------------------
--返回选择角色的可升级技能列表
--@req
-- table:
--		int32_t pid;
--@ret
-- table:
--		int32_t skill_id;
--		int32_t skill_resid;
--		int32_t skill_lvl;
--		int32_t skill_exp;
------------------------------
function NetworkMsg_Skill:onRetSkillListInfo(msg)
	local info = model.CollegeModel:getSkillInfoBySkillIdAndLevel(msg.skill_list_info)
	EventManager:FireEvent(EventType.UIRetSkillListInfo, info)
end

-----------------------------
--开始技能升级
--@req
-- table:
--		int32_t pid;
--		int32_t slot_id;    
--		int32_t skill_id;   
--		int32_t item_id;    
--		int32_t skill_resid;
--@ret
-- table:
--		int32_t code;
--		int32_t pid;
--		int32_t skill_id;
--		int32_t skill_state;
--		int32_t skill_learn_time;
------------------------------
function NetworkMsg_Skill:onRetStartSkillLevelUp(msg)
	if msg.code == 0 then
		model.SkillLevelUpModel:onRetStartLearn(msg);
		--更新技能升级状态 
		--model.StatusModel:setSkillUpgrades(msg.pid,true);
	end
end


-----------------------------
--取消技能升级
--@req
-- table:
--		int32_t slot_id;
--@ret
-- table:
--		int32_t code;
------------------------------
function NetworkMsg_Skill:onRetCancelSkillLevelUp(msg)
	if msg.code == 0 then
		model.SkillLevelUpModel:onRetSkillLevelCancel(msg);
		EventManager:FireEvent(EventType.UIRetCancelSkillLevelUp, msg)
		--更新技能升级状态 
		--model.StatusModel:setSkillUpgrades(msg.pid,false);
	end
end

function NetworkMsg_Skill:onRetSpeedSkillLevelUp(msg)
	if msg.code == 0 then
		model.SkillLevelUpModel:onRetSkillLevelSpeed(msg);
		EventManager:FireEvent(EventType.UIRetSpeedSkillLevelUp, msg)
	end
end
-----------------------------
--完成技能升级
--@req
-- table:
--		int32_t slot_id;
--@ret
-- table:
--		int32_t pid;
--		int32_t slot_id;
--		int32_t skill_id;
--		int32_t skill_resid;
--		int32_t skill_lvl;			// 当前技能的等级
--		int32_t skill_exp;			// 当前总经验
--		int32_t skill_state;		// 3:学习完成，并且升级了 2: 学习完成，但是没升级，1:学习中
--		uint32_t skill_learn_time;	// 还剩多长时间学习完成
--		int32_t consume_item;
------------------------------
function NetworkMsg_Skill:onRetFinishSkillLevelUp(msg)
--[[
	print("-------------onRetFinishSkillLevelUp------------")
	print(json.encode(msg))
	print("------------------------------------------------")
--]]
	if msg.code == 0 then
		--local info = model.CollegeModel:getSkillUpgradeInfo(msg.skill_lvlup_info)
		--model.CollegeModel:updatePartnerSkillInfo(msg.skill_lvlup_info);
		model.SkillLevelUpModel:onRetSkillLearnFinish(msg);
		EventManager:FireEvent(EventType.UIRetFinishSkillLevelUp,msg);
	
	
		--更新技能升级状态 
		--model.StatusModel:setSkillUpgrades(msg.skill_lvlup_info[1].pid,false)
	end
end

return NetworkMsg_Skill