local SDKLuaHelper = class('SDKLuaHelper')
local platform = cc.Application:getInstance():getTargetPlatform()
-- local Cjson = require "Cjson"

local STATIC_COUNT = 1;
local LUA_PAY_CLASS 		= nil
--用于异步更新渠道判断
if (cc.PLATFORM_OS_ANDROID == platform) then
    LUA_PAY_CLASS 	= 'com/ego/sdk/SDKHelper'
elseif (cc.PLATFORM_OS_IPHONE == platform) or (cc.PLATFORM_OS_IPAD == platform) or (cc.PLATFORM_OS_MAC == platform) then
    LUA_PAY_CLASS 	= "SDKHelper" --IOS官网
end

function SDKLuaHelper:ctor( ... )
    -- body
    print('SDKLuaHelper ======== STATIC_COUNT=== ',STATIC_COUNT);
    STATIC_COUNT = STATIC_COUNT + 1;
end

--------------------- test -------
function SDKLuaHelper:test( callbacklua )
    local args = {
        param1 = 1,
    }
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"test",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) or (cc.PLATFORM_OS_MAC == platform) then
        local sigs = "()V"
        args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"test",args,sigs)
    end
end

function SDKLuaHelper:getPackageName(  )
    local args = {};
    local ok = false
    local ret = nil
    if platform == cc.PLATFORM_OS_ANDROID then
        local sigs = "()Ljava/lang/String;"
       ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"getPackageName",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) or (cc.PLATFORM_OS_MAC == platform) then
        ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"getPackageName",args,nil)
    else
        ret = 'com.nani.ego.kr.aos';
    end
    return ret;
end

function SDKLuaHelper:getCountry(  )
    local args = {};
    local ok = false
    local ret = nil
	if platform == cc.PLATFORM_OS_ANDROID then
		local sigs = "()Ljava/lang/String;"
        local className = "org/cocos2dx/lua/AppActivity"
		ok,ret = self:luaBridgeCall(className,"getCountry",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) or (cc.PLATFORM_OS_MAC == platform) then
        ok,ret = true, 'kr'
    else
        ret = 'COMMON';
    end
    return ret;
end

function SDKLuaHelper:getXignCodeInfo(  )
    local args = {};
    local ok = false
    local ret = nil
    if platform == cc.PLATFORM_OS_ANDROID then
        local sigs = "()Ljava/lang/String;"
        local className = "org/cocos2dx/lua/AppActivity"
        ok,ret = self:luaBridgeCall(className,"getXignCodeInfo",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) or (cc.PLATFORM_OS_MAC == platform) then
        ok,ret = false, ''
    else
        ret = '';
    end
    return ret;
end

function SDKLuaHelper:getNotchHeight(  )
    local args = {};
    local ok = false
    local ret = nil
    if platform == cc.PLATFORM_OS_ANDROID then
		local sigs = "()I"
        local className = "org/cocos2dx/lua/AppActivity"
		ok,ret = self:luaBridgeCall(className,"getNotchHeight",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"getNotchHeight",args,nil)
    else
        ret = 0;
    end
    return ret;
end

function SDKLuaHelper:getNotchBottomHeight(  )
    local args = {};
    local ok = false
    local ret = nil
    if platform == cc.PLATFORM_OS_ANDROID then
		local sigs = "()I"
        local className = "org/cocos2dx/lua/AppActivity"
        -- ok,ret = self:luaBridgeCall(className,"getNotchHeight",args,sigs)
        ok,ret = true,0;
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"getNotchBottomHeight",args,nil)
    else
        ret = 0;
    end
    return ret;
end

function SDKLuaHelper:sendNotification( detail )
    local args = {
        detail = detail or 1000,
    }
    if platform == cc.PLATFORM_OS_ANDROID then
        -- local args = {Cjson.encode(args),callbacklua};
        -- local sigs = "(Ljava/lang/String;I)V"
        -- self:luaBridgeCall(LUA_PAY_CLASS,"test",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD )  then
        local sigs = "()V"
        -- args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"sendNotification",args,sigs)
    end
end

function SDKLuaHelper:restart()
	local args = {}
	local ok = false
	if platform == cc.PLATFORM_OS_ANDROID then
		local sigs = "()V"
        local className = "org/cocos2dx/lua/AppActivity"
		self:luaBridgeCall(className,"restartApp",args,sigs);
	elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
		cc.Director:getInstance():endToLua()
	else
		cc.Director:getInstance():endToLua()
	end
	return
end

function SDKLuaHelper:checkPermission(  )
    local args = {};
    local ok = false
    local ret = nil
    if platform == cc.PLATFORM_OS_ANDROID then
        local sigs = "(I)I"
        args = {-1}
		ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"checkPermission",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        -- ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"checkPermission",args,nil)
        ret = 0;
    else
        ret = 0;
    end
    -- 0或者2 权限通关，  1 权限未通过且不显示权限info ，3 权限未通过且需要显示权限info
    -- 此处无法判断是否为
    return ret;
end

function SDKLuaHelper:showPermission( callbacklua )
    local args = {};
    local ok = false
    local ret = nil
    if platform == cc.PLATFORM_OS_ANDROID then
        local sigs = "(I)V"
        args = {callbacklua}
		ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"showPermission",args,sigs)
    -- elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        -- ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"getNotchHeight",args,nil)
    else
        -- ret = 0;
        if callbacklua and callbacklua ~= -1 then
            local ret = {
                code = 0,
                show_info = false,
            }
            callbacklua(Cjson.encode(ret))
        end
    end

    -- // code 0 同意权限 1 拒绝权限
    -- // code = 1时 ，show_info true 本次选择拒绝，false 本次选择拒绝并不在提示

    return ret;
end

---------------------------------- login --------------------------
function SDKLuaHelper:checkSign( loginType,callbacklua )
    local args = {
        login_type = loginType or 1 -- 0 google ,1 facebook 2 guest
    };
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"checkSign",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD )  then
        local sigs = "()V"
        args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"checkSign",args,sigs)
    else
        local ret = {
            code = 0,
            platform_name = "test_name",
            email = "test_email@123.com",
            platform_id = "test123",
            platform_token = "test_token"..loginType,
            debug = true
        }
        callbacklua(Cjson.encode(ret))
    end
end
function SDKLuaHelper:signIn( loginType, callbacklua )
    local args = {
        login_type = loginType or 1 -- 0 google ,1 facebook 2 guest
    };
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"sign",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD )  then
        local sigs = "()V"
        args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"sign",args,sigs)
    else
        local ret = {
            code = 0,
            platform_name = "test_name",
            email = "test_email@123.com",
            platform_id = "test123",
            platform_token = "test_token"..loginType,
            debug = true
        }
        callbacklua(Cjson.encode(ret))
    end

end

function SDKLuaHelper:signOut( loginType, callbacklua )
    local args = {
        login_type = loginType or 1 -- 0 google ,1 facebook 2 guest
    };
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"signOut",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD )   then
        local sigs = "()V"
        args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"signOut",args,sigs)
    else
        local ret = {
            code = 0,
        }
        callbacklua(Cjson.encode(ret))
    end
end
---------------------------------- login --------------------------
---------------------------------- analytics  begin --------------------------

function SDKLuaHelper:logEvent( args ,callbacklua )
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"logEvent",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
        local sigs = "()V"
        -- self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
        callbacklua(Cjson.encode({code = 1}))
    end
end

function SDKLuaHelper:setUserProperty( name ,val )
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {name,val};
        local sigs = "(Ljava/lang/String;Ljava/lang/String;)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"setUserProperty",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
        local sigs = "()V"
        -- callbacklua(Cjson.encode({code = 2}))
    end
end


---------------------------------- analytics  end --------------------------
---------------------------------- payment  start --------------------------
-- 支付类型：0 googleBilling 1 OneStore
-- function SDKLuaHelper:getPaymentType(  )
--     local ok,ret = false,nil;
--     if platform == cc.PLATFORM_OS_ANDROID then
--         local args = {};
--         local sigs = "()I"
--         ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"getPaymentType",args,sigs)
--     elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
--         local sigs = "()I"
--         -- self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
--         ret = 1;
--     end
--     return ret;
-- end
function SDKLuaHelper:checkPaymentSDKInit(  )
    local ok,ret = false,nil;
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {};
        local sigs = "()Z"
        ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"checkSDKInit",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
        local sigs = "()Z"
        -- self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
    end
    return ret;
end

function SDKLuaHelper:onPaymentLogin( callbacklua )
    local ok,ret = false,nil;
    if platform == cc.PLATFORM_OS_ANDROID then
        print('===========onLoginPayment lua    =============')
        local args = {"",callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        ok,ret = self:luaBridgeCall(LUA_PAY_CLASS,"onLoginPayment",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
        local sigs = "()V"
        -- self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
        callbacklua(Cjson.encode({code = 1}))
    end
    return ret;
end

--[[
    查询购买记录，应在登陆时调用
    -- SDK 初始化后自动调用
]]
function SDKLuaHelper:queryPurchases( product_type,callbacklua )
    if not self:checkPaymentSDKInit() then
        print('============SDK 初始化失败')
        callbacklua(Cjson.encode({code = 1,error_msg="SDK 初始化失败"}))
        return ;
    end
    local args = {
        product_type = product_type -- inapp 消耗型,auto 包月型 
    }
    
    dump(args,"query purchase info ");
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"queryPurchases",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
        local sigs = "()V"
        -- self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
        callbacklua(Cjson.encode({code = 1}))
    end
end

function SDKLuaHelper:onPayment( args,callbacklua )
    print('onpayment   STATIC_COUNT = ',STATIC_COUNT);
    dump(args,'onPayment === ');
    -- 商品类型 inapp 管理型  （购买后需要执行消耗才能再次购买， 根据消耗调用时间，细分为 立即消耗型，限期型，永久型）
    --          auto 包月自动支付
    local args = {
        product_id  = args.product_id,      -- 商品ID
        product_type= args.product_type,    -- inapp 消耗型，auto 包月自动支付
        payload     = args.payload          -- 开发者自定义信息 用于服务器验证   

        -- productName = "",       -- 非必要 商品名，不填时显示开发者中心商品名
        -- gameUserId = "",        -- 非必要
        -- promotionApplicable = false -- 非必要 
    }
  
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        local sigs = "()V"
        args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
    else
        local ret = {
            purchases = {
                {
                    payload = args.payload,
                    signature = 'QRF8366Pk32C6qcUmUbJe7pLMsD5MhNQUM/IM542o1MCzyNgq8/AYm3cFzi0CEyPIBDfjhRkfeodztUCsxG2K6Sf5kBL8uU43cjm6gX4l5TgCKixdPvVbDf32L2PujwsfLmJlxxtFzu+xpy2oeh5S24igN4ZA2n4dCVbM8A++ys="',
                    purchase_id = 'SANDBOX3000000838088',
                    purchaseData = '{\"orderId\":\"ONESTORE7_000000000000000000000000836090\",\"packageName\":\"com.nani.ego.kr.one\",\"productId\":\"diamond_1\",\"purchaseTime\":1582875457825,\"purchaseId\":\"SANDBOX3000000838088\",\"developerPayload\":\"diamond_1_1582875455\"}',
                    product_id = args.product_id,
                }
            },
            code = 0
        }
        callbacklua(Cjson.encode(ret))
    end
end
-- google pay 无法直接通过product_id 购买，需要预先获取商品数据
-- function SDKLuaHelper:queryProducts( pruducts,callbacklua )
    
--     local args = {
--         productIds = pruducts -- {'product_id1','product_id2',...} 
--     }
    
--     dump(args,"query purchase info ");
--     if platform == cc.PLATFORM_OS_ANDROID then
--         local args = {Cjson.encode(args),callbacklua};
--         local sigs = "(Ljava/lang/String;I)V"
--         self:luaBridgeCall(LUA_PAY_CLASS,"queryPurchases",args,sigs)
--     elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
--         local sigs = "()V"
--         -- self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
--         callbacklua(Cjson.encode({code = 1}))
--     end

-- end
-- 消耗商品
-- SDK支付完成，发送服务器验证，然后返回客户端，客户端需要发起SDK消耗
function SDKLuaHelper:consumePurchase( args,callbacklua )
    -- body

    -- local args = {
    --     product_id = '',
    --     purchase_token = '',        -- google 参数
    --     payload = ''
    -- }
    
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"consumePurchase",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD) then
        -- ios 不做消耗处理
        local ret = {
            purchases = {
                {
                    payload = args.payload,
                    purchase_id = args.transaction_id,
                    product_id = args.product_id,
                }
            },
            code = 0
        }
        callbacklua(Cjson.encode(ret))
        -- local sigs = "()V"
        -- self:luaBridgeCall(LUA_PAY_CLASS,"onPayment",args,sigs)
        -- callbacklua(Cjson.encode({code = 1}))
    else
        local ret = {
            purchases = {
                {
                    payload = args.payload,
                    purchase_id = 'SANDBOX3000000833468',
                    product_id = args.product_id,
                }
            },
            code = 0
        }
        callbacklua(Cjson.encode(ret))
    end
end
---------------------------------- payment  start --------------------------
---------------------------------- admob  start --------------------------

function SDKLuaHelper:playAdMob( args,callbacklua )
    -- args = {
    --     admob_id = '',
    -- }
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"showAdmob",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        local sigs = "()V"
        args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"showAdmob",args,sigs)
        -- callbacklua(Cjson.encode({code = 1}))
    else
        local ret = {
            code = 0
        }
        callbacklua(Cjson.encode(ret))
    
    end
end
---------------------------------- admob  end --------------------------

---------------------------------- firebase cloud message  start --------------------------

function SDKLuaHelper:getFCMToken( callbacklua )
    local args = {
    }
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"getFCMToken",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        local sigs = "()V"
        args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"getFCMToken",args,sigs)
    else
        local ret = {
            code = 1
        }
        callbacklua(Cjson.encode(ret))
    end
end
function SDKLuaHelper:changeSubscriptionStatus( args,callbacklua )
    -- args = {
        -- name，
        -- state
    -- }
    if callbacklua == nil then
        callbacklua = -1;
    end
    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args),callbacklua};
        local sigs = "(Ljava/lang/String;I)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"changeSubscriptionStatus",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        local sigs = "()V"
        args['callbackLua'] = callbacklua;
        self:luaBridgeCall(LUA_PAY_CLASS,"changeSubscriptionStatus",args,sigs)
    else
        if callbacklua and callbacklua ~= -1 then
            local ret = {
                code = 0,
                state = args.state;
            }
            callbacklua(Cjson.encode(ret))
        end

    end
end
---------------------------------- firebase cloud message  end --------------------------


function SDKLuaHelper:trackEvent( args )
    -- body
    if args == nil or args.eventName == nil then
        print('error ========= track event doesnot have args [eventName]')
        return 
        -- args = {
        --     eventName = Enum:getTable('TrackEventToken').TRACK_RE_START, -- 

        --     price = 1,           -- 收入统计必传
        --     currency = 'KRW',

        --     orderId = '123'      -- 相同订单只统计一次
        -- }
    end

    dump(args,'trackEvent ==== ')

    if platform == cc.PLATFORM_OS_ANDROID then
        local args = {Cjson.encode(args)};
        local sigs = "(Ljava/lang/String;)V"
        self:luaBridgeCall(LUA_PAY_CLASS,"trackEvent",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        local sigs = "()V"
        self:luaBridgeCall(LUA_PAY_CLASS,"trackEvent",args,sigs)
        -- callbacklua(Cjson.encode({code = 1}))
    else 
        print('============ trackEvent Unsupplied !!! ')
    end

end


function SDKLuaHelper:luaBridgeCall(className,functionName,args,sigs)
    local platform = cc.Application:getInstance():getTargetPlatform()
    local ok = false
    local ret = nil
    if platform == cc.PLATFORM_OS_ANDROID then
        local luaj = require("cocos.cocos2d.luaj")
        ok,ret  = luaj.callStaticMethod(className,functionName,args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD or platform == cc.PLATFORM_OS_MAC) then
        local luaoc = require "cocos.cocos2d.luaoc" 
        ok,ret  = luaoc.callStaticMethod(className, functionName, args)
    end
    if not ok then
        print("luaoc error:"..tostring(ret)..",className="..tostring(className)..",methodName="..tostring(functionName))
    else
        print("The oc ret is:"..tostring(ret)..",className="..tostring(className)..",methodName="..tostring(functionName))
    end
    return ok, ret
end

function SDKLuaHelper:retApkRelease()
    local platform = cc.Application:getInstance():getTargetPlatform()
    local ok = false
    local ret = nil
    local args = {};
    if platform == cc.PLATFORM_OS_ANDROID then
        local sigs = "()I"
        ok, ret = self:luaBridgeCall(LUA_PAY_CLASS,"retApkRelease",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
        ret = 2;
    else 
        ret = 2;
    end
    return ret
end

function SDKLuaHelper:launchMediationTestSuite()
    local args = {};
    local ok = false
    local ret = nil
    if platform == cc.PLATFORM_OS_ANDROID then
		local sigs = "()V"
        local className = "org/cocos2dx/lua/AppActivity"
		ok,ret = self:luaBridgeCall(className,"launchMediationTestSuite",args,sigs)
    elseif (platform == cc.PLATFORM_OS_IPHONE or platform == cc.PLATFORM_OS_IPAD ) then
		ok,ret = true, 0
    else
        ret = 0;
    end
    return ret;
end

return SDKLuaHelper;
