local H063_6301_Skill = class("H063_6301_Skill")
local EffectFun = cc.exports.EffectFunction;

function H063_6301_Skill:ctor()
	self.info_pool = {};
end

function H063_6301_Skill:init( effectScript )
	self.effectScript = effectScript;
	self.info_pool = { Attacker = 0, Target = {}, AttackType = 0, AttackDataList = {}, AttackIndex = 1, Skill = {} }
end

function H063_6301_Skill:setArg(key, value)
	if self.info_pool[key] then
		self.info_pool[key] = value;
	end
end

function H063_6301_Skill:clean()
	EffectFun:EffectScriptEnd(self.info_pool.Attacker)
	self.info_pool = nil
end

function H063_6301_Skill:run()
	self.effectScript:RegisterEvent( 0,		handler(self, self.time_000) )
	self.effectScript:RegisterEvent( 5,		handler(self, self.time_005) )
	self.effectScript:RegisterEvent( 10,		handler(self, self.time_006) )
	self.effectScript:RegisterEvent( 15,	handler(self, self.time_007) )
	self.effectScript:RegisterEvent( 20,	handler(self, self.time_008) )
	self.effectScript:RegisterEvent( 30,	handler(self, self.time_030) )
	self.effectScript:RegisterEvent( 31,	handler(self, self.time_031) )
	self.effectScript:RegisterEvent( 62,	handler(self, self.time_032) )
--	self.effectScript:RegisterEvent( 33,	handler(self, self.time_033) )	
--	self.effectScript:RegisterEvent( 34,	handler(self, self.time_034) )
	self.effectScript:RegisterEvent( 65,	handler(self, self.time_035) )
	self.effectScript:RegisterEvent( 72,	handler(self, self.time_036) )
	self.effectScript:RegisterEvent( 80,	handler(self, self.time_037) )
	self.effectScript:RegisterEvent( 86,	handler(self, self.time_038) )
	self.effectScript:RegisterEvent( 90,	handler(self, self.time_039) )
	self.effectScript:RegisterEvent( 95,	handler(self, self.time_040) )
	self.effectScript:RegisterEvent( 100,	handler(self, self.time_041) )
end

function H063_6301_Skill:time_000()
	EffectFun:SetState(self.info_pool.Attacker, 'skill')
end

function H063_6301_Skill:time_005()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=-100, y=220}, 1, 100, "s_atk4_1", self.info_pool.Skill:GetResID())
	EffectFun:PlaySound(Conf.rocketAttack)
end

function H063_6301_Skill:time_006()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=100, y=220}, 1, 100, "s_atk4_1", self.info_pool.Skill:GetResID())
	EffectFun:PlaySound(Conf.rocketAttack)
end

function H063_6301_Skill:time_007()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=120, y=220}, 1, 100, "s_atk4_1", self.info_pool.Skill:GetResID())
	EffectFun:PlaySound(Conf.rocketAttack)
end

function H063_6301_Skill:time_008()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=-80, y=220}, 1, 100, "s_atk4_1", self.info_pool.Skill:GetResID())
	EffectFun:PlaySound(Conf.rocketAttack)
end

function H063_6301_Skill:time_030()
	EffectFun:SetState(self.info_pool.Target, 'hit')
	--EffectFun:PlaySound(Conf.artilleryHit_1)
end

function H063_6301_Skill:time_031()
    --EffectFun:AttachAvatarPosEffect(self.info_pool.Target, 0, {x=100, y=-100}, 100, 100, "s_atk4_2", self.info_pool.Skill:GetResID())
end

function H063_6301_Skill:time_032()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachMissileHitEffect(self.info_pool.Attacker, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

--[[
function H001_101_Skill:time_033()
	EffectFun:AddBuff(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill)
end

function H001_101_Skill:time_034()
	EffectFun:AddFollow(self.info_pool.Attacker, self.info_pool.Skill)
end
]]--

function H063_6301_Skill:time_035()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachMissileHitEffect(self.info_pool.Attacker, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

function H063_6301_Skill:time_036()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachMissileHitEffect(self.info_pool.Attacker, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

function H063_6301_Skill:time_037()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachMissileHitEffect(self.info_pool.Attacker, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

function H063_6301_Skill:time_038()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachMissileHitEffect(self.info_pool.Attacker, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

function H063_6301_Skill:time_039()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachMissileHitEffect(self.info_pool.Attacker, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

function H063_6301_Skill:time_040()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachMissileHitEffect(self.info_pool.Attacker, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

function H063_6301_Skill:time_041()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachMissileHitEffect(self.info_pool.Attacker, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end



return H063_6301_Skill;

