local H026_2600_Skill = class("H026_2600_Skill")
local EffectFun = cc.exports.EffectFunction;

function H026_2600_Skill:ctor()
	self.info_pool = {};
end

function H026_2600_Skill:init( effectScript )
	self.effectScript = effectScript;
	self.info_pool = { Attacker = 0, Target = {}, AttackType = 0, AttackDataList = {}, AttackIndex = 1, Skill = {} }
end

function H026_2600_Skill:setArg(key, value)
	if self.info_pool[key] then
		self.info_pool[key] = value;
	end
end

function H026_2600_Skill:clean()
	EffectFun:EffectScriptEnd(self.info_pool.Attacker)
	self.info_pool = nil
end

function H026_2600_Skill:preLoad()
	--glFun:PreLoadSound("skill_0301")
--	glFun:PreLoadAvatar("H003_pugong_1")
	--flFun:PreLoadSound("atalk_0301")
	--glFun:PreLoadSound("attack_0301")
--	glFun:PreLoadAvatar("H003_pugong_2")
end

function H026_2600_Skill:run()
	self.effectScript:RegisterEvent( 0,		handler(self, self.time_000) )
	self.effectScript:RegisterEvent( 2,		handler(self, self.time_005) )
	self.effectScript:RegisterEvent( 17,	handler(self, self.time_015) )
	self.effectScript:RegisterEvent( 18,	handler(self, self.time_016) )
	self.effectScript:RegisterEvent( 19,	handler(self, self.time_017) )
end

function H026_2600_Skill:time_000()
	EffectFun:SetState(self.info_pool.Attacker, 'attack')
	EffectFun:PlaySound(Conf.ordinaryBullet)
end

function H026_2600_Skill:time_005()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=120, y=-70}, 1, 100, "n_atk2_1", self.info_pool.Skill:GetResID())
end

function H026_2600_Skill:time_015()
	EffectFun:SetState(self.info_pool.Target, 'hit')
	--EffectFun:PlaySound(Conf.armorHit)
end

function H026_2600_Skill:time_016()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Target, 0, {x=0, y=0}, 1, 100, "n_atk2_2", self.info_pool.Skill:GetResID())
end

function H026_2600_Skill:time_017()
	EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill,1)
end

return H026_2600_Skill;
