local H041_4101_Skill = class("H041_4101_Skill")
local EffectFun = cc.exports.EffectFunction;

function H041_4101_Skill:ctor()
	self.info_pool = {};
end

function H041_4101_Skill:init( effectScript )
	self.effectScript = effectScript;
	self.info_pool = { Attacker = 0, Target = {}, AttackType = 0, AttackDataList = {}, AttackIndex = 1, Skill = {} }
end

function H041_4101_Skill:setArg(key, value)
	if self.info_pool[key] then
		self.info_pool[key] = value;
	end
end

function H041_4101_Skill:clean()
	EffectFun:EffectScriptEnd(self.info_pool.Attacker)
	self.info_pool = nil
end

function H041_4101_Skill:run()
	self.effectScript:RegisterEvent( 0,		handler(self, self.time_000) )
	self.effectScript:RegisterEvent( 8,		handler(self, self.time_001) )
	self.effectScript:RegisterEvent( 12,	handler(self, self.time_005) )
	self.effectScript:RegisterEvent( 16,		handler(self, self.time_006) )
	self.effectScript:RegisterEvent( 24,		handler(self, self.time_007) )
	self.effectScript:RegisterEvent( 32,		handler(self, self.time_008) )
	self.effectScript:RegisterEvent( 60,	handler(self, self.time_030) )
	self.effectScript:RegisterEvent( 62,	handler(self, self.time_031) )
	self.effectScript:RegisterEvent( 64,	handler(self, self.time_032) )
	self.effectScript:RegisterEvent( 72,	handler(self, self.time_033) )
	self.effectScript:RegisterEvent( 80,	handler(self, self.time_034) )
	self.effectScript:RegisterEvent( 88,	handler(self, self.time_035) )
	self.effectScript:RegisterEvent( 96,	handler(self, self.time_036) )
--	self.effectScript:RegisterEvent( 33,	handler(self, self.time_033) )	
--	self.effectScript:RegisterEvent( 34,	handler(self, self.time_034) )
end

function H041_4101_Skill:time_000()
	EffectFun:SetState(self.info_pool.Attacker, 'skill')
	EffectFun:PlaySound(Conf.artilleryAttack_1)
end

function H041_4101_Skill:time_001()
	EffectFun:PlaySound(Conf.artilleryAttack_1)
end

function H041_4101_Skill:time_005()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=200, y=-90}, 1, 100, "s_atk2_1", self.info_pool.Skill:GetResID())
end

function H041_4101_Skill:time_006()
	EffectFun:PlaySound(Conf.artilleryAttack_1)
end

function H041_4101_Skill:time_007()
	EffectFun:PlaySound(Conf.artilleryAttack_1)
end

function H041_4101_Skill:time_008()
	EffectFun:PlaySound(Conf.artilleryAttack_1)
end

function H041_4101_Skill:time_030()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Target, 0, {x=0, y=0}, 1, 100, "s_atk2_2", self.info_pool.Skill:GetResID())
end

function H041_4101_Skill:time_031()
   EffectFun:SetState(self.info_pool.Target, 'hit')
end

function H041_4101_Skill:time_032()
	EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill,1)
end
function H041_4101_Skill:time_033()
	EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill,1)
end
function H041_4101_Skill:time_034()
	EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill,1)
end
function H041_4101_Skill:time_035()
	EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill,1)
end
function H041_4101_Skill:time_036()
	EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill,1)
end

--[[
function H041_4101_Skill:time_033()
	EffectFun:AddBuff(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill)
end

function H041_4101_Skill:time_034()
	EffectFun:AddFollow(self.info_pool.Attacker, self.info_pool.Skill)
end
]]--


return H041_4101_Skill;
