local H051_5101_Skill = class("H051_5101_Skill")
local EffectFun = cc.exports.EffectFunction;

function H051_5101_Skill:ctor()
	self.info_pool = {};
end

function H051_5101_Skill:init( effectScript )
	self.effectScript = effectScript;
	self.info_pool = { Attacker = 0, Target = {}, AttackType = 0, AttackDataList = {}, AttackIndex = 1, Skill = {} }
end

function H051_5101_Skill:setArg(key, value)
	if self.info_pool[key] then
		self.info_pool[key] = value;
	end
end

function H051_5101_Skill:clean()
	EffectFun:EffectScriptEnd(self.info_pool.Attacker)
	self.info_pool = nil
end

function H051_5101_Skill:run()
	self.effectScript:RegisterEvent( 0,		handler(self, self.time_000) )
	self.effectScript:RegisterEvent( 2,		handler(self, self.time_005) )
	self.effectScript:RegisterEvent( 44,	handler(self, self.time_030) )
	self.effectScript:RegisterEvent( 46,	handler(self, self.time_031) )
	self.effectScript:RegisterEvent( 48,	handler(self, self.time_032) )
--	self.effectScript:RegisterEvent( 33,	handler(self, self.time_033) )	
--	self.effectScript:RegisterEvent( 34,	handler(self, self.time_034) )
end

function H051_5101_Skill:time_000()
	EffectFun:SetState(self.info_pool.Attacker, 'skill')
	EffectFun:PlaySound(Conf.antitankAttack)
end

function H051_5101_Skill:time_005()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=260, y=50}, 1, 100, "s_atk3_1", self.info_pool.Skill:GetResID())
end

function H051_5101_Skill:time_030()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Target, 0, {x=-0, y=0}, 1, 100, "s_atk3_2", self.info_pool.Skill:GetResID())
end

function H051_5101_Skill:time_031()
	EffectFun:SetState(self.info_pool.Target, 'hit')
end

function H051_5101_Skill:time_032()
	EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill,1)
end
--[[
function H051_5101_Skill:time_033()
	EffectFun:AddBuff(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill)
end

function H051_5101_Skill:time_034()
	EffectFun:AddFollow(self.info_pool.Attacker, self.info_pool.Skill)
end
]]--

return H051_5101_Skill;
