local M017_101_Attack = class("M017_101_Attack")
local EffectFun = cc.exports.EffectFunction;

function M017_101_Attack:ctor()
	self.info_pool = {};
end

function M017_101_Attack:init( effectScript )
	self.effectScript = effectScript;
	self.info_pool = { Attacker = 0, Target = {}, AttackType = 0, AttackDataList = {}, AttackIndex = 1, Skill = {} }
end

function M017_101_Attack:setArg(key, value)
	if self.info_pool[key] then
		self.info_pool[key] = value;
	end
end

function M017_101_Attack:clean()
	EffectFun:EffectScriptEnd(self.info_pool.Attacker)
	self.info_pool = nil
end

function M017_101_Attack:run()
	self.effectScript:RegisterEvent( 0,		handler(self, self.time_000) )
	self.effectScript:RegisterEvent( 5,		handler(self, self.time_005) )
--	self.effectScript:RegisterEvent( 15,	handler(self, self.time_015) )
	self.effectScript:RegisterEvent( 16,	handler(self, self.time_016) )
	self.effectScript:RegisterEvent( 17,	handler(self, self.time_017) )
end

function M017_101_Attack:time_000()
	EffectFun:SetState(self.info_pool.Attacker, 'attack')
end

function M017_101_Attack:time_005()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=80, y=-80}, 1, 100, "n_atk3_1", self.info_pool.Skill:GetResID())
end
--[[
function M017_101_Attack:time_015()
	EffectFun:SetState(self.info_pool.Target, 'hit')
end
]]--
function M017_101_Attack:time_016()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Target, 0, {x=140, y=-60}, 1, 100, "n_atk3_2", self.info_pool.Skill:GetResID())
end

function M017_101_Attack:time_017()
	EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill,1)
end


return M017_101_Attack;
