local M017_501_Skill = class("M017_501_Skill")
local EffectFun = cc.exports.EffectFunction;

function M017_501_Skill:ctor()
	self.info_pool = {};
end

function M017_501_Skill:init( effectScript )
	self.effectScript = effectScript;
	self.info_pool = { Attacker = 0, Target = {}, AttackType = 0, AttackDataList = {}, AttackIndex = 1, Skill = {} }
end

function M017_501_Skill:setArg(key, value)
	if self.info_pool[key] then
		self.info_pool[key] = value;
	end
end

function M017_501_Skill:clean()
	EffectFun:EffectScriptEnd(self.info_pool.Attacker)
	self.info_pool = nil
end

function M017_501_Skill:run()
	self.effectScript:RegisterEvent( 0,		handler(self, self.time_000) )
	self.effectScript:RegisterEvent( 5,		handler(self, self.time_005) )
	self.effectScript:RegisterEvent( 10,		handler(self, self.time_006) )
	self.effectScript:RegisterEvent( 15,		handler(self, self.time_007) )
	self.effectScript:RegisterEvent( 20,		handler(self, self.time_008) )
	self.effectScript:RegisterEvent( 30,	handler(self, self.time_030) )
	self.effectScript:RegisterEvent( 31,	handler(self, self.time_031) )
	self.effectScript:RegisterEvent( 62,	handler(self, self.time_032) )
--	self.effectScript:RegisterEvent( 33,	handler(self, self.time_033) )	
--	self.effectScript:RegisterEvent( 34,	handler(self, self.time_034) )
	self.effectScript:RegisterEvent( 65,	handler(self, self.time_035) )
	self.effectScript:RegisterEvent( 66,	handler(self, self.time_036) )
	self.effectScript:RegisterEvent( 67,	handler(self, self.time_037) )
end

function M017_501_Skill:time_000()
	EffectFun:SetState(self.info_pool.Attacker, 'skill')
end

function M017_501_Skill:time_005()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=-100, y=220}, 1, 100, "s_atk4_1", self.info_pool.Skill:GetResID())
	EffectFun:PlaySound(Conf.rocketAttack)
end

function M017_501_Skill:time_006()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=100, y=220}, 1, 100, "s_atk4_1", self.info_pool.Skill:GetResID())
	EffectFun:PlaySound(Conf.rocketAttack)
end

function M017_501_Skill:time_007()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=120, y=220}, 1, 100, "s_atk4_1", self.info_pool.Skill:GetResID())
	EffectFun:PlaySound(Conf.rocketAttack)
end

function M017_501_Skill:time_008()
	EffectFun:AttachAvatarPosEffect(self.info_pool.Attacker, 0, {x=-120, y=220}, 1, 100, "s_atk4_1", self.info_pool.Skill:GetResID())
	EffectFun:PlaySound(Conf.rocketAttack)
end

function M017_501_Skill:time_030()
	EffectFun:SetState(self.info_pool.Target, 'hit')
	--EffectFun:PlaySound(Conf.artilleryHit_1)
end

function M017_501_Skill:time_031()
    --EffectFun:AttachAvatarPosEffect(self.info_pool.Target, 0, {x=100, y=-100}, 100, 100, "s_atk4_2", self.info_pool.Skill:GetResID())
end

function M017_501_Skill:time_032()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachSceneEffect(self.info_pool.Attacker, 2, {x=0, y=1}, 1, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 1)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

--[[
function H001_101_Skill:time_033()
	EffectFun:AddBuff(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill)
end

function H001_101_Skill:time_034()
	EffectFun:AddFollow(self.info_pool.Attacker, self.info_pool.Skill)
end
]]--

function M017_501_Skill:time_035()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachSceneEffect(self.info_pool.Attacker, 2, {x=0, y=1}, 1, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 2)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

function M017_501_Skill:time_036()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachSceneEffect(self.info_pool.Attacker, 2, {x=0, y=1}, 1, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 3)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

function M017_501_Skill:time_037()
	if FightManager:MissileHit(self.info_pool.Attacker) then
		EffectFun:AttachSceneEffect(self.info_pool.Attacker, 2, {x=0, y=1}, 1, "s_atk4_2", self.info_pool.Skill:GetResID())
		EffectFun:AddDamage(self.info_pool.Attacker, self.info_pool.Target, self.info_pool.Skill, 4)
	else
		EffectFun:AttachMissileEffect(self.info_pool.Attacker, self.info_pool.Skill:GetResID())
	end
end

return M017_501_Skill;

