local ActivityLevelGiftItemTemplate = class("ActivityLevelGiftItemTemplate",function (  )
	return cc.Node:create();
end)

local fonts = Enum:getTable("SystemFont");

function ActivityLevelGiftItemTemplate:ctor()

	self:initItem();

end

function ActivityLevelGiftItemTemplate:initItem(  )
	
	local bg = cc.Sprite:create("res/image/activity/main/level_item_bg.png");
	bg:addTo(self)

	self.infoLabel = cc.Label:createWithTTF('战力达到12345' , fonts.FONT_SIYUAN , 20);
	self.infoLabel:addTo(self);
	self.infoLabel:setAnchorPoint(cc.p(0,0.5))
	self.infoLabel:setPosition(cc.p(0 , 29));
	self.infoLabel:setTextColor(cc.c4b(60 , 60 , 60, 255));

    local btnLabel = cc.Label:createWithTTF(LANG.UI_ACTIVITY_26, fonts.FONT_SIYUAN, 20)
    btnLabel:enableOutline(cc.c4b(40 , 130 , 231 , 255),2);
    self.btnGet = ccui.Button:create('image/common/common_button_30_1.png','','image/common/common_button_30_1_2.png');
    self.btnGet:setPosition(245,-30);
    self.btnGet:setTitleLabel(btnLabel);
    self.btnGet:addClickEventListener(handler(self, self.onItemClick));
	self.btnGet:addTo(self);
	
	self.get = require("app.template.GetTemplate"):create(self);
	self.get:setPosition(245,0);

	local progressBg =  cc.Sprite:create("res/image/activity/main/bar_1_1.png");
	progressBg:addTo(self);
	progressBg:setPosition(cc.p(90,-30));

	self.progressBar = cc.ProgressTimer:create(cc.Sprite:create("res/image/activity/main/bar_1_2.png"));
	self.progressBar:setType(cc.PROGRESS_TIMER_TYPE_BAR)
		:setMidpoint(cc.p(0, 0))
		:setBarChangeRate(cc.p(1, 0))
		:setPosition(progressBg:getContentSize().width/2,progressBg:getContentSize().height/2)
		:addTo(progressBg)
		:setPercentage(100);

	self.progressLabel = cc.Label:createWithTTF('0/0', fonts.FONT_SIYUAN, 20);
	self.progressLabel:addTo(self);
	self.progressLabel:setPosition(85,-42);
	self.progressLabel:enableOutline(cc.c4b(60,60,60,255),2);

	self.rewardScrollView = ccui.ScrollView:create();
	self.rewardScrollView:setTouchEnabled(true)
		:setBounceEnabled(true)
		:setDirection(ccui.ScrollViewDir.horizontal)
		:setContentSize(cc.size(266, 95))
		:setPosition(-156,  -2)
		:setScrollBarEnabled(false)
		:addTo(self)
		:setAnchorPoint(cc.p(0.5,0.5))

end

function ActivityLevelGiftItemTemplate:setData( data )

	-- dump(data,'ActivityLevelGiftItemTemplate.setData = ')
	self.activityType = data.activityType;
	self.id = data.id;
	self.operate_id = data.operate_id;
	self.value = data.value;
	self.type = data.type;
	self.reward = data.reward_item
	self.description = data.description;

	self.infoLabel:setString(tostring(self.description))
	self:setProgress()
	self:setState();

	self.rewardScrollView:removeAllChildren();
	local rewards = self.reward or {};
	local num = #rewards;
	local count2 = 0;
	local scale = 0.7;
	local totalWidth = 0;
	for itemID , item in pairs(rewards) do
		local rewardIcon = template.IconTemplate:create(self.rewardScrollView)
		rewardIcon:Init(tonumber(item[1]) , tonumber(item[2]));
		local width = rewardIcon:getContentSize().width * scale;
		rewardIcon:setPosition(cc.p(count2*width + width /2,rewardIcon:getContentSize().height/2 - 15));
		rewardIcon:setScale(scale);
		count2 = count2 +1
		totalWidth = count2*width;
	end

	totalWidth = totalWidth < 266 and 266 or totalWidth;
	print('width==============>',totalWidth);
	self.rewardScrollView:setInnerContainerSize(cc.size(totalWidth , 95));

end

function ActivityLevelGiftItemTemplate:setProgress(  )
	local itemValue = self.value;
	local myValue = model.ActivityModel:getActivityProgressValueByType(self.activityType);
	local precent = tonumber(myValue/itemValue) *100 

	self.progressLabel:setString(tostring(myValue)..'/'..tostring(itemValue))
	self.progressBar:setPercentage(precent);

	-- if itemValue < myValue then
	-- 	self.btnGet:setVisible(false);
	-- end

end

function ActivityLevelGiftItemTemplate:setState( )
	local state = model.ActivityModel:getActivityStateByTypeAndId(self.activityType,self.id,self.value);

	self.get:setState(state);

	if state == 1 then
		-- 可领取
		self.btnGet:setVisible(true);
	--elseif state == 2 then 
	--	-- 已领取
	--	self.btnGet:setVisible(true)
	--	self.btnGet:setTouchEnabled(false);
	--	self.btnGet:setBright(false)
	--	self.btnGet:getTitleLabel():setString(LANG.UI_ACTIVITY_19)
	else
		self.btnGet:setVisible(false)
	end


end

function ActivityLevelGiftItemTemplate:setStateAction(callback)
	self.btnGet:setVisible(false);
	self.get:showAction(callback);
end

function ActivityLevelGiftItemTemplate:onItemClick( sender,event )
	model.ActivityModel:reqActivityItemReward(self.activityType,self.id);
end



return ActivityLevelGiftItemTemplate;
