local ArenaMultEnemyTemplate = class('ArenaMultEnemyTemplate')
local fonts = Enum:getTable("SystemFont")
function ArenaMultEnemyTemplate:ctor(father)
	self.root = cc.Node:create();
    self.root:addTo(father);
    self.root:setCascadeOpacityEnabled(true);

    self.node = cc.Node:create();
    self.node:addTo(self.root);
    self.node:setCascadeOpacityEnabled(true);

	local bg = cc.Sprite:create('image/arena/rankList/arena_rank_list_1.png');
    bg:addTo(self.node);

    self.headBtn = ccui.Button:create('image/commonImg/icon_enemy.png','image/commonImg/icon_enemy.png');
    self.headBtn:addClickEventListener(handler(self , self.headBtnClick));
    self.headBtn:setPosition(-212 , -2);
    self.headBtn:addTo(self.node);

    self.headIcon = cc.Sprite:create();
    self.headIcon:addTo(self.node);
    self.headIcon:setPosition(-212,-2);
    self.headIcon:setScale(0.9);

    self.curName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22);
    self.curName:addTo(self.node);
    self.curName:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.curName:setAnchorPoint(0 , 0.5);
    self.curName:setPosition(-139 , 39);

    self.level = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22);
    self.level:addTo(self.node);
    self.level:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.level:setAnchorPoint(0 , 0.5);
    self.level:setPosition(-139 , 8);

    local label = cc.Label:createWithTTF(LANG.UI_ARENA_9 ,  fonts.FONT_SIYUAN , 20)
    label:enableOutline(cc.c4b(110 , 0 , 0 , 255),2);
    self.challengeBtn = ccui.Button:create('image/commonImg/btn_10.png' , 'image/commonImg/btn_10.png');
    self.challengeBtn:addTo(self.node);
    self.challengeBtn:addClickEventListener(handler(self , self.challengeBtnClick));
    self.challengeBtn:setPosition(79 , 23);
    self.challengeBtn:setTitleLabel(label);

    local fpBg = cc.Scale9Sprite:create('image/arena/rankList/arena_rank_list_8.png');
	fpBg:addTo(self.node);
	fpBg:setPosition(5-50 , -36);
    fpBg:setCapInsets(cc.rect(45,0,110,39));
    fpBg:setContentSize(cc.size(200 , 39));
    
    local fpImg = cc.Sprite:create('image/arena/rankList/arena_rank_list_7.png');
    fpImg:addTo(self.node);
    fpImg:setPosition(-122,-36);

    self.fp = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    self.fp:addTo(self.node);
    self.fp:setPosition(-39 , -36);

    self.rankIconNode = cc.Node:create();
    self.rankIconNode:addTo(self.node);
    -- self.rankIconNode:setScale(0.25);
    self.rankIconNode:setPosition(214 , 0);
    self.rankIconNode:setCascadeOpacityEnabled(true);

    self.rankBg = cc.Sprite:create();
    self.rankBg:addTo(self.rankIconNode);
    self.rankBg:setPosition(0, 15)

    self.addScroe = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22)
    self.addScroe:addTo(self.rankIconNode);
    self.addScroe:setPosition(0, 15)
    self.addScroe:enableOutline(cc.c4b(63 , 106 , 115 , 255),2);

    local rwdNode = cc.Node:create()
    rwdNode:addTo(self.rankIconNode)
    rwdNode:setPosition(0, -40)
    local rwdBg = cc.Scale9Sprite:create('image/commonImg/bg_3_200_42.png')
    rwdBg:addTo(rwdNode)
    rwdBg:setContentSize(cc.size(120,30))
    local rwdIcon = cc.Sprite:create('image/icon/I10031.png')
    rwdIcon:addTo(rwdNode)
    rwdIcon:setPosition(-50,0)
    rwdIcon:setScale(0.3)
    self.rwdNumLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 16)
    self.rwdNumLabel:addTo(rwdNode);
    self.rwdNumLabel:setPosition(54, 0)
    self.rwdNumLabel:setAnchorPoint(1,0.5)
    self.rwdNumLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    
    local spine_res = 'shengya_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankListSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.rankListSpine:addTo(self.root)
        self.rankListSpine:setPosition(cc.p(0 , 0))
        self.rankListSpine:registerSpineEventHandler(function (event)
            if event.eventData.name == 'appear' then
                self.node:setVisible(true);
                self.node:setOpacity(0);
                self.node:runAction(cc.FadeIn:create(16/30));
            end
        end, sp.EventType.ANIMATION_EVENT)

        self.rankListSpine:registerSpineEventHandler(function (event)
            self.rankListSpine:setVisible(false);
        end, sp.EventType.ANIMATION_COMPLETE)
	else
		print('error : 缺少spine 资源')
	end  
	
end
function ArenaMultEnemyTemplate:initData(data)

	self.data = data;

    self.headBtn:setTag(data.uid);
    local headIconFile = GlobalFunctions:getHeadIconFile(data.head_icon)
    self.headIcon:setTexture(headIconFile);
    self.level:setString('Lv.'..tostring(data.level));

    local fp = 0
    for k,v in pairs(data.powerList) do
        fp = fp+v;
    end
    self.curName:setString(tostring(data.name));
	self.fp:setString(tostring(fp));

    self.addScroe:setString(tostring(data.rank));
    if data.rank>0 and data.rank<4 then
        self.addScroe:setString( '' )
        self.rankBg:setTexture('image/arena/arenaMult/am_rk'..data.rank..'.png')
    else
        self.rankBg:setTexture('image/arena/arenaMult/am_rk4.png')
    end

    local num = model.ArenaModel:getNumPerHourByRank( data.rank )
    self.rwdNumLabel:setString(string.format(LANG.UI_ARENA_MU_10, tostring(num)))
end

function ArenaMultEnemyTemplate:headBtnClick()
    AudioManager:playEffect(Conf.buttonClick);
    -- UIManager:push('ArenaRankListInfoPanel' , self.data.uid);
end

function ArenaMultEnemyTemplate:challengeBtnClick()
    AudioManager:playEffect(Conf.confirmButton);
    UIManager:push('ArenaMultFightPanel', self.data.uid);
end

function ArenaMultEnemyTemplate:getchallengeBtn( ... )
    return self.challengeBtn;
end

function ArenaMultEnemyTemplate:setPosition(x , y)
	self.root:setPosition(x , y);
end
function ArenaMultEnemyTemplate:btnClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(tag , self.data);
	end
end
function ArenaMultEnemyTemplate:addClickEventListener(callback)
	self.callback = callback;
end

function ArenaMultEnemyTemplate:setChallengeBtnVisible(visible)
    self.challengeBtn:setVisible(visible);
end

function ArenaMultEnemyTemplate:runRefreshAction(delayFrame)
    delayFrame = delayFrame or 1;
    self.root:stopAllActions()
    self.node:stopAllActions()
    self.node:setVisible(false);
	self.root:runAction(cc.Sequence:create(
		cc.DelayTime:create(delayFrame/30),
		cc.CallFunc:create( function (  )
            if self.rankListSpine  then
                self.rankListSpine:setVisible(true);
	            self.rankListSpine:clearTracks();
				self.rankListSpine:setAnimation(0, 'jingjichang_spine', false)
			end
		end)
	));
end

return ArenaMultEnemyTemplate;