local ArenaMultHistoryItem = class('ArenaMultHistoryItem', function() 
    return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")
local RANK_ENUM = Enum:getTable('RANK_ENUM');

function ArenaMultHistoryItem:ctor(father)
    self:addTo(father);

    self.node = cc.Node:create();
    self.node:addTo(self);
    self.node:setPosition(290, 46)
    self.node:setCascadeOpacityEnabled(true);

    local bg = cc.Scale9Sprite:create('image/arena/arenaMult/am_h_bg.png')
    bg:addTo(self.node)
    -- bg:setContentSize(cc.size(558 , 68));
    -- bg:setCapInsets(CCRectMake(15,0,10,68));

    local headBg = cc.Sprite:create('image/commonImg/icon_enemy.png');
    headBg:setPosition(-150 , 0);
    headBg:addTo(self.node);
    headBg:setScale(0.6);

    self.headIcon = cc.Sprite:create();
    self.headIcon:addTo(self.node);
    self.headIcon:setPosition(-150,0);
    self.headIcon:setScale(0.5);

    self.timeLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18)
    self.timeLabel:addTo(self.node);
    self.timeLabel:setTextColor(cc.c3b(90,157,255));
    -- self.timeLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.timeLabel:setPosition(-100 , -15);
    self.timeLabel:setAnchorPoint(0 , 0.5);

    self.infoLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18)
    self.infoLabel:addTo(self.node);
    -- self.infoLabel:setTextColor(cc.c3b(0,100,255));
    -- self.infoLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.infoLabel:setPosition(0 , -15);
    self.infoLabel:setAnchorPoint(0 , 0.5);

    self.nameLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18)
    self.nameLabel:addTo(self.node);
    self.nameLabel:setTextColor(cc.c3b(255,92,92));
    -- self.nameLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.nameLabel:setPosition(-100 , 15);
    self.nameLabel:setAnchorPoint(0 , 0.5);

	self.winIcon = cc.Sprite:create('image/arena/arenaMult/am_win_icon.png');
    self.winIcon:addTo(self.node);
    self.winIcon:setPosition(-230,15);

    self.scoreNumLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 18)
    self.scoreNumLabel:addTo(self.node);
    -- self.scoreNumLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.scoreNumLabel:setPosition(-230 , -15);
    self.scoreNumLabel:setTextColor(cc.c3b(42,255,0));

    self.rankBg = cc.Sprite:create('image/arena/arenaMult/am_rk4.png');
    self.rankBg:addTo(self.node);
    self.rankBg:setPosition(210,0);

    self.rankNumLabel = cc.Label:createWithTTF('99' ,  fonts.FONT_SIYUAN , 22)
    self.rankNumLabel:addTo(self.node);
    self.rankNumLabel:enableOutline(cc.c4b(63 , 106 , 115 , 255),2);
    self.rankNumLabel:setPosition(210 , 0);
	
end
function ArenaMultHistoryItem:initData(data)
	-- self.data = data;
	 -- {
  --           "create_time": "2021-04-12 16:04", //时间
  --           "to_uname": "发发发", //被谁挑战
  --           "score": "0:2", //比分
  --           "win": 0, //1赢 0败
  --           "rank": 78, //排名
  --           "rank_change": 0 //排名变化与否  -1不变 1升了 0降了
  --       },
    self.timeLabel:setString( GlobalFunctions:changeStamp2Datetime2(data.create_time) )

    self.nameLabel:setString( data.to_uname )
    self.scoreNumLabel:setString( data.score )
    self.rankNumLabel:setString( data.rank )

    local headIconFile = GlobalFunctions:getHeadIconFile(data.head_icon)
    self.headIcon:setTexture(headIconFile);

    if data.win == 1 then
    	self.winIcon:setTexture('image/arena/arenaMult/am_win_icon.png')
    else
    	self.winIcon:setTexture('image/arena/arenaMult/am_lose_icon.png')
    end

    if data.rank>0 and data.rank<4 then
        self.rankNumLabel:setString( '' )
        self.rankBg:setTexture('image/arena/arenaMult/am_rk'..data.rank..'.png')
    elseif data.rank == 0 then
        self.rankNumLabel:setString( '9999+' )
        self.rankBg:setTexture('image/arena/arenaMult/am_rk4.png')
    else
        self.rankBg:setTexture('image/arena/arenaMult/am_rk4.png')
    end

    if data.is_self == 1 then
        self.infoLabel:setString(LANG.UI_ARENA_MU_19)
    else
        self.infoLabel:setString(LANG.UI_ARENA_MU_20)
    end
    
end

return ArenaMultHistoryItem;