local ArenaRankListTemplate = class('ArenaRankListTemplate')
local fonts = Enum:getTable("SystemFont")
function ArenaRankListTemplate:ctor(father)
	self.root = cc.Node:create();
    self.root:addTo(father);
    self.root:setCascadeOpacityEnabled(true);

    self.node = cc.Node:create();
    self.node:addTo(self.root);
    self.node:setCascadeOpacityEnabled(true);

	local bg = cc.Sprite:create('image/arena/rankList/arena_rank_list_1.png');
    bg:addTo(self.node);

    self.headBtn = ccui.Button:create('image/commonImg/icon_enemy.png','image/commonImg/icon_enemy.png');
    self.headBtn:addClickEventListener(handler(self , self.headBtnClick));
    self.headBtn:setPosition(-212 , -2);
    self.headBtn:addTo(self.node);

    self.headIcon = cc.Sprite:create();
    self.headIcon:addTo(self.node);
    self.headIcon:setPosition(-212,-2);
    self.headIcon:setScale(0.9);

    self.curName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22);
    self.curName:addTo(self.node);
    self.curName:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.curName:setAnchorPoint(0 , 0.5);
    self.curName:setPosition(-139 , 39);

    self.level = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 22);
    self.level:addTo(self.node);
    self.level:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.level:setAnchorPoint(0 , 0.5);
    self.level:setPosition(-139 , 8);

    local label = cc.Label:createWithTTF(LANG.UI_ARENA_9 ,  fonts.FONT_SIYUAN , 20)
    label:enableOutline(cc.c4b(110 , 0 , 0 , 255),2);
    self.challengeBtn = ccui.Button:create('image/commonImg/btn_10.png' , 'image/commonImg/btn_10.png');
    self.challengeBtn:addTo(self.node);
    self.challengeBtn:addClickEventListener(handler(self , self.challengeBtnClick));
    self.challengeBtn:setPosition(79 , 23);
    self.challengeBtn:setTitleLabel(label);

    local fpBg = cc.Scale9Sprite:create('image/arena/rankList/arena_rank_list_8.png');
	fpBg:addTo(self.node);
	fpBg:setPosition(5 , -36);
    fpBg:setCapInsets(cc.rect(45,0,110,39));
    fpBg:setContentSize(cc.size(300 , 39));
    
    local fpImg = cc.Sprite:create('image/arena/rankList/arena_rank_list_7.png');
    fpImg:addTo(self.node);
    fpImg:setPosition(-122,-36);

    self.fp = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    self.fp:addTo(self.node);
    self.fp:setPosition(-39 , -36);

    local addScroeImg = cc.Sprite:create('image/arena/rankList/arena_rank_list_3.png');
    addScroeImg:addTo(self.node);
    addScroeImg:setPosition(51,-36);

    self.addScroe = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    self.addScroe:addTo(self.node);
    self.addScroe:setTextColor(cc.c3b(255 , 255 , 0));
    self.addScroe:setPosition(108 , -36);

    self.rankIconNode = cc.Node:create();
    self.rankIconNode:addTo(self.node);
    self.rankIconNode:setScale(0.25);
    self.rankIconNode:setPosition(214 , 0);
    self.rankIconNode:setCascadeOpacityEnabled(true);

    self.rankBg = cc.Sprite:create();
    self.rankBg:addTo(self.rankIconNode);

    self.rankStar = cc.Sprite:create();
    self.rankStar:addTo(self.rankIconNode);

    --self.score = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    --self.score:addTo(self.node);
    --self.score:setPosition(117 , -45);
    
    local spine_res = 'shengya_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.rankListSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.rankListSpine:addTo(self.root)
        self.rankListSpine:setPosition(cc.p(0 , 0))
        self.rankListSpine:registerSpineEventHandler(function (event)
            if event.eventData.name == 'appear' then
                self.node:setVisible(true);
                self.node:setOpacity(0);
                self.node:runAction(cc.FadeIn:create(16/30));
            end
        end, sp.EventType.ANIMATION_EVENT)

        self.rankListSpine:registerSpineEventHandler(function (event)
            self.rankListSpine:setVisible(false);
        end, sp.EventType.ANIMATION_COMPLETE)
	else
		print('error : 缺少spine 资源')
	end  
	
end
function ArenaRankListTemplate:initData(data)

	self.data = data;

    self.headBtn:setTag(data.uid);
    local headIconFile = GlobalFunctions:getHeadIconFile(data.head_icon)
    self.headIcon:setTexture(headIconFile);

	self.curName:setString(tostring(data.name));
    self.level:setString('Lv.'..tostring(data.level));
    
    local fp = data.top_power
    if data.isRobot == 0 then
        fp = 0
        for i=1, TEAM_MAX_MEMBER do
            if data.pro[i].fp then
                fp = fp + data.pro[i].fp
            end
        end
    end
	self.fp:setString(tostring(fp));
    self.addScroe:setString('+'..tostring(data.fight_score));
    
    self.rankBg:setTexture('image/arena/arena_rank_bg_'..data.rankData.rank..'.png');
    self.rankStar:setTexture('image/arena/arena_rank_star_'..data.rankData.order..'.png');
end

function ArenaRankListTemplate:headBtnClick()
    AudioManager:playEffect(Conf.buttonClick);
    UIManager:push('ArenaRankListInfoPanel' , self.data.uid);
end

function ArenaRankListTemplate:challengeBtnClick()
    AudioManager:playEffect(Conf.confirmButton);
    TimeManager:registUpdateEvent('ArenaPanel',nil,true);
    model.ArenaModel:reqArenaChallenge(self.data.uid);
end

function ArenaRankListTemplate:getchallengeBtn( ... )
    return self.challengeBtn;
end

function ArenaRankListTemplate:setPosition(x , y)
	self.root:setPosition(x , y);
end
function ArenaRankListTemplate:btnClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(tag , self.data);
	end
end
function ArenaRankListTemplate:addClickEventListener(callback)
	self.callback = callback;
end

function ArenaRankListTemplate:setChallengeBtnVisible(visible)
    self.challengeBtn:setVisible(visible);
end

function ArenaRankListTemplate:runRefreshAction(delayFrame)
    delayFrame = delayFrame or 1;
    self.root:stopAllActions()
    self.node:stopAllActions()
    self.node:setVisible(false);
	self.root:runAction(cc.Sequence:create(
		cc.DelayTime:create(delayFrame/30),
		cc.CallFunc:create( function (  )
            if self.rankListSpine  then
                self.rankListSpine:setVisible(true);
	            self.rankListSpine:clearTracks();
				self.rankListSpine:setAnimation(0, 'jingjichang_spine', false)
			end
		end)
	));
end

return ArenaRankListTemplate;