local ArenaRewardTemplate = class('ArenaRewardTemplate' , function()
	return  cc.Node:create();
end)
local fonts = Enum:getTable("SystemFont")
local rewardName = {
    [1] = 'reward_rank',
	[2] = 'reward_daily',
	[3] = 'reward_season',
}
function ArenaRewardTemplate:ctor(father)
	self:addTo(father);

	self.bg = cc.Sprite:create('image/arena/arenaReward/arena_reward_1.png');
	self.bg:addTo(self);

	self.rankIconNode = cc.Node:create();
    self.rankIconNode:addTo(self);
    self.rankIconNode:setScale(0.25);
    self.rankIconNode:setPosition(0 , 58);

    self.rankBg = cc.Sprite:create();
    self.rankBg:addTo(self.rankIconNode);

    self.rankStar = cc.Sprite:create();
    self.rankStar:addTo(self.rankIconNode);

	local rankLevelBg = cc.Sprite:create('image/arena/arenaReward/arena_reward_5.png');
	rankLevelBg:addTo(self);
	rankLevelBg:setPosition(0,-21);

	self.rankLevel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 25);
	self.rankLevel:addTo(self);
	self.rankLevel:setPosition(0 , -21);

	local bg = cc.Sprite:create('image/arena/arenaReward/arena_reward_8.png');
    bg:addTo(self);
    bg:setContentSize(cc.size(137,71));
    bg:setPosition(0,-82);

	self.rewardList = {};
	for i = 1 , 2 do
		local icon = template.ItemTemplate:create(2);
		icon:addTo(self);
		icon:setPosition(i == 1 and -32 or 32 , -84);
		icon:setScale(0.6);
		self.rewardList[i] = icon;
	end

	self.rankSpine = cc.Node:create();
	self.rankSpine:addTo(self);

	self.redDotNode = cc.Node:create();
	self.redDotNode:addTo(self);

	self.getNode = cc.Node:create();
	self.getNode:addTo(self);
	
	local getBg = cc.Sprite:create('image/arena/arenaReward/arena_reward_2.png');
	getBg:addTo(self.getNode);
	getBg:setPosition(0,-49);

	local getImg = cc.Sprite:create('image/commonImg/geted.png');
	getImg:addTo(self.getNode);
	getImg:setPosition(0,-85);

	self.notOpen = cc.Sprite:create('image/arena/arenaReward/arena_reward_4.png');
	self.notOpen:addTo(self);

	self.no = 0;
	EventManager:RegisterEvent(EventType.NetworkRetGetArenaRankLvReward,handler(self,self.setGetState));
end
function ArenaRewardTemplate:initData(data , rewardType)
	self.no = data.no
	local curRankData = model.ArenaModel:getCurArenaRankData();
	
	self.notOpen:setVisible(data.point > curRankData.point);
	
	local rankData = ResTable:getRowData('arena_rank' , data.point);
	self.rankLevel:setString(tostring(rankData.name));
	self.rankBg:setTexture('image/arena/arena_rank_bg_'..rankData.rank..'.png');
    self.rankStar:setTexture('image/arena/arena_rank_star_'..rankData.order..'.png');

	local reward = data[rewardName[rewardType]];
	local rewardNum = #reward;
	if rewardNum == 1 then
		self.rewardList[1]:setVisible(true);
		self.rewardList[2]:setVisible(false);

		self.rewardList[1]:Init(reward[1][1] , reward[1][2]);
		self.rewardList[1]:setPosition(0 , -84);
	else
		for i = 1 , 2 do
			if reward[i] then
				self.rewardList[i]:setVisible(true);
				self.rewardList[i]:Init(reward[i][1] , reward[i][2]);
				self.rewardList[i]:setPosition(i == 1 and -32 or 32 , -84);
			else
				self.rewardList[i]:setVisible(false);
			end
		end
	end

	self.rankSpine:removeAllChildren();
	self.redDotNode:removeAllChildren();

	if rewardType == 1 then
		local state = model.ArenaModel:getRankRewardState(data.no) or 0;
		self.getNode:setVisible(state == 2);

		local state = model.ArenaModel:rewardRedDotActiveState(data.no);
		if state then
			local spine_res = 'jingjiui_spine'
			if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
				local rankSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
				rankSpine:setAnimation(0,'idle8',true);
				rankSpine:addTo(self.rankSpine);
			else
				print('error : 缺少spine 资源')
			end
		end
		tools.RedDotTools:setRedDotToNode(self.redDotNode,state,nil,cc.p(70 , 110));
	else
		self.getNode:setVisible(false);
		tools.RedDotTools:setRedDotToNode(self.redDotNode,false,nil,cc.p(70 , 110));
	end
end

function ArenaRewardTemplate:setGetState()--state
	local state = model.ArenaModel:getRankRewardState(self.no) or 0;
	if state == 2 then
		self.redDotNode:removeAllChildren();
		self.rankSpine:removeAllChildren();
		self.getNode:setVisible(state == 2);
	end
end

function ArenaRewardTemplate:getNo()
	return self.no
end

return ArenaRewardTemplate;