local ArenaRwdRankItem = class('ArenaRwdRankItem', function() 
    return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")
local RANK_ENUM = Enum:getTable('RANK_ENUM');

function ArenaRwdRankItem:ctor(father)
    self:addTo(father);

    self.node = cc.Node:create();
    self.node:addTo(self);
    self.node:setPosition(280, 34)
    self.node:setCascadeOpacityEnabled(true);

    local bg = cc.Scale9Sprite:create('image/rank/rank_cell_bg.png')
    bg:addTo(self.node)
    bg:setContentSize(cc.size(558 , 68));
    bg:setCapInsets(CCRectMake(15,0,10,68));

	self.bg = cc.Scale9Sprite:create('image/rank/rank_cell_1.png');
    self.bg:setContentSize(cc.size(558 , 68));
    self.bg:setCapInsets(CCRectMake(55,0,40,68));
    self.bg:addTo(self.node);

    self.rankNumLabel = cc.Label:createWithTTF('99' ,  fonts.FONT_SIYUAN , 30)
    self.rankNumLabel:addTo(self.node);
    self.rankNumLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.rankNumLabel:setPosition(-250 , 0);
    self.rankNumLabel:setAnchorPoint(0, 0.5)

    self.itemList = {}
    for j = 1 , 2 do
        local itemCell = template.ItemTemplate:create(2);
        itemCell:addTo(self.node);
        itemCell:setPosition(200 - 80 * (j - 1) , 0);
        itemCell:setScale(0.6)
        self.itemList[j] = itemCell;
    end
	
end
function ArenaRwdRankItem:initData(data)
	self.data = data;

    if data.no<=0 or data.no > 3 then
        self.bg:setVisible(false)
        self.rankNumLabel:setString(tostring(data.rank[1])..'~'..tostring(data.rank[2]))
    else
        self.bg:setVisible(true)
        self.rankNumLabel:setString('')

        self.bg:setTexture('image/rank/rank_cell_'..data.no..'.png');
        self.bg:setContentSize(cc.size(558 , 68));
        self.bg:setCapInsets(CCRectMake(55,0,40,68));
    end

    for k,v in pairs(self.data.reward_season) do
        if self.itemList[k] then
            self.itemList[k]:Init(v[1], v[2])
        end
    end
    
end

function ArenaRwdRankItem:runRefreshAction(delayFrame)
    delayFrame = delayFrame or 1;
    self:stopAllActions()
    self.node:stopAllActions()
    self.node:setVisible(false);
	self:runAction(cc.Sequence:create(
		cc.DelayTime:create(delayFrame/30),
		cc.CallFunc:create( function (  )
   --          if self.rankListSpine  then
   --              self.rankListSpine:setVisible(true);
	  --           self.rankListSpine:clearTracks();
			-- 	self.rankListSpine:setAnimation(0, 'jingjichang_spine', false)
			-- end
		end)
	));
end

return ArenaRwdRankItem;