local BankTaskItem = class('BankTaskItem', function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")

function BankTaskItem:ctor(father)
	self:addTo(father)

	local node = cc.Node:create()
	node:addTo(self)
	node:setPosition(275, 75)

	local bg = cc.Sprite:create('image/activity/three_day/rd_cell_bg.png');
	bg:addTo(node);

	local bg = cc.Sprite:create('image/fight/roundReward/round_reward_1.png');
	bg:setPosition(-240 , 35);
	bg:addTo(node);

	self.title = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.title:addTo(node);
	self.title:setPosition(-220 , 35);
	self.title:setAnchorPoint(0 , 0.5);
	self.title:setTextColor(cc.c3b(255 , 255 , 255));
	self.title:enableOutline(cc.c3b(0 , 0 , 0) , 2);

	self.itemList = {}
	for i=1,2 do
		local rwdNode = cc.Node:create()
		rwdNode:addTo(node);
		rwdNode:setPosition(20 + 167 * (i - 1) , 0);

		local icon = template.ItemTemplate:create(2);
		icon:addTo(rwdNode);

		local spine_res = 'kelingqu_spine'
		local spine = nil;
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
	        spine:addTo(rwdNode)
	        spine:setAnimation(0, 'idle', true);
	        spine:setVisible(false)
	    end

	    local getedNode = cc.Node:create()
        getedNode:addTo(rwdNode)
        getedNode:setVisible(false)
        local getedBG = cc.Scale9Sprite:create('image/commonImg/mask_icon.png')
        getedBG:addTo(getedNode)
        local getedIcon = cc.Sprite:create('image/commonImg/ok_icon.png')
        getedIcon:addTo(getedNode)

        local btn = ccui.Button:create('image/commonImg/mask_icon.png');
		btn:addTo(rwdNode);
		btn:setTag(i);
		btn:addClickEventListener(handler(self , self.btnClick));
		btn:setOpacity(0)

		self.itemList[i] = {icon=icon, spine=spine, getedNode=getedNode, btn=btn};
	end

	local lockNode = cc.Node:create()
    lockNode:addTo(node)
    lockNode:setPosition(20 + 167 , 0);
    -- lockNode:setVisible(false)
    local lockBG = cc.Scale9Sprite:create('image/commonImg/mask_icon.png')
    lockBG:addTo(lockNode)
    local lockIcon = cc.Sprite:create('image/lock/lock_bg_2.png')
    lockIcon:addTo(lockNode)
    local vipIcon = cc.Sprite:create('image/activity/three_day/rd_vip.png')
    vipIcon:addTo(lockNode)
    vipIcon:setPosition(0,50)
    self.lockNode = lockNode;

	local progressBg = cc.Scale9Sprite:create('image/commonImg/pgs_bg_1_213_12.png');
	progressBg:addTo(node);
	progressBg:setContentSize(cc.size(180, 12))
	progressBg:setPosition(-160 , -1);

	self.progress = cc.Scale9Sprite:create('image/commonImg/pgs_2_14_12.png');
	self.progress:setCapInsets(CCRectMake(6,0,2,12));
	self.progress:addTo(node);
	self.progress:setAnchorPoint(0 , 0.5);
	self.progress:setPosition(-250 , -1);

	self.num = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.num:addTo(node);
	self.num:setPosition(-160 , -25);
	self.num:enableOutline(cc.c3b(0 , 0 , 0) , 2);

	EventManager:RegisterEvent('BankTaskItem:onRwdUpdate',handler(self,self.onRwdUpdate));
	EventManager:RegisterEvent('BankTaskItem:onRechargeUpdate',handler(self,self.onRechargeUpdate));

end
function BankTaskItem:Init(data, seasonId, is_recharge)
	self.data = data;
	self.season_id = seasonId;
	self.is_recharge = is_recharge;
	if data.reward and data.reward[1] then
		self.itemList[1].icon:Init(data.reward[1][1], data.reward[1][2])
	end

	if data.ex_reward and data.ex_reward[1] then
		self.itemList[2].icon:Init(data.ex_reward[1][1], data.ex_reward[1][2])
	end

	local name = ResTable:getValue('round_bank_mission', self.data.no, 'mission_info')
	self.title:setString(string.format(name,self.data.mission));

	self:onUpdate();

end

function BankTaskItem:onRechargeUpdate(is_recharge)
	self.is_recharge = is_recharge;
	self:onUpdate();

end

function BankTaskItem:onRwdUpdate()
	self.data = model.RoundModel:getRoundMissionTaskById(self.season_id, self.data.no)
	self:onUpdate()
end

function BankTaskItem:onUpdate()

	local curVal = self.data.progress;
	curVal = math.min(curVal, self.data.mission)
	self.num:setString(string.format('(%d/%d)',curVal ,self.data.mission));

	local percentage = curVal/self.data.mission;
	percentage = percentage > 1 and 1 or percentage;
	local width = 180 * percentage;
	if width > 0 then
		width = math.max(width,12);
		width = math.min(width,180);
	else
		width = 0;
	end
	self.progress:setContentSize(cc.size(width , 12)); --min:14 max: 213
	
	if self.data.status_1 == 0 then
		self.itemList[1].spine:setVisible(false)
		self.itemList[1].getedNode:setVisible(false)
	elseif self.data.status_1 == 1 then
		self.itemList[1].spine:setVisible(true)
		self.itemList[1].getedNode:setVisible(false)
	elseif self.data.status_1 == 2 then
		self.itemList[1].spine:setVisible(false)
		self.itemList[1].getedNode:setVisible(true)
	end

	if self.is_recharge==1 then
		self.lockNode:setVisible(false)
		if self.data.status_2 == 0 then
			self.itemList[2].spine:setVisible(false)
			self.itemList[2].getedNode:setVisible(false)
		elseif self.data.status_2 == 1 then
			self.itemList[2].spine:setVisible(true)
			self.itemList[2].getedNode:setVisible(false)
		elseif self.data.status_2 == 2 then
			self.itemList[2].spine:setVisible(false)
			self.itemList[2].getedNode:setVisible(true)
		end
	else
		self.itemList[2].spine:setVisible(false)
		self.itemList[2].getedNode:setVisible(false)
		self.lockNode:setVisible(true)
	end
	
end

function BankTaskItem:btnClick(sender , event)
    local idx = sender:getTag()
    if idx==1 and self.data.status_1 ~= 1 then
    	return;
    end

    if idx==2 and (self.data.status_2 ~= 1 or self.is_recharge~=1) then
    	return;
    end

    local msg = {};
    msg.season_id = self.season_id;
    msg.mission_id = self.data.no;
    msg.tag = idx;
	Network.NetworkManager:Send(Network.NetworkCmdType.req_round_mission_item_rwd, msg);
end

return BankTaskItem;