local BareCollectTemplate = class("BareCollectTemplate" , function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")
local moveWidth = 320;

local activeSpineName = {
	[1] = 'zuoshang',
	[3] = 'youshang',
	[10] = 'zuoxia',
	[12] = 'youxia',
}

function BareCollectTemplate:ctor()

	self.bg = cc.Sprite:create('image/bareCollect/bare_collect_1.png');
	self.bg:addTo(self);

	self.blackBg = ccui.ImageView:create('image/bareCollect/bare_collect_2.png');
	self.blackBg:addTo(self);
	self.blackBg:setPosition(0 , 4);

	self.activeBgNode = cc.Node:create();
	self.activeBgNode:addTo(self);
	self.activeBgNode:setPosition(0,3);

	self.spineNode = cc.Node:create();
	self.spineNode:addTo(self);
	self.spineNode:setPosition(0, 4);
	self.spineNode:setLocalZOrder(10);

	--self.blackTranslucentBg = cc.Sprite:create('image/bareCollect/bare_collect_10.png');
	--self.blackTranslucentBg:addTo(self);
	--self.blackTranslucentBg:setPosition(0 , 4);

	self.fg = cc.Sprite:create('image/bareCollect/bare_collect_3.png');
	self.fg:addTo(self);
	self.fg:setPosition(0 , 3)

	self.gridBg = cc.Sprite:create('image/bareCollect/bare_collect_5.png');
	self.gridBg:addTo(self);
	self.gridBg:setPosition(0,4);

	self.infoNode = cc.Node:create();
	self.infoNode:addTo(self);

	self.headNode = cc.Node:create();
	self.headNode:addTo(self.infoNode);

	local roleIconBg = cc.Sprite:create('image/bareCollect/bare_collect_13.png');
	roleIconBg:addTo(self.headNode);
	roleIconBg:setPosition(-2 , 79);

	self.iconNode = cc.Node:create();
	self.iconNode:addTo(self.headNode);
	self.iconNode:setPosition(-2 , 79);

	local roleIconFg = cc.Sprite:create('image/bareCollect/bare_collect_6.png');
	roleIconFg:addTo(self.headNode);
	roleIconFg:setPosition(0,82);

	self.name = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 25);
	self.name:setPosition(0 , -21);
	self.name:addTo(self.infoNode);
	self.name:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

	local bg = cc.Sprite:create('image/bareCollect/bare_collect_4.png');
	bg:addTo(self.infoNode);
	bg:setPosition(0 , -44);

	self.infoLabel = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 16);
	self.infoLabel:setPosition(0 , -57);
	self.infoLabel:addTo(self.infoNode);
	self.infoLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

	self.infoIcon = cc.Sprite:create('image/commonImg/def_type_1.png')
	self.infoIcon:addTo(self.infoNode)
	self.infoIcon:setPosition(0, -57)
	self.infoIcon:setScale(0.5)
	self.infoIcon:setVisible(false)

	self.largeBtn = ccui.Button:create('image/bareCollect/bare_collect_9.png');
	self.largeBtn:addTo(self);
	--self.largeBtn:setSwallowTouches(false);
	self.largeBtn:setPosition(-223 , 397);
	--self.largeBtn:addClickEventListener(handler(self , self.largeBtnClick));

	self.imgPos = {};
	for i = 1 , 12 do
		local row = math.ceil(i / 3);
		local col =  i % 3;
		col = col == 0 and 3 or col;
		
		local x , y = -139 + 139 * (col - 1) , 293.625 - 195.75 * (row - 1);
		self.imgPos[i] = cc.p(x , y);
	end
	self.imgShadowList = {};

	self.initEnd = false;
end

function BareCollectTemplate:isInitEnd()
	return self.initEnd;
end

function BareCollectTemplate:Init(data)

	self.activeBgNode:removeAllChildren();

	local bareImg = ResTable:getValue('role_resource',data.resource_id,'card');
	local activeSp = cc.Sprite:create('image/role/'..bareImg..'.png');
	local spSize = activeSp:getContentSize();
	self.x = (spSize.width-417)/2;
	self.y = (spSize.height-785)/2;
	activeSp:setTextureRect(cc.rect(self.x , self.y , 417 , 785));
	--activeSp:addTo(self.activeBgNode);

	local stencil = cc.Sprite:create('image/bareCollect/bare_collect_2.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0.5);
	-- clippingNode:setPosition(208.5,392.5)
	clippingNode:addTo(self.activeBgNode);
	-- clippingNode:addChild(activeSp);

	if not (data.activeNum >= 12) then
		-- local spine_res = ResTable:getValue('role_resource',data.resource_id,'spine')
		-- if spine_res and cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		-- 	local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		-- 	spine:addTo(clippingNode)
		-- 	spine:setAnimation(0,'black',false);
		-- end

		local spB1 = cc.Sprite:createWithTexture( activeSp:getTexture() )
		spB1:addTo(clippingNode)
		local spB2 = cc.Sprite:create('image/role/'..bareImg..'_b2.png');
		spB2:addTo(clippingNode)

	end

	activeSp:addTo(clippingNode);
	activeSp:setVisible(false);

	self:initShadow();

	-- local renderTexture = cc.RenderTexture:create(417,785,cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888,gl.DEPTH24_STENCIL8_OES);
	-- renderTexture:beginWithClear(0,0,0,0);
	-- clippingNode:visit();
	-- renderTexture:endToLua();
	-- local spTexture = renderTexture:getSprite():getTexture();
	-- activeSp = cc.Sprite:createWithTexture(spTexture)
	-- activeSp:addTo(self.activeBgNode);
	-- activeSp:setScaleY(-1);

	if data.activeState == 0 or data.activeNum < 12 then
		-- activeSp:setOpacity(38.25);
		-- GlobalFunctions:setSpriteGrey(activeSp);

		self.gridBg:setVisible(true);
		self.largeBtn:setVisible(false);
	end

	if data.activeState ~= 0 and data.activeNum < 12 then
		for i = 1 , 12 do
			if data.mapState[i] then
				self:updateImg(i,bareImg)
			end
		end
	elseif data.activeNum >= 12 then
		self.gridBg:setVisible(false);
		self.largeBtn:setVisible(true);
		for i=1,12 do
			self.imgShadowList[i]:setVisible(false);
		end

		activeSp:setVisible(true);
	end

	if data.activeState == 0 then
		self.infoNode:setPosition(0,0)
		self.headNode:setVisible(true);

		local resource_id = ResTable:getValue('role', data.role_id, 'resource_id');
		local iconPath = ResTable:getValue('role_resource', resource_id, 'icon');
		self:initHeadIcon(iconPath);

		local roleInfo = ResTable:getRowData('role_info' , data.role_id);
		if not roleInfo then
			return
		end
		self.name:setString(tostring(roleInfo.name));

		self.infoLabel:setString(data.get_des);
		self.infoIcon:setVisible(false)
		--self.blackTranslucentBg:setVisible(true);
	else
		self.infoNode:setPosition(0,-300)
		self.headNode:setVisible(false);
		local roleInfo = ResTable:getRowData('role_info' , data.role_id);
		if not roleInfo then
			return
		end
		self.name:setString(tostring(roleInfo.name));

		local str = '';
		local att = data.attribute_effect;
		if att[2] > 0 then
			str = string.format(LANG.UI_CARD_LOVE_ATT_NAME[att[1]],tostring(att[2]));
		end
		if att[3] > 0 then
			local str1 = string.format(LANG.UI_CARD_LOVE_ATT_NAME[att[1]],(tostring(att[3] * 100)..'%'));
			if att[2] > 0 then
				str = str..', '..str1;
			else
				str = str1;
			end
		end
		if att[2]>0 or att[3] > 0 then
			str = string.format(LANG.UI_BARE_COLLECT_16, str);
			self.infoIcon:setVisible(false)
		else
			att = data.attribute_effect2;
			local colorName = LANG.UI_GROUP_NAME[data.attribute_color]
			if att[2] > 0 then
				str = string.format(LANG.UI_CARD_BARE_COLOR_ATT_NAME[att[1]],tostring(att[2]));
			end
			if att[3] > 0 then
				local str1 = string.format(LANG.UI_CARD_BARE_COLOR_ATT_NAME[att[1]],(tostring(att[3] * 100)..'%'));
				if att[2] > 0 then
					str = str..', '..str1;
				else
					str = str1;
				end
			end

			str = string.format(LANG.UI_BARE_COLLECT_17, colorName, str);

			self.infoIcon:setTexture('image/commonImg/def_type_'..data.attribute_color..'.png')
			self.infoIcon:setVisible(true)
		end
		self.infoLabel:setString(str);
		self.infoIcon:setPosition(-20-self.infoLabel:getContentSize().width/2,-57)

		--self.blackTranslucentBg:setVisible(false);
	end

	self.bareId = data.bare_id;
	
	self.slotMachineCallback = nil;

	self.initEnd = true;
	model.BareCollectModel:setBareDataInitEnd(self.bareId, false)

end

function BareCollectTemplate:initHeadIcon(icon)
	self.iconNode:removeAllChildren();
	local sp = cc.Sprite:create('image/icon/'..icon..'.png');
	local size = sp:getContentSize();
	local stencil = cc.Sprite:create('image/bareCollect/bare_collect_13.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:addChild(sp);
	clippingNode:setPosition(size.width/2,size.height/2)

	local renderTexture = cc.RenderTexture:create(size.width,size.height,cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888,gl.DEPTH24_STENCIL8_OES);
	renderTexture:beginWithClear(0,0,0,0);
	clippingNode:visit();
	renderTexture:endToLua();
	local spTexture = renderTexture:getSprite():getTexture();
	sp = cc.Sprite:createWithTexture(spTexture)
	sp:addTo(self.iconNode);
	sp:setScaleY(-1);
end

function BareCollectTemplate:updateBgImg(pos)
	local bareData = model.BareCollectModel:getBareData(self.bareId);
	if bareData then
		local bareImg = ResTable:getValue('role_resource',bareData.resource_id,'card');
		self:updateImg(pos,bareImg,true);
	end
end

function BareCollectTemplate:initShadow()
	for i=1,12 do
		local pos = i;
		local row = math.ceil(pos / 3);
		local col =  pos % 3;
		col = col == 0 and 3 or col;

		local activeSp = cc.Sprite:create('image/bareCollect/bare_collect_2.png');
		activeSp:setTextureRect(cc.rect(0 + 139 * (col - 1), 0 + 195.75 * (row - 1) , 139 , 195.75));
		activeSp:addTo(self.activeBgNode);
		activeSp:setPosition(self.imgPos[pos]);
		activeSp:setOpacity(200);

		self.imgShadowList[i] = activeSp;
	end
	
end

function BareCollectTemplate:updateImg(pos,bareImg,showAction)
	local row = math.ceil(pos / 3);
	local col =  pos % 3;
	col = col == 0 and 3 or col;

	local activeSp = cc.Sprite:create('image/role/'..bareImg..'.png');
	activeSp:setTextureRect(cc.rect(self.x + 139 * (col - 1), self.y + 195.75 * (row - 1) , 139 , 195.75));

	if pos == 1 or pos == 3 or pos == 10 or pos == 12 then
		local stencil = cc.Sprite:create('image/bareCollect/bare_collect_2.png');
		stencil:setTextureRect(cc.rect(0,0,139,195.75));
		local scaleX,scaleY = 1 , 1;
		if pos == 3 then
			scaleX = -1;
		elseif pos == 10 then
			scaleY = -1;
		elseif pos == 12 then
			scaleX = -1;
			scaleY = -1;
		end
		stencil:setScaleX(scaleX);
		stencil:setScaleY(scaleY);

		local clippingNode = cc.ClippingNode:create();
		clippingNode:setStencil(stencil);
		clippingNode:setInverted(false);
		clippingNode:setAlphaThreshold(0);
		clippingNode:addChild(activeSp);
		clippingNode:setPosition(69.5,97.875)

		-- local spine_res = bareImg..'_Spine';
		-- if spine_res and cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		-- 	local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		-- 	spine:addTo(clippingNode)
		-- 	spine:setAnimation(0,'idle',false);
		-- end

		local renderTexture = cc.RenderTexture:create(139,195.75,cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888,gl.DEPTH24_STENCIL8_OES);
		renderTexture:beginWithClear(0,0,0,0);
		clippingNode:visit();
		renderTexture:endToLua();
		local spTexture = renderTexture:getSprite():getTexture();
		activeSp = cc.Sprite:createWithTexture(spTexture)
		activeSp:setScaleY(-1);
	end

	activeSp:addTo(self.activeBgNode);
	activeSp:setPosition(self.imgPos[pos]);
	self.imgShadowList[pos]:setOpacity(255);
	if showAction then
		activeSp:setOpacity(0);
		activeSp:runAction(cc.FadeIn:create(0.4));
	end
end

function BareCollectTemplate:getBareId()
	return self.bareId
end

function BareCollectTemplate:setIndexPos(index)
	self.indexPos = index;
end

function BareCollectTemplate:getIndexPos()
	return self.indexPos;
end

function BareCollectTemplate:setLargeBtnTag(tag)
	self.largeBtn:setTag(tag);
end

function BareCollectTemplate:addLargeBtnClickEventListener(callback)
	self.largeBtn:addClickEventListener(callback)
end

function BareCollectTemplate:setBgBtnTag(tag)
	self.blackBg:setTag(tag);
end
function BareCollectTemplate:addBgTouchEvent(callback)
	self.blackBg:setTouchEnabled(true);
    self.blackBg:addClickEventListener(callback);
    self.blackBg:setSwallowTouches(false);
end

function BareCollectTemplate:showSlotMachine(pos,callback)
	self.slotMachineCallback = callback;
	self:showActiveSpine(pos);
end

function BareCollectTemplate:showActiveSpine(pos)
	local spineName = 'zhijiao';
	if activeSpineName[pos] then
		spineName = activeSpineName[pos];
	end
	local spinePos = self.imgPos[pos];
	
	self.spineNode:removeAllChildren();

	if cc.FileUtils:getInstance():isFileExist('spine/jinghua_spine/jinghua_spine.json') then
		local skeletonNode = sp.SkeletonAnimation:create('spine/jinghua_spine/jinghua_spine.json', 'spine/jinghua_spine/jinghua_spine.atlas', 1)

		skeletonNode:setPosition(spinePos);
		skeletonNode:addTo(self.spineNode)
		skeletonNode:setAnimation(0 , spineName , false);

		skeletonNode:registerSpineEventHandler(function ( event )
			local eventName = event.eventData.name;
			if eventName == 'appear' then
				self:updateBgImg(pos)
			end
		end,sp.EventType.ANIMATION_EVENT)

		skeletonNode:registerSpineEventHandler(function (event)
			if self.slotMachineCallback then
				self.slotMachineCallback();
			end
		end, sp.EventType.ANIMATION_COMPLETE)
	end
end

function BareCollectTemplate:removeActiveSpine()
	self.spineNode:removeAllChildren();
	self.slotMachineCallback = nil;
end

return BareCollectTemplate;
--[[
function BareCollectTemplate:updateBgPosImg(idx , data)

	if self.bgList[idx] then
		self.bgList[idx]:removeFromParent();
		self.bgList[idx] = nil;
	end

	local row = math.ceil(idx / 3);
	local col =  idx % 3;
	col = col == 0 and 3 or col;

	local node = cc.Node:create();
	node:addTo(self.activeBgNode);
	node:setPosition(self.imgPos[idx]);

	local activeSp = cc.Sprite:create('image/role/'..data.res_name..'.png');
	activeSp:setTextureRect(cc.rect(1065.5 + 123 * (col - 1), 886 + 182 * (row - 1) , 123 , 182));
	activeSp:addTo(node);
	activeSp:setName('sp');

	if not data.mapState[idx] then
		local spSize = activeSp:getContentSize();
		local whiteSp = cc.Sprite:createWithSpriteFrame(activeSp:getSpriteFrame());
		--GlobalFunctions:setSpriteGrey(whiteSp,4,4,4);
		whiteSp:setPosition(spSize.width/2 , spSize.height/2);
		local renderTexture = cc.RenderTexture:create(spSize.width,spSize.height,cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888);
		renderTexture:begin();
		whiteSp:visit();
		renderTexture:endToLua();

		local spTexture = renderTexture:getSprite():getTexture();
		whiteSp = cc.Sprite:createWithTexture(spTexture)
		whiteSp:setScaleY(-1);
		whiteSp:addTo(node);
		whiteSp:setOpacity(127);

		--local whiteSp = cc.Sprite:createWithSpriteFrame(activeSp:getSpriteFrame());
		--whiteSp:addTo(node);
		--GlobalFunctions:setSpriteGrey(whiteSp,4,4,4);
		--activeSp:setOpacity(127);

		--local spSize = activeSp:getContentSize();
		local sp = cc.Sprite:createWithSpriteFrame(activeSp:getSpriteFrame());
		sp:setPosition(spSize.width/2 , spSize.height/2);
		--GlobalFunctions:setSpriteGrey(sp);

		local renderTexture = cc.RenderTexture:create(spSize.width,spSize.height,cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888);
		renderTexture:begin();
		sp:visit();
		renderTexture:endToLua();

		local spTexture = renderTexture:getSprite():getTexture();
		sp = cc.Sprite:createWithTexture(spTexture)
		sp:setScaleY(-1);
		sp:setOpacity(102);
		--GlobalFunctions:setGaussianGary(sp,30,20);
		sp:addTo(node);
		--sp:setLocalZOrder(100);

		--GlobalFunctions:setSpriteGrey(activeSp);
	end

	self.bgList[idx] = node;
end
]]