local BareLoveWearTemplate = class("BareLoveWearTemplate" , function()
	return ccui.Layout:create();
end)

local fonts = Enum:getTable('SystemFont')
local outlineColor = {
	[1] = cc.c3b(30,130,35),
	[2] = cc.c3b(210,80,10),
}

function BareLoveWearTemplate:ctor()
	local bg = cc.Sprite:create('image/equip/equip_wear/equip_wear_6.png')
		:addTo(self)

	local bg = cc.Sprite:create('image/commonImg/item_quality_2.png')
		:addTo(self)
		:setPosition(-207,0)

	self.headIcon = cc.Sprite:create()
		:addTo(self)
		:setPosition(-207,0)
		:setScale(0.85);

	self.roleName = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
		:addTo(self)
		:setAnchorPoint(0,0.5)
		:setPosition(-142.5,20.5)
		:enableBold()

	self.infoIcon = cc.Sprite:create('image/commonImg/def_type_1.png')
	self.infoIcon:addTo(self)
	self.infoIcon:setPosition(-142, -20)
	self.infoIcon:setScale(0.5)
	self.infoIcon:setVisible(false)
	
	self.attList = {};
	for i = 1 , 2 do
		self.attList[i] = {};
		local attName = cc.Label:createWithTTF('sss',fonts.FONT_SIYUAN,20)
			:addTo(self)
			:setAnchorPoint(0,0.5)
			:setPosition(-142 + 132*(i-1),-20)
		self.attList[i].attName = attName;

		local att = cc.Label:createWithTTF('aaa',fonts.FONT_SIYUAN,20)
			:addTo(self)
			:setAnchorPoint(0,0.5)
			:setPosition(-142 + 132*(i-1),-20)
		self.attList[i].att = att;
	end

	local label = cc.Label:createWithTTF(LANG.UI_EQUIP_47,fonts.FONT_SIYUAN,20)
		:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
	self.wearBtn = ccui.Button:create('image/commonImg/btn_1_139_55.png','image/commonImg/btn_1_139_55.png');
	self.wearBtn:addTo(self);
	self.wearBtn:setPosition(190,0)
	self.wearBtn:setTag(1)
	self.wearBtn:setTitleLabel(label)
	self.wearBtn:addClickEventListener(handler(self , self.btnClick))

	local label = cc.Label:createWithTTF(LANG.UI_EQUIP_48,fonts.FONT_SIYUAN,20)
		:enableOutline(cc.c3b(120 , 120 , 120) , 2);
	self.takeOffBtn = ccui.Button:create('image/commonImg/btn_1_139_55_2.png','image/commonImg/btn_1_139_55_2.png');
	self.takeOffBtn:addTo(self);
	self.takeOffBtn:setPosition(190,0)
	self.takeOffBtn:setTag(2)
	self.takeOffBtn:setTitleLabel(label)
	self.takeOffBtn:addClickEventListener(handler(self , self.btnClick))

	self.tipNode = cc.Node:create()
		:setPosition(265,0)
		:addTo(self)

	self.tipBg = cc.Sprite:create('image/commonImg/tip_2.png');
	self.tipBg:addTo(self.tipNode);

	self.tipLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_50 , fonts.FONT_SIYUAN , 20);
	self.tipLabel:addTo(self.tipNode);
	self.tipLabel:setAnchorPoint(1,0.5);
	self.tipLabel:setTextColor(cc.c3b(255 , 200 , 0));

end

function BareLoveWearTemplate:Init(data,bareLoveType)
	local attData = nil;
	local headIcon = '';
	local roleId = 1;
	local canWear = false;
	self.infoIcon:setVisible(false)
	if bareLoveType == 1 then--爱恋
		attData = data.loveData[5].effect
		headIcon = data.loveData[5].show_icon;
		if data.loveLevel >= 5 then
			canWear = true;
		else
			self.tipLabel:setString(LANG.UI_EQUIP_50);
		end
		roleId = data.loveData[5].role_id
	else 
		if data.attribute_effect2[2] > 0 or data.attribute_effect2[3]>0 then
			attData = {data.attribute_effect2};
			self.infoIcon:setTexture('image/commonImg/def_type_'..data.attribute_color..'.png')
			self.infoIcon:setVisible(true)
		else
			attData = {data.attribute_effect};
		end 
		headIcon = ResTable:getValue('role_resource',data.resource_id,'icon');
		if data.activeNum >= 12 then
			canWear = true;
		else
			self.tipLabel:setString(LANG.UI_EQUIP_50);
		end
		if data.pid > 0 then
			local card = model.CardModel:GetCard(data.pid);
			if card then
				canWear = false;
				local name = ResTable:getValue('role_info' , card.no , 'name');
				self.tipLabel:setString(string.format(LANG.UI_EQUIP_59,tostring(name)));
			end
		end
		roleId = data.role_id
	end

	for i = 1 , 2 do
		local att = attData[i];
		if att then
			self.attList[i].attName:setVisible(true)
			self.attList[i].att:setVisible(true)
			self.attList[i].attName:enableOutline(outlineColor[att[1]],2)
			self.attList[i].attName:setString(tostring(LANG.UI_CARD_ATT_NAME[att[1]]));
			if att[2] > 0 then
				self.attList[i].att:setString('+'..tostring(att[2]));
			elseif att[3] > 0 then
				self.attList[i].att:setString('+'..tostring(att[3] * 100)..'%');
			end

			if self.infoIcon:isVisible() then
				self.attList[i].attName:setPosition(-122 + 132*(i-1),-20)
			else
				self.attList[i].attName:setPosition(-142 + 132*(i-1),-20)
			end
			local width = self.attList[i].attName:getContentSize().width;
			self.attList[i].att:setPositionX(self.attList[i].attName:getPositionX()+width+5);
		else
			self.attList[i].attName:setVisible(false)
			self.attList[i].att:setVisible(false)
		end
	end

	local name = ResTable:getValue('role_info',roleId,'name');
	self.roleName:setString(tostring(name));
	self.headIcon:setTexture('image/icon/'..headIcon..'.png');

	self.takeOffBtn:setVisible(false);
	if not canWear then
		self.wearBtn:setVisible(false);
		self.tipNode:setVisible(true);
		
		self.tipBg:setPosition(-self.tipLabel:getContentSize().width-20,0);
	else
		self.wearBtn:setVisible(true);
		self.tipNode:setVisible(false);
	end
end

function BareLoveWearTemplate:setBtnTag(tag)
	self.curTag = tag
end

function BareLoveWearTemplate:addBtnClickEventListener(callback)
	self.callback = callback
end

function BareLoveWearTemplate:btnClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(tag,self.curTag);
	end
end

function BareLoveWearTemplate:setTakeOff(bTakeOff)
	self.takeOffBtn:setVisible(bTakeOff)
	self.wearBtn:setVisible(not bTakeOff)
	self.tipNode:setVisible(false);
end

return BareLoveWearTemplate;
