local BattlePassRewardTemplate = class('BattlePassRewardTemplate')
local fonts = Enum:getTable("SystemFont")
function BattlePassRewardTemplate:ctor(father)
	self.root = cc.Node:create();
	self.root:addTo(father);

	self.bg = cc.Sprite:create();
    self.bg:addTo(self.root);
  
	self.level = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
    self.level:addTo(self.root);
    self.level:setPosition(-229,0);
    self.level:setTextColor(cc.c3b(60 , 60 , 60));

    local bg = cc.Sprite:create('image/battlePass/battle_pass_bg_30.png');
    bg:addTo(self.root);
    bg:setPosition(-77 , 0);

    self.rewardIcon = template.IconTemplate:create(self.root);
	self.rewardIcon:setPosition(-77 , 0);
	self.rewardIcon:setScale(0.7);
	self.rewardIcon:setTag(1);
	self.rewardIcon:addClickEventListener(handler(self , self.rewardClick));

    self.rewardLock = cc.Sprite:create('image/battlePass/battle_pass_bg_13.png');
    self.rewardLock:addTo(self.root);
    self.rewardLock:setPosition(-116 , 31);

    self.rewardGeted = cc.Sprite:create('image/battlePass/battle_pass_bg_11.png');
    self.rewardGeted:addTo(self.root);
    self.rewardGeted:setPosition(-77 , 0);

    bg = cc.Sprite:create('image/battlePass/battle_pass_bg_10.png');
    bg:addTo(self.root);
	bg:setPosition(155 , 0);
	
	self.viewItemNode = cc.Sprite:create();
	self.viewItemNode:addTo(self.root);
	self.viewItemNode:setPosition(115,0);

    --self.viewItemView = ccui.ScrollView:create();
	--self.viewItemView:setTouchEnabled(true);
	--self.viewItemView:setBounceEnabled(true);
	--self.viewItemView:setDirection(ccui.ScrollViewDir.horizontal);
	--self.viewItemView:setContentSize(cc.size(161, 86));
	--self.viewItemView:setAnchorPoint(cc.p(0.5, 0.5));
	--self.viewItemView:setPosition(155 , 0);
	--self.viewItemView:setScrollBarEnabled(false);
	--self.viewItemView:addTo(self.root);
end
function BattlePassRewardTemplate:initData(data)

	self.no = data.no;

	local no = data.no%2;

	if no == 1 then
		self.bg:setTexture('image/battlePass/battle_pass_bg_15.png');
	else
		self.bg:setTexture('image/battlePass/battle_pass_bg_14.png');
	end
	self.level:setString(tostring(data.no));
	local curPointNum = model.ItemModel:getItemNum(BATTLE_PASS);
	
	if data.reward and data.reward[1] then
		local reward = data.reward[1];
		self.rewardIcon:Init(reward[1] , reward[2]);
		self.rewardIcon:setTag(1);
		self.rewardGeted:setVisible(data.reward_state == 1);
		self.rewardLock:setVisible(curPointNum < data.total_point);
		self.rewardIcon:setVisible(true);
	else
		self.rewardGeted:setVisible(false);
		self.rewardLock:setVisible(false);
		self.rewardIcon:setVisible(false);
	end

	self.viewItemNode:removeAllChildren();

	if data.special_reward and data.special_reward[1] then

		local specialState = model.BattlepassEventModel:getSpecialState();

		for _k , item in pairs(data.special_reward) do
			local layout = ccui.Layout:create();
			layout:addTo(self.viewItemNode);
			layout:setPosition(80 * (_k - 1) , 0);

			local icon = template.IconTemplate:create(layout);
			icon:Init(item[1] , item[2]);
			icon:setScale(0.7);
			icon:setTag(2);
			icon:addClickEventListener(handler(self , self.rewardClick));

			if curPointNum < data.total_point or specialState == 0 then
				local lock = cc.Sprite:create('image/battlePass/battle_pass_bg_13.png');
				lock:addTo(layout);
				lock:setPosition(-39 , 31);
			elseif data.reward_special_state == 1 then
				local geted = cc.Sprite:create('image/battlePass/battle_pass_bg_11.png');
				geted:addTo(layout);
			end
		end
	end

	--[[
	self.viewItemView:removeAllChildren();

	local num = #data.special_reward;
	local maxWidth = 80 * num;

	self.viewItemView:setInnerContainerSize(cc.size(maxWidth , 86));

	for _k , item in pairs(data.special_reward) do
		local layout = ccui.Layout:create();
		layout:addTo(self.viewItemView);
		layout:setPosition(40 + 80 * (_k - 1) , 43);

		local icon = template.IconTemplate:create(layout);
		icon:Init(item[1] , item[2]);
		icon:setScale(0.7);

		if curPointNum < data.total_point then
			local lock = cc.Sprite:create('image/battlePass/battle_pass_bg_13.png');
			lock:addTo(layout);
			lock:setPosition(-39 , 31);
		elseif data.reward_special_state == 1 then
			local geted = cc.Sprite:create('image/battlePass/battle_pass_bg_11.png');
			geted:addTo(layout);
		end
	end
	]]
end

function BattlePassRewardTemplate:rewardClick(tag)
	if self.callback then
		self.callback(tag , self.no);
	end
end

function BattlePassRewardTemplate:getParent()
	return self.root:getParent();
end

function BattlePassRewardTemplate:setPosition(x , y)
	self.root:setPosition(x , y);
end

function BattlePassRewardTemplate:addClickEventListener(callback)
	self.callback = callback;
end

return BattlePassRewardTemplate;