local BattlepassEventMissionTemplate = class('BattlepassEventMissionTemplate', function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")
function BattlepassEventMissionTemplate:ctor()
	local bg = cc.Sprite:create('image/commonImg/bg_4_563_126.png');
	bg:addTo(self);

	local bg = cc.Sprite:create('image/fight/roundReward/round_reward_1.png');
	bg:setPosition(-252 , 35);
	bg:addTo(self);

	self.timeType = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.timeType:addTo(self);
	self.timeType:setAnchorPoint(0 , 0.5);
	self.timeType:setPosition(-232 , 35);
	self.timeType:setTextColor(cc.c3b(20 , 140 , 0));

	self.title = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.title:addTo(self);
	self.title:setPosition(-232 , 35);
	self.title:setAnchorPoint(0 , 0.5);
	self.title:setTextColor(cc.c3b(255 , 255 , 255));
	self.title:enableOutline(cc.c3b(40 , 50 , 60) , 2);

	local itemBg = cc.Sprite:create('image/commonImg/bg_3_194_102.png');
	itemBg:addTo(self);
	itemBg:setPosition(58 , 0);

	self.itemView = ccui.ScrollView:create();
	self.itemView:setTouchEnabled(true);
	self.itemView:setBounceEnabled(true);
	self.itemView:setDirection(ccui.ScrollViewDir.horizontal);
	self.itemView:setContentSize(cc.size(185, 87));
	self.itemView:setAnchorPoint(cc.p(0.5, 0.5));
	self.itemView:setPosition(58 , 0);
	self.itemView:setScrollBarEnabled(false);
	self.itemView:addTo(self);
	self.itemView:setSwallowTouches(false);

	local progressBg = cc.Sprite:create('image/commonImg/pgs_bg_1_213_12.png');
	progressBg:addTo(self);
	progressBg:setPosition(-160 , -1);

	self.progress = cc.Scale9Sprite:create('image/commonImg/pgs_2_14_12.png');
	self.progress:setCapInsets(CCRectMake(6,0,2,12));
	self.progress:addTo(self);
	self.progress:setAnchorPoint(0 , 0.5);
	self.progress:setPosition(-266 , -1);

	self.num = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.num:addTo(self);
	self.num:setPosition(-160 , -25);
	self.num:enableOutline(cc.c4b(40 , 50 , 60 , 255) , 2);

	self.btnLabel = cc.Label:createWithTTF(LANG.UI_ACTIVITY_13, fonts.FONT_SIYUAN, 18)
	self.btnLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.btnLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

	self.btn = ccui.Button:create('image/commonImg/btn_2_103_36.png' ,'image/commonImg/btn_2_103_36.png' , 'image/commonImg/btn_3_103_36.png');
	self.btn:addTo(self);
    self.btn:setTitleLabel(self.btnLabel)
	self.btn:addClickEventListener(handler(self , self.btnClick));
	self.btn:setPosition(219 , 0);

	self.effect = cc.ParticleSystemQuad:create('Effect/particle/lingqu.plist');
	self.effect:addTo(self);
	self.effect:setPositionType(cc.POSITION_TYPE_RELATIVE);
	self.effect:setPosition(219 , 0)
	self.effect:stopSystem();

	self.geted = cc.Sprite:create('image/commonImg/geted_2.png');
	self.geted:addTo(self);
	self.geted:setPosition(219 , 0);
	self.geted:setVisible(false);
end
function BattlepassEventMissionTemplate:initData(data)
	self.itemView:removeAllChildren();
	local num = #data.reward;
	local maxWidth = 80 * num;

	self.itemView:setInnerContainerSize(cc.size(maxWidth , 86));

	for _k , item in pairs(data.reward) do 
		local icon = template.ItemTemplate:create(2);
		icon:addTo(self.itemView);
		icon:setScale(0.8);
		icon:setPosition(41.2 + 82.4 * (_k - 1) , 43.5);
		icon:Init(item[1] , item[2]);
	end

	--local pos = string.find(data.name , ']');
	--if pos then 
	--	self.timeType:setString(string.sub(data.name , 1 , pos));
	--	self.title:setString(string.sub(data.name , (pos + 1)));
	--	self.title:setPositionX(self.timeType:getPositionX() + self.timeType:getContentSize().width);
	--end

	self.title:setString(tostring(ResTable:getLangByNum(data.name_no)));
	
	self.btn:setTouchEnabled(true);

	if data.type == Enum:getTable("MissionType").MISSION_GOLD_COST then
		local curNum = ConvertDigitUnitToStr(tostring(data.num));
		self.num:setString(string.format('(%s/%s)',curNum,tostring(data.times)));
	else
		self.num:setString(string.format('(%d/%d)',data.num,data.times));
	end

	local percentage = data.percent or 0;
	percentage = percentage > 1 and 1 or percentage;
	local width = 213 * percentage;
	if width > 0 then
		width = math.max(width,12);
		width = math.min(width,213);
	else
		width = 0;
	end
	self.progress:setContentSize(cc.size(width , 12)); --min:14 max: 213

	self.geted:setVisible(data.state == 1);
	self.btn:setVisible(true);

	if data.state == 2 then
		self.btn:setBright(true)
		self.effect:resetSystem();
		self.btnLabel:setString(LANG.UI_ACTIVITY_13);
        self.btnLabel:setTextColor(cc.c3b(255 , 255 , 255))
		self.btnLabel:enableOutline(cc.c3b(40, 130, 230), 2)
		self.btn:setTag(1);
	elseif data.state == 0 then
		-- self.btn:loadTextures('image/battlePass/battle_pass_bg_19.png' , 'image/battlePass/battle_pass_bg_19.png');
		self.btn:setBright(false)
		self.effect:stopSystem();
		self.btnLabel:setString(LANG.UI_MISSION_27);
        self.btnLabel:setTextColor(cc.c3b(60 , 60 , 60))
        self.btnLabel:enableOutline(cc.c3b(255, 255, 255), 2)
		self.btn:setTag(2);
		-- if data.type == Enum:getTable("MissionType").MISSION_ROLE_STAR_FIVE then
		-- 	self.btn:setVisible(false);
		-- end
	else
		self.effect:stopSystem();
		self.btn:setBright(true)
		self.btnLabel:setString(LANG.UI_ACTIVITY_13);
        self.btnLabel:setTextColor(cc.c3b(255 , 255 , 255))
		self.btnLabel:enableOutline(cc.c3b(40, 130, 230), 2)
		self.btn:setTouchEnabled(false);
	end

	self.data = data;
end

function BattlepassEventMissionTemplate:btnClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(tag , self.data);
	end
end
function BattlepassEventMissionTemplate:addDailyMissionClickEventListener(callback)
	self.callback = callback;
end

return BattlepassEventMissionTemplate;