local BattlepassEventTemplate = class('BattlepassEventTemplate',function() 
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")
function BattlepassEventTemplate:ctor()
	local bg = cc.Sprite:create('image/battlePass/battlepass_bg_8.png')
		:addTo(self)

	self.rewardFreeNode = cc.Node:create()
		:addTo(self)
		:setPosition(166,0)

	self.rewardSpecialNode = cc.Node:create()
		:addTo(self)
		:setPosition(-166,0)

	self.line = cc.Scale9Sprite:create('image/battlePass/battlepass_bg_12.png')
	self.line:addTo(self)
	self.line:setAnchorPoint(0.5,1)
	self.line:setPosition(-2,86)
	self.line:setCapInsets(cc.rect(0,2,10,4))

	self.levelNode = cc.Node:create()
		:addTo(self)
		:setPosition(-2,0)

	self.canGet = cc.Sprite:create('image/battlePass/battlepass_bg_13.png')
		:addTo(self.levelNode)

	local levelBg = cc.Sprite:create('image/battlePass/battlepass_bg_15.png')
		:addTo(self.levelNode)
		
	self.level = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
		:addTo(self.levelNode)
		:setTextColor(cc.c3b(255,255,0))
		:enableOutline(cc.c3b(0,0,0),2)
end
function BattlepassEventTemplate:Init(data)

	self.rewardFreeNode:removeAllChildren();
	self.rewardSpecialNode:removeAllChildren();

	self.no = data.no;
	if data.no == 0 then
		local bg = cc.Sprite:create('image/battlePass/battlepass_bg_11.png')
			:addTo(self.rewardSpecialNode)

		local lable = cc.Label:createWithTTF(LANG.UI_BATTLEPASS_1 , fonts.FONT_SIYUAN , 20)
			:addTo(self.rewardSpecialNode)
			:setPosition(0,-12)
			:setTextColor(cc.c3b(255,220,110))
			:enableOutline(cc.c3b(65,45,40),1)

		local bg = cc.Sprite:create('image/battlePass/battlepass_bg_10.png')
			:addTo(self.rewardFreeNode)

		local lable = cc.Label:createWithTTF(LANG.UI_FIGHT_65 , fonts.FONT_SIYUAN , 20)
			:addTo(self.rewardFreeNode)
			:enableOutline(cc.c3b(0,0,0),1)

		self.line:setVisible(true);
		self.line:setContentSize(cc.size(10,173));
		self.levelNode:setVisible(false)
	else
		local canGet = false;
		self.levelNode:setVisible(true)
		if data.level == 1 then
			if not self.firstBg then
				self.firstBg = cc.Sprite:create('image/battlePass/battlepass_bg_9.png')
				:addTo(self.levelNode)
			end
			self.level:setVisible(false);
		else
			self.level:setString(tostring(data.level));
			self.level:setVisible(true);
		end

		if (data.reward_free_state == 1 or (data.reward_free_state == 0 and #data.reward<=0)) 
		  and data.reward_special_state == 1 then
			self.canGet:setVisible(false);
		else
			local specialState = model.BattlepassEventModel:getSpecialState();
			local curPointNum = model.BattlepassEventModel:getCurBattlepassPoint()
			if (data.reward_free_state == 0 or (data.reward_special_state==0 and specialState == 1))
				and curPointNum >= data.total_point then
				self.canGet:setVisible(true);
				canGet = true;
			else
				self.canGet:setVisible(false);
			end
		end

		local curBattlepassNo = model.BattlepassEventModel:getCurBattlepassRewardNo();
		if curBattlepassNo > self.no then
			self.line:setVisible(true);
			self.line:setContentSize(cc.size(10,173));
		elseif curBattlepassNo == self.no then
			self.line:setVisible(true);
			self.line:setContentSize(cc.size(10,86.5));
		else
			self.line:setVisible(false);
		end
		
		if data.reward then
			local num = #data.reward;
			local startPosX = -(103*(num-1))/2
			for _k , reward in pairs(data.reward) do
				local x = startPosX+103*(_k-1);
				local item=template.ItemTemplate:create()
				item:Init(reward[1] , reward[2]);
				item:addTo(self.rewardFreeNode);
				item:setPosition(x,0)
				item:setItemTag(1);
				item:addItemClickEventListener(handler(self , self.rewardClick));
				if data.reward_free_state == 1 then
					local bg = cc.Sprite:create('image/battlePass/battlepass_bg_16.png')
						:addTo(self.rewardFreeNode)
						:setPosition(x,0)
					local bg = cc.Sprite:create('image/battlePass/battlepass_bg_17.png')
						:addTo(self.rewardFreeNode)
						:setPosition(x,0)
				else
					if canGet then
						local bg = cc.Sprite:create('image/commonImg/icon_item_light.png')
						:addTo(self.rewardFreeNode)
						:setPosition(x,0)
					end
				end
			end
		end

		if data.special_reward then
			local num = #data.special_reward;
			local startPosX = -(103*(num-1))/2
			for _k , reward in pairs(data.special_reward) do
				local x = startPosX+103*(_k-1);
				local item=template.ItemTemplate:create()
				item:Init(reward[1] , reward[2]);
				item:addTo(self.rewardSpecialNode);
				item:setPosition(x,0)
				item:setItemTag(2);
				item:addItemClickEventListener(handler(self , self.rewardClick));
				if data.reward_special_state == 1 then
					local bg = cc.Sprite:create('image/battlePass/battlepass_bg_16.png')
						:addTo(self.rewardSpecialNode)
						:setPosition(x,0)
					local bg = cc.Sprite:create('image/battlePass/battlepass_bg_17.png')
						:addTo(self.rewardSpecialNode)
						:setPosition(x,0)
				else
					if canGet then
						local bg = cc.Sprite:create('image/commonImg/icon_item_light.png')
						:addTo(self.rewardSpecialNode)
						:setPosition(x,0)
					end
				end
			end
		end
	end
end

function BattlepassEventTemplate:rewardClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(tag , self.no);
	end
end
function BattlepassEventTemplate:addBattlepassClickEventListener(callback)
	self.callback = callback;
end

return BattlepassEventTemplate;