local BloodVolume = class("BloodVolume")
local fonts = Enum:getTable("SystemFont")
local imgPath = 'image/blood/'

function BloodVolume:ctor(father, vol_type)
	self.root = cc.Node:create();
	self.father = father;
	self.root:addTo(father);

	self.vol_type = vol_type or 1

	if self.vol_type == 1 then
		
		local skillBarBg = cc.Sprite:create(imgPath .. 'nblood_bar_bg.png')
			:addTo(self.root)
			:setPosition(6,6)

		self.skillProgress = cc.ProgressTimer:create(cc.Sprite:create(imgPath .. 'nblood_skill.png'))
			:setPosition(9, 2)
			:setAnchorPoint(cc.p(0.5, 0.5))
			:addTo(self.root)
			:setType(cc.PROGRESS_TIMER_TYPE_BAR)
			:setMidpoint(cc.p(0, 0))
			:setBarChangeRate(cc.p(1, 0))
			:setPercentage(100)
			:setVisible(false)

		self.whiteSpr = cc.Sprite:create(imgPath .. 'nblood_white.png')
			:setPosition(-19, 8)
			:setAnchorPoint(cc.p(0, 0.5))
			:addTo(self.root)

		self.hpGreenProgress = cc.ProgressTimer:create(cc.Sprite:create(imgPath .. 'nblood_green.png'))
			:setPosition(9, 8)
			:setAnchorPoint(cc.p(0.5, 0.5))
			:addTo(self.root)
			:setType(cc.PROGRESS_TIMER_TYPE_BAR)
			:setMidpoint(cc.p(0, 0))
			:setBarChangeRate(cc.p(1, 0))
			:setPercentage(50)

		self.hpRedProgress = cc.ProgressTimer:create(cc.Sprite:create(imgPath .. 'nblood_red.png'))
			:setPosition(9, 8)
			:setAnchorPoint(cc.p(0.5, 0.5))
			:addTo(self.root)
			:setType(cc.PROGRESS_TIMER_TYPE_BAR)
			:setMidpoint(cc.p(0, 0))
			:setBarChangeRate(cc.p(1, 0))

		self.hpBg = cc.Sprite:create(imgPath .. 'nblood_bg.png')
			:addTo(self.root);

		-- self.restraintBg = cc.Sprite:create(imgPath .. 'restraint_bg.png')
		-- 	:setPosition(-25, 0)
		-- 	:addTo(self.root);
	
		self.restraintType = cc.Sprite:create(imgPath .. 'restraint_1.png')
			:setPosition(-27, 0)
			:setScale(0.8)
			:addTo(self.root);

		self.levelLabel = cc.Label:createWithTTF('LV 99', fonts.FONT_JP, 12)
			:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 1)
			:setPosition(4, -6)
			:setVisible(false)
			:addTo(self.root);

		self.maxHp = '1';
		self.curHp = '0';

		-- self.hpBg = cc.Sprite:create(imgPath .. 'blood_bg.png')
		-- 	:addTo(self.root);

		-- self.hpGreenProgress = cc.ProgressTimer:create(cc.Sprite:create(imgPath .. 'blood_green.png'))
		-- 	:setPosition(5, -8)
		-- 	:setAnchorPoint(cc.p(0.5, 0.5))
		-- 	:addTo(self.root)
		-- 	:setType(cc.PROGRESS_TIMER_TYPE_BAR)
		-- 	:setMidpoint(cc.p(0, 0))
		-- 	:setBarChangeRate(cc.p(1, 0))
		-- 	:setPercentage(50)

		-- self.hpRedProgress = cc.ProgressTimer:create(cc.Sprite:create(imgPath .. 'blood_red.png'))
		-- 	:setPosition(5, -8)
		-- 	:setAnchorPoint(cc.p(0.5, 0.5))
		-- 	:addTo(self.root)
		-- 	:setType(cc.PROGRESS_TIMER_TYPE_BAR)
		-- 	:setMidpoint(cc.p(0, 0))
		-- 	:setBarChangeRate(cc.p(1, 0))

		-- self.restraintBg = cc.Sprite:create(imgPath .. 'restraint_bg.png')
		-- 	:setPosition(-25, 0)
		-- 	:addTo(self.root);
	
		-- self.restraintType = cc.Sprite:create(imgPath .. 'restraint_1.png')
		-- 	:setPosition(-25, 0)
		-- 	:setScale(0.5)
		-- 	:addTo(self.root);

		-- self.levelLabel = cc.Label:createWithTTF('LV 99', fonts.FONT_JP, 12)
		-- 	:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2)
		-- 	:setPosition(0, 0)
		-- 	:setVisible(false)
		-- 	:addTo(self.root);

		-- self.maxHp = '1';
		-- self.curHp = '0';

	elseif self.vol_type == 2 then
		self.bg1 = cc.Sprite:create(imgPath .. 'blood_small_bg1.png')
			:addTo(self.root);

		self.bg2 = cc.Sprite:create(imgPath .. 'blood_small_bg2.png')
			:addTo(self.root);

		self.blood = cc.ProgressTimer:create(cc.Sprite:create(imgPath .. 'blood_small_fg.png'))
			:setAnchorPoint(cc.p(0.5, 0.5))
			:addTo(self.root)
			:setType(cc.PROGRESS_TIMER_TYPE_BAR)
			:setMidpoint(cc.p(0, 0))
			:setBarChangeRate(cc.p(1, 0))
			:setPercentage(50)

	elseif self.vol_type == 3 then
		self.bg1 = cc.Sprite:create(imgPath .. 'blood_big_bg1.png')
			:addTo(self.root);

		self.bg2 = cc.Sprite:create(imgPath .. 'blood_big_bg2.png')
			:addTo(self.root);

		self.blood = cc.ProgressTimer:create(cc.Sprite:create(imgPath .. 'blood_big_fg.png'))
			:setAnchorPoint(cc.p(0.5, 0.5))
			:addTo(self.root)
			:setType(cc.PROGRESS_TIMER_TYPE_BAR)
			:setMidpoint(cc.p(0, 0))
			:setBarChangeRate(cc.p(1, 0))
			:setPercentage(50)
	end
end

function BloodVolume:setDefType(d_type)
	if self.vol_type == 1 then
		self.restraintType:setTexture(imgPath .. 'restraint_' .. d_type .. '.png');
	end
end

function BloodVolume:showSkillBar()
	self.skillProgress:setVisible(true)
	self.skillProgress:setPercentage(0)
end

function BloodVolume:setSkillPercent(per)
	if self.skillProgress then
		self.skillProgress:setPercentage(per*100)
	end
end

function BloodVolume:setMaxHp(hp)
	if self.vol_type == 1 then
		self.maxHp = hp;
	end
end

function BloodVolume:setCurHp(hp)
	if self.vol_type == 1 then
		self.curHp = hp;
		local percent = 100;
		if HpCompare(self.curHp, '>', self.maxHp) then
			percent = 100;
		elseif HpCompare(self.curHp, '<=', '0') then
			percent = 0;
		else
			percent = HpDivide(HpMultiply(self.curHp, 100), self.maxHp);
		end

		self:setPercent(percent);
	end
end

function BloodVolume:setPercent(percent)
	if self.vol_type == 1 then
		-- self.hpGreenProgress:setVisible(false);
		-- self.hpRedProgress:setVisible(false);
		-- if percent >= 50 then
		-- 	self.hpGreenProgress:setVisible(true);
		-- 	self.hpGreenProgress:setPercentage(percent);
		-- else
		-- 	self.hpRedProgress:setVisible(true);
		-- 	self.hpRedProgress:setPercentage(percent);
		-- end

		self.hpGreenProgress:setPercentage(percent);
		self.hpGreenProgress:setVisible(true);
		self.hpRedProgress:setVisible(false);
		
	elseif self.vol_type == 2 then
		self.blood:setPercentage(percent)

	elseif self.vol_type == 3 then
		self.blood:setPercentage(percent)
	end

	self:playWhiteSpr(percent)
end

function BloodVolume:playWhiteSpr( percent )
	-- body
	if self.whiteSpr == nil then
		return
	end
	self.whiteSpr:stopAllActions()
	self.whiteSpr:setColor( cc.c3b(255,255,0) )
	local scaleX = percent/100;

	local act = cc.Sequence:create(
		cc.FadeIn:create(0),
		cc.DelayTime:create(0.1),
		cc.TintTo:create(0.2, 255,0,0),
		cc.ScaleTo:create(0.3, scaleX, 1),
		cc.FadeOut:create(0)
	)

	self.whiteSpr:runAction(act)
end

function BloodVolume:setLevel(level)
	if self.vol_type == 1 then
		self.levelLabel:setVisible(true)
		self.levelLabel:setString('     ' .. level)
	end
end

function BloodVolume:setPosition(x, y)
	self.root:setPosition(x, y);
end

function BloodVolume:setScale(scale)
	self.root:setScale(scale);
end

function BloodVolume:removeFromParent()
	self.root:removeFromParent();
end

function BloodVolume:setLocalZOrder(zorder)
	self.root:setLocalZOrder(zorder);
end

function BloodVolume:setVisible(v)
	self.root:setVisible(v);
end

return BloodVolume;
