local CardCommentTemplate = class("CardCommentTemplate" , function()
	return cc.Node:create();
end)

local imagePath = 'image/card/cardComment/'
local fonts = Enum:getTable("SystemFont")

function CardCommentTemplate:ctor()

	self.bg = cc.Sprite:create()
	self.bg:addTo(self)

	self.name = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	self.name:enableOutline(cc.c3b(10, 90, 165), 2)
	self.name:setPosition(-227, 44)
	self.name:addTo(self)
	self.name:setAnchorPoint(0 , 0.5)

	self.likeNode = cc.Node:create();
	self.likeNode:addTo(self);
	self.likeNode:setPosition(48 , 39);

	local bg = cc.Sprite:create(imagePath..'card_comment_bg_11.png');
	bg:addTo(self.likeNode);

	self.liked = cc.Sprite:create(imagePath..'card_comment_bg_17.png');
	self.liked:addTo(self.likeNode);
	self.liked:setPosition(-35 , 0);
	
	self.likeBtn = ccui.Button:create(imagePath..'card_comment_bg_15.png',imagePath..'card_comment_bg_15.png');
	self.likeBtn:addTo(self.likeNode);
	self.likeBtn:setPosition(-35 , 0);
	self.likeBtn:setTag(1);
	self.likeBtn:addClickEventListener(handler(self , self.btnClick));

	self.likeNum = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	self.likeNum:enableOutline(cc.c3b(60, 60, 60), 2)
	self.likeNum:setPosition(15, 0)
	self.likeNum:addTo(self.likeNode)

	self.notLikeNode = cc.Node:create();
	self.notLikeNode:addTo(self);
	self.notLikeNode:setPosition(169 , 39);

	local bg = cc.Sprite:create(imagePath..'card_comment_bg_11.png');
	bg:addTo(self.notLikeNode);

	self.notLiked = cc.Sprite:create(imagePath..'card_comment_bg_18.png');
	self.notLiked:addTo(self.notLikeNode);
	self.notLiked:setPosition(-35 , 0);
	
	self.notLikeBtn = ccui.Button:create(imagePath..'card_comment_bg_16.png',imagePath..'card_comment_bg_16.png');
	self.notLikeBtn:addTo(self.notLikeNode);
	self.notLikeBtn:setPosition(-35 , 0);
	self.notLikeBtn:setTag(2);
	self.notLikeBtn:addClickEventListener(handler(self , self.btnClick));

	self.notLikeNum = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	self.notLikeNum:enableOutline(cc.c3b(60, 60, 60), 2)
	self.notLikeNum:setPosition(15, 0)
	self.notLikeNum:addTo(self.notLikeNode)

	self.comment = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20);
	self.comment:setTextColor(cc.c3b(60, 60, 60));
	self.comment:setPosition(-224, 13);
	self.comment:setMaxLineWidth(453);
	self.comment:setLineHeight(25);
	self.comment:setAnchorPoint(0 , 1);
	self.comment:addTo(self);

	self.hot = cc.Sprite:create(imagePath..'card_comment_bg_7.png');
	self.hot:addTo(self);
	self.hot:setPosition(231,61);
	
end

function CardCommentTemplate:Init(data)

	self.name:setString(tostring(data.name));
	self.comment:setString(tostring(data.comment));
	self.likeNum:setString(tostring(data.like));
	self.notLikeNum:setString(tostring(data.notLike));

	if data.uid == model.UserModel:getUserUid() then
		self.bg:setTexture(imagePath..'card_comment_bg_6.png');
		self.name:enableOutline(cc.c3b(10, 90, 165), 2)
	else
		self.bg:setTexture(imagePath..'card_comment_bg_5.png');
		self.name:enableOutline(cc.c3b(192, 120, 0), 2)
	end

	local likeState = model.CardCommentModel:getCommentLikeState(data.no,data.cid);
	if likeState == 1 then
		self.likeBtn:setVisible(false);
		self.liked:setVisible(true);
		self.notLikeBtn:setVisible(false);
		self.notLiked:setVisible(true)
	else 
		self.likeBtn:setVisible(true);
		self.liked:setVisible(false);
		self.notLikeBtn:setVisible(true);
		self.notLiked:setVisible(false)
	end

	self.hot:setVisible(data.like > 0);
	self.cid = data.cid;
	self.no = data.no;
end

function CardCommentTemplate:btnClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(tag , self.no , self.cid);
	end
end

function CardCommentTemplate:addLikeClickEventListener(callback)
	self.callback = callback;
end

function CardCommentTemplate:getCid()
	return self.cid;
end

return CardCommentTemplate;
