local CardGachaTemplate = class("CardGachaTemplate" , function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")
local imgPath = 'image/chouka/result/'
local PlaySpeState = false
local PlayShowBig = false
local cvTypeEnum = Enum:getTable("cvTypeEnum");
local cvSoundId = -1;

function CardGachaTemplate:ctor(father, idx)
	self.idx = idx;
	self.isGoldCard = false
	self.effSpName = 'touch1'
	self:addTo(father);
	self:setCascadeOpacityEnabled(true);

	self.particle3 = cc.ParticleSystemQuad:create("Effect/particle/gacha4.plist")
	self.particle3:addTo(self);
	self.particle3:setVisible(false)

	self.particleNode = cc.Node:create()
	self.particleNode:addTo(self)
	self.particleNode:setVisible(false)

	local particle1 = cc.ParticleSystemQuad:create("Effect/particle/gacha1.plist")
	particle1:addTo(self.particleNode);

	self.mainNode = cc.Node:create()
	self.mainNode:addTo(self)

	self.roleNode = cc.Node:create()
	self.roleNode:addTo(self.mainNode)

	self.clickQualityBg = ccui.ImageView:create();
	self.clickQualityBg:addTo(self.roleNode);
	self.clickQualityBg:setTouchEnabled(true);

	self.roleM = cc.Sprite:create();
	self.roleM:setScale(2);
	self.roleM:addTo(self.roleNode);

	local roleShadow = cc.Sprite:create(imgPath..'gRole_shadow.png')
	:addTo(self.roleNode)
	:setOpacity(200)
	--[[
	self.enName = cc.Label:createWithTTF('SEREN', 'font/NanumBrushScript-Regular.ttf', 200);
	self.enName:setTextColor(cc.c3b(255, 255, 255));
	self.enName:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
	self.enName:setPosition(0, -250);
	self.enName:addTo(self.roleNode);
	self.enName:setDimensions(400, 210)
	self.enName:setOverflow(cc.LabelOverflow.SHRINK)
	self.enName:setVisible(false)
	]]
	self.iconImage = cc.Sprite:create();
	self.iconImage:addTo(self.roleNode);
	self.iconImage:setPosition(0 , 0);
	self.iconImage:setScale(0.6)

	self.roldMsgBg = cc.Sprite:create(imgPath..'gRoleMsg_bg3.png');
	self.roldMsgBg:addTo(self.roleNode);
	self.roldMsgBg:setPosition(0, -350);

	self.quSpBg2 = cc.Sprite:create(imgPath .. 'gBg2_3.png');
	self.quSpBg2:setPosition(0, 0);
	self.quSpBg2:addTo(self.roleNode);

	self.labelMsg = cc.Label:createWithTTF('', fonts.FONT_CV, 18);
	self.labelMsg:setTextColor(cc.c3b(255, 255, 255));
	self.labelMsg:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
	self.labelMsg:setPosition(0, -350);
	self.labelMsg:setDimensions(400, 0)
	self.labelMsg:addTo(self.roleNode);

	local quNode = cc.Node:create();
	quNode:setPosition(0, 350);
	quNode:addTo(self.roleNode);

	self.star = cc.Node:create();
	self.star:addTo(quNode);

	self.name = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 28);
	self.name:setPosition(0 , 300);
	self.name:addTo(self.roleNode);

	self.labelNameSpr = cc.Sprite:create()
	:addTo(self.roleNode)
	:setPosition(0, 300)
	
	self.role_id = 0

	self:initSpineNode();

	self.mainNode:setScale(0.3)

	local btn = ccui.Button:create('image/card/card_head_icon_bg_3.png');
	btn:addTo(self.mainNode);
	btn:setAlphaTouchEnable(true);
	-- btn:setContentSize(cc.size(140, 250))
	btn:setContentSize(cc.size(466, 833))
	btn:setScale9Enabled(true)
	btn:setOpacity(0);
	btn:addClickEventListener(handler(self, self.btnClick));

	self.clickParticle = cc.ParticleSystemQuad:create("Effect/particle/gacha3.plist")
	self.clickParticle:addTo(self);
	self.clickParticle:stopSystem();

	self.click2Particle = cc.ParticleSystemQuad:create("Effect/particle/gacha6.plist")
	self.click2Particle:addTo(self);
	self.click2Particle:stopSystem();

	self.oriX = 0;
	self.oriY = 0;
	self.quality = 3
	self.speed = 1
	self.isSkip = false;
end

function CardGachaTemplate:savePos()
	self.oriX, self.oriY = self:getPosition()
end

function CardGachaTemplate:initSpineNode()
	local spine_res = 'gacha_spine'
	self.gachaSpine = nil
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.gachaSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.gachaSpine:addTo(self.mainNode)

		self.gachaSpine:registerSpineEventHandler(function (event)
			if event.animation == 'card1' or event.animation == 'card2' or event.animation == 'card3' then
				if event.animation == 'card3' then
					self.particleNode:setVisible(true)
					self.particle3:setVisible(true)
					self.particleNode:setLocalZOrder(10)
				end
			end
			if event.animation == 'touch1' or event.animation == 'touch2' or event.animation == 'touch3' then
				-- 动画最后结束
				if event.animation == 'touch1' or event.animation == 'touch2' then
					EventManager:FireEvent(EventType.UIGachaOpen, self.isGoldCard);
				end
			end
			
		end, sp.EventType.ANIMATION_COMPLETE)

		self.gachaSpine:registerSpineEventHandler(function (event)
			if event.eventData.name == 'appear' then
				self.roleNode:setVisible(true)
				self.roleNode:setScaleX(0)
				self.roleNode:runAction( cc.ScaleTo:create(0.3, 1, 1) )

				self.clickParticle:stopSystem();

				if self.isGoldCard then
					self.particleNode:setVisible(true)
					self.particle3:setVisible(true)
					self.particleNode:setLocalZOrder(-1)
				end

			elseif event.eventData.name == 'shake' then
				if self.isGoldCard then
					EventManager:FireEvent('GachaResultPanel:shakeRoot')
				end
			end
			
		end, sp.EventType.ANIMATION_EVENT)
		
	end
end

function CardGachaTemplate:btnClick()
	if cvSoundId ~=nil and cvSoundId ~= -1 then
		AudioManager:stopEffect(cvSoundId)
		cvSoundId = -1
	end
	if self.clickType ==2 then
		if PlayShowBig then
			return
		end

		if self.isSkip ~= true then --and PlaySpeState ~= true
			cvSoundId =	AudioManager:playCVStopBefor(self.role_id ,nil,cvTypeEnum.CV_GACHA );
		else
			if self.isGoldCard then
				cvSoundId =	AudioManager:playCVStopBefor(self.role_id ,nil,cvTypeEnum.CV_GACHA );
			end
		end

		self.clickParticle:resetSystem();
		if self.isGoldCard then
			self:playSpcialeAni();
		else
			if self.quality == 4 then
				self.click2Particle:resetSystem();
			end
			self:runCardAction();
		end
	elseif self.clickType == 3 then
		if self.isGoldCard and PlaySpeState==false then
			if PlayShowBig == false or (PlayShowBig==true and self.isBig) then
				self:showBigState();
			end
		end
	end
end

function CardGachaTemplate:InitByNo(no)
	self.isSkip = false;
	self.clickType = 0
	self.speed = 1
	self.mainNode:setPosition(0,0)
	self.mainNode:setScale(0.3)
	PlaySpeState = false
	PlayShowBig = false
	self.isBig = false
	self:setLocalZOrder(self.idx)
	self.gachaSpine:setVisible(false)
	self.roleNode:setVisible(false)
	self:setData(no);
end

function CardGachaTemplate:setData(no)

	local role_data = ResTable:getRowData('role', no);
	if not role_data then
		return;
	end
	if self.role_id == no then
		return
	end
	self.role_id = no
	local role_re = ResTable:getRowData('role_resource', role_data.role_id);
	local role_pre = ResTable:getRowData('role_pre' , role_data.role_id);
	local role_info = ResTable:getRowData('role_info', role_data.role_id);
	local qu = role_data['quality'];
	self.quality = qu

	self.roleM:setTexture('image/role/'..role_re['card']..'.png');
	local roleSize = self.roleM:getContentSize();
	local w = 223
	local h = 380
	local offx = role_re['navi_show'][1]
	local offy = role_re['navi_show'][2]
	self.roleM:setTextureRect(cc.rect( roleSize.width/2+offx-50, roleSize.height/2-offy-106 , w , h));
	--GlobalFunctions:setSpriteGrey(self.roleM, 1,0,0)
	self.roleM:setOpacity(80)

	self.iconImage:setTexture('image/role/'..role_re['card']..'.png');
	local roleSize = self.iconImage:getContentSize();
	self.iconImage:setTextureRect(cc.rect( (roleSize.width-760)/2, (roleSize.height-1330)/2 , 760 , 1330));

	
	if GlobalFunctions:isKorean() then
		self.name:setVisible(false)
		self.labelNameSpr:setTexture('image/name/'..role_re['role_name']..'.png');
		self.labelNameSpr:setVisible(true)
	else
		self.labelNameSpr:setVisible(false)
		self.name:setString('['..tostring(role_info['name'])..']');
		self.name:setVisible(true)
	end
	--self.enName:setString(tostring(role_info['name_en']));
	local cvInfo = model.UserModel:getRoleCvInfo(role_data.resource_id,cvTypeEnum.CV_GACHA);
	self.labelMsg:setString( tostring(cvInfo) )
	local starName = 'gStar_3.png'
	if qu >=5 then
		self.name:enableOutline(cc.c3b(230,110,120),2);
		self.labelMsg:setTextColor(cc.c3b(235,100,110))
		--self.enName:setTextColor(cc.c3b(250,130,130))
		starName = 'gStar_5.png'
		self.effSpName = 'touch3'
	elseif qu == 4 then
		self.name:enableOutline(cc.c3b(25,140,180),2);
		self.labelMsg:setTextColor(cc.c3b(50,160,200))
		--self.enName:setTextColor(cc.c3b(130,140,250))
		starName = 'gStar_4.png'
		self.effSpName = 'touch2'
	else
		self.name:enableOutline(cc.c3b(150,150,130),2);
		self.labelMsg:setTextColor(cc.c3b(115,115,105))
		--self.enName:setTextColor(cc.c3b(135,135,135))
		starName = 'gStar_3.png'
		self.effSpName = 'touch1'
	end

	self.isGoldCard = false
	if qu >=5 then
		self.isGoldCard = true
	end

	self.particleNode:setVisible(false)
	self.particle3:setVisible(false)

	self.clickQualityBg:loadTexture(imgPath..'gBg1_'..qu..'.png');
	self.clickQualityBg:setTouchEnabled(true);
	self.clickQualityBg:setSwallowTouches(false);
	self.quSpBg2:setTexture(imgPath..'gBg2_'..qu..'.png');
	self.quSpBg2:setTexture(imgPath..'gBg2_'..qu..'.png');

	self.roldMsgBg:setTexture(imgPath..'gRoleMsg_bg'..qu..'.png');

	local starLv = role_pre['rank'];
	self.star:removeAllChildren()
	local col = (starLv - 1) % 5 + 1
	local row = math.floor((starLv - 1) / 5);
	local lastStarX = 0
	for j=1,5 do
		local row1 = row;
		if col < j then
			row1 = row -1 
		end
		if row1 >= 0 then 
			local sp = cc.Sprite:create(imgPath..starName)
			sp:addTo(self.star);
			sp:setPosition(cc.p(25*(j-1),0));
			lastStarX = 25*(j-1);
		end 
	end
	self.star:setPositionX(-lastStarX/2)

	self.isBig = false

end

function CardGachaTemplate:isGold()
	return self.isGoldCard
end

function CardGachaTemplate:runCardAction()
	if self:isVisible() == false then
		return
	end
	if PlaySpeState == true then
		return
	end
	if self.isGoldCard then
		PlaySpeState = true
	end
	self.clickType = 3
	self:stopAllActions()
	self.gachaSpine:setAnimation(0, self.effSpName, false)
	self.gachaSpine:setTimeScale(self.speed)
	AudioManager:playEffect(Conf.gachaTouch);

end

function CardGachaTemplate:initAni( i )
	if self:isVisible() == false then
		return
	end
	self.clickType = 1
	self.particleNode:setVisible(false)
	self.particle3:setVisible(false)

	self.roleNode:setVisible(false)
	local seq = cc.Sequence:create(
		cc.DelayTime:create(0.1*i),
		cc.CallFunc:create(function() 
			if self.gachaSpine then
				self.spPlayTouch = false
				self.gachaSpine:setVisible(true)
				if self.quality==5 then
					self.gachaSpine:setAnimation(0, "card3", false)

				elseif self.quality==4 then
					self.gachaSpine:setAnimation(0, "card2", false)

				else
					self.gachaSpine:setAnimation(0, "card1", false)
				end
				-- AudioManager:playEffect(Conf.gachaFly);
			end
			self:setPosition(0, -StageSize.width/2-100)
			self:runAction( cc.MoveTo:create(0.3, cc.p(self.oriX, self.oriY)) )
		end),
		cc.DelayTime:create(0.3),
		cc.CallFunc:create(function() 
			self.clickType = 2
		end)
	)
	self:runAction(seq)
	
end

function CardGachaTemplate:skipAni()
	self.isSkip = true;
	if self.clickType ~= 3 then
		-- self.cardPick:stopAllActions()
		-- self.cardPick:setScale(1)
		-- self.cardPick:setOpacity(255)
		-- self.roleNode:setVisible(true)
		-- self:runCardAction()

		self.speed = 1
		self:btnClick();
	end
end

function CardGachaTemplate:playSpcialeAni()
	if PlaySpeState == true then
		return
	end
	self.clickType = 3
	if self.isGoldCard then
		PlaySpeState = true
	end
	self.particleNode:setVisible(false)
	self.particle3:setVisible(false)
	self.clickParticle:stopSystem();

	AudioManager:playEffect(Conf.gachaTouch3);

	self:playSpcialeAni2()
	
end

function CardGachaTemplate:playSpcialeAni2()
	local endPos = self:convertToNodeSpace( cc.p( StageSize.width/2, StageSize.height/2 ) )
	local seq = cc.Sequence:create(
		cc.Spawn:create(
			cc.MoveTo:create(0.3/self.speed, endPos),
			cc.ScaleTo:create(0.3/self.speed, 1)
		),
		cc.DelayTime:create(0.2/self.speed),
		cc.CallFunc:create(function() 
			self.gachaSpine:setAnimation(0, self.effSpName, false)
			self.gachaSpine:setTimeScale(self.speed)

			if self.isGoldCard then
				self.particleNode:setVisible(true)
				self.particle3:setVisible(true)
				self.particleNode:setLocalZOrder(-1)
			end
			
		end),
		cc.DelayTime:create(4/self.speed),
		cc.CallFunc:create(function() 
			self:playEndSpcialeAni()
		end)
		
	)
	GlobalFunctions:setSpriteGrey(self.roleM, 1,0,0)
	self.mainNode:runAction( seq )
	self:setLocalZOrder(99)
end

function CardGachaTemplate:playEndSpcialeAni()
	self.roleNode:setVisible(true)
	self.roleNode:setScale(1)
	local seq = cc.Sequence:create(
		cc.Spawn:create(
			cc.MoveTo:create(0.3/self.speed, cc.p(0,0)),
			cc.ScaleTo:create(0.3/self.speed, 0.3)
		),
		cc.CallFunc:create(function() 
			self:setLocalZOrder(self.idx)
			PlaySpeState = false
			EventManager:FireEvent(EventType.UIGachaOpen, self.isGoldCard);
		end)
	)

	self.mainNode:runAction( seq )
	
end

function CardGachaTemplate:directShow()
	if self:isVisible() == false then
		return
	end

	self.clickParticle:resetSystem();
	if self.quality == 4 then
		self.click2Particle:resetSystem();
	end
	self.gachaSpine:setVisible(true)
	self.gachaSpine:setAnimation(0, self.effSpName, false)
	self.clickType = 3;
end

function CardGachaTemplate:isCanPlay()
	return self.clickType == 2
end

function CardGachaTemplate:getPlayState()
	return PlaySpeState
end

function CardGachaTemplate:showBigState()
	-- body
	if self.isBig == false then
		cvSoundId =	AudioManager:playCVStopBefor(self.role_id ,nil,cvTypeEnum.CV_GACHA );
		if self.isGoldCard then
			PlaySpeState = true
		end
		PlayShowBig = true
		self.isBig = true
		local endPos = self:convertToNodeSpace( cc.p( StageSize.width/2, StageSize.height/2 ) )
		local seq = cc.Sequence:create(
			cc.Spawn:create(
				cc.MoveTo:create(0.3, endPos),
				cc.ScaleTo:create(0.3, 1)
			),
			cc.CallFunc:create(function() 
				PlaySpeState = false
			end)
		)
		GlobalFunctions:setSpriteGrey(self.roleM, 1,0,0)
		self.mainNode:runAction( seq )
		self:setLocalZOrder(99)
	else
		if self.isGoldCard then
			PlaySpeState = true
		end
		local seq = cc.Sequence:create(
			cc.Spawn:create(
				cc.MoveTo:create(0.3, cc.p(0,0)),
				cc.ScaleTo:create(0.3, 0.3)
			),
			cc.CallFunc:create(function() 
				self:setLocalZOrder(self.idx)
				PlaySpeState = false
				PlayShowBig = false
				self.isBig = false
			end)
		)

		self.mainNode:runAction( seq )
	end
end

return CardGachaTemplate;
