local CardHeadSkinTemplate = class("CardHeadSkinTemplate")
local fonts = Enum:getTable("SystemFont")
function CardHeadSkinTemplate:ctor(father)
	self.root = cc.Node:create();
	self.father = father;

	self.father:addChild(self.root);

	self.root:setCascadeOpacityEnabled(true);

	-- bg
	self.qualityBg = cc.Sprite:create('image/equipFrame/quality1BG.png');
    self.qualityBg:addTo(self.root)

	-- card image
	self.roleImage = cc.Sprite:create('image/icon/R001_Icon.png');
	self.root:addChild(self.roleImage);

	self.currentEquipNode = cc.Node:create();
	self.currentEquipNode:setPosition(-31, 39);
	self.currentEquipNode:addTo(self.root);

	self.equipBg = cc.Sprite:create('image/card/card_iconlevelbg.png');
	self.equipBg:setPosition(0, 0);
	self.equipBg:addTo(self.currentEquipNode);

	self.equipLabel = cc.Label:createWithTTF('E', fonts.FONT_HUAKANG, 24);
	self.equipLabel:setPosition(-3, 0);
	self.equipLabel:setTextColor(cc.c4b(63 , 255 , 142 , 255));
	self.equipLabel:addTo(self.currentEquipNode);

	self.blackChoose = cc.Scale9Sprite:create('image/card/card_select.png');
	self.blackChoose:setCapInsets(CCRectMake(70,70,30,30));
    self.blackChoose:setContentSize(cc.size(135, 135))
	self.blackChoose:setVisible(false);
	self.root:addChild(self.blackChoose);

	self.nameBg = cc.Sprite:create('image/card/139.png');
	self.nameBg:setPosition(0, -40);
	self.nameBg:addTo(self.root);

	self.nameLabel = cc.Label:createWithTTF('', fonts.FONT_HUAKANG, 18);
	self.nameLabel:setPosition(0, -40);
	self.nameLabel:addTo(self.root);
	
	self.notGet = cc.Sprite:create('image/card/138.png');
	self.notGet:addTo(self.root);

	-- layout
	self.layout = ccui.Layout:create();
	self.layout:setContentSize(104, 137);
	self.layout:ignoreAnchorPointForPosition(false);
	self.layout:setAnchorPoint(cc.p(0.5, 0.5));
	self.layout:setTouchEnabled(true);
	self.layout:setSwallowTouches(false);
	self.layout:addTouchEventListener(handler(self, self.beClicked));
	self.layout:addTo(self.root);
end

function CardHeadSkinTemplate:Init(pid, isEquip)
	self.pid = pid or -1;

	self.notGet:setVisible(false);
	local data = model.CardModel:GetCard(pid);
	if not data then
		return;
	end

	self.currentEquipNode:setVisible(isEquip);

	local resid = model.CardModel:getCardResIdByPid(self.pid);;

	local imagePath = ResTable:getValue('role_resource', resid, 'icon');
	self.roleImage:setTexture('image/icon/'..imagePath..'.png');

	self.nameLabel:setString(tostring(ResTable:getValue('role', resid, 'name')));
end

function CardHeadSkinTemplate:InitWithResid(resid)
	self.root:setOpacity(128);
	self.currentEquipNode:setVisible(false);
	self.notGet:setVisible(true);

	local imagePath = ResTable:getValue('role_resource', resid, 'icon');
	self.roleImage:setTexture('image/icon/'..imagePath..'.png');

	self.nameLabel:setString(tostring(ResTable:getValue('role', resid, 'name')));
end

function CardHeadSkinTemplate:setEquip(flag)
	self.currentEquipNode:setVisible(flag);
end

function CardHeadSkinTemplate:setPosition(x, y)
	self.root:setPosition(x, y);
end

function CardHeadSkinTemplate:setScale(scale)
	self.root:setScale(scale);
end

function CardHeadSkinTemplate:addClickFun(callback)
	self.callback = callback;
end
function CardHeadSkinTemplate:setSelect(visible)
	self.blackChoose:setVisible(visible)
end
function CardHeadSkinTemplate:beClicked(sender, eventType)
	if eventType == ccui.TouchEventType.ended then
		local moveEnd = sender:getTouchEndPosition();
		local moveBegin = sender:getTouchBeganPosition();

		if math.abs(moveEnd.x - moveBegin.x) > 30 or
			math.abs(moveEnd.y - moveBegin.y) > 30 then 
			return;
		end
		if self.callback then
			self.callback(self.pid);
		end
	end
end

return CardHeadSkinTemplate;
