local CardHeadTemplate = class("CardHeadTemplate")

function CardHeadTemplate:ctor(father)
	self.root = cc.Node:create();
	self.father = father;

	self.father:addChild(self.root);

	self.bg = cc.Sprite:create('image/card/card_head_icon_bg_3.png');
	self.bg:addTo(self.root);

	self.bg = cc.Sprite:create('image/equipFrame/quality1BG.png');
	self.root:addChild(self.bg);
	self.bg:setCascadeOpacityEnabled(true);
	self.bg:setPosition(0 , 17);

	self.icon = cc.Sprite:create();
	self.icon:setCascadeOpacityEnabled(true);
	self.icon:addTo(self.root);
	self.icon:setPosition(0 , 17);

	self.teamState = cc.Sprite:create('image/card/card_level_up_bg_3.png');
	self.teamState:addTo(self.root);
	self.teamState:setPosition(-1 , 11);

	self.qualityBg = cc.Sprite:create('image/card/card_head_icon_bg_1.png');
	self.qualityBg:addTo(self.root);
	self.qualityBg:setPosition(-28 , 70);

	self.quality = cc.Sprite:create();
	self.quality:addTo(self.root);
	self.quality:setPosition(-35 , 70);
	self.quality:setScale(0.8);

	self.defTypeBg = cc.Sprite:create('image/card/card_head_icon_bg_2.png');
	self.defTypeBg:addTo(self.root);
	self.defTypeBg:setPosition(-44 , -55);

	self.defType = cc.Sprite:create();
	self.defType:addTo(self.root);
	self.defType:setPosition(-44 , -55);
	self.defType:setScale(0.7);

	self.starList = {};
	for i = 1 , 5 do
		self.starList[i] = cc.Sprite:create();
		self.starList[i]:addTo(self.root);
		self.starList[i]:setPosition(-5 + 12 * (i - 1) , -55);
	end
end

function CardHeadTemplate:Init(pid , state)
	self.pid = pid or -1;
	local data = model.CardModel:GetCard(pid);
	if not data then
		return;
	end

	local roleData = ResTable:getRowData('role' , data.no);
	if not roleData then
		return;
	end
	local resId = model.CardModel:getCardResIdByPid(pid);
	local imagePath = ResTable:getValue('role_resource', resId , 'icon');
	if not imagePath then
		return;
	end

	local rolePreData = ResTable:getRowData('role_pre', roleData.role_id);
	
	self.bg:setTexture('image/card/card_quality_little_'..roleData.quality..'.png');
	self.icon:setTexture('image/icon/'..imagePath..'.png');

	self.quality:setTexture('image/card/card_quality_'..roleData.quality..'.png');
	self.defType:setTexture('image/common/restraint_'..rolePreData.def_type..'.png');

	self:updateStarNum(data.star_lv);

	if state then
		local inTeam = model.TeamModel:isRoleInTeam(pid);
		self.teamState:setVisible(inTeam);
	end
end

function CardHeadTemplate:updateStarNum(starLv)

	if not starLv then
		return;
	end

	local color = math.ceil(starLv / 5);
	local num = starLv % 5;
	num = num == 0 and 5 or num;

	for i = 1 , 5 do
		if i <= num then
			self.starList[i]:setVisible(true);
			self.starList[i]:setTexture('image/card/card_star_'..color..'.png');
		else
			self.starList[i]:setVisible(false);
		end
	end
end

function CardHeadTemplate:setPosition(x, y)
	self.root:setPosition(x, y);
end

function CardHeadTemplate:setScale(scale)
	self.root:setScale(scale);
end

function CardHeadTemplate:runAction(action)
	self.root:runAction(action)
end

return CardHeadTemplate;
