local CardMidHeadSkinTemplate = class("CardMidHeadSkinTemplate")
local fonts = Enum:getTable("SystemFont")
function CardMidHeadSkinTemplate:ctor(father)
	self.root = cc.Node:create();
	self.father = father;

	self.father:addChild(self.root);

	-- bg
	self.bg = cc.Sprite:create('image/card/card_quality_bg2.png');
	self.bg:setPosition(cc.p(0 , 0));
    self.bg:addTo(self.root)

	-- card image
	self.roleImage = cc.Sprite:create('image/iconL/R001_IconL.png');
	self.roleImage:setPosition(0, 11);
	self.roleImage:setTextureRect(LRect);
	self.root:addChild(self.roleImage);

	self.roleFrontImage = cc.Sprite:create('image/card/150.png');
	self.roleFrontImage:setPosition(0, 11);
	self.root:addChild(self.roleFrontImage);

	self.notGet = cc.Sprite:create('image/card/card_skin_bg_4.png');
	self.notGet:setPosition(0, 11);
	self.root:addChild(self.notGet);

	self.used = cc.Sprite:create('image/card/card_skin_bg_3.png');
	self.used:setPosition(0, 11);
	self.root:addChild(self.used);

	-- card name
	self.nameLabel = cc.Label:createWithTTF("", fonts.FONT_HUAKANG, 14);
	self.nameLabel:setPosition(0, -122)
	self.nameLabel:setTextColor(cc.c4b(50 ,  50 , 50 , 255));
	self.root:addChild(self.nameLabel)

	self.blackChoose = ccui.Scale9Sprite:create('image/card/card_select.png');
	self.blackChoose:setCapInsets(CCRectMake(70,70,30,30));
	self.blackChoose:setContentSize(cc.size(142 , 300));
    self.blackChoose:setPosition(0 , 0)
	self.blackChoose:setVisible(false);
	self.root:addChild(self.blackChoose);
	
	-- layout
	self.layout = ccui.Layout:create();
	self.layout:setContentSize(110, 300);
	self.layout:ignoreAnchorPointForPosition(false);
	self.layout:setAnchorPoint(cc.p(0.5, 0.5));
	self.layout:setTouchEnabled(true);
	self.layout:setSwallowTouches(false);
	self.layout:addTouchEventListener(handler(self, self.beClicked));
	self.layout:addTo(self.root);
end

function CardMidHeadSkinTemplate:Init(pid, isEquip)
	self.pid = pid or -1;

	self.notGet:setVisible(false);
	local data = model.CardModel:GetCard(pid);
	if not data then
		return;
	end

	self.used:setVisible(isEquip);

	local resid = data.no;
	local roleData = ResTable:getRowData('role', resid);
	local resId = model.CardModel:getCardResIdByPid(self.pid);
	local imagePath = ResTable:getValue('role_resource', resId, 'iconlarge');

	self.bg:setTexture('image/card/card_quality_skin_bg'..roleData.quality..'.png');
	self.roleImage:setTexture('image/iconL/'..imagePath..'.png');
	self.roleImage:setTextureRect(LRect);

	self.nameLabel:setString(tostring(roleData.name));
end
function CardMidHeadSkinTemplate:InitWithResid(resid)
	self.root:setOpacity(128);
	self.used:setVisible(false);
	self.notGet:setVisible(true);

	local roleData = ResTable:getRowData('role', resid);

	self.bg:setTexture('image/card/card_quality_skin_bg'..roleData.quality..'.png');

	local imagePath = ResTable:getValue('role_resource', resid, 'iconlarge');
	self.roleImage:setTexture('image/iconL/'..imagePath..'.png');
	self.roleImage:setTextureRect(LRect);
	self.nameLabel:setString(tostring(roleData.name));
end
function CardMidHeadSkinTemplate:setPosition(x , y)
	self.root:setPosition(x , y);
end
function CardMidHeadSkinTemplate:setEquip(flag)
	self.used:setVisible(flag);
end
function CardMidHeadSkinTemplate:addClickFun(callback)
	self.callback = callback;
end
function CardMidHeadSkinTemplate:setSelect(visible)
	self.blackChoose:setVisible(visible)
end
function CardMidHeadSkinTemplate:beClicked(sender, eventType)
	if eventType == ccui.TouchEventType.ended then
		local moveEnd = sender:getTouchEndPosition();
		local moveBegin = sender:getTouchBeganPosition();

		if math.abs(moveEnd.x - moveBegin.x) > 30 or
			math.abs(moveEnd.y - moveBegin.y) > 30 then 
			return;
		end
		if self.callback then
			self.callback(self.pid);
		end
	end
end

return CardMidHeadSkinTemplate;
