local CardSkillTemplate     =   class("CardSkillTemplate")

function CardSkillTemplate:ctor(father)
	self.root = cc.Node:create();
	self.father = father;

	self.father:addChild(self.root);

	self.icon = cc.Sprite:create();
	self.icon:addTo(self.root);

	self.lvBg = cc.Sprite:create('image/skill/skill_lv.png');
	self.lvBg:setPosition(14 , -27);
	--self.lvBg:addTo(self.root);

	self.lvLabel = cc.Label:createWithTTF("0", Enum:getTable('SystemFont').FONT_IMPACT, 22);
	self.lvLabel:setTextColor(cc.c4b(77 , 77 , 77 , 255));
	self.lvLabel:setPosition(21, 12);
	--self.lvLabel:addTo(self.lvBg);

	self.skillType = cc.Sprite:create();
	self.skillType:addTo(self.root);
	self.skillType:setPosition(0 , 30);

	self.lockBg = cc.Sprite:create('image/skill/skill_activation.png');
	--self.lockBg:addTo(self.root);
	
	self.layout = ccui.Layout:create();
	self.layout:setContentSize(115, 115);
	self.layout:ignoreAnchorPointForPosition(false);
	self.layout:setAnchorPoint(cc.p(0.5, 0.5));
	self.layout:setTouchEnabled(true);
	--self.layout:setSwallowTouches(false);
	self.layout:addClickEventListener(handler(self, self.beClicked));
	self.layout:addTo(self.root);
end

function CardSkillTemplate:Init(skill)
	local skillBaseData = nil;
	if skill then
		skillBaseData = ResTable:getRowData('skill', skill.resid);
	end

	if skill and skillBaseData then
		self.data = skill;

		--self.lockBg:setVisible(self.data.sid == -1);
		--self.lvBg:setVisible(self.data.sid ~= -1);
		self.icon:setVisible(true);
		--self.lvLabel:setVisible(true);

		self.icon:setTexture('image/skillicon/' .. skillBaseData['icon'] .. '.png');
		--self.lvLabel:setString(tostring(self.data.level > 0 and self.data.level or ''));
		self.layout:setVisible(true);
	else
		--self.lockBg:setVisible(false);
		self.icon:setVisible(false);
		--self.lvBg:setVisible(false);
		--self.lvLabel:setVisible(false);
		self.layout:setVisible(false);
	end
end

function CardSkillTemplate:setClickFun(callback)
	self.callback = callback;
end

function CardSkillTemplate:beClicked()
	if self.callback then
		self.callback(self.data);
	end
end

function CardSkillTemplate:setPosition(x, y)
	self.root:setPosition(x, y);
end
function CardSkillTemplate:setRotation(rotation)
	self.root:setRotation(rotation);
end

function CardSkillTemplate:runAction(action)
	self.icon:runAction(action);
end

function CardSkillTemplate:setOpacity(opacity)
	self.icon:setOpacity(opacity);
end

function CardSkillTemplate:setScale(scale)
	self.icon:setScale(scale);
end
return CardSkillTemplate;
