local CardSticTemplate = class("CardSticTemplate")
local imagePath = 'image/fight/result/';
local fonts = Enum:getTable("SystemFont")

local btnDotPos = {
	[1] = cc.p(0 , -150),
	[2] = cc.p(0 , -263),
	[3] = cc.p(0 , -376)

}

function CardSticTemplate:ctor(father)
	self.root = cc.Node:create();
	self.father = father;

	self.father:addChild(self.root);

	self.bg = cc.Scale9Sprite:create(imagePath..'statistics_bg_1.png');
	self.bg:addTo(self.root);
	self.bg:setAnchorPoint(0.5,1);
    self.bg:setCapInsets(cc.rect(25,25,74,150));

	self.nofighterNode = cc.Node:create()
	:addTo(self.root)

	local noBg1 = cc.Sprite:create(imagePath..'statistics_bg_3.png')
	:addTo(self.nofighterNode)
	:setPosition(0,-43)

	local noBg2 = cc.Sprite:create(imagePath..'statistics_bg_5.png')
	:addTo(self.nofighterNode)
	:setPosition(0,-83.5)

	local empty = cc.Label:createWithTTF('EMPTY' , fonts.FONT_SIYUAN , 20)
	:addTo(self.nofighterNode)
	:setPosition(0,-137)

	self.fighterNode = cc.Node:create()
	:addTo(self.root)

	self.headNode = template.ItemTemplate:create(2);
	self.headNode:addTo(self.fighterNode);
	self.headNode:setPosition(0,-43);
	self.headNode:setScale(0.6);

	self.skillNodeList = {}
	self.skillLabelList = {}
	for i=1,3 do
		local skillNode = cc.Node:create()
		:addTo(self.fighterNode)
		:setPosition(btnDotPos[i])
		self.skillNodeList[i] = skillNode;
		self.skillLabelList[i] = {}

		if true then
			local bg = cc.Sprite:create(imagePath..'statistics_bg_2.png')
			:addTo(skillNode)

			local ibg = cc.Sprite:create(imagePath..'statistics_bg_5.png')
			:addTo(skillNode)
			:setPosition(0, 66.5)

			local tagName = 'statistics_z_0.png'
			local tagMsg = LANG.UI_CARD_STIC_2 --普攻
			if i==1 then
				tagName = 'statistics_z_2.png'
				tagMsg = LANG.UI_CARD_STIC_1--'主动技能'
			elseif i==2 then
				tagName = 'statistics_z_4.png'
				tagMsg = LANG.UI_CARD_STIC_3--'觉醒技能'
			end

			local iTag = cc.Sprite:create(imagePath..tagName)
			:addTo(skillNode)
			:setPosition(34, 52)

			local sNameLabel = cc.Label:createWithTTF('火炮', fonts.FONT_SIYUAN, 14)
			:setPosition(-55, 52)
			:addTo(skillNode)
			:setAnchorPoint(0, 0.5)
			self.skillLabelList[i][1] = sNameLabel

			-- local sName2Label = cc.Label:createWithTTF(tagMsg, fonts.FONT_SIYUAN, 15)
			-- :setPosition(34, 52 )
			-- :addTo(skillNode)
			-- :setAnchorPoint(0.5, 0.5)

			local label1 = cc.Label:createWithTTF('发动：1', fonts.FONT_SIYUAN, 15)
			:setPosition(-45, 24)
			:addTo(skillNode)
			:setAnchorPoint(0, 0.5)
			self.skillLabelList[i][2] = label1

			local label2 = cc.Label:createWithTTF('伤害：150000', fonts.FONT_SIYUAN, 15)
			:setPosition(-45, 0)
			:addTo(skillNode)
			:setAnchorPoint(0, 0.5)
			self.skillLabelList[i][3] = label2

			local label3 = cc.Label:createWithTTF('治疗：0', fonts.FONT_SIYUAN, 15)
			:setPosition(-45, -24)
			:addTo(skillNode)
			:setAnchorPoint(0, 0.5)
			self.skillLabelList[i][4] = label3

		end
	end

end

function CardSticTemplate:Init(fighter)

	if fighter==nil then
		self.bg:setContentSize(cc.size(124,200));
		self.nofighterNode:setVisible(true)
		self.fighterNode:setVisible(false)
		return
	end

	self.nofighterNode:setVisible(false)
	self.fighterNode:setVisible(true)

	local skillData, skillTime = FightManager:getSkillDataByFid( fighter:GetID(), fighter:IsEnemy() )

	local activeSkillId = 0
	local awakeSkillId = 0
	if fighter.pid and fighter.pid > 0 then
    	local card = model.CardModel:GetCard(fighter.pid);
		self.headNode:Init(ROLE_TYPE , card.no,card.star_lv,card.level);
		self.headNode:updateAltarLevelColor(card.oriLv)
        local skill_id = model.CardModel:getCardSkillIdByPid(fighter.pid);
        local roleSkillData = ResTable:getRowData('role_skill' , skill_id);
        if roleSkillData and roleSkillData.skill2_no then
        	activeSkillId = roleSkillData.skill2_no;
        end 
        if roleSkillData and roleSkillData.skill4_no then
        	awakeSkillId = roleSkillData.skill4_no;
        end 
        
    else
    	if fighter:getIsAutoMonster() then
    		self.headNode:Init(MONSTER_ROLE_TYPE , fighter.resID, 1, fighter:getFightLv());

			local monsterSkillData = ResTable:getRowData('monster', fighter.resID);
			if monsterSkillData then
				if monsterSkillData['skill_2'] and (monsterSkillData['skill_2'] > 0) then
					activeSkillId = monsterSkillData['skill_2'];
				end
				if monsterSkillData['skill_4'] and (monsterSkillData['skill_4'] > 0) then
					awakeSkillId = monsterSkillData['skill_4'];
				end

			end
			
		else
			self.headNode:Init(ROLE_TYPE , fighter.resID, 1, fighter:getFightLv());

			local skill_id = ResTable:getValue('role', fighter.resID, 'skill_id');
	        local roleSkillData = ResTable:getRowData('role_skill' , skill_id);
	        if roleSkillData and roleSkillData.skill2_no then
	        	activeSkillId = roleSkillData.skill2_no;
	        end 
	        if roleSkillData and roleSkillData.skill4_no then
	        	awakeSkillId = roleSkillData.skill4_no;
	        end 
		end
		
    end	

    self.skillNodeList[1]:setVisible(false);
    self.skillNodeList[2]:setVisible(false);
    self.skillNodeList[3]:setVisible(false);

    local showIdx = 1;
    if activeSkillId>0 and skillData[activeSkillId] then
    	local skillXmlData = ResTable:getRowData('skill', activeSkillId)
	    self.skillNodeList[1]:setVisible(true);
	    self.skillLabelList[1][1]:setString( self:subLimitStr(skillXmlData.name) );
	    local t = skillTime[activeSkillId] or 0
	    self.skillLabelList[1][2]:setString(LANG.UI_CARD_STIC_4..':'..t);
	    self.skillLabelList[1][3]:setString(LANG.UI_CARD_STIC_5..':'..skillData[activeSkillId]['Atk']);
	    self.skillLabelList[1][4]:setString(LANG.UI_CARD_STIC_6..':'..skillData[activeSkillId]['Help']);

	    self.skillNodeList[1]:setPosition( btnDotPos[showIdx] )
	    showIdx = showIdx + 1
    end
    
    if awakeSkillId>0 and skillData[awakeSkillId] then
	    local awakeXmlData = ResTable:getRowData('skill', awakeSkillId)
	    self.skillNodeList[2]:setVisible(true);
	    self.skillLabelList[2][1]:setString( self:subLimitStr(awakeXmlData.name) );
	    -- self.skillLabelList[2][2]:setString('发动：'..skillTime[awakeSkillId]);
	    local t = skillTime[awakeSkillId] or 0
	    self.skillLabelList[2][2]:setString(LANG.UI_CARD_STIC_4..':'..t);
	    self.skillLabelList[2][3]:setString(LANG.UI_CARD_STIC_5..':'..skillData[awakeSkillId]['Atk']);
	    self.skillLabelList[2][4]:setString(LANG.UI_CARD_STIC_6..':'..skillData[awakeSkillId]['Help']);

	    self.skillNodeList[2]:setPosition( btnDotPos[showIdx] )
	    showIdx = showIdx + 1
	end

    local comSkillId = 0 --普攻
    self.skillNodeList[3]:setVisible(true);
    self.skillLabelList[3][1]:setString(LANG.UI_CARD_STIC_2);
    -- self.skillLabelList[3][2]:setString('发动：'..skillTime[comSkillId]);
    local t = 0
    if skillTime and skillTime[comSkillId] then
    	t = skillTime[comSkillId]
    end
	self.skillLabelList[3][2]:setString(LANG.UI_CARD_STIC_4..':'..t);--发动
	if skillData[comSkillId] then
		self.skillLabelList[3][3]:setString(LANG.UI_CARD_STIC_5..':'..skillData[comSkillId]['Atk']);--伤害
	    self.skillLabelList[3][4]:setString(LANG.UI_CARD_STIC_6..':'..skillData[comSkillId]['Help']);--治疗
	end

    self.skillNodeList[3]:setPosition( btnDotPos[showIdx] )

	self.bg:setContentSize(cc.size(124,200+106*(showIdx-1)));

end

function CardSticTemplate:subLimitStr( str )
	local len = UTF8Len(str)
	if len >= 5 then
		local ret = UTF8Sub(str, 4)..'...'
		return ret;
	end
	return str
end

function CardSticTemplate:setPosition(x, y)
	self.root:setPosition(x, y);
end

function CardSticTemplate:setScale(scale)
	self.root:setScale(scale);
end

function CardSticTemplate:runAction(action)
	self.root:runAction(action)
end

return CardSticTemplate;
