local CardTemplate = class("CardTemplate" , function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")

function CardTemplate:ctor(father)
	self:addTo(father);

	self:setCascadeOpacityEnabled(true);

	self.clickQualityBg = ccui.ImageView:create();
	self.clickQualityBg:addTo(self);
	self.clickQualityBg:setTouchEnabled(true);

	self.selectNode = cc.Sprite:create('image/card/card_select_mid_.png')
		:setVisible(false)
		:addTo(self)

	self.iconImage = cc.Sprite:create();
	self.iconImage:addTo(self);
	self.iconImage:setPosition(0 , 16);

	self.fg = cc.Sprite:create('image/card/card_quality_fg.png');
	self.fg:addTo(self);

	self.name = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.name:setPosition(0 , -184);
	self.name:addTo(self);

	self.starList = {};
	self.starBgNode = cc.Node:create():addTo(self);
	for i = 1 , 5 do
		local starBg = cc.Sprite:create('image/card/star_level_bg.png');
		starBg:addTo(self.starBgNode);
		starBg:setScale(0.9);
		starBg:setPosition(-18 + 22 * (i - 1) , -152);

		self.starList[i] = cc.Sprite:create();
		self.starList[i]:addTo(self);
		self.starList[i]:setScale(0.9);
		self.starList[i]:setPosition(-18 + 22 * (i - 1) , -152);
	end

	self.quality = cc.Sprite:create();
	self.quality:setPosition(-78 , 173);
	self.quality:setAnchorPoint(0 , 0.5);
	self.quality:addTo(self);

	self.jobTypeImg = cc.Sprite:create('image/card/card_job_1.png');
	self.jobTypeImg:addTo(self);
	self.jobTypeImg:setPosition(-13 , -129);

	self.defTypeNode = cc.Sprite:create('image/card/card_def_type_bg.png');
	self.defTypeNode:addTo(self);
	self.defTypeNode:setPosition(-56 , -146);
	self.defTypeNode:setCascadeOpacityEnabled(true);

	local size = self.defTypeNode:getContentSize();
	self.defType = cc.Sprite:create();
	self.defType:addTo(self.defTypeNode);
	self.defType:setScale(0.65);
	self.defType:setPosition(size.width/2 , size.height/2);

	self.avatarFlag = cc.Sprite:create('image/card/btn_avatar.png');
	self.avatarFlag:setPosition(-62 , 116);
	self.avatarFlag:setScale(0.8);
	self.avatarFlag:addTo(self);
	self.avatarFlag:setVisible(false);

	self.bareFlag = cc.Sprite:create('image/card/btn_bare.png');
	self.bareFlag:setPosition(-62 , 74);
	self.bareFlag:setScale(0.8);
	self.bareFlag:addTo(self);
	self.bareFlag:setVisible(false);

	self.level = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.level:addTo(self);
	self.level:setAnchorPoint(1 , 0.5);
	self.level:enableOutline(cc.c4b(69 , 60 , 60) , 2);
	self.level:setPosition(80 , -129);

	self.hpNode = cc.Node:create()
		:addTo(self)
		:setPosition(0, -95)
		:setCascadeOpacityEnabled(true)
		:setVisible(false)

	self.hpNodeBg = cc.Sprite:create('image/team/hp_bg1.png')
		:addTo(self.hpNode)
		:setCascadeOpacityEnabled(true)

	self.hpBg = cc.Sprite:create('image/team/hp_bg2.png')
		:addTo(self.hpNode)
		:setCascadeOpacityEnabled(true)

	self.hp = cc.ProgressTimer:create(cc.Sprite:create('image/team/hp_fg.png'))
		:setType(cc.PROGRESS_TIMER_TYPE_BAR)
		:setMidpoint(cc.p(0, 0))
		:setBarChangeRate(cc.p(1, 0))
		:addTo(self.hpNode)
			
	self.hpRed = cc.Sprite:create('image/team/hp_bg3.png')
		:addTo(self.hpNode)
		:setCascadeOpacityEnabled(true)

	self.hpLabel = cc.Label:createWithTTF('HP', fonts.FONT_SIYUAN, 18)
		:setPosition(-60, 3)
		:addTo(self.hpNode)
		:enableOutline(cc.c3b(60, 60, 60), 2)
		:setCascadeOpacityEnabled(true)

	self.hpNumLabel = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 18)
		:setAnchorPoint(cc.p(1, 0.5))
        :setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
		:setPosition(75, 3)
		:addTo(self.hpNode)
		:enableOutline(cc.c3b(60, 60, 60), 2)
		:setCascadeOpacityEnabled(true)

--
	--self.stateNode = cc.DrawNode:create();
	--self.stateNode:drawPolygon({cc.p(0,0),cc.p(0,411),cc.p(182,411),cc.p(182,0)} , 4 , cc.c4f(0,0,0,0.4) , 0 , cc.c4f(0,0,0,0));
	--self.stateNode:setPosition(-91 , -205.5);
	--self.stateNode:addTo(self);
	--self.stateNode:setVisible(false);

	self.stateNodeMaskBg = cc.Sprite:create('image/card/card_shader.png');
	self.stateNodeMaskBg:addTo(self);
	self.stateNodeMaskBg:setVisible(false);

	self.stateNode = cc.Node:create();
	self.stateNode:addTo(self);
	self.stateNode:setVisible(false);

	self.stateImg = cc.Sprite:create('image/card/state_bg_1.png');
	self.stateImg:addTo(self)
	self.stateImg:setVisible(false);
	self.stateImg:setPosition(53, 173);

	local size = self.stateImg:getContentSize();
	self.stateLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 16);
	self.stateLabel:addTo(self.stateImg);
	self.stateLabel:setPosition(size.width/2 , size.height/2);
	self.stateLabel:enableOutline(cc.c3b(240,170,0),2);

	self.upStarNode = cc.Node:create();
	self.upStarNode:addTo(self);
	self.upStarNode:setPosition(0 , -101);
	self.upStarNode:setVisible(false);
	self.upStarNode:setCascadeOpacityEnabled(true);

	local upStarProgressBg = cc.Sprite:create('image/card/cardLevelUpStar/card_levelup_star_progress.png');
	upStarProgressBg:addTo(self.upStarNode);

	self.upStarProgress = cc.Scale9Sprite:create('image/commonImg/pgs_3_9_12.png');
	self.upStarProgress:setCapInsets(CCRectMake(3,0,3,12));
	self.upStarProgress:addTo(self.upStarNode);
	self.upStarProgress:setAnchorPoint(0 , 0.5);
	self.upStarProgress:setPosition(-57 , 0.7);

	self.upStarNum = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.upStarNum:addTo(self.upStarNode);
	self.upStarNum:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
	self.upStarNum:setPosition(0 , 3);

	self.redDot = cc.Sprite:create('image/commonImg/tip_1.png');
	self.redDot:setPosition(81 , 195.5);
	self.redDot:setVisible(false);
	self.redDot:addTo(self);

	self.timeNode = cc.Node:create();
	self.timeNode:addTo(self);
	self.timeNode:setPosition(-90 , 170);
	self.timeNode:setVisible(false);

	local timeBg = cc.Sprite:create('image/card/cardAvatar/avatar_time.png');
	timeBg:addTo(self.timeNode);
	timeBg:setAnchorPoint(0 , 0.5);

	self.timeLabel = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 20);
	self.timeLabel:addTo(self.timeNode);
	self.timeLabel:setAnchorPoint( cc.p(0,0.5) );
	self.timeLabel:enableOutline(cc.c4b(40 , 40 , 40 , 255) , 2);
	self.timeLabel:setPosition(36 , 0);

	self.libraryMapNode = cc.Node:create();
	self.libraryMapNode:addTo(self);
	self.libraryMapNode:setVisible(false);

	local bg = cc.Sprite:create('image/cardBook/library_map_bg_1.png');
	bg:addTo(self.libraryMapNode);
	bg:setPosition(-57 , 194);

	self.libraryMapRewardTip = cc.Sprite:create('image/commonImg/tip_2.png');
	self.libraryMapRewardTip:addTo(self);
	self.libraryMapRewardTip:setPosition(0 , -184);
	self.libraryMapRewardTip:setVisible(false);
	
	self.stateMinPosY = 173;

	self.resId = 0;
end

--==============================--
--desc:抽卡，超过上限时，会通过邮箱发送，此时没有PID
--time:2019-08-03 05:16:06
--@pid:
--@return 
--==============================--
function CardTemplate:Init(pid)
	local data = model.CardModel:GetCard(pid);
	if not data then
		return;
	end

	self.pid = pid or -1;

	self:setData(data.no , data.star_lv , data.quality , data.level);
	self:updateAltarLevelColor(data.oriLv);
	self.card = data;
end

function CardTemplate:InitCardReset(pid)
	local data = model.CardModel:GetCard(pid);
	if not data then
		return;
	end

	self.pid = pid or -1;
	local level = data.oriLv and data.oriLv or data.level;
	self:setData(data.no , data.star_lv , data.quality ,level);
	self.card = data;
end

--[[
function CardTemplate:InitHp(pid)

	local data = model.CardModel:GetCard(pid);
	if not data then
		return;
	end

	self.card = data;

	self.pid = pid or -1;

	self:setData(data.no , data.star_lv);
	self.level:setString('LV '..tostring(data.level));
	self.hpNode:setVisible(true);

	local pro = CardProManager:GetCardPro(pid);
	if not pro then
		return
	end

	local hpPercent = data.hp / 10000;

	local curHp = ConvertStrToDigitUnit(HpMultiply(ConvertDigitUnitToStr(pro.hp) ,  hpPercent))
	self.hp:setString(tostring(curHp)..'/'..tostring(pro.hp));
	self.hpProgress:setTextureRect(cc.rect(0, 0, 181*hpPercent, 23));
end
--]]

function CardTemplate:InitByNo(no)
	self:setData(no);
end

function CardTemplate:InitUpStar(pid , numData)
	local data = model.CardModel:GetCard(pid);
	if not data then
		return;
	end

	self.pid = pid or -1;

	local tNum = numData.mainNum + numData.secondNum;
	self:setData(data.no , data.star_lv,data.quality,data.level);
	self.upStarNum:setString(tostring(tNum)..'/'..tostring(numData.totalNum));

	local percentage = tNum / numData.totalNum;
	percentage = percentage > 1 and 1 or percentage;
	local width = 114 * percentage;
	if width > 0 then
		width = width < 14 and 14 or width;
	end
	self.upStarProgress:setContentSize(cc.size(width , 12));

	self.jobTypeImg:setVisible(false)
	self.upStarNode:setVisible(true);

	self.redDot:setVisible(numData.isEnough);

	self:updateAltarLevelColor(data.oriLv);
	self.card = data;
end

function CardTemplate:InitBareCollect(bareData)

	local no = bareData.role_id;

	local roleData = ResTable:getRowData('role', no);
	if not roleData then
		return;
	end

	local rolePre = ResTable:getRowData('role_pre', roleData.role_id);
	
	self.clickQualityBg:loadTexture('image/card/card_quality_bg_'..roleData.quality..'.png');
	self.clickQualityBg:setTouchEnabled(true);
	self.clickQualityBg:setSwallowTouches(false);

	local roleInfo = ResTable:getRowData('role_info', roleData.role_id);
	self.name:setString(tostring(roleInfo.name));
	self:updateIconImage(bareData.resource_id);

	self.jobTypeImg:setVisible(false);
	self.level:setVisible(false);
	self.defTypeNode:setVisible(false);
	self.starBgNode:setVisible(false);
end

function CardTemplate:InitByCardBook(data)
	self:setData(data.no);
	if data.getCard == 0 then
		self.libraryMapNode:setVisible(false);
		self.selectNode:setVisible(false);
		self.libraryMapRewardTip:setVisible(false);
		self.stateNodeMaskBg:setVisible(true);
		self.name:setPositionX(0);
	elseif data.rewardState == 0 and data.getCard == 1 then
		self.libraryMapNode:setVisible(true);
		self.selectNode:setVisible(true);
		self.libraryMapRewardTip:setVisible(true);
		self.stateNodeMaskBg:setVisible(false);
		
		local width = self.libraryMapRewardTip:getContentSize().width;
		local nameWidth = self.name:getContentSize().width;
		local posX = -nameWidth / 2;

		self.libraryMapRewardTip:setPositionX(posX);
		self.name:setPositionX(posX + width / 2 + nameWidth / 2);
	else
		self.libraryMapNode:setVisible(false);
		self.selectNode:setVisible(false);
		self.libraryMapRewardTip:setVisible(false);
		self.stateNodeMaskBg:setVisible(false);
		self.name:setPositionX(0);
	end
end

function CardTemplate:setNameInfo(str)
	self.name:setString(str)
end

function CardTemplate:setData(no , star , quality,level)

	local roleData = ResTable:getRowData('role', no);
	if not roleData then
		return;
	end

	local rolePre = ResTable:getRowData('role_pre', roleData.role_id);
	
	self.rank = star or rolePre.initial_star

	self.fightAttribute = rolePre.def_type;

	self.defType:setTexture('image/commonImg/def_type_'..rolePre.def_type..'.png');

	quality = quality or roleData.quality;
	self.quality:setTexture('image/card/card_quality_'..quality..'.png');
	
	self.clickQualityBg:loadTexture('image/card/card_quality_bg_'..quality..'.png');
	self.clickQualityBg:setTouchEnabled(true);
	self.clickQualityBg:setSwallowTouches(false);
	--self.clickQualityBg:loadTextures('image/card/card_quality_bg_'..roleData.quality..'.png' , 'image/card/card_quality_bg_'..roleData.quality..'.png');
	self.jobTypeImg:setTexture('image/card/card_job_'..rolePre.job_type..'.png');

	local levelStr = '';
	local offsetX = 0;
	if level then
		levelStr = 'Lv'..tostring(level);
		offsetX = 5;
	end
	self.level:setString(levelStr);
	self.level:setTextColor(cc.c3b(255,255,255));
	local levelWidth = self.level:getContentSize().width;
	local jobTypeWidth = self.jobTypeImg:getContentSize().width;
	self.jobTypeImg:setPositionX(self.level:getPositionX() - levelWidth - jobTypeWidth/2 - offsetX);

	local color = math.ceil(self.rank / 5);
	local num = self.rank % 5;
	num = num == 0 and 5 or num;

	for i = 1 , 5 do
		if i <= num then
			self.starList[i]:setTexture('image/card/card_star_'..color..'.png');
		end
		self.starList[i]:setVisible(i <= num);
	end
	self.starBgNode:setVisible(true);

	local resId = roleData.resource_id;
	local tmpResId = model.CardModel:getCardResIdByPid(self.pid);
	if tmpResId > 0 then
		resId = tmpResId;
	end
	self:updateIconImage(resId);

	local roleInfo = ResTable:getRowData('role_info', roleData.role_id);
	self.name:setString(tostring(roleInfo.name));

	self.totalOrder = 0;
	self.curOrder = 0;
	self.defTypeNode:setVisible(true);
end

function CardTemplate:updateAltarLevelColor(oriLv)
	if oriLv and oriLv>=1 then
		self.level:setTextColor(cc.c3b(255,255,0));
	else
		self.level:setTextColor(cc.c3b(255,255,255));
	end
end

function CardTemplate:checkRedDot()

	if not self.card then
		return
	end
	self.redDot:setVisible(model.CardModel:getTeamActiveState(self.pid));

	if self.redDot:isVisible()==false then
		self.redDot:setVisible(not model.CardModel:IsHaveLive2d(self.pid));
	end
end

function CardTemplate:checkFlag(no)
	--[[
	local posY = 116
	if model.CardModel:isHaveAvatar(no) then
		self.avatarFlag:setVisible(true);
		self.avatarFlag:setPositionY(posY);
		posY = posY - 42
	else
		self.avatarFlag:setVisible(false);
	end
	
	local isHave = model.BareCollectModel:isHaveBare(no);
	if isHave then
		self.bareFlag:setVisible(true);
		self.bareFlag:setPositionY(posY);
	else
		self.bareFlag:setVisible(false);
	end
	]]
end

function CardTemplate:updateIconImage( resId )
	-- body
	if self.resId ~= resId and resId~=0 then
		self.resId = resId;
		local roleResource = ResTable:getRowData('role_resource', resId);
		self.iconImage:setTexture('image/iconL/'..roleResource.iconlarge..'.png');
		self.iconImage:setTextureRect(LRect);
	end
end

function CardTemplate:setAvatarRes( no, resId, avatarData, time )
	-- body
	local roleData = ResTable:getRowData('role', no);
	if not roleData then
		return;
	end
	self.starBgNode:setVisible(false);

	local rolePre = ResTable:getRowData('role_pre', roleData.role_id);
	
	self.rank = star or rolePre.initial_star

	self.fightAttribute = rolePre.def_type;

	-- self.defType:setTexture('image/commonImg/def_type_'..rolePre.def_type..'.png');

	-- self.quality:setTexture('image/card/card_quality_'..roleData.quality..'.png');

	local quality = roleData.quality;

	self.jobTypeImg:setVisible(false);
	self.defTypeNode:setVisible(false);
	self.clickQualityBg:loadTexture('image/card/card_quality_bg_'..quality..'.png');

	local isHave = avatarData[2];
	local avatarNo = avatarData[1];

	self.stateNodeMaskBg:setVisible(not isHave);

	if isHave then
		if self.avatarTipNode then
			self.avatarTipNode:setVisible(false);
		end
	elseif avatarNo == no * 100 then
		if not self.avatarTipNode then
			self.avatarTipNode = cc.Node:create();
			self.avatarTipNode:addTo(self);

			self.avatarTipLabel = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
				:addTo(self.avatarTipNode)
				:setPosition(0,3)
				:enableOutline(cc.c4b(0,0,0,255),2)

			self.avatarTipLine = cc.Scale9Sprite:create('image/commonImg/line4.png')
				:addTo(self.avatarTipNode)
				:setPosition(0 , -10)
				:setCapInsets(cc.rect(4,0,16,5))

			local label = cc.Label:createWithTTF(LANG.COMMON_CLICK_GET,fonts.FONT_SIYUAN,20)
				:setTextColor(cc.c3b(255,255,0))
				:enableOutline(cc.c3b(135,100,55),2)

			self.getAvatarBtn = ccui.Button:create('image/commonImg/btn_13.png','image/commonImg/btn_13.png');
			self.getAvatarBtn:addTo(self.avatarTipNode);
			self.getAvatarBtn:setTitleLabel(label);
			self.getAvatarBtn:addClickEventListener(function()
				Network.NetworkManager:Send(Network.NetworkCmdType.req_card_avatar_get , {no = no});
			end);
		end
		self.avatarTipNode:setVisible(true);

		self.avatarTipLabel:setString(tostring(avatarData[4]));
		local width = self.avatarTipLabel:getContentSize().width;
		self.avatarTipLine:setContentSize(cc.size(width+6,5));

		self:setGetAvatar(false)
	end

	self:updateIconImage(resId);

	local roleInfo = ResTable:getRowData('role_info', roleData.role_id);
	self.name:setString(tostring(roleInfo.name));
	if avatarData[3] and avatarData[3] ~= '' then
		self.name:setString(tostring(avatarData[3]));
	end

	if isHave and time and time~='' then
		self.timeLabel:setString(tostring(time));
		self.timeNode:setVisible(true);
	else 
		self.timeNode:setVisible(false);
	end

	self.totalOrder = 0;
	self.curOrder = 0;
end

function CardTemplate:setGetAvatar(isGet)
	if self.avatarTipNode then
		self.avatarTipLabel:setVisible(not isGet);
		self.avatarTipLine:setVisible(not isGet);
		self.getAvatarBtn:setVisible(isGet);
	end
end

function CardTemplate:checkUpStarRedDot()
	if not self.card then
		return
	end
	
	local state = model.CardModel:getCardStarActiveState(self.pid);
	self.redDot:setVisible(state);
end

function CardTemplate:setHpZeroAction(run)
	self.hpNodeBg:stopAllActions();
	if run then
		self.hpNodeBg:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeTo:create(40/60 , 255) , cc.FadeTo:create(40/60 , 76.5))));
	end
end

function CardTemplate:updateHp(percent, hp)
	if percent and hp then
		self.hpNode:setVisible(true)
		if percent > 0 then
			self.hpRed:setVisible(false)
			-- self.hpNumLabel:setString(ConvertStrToDigitUnit(HpMultiply(ConvertDigitUnitToStr(hp), percent)));
			self.hpNumLabel:setString('');
			self.hpLabel:setVisible(false)
			self.hp:setVisible(true)
			self.hp:setPercentage(percent*100)
		else
			self.hpRed:setVisible(true)
			self.hpRed:stopAllActions()
			self.hpRed:runAction(cc.RepeatForever:create(cc.Sequence:create(cc.FadeOut:create(1), cc.FadeIn:create(1))))
			self.hp:setVisible(false)
			self.hpNumLabel:setString(LANG.UI_TEAM_31)
			self.hpLabel:setVisible(true)
		end
	end
end

function CardTemplate:hideHpNode()
	self.hpNode:setVisible(false)
end

function CardTemplate:initCardInTeamState(states , showMask , teamType)
	if teamType == Enum:getTable('TeamType').EVENT then
		self.stateMinPosY = -59
	else
		self.stateMinPosY = 173
	end

	local statesNum = states and #states or 0;

	if statesNum > 0 then
		self.stateNode:setVisible(true);
		self.stateNode:removeAllChildren();
		self.stateNodeMaskBg:setVisible(showMask);

		for _k , state in pairs(states) do
			local stateSp = cc.Sprite:create('image/card/state_bg.png');
			stateSp:addTo(self.stateNode)
			stateSp:setPosition(53 , self.stateMinPosY);

			local stateSize = stateSp:getContentSize();
			local stateImg = cc.Sprite:create('image/card/state_fight.png');
			stateImg:addTo(stateSp);
			stateImg:setPosition(stateSize.width/2 - 26 , stateSize.height/2 + 1);

			local stateLabel = cc.Label:createWithTTF(LANG.UI_CARD_TEAM_STATE[state] or '', fonts.FONT_SIYUAN , 15);
			stateLabel:addTo(stateSp);
			stateLabel:setPosition(stateSize.width/2 + 11 , stateSize.height/2 + 1);
			stateLabel:enableOutline(cc.c3b(215 , 20 , 25) , 2);

			self.stateMinPosY = self.stateMinPosY - 40;
		end
	else
		self.stateNodeMaskBg:setVisible(false);
		self.stateNode:setVisible(false);
	end
end

function CardTemplate:setState(flag,maskType)
	self.stateImg:setVisible(true);
	self.selectNode:setVisible(maskType==2);
	self.stateImg:setPositionY(self.stateMinPosY)
	if flag == 'select' then
		self.stateLabel:setString(tostring(LANG.UI_CARD_STATE_1));
	elseif flag == 'teamChange' then
		self.stateLabel:setString(tostring(LANG.UI_CARD_STATE_2));
	elseif flag == 'eventTeamChange' then
		self.stateLabel:setString(tostring(LANG.UI_CARD_STATE_2));
	else
		self.stateImg:setVisible(false);
		self.selectNode:setVisible(false);
	end
end

function CardTemplate:getRank()
	return self.rank;
end

function CardTemplate:getFightAttribute()
	return self.fightAttribute;
end

function CardTemplate:showMask(showMask)
	self.stateNodeMaskBg:setVisible(showMask);
end

-- grey
function CardTemplate:setCanChoose(flag)
	self.canChoose = flag;
end

function CardTemplate:getCanChoose()
	return self.canChoose;
end

function CardTemplate:setCardTag(tag)
	self.clickQualityBg:setTag(tag);
end

function CardTemplate:getCardTag()
	return self.clickQualityBg:getTag();
end

function CardTemplate:setCardTouchEnabled()
	self.clickQualityBg:loadTexture('image/fight/result/quality_bg_null.png');
	self.clickQualityBg:setTouchEnabled(true);
	self.clickQualityBg:setSwallowTouches(false);
end

function CardTemplate:addCardClickEventListener(callback)
	self.clickQualityBg:addClickEventListener(callback);
end

function CardTemplate:setCardSwallowTouches(swallow)
	self.clickQualityBg:setSwallowTouches(swallow);
end

function CardTemplate:setSelect(isSelect)
	self.selectNode:setVisible(isSelect);
end

function CardTemplate:runCardListAction(delayTime)
	self:runAction(cc.Sequence:create(cc.DelayTime:create(delayTime),cc.CallFunc:create(function() 
		self:setVisible(true);
		local x , y = self:getPosition();
		self:runAction(cc.MoveTo:create(0.2, cc.p( x , y + 60)));
		for _k , child in pairs(self:getChildren()) do
			child:setOpacity(0)
			child:runAction(cc.FadeIn:create(0.2));
		end
	end)));
end

return CardTemplate;
