local CommonRowItemCell = class("CommonRowItemCell" , function() 
	return ccui.Layout:create();
end)
local fonts = Enum:getTable('SystemFont')

function CommonRowItemCell:ctor(father)
	self:addTo(father);

	self.itemList = {}
	self.callback = nil;

	for i=1,5 do
		local mainNode = cc.Node:create()
		:addTo(self)
		:setPosition(60+(i-1)*110, 50)

		local roleNode = template.ItemTemplate:create()
		:addTo(mainNode)
		roleNode:setItemTag(i)
		roleNode:addItemClickEventListener(handler(self , self.clickBtn));

		-- local flagNode = cc.Node:create()
		-- :addTo(mainNode)
		-- :setVisible(false)
		-- local flagSpr = cc.Sprite:create('image/commonImg/ok_icon.png')
		-- :addTo(flagNode)

		table.insert( self.itemList, {mainNode=mainNode, roleNode=roleNode} ) --, flagNode=flagNode

	end

end

function CommonRowItemCell:initData( list, st )
	self.data = list;
	for i=1,5 do
		self.itemList[i].mainNode:setVisible(false)
		if self.data[i] then
			self.itemList[i].mainNode:setVisible(true)
			if st==1 then
				local card = model.CardModel:GetCard(self.data[i]);
				if card then
					self.itemList[i].roleNode:Init(ROLE_TYPE , card.no,card.star_lv,card.level);
				end
			else
				self.itemList[i].roleNode:Init(self.data[i][1], self.data[i][2]);
			end
		end
	end

end

function CommonRowItemCell:setCallBack( callback )
	self.callback = callback;
end

function CommonRowItemCell:clickBtn(sender , event)
	local tag = sender:getTag();
	print('fubin--CommonRowItemCell:clickBtn----:', tag)
	if self.callback then
		self.callback( self.data[tag][1] )
	end
	-- EventManager:FireEvent(EventType.UIFutureCardSel, self.data[tag]);
end


return CommonRowItemCell;