local CommonTaskCell = class("CommonTaskCell" , function()
	return cc.Node:create();
end)
local fonts = Enum:getTable("SystemFont")

function CommonTaskCell:ctor()

	self:setCascadeOpacityEnabled(true);

	local bg = cc.Sprite:create('image/commonImg/bg_4_563_126.png');
	bg:addTo(self);

	local bg = cc.Sprite:create('image/fight/roundReward/round_reward_1.png');
	bg:setPosition(-252 , 35);
	bg:addTo(self);

	self.round = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.round:setPosition(-232 , 35);
	self.round:setAnchorPoint(0 , 0.5);
	self.round:setTextColor(cc.c3b(255 , 255 , 255));
	self.round:enableOutline(cc.c3b(40 , 50 , 60) , 2);
	self.round:addTo(self);

	local rewardBg = cc.Sprite:create('image/commonImg/bg_3_194_102.png');
	rewardBg:addTo(self);
	rewardBg:setPosition(58 , 0);

	self.rewardView = ccui.ScrollView:create();
	self.rewardView:setTouchEnabled(true); 
	self.rewardView:setBounceEnabled(true);
	self.rewardView:setDirection(ccui.ScrollViewDir.horizontal);
	self.rewardView:setContentSize(cc.size(185, 87));
	self.rewardView:setAnchorPoint(cc.p(0.5, 0.5));
	self.rewardView:setPosition(58 , 0);
	self.rewardView:setScrollBarEnabled(false);
	self.rewardView:addTo(self);

	local rewardProgressBg = cc.Sprite:create('image/commonImg/pgs_bg_1_213_12.png');
	rewardProgressBg:addTo(self);
	rewardProgressBg:setPosition(-160 , -1);

	self.rewardProgress = cc.Scale9Sprite:create('image/commonImg/pgs_2_14_12.png');
	self.rewardProgress:setCapInsets(CCRectMake(6,0,2,12));
	self.rewardProgress:addTo(self);
	self.rewardProgress:setAnchorPoint(0 , 0.5);
	self.rewardProgress:setPosition(-266 , -1);

	self.roundProgress = cc.Label:createWithTTF('1/1' , fonts.FONT_SIYUAN , 18);
	self.roundProgress:addTo(self);
	self.roundProgress:setPosition(-160 , -25);
	self.roundProgress:enableOutline(cc.c4b(40 , 50 , 60 , 255) , 2);

	self.rewardBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png' , 'image/commonImg/btn_2_103_36.png');
	self.rewardBtn:addTo(self);
	self.rewardBtn:setPosition(219 , 0);
	self.rewardBtn:addClickEventListener(handler(self , self.rewardBtnClick));

	self.rewardLabel = cc.Label:createWithTTF(LANG.UI_ROUND_18 , fonts.FONT_SIYUAN , 18);
	self.rewardLabel:addTo(self.rewardBtn);
	self.rewardLabel:setPosition(self.rewardBtn:getContentSize().width/2 , self.rewardBtn:getContentSize().height/2);
	self.rewardLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.rewardLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

	self.msgBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png' , 'image/commonImg/btn_2_103_36.png');
	self.msgBtn:addTo(self);
	self.msgBtn:setPosition(219 , -30);
	self.msgBtn:addClickEventListener(handler(self , self.msgBtnClick));
	self.msgBtn:setVisible(false);
	self.msgLabel = cc.Label:createWithTTF(LANG.UI_ROUND_26 , fonts.FONT_SIYUAN , 18);
	self.msgLabel:addTo(self.msgBtn);
	self.msgLabel:setPosition(self.msgBtn:getContentSize().width/2 , self.msgBtn:getContentSize().height/2);
	self.msgLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.msgLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

	self.notEnough = cc.Sprite:create('image/commonImg/btn_7_103_36.png');
	self.notEnough:addTo(self);
	self.notEnough:setPosition(219 , 0);

	local label = cc.Label:createWithTTF(LANG.UI_ROUND_21 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.notEnough);
	label:setPosition(self.notEnough:getContentSize().width/2 , self.notEnough:getContentSize().height/2);
	label:setTextColor(cc.c3b(60 , 60 , 60));
	label:enableOutline(cc.c4b(200 , 200 , 200 , 255) , 2);

	self.geted = cc.Sprite:create('image/commonImg/btn_4_103_36.png');
	self.geted:addTo(self);
	self.geted:setPosition(219 , 0);

	local label = cc.Label:createWithTTF(LANG.UI_ACTIVITY_19 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.geted);
	label:setPosition(self.geted:getContentSize().width/2 , self.geted:getContentSize().height/2);
	label:setTextColor(cc.c3b(255 , 255 , 255));
	label:enableOutline(cc.c4b(55 , 85 , 155 , 255) , 2);
end

function CommonTaskCell:Init(rewardId, tbName, dict)

	self.tbName = tbName;
	self.cellId = rewardId;
	local totalNum = 1
	local curNum = 0
	if tbName=='twin_reward' then
		local data = ResTable:getRowData(tbName, rewardId);
		self:setReward(data.twin_reward);
		totalNum = data.itemnumber;
		if dict and dict.curVal then
			curNum = dict.curVal;
		end
		if model.DBActivityModel:getTwinInfo()[rewardId] then
			self:updateState(2);
		else
			if curNum>=totalNum then
				self:updateState(1);
			else
				self:updateState(0);
			end
		end

		self.round:setString(string.format(LANG.UI_ROUND_25,tostring(self.cellId)));
	elseif tbName=='round_bank_mission' then
		self:setReward(dict.reward);
		totalNum = dict.mission;
		curNum = dict.progress;
		self:updateState(dict.status_1);

		local name = ResTable:getValue('round_bank_mission', self.cellId, 'mission_info')
		self.round:setString(string.format(name,totalNum));
	else

	end
	
	self.roundProgress:setString(tostring(curNum)..'/'..tostring(totalNum));
	local percentage = curNum / totalNum;
	percentage = percentage > 1 and 1 or percentage;
	local width = 213 * percentage;
	if width > 0 then
		width = width < 14 and 14 or width;
	end
	self.rewardProgress:setContentSize(cc.size(width , 12)); --min:14 max: 213

end

function CommonTaskCell:updateState(state)
	self.rewardBtn:setVisible(false);
	self.notEnough:setVisible(false);
	self.geted:setVisible(false);
	if state == 0 then -- 未达成
		self.rewardLabel:setString(LANG.UI_ROUND_19);
		self.notEnough:setVisible(true);
	elseif state == 1 then --领取
		self.rewardLabel:setString(LANG.UI_ROUND_18);
		self.rewardBtn:setTag(1);
		self.rewardBtn:setVisible(true);
	elseif state == 2 then --以领取
		self.geted:setVisible(true);
	end
end

function CommonTaskCell:setReward(reward)
	local rewardNum = #reward;

	local maxWidth = rewardNum * 82.4;
	maxWidth = maxWidth < 185 and 185 or maxWidth;

	self.rewardView:removeAllChildren();
	self.rewardView:setInnerContainerSize(cc.size(maxWidth, 87));

	for i=1, rewardNum do
		local r = reward[i];
		local layout = ccui.Layout:create();
		layout:addTo(self.rewardView);
		local icon = template.ItemTemplate:create(2);
		icon:addTo(layout);
		icon:Init(r[1] , r[2]);
		icon:setScale(0.8);
		icon:setPosition(41.2 + 82.4 * (i - 1) , 43.5);
	end
	self.rewardView:setTouchEnabled(rewardNum > 2);
end

function CommonTaskCell:rewardBtnClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(self.tag , tag);
	end
	self:updateState(2)
end

function CommonTaskCell:showMsgBtn()
	self.msgBtn:setVisible(true)
	self.rewardBtn:setPosition(219, 30)
	self.notEnough:setPosition(219, 30)
	self.geted:setPosition(219, 30)
end

function CommonTaskCell:msgBtnClick()
	UIManager:push('DBActivityTaskPanel');
end

function CommonTaskCell:setBtnTag(tag)
	self.tag = tag;
end

function CommonTaskCell:addBtnClickEventListener(callback)
	self.callback = callback;
end

function CommonTaskCell:setGetRewardBtnVisible(visible)
	self.rewardBtn:setVisible(visible);
end

function CommonTaskCell:getGuideBtn(  )
	return self.rewardBtn;
end

return CommonTaskCell;
