local EventBaseMapItem = class("EventBaseMapItem",function (  )
	return cc.Node:create();
end)

local fonts = Enum:getTable("SystemFont");
local FightType = Enum:getTable('FightType');
local imagePath = 'image/event/map/';
local MessageBoxType = Enum:getTable('MessageBoxType')

function EventBaseMapItem:ctor(pos)
	self.pos = pos;

	self:setCascadeOpacityEnabled(true);

	--大背景
	self.clickLayout = ccui.Layout:create();
	self.clickLayout:addTo(self);
	self.clickLayout:setAnchorPoint(cc.p(0.5, 0.5));
	self.clickLayout:setPosition(0 , 10);
	self.clickLayout:setContentSize(cc.size(98 , 98));
	self.clickLayout:addClickEventListener(handler(self , self.clickItem));
	self.clickLayout:setTouchEnabled(true);

	self.aniNode = cc.Node:create();
	self.aniNode:addTo(self)

	self.bg = cc.Sprite:create();
	self.bg:addTo(self);

	self.border = cc.Sprite:create();
	self.border:addTo(self);
	self.border:setPosition(0 , 10);

	self.isOpen = false
	self.bgIdx = 0;

	self:setBgSprite();

end

function EventBaseMapItem:setBgSprite( )
	self.tileData = model.EventModel:getMapCellInfo(self.pos)
	self.isOpen = self.tileData.open ~= 0 and true or false

	local bgSpriteTexture = '';
	local borderTexture = '';
	local spineRes = '';
	local canTouch = false;
	self.bgIdx = 0
	self.bgSpine = nil
	self.originZorder = 0
	if self.isOpen == false then
		local key = math.random(1, 7);
		bgSpriteTexture = imagePath..'item_bg'..key..'.png';
		self.bgIdx = key
		-- if self.pos%2 == 0 then
		-- 	bgSpriteTexture = imagePath..'item_bg1.png';
		-- else
		-- 	bgSpriteTexture = imagePath..'item_bg2.png';
		-- end

		local spine_res = 'zhuan0'..key..'_spine';
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			spine:addTo(self)
			spine:registerSpineEventHandler(function (event)
				if event.animation == 'boom1' then
					self.originZorder = self:getLocalZOrder()
					spine:setAnimation(0, "boom2", false)
					self:setLocalZOrder(self.originZorder + 35)
				elseif event.animation == 'boom2' then
					-- self.bgSpine:removeFromParent()
					self:setLocalZOrder(self.originZorder)
					self.bgSpine=nil
				end
			end, sp.EventType.ANIMATION_COMPLETE)
			self.bgSpine = spine;
		end

	end

	if bgSpriteTexture == '' then
		self.bg:setVisible(false);
	else
		self.bg:setVisible(true);
		self.bg:setTexture(bgSpriteTexture)
	end

	self:showSpine();

end

function EventBaseMapItem:isCaoDi()
	if self.isOpen == false and (self.bgIdx==3 or self.bgIdx==5 or self.bgIdx==6 or self.bgIdx==7) then
		return true
	end
	return false
end

function EventBaseMapItem:updateState()
	local ret = false
	self.tileData = model.EventModel:getMapCellInfo(self.pos)
	self.isOpen = self.tileData.open ~= 0 and true or false

	if self.isOpen then
		self.bg:setVisible(false);
		if self.bgSpine then
			ret = true
			self.originZorder = self:getLocalZOrder()
			self.bgSpine:setAnimation(0, "boom2", false)
			self:setLocalZOrder(self.originZorder + 35)
			-- self.bgSpine:setAnimation(0, "boom1", false)
		end
	end

	self:showSpine();

	return ret;

end

function EventBaseMapItem:showSpine()
end

function EventBaseMapItem:clickItem(  )
	if model.EventModel:isEnd() then
		local tier = model.EventModel:getTier()
		if tier == 1 or tier == 2 then
			Prompt:Show(LANG.UI_MAZE_16)
		else
			Prompt:Show(LANG.UI_MAZE_17)
		end
		return;
	end
	if model.EventModel:isNeedRest() then
		Prompt:Show(LANG.UI_MAZE_19)
		return;
	end

	if self.isOpen == false then --state==0
		if model.EventModel:checkCanClick(self.pos) == false then
			return;
		end

		if model.EventModel:getMovePoints() <= 0 then
			return Prompt:Show(LANG.UI_MAZE_20)
		end
		model.EventModel:reqEventTileInfo( self.pos )

	elseif self.isOpen == true then
		if self.tileData.state == -1 then --state==-1
			if model.EventModel:checkCanClick(self.pos) == false then
				return;
			end

			if model.EventModel:getMovePoints() <= 0 then
				return Prompt:Show(LANG.UI_MAZE_20)
			end
			model.EventModel:reqEventTileInfo( self.pos )
		else --state==1,2,3
			local canClick = model.EventModel:checkCanClick(self.pos);
			self:showItemInfo( canClick );
		end
	end
end

function EventBaseMapItem:showItemInfo( bclick )
	-- print(' ！！！！ show item info:  pos == ',self.pos,'...value == ',self.value);
	print('fubin---base---showItem:', self.pos)
end

-- 切换场景动画
function EventBaseMapItem:runChangeTierAct( delay,bShowAct )
	if bShowAct ~= true then
		return ;
	end
	local act1 = cc.Sequence:create(
		cc.DelayTime:create(delay),
		cc.Spawn:create(
			cc.ScaleTo:create(3/15,1.3),
			cc.FadeIn:create(3/15)
		),
		cc.ScaleTo:create(5/15,1)
	)
	self:setOpacity(0);
	self:runAction(act1)
end

function EventBaseMapItem:runItemAct( ... )
	if self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_1  then
		self:runDoorOpenAct();
	elseif  self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_2 then 
		local doorOpen = model.EventModel:getEventMapDoorState();
		if doorOpen == 2 then
			self:runItemRemove(...);
		end
	elseif  self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_4 then 
		self:runItemRemove(...)
	elseif  self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_5 then 
		self:runItemRemove(...)
	elseif  self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_9 then 
		self:runItemRemove(...)
	end
end

function EventBaseMapItem:runOpenParticleAct(  )
	local tapeffect1 = cc.ParticleSystemQuad:create("Effect/particle/baoxingxing.plist")
		:addTo(self)
		:setAutoRemoveOnFinish(true)
end

function EventBaseMapItem:runDoorOpenAct(  )
	if self.itemSpine then
		self.itemSpine:setToSetupPose();
		local aniName1 = 'idle'
		local aniName2 = 'open'

		self.itemSpine:setMix(aniName2,aniName1,0.1);
		self.itemSpine:setAnimation(0, aniName2, false)
		self.itemSpine:addAnimation(0, aniName1, true)
	end
end

function EventBaseMapItem:runItemRemove( ... )
	self.value  = 0;
	-- self.bg:setVisible(false);
	self.clickLayout:setTouchEnabled(false);
	self:runAction(cc.Sequence:create(cc.DelayTime:create(0.2),cc.CallFunc:create(function (  )
		self.bg:setVisible(false);
		if self.itemSpine then
			self.itemSpine:removeFromParent();
			self.itemSpine = nil;
		end
		self.spine_res = '';
	end )))
end

return EventBaseMapItem;
