local EventBattlePassItemCell = class('EventBattlePassItemCell',function() 
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")
function EventBattlePassItemCell:ctor()
	local bg = cc.Sprite:create('image/event/eventbp/bp_rwd_bg.png')
		:addTo(self)
		:setFlipX(true)

	self.rewardFreeNode = cc.Node:create()
		:addTo(self)
		:setPosition(166,0)
	self.rewardFreeShadowNode = cc.Node:create()
		:addTo(self)
		:setPosition(166,0)

	self.rewardSpecialNode = cc.Node:create()
		:addTo(self)
		:setPosition(-166,0)
	self.rewardSpecialShadowNode = cc.Node:create()
		:addTo(self)
		:setPosition(-166,0)
	self.rwdSpeLocalSpr = cc.Node:create()--cc.Sprite:create('image/event/eventbp/bp_lock.png')
		:addTo(self)
		:setPosition(-166,0)

	self.line = cc.Scale9Sprite:create('image/event/eventbp/bp_bar.png')
	self.line:addTo(self)
	self.line:setAnchorPoint(0.5,1)
	self.line:setPosition(-2,86)
	-- self.line:setCapInsets(cc.rect(0,2,10,4))

	local achieveBG = cc.Sprite:create('image/event/eventbp/meijihuo.png')
	achieveBG:addTo(self)
	achieveBG:setPosition(0, 0)

	self.achieveIcon = cc.Sprite:create('image/event/eventbp/jihuo.png')
	self.achieveIcon:addTo(self)
	self.achieveIcon:setPosition(0, 0)

	self.levelNode = cc.Node:create()
		:addTo(self)
		:setPosition(-2,0)

	self.canGet = cc.Sprite:create('image/battlePass/battlepass_bg_13.png')
		:addTo(self.levelNode)
		:setVisible(false)

	local levelBg = cc.Sprite:create('image/event/eventbp/bp_num_bg.png')
		:addTo(self.levelNode)
		:setPosition(0, -30)
		
	self.level = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
		:addTo(self.levelNode)
		:setPosition(0, -30)
		:setTextColor(cc.c3b(255,255,0))
		:enableOutline(cc.c3b(0,0,0),2)

	local rwdIcon = cc.Sprite:create('image/event/eventbp/bp_icon.png')
        :addTo(self.levelNode)
        :setScale(0.6)

    EventManager:RegisterEvent('EventBattlePassItemCell:openAcitve', handler(self, self.openAcitve));
end
function EventBattlePassItemCell:Init(data)

	self.rewardFreeNode:removeAllChildren();
	self.rewardSpecialNode:removeAllChildren();

	self.no = data.no;
	self.total_point = data.total_point;
	local canGet = false;
	self.levelNode:setVisible(true)
	self.level:setString(tostring(data.total_point));
	self.level:setVisible(true);
		
	-- if data.total_point == 1 then
	-- 	if not self.firstBg then
	-- 		self.firstBg = cc.Sprite:create('image/battlePass/battlepass_bg_9.png')
	-- 		:addTo(self.levelNode)
	-- 	end
	-- 	self.level:setVisible(false);
	-- else
	-- 	self.level:setString(tostring(data.total_point));
	-- 	self.level:setVisible(true);
	-- end

	-- if (data.reward_free_state == 1 or (data.reward_free_state == 0 and #data.reward<=0)) 
	--   and data.reward_special_state == 1 then
	-- 	self.canGet:setVisible(false);
	-- else
	-- 	local specialState = model.BattlepassEventModel:getSpecialState();
	-- 	local curPointNum = model.BattlepassEventModel:getCurBattlepassPoint()
	-- 	if (data.reward_free_state == 0 or (data.reward_special_state==0 and specialState == 1))
	-- 		and curPointNum >= data.total_point then
	-- 		self.canGet:setVisible(true);
	-- 		canGet = true;
	-- 	else
	-- 		self.canGet:setVisible(false);
	-- 	end
	-- end

	local curPointNum = model.EventModel:getEventBPPoint()
	local curBattlepassNo = model.EventModel:getBPData().curLimitRwdId;
	-- if curBattlepassNo > self.no then
	-- elseif curBattlepassNo == self.no then
	if data.total_point<curPointNum then
		self.line:setVisible(true);
		self.line:setContentSize(cc.size(10,173));
		self.achieveIcon:setVisible(true);
	elseif data.total_point==curPointNum then
		self.line:setVisible(true);
		self.line:setContentSize(cc.size(10,86.5));
		self.achieveIcon:setVisible(true);
	else
		self.line:setVisible(false);
		self.achieveIcon:setVisible(false);
	end
	
	if data.reward then
		local num = #data.reward;
		local startPosX = -(103*(num-1))/2
		for _k , reward in pairs(data.reward) do
			local x = startPosX+103*(_k-1);
			local item=template.ItemTemplate:create()
			item:Init(reward[1] , reward[2]);
			item:addTo(self.rewardFreeNode);
			item:setPosition(x,0)
			item:setItemTag(1);
			item:addItemClickEventListener(handler(self , self.rewardClick));

			local bg = cc.Sprite:create('image/battlePass/battlepass_bg_16.png')
				:addTo(self.rewardFreeShadowNode)
				:setPosition(x,0)
			local bg = cc.Sprite:create('image/battlePass/battlepass_bg_17.png')
				:addTo(self.rewardFreeShadowNode)
				:setPosition(x,0)
			self.rewardFreeShadowNode:setVisible( data.reward_free_state == 1 )

			if canGet then
				local bg = cc.Sprite:create('image/commonImg/icon_item_light.png')
				:addTo(self.rewardFreeNode)
				:setPosition(x,0)
			end

		end
	end

	if data.special_reward then
		local num = #data.special_reward;
		local startPosX = -(103*(num-1))/2
		for _k , reward in pairs(data.special_reward) do
			local x = startPosX+103*(_k-1);
			local item=template.ItemTemplate:create()
			item:Init(reward[1] , reward[2]);
			item:addTo(self.rewardSpecialNode);
			item:setPosition(x,0)
			item:setItemTag(2);
			item:addItemClickEventListener(handler(self , self.rewardClick));

			local bg = cc.Sprite:create('image/battlePass/battlepass_bg_16.png')
				:addTo(self.rewardSpecialShadowNode)
				:setPosition(x,0)
			local bg = cc.Sprite:create('image/battlePass/battlepass_bg_17.png')
				:addTo(self.rewardSpecialShadowNode)
				:setPosition(x,0)
			self.rewardSpecialShadowNode:setVisible( data.reward_special_state == 1 )

			local lockspr = cc.Sprite:create('image/event/eventbp/bp_lock.png')
				:addTo(self.rwdSpeLocalSpr)
				:setPosition(x+50,50)

			if canGet then
				local bg = cc.Sprite:create('image/commonImg/icon_item_light.png')
				:addTo(self.rewardSpecialNode)
				:setPosition(x,0)
			end
		end
	end

	self:openAcitve();
	
end

function EventBattlePassItemCell:openAcitve()
	self.rwdSpeLocalSpr:setVisible( model.EventModel:getBPData().special_state ~= 1 )
end

function EventBattlePassItemCell:updateGetState(data)
	if data.no == self.no then
		self.rewardFreeShadowNode:setVisible( data.reward_free_state == 1 )
		self.rewardSpecialShadowNode:setVisible( data.reward_special_state == 1 )
	end
end

function EventBattlePassItemCell:updateInfo(data)
	local curPointNum = model.EventModel:getEventBPPoint()
	local curBattlepassNo = model.EventModel:getBPData().curLimitRwdId;
	if curPointNum > self.total_point then
		self.line:setVisible(true);
		self.line:setContentSize(cc.size(10,173));
		self.achieveIcon:setVisible(true);
	elseif curPointNum == self.total_point then
		self.line:setVisible(true);
		self.line:setContentSize(cc.size(10,86.5));
		self.achieveIcon:setVisible(true);
	else
		self.line:setVisible(false);
		self.achieveIcon:setVisible(false);
	end
end

function EventBattlePassItemCell:rewardClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(tag , self.no);
	end
end
function EventBattlePassItemCell:addBattlepassClickEventListener(callback)
	self.callback = callback;
end

return EventBattlePassItemCell;