local EventBuffBigTemplate = class("EventBuffBigTemplate" , function()
	return ccui.Layout:create();
end)
local imagePath = "image/event/eventBuff/"
local fonts = Enum:getTable("SystemFont");
local buffQualityColor = {
	[1] = cc.c3b(155,200,255),
	[2] = cc.c3b(255,180,255),
	[3] = cc.c3b(255,230,165),
}

function EventBuffBigTemplate:ctor()
	--大背景
	self.qualityBg = cc.Sprite:create();
	self.qualityBg:addTo(self);

	self.name = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 18)
	self.name:addTo(self);
	self.name:setPosition(0 , 165);

	self.buffColor = cc.Sprite:create()
		:addTo(self)
		:setPosition(0,130)
		:setScale(0.7)

	self.buffJobNode = cc.Node:create()
	self.buffJobNode:addTo(self)
	self.buffJobNode:setPosition(0,130)
	self.buffJobNode:setScale(0.35)

	self.jobBg = cc.Sprite:create('image/commonImg/item_quality_2.png')
	self.jobBg:addTo(self.buffJobNode)
	self.buffJob = cc.Sprite:create()
		:addTo(self.buffJobNode)
	

	self.buffAll = cc.Sprite:create(imagePath..'buff_bg_1.png')
		:addTo(self)
		:setScale(0.7)
		:setPosition(0,130)

	-- local label = cc.Label:createWithTTF(LANG.UI_CARD_44,fonts.FONT_SIYUAN,16)
	-- 	:addTo(self.buffAll)
	-- 	:setPosition(self.buffAll:getContentSize().width/2,self.buffAll:getContentSize().height/2)
	-- 	:enableOutline(cc.c3b(240,170,0), 2)

	self.buff = cc.Sprite:create();
	self.buff:addTo(self);
	self.buff:setPosition(0 , 55);

	-- self.scorllview = ccui.ScrollView:create();
	-- self.scorllview:setTouchEnabled(true);
	-- self.scorllview:setBounceEnabled(true);
	-- self.scorllview:setDirection(ccui.ScrollViewDir.vertical);
	-- self.scorllview:setContentSize(cc.size(125 , 136));
	-- self.scorllview:setAnchorPoint(cc.p(0,0));
	-- self.scorllview:setScrollBarEnabled(false);
 --    self.scorllview:setPosition(-63 , -151);
 --    self.scorllview:addTo(self);

	self.buffInfo = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.buffInfo:addTo(self)
	self.buffInfo:setAnchorPoint(0 , 1);
	self.buffInfo:setTextColor(cc.c3b(60 , 60 , 60));
	self.buffInfo:setPosition(-75 , -15);
	self.buffInfo:setContentSize(cc.size(155 , 180));
	self.buffInfo:setDimensions(155 , 180);
	self.buffInfo:setLineBreakWithoutSpace(true);
	-- self.buffInfo:setMaxLineWidth(125);
	self.buffInfo:setLineHeight(23);
	-- self.buffInfo:setOverflow(cc.LabelOverflow.SHRINK)

end

function EventBuffBigTemplate:Init(buff)

	local buffData = ResTable:getRowData('maze_buff' , buff);

	self.qualityBg:setTexture(imagePath..'buff_quality_'..buffData.quality..'.png');
	
	self.buff:setTexture('image/event/event_att_type_'..buffData.icon..'.png');

	self.name:setString(tostring(buffData.name));
	self.name:setTextColor(buffQualityColor[buffData.quality]);

	self.buffInfo:setString(tostring(buffData.info));
	-- local infoH = self.buffInfo:getContentSize().height;
	-- self.buffInfo:setPosition(0, infoH)
	-- self.scorllview:setInnerContainerSize(cc.size(125, infoH));

	self.buffInfo:setTextColor(buffQualityColor[buffData.quality]);

	if buffData.color ~= 4 and buffData.job == 0 then
		self.buffColor:setTexture('image/commonImg/def_type_'..buffData.color..'.png');
		self.buffColor:setVisible(true);
		self.buffJobNode:setVisible(false);
		self.buffAll:setVisible(false);
	elseif buffData.color == 4 and buffData.job ~= 0 then
		self.buffJob:setTexture(imagePath..'card_job_'..buffData.job..'.png');
		self.buffColor:setVisible(false);
		self.buffJobNode:setVisible(true);
		self.buffAll:setVisible(false);
	else
		self.buffColor:setVisible(false);
		self.buffJobNode:setVisible(false);
		self.buffAll:setVisible(true);
	end

	self.buffJobNode:setScale(1)
	self.jobBg:setVisible(false)
	if buffData.type == 3 then
		local roleId = buffData.value[1];
		local data = ResTable:getRowData('role' , roleId);
		local imagePath = ResTable:getValue('role_resource', data.resource_id , 'icon');
		-- local rolePre = ResTable:getRowData('role_pre', data.role_id);
		local icon = 'image/icon/'..imagePath..'.png';

		self.buffJob:setTexture(icon);
		self.buffJobNode:setVisible(true);
		self.buffJobNode:setScale(0.35)
		self.jobBg:setVisible(true)

		self.buffColor:setVisible(false);
		self.buffAll:setVisible(false);
	elseif buffData.type == 2 or buffData.type == 4 then
		local icon = 'image/event/god_icon.png';
		self.buffJob:setTexture(icon);
		self.buffJobNode:setVisible(true);
		self.buffJobNode:setScale(0.35)
		self.jobBg:setVisible(true)

		self.buffColor:setVisible(false);
		self.buffAll:setVisible(false);
	end

	self.curBuff = buff;

	return buffData.quality
end

return EventBuffBigTemplate;
