local EventBuffTemplate = class("EventBuffTemplate")

local fonts = Enum:getTable("SystemFont");
local outlineColor = {
	[1] = cc.c4b(30 , 170 , 70),
	[2] = cc.c4b(30 , 115 , 200),
	[3] = cc.c4b(170 , 20 , 190),
	[4] = cc.c4b(200 , 140 , 30),
}

function EventBuffTemplate:ctor(father)
	local root  = cc.Node:create();
	self.root   = root;
	self.father = father;

	--大背景
	self.nameBg = cc.Sprite:create();
	self.nameBg:addTo(self.root);
	self.nameBg:setPosition(0 , -51);

	self.name = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
	self.name:addTo(self.root);
	self.name:setPosition(0 , -51);

	self.qualityBg = cc.Sprite:create();
	self.qualityBg:addTo(self.root);
	self.qualityBg:setPosition(0 , 10);

	self.buffType = cc.Sprite:create('image/event/event_buff_type.png');
	self.buffType:addTo(self.root);
	self.buffType:setPosition(-9 , 50); -- -9,50 , -29,50 
	self.buffType:setVisible(false);

	local size = self.buffType:getContentSize();
	local tmpLabel = cc.Label:createWithTTF(LANG.UI_L_ALLJU ,  fonts.FONT_IMPACT , 16);
    tmpLabel:addTo(self.buffType);
    tmpLabel:setPosition( size.width/2, size.height/2 );
    tmpLabel:enableOutline(cc.c4b(0, 85, 181 , 255) , 2);
	
	self.colorBg = cc.Sprite:create('image/event/event_bg_8.png');
	self.colorBg:addTo(self.root);
	self.colorBg:setPosition(-45 , 51);
	self.colorBg:setScale(0.7);

	self.color = cc.Sprite:create();
	self.color:addTo(self.root);
	self.color:setPosition(-45 , 51);
	self.color:setScale(0.5);

	self.buff = cc.Sprite:create();
	self.buff:addTo(self.root);
	self.buff:setPosition(0 , 16);

	self.father:addChild(self.root);
end

function EventBuffTemplate:Init(buff)

	local buffData = ResTable:getRowData('event_buff_effect' , buff);

	self.nameBg:setTexture('image/event/event_buff_name_bg_'..buffData.quality..'.png');
	self.qualityBg:setTexture('image/event/event_att_type_bg_'..buffData.quality..'.png');
	self.name:setString(LANG.UI_EVENT_BUFF_QUALITY[buffData.quality]..LANG.UI_CARAD_ATT_TYPE[buffData.attribute]);
	self.name:enableOutline(outlineColor[buffData.quality] , 2);
	self.buff:setTexture('image/event/event_att_type_'..buffData.attribute..'.png');

	self.buffType:setVisible(buffData.type == 1);

	if buffData.color == 4 then
		self.colorBg:setVisible(false);
		self.color:setVisible(false);
		self.buffType:setPosition(-29 , 50);
	else
		self.color:setTexture('image/event/color_'..buffData.color..'.png');
		self.colorBg:setVisible(true);
		self.color:setVisible(true);
		self.buffType:setPosition(-9 , 50);
	end
end

function EventBuffTemplate:setPosition(x , y)
	self.root:setPosition(x , y);
end

return EventBuffTemplate;
