local EventHealthMapItem = class("EventHealthMapItem", require("app.template.EventBaseMapItem"))

local fonts = Enum:getTable("SystemFont");
local FightType = Enum:getTable('FightType');
local imagePath = 'image/event/map/';
local MessageBoxType = Enum:getTable('MessageBoxType')

function EventHealthMapItem:ctor(pos)

	EventHealthMapItem.super.ctor(self, pos);

end

function EventHealthMapItem:showSpine()
	self.aniNode:removeAllChildren();
	if self.tileData.state == 1 then
		local spine_res = 'wenquan_spine';
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			spine:addTo(self.aniNode)
			spine:setAnimation(0, "wenquan_spine", true)
		end
	end
end

function EventHealthMapItem:showItemInfo( bclick )
	print('fubin---EventHealthMapItem---showItem:', self.pos)
	if bclick == false then
		return;
	end
	if self.tileData.state == 1 then
		local msg = ''
		local ishave = model.EventModel:isHaveDeadOrBadRole()
		if ishave then
			msg = LANG.UI_MAZE_32;
		else
			msg = LANG.UI_MAZE_14;
		end
		local callback = function()
				model.EventModel:reqEventTileInfo( self.pos )
				if ishave then
					Prompt:Show(LANG.UI_MAZE_25)
				else
					Prompt:Show(LANG.UI_MAZE_24)
				end
			end
		UIManager:push('EventMsgTipPanel', { 
												title = LANG.UI_MAZE_43,
												info = msg,
												icon = imagePath..'item_thing_4.png',
												callback = callback
										 })

	end

	
end

return EventHealthMapItem;