local EventMapItemTemplate = class("EventMapItemTemplate",function (  )
	return cc.Node:create();
end)

local fonts = Enum:getTable("SystemFont");
local FightType = Enum:getTable('FightType');
local imagePath = 'image/event/map/';
local MessageBoxType = Enum:getTable('MessageBoxType')

function EventMapItemTemplate:ctor()

	self:setCascadeOpacityEnabled(true);

	--大背景
	self.clickLayout = ccui.Layout:create();
	self.clickLayout:addTo(self);
	self.clickLayout:setAnchorPoint(cc.p(0.5, 0.5));
	self.clickLayout:setPosition(0 , 10);
	self.clickLayout:setContentSize(cc.size(98 , 98));
	self.clickLayout:addClickEventListener(handler(self , self.clickItem));

	self.bg = cc.Sprite:create();
	self.bg:addTo(self);

	self.border = cc.Sprite:create();
	self.border:addTo(self);
	self.border:setPosition(0 , 10);

	self.itemSpine = nil;
end

-- openOrUseItem 1 初始化，2 开启地板 3 使用地图元素
-- function EventMapItemTemplate:updateItemValue( pos,openOrUseItem )

-- 	if openOrUseItem == 1 then
-- 		self.pos = pos;
-- 		self.tier = model.EventModel:getTier();
-- 	end


-- 	local itemData = model.EventModel:getMapItemByPos(self.pos);
-- 	if self.isOpen == itemData.isOpen and self.posState == itemData.posState and self.value == itemData.value then
-- 		if self.value ~= model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_1 then
-- 			return
-- 		end
-- 	end
-- 	self.isOpen = itemData.isOpen or false; -- 未开启，已开启
-- 	self.posState = itemData.posState ;

-- 	-- print('self.isopen === ',self.isOpen,'....value == ',self.value)
-- 	if (openOrUseItem == 2 and self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_5 ) or
-- 		(openOrUseItem == 3 and self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_4 )  then
-- 			self:setBgSprite()
-- 			self:runItemAct(nil,itemData.value );
-- 	else
-- 		self.value = itemData.value;
-- 		self:setBgSprite()
-- 	end

-- end

function EventMapItemTemplate:setBgSprite( )
	local bgSpriteTexture = '';
	local borderTexture = '';
	local spineRes = '';
	local canTouch = false;
	if self.isOpen == false then
		if self.pos%2 == 0 then
			bgSpriteTexture = imagePath..'item_bg1.png';
		else
			bgSpriteTexture = imagePath..'item_bg2.png';
		end

		if self.posState == nil then
			borderTexture = imagePath..'item_state_1.png'
		elseif self.posState == 1 then 
			borderTexture = imagePath..'item_state_0.png'
			canTouch = true;
		elseif self.posState == 2 then 
			borderTexture = imagePath..'item_state_2.png'
		end
	else
		if self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_NULL then

		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_1 then 
			local doorOpen = model.EventModel:getEventMapDoorState();
			spineRes = 'event_door'..(self.tier == model.EventModel.EVENT_MAP_MAX_TIER and 2 or 1)

			self:showDoorSpine(spineRes,doorOpen == 2);
			canTouch = true 
		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_2 then 
			local doorOpen = model.EventModel:getEventMapDoorState();
			if doorOpen == 1 then
				spineRes = 'event_key'
				bgSpriteTexture = ''
			else
				spineRes = ''
				bgSpriteTexture = imagePath..(self.tier == model.EventModel.EVENT_MAP_MAX_TIER and 'item_monster_3.png' or 'item_monster_2.png')
			end
			canTouch = true 
		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_3 then 
			bgSpriteTexture = imagePath..'item_monster_1.png'
			canTouch = true 
		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_4 then 
			spineRes = 'event_thing2'
			canTouch = true 
		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_5 then 
			bgSpriteTexture = '' 
			canTouch = true 
		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_6 then 
			spineRes = 'event_box1'
			canTouch = true 
		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_7 then 
			spineRes = 'event_box2'
			canTouch = true 
		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_8 then 
			spineRes = 'event_box3'
			canTouch = true 
		elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_9 then 
			spineRes = 'thing3'
			canTouch = true 
		end
	end

	self:showSpine(spineRes);
	if bgSpriteTexture == '' then
		self.bg:setVisible(false);
	else
		self.bg:setVisible(true);
		self.bg:setTexture(bgSpriteTexture)
	end

	if borderTexture == '' then
		self.border:setVisible(false);
	else
		self.border:setVisible(true);
		self.border:setTexture(borderTexture)
	end

	self.clickLayout:setTouchEnabled(canTouch);
end

function EventMapItemTemplate:showSpine( spine_res )
	if spine_res == '' then
		self.spine_res = '';
		if self.itemSpine ~= nil  then
			self.itemSpine:removeFromParent() ;
			self.itemSpine = nil;
		end
		return;
	end
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		if self.itemSpine ~= nil and self.spine_res ~= spine_res then
			self.itemSpine:removeFromParent() ;
			self.itemSpine = nil;
		end
		if self.itemSpine == nil  then
			self.spine_res = spine_res;
			self.itemSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			self.itemSpine:addTo(self)
			self.itemSpine:setAnimation(0, 'idle', true)
		end
	end
end

function EventMapItemTemplate:showDoorSpine( spine_res ,isOpen )
	if self.itemSpine == nil  then
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			self.spine_res = spine_res;
			self.itemSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			self.itemSpine:addTo(self)
		end
	end

	if self.itemSpine ~= nil then
		if not isOpen then
			-- self.itemSpine:setAnimation(0, aniName, true)
		else
			self.itemSpine:setAnimation(0, 'idle', true)
		end
	end

end

function EventMapItemTemplate:setCallback( callfunc )
	self.callfunc = callfunc;
end

function EventMapItemTemplate:clickItem(  )

	-- print('  pos == ',self.pos,'...value == ',self.value,'...posState == ',self.posState,'...isOpen = ',self.isOpen);

	if self.callfunc then
		self.callfunc(self.isOpen,self.posState, self.pos,self.value)
		return ;
	end

	if self.isOpen == false and self.posState == 1 then
		-- 未开启，可点击
		self:runOpenParticleAct();

	elseif self.isOpen == true then
		-- 已开启 且 且可点击
		self:showItemInfo();
	end
end

function EventMapItemTemplate:showItemInfo(  )
	-- print(' ！！！！ show item info:  pos == ',self.pos,'...value == ',self.value);

	if self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_NULL then
		-- do nothing
		GlobalFunctions:showErrorPromt('error ====== 不应有的触摸事件 === pos = '..tostring(self.pos)..'..value == '..tostring(self.value))
	elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_1 then 
		-- show door info
		local doorOpen = model.EventModel:getEventMapDoorState();
		if doorOpen == 2  then
			-- 检测是否有怪物未击杀！
			-- if model.EventModel:checkMonsterNeedKill() then
			-- 	MessageBox:create(LANG.UI_EVENT_30,MessageBoxType.OK);
			-- else
				-- model.EventModel:reqEventMapItemInfo(self.pos,self.value);
			-- end
		else
			-- MessageBox:create(LANG.UI_EVENT_MAP_1,MessageBoxType.OK);
		end

	elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_2 then 
		local doorOpen = model.EventModel:getEventMapDoorState();

		if doorOpen == 1 then
			-- check key
			-- model.EventModel:reqEventMapItemInfo(self.pos,self.value);
		else
			-- check boss
			local fightInfo = model.EventModel:getMapMonsterInfo(self.pos)
			if fightInfo == nil then
				GlobalFunctions:showErrorPromt('error ====== fight info error === pos = '..tostring(self.pos)..'..value == '..tostring(self.value))
			else
				-- dump(fightInfo)
				UIManager:push('RoundInfoPanel', {fightType = FightType.Event, fromPanel = 'EventMapPanel', select_key = self.pos})
			end
		end

	elseif	self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_3 then 
		-- show key monster or boss
		local fightInfo = model.EventModel:getMapMonsterInfo(self.pos)
		if fightInfo == nil then
			GlobalFunctions:showErrorPromt('error ====== fight info error === pos = '..tostring(self.pos)..'..value == '..tostring(self.value))
		else
			-- dump(fightInfo)
			UIManager:push('RoundInfoPanel', {fightType = FightType.Event, fromPanel = 'EventMapPanel', select_key = self.pos})
		end
	elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_4 
		or self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_9 then 
		-- show event thing 1 
		-- local thingInfo = model.EventModel:getMapThingInfo(self.pos) 
		if thingInfo == nil then
			GlobalFunctions:showErrorPromt('error ====== thing info error === pos = '..tostring(self.pos)..'..value == '..tostring(self.value))
		else
			local msgData = {
				text = tostring(thingInfo.info);
				title = tostring(thingInfo.name),
				icon = imagePath..'item_thing_'..self.value..'.png',
				OKLabelName = LANG.UI_FIGHT_29,
			}
			MessageBox:create( msgData,1,function()
				-- model.EventModel:reqEventMapItemInfo(self.pos,self.value);
			end);
		end
	elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_5 then 
		-- do nothing
		GlobalFunctions:showErrorPromt('error ====== 不应有的触摸事件 === pos = '..tostring(self.pos)..'..value == '..tostring(self.value))

	elseif self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_6 or 
		self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_7 or 
		self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_8 then 
		-- show box 1
		-- local boxInfo = model.EventModel:getMapBoxInfo(self.pos) 
		if boxInfo == nil then
			GlobalFunctions:showErrorPromt('error ====== box info error === pos = '..tostring(self.pos)..'..value == '..tostring(self.value))
		else
			-- model.EventModel:reqEventMapItemInfo(self.pos,self.value);
		end
	end

end

-- 切换场景动画
function EventMapItemTemplate:runChangeTierAct( delay,bShowAct )
	if bShowAct ~= true then
		return ;
	end
	local act1 = cc.Sequence:create(
		cc.DelayTime:create(delay),
		cc.Spawn:create(
			cc.ScaleTo:create(3/15,1.3),
			cc.FadeIn:create(3/15)
		),
		cc.ScaleTo:create(5/15,1)
	)
	self:setOpacity(0);
	self:runAction(act1)
end

function EventMapItemTemplate:runItemAct( ... )
	if self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_1  then
		self:runDoorOpenAct();
	elseif  self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_2 then 
		local doorOpen = model.EventModel:getEventMapDoorState();
		if doorOpen == 2 then
			self:runItemRemove(...);
		end
	elseif  self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_4 then 
		self:runItemRemove(...)
	elseif  self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_5 then 
		self:runItemRemove(...)
	elseif  self.value == model.EventModel.EVENT_MAP_ITEM_TYPES.EVENT_MAP_ITEM_TYPE_9 then 
		self:runItemRemove(...)
	end
end

function EventMapItemTemplate:runOpenParticleAct(  )
	local tapeffect1 = cc.ParticleSystemQuad:create("Effect/particle/baoxingxing.plist")
		:addTo(self)
		:setAutoRemoveOnFinish(true)
end

function EventMapItemTemplate:runDoorOpenAct(  )
	if self.itemSpine then
		self.itemSpine:setToSetupPose();
		local aniName1 = 'idle'
		local aniName2 = 'open'

		self.itemSpine:setMix(aniName2,aniName1,0.1);
		self.itemSpine:setAnimation(0, aniName2, false)
		self.itemSpine:addAnimation(0, aniName1, true)
	end
end

function EventMapItemTemplate:runItemRemove( ... )
	self.value  = 0;
	-- self.bg:setVisible(false);
	self.clickLayout:setTouchEnabled(false);
	self:runAction(cc.Sequence:create(cc.DelayTime:create(0.2),cc.CallFunc:create(function (  )
		self.bg:setVisible(false);
		if self.itemSpine then
			self.itemSpine:removeFromParent();
			self.itemSpine = nil;
		end
		self.spine_res = '';
	end )))
end

return EventMapItemTemplate;
