local EventMonster10MapItem = class("EventMonster10MapItem", require("app.template.EventBaseMapItem"))

local fonts = Enum:getTable("SystemFont");
local FightType = Enum:getTable('FightType');
local imagePath = 'image/event/map/';
local MessageBoxType = Enum:getTable('MessageBoxType')
local AnimationType = Enum:getTable('AnimationType');

function EventMonster10MapItem:ctor(pos)

	EventMonster10MapItem.super.ctor(self, pos);

end

function EventMonster10MapItem:showSpine()
	self.aniNode:removeAllChildren();
	if self.tileData.state == 1 then
		if self.tileData.monster then
			local modelName = 'B004_Model'
			local tier = model.EventModel:getTier()
			if tier==1 or tier==2 then
				modelName = 'B005_Model'
			end
			local armature, id = DragonBonesManager:GetArmature(modelName)
			armature:addTo(self.aniNode)
			armature:setScale(0.55);
			armature:setPosition(0, 20)
			armature:getAnimation():play(AnimationType.idle, -1);

			local fpStr, maxLv = model.EventModel:getMonsterFpLv( self.pos )
			local infoNode = cc.Node:create();
			infoNode:addTo(self.aniNode)

			local info1Bg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
			info1Bg:addTo(infoNode)
			info1Bg:setPosition(0, -40)
			info1Bg:setContentSize(cc.size(90, 21))
			local fpIcon = cc.Sprite:create('image/head/head_fp.png')
			fpIcon:setPosition(-35, -40)
			fpIcon:addTo(infoNode)
			fpIcon:setScale(0.5)

			local lvLabel = cc.Label:createWithTTF('LV'..maxLv, fonts.FONT_SIYUAN, 16)
			lvLabel:addTo(infoNode)
			lvLabel:enableOutline(cc.c3b(0,0,0), 2)
			lvLabel:setTextColor(cc.c3b(255,255,0))
			lvLabel:setPosition(40, 100)
			lvLabel:setAnchorPoint(1,0.5)

			local fpLabel = cc.Label:createWithTTF(fpStr, fonts.FONT_SIYUAN, 16)
			fpLabel:addTo(infoNode)
			fpLabel:enableOutline(cc.c3b(0,0,0), 2)
			fpLabel:setPosition(40, -40)
			fpLabel:setAnchorPoint(1,0.5)
		end
	elseif self.tileData.state == 2 then
		local spine_res = 'buff_spine';
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			spine:addTo(self.aniNode)
			spine:setAnimation(0, "buff_spine", true)
		end

	elseif self.tileData.state == 3 then
		local spine_res = 'events_baoxiang_spine';
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			spine:addTo(self.aniNode)
			spine:setAnimation(0, "events_baoxiang_spine", true)
		end

	elseif self.tileData.state == -1 then
		-- local spr = cc.Sprite:create(imagePath..'item_door_1.png')
		-- spr:addTo(self.aniNode)
	end
end

function EventMonster10MapItem:showItemInfo( bclick )
	if self.tileData.state == 1 then --state==1
		UIManager:push('EventRoundInfoPanel', {fightType = FightType.Event, fromPanel = 'EventMapPanel', select_key = self.pos, blook=not bclick})
	elseif self.tileData.state == 2 then
		UIManager:push('EventBuffSelectPanel', self.pos, bclick);
	elseif self.tileData.state == 3 then
		if bclick == false then
			return;
		end
		model.EventModel:reqEventTileInfo( self.pos )
	end
	print('fubin---EventMonster10MapItem---showItem:', self.pos)
end

return EventMonster10MapItem;
