local EventRebornMapItem = class("EventRebornMapItem", require("app.template.EventBaseMapItem"))

local fonts = Enum:getTable("SystemFont");
local FightType = Enum:getTable('FightType');
local imagePath = 'image/event/map/';
local MessageBoxType = Enum:getTable('MessageBoxType')

function EventRebornMapItem:ctor(pos)

	EventRebornMapItem.super.ctor(self, pos);

end

function EventRebornMapItem:showSpine()
	self.aniNode:removeAllChildren();
	if self.tileData.state == 1 then
		local spine_res = 'niaoju_spine';
		if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
			local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			spine:addTo(self.aniNode)
			spine:setAnimation(0, "niaoju_spine", true)
		end
	end
end

function EventRebornMapItem:showItemInfo( bclick )
	if bclick == false then
		return;
	end
	print('fubin---EventRebornMapItem---showItem:', self.pos)
	if self.tileData.state == 1 then
		local msg = ''
		local st = model.EventModel:isHaveDeadRole()
		if st==1 then
			msg = LANG.UI_MAZE_34;
		elseif st==2 then
			msg = LANG.UI_MAZE_34;
		else
			msg = LANG.UI_MAZE_14;
		end

		local callback = function()
				model.EventModel:reqEventTileInfo( self.pos )
				if st == 0 then
					Prompt:Show(LANG.UI_MAZE_24)
				end
			end
		UIManager:push('EventMsgTipPanel', { 
												title = LANG.UI_MAZE_42,
												info = msg,
												icon = imagePath..'item_thing_3.png',
												callback = callback
										 })
		
	end
end

return EventRebornMapItem;