local EventUseToRoleCell = class("EventUseToRoleCell" , function() 
	return ccui.Layout:create();
end)
local fonts = Enum:getTable('SystemFont')

function EventUseToRoleCell:ctor(father)
	self:addTo(father);

	self.itemList = {}

	for i=1,4 do
		local mainNode = cc.Node:create()
		:addTo(self)
		:setPosition(85+(i-1)*136, 90)

		local roleNode = template.ItemTemplate:create()
		:addTo(mainNode)
		roleNode:setItemTag(i)
		roleNode:addItemClickEventListener(handler(self , self.clickBtn));

		local flagNode = cc.Node:create()
		:addTo(mainNode)
		:setPosition(-50, -60)

		local hpBarBg = ccui.Scale9Sprite:create("image/blood/e_hp_bg.png");
		hpBarBg:setContentSize(cc.size(86 , 13));
		hpBarBg:setPosition(cc.p(7 , 0));
		hpBarBg:setAnchorPoint(cc.p(0,0.5))
		hpBarBg:addTo(flagNode);

		local hpGreenProgress = ccui.Scale9Sprite:create("image/blood/e_hp_bar.png");
		hpGreenProgress:setContentSize(cc.size(80 , 7));
		hpGreenProgress:setPosition(cc.p(10 , 0));
		hpGreenProgress:setAnchorPoint(cc.p(0,0.5))
		hpGreenProgress:addTo(flagNode);

		local skillBarBg = ccui.Scale9Sprite:create("image/blood/e_skill_bg.png");
		skillBarBg:setContentSize(cc.size(86 , 10));
		skillBarBg:setPosition(cc.p(7 , -15));
		skillBarBg:setAnchorPoint(cc.p(0,0.5))
		skillBarBg:addTo(flagNode);

		local skillProgress = ccui.Scale9Sprite:create("image/blood/e_skill_bar.png");
		skillProgress:setContentSize(cc.size(80 , 4));
		skillProgress:setPosition(cc.p(10 , -15));
		skillProgress:setAnchorPoint(cc.p(0,0.5))
		skillProgress:addTo(flagNode);

		local deadNode = cc.Node:create()
		deadNode:addTo(mainNode)
		deadNode:setVisible(false)
		local deadBg = cc.Scale9Sprite:create('image/commonImg/bg_1_11_11_34_28.png')
		deadBg:setContentSize(cc.size(100,100))
		deadBg:addTo(deadNode)
		local deadIcon = cc.Sprite:create('image/fight/footernew/dead_icon.png')
		deadIcon:addTo(deadNode)


		table.insert( self.itemList, {mainNode=mainNode, roleNode=roleNode, 
			skillProgress=skillProgress, hpGreenProgress=hpGreenProgress,
			deadNode=deadNode
		} ) 

	end

end

function EventUseToRoleCell:initData( list, tid )
	self.data = list;
	self.tid = tid
	for i=1,4 do
		self.itemList[i].mainNode:setVisible(false)
		if self.data[i] then
			self.itemList[i].mainNode:setVisible(true)
			local card = model.CardModel:GetCard(self.data[i]);
			if card then
				self.itemList[i].roleNode:Init(ROLE_TYPE , card.no,card.star_lv,card.level);
				self.itemList[i].hpGreenProgress:setScaleX(card.event_hp/10000);
				self.itemList[i].skillProgress:setScaleX(card.event_cd/10000);

				self.itemList[i].deadNode:setVisible(card.event_hp <= 0)
			end
		end
	end

end

function EventUseToRoleCell:clickBtn(sender , event)
	local tag = sender:getTag();
	print('fubin--EventUseToRoleCell:clickBtn----:', tag)
	-- EventManager:FireEvent(EventType.UIFutureCardSel, self.data[tag]);
end


return EventUseToRoleCell;