local FightEndShowExpTemplate = class("FightEndShowExpTemplate")
local scheduler = cc.Director:getInstance():getScheduler();

function FightEndShowExpTemplate:ctor(father)
	self.root = cc.Node:create();
	self.father = father;

	self.father:addChild(self.root);

	self.roleNode = require('app.template.CardHeadTemplate'):create(self.root);
	self.roleNode:setPosition(0, 20);
	self.roleNode:setScale(1.4);

	self.expBg = cc.Sprite:create('image/fight/fight_end_bg_exp.png');
	self.expBg:setPosition(0, -75);
	self.root:addChild(self.expBg);

	self.exp = cc.ProgressTimer:create(cc.Sprite:create("image/fight/fight_end_exp.png"));
	self.exp:setType(cc.PROGRESS_TIMER_TYPE_BAR);
    self.exp:setMidpoint(cc.p(0, 0));
    self.exp:setBarChangeRate(cc.p(1, 0));

	self.exp:setPosition(0, -75);
	self.root:addChild(self.exp);

	self.expMark = cc.Sprite:create('image/fight/fight_end_exp_mark.png');
	self.expMark:setPosition(0, -75);
	self.root:addChild(self.expMark);

	self.heartList = {};
	--[[
	for i=1, 5 do
		local bgHeart = cc.Sprite:create('image/fight/fight_end_bg_heart.png');
		bgHeart:setAnchorPoint(cc.p(0,0));
		bgHeart:setPosition(i*32 - 59, -40);
		self.root:addChild(bgHeart);

		self.heartList[i] = cc.Sprite:create('image/fight/fight_end_heart.png');
		self.heartList[i]:setAnchorPoint(cc.p(0,0));
		self.heartList[i]:setPosition(i*32 - 59, -40);
		self.root:addChild(self.heartList[i]);
	end
	self.heartWidth = self.heartList[1]:getContentSize().width;
	self.heartHeight = self.heartList[1]:getContentSize().height;
	--]]
end

function FightEndShowExpTemplate:Init(pid, oldExp, newExp)
	self.roleNode:Init(pid);
	--self:setHeart(1);

	-- exp
	local oldLv = self:findLvByExp(oldExp);
	local oldCurExp, oldMaxExp = self:findCurLvExpByLv(oldExp, oldLv);
	local newLv = self:findLvByExp(newExp);
	local newCurExp, newMaxExp = self:findCurLvExpByLv(newExp, newLv);
	local oldPercent = oldCurExp / oldMaxExp;
	local newPercent = newCurExp / newMaxExp;
	if oldPercent < 0 then
		oldPercent = 0;
	elseif oldPercent > 1 then
		oldPercent = 1;
	end
	oldPercent = math.floor(oldPercent * 100);
	if newPercent < 0 then
		newPercent = 0;
	elseif newPercent > 1 then
		newPercent = 1;
	end
	newPercent = math.floor(newPercent * 100);

	self.exp:setPercentage(oldPercent);
	if oldLv < newLv then
		self.exp:runAction(cc.Sequence:create(cc.ProgressTo:create(0.5, 100), 
		cc.CallFunc:create(function()
			self.exp:setPercentage(0);
			self.roleNode:setNewLevel(newLv);
		end),
		cc.ProgressTo:create(0.5, newPercent)));
	else
		self.exp:runAction(cc.ProgressTo:create(1, newPercent));
	end
end

function FightEndShowExpTemplate:setPosition(x, y)
	self.root:setPosition(x, y);
end

function FightEndShowExpTemplate:setHeart(num)
	for i=1, 5 do
		self.heartList[i]:setVisible(i<=num);
	end	
	if math.floor(num) ~= num then
		local percent = (num-math.floor(num)) / 1;
		local dx = math.floor(self.heartWidth*percent);
		self.heartList[math.floor(num)]:setTextureRect(cc.rect(0, 0, dx, self.heartHeight));
	end
end

function FightEndShowExpTemplate:removeFromParent()
	self.root:removeFromParent();
end

function FightEndShowExpTemplate:findLvByExp( exp )
	local maxLv = 1;
	local tableData = ResTable:getTable("role_lv");
	for k, v in pairs(tableData.contain) do
		if v.lv > maxLv then
			maxLv = v.lv;
		end
	end

	local curLv = 1;
	if tableData.contain[tostring(maxLv)].exp < exp then
		curLv = maxLv;
	else
		for i=1, maxLv do
			local preExp = 0
			if i > 1 then
				preExp = tableData.contain[tostring(i-1)].exp;
			end
			if (exp >= preExp) and (exp < tableData.contain[tostring(i)].exp) then
				curLv = i;
				break;
			end
		end
	end

	return curLv;
end

function FightEndShowExpTemplate:findCurLvExpByLv( exp, lv )
	local maxLv = 1;
	local tableData = ResTable:getTable("role_lv");
	for k, v in pairs(tableData.contain) do
		if v.lv > maxLv then
			maxLv = v.lv;
		end
	end

	local preExp = 0;
	if lv > 1 then
		preExp = tableData.contain[tostring(lv-1)].exp;
	end
	local curMaxExp = tableData.contain[tostring(lv)].exp - preExp;
	local curExp = exp - preExp;

	return curExp, curMaxExp;
end

return FightEndShowExpTemplate;
