local FutureCardSelCell = class("FutureCardSelCell" , function() 
	return ccui.Layout:create();
end)
local fonts = Enum:getTable('SystemFont')

function FutureCardSelCell:ctor(father)
	self:addTo(father);

	self.itemList = {}

	for i=1,5 do
		local mainNode = cc.Node:create()
		:addTo(self)
		:setPosition(60+(i-1)*110, 50)

		local roleNode = template.ItemTemplate:create()
		:addTo(mainNode)
		roleNode:setItemTag(i)
		roleNode:addItemClickEventListener(handler(self , self.clickBtn));

		local flagNode = cc.Node:create()
		:addTo(mainNode)
		:setVisible(false)
		local flagSpr = cc.Sprite:create('image/commonImg/ok_icon.png')
		:addTo(flagNode)

		table.insert( self.itemList, {mainNode=mainNode, roleNode=roleNode, flagNode=flagNode} )

	end

	self.SelPid = -1
	EventManager:RegisterEvent(EventType.UIFutureCardSel, handler(self, self.selOneCard));

end

function FutureCardSelCell:initData( list, sid )
	self.data = list;
	self.sid = sid;
	self.SelPid = -1
	for i=1,5 do
		self.itemList[i].mainNode:setVisible(false)
		if self.data[i] then
			local card = model.CardModel:GetCard(self.data[i]);
			if card then
				self.itemList[i].roleNode:Init(ROLE_TYPE , card.no,card.star_lv,card.level,self.data[i]);
				self.itemList[i].mainNode:setVisible(true)
				self.itemList[i].flagNode:setVisible(false)
			end
		end
	end

end

function FutureCardSelCell:selOneCard( pid )
	self.SelPid = pid
	for i=1,5 do
		if self.itemList[i].mainNode:isVisible() then
			if self.data[i] == self.SelPid then
				self.itemList[i].flagNode:setVisible(true)
			else
				self.itemList[i].flagNode:setVisible(false)
			end
		end
	end
end

function FutureCardSelCell:clickBtn(sender , event)
	local tag = sender:getTag();
	EventManager:FireEvent(EventType.UIFutureCardSel, self.data[tag]);
end


return FutureCardSelCell;