local GemListCell = class("GemListCell" , function() 
	return ccui.Layout:create();
end)
local fonts = Enum:getTable('SystemFont')

function GemListCell:ctor(father)
	self:addTo(father);

	self.mainNode = cc.Node:create();
	self.mainNode:addTo(self)
	self.mainNode:setPosition(290,80)

	-- local infobg = ccui.Scale9Sprite:create("image/commonImg/common_tips_bg_s2.png");
	local infobg = ccui.Scale9Sprite:create("image/commonImg/bg_4_563_126.png");
	infobg:setContentSize(cc.size(570 , 140));
	infobg:addTo(self.mainNode);

	self.qualityBg = cc.Sprite:create('image/commonImg/item_quality_2.png') --cc.p(103,103)
		:addTo(self.mainNode)
		:setPosition(-220, 0)

	self.iconSpr = cc.Sprite:create();
	self.iconSpr:addTo(self.mainNode)
	self.iconSpr:setPosition(-220, 0)

	self.atkName = cc.Label:createWithTTF('攻击', fonts.FONT_SIYUAN, 18);
	self.atkName:addTo(self.mainNode);
	self.atkName:setAnchorPoint(cc.p(0,0.5))
	self.atkName:setPosition(-150, 30);
	self.atkName:enableOutline(cc.c3b(210 , 80 , 10),2);

	self.atkVal = cc.Label:createWithTTF('+999.99k', fonts.FONT_SIYUAN, 18);
	self.atkVal:addTo(self.mainNode);
	self.atkVal:setAnchorPoint(cc.p(0,0.5))
	self.atkVal:setPosition(-80, 30);
	self.atkVal:enableOutline(cc.c4b(0 , 0 , 0 ,255),2);


	self.hpName = cc.Label:createWithTTF('防御', fonts.FONT_SIYUAN, 18);
	self.hpName:addTo(self.mainNode);
	self.hpName:setAnchorPoint(cc.p(0,0.5))
	self.hpName:setPosition(-150, 0);
	self.hpName:enableOutline(cc.c3b(30 , 90 , 190),2);

	self.hpVal = cc.Label:createWithTTF('+874754', fonts.FONT_SIYUAN, 18);
	self.hpVal:addTo(self.mainNode);
	self.hpVal:setAnchorPoint(cc.p(0,0.5))
	self.hpVal:setPosition(-80, 0);
	self.hpVal:enableOutline(cc.c4b(0 , 0 , 0 ,255),2);

	self.skillNames = cc.Label:createWithTTF('[肥而不腻] [天下无贼]', fonts.FONT_SIYUAN, 18);
	self.skillNames:addTo(self.mainNode);
	self.skillNames:setAnchorPoint(cc.p(0,0.5))
	self.skillNames:setPosition(-150, -30);
	self.skillNames:enableOutline(cc.c4b(0 , 0 , 0 ,255),2);

	self.useTipNode = cc.Node:create()
	self.useTipNode:addTo(self.mainNode)
	self.useTipNode:setPosition(100,0)
	local tipSpr = cc.Sprite:create('image/commonImg/tip_2_19_19.png')
	:addTo(self.useTipNode)
	self.tipLabel = cc.Label:createWithTTF('12星卡可用', fonts.FONT_SIYUAN, 20);
	self.tipLabel:addTo(self.useTipNode);
	self.tipLabel:setAnchorPoint(cc.p(0,0.5))
	self.tipLabel:setPosition(20, 0);
	self.tipLabel:enableOutline(cc.c4b(0 , 0 , 0 ,255),2);
	self.useTipNode:setVisible(false)

	local label = cc.Label:createWithTTF('合成' , fonts.FONT_SIYUAN , 20)
	:enableOutline(cc.c3b(55 , 85 , 155) , 2)
	self.btn = ccui.Button:create('image/commonImg/btn_1_169_55.png');
	self.btn:addTo(self.mainNode);
	self.btn:setPosition(210, 30)
	self.btn:addClickEventListener(handler(self, self.clickBtn));
	self.btn:setTitleLabel(label);
	self.btn:setContentSize(cc.size(120 , 55))
	self.btn:setScale9Enabled(true)
	-- self.btn:setVisible(false)


	local label = cc.Label:createWithTTF('重铸' , fonts.FONT_SIYUAN , 20)
	:enableOutline(cc.c3b(55 , 85 , 155) , 2)
	self.recastbtn = ccui.Button:create('image/commonImg/btn_1_169_55.png');
	self.recastbtn:addTo(self.mainNode);
	self.recastbtn:setPosition(210, -30)
	self.recastbtn:addClickEventListener(handler(self, self.clickRecastBtn));
	self.recastbtn:setTitleLabel(label);
	self.recastbtn:setContentSize(cc.size(120 , 55))
	self.recastbtn:setScale9Enabled(true)

end

function GemListCell:initData( itemId )
	self.itemId = itemId;

	-- local data = ResTable:getRowData('skill', skillid)
	-- if not data then
	-- 	return;
	-- end
	-- self.iconSpr:setTexture( "image/skillicon/"..data.icon..".png" )
	-- self.skillName:setString( data.name )
	-- self.skillDes:setString( data.info )

end

function GemListCell:setCallBack( callback )
	self.callback = callback;
end

function GemListCell:clickBtn(sender , event)
	UIManager:push('GemComposePanel');
end

function GemListCell:clickRecastBtn(sender , event)
	UIManager:push('GemRecastPanel');
end


return GemListCell;