local GetTemplate = class("GetTemplate")

function GetTemplate:ctor(father)
	self.root = cc.Node:create();
	self.father = father;

	self.father:addChild(self.root);

	self.get = cc.Sprite:create('image/commonImg/geted.png');
	self.get:addTo(self.root);
	self.get:setVisible(false);

	local spine_res = 'get_spine';
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.skeleton = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.skeleton:addTo(self.root)
		self.skeleton:registerSpineEventHandler(function (event)
			if event.eventData.name == 'get.plist' then
				local effect = cc.ParticleSystemQuad:create('Effect/particle/get.plist');
				effect:addTo(self.root);
				effect:setAutoRemoveOnFinish(true)
			end
		end, sp.EventType.ANIMATION_EVENT)
		self.skeleton:registerSpineEventHandler(function (event)
			self:setState(2);
			self.skeleton:setVisible(false);
			if self.callback then
				self.root:runAction(cc.Sequence:create(cc.DelayTime:create(0.2),cc.CallFunc:create(function()
					self.callback();
					self.callback = nil;
				end)));
			end
		end, sp.EventType.ANIMATION_COMPLETE)
	end
end

function GetTemplate:setState(state)
	self.get:setVisible(state == 2);
end

function GetTemplate:showAction(callback)
	self.callback = callback;
	self.get:setVisible(false);
	self.skeleton:setVisible(true);
	self.skeleton:clearTracks();
	self.skeleton:addAnimation(0, GlobalFunctions:lAnimationName('get_spine') , false);
end

function GetTemplate:setPosition(x, y)
	self.root:setPosition(x, y);
end

function GetTemplate:setVisible(visible)
	self.root:setVisible(visible);
end

return GetTemplate;
