local GuildChatItemTemplate = class("GuildChatItemTemplate",function (  )
	return cc.Node:create();
end)


local fonts = Enum:getTable("SystemFont")

function GuildChatItemTemplate:ctor()

	self.uid = 0;

	self:initItem()

end

function GuildChatItemTemplate:initItem( )

	self.bg = cc.Sprite:create('image/guild/guild_chat_item_bg.png')
		:addTo(self)
	
	self.iconNode = cc.Node:create();
	self.iconNode:addTo(self);
	self.iconNode:setPosition(cc.p(-214,0));

	local headIconBg = cc.Sprite:create("image/commonImg/icon_role_2.png");
	headIconBg:addTo(self.iconNode);

	self.icon = cc.Sprite:create();
	local stencil = cc.Sprite:create('image/commonImg/icon_clipping_bg.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:addChild(self.icon);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:addTo(self.iconNode);

	local onlineBg = cc.Sprite:create('image/commonImg/online_bg_1.png')
	onlineBg:addTo(self.iconNode);
	onlineBg:setPosition(cc.p(35,35))

	self.headOnlineSp = cc.Sprite:create('image/commonImg/online_bg_2.png');
	self.headOnlineSp:setPosition(cc.p(35,35));
	self.headOnlineSp:addTo(self.iconNode);

	self.name = cc.Label:createWithTTF('name' , fonts.FONT_SIYUAN , 20)
		:addTo(self)
		:setPosition(cc.p(-131 , 39))
		:setAnchorPoint(cc.p(0 , 0.5))

	self.time = cc.Label:createWithTTF('01-11 01:01' , fonts.FONT_SIYUAN , 16)
		:addTo(self)
		:setAnchorPoint(1,0.5)
		:setPosition(cc.p(214 , 39))
	

	self.flagBg = cc.Sprite:create();
	self.flagBg:addTo(self);
	self.flagBg:setPosition(cc.p(245 , 35));


	self.text = cc.Label:createWithTTF('' , fonts.FONT_HUAKANG , 18)
		:addTo(self)
		:setContentSize(cc.size(396 , 56))
		:setLineBreakWithoutSpace(true)
		:setMaxLineWidth(396)
		:setAnchorPoint(cc.p(0 , 1))
		:setPosition(-134 , 8)


	self:setVisible(true);
end


function GuildChatItemTemplate:initData(data)
	if not data then
		return;
	end

	local myUid = model.UserModel:getUserUid();

	local loginTime = data.login or 0;

	if tostring(data.uid) == tostring(myUid) then
		loginTime = TimeManager:getCurTime()
		self.bg:setTexture('image/guild/main_info/chat_bg_2.png');

		data.head_icon = model.UserModel:getHeadIcon()
	else
		self.bg:setTexture('image/guild/main_info/chat_bg_1.png');
	end

	if data.head_icon == nil or data.head_icon == 0 then
		data.head_icon = 1
	end
	local headIconFile = GlobalFunctions:getHeadIconFile(data.head_icon)
	self.icon:setTexture(headIconFile);
	
	self.name:setString(tostring(data.name));
	self.text:setString(data.message);

	local timestamp = data.message_time;
	local timeStr = os.date("%m-%d %H:%M",timestamp);

	self.time:setString(timeStr);
	
	if data.guild_flag == 2 then
		self.flagBg:setVisible(false);
		self.time:setPositionX(245);
	else
		self.time:setPositionX(214);
		self.flagBg:setTexture('image/guild/main_info/'..(data.guild_flag == 0 and 'manager_icon_1' or 'manager_icon_2')..'.png');
	end

	local loginTimeStr = GlobalFunctions:convertTimeEnumType(loginTime);
	self.headOnlineSp:setVisible(loginTimeStr == Enum:getTable('TimeEnum').TimeEnumNow)
end

return GuildChatItemTemplate;
