local GuildJoinItemTemplate = class("GuildJoinItemTemplate",function (  )
	return cc.Node:create();
end)

local fonts = Enum:getTable("SystemFont")

function GuildJoinItemTemplate:ctor()
	self.callback = nil;

	self:initItem();
end

function GuildJoinItemTemplate:initItem(  )

	self.guildIcon = cc.Sprite:create('image/guild/guild_icon/icon_bg.png')
		:addTo(self)
		:setScale(0.25)
	local size = self.guildIcon:getContentSize()
	self.icon = cc.Sprite:create()
		:addTo(self.guildIcon)
		:setPosition(size.width/2,size.height/2)

	self.guildName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18)
		:addTo(self)
		:setAnchorPoint(cc.p(0 , 0.5))
	
	self.applyLabel = cc.Label:createWithTTF(LANG.UI_GUILD_8, fonts.FONT_SIYUAN, 16)

	self.applyBtn = ccui.Button:create('image/guild/not_join/not_join_btn_2.png','','image/guild/not_join/not_join_btn_2.png')
	self.applyBtn:addTo(self)
		:setPosition(cc.p(31,-17))
		:setTitleLabel(self.applyLabel)
		:addClickEventListener(handler(self , self.joinSearchBtnClick))	

	self.line = cc.Sprite:create('image/commonImg/line.png')
		:addTo(self)
		:setPosition(0,-40)
		:setContentSize(cc.size(244,1))

	self.roleIcon = cc.Sprite:create('image/guild/not_join/not_join_bg_5.png')
		:addTo(self)
		:setPosition(35,0)

	self.memberNum = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 18)
		:addTo(self)
		:setPosition(90,0)
end

function GuildJoinItemTemplate:initData(data,type)
	if not data then
		return;
	end
	self.gid = data.gid;
	self.is_apply = data.is_apply;

	self.guildName:setString(tostring(data.name or '')..' '..string.format( "Lv %s",tostring(data.level or 0) ));
	
	self:setApplyJoin(self.is_apply ~= 0)

	if data.icon == nil or data.icon < 1 or data.icon > 5 then
		data.icon = 1;
	end
	self.icon:setTexture('res/image/guild/guild_icon/icon_'..data.icon..'.png');

	if type == 2 then
		self.guildIcon:setPosition(-252 , 0)
		self.guildName:setPosition(cc.p(-215 , 0))
		self.applyBtn:setPosition(cc.p(205,0))
		self.line:setPosition(0,-34)
		self.line:setContentSize(cc.size(580,1))
		self.roleIcon:setVisible(true)

		if data.level > 0 then
			local curGuildLv = ResTable:getRowData('guild_lv' , data.level);
			if curGuildLv then
				self.memberNum:setString('['..tostring(data.member_count or 0)..'/'..tostring(curGuildLv['num'])..']');
			end
		else
			self.memberNum:setString('['..tostring(data.member_count or 0)..']');
		end
	else
		self.guildIcon:setPosition(-88 , 0)
		self.guildName:setPosition(cc.p(-40 , 18))
		self.applyBtn:setPosition(cc.p(31,-17))
		self.line:setPosition(0,-40)
		self.line:setContentSize(cc.size(244,1))
		self.roleIcon:setVisible(false)
	end
end

function GuildJoinItemTemplate:joinSearchBtnClick(sender , event)
	-- local index = sender:getTag();

	-- local item = self.joinAllGuildList[index];
	-- if not item then
	-- 	return;
	-- end
	if self.is_apply ~= 0 then
		Prompt:Show(LANG.UI_GUILD_7);
		-- print(' 已申请==== ，倒计时：',self.apply_time)
		return 
	end

	model.GuildModel:applyJoinGuild(self.gid);
end

function GuildJoinItemTemplate:setApplyJoin(isJoin)

	if isJoin == true then
		self.applyLabel:setString(LANG.UI_GUILD_7)
		self.applyBtn:setBright(false);
		self.applyBtn:setTouchEnabled(false);
	else
		self.applyLabel:setString(LANG.UI_GUILD_8)
		self.applyBtn:setBright(true);
		self.applyBtn:setTouchEnabled(true);

	end
end

return GuildJoinItemTemplate;
