local GuildMemberTemplate = class("GuildMemberTemplate",function (  )
	return cc.Node:create();
end)


local fonts = Enum:getTable("SystemFont")

function GuildMemberTemplate:ctor()
	self:initItem();
end

function GuildMemberTemplate:initItem(  )

	self.bg = cc.Sprite:create()
		:addTo(self)

	self.infoNode = cc.Node:create();
	self.infoNode:addTo(self);

	self.iconNode = cc.Node:create();
	self.iconNode:addTo(self.infoNode);
	self.iconNode:setPosition(cc.p(-216,-1));

	local headIconBg = ccui.Button:create("image/commonImg/icon_role_2.png" , "image/commonImg/icon_role_2.png");
	headIconBg:addTo(self.iconNode);
	headIconBg:addClickEventListener(handler(self , self.headBtnClick));

	self.icon = cc.Sprite:create();
	local stencil = cc.Sprite:create('image/commonImg/icon_clipping_bg.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:addChild(self.icon);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:addTo(self.iconNode);

	local onlineBg = cc.Sprite:create('image/commonImg/online_bg_1.png')
	onlineBg:addTo(self.iconNode);
	onlineBg:setPosition(cc.p(35,35))

	self.headOnlineSp = cc.Sprite:create('image/commonImg/online_bg_2.png');
	self.headOnlineSp:setPosition(cc.p(35,35));
	self.headOnlineSp:addTo(self.iconNode);

	--self.headMask = cc.Sprite:create('image/commonImg/mask_icon.png');
	--self.headMask:addTo(iconNode);
	--self.headMask:setContentSize(cc.size(100,110));
	--self.headMask:setVisible(false);

	self.name = cc.Label:createWithTTF('name' , fonts.FONT_SIYUAN , 22)
		:addTo(self.infoNode)
		:setAnchorPoint(cc.p(0,0.5))
		:setPosition(cc.p(-131 , 29))

	self.loginLabel = cc.Label:createWithTTF('login' , fonts.FONT_SIYUAN , 16)
		:addTo(self.infoNode)
		:setAnchorPoint(cc.p(0,0.5))
		:setPosition(cc.p(20 , 29))

	self.level = cc.Label:createWithTTF('LV 999' , fonts.FONT_SIYUAN , 16)
		:addTo(self.infoNode)
		:setPosition(cc.p(191 , 29))
		:setAnchorPoint(cc.p(1,0.5))

	self.managerIcon = cc.Sprite:create()
		:addTo(self.infoNode)
		:setPosition(cc.p(235,27))
		:setVisible(false);

	self.fpLabel = cc.Label:createWithTTF(LANG.UI_GUILD_4 , fonts.FONT_SIYUAN , 18)
		:addTo(self.infoNode)
		:setPosition(cc.p(-101 , -29))
		:setTextColor(cc.c4b(255 , 255 , 0 , 255))

	self.fp = cc.Label:createWithTTF('9999999' , fonts.FONT_SIYUAN , 18);
	self.fp:addTo(self.infoNode);
	self.fp:setPosition(cc.p(-48 , -29));
	self.fp:setAnchorPoint(cc.p(0 , 0.5));

	--捐献
	self.donateLabel = cc.Label:createWithTTF(LANG.UI_GUILD_11 , fonts.FONT_SIYUAN , 20)
		:addTo(self.infoNode)
		:setPosition(cc.p(109 , -29))
		:setTextColor(cc.c4b(255 , 255 , 0 , 255))

	self.donate = cc.Label:createWithTTF('name' , fonts.FONT_SIYUAN , 20);
	self.donate:addTo(self.infoNode);
	self.donate:setPosition(cc.p(246 , -29));
	self.donate:setAnchorPoint(cc.p(1 , 0.5));

	--底部增加一部分内容
	self.applyNode = cc.Node:create();
	self.applyNode:addTo(self);
	self.applyNode:setVisible(false);
	self.applyNode:setPosition(0,-54)

	local line = cc.Sprite:create('image/commonImg/line.png');
    line:addTo(self.applyNode);
	line:setPosition(0,27);
	line:setContentSize(cc.size(558,1));
	
	-- self.bg2 = cc.Sprite:create('image/guild/member/member_bg2.png');
	-- self.bg2:addTo(self.applyNode);
	-- self.bg2:setPosition(cc.p(0,-85))
	local label2 = cc.Label:createWithTTF(LANG.COMMON_REFUSE, fonts.FONT_SIYUAN, 17)
		:setTextColor(cc.c4b(60 , 60 , 60 , 255))
		:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2)
	self.refuseBtn = ccui.Button:create('image/commonImg/btn_3_103_3.png');
	self.refuseBtn:addClickEventListener(handler(self , self.notApplyBtnClick));
	self.refuseBtn:setTitleLabel(label2);
	self.refuseBtn:addTo(self.applyNode)
	self.refuseBtn:setPosition(cc.p(-64 , 0));

	local label1 = cc.Label:createWithTTF(LANG.COMMON_AGREE, fonts.FONT_SIYUAN, 17)
		:setTextColor(cc.c4b(255 , 255 , 255 , 255))
		:enableOutline(cc.c4b(55 , 85 , 155 , 255) , 2)
	self.applyBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png');
	self.applyBtn:setTitleLabel(label1);
	self.applyBtn:addClickEventListener(handler(self , self.applyBtnClick));
	-- self:addChild(self.applyBtn);
	self.applyBtn:addTo(self.applyNode);
	self.applyBtn:setPosition(cc.p(64 , 0));
end

function GuildMemberTemplate:initData(data , index)
	if not data then
		return;
	end

	if index == 1 then--面板单
		self.iconNode:setPosition(cc.p(-225,-1));
		self.iconNode:setScale(1);
		self.name:setPosition(cc.p(-139 , 29))
		self.level:setPosition(cc.p(205 , 29))
		self.managerIcon:setPosition(cc.p(248,27))
		self.fpLabel:setPosition(cc.p(-108 , -29))
		self.fp:setPosition(cc.p(-56 , -29));
		self.donateLabel:setPosition(cc.p(123 , -29))
		self.donate:setPosition(cc.p(260 , -29));
		self.loginLabel:setString('')
	elseif index == 3 then--申请列表
		self.iconNode:setPosition(cc.p(-222,22));
		self.iconNode:setScale(0.9);
		self.name:setPosition(cc.p(-131 , 56))
		self.level:setPosition(cc.p(250 , 56))
		self.fpLabel:setPosition(cc.p(-101 , 4))
		self.fp:setPosition(cc.p(-48 , 4))
		self.donateLabel:setPosition(cc.p(127 , 4))
		self.donate:setPosition(cc.p(248 , 4))
		self.loginLabel:setString('')
	else--成员列表
		self.iconNode:setPosition(cc.p(-216,-1));
		self.iconNode:setScale(1);
		self.name:setPosition(cc.p(-131 , 29))
		self.level:setPosition(cc.p(191 , 29))
		self.managerIcon:setPosition(cc.p(235,27))
		self.fpLabel:setPosition(cc.p(-101 , -29))
		self.fp:setPosition(cc.p(-48 , -29));
		self.donateLabel:setPosition(cc.p(109 , -29))
		self.donate:setPosition(cc.p(246 , -29));

		if data.login then
			local lastDay = GlobalFunctions:getLastDay(data.login)
			if lastDay==0 then
				self.loginLabel:setString(LANG.UI_COMMON_4)
			elseif lastDay>=7 then
				self.loginLabel:setString(string.format(LANG.UI_COMMON_5,7))
			else
				self.loginLabel:setString(string.format(LANG.UI_COMMON_5,lastDay))
			end
		else
			self.loginLabel:setString('')
		end
	end

	self.index = index;
	self.uid = data.uid;

	self.name:setString(tostring(data.name));
	self.fp:setString(tostring(data.top_power));
	self.level:setString('Lv  '..tostring(data.level));
	self:setManager(data.guild_flag)
	-- self.applyNode:setVisible(index == 3);
	if index == 3 then
		self.applyNode:setVisible(true);
	end
	if data.head_icon == nil or data.head_icon == 0 then
		data.head_icon = 1
	end

	local loginTime = data.login or 0;
	if data.uid == model.UserModel:getUserUid() then
		--玩家自己总是在线
		loginTime = TimeManager:getCurTime()
		data.head_icon = model.UserModel:getHeadIcon()
	end

	local headIconFile = GlobalFunctions:getHeadIconFile(data.head_icon)
	self.icon:setTexture(headIconFile);

	if index == 1 then
		self.bg:setTexture('image/guild/main_info/main_info_top_bg.png');
	elseif index == 3 then
		self.bg:setTexture('image/guild/main_info/main_info_bg_6.png');
	else
		if data.uid == model.UserModel:getUserUid() then
			self.bg:setTexture('image/guild/main_info/main_info_bg_1.png');
		else
			self.bg:setTexture('image/guild/main_info/main_info_bg_2.png');
		end
	end

	local loginTimeStr = GlobalFunctions:convertTimeEnumType(loginTime);
	self.headOnlineSp:setVisible(loginTimeStr == Enum:getTable('TimeEnum').TimeEnumNow);

	if index == 1 or index == 2 then
		self.donate:setString(tostring(data.donate_today));
		self.donateLabel:setString(LANG.UI_GUILD_11);
	else
		local time1 = data.apply_time or 0;
		if time1 == 0 then
			time1 = TimeManager:getCurTime();
		end
		local applyTime = os.date("%m/%d %H:%M",time1);
		self.donate:setString(applyTime);
		self.donateLabel:setString(LANG.UI_GUILD_8);

		local width = self.donate:getContentSize().width;
		local labelWidth = self.donateLabel:getContentSize().width;
		self.donateLabel:setPositionX(self.donate:getPositionX()-width-labelWidth/2-10);
	end
end
function GuildMemberTemplate:headBtnClick(sender , event)
	if self.index == 2 then
		-- 只有公会成员才能查看详情
		UIManager:push('GuildMemberDetailPanel',self.uid,self.index);
	end
end

function GuildMemberTemplate:applyBtnClick(sender , event)
	if model.GuildModel:getGuildInfo().guild_flag > 1 then
		Prompt:Show(LANG.ERROR_INFO[9518]);
		return;
	end
	local uidList = {};
	table.insert(uidList , self.uid);
	model.GuildModel:reqGuildApply(uidList);
end

function GuildMemberTemplate:notApplyBtnClick(sender , event)
	if model.GuildModel:getGuildInfo().guild_flag > 1 then
		Prompt:Show(LANG.ERROR_INFO[9518]);
		return;
	end
	local uidList = {};
	table.insert(uidList , self.uid);
	model.GuildModel:reqGuildNotApply(uidList);
end

function GuildMemberTemplate:setManager(guildFlag)
	if guildFlag == nil or  guildFlag > 1 then

		if self.index == 1 then
			self.level:setPositionX(260);
		elseif self.index == 2 then
			self.level:setPositionX(240);
		end
		self.managerIcon:setVisible(false);
	else
		if self.index == 1 then
			self.level:setPositionX(205);
		else
			self.level:setPositionX(191);
		end
		self.managerIcon:setVisible(true)
		self.managerIcon:setTexture('image/guild/main_info/'..(guildFlag == 0 and 'manager_icon_1' or 'manager_icon_2')..'.png');
	end
end

return GuildMemberTemplate;
