local GuildRaidRankRewardTemplate = class("GuildRaidRankRewardTemplate" , function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")

function GuildRaidRankRewardTemplate:ctor()
	
	local bg = cc.Sprite:create('image/guild/raid_rank/raid_rank_7.png')
	bg:addTo(self)

	local bg = cc.Sprite:create('image/guild/raid_rank/raid_rank_6.png')
	bg:addTo(self)
	bg:setPosition(2 , -17)

	self.rewardName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.rewardName:addTo(self);
	self.rewardName:setAnchorPoint(0 , 0.5);
	self.rewardName:setPosition(-183 , 59);

	self.rewardListView = ccui.ScrollView:create();
	self.rewardListView:setDirection(ccui.ScrollViewDir.horizontal);
	self.rewardListView:setContentSize(cc.size(370, 102));
	self.rewardListView:setScrollBarEnabled(false);
	self.rewardListView:addTo(self);
	self.rewardListView:setAnchorPoint(cc.p(0.5,0.5));
	self.rewardListView:setPosition(cc.p(2,-17));
end

function GuildRaidRankRewardTemplate:Init(data)

	local rewards = data.reward;

	local rewardNum = #rewards;

	local maxWidth = rewardNum * 103;
	maxWidth = maxWidth < 370 and 370 or maxWidth;
	self.rewardListView:removeAllChildren();
	self.rewardListView:setInnerContainerSize(cc.size(maxWidth, 103));
	for i=1, rewardNum do
		local r = rewards[i];
		local icon = template.ItemTemplate:create();
		icon:Init(r[1] , r[2]);
		icon:addTo(self.rewardListView)
		icon:setPosition(51.5 + 103 * (i - 1) , 51.5);
		icon:setScale(0.8);
	end
	self.rewardListView:setTouchEnabled(rewardNum > 4);
	if data.ranking_min == 1 then
		self.rewardName:setString(tostring(data.ranking_min));
	else
		self.rewardName:setString(tostring(data.ranking_min)..'-'..tostring(data.ranking_max));
	end
	
end


return GuildRaidRankRewardTemplate;
