local GuildRaidRankTemplate = class("GuildRaidRankTemplate" , function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")

function GuildRaidRankTemplate:ctor()
	
	self.bg = cc.Sprite:create()
	self.bg:addTo(self)

	self.rankImg = cc.Sprite:create();
	self.rankImg:addTo(self);
	self.rankImg:setPosition(-243 , 1)

	self.rankNum = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.rankNum:addTo(self);
	self.rankNum:setPosition(-243 , 1);

	self.rankName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.rankName:addTo(self);
	self.rankName:setAnchorPoint(0 , 0.5);
	self.rankName:setPosition(-201 , 0);

	local bg = cc.Sprite:create('image/guild/raid_rank/raid_rank_5.png');
	bg:addTo(self);
	bg:setPosition(157 , 0);

	local bg = cc.Sprite:create('image/guild/raid_rank/raid_rank_4.png');
	bg:addTo(self);
	bg:setPosition(71 , 0);

	local label = cc.Label:createWithTTF(LANG.UI_GUILD_RAID_RANK_5 , fonts.FONT_SIYUAN , 17);
	label:addTo(self);
	label:setAnchorPoint(0 , 0.5);
	label:setPosition(89 , 0);

	self.damage = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.damage:addTo(self);
	self.damage:setPosition(204 , 0);
end

function GuildRaidRankTemplate:Init(rank,data,rankType)

	if rankType == 1 then
		local curGid = model.GuildModel:getGuildInfo().gid;
		if curGid == data.gid then
			self.bg:setTexture('image/guild/raid_rank/raid_rank_3.png');
		else
			self.bg:setTexture('image/guild/raid_rank/raid_rank_2.png');
		end
	else
		local curUid = model.UserModel:getUserUid();
		if curUid == data.uid then
			self.bg:setTexture('image/guild/raid_rank/raid_rank_3.png');
		else
			self.bg:setTexture('image/guild/raid_rank/raid_rank_2.png');
		end
	end

	self.rankImg:setVisible(true);
	self.rankNum:setVisible(false);
	if rank == 1 then
		self.rankImg:setTexture('image/guild/raid_rank/rank_1.png');
	elseif rank == 2 then
		self.rankImg:setTexture('image/guild/raid_rank/rank_2.png');
	elseif rank == 3 then
		self.rankImg:setTexture('image/guild/raid_rank/rank_3.png');
	else
		self.rankImg:setVisible(false);
		self.rankNum:setVisible(true);
		self.rankNum:setString(tostring(rank));
	end

	self.rankName:setString(tostring(data.name));
	self.damage:setString(ConvertStrToDigitUnit(tostring(data.damage)));
end


return GuildRaidRankTemplate;
