 local HomeBaseItemTemplate = class('HomeBaseItemTemplate',function (  )
	return cc.Node:create();
end) 
local fonts = Enum:getTable('SystemFont')
local imagePath = 'image/home/'

local skillProgressPos = {
	[1] = {cc.p(-42 , -70), 'home_base_skill_progress_1.png'},
	[2] = {cc.p(-42 , -59), 'home_base_skill_progress_1.png'},
	[3] = {cc.p(-42 , -48), 'home_base_skill_progress_1.png'},
	[4] = {cc.p(-40 , -36), 'home_base_skill_progress_2.png'},
	[5] = {cc.p(-40 , -25), 'home_base_skill_progress_2.png'},
	[6] = {cc.p(-40 , -14), 'home_base_skill_progress_2.png'},
	[7] = {cc.p(-39 , -3), 'home_base_skill_progress_3.png'},
	[8] = {cc.p(-39 , 7), 'home_base_skill_progress_3.png'},
	[9] = {cc.p(-39 , 17), 'home_base_skill_progress_3.png'},
	[10] = {cc.p(-39 , 27), 'home_base_skill_progress_3.png'},
}

local homeBtnType = {
	[1] = 'equip',
	[2] = 'skill',
	[3] = 'library',
	[4] = 'card',
	[5] = 'treatment',
	[6] = 'trial',
	[7] = 'cardCompose',
	[8] = 'randomShop',
}

local scaleX = {
	[1] = 1,-- 军械库
	[2] = 1,-- 爱恋 
	[3] = 1,-- 图书馆
	[4] = -1,-- 重构中心
	[5] = -1,-- 竞技场--TAG_TREATMENT
	[6] = 1,-- 试炼之战
	[7] = 1,-- 融合中心
	[8] = -1,-- 随机商店
	[9] = 1,-- 每日副本
	[10] = 1,-- 共鸣水晶
}

local labelPosX = {
	[1] = 18,
	[2] = 18,
	[3] = 18,
	[4] = -13,
	[5] = -13,
	[6] = 18,
	[7] = 18,
	[8] = -13,
	[9] = 18,
	[10] = 18,
}

function HomeBaseItemTemplate:ctor(btnType)
	
	self.itemType = -1;
	self.startSchedule = true;
	self.btnType = btnType;

    self:InitItem();

end

function HomeBaseItemTemplate:InitItem(  )
	self.root = self;
	self.root:setCascadeOpacityEnabled(true);

	-- local node = cc.Node:create();
	-- node:addTo(self.root);
	-- node:setPosition(homeBtnPos[i]);

	local btn =  ccui.Button:create(imagePath..'home_btn_1.png',imagePath..'home_btn_1.png');
	btn:addTo(self);
	btn:addClickEventListener(handler(self , self.homeBtnClick));
	btn:setAlphaTouchEnable(true);
	btn:setScaleX(scaleX[self.btnType]);

	self.itemLabel = cc.Label:createWithTTF(LANG.UI_L_HOME[1] ,  fonts.FONT_SIYUAN , 18);
	self.itemLabel:addTo(self);
	self.itemLabel:enableOutline(cc.c4b(60, 60, 60 , 255) , 2);
	self.itemLabel:setPosition(labelPosX[self.btnType],2);
	-- self.itemLabel:enableShadow	( cc.c4b(0, 0, 0 , 255), cc.size(2,-2), 0);
	-- self.itemLabel:enableGlow	( cc.c4b(0, 0, 255 , 255));

	-- 当前等级 
	--self.curLevelNode = cc.Node:create()
	--	:addTo(self)
	--	:setPosition(0 , -106)
	--	:setVisible(false);

	--local levelNodeBg = cc.Sprite:create(imagePath..'home_base_bg_17.png');
	--levelNodeBg:addTo(self.curLevelNode);

	--self.level   = cc.Label:createWithTTF('0' ,  fonts.FONT_IMPACT , 15);
	--self.level:addTo(self.curLevelNode);

	--self:initLevelUp()
	-- 动画
	--local animateSp = cc.Sprite:create();
	--animateSp:addTo(self);
	--animateSp:setPosition(9 , -49);
	--local animation = FrameEffectManager:createFrameAnimation('home_8', 45, 24)
	--animateSp:runAction(cc.RepeatForever:create(cc.Animate:create(animation)));
	--animateSp:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_DST_ALPHA));

	-- self.homeBtnTips[i] = cc.Sprite:create('image/common/btn_bg_0.png');
	-- self.homeBtnTips[i]:addTo(node);
	-- self.homeBtnTips[i]:setPosition(30 , -81);
	-- self.homeBtnTips[i]:setVisible(false);

	--self.homeBtnlevelUpTips = cc.Sprite:create('image/common/btn_bg_0.png');
	--self.homeBtnlevelUpTips:addTo(self);
	--self.homeBtnlevelUpTips:setPosition(0 , 0);
	--self.homeBtnlevelUpTips:setVisible(false);
end
	--军械库
function HomeBaseItemTemplate:initEquipProgress(  )
	if self.equipNumNode ~= nil then
		return 
	end

	self.equipNumNode = cc.Node:create()
		:addTo(self);
		-- :setPosition()

	self.equipNum   = cc.Label:createWithTTF('0' ,  fonts.FONT_SIYUAN , 16);
	self.equipNum:addTo(self.equipNumNode);
	self.equipNum:setPosition(65 , -33);
	self.equipNum:setAnchorPoint(1 , 0.5);
	self.equipNum:enableOutline(cc.c4b(60, 60, 60 , 255) , 2);

end

function HomeBaseItemTemplate:setEquipProgress(   )
	--[[
	if self.equipNumNode == nil then
		return 
	end
	local data = model.HomeModel:getHomeBaseByKey('equip');
	local equipMax = ResTable:getValue('base_equip' , data.level or 1 , 'equip_max');
	self.equipNum:setString(tostring(model.EquipModel:getEquipNum())..'/'..tostring(equipMax or 0));
	]]
end
	-- 科研所
function HomeBaseItemTemplate:initSkillProgress( ... )
	if self.skillNode ~= nil then
		return 
	end

	self.skillNode = cc.Node:create()
		:addTo(self);

	local skillProgressBg = cc.Sprite:create(imagePath..'home_base_1.png');
	skillProgressBg:addTo(self.skillNode);
	skillProgressBg:setPosition(-34 , 0);

	self.homeBtnSkilProgress = cc.ProgressTimer:create(cc.Sprite:create(imagePath..'home_base_2.png'));
	self.homeBtnSkilProgress:addTo(self.skillNode);
	self.homeBtnSkilProgress:setPosition(-34 , 0);
	self.homeBtnSkilProgress:setType(cc.PROGRESS_TIMER_TYPE_BAR);
	self.homeBtnSkilProgress:setMidpoint(cc.p(0.5, 0));
	self.homeBtnSkilProgress:setBarChangeRate(cc.p(0, 1));
	self.homeBtnSkilProgress:setPercentage(0);
end

function HomeBaseItemTemplate:setSkillProgress(  )
	--[[
	if self.skillNode == nil then
		return 
	end

	local skillLevels = model.HomeModel:getBaseSkillLevel();
	local data = model.HomeModel:getHomeBaseByKey('skill');
	local skillMax = ResTable:getValue('base_skill' , data.level or 1 , 'skill_lv');

	local totalLevel = 0;
	local maxLevel = 0;

	for skillId , level in pairs(skillLevels) do
		totalLevel = totalLevel + level;
		maxLevel = maxLevel + skillMax;
	end
	if maxLevel == 0 then
		maxLevel = 1;
	end

	local percent = totalLevel / maxLevel * 100;
	self.homeBtnSkilProgress:setPercentage(percent)
	]]
end

function HomeBaseItemTemplate:initLevelUp(  )
	-- 升级 进度条
	if self.levelUpNode ~= nil then
		return 
	end
	self.levelUpNode = cc.Node:create()
		:addTo(self)
		:setPosition(-9 , -105)
		:setVisible(false);

	local levelUpBg = cc.Sprite:create(imagePath..'home_base_bg_4.png');
	levelUpBg:addTo(self.levelUpNode);

	self.levelNode = cc.Node:create();
	self.levelNode:addTo(self.levelUpNode);
	self.levelNode:setPosition(4 , 11);
	
	self.levelUpCurLevel   = cc.Label:createWithTTF('0' ,  fonts.FONT_IMPACT , 15);
	self.levelUpCurLevel:addTo(self.levelNode);
	self.levelUpCurLevel:setPosition(-12 , 0);
	self.levelUpCurLevel:setAnchorPoint(cc.p(1 , 0.5));

	local levelNodeImg   = cc.Sprite:create(imagePath..'home_base_bg_18.png');
	levelNodeImg:addTo(self.levelNode);

	self.levelUpNextLevel   = cc.Label:createWithTTF('0' ,  fonts.FONT_IMPACT , 15);
	self.levelUpNextLevel:addTo(self.levelNode);
	self.levelUpNextLevel:setPosition(10 , 0);
	self.levelUpNextLevel:setAnchorPoint(cc.p(0 , 0.5));

	self.levelUpTime   = cc.Label:createWithTTF('0' ,  fonts.FONT_IMPACT , 15);
	self.levelUpTime:addTo(self.levelUpNode);
	self.levelUpTime:setPosition(10 , -13);

end

function HomeBaseItemTemplate:initProgress( type )
	self.itemType = type;
	self.itemLabel:setString( LANG.UI_L_HOME[ type ] );
end

function HomeBaseItemTemplate:setProgress(  )
	local locked = model.HomeModel:getLockStateByType(self.itemType);
	if locked then
		return ;
	end

	--self:setLevelUp();
end

function HomeBaseItemTemplate:setLevelUp(   )
	
	local homeBase = model.HomeModel:getHomeBase()
	local data = model.HomeModel:getHomeBaseByKey(homeBtnType[self.itemType]) 
	-- dump(data,'item=============='..tostring(self.itemType));

	if data == nil then
		self:setSchedule(false);
		return 
	end

	if data.state == 1 then
		self.levelUpNode:setVisible(true);
		--self.curLevelNode:setVisible(false);
		self.levelUpTime:setString(GlobalFunctions:ChangeTime(math.floor(data.time)));
		self.levelNode:setVisible(data.time > 0);
		self.levelUpCurLevel:setString('Lv'..tostring(data.level));
		self.levelUpNextLevel:setString('Lv'..tostring(data.level+1));
		--self.homeBtnlevelUpTips:setVisible(data.time <= 0);
		self:setSchedule(data.time <= 0);
	else
		--self.homeBtnlevelUpTips:setVisible(false);
		self.levelUpNode:setVisible(false);
		--self.curLevelNode:setVisible(true);
		self.level:setString('Lv.'..tostring(data.level));

		self:setSchedule(false);
	end
end

function HomeBaseItemTemplate:updateLevelUp(  )

	if self.startSchedule ~= true then
		return 
	end
	local locked = model.HomeModel:getLockStateByType(self.itemType);
	if locked then
		self:setSchedule(false);
		return ;
	end
	--self:setLevelUp();
end

function HomeBaseItemTemplate:setSchedule( status )
	self.startSchedule = status
end

function HomeBaseItemTemplate:homeBtnClick(  )
	if self.itemCallback then
		self.itemCallback(self.itemType);
	end
end

function HomeBaseItemTemplate:setItemCallback(callback)
	self.itemCallback = callback;
end


function HomeBaseItemTemplate:runAction(action)
	self.root:runAction(action);
end

return HomeBaseItemTemplate;