local IconTemplate = class("IconTemplate")
local scheduler = cc.Director:getInstance():getScheduler();
local fonts = Enum:getTable('SystemFont')

local qualityBg = Enum:getTable('ItemQualityBg')

local qualityAnimation = {
	--[3] = '1',
	[6] = 'icon_quality',
	[7] = 'icon_quality',
	[8] = 'icon_quality',
	[9] = 'icon_quality_1',
	[10] = 'icon_quality_1',
	[11] = 'icon_quality_1',
}
 -- 
local roleQualityAnimation = {
	[4] = 8,
	[5] = 9,
}

function IconTemplate:ctor(father)

	self.canShowInfo = false; -- 点击icon是否弹出详情
	self.isEuqip = false;

	self.id = -1;
	self.count = -1;



	self.root = cc.Node:create();
	self.root:setCascadeOpacityEnabled(true);
	self.root:setVisible(true);
	if father then
		father:addChild(self.root);
	end
	
	self:iconInit();

	-- self.root:setCascadeOpacityEnabled(true);
end

function IconTemplate:iconInit(  )
	
	self.bg = cc.Sprite:create('image/equipFrame/quality1BG.png');
	self.root:addChild(self.bg);
	self.bg:setCascadeOpacityEnabled(true);

	self.icon = cc.Sprite:create();
	-- self.icon:setCascadeOpacityEnabled(true);
	self.icon:addTo(self.root);

	self.otherNode = cc.Node:create();
	self.otherNode:addTo(self.root);
	-- self.otherNode:setCascadeOpacityEnabled(true);

	self.infoNode = cc.Node:create();
	self.infoNode:addTo(self.root);
	self.infoNode:setVisible(false)
	self.infoNode:setCascadeOpacityEnabled(true);

	local defTypeBg = cc.Sprite:create('image/card/card_deftype_bg.png');
	defTypeBg:addTo(self.infoNode);
	defTypeBg:setPosition(-34 , -34);
	defTypeBg:setScale(0.55);

	self.defType = cc.Sprite:create();
	self.defType:addTo(self.infoNode);
	self.defType:setPosition(-34 , -34);
	self.defType:setScale(0.41);

	self.starList = {};
	for i = 1 , 5 do
		local starBg = cc.Sprite:create('image/card/card_star_bg.png')
			:addTo(self.infoNode)
			:setScale(0.55)
			:setPosition(-15 + 13 * (i - 1) , -41)

		self.starList[i] = cc.Sprite:create()
			:addTo(self.infoNode)
			:setScale(0.55)
			:setPosition(-15 + 13 * (i - 1) , -41)
	end

	self.levelLabel = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
		:setVisible(false)
		:enableOutline(cc.c3b(50, 50, 50), 2)
		:setHorizontalAlignment(cc.TEXT_ALIGNMENT_LEFT)
		:setAnchorPoint(cc.p(0, 0.5))
		:setPosition(-48, 40)
		:addTo(self.infoNode)

	self.clickLayout = ccui.Layout:create();
	self.clickLayout:addTo(self.root);
	self.clickLayout:setAnchorPoint(cc.p(0.5, 0.5));
	self.clickLayout:setPosition(0 , 0);
	self.clickLayout:setContentSize(cc.size(114 , 118));
	self.clickLayout:addClickEventListener(handler(self , self.click));

	self.strNumLabel = cc.Label:createWithSystemFont('', "Arial", 16);
	self.root:addChild(self.strNumLabel);
	-- self.strNumLabel:setCascadeOpacityEnabled(true);

	self.countNumDULabel = cc.Label:createWithTTF('', fonts.FONT_IMPACT, 22);
	self.countNumDULabel:addTo(self.root);
	self.countNumDULabel:setAnchorPoint(cc.p(1,0.5))
	self.countNumDULabel:setPosition(44, -36);
	self.countNumDULabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
		
	self.NotGetLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_14, fonts.FONT_HUAKANG, 16);
	self.NotGetLabel:addTo(self.root);
	self.NotGetLabel:setAnchorPoint(cc.p(1,0.5))
	self.NotGetLabel:setPosition(44, -36);
	self.NotGetLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
	-- self.NotGetLabel:setCascadeOpacityEnabled(true);
	self.NotGetLabel:setVisible(false);

	self.probability = cc.Sprite:create('image/entrust/entrust_bg_5.png');
	self.probability:addTo(self.root);
	self.probability:setPosition(0 , 39);
	self.probability:setVisible(false);

	self.select = cc.Sprite:create('image/commonImg/common_item_select.png');
	self.select:addTo(self.root);
	self.select:setVisible(false);

	self.equipInSlot = cc.Sprite:create('image/equip/equip_bg2.png');
	self.equipInSlot:addTo(self.root);
	self.equipInSlot:setPosition(19 , 35);
	self.equipInSlot:setVisible(false);

	local equipInSlotSize = self.equipInSlot:getContentSize();
	local equipInSlotLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_43 , fonts.FONT_SIYUAN , 18);
	equipInSlotLabel:addTo(self.equipInSlot);
	equipInSlotLabel:setPosition(equipInSlotSize.width/2 , equipInSlotSize.height/2);
	equipInSlotLabel:enableOutline(cc.c3b(0 , 100 , 200),2);

	self.gachaProbablityNode = cc.Node:create();
	self.gachaProbablityNode:addTo(self.root);
	self.gachaProbablityNode:setVisible(false);

	local bg = cc.Sprite:create('image/chouka/probability/gacha_probility_bg_1.png');
	bg:addTo(self.gachaProbablityNode);
	bg:setPosition(18 , -41);

	self.gachaProbablity = cc.Label:createWithTTF(LANG.UI_EQUIP_15 , fonts.FONT_SIYUAN , 20);
	self.gachaProbablity:addTo(self.gachaProbablityNode);
	self.gachaProbablity:setPosition(18 , -41);
	self.gachaProbablity:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

	local probabilityLabel = cc.Label:createWithTTF(LANG.UI_EQUIP_15 , fonts.FONT_HUAKANG , 16);
	probabilityLabel:addTo(self.probability);
	probabilityLabel:setPosition(39 , 15);


	self.getIcon = cc.Sprite:create('image/activity/main/sign_item_get.png')
		:addTo(self.root)
		:setVisible(false)

	self.blackShader = cc.Sprite:create('image/mail/mail_bg_2.png');
	self.blackShader:addTo(self.root);
	self.blackShader:setVisible(false);
end

function IconTemplate:Init(id, count, star, level, pid)
	self.id = id;
	self.count = count;

	count = count or 0;
	local data = {};

	self.infoNode:setVisible(false);
	self.otherNode:removeAllChildren();

	if id == MONEY_ID then
		data = ResTable:getRowData('item', id)
		self.bg:setTexture('image/equipFrame/quality'..qualityBg[data.quality]..'BG.png');
		self.icon:setTexture("image/icon/I"..data.icon..".png");
		if string.len(count) <= 2 then
			self.countNumDULabel:setString(count == 0 and '' or tostring(count));
		else
			self.countNumDULabel:setString(count == 0 and '' or ConvertStrToDigitUnit(tostring(count)));
		end
		
		self:runAnimation(data.quality);
	elseif id == MONSTER_TYPE then
		id = count;
		data = ResTable:getRowData('monster', id);
		if not data then
			return;
		end

		local iconPath = data['icon'];
		if not iconPath then
			return;
		end
		self.icon:setTexture('image/icon/'..iconPath..'.png');
		local restraint = cc.Sprite:create('image/common/restraint_'..data['def_type']..'.png');
		restraint:setScale(0.5);
		restraint:setPosition(0, 52);
		restraint:addTo(self.otherNode);
		self.countNumDULabel:setString('');
	elseif id == MONSTER_ROLE_TYPE then
		id = count;
		data = ResTable:getRowData('monster', id);
		if not data then
			return;
		end

		star = star or 1;

		local quality = star > 5 and 5 or star;

		self.bg:setTexture('image/card/card_quality_little_'..quality..'.png');
		self.icon:setTexture('image/icon/'..data.icon..'.png');
		self.countNumDULabel:setString('');

		self.infoNode:setVisible(true);
		self:updateStar(star);
		self.defType:setTexture('image/common/restraint_'..data.def_type..'.png');

		if level then
			self.levelLabel:setVisible(true)
			self.levelLabel:setString(tostring(level))
		end
	elseif id == ROLE_TYPE then
		id = count;
		data = ResTable:getRowData('role' , id);
		if not data then
			return;
		end

		local resItemId = 0;
		local quality = data.quality;
		if pid and pid > 0 then
			resItemId = model.CardModel:getCardResIdByPid(pid);
			local cardData = model.CardModel:GetCard(pid);
			quality = cardData.quality;
		end
		if resItemId == 0 then
			resItemId = data.resource_id;
		end
		local imagePath = ResTable:getValue('role_resource', resItemId , 'icon');
		if not imagePath then
			return;
		end
		
		local rolePre = ResTable:getRowData('role_pre', data.role_id);

		self.icon:setTexture('image/icon/'..imagePath..'.png');
		
		self.countNumDULabel:setString('');

		self:runAnimation(quality , true);

		self.infoNode:setVisible(true);
		self:updateStar(star or rolePre.initial_star);
		self.defType:setTexture('image/common/restraint_'..rolePre.def_type..'.png');

		quality = quality > 5 and 5 or quality;
		self.bg:setTexture('image/card/card_quality_little_'..quality..'.png');

		if level and level>0 then
			self.levelLabel:setVisible(true)
			self.levelLabel:setString(tostring(level))
		end
	elseif id == ROLE_AVATAR_TYPE then
		id = count;
		data = ResTable:getRowData('role_avatar' , id);
		if not data then
			return;
		end

		local imagePath = ResTable:getValue('role_resource', data.resource_id , 'icon');
		if not imagePath then
			return;
		end

		local roleData = ResTable:getRowData('role', data.role_id);
		if not roleData then
			return
		end

		local rolePre = ResTable:getRowData('role_pre', data.role_id);
		
		self.bg:setTexture('image/card/card_quality_little_'..roleData.quality..'.png');
		self.icon:setTexture('image/icon/'..imagePath..'.png');
		
		self.countNumDULabel:setString('');

		self:runAnimation(roleData.quality , true);

		self.infoNode:setVisible(true);
		self:updateStar(star or rolePre.initial_star);
		self.defType:setTexture('image/common/restraint_'..rolePre.def_type..'.png');

		if level and level>0 then
			self.levelLabel:setVisible(true)
			self.levelLabel:setString(tostring(level))
		end
	elseif id == BARE_COLLECT_TYPE then
		id = count;
		data = ResTable:getRowData('role' , id);
		if not data then
			return;
		end

		local imagePath = ResTable:getValue('role_resource', data.resource_id , 'icon');
		if not imagePath then
			return;
		end

		self.bg:setTexture('image/card/card_quality_little_'..data.quality..'.png');
		self.icon:setTexture('image/icon/'..imagePath..'.png');
		
		self.countNumDULabel:setString('');

	elseif id > 80000 and id < 90000 then
		data = ResTable:getRowData('equip', id)
		if not data then
			return;
		end

		local itemData = ResTable:getRowData('item' , id);
		--武器背景
		self.bg:setTexture('image/equipFrame/quality'..qualityBg[itemData.quality]..'BG.png');
		--武器画像
		self.icon:setTexture('image/icon/E'..itemData.icon..'.png')
		if count and count > 0 then
			self.countNumDULabel:setString(tostring(count));
		else
			self.countNumDULabel:setString('');
		end

		local starNum = equipStar[itemData.quality];
		if starNum then
			for i = 1 , 5 do
				if i <= starNum then
					local star = cc.Sprite:create('image/equip/equip_star.png');
					star:setPosition(32 - 9 * (i - 1) , -35);
					star:addTo(self.otherNode);
				end
			end
		end

		self:runAnimation(itemData.quality);
	else
		data = ResTable:getRowData('item', id)
		if not data then
			return;
		end
		self.bg:setTexture('image/equipFrame/quality'..qualityBg[data.quality]..'BG.png');
		self.icon:setTexture("image/icon/I"..data.icon..".png");
		self.countNumDULabel:setString(count == 0 and '' or tostring(count));

		self:runAnimation(data.quality);
	end
end

function IconTemplate:updateStar(star)
	local color = math.ceil(star / 5);
	local num = star % 5;
	num = num == 0 and 5 or num;
	for i = 1 , 5 do
		if i <= num then
			self.starList[i]:setTexture('image/card/card_star_'..color..'.png');
		end
		self.starList[i]:setVisible(i <= num);
	end
end

function IconTemplate:runAnimation(quality , isRole)
	
	if isRole then
		quality = roleQualityAnimation[quality];
	end

	if qualityAnimation[quality] then
		local animate = qualityAnimation[quality];
		if quality == 9 then
			local qualityAnimationSp = cc.Sprite:create();
			qualityAnimationSp:addTo(self.otherNode);
			qualityAnimationSp:setCascadeOpacityEnabled(true);
			qualityAnimationSp:setBlendFunc(cc.blendFunc(GL_SRC_ALPHA , GL_ONE));
			
			local animation = FrameEffectManager:createFrameAnimation(animate , 20 , 15);
			qualityAnimationSp:runAction(cc.RepeatForever:create(cc.Animate:create(animation)));
		end

		local particle = cc.ParticleSystemQuad:create("Effect/particle/icon_quality.plist");
		particle:addTo(self.otherNode);
		particle:setPositionType(cc.POSITION_TYPE_RELATIVE);
		particle:resetSystem();
		
	end
end

function IconTemplate:setBlackShader(visible)
	self.blackShader:setVisible(visible);
end

function IconTemplate:setGachaProbablity(probability)
	self.gachaProbablityNode:setVisible(true);
	self.gachaProbablity:setString(probability);
end

function IconTemplate:InitContract(no, num, have)
	self:Init(no,num);
end
-- function IconTemplate:setIconVisible(visible)
-- 	self.icon:setVisible(visible);
-- end

function IconTemplate:setScale(scale)
	self.root:setScale(scale);
end

-- function IconTemplate:setClickEvent(click_hander, arg)
-- 	self.callback = click_hander;
-- 	self.callback_arg = arg;
-- end

-- bSwallowEnabled 是否不吞噬触摸 默认false
-- 是否可点击弹出 详情
function IconTemplate:setCanShowInfo( bTrue ,bSwallowEnabled)
	self.canShowInfo = bTrue;
	self.clickLayout:setTouchEnabled(bTrue);
	self:setSwallowTouches(bSwallowEnabled == true );

end

function IconTemplate:setTouchEnabled(bTrue)
	self.clickLayout:setTouchEnabled(bTrue);
	self:setSwallowTouches(bTrue);
end

-- 用于 领取完奖励，停止特效+加灰
function IconTemplate:setGray( bTrue )
	if not bTrue  then
		return;
	end
	print(' 未完成  需要 加灰 ！！');
end
-- function IconTemplate:beClicked(sender, eventType)
-- 	if self.callback then
-- 		self.callback(self.callback_arg);
-- 	end
-- end

function IconTemplate:removeFromParent()
	self.root:removeFromParent();
end
function IconTemplate:getContentSize()
	return self.bg:getContentSize();
end

function IconTemplate:setPosition(x,y)
	return self.root:setPosition(cc.p(x,y));
end

function IconTemplate:getPosition()
	return self.root:getPosition();
end

function IconTemplate:setVisible(flag)
	self.root:setVisible(flag)
end

function IconTemplate:setName(name)
	self.root:setName(name)
end
function IconTemplate:getName()
	return self.root:getName()
end
function IconTemplate:addChild(child)
	self.root:addChild(child)
end

function IconTemplate:setOpacity(opacity)
	self.root:setOpacity(opacity);
end

function IconTemplate:stopAllActions()
	self.root:stopAllActions();
end
function IconTemplate:runAction(action)
	self.root:runAction(action);
end
function IconTemplate:setAnchorPoint(point)
	self.root:setAnchorPoint(point);
end
function IconTemplate:setNum(num,zeroToStr) --当为0时，显示未获得
	self.countNumDULabel:setString(ConvertStrToDigitUnit(tostring(num)));
	self:showNotGet(num == 0 and zeroToStr == true )
end

function IconTemplate:setIconNum(num)
	self.countNumDULabel:setString(tostring(num));
end

function IconTemplate:showNotGet( visible )
	self.NotGetLabel:setVisible(visible);
	self.countNumDULabel:setVisible(not visible);
end

function IconTemplate:setItemNum(no,count)
	-- self.countNumDULabel:setString(ConvertStrToDigitUnit(tostring(count)));
	self:setNum(count);
end

function IconTemplate:setProbabilityShow(visible)
	self.probability:setVisible(visible);
end

function IconTemplate:showRedDot(show)
	tools.RedDotTools:setRedDotToNode(self.root,show,nil,cc.p(47 , 49));
end

function IconTemplate:setEquipInSlot(visible)
	self.equipInSlot:setVisible(visible);
end

local getVFShader = function(size, blurR, blurNum)
	local vertShaderByteArray = "\n"..  
	"attribute vec4 a_position; \n" ..
	"attribute vec2 a_texCoord; \n" ..
    "attribute vec4 a_color; \n\n" ..
	"#ifdef GL_ES \n" .. 
	"varying lowp vec4 v_fragmentColor; \n" ..
	"varying mediump vec2 v_texCoord; \n" ..
	"#else \n" ..
	"varying vec4 v_fragmentColor; \n" ..
	"varying vec2 v_texCoord; \n" ..
	"#endif \n" ..
    "void main() \n" ..
    "{ \n" .. 
    "   gl_Position = CC_PMatrix * a_position;\n"..
    "   v_fragmentColor = a_color;\n"..
    "   v_texCoord = a_texCoord;\n" ..
    "} \n";
	
	local resolutionStr = string.format("vec2 resolution = vec2(%f, %f); \n", size.width, size.height);
	local blurRadiusStr = string.format("float blurRadius = %f; \n", blurR);
	local blurNumStr = string.format("float sampleNum = %f; \n", blurNum);
	local flagShaderByteArray = "\n" ..
	"#ifdef GL_ES \n" ..
	"precision mediump float; \n" ..
	"#endif \n" ..
	"varying vec4 v_fragmentColor; \n" ..
	"varying vec2 v_texCoord; \n" ..
	"vec4 blur(vec2); \n" ..
	"void main() \n" ..
	"{ \n" ..
	"	vec4 col = blur(v_texCoord); \n" ..
	"	gl_FragColor = vec4(col) * v_fragmentColor; \n" ..
	"} \n" ..
	"vec4 blur(vec2 p) \n" ..
	"{ \n" ..
	resolutionStr ..
	blurRadiusStr ..
	blurNumStr ..
	"	if (blurRadius > 0.0 && sampleNum > 1.0) \n" ..
	"	{ \n" ..
	"		vec4 col = vec4(0); \n" ..
	"		vec2 unit = 1.0 / resolution.xy; \n" ..
	"		float r = blurRadius; \n" ..
	"		float sampleStep = r / sampleNum; \n" ..
	"		float count = 0.0; \n" ..
	--遍历一个矩形，当前的坐标为中心点，遍历矩形中每个像素点的颜色
	"		for(float x = -r; x < r; x += sampleStep) \n" ..
	"		{ \n" ..
	"			for(float y = -r; y < r; y += sampleStep) \n" ..
	"			{ \n" ..
	--权重，p点的权重最高，向四周依次减少
	"				float weight = (r - abs(x)) * (r - abs(y)); \n" ..
	"				col += texture2D(CC_Texture0, p + vec2(x * unit.x, y * unit.y)) * weight; \n" ..
	"				count += weight; \n" ..
	"			} \n" ..
	"		} \n" ..
	--到实际模糊颜色的值
	"		return col / count; \n" ..
	"	} \n" ..
	"return texture2D(CC_Texture0, p); \n" ..
	"} \n";
	return vertShaderByteArray, flagShaderByteArray;
end

function IconTemplate:showShader()

	self.m_scheduleHandler = scheduler:scheduleScriptFunc(handler(self, self.update), 0, false);
	self.time = 1;
	self.key = 10;
	self.pos = -1;
	--local bg = cc.LayerColor:create(cc.c4b(255, 255, 0, 255),display.width, display.height):addTo(self);

	local size = self.icon:getTexture():getContentSizeInPixels();
	local br, bn = self.key*5-5, self.key;
	local vertShaderByteArray, flagShaderByteArray = getVFShader(size, br, bn);
	
	local glProgram = cc.GLProgram:createWithByteArrays(vertShaderByteArray, flagShaderByteArray);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
	glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
	glProgram:link();
	glProgram:updateUniforms();
	self.icon:setGLProgram(glProgram);
	if self.isEuqip then
		if self.equipImg ~= nil then
			local size = self.equipImg:getTexture():getContentSizeInPixels();
			local br, bn = self.key*5-5, self.key;
			local vertShaderByteArray, flagShaderByteArray = getVFShader(size, br, bn);

			local glProgram = cc.GLProgram:createWithByteArrays(vertShaderByteArray, flagShaderByteArray);
			glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
			glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
			glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
			glProgram:link();
			glProgram:updateUniforms();
			self.equipImg:setGLProgram(glProgram);
		end
	end
end
function IconTemplate:setGet(flag)
	self.getIcon:setVisible(flag)
end
function IconTemplate:update()
	self.time = self.time + 1;
	if self.time % 5 == 1 then
		self.key = self.key + self.pos;
		if self.key == 1 then
			if self.m_scheduleHandler then
				scheduler:unscheduleScriptEntry(self.m_scheduleHandler)
				self.m_scheduleHandler = nil 
			end
		end
		local size = self.icon:getTexture():getContentSizeInPixels();
		local br, bn = self.key*5-5, self.key;
		local vertShaderByteArray, flagShaderByteArray = getVFShader(size, br, bn);

		local glProgram = cc.GLProgram:createWithByteArrays(vertShaderByteArray, flagShaderByteArray);
		glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
		glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
		glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
		glProgram:link();
		glProgram:updateUniforms();
		self.icon:setGLProgram(glProgram);

		if self.isEuqip then
			if self.equipImg ~= nil then
				local size = self.equipImg:getTexture():getContentSizeInPixels();
				local br, bn = self.key*5-5, self.key;
				local vertShaderByteArray, flagShaderByteArray = getVFShader(size, br, bn);
	
				local glProgram = cc.GLProgram:createWithByteArrays(vertShaderByteArray, flagShaderByteArray);
				glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_POSITION, cc.VERTEX_ATTRIB_POSITION);
				glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_COLOR, cc.VERTEX_ATTRIB_COLOR);
				glProgram:bindAttribLocation(cc.ATTRIBUTE_NAME_TEX_COORD, cc.VERTEX_ATTRIB_TEX_COORDS);
				glProgram:link();
				glProgram:updateUniforms();
				self.equipImg:setGLProgram(glProgram);
			end
		end
	end
end

function IconTemplate:setTag(tag)
	self.tag = tag
end
function IconTemplate:addClickEventListener(callback)
	self.clickLayout:setTouchEnabled(true);
	self.callback = callback;
end
function IconTemplate:setSwallowTouches( swalled )
	-- body
	self.clickLayout:setSwallowTouches(swalled);
end
function IconTemplate:click()
	if self.canShowInfo then
		GlobalFunctions:showCommonInfo(self.id,self.count);
		return 
	end
	if self.callback then
		self.callback(self.tag);
	end
end
function IconTemplate:setSelect(isSelect)
	self.select:setVisible(isSelect);
end
return IconTemplate;
