local ItemCell = class("ItemCell" , function()
	return ccui.Layout:create();
end)

local fonts = Enum:getTable('SystemFont')
local qualityBg = Enum:getTable('ItemQualityBg')

function ItemCell:ctor(bgType)

	self.id = -1;
	self.itemId = -1;
	
	self:iconInit(bgType);
end

function ItemCell:iconInit( bgType )
	
	self:setCascadeOpacityEnabled(true);

	self.qualityBg = ccui.ImageView:create('image/commonImg/item_quality_2.png') --cc.p(103,103)
		:addTo(self)

	if bgType == 2 then
		self.lightBg = cc.Sprite:create('image/commonImg/icon_item_light.png')
			:addTo(self)
	end

	self.iconNode = cc.Node:create();
	self.iconNode:addTo(self);
	self.iconNode:setCascadeOpacityEnabled(true);
	self.iconSpr = cc.Sprite:create();
	self.iconSpr:addTo(self.iconNode)

	self.otherNode = cc.Node:create()
		:addTo(self)

	self.itemNum = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20);
	self.itemNum:addTo(self);
	self.itemNum:setAnchorPoint(cc.p(1,0.5))
	self.itemNum:setPosition(39, -29);
	self.itemNum:enableOutline(cc.c4b(0 , 0 , 0 ,255),2);

	self.itemName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20);
	self.itemName:addTo(self);
	self.itemName:setAnchorPoint(cc.p(0.5,0.5))
	self.itemName:setPosition(0, -59);
	self.itemName:enableOutline(cc.c4b(0 , 0 , 0 ,255),2);
end

function ItemCell:Init(id, itemId)
	self.id = id;
	self.itemId = itemId;

	local data = {};

	local icon = '';
	if self.id == 1 then
		data = ResTable:getRowData('skill', self.itemId)
		if not data then
			return;
		end
		icon = "image/skillicon/"..data.icon..".png";
		-- self.itemNum:setString(count == 0 and '' or tostring(count));
		-- self.qualityBg:loadTexture('image/commonImg/item_quality_'..qualityBg[data.quality]..'.png');

		self.iconSpr:setTexture(icon)
		self.itemName:setString( data.name )
	end

	-- self:initIcon(icon);
end

function ItemCell:initIcon(icon)
	self.iconNode:removeAllChildren();
	local icon = cc.Sprite:create(icon);
	if not icon then
		return;
	end
	local size = icon:getContentSize();

	local stencil = cc.Sprite:create('image/commonImg/icon_clipping_bg.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:addChild(icon);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:setPosition(size.width/2,size.height/2)

	local renderTexture = cc.RenderTexture:create(size.width,size.height,cc.TEXTURE2_D_PIXEL_FORMAT_RGB_A8888,gl.DEPTH24_STENCIL8_OES);
	renderTexture:beginWithClear(0,0,0,0);
	clippingNode:visit();
	renderTexture:endToLua();
	local spTexture = renderTexture:getSprite():getTexture();
	icon = cc.Sprite:createWithTexture(spTexture)
	icon:addTo(self.iconNode);
	icon:setScaleY(-1);
end

function ItemCell:addItemClickEventListener(callback)
	self.qualityBg:addClickEventListener(callback)
	self.qualityBg:setTouchEnabled(true)
	self.qualityBg:setSwallowTouches(false);
end

function ItemCell:setItemTag(tag)
	self.qualityBg:setTag(tag);
end

function ItemCell:getItemTag()
	return self.qualityBg:getTag();
end

function ItemCell:setItemSwallowTouches(swallow)
	self.qualityBg:setSwallowTouches(swallow);
end

function ItemCell:setSelect(select)
	if not self.select then
		self.select = cc.Sprite:create('image/commonImg/common_item_select.png');
		self.select:addTo(self);
	end

	self.select:setVisible(select)
end

function ItemCell:showRedDot(show)
	tools.RedDotTools:setRedDotToNode(self,show,nil,cc.p(41.5 , 41.5));
end

function ItemCell:setBlackShader(visible)
	if not self.blackShader then
		self.blackShader = cc.Sprite:create('image/mail/mail_bg_2.png');
		self.blackShader:addTo(self);
	end

	self.blackShader:setVisible(visible);
end

function ItemCell:setCanShowInfo(showInfo,bSwallowEnabled)
	if showInfo then
		self.qualityBg:addClickEventListener(function()
			GlobalFunctions:showCommonInfo(self.id,self.count);
		end)
		self.qualityBg:setTouchEnabled(true)
		self.qualityBg:setSwallowTouches(bSwallowEnabled == true);
	else
		self.qualityBg:setTouchEnabled(false)
		self.qualityBg:setSwallowTouches(false);
	end
end

return ItemCell;
