local LoveTemplate = class("LoveTemplate" , function()
	return ccui.Layout:create();
end)

local fonts = Enum:getTable("SystemFont")

function LoveTemplate:ctor()
    self.bg = ccui.Button:create();
    self.bg:addTo(self);
    self.bg:setTag(1);
    self.bg:addClickEventListener(handler(self , self.btnClick));

    self.loveValue = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.loveValue:addTo(self);
	self.loveValue:enableOutline(cc.c3b(255 , 60 , 155) , 2);
	self.loveValue:setPosition(0 , -5);

    self.openNode = cc.Node:create();
    self.openNode:addTo(self);

    local bg = cc.Sprite:create('image/cardLove/card_love_bg_5.png');
    bg:addTo(self.openNode);

    self.loveBtn = ccui.Button:create('image/cardLove/card_love_bg_4.png');
	self.loveBtn:addTo(self.openNode);
    self.loveBtn:setPosition(0 , -53);
    self.loveBtn:addClickEventListener(handler(self , self.btnClick));
    self.loveBtn:setSwallowTouches(false);
    self.loveBtn:setTag(2);

end
function LoveTemplate:Init(roleId , loveLevel)

    local loveData = model.CardModel:getLoveData(roleId);
    local data = loveData.loveData[loveLevel];
    if loveData.loveLevel >= data.love_lv then
        self.openNode:setVisible(true);
        self.bg:loadTextures('image/cardLove/card_love_bg_11.png','image/cardLove/card_love_bg_11.png');
    else
        self.openNode:setVisible(false);
        self.bg:loadTextures('image/cardLove/card_love_bg_10.png','image/cardLove/card_love_bg_10.png');
    end
    self.bg:setSwallowTouches(false);
    local str = '';
    for _k , effect in pairs(data.effect) do
        local typeName = LANG.UI_CARAD_ATT_TYPE[effect[1]];
        if effect[2] > 0 then
            str = str..tostring(typeName)..'+'..effect[2]..',';
        end

        if effect[3] > 0 then
            local percent = effect[3] * 100
            str = str..tostring(typeName)..'+'..percent..'%,';
        end
    end
    str = string.sub(str , 1 , -2);
    self.loveValue:setString(tostring(str));
end

function LoveTemplate:btnClick(sender , event)
    local tag = sender:getTag();
    
    if self.btnCallback then
        self.btnCallback(tag , self.btnTag);
    end
end

function LoveTemplate:addLoveClickEventListener(callback)
    self.btnCallback = callback;
end

function LoveTemplate:setLoveTag(tag)
    self.btnTag = tag;
end

return LoveTemplate;
