local MailItemTemplate = class("MailItemTemplate" , function()
	return ccui.Layout:create();
end)

local imagePath = 'image/mail/'

local fonts = Enum:getTable("SystemFont")

function MailItemTemplate:ctor(father)
	
	self.bg =  ccui.Button:create(imagePath.."mail_bg_6.png" , imagePath.."mail_bg_6.png");
	self.bg:addTo(self);
	self.bg:setSwallowTouches(false);

	local iconBg = cc.Sprite:create(imagePath..'mail_icon.png')
		:addTo(self)
		:setPosition(cc.p(-224,0))

	self.state = cc.Sprite:create()
	self.state:addTo(self);
	self.state:setPosition(-224 , 0);

	self.stateRedDot = cc.Sprite:create('image/commonImg/tip_1.png')
	self.stateRedDot:addTo(self);
	self.stateRedDot:setPosition(-193 , 22);

	--邮件标题
	self.mailTitle = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 16);
	self.mailTitle:setAnchorPoint(cc.p(0 , 0.5));
	self.mailTitle:setPosition(cc.p(-149, 0));
	-- self.mailTitle:setTextColor(cc.c4b(60 , 60 , 60));
	self.mailTitle:addTo(self);
	-- self.mailTitle:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);

	local bg =  cc.Sprite:create(imagePath.."mail_bg_3.png");
	bg:addTo(self);
	bg:setPosition(183 , 0);

	self.lastTime = cc.Label:createWithTTF("", fonts.FONT_SIYUAN, 16);
	self.lastTime:setPosition(cc.p(183 , 0));
	self.lastTime:setTextColor(cc.c4b(120 , 150 , 200));
	-- self.lastTime:enableOutline(cc.c4b(100 , 100 , 100 , 255) , 2);
	self.lastTime:addTo(self);

end

function MailItemTemplate:Init(data)

	if not data then
		return
	end 

	local lastTime = data.stamp - TimeManager:getCurTime()
	lastTime = lastTime < 0 and 0 or lastTime;
	local days = math.floor(lastTime / 86400);
	local modDay = lastTime % 86400;

	if days > 0 then
		if modDay > 0 then
			days = days+1;
			days = days > 30 and 30 or days;
		end
		self.lastTime:setString(string.format(LANG.UI_MAIL_LAST_TIME,days));
	else
		local hours = math.floor(modDay/3600);
		local modHour = modDay%3600;
		if hours > 0 then
			if modHour > 0 then
				hours = hours + 1;
				hours = hours > 24 and 24 or hours;
			end
			self.lastTime:setString(string.format(LANG.UI_MAIL_15,hours));
		else
			self.lastTime:setString(LANG.UI_MAIL_16);
		end
	end
	self.mailTitle:setString(tostring(data.title));
	--self.lastTime:setString(string.format(LANG.UI_MAIL_LAST_TIME,lastTime));
	
	--如果有附件，且附件已领取，或者没有附件，但是邮件已打开，则透明度50%,地图加灰
	if data.opened ~= 0 or data.rewarded == 2 then
		self.state:setTexture(imagePath..'mail_bg_5.png');
		self.stateRedDot:setVisible(false);
	else
		self.state:setTexture(imagePath..'mail_bg_4.png');
		self.stateRedDot:setVisible(true);
	end
end

return MailItemTemplate;
