local MainBgSelectTemplate = class("MainBgSelectTemplate", function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable('SystemFont')
local imagePath = 'image/setup/bgSelect/'

function MainBgSelectTemplate:ctor()

	self.bg = ccui.ImageView:create(imagePath..'main_bgsmaill_0.png');
	self.bg:addTo(self);

	self.openNode = cc.Node:create();
	self.openNode:addTo(self);

	self.bgName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.bgName:addTo(self.openNode);
	self.bgName:setAnchorPoint(0 , 0.5)
	self.bgName:setPosition(-272 , 63)

	self.haveNode = cc.Node:create();
	self.haveNode:addTo(self.openNode);


	self.limitTimeNode = cc.Sprite:create(imagePath..'bg_select_2.png');
	self.limitTimeNode:addTo(self.haveNode);
	self.limitTimeNode:setPosition(169 , 62);
	
	local size = self.limitTimeNode:getContentSize();

	local label = cc.Label:createWithTTF(LANG.UI_SETTING_19 , fonts.FONT_SIYUAN , 17);
	label:addTo(self.limitTimeNode);
	label:setPosition(size.width / 2 - 59 , size.height / 2);
	label:enableOutline(cc.c4b(165 , 0 , 50 , 255) , 2);

	self.limitTime = cc.Label:createWithTTF('00:00:00' , fonts.FONT_SIYUAN , 20);
	self.limitTime:addTo(self.limitTimeNode);
	self.limitTime:setPosition(size.width / 2 + 50 , size.height / 2);

	self.useNode = cc.Sprite:create(imagePath..'bg_select_4.png');
	self.useNode:addTo(self.haveNode);

	local size = self.useNode:getContentSize();

	self.useState = cc.Sprite:create(imagePath..'bg_select_1.png');
	self.useState:addTo(self.useNode);
	self.useState:setPosition(size.width / 2 + 26 , size.height / 2 + 62); -- 237,62

	local label = cc.Label:createWithTTF(LANG.UI_SETTING_23 , fonts.FONT_SIYUAN , 17);
	label:addTo(self.useState);
	label:setPosition(36.5 , 15);
	label:enableOutline(cc.c4b(180 , 100 , 0 , 255) , 2);

	self.useTip = cc.Sprite:create(imagePath..'bg_select_3.png');
	self.useTip:addTo(self.haveNode);
	self.useTip:setPosition(-260 , -51);

	local size = self.useTip:getContentSize();

	local label = cc.Label:createWithTTF(LANG.UI_SETTING_20 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.useTip);
	label:setAnchorPoint(0 , 0.5);
	label:setPosition(size.width / 2 + 13 , size.height / 2);
	label:setTextColor(cc.c4b(255 , 0 , 100 , 255));
	label:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);

	self.notHaveNode = cc.Sprite:create(imagePath..'bg_select_5.png');
	self.notHaveNode:addTo(self.openNode);

	local size = self.notHaveNode:getContentSize();

	local label = cc.Label:createWithTTF(LANG.UI_SETTING_22 , fonts.FONT_SIYUAN , 20);
	label:addTo(self.notHaveNode);
	label:setAnchorPoint(0 , 0.5);
	label:setPosition(size.width / 2 - 27 , size.height / 2);

	local label = cc.Label:createWithTTF(LANG.UI_SETTING_21 , fonts.FONT_SIYUAN , 20);
	label:enableOutline(cc.c3b(40 , 130 , 230) , 2);

	self.buyBtn = ccui.Button:create(imagePath..'bg_select_btn_1.png');
	self.buyBtn:addTo(self.openNode);
	self.buyBtn:setTitleLabel(label);
	self.buyBtn:setPosition(204 , -52);
	self.buyBtn:addClickEventListener(function()
		if model.ArenaModel:getLockStateArena() then
			Prompt:Show(LANG.UI_SETTING_32);
			return;
		end
		UIManager:push('StorePanel' , Enum:getTable('CommonShopType').ARENA);
	end);

end

function MainBgSelectTemplate:Init(data)

	if not data then
		self.openNode:setVisible(false);
		self.bg:loadTexture(imagePath..'main_bgsmaill_0.png');
	else
		self.openNode:setVisible(true);
		self.bg:loadTexture(imagePath..data.small_show..'.png');
		self.bgName:setString(tostring(data.bg_name));
		self:updateState(data);
	end
end

function MainBgSelectTemplate:updateState(data)
	local state = 3; --未获得
	if data.activateTime > 0 then --时效
		state = 1;
		self.useState:setPosition(335 , 169.5);
	elseif data.activateTime == 0 then --永久
		state = 2;
		self.useState:setPosition(546 , 169.5);
	end
	self.limitTimeNode:setVisible(state == 1);
	self.notHaveNode:setVisible(state == 3);
	self.buyBtn:setVisible(state ~= 2);
	self:updateUseState(data.id);
end

function MainBgSelectTemplate:updateUseState(bgId)
	local curMainBg = model.UserModel:getMainBg();
	local useState = curMainBg == bgId;

	self.useNode:setVisible(useState);
	self.useTip:setVisible(not useState);
end

function MainBgSelectTemplate:updateTime(lastTime)
	self.limitTime:setString(GlobalFunctions:ChangeTime(lastTime));
end

function MainBgSelectTemplate:addBgClickEventListener(callback)
	self.bg:setTouchEnabled(true);
	self.bg:addClickEventListener(callback);
	self.bg:setSwallowTouches(false);
end

function MainBgSelectTemplate:setBgTag(tag)
	self.bg:setTag(tag);
end

function MainBgSelectTemplate:getBgTag()
	return self.bg:getTag();
end

return MainBgSelectTemplate;
