local MessageBoxTemplate = class("MessageBoxTemplate")

local fonts = Enum:getTable("SystemFont")
local default = 
{
	[1] = cc.c3b(165, 200, 255),
	[2] = fonts.FONT_SIYUAN,
	[3] = 20
}

function MessageBoxTemplate:ctor(father)

	self.btnCount = 0;
	default = 
	{
		[1] = cc.c3b(165, 200, 255),
		[2] = fonts.FONT_SIYUAN,
		[3] = 20
	}

	local root  = cc.Node:create();
	self.root   = root;
	self.father = father;

	--大背景
	self.blackBg = cc.LayerColor:create(cc.c4b(0, 0, 0, 210), StageSize.width, StageSize.height);
    self.blackBg:setLocalZOrder(-100);
	self.blackBg:setPosition(-StageSize.width/2, -StageSize.height/2);
	self.blackBg:addTo(self.root);

	self.close = ccui.Layout:create();
	self.close:setTouchEnabled(true);
	self.close:setContentSize(cc.size(StageSize.width, StageSize.height));
	self.close:setAnchorPoint(cc.p(0.5,0.5));
	self.close:setPosition(0, 0);
	self.close:addTo(self.root);
	self.close:addClickEventListener(handler(self , self.onClickBack));

	self.boxBg = ccui.Layout:create();
	self.boxBg:setBackGroundImage('image/commonImg/bg_2_11_4_18_21.png')
	self.boxBg:setBackGroundImageScale9Enabled(true)
	self.boxBg:setBackGroundImageCapInsets(cc.rect(11,4,18,21))
	self.boxBg:setContentSize(cc.size(602,350));
	self.boxBg:setTouchEnabled(true);
	self.boxBg:setAnchorPoint(cc.p(0.5,0.5));
	self.boxBg:setPosition(0, 42.5);
	self.boxBg:addTo(self.root);

	self.title =  GlobalFunctions:createTitle(LANG.UI_L_MESSAGE_TITLE_1 , 602 , 46);
	self.title:addTo(self.root);
	self.title:setPosition(0 , 240);

    self.boxBg1 = ccui.Layout:create();
	self.boxBg1:setBackGroundImage('image/commonImg/bg_1_11_11_34_28.png')
	self.boxBg1:setBackGroundImageScale9Enabled(true)
	self.boxBg1:setBackGroundImageCapInsets(cc.rect(11,11,34,28))
	self.boxBg1:setContentSize(cc.size(582,255));
	self.boxBg1:setTouchEnabled(true);
	self.boxBg1:setAnchorPoint(cc.p(0.5,0.5));
	self.boxBg1:setPosition(0, 80);
	self.boxBg1:addTo(self.root);

	local posX = 
	{
		[1] = {0},
		[2] = {-118, 118},
	}
	local btnText = 
	{
		[1] = {LANG.COMMON_OK},
		[2] = {LANG.COMMON_CANCEL , LANG.COMMON_OK},
	}
	local btnImg = {
		[1] = {'res/image/commonImg/btn_1_219_55.png'},
		[2] = {'res/image/commonImg/btn_1_219_55_2.png' , 'res/image/commonImg/btn_1_219_55.png'},
	}

	self.buttonList = {};
	self.buttonNodeList = {};
	self.buttonLabel = {}

	self.btnNode = cc.Node:create()
	:addTo(self.root)

	for i = 1 , 2 do
		self.buttonList[i] = {}
		self.buttonLabel[i] = {}
		self.buttonNodeList[i] = cc.Node:create();
		self.buttonNodeList[i]:addTo(self.btnNode);
		self.buttonNodeList[i]:setPosition(0 , -90);
		self.buttonNodeList[i]:setVisible(false);
		for j = 1 , i do
			self.buttonList[i][j] = ccui.Button:create(btnImg[i][j] , btnImg[i][j]);
			self.buttonList[i][j]:addTo(self.buttonNodeList[i]);
			self.buttonList[i][j]:setPosition(posX[i][j], 0);

			local btnLabel = cc.Label:createWithTTF(btnText[i][j] , fonts.FONT_SIYUAN , 20);
			btnLabel:addTo(self.buttonList[i][j]);
			btnLabel:setPosition(self.buttonList[i][j]:getContentSize().width/2 , self.buttonList[i][j]:getContentSize().height/2);
			if i == 2 and j == 1 then
				btnLabel:setTextColor(cc.c3b(255 , 255 , 255));
				btnLabel:enableOutline(cc.c4b(120 , 120 , 120 , 255) , 2);
			else
				btnLabel:setTextColor(cc.c3b(255 , 255 , 255));
				btnLabel:enableOutline(cc.c4b(50 , 85 , 150 , 255) , 2);
			end
			self.buttonLabel[i][j] = btnLabel


		end
	end

	self:initCostNode()

	--self.title = cc.Label:createWithTTF('提示' , fonts.FONT_JP , 33);
	--self.title:addTo(self.root);
	--self.title:setPosition(- 238, 121);

	--self.midText = ccui.RichText:create();
	--self.midText:setAnchorPoint(cc.p(0.5 , 0.5));
	--self.midText:addTo(self.root);
	--self.midText:setPosition(0 , 93);

	self.midText = cc.Label:createWithTTF('',default[2],default[3])
	self.midText:addTo(self.root);
	self.midText:setPosition(0,80);
	self.midText:setMaxLineWidth(540);
	self.midText:setTextColor(default[1]);
	self.midText:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
	
	--self.root:setScale(0.5);
	--self.root:runAction(cc.ScaleTo:create(0.1,1,1));
	self.root:setVisible(true);

	father:addChild(self.root);
end

function MessageBoxTemplate:initCostNode()
	self.costNode = cc.Node:create();
	self.costNode:addTo(self.root);
	self.costNode:setPosition(0, -85);
	self.costNode:setVisible(false)

	local cost1Node = cc.Node:create()
	:addTo(self.costNode)
	:setPosition(-240,0)
	local c1bg = ccui.Scale9Sprite:create("image/commonImg/bg_3_200_42.png");
	c1bg:setContentSize(cc.size(250 , 50));
	c1bg:addTo(cost1Node)
	c1bg:setPosition(90,0)
	self.cost1Icon = cc.Sprite:create()
	:addTo(cost1Node)
	:setScale(0.5)
	local cost1Label = cc.Label:createWithTTF(LANG.UI_HOME_37..':', fonts.FONT_SIYUAN , 20)
	:addTo(cost1Node)
	:setPosition(30,0)
	:setAnchorPoint(0,0.5)
	:setTextColor(cc.c3b(160,200,255))
	self.cost1Value = cc.Label:createWithTTF('10000', fonts.FONT_SIYUAN , 20)
	:addTo(cost1Node)
	:setPosition(40+cost1Label:getContentSize().width,0)
	:setAnchorPoint(0,0.5)

	local cost2Node = cc.Node:create()
	:addTo(self.costNode)
	:setPosition(60,0)
	local c2bg = ccui.Scale9Sprite:create("image/commonImg/bg_3_200_42.png");
	c2bg:setContentSize(cc.size(250 , 50));
	c2bg:addTo(cost2Node)
	c2bg:setPosition(90,0)
	self.cost2Icon = cc.Sprite:create()
	:addTo(cost2Node)
	:setScale(0.5)
	local cost2Label = cc.Label:createWithTTF(LANG.UI_ENTRUST_16..':', fonts.FONT_SIYUAN , 20)
	:addTo(cost2Node)
	:setPosition(30,0)
	:setAnchorPoint(0,0.5)
	:setTextColor(cc.c3b(160,200,255))
	self.cost2Value = cc.Label:createWithTTF('10000', fonts.FONT_SIYUAN , 20)
	:addTo(cost2Node)
	:setPosition(40+cost2Label:getContentSize().width,0)
	:setAnchorPoint(0,0.5)
end

function MessageBoxTemplate:initData(texts,buttonCount)
	self.btnCount = buttonCount;
	if not self.buttonList[self.btnCount] or not self.buttonNodeList[self.btnCount]then
		return;
	end

	self.midText:setString(tostring(texts));
	--[[
	if type(texts) == 'string' then
		local str = texts;
		texts = {};
		table.insert(texts , {text = str});
	end

	for _k , text in pairs(texts) do
		local t = ccui.RichElementText:create(_k,(text.color or default[1]), 255,tostring(text.text),(text.font or default[2]),(text.fontSize or default[3]));  
        self.midText:pushBackElement(t)
	end
	self.midText:formatText();
	local size = self.midText:getContentSize();
	local height = math.ceil(size.width / 450) * size.height;
	self.midText:ignoreContentAdaptWithSize(false);
	self.midText:setContentSize(cc.size((size.width < 450 and size.width or 450),height))
	self.midText:setPosition(0,93);
	]]

	self.buttonNodeList[self.btnCount]:setVisible(true);
	self.costNode:setVisible(false)
	self.btnNode:setPosition(0,0)
	self.boxBg:setContentSize(cc.size(602,350));
	self.boxBg:setPosition(0, 42.5);
end

function MessageBoxTemplate:addClickListener(callback, cancelCallback, clickBackgroundCallback)
	for i = 1 , self.btnCount do
		if callback and (i == self.btnCount) then
			self:setCallback(callback);
			self.buttonList[self.btnCount][i]:addClickEventListener(handler(self,self.OkClick));
		else
			self.buttonList[self.btnCount][i]:addClickEventListener(handler(self,self.CancelClick));
		end
	end

	if cancelCallback then
		self:setCancelCallback(cancelCallback);
	end

	if clickBackgroundCallback then
		self:setClickBackgroundCallback(clickBackgroundCallback)
	else
		self.closeCallback = nil
	end
end
function MessageBoxTemplate:setCallback(callback)
	if callback then
		self.callback = callback;
	end
end

function MessageBoxTemplate:setCancelCallback(callback)
	if callback then
		self.cancelCallback = callback;
	end
end

function MessageBoxTemplate:setClickBackgroundCallback(callback)
	if callback then
		self.closeCallback = callback
	end
end

function MessageBoxTemplate:OkClick()
	AudioManager:playEffect(Conf.confirmButton)
	if self.callback then
		self.callback();
		self.callback = nil;
	end
	EventManager:FireEvent(EventType.UIMessageBoxClose);
end
function MessageBoxTemplate:CancelClick()
	AudioManager:playEffect(Conf.cancleButton)
	if self.cancelCallback then
		self.cancelCallback();
		self.cancelCallback = nil;
	end
	EventManager:FireEvent(EventType.UIMessageBoxClose);
end
function MessageBoxTemplate:onClickBack()
	AudioManager:playEffect(Conf.cancleButton)
	if self.closeCallback then
		self.closeCallback();
		return
	end
	EventManager:FireEvent(EventType.UIMessageBoxClose);
end

function MessageBoxTemplate:setPosition(x,y)
	self.root:setPosition(cc.p(x,y))
end
function MessageBoxTemplate:setZOrder(order)
	self.root:setZOrder(order);
end
function MessageBoxTemplate:setName(name)
	self.root:setName(name);
end
function MessageBoxTemplate:setOkBtnName(text)
	-- self.buttonList[self.btnCount][self.btnCount]:setTitleText(text)
	self.buttonLabel[self.btnCount][self.btnCount]:setString(text)
end

function MessageBoxTemplate:getOKBtn(  )
	if self.btnCount == nil or self.buttonList[self.btnCount] == nil then
		return nil;
	end
	return self.buttonList[self.btnCount][self.btnCount];
end

function MessageBoxTemplate:setCancelBtnName(text)
	-- self.buttonList[1][1]:setTitleText(text)
	self.buttonLabel[self.btnCount][1]:setString(text)
end

function MessageBoxTemplate:removeFromParent()
	self.root:removeFromParent();
end

function MessageBoxTemplate:setLocalZOrder(zorder)
	self.root:setLocalZOrder(zorder);
end

function MessageBoxTemplate:setCostInfo(icon, v1, v2)
	-- body
	self.costNode:setVisible(true)
	self.btnNode:setPosition(0,-90)
	self.boxBg:setContentSize(cc.size(602,350+100));
	self.boxBg:setPosition(0, 42.5-50);

	self.cost1Icon:setTexture(icon)
	self.cost2Icon:setTexture(icon)
	self.cost1Value:setString(v1)
	self.cost2Value:setString(v2)

end

function MessageBoxTemplate:setTitle(title)
	if title then
		self.title:getChildByName('title'):setString(tostring(title));
	end
end
return MessageBoxTemplate;
