local MessageBoxType2Template = class("MessageBoxType2Template")

local fonts = Enum:getTable("SystemFont")

local default = 
{
	[1] = cc.c3b(100, 100, 100),
	[2] = fonts.FONT_SIYUAN,
	[3] = 20
}
--[[ 
	boxData = {
		title = '',
		text = '',
		icon = '',
		OKLabelName = '',
	}
]]
function MessageBoxType2Template:ctor(father)

	self.btnCount = 0;

	local root  = cc.Node:create();
	self.root   = root;
	self.father = father;

	 default = 
	{
		[1] = cc.c3b(100, 100, 100),
		[2] = fonts.FONT_SIYUAN,
		[3] = 20
	}

	--大背景
	self.blackBg = cc.LayerColor:create(cc.c4b(0, 0, 0, 210), StageSize.width, StageSize.height);
    self.blackBg:setLocalZOrder(-100);
	self.blackBg:setPosition(-StageSize.width/2, -StageSize.height/2);
	self.blackBg:addTo(self.root);

	self.close = ccui.Layout:create();
	self.close:setTouchEnabled(true);
	self.close:setContentSize(cc.size(StageSize.width, StageSize.height));
	self.close:setAnchorPoint(cc.p(0.5,0.5));
	self.close:setPosition(0, 0);
	self.close:addTo(self.root);
	self.close:addClickEventListener(handler(self , self.onClickBack));

	self.boxBg = ccui.Layout:create();
	self.boxBg:setBackGroundImage('image/commonImg/common_tips_bg2.png');
	self.boxBg:setTouchEnabled(true);
	self.boxBg:setAnchorPoint(cc.p(0.5,0.5));
	-- self.boxBg:setPosition(0, 73);
	self.boxBg:addTo(self.root);

	local posX = 
	{
		[1] = {0},
		[2] = {-118, 118},
	}
	local btnText = 
	{
		[1] = {LANG.COMMON_OK},
		[2] = {LANG.COMMON_CANCEL , LANG.COMMON_OK},
	}
	local btnImg = {
		[1] = {'res/image/commonImg/btn_bg1.png'},
		[2] = {'res/image/commonImg/btn_bg2.png' , 'res/image/commonImg/btn_bg1.png'},
	}

	self.buttonList = {};
	for i = 1 , 2 do
		self.buttonList[i] = {}
		local btnNode = cc.Node:create();
		btnNode:addTo(self.root);
		btnNode:setPosition(0 , -6);
		btnNode:setVisible(false);
		self.buttonList[i].node = btnNode
		self.buttonList[i].btn = {}
		self.buttonList[i].btnLabel = {}
		for j = 1 , i do
			self.buttonList[i].btn[j] = ccui.Button:create(btnImg[i][j] , btnImg[i][j]);
			self.buttonList[i].btn[j]:addTo(btnNode);
			self.buttonList[i].btn[j]:setPosition(posX[i][j], -147);

			local btnLabel = cc.Label:createWithTTF(btnText[i][j] , fonts.FONT_SIYUAN , 20);
			if i == 2 and j == 1 then
				btnLabel:setTextColor(cc.c3b(60 , 60 , 60));
				btnLabel:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
			else
				btnLabel:setTextColor(cc.c3b(255 , 255 , 255));
				btnLabel:enableOutline(cc.c4b(60 , 60 , 60 , 60) , 2);
			end
			self.buttonList[i].btnLabel[j] = btnLabel;
			self.buttonList[i].btn[j]:setTitleLabel(btnLabel);

		end
	end

	self.title = cc.Label:createWithTTF(LANG.COMMON_TIP , fonts.FONT_SIYUAN , 20);
	self.title:addTo(self.root);
	self.title:setPosition(0, 183);

	self.icon = cc.Sprite:create()
		:addTo(self.root)
		:setPosition(cc.p(0,91))

	self.midText = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20)
		:addTo(self.root)
		:setTextColor(cc.c4b(60 , 60 , 60 , 255))
		:setPosition(cc.p(0,-2))
		:setAnchorPoint(cc.p(0.5 , 1))
		:setLineBreakWithoutSpace(true)
		:setMaxLineWidth(450)
			-- self.midText = ccui.RichText:create();
	-- self.midText:setAnchorPoint(cc.p(0.5 , 0.5));
	-- self.midText:addTo(self.root);
	-- self.midText:setPosition(0 , 93);

	--self.root:setScale(0.5);
	--self.root:runAction(cc.ScaleTo:create(0.1,1,1));
	self.root:setVisible(true);

	father:addChild(self.root);
end

function MessageBoxType2Template:initData(boxData,buttonCount)
	self.btnCount = buttonCount;
	if not self.buttonList[self.btnCount] or not self.buttonList[self.btnCount].node then
		return;
	end
	local text ='';
	if type(boxData) == 'string' then
		text = boxData
	else
		text = boxData.text or ''
	end

	self.midText:setString(text)

	if boxData.title then
		self.title:setString(boxData.title)
	end

	self.icon:setVisible(boxData.icon and boxData ~= '')
	if boxData.icon then
		self.icon:setTexture(boxData.icon);
	end
	if boxData.OKLabelName then
		self.buttonList[self.btnCount].btnLabel[self.btnCount]:setString(boxData.OKLabelName);
	end

	self.buttonList[self.btnCount].node:setVisible(true);
end

function MessageBoxType2Template:addClickListener(callback, cancelCallback, clickBackgroundCallback)
	for i = 1 , self.btnCount do
		if callback and (i == self.btnCount) then
			self:setCallback(callback);
			self.buttonList[self.btnCount].btn[i]:addClickEventListener(handler(self,self.OkClick));
		else
			self.buttonList[self.btnCount].btn[i]:addClickEventListener(handler(self,self.CancelClick));
		end
	end

	if cancelCallback then
		self:setCancelCallback(cancelCallback);
	end

	if clickBackgroundCallback then
		self:setCloseCallbak(clickBackgroundCallback)
	else
		self.closeCallback = nil
	end
end

function MessageBoxType2Template:setCallback(callback)
	if callback then
		self.callback = callback;
	end
end

function MessageBoxType2Template:setCancelCallback(callback)
	if callback then
		self.cancelCallback = callback;
	end
end

function MessageBoxType2Template:setCloseCallbak(callback)
	if callback then
		self.closeCallback = callback
	end
end

function MessageBoxType2Template:OkClick()
	AudioManager:playEffect(Conf.confirmButton)
	if self.callback then
		self.callback();
		self.callback = nil;
	end
	EventManager:FireEvent(EventType.UIMessageBoxClose);
end
function MessageBoxType2Template:CancelClick()
	AudioManager:playEffect(Conf.cancleButton)
	if self.cancelCallback then
		self.cancelCallback();
		self.cancelCallback = nil;
	end
	EventManager:FireEvent(EventType.UIMessageBoxClose);
end
function MessageBoxType2Template:onClickBack()
	AudioManager:playEffect(Conf.cancleButton)
	if self.closeCallback then
		self.closeCallback();
		return
	end
	EventManager:FireEvent(EventType.UIMessageBoxClose);
end

function MessageBoxType2Template:setPosition(x,y)
	self.root:setPosition(cc.p(x,y))
end
function MessageBoxType2Template:setZOrder(order)
	self.root:setZOrder(order);
end
function MessageBoxType2Template:setName(name)
	self.root:setName(name);
end
function MessageBoxType2Template:setOkBtnName(text)
	self.buttonList[self.btnCount].btnLabel[self.btnCount]:setString(text)
end

function MessageBoxType2Template:setCancelBtnName(text)
	self.buttonList[self.btnCount].btnLabel[1]:setString(text)
end

function MessageBoxType2Template:removeFromParent()
	self.root:removeFromParent();
end

function MessageBoxType2Template:setLocalZOrder(zorder)
	self.root:setLocalZOrder(zorder);
end

function MessageBoxType2Template:setTitle(title)
	if title then
		self.title:setString(tostring(title));
	end
end

return MessageBoxType2Template;
