local OnlineItemTemplate = class('OnlineItemTemplate',function (  )
	return cc.Node:create();
end) --,cc.Node:create()
local fonts = Enum:getTable('SystemFont')

function OnlineItemTemplate:ctor(  )
	
	self.id = -1;
	self.status = -1;

    self:InitItem();

end

function OnlineItemTemplate:InitItem(  )
	self:setCascadeOpacityEnabled(true);

	local itemBg = cc.Sprite:create('image/onlineReward/online_reward_2.png')
	itemBg:addTo(self);

	self.rewardIcon = template.ItemTemplate:create(2);
	self.rewardIcon:addTo(self);
	self.rewardIcon:setPosition(0 , 11);
	self.rewardIcon:addItemClickEventListener(handler(self,self.clickItem));

	self.getNode = cc.Node:create();
	self.getNode:addTo(self);

	local selectBg = cc.Scale9Sprite:create('image/commonImg/select_1_20_20_93_117.png');
	selectBg:addTo(self.getNode);
    selectBg:setCapInsets(cc.rect(20,20,93,117));
	selectBg:setContentSize(cc.size(133 , 157));

	self.getLabel = cc.Label:createWithTTF(LANG.UI_ACTIVITY_20 , fonts.FONT_JP , 18);
	self.getLabel:addTo(self);
	self.getLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);
	self.getLabel:setPosition(0 , -54);
	self.getLabel:setTextColor(cc.c3b(255 , 255 , 255));

	self.getedNode = cc.Node:create();
	self.getedNode:addTo(self);

	local getedLabel = cc.Label:createWithTTF(LANG.UI_ACTIVITY_19 , fonts.FONT_JP , 18);
	getedLabel:addTo(self.getedNode);
	getedLabel:setTextColor(cc.c3b(60 , 60 , 60));
	getedLabel:enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2);
	getedLabel:setPosition(0 , -54);

	local getedBg = cc.Scale9Sprite:create('image/commonImg/geted_1_20_20_77_102.png');
	getedBg:addTo(self.getedNode);
    getedBg:setCapInsets(cc.rect(20,20,70,102));
	getedBg:setContentSize(cc.size(117 , 142));

	local bg = cc.Sprite:create('image/commonImg/geted.png');
	bg:addTo(self.getedNode);
	bg:setPosition(0,11);
end

function OnlineItemTemplate:InitData( data  )

	self.id = data.id;
	self.time = data.time;
	local _k, reward = next(data.reward);
	self.reward = reward;
	self.rewardIcon:Init(tonumber(reward[1]) , tonumber(reward[2]));
	self.canGet = false;
    -- local rank = ResTable:getValue('role_pre', data.role_id , 'rank');
	self:setStatus( data.status )
end

function OnlineItemTemplate:setStatus( status )
	self.status = status or false;
	if self.status == true  then
		self.getNode:setVisible(false);
		self.getedNode:setVisible(true);
		self.getLabel:setVisible(false);
	else
		self.getLabel:setVisible(true);
		local onlineSecond = model.OnlineModel:getOnlineSecondTotal()
		if onlineSecond < self.time then
			--为到时
			self.getNode:setVisible(false);
			self.getLabel:setString(LANG.UI_ROUND_21);
			self.getedNode:setVisible(false);
		else
			self.canGet = true ;
			self.getNode:setVisible(true);
			self.getedNode:setVisible(false);
			self.getLabel:setString(LANG.UI_ACTIVITY_20);
		end
	end


end

function OnlineItemTemplate:clickItem(  )
	-- if self.itemCallback then
	-- 	self.itemCallback(self.id);
	-- end
	print('============click Item ',self.id,'....',self.canGet)
	if self.canGet == true  then
		model.OnlineModel:reqOnlineReward(self.id);
	else
		GlobalFunctions:showCommonInfo(self.reward[1],self.reward[2]);
	end

end

function OnlineItemTemplate:setStateAction(callback)
	self.geted:showAction(callback);
end

function OnlineItemTemplate:setItemCallback(callback)
	self.itemCallback = callback;
end

return OnlineItemTemplate;