local RankItem = class('RankItem', function() 
    return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")
local RANK_ENUM = Enum:getTable('RANK_ENUM');

function RankItem:ctor(father)
    self:addTo(father);

    self.node = cc.Node:create();
    self.node:addTo(self);
    self.node:setPosition(280, 34)
    self.node:setCascadeOpacityEnabled(true);

    local bg = cc.Scale9Sprite:create('image/rank/rank_cell_bg.png')
    bg:addTo(self.node)
    bg:setContentSize(cc.size(558 , 68));
    bg:setCapInsets(CCRectMake(15,0,10,68));

	self.bg = cc.Scale9Sprite:create('image/rank/rank_cell_1.png');
    self.bg:setContentSize(cc.size(558 , 68));
    self.bg:setCapInsets(CCRectMake(55,0,40,68));
    self.bg:addTo(self.node);

    -- self.rankNumSpr = cc.Sprite:create('image/commonImg/npc_icon.png')
    -- self.rankNumSpr:addTo(self.node)
    -- self.rankNumSpr:setPosition(-230, 0)

    self.rankNumLabel = cc.Label:createWithTTF('99' ,  fonts.FONT_SIYUAN , 20)
    self.rankNumLabel:addTo(self.node);
    self.rankNumLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.rankNumLabel:setPosition(-240 , 0);

    local headBg = cc.Sprite:create('image/commonImg/icon_enemy.png');
    headBg:setPosition(-170 , 0);
    headBg:addTo(self.node);
    headBg:setScale(0.55)

    self.headIcon = cc.Sprite:create();
    self.headIcon:addTo(self.node);
    self.headIcon:setPosition(-170, 0);
    self.headIcon:setScale(0.5);

    self.curName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20);
    self.curName:addTo(self.node);
    self.curName:enableOutline(cc.c4b(60 , 60 , 60 , 255),2);
    self.curName:setAnchorPoint(0 , 0.5);
    self.curName:setPosition(-100 , 0);
    
    self.valIcon = cc.Sprite:create('image/arena/rankList/arena_rank_list_3.png');
    self.valIcon:addTo(self.node);
    self.valIcon:setPosition(120,0);

    self.valName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 20)
    self.valName:addTo(self.node);
    self.valName:setAnchorPoint(cc.p(0,0.5));
    self.valName:setPosition(100 , 0);

    self.guildValName = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 15)
    self.guildValName:addTo(self.node);
    self.guildValName:setAnchorPoint(cc.p(0,0.5));
    self.guildValName:setPosition(100 , 0);

    self.valLabel = cc.Label:createWithTTF('' ,  fonts.FONT_SIYUAN , 15)
    self.valLabel:addTo(self.node);
    self.valLabel:setAnchorPoint(cc.p(1, 0.5));
    -- self.valLabel:setTextColor(cc.c3b(255 , 255 , 0));
    self.valLabel:setPosition(240 , 0);
    self.valLabel:enableOutline(cc.c4b(0 , 0 , 0 , 255),1);
    
 --    local spine_res = 'shengya_spine'
	-- if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
	-- 	self.rankListSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
	-- 	self.rankListSpine:addTo(self)
 --        self.rankListSpine:setPosition(cc.p(0 , 0))
 --        self.rankListSpine:registerSpineEventHandler(function (event)
 --            if event.eventData.name == 'appear' then
 --                self.node:setVisible(true);
 --                self.node:setOpacity(0);
 --                self.node:runAction(cc.FadeIn:create(16/30));
 --            end
 --        end, sp.EventType.ANIMATION_EVENT)

 --        self.rankListSpine:registerSpineEventHandler(function (event)
 --            self.rankListSpine:setVisible(false);
 --        end, sp.EventType.ANIMATION_COMPLETE)
	-- else
	-- 	print('error : 缺少spine 资源')
	-- end  
	
end
function RankItem:initData(data, rankType)
	self.data = data;

    if rankType ~= RANK_ENUM.ENUM_4 then
        local headIconFile = GlobalFunctions:getHeadIconFile(data.role)
    	self.headIcon:setTexture(headIconFile);
        self.headIcon:setScale(0.5);
    else 
        self.headIcon:setScale(0.3);
    end
   

	self.curName:setString(tostring(data.name));

    if rankType == RANK_ENUM.ENUM_1 then
        local tmpVal = ResTable:getValue('round', data.value , 'name') or 0;
        self.valLabel:setString(string.format(LANG.UI_ROUND_23, tostring(tmpVal)));
        self.valName:setString(LANG.UI_L_RANK_11)
        self.valName:setBMFontSize(20);
        self.valIcon:setVisible(false);
        self.valName:setVisible(true);
        self.guildValName:setVisible(false);
        if tmpVal == '9999' then
            self.valLabel:setString(LANG.UI_L_PASS)
        end

    elseif rankType == RANK_ENUM.ENUM_2 or rankType == RANK_ENUM.ENUM_201 then
        local tmpVal = data.value or 0;
        self.valLabel:setString(tostring(tmpVal));
        self.valName:setString('')
        self.valIcon:setVisible(true);
        self.valName:setVisible(true);
        self.guildValName:setVisible(false);
        -- self.valIcon:setTexture('image/arena/rankList/arena_rank_list_3.png');

    elseif rankType == RANK_ENUM.ENUM_3 then
        local tmpVal = ResTable:getValue('trial_round', data.value , 'no') or 0;
        self.valLabel:setString(string.format(LANG.UI_MAZE_4, tostring(tmpVal)));
        self.valName:setString(LANG.UI_L_RANK_11)
        self.valName:setBMFontSize(20);
        self.valIcon:setVisible(false);
        self.valName:setVisible(true);
        self.guildValName:setVisible(false);

    elseif rankType == RANK_ENUM.ENUM_4 then
        if data.value then
            self.valLabel:setString(tostring(ConvertStrToDigitUnit(data.value)));
        else
            self.valLabel:setString('');
        end
        self.valName:setVisible(false);
        self.guildValName:setVisible(true);
        self.guildValName:setString(LANG.UI_GUILD_RAID_RANK_5..':')
        self.valIcon:setVisible(false);

        if data.role then
            self.headIcon:setTexture('image/guild/guild_icon/icon_'..data.role..'.png');
        end

    elseif rankType == RANK_ENUM.ENUM_401 then
        if data.value then
            self.valLabel:setString(tostring(ConvertStrToDigitUnit(data.value)));
        else
            self.valLabel:setString('');
        end
        self.valName:setVisible(false);
        self.guildValName:setVisible(true);
        self.guildValName:setString(LANG.UI_GUILD_RAID_RANK_5..':')
        self.valIcon:setVisible(false);

    end

    if data.rank<=0 or data.rank > 3 then
        self.bg:setVisible(false)
        self.rankNumLabel:setString(tostring(data.rank))
        if data.rank == -1 then
            self.rankNumLabel:setString(LANG.UI_L_RANK_12)
        end
    else
        self.bg:setVisible(true)
        self.rankNumLabel:setString('')

        self.bg:setTexture('image/rank/rank_cell_'..data.rank..'.png');
        self.bg:setContentSize(cc.size(558 , 68));
        self.bg:setCapInsets(CCRectMake(55,0,40,68));
    end
    
end

function RankItem:runRefreshAction(delayFrame)
    delayFrame = delayFrame or 1;
    self:stopAllActions()
    self.node:stopAllActions()
    self.node:setVisible(false);
	self:runAction(cc.Sequence:create(
		cc.DelayTime:create(delayFrame/30),
		cc.CallFunc:create( function (  )
   --          if self.rankListSpine  then
   --              self.rankListSpine:setVisible(true);
	  --           self.rankListSpine:clearTracks();
			-- 	self.rankListSpine:setAnimation(0, 'jingjichang_spine', false)
			-- end
		end)
	));
end

return RankItem;