local RechargeTaskCell = class("RechargeTaskCell" , function()
	return cc.Node:create();
end)
local fonts = Enum:getTable("SystemFont")

function RechargeTaskCell:ctor()

	self:setCascadeOpacityEnabled(true);

	local bg = cc.Sprite:create('image/activity/three_day/re_task_cell.png');
	bg:addTo(self);

	self.round = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.round:setPosition(0 , 52);
	self.round:setAnchorPoint(0.5 , 0.5);
	self.round:setTextColor(cc.c3b(255 , 255 , 255));
	self.round:enableOutline(cc.c3b(0 , 0 , 0) , 2);
	self.round:addTo(self);

	self.rewardView = ccui.ScrollView:create();
	self.rewardView:setTouchEnabled(true); 
	self.rewardView:setBounceEnabled(true);
	self.rewardView:setDirection(ccui.ScrollViewDir.horizontal);
	self.rewardView:setContentSize(cc.size(230, 87));
	self.rewardView:setAnchorPoint(cc.p(0.5, 0.5));
	self.rewardView:setPosition(-55 , -16);
	-- self.rewardView:setScrollBarEnabled(false);
	self.rewardView:addTo(self);

	local rdNode = cc.Node:create()
	rdNode:addTo(self)
	rdNode:setPosition(123, -16)

	self.rewardBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png' , 'image/commonImg/btn_2_103_36.png');
	self.rewardBtn:addTo(rdNode);
	self.rewardBtn:addClickEventListener(handler(self , self.rewardBtnClick));

	self.rewardLabel = cc.Label:createWithTTF(LANG.UI_ROUND_18 , fonts.FONT_SIYUAN , 18);
	self.rewardLabel:addTo(self.rewardBtn);
	self.rewardLabel:setPosition(self.rewardBtn:getContentSize().width/2 , self.rewardBtn:getContentSize().height/2);
	self.rewardLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.rewardLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

	self.notEnough = cc.Sprite:create('image/commonImg/btn_7_103_36.png');
	self.notEnough:addTo(rdNode);

	local label = cc.Label:createWithTTF(LANG.UI_ROUND_21 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.notEnough);
	label:setPosition(self.notEnough:getContentSize().width/2 , self.notEnough:getContentSize().height/2);
	label:setTextColor(cc.c3b(60 , 60 , 60));
	label:enableOutline(cc.c4b(200 , 200 , 200 , 255) , 2);

	self.geted = cc.Sprite:create('image/commonImg/btn_7_103_36.png');
	self.geted:addTo(rdNode);

	local label = cc.Label:createWithTTF(LANG.UI_MISSION_26 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.geted);
	label:setPosition(self.geted:getContentSize().width/2 , self.geted:getContentSize().height/2);
	label:setTextColor(cc.c3b(255 , 255 , 255));
	label:enableOutline(cc.c4b(55 , 85 , 155 , 255) , 2);
	local spr = cc.Sprite:create('image/commonImg/geted.png')
	spr:addTo(self.geted)
	spr:setPosition(self.geted:getContentSize().width/2 , self.geted:getContentSize().height/2);
end

function RechargeTaskCell:Init(rewardId, tbName, dict)

	self.tbName = tbName;
	self.cellId = rewardId;
	if tbName=='recharge_task' then
		self:setReward(dict.reward_item);
		local name = string.format(LANG.UI_RECHARGE_10, tostring(dict.value))
		self.round:setString(name);

		self:updateState(dict.status);
	else

	end

end

function RechargeTaskCell:updateState(state)
	self.rewardBtn:setVisible(false);
	self.notEnough:setVisible(false);
	self.geted:setVisible(false);
	if state == 0 then -- 未达成
		self.rewardLabel:setString(LANG.UI_ROUND_19);
		self.notEnough:setVisible(true);
	elseif state == 1 then --领取
		self.rewardLabel:setString(LANG.UI_ROUND_18);
		self.rewardBtn:setTag(1);
		self.rewardBtn:setVisible(true);
		self.round:setString(LANG.UI_RECHARGE_9);
	elseif state == 2 then --以领取
		self.geted:setVisible(true);
		self.round:setString(LANG.UI_RECHARGE_9);
	end
end

function RechargeTaskCell:setReward(reward)
	local rewardNum = #reward;

	local maxWidth = rewardNum * 76;
	maxWidth = maxWidth < 230 and 230 or maxWidth;

	self.rewardView:removeAllChildren();
	self.rewardView:setInnerContainerSize(cc.size(maxWidth, 87));

	for i=1, rewardNum do
		local r = reward[i];
		local layout = ccui.Layout:create();
		layout:addTo(self.rewardView);
		local icon = template.ItemTemplate:create(2);
		icon:addTo(layout);
		icon:Init(r[1] , r[2]);
		-- icon:Init(10007+i , 100);
		icon:setScale(0.7);
		icon:setPosition(38 + 76 * (i - 1) , 43.5);
	end
	self.rewardView:setTouchEnabled(rewardNum > 2);
end

function RechargeTaskCell:rewardBtnClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(self.tag , tag);
	end
	self:updateState(2)
end

function RechargeTaskCell:setBtnTag(tag)
	self.tag = tag;
end

function RechargeTaskCell:addBtnClickEventListener(callback)
	self.callback = callback;
end

function RechargeTaskCell:setGetRewardBtnVisible(visible)
	self.rewardBtn:setVisible(visible);
end

return RechargeTaskCell;
