local RoleTemplate = class('RoleTemplate') --,cc.Node:create()
local fonts = Enum:getTable('SystemFont')

function RoleTemplate:ctor( father )
    
    self:InitRole(father);

end

function RoleTemplate:InitRole( father )
	self.root=ccui.Layout:create();
	father:addChild(self.root);
	self.root:setCascadeOpacityEnabled(true);

	self.click = ccui.Layout:create()
	self.click:setBackGroundImage('image/home/equip_bg_14.png');
	self.click:setContentSize(cc.size(116 , 156));
	self.click:setTouchEnabled(true);
	self.click:setSwallowTouches(false);
	self.click:setPosition(-58 , -78);
	self.click:addTo(self.root);
	-- icon
	self.icon = require('app.template.IconTemplate'):create(self.root);
	self.icon:setPosition(0 , 17);

	self.qualityNode = cc.Node:create();
	self.qualityNode:addTo(self.root);
	self.qualityNode:setPosition(0 , -55);

    self.select = {}
    self.select[1] = cc.Sprite:create('image/card/card_select_bg.png');
    self.select[1]:setAnchorPoint(cc.p(0,1));
    self.select[1]:setPosition(cc.p(-68,86));
    self.select[1]:addTo(self.root);
    self.select[1]:setVisible(false);

    self.select[2] = cc.Sprite:create('image/card/card_select_bg.png');
    self.select[2]:setAnchorPoint(cc.p(0,1));
    self.select[2]:setPosition(cc.p(68,-86));
    self.select[2]:addTo(self.root);
    self.select[2]:setRotation(180);
    self.select[2]:setVisible(false);

end

function RoleTemplate:Init( id , pid  )
    self.icon:Init(ROLE_TYPE,id, 0, 0, pid);

    local data = ResTable:getRowData('role' , id);
    local rank = ResTable:getValue('role_pre', data.role_id , 'rank');

	local col = (rank - 1) % 5 + 1
	local row = math.floor((rank - 1) / 5);
	for j=1,5 do
		local row1 = row;
		if col < j then
			row1 = row -1 
		end
		if row1 >= 0 then 
			local star = cc.Sprite:create('image/card/card_rank_'..tostring(row1 + 1)..'/6.png')
            star:addTo(self.qualityNode);
            star:setScale(0.7);
            star:setPosition(-40 + 20 * (j - 1) , 0);
		end 
	end

end

function RoleTemplate:setPosition(x, y)
	self.root:setPosition(cc.p(x, y));
end

function RoleTemplate:getPosition(  )
    return cc.p(self.root:getPosition());
end

function RoleTemplate:setScale(x, y)
	self.root:setScale(x, y);
end
function RoleTemplate:addClickEventListener(callback)
	self.click:addClickEventListener(callback);
end

function RoleTemplate:setTag(tag)
	self.click:setTag(tag);
end

function RoleTemplate:setSelect( select  )
    self.select[1]:setVisible(select);
    self.select[2]:setVisible(select);
end

function RoleTemplate:runAction(action)
	self.root:runAction(action);
end

function RoleTemplate:setVisible(visible)
	self.root:setVisible(visible);
end

return RoleTemplate;