local RoundBossItemTemplate = class('RoundBossItemTemplate',function (  )
	return cc.Node:create();
end) 

local MessageBoxType = Enum:getTable('MessageBoxType')
local fonts = Enum:getTable('SystemFont')
local imgPath = 'image/randomBoss/';

-- local bossQualityName = {
-- 	'普通级Boss',	--N
-- 	'一般级Boss',	--R
-- 	'稀有级Boss',	--SR
-- 	'传说级Boss',	--SSR
-- 	'史诗级Boss',	--HSSR
-- }

local bossQualityColor = {
	cc.c4b(175 , 175 , 175 , 255),
	cc.c4b(50 , 115 , 240 , 255),
	cc.c4b(170 , 0 , 220 , 255),
	cc.c4b(195 , 80 , 0 , 255),
	cc.c4b(180 , 130 , 0 , 255)
}

function RoundBossItemTemplate:ctor(  )
	
	self.no = -1;
	self.selected = false;
	self.bPlay = false;

    self:InitItem();
end

function RoundBossItemTemplate:InitItem(  )
	
	self.itemNode = cc.Node:create()
	self.title_pos = {50,50,75,99,123};

	self.stencil = cc.Sprite:create('image/commonImg/mask_icon.png');
	self.stencil:setContentSize(cc.size(586,180));
	self.stencil:setPosition(cc.p(293,0))
		:setAnchorPoint(cc.p(1,0.5))
		:setScale(0)
	self.clippingNode = cc.ClippingNode:create();
	self.clippingNode:setStencil(self.stencil);
	self.clippingNode:addChild(self.itemNode);
	self.clippingNode:setInverted(true);
	self.clippingNode:setAlphaThreshold(0);
	self:addChild(self.clippingNode);

	self.floorSp = cc.Sprite:create( imgPath .. 'bg_1_1.png')
	self.floorSp:addTo(self.itemNode)


	self.bossIcon = cc.Sprite:create( 'image/iconRoundBoss/boss1.png')
		:addTo(self.itemNode)
		:setPosition(cc.p(69,-1))

	local infoBgSp = cc.Sprite:create( imgPath.. 'random_bg4.png')
		:addTo(self.itemNode)
		:setPosition(cc.p(0,-62))

	self.floorBorder = cc.Sprite:create( imgPath .. 'bg_1_2.png')
		:addTo(self.itemNode)

	self.bossTitleSp = cc.Sprite:create( imgPath .. 'boss_difficult2.png')
		:addTo(self.itemNode)
		:setPosition(cc.p(-237,58))

    self.bossTitleLabel = cc.Label:createWithTTF(LANG.UI_RANDOMBOSS_TITLE[2], fonts.FONT_SIYUAN, 32)
		:addTo(self.itemNode)
		:setPosition(cc.p(-209,59))
		:setAnchorPoint( cc.p(0, 0.5) )
		:enableOutline(bossQualityColor[1] , 2)

	local powerSp = cc.Sprite:create('image/head/header_bg_9.png')
		:addTo(self.itemNode)
		:setPosition(cc.p(-237,5))

	local fpLable1 = cc.Label:createWithTTF(LANG.UI_ROUND_24,fonts.FONT_SIYUAN,20)
		:addTo(self.itemNode)
		:setPosition(cc.p(-220,6))
		:setAnchorPoint(cc.p(0,0.5))
		-- :setTextColor(cc.c4b(60 , 60 , 60 , 255))
	self.fpLabel = cc.Label:createWithTTF('9999',fonts.FONT_SIYUAN,25)
		:addTo(self.itemNode)
		:setPosition(cc.p(-249,-24))
		:setAnchorPoint(cc.p(0,0.5))	
		-- :setTextColor(cc.c4b(60 , 60 , 60 , 255))
		-- :enableOutline(cc.c4b(255 , 255 , 255 , 255) , 2)

	self.restraint = cc.Sprite:create()
		:addTo(self.itemNode)
		:setPosition(cc.p(-244,-61))
		:setScale(0.5)

	self.bossInfo = cc.Label:createWithTTF('boss info ',fonts.FONT_SIYUAN,16)
		:addTo(self.itemNode)
		:setPosition(cc.p(-223,-59))
		:setAnchorPoint(cc.p(0,0.5))

	-- self.fpRedDot = cc.Sprite:create( 'image/commonImg/tip_1.png')
	-- 	:addTo(self.itemNode)
	-- 	:setPosition(cc.p(-267,75))
	-- 	:setVisible(false)

	local rewardBg = cc.Sprite:create( imgPath..'reward_bg.png')
	rewardBg:addTo(self.itemNode);
	rewardBg:setPosition(cc.p(198,10))

	self.reward = template.ItemTemplate:create()
	self.reward:addTo(self.itemNode)
	self.reward:setPosition(cc.p(199,10))
	self.reward:setScale(0.7)
	self.reward:setCanShowInfo(true,true);

	local spine_res = 'ganzhi_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.randomBossSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.randomBossSpine:addTo(self)
		self.randomBossSpine:setPosition(cc.p(0 , 0))
	else
		print('error : 缺少spine 资源')
	end

	local spine_res = 'boss_double_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.dbSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.dbSpine:addTo(self.itemNode)
		self.dbSpine:setPosition(cc.p(220,70))
		self.dbSpine:setAnimation(0, 'boss_double_spine', true)
	else
		print('error : 缺少spine 资源')
	end  

	EventManager:RegisterEvent('RoundBossPanel:onUpdateDbInfo', handler(self, self.updateDoubleShow));
end






function RoundBossItemTemplate:itemTouchCall( sender )
	-- if self.callback then
	-- 	self.callback(self.no);
	-- end

	-- self:runRefresh()
end

function RoundBossItemTemplate:addClickCallBack( callback )
	self.callback = callback;
end

function RoundBossItemTemplate:initData( data )

	self.boss_difficulty = data.boss_difficulty 
	self.bossTitleSp:setTexture( imgPath .. 'boss_difficult'..tostring(self.boss_difficulty)..'.png')

	self.bossTitleLabel:setString( LANG.UI_RANDOMBOSS_TITLE[self.boss_difficulty] )
		:enableOutline(bossQualityColor[self.boss_difficulty] , 2)

	local def = data.def_type or 0
	self.restraint:setTexture('image/commonImg/def_type_'..tostring(def)..'.png');
	self.bossInfo:setString(tostring(data.info))

	local boss = { 
		{data.monster_id,data.attribute_id}
	}
	local totalFp = '0';
	local restraintFactor,enemyRestraintString = CardProManager:GetMonsterRestraintFactor(boss);
	for _k , data in pairs(boss) do
		local pro = CardProManager:GenMonsterPro(data[1], data[2],restraintFactor);
		if pro then
			totalFp = HpPlus(totalFp, ConvertDigitUnitToStr(pro.fp));
		end
	end
	self.fpLabel:setString(tostring(totalFp))
	--self.fpLabel:setString(tostring(data.fp))

	local curFp = model.TeamModel:getCurrentTeamFp()
	if compareTwoNumGreaterAndEqual(curFp, data.fp,true) then
		self.fpLabel:setTextColor(cc.c4b(255 , 255 , 255 , 255));
		-- self.fpRedDot:setVisible(true)
	else
		self.fpLabel:setTextColor(cc.c4b(255 , 0 , 0 , 255));
		-- self.fpRedDot:setVisible(false)
	end

	local boss_icon = data.boss_icon
	local filePath ='image/iconRoundBoss/boss'..tostring(boss_icon)..'.png'
	if cc.FileUtils:getInstance():isFileExist(filePath) then
		self.bossIcon:setTexture(filePath)
	end

	local filePath = imgPath .. 'bg_'..tostring(data.boss_difficulty)..'_1.png'  
	if cc.FileUtils:getInstance():isFileExist(filePath) then
		self.floorSp:setTexture(filePath)
	end
	local filePath2 = imgPath .. 'bg_'..tostring(data.boss_difficulty)..'_2.png' 
	if cc.FileUtils:getInstance():isFileExist(filePath2) then
		self.floorBorder:setTexture(filePath2)
	end
	local _k,reward1 = next(data.reward)
	if reward1 then
		self.reward:Init(reward1[1],reward1[2])
	end

	self:updateDoubleShow();
end

function RoundBossItemTemplate:runRefresh( bTrue ,delayFrame)
	if self.bPlay == true then
		return;
	end
	if bTrue then
		self.bPlay = true;
		delayFrame = delayFrame or 1

		self:stopAllActions()
		self.stencil:stopAllActions()
		self.stencil:setScale(1,1)
		self.itemNode:setVisible(true)
		self:runAction(cc.Sequence:create(
			cc.DelayTime:create(delayFrame/30),
			cc.CallFunc:create( function (  )
				if self.randomBossSpine  then
					local animationName = 'boss'..self.boss_difficulty
					self.randomBossSpine:setAnimation(0, animationName, false)
				end
				self.stencil:runAction(cc.ScaleTo:create(16/30,0,1))
			end),
			cc.DelayTime:create(17/30),
			cc.CallFunc:create( function (  )
				self.bPlay = false;
			end)
		))

		

	end

end

function RoundBossItemTemplate:updateDoubleShow()
	if model.RoundBossModel:isValidDBAct() and model.RoundBossModel:getDBTimes()>0 then
		self.dbSpine:setVisible(true)
	else
		self.dbSpine:setVisible(false)
	end
end


return RoundBossItemTemplate;