local RoundIconTemplate = class("RoundIconTemplate")

local imgPath = 'image/fight/map/';
function RoundIconTemplate:ctor(father)
	self.father = father;
	
	self.root = cc.Node:create();
	self.root:addTo(self.father);

	self.bottomMark = cc.Sprite:create(imgPath .. 'bottom.png')
		:addTo(self.root)

	self.finishMark = cc.Sprite:create(imgPath .. 'point_finish.png')
		:setAnchorPoint(cc.p(0.5, 0))
		:addTo(self.root)

	self.unFinishMark = cc.Sprite:create(imgPath .. 'point_unfinish.png')
		:setAnchorPoint(cc.p(0.5, 0))
		:addTo(self.root)

	self.smallMark = cc.Sprite:create(imgPath .. 'point_small.png')
		:addTo(self.root)
end

function RoundIconTemplate:Init(no, isBig)
	self.no = no;
	self.isBig = isBig or false;
	local name = ResTable:getValue('round', no, 'name');
	self.name = name
end

function RoundIconTemplate:setCur(curRound)
	if not self.no then
		return;
	end
	self.smallMark:setVisible(false);
	if self.isBig then
		self.bottomMark:setVisible(true)
		self.finishMark:setVisible(self.no < curRound);
		self.unFinishMark:setVisible(self.no > curRound);
	else
		self.bottomMark:setVisible(false)
		self.finishMark:setVisible(false);
		self.unFinishMark:setVisible(false);
		self.smallMark:setVisible(true);
	end
	if self.no == curRound then
		local spine_res = 'guanqia'
		if not self.skeletonNode then
			self.skeletonNode = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
			self.skeletonNode:addTo(self.father)
			self.skeletonNode:setPosition(self.posX, self.posY)
			self.skeletonNode:setAnimation(0, "guanqia", true)

			self.sp = cc.Sprite:create(imgPath .. 'sp.png')
				:setPosition(self.posX, self.posY)
				:addTo(self.father)

			self.word = cc.Label:createWithTTF(string.format(LANG.UI_ROUND_23, tostring(self.name)), Enum:getTable('SystemFont').FONT_SIYUAN, 18)
				:setPosition(self.posX, self.posY)
				:enableOutline(cc.c3b(0, 0, 0), 1)
				:addTo(self.father)

			if self.name == '9999' then
				self.word:setString(LANG.UI_L_PASS)
			end
		end
	else
		if self.skeletonNode then
			self.skeletonNode:removeFromParent()
			self.skeletonNode = nil

			self.sp:removeFromParent()

			self.word:removeFromParent()
		end
	end
	if self.no < curRound then
		self.smallMark:setVisible(false);
	end
end

function RoundIconTemplate:setPosition(x, y)
	self.root:setPosition(x, y)
	self.posX = x
	self.posY = y
end

function RoundIconTemplate:setScalue( scale )
	self.root:setScalue( scale );
end

function RoundIconTemplate:setVisible( flag )
	self.root:setVisible(flag);
end

return RoundIconTemplate;
