local RoundTargetRewardTemplate = class("RoundTargetRewardTemplate" , function() 
	return cc.Node:create();
end)
local fonts = Enum:getTable("SystemFont")

function RoundTargetRewardTemplate:ctor()

	self:setCascadeOpacityEnabled(true);

	local bg = cc.Sprite:create('image/commonImg/bg_4_563_126.png');
	bg:addTo(self);

	self.round = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.round:setPosition(-60 , 32);
	self.round:setAnchorPoint(0 , 0.5);
	self.round:enableOutline(cc.c3b(40 , 50 , 60) , 2);
	self.round:addTo(self);

	local rewardBg = cc.Sprite:create('image/commonImg/bg_3_194_102.png');
	rewardBg:addTo(self);
	rewardBg:setPosition(-174 , 0);

	self.rewardView = ccui.ScrollView:create();
	self.rewardView:setTouchEnabled(true);
	self.rewardView:setBounceEnabled(true);
	self.rewardView:setDirection(ccui.ScrollViewDir.horizontal);
	self.rewardView:setContentSize(cc.size(185, 87));
	self.rewardView:setAnchorPoint(cc.p(0.5, 0.5));
	self.rewardView:setPosition(-174 , 0);
	self.rewardView:setScrollBarEnabled(false);
	self.rewardView:addTo(self);

	local rewardProgressBg = cc.Sprite:create('image/commonImg/pgs_bg_1_213_12.png');
	rewardProgressBg:addTo(self);
	rewardProgressBg:setPosition(41 , -14);

	self.rewardProgress = cc.Scale9Sprite:create('image/commonImg/pgs_2_14_12.png');
	self.rewardProgress:setCapInsets(CCRectMake(6,0,2,12));
	self.rewardProgress:addTo(self);
	self.rewardProgress:setAnchorPoint(0 , 0.5);
	self.rewardProgress:setPosition(-65 , -14);

	self.roundProgress = cc.Label:createWithTTF('1/1' , fonts.FONT_SIYUAN , 18);
	self.roundProgress:addTo(self);
	self.roundProgress:setPosition(41 , -37);
	self.roundProgress:enableOutline(cc.c4b(40 , 50 , 60 , 255) , 2);

	self.rewardBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png' , 'image/commonImg/btn_2_103_36.png');
	self.rewardBtn:addTo(self);
	self.rewardBtn:setPosition(219 , -12);
	self.rewardBtn:addClickEventListener(handler(self , self.rewardBtnClick));

	self.rewardLabel = cc.Label:createWithTTF(LANG.UI_ROUND_18 , fonts.FONT_SIYUAN , 18);
	self.rewardLabel:addTo(self.rewardBtn);
	self.rewardLabel:setPosition(self.rewardBtn:getContentSize().width/2 , self.rewardBtn:getContentSize().height/2);
	self.rewardLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.rewardLabel:enableOutline(cc.c4b(60 , 60 , 60 , 255) , 2);

	self.notEnough = cc.Sprite:create('image/commonImg/btn_3_103_36.png');
	self.notEnough:addTo(self);
	self.notEnough:setPosition(219 , 0);

	local label = cc.Label:createWithTTF(LANG.UI_ROUND_21 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.notEnough);
	label:setPosition(self.notEnough:getContentSize().width/2 , self.notEnough:getContentSize().height/2);
	label:setTextColor(cc.c3b(60 , 60 , 60));
	label:enableOutline(cc.c4b(200 , 200 , 200 , 255) , 2);

	self.geted = cc.Sprite:create('image/commonImg/btn_4_103_36.png');
	self.geted:addTo(self);
	self.geted:setPosition(219 , 0);

	local label = cc.Label:createWithTTF(LANG.UI_ACTIVITY_19 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.geted);
	label:setPosition(self.geted:getContentSize().width/2 , self.geted:getContentSize().height/2);
	label:setTextColor(cc.c3b(255 , 255 , 255));
	label:enableOutline(cc.c4b(55 , 85 , 155 , 255) , 2);

	self.eventPtIcon = cc.Sprite:create();
	self.eventPtIcon:addTo(self);
	self.eventPtIcon:setPosition(-25 , 45);
	self.eventPtIcon:setAnchorPoint(0 , 0.5);
	self.eventPtIcon:setScale(0.5);
	self.eventPtIcon:setVisible(false);

	self.eventPtLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.eventPtLabel:setPosition(-25 , 45);
	self.eventPtLabel:setAnchorPoint(0 , 0.5);
	self.eventPtLabel:setTextColor(cc.c3b(60 , 60 , 60));
	self.eventPtLabel:addTo(self);
	self.eventPtLabel:setVisible(false);
end

function RoundTargetRewardTemplate:Init(reward)

	local roundName = ResTable:getValue('round', reward.round_id, 'name');

	local curRound = model.RoundModel:getRoundIndex();

	self.rewardBtn:setVisible(true);
	if not model.RoundModel:getRoundRewarded(reward.id) and curRound > reward.round_id then
		self:updateState(1);
	elseif model.RoundModel:getRoundRewarded(reward.id) and curRound > reward.round_id then
		self:updateState(2);
	else
		self:updateState(0);
	end

	local curChapter = model.RoundModel:getChapter();
	local curPoint = model.RoundModel:getCheckpoint();

	local preRoundData = model.RoundModel:getChapterData(curChapter, (curPoint - 1));
	if not preRoundData then
		local preChapterData = model.RoundModel:getChapterData(curChapter - 1);
		if preChapterData then
			preRoundData = preChapterData[#preChapterData];
		end
	end

	local curRoundName = '0';
	if preRoundData then
		curRoundName = ResTable:getValue('round' , preRoundData.round_id , 'name');
	end

	self.round:setString(tostring(LANG.UI_ROUND_20..tostring(roundName))..' ('..tostring(curRoundName)..'/'..tostring(roundName)..')');
	self.roundProgress:setString(tostring(curRoundName)..'/'..tostring(roundName));

	local percent = tonumber(curRoundName) / tonumber(roundName);
	percent = percent > 1 and 1 or percent;
	self.rewardProgress:setTextureRect(cc.rect(0, 0, 187*percent, 7));

	self:setReward(reward.reward);

	self.eventPtIcon:setVisible(false);
	self.eventPtLabel:setVisible(false);
end

function RoundTargetRewardTemplate:InitTrial(reward)
	local curRound = model.TrialModel:getFinshTrialId();
	
	if not model.TrialModel:getStatusById(reward.id) and curRound >= reward.round_id then
		self:updateState(1);
	elseif model.TrialModel:getStatusById(reward.id) and curRound >= reward.round_id then
		self:updateState(2);
	else
		self:updateState(0);
	end

	self.roundProgress:setString(tostring(curRound)..'/'..tostring(reward.round_id));

	local percentage = tonumber(curRound) / tonumber(reward.round_id);
	percentage = percentage > 1 and 1 or percentage;

	local width = 213 * percentage;
	if width > 0 then
		width = width < 14 and 14 or width;
	end
	self.rewardProgress:setContentSize(cc.size(width , 12));

	self.round:setString(string.format(LANG.UI_ROUND_27,reward.round_id));

	self:setReward(reward.aim_reward);

	self.eventPtIcon:setVisible(false);
	self.eventPtLabel:setVisible(false);
end

function RoundTargetRewardTemplate:InitEventReward(reward)
	local curTotalMoeny = model.EventModel:getEventTotalMoney();
	
	if not model.EventModel:getEventRewardState(reward.id) and curTotalMoeny >= reward.total_point then
		self:updateState(1);
	elseif model.EventModel:getEventRewardState(reward.id) and curTotalMoeny >= reward.total_point then
		self:updateState(2);
	else
		self:updateState(0);
	end

	self.roundProgress:setString(tostring(curTotalMoeny)..'/'..tostring(reward.total_point));

	local percentage = tonumber(curTotalMoeny) / tonumber(reward.total_point);
	percentage = percentage > 1 and 1 or percentage;

	local width = 213 * percentage;
	if width > 0 then
		width = width < 14 and 14 or width;
	end
	self.rewardProgress:setContentSize(cc.size(width , 12));

	self.round:setString(LANG.UI_ROUND_22);

	local data = ResTable:getRowData('item' , EVENT_MONEY);

	self.eventPtIcon:setVisible(true);
	self.eventPtIcon:setTexture('image/icon/I'..data.icon..'.png');
	self.eventPtLabel:setVisible(true);
	self.eventPtLabel:setString(tostring(data.name)..':'..tostring(reward.total_point));

	self.eventPtIcon:setPositionX(self.round:getPositionX()+self.round:getContentSize().width);
	self.eventPtLabel:setPositionX(self.eventPtIcon:getPositionX() + self.eventPtIcon:getBoundingBox().width);

	self:setReward(reward.reward);
end

function RoundTargetRewardTemplate:InitGuildBossReward( data )
	if not data then
		return;
	end
	-- tableView cell tag值需要固定为999，无法通过setTag设置！！
	self.tag = data.rewardNo;--data.curStage;

	self.round:setString(tostring(data.title));
	self.roundProgress:setString(ConvertStrToDigitUnit(tostring(data.completeStage))..'/'..ConvertStrToDigitUnit(tostring(data.curStage)));
	local percentage = tonumber(data.completeStage) / tonumber(data.curStage) or 0;
	percentage = percentage > 1 and 1 or percentage;
	local width = 213 * percentage;
	if width > 0 then
		width = width < 14 and 14 or width;
	end
	self.rewardProgress:setContentSize(cc.size(width , 12));

	self:updateState(data.receive_state)
	self:setReward(data.reward);

	self.eventPtIcon:setVisible(false);
	self.eventPtLabel:setVisible(false);
end

function RoundTargetRewardTemplate:updateState(state)
	self.rewardBtn:setVisible(false);
	self.notEnough:setVisible(false);
	self.geted:setVisible(false);
	if state == 0 then -- 未达成
		self.rewardLabel:setString(LANG.UI_ROUND_19);
		self.notEnough:setVisible(true);
	elseif state == 1 then --领取
		self.rewardLabel:setString(LANG.UI_ROUND_18);
		self.rewardBtn:setTag(1);
		self.rewardBtn:setVisible(true);
	elseif state == 2 then --以领取
		self.geted:setVisible(true);
	end
end

function RoundTargetRewardTemplate:setReward(reward)
	local rewardNum = #reward;

	local maxWidth = rewardNum * 82.4;
	maxWidth = maxWidth < 185 and 185 or maxWidth;

	self.rewardView:removeAllChildren();
	self.rewardView:setInnerContainerSize(cc.size(maxWidth, 87));

	for i=1, rewardNum do
		local r = reward[i];
		local layout = ccui.Layout:create();
		layout:addTo(self.rewardView);
		local icon = template.ItemTemplate:create(2);
		icon:addTo(layout);
		icon:Init(r[1] , r[2]);
		icon:setScale(0.8);
		icon:setPosition(41.2 + 82.4 * (i - 1) , 43.5);
	end
	self.rewardView:setTouchEnabled(rewardNum > 2);
end

function RoundTargetRewardTemplate:rewardBtnClick(sender , event)
	local tag = sender:getTag();
	if self.callback then
		self.callback(self.tag , tag);
	end
end

function RoundTargetRewardTemplate:setBtnTag(tag)
	self.tag = tag;
end

function RoundTargetRewardTemplate:addBtnClickEventListener(callback)
	self.callback = callback;
end

function RoundTargetRewardTemplate:setGetRewardBtnVisible(visible)
	self.rewardBtn:setVisible(visible);
end

return RoundTargetRewardTemplate;
