local ShopAvatarTemplate = class('ShopAvatarTemplate',function ()
    return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")

function ShopAvatarTemplate:ctor(  )
    -- body
    self:initItem()
end

function ShopAvatarTemplate:initItem(  )
    
    self.bg = ccui.ImageView:create('image/shop/avatar_bg_3.png')
    self.bg:addTo(self);

    self.spineNode = cc.Node:create()
        :addTo(self)

    self.icon = cc.Sprite:create();
    self.icon:addTo(self);
    self.icon:setPosition(0 , 1);

    self.title = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.title:addTo(self);
	self.title:setPosition(cc.p(0 , 93));
    self.title:enableOutline(cc.c4b(50 , 50 , 50 , 255) , 2);

--[[
    self.title:setDimensions(130, 24)
    self.title:setContentSize(cc.size(130, 24))
    self.title:setAnchorPoint(cc.p(0.5,0.5))
    self.title:setHorizontalAlignment(cc.TEXT_ALIGNMENT_CENTER)
    self.title:setAlignment(cc.VERTICAL_TEXT_ALIGNMENT_CENTER,cc.TEXT_ALIGNMENT_CENTER)
    self.title:setOverflow(cc.LabelOverflow.SHRINK)
--]]
    -- 消耗货币
    self.moneyNode = cc.Node:create();
    self.moneyNode:addTo(self);
    self.moneyNode:setPosition(0 , -90);

    self.moneyIcon = cc.Sprite:create();
    self.moneyIcon:setPosition(cc.p(-43,0))
    self.moneyIcon:addTo(self.moneyNode);
    self.moneyIcon:setScale(0.3);

    self.price = cc.Label:createWithTTF('999999', fonts.FONT_SIYUAN, 16);
    self.price:addTo(self.moneyNode);
    self.price:setAnchorPoint(cc.p(1,0.5));
    self.price:setPosition(cc.p(55,0));

    self.clickLayout = ccui.Layout:create();
	self.clickLayout:addTo(self.moneyNode);
	self.clickLayout:setAnchorPoint(cc.p(0.5, 0.5));
    self.clickLayout:setContentSize(cc.size(132 , 36));
    self.clickLayout:setTouchEnabled(false);

    self.discountNode = cc.Node:create()
    :addTo(self.moneyNode)
    local discountBg = cc.Sprite:create('image/shop/avatar_bg_9.png')
    :addTo(self.discountNode)
    :setPosition(0,90)

    local discountBg = cc.Sprite:create('image/shop/avatar_bg_10.png')
    :addTo(self.discountNode)
    :setPosition(40,35)
    local discountLabel = cc.Label:createWithTTF(LANG.UI_SHOP_83,fonts.FONT_SIYUAN,12)
    :addTo(self.discountNode)
    :setPosition(40,35)
    :enableOutline(cc.c3b(235,170,0),2)

    self.discountPrice = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,20)
    :addTo(self.discountNode)
    :setPosition(0,0)
    :setAnchorPoint(cc.p(1,0.5))
    :setTextColor(cc.c3b(255,255,0))
    :enableOutline(cc.c3b(0,0,0),2)

    self.discountLine = cc.Scale9Sprite:create('image/shop/avatar_bg_11.png')
    :addTo(self.discountNode)
    :setCapInsets(cc.rect(3,0,21,3))
    :setPosition(cc.p(55,0));

    self.isHaveNode = cc.Node:create();
    self.isHaveNode:addTo(self);
    
    local bg = cc.Sprite:create('image/shop/avatar_bg_8.png');
    bg:addTo(self.isHaveNode);

    local bg = cc.Sprite:create('image/shop/avatar_bg_7.png');
    bg:addTo(self.isHaveNode);

    local haveLabel = cc.Label:createWithTTF(LANG.UI_SHOP_71, fonts.FONT_SIYUAN, 16);
    haveLabel:addTo(self.isHaveNode);

end


function ShopAvatarTemplate:Init(data,inEvent)

    if data then
        self.title:setVisible(true);
        self.moneyNode:setVisible(true);

        local nameStr = data.name;
        if nameStr == nil then
            nameStr = ResTable:getLangByNum(data.name_no)
        end
        self.title:setString(nameStr)
        local isEqual = true;
        if data.price[1] == MONEY_ID then
            local price = ConvertDigitUnitToStr(tostring(data.price[2]));
            local eventPrice = ConvertDigitUnitToStr(tostring(data.price_event[2]));

            isEqual = HpCompare(price,'==' , eventPrice)
            
            self.price:setString(ConvertStrToDigitUnit(tostring(data.price[2])));
            self.discountPrice:setString(ConvertStrToDigitUnit(tostring(data.price_event[2])));
        else
            isEqual = data.price[2] == data.price_event[2];
            self.price:setString(tostring(data.price[2]));
            self.discountPrice:setString(tostring(data.price_event[2]));
        end
        local itemIcon = ResTable:getValue('item' , data.price[1] , 'icon');
        self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
        local item = data.item;

        self.icon:setTexture('image/shop/avatar_icon/R0'..data.item[2]..'_Icon.png');
    
        self.isHaveNode:setVisible(data.times == 0)

        if inEvent and not isEqual then
            local width = self.price:getContentSize().width;
            self.discountLine:setPositionX(55-width/2);
            self.discountPrice:setPositionX(55-width-10);
            self.price:setOpacity(127.5)
            self.discountNode:setVisible(true);
        else
            self.price:setOpacity(255)
            self.discountNode:setVisible(false);
        end

        self.spineNode:removeAllChildren();
        local spine_res = 'shop_bg_effect'
        if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
            local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
            spine:addTo(self.spineNode)
            spine:setAnimation(0, 'skin1', true)
        end
    else
        self.title:setVisible(false);
        self.moneyNode:setVisible(false);
        self.isHaveNode:setVisible(false);
        self.icon:setTexture('image/shop/avatar_bg_2.png');
    end
end

function ShopAvatarTemplate:addItemClickEventListener(callback)
    self.bg:setTouchEnabled(true);
    self.bg:addClickEventListener(callback);
    self.bg:setSwallowTouches(false);
end

function ShopAvatarTemplate:setItemTag(tag)
    self.bg:setTag(tag);
end

function ShopAvatarTemplate:addBuyClickEventListener(callback)
    self.clickLayout:setTouchEnabled(true);
    self.clickLayout:addClickEventListener(callback);
    --self.clickLayout:setSwallowTouches(false);
end

function ShopAvatarTemplate:setBuyTag(tag)
    self.clickLayout:setTag(tag);
end

return ShopAvatarTemplate