local ShopGiftItemTemplate = class("ShopGiftItemTemplate" , function()
	return cc.Node:create();
end)

local fonts = Enum:getTable("SystemFont")

function ShopGiftItemTemplate:ctor()

	--大背景
	local bg = cc.Sprite:create("image/shop/shop_gift_bg_2.png")
	bg:addTo(self);

	bg = cc.Sprite:create('image/shop/shop_gift_bg_1.png');
	bg:addTo(self);
	bg:setPosition(-88,-19);

	self.name = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.name:addTo(self);
	self.name:setAnchorPoint(cc.p(0 , 0.5));
	self.name:setPosition(cc.p(-270 , 60));
	self.name:enableOutline(cc.c4b(200 , 0 , 50 , 255));

	self.itemView = ccui.ScrollView:create();
	self.itemView:setTouchEnabled(true);
	self.itemView:setBounceEnabled(true);
	self.itemView:setSwallowTouches(true);
	self.itemView:setDirection(ccui.ScrollViewDir.horizontal);
	self.itemView:setContentSize(cc.size(368, 100));
	self.itemView:setAnchorPoint(cc.p(0.5, 0.5));
	self.itemView:setPosition(-88 , -18);
	self.itemView:setScrollBarEnabled(false);
	self.itemView:addTo(self);

	self.buyBtn = ccui.Button:create('image/commonImg/btn_bg1.png' , 'image/commonImg/btn_bg1.png');
	self.buyBtn:addTo(self);
	self.buyBtn:setPosition(180 , -3);

	self.buyLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.buyLabel:addTo(self.buyBtn);
	self.buyLabel:setPosition(self.buyBtn:getContentSize().width/2 , self.buyBtn:getContentSize().height/2);
	self.buyLabel:setTextColor(cc.c3b(255 , 255 , 255));
	self.buyLabel:enableOutline(cc.c4b(19 , 93 , 188 , 255) , 2);

	self.limitNode = cc.Node:create();
	self.limitNode:addTo(self);
	self.limitNode:setPosition(176 , -54);

	bg = cc.Sprite:create('image/shop/shop_gift_bg_3.png');
	bg:addTo(self.limitNode);

	local label = cc.Label:createWithTTF(LANG.UI_SHOP_64 , fonts.FONT_SIYUAN , 18);
	label:addTo(self.limitNode);
	label:setPosition(-25 , 0);

	self.lastTimes = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 18);
	self.lastTimes:addTo(self.limitNode);
	self.lastTimes:setPosition(48,0);
	self.lastTimes:setTextColor(cc.c3b(60 , 60 , 60));
end

function ShopGiftItemTemplate:InitData(data)

	local rTableData = data -- ResTable:getRowData('shop_gift',data.id);

	self.name:setString(tostring(rTableData.name));

	self.lastTimes:setString(data.times);
	self.limitNode:setVisible(data.times ~= -1);

	self:setData(rTableData);
end

function ShopGiftItemTemplate:InitDataEventWelfate(data)
	self.name:setString(tostring(data.giftname));

	self.lastTimes:setString(data.rest_times);
	self.limitNode:setVisible(data.rest_times ~= -1);

	self:setData(data);
end

function ShopGiftItemTemplate:setData(rTableData)
	self.itemView:removeAllChildren();

	if rTableData.item or #rTableData.item > 0 then
		local num = #rTableData.item;
		local maxWidth = 97 * num;
		maxWidth = maxWidth > 368 and maxWidth or 368;

		self.itemView:removeAllChildren();
		self.itemView:setInnerContainerSize(cc.size(maxWidth, 100));

		for _k , item in pairs(rTableData.item) do
			local itemTemplate = template.IconTemplate:create(self.itemView);
			itemTemplate:Init(item[1] , item[2]);
			itemTemplate:setScale(0.8);
			itemTemplate:setPosition(46 + 97 * (_k-1) , 50);
		end
	end
	--self.buyLabel:setString(string.format(LANG.UI_SHOP_65 , rTableData.price));
	self.buyLabel:setString(LANG.TAPTAP_BUY);
end

function ShopGiftItemTemplate:addBtnClickEventListener(callback)
	self.buyBtn:addClickEventListener(callback);
end

function ShopGiftItemTemplate:setBtnTag(tag)
	self.buyBtn:setTag(tag);
end
return ShopGiftItemTemplate;
