local ShopGiftTemplate = class("ShopGiftTemplate" , function()
	return ccui.Layout:create();
end)
local imagePath = 'image/shop/'

local fonts = Enum:getTable("SystemFont")
local itemSpace = {
    [1] = 92,
    [2] = 92,
    [3] = 92,
    [4] = 122,
    [5] = 122
}

function ShopGiftTemplate:ctor()

    self.bg = ccui.ImageView:create()
        :addTo(self)
    self.itemNode = cc.Node:create()
        :addTo(self)
        :setPosition(0,8)

    self.itemName = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20)
        :addTo(self)
        :setPosition(cc.p(0,75))
        :enableOutline(cc.c3b(55, 70, 100), 2)

    self.priceNode = cc.Node:create()
        :addTo(self)
        :setPosition(0,-84)
    --[[
    self.discountNode = cc.Node:create()
        :addTo(self.priceNode)
        :setPosition(78,0)
    local discount_bg = cc.Sprite:create( imagePath.. 'month_bg2.png')
        :addTo(self.discountNode)
    self.discountLabel = cc.Label:createWithTTF(' DC\n11%' , 'font/SourceHanSansCN-Medium.otf' , 13)
        :addTo(self.discountNode)
        :enableOutline(cc.c3b(80, 50, 15), 2)
    ]]
    self.moneyIcon = cc.Sprite:create( imagePath.. 'currency_icon.png')
        :addTo(self.priceNode)
        :setPosition(cc.p(-78,0))

    self.price = cc.Label:createWithTTF('0' , fonts.FONT_SIYUAN , 16)
        :addTo(self.priceNode)
        :setPosition(cc.p(31,0))
        :setAnchorPoint(cc.p(1,0.5))

    self.freeLabel = cc.Label:createWithTTF(LANG.UI_FIGHT_65,fonts.FONT_SIYUAN,20)
        :addTo(self)
        :setPosition(0,-84)
 
    self.remainingTimeLabel = cc.Label:createWithTTF(LANG.UI_SHOP_50 , fonts.FONT_SIYUAN , 15)
         :addTo(self)
         :setPosition(0 , 55) -- 61 , 53
         :enableOutline(cc.c4b(55 , 70 , 100 , 255) , 2)

   
    self.lastTimeNode = cc.Node:create()
        :addTo(self)
        :setPosition(0,-49)

    self.lastTimeImg = cc.Sprite:create(imagePath..'item_lock.png')
        :addTo(self.lastTimeNode)
    self.lastTime = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,15)
        :addTo(self.lastTimeNode)
        :enableOutline(cc.c4b(55 , 70 , 100 , 255) , 2)
    local spine_res = 'shop_bg_effect'
    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
        self.itemSpine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
        self.itemSpine:addTo(self)
    end
end
function ShopGiftTemplate:Init(data)
    -- self.bg:loadTexture('image/shop/shop_gift_item_bg_'..data.icon_type..'.png');
    -- self.itemSpine:setAnimation(0, ('gift'..data.icon_type), true)
    self.bg:loadTexture('image/shop/shop_gift_item_bg_2.png');
    self.itemSpine:setAnimation(0, ('gift2'), true)
    local name = data.giftname or ResTable:getLangByNum(data.giftname_no);
    self.itemName:setString(tostring(name));
    local bgWidth = self.bg:getContentSize().width

    if tonumber(data.price) > 0 then
        self.price:setString(tostring(data.price));

        local posX = bgWidth/2-22;
        --self.discountNode:setPositionX(posX);
        self.moneyIcon:setPositionX(-posX);
        self.price:setPositionX(bgWidth/2-37);
        self.priceNode:setVisible(true);
        self.freeLabel:setVisible(false);
    else
        self.freeLabel:setVisible(true);
        self.priceNode:setVisible(false);
    end
    if data.price == 0 and data.times ~= 0 then
        tools.RedDotTools:setRedDotToNode(self,true,nil,cc.p(84,100));
    else
        tools.RedDotTools:setRedDotToNode(self,false,nil,cc.p(84,100));
    end

    self.itemNode:removeAllChildren();

    local icon = cc.Sprite:create('image/shop/shop_icon/'..data.resource..'.png')
        :addTo(self.itemNode)
        :setPosition(0, -10);
        -- :setScale(0.65);

    -- local itemNum = #data.item;
    -- local space = itemSpace[data.icon_type];
    -- local totalWidth = space*(itemNum-1);
    -- local startPosX = -totalWidth/2;

    -- for i = 1 , itemNum do

    --     if i > 1 then
    --         local addImg = cc.Sprite:create(imagePath.. 'item_plus.png')
    --             :addTo(self.itemNode)
    --             :setPosition(startPosX+space*(i-1)-space/2,0);
    --     end

    --     local node = cc.Node:create()
    --         :addTo(self.itemNode)
    --         :setPosition(startPosX+space*(i-1),0)

    --     local img,num = GlobalFunctions:getItemIconFileAndNum(data.item[i]);
    --     local icon = cc.Sprite:create(img)
    --         :addTo(node)
    --         :setScale(0.65);

    --     local num = cc.Label:createWithTTF('x'..tostring(num),fonts.FONT_SIYUAN,15)
    --         :addTo(node)
    --         :setPosition(0,-23)
    --         :enableBold()
    --         :enableOutline(cc.c3b(0,0,0),2)
    -- end

    -- local totalItemWidth = space*itemNum
    -- if totalItemWidth > (bgWidth-10) then
    --     self.itemNode:setScale((bgWidth-10)/totalItemWidth);
    -- else
    --     self.itemNode:setScale(1);
    -- end

    if data.time_stamp and data.time_stamp>0 then
        local curTime = TimeManager:getCurTime();
        if data.time_stamp > curTime then
            self.lastTimeNode:setVisible(true);
            local lastTime = data.time_stamp - curTime;
            local days = math.floor(lastTime / 86400);
            if days > 0 then
                self.lastTime:setString(string.format(LANG.UI_ACTIVITY_38,days));
            else
                local hores = math.ceil(lastTime / 3600);
                self.lastTime:setString(string.format(LANG.UI_MAIL_15,hores));
            end
            
            local width = self.lastTimeImg:getContentSize().width+5;
            local timeWidth = self.lastTime:getContentSize().width+5;
            local startPosX = -timeWidth/2;
            self.lastTimeImg:setPositionX(startPosX);
            self.lastTime:setPositionX(startPosX+width/2+timeWidth/2)
        else
            self.lastTimeNode:setVisible(false);
        end
    else
        self.lastTimeNode:setVisible(false);
    end

    if data.times ~= -1 then
        self.remainingTimeLabel:setVisible(true);
        local info = model.ShopModel:getLimitBuyInfo( data.type, data.times )
        self.remainingTimeLabel:setString('('..info..')');
        --self.remainingTimeLabel:setString(string.format(LANG.UI_SHOP_50,data.times));
    else 
        self.remainingTimeLabel:setVisible(false);
    end
end

function ShopGiftTemplate:addItemClickEventListener(callback)
    self.bg:setTouchEnabled(true);
    self.bg:addClickEventListener(callback);
    self.bg:setSwallowTouches(false);
end

function ShopGiftTemplate:setItemTag(tag)
    self.bg:setTag(tag);
end

return ShopGiftTemplate;
