local ShopGrowupTemplate = class("ShopGrowupTemplate" , function()
	return ccui.Layout:create();
end)
local imagePath = 'image/shop/'

local fonts = Enum:getTable("SystemFont")
local CommonShopType = Enum:getTable('CommonShopType');

function ShopGrowupTemplate:ctor()

    self.bg = ccui.ImageView:create('image/shop/shop_item_bg_2.png')
    self.bg:addTo(self);

	self.title = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.title:addTo(self);
	self.title:setPosition(cc.p(1 , 55));
    self.title:enableOutline(cc.c4b(55 , 70 , 100 , 255) , 2);

    self.icon = cc.Sprite:create();
    self.icon:addTo(self);
    self.icon:setPosition(3 , 22);
    self.icon:setScale(0.6);

    self.num = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 15);
    self.num:addTo(self);
    self.num:setPosition(2 , -17);
    self.num:enableOutline(cc.c3b(50 , 50 , 50) , 2);

    local getLabel = cc.Label:createWithTTF('',fonts.FONT_SIYUAN,18)
        :enableOutline(cc.c3b(55 , 85 , 155),2)

    self.getBtn = ccui.Button:create('image/commonImg/btn_2_103_36.png','image/commonImg/btn_2_103_36.png','image/commonImg/btn_4_103_36.png');
    self.getBtn:addTo(self);
    self.getBtn:setPosition(0,-56);
    self.getBtn:setTitleLabel(getLabel);
    --self.getBtn:addClickEventListener(handler(self , self.));

    local notLabel = cc.Label:createWithTTF(LANG.UI_ROUND_21,fonts.FONT_SIYUAN,18)
    :setTextColor(cc.c3b(60 , 60 , 60))
    :enableOutline(cc.c3b(255 , 255 , 255),2)

    self.notBtn = ccui.Button:create('image/commonImg/btn_3_103_36.png','image/commonImg/btn_3_103_36.png');
    self.notBtn:addTo(self)
    self.notBtn:setPosition(0,-56)
    self.notBtn:setTitleLabel(notLabel)

    local spine_res = 'shop_bg_effect'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(self)
		spine:setAnimation(0, 'shop2', true)
	end
end
function ShopGrowupTemplate:Init(data, t)
	self.curShopType = t
    local curLevel = model.UserModel:getUserLevel();
    if data.state == 1 then 
        self.getBtn:setBright(false);
        self.getBtn:setVisible(true);
        self.notBtn:setVisible(false);
        local label = self.getBtn:getTitleLabel();
        label:enableOutline(cc.c3b(60,60,60),2)
        label:setString(LANG.UI_ACTIVITY_19);
    else 
        local growupState = 0;
        if self.curShopType == CommonShopType.GROWUP then
            growupState = model.RechargeModel:getGrowupState();
        elseif self.curShopType == CommonShopType.GROWUP_SP then
            growupState = model.RechargeModel:getGrowupSpState();
        end
        if growupState == 1 and curLevel >= data.lv then
            local label = self.getBtn:getTitleLabel();
            label:enableOutline(cc.c3b(55 , 85 , 155),2)
            label:setString(LANG.UI_ACTIVITY_13);
            self.getBtn:setVisible(true);
            self.notBtn:setVisible(false);
        else
            self.getBtn:setVisible(false);
            self.notBtn:setVisible(true);
        end
    end

    local name = data.name or ResTable:getLangByNum(data.name_no);
    self.title:setString(tostring(name))

    if data.reward and data.reward[1] then
        local itemIcon = ResTable:getValue('item' , data.reward[1][1] , 'icon');
        self.icon:setTexture('image/icon/I'..itemIcon..'.png');
        self.num:setString('X'..tostring(data.reward[1][2]));
    end
end

function ShopGrowupTemplate:addItemClickEventListener(callback)
    self.getBtn:setTouchEnabled(true);
    self.getBtn:addClickEventListener(callback);
    self.getBtn:setSwallowTouches(false);
end

function ShopGrowupTemplate:setItemTag(tag)
    self.getBtn:setTag(tag);
end

return ShopGrowupTemplate;
