local ShopItemTemplate = class('ShopItemTemplate',function ()
    return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")

function ShopItemTemplate:ctor(  )
    -- body
    self:initItem()
end

function ShopItemTemplate:initItem(  )
    
    self.bg = ccui.ImageView:create('image/shop/shop_item_bg_1.png')
    self.bg:addTo(self);

	self.title = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.title:addTo(self);
	self.title:setPosition(cc.p(1 , 68));
    self.title:enableOutline(cc.c4b(55 , 70 , 100 , 255) , 2);

    self.icon = cc.Sprite:create();
    self.icon:addTo(self);
    self.icon:setScale(0.6);
    self.icon:setPosition(0 , 9);
    --self.icon:setVisible(false);

    --self.item = template.IconNewTemplate:create();
    --self.item:setPosition(cc.p(0,9))
    --self.item:setScale(0.7);
    --self.item:addTo(self);
    --self.item:setVisible(false);

    self.num = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 15);
    self.num:addTo(self);
    self.num:setPosition(2 , -28);
    self.num:enableOutline(cc.c3b(50 , 50 , 50) , 2);

    self.remainingTimeLabel = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 15)
        :addTo(self)
        :setPosition(2,45)
        :setTextColor(cc.c4b(165 , 220 , 255 , 255))
        :enableOutline(cc.c4b(55 , 70 , 100 , 255),2)

    -- 消耗货币
    self.moneyNode = cc.Node:create();
    self.moneyNode:addTo(self);
    self.moneyNode:setPosition(0 , -68);

    self.moneyIcon = cc.Sprite:create('image/icon/I11001.png');
    self.moneyIcon:setPosition(cc.p(-61,0))
    self.moneyIcon:addTo(self.moneyNode);
    self.moneyIcon:setScale(0.3);

    self.price = cc.Label:createWithTTF('999999', fonts.FONT_SIYUAN, 20);
    self.price:addTo(self.moneyNode);
    self.price:setAnchorPoint(cc.p(1,0.5));
    self.price:setPosition(cc.p(58,0));

    
    self.sellOut = cc.Sprite:create('image/shop/shop_item_bg_1_black.png');
    self.sellOut:addTo(self);

    local sellOutSize = self.sellOut:getContentSize();

    local sellOutLabel = cc.Label:createWithTTF(LANG.UI_SHOP_62, fonts.FONT_SIYUAN, 20);
    sellOutLabel:addTo(self.sellOut);
    sellOutLabel:setPosition(sellOutSize.width/2 , sellOutSize.height/2-68);

    local spine_res = 'shop_bg_effect'
    if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(self)
		spine:setAnimation(0, 'shop1', true)
	end
end


function ShopItemTemplate:Init(data , notShowBg)

    local nameStr = data.name;
    if nameStr == nil then
        nameStr = ResTable:getLangByNum(data.name_no)
    end
    self.title:setString(nameStr)
    if data.price[1] == MONEY_ID then
        self.price:setString(ConvertStrToDigitUnit(tostring(data.price[2])));
    else
        self.price:setString(tostring(data.price[2]));
    end
    local itemIcon = ResTable:getValue('item' , data.price[1] , 'icon');
    self.moneyIcon:setTexture('image/icon/I'..itemIcon..'.png');
    local item = data.item;
    local iconFile , num = GlobalFunctions:getItemIconFileAndNum(item);
    self.icon:setTexture(iconFile);
    self.num:setString('X'..tostring(num));
    
    local bShowSellOut = data.times ~= nil and data.times == 0
    self.moneyNode:setVisible(not bShowSellOut)
    self.sellOut:setVisible(bShowSellOut)
    self.remainingTimeLabel:setVisible(data.times > 0)
    if data.times >= 0 then
        local info = model.ShopModel:getLimitBuyInfo( data.type, data.times )
        self.remainingTimeLabel:setString('('..info..')');
        -- self.remainingTimeLabel:setString('('..string.format(LANG.UI_SHOP_50 , tostring(data.times))..')');
    end
    if data.buytype and data.buytype ~= 0 then
        local bt = data.buytype;
        local bv = data.buyvalue;
        local res_data = ResTable:getMultiValue('shop_buy_icon', bt, bv);
        local icon = res_data['icon']
        local sp = cc.Sprite:create('image/shop/'.. icon ..'.png')
        sp:setAnchorPoint(cc.p(1,1))
        sp:setPosition(102, 105)
        sp:addTo(self)
    end
end

function ShopItemTemplate:addItemClickEventListener(callback)
    self.bg:setTouchEnabled(true);
    self.bg:addClickEventListener(callback);
    self.bg:setSwallowTouches(false);
end

function ShopItemTemplate:setItemTag(tag)
    self.bg:setTag(tag);
end

return ShopItemTemplate