local ShopRechargeItemTemplate = class("ShopRechargeItemTemplate" , function()
	return ccui.Layout:create();
end)

local fonts = Enum:getTable("SystemFont")

function ShopRechargeItemTemplate:ctor()

	self.bg = ccui.ImageView:create('image/shop/shop_item_bg_1.png')
    self.bg:addTo(self);

	self.title = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 20);
	self.title:addTo(self);
	self.title:setPosition(cc.p(1 , 55));
    self.title:enableOutline(cc.c4b(55 , 70 , 100 , 255) , 2);

    self.icon = cc.Sprite:create();
    self.icon:addTo(self);
    self.icon:setPosition(3 , 22);

    self.num = cc.Label:createWithTTF('' , fonts.FONT_SIYUAN , 15);
    self.num:addTo(self);
    self.num:setPosition(2 , -17);
    self.num:enableOutline(cc.c3b(50 , 50 , 50) , 2);

    -- 消耗货币
    self.moneyNode = cc.Node:create();
    self.moneyNode:addTo(self);
    self.moneyNode:setPosition(0 , -68);

    self.moneyIcon = cc.Sprite:create('image/shop/currency_icon.png');
    self.moneyIcon:setPosition(cc.p(-62,0))
    self.moneyIcon:addTo(self.moneyNode);

    self.price = cc.Label:createWithTTF('999999', fonts.FONT_SIYUAN, 20);
    self.price:addTo(self.moneyNode);
    self.price:setAnchorPoint(cc.p(1,0.5));
    self.price:setPosition(cc.p(58,0));

    self.dbIcon = cc.Sprite:create('image/shop/fst_icon.png');
    self.dbIcon:setPosition(cc.p(65,0))
    self.dbIcon:addTo(self.moneyNode);
    
    local spine_res = 'shop_bg_effect'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		local spine = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		spine:addTo(self)
		spine:setAnimation(0, 'shop1', true)
	end 
end

function ShopRechargeItemTemplate:Init(data)
	local nameStr = data.name;
    if nameStr == nil then
        nameStr = ResTable:getLangByNum(data.name_no)
	end
	self.title:setString(nameStr)

	self.num:setString('X'..tostring(data.diamond))
	self.icon:setTexture('image/shop/'..data.resource..'.png');
	self.price:setString(tostring(data.price));
    if data.is_recharged == 1 then
        self.dbIcon:setVisible(false)
        self.price:setPosition(cc.p(58,0));
    else
        self.dbIcon:setVisible(true)
        self.price:setPosition(cc.p(37,0));
    end
end

function ShopRechargeItemTemplate:setItemTag(tag)
	self.bg:setTag(tag);
end

function ShopRechargeItemTemplate:addItemClickEventListener(callback)
	self.bg:setTouchEnabled(true);
	self.bg:addClickEventListener(callback);
	self.bg:setSwallowTouches(false);
end

return ShopRechargeItemTemplate;
