local SkillBuffTemplate = class("SkillBuffTemplate" , function()
	return ccui.Layout:create();
end)
local fonts = Enum:getTable("SystemFont")

--width = 424 , height = 128
function SkillBuffTemplate:ctor()

	self.bg = cc.Scale9Sprite:create('image/card/cardSkill/card_skill_buff_bg_2.png');
	self.bg:setCapInsets(cc.rect(30,30,200,40));
   	self.bg:addTo(self);

   	self.bg2 = cc.Sprite:create('image/card/cardSkill/card_buff_red.png')
   	self.bg2:addTo(self)
   	self.bg2:setPosition(0, 20)

	self.buffImg = cc.Sprite:create();
	self.buffImg:addTo(self);
	self.buffImg:setPosition(-238,18);

	self.buffName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 23);
	self.buffName:addTo(self);
	self.buffName:setAnchorPoint(cc.p(0,0.5));
	self.buffName:setPosition(-219 , 18);

	self.buffInfo = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 18);
	self.buffInfo:addTo(self);
	self.buffInfo:setAnchorPoint(cc.p(0,1));
	self.buffInfo:setPosition(-250 , -11);
	self.buffInfo:setLineBreakWithoutSpace(true);
	self.buffInfo:setMaxLineWidth(484);
	self.buffInfo:setLineHeight(25);
	
end
function SkillBuffTemplate:Init(buffId)

	local buff = ResTable:getRowData('buff', buffId);

	if not buff then
		return;
	end

	local btype = buff.buff_type;
	local bgName = 'image/card/cardSkill/card_buff_green.png'
	local titleColor = cc.c3b(90 , 190 , 90)
	if btype==2 or btype==4 or btype==6 or btype==7 or btype==11 or btype==14 or btype==18 then
		bgName = 'image/card/cardSkill/card_buff_red.png'
		titleColor = cc.c3b(255 , 50 , 50)
	end

	local formatStr , colorPos = formatColorText(buff.name);

	self.buffName:setString(tostring(formatStr));
	local strLen = getStrLen(formatStr);
	for i = 0 , strLen-1 do
		local label = self.buffName:getLetter(i);
		if label then
			local changeColor = false
			for _k , pos in pairs(colorPos) do
				if i >= pos.sPos-1 and i <= pos.ePos-1 then
					label:setColor(cc.c3b(pos.color[1] , pos.color[2] , pos.color[3]));
					changeColor = true;
					break;
				end
			end
			if not changeColor then
				label:setColor(titleColor);
			end
		end
	end

	if buff.icon then
		self.buffImg:setTexture('image/icon_buff/'..buff.icon..'.png');
	end
	self.buffInfo:setString(tostring(buff.info));
	self.bg2:setTexture(bgName);
	
	local size = self.buffInfo:getContentSize();
	local height = size.height + 60;

	self.bg:setContentSize(cc.size(529 , height));

	self.buffImg:setPositionY(height/2 - 27);
	self.buffName:setPositionY(height/2 - 27);
	self.buffInfo:setPositionY(height/2 - 56);
	self.bg2:setPositionY(height/2)
end

function SkillBuffTemplate:getBuffContentSize()
	return self.bg:getContentSize();
end	

return SkillBuffTemplate;
