local SkillCastTemplateNew = class("SkillCastTemplateNew")

local imgPath = 'image/fight/footernew/';
local fonts = Enum:getTable('SystemFont');
local remindIdx = nil;

function SkillCastTemplateNew:ctor(father, pos)
	self.root = cc.Node:create();
	father:addChild(self.root);
	self.pos = pos
	self.showRemind = false;

	self.subRoot = cc.Node:create()
		:addTo(self.root)

	--
	self.scale = 1
	self.totalHp = 0
	self.fid = -1
	self.cdPercent = 0;

	self.spine1 = nil;
	self.spine2 = nil;
	self.spine3 = nil;
	self.spine4 = nil;
	self.spine5 = nil;
	local spine_res = 'nuqi_spine'
	if cc.FileUtils:getInstance():isFileExist('spine/'..spine_res.."/"..spine_res..".json") then
		self.spine1 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.spine2 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.spine3 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.spine4 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)
		self.spine5 = sp.SkeletonAnimation:create('spine/'..spine_res.."/"..spine_res..".json", 'spine/'..spine_res.."/"..spine_res..".atlas", 1)

		self.spine1:setVisible(false)
		self.spine2:setVisible(false)
		self.spine3:setVisible(false)
		self.spine4:setVisible(false)
		self.spine5:setVisible(false)

		self.spine1:registerSpineEventHandler(function (event)
			self.spine1:setVisible(false)
		end, sp.EventType.ANIMATION_COMPLETE)

		self.spine2:registerSpineEventHandler(function (event)
			self.spine2:setVisible(false)
		end, sp.EventType.ANIMATION_COMPLETE)

	else
		print('error : 缺少spine 资源')
    end

	--
	self.bgSkill = cc.Sprite:create(imgPath .. 'item_bg.png')
		:addTo(self.subRoot)

	self.emptyNode = cc.Node:create()
		:setPosition(0, 50)
		:addTo(self.subRoot)
	
	self.emptySp = cc.Sprite:create(imgPath .. 'empty.png')
		:addTo(self.emptyNode)

	self.emptyWord = cc.Sprite:create(imgPath .. 'GN-0' .. pos .. '.png')
		:setPosition(0, 0)
		:addTo(self.emptyNode)
	-----

	self.infoNode = cc.Node:create()
		:setPosition(0, 0)
		:addTo(self.subRoot)
		:setVisible(false)

	self.spine3:addTo( self.infoNode )
	self.spine3:setPosition(0,140)

	local stencil = cc.Sprite:create(imgPath..'clipBg.png');
	local clippingNode = cc.ClippingNode:create();
	clippingNode:setStencil(stencil);
	clippingNode:setInverted(false);
	clippingNode:setAlphaThreshold(0);
	clippingNode:addTo(self.infoNode);
	clippingNode:setPosition(0, 25);

	self.bg = cc.Sprite:create('image/iconL/M037_IconL.png')
		:setAnchorPoint(cc.p(0.5, 0.5))
		-- :setPosition(0, 25)
		:setScale(0.6)
		:addTo(clippingNode) --self.infoNode
		:setTextureRect(LRect)
	self.bg2 = cc.Sprite:create(imgPath .. 'skill4Bg.png')
		:addTo(clippingNode)
		:setOpacity(0)

	self.quBg = cc.Sprite:create(imgPath .. 'l_bg_1.png')
		:setAnchorPoint(cc.p(0.5, 0))
		:setPosition(0, -70)
		:addTo(self.subRoot)

	self.type_bg = cc.Sprite:create(imgPath .. 'flag_bg_1.png')
		:setPosition(-30, 120)
		:addTo(self.infoNode)

	self.type_icon = cc.Sprite:create()
		:setPosition(-30, 120)
		:setScale(0.5)
		:addTo(self.infoNode)

	self.roleNode = cc.Node:create()
	:addTo(self.subRoot)
	:setPosition(0,-35)
	:setScale(0.6)
	:setVisible(false)
	self.bigRole = cc.Sprite:create('image/iconL/M037_IconL.png')
	:addTo(self.roleNode)
	:setAnchorPoint(0.5, 0)
	self.big1Role = cc.Sprite:create('image/iconL/M037_IconL.png')
	:addTo(self.roleNode)
	:setAnchorPoint(0.5, 0)
	self.big2Role = cc.Sprite:create('image/iconL/M037_IconL.png')
	:addTo(self.roleNode)
	:setAnchorPoint(0.5, 0)

	self:initTopAnimation()

	self.spine4:addTo( self.infoNode )
	self.spine4:setPosition(0,140)

	self.spine1:addTo( self.infoNode )
	self.spine1:setPosition(0,140)
	

	local btn = ccui.Button:create(imgPath .. 'l_bg_1.png');
	btn:addTo(self.subRoot);
	btn:setAnchorPoint(cc.p(0.5, 0))
	btn:setPosition(0, -70);
	btn:addClickEventListener(handler(self, self.btnClick));
	btn:setOpacity(0)

	self.dieNode = cc.Node:create()
		:setPosition(0, 35)
		:addTo(self.subRoot)
		:setVisible(false)

	local dead_bg = cc.Sprite:create(imgPath .. 'dead_bg.png')
		:addTo(self.dieNode)
	-- local dead_icon = cc.Sprite:create(imgPath .. 'dead_icon.png')
	-- 	:addTo(self.dieNode)

	----
	self.msgNode = cc.Node:create()
		:setPosition(0, -60)
		:addTo(self.subRoot)

	self.info_bg = cc.Sprite:create(imgPath .. 'bar_bg.png')
		:setPosition(0, 0)
		:addTo(self.msgNode)

	self.info_bar_blood = cc.Sprite:create(imgPath .. 'bar_blood.png')
		:setPosition(-27, 7)
		:setAnchorPoint(cc.p(0,0.5))
		:addTo(self.msgNode)
		:setScaleX(0)

	self.info_b_label = cc.Label:createWithTTF('0', fonts.FONT_SIYUAN, 14)
		:setPosition(50, 14)
		:addTo(self.msgNode)
		:setAnchorPoint(cc.p(1, 0.5))
		:enableOutline(cc.c4b(60 , 60 , 60 , 255),1)

	self.info_bar_time = cc.Sprite:create(imgPath .. 'bar_time.png')
		:setPosition(-27, -14)
		:setAnchorPoint(cc.p(0,0.5))
		:addTo(self.msgNode)
		:setScaleX(0)

	self.spine2:addTo( self.msgNode )
	self.spine2:setPosition(12, -14)

	self.spine5:addTo( self.msgNode )
	self.spine5:setPosition(12, -14)

	self.buffNode = cc.Node:create()
		:addTo(self.infoNode)
		:setPosition( 45, -5 )

	self.buffItemList = {}

	EventManager:RegisterEvent(EventType.FightShowSkillExt, handler(self, self.FightShowSkill));
	EventManager:RegisterEvent(EventType.FightShowSkillAuto, handler(self, self.showAutoState));
	self.sillPlay = false;

end

function SkillCastTemplateNew:showSpine()
	self.spine1:setVisible(true)
	self.spine2:setVisible(true)
	self.spine1:setAnimation(0,'nuqi_spine_1',false);
	self.spine2:setAnimation(0,'nuqi_spine_2',false);

	self.msgNode:stopAllActions()
	local actSeq = cc.Sequence:create(
		cc.DelayTime:create(0.1),
		cc.CallFunc:create(function()
			if self.canEffect then
				return
			end
			self.spine3:setVisible(true)
			self.spine4:setVisible(true)
			self.spine5:setVisible(true)
			self.spine3:setAnimation(0,'nuqi_spine_3',true);
			self.spine4:setAnimation(0,'nuqi_spine_4',true);
			self.spine5:setAnimation(0,'nuqi_spine_5',true);
		end)
	)
	self.msgNode:runAction(actSeq)

	if FightManager:getAutoRelease() then --开启自动释放
		self:playWiteRelease()
		local fighter = FightManager:GetFighter(self.fid)
		if fighter then
			fighter:SetActiveRelease() --设置一下数据，防止再次关闭自动释放后，之前自动释放的技能不释放了
		end
	end

end

function SkillCastTemplateNew:playWiteRelease()
	local subAct = cc.Sequence:create(
		cc.DelayTime:create(0.03),
		cc.CallFunc:create(function()
			local x = math.random()*6 - 3
			local y = math.random()*6 - 3
			self.subRoot:setPosition(x,y)
		end)
	)
	self.subRoot:runAction( cc.RepeatForever:create(subAct) )
end

function SkillCastTemplateNew:hideSpine()
	-- self.spine1:setVisible(false)
	-- self.spine2:setVisible(false)
	self.spine3:setVisible(false)
	self.spine4:setVisible(false)
	self.spine5:setVisible(false)
	self.msgNode:stopAllActions()
	self.subRoot:stopAllActions()
	self.subRoot:setPosition(0,0)
end

function SkillCastTemplateNew:addBuff( bid, btype, icon )
	-- body
	-- 1 属性增加 atk aspd crit crit_dam
	-- 2 属性减少 atk aspd crit crit_dam
	-- 3 反射状态 
	-- 4 持续百分比掉血 
	-- 5 持续百分比回血
	-- 6 立即百分比回血
	-- 7 眩晕 
	-- 8 盾 atk 
	-- 9 清除 buff 1,5,12 进攻驱散     净化 purge
	-- 10 清除 debuff 2,4,11 防御驱散  驱散 dispel
	-- 11 持续掉血 基于atk
	-- 12 持续回血 基于atk
	-- 13 立即回血 基于atk
	-- 14 沉默 (增加技能cd)
	-- 15 刷新 (减少技能cd)
	-- 16 免疫负面状态
	-- 17 免疫伤害
	-- 18 法术反噬
	-- 19 法术连击
	-- 20 春哥
	local idx = 0
	for k,v in pairs(self.buffItemList) do
		if v.type == btype then
			idx = k
			break
		end
	end

	if idx == 0 then
		local item = cc.Node:create()
		local bgName = 'buff_g.png'
		local txtColor = cc.c3b(215,255,200)
		local outLine = cc.c3b(35,120,35)
		if btype==2 or btype==4 or btype==6 or btype==7 or btype==11 or btype==14 or btype==18 then
			bgName = 'buff_r.png'
			txtColor = cc.c3b(255,200,200)
			outLine = cc.c3b(175,10,5)
		end
		local bg = cc.Sprite:create('image/fight/footernew/' .. bgName)
			:setPosition(0, 0)
			:addTo(item)

		if icon and icon ~= '' then
			local iconspr = cc.Sprite:create('image/icon_buff/' .. icon..'.png')
				:setPosition(0, -9)
				:addTo(item)
		end
		local label = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 13)
		:addTo(item)
		:setPosition(5 , -18)
		:setTextColor(txtColor)
		:enableOutline(outLine,2)

		item:addTo(self.buffNode)

		table.insert( self.buffItemList, {type=btype, node=item, label = label, num = 1 } )

		self:updateBuffItemPos()

	else
		self.buffItemList[idx].num = self.buffItemList[idx].num + 1
		self.buffItemList[idx].label:setString( ''..self.buffItemList[idx].num )

	end

end

function SkillCastTemplateNew:removeBuff( btype )
	-- body
	local idx = 0
	for k,v in pairs(self.buffItemList) do
		if v.type == btype then
			idx = k
			break
		end
	end
	if idx == 0 then
		return
	end
	if self.buffItemList[idx] then
		self.buffItemList[idx].num = self.buffItemList[idx].num - 1
		if self.buffItemList[idx].num <= 0 then
			if self.buffItemList[idx].node then
				self.buffItemList[idx].node:removeFromParent()
			end
			table.remove( self.buffItemList, idx )
			self:updateBuffItemPos()
		elseif self.buffItemList[idx].num==1 then
			self.buffItemList[idx].label:setString( '' )
		else
			self.buffItemList[idx].label:setString( ''..self.buffItemList[idx].num )
		end
	end

end

function SkillCastTemplateNew:updateBuffItemPos()
	local idx = 0
	for k,v in pairs(self.buffItemList) do
		v.node:setPosition(0-24*(idx%5),0+math.floor(idx/5)*50)
		idx = idx + 1
	end
end

function SkillCastTemplateNew:Init(fighter)
	self.emptyNode:setVisible(false)
	self.infoNode:setVisible(false)
	self.dieNode:setVisible(false)
	self.buffNode:removeAllChildren()
	self.buffItemList = {}
	self:hideSpine();
	self.fid = -1
	self.resId = -1

	if fighter then
		self.infoNode:setVisible(true)
		self.fid = fighter:GetID()

		local data = ResTable:getRowData('role', fighter.resID);
		self.resId = fighter.resID;

		local resItemId = 0;
		if fighter.pid and fighter.pid > 0 then
			resItemId = model.CardModel:getCardResIdByPid(fighter.pid);
		end
		if resItemId == 0 then
			resItemId = data.resource_id;
		end
		local roleResource = ResTable:getRowData('role_resource', resItemId);
		local rolePre = ResTable:getRowData('role_pre' , data.resource_id);

		self.quBg:setTexture(imgPath .. 'l_bg_'..data.quality..'.png');
		self.bg:setTexture('image/iconL/' .. roleResource.iconlarge .. '.png')
		self.bg:setTextureRect(LRect);

		self.bigRole:setTexture('image/iconL/' .. roleResource.iconlarge .. '.png')
		self.big1Role:setTexture('image/iconL/' .. roleResource.iconlarge .. '.png')
		self.big1Role:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE))
		self.big2Role:setTexture('image/iconL/' .. roleResource.iconlarge .. '.png')
		GlobalFunctions:setSpriteGrey( self.big2Role ,4,4,4)

		self.type_bg:setTexture(imgPath .. 'flag_bg_'..rolePre.def_type..'.png')
		self.type_icon:setTexture('image/commonImg/def_type_' .. rolePre.def_type .. '.png')

		self.totalHp = fighter.m_propertyData:GetMaxHP()
		self.info_b_label:setString( fighter.m_propertyData:GetCurrentHP()..'')
		self.info_bar_blood:setScaleX( fighter.m_propertyData:GetCurrentHP()/self.totalHp )

		self.canEffect = true;
		self:updateSkillCD();
	else
		self.emptyNode:setVisible(true)
		self.quBg:setTexture(imgPath .. 'l_bg_1'..'.png');
		self.info_bar_time:setScaleX( 0 )
		self.info_bar_blood:setScaleX( 0 )
	end
end

function SkillCastTemplateNew:FightShowSkill(fid, ptype)
	if fid ~= self.fid then
		return
	end
	if ptype == 1 then
		self:playActiveSkillEff()
	elseif ptype == 2 then
		self:playSkill4Eff()
	end
end

function SkillCastTemplateNew:playSkill4Eff()
	-- body
	if self.sillPlay then
		return
	end
	local speedup = FightManager:SpeedUp()
	self:hideSpine()
	local seq1 = cc.Sequence:create( cc.FadeIn:create(0.12*speedup),  cc.FadeOut:create(0.12*speedup) );
	self.bg2:runAction(seq1)

	local spaw1 = cc.Spawn:create(
		cc.ScaleTo:create(0.08*speedup, 0.9),
		cc.MoveBy:create(0.08*speedup, cc.p(0,30)),
		cc.RotateTo:create(0.08*speedup,15)
		) 
	local spaw2 = cc.Spawn:create(
		cc.ScaleTo:create(0.12*speedup, 0.6),
		cc.MoveBy:create(0.12*speedup, cc.p(0,-30)),
		cc.RotateTo:create(0.12*speedup,0)
		) 

	local seq2 = cc.Sequence:create( cc.DelayTime:create(0.12*speedup), spaw1, spaw2 )
	self.bg:runAction(seq2)

end

function SkillCastTemplateNew:initTopAnimation()
	-- body
	if cc.FileUtils:getInstance():isFileExist('spine/skill_show/skill_show.json') then
		self.spTop = sp.SkeletonAnimation:create('spine/skill_show/skill_show.json', 'spine/skill_show/skill_show.atlas', 1)
		self.spTop:addTo(self.subRoot)
		self.spTop:setPosition(0 , 40);
		self.spTop:setVisible(false);

		self.spTop:registerSpineEventHandler(function (event)
			local speedup = FightManager:SpeedUp()
			if event.eventData.name == 'appear' then
				self.roleNode:setScale(0.72)
				self.roleNode:setPosition(0, -35)
				self.roleNode:setVisible(true)
				self.bigRole:setOpacity(255)
				self.big1Role:setOpacity(255)
				self.big2Role:setOpacity(255)

				self.big1Role:runAction( cc.FadeOut:create(0.1*speedup) )
				self.big2Role:runAction( cc.FadeOut:create(0.33*speedup) )
				self.roleNode:runAction( cc.ScaleTo:create(0.1*speedup, 0.6) )

			elseif event.eventData.name == 'down' then
				self.big2Role:runAction( cc.Sequence:create( cc.FadeIn:create(0.1*speedup), cc.FadeOut:create(0.1*speedup) ) )
				self.roleNode:runAction( cc.MoveTo:create(0.15*speedup, cc.p(0, -150)) )

			elseif event.eventData.name == 'remove' then
				self.bigRole:setOpacity(0)

			end
		end, sp.EventType.ANIMATION_EVENT);

		self.spTop:registerSpineEventHandler(function (event)
			self.roleNode:setVisible(false)
			self.sillPlay = false
			self.bg:setOpacity(255)
		end, sp.EventType.ANIMATION_COMPLETE)
	end
	
end

function SkillCastTemplateNew:playActiveSkillEff()
	-- body
	if self.sillPlay then
		return
	end
	self.sillPlay = true
	self:hideSpine()
	self.bg2:stopAllActions()
	self.bg2:setOpacity(0)

	self.bg:stopAllActions()
	self.bg:setPosition(0, 0)
	self.bg:setRotation(0)
	self.bg:setScale(0.6)
	self.bg:setOpacity(0)

	local timeScale = 1/FightManager:SpeedUp()
	self.spTop:setVisible(true);
	self.spTop:setAnimation(0, "up", false);
	self.spTop:setTimeScale(timeScale);

end

function SkillCastTemplateNew:updateSkillCD()
	-- local beginX, beginY = 0, self.fgSize.height*self.cdPercent;
	-- local width, height = self.fgSize.width, self.fgSize.height*(1-self.cdPercent);

	-- self.mask:setTextureRect(cc.rect(beginX, beginY, width, height));

	self.info_bar_time:setScaleX( self.cdPercent )

	-- self.line:setPosition(0, self.fgSize.height*(0.5-self.cdPercent));
end

function SkillCastTemplateNew:setCurHp( curHp )
	self.info_b_label:setString( curHp..'')
	-- self.info_b_label:setString( curHp..'/'.. self.totalHp)
	-- self.info_b_label:setString( tostring(ConvertStrToDigitUnit(curHp)) ..'/'.. tostring(ConvertStrToDigitUnit(self.totalHp)))
	self.info_bar_blood:setScaleX( curHp/self.totalHp )
end

function SkillCastTemplateNew:setCD(cd)
	if self.dieNode:isVisible() then
		return
	end
	cd = cd>1 and 1 or cd;
	cd = cd<0 and 0 or cd;
	cd = math.floor(cd*100)/100;
	self.cdPercent = cd;
	self:updateSkillCD()

	if cd > 0.97 and self.canEffect then
		self.canEffect = false;
		self:showSpine()

		self:checkRemind()
	end

	if cd < 0.5 and not self.canEffect then
		self.canEffect = true;
		self:hideSpine()
	end
end

function SkillCastTemplateNew:setDie()
	self.dieNode:setVisible(true)
	self.info_bar_time:setScaleX( 0 )
	self.info_bar_blood:setScaleX( 0 )
	self.info_b_label:setString( '0')--self.totalHp
	self.buffNode:removeAllChildren()
	self.buffItemList = {}
	self:hideSpine()

	if self.showRemind then
		EventManager:FireEvent(EventType.UIGuidePanel);
	end
end

function SkillCastTemplateNew:setPosition(x, y)
	self.root:setPosition(x, y)
end

function SkillCastTemplateNew:showAutoState() --当关闭自动释放，技能好了等待点击，这时候开启自动释放，通知当前技能自动开启
	if self.dieNode:isVisible() then
		return
	end
	if self.cdPercent<0.99 then --进度条没有到100%不能点击
		return
	end
	local fighter = FightManager:GetFighter(self.fid)
	if fighter then
		if fighter:SetActiveRelease() then
			--释放成功 播放抖动动画
			self:playWiteRelease()
		end
	end
end

function SkillCastTemplateNew:btnClick(sender, event)
	if self.showRemind then
		EventManager:FireEvent(EventType.UIGuidePanel);
	end
	if FightManager:getAutoRelease() then --自动释放开关开启后，按钮不再响应
		return
	end
	self:showAutoState();
end

function SkillCastTemplateNew:checkRemind()
	if remindIdx == nil then
		remindIdx = model.UserDefaultModel:getDataByKey('remind_SkillCastTemplateNew');
	else
		return;
	end

	if remindIdx == nil then
		model.UserDefaultModel:setDataByKey('remind_SkillCastTemplateNew', self.pos);

		self.showRemind = true;
		local wpt = self.root:getParent():convertToWorldSpace(cc.p(self.root:getPosition()));
		EventManager:FireEvent(EventType.UIGuidePanel, wpt, LANG.UI_REMIND_1);
		GlobalFunctions:sendFunnel(Enum:getTable('FunnelType').tu8_skill);

		--[[
		local args = {
			eventName = Enum:getTable('TrackEventToken').TRACK_TU8_SKILL
		}
		sdkManager.SDKLuaHelper:trackEvent(args)
		]]
		GlobalFunctions:trackEvent('TRACK_TU8_SKILL')
	end
end

return SkillCastTemplateNew;
