local StoryCell = class("StoryCell" , function() 
	return ccui.Layout:create();
end)
local fonts = Enum:getTable('SystemFont')
local MessageBoxType = Enum:getTable('MessageBoxType')

function StoryCell:ctor(father)
	self:addTo(father);

	self.mainNode = cc.Node:create();
	self.mainNode:addTo(self)

	local bg0 = cc.Sprite:create('image/storyLine/story_c_bg1.png')
	bg0:addTo(self.mainNode)

	self.roleBg = cc.Sprite:create()
	self.roleBg:addTo(self.mainNode)
	self.roleBg:setPosition(0,10)

	local bg = cc.Sprite:create('image/storyLine/story_c_bg2.png')
	bg:addTo(self.mainNode)

	local roundBtn = ccui.Button:create('image/commonImg/bg_3_194_102.png');
	roundBtn:addTo(self.mainNode);
	roundBtn:setScale9Enabled(true);
	roundBtn:setPosition(0, 30)
	roundBtn:setOpacity(0)
	roundBtn:setContentSize(cc.size(460, 300))
	roundBtn:setSwallowTouches(false)
	roundBtn:addClickEventListener(handler(self, self.clickOpenRound));

	self.storyName = cc.Label:createWithTTF('', fonts.FONT_SIYUAN, 20);
	self.storyName:addTo(self.mainNode);
	self.storyName:setPosition(0, -118);
	self.storyName:enableOutline(cc.c3b(0 , 0 , 0),2);

	-- self.storyVal = cc.Label:createWithTTF('99', fonts.FONT_SIYUAN, 18);
	-- self.storyVal:addTo(self.mainNode);
	-- self.storyVal:setPosition(50, -115);
	-- self.storyVal:enableOutline(cc.c4b(0 , 0 , 0 ,255),2);

	local castNode = cc.Node:create()
	castNode:addTo(self.mainNode)
	castNode:setPosition(0, -160)
	local expProgressBg = cc.Scale9Sprite:create("image/commonImg/pgs_bg_1_223_12.png")
		:addTo(castNode)
		:setPosition(0,-50)
		:setCapInsets(cc.rect(10,0,203,12))
		:setContentSize(cc.size(439 , 15))
	local progress = cc.Scale9Sprite:create("image/commonImg/pgs_1_445_21.png")
	self.expProgress = cc.ProgressTimer:create(progress);
	self.expProgress:setType(cc.PROGRESS_TIMER_TYPE_BAR);
	self.expProgress:setMidpoint(cc.p(0, 0));
	self.expProgress:setBarChangeRate(cc.p(1, 0));
	self.expProgress:setPosition(expProgressBg:getContentSize().width/2,expProgressBg:getContentSize().height/2);
	self.expProgress:setPercentage(10);
	self.expProgress:addTo(expProgressBg);
	self.proLabel = cc.Label:createWithTTF('10/15', fonts.FONT_SIYUAN, 18)
		:addTo(castNode)
		:setPosition(0,-50)
		:setAnchorPoint(0.5 , 0.5)
		:enableOutline(cc.c3b(50 , 20 , 0),2)

	self.rwdBg = cc.Sprite:create('image/storyLine/gold_shine.png')
	self.rwdBg:setPosition(200, 300)
	self.rwdBg:setBlendFunc(cc.blendFunc(GL_ONE, GL_ONE));
	self.rwdBg:addTo(castNode);

	self.rwdBtn = ccui.Button:create('image/icon/I18003.png');
	self.rwdBtn:addTo(castNode);
	self.rwdBtn:setPosition(200, 300)
	self.rwdBtn:addClickEventListener(handler(self, self.clickRwdBtn));



	local label = cc.Label:createWithTTF('查看进度' , fonts.FONT_SIYUAN , 18)
	:enableOutline(cc.c3b(60 , 60 , 60) , 1)
	:setPosition(72,15)
	self.mapbtn = ccui.Button:create('image/storyLine/map_btn.png');
	self.mapbtn:addTo(self.mainNode);
	self.mapbtn:setPosition(-80, -250)
	self.mapbtn:addClickEventListener(handler(self, self.clickMapBtn));
	-- self.mapbtn:setTitleLabel(label);
	self.mapbtn:addChild(label);
	-- self.btn:setContentSize(cc.size(120 , 55))
	-- self.btn:setScale9Enabled(true)
	-- self.btn:setVisible(false)


	local label = cc.Label:createWithTTF('查看技能' , fonts.FONT_SIYUAN , 18)
	:enableOutline(cc.c3b(60 , 60 , 60) , 1)
	:setPosition(72,15)
	self.skillbtn = ccui.Button:create('image/storyLine/skill_btn.png');
	self.skillbtn:addTo(self.mainNode);
	self.skillbtn:setPosition(80, -250)
	self.skillbtn:addClickEventListener(handler(self, self.clickSkillBtn));
	-- self.skillbtn:setTitleLabel(label);
	self.skillbtn:addChild(label);
	-- self.skillbtn:setContentSize(cc.size(120 , 55))
	-- self.skillbtn:setScale9Enabled(true)


	local resetBtn = ccui.Button:create('image/storyLine/reset_btn.png');
	resetBtn:addTo(self.mainNode);
	resetBtn:setPosition(0, -170)
	resetBtn:addClickEventListener(handler(self, self.clickReset));

	self.clickName = cc.Label:createWithTTF('点击进入', fonts.FONT_SIYUAN, 30);
	self.clickName:addTo(self.mainNode);
	self.clickName:setPosition(0, -60);
	self.clickName:enableOutline(cc.c3b(60 , 60 , 60),3);

	local act1 = cc.FadeOut:create(0.4)
	local act2 = cc.FadeIn:create(0.4)
	local act3 = cc.FadeOut:create(0.4)
	local act4 = cc.FadeIn:create(0.4)
	local act5 = cc.FadeOut:create(0.4)
	local act6 = cc.FadeIn:create(0.4)
	local act7 = cc.FadeOut:create(0.4)
	local act8 = cc.DelayTime:create(3)
	local seqAct = cc.Sequence:create(act1,act2,act3,act4,act5,act6,act7,act8)
	self.clickName:runAction( cc.RepeatForever:create(seqAct) )

	self.storyId = 0;
	
end

function StoryCell:initData( storyId )
	self.storyId = storyId
	-- self.storyVal:setString( storyId )

	local data = ResTable:getRowData('dungeon', self.storyId)
	if not data then
		return;
	end
	local storyData = model.StoryModel:getStoryDataById( self.storyId )

	self.roleBg:setTexture('image/role/'..data.res..'.png')
	local size = self.roleBg:getContentSize();
	local cut = data.res_coordinate;
	local width = 500;
	local height = 360;
	self.roleBg:setTextureRect(cc.rect(size.width/2-width/2+cut[1],size.height/2-height/2+cut[2],width,height));

	local plotName = ResTable:getValue( 'dungeon_plot', storyData.storyPlotId, 'name' )
	local roundName = ResTable:getValue( 'dungeon_round', storyData.storyRoundId, 'name' )

	self.storyName:setString( plotName..' - '..roundName );

	local proInfo = math.floor(storyData.storyPro*100/storyData.storyTotal);
	self.proLabel:setString(proInfo..'%')
	self.expProgress:setPercentage(proInfo);

	-- self.skillName:setString( data.name )
	-- self.skillDes:setString( data.info )

end

function StoryCell:setCallBack( callback )
	self.callback = callback;
end

function StoryCell:clickSkillBtn(sender , event)
	if self.storyId ~= model.StoryModel:getCurStoryId() then
		return;
	end
	UIManager:push('StorySkillListPanel', self.storyId)
end

function StoryCell:clickMapBtn(sender , event)
	UIManager:push('StoryLinePanel', self.storyId);
end

function StoryCell:clickReset(sender , event)
	if self.storyId ~= model.StoryModel:getCurStoryId() then
		return;
	end
	local msgBox = MessageBox:create('是否要重置当前剧情？', MessageBoxType.CANCEL_OK, function()
		local msg = {};
		msg.storyid = self.storyId;
		Network.NetworkManager:Send(Network.NetworkCmdType.req_story_reset , msg);
	end,function()
	end,function()
	end);
	-- msgBox:setTitle(LANG.UI_TITLE_NOTICE)
	
end

function StoryCell:clickRwdBtn(sender , event)
	UIManager:push('StoryRwdPanel', self.storyId);
end

function StoryCell:clickOpenRound()
	if GlobalMove then
		return;
	end
	model.StoryModel:checkShowPanel(self.storyId)
	-- UIManager:push('StoryRoundPanel', self.storyId);
end

return StoryCell;