local TableViewTemplate = class("TableViewTemplate")
--==============================--
--demo:
-- local myTbale = template.TableViewTemplate:create()
-- myTbale:initWithSizeAndItem(initData) ;
-- myTbale:getView():setPosition(cc.p(-320,-375));
-- tableNode:addChild(myTbale:getView())

-- myTbale:reloadData(data)
--==============================------
function TableViewTemplate:ctor(  )
    
    self.tableSizeWidth = 0;
    self.tableSizeHeight = 0;

    self.cellWidth = 0;
    self.cellHeight = 0;

    self.fillOrder = 0;

    self.father = nil ;

    self.cellReloadFunc = nil;
    self.cellTouchFunc = nil;

    self.dataCount = 0;

end

-- Tip:!!!! 	-- tableView cell 为了重复利用cell,需要将外界cellTag固定为999！！！

-- initData = {
--     father
--     width = 1,
--     height = 1,
--     cellWidht = 1,
--     cellHeight = 1,
--     fillOrder = 0, -- 加载方向 0 从上到下，1 从下到上
--     direction = 1, -- 滑动方向 0 左右 1 上下(默认)
--     cellReloadFunc = function ( ... ) end
--     cellTouchFunc = function (  )end


-- }
function TableViewTemplate:initWithSizeAndItem( initData )
    -- body
    -- print("===========111111111===========")
    -- dump(initData);
    self.tableSizeWidth ,self.tableSizeHeight = initData.width,initData.height
    self.cellWidth,self.cellHeight = initData.cellWidth,initData.cellHeight;
    self.fillOrder = initData.fillOrder or 0;
    self.direction = initData.direction or cc.SCROLLVIEW_DIRECTION_VERTICAL;
    self.cellReloadFunc = initData.cellReloadFunc;
    self.cellTouchFunc = initData.cellTouchFunc;
    self.viewDidScrollFunc = initData.viewDidScrollFunc;
    self.father = initData.father;

    -- self.dataCount = initData.dataCount;

    self:initTable();

end

function TableViewTemplate:initTable(  )
    -- body

    self.root = cc.Node:create();

    -- tableView 为extensions::gui组件，子组件内如果有cocos::ui组件需要判断触摸范围，需要提供一个ui裁剪区域
    local layout = ccui.Layout:create()
        :setContentSize(cc.size(self.tableSizeWidth,self.tableSizeHeight))
        :addTo(self.root)
    layout:setClippingEnabled(true)

    self.tableView = cc.TableView:create( cc.size(self.tableSizeWidth,self.tableSizeHeight) );
    self.tableView:setDirection(self.direction);
    local fillOrder = cc.TABLEVIEW_FILL_TOPDOWN 
    if self.fillOrder ~= 0 then
        fillOrder = cc.TABLEVIEW_FILL_BOTTOMUP
    end
    self.tableView:setVerticalFillOrder(fillOrder );
    -- self.tableView:setPosition(cc.p(-320,-375));
    -- tableView:setAnchorPoint(cc.p(0.5,0.5));
    self.tableView:setDelegate()
    --registerScriptHandler functions must be before the reloadData funtion
    self.tableView:registerScriptHandler(handler(self,self.numberOfCellsInTableView),cc.NUMBER_OF_CELLS_IN_TABLEVIEW)  
    self.tableView:registerScriptHandler(handler(self,self.scrollViewDidScroll),cc.SCROLLVIEW_SCRIPT_SCROLL)
    self.tableView:registerScriptHandler(handler(self,self.scrollViewDidZoom),cc.SCROLLVIEW_SCRIPT_ZOOM)
    self.tableView:registerScriptHandler(handler(self,self.tableCellTouched),cc.TABLECELL_TOUCHED)
    self.tableView:registerScriptHandler(handler(self,self.cellSizeForTable),cc.TABLECELL_SIZE_FOR_INDEX)
    self.tableView:registerScriptHandler(handler(self,self.tableCellAtIndex),cc.TABLECELL_SIZE_AT_INDEX)

    layout:addChild(self.tableView);
    if self.father ~= nil  then
        self.father:addChild(self.root)
    end

end

function TableViewTemplate:getView(  )
    -- return self.tableView;
    return self.root;

end

function TableViewTemplate:setDataCount(dataCount)
    self.dataCount = dataCount or 0;
end

function TableViewTemplate:setCellSize(size)
    if size then
        self.cellWidth,self.cellHeight = size.width , size.height;
    end
end

function TableViewTemplate:setData(data)
    if data then
        self.data = data;
        self.dataCount = #table.keys(data);
    end
end

function TableViewTemplate:reloadData( data )
    if data then
        self:setData(data);
        -- print("=======reloadData ========= count === "..tostring(self.dataCount))
    end
    self.tableView:reloadData();
end

function TableViewTemplate:updateCellAtIndex( index )
    self.tableView:updateCellAtIndex(index);
end

function TableViewTemplate:scrollViewDidScroll(view)
    
    if self.viewDidScrollFunc then
        self.viewDidScrollFunc(view);
    end
end

function TableViewTemplate:scrollViewDidZoom(view)
end

function TableViewTemplate:tableCellTouched(table,cell)
    -- print("cell touched at index: " .. cell:getIdx())
    if self.cellTouchFunc then
        self.cellTouchFunc(table,cell);
    end
end

function TableViewTemplate:cellSizeForTable(table,idx)
    return self.cellWidth,self.cellHeight
    -- 依据index值来获取不等高的高度
end

function TableViewTemplate:tableCellAtIndex(table, idx)
    local cell = table:dequeueCell()
    if nil == cell then
        cell = cc.TableViewCell:new()
    end

    if self.cellReloadFunc then 
        self.cellReloadFunc(cell,idx);
    end

    return cell
end

function TableViewTemplate:numberOfCellsInTableView(table)
   return self.dataCount
end

function TableViewTemplate:removeCellAtIndex(idx)
    if idx then
        self.tableView:removeCellAtIndex(idx);
    end
end

function TableViewTemplate:cellAtIndex(idx)
    if idx then
        return self.tableView:cellAtIndex(idx);
    end
end

function TableViewTemplate:scroolToBottom( dt )

    if tonumber(dt) == nil then
        dt = 0
    end

	local offset = self.tableView:maxContainerOffset();
    local minInset = self.tableView:minContainerOffset();

    offset.x = math.max(offset.x, minInset.x);
    offset.y = math.max(offset.y, minInset.y);

    self.tableView:setContentOffsetInDuration(offset , dt);

end

function TableViewTemplate:jumpToCurPos(callback)
    local offset = self.tableView:getContentOffset();
	local offsetX = offset.x;
	local offsetY = offset.y;

    if callback then
        callback();
    end

	local maxInset = self.tableView:maxContainerOffset();
    local minInset = self.tableView:minContainerOffset();

    offsetX = math.min(offsetX, maxInset.x);
    offsetX = math.max(offsetX, minInset.x);
    offsetY = math.min(offsetY, maxInset.y);
    offsetY = math.max(offsetY, minInset.y);

    self.tableView:setContentOffsetInDuration(cc.p(offsetX , offsetY) , 0);
end

function TableViewTemplate:scrollToCellIndex(idx , dt)

    local offsetX = 0;
    local offsetY = 0;

    dt = dt or 0;

    if self.direction == cc.SCROLLVIEW_DIRECTION_VERTICAL then
        if self.fillOrder == cc.TABLEVIEW_FILL_BOTTOMUP then
            offsetY = -self.cellHeight * (self.dataCount - idx - 1); 
        else
            offsetY = -self.cellHeight *  idx; 
        end
    else
        if self.fillOrder == cc.TABLEVIEW_FILL_BOTTOMUP then
            offsetX = -self.cellWidth * (self.dataCount - idx - 1); 
        else
            offsetX = -self.cellWidth *  idx;
        end
    end

    local maxInset = self.tableView:maxContainerOffset();
    local minInset = self.tableView:minContainerOffset();

    offsetX = math.min(offsetX, maxInset.x);
    offsetX = math.max(offsetX, minInset.x);
    offsetY = math.min(offsetY, maxInset.y);
    offsetY = math.max(offsetY, minInset.y);

    self.tableView:setContentOffsetInDuration(cc.p(offsetX , offsetY) , dt);
end

--加载数据的时候是否使用缓存cell
function TableViewTemplate:setUseCellFreed(userCellFreed)
    self.tableView:setUseCellFreed(userCellFreed);
end

--获取所有可见cell的idx
function TableViewTemplate:getAllIndicesCellIdx()
    return self.tableView:getAllIndicesCellIdx()
end

return TableViewTemplate;
