cc.FileUtils:getInstance():setPopupNotify(false)

require("socket")
require "config"
require "cocos.init"
-- require "Cjson"

local fileUtils = cc.FileUtils:getInstance();
local scheduler = cc.Director:getInstance():getScheduler();

local function saveErrorLog( errorMsg,model )

	local msg =string.format('%s \n', os.date());
	msg = msg..tostring(errorMsg)..'\n===========================================\n';

    local writePath = fileUtils:getWritablePath()
    if not fileUtils:isDirectoryExist(writePath..'/Error') then
    	fileUtils:createDirectory(writePath..'/Error');
    end
	local fielPath = writePath..'Error/error_log.txt';
	io.writefile(fielPath , msg, model)  -- "a+"：追加


end

local function createDynamicResDir()
	local writePath = fileUtils:getWritablePath()
    if not fileUtils:isDirectoryExist(writePath..'/DynamicRes') then
    	fileUtils:createDirectory(writePath..'/DynamicRes');
    end
    fileUtils:addSearchPath(writePath..'/DynamicRes', true)
end

__G__TRACKBACK__ = function(msg)
    local msg = debug.traceback(msg, 3)
    print(msg)
	saveErrorLog(msg,'a+')

    -- report lua exception
	sdkManager.BuglyManager:buglyReportLuaException(msg);
    return msg
end

require "global_branch"
require "global_define"

local storagePath = define.writablePath .. "/new_version/hotfix/";
local fullPath = define.writablePath .. "/new_version/"
--增加多语言资源搜索路径 
cc.FileUtils:getInstance():addSearchPath(storagePath..'src/', true)
require "global_function"
require "app.AllRequire"

-- cc.FileUtils:getInstance():addSearchPath(fullPath..'res/', true)
-- cc.FileUtils:getInstance():addSearchPath(storagePath..'res/', true)

-- local lg = model.UserDefaultModel:getLanguageSet()
-- cc.FileUtils:getInstance():addSearchPath(fullPath..'res_'..lg..'/',true)
-- cc.FileUtils:getInstance():addSearchPath(storagePath..'res_'..lg..'/', true)

local function main()
	saveErrorLog(msg,'w')
	createDynamicResDir()

	cc.exports.App = require("app.MyApp"):create();
	cc.exports.App:run("VersionUpdateScene");

    GlobalFunctions:recordTime('fb-log---run versionUpdateScene end')
end

local status, msg = xpcall(main, __G__TRACKBACK__)
if not status then
    print(msg)
end
