
local ViewBase = class("ViewBase", cc.Node)

function ViewBase:ctor(app, name)
	self:enableNodeEvents()
	self.app_ = app
	self.name_ = name

	if self.onCreate then self:onCreate() end
end

function ViewBase:getApp()
	return self.app_
end

function ViewBase:getName()
	return self.name_
end

function ViewBase:showWithScene(transition, time, more)
	if self.scene then
		display.runScene(self.scene, transition, time, more)
		return self;
	end
	self:setVisible(true)
	self.scene = require("app.controller." .. self.name_).create()
	self.scene:addChild(self)
	display.runScene(self.scene, transition, time, more)
    return self
end

function ViewBase:getScene()
	if not self.scene then
		print('No scene created')
		return nil
	else
		return self.scene
	end
end

return ViewBase
